#!/usr/bin/python
from sqlite3 import *
import sys
import codecs

sys.stdout = codecs.open("musica.xml","w",encoding="utf-8")
def encode(str):
    str = str.replace('&','&amp;')
    str = str.replace('<','&lt;')
    str = str.replace('>','&gt;')
    str = str.replace('\'','&apos;')
    str = str.replace('"','&quot;')
    return str

conn = connect('musica.db')
conn.row_factory = Row

print "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
print "<!DOCTYPE diskotheque SYSTEM \"musica.dtd\">"
print "<diskotheque>"

disques = conn.cursor()
chansons = conn.cursor()

disques.execute("select *, IFNULL(art_prenom,\"\") || \
                           IFNULL(art_nom,\"\") || \
                           IFNULL(art_groupe,\"\") as artiste_nom\
                 from disque \
                      left outer join artiste \
                      left outer join etat \
                 where disque.dis_artiste = artiste.art_num \
                   and disque.dis_etat = etat.eta_num \
                ")

for disque in disques :
    print "   <disque cddb=\"%s\">" % encode(disque["dis_cddb"]) 
    print "      <titre>%s</titre>" % encode(disque["dis_titre"])
    print "      <artiste>%s</artiste>" % encode(disque["artiste_nom"])
    print "      <annee>%s</annee>" % encode(disque["dis_annee"])
    print "      <annee-achat>%s</annee-achat>" % encode(disque["dis_anneeachat"])
    print "      <etat>%s</etat>" % encode(disque["eta_nom"])
    print "      <prix>%.2f</prix>" % disque["dis_prixachat"]
    print "      <chansons>"
    chansons.execute("select *, IFNULL(art_prenom,\"\") || \
                                IFNULL(art_nom,\"\") || \
                                IFNULL(art_groupe,\"\") as ecrit_nom \
                      from chanson, interprete, genre \
                           left outer join languechanson \
                                on (languechanson.lac_chanson = chanson.cha_num) \
                           left outer join langue \
                                on (languechanson.lac_langue = langue.lan_num) \
                           left outer join ecrit \
                                on (ecrit.ecr_chanson = chanson.cha_num) \
                           left outer join artiste \
                                on (ecrit.ecr_artiste = artiste.art_num) \
                      where chanson.cha_num = interprete.int_chanson \
                        and chanson.cha_genre = genre.gen_num \
                        and int_disque = %i \
                      order by int_numero asc" % disque["dis_num"])
    for chanson in chansons :
        print "        ",
        print "<chanson numero=\"%i\">" % chanson["int_numero"]
        print "           ",
        print "<titre>%s</titre>" % encode(chanson["cha_titre"])
        print "           ",
        print "<genre>%s</genre>" % encode(chanson["gen_nom"])
        if chanson["ecr_artiste"] :
            print "           ",
            print "<ecrit>%s</ecrit>" % encode(chanson["ecrit_nom"])
        if chanson["lan_nom"] :
            print "           ",
            print "<langue>%s</langue>" % encode(chanson["lan_nom"])
        print "        ",
        print "</chanson>"
    print "      </chansons>"
    print "   </disque>"

print "</diskotheque>"
