import sys
from xml.dom.minidom import *
from sqlite3 import *

conn = connect('travaho.db')
conn.row_factory = Row

boss = conn.cursor()
emp = conn.cursor()

doc = Document()

def append_employee(emp_id, parent) :
    emp.execute("SELECT E.NOM      as e_nom, \
                        E.PRENOM   as e_prenom, \
                        E.EMBAUCHE as e_embauche, \
                        E.SALAIRE  as e_salaire, \
                        D.NOM      as d_nom, \
                        D.VILLE    as d_ville \
                 FROM EMPLOYE E, DEPARTAMENT D \
                 WHERE E.ID = %i AND E.NODEPT = D.ID" % emp_id)
    e = emp.fetchone()

    employe = doc.createElement("employe")
    parent.appendChild(employe)

    nom = doc.createElement("nom")
    nom.appendChild(doc.createTextNode(str(e["e_nom"])))
    employe.appendChild(nom)

    prenom  = doc.createElement("prenom")
    prenom.appendChild(doc.createTextNode(str(e["e_prenom"])))
    employe.appendChild(prenom)

    embauche = doc.createElement("embauche")
    embauche.appendChild(doc.createTextNode(str(e["e_embauche"])))
    employe.appendChild(embauche)

    salaire = doc.createElement("salaire")
    salaire.appendChild(doc.createTextNode(str(e["e_salaire"])))
    employe.appendChild(salaire)

    departament = doc.createElement("departament")
    departament.setAttribute("nom",e["d_nom"])
    departament.setAttribute("ville",e["d_ville"])
    employe.appendChild(departament)

    subemp = conn.cursor()
    subemp.execute("SELECT EMPLOYE_ID FROM SUPERIEUR \
                 WHERE SUPERIEUR_ID = %i" % emp_id);
    for sub in subemp :
        append_employee(sub["EMPLOYE_ID"], employe)


root = doc.createElement('travail')

boss.execute("SELECT EMPLOYE_ID FROM SUPERIEUR \
              WHERE SUPERIEUR_ID IS NULL");

boss_id = boss.fetchone()["EMPLOYE_ID"]

append_employee(boss_id, root)

print root.toprettyxml()
