from xml.dom.minidom import *
from sqlite3 import *

conn = connect('travaho-import-dom.db')

c = conn.cursor()

c.execute("DROP TABLE IF EXISTS EMPLOYE")
c.execute("""
CREATE TABLE IF NOT EXISTS EMPLOYE (
   ID       INTEGER PRIMARY KEY AUTOINCREMENT, 
   NOM      TEXT,
   PRENOM   TEXT,
   EMBAUCHE DATE,
   DEPT     TEXT,
   VILLE    TEXT,
   SALAIRE  FLOAT,
   ID_SUPERIEUR INT REFERENCES EMPLOYE(ID)
);
""");

def insert_employe(emp, superieur_id):
    nom = emp.getElementsByTagName("nom")[0].firstChild.data
    prenom = emp.getElementsByTagName("prenom")[0].firstChild.data
    embauche = emp.getElementsByTagName("embauche")[0].firstChild.data
    salaire = emp.getElementsByTagName("salaire")[0].firstChild.data
    dep = emp.getElementsByTagName("departament")[0]
    dept = dep.getAttribute("nom")
    ville = dep.getAttribute("ville")

    c.execute("INSERT INTO EMPLOYE(NOM,PRENOM,EMBAUCHE,\
               DEPT,VILLE,SALAIRE,ID_SUPERIEUR) VALUES \
               (?,?,?,?,?,?,?)",
              (nom,prenom,embauche,salaire,dept,ville,superieur_id));

    emp_id = c.lastrowid

    for sub in emp.childNodes:
        if sub.nodeType == sub.ELEMENT_NODE and sub.tagName == "employe":
            insert_employe(sub, emp_id)

dom = parse("travaho-import.xml")

root = dom.getElementsByTagName("travail")[0]

for emp in root.childNodes:
    if emp.nodeType == emp.ELEMENT_NODE and emp.tagName == "employe":
        insert_employe(emp, "NULL")


conn.commit()
conn.close()
