BEGIN TRANSACTION;
CREATE TABLE artiste (
                art_num integer NOT NULL PRIMARY KEY,
                art_prenom varchar(255),
                art_nom varchar(255),
                art_groupe varchar(255),
                art_modif timestamp );


CREATE TABLE chanson (
                cha_num integer NOT NULL PRIMARY KEY,
                cha_titre varchar,
                cha_genre integer,
                cha_texte varchar,
                cha_libre boolean,
                cha_modif timestamp);

CREATE TABLE etat (
                eta_num integer NOT NULL PRIMARY KEY,
                eta_nom varchar(255));

CREATE TABLE genre (
                gen_num integer NOT NULL PRIMARY KEY,
                gen_nom varchar(255),
                gen_modif timestamp  );

CREATE TABLE droits (
                dro_num integer NOT NULL PRIMARY KEY,
                dro_nom varchar(255),
                dro_niveau integer);

CREATE TABLE langue (
                lan_num varchar(255) NOT NULL PRIMARY KEY,
                lan_nom varchar(255));

CREATE TABLE langueartiste (
                laa_langue varchar(255) NOT NULL,
                laa_artiste integer NOT NULL,
                laa_maternelle boolean DEFAULT true,
                PRIMARY KEY (laa_langue, laa_artiste));

CREATE TABLE languechanson (
                lac_langue varchar(255) NOT NULL,
                lac_chanson integer NOT NULL,
                lac_principale boolean DEFAULT true NOT NULL,
                PRIMARY KEY (lac_langue, lac_chanson, lac_principale));

CREATE TABLE membre (
                mem_membre integer NOT NULL,
                mem_groupe integer NOT NULL,
                mem_debut varchar(255) NOT NULL,
                mem_fin varchar(255) NOT NULL,
                PRIMARY KEY (mem_membre, mem_groupe, mem_debut, mem_fin));

CREATE TABLE disque (
                dis_num integer NOT NULL PRIMARY KEY,
                dis_titre varchar(255),
                dis_artiste integer,
                dis_annee varchar(255),
                dis_cddb varchar(255),
                dis_anneeachat varchar(255),
                dis_prixachat numeric(8,2),
                dis_etat integer,
                dis_perdu boolean DEFAULT false,
                dis_modif timestamp);
CREATE TABLE interprete (
                int_artiste integer NOT NULL,
                int_chanson integer NOT NULL,
                int_disque integer NOT NULL,
                int_numero integer NOT NULL,
                PRIMARY KEY (int_artiste, int_chanson, int_disque, int_numero)
);

CREATE TABLE ecrit (
                ecr_artiste integer NOT NULL,
                ecr_chanson integer NOT NULL,
                PRIMARY KEY (ecr_artiste, ecr_chanson));

INSERT INTO ARTISTE VALUES(0,'Beverly Jo','Scott','','2009-02-15 18:12:44.028935');
INSERT INTO ARTISTE VALUES(1,'','Bâton Rouge','','2008-03-30 09:11:42');
INSERT INTO ARTISTE VALUES(2,'','Dusters','','2008-03-12 13:11:36');
INSERT INTO ARTISTE VALUES(3,'Calvin','Russell','','2009-02-15 17:59:09.267532');
INSERT INTO ARTISTE VALUES(4,'','AC DC','','2009-06-04 17:33:12.786821');
INSERT INTO ARTISTE VALUES(5,'Robert','Cray','','2008-03-12 08:37:48');
INSERT INTO ARTISTE VALUES(6,'','Björk','','2008-03-12 12:44:58');
INSERT INTO ARTISTE VALUES(7,'The Jeff','Healey','Band','2008-03-12 17:58:43');
INSERT INTO ARTISTE VALUES(8,'','B.O.','','2008-03-12 18:51:00');
INSERT INTO ARTISTE VALUES(9,'Chris','Whitley','','2008-03-12 10:34:10');
INSERT INTO ARTISTE VALUES(10,'Carla','Bruni','','2008-03-12 12:15:44');
INSERT INTO ARTISTE VALUES(11,'','Queen','','2008-03-12 14:22:55');
INSERT INTO ARTISTE VALUES(12,'','Creedence Clearwater Revival','','2008-03-12 10:49:07');
INSERT INTO ARTISTE VALUES(13,'Olivia','Ruiz','','2008-03-12 17:55:49');
INSERT INTO ARTISTE VALUES(14,'Bob','Dylan','','2008-03-12 13:21:56');
INSERT INTO ARTISTE VALUES(15,'','Puccini','','2008-03-12 09:23:33');
INSERT INTO ARTISTE VALUES(16,'Gustav','Mahler','','2008-03-12 19:47:17');
INSERT INTO ARTISTE VALUES(17,'Frédéric','Chopin','','2009-04-26 12:53:19.497856');
INSERT INTO ARTISTE VALUES(18,'Piotr I.','Tchaikovsky','','2008-03-12 15:29:06');
INSERT INTO ARTISTE VALUES(19,'Wolfgang Amadeus','Mozart','','2008-03-12 15:40:41');
INSERT INTO ARTISTE VALUES(20,'Hector','Berlioz','','2008-03-12 17:04:57');
INSERT INTO ARTISTE VALUES(21,'Ludwig van','Beethoven','','2008-03-12 14:35:19');
INSERT INTO ARTISTE VALUES(22,'Franz','Schubert','','2008-03-12 13:48:09');
INSERT INTO ARTISTE VALUES(23,'Joseph','Haydn','','2008-03-12 15:37:05');
INSERT INTO ARTISTE VALUES(24,'Franz','Liszt','','2008-03-12 12:03:27');
INSERT INTO ARTISTE VALUES(25,'Johan Sebastian','Bach','','2008-03-12 12:10:51');
INSERT INTO ARTISTE VALUES(26,'','Classique -Divers-','','2008-03-12 18:05:38');
INSERT INTO ARTISTE VALUES(27,'Antonio','Vivaldi','','2008-03-12 10:59:16');
INSERT INTO ARTISTE VALUES(28,'Carl','Orff','','2008-03-12 13:37:45');
INSERT INTO ARTISTE VALUES(29,'Richard','Wagner','','2008-03-12 14:15:26');
INSERT INTO ARTISTE VALUES(30,'Richard','Strauss','','2008-03-12 11:03:31');
INSERT INTO ARTISTE VALUES(31,'The','Stooges','','2008-03-12 10:36:06');
INSERT INTO ARTISTE VALUES(32,'Richard','Strauss-Karajan','','2008-03-12 14:04:55');
INSERT INTO ARTISTE VALUES(33,'','Coro de monjes del Monasterio Benedictino de Santo Domingo de Silos','','2008-03-12 16:40:33');
INSERT INTO ARTISTE VALUES(40,'Alvin','Lee','& Ten Years After','2008-03-12 10:50:47');
INSERT INTO ARTISTE VALUES(41,'The','Clash','','2008-03-12 16:04:23');
INSERT INTO ARTISTE VALUES(42,'','Trust','','2008-03-12 18:37:28');
INSERT INTO ARTISTE VALUES(43,'','Nada Surf','','2008-03-12 17:19:08');
INSERT INTO ARTISTE VALUES(44,'The','Rolling Stones','','2008-06-05 16:16:31.286402');
INSERT INTO ARTISTE VALUES(45,'','ZZ Top','','2008-03-12 11:07:13');
INSERT INTO ARTISTE VALUES(46,'','Moby','','2008-03-12 19:22:39');
INSERT INTO ARTISTE VALUES(47,'','Bérurier Noir','','2008-03-12 16:28:00');
INSERT INTO ARTISTE VALUES(48,'','T.Rex','','2008-03-12 14:13:32');
INSERT INTO ARTISTE VALUES(49,'','Arno','','2008-05-25 10:26:47');
INSERT INTO ARTISTE VALUES(50,'','Pink Floyd','','2008-03-12 12:14:33');
INSERT INTO ARTISTE VALUES(51,'','Ludwig von 88','','2008-03-12 18:01:08');
INSERT INTO ARTISTE VALUES(52,'David','Bowie','','2008-03-12 15:14:59');
INSERT INTO ARTISTE VALUES(53,'Jerry Lee','Lewis','','2008-03-12 12:59:03');
INSERT INTO ARTISTE VALUES(54,'','New York Dolls','','2008-03-12 17:50:40');
INSERT INTO ARTISTE VALUES(55,'The','Breeders','','2008-03-12 11:36:59');
INSERT INTO ARTISTE VALUES(56,'Lou','Reed','','2008-03-12 12:56:07');
INSERT INTO ARTISTE VALUES(57,'','Noir Désir','','2008-03-12 15:51:29');
INSERT INTO ARTISTE VALUES(58,'John','Lennon','','2008-03-12 11:33:58');
INSERT INTO ARTISTE VALUES(59,'','Bijou','','2008-03-12 11:07:12');
INSERT INTO ARTISTE VALUES(60,'Les','Steacks Bulgares','','2008-03-12 18:31:26');
INSERT INTO ARTISTE VALUES(61,'Hubert-Félix','Thiéfaine','','2008-03-12 12:24:28');
INSERT INTO ARTISTE VALUES(62,'','Genesis','','2008-03-12 14:01:42');
INSERT INTO ARTISTE VALUES(63,'','Ange','','2008-03-12 14:25:42');
INSERT INTO ARTISTE VALUES(64,'','Deep Purple','','2008-03-12 14:12:32');
INSERT INTO ARTISTE VALUES(65,'','Eurythmics','','2008-03-12 10:27:09');
INSERT INTO ARTISTE VALUES(66,'Jacques','Higelin','','2008-03-12 10:51:06');
INSERT INTO ARTISTE VALUES(67,'','Led Zeppelin','','2008-03-12 12:28:57');
INSERT INTO ARTISTE VALUES(68,'','Molodoï','','2008-03-12 18:45:31');
INSERT INTO ARTISTE VALUES(69,'Chuck','Berry','','2008-03-12 17:02:38');
INSERT INTO ARTISTE VALUES(70,'','Guns N'' Roses','','2008-03-12 08:52:10');
INSERT INTO ARTISTE VALUES(71,'Alice','Cooper','','2009-04-26 09:52:14.635208');
INSERT INTO ARTISTE VALUES(72,'','Iron Maiden','','2008-03-12 19:47:36');
INSERT INTO ARTISTE VALUES(73,'Izzy','Stradlin','And The Ju Ju Hounds','2008-03-12 15:18:01');
INSERT INTO ARTISTE VALUES(74,'','Van Halen','','2008-03-12 12:52:13');
INSERT INTO ARTISTE VALUES(75,'Iggy','Pop','And The Stooges','2008-03-12 18:06:41');
INSERT INTO ARTISTE VALUES(76,'Leonard','Cohen','','2008-03-12 08:20:32');
INSERT INTO ARTISTE VALUES(77,'Alain','Bashung','','2008-06-02 14:11:37.495902');
INSERT INTO ARTISTE VALUES(78,'The','Who','','2008-03-12 09:32:45');
INSERT INTO ARTISTE VALUES(79,'','T.C. Matic','','2008-03-12 15:22:48');
INSERT INTO ARTISTE VALUES(80,'Mick','Jagger','','2008-03-12 11:24:41');
INSERT INTO ARTISTE VALUES(81,'','Midnight Oil','','2008-03-12 13:52:57');
INSERT INTO ARTISTE VALUES(82,'','Stocks','','2008-03-12 08:49:45');
INSERT INTO ARTISTE VALUES(83,'','Roxy Music','','2008-03-12 15:29:03');
INSERT INTO ARTISTE VALUES(84,'Iggy','Pop','','2008-03-12 16:51:55');
INSERT INTO ARTISTE VALUES(85,'Nina','Hagen','','2008-03-12 19:45:01');
INSERT INTO ARTISTE VALUES(86,'Cyndi','Lauper','','2008-03-12 15:50:21');
INSERT INTO ARTISTE VALUES(87,'Patti','Smith','Group','2008-03-12 09:01:03');
INSERT INTO ARTISTE VALUES(88,'Patti','Smith','','2008-03-12 09:09:35');
INSERT INTO ARTISTE VALUES(89,'Les','Rita Mitsouko','','2008-03-12 19:49:57');
INSERT INTO ARTISTE VALUES(90,'','Fish','','2008-03-12 16:07:22');
INSERT INTO ARTISTE VALUES(91,'','Sade','','2008-03-12 12:36:15');
INSERT INTO ARTISTE VALUES(92,'Rod','Stewart','','2008-03-12 12:39:05');
INSERT INTO ARTISTE VALUES(93,'','Téléphone','','2008-03-12 09:19:34');
INSERT INTO ARTISTE VALUES(94,'Brian','Ferry','','2008-03-12 10:01:25');
INSERT INTO ARTISTE VALUES(95,'Jane','Birkin','','2008-03-12 09:56:11');
INSERT INTO ARTISTE VALUES(96,'','Sex Pistols','','2008-03-12 09:33:01');
INSERT INTO ARTISTE VALUES(97,'','Anouk','','2008-03-12 14:42:02');
INSERT INTO ARTISTE VALUES(98,'Les','Garçons Bouchers','','2008-03-12 14:51:12');
INSERT INTO ARTISTE VALUES(99,'The','Doors','','2008-03-12 09:47:01');
INSERT INTO ARTISTE VALUES(100,'Keith','Richards','','2008-03-12 09:31:09');
INSERT INTO ARTISTE VALUES(101,'Kate','Bush','','2008-03-12 14:56:45');
INSERT INTO ARTISTE VALUES(102,'','Scorpions','','2008-03-12 17:18:25');
INSERT INTO ARTISTE VALUES(103,'Nina','Hagen','Band','2008-03-12 18:26:45');
INSERT INTO ARTISTE VALUES(104,'','Saxon','','2008-03-12 12:37:47');
INSERT INTO ARTISTE VALUES(105,'','Southern Culture on the Skids','','2008-03-12 18:44:43');
INSERT INTO ARTISTE VALUES(106,'','Dire Straits','','2008-03-12 08:52:16');
INSERT INTO ARTISTE VALUES(107,'Janis','Joplin','','2008-03-12 08:23:59');
INSERT INTO ARTISTE VALUES(108,'','No One Is Innocent','','2008-03-12 09:57:51');
INSERT INTO ARTISTE VALUES(109,'Elliott','Murphy','','2009-04-26 11:47:58.609452');
INSERT INTO ARTISTE VALUES(110,'Judas','Priest','','2008-03-12 12:15:10');
INSERT INTO ARTISTE VALUES(111,'Frank','Zappa','','2008-03-12 13:45:06');
INSERT INTO ARTISTE VALUES(112,'','Compil','','2008-03-12 11:30:25');
INSERT INTO ARTISTE VALUES(113,'','Foil','','2008-03-12 16:20:51');
INSERT INTO ARTISTE VALUES(114,'','Little Village','','2008-03-12 13:45:29');
INSERT INTO ARTISTE VALUES(115,'Jean-Louis','Aubert','','2008-03-12 10:35:13');
INSERT INTO ARTISTE VALUES(116,'Louis','Bertignac','','2008-03-12 19:37:06');
INSERT INTO ARTISTE VALUES(117,'The','Cranberries','','2008-03-12 11:40:29');
INSERT INTO ARTISTE VALUES(118,'','Tin Machine','','2008-03-12 10:46:27');
INSERT INTO ARTISTE VALUES(119,'Tom','Waits','','2008-03-12 09:05:35');
INSERT INTO ARTISTE VALUES(120,'','Placebo','','2008-03-12 16:25:50');
INSERT INTO ARTISTE VALUES(121,'','Nirvana','','2008-03-12 18:55:35');
INSERT INTO ARTISTE VALUES(122,'Les','Wampas','','2008-03-30 08:11:06');
INSERT INTO ARTISTE VALUES(123,'','Bad Religion','','2008-03-12 13:53:27');
INSERT INTO ARTISTE VALUES(124,'Phil','Collins','','2008-03-12 11:20:12');
INSERT INTO ARTISTE VALUES(125,'Georges','Moustaki','','2008-03-12 17:34:48');
INSERT INTO ARTISTE VALUES(126,'','Motörhead','','2009-02-15 18:01:00.404421');
INSERT INTO ARTISTE VALUES(127,'','Skunk Anansie','','2008-03-12 09:48:06');
INSERT INTO ARTISTE VALUES(128,'','Mano Negra','','2008-03-12 15:02:53');
INSERT INTO ARTISTE VALUES(129,'Avril','Lavigne','','2008-03-12 09:07:58');
INSERT INTO ARTISTE VALUES(130,'','Metallica','','2008-03-12 16:51:24');
INSERT INTO ARTISTE VALUES(131,'Etienne','Daho','','2008-03-12 14:46:20');
INSERT INTO ARTISTE VALUES(132,'Bruce','Springsteen','& The E Street Band','2008-03-12 09:47:31');
INSERT INTO ARTISTE VALUES(133,'','Skwée','','2008-03-12 10:14:25');
INSERT INTO ARTISTE VALUES(134,'','Au Bonheur des Dames','','2008-03-12 15:33:45');
INSERT INTO ARTISTE VALUES(135,'The','Beatles','','2008-03-12 18:21:20');
INSERT INTO ARTISTE VALUES(136,'','Garbage','','2008-03-12 16:23:53');
INSERT INTO ARTISTE VALUES(137,'Guesch','Patti','','2008-03-12 09:31:41');
INSERT INTO ARTISTE VALUES(138,'Lou','Reed','& John Cale','2008-06-02 15:21:19.40004');
INSERT INTO ARTISTE VALUES(139,'Mano','Solo','','2008-03-12 09:15:52');
INSERT INTO ARTISTE VALUES(140,'','Aerosmith','','2008-03-12 09:55:43');
INSERT INTO ARTISTE VALUES(141,'The','Velvet Underground','','2008-03-12 14:26:30');
INSERT INTO ARTISTE VALUES(142,'','U2','','2008-03-12 18:33:17');
INSERT INTO ARTISTE VALUES(143,'','Renaud','','2008-03-12 12:46:32');
INSERT INTO ARTISTE VALUES(144,'','Matmatah','','2008-03-12 17:26:05');
INSERT INTO ARTISTE VALUES(145,'','R.E.M.','','2008-03-12 14:18:27');
INSERT INTO ARTISTE VALUES(146,'','Blur','','2008-03-12 18:59:51');
INSERT INTO ARTISTE VALUES(147,'','Cornershop','','2008-03-12 17:06:22');
INSERT INTO ARTISTE VALUES(148,'Klaus','Nomi','','2008-03-12 13:19:32');
INSERT INTO ARTISTE VALUES(149,'Jimmy','Page','& Robert Plant','2008-03-12 09:31:43');
INSERT INTO ARTISTE VALUES(150,'Richard','Bohringer','','2008-03-12 18:02:09');
INSERT INTO ARTISTE VALUES(151,'','Pearl Jam','','2008-03-12 12:52:43');
INSERT INTO ARTISTE VALUES(152,'Neil','Young','& Crazy Horse','2008-03-12 15:15:30');
INSERT INTO ARTISTE VALUES(153,'','Lynyrd Skynyrd','','2008-03-12 10:03:56');
INSERT INTO ARTISTE VALUES(154,'','Kraftwerk','','2008-03-12 11:36:15');
INSERT INTO ARTISTE VALUES(155,'','Jefferson Airplane','','2008-03-12 16:30:15');
INSERT INTO ARTISTE VALUES(156,'The','Secret Policeman','','2008-03-12 15:18:21');
INSERT INTO ARTISTE VALUES(157,'','Simon & Garfunkel','','2008-03-12 19:48:41');
INSERT INTO ARTISTE VALUES(158,'','Disiz la Peste','','2008-03-12 13:03:08');
INSERT INTO ARTISTE VALUES(159,'','Manau','','2008-03-12 11:09:40');
INSERT INTO ARTISTE VALUES(160,'Jacques','Dutronc','','2008-03-12 08:00:42');
INSERT INTO ARTISTE VALUES(161,'Les','Blaireaux','','2008-03-12 10:20:35');
INSERT INTO ARTISTE VALUES(162,'Les','Bidochons','','2008-03-12 18:59:50');
INSERT INTO ARTISTE VALUES(163,'','Afro Celt Sound System','','2008-03-12 12:09:53');
INSERT INTO ARTISTE VALUES(164,'','Gogol 1er','et la horde','2008-03-12 12:26:30');
INSERT INTO ARTISTE VALUES(165,'Jimi','Hendrix','Experience','2008-05-25 16:31:45');
INSERT INTO ARTISTE VALUES(166,'','A.S Dragon','','2008-03-12 15:10:01');
INSERT INTO ARTISTE VALUES(167,'','Crosby Nash','','2008-03-12 18:45:20');
INSERT INTO ARTISTE VALUES(168,'Serge','Gainsbourg','','2009-04-26 12:42:44.067692');
INSERT INTO ARTISTE VALUES(169,'Michel','Polnareff','','2008-03-12 19:13:12');
INSERT INTO ARTISTE VALUES(170,'Didier','Super','','2008-03-12 08:30:21');
INSERT INTO ARTISTE VALUES(171,'The','Film','','2008-03-12 16:30:21');
INSERT INTO ARTISTE VALUES(172,'','Hedningarna','','2008-03-12 13:40:42');
INSERT INTO ARTISTE VALUES(173,'','La Lugh','','2008-03-12 08:34:41');
INSERT INTO ARTISTE VALUES(174,'','Slade','','2008-03-12 18:57:51');
INSERT INTO ARTISTE VALUES(175,'','Beatallica','','2008-03-12 17:18:17');
INSERT INTO ARTISTE VALUES(176,'','Marcel','et son Orchestre','2008-03-12 11:54:28');
INSERT INTO ARTISTE VALUES(177,'Kim','Wilde','','2008-03-12 11:45:13');
INSERT INTO ARTISTE VALUES(178,'','Velvet Revolver','','2008-03-12 15:58:57');
INSERT INTO ARTISTE VALUES(179,'Charlotte','Gainsbourg','','2009-04-26 11:50:59.515928');
INSERT INTO ARTISTE VALUES(180,'Nelly','Furtado','','2008-03-12 19:57:40');
INSERT INTO ARTISTE VALUES(181,'','Sttellla','','2008-03-12 12:40:11');
INSERT INTO ARTISTE VALUES(183,'The','Kinks','','2008-03-12 16:06:51');
INSERT INTO ARTISTE VALUES(184,'Louis','Bertignac','','2008-03-12 13:07:25');
INSERT INTO ARTISTE VALUES(185,'','Black Sabbath','','2008-03-12 09:59:23');
INSERT INTO ARTISTE VALUES(186,'','Pigalle','','2008-03-12 19:44:41');
INSERT INTO ARTISTE VALUES(187,'Keith','Richards','& The X-Pensive Winos','2008-03-12 11:01:35');
INSERT INTO ARTISTE VALUES(188,'Manu','Chao','','2008-03-12 16:18:21');
INSERT INTO ARTISTE VALUES(191,'','Sparks','','2008-03-12 09:42:11');
INSERT INTO ARTISTE VALUES(193,'','Cali','','2008-03-12 17:03:52');
INSERT INTO ARTISTE VALUES(194,'Jeanne','Cherhal','','2008-03-12 19:46:58');
INSERT INTO ARTISTE VALUES(196,'','Tri Yann','','2008-03-12 17:11:06');
INSERT INTO ARTISTE VALUES(197,'Rachid','Taha','','2008-03-12 11:18:05');
INSERT INTO ARTISTE VALUES(198,'Jean','Ferrat','','2008-03-12 15:16:50');
INSERT INTO ARTISTE VALUES(199,'François','Béranger','','2009-06-04 17:28:52.309974');
INSERT INTO ARTISTE VALUES(200,'','Taha, Khaled et Faudel','','2008-03-12 19:15:09');
INSERT INTO ARTISTE VALUES(201,'','Crosby Stills Nash And Young','','2008-03-12 11:13:06');
INSERT INTO ARTISTE VALUES(202,'Neil','Young','','2008-03-12 15:08:50');
INSERT INTO ARTISTE VALUES(203,'','Throat Wobbler Mangrove','','2008-03-12 18:13:32');
INSERT INTO ARTISTE VALUES(204,'','Djurdjura','','2008-03-12 08:00:36');
INSERT INTO ARTISTE VALUES(205,'','Kadril','','2008-03-12 19:58:22');
INSERT INTO ARTISTE VALUES(206,'Vincent','Delerm','','2008-03-12 19:47:34');
INSERT INTO ARTISTE VALUES(207,'Alan','Stivell','','2008-03-12 08:03:52');
INSERT INTO ARTISTE VALUES(208,'','Laïs','','2008-03-12 09:42:08');
INSERT INTO ARTISTE VALUES(209,'Graeme','Allwright','','2008-03-12 19:03:40');
INSERT INTO ARTISTE VALUES(210,'William','Schotte','et Cie','2008-03-12 17:00:55');
INSERT INTO ARTISTE VALUES(211,'','Dan Ar Braz','','2008-03-12 19:18:09');
INSERT INTO ARTISTE VALUES(212,'The','Corrs','','2008-03-12 08:57:17');
INSERT INTO ARTISTE VALUES(213,'The','Pogues','','2008-03-12 19:50:31');
INSERT INTO ARTISTE VALUES(214,'','Idir','','2008-03-12 13:54:31');
INSERT INTO ARTISTE VALUES(215,'','Beau Dommage','','2008-03-12 08:51:29');
INSERT INTO ARTISTE VALUES(216,'Georges','Brassens','','2008-03-12 13:47:16');
INSERT INTO ARTISTE VALUES(217,'Duo','Bertrand','et Cie','2008-03-12 08:48:20');
INSERT INTO ARTISTE VALUES(218,'','Forzh penaos','','2008-03-12 18:56:02');
INSERT INTO ARTISTE VALUES(219,'Les','Trompettes du Mozambique','','2008-03-12 08:53:05');
INSERT INTO ARTISTE VALUES(220,'','Bagad Kemper','','2008-03-12 16:41:05');
INSERT INTO ARTISTE VALUES(221,'','Plantec','','2008-03-12 15:40:23');
INSERT INTO ARTISTE VALUES(222,'Yann Fanch','Kemener','& Aldo Ripoche','2008-03-12 17:45:21');
INSERT INTO ARTISTE VALUES(223,'','Gwendal','','2008-03-12 08:40:11');
INSERT INTO ARTISTE VALUES(224,'','Sonerien Du','','2008-03-12 15:07:05');
INSERT INTO ARTISTE VALUES(225,'Gilbert','Hervieux',' - Jacques Beauchamp - Job Defernez - Gwenn Dayot','2008-06-02 15:19:23.32262');
INSERT INTO ARTISTE VALUES(226,'','Malicorne','','2008-03-12 15:39:44');
INSERT INTO ARTISTE VALUES(227,'','Carré Manchot','','2008-03-12 18:40:33');
INSERT INTO ARTISTE VALUES(228,'','Bretagnes à Bercy','','2008-03-12 10:33:29');
INSERT INTO ARTISTE VALUES(229,'','Bagad Men Ha Tan','','2008-03-12 11:35:22');
INSERT INTO ARTISTE VALUES(230,'Gilles','Servat','','2008-03-12 12:16:04');
INSERT INTO ARTISTE VALUES(231,'','Bagad de Lann-Bihoué','','2008-03-12 13:54:44');
INSERT INTO ARTISTE VALUES(232,'Ar c''hoarezed','Goadeg','','2009-04-26 09:49:53.125174');
INSERT INTO ARTISTE VALUES(233,'Nolwenn','Korbell','','2008-03-12 10:45:10');
INSERT INTO ARTISTE VALUES(234,'','Bagad Kemperle','','2008-03-12 12:21:18');
INSERT INTO ARTISTE VALUES(235,'','Skolvan','','2008-03-12 13:27:30');
INSERT INTO ARTISTE VALUES(236,'','La musique bretonne','','2008-03-12 13:04:09');
INSERT INTO ARTISTE VALUES(237,'Yann Fanch','Kemener','','2008-03-12 10:56:49');
INSERT INTO ARTISTE VALUES(238,'Carlos','Nunez','','2008-03-12 16:10:22');
INSERT INTO ARTISTE VALUES(240,'Luc','Pilartz','','2008-03-12 15:46:14');
INSERT INTO ARTISTE VALUES(241,'','Holva Trio','','2008-03-12 16:12:09');
INSERT INTO ARTISTE VALUES(242,'Marie-Anne','Lagadic','et Klervi Rivière','2008-03-12 13:02:50');
INSERT INTO ARTISTE VALUES(244,'Cécile','Corbel','','2008-03-12 09:36:57');
INSERT INTO ARTISTE VALUES(246,'Eric','Gemsa','','2008-03-12 18:30:29');
INSERT INTO ARTISTE VALUES(247,'Duke','Ellington','','2008-03-12 08:41:26');
INSERT INTO ARTISTE VALUES(248,'Arthur','H','','2008-03-12 18:25:36');
INSERT INTO ARTISTE VALUES(249,'Louis','Armstrong','','2008-03-12 11:38:01');
INSERT INTO ARTISTE VALUES(250,'Michel','Godard','','2008-03-12 10:15:48');
INSERT INTO ARTISTE VALUES(251,'The','Police','','2008-03-12 13:56:00');
INSERT INTO ARTISTE VALUES(252,'Jacques','Brel','','2008-03-12 15:22:03');
INSERT INTO ARTISTE VALUES(253,'Maxime','Le Forestier','','2008-03-12 13:18:17');
INSERT INTO ARTISTE VALUES(254,'Alain','Souchon','','2008-03-12 09:24:53');
INSERT INTO ARTISTE VALUES(255,'Yann','Tiersen','','2008-03-12 08:48:58');
INSERT INTO ARTISTE VALUES(256,'Dick','Annegarn','','2008-03-12 13:43:29');
INSERT INTO ARTISTE VALUES(257,'Boby','Lapointe','','2008-03-12 19:47:11');
INSERT INTO ARTISTE VALUES(258,'Pascal','Comelade','','2008-03-12 13:40:36');
INSERT INTO ARTISTE VALUES(259,'Pierre','Desproges','','2008-03-12 08:57:15');
INSERT INTO ARTISTE VALUES(260,'Gérard','Manset','','2008-03-12 08:11:30');
INSERT INTO ARTISTE VALUES(262,'Françoise','Hardy','','2008-03-12 18:19:48');
INSERT INTO ARTISTE VALUES(263,'Daniel','Balavoine','','2008-06-02 14:09:30.241965');
INSERT INTO ARTISTE VALUES(264,'','Font et Val','','2009-04-26 12:37:08.932922');
INSERT INTO ARTISTE VALUES(265,'','Kommil Foo','','2008-03-12 09:57:19');
INSERT INTO ARTISTE VALUES(266,'','Varttinä','','2008-03-12 09:25:02');
INSERT INTO ARTISTE VALUES(267,'','Czerkinsky','','2008-03-12 15:24:49');
INSERT INTO ARTISTE VALUES(268,'Sandrine','Kiberlain','','2008-03-12 17:49:29');
INSERT INTO ARTISTE VALUES(269,'','Camille','','2008-03-12 12:51:26');
INSERT INTO ARTISTE VALUES(270,'Philippe','Léotard','','2008-03-12 15:55:38');
INSERT INTO ARTISTE VALUES(271,'Pierre','Vassiliu','','2008-03-12 09:47:19');
INSERT INTO ARTISTE VALUES(272,'Charles','Trénet','','2008-03-12 15:39:38');
INSERT INTO ARTISTE VALUES(273,'Ravi','Shankar','','2008-03-12 12:34:26');
INSERT INTO ARTISTE VALUES(274,'','Coluche','','2008-03-12 13:47:20');
INSERT INTO ARTISTE VALUES(275,'','Bénabar','','2008-03-12 08:54:17');
INSERT INTO ARTISTE VALUES(276,'François','Hadji-Lazaro','','2008-03-12 11:00:43');
INSERT INTO ARTISTE VALUES(281,'','Anouk (F)','','2008-03-12 12:35:07');
INSERT INTO ARTISTE VALUES(282,'Bob','Marley','& The Wailers','2008-03-12 10:22:57');
INSERT INTO ARTISTE VALUES(283,'Les','Charlots','','2008-03-12 16:45:48');
INSERT INTO ARTISTE VALUES(284,'Mike','Oldfield','','2008-03-12 09:24:44');
INSERT INTO ARTISTE VALUES(285,'','BPO - Karajan','','2008-03-12 17:32:31');
INSERT INTO ARTISTE VALUES(286,'Francis','Cabrel','','2008-04-14 09:07:10');
INSERT INTO ARTISTE VALUES(287,'','Kadril & Alumea','','2008-05-27 06:33:20.129149');
INSERT INTO ARTISTE VALUES(288,'','Kervegan''s','','2008-06-02 13:50:58.01438');
INSERT INTO ARTISTE VALUES(289,'','Choeur des moines de l''abbaye Saint-Pierre de Solesmes','','2008-06-02 14:45:10.37554');
INSERT INTO ARTISTE VALUES(290,'Jean-Jacques','Révillion','Mabidon et autres compagnons','2008-06-02 15:05:02.931439');
INSERT INTO ARTISTE VALUES(291,'','Ewen, Delahaye, Favennec','','2008-07-09 09:40:09.064735');
INSERT INTO ARTISTE VALUES(292,'Les','Suprèmes Dindes','','2008-07-12 07:40:45.729055');
INSERT INTO ARTISTE VALUES(293,'Les','Ramoneurs de Menhirs','','2009-02-15 16:46:28.655015');
INSERT INTO ARTISTE VALUES(294,'Thomas','Fersen ','','2009-02-15 17:51:00.416208');
INSERT INTO ARTISTE VALUES(295,'The','Sweet','','2009-02-15 18:03:39.09587');
INSERT INTO ARTISTE VALUES(296,'George','Harrison','','2009-02-15 18:15:32.441126');
INSERT INTO ARTISTE VALUES(297,'Maurice','Ravel','','2009-04-26 12:55:55.37743');
INSERT INTO ARTISTE VALUES(298,'Jimmy','Page','',NULL);
INSERT INTO ARTISTE VALUES(299,'Izzy','Stradlin','',NULL);
INSERT INTO ARTISTE VALUES(300,'Robert','Plant','',NULL);
INSERT INTO ARTISTE VALUES(301,'Aldo','Ripoche','',NULL);
INSERT INTO ARTISTE VALUES(302,'Gilbert','Hervieux','',NULL);
INSERT INTO ARTISTE VALUES(303,'Jacques','Beauchamp','',NULL);
INSERT INTO ARTISTE VALUES(304,'Job','Defernez','',NULL);
INSERT INTO ARTISTE VALUES(305,'Gwenn','Dayot','',NULL);
INSERT INTO ARTISTE VALUES(306,'John','Cale','',NULL);
INSERT INTO ARTISTE VALUES(307,'','Khaled','',NULL);
INSERT INTO ARTISTE VALUES(308,'','Faudel','',NULL);
INSERT INTO ARTISTE VALUES(309,'Marie-Anne','Lagadic','',NULL);
INSERT INTO ARTISTE VALUES(310,'Klervi','Rivière','',NULL);
INSERT INTO ARTISTE VALUES(311,'','Armens','',NULL);
INSERT INTO ARTISTE VALUES(312,'','Dan Ar Braz','Et L''héritage Des Celtes',NULL);
INSERT INTO ARTISTE VALUES(313,'','Gorky Park','',NULL);
INSERT INTO ARTISTE VALUES(314,'','Skid Row','',NULL);
INSERT INTO ARTISTE VALUES(315,'Ozzy','Osbourne','',NULL);
INSERT INTO ARTISTE VALUES(316,'','Motley Crue','',NULL);
INSERT INTO ARTISTE VALUES(317,'Bon','Jovi','',NULL);
INSERT INTO ARTISTE VALUES(318,'','Cinderella','',NULL);
INSERT INTO ARTISTE VALUES(319,'','Drum Madness','',NULL);
INSERT INTO ARTISTE VALUES(320,'','Floatsam and Jetsam','',NULL);
INSERT INTO ARTISTE VALUES(321,'','Fucky Pup','',NULL);
INSERT INTO ARTISTE VALUES(322,'','D.R.I.','',NULL);
INSERT INTO ARTISTE VALUES(323,'','Pestilence','',NULL);
INSERT INTO ARTISTE VALUES(324,'','Toxik','',NULL);
INSERT INTO ARTISTE VALUES(325,'','Paradox','',NULL);
INSERT INTO ARTISTE VALUES(326,'','Stormtroopers of Death','',NULL);
INSERT INTO ARTISTE VALUES(327,'','Acrophet','',NULL);
INSERT INTO ARTISTE VALUES(328,'','Gothic Slam','',NULL);
INSERT INTO ARTISTE VALUES(329,'','Slayer','',NULL);
INSERT INTO ARTISTE VALUES(330,'','Sacred Reich','',NULL);
INSERT INTO ARTISTE VALUES(331,'','Znowhite','',NULL);
INSERT INTO ARTISTE VALUES(332,'','Kat','',NULL);
INSERT INTO ARTISTE VALUES(333,'','Atrophy','',NULL);
INSERT INTO ARTISTE VALUES(334,'','Hades','',NULL);
INSERT INTO ARTISTE VALUES(335,'','Backsliders','',NULL);
INSERT INTO ARTISTE VALUES(336,'','Coma Ethylique','',NULL);
INSERT INTO ARTISTE VALUES(337,'Les','David Vincent','',NULL);
INSERT INTO ARTISTE VALUES(338,'','Eliot Ness','',NULL);
INSERT INTO ARTISTE VALUES(339,'','Jill and the Gun','',NULL);
INSERT INTO ARTISTE VALUES(340,'','Jivaro Quartet','',NULL);
INSERT INTO ARTISTE VALUES(341,'','Hanky Panky','',NULL);
INSERT INTO ARTISTE VALUES(342,'','Jive Turkey','',NULL);
INSERT INTO ARTISTE VALUES(343,'','Mister Moonlight','',NULL);
INSERT INTO ARTISTE VALUES(344,'','Modèle Martial','',NULL);
INSERT INTO ARTISTE VALUES(345,'The','Soap Eaters','',NULL);
INSERT INTO ARTISTE VALUES(346,'','Steamin'' Mushrooms','',NULL);
INSERT INTO ARTISTE VALUES(347,'','Nikki Sudden','',NULL);
INSERT INTO ARTISTE VALUES(348,'','Tison','',NULL);
INSERT INTO ARTISTE VALUES(349,'Les','Tontons Flingueurs','',NULL);
INSERT INTO ARTISTE VALUES(350,'','Woo Watchiz Ze Watchmain?','',NULL);
INSERT INTO ARTISTE VALUES(351,'','Wroomble Experience','',NULL);
INSERT INTO ARTISTE VALUES(352,'','Giant Sand','',NULL);
INSERT INTO ARTISTE VALUES(353,'The','Thrills','',NULL);
INSERT INTO ARTISTE VALUES(354,'Le','Tigre','',NULL);
INSERT INTO ARTISTE VALUES(355,'Nathaniel','Mayer','',NULL);
INSERT INTO ARTISTE VALUES(356,'The','Datsuns','',NULL);
INSERT INTO ARTISTE VALUES(357,'The','Dears','',NULL);
INSERT INTO ARTISTE VALUES(358,'The','Czars','',NULL);
INSERT INTO ARTISTE VALUES(359,'The','Detroit Cobras','',NULL);
INSERT INTO ARTISTE VALUES(360,'Aimee','Mann','',NULL);
INSERT INTO ARTISTE VALUES(361,'','Kasabian','',NULL);
INSERT INTO ARTISTE VALUES(362,'Stina','Nordenstam','',NULL);
INSERT INTO ARTISTE VALUES(363,'Jacqueline','Taïeb','',NULL);
INSERT INTO ARTISTE VALUES(364,'Jenifer','Jackson','',NULL);
INSERT INTO ARTISTE VALUES(365,'The','Methadones','',NULL);
INSERT INTO ARTISTE VALUES(366,'The','Polyphonic Spree','',NULL);
INSERT INTO ARTISTE VALUES(367,'','Midnight Movies','',NULL);
INSERT INTO ARTISTE VALUES(368,'Robert','Wyatt','',NULL);
INSERT INTO ARTISTE VALUES(369,'','Polmo Polpo','',NULL);
INSERT INTO ARTISTE VALUES(370,'','Motherkingdom','',NULL);
INSERT INTO ARTISTE VALUES(371,'','Honky Stomp','',NULL);
INSERT INTO ARTISTE VALUES(372,'','Eagle Of Death Metal','',NULL);
INSERT INTO ARTISTE VALUES(373,'','Naast','',NULL);
INSERT INTO ARTISTE VALUES(374,'','Danielson','',NULL);
INSERT INTO ARTISTE VALUES(375,'','Vanessa','& The O''s',NULL);
INSERT INTO ARTISTE VALUES(376,'The','Masons','',NULL);
INSERT INTO ARTISTE VALUES(377,'Ben','Kweller','',NULL);
INSERT INTO ARTISTE VALUES(378,'','Cirkus','',NULL);
INSERT INTO ARTISTE VALUES(379,'The','Walkmen','',NULL);
INSERT INTO ARTISTE VALUES(380,'Elli','Medeiros','',NULL);
INSERT INTO ARTISTE VALUES(381,'','Lambchop','',NULL);
INSERT INTO ARTISTE VALUES(382,'The','Elderberries','',NULL);
INSERT INTO ARTISTE VALUES(383,'','El Perro Del Mar','',NULL);
INSERT INTO ARTISTE VALUES(384,'','Twiggs','',NULL);
INSERT INTO ARTISTE VALUES(385,'Justine','Electra','',NULL);
INSERT INTO ARTISTE VALUES(386,'','ZZZ','',NULL);
INSERT INTO ARTISTE VALUES(387,'Frida','Hyvonen','',NULL);
INSERT INTO ARTISTE VALUES(388,'','Firebird','',NULL);
INSERT INTO ARTISTE VALUES(389,'','Eagle Seagull','',NULL);
INSERT INTO ARTISTE VALUES(390,'Chad','Vangaalen','',NULL);
INSERT INTO ARTISTE VALUES(391,'Olivier','Louvel','(de l''ONB)',NULL);
INSERT INTO ARTISTE VALUES(392,'','Tibet or not Tibet','',NULL);
INSERT INTO ARTISTE VALUES(393,'Raoul','Petite','',NULL);
INSERT INTO ARTISTE VALUES(394,'','Mister Gang','',NULL);
INSERT INTO ARTISTE VALUES(395,'','Lagony','',NULL);
INSERT INTO ARTISTE VALUES(396,'','Kovo et Berthy (7 Corrompus)','',NULL);
INSERT INTO ARTISTE VALUES(397,'','Bustafunk','',NULL);
INSERT INTO ARTISTE VALUES(398,'','Dead Pop Club','',NULL);
INSERT INTO ARTISTE VALUES(399,'','Hightone','',NULL);
INSERT INTO ARTISTE VALUES(400,'','Tiptop Taylor','',NULL);
INSERT INTO ARTISTE VALUES(401,'','Tenzin Gönpo','feat. Yangdu Tso',NULL);
INSERT INTO ARTISTE VALUES(402,'','Ceux qui marchent debout','',NULL);
INSERT INTO ARTISTE VALUES(403,'','Renega','',NULL);
INSERT INTO ARTISTE VALUES(404,'','Orange Blossom','',NULL);
INSERT INTO ARTISTE VALUES(405,'','Trigger','(Sleepers)',NULL);
INSERT INTO ARTISTE VALUES(406,'','Zenzile','',NULL);
INSERT INTO ARTISTE VALUES(407,'','Andy Emler et François Verly','',NULL);
INSERT INTO ARTISTE VALUES(408,'','Bagad Ronsed Mor','',NULL);
INSERT INTO ARTISTE VALUES(409,'','Bagad Saint-Nazer','',NULL);
INSERT INTO ARTISTE VALUES(410,'','Bagad Ar Meilhoù-Glaz','',NULL);
INSERT INTO ARTISTE VALUES(411,'','Bagad Bleimor','',NULL);
INSERT INTO ARTISTE VALUES(412,'','Kevrenn Alre','',NULL);
INSERT INTO ARTISTE VALUES(413,'','Bagad Cap Caval','',NULL);
INSERT INTO ARTISTE VALUES(414,'','Bagad Sonerien An Oriant','',NULL);
INSERT INTO ARTISTE VALUES(415,'','Bagad Quic-en Grogne','',NULL);
INSERT INTO ARTISTE VALUES(416,'','Kerlenn Pondi','',NULL);
INSERT INTO ARTISTE VALUES(417,'','Bagad Brieg','',NULL);
INSERT INTO ARTISTE VALUES(418,'','Bagad de Vannes','',NULL);
INSERT INTO ARTISTE VALUES(419,'','Bagad Bro Kemperle','',NULL);
INSERT INTO ARTISTE VALUES(420,'','Bagad Gwengamp','',NULL);
INSERT INTO ARTISTE VALUES(421,'','Bagad Beuzeg Ar C''Hab','',NULL);
INSERT INTO ARTISTE VALUES(422,'','Kevrenn Brest Saint Mark','',NULL);
INSERT INTO ARTISTE VALUES(423,'','Bagad Keriz','',NULL);
INSERT INTO ARTISTE VALUES(424,'','Kevrenn de Rennes','',NULL);
INSERT INTO ARTISTE VALUES(425,'','Dexy''s Midnight Runners','',NULL);
INSERT INTO ARTISTE VALUES(426,'','Celtas Cortos','',NULL);
INSERT INTO ARTISTE VALUES(427,'','Simple Minds','',NULL);
INSERT INTO ARTISTE VALUES(428,'Sharon','Shannon','',NULL);
INSERT INTO ARTISTE VALUES(429,'The','Levellers','',NULL);
INSERT INTO ARTISTE VALUES(430,'Shane','Mc Gowan','',NULL);
INSERT INTO ARTISTE VALUES(431,'Mary','Black','',NULL);
INSERT INTO ARTISTE VALUES(432,'','Cherish The Ladies','',NULL);
INSERT INTO ARTISTE VALUES(433,'','1691','',NULL);
INSERT INTO ARTISTE VALUES(434,'Ted','Fury','',NULL);
INSERT INTO ARTISTE VALUES(435,'','Lordryk','',NULL);
INSERT INTO ARTISTE VALUES(436,'','Castle Ceili Band','',NULL);
INSERT INTO ARTISTE VALUES(437,'Katell','Keineg','',NULL);
INSERT INTO ARTISTE VALUES(438,'The','Tanahill Weavers','',NULL);
INSERT INTO ARTISTE VALUES(439,'Ewan','Mc Coll','',NULL);
INSERT INTO ARTISTE VALUES(440,'','Er Melinerion','',NULL);
INSERT INTO ARTISTE VALUES(441,'','Tonymara','',NULL);
INSERT INTO ARTISTE VALUES(442,'','Planxty','',NULL);
INSERT INTO ARTISTE VALUES(443,'The','Waterboys','',NULL);
INSERT INTO ARTISTE VALUES(444,'','Clannad','avec Bono',NULL);
INSERT INTO ARTISTE VALUES(445,'','Diaouled Ar Menez','',NULL);
INSERT INTO ARTISTE VALUES(446,'','New Celeste','',NULL);
INSERT INTO ARTISTE VALUES(447,'','Van Morrison','',NULL);
INSERT INTO ARTISTE VALUES(448,'','Battlefield Band','',NULL);
INSERT INTO ARTISTE VALUES(449,'','Ar Re Yaouank','',NULL);
INSERT INTO ARTISTE VALUES(450,'Maire','Breenan','',NULL);
INSERT INTO ARTISTE VALUES(451,'The','Dublinners','',NULL);
INSERT INTO ARTISTE VALUES(452,'Mikael','Yaouank','',NULL);
INSERT INTO ARTISTE VALUES(453,'','EV','',NULL);
INSERT INTO ARTISTE VALUES(454,'','Boys of the lough','',NULL);
INSERT INTO ARTISTE VALUES(455,'','Kila','',NULL);
INSERT INTO ARTISTE VALUES(456,'','Storlok','',NULL);
INSERT INTO ARTISTE VALUES(457,'Paul','Brady','',NULL);
INSERT INTO ARTISTE VALUES(458,'Alain','Genty','',NULL);
INSERT INTO ARTISTE VALUES(459,'','Creepy Crawly Boys','',NULL);
INSERT INTO ARTISTE VALUES(460,'','Bohemian Heart','',NULL);
INSERT INTO ARTISTE VALUES(461,'Eliza','Carthy','',NULL);
INSERT INTO ARTISTE VALUES(462,'John B.','Sebastian','',NULL);
INSERT INTO ARTISTE VALUES(463,'','Canned Heat','',NULL);
INSERT INTO ARTISTE VALUES(464,'Richie','Havens','',NULL);
INSERT INTO ARTISTE VALUES(465,'','Country Joe McDonald','& The Fish',NULL);
INSERT INTO ARTISTE VALUES(466,'','Country Joe McDonald','',NULL);
INSERT INTO ARTISTE VALUES(467,'Arlo','Guthrie','',NULL);
INSERT INTO ARTISTE VALUES(468,'','Sha-Na-Na','',NULL);
INSERT INTO ARTISTE VALUES(469,'Joan','Baez','Featuring Jeffrey Shurtleff',NULL);
INSERT INTO ARTISTE VALUES(470,'Joan','Baez','',NULL);
INSERT INTO ARTISTE VALUES(471,'','Crosby Stills and Nash','',NULL);
INSERT INTO ARTISTE VALUES(472,'','Ten Years After','',NULL);
INSERT INTO ARTISTE VALUES(473,'','Santana','',NULL);
INSERT INTO ARTISTE VALUES(474,'Bruce','Springsteen','',NULL);
INSERT INTO ARTISTE VALUES(475,'Peter','Gabriel','',NULL);
INSERT INTO ARTISTE VALUES(476,'Pauletta','Washington','',NULL);
INSERT INTO ARTISTE VALUES(477,'','RAM','',NULL);
INSERT INTO ARTISTE VALUES(478,'','Spin Doctors','',NULL);
INSERT INTO ARTISTE VALUES(479,'','Indigo Girls','',NULL);
INSERT INTO ARTISTE VALUES(480,'Maria','Callas','',NULL);
INSERT INTO ARTISTE VALUES(481,'Howard','Shore','',NULL);
INSERT INTO ARTISTE VALUES(482,'','David Bowie & Trevor Jones','',NULL);
INSERT INTO ARTISTE VALUES(483,'Trevor','Jones','',NULL);
INSERT INTO ARTISTE VALUES(484,'Dahmane','El Harachi','',NULL);
INSERT INTO ARTISTE VALUES(485,'Slimane','Azem','',NULL);
INSERT INTO ARTISTE VALUES(486,'Enrico','Macias','',NULL);
INSERT INTO ARTISTE VALUES(487,'Cheb','Hasni','',NULL);
INSERT INTO ARTISTE VALUES(488,'Malika','Dom-Ran','',NULL);
INSERT INTO ARTISTE VALUES(489,'Bellemou','Messaoud','',NULL);
INSERT INTO ARTISTE VALUES(490,'Cheb','Mami','',NULL);
INSERT INTO ARTISTE VALUES(491,'Lili','Boniche','',NULL);
INSERT INTO ARTISTE VALUES(492,'Aït','Menguellet','',NULL);
INSERT INTO ARTISTE VALUES(493,'Rachid','Bahri','',NULL);
INSERT INTO ARTISTE VALUES(494,'Stephen','Gately','',NULL);
INSERT INTO ARTISTE VALUES(495,'The','Jam','',NULL);
INSERT INTO ARTISTE VALUES(496,'Eagle-Eye','Cherry','',NULL);
INSERT INTO ARTISTE VALUES(497,'The','Style Council','',NULL);
INSERT INTO ARTISTE VALUES(498,'Brian','Eno','',NULL);
INSERT INTO ARTISTE VALUES(499,'','Primal Scream','',NULL);
INSERT INTO ARTISTE VALUES(500,'','Sleeper','',NULL);
INSERT INTO ARTISTE VALUES(501,'','New Order','',NULL);
INSERT INTO ARTISTE VALUES(502,'','Pulp','',NULL);
INSERT INTO ARTISTE VALUES(503,'','Bedrock','',NULL);
INSERT INTO ARTISTE VALUES(504,'','Elastica','',NULL);
INSERT INTO ARTISTE VALUES(505,'','Leftfield','',NULL);
INSERT INTO ARTISTE VALUES(506,'','Underworld','',NULL);
INSERT INTO ARTISTE VALUES(507,'Damon','Albarn','',NULL);
INSERT INTO ARTISTE VALUES(508,'Joe','Cocker','',NULL);
INSERT INTO ARTISTE VALUES(509,'','Sly & The Family Stone','',NULL);
INSERT INTO ARTISTE VALUES(510,'','Butterfield Blues Band','',NULL);
INSERT INTO ARTISTE VALUES(511,'Vanessa','Daou','',NULL);
INSERT INTO ARTISTE VALUES(512,'Solomon','Burke','',NULL);
INSERT INTO ARTISTE VALUES(513,'Lenny','Kravitz','',NULL);
INSERT INTO ARTISTE VALUES(514,'Charly','Olleg','',NULL);
INSERT INTO ARTISTE VALUES(515,'','Toy','',NULL);
INSERT INTO ARTISTE VALUES(516,'','Akhénaton','',NULL);
INSERT INTO ARTISTE VALUES(517,'Joey','Starr','',NULL);
INSERT INTO ARTISTE VALUES(518,'','Attitude','',NULL);
INSERT INTO ARTISTE VALUES(519,'','Timbaland','',NULL);
INSERT INTO ARTISTE VALUES(520,'','Juanes','',NULL);
INSERT INTO ARTISTE VALUES(521,'Mike','Scott','',NULL);
INSERT INTO ARTISTE VALUES(522,'','Mister Mystery','',NULL);
INSERT INTO ARTISTE VALUES(523,'','DJ Ray','',NULL);
INSERT INTO ARTISTE VALUES(524,'','DJ Steve','',NULL);
INSERT INTO ARTISTE VALUES(525,'Buddy','Guy','',NULL);
INSERT INTO ARTISTE VALUES(526,'','Reggie','',NULL);
INSERT INTO ARTISTE VALUES(527,'Paul','Personne','',NULL);
INSERT INTO ARTISTE VALUES(528,'','Gaëlle','',NULL);
INSERT INTO ARTISTE VALUES(529,'Faf','Larage','',NULL);
INSERT INTO ARTISTE VALUES(530,'Johnny','Cash','',NULL);
INSERT INTO ARTISTE VALUES(531,'Jack','White','III',NULL);
INSERT INTO ARTISTE VALUES(532,'Christina','Aguilera','',NULL);
INSERT INTO ARTISTE VALUES(533,'Marianne','Faithfull','',NULL);
INSERT INTO ARTISTE VALUES(534,'','Dani','',NULL);
INSERT INTO ARTISTE VALUES(535,'Axelle','Red','',NULL);
INSERT INTO ARTISTE VALUES(536,'Brigitte','Bardot','',NULL);
INSERT INTO ARTISTE VALUES(537,'Serj','Tankian','',NULL);

INSERT INTO ETAT VALUES(1,'Neuf');
INSERT INTO ETAT VALUES(2,'Usagé');
INSERT INTO ETAT VALUES(3,'Endommagé');
INSERT INTO ETAT VALUES(4,'Détruit');

INSERT INTO GENRE VALUES(0,'Blues','2008-03-12 09:10:55');
INSERT INTO GENRE VALUES(1,'Classique','2009-04-26 12:55:55.360739');
INSERT INTO GENRE VALUES(2,'Rock','2009-06-04 17:33:12.781681');
INSERT INTO GENRE VALUES(3,'Folk','2009-04-26 09:49:53.121879');
INSERT INTO GENRE VALUES(4,'Jazz','2008-03-12 09:22:14');
INSERT INTO GENRE VALUES(5,'Français','2009-06-04 17:28:52.308347');
INSERT INTO GENRE VALUES(6,'New Age','2008-03-12 15:58:58');
INSERT INTO GENRE VALUES(7,'Humour','2009-04-26 12:37:08.931314');
INSERT INTO GENRE VALUES(8,'Reggae','2008-03-12 08:05:31');
INSERT INTO GENRE VALUES(9,'B.O.','2008-03-12 18:23:31');

INSERT INTO LANGUE VALUES('fr','Français');
INSERT INTO LANGUE VALUES('en','Anglais');
INSERT INTO LANGUE VALUES('de','Allemand');
INSERT INTO LANGUE VALUES('be','Berbère');
INSERT INTO LANGUE VALUES('br','Breton');
INSERT INTO LANGUE VALUES('es','Espagnol');
INSERT INTO LANGUE VALUES('la','Latin');
INSERT INTO LANGUE VALUES('nl','Néerlandais');
INSERT INTO LANGUE VALUES('fn','Finlandais');
INSERT INTO LANGUE VALUES('ar','Arabe');


INSERT INTO LANGUECHANSON VALUES('nl',11043,'t');
INSERT INTO LANGUECHANSON VALUES('en',11053,'t');
INSERT INTO LANGUECHANSON VALUES('en',11288,'t');
INSERT INTO LANGUECHANSON VALUES('en',4488,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11044,'t');
INSERT INTO LANGUECHANSON VALUES('en',11054,'t');
INSERT INTO LANGUECHANSON VALUES('en',11168,'t');
INSERT INTO LANGUECHANSON VALUES('en',4490,'t');
INSERT INTO LANGUECHANSON VALUES('en',126,'t');
INSERT INTO LANGUECHANSON VALUES('en',127,'t');
INSERT INTO LANGUECHANSON VALUES('en',128,'t');
INSERT INTO LANGUECHANSON VALUES('en',129,'t');
INSERT INTO LANGUECHANSON VALUES('en',130,'t');
INSERT INTO LANGUECHANSON VALUES('en',131,'t');
INSERT INTO LANGUECHANSON VALUES('en',132,'t');
INSERT INTO LANGUECHANSON VALUES('en',133,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11045,'t');
INSERT INTO LANGUECHANSON VALUES('en',4500,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11046,'t');
INSERT INTO LANGUECHANSON VALUES('en',1270,'t');
INSERT INTO LANGUECHANSON VALUES('en',11171,'t');
INSERT INTO LANGUECHANSON VALUES('en',4491,'t');
INSERT INTO LANGUECHANSON VALUES('en',11172,'t');
INSERT INTO LANGUECHANSON VALUES('en',11293,'t');
INSERT INTO LANGUECHANSON VALUES('en',4432,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11032,'t');
INSERT INTO LANGUECHANSON VALUES('en',11173,'t');
INSERT INTO LANGUECHANSON VALUES('en',4435,'t');
INSERT INTO LANGUECHANSON VALUES('en',11174,'t');
INSERT INTO LANGUECHANSON VALUES('en',4436,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11047,'t');
INSERT INTO LANGUECHANSON VALUES('en',11175,'t');
INSERT INTO LANGUECHANSON VALUES('en',11058,'t');
INSERT INTO LANGUECHANSON VALUES('en',11296,'t');
INSERT INTO LANGUECHANSON VALUES('en',3890,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11048,'t');
INSERT INTO LANGUECHANSON VALUES('en',11176,'t');
INSERT INTO LANGUECHANSON VALUES('en',3891,'t');
INSERT INTO LANGUECHANSON VALUES('en',11177,'t');
INSERT INTO LANGUECHANSON VALUES('en',3893,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11050,'t');
INSERT INTO LANGUECHANSON VALUES('en',11060,'t');
INSERT INTO LANGUECHANSON VALUES('en',11178,'t');
INSERT INTO LANGUECHANSON VALUES('en',11299,'t');
INSERT INTO LANGUECHANSON VALUES('en',1175,'t');
INSERT INTO LANGUECHANSON VALUES('en',1034,'t');
INSERT INTO LANGUECHANSON VALUES('en',11061,'t');
INSERT INTO LANGUECHANSON VALUES('en',11179,'t');
INSERT INTO LANGUECHANSON VALUES('en',11300,'t');
INSERT INTO LANGUECHANSON VALUES('en',1176,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1232,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11051,'t');
INSERT INTO LANGUECHANSON VALUES('en',11180,'t');
INSERT INTO LANGUECHANSON VALUES('en',1179,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11052,'t');
INSERT INTO LANGUECHANSON VALUES('en',11181,'t');
INSERT INTO LANGUECHANSON VALUES('en',11302,'t');
INSERT INTO LANGUECHANSON VALUES('en',2266,'t');
INSERT INTO LANGUECHANSON VALUES('en',1180,'t');
INSERT INTO LANGUECHANSON VALUES('en',11064,'t');
INSERT INTO LANGUECHANSON VALUES('en',11182,'t');
INSERT INTO LANGUECHANSON VALUES('en',11303,'t');
INSERT INTO LANGUECHANSON VALUES('en',1420,'t');
INSERT INTO LANGUECHANSON VALUES('en',1422,'t');
INSERT INTO LANGUECHANSON VALUES('en',11183,'t');
INSERT INTO LANGUECHANSON VALUES('en',11304,'t');
INSERT INTO LANGUECHANSON VALUES('en',1181,'t');
INSERT INTO LANGUECHANSON VALUES('en',4586,'t');
INSERT INTO LANGUECHANSON VALUES('en',11184,'t');
INSERT INTO LANGUECHANSON VALUES('en',1520,'t');
INSERT INTO LANGUECHANSON VALUES('en',11305,'t');
INSERT INTO LANGUECHANSON VALUES('en',1519,'t');
INSERT INTO LANGUECHANSON VALUES('en',11185,'t');
INSERT INTO LANGUECHANSON VALUES('en',11306,'t');
INSERT INTO LANGUECHANSON VALUES('en',1182,'t');
INSERT INTO LANGUECHANSON VALUES('en',2949,'t');
INSERT INTO LANGUECHANSON VALUES('en',11186,'t');
INSERT INTO LANGUECHANSON VALUES('en',11307,'t');
INSERT INTO LANGUECHANSON VALUES('en',1183,'t');
INSERT INTO LANGUECHANSON VALUES('en',1630,'t');
INSERT INTO LANGUECHANSON VALUES('en',1631,'t');
INSERT INTO LANGUECHANSON VALUES('en',1632,'t');
INSERT INTO LANGUECHANSON VALUES('en',1634,'t');
INSERT INTO LANGUECHANSON VALUES('en',1635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11556,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1640,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1641,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1643,'t');
INSERT INTO LANGUECHANSON VALUES('en',1644,'t');
INSERT INTO LANGUECHANSON VALUES('en',1646,'t');
INSERT INTO LANGUECHANSON VALUES('en',1647,'t');
INSERT INTO LANGUECHANSON VALUES('en',1648,'t');
INSERT INTO LANGUECHANSON VALUES('en',1649,'t');
INSERT INTO LANGUECHANSON VALUES('en',1676,'t');
INSERT INTO LANGUECHANSON VALUES('en',11069,'t');
INSERT INTO LANGUECHANSON VALUES('en',11187,'t');
INSERT INTO LANGUECHANSON VALUES('en',11308,'t');
INSERT INTO LANGUECHANSON VALUES('en',3550,'t');
INSERT INTO LANGUECHANSON VALUES('en',11070,'t');
INSERT INTO LANGUECHANSON VALUES('en',11188,'t');
INSERT INTO LANGUECHANSON VALUES('en',11309,'t');
INSERT INTO LANGUECHANSON VALUES('en',3551,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1787,'t');
INSERT INTO LANGUECHANSON VALUES('en',11071,'t');
INSERT INTO LANGUECHANSON VALUES('en',11189,'t');
INSERT INTO LANGUECHANSON VALUES('en',4486,'t');
INSERT INTO LANGUECHANSON VALUES('en',11190,'t');
INSERT INTO LANGUECHANSON VALUES('en',11072,'t');
INSERT INTO LANGUECHANSON VALUES('en',11311,'t');
INSERT INTO LANGUECHANSON VALUES('en',2175,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1856,'t');
INSERT INTO LANGUECHANSON VALUES('en',2176,'t');
INSERT INTO LANGUECHANSON VALUES('en',1913,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1917,'t');
INSERT INTO LANGUECHANSON VALUES('en',11192,'t');
INSERT INTO LANGUECHANSON VALUES('en',11074,'t');
INSERT INTO LANGUECHANSON VALUES('en',2177,'t');
INSERT INTO LANGUECHANSON VALUES('en',1947,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11557,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1945,'t');
INSERT INTO LANGUECHANSON VALUES('en',1946,'t');
INSERT INTO LANGUECHANSON VALUES('en',11193,'t');
INSERT INTO LANGUECHANSON VALUES('en',11075,'t');
INSERT INTO LANGUECHANSON VALUES('en',2015,'t');
INSERT INTO LANGUECHANSON VALUES('en',2016,'t');
INSERT INTO LANGUECHANSON VALUES('en',2018,'t');
INSERT INTO LANGUECHANSON VALUES('en',2019,'t');
INSERT INTO LANGUECHANSON VALUES('en',2020,'t');
INSERT INTO LANGUECHANSON VALUES('en',2022,'t');
INSERT INTO LANGUECHANSON VALUES('en',2023,'t');
INSERT INTO LANGUECHANSON VALUES('en',2025,'t');
INSERT INTO LANGUECHANSON VALUES('en',11076,'t');
INSERT INTO LANGUECHANSON VALUES('en',11194,'t');
INSERT INTO LANGUECHANSON VALUES('en',11315,'t');
INSERT INTO LANGUECHANSON VALUES('en',2178,'t');
INSERT INTO LANGUECHANSON VALUES('en',3337,'t');
INSERT INTO LANGUECHANSON VALUES('en',3295,'t');
INSERT INTO LANGUECHANSON VALUES('en',2179,'t');
INSERT INTO LANGUECHANSON VALUES('en',2130,'t');
INSERT INTO LANGUECHANSON VALUES('en',2131,'t');
INSERT INTO LANGUECHANSON VALUES('en',11078,'t');
INSERT INTO LANGUECHANSON VALUES('en',3341,'t');
INSERT INTO LANGUECHANSON VALUES('en',3832,'t');
INSERT INTO LANGUECHANSON VALUES('en',4427,'t');
INSERT INTO LANGUECHANSON VALUES('en',2173,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2220,'t');
INSERT INTO LANGUECHANSON VALUES('en',2905,'t');
INSERT INTO LANGUECHANSON VALUES('en',2507,'t');
INSERT INTO LANGUECHANSON VALUES('en',2731,'t');
INSERT INTO LANGUECHANSON VALUES('en',4415,'t');
INSERT INTO LANGUECHANSON VALUES('en',6501,'t');
INSERT INTO LANGUECHANSON VALUES('en',119,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11036,'t');
INSERT INTO LANGUECHANSON VALUES('en',1636,'t');
INSERT INTO LANGUECHANSON VALUES('en',2722,'t');
INSERT INTO LANGUECHANSON VALUES('en',1534,'t');
INSERT INTO LANGUECHANSON VALUES('en',4214,'t');
INSERT INTO LANGUECHANSON VALUES('en',1914,'t');
INSERT INTO LANGUECHANSON VALUES('en',3730,'t');
INSERT INTO LANGUECHANSON VALUES('en',4366,'t');
INSERT INTO LANGUECHANSON VALUES('en',4208,'t');
INSERT INTO LANGUECHANSON VALUES('en',10987,'t');
INSERT INTO LANGUECHANSON VALUES('en',2909,'t');
INSERT INTO LANGUECHANSON VALUES('en',5509,'t');
INSERT INTO LANGUECHANSON VALUES('en',2726,'t');
INSERT INTO LANGUECHANSON VALUES('en',2728,'t');
INSERT INTO LANGUECHANSON VALUES('en',4212,'t');
INSERT INTO LANGUECHANSON VALUES('en',2720,'t');
INSERT INTO LANGUECHANSON VALUES('en',11124,'t');
INSERT INTO LANGUECHANSON VALUES('en',2385,'t');
INSERT INTO LANGUECHANSON VALUES('en',2327,'t');
INSERT INTO LANGUECHANSON VALUES('en',11081,'t');
INSERT INTO LANGUECHANSON VALUES('en',11316,'t');
INSERT INTO LANGUECHANSON VALUES('en',4148,'t');
INSERT INTO LANGUECHANSON VALUES('en',2400,'t');
INSERT INTO LANGUECHANSON VALUES('en',2401,'t');
INSERT INTO LANGUECHANSON VALUES('en',2402,'t');
INSERT INTO LANGUECHANSON VALUES('en',2403,'t');
INSERT INTO LANGUECHANSON VALUES('en',2404,'t');
INSERT INTO LANGUECHANSON VALUES('en',2406,'t');
INSERT INTO LANGUECHANSON VALUES('en',2408,'t');
INSERT INTO LANGUECHANSON VALUES('en',2409,'t');
INSERT INTO LANGUECHANSON VALUES('en',2412,'t');
INSERT INTO LANGUECHANSON VALUES('en',2413,'t');
INSERT INTO LANGUECHANSON VALUES('en',2414,'t');
INSERT INTO LANGUECHANSON VALUES('en',2415,'t');
INSERT INTO LANGUECHANSON VALUES('en',2416,'t');
INSERT INTO LANGUECHANSON VALUES('en',2417,'t');
INSERT INTO LANGUECHANSON VALUES('en',2418,'t');
INSERT INTO LANGUECHANSON VALUES('en',2419,'t');
INSERT INTO LANGUECHANSON VALUES('en',2420,'t');
INSERT INTO LANGUECHANSON VALUES('en',2421,'t');
INSERT INTO LANGUECHANSON VALUES('en',2422,'t');
INSERT INTO LANGUECHANSON VALUES('en',2423,'t');
INSERT INTO LANGUECHANSON VALUES('en',2424,'t');
INSERT INTO LANGUECHANSON VALUES('en',11083,'t');
INSERT INTO LANGUECHANSON VALUES('en',11318,'t');
INSERT INTO LANGUECHANSON VALUES('en',1184,'t');
INSERT INTO LANGUECHANSON VALUES('en',5515,'t');
INSERT INTO LANGUECHANSON VALUES('en',11319,'t');
INSERT INTO LANGUECHANSON VALUES('en',1186,'t');
INSERT INTO LANGUECHANSON VALUES('en',11085,'t');
INSERT INTO LANGUECHANSON VALUES('en',1187,'t');
INSERT INTO LANGUECHANSON VALUES('en',2615,'t');
INSERT INTO LANGUECHANSON VALUES('en',2616,'t');
INSERT INTO LANGUECHANSON VALUES('en',2617,'t');
INSERT INTO LANGUECHANSON VALUES('en',2618,'t');
INSERT INTO LANGUECHANSON VALUES('en',2620,'t');
INSERT INTO LANGUECHANSON VALUES('en',11086,'t');
INSERT INTO LANGUECHANSON VALUES('en',3343,'t');
INSERT INTO LANGUECHANSON VALUES('en',2683,'t');
INSERT INTO LANGUECHANSON VALUES('en',2684,'t');
INSERT INTO LANGUECHANSON VALUES('en',2685,'t');
INSERT INTO LANGUECHANSON VALUES('en',1188,'t');
INSERT INTO LANGUECHANSON VALUES('en',2687,'t');
INSERT INTO LANGUECHANSON VALUES('en',2688,'t');
INSERT INTO LANGUECHANSON VALUES('en',11087,'t');
INSERT INTO LANGUECHANSON VALUES('en',2730,'t');
INSERT INTO LANGUECHANSON VALUES('en',2734,'t');
INSERT INTO LANGUECHANSON VALUES('en',3344,'t');
INSERT INTO LANGUECHANSON VALUES('en',1189,'t');
INSERT INTO LANGUECHANSON VALUES('en',2751,'t');
INSERT INTO LANGUECHANSON VALUES('en',2753,'t');
INSERT INTO LANGUECHANSON VALUES('en',2754,'t');
INSERT INTO LANGUECHANSON VALUES('en',2755,'t');
INSERT INTO LANGUECHANSON VALUES('en',3345,'t');
INSERT INTO LANGUECHANSON VALUES('en',1190,'t');
INSERT INTO LANGUECHANSON VALUES('en',3346,'t');
INSERT INTO LANGUECHANSON VALUES('en',2830,'t');
INSERT INTO LANGUECHANSON VALUES('en',2835,'t');
INSERT INTO LANGUECHANSON VALUES('en',2837,'t');
INSERT INTO LANGUECHANSON VALUES('en',2839,'t');
INSERT INTO LANGUECHANSON VALUES('en',3347,'t');
INSERT INTO LANGUECHANSON VALUES('en',1192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2847,'t');
INSERT INTO LANGUECHANSON VALUES('en',1280,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2853,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2856,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2859,'t');
INSERT INTO LANGUECHANSON VALUES('en',3348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2912,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2913,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2914,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2915,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2916,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2917,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2918,'t');
INSERT INTO LANGUECHANSON VALUES('en',1978,'t');
INSERT INTO LANGUECHANSON VALUES('en',2962,'t');
INSERT INTO LANGUECHANSON VALUES('en',1536,'t');
INSERT INTO LANGUECHANSON VALUES('en',3028,'t');
INSERT INTO LANGUECHANSON VALUES('en',3030,'t');
INSERT INTO LANGUECHANSON VALUES('en',3031,'t');
INSERT INTO LANGUECHANSON VALUES('en',3032,'t');
INSERT INTO LANGUECHANSON VALUES('en',3033,'t');
INSERT INTO LANGUECHANSON VALUES('en',3034,'t');
INSERT INTO LANGUECHANSON VALUES('en',3035,'t');
INSERT INTO LANGUECHANSON VALUES('en',2950,'t');
INSERT INTO LANGUECHANSON VALUES('en',3542,'t');
INSERT INTO LANGUECHANSON VALUES('en',2951,'t');
INSERT INTO LANGUECHANSON VALUES('en',3543,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3270,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3271,'t');
INSERT INTO LANGUECHANSON VALUES('en',2952,'t');
INSERT INTO LANGUECHANSON VALUES('en',3544,'t');
INSERT INTO LANGUECHANSON VALUES('en',11100,'t');
INSERT INTO LANGUECHANSON VALUES('en',2953,'t');
INSERT INTO LANGUECHANSON VALUES('en',3546,'t');
INSERT INTO LANGUECHANSON VALUES('en',3385,'t');
INSERT INTO LANGUECHANSON VALUES('en',3379,'t');
INSERT INTO LANGUECHANSON VALUES('en',3384,'t');
INSERT INTO LANGUECHANSON VALUES('en',3386,'t');
INSERT INTO LANGUECHANSON VALUES('en',3383,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3372,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3373,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3374,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3387,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3388,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3389,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3390,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3391,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3392,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3393,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3394,'t');
INSERT INTO LANGUECHANSON VALUES('en',2955,'t');
INSERT INTO LANGUECHANSON VALUES('en',3440,'t');
INSERT INTO LANGUECHANSON VALUES('en',3441,'t');
INSERT INTO LANGUECHANSON VALUES('en',3442,'t');
INSERT INTO LANGUECHANSON VALUES('en',3443,'t');
INSERT INTO LANGUECHANSON VALUES('en',3444,'t');
INSERT INTO LANGUECHANSON VALUES('en',3445,'t');
INSERT INTO LANGUECHANSON VALUES('en',3447,'t');
INSERT INTO LANGUECHANSON VALUES('en',3448,'t');
INSERT INTO LANGUECHANSON VALUES('en',3449,'t');
INSERT INTO LANGUECHANSON VALUES('en',3450,'t');
INSERT INTO LANGUECHANSON VALUES('en',3451,'t');
INSERT INTO LANGUECHANSON VALUES('en',3454,'t');
INSERT INTO LANGUECHANSON VALUES('en',3455,'t');
INSERT INTO LANGUECHANSON VALUES('en',3456,'t');
INSERT INTO LANGUECHANSON VALUES('en',2956,'t');
INSERT INTO LANGUECHANSON VALUES('en',2957,'t');
INSERT INTO LANGUECHANSON VALUES('en',2170,'t');
INSERT INTO LANGUECHANSON VALUES('en',3630,'t');
INSERT INTO LANGUECHANSON VALUES('en',3631,'t');
INSERT INTO LANGUECHANSON VALUES('en',3632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3636,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3640,'t');
INSERT INTO LANGUECHANSON VALUES('en',11105,'t');
INSERT INTO LANGUECHANSON VALUES('en',2958,'t');
INSERT INTO LANGUECHANSON VALUES('en',2171,'t');
INSERT INTO LANGUECHANSON VALUES('en',3712,'t');
INSERT INTO LANGUECHANSON VALUES('en',11106,'t');
INSERT INTO LANGUECHANSON VALUES('en',1980,'t');
INSERT INTO LANGUECHANSON VALUES('en',2172,'t');
INSERT INTO LANGUECHANSON VALUES('en',3749,'t');
INSERT INTO LANGUECHANSON VALUES('en',3750,'t');
INSERT INTO LANGUECHANSON VALUES('en',3751,'t');
INSERT INTO LANGUECHANSON VALUES('en',3752,'t');
INSERT INTO LANGUECHANSON VALUES('en',3753,'t');
INSERT INTO LANGUECHANSON VALUES('en',3754,'t');
INSERT INTO LANGUECHANSON VALUES('en',3755,'t');
INSERT INTO LANGUECHANSON VALUES('en',1981,'t');
INSERT INTO LANGUECHANSON VALUES('en',11107,'t');
INSERT INTO LANGUECHANSON VALUES('en',2174,'t');
INSERT INTO LANGUECHANSON VALUES('en',4210,'t');
INSERT INTO LANGUECHANSON VALUES('en',5340,'t');
INSERT INTO LANGUECHANSON VALUES('en',2453,'t');
INSERT INTO LANGUECHANSON VALUES('en',10985,'t');
INSERT INTO LANGUECHANSON VALUES('en',1209,'t');
INSERT INTO LANGUECHANSON VALUES('en',1544,'t');
INSERT INTO LANGUECHANSON VALUES('en',2902,'t');
INSERT INTO LANGUECHANSON VALUES('en',1562,'t');
INSERT INTO LANGUECHANSON VALUES('en',1560,'t');
INSERT INTO LANGUECHANSON VALUES('en',1564,'t');
INSERT INTO LANGUECHANSON VALUES('en',4209,'t');
INSERT INTO LANGUECHANSON VALUES('en',11122,'t');
INSERT INTO LANGUECHANSON VALUES('en',3342,'t');
INSERT INTO LANGUECHANSON VALUES('en',2478,'t');
INSERT INTO LANGUECHANSON VALUES('en',2476,'t');
INSERT INTO LANGUECHANSON VALUES('en',11156,'t');
INSERT INTO LANGUECHANSON VALUES('en',1549,'t');
INSERT INTO LANGUECHANSON VALUES('en',3562,'t');
INSERT INTO LANGUECHANSON VALUES('en',1281,'t');
INSERT INTO LANGUECHANSON VALUES('en',1986,'t');
INSERT INTO LANGUECHANSON VALUES('en',11109,'t');
INSERT INTO LANGUECHANSON VALUES('en',1987,'t');
INSERT INTO LANGUECHANSON VALUES('en',2210,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3871,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3872,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3873,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3874,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3875,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3876,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3877,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3878,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3879,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3880,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3881,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3882,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3883,'t');
INSERT INTO LANGUECHANSON VALUES('en',11110,'t');
INSERT INTO LANGUECHANSON VALUES('en',1988,'t');
INSERT INTO LANGUECHANSON VALUES('en',4037,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3932,'t');
INSERT INTO LANGUECHANSON VALUES('en',3917,'t');
INSERT INTO LANGUECHANSON VALUES('en',3919,'t');
INSERT INTO LANGUECHANSON VALUES('en',3920,'t');
INSERT INTO LANGUECHANSON VALUES('en',3921,'t');
INSERT INTO LANGUECHANSON VALUES('en',3922,'t');
INSERT INTO LANGUECHANSON VALUES('en',3923,'t');
INSERT INTO LANGUECHANSON VALUES('en',3924,'t');
INSERT INTO LANGUECHANSON VALUES('en',3925,'t');
INSERT INTO LANGUECHANSON VALUES('en',3926,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3927,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3928,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3929,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3930,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3931,'t');
INSERT INTO LANGUECHANSON VALUES('en',11111,'t');
INSERT INTO LANGUECHANSON VALUES('en',2938,'t');
INSERT INTO LANGUECHANSON VALUES('en',3788,'t');
INSERT INTO LANGUECHANSON VALUES('en',11112,'t');
INSERT INTO LANGUECHANSON VALUES('en',2940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4066,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4067,'t');
INSERT INTO LANGUECHANSON VALUES('en',3790,'t');
INSERT INTO LANGUECHANSON VALUES('en',4154,'t');
INSERT INTO LANGUECHANSON VALUES('en',4155,'t');
INSERT INTO LANGUECHANSON VALUES('en',4162,'t');
INSERT INTO LANGUECHANSON VALUES('en',4163,'t');
INSERT INTO LANGUECHANSON VALUES('en',4164,'t');
INSERT INTO LANGUECHANSON VALUES('en',4165,'t');
INSERT INTO LANGUECHANSON VALUES('en',4166,'t');
INSERT INTO LANGUECHANSON VALUES('en',4167,'t');
INSERT INTO LANGUECHANSON VALUES('en',4168,'t');
INSERT INTO LANGUECHANSON VALUES('en',4169,'t');
INSERT INTO LANGUECHANSON VALUES('en',4170,'t');
INSERT INTO LANGUECHANSON VALUES('en',4171,'t');
INSERT INTO LANGUECHANSON VALUES('en',4172,'t');
INSERT INTO LANGUECHANSON VALUES('en',2941,'t');
INSERT INTO LANGUECHANSON VALUES('en',3792,'t');
INSERT INTO LANGUECHANSON VALUES('en',4181,'t');
INSERT INTO LANGUECHANSON VALUES('en',4182,'t');
INSERT INTO LANGUECHANSON VALUES('en',4183,'t');
INSERT INTO LANGUECHANSON VALUES('en',4184,'t');
INSERT INTO LANGUECHANSON VALUES('en',4185,'t');
INSERT INTO LANGUECHANSON VALUES('en',4186,'t');
INSERT INTO LANGUECHANSON VALUES('en',4187,'t');
INSERT INTO LANGUECHANSON VALUES('en',4188,'t');
INSERT INTO LANGUECHANSON VALUES('en',2942,'t');
INSERT INTO LANGUECHANSON VALUES('en',3793,'t');
INSERT INTO LANGUECHANSON VALUES('en',4245,'t');
INSERT INTO LANGUECHANSON VALUES('en',4246,'t');
INSERT INTO LANGUECHANSON VALUES('en',4247,'t');
INSERT INTO LANGUECHANSON VALUES('en',4248,'t');
INSERT INTO LANGUECHANSON VALUES('en',2943,'t');
INSERT INTO LANGUECHANSON VALUES('en',4299,'t');
INSERT INTO LANGUECHANSON VALUES('en',4301,'t');
INSERT INTO LANGUECHANSON VALUES('en',4297,'t');
INSERT INTO LANGUECHANSON VALUES('en',4298,'t');
INSERT INTO LANGUECHANSON VALUES('en',4296,'t');
INSERT INTO LANGUECHANSON VALUES('en',11117,'t');
INSERT INTO LANGUECHANSON VALUES('en',2944,'t');
INSERT INTO LANGUECHANSON VALUES('en',4321,'t');
INSERT INTO LANGUECHANSON VALUES('en',11118,'t');
INSERT INTO LANGUECHANSON VALUES('en',2204,'t');
INSERT INTO LANGUECHANSON VALUES('en',3791,'t');
INSERT INTO LANGUECHANSON VALUES('en',1195,'t');
INSERT INTO LANGUECHANSON VALUES('en',11120,'t');
INSERT INTO LANGUECHANSON VALUES('en',2206,'t');
INSERT INTO LANGUECHANSON VALUES('en',1277,'t');
INSERT INTO LANGUECHANSON VALUES('en',4448,'t');
INSERT INTO LANGUECHANSON VALUES('en',4449,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4455,'t');
INSERT INTO LANGUECHANSON VALUES('en',2208,'t');
INSERT INTO LANGUECHANSON VALUES('en',1278,'t');
INSERT INTO LANGUECHANSON VALUES('en',2209,'t');
INSERT INTO LANGUECHANSON VALUES('en',1279,'t');
INSERT INTO LANGUECHANSON VALUES('en',11123,'t');
INSERT INTO LANGUECHANSON VALUES('en',4158,'t');
INSERT INTO LANGUECHANSON VALUES('en',4684,'t');
INSERT INTO LANGUECHANSON VALUES('en',4771,'t');
INSERT INTO LANGUECHANSON VALUES('en',4772,'t');
INSERT INTO LANGUECHANSON VALUES('en',4773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4776,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4778,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4780,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4781,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4782,'t');
INSERT INTO LANGUECHANSON VALUES('en',4333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4797,'t');
INSERT INTO LANGUECHANSON VALUES('en',2678,'t');
INSERT INTO LANGUECHANSON VALUES('en',2679,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4831,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4833,'t');
INSERT INTO LANGUECHANSON VALUES('en',4672,'t');
INSERT INTO LANGUECHANSON VALUES('en',2258,'t');
INSERT INTO LANGUECHANSON VALUES('en',4685,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4859,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4860,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4861,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4862,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4863,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4864,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4865,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4866,'t');
INSERT INTO LANGUECHANSON VALUES('en',2260,'t');
INSERT INTO LANGUECHANSON VALUES('en',4031,'t');
INSERT INTO LANGUECHANSON VALUES('en',1983,'t');
INSERT INTO LANGUECHANSON VALUES('en',4033,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4881,'t');
INSERT INTO LANGUECHANSON VALUES('en',1471,'t');
INSERT INTO LANGUECHANSON VALUES('en',3965,'t');
INSERT INTO LANGUECHANSON VALUES('en',1472,'t');
INSERT INTO LANGUECHANSON VALUES('en',1473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4899,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4901,'t');
INSERT INTO LANGUECHANSON VALUES('en',1474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4909,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4910,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4911,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4912,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4913,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4916,'t');
INSERT INTO LANGUECHANSON VALUES('en',1475,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4936,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4941,'t');
INSERT INTO LANGUECHANSON VALUES('en',2727,'t');
INSERT INTO LANGUECHANSON VALUES('en',1985,'t');
INSERT INTO LANGUECHANSON VALUES('en',4338,'t');
INSERT INTO LANGUECHANSON VALUES('en',4279,'t');
INSERT INTO LANGUECHANSON VALUES('en',1984,'t');
INSERT INTO LANGUECHANSON VALUES('en',1136,'t');
INSERT INTO LANGUECHANSON VALUES('en',3903,'t');
INSERT INTO LANGUECHANSON VALUES('en',2723,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4828,'t');
INSERT INTO LANGUECHANSON VALUES('en',3706,'t');
INSERT INTO LANGUECHANSON VALUES('en',2569,'t');
INSERT INTO LANGUECHANSON VALUES('en',4324,'t');
INSERT INTO LANGUECHANSON VALUES('en',11136,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4967,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4974,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4977,'t');
INSERT INTO LANGUECHANSON VALUES('en',2217,'t');
INSERT INTO LANGUECHANSON VALUES('en',4985,'t');
INSERT INTO LANGUECHANSON VALUES('en',4986,'t');
INSERT INTO LANGUECHANSON VALUES('en',4987,'t');
INSERT INTO LANGUECHANSON VALUES('en',4988,'t');
INSERT INTO LANGUECHANSON VALUES('en',4989,'t');
INSERT INTO LANGUECHANSON VALUES('en',4990,'t');
INSERT INTO LANGUECHANSON VALUES('en',11139,'t');
INSERT INTO LANGUECHANSON VALUES('en',2373,'t');
INSERT INTO LANGUECHANSON VALUES('en',2374,'t');
INSERT INTO LANGUECHANSON VALUES('en',2375,'t');
INSERT INTO LANGUECHANSON VALUES('en',4598,'t');
INSERT INTO LANGUECHANSON VALUES('en',2376,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5264,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5266,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5269,'t');
INSERT INTO LANGUECHANSON VALUES('en',5270,'t');
INSERT INTO LANGUECHANSON VALUES('en',5271,'t');
INSERT INTO LANGUECHANSON VALUES('en',5272,'t');
INSERT INTO LANGUECHANSON VALUES('en',5273,'t');
INSERT INTO LANGUECHANSON VALUES('en',5274,'t');
INSERT INTO LANGUECHANSON VALUES('en',5275,'t');
INSERT INTO LANGUECHANSON VALUES('en',5276,'t');
INSERT INTO LANGUECHANSON VALUES('en',5277,'t');
INSERT INTO LANGUECHANSON VALUES('en',5278,'t');
INSERT INTO LANGUECHANSON VALUES('en',5279,'t');
INSERT INTO LANGUECHANSON VALUES('en',5280,'t');
INSERT INTO LANGUECHANSON VALUES('en',5281,'t');
INSERT INTO LANGUECHANSON VALUES('en',11143,'t');
INSERT INTO LANGUECHANSON VALUES('en',4601,'t');
INSERT INTO LANGUECHANSON VALUES('en',1468,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5361,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5363,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5367,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5369,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5372,'t');
INSERT INTO LANGUECHANSON VALUES('en',4603,'t');
INSERT INTO LANGUECHANSON VALUES('en',1469,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5397,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5399,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5407,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5408,'t');
INSERT INTO LANGUECHANSON VALUES('en',5409,'t');
INSERT INTO LANGUECHANSON VALUES('en',5410,'t');
INSERT INTO LANGUECHANSON VALUES('en',1470,'t');
INSERT INTO LANGUECHANSON VALUES('en',11146,'t');
INSERT INTO LANGUECHANSON VALUES('en',1267,'t');
INSERT INTO LANGUECHANSON VALUES('en',3784,'t');
INSERT INTO LANGUECHANSON VALUES('en',5502,'t');
INSERT INTO LANGUECHANSON VALUES('en',5503,'t');
INSERT INTO LANGUECHANSON VALUES('en',5504,'t');
INSERT INTO LANGUECHANSON VALUES('en',11147,'t');
INSERT INTO LANGUECHANSON VALUES('en',1268,'t');
INSERT INTO LANGUECHANSON VALUES('en',3787,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5530,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5532,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5533,'t');
INSERT INTO LANGUECHANSON VALUES('en',1033,'t');
INSERT INTO LANGUECHANSON VALUES('en',5583,'t');
INSERT INTO LANGUECHANSON VALUES('en',3232,'t');
INSERT INTO LANGUECHANSON VALUES('en',5580,'t');
INSERT INTO LANGUECHANSON VALUES('en',3418,'t');
INSERT INTO LANGUECHANSON VALUES('en',5640,'t');
INSERT INTO LANGUECHANSON VALUES('en',5641,'t');
INSERT INTO LANGUECHANSON VALUES('en',5642,'t');
INSERT INTO LANGUECHANSON VALUES('en',5643,'t');
INSERT INTO LANGUECHANSON VALUES('en',5644,'t');
INSERT INTO LANGUECHANSON VALUES('en',5645,'t');
INSERT INTO LANGUECHANSON VALUES('en',5646,'t');
INSERT INTO LANGUECHANSON VALUES('en',5647,'t');
INSERT INTO LANGUECHANSON VALUES('en',4496,'t');
INSERT INTO LANGUECHANSON VALUES('en',5729,'t');
INSERT INTO LANGUECHANSON VALUES('en',5730,'t');
INSERT INTO LANGUECHANSON VALUES('en',5731,'t');
INSERT INTO LANGUECHANSON VALUES('en',5732,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5733,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5734,'t');
INSERT INTO LANGUECHANSON VALUES('en',4035,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5776,'t');
INSERT INTO LANGUECHANSON VALUES('en',4038,'t');
INSERT INTO LANGUECHANSON VALUES('en',11153,'t');
INSERT INTO LANGUECHANSON VALUES('en',2009,'t');
INSERT INTO LANGUECHANSON VALUES('en',4040,'t');
INSERT INTO LANGUECHANSON VALUES('en',5842,'t');
INSERT INTO LANGUECHANSON VALUES('en',5843,'t');
INSERT INTO LANGUECHANSON VALUES('en',5846,'t');
INSERT INTO LANGUECHANSON VALUES('en',5849,'t');
INSERT INTO LANGUECHANSON VALUES('en',2013,'t');
INSERT INTO LANGUECHANSON VALUES('en',5887,'t');
INSERT INTO LANGUECHANSON VALUES('en',5894,'t');
INSERT INTO LANGUECHANSON VALUES('en',5893,'t');
INSERT INTO LANGUECHANSON VALUES('en',4041,'t');
INSERT INTO LANGUECHANSON VALUES('en',5886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5897,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5899,'t');
INSERT INTO LANGUECHANSON VALUES('en',5924,'t');
INSERT INTO LANGUECHANSON VALUES('en',2010,'t');
INSERT INTO LANGUECHANSON VALUES('en',4043,'t');
INSERT INTO LANGUECHANSON VALUES('en',5947,'t');
INSERT INTO LANGUECHANSON VALUES('en',2012,'t');
INSERT INTO LANGUECHANSON VALUES('en',3620,'t');
INSERT INTO LANGUECHANSON VALUES('en',2014,'t');
INSERT INTO LANGUECHANSON VALUES('en',3003,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6050,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6051,'t');
INSERT INTO LANGUECHANSON VALUES('en',3004,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6090,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6094,'t');
INSERT INTO LANGUECHANSON VALUES('en',11159,'t');
INSERT INTO LANGUECHANSON VALUES('en',2368,'t');
INSERT INTO LANGUECHANSON VALUES('en',3206,'t');
INSERT INTO LANGUECHANSON VALUES('en',2369,'t');
INSERT INTO LANGUECHANSON VALUES('en',11162,'t');
INSERT INTO LANGUECHANSON VALUES('en',1528,'t');
INSERT INTO LANGUECHANSON VALUES('en',11163,'t');
INSERT INTO LANGUECHANSON VALUES('en',2214,'t');
INSERT INTO LANGUECHANSON VALUES('en',3209,'t');
INSERT INTO LANGUECHANSON VALUES('en',4311,'t');
INSERT INTO LANGUECHANSON VALUES('en',6670,'t');
INSERT INTO LANGUECHANSON VALUES('br',6681,'t');
INSERT INTO LANGUECHANSON VALUES('en',6554,'t');
INSERT INTO LANGUECHANSON VALUES('br',6684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6645,'t');
INSERT INTO LANGUECHANSON VALUES('en',11165,'t');
INSERT INTO LANGUECHANSON VALUES('en',3210,'t');
INSERT INTO LANGUECHANSON VALUES('en',4315,'t');
INSERT INTO LANGUECHANSON VALUES('br',6690,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1771,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4808,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1569,'t');
INSERT INTO LANGUECHANSON VALUES('en',2455,'t');
INSERT INTO LANGUECHANSON VALUES('en',2011,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4792,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4888,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2269,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2433,'t');
INSERT INTO LANGUECHANSON VALUES('en',2472,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3490,'t');
INSERT INTO LANGUECHANSON VALUES('en',1639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5834,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5963,'t');
INSERT INTO LANGUECHANSON VALUES('en',2461,'t');
INSERT INTO LANGUECHANSON VALUES('br',6695,'t');
INSERT INTO LANGUECHANSON VALUES('en',2254,'t');
INSERT INTO LANGUECHANSON VALUES('en',4332,'t');
INSERT INTO LANGUECHANSON VALUES('en',3223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6751,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6752,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6753,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6754,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6755,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6756,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6757,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6758,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6759,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6760,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6767,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6771,'t');
INSERT INTO LANGUECHANSON VALUES('en',4592,'t');
INSERT INTO LANGUECHANSON VALUES('en',3224,'t');
INSERT INTO LANGUECHANSON VALUES('en',4203,'t');
INSERT INTO LANGUECHANSON VALUES('en',4593,'t');
INSERT INTO LANGUECHANSON VALUES('en',4204,'t');
INSERT INTO LANGUECHANSON VALUES('en',3225,'t');
INSERT INTO LANGUECHANSON VALUES('en',10844,'t');
INSERT INTO LANGUECHANSON VALUES('en',7033,'t');
INSERT INTO LANGUECHANSON VALUES('br',7035,'t');
INSERT INTO LANGUECHANSON VALUES('en',2261,'t');
INSERT INTO LANGUECHANSON VALUES('en',6073,'t');
INSERT INTO LANGUECHANSON VALUES('es',7098,'t');
INSERT INTO LANGUECHANSON VALUES('es',7099,'t');
INSERT INTO LANGUECHANSON VALUES('es',7100,'t');
INSERT INTO LANGUECHANSON VALUES('es',7101,'t');
INSERT INTO LANGUECHANSON VALUES('es',7102,'t');
INSERT INTO LANGUECHANSON VALUES('es',7103,'t');
INSERT INTO LANGUECHANSON VALUES('es',7104,'t');
INSERT INTO LANGUECHANSON VALUES('es',7105,'t');
INSERT INTO LANGUECHANSON VALUES('es',7106,'t');
INSERT INTO LANGUECHANSON VALUES('es',7107,'t');
INSERT INTO LANGUECHANSON VALUES('en',2263,'t');
INSERT INTO LANGUECHANSON VALUES('en',4596,'t');
INSERT INTO LANGUECHANSON VALUES('en',3624,'t');
INSERT INTO LANGUECHANSON VALUES('en',2264,'t');
INSERT INTO LANGUECHANSON VALUES('en',3625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7275,'t');
INSERT INTO LANGUECHANSON VALUES('en',2265,'t');
INSERT INTO LANGUECHANSON VALUES('en',3626,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7316,'t');
INSERT INTO LANGUECHANSON VALUES('en',1566,'t');
INSERT INTO LANGUECHANSON VALUES('en',3628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7325,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7330,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7334,'t');
INSERT INTO LANGUECHANSON VALUES('en',1542,'t');
INSERT INTO LANGUECHANSON VALUES('en',3629,'t');
INSERT INTO LANGUECHANSON VALUES('br',7365,'t');
INSERT INTO LANGUECHANSON VALUES('en',1543,'t');
INSERT INTO LANGUECHANSON VALUES('en',3959,'t');
INSERT INTO LANGUECHANSON VALUES('en',2995,'t');
INSERT INTO LANGUECHANSON VALUES('en',1526,'t');
INSERT INTO LANGUECHANSON VALUES('en',4192,'t');
INSERT INTO LANGUECHANSON VALUES('en',2996,'t');
INSERT INTO LANGUECHANSON VALUES('en',4193,'t');
INSERT INTO LANGUECHANSON VALUES('en',2997,'t');
INSERT INTO LANGUECHANSON VALUES('en',4194,'t');
INSERT INTO LANGUECHANSON VALUES('br',7459,'t');
INSERT INTO LANGUECHANSON VALUES('br',7460,'t');
INSERT INTO LANGUECHANSON VALUES('br',7464,'t');
INSERT INTO LANGUECHANSON VALUES('en',4195,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7566,'t');
INSERT INTO LANGUECHANSON VALUES('en',4197,'t');
INSERT INTO LANGUECHANSON VALUES('br',7622,'t');
INSERT INTO LANGUECHANSON VALUES('br',7623,'t');
INSERT INTO LANGUECHANSON VALUES('br',7626,'t');
INSERT INTO LANGUECHANSON VALUES('en',4198,'t');
INSERT INTO LANGUECHANSON VALUES('en',2998,'t');
INSERT INTO LANGUECHANSON VALUES('en',4199,'t');
INSERT INTO LANGUECHANSON VALUES('en',3000,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11558,'t');
INSERT INTO LANGUECHANSON VALUES('en',4200,'t');
INSERT INTO LANGUECHANSON VALUES('en',3001,'t');
INSERT INTO LANGUECHANSON VALUES('en',4201,'t');
INSERT INTO LANGUECHANSON VALUES('en',3002,'t');
INSERT INTO LANGUECHANSON VALUES('en',2945,'t');
INSERT INTO LANGUECHANSON VALUES('en',2740,'t');
INSERT INTO LANGUECHANSON VALUES('br',7981,'t');
INSERT INTO LANGUECHANSON VALUES('br',7984,'t');
INSERT INTO LANGUECHANSON VALUES('en',2946,'t');
INSERT INTO LANGUECHANSON VALUES('en',2742,'t');
INSERT INTO LANGUECHANSON VALUES('en',5579,'t');
INSERT INTO LANGUECHANSON VALUES('en',2743,'t');
INSERT INTO LANGUECHANSON VALUES('br',8155,'t');
INSERT INTO LANGUECHANSON VALUES('en',254,'t');
INSERT INTO LANGUECHANSON VALUES('en',2744,'t');
INSERT INTO LANGUECHANSON VALUES('en',5584,'t');
INSERT INTO LANGUECHANSON VALUES('en',4306,'t');
INSERT INTO LANGUECHANSON VALUES('en',4307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8451,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8455,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8457,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8458,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8459,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8460,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8461,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8463,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8464,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8466,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8467,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8468,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8469,'t');
INSERT INTO LANGUECHANSON VALUES('br',7087,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11560,'t');
INSERT INTO LANGUECHANSON VALUES('br',7093,'t');
INSERT INTO LANGUECHANSON VALUES('br',7351,'t');
INSERT INTO LANGUECHANSON VALUES('en',4344,'t');
INSERT INTO LANGUECHANSON VALUES('br',7478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8470,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8471,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8472,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8475,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8476,'t');
INSERT INTO LANGUECHANSON VALUES('en',5585,'t');
INSERT INTO LANGUECHANSON VALUES('en',2248,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8525,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8531,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8532,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8534,'t');
INSERT INTO LANGUECHANSON VALUES('en',2249,'t');
INSERT INTO LANGUECHANSON VALUES('en',2252,'t');
INSERT INTO LANGUECHANSON VALUES('en',2904,'t');
INSERT INTO LANGUECHANSON VALUES('en',3701,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8871,'t');
INSERT INTO LANGUECHANSON VALUES('en',5588,'t');
INSERT INTO LANGUECHANSON VALUES('en',3702,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8967,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8968,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9005,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9006,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9007,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9008,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9009,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9010,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9011,'t');
INSERT INTO LANGUECHANSON VALUES('en',3713,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9024,'t');
INSERT INTO LANGUECHANSON VALUES('en',3704,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9034,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9035,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9036,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9037,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9038,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9039,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9040,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9041,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9042,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9043,'t');
INSERT INTO LANGUECHANSON VALUES('en',3211,'t');
INSERT INTO LANGUECHANSON VALUES('en',5669,'t');
INSERT INTO LANGUECHANSON VALUES('en',4300,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9074,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9075,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9076,'t');
INSERT INTO LANGUECHANSON VALUES('en',5661,'t');
INSERT INTO LANGUECHANSON VALUES('en',4302,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9093,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9094,'t');
INSERT INTO LANGUECHANSON VALUES('en',6262,'t');
INSERT INTO LANGUECHANSON VALUES('en',3203,'t');
INSERT INTO LANGUECHANSON VALUES('en',4304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9114,'t');
INSERT INTO LANGUECHANSON VALUES('en',5675,'t');
INSERT INTO LANGUECHANSON VALUES('en',4303,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9130,'t');
INSERT INTO LANGUECHANSON VALUES('en',5674,'t');
INSERT INTO LANGUECHANSON VALUES('en',4305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9215,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9216,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9218,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9220,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9221,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9228,'t');
INSERT INTO LANGUECHANSON VALUES('en',5667,'t');
INSERT INTO LANGUECHANSON VALUES('en',2733,'t');
INSERT INTO LANGUECHANSON VALUES('en',4588,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9284,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9288,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9290,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9291,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9293,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9302,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9308,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9309,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9310,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9311,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9312,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9313,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9314,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9315,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9316,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9317,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9320,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9321,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9322,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9323,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9324,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9325,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9326,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9327,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9328,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9329,'t');
INSERT INTO LANGUECHANSON VALUES('en',5665,'t');
INSERT INTO LANGUECHANSON VALUES('en',2216,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9345,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9346,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9347,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9349,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9350,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9351,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9352,'t');
INSERT INTO LANGUECHANSON VALUES('en',2724,'t');
INSERT INTO LANGUECHANSON VALUES('en',5419,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9444,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9445,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9446,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9447,'t');
INSERT INTO LANGUECHANSON VALUES('en',6465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9523,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9524,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9525,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9526,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9527,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9528,'t');
INSERT INTO LANGUECHANSON VALUES('en',2474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9560,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9561,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9563,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9564,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9565,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9566,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9567,'t');
INSERT INTO LANGUECHANSON VALUES('en',2477,'t');
INSERT INTO LANGUECHANSON VALUES('en',5662,'t');
INSERT INTO LANGUECHANSON VALUES('en',3943,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9613,'t');
INSERT INTO LANGUECHANSON VALUES('en',2480,'t');
INSERT INTO LANGUECHANSON VALUES('en',5671,'t');
INSERT INTO LANGUECHANSON VALUES('en',6464,'t');
INSERT INTO LANGUECHANSON VALUES('en',4292,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9740,'t');
INSERT INTO LANGUECHANSON VALUES('en',2725,'t');
INSERT INTO LANGUECHANSON VALUES('en',5666,'t');
INSERT INTO LANGUECHANSON VALUES('en',4293,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9836,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8541,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9175,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8678,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9254,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8680,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8682,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8640,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8537,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9176,'t');
INSERT INTO LANGUECHANSON VALUES('en',3555,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8676,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9837,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9838,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9839,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9841,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9842,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9843,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9844,'t');
INSERT INTO LANGUECHANSON VALUES('en',5663,'t');
INSERT INTO LANGUECHANSON VALUES('en',4294,'t');
INSERT INTO LANGUECHANSON VALUES('en',3894,'t');
INSERT INTO LANGUECHANSON VALUES('en',5673,'t');
INSERT INTO LANGUECHANSON VALUES('en',3895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9936,'t');
INSERT INTO LANGUECHANSON VALUES('en',5513,'t');
INSERT INTO LANGUECHANSON VALUES('en',3896,'t');
INSERT INTO LANGUECHANSON VALUES('en',2959,'t');
INSERT INTO LANGUECHANSON VALUES('en',3897,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11195,'t');
INSERT INTO LANGUECHANSON VALUES('en',3898,'t');
INSERT INTO LANGUECHANSON VALUES('en',1577,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11196,'t');
INSERT INTO LANGUECHANSON VALUES('en',3899,'t');
INSERT INTO LANGUECHANSON VALUES('en',1578,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11197,'t');
INSERT INTO LANGUECHANSON VALUES('en',3900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10455,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10457,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10458,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10459,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10460,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10461,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10463,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10466,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10467,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10471,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10472,'t');
INSERT INTO LANGUECHANSON VALUES('en',1581,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11198,'t');
INSERT INTO LANGUECHANSON VALUES('en',2213,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10475,'t');
INSERT INTO LANGUECHANSON VALUES('en',1582,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11199,'t');
INSERT INTO LANGUECHANSON VALUES('en',4413,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11200,'t');
INSERT INTO LANGUECHANSON VALUES('en',6062,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11201,'t');
INSERT INTO LANGUECHANSON VALUES('en',1178,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11202,'t');
INSERT INTO LANGUECHANSON VALUES('en',6462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10806,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10807,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10808,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10809,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10811,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10812,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10813,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10814,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10815,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10816,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10817,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10820,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11203,'t');
INSERT INTO LANGUECHANSON VALUES('en',6458,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11204,'t');
INSERT INTO LANGUECHANSON VALUES('en',6467,'t');
INSERT INTO LANGUECHANSON VALUES('en',10923,'t');
INSERT INTO LANGUECHANSON VALUES('en',10924,'t');
INSERT INTO LANGUECHANSON VALUES('en',10925,'t');
INSERT INTO LANGUECHANSON VALUES('en',10926,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11205,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11206,'t');
INSERT INTO LANGUECHANSON VALUES('br',11207,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10967,'t');
INSERT INTO LANGUECHANSON VALUES('br',11208,'t');
INSERT INTO LANGUECHANSON VALUES('br',11209,'t');
INSERT INTO LANGUECHANSON VALUES('en',10656,'t');
INSERT INTO LANGUECHANSON VALUES('br',11210,'t');
INSERT INTO LANGUECHANSON VALUES('en',2524,'t');
INSERT INTO LANGUECHANSON VALUES('br',11211,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3850,'t');
INSERT INTO LANGUECHANSON VALUES('br',11213,'t');
INSERT INTO LANGUECHANSON VALUES('en',5247,'t');
INSERT INTO LANGUECHANSON VALUES('br',11214,'t');
INSERT INTO LANGUECHANSON VALUES('en',1194,'t');
INSERT INTO LANGUECHANSON VALUES('br',11215,'t');
INSERT INTO LANGUECHANSON VALUES('en',1530,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4984,'t');
INSERT INTO LANGUECHANSON VALUES('br',11216,'t');
INSERT INTO LANGUECHANSON VALUES('br',11217,'t');
INSERT INTO LANGUECHANSON VALUES('en',2748,'t');
INSERT INTO LANGUECHANSON VALUES('br',11218,'t');
INSERT INTO LANGUECHANSON VALUES('en',4767,'t');
INSERT INTO LANGUECHANSON VALUES('br',6739,'t');
INSERT INTO LANGUECHANSON VALUES('br',11219,'t');
INSERT INTO LANGUECHANSON VALUES('en',3382,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7317,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10049,'t');
INSERT INTO LANGUECHANSON VALUES('en',3627,'t');
INSERT INTO LANGUECHANSON VALUES('br',7667,'t');
INSERT INTO LANGUECHANSON VALUES('br',8241,'t');
INSERT INTO LANGUECHANSON VALUES('en',3381,'t');
INSERT INTO LANGUECHANSON VALUES('br',8182,'t');
INSERT INTO LANGUECHANSON VALUES('en',3623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11220,'t');
INSERT INTO LANGUECHANSON VALUES('en',4671,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11221,'t');
INSERT INTO LANGUECHANSON VALUES('en',1708,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11222,'t');
INSERT INTO LANGUECHANSON VALUES('en',4761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11223,'t');
INSERT INTO LANGUECHANSON VALUES('en',4762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11224,'t');
INSERT INTO LANGUECHANSON VALUES('en',1701,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11225,'t');
INSERT INTO LANGUECHANSON VALUES('en',1710,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11226,'t');
INSERT INTO LANGUECHANSON VALUES('en',4770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9252,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11227,'t');
INSERT INTO LANGUECHANSON VALUES('en',4766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11228,'t');
INSERT INTO LANGUECHANSON VALUES('en',4769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11229,'t');
INSERT INTO LANGUECHANSON VALUES('en',1704,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9555,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11230,'t');
INSERT INTO LANGUECHANSON VALUES('en',4675,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11231,'t');
INSERT INTO LANGUECHANSON VALUES('en',2732,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11232,'t');
INSERT INTO LANGUECHANSON VALUES('en',6459,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11233,'t');
INSERT INTO LANGUECHANSON VALUES('en',3377,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4047,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11234,'t');
INSERT INTO LANGUECHANSON VALUES('en',1702,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11235,'t');
INSERT INTO LANGUECHANSON VALUES('en',3375,'t');
INSERT INTO LANGUECHANSON VALUES('en',2999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11236,'t');
INSERT INTO LANGUECHANSON VALUES('en',1193,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11237,'t');
INSERT INTO LANGUECHANSON VALUES('en',1707,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11238,'t');
INSERT INTO LANGUECHANSON VALUES('en',3789,'t');
INSERT INTO LANGUECHANSON VALUES('en',3553,'t');
INSERT INTO LANGUECHANSON VALUES('en',4211,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9091,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7303,'t');
INSERT INTO LANGUECHANSON VALUES('en',3549,'t');
INSERT INTO LANGUECHANSON VALUES('en',4206,'t');
INSERT INTO LANGUECHANSON VALUES('en',1706,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11239,'t');
INSERT INTO LANGUECHANSON VALUES('en',3376,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11240,'t');
INSERT INTO LANGUECHANSON VALUES('en',4768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11241,'t');
INSERT INTO LANGUECHANSON VALUES('en',3380,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11242,'t');
INSERT INTO LANGUECHANSON VALUES('en',4765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11243,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11244,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11246,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4819,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9641,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6925,'t');
INSERT INTO LANGUECHANSON VALUES('en',1580,'t');
INSERT INTO LANGUECHANSON VALUES('en',4430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10010,'t');
INSERT INTO LANGUECHANSON VALUES('en',9976,'t');
INSERT INTO LANGUECHANSON VALUES('en',79,'t');
INSERT INTO LANGUECHANSON VALUES('en',4314,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3115,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2104,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5265,'t');
INSERT INTO LANGUECHANSON VALUES('en',4424,'t');
INSERT INTO LANGUECHANSON VALUES('en',1583,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8030,'t');
INSERT INTO LANGUECHANSON VALUES('en',6994,'t');
INSERT INTO LANGUECHANSON VALUES('en',3241,'t');
INSERT INTO LANGUECHANSON VALUES('en',10994,'t');
INSERT INTO LANGUECHANSON VALUES('en',10996,'t');
INSERT INTO LANGUECHANSON VALUES('en',10999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6660,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11034,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10,'t');
INSERT INTO LANGUECHANSON VALUES('en',21,'t');
INSERT INTO LANGUECHANSON VALUES('en',22,'t');
INSERT INTO LANGUECHANSON VALUES('en',23,'t');
INSERT INTO LANGUECHANSON VALUES('en',24,'t');
INSERT INTO LANGUECHANSON VALUES('en',25,'t');
INSERT INTO LANGUECHANSON VALUES('en',26,'t');
INSERT INTO LANGUECHANSON VALUES('en',27,'t');
INSERT INTO LANGUECHANSON VALUES('en',28,'t');
INSERT INTO LANGUECHANSON VALUES('en',29,'t');
INSERT INTO LANGUECHANSON VALUES('en',30,'t');
INSERT INTO LANGUECHANSON VALUES('en',32,'t');
INSERT INTO LANGUECHANSON VALUES('en',33,'t');
INSERT INTO LANGUECHANSON VALUES('en',34,'t');
INSERT INTO LANGUECHANSON VALUES('en',35,'t');
INSERT INTO LANGUECHANSON VALUES('en',36,'t');
INSERT INTO LANGUECHANSON VALUES('en',37,'t');
INSERT INTO LANGUECHANSON VALUES('en',38,'t');
INSERT INTO LANGUECHANSON VALUES('en',39,'t');
INSERT INTO LANGUECHANSON VALUES('en',40,'t');
INSERT INTO LANGUECHANSON VALUES('en',41,'t');
INSERT INTO LANGUECHANSON VALUES('en',42,'t');
INSERT INTO LANGUECHANSON VALUES('en',43,'t');
INSERT INTO LANGUECHANSON VALUES('en',44,'t');
INSERT INTO LANGUECHANSON VALUES('en',45,'t');
INSERT INTO LANGUECHANSON VALUES('en',46,'t');
INSERT INTO LANGUECHANSON VALUES('en',47,'t');
INSERT INTO LANGUECHANSON VALUES('en',48,'t');
INSERT INTO LANGUECHANSON VALUES('en',49,'t');
INSERT INTO LANGUECHANSON VALUES('en',50,'t');
INSERT INTO LANGUECHANSON VALUES('en',51,'t');
INSERT INTO LANGUECHANSON VALUES('en',52,'t');
INSERT INTO LANGUECHANSON VALUES('en',53,'t');
INSERT INTO LANGUECHANSON VALUES('en',54,'t');
INSERT INTO LANGUECHANSON VALUES('en',55,'t');
INSERT INTO LANGUECHANSON VALUES('en',56,'t');
INSERT INTO LANGUECHANSON VALUES('en',57,'t');
INSERT INTO LANGUECHANSON VALUES('en',58,'t');
INSERT INTO LANGUECHANSON VALUES('en',59,'t');
INSERT INTO LANGUECHANSON VALUES('en',60,'t');
INSERT INTO LANGUECHANSON VALUES('en',61,'t');
INSERT INTO LANGUECHANSON VALUES('en',62,'t');
INSERT INTO LANGUECHANSON VALUES('en',63,'t');
INSERT INTO LANGUECHANSON VALUES('en',64,'t');
INSERT INTO LANGUECHANSON VALUES('en',65,'t');
INSERT INTO LANGUECHANSON VALUES('en',66,'t');
INSERT INTO LANGUECHANSON VALUES('en',67,'t');
INSERT INTO LANGUECHANSON VALUES('en',68,'t');
INSERT INTO LANGUECHANSON VALUES('en',69,'t');
INSERT INTO LANGUECHANSON VALUES('en',70,'t');
INSERT INTO LANGUECHANSON VALUES('en',71,'t');
INSERT INTO LANGUECHANSON VALUES('en',72,'t');
INSERT INTO LANGUECHANSON VALUES('en',73,'t');
INSERT INTO LANGUECHANSON VALUES('en',74,'t');
INSERT INTO LANGUECHANSON VALUES('en',75,'t');
INSERT INTO LANGUECHANSON VALUES('en',76,'t');
INSERT INTO LANGUECHANSON VALUES('en',77,'t');
INSERT INTO LANGUECHANSON VALUES('en',78,'t');
INSERT INTO LANGUECHANSON VALUES('en',80,'t');
INSERT INTO LANGUECHANSON VALUES('en',81,'t');
INSERT INTO LANGUECHANSON VALUES('en',82,'t');
INSERT INTO LANGUECHANSON VALUES('en',83,'t');
INSERT INTO LANGUECHANSON VALUES('en',84,'t');
INSERT INTO LANGUECHANSON VALUES('en',85,'t');
INSERT INTO LANGUECHANSON VALUES('en',86,'t');
INSERT INTO LANGUECHANSON VALUES('en',87,'t');
INSERT INTO LANGUECHANSON VALUES('en',88,'t');
INSERT INTO LANGUECHANSON VALUES('en',89,'t');
INSERT INTO LANGUECHANSON VALUES('en',90,'t');
INSERT INTO LANGUECHANSON VALUES('en',91,'t');
INSERT INTO LANGUECHANSON VALUES('en',92,'t');
INSERT INTO LANGUECHANSON VALUES('en',93,'t');
INSERT INTO LANGUECHANSON VALUES('en',94,'t');
INSERT INTO LANGUECHANSON VALUES('en',95,'t');
INSERT INTO LANGUECHANSON VALUES('en',96,'t');
INSERT INTO LANGUECHANSON VALUES('en',97,'t');
INSERT INTO LANGUECHANSON VALUES('en',98,'t');
INSERT INTO LANGUECHANSON VALUES('en',99,'t');
INSERT INTO LANGUECHANSON VALUES('en',100,'t');
INSERT INTO LANGUECHANSON VALUES('en',101,'t');
INSERT INTO LANGUECHANSON VALUES('en',102,'t');
INSERT INTO LANGUECHANSON VALUES('en',103,'t');
INSERT INTO LANGUECHANSON VALUES('en',104,'t');
INSERT INTO LANGUECHANSON VALUES('en',105,'t');
INSERT INTO LANGUECHANSON VALUES('en',106,'t');
INSERT INTO LANGUECHANSON VALUES('en',107,'t');
INSERT INTO LANGUECHANSON VALUES('en',109,'t');
INSERT INTO LANGUECHANSON VALUES('en',110,'t');
INSERT INTO LANGUECHANSON VALUES('en',111,'t');
INSERT INTO LANGUECHANSON VALUES('en',112,'t');
INSERT INTO LANGUECHANSON VALUES('en',113,'t');
INSERT INTO LANGUECHANSON VALUES('en',1911,'t');
INSERT INTO LANGUECHANSON VALUES('en',3785,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1142,'t');
INSERT INTO LANGUECHANSON VALUES('en',4323,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11561,'t');
INSERT INTO LANGUECHANSON VALUES('en',134,'t');
INSERT INTO LANGUECHANSON VALUES('en',135,'t');
INSERT INTO LANGUECHANSON VALUES('en',136,'t');
INSERT INTO LANGUECHANSON VALUES('en',137,'t');
INSERT INTO LANGUECHANSON VALUES('en',138,'t');
INSERT INTO LANGUECHANSON VALUES('en',139,'t');
INSERT INTO LANGUECHANSON VALUES('en',140,'t');
INSERT INTO LANGUECHANSON VALUES('en',141,'t');
INSERT INTO LANGUECHANSON VALUES('en',142,'t');
INSERT INTO LANGUECHANSON VALUES('en',143,'t');
INSERT INTO LANGUECHANSON VALUES('en',144,'t');
INSERT INTO LANGUECHANSON VALUES('en',145,'t');
INSERT INTO LANGUECHANSON VALUES('en',146,'t');
INSERT INTO LANGUECHANSON VALUES('en',147,'t');
INSERT INTO LANGUECHANSON VALUES('en',148,'t');
INSERT INTO LANGUECHANSON VALUES('en',149,'t');
INSERT INTO LANGUECHANSON VALUES('en',150,'t');
INSERT INTO LANGUECHANSON VALUES('fr',151,'t');
INSERT INTO LANGUECHANSON VALUES('fr',152,'t');
INSERT INTO LANGUECHANSON VALUES('fr',153,'t');
INSERT INTO LANGUECHANSON VALUES('fr',154,'t');
INSERT INTO LANGUECHANSON VALUES('fr',155,'t');
INSERT INTO LANGUECHANSON VALUES('fr',156,'t');
INSERT INTO LANGUECHANSON VALUES('fr',157,'t');
INSERT INTO LANGUECHANSON VALUES('fr',158,'t');
INSERT INTO LANGUECHANSON VALUES('fr',159,'t');
INSERT INTO LANGUECHANSON VALUES('fr',160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11562,'t');
INSERT INTO LANGUECHANSON VALUES('fr',163,'t');
INSERT INTO LANGUECHANSON VALUES('fr',164,'t');
INSERT INTO LANGUECHANSON VALUES('fr',165,'t');
INSERT INTO LANGUECHANSON VALUES('fr',166,'t');
INSERT INTO LANGUECHANSON VALUES('fr',167,'t');
INSERT INTO LANGUECHANSON VALUES('fr',168,'t');
INSERT INTO LANGUECHANSON VALUES('fr',169,'t');
INSERT INTO LANGUECHANSON VALUES('fr',170,'t');
INSERT INTO LANGUECHANSON VALUES('fr',171,'t');
INSERT INTO LANGUECHANSON VALUES('fr',172,'t');
INSERT INTO LANGUECHANSON VALUES('fr',173,'t');
INSERT INTO LANGUECHANSON VALUES('en',175,'t');
INSERT INTO LANGUECHANSON VALUES('en',176,'t');
INSERT INTO LANGUECHANSON VALUES('en',177,'t');
INSERT INTO LANGUECHANSON VALUES('en',178,'t');
INSERT INTO LANGUECHANSON VALUES('en',179,'t');
INSERT INTO LANGUECHANSON VALUES('en',180,'t');
INSERT INTO LANGUECHANSON VALUES('en',181,'t');
INSERT INTO LANGUECHANSON VALUES('en',182,'t');
INSERT INTO LANGUECHANSON VALUES('en',183,'t');
INSERT INTO LANGUECHANSON VALUES('en',184,'t');
INSERT INTO LANGUECHANSON VALUES('en',185,'t');
INSERT INTO LANGUECHANSON VALUES('en',186,'t');
INSERT INTO LANGUECHANSON VALUES('en',187,'t');
INSERT INTO LANGUECHANSON VALUES('en',188,'t');
INSERT INTO LANGUECHANSON VALUES('en',190,'t');
INSERT INTO LANGUECHANSON VALUES('en',192,'t');
INSERT INTO LANGUECHANSON VALUES('en',193,'t');
INSERT INTO LANGUECHANSON VALUES('en',194,'t');
INSERT INTO LANGUECHANSON VALUES('en',195,'t');
INSERT INTO LANGUECHANSON VALUES('en',196,'t');
INSERT INTO LANGUECHANSON VALUES('en',197,'t');
INSERT INTO LANGUECHANSON VALUES('en',198,'t');
INSERT INTO LANGUECHANSON VALUES('en',199,'t');
INSERT INTO LANGUECHANSON VALUES('en',200,'t');
INSERT INTO LANGUECHANSON VALUES('en',201,'t');
INSERT INTO LANGUECHANSON VALUES('en',202,'t');
INSERT INTO LANGUECHANSON VALUES('fr',203,'t');
INSERT INTO LANGUECHANSON VALUES('fr',204,'t');
INSERT INTO LANGUECHANSON VALUES('fr',205,'t');
INSERT INTO LANGUECHANSON VALUES('fr',206,'t');
INSERT INTO LANGUECHANSON VALUES('fr',207,'t');
INSERT INTO LANGUECHANSON VALUES('fr',208,'t');
INSERT INTO LANGUECHANSON VALUES('fr',209,'t');
INSERT INTO LANGUECHANSON VALUES('fr',210,'t');
INSERT INTO LANGUECHANSON VALUES('fr',211,'t');
INSERT INTO LANGUECHANSON VALUES('fr',212,'t');
INSERT INTO LANGUECHANSON VALUES('fr',213,'t');
INSERT INTO LANGUECHANSON VALUES('fr',214,'t');
INSERT INTO LANGUECHANSON VALUES('en',215,'t');
INSERT INTO LANGUECHANSON VALUES('en',216,'t');
INSERT INTO LANGUECHANSON VALUES('en',217,'t');
INSERT INTO LANGUECHANSON VALUES('en',218,'t');
INSERT INTO LANGUECHANSON VALUES('en',219,'t');
INSERT INTO LANGUECHANSON VALUES('en',220,'t');
INSERT INTO LANGUECHANSON VALUES('en',221,'t');
INSERT INTO LANGUECHANSON VALUES('en',222,'t');
INSERT INTO LANGUECHANSON VALUES('en',223,'t');
INSERT INTO LANGUECHANSON VALUES('en',224,'t');
INSERT INTO LANGUECHANSON VALUES('en',225,'t');
INSERT INTO LANGUECHANSON VALUES('en',226,'t');
INSERT INTO LANGUECHANSON VALUES('en',227,'t');
INSERT INTO LANGUECHANSON VALUES('en',228,'t');
INSERT INTO LANGUECHANSON VALUES('en',229,'t');
INSERT INTO LANGUECHANSON VALUES('en',230,'t');
INSERT INTO LANGUECHANSON VALUES('en',231,'t');
INSERT INTO LANGUECHANSON VALUES('en',232,'t');
INSERT INTO LANGUECHANSON VALUES('en',233,'t');
INSERT INTO LANGUECHANSON VALUES('en',234,'t');
INSERT INTO LANGUECHANSON VALUES('en',235,'t');
INSERT INTO LANGUECHANSON VALUES('en',236,'t');
INSERT INTO LANGUECHANSON VALUES('en',237,'t');
INSERT INTO LANGUECHANSON VALUES('en',238,'t');
INSERT INTO LANGUECHANSON VALUES('en',239,'t');
INSERT INTO LANGUECHANSON VALUES('en',240,'t');
INSERT INTO LANGUECHANSON VALUES('en',241,'t');
INSERT INTO LANGUECHANSON VALUES('en',242,'t');
INSERT INTO LANGUECHANSON VALUES('en',243,'t');
INSERT INTO LANGUECHANSON VALUES('en',244,'t');
INSERT INTO LANGUECHANSON VALUES('en',245,'t');
INSERT INTO LANGUECHANSON VALUES('en',246,'t');
INSERT INTO LANGUECHANSON VALUES('en',247,'t');
INSERT INTO LANGUECHANSON VALUES('en',248,'t');
INSERT INTO LANGUECHANSON VALUES('en',249,'t');
INSERT INTO LANGUECHANSON VALUES('en',250,'t');
INSERT INTO LANGUECHANSON VALUES('en',251,'t');
INSERT INTO LANGUECHANSON VALUES('en',252,'t');
INSERT INTO LANGUECHANSON VALUES('en',253,'t');
INSERT INTO LANGUECHANSON VALUES('en',255,'t');
INSERT INTO LANGUECHANSON VALUES('en',256,'t');
INSERT INTO LANGUECHANSON VALUES('en',257,'t');
INSERT INTO LANGUECHANSON VALUES('en',258,'t');
INSERT INTO LANGUECHANSON VALUES('en',259,'t');
INSERT INTO LANGUECHANSON VALUES('en',260,'t');
INSERT INTO LANGUECHANSON VALUES('en',261,'t');
INSERT INTO LANGUECHANSON VALUES('en',262,'t');
INSERT INTO LANGUECHANSON VALUES('en',263,'t');
INSERT INTO LANGUECHANSON VALUES('en',264,'t');
INSERT INTO LANGUECHANSON VALUES('en',265,'t');
INSERT INTO LANGUECHANSON VALUES('fr',266,'t');
INSERT INTO LANGUECHANSON VALUES('fr',267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',269,'t');
INSERT INTO LANGUECHANSON VALUES('fr',270,'t');
INSERT INTO LANGUECHANSON VALUES('fr',271,'t');
INSERT INTO LANGUECHANSON VALUES('fr',272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',274,'t');
INSERT INTO LANGUECHANSON VALUES('fr',275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',276,'t');
INSERT INTO LANGUECHANSON VALUES('fr',277,'t');
INSERT INTO LANGUECHANSON VALUES('fr',278,'t');
INSERT INTO LANGUECHANSON VALUES('en',280,'t');
INSERT INTO LANGUECHANSON VALUES('en',281,'t');
INSERT INTO LANGUECHANSON VALUES('en',282,'t');
INSERT INTO LANGUECHANSON VALUES('en',283,'t');
INSERT INTO LANGUECHANSON VALUES('en',285,'t');
INSERT INTO LANGUECHANSON VALUES('en',286,'t');
INSERT INTO LANGUECHANSON VALUES('en',287,'t');
INSERT INTO LANGUECHANSON VALUES('en',288,'t');
INSERT INTO LANGUECHANSON VALUES('en',289,'t');
INSERT INTO LANGUECHANSON VALUES('en',290,'t');
INSERT INTO LANGUECHANSON VALUES('en',291,'t');
INSERT INTO LANGUECHANSON VALUES('en',292,'t');
INSERT INTO LANGUECHANSON VALUES('en',293,'t');
INSERT INTO LANGUECHANSON VALUES('en',294,'t');
INSERT INTO LANGUECHANSON VALUES('en',295,'t');
INSERT INTO LANGUECHANSON VALUES('en',296,'t');
INSERT INTO LANGUECHANSON VALUES('en',770,'t');
INSERT INTO LANGUECHANSON VALUES('en',771,'t');
INSERT INTO LANGUECHANSON VALUES('en',772,'t');
INSERT INTO LANGUECHANSON VALUES('en',773,'t');
INSERT INTO LANGUECHANSON VALUES('en',774,'t');
INSERT INTO LANGUECHANSON VALUES('en',775,'t');
INSERT INTO LANGUECHANSON VALUES('en',776,'t');
INSERT INTO LANGUECHANSON VALUES('en',777,'t');
INSERT INTO LANGUECHANSON VALUES('en',778,'t');
INSERT INTO LANGUECHANSON VALUES('en',779,'t');
INSERT INTO LANGUECHANSON VALUES('en',780,'t');
INSERT INTO LANGUECHANSON VALUES('en',781,'t');
INSERT INTO LANGUECHANSON VALUES('la',792,'t');
INSERT INTO LANGUECHANSON VALUES('la',793,'t');
INSERT INTO LANGUECHANSON VALUES('la',794,'t');
INSERT INTO LANGUECHANSON VALUES('la',795,'t');
INSERT INTO LANGUECHANSON VALUES('la',796,'t');
INSERT INTO LANGUECHANSON VALUES('la',797,'t');
INSERT INTO LANGUECHANSON VALUES('la',798,'t');
INSERT INTO LANGUECHANSON VALUES('la',799,'t');
INSERT INTO LANGUECHANSON VALUES('la',800,'t');
INSERT INTO LANGUECHANSON VALUES('la',801,'t');
INSERT INTO LANGUECHANSON VALUES('la',802,'t');
INSERT INTO LANGUECHANSON VALUES('la',803,'t');
INSERT INTO LANGUECHANSON VALUES('la',804,'t');
INSERT INTO LANGUECHANSON VALUES('la',805,'t');
INSERT INTO LANGUECHANSON VALUES('la',806,'t');
INSERT INTO LANGUECHANSON VALUES('la',807,'t');
INSERT INTO LANGUECHANSON VALUES('la',808,'t');
INSERT INTO LANGUECHANSON VALUES('la',809,'t');
INSERT INTO LANGUECHANSON VALUES('la',810,'t');
INSERT INTO LANGUECHANSON VALUES('la',811,'t');
INSERT INTO LANGUECHANSON VALUES('la',812,'t');
INSERT INTO LANGUECHANSON VALUES('la',813,'t');
INSERT INTO LANGUECHANSON VALUES('la',814,'t');
INSERT INTO LANGUECHANSON VALUES('la',815,'t');
INSERT INTO LANGUECHANSON VALUES('la',816,'t');
INSERT INTO LANGUECHANSON VALUES('la',817,'t');
INSERT INTO LANGUECHANSON VALUES('la',818,'t');
INSERT INTO LANGUECHANSON VALUES('la',819,'t');
INSERT INTO LANGUECHANSON VALUES('la',820,'t');
INSERT INTO LANGUECHANSON VALUES('la',821,'t');
INSERT INTO LANGUECHANSON VALUES('la',822,'t');
INSERT INTO LANGUECHANSON VALUES('la',823,'t');
INSERT INTO LANGUECHANSON VALUES('en',981,'t');
INSERT INTO LANGUECHANSON VALUES('en',982,'t');
INSERT INTO LANGUECHANSON VALUES('en',983,'t');
INSERT INTO LANGUECHANSON VALUES('en',984,'t');
INSERT INTO LANGUECHANSON VALUES('en',985,'t');
INSERT INTO LANGUECHANSON VALUES('en',986,'t');
INSERT INTO LANGUECHANSON VALUES('en',987,'t');
INSERT INTO LANGUECHANSON VALUES('en',988,'t');
INSERT INTO LANGUECHANSON VALUES('en',989,'t');
INSERT INTO LANGUECHANSON VALUES('en',990,'t');
INSERT INTO LANGUECHANSON VALUES('en',991,'t');
INSERT INTO LANGUECHANSON VALUES('en',992,'t');
INSERT INTO LANGUECHANSON VALUES('en',993,'t');
INSERT INTO LANGUECHANSON VALUES('en',994,'t');
INSERT INTO LANGUECHANSON VALUES('en',995,'t');
INSERT INTO LANGUECHANSON VALUES('en',996,'t');
INSERT INTO LANGUECHANSON VALUES('en',997,'t');
INSERT INTO LANGUECHANSON VALUES('en',998,'t');
INSERT INTO LANGUECHANSON VALUES('en',999,'t');
INSERT INTO LANGUECHANSON VALUES('en',1000,'t');
INSERT INTO LANGUECHANSON VALUES('en',1001,'t');
INSERT INTO LANGUECHANSON VALUES('en',1002,'t');
INSERT INTO LANGUECHANSON VALUES('en',1003,'t');
INSERT INTO LANGUECHANSON VALUES('en',1004,'t');
INSERT INTO LANGUECHANSON VALUES('en',1005,'t');
INSERT INTO LANGUECHANSON VALUES('en',1006,'t');
INSERT INTO LANGUECHANSON VALUES('en',1007,'t');
INSERT INTO LANGUECHANSON VALUES('en',1008,'t');
INSERT INTO LANGUECHANSON VALUES('en',1009,'t');
INSERT INTO LANGUECHANSON VALUES('en',1010,'t');
INSERT INTO LANGUECHANSON VALUES('en',1011,'t');
INSERT INTO LANGUECHANSON VALUES('en',1012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1013,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1018,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1024,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1026,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1027,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1028,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1029,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1030,'t');
INSERT INTO LANGUECHANSON VALUES('en',1031,'t');
INSERT INTO LANGUECHANSON VALUES('en',1032,'t');
INSERT INTO LANGUECHANSON VALUES('en',1035,'t');
INSERT INTO LANGUECHANSON VALUES('en',1036,'t');
INSERT INTO LANGUECHANSON VALUES('en',1037,'t');
INSERT INTO LANGUECHANSON VALUES('en',1038,'t');
INSERT INTO LANGUECHANSON VALUES('en',1039,'t');
INSERT INTO LANGUECHANSON VALUES('en',1040,'t');
INSERT INTO LANGUECHANSON VALUES('en',1041,'t');
INSERT INTO LANGUECHANSON VALUES('en',1043,'t');
INSERT INTO LANGUECHANSON VALUES('en',1044,'t');
INSERT INTO LANGUECHANSON VALUES('en',1045,'t');
INSERT INTO LANGUECHANSON VALUES('en',1047,'t');
INSERT INTO LANGUECHANSON VALUES('en',1048,'t');
INSERT INTO LANGUECHANSON VALUES('en',1049,'t');
INSERT INTO LANGUECHANSON VALUES('en',1050,'t');
INSERT INTO LANGUECHANSON VALUES('en',1051,'t');
INSERT INTO LANGUECHANSON VALUES('en',1052,'t');
INSERT INTO LANGUECHANSON VALUES('en',1053,'t');
INSERT INTO LANGUECHANSON VALUES('en',1054,'t');
INSERT INTO LANGUECHANSON VALUES('en',1055,'t');
INSERT INTO LANGUECHANSON VALUES('en',1056,'t');
INSERT INTO LANGUECHANSON VALUES('en',1057,'t');
INSERT INTO LANGUECHANSON VALUES('en',1058,'t');
INSERT INTO LANGUECHANSON VALUES('en',1059,'t');
INSERT INTO LANGUECHANSON VALUES('en',1060,'t');
INSERT INTO LANGUECHANSON VALUES('en',1061,'t');
INSERT INTO LANGUECHANSON VALUES('en',1062,'t');
INSERT INTO LANGUECHANSON VALUES('en',1063,'t');
INSERT INTO LANGUECHANSON VALUES('en',1064,'t');
INSERT INTO LANGUECHANSON VALUES('en',1065,'t');
INSERT INTO LANGUECHANSON VALUES('en',1066,'t');
INSERT INTO LANGUECHANSON VALUES('en',1067,'t');
INSERT INTO LANGUECHANSON VALUES('en',1068,'t');
INSERT INTO LANGUECHANSON VALUES('en',1069,'t');
INSERT INTO LANGUECHANSON VALUES('en',1070,'t');
INSERT INTO LANGUECHANSON VALUES('en',1071,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1072,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1073,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1074,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1075,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1076,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1078,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1079,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1080,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1081,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1082,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1083,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1084,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1085,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1086,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1087,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1089,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1090,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1091,'t');
INSERT INTO LANGUECHANSON VALUES('en',1092,'t');
INSERT INTO LANGUECHANSON VALUES('en',1093,'t');
INSERT INTO LANGUECHANSON VALUES('en',1094,'t');
INSERT INTO LANGUECHANSON VALUES('en',1095,'t');
INSERT INTO LANGUECHANSON VALUES('en',1096,'t');
INSERT INTO LANGUECHANSON VALUES('en',1097,'t');
INSERT INTO LANGUECHANSON VALUES('en',1098,'t');
INSERT INTO LANGUECHANSON VALUES('en',1100,'t');
INSERT INTO LANGUECHANSON VALUES('en',1101,'t');
INSERT INTO LANGUECHANSON VALUES('en',1102,'t');
INSERT INTO LANGUECHANSON VALUES('en',1103,'t');
INSERT INTO LANGUECHANSON VALUES('en',1104,'t');
INSERT INTO LANGUECHANSON VALUES('en',1105,'t');
INSERT INTO LANGUECHANSON VALUES('en',1106,'t');
INSERT INTO LANGUECHANSON VALUES('en',1107,'t');
INSERT INTO LANGUECHANSON VALUES('en',1108,'t');
INSERT INTO LANGUECHANSON VALUES('en',1109,'t');
INSERT INTO LANGUECHANSON VALUES('en',1110,'t');
INSERT INTO LANGUECHANSON VALUES('en',1111,'t');
INSERT INTO LANGUECHANSON VALUES('en',1112,'t');
INSERT INTO LANGUECHANSON VALUES('en',1113,'t');
INSERT INTO LANGUECHANSON VALUES('en',1114,'t');
INSERT INTO LANGUECHANSON VALUES('en',1117,'t');
INSERT INTO LANGUECHANSON VALUES('en',1118,'t');
INSERT INTO LANGUECHANSON VALUES('en',1119,'t');
INSERT INTO LANGUECHANSON VALUES('en',1120,'t');
INSERT INTO LANGUECHANSON VALUES('en',1121,'t');
INSERT INTO LANGUECHANSON VALUES('en',1122,'t');
INSERT INTO LANGUECHANSON VALUES('en',1123,'t');
INSERT INTO LANGUECHANSON VALUES('en',1124,'t');
INSERT INTO LANGUECHANSON VALUES('en',1125,'t');
INSERT INTO LANGUECHANSON VALUES('en',1126,'t');
INSERT INTO LANGUECHANSON VALUES('en',1127,'t');
INSERT INTO LANGUECHANSON VALUES('en',1128,'t');
INSERT INTO LANGUECHANSON VALUES('en',1129,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1130,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1131,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1132,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1133,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1134,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1135,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1137,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1138,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1139,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1140,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1141,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1143,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1144,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1145,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1146,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1147,'t');
INSERT INTO LANGUECHANSON VALUES('en',1148,'t');
INSERT INTO LANGUECHANSON VALUES('en',1149,'t');
INSERT INTO LANGUECHANSON VALUES('en',1150,'t');
INSERT INTO LANGUECHANSON VALUES('en',1151,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1152,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1153,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1154,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1155,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1156,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1157,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1158,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1159,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1162,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1163,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1164,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1165,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1166,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1167,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1168,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1169,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1170,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1171,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1172,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1173,'t');
INSERT INTO LANGUECHANSON VALUES('en',1177,'t');
INSERT INTO LANGUECHANSON VALUES('en',1197,'t');
INSERT INTO LANGUECHANSON VALUES('en',1198,'t');
INSERT INTO LANGUECHANSON VALUES('en',1199,'t');
INSERT INTO LANGUECHANSON VALUES('en',1200,'t');
INSERT INTO LANGUECHANSON VALUES('en',1185,'t');
INSERT INTO LANGUECHANSON VALUES('en',1174,'t');
INSERT INTO LANGUECHANSON VALUES('en',1201,'t');
INSERT INTO LANGUECHANSON VALUES('en',1202,'t');
INSERT INTO LANGUECHANSON VALUES('en',1203,'t');
INSERT INTO LANGUECHANSON VALUES('en',1204,'t');
INSERT INTO LANGUECHANSON VALUES('en',1205,'t');
INSERT INTO LANGUECHANSON VALUES('en',1206,'t');
INSERT INTO LANGUECHANSON VALUES('en',1207,'t');
INSERT INTO LANGUECHANSON VALUES('en',1208,'t');
INSERT INTO LANGUECHANSON VALUES('en',1210,'t');
INSERT INTO LANGUECHANSON VALUES('en',1211,'t');
INSERT INTO LANGUECHANSON VALUES('en',1212,'t');
INSERT INTO LANGUECHANSON VALUES('en',1213,'t');
INSERT INTO LANGUECHANSON VALUES('en',1214,'t');
INSERT INTO LANGUECHANSON VALUES('en',1216,'t');
INSERT INTO LANGUECHANSON VALUES('en',1217,'t');
INSERT INTO LANGUECHANSON VALUES('en',1218,'t');
INSERT INTO LANGUECHANSON VALUES('en',1219,'t');
INSERT INTO LANGUECHANSON VALUES('en',1220,'t');
INSERT INTO LANGUECHANSON VALUES('en',1221,'t');
INSERT INTO LANGUECHANSON VALUES('en',1222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1228,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1230,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1231,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1233,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1234,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1235,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1236,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1237,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1238,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1239,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1240,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1241,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1242,'t');
INSERT INTO LANGUECHANSON VALUES('en',1243,'t');
INSERT INTO LANGUECHANSON VALUES('en',1244,'t');
INSERT INTO LANGUECHANSON VALUES('en',1245,'t');
INSERT INTO LANGUECHANSON VALUES('en',1246,'t');
INSERT INTO LANGUECHANSON VALUES('en',1247,'t');
INSERT INTO LANGUECHANSON VALUES('en',1248,'t');
INSERT INTO LANGUECHANSON VALUES('en',1249,'t');
INSERT INTO LANGUECHANSON VALUES('en',1250,'t');
INSERT INTO LANGUECHANSON VALUES('en',1251,'t');
INSERT INTO LANGUECHANSON VALUES('en',1252,'t');
INSERT INTO LANGUECHANSON VALUES('en',1253,'t');
INSERT INTO LANGUECHANSON VALUES('en',1254,'t');
INSERT INTO LANGUECHANSON VALUES('en',1255,'t');
INSERT INTO LANGUECHANSON VALUES('en',1256,'t');
INSERT INTO LANGUECHANSON VALUES('en',1257,'t');
INSERT INTO LANGUECHANSON VALUES('en',1258,'t');
INSERT INTO LANGUECHANSON VALUES('en',1259,'t');
INSERT INTO LANGUECHANSON VALUES('en',1260,'t');
INSERT INTO LANGUECHANSON VALUES('en',1261,'t');
INSERT INTO LANGUECHANSON VALUES('en',1262,'t');
INSERT INTO LANGUECHANSON VALUES('en',1263,'t');
INSERT INTO LANGUECHANSON VALUES('en',1264,'t');
INSERT INTO LANGUECHANSON VALUES('en',1265,'t');
INSERT INTO LANGUECHANSON VALUES('en',1266,'t');
INSERT INTO LANGUECHANSON VALUES('en',1269,'t');
INSERT INTO LANGUECHANSON VALUES('en',1271,'t');
INSERT INTO LANGUECHANSON VALUES('en',1274,'t');
INSERT INTO LANGUECHANSON VALUES('en',1275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1282,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1283,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1284,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1286,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1287,'t');
INSERT INTO LANGUECHANSON VALUES('en',1288,'t');
INSERT INTO LANGUECHANSON VALUES('en',1289,'t');
INSERT INTO LANGUECHANSON VALUES('en',1290,'t');
INSERT INTO LANGUECHANSON VALUES('en',1291,'t');
INSERT INTO LANGUECHANSON VALUES('en',1292,'t');
INSERT INTO LANGUECHANSON VALUES('en',1293,'t');
INSERT INTO LANGUECHANSON VALUES('en',1294,'t');
INSERT INTO LANGUECHANSON VALUES('en',1295,'t');
INSERT INTO LANGUECHANSON VALUES('en',1297,'t');
INSERT INTO LANGUECHANSON VALUES('en',1298,'t');
INSERT INTO LANGUECHANSON VALUES('en',1299,'t');
INSERT INTO LANGUECHANSON VALUES('en',1300,'t');
INSERT INTO LANGUECHANSON VALUES('en',1301,'t');
INSERT INTO LANGUECHANSON VALUES('en',1302,'t');
INSERT INTO LANGUECHANSON VALUES('en',1303,'t');
INSERT INTO LANGUECHANSON VALUES('en',1304,'t');
INSERT INTO LANGUECHANSON VALUES('en',1305,'t');
INSERT INTO LANGUECHANSON VALUES('en',1306,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1309,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1310,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1311,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1312,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1313,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1314,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1315,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1316,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1317,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1318,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1319,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1320,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1321,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1322,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1323,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1324,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1325,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1326,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1327,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1328,'t');
INSERT INTO LANGUECHANSON VALUES('en',1329,'t');
INSERT INTO LANGUECHANSON VALUES('en',1330,'t');
INSERT INTO LANGUECHANSON VALUES('en',1331,'t');
INSERT INTO LANGUECHANSON VALUES('en',1332,'t');
INSERT INTO LANGUECHANSON VALUES('en',1333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1334,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1335,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1336,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1337,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1338,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1339,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1343,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1344,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1345,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1347,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1350,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1351,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1355,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1356,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1357,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1358,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1360,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1361,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1362,'t');
INSERT INTO LANGUECHANSON VALUES('en',125,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1363,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1364,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1365,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1366,'t');
INSERT INTO LANGUECHANSON VALUES('en',1367,'t');
INSERT INTO LANGUECHANSON VALUES('en',1368,'t');
INSERT INTO LANGUECHANSON VALUES('en',1369,'t');
INSERT INTO LANGUECHANSON VALUES('en',1370,'t');
INSERT INTO LANGUECHANSON VALUES('en',1371,'t');
INSERT INTO LANGUECHANSON VALUES('en',1296,'t');
INSERT INTO LANGUECHANSON VALUES('en',1372,'t');
INSERT INTO LANGUECHANSON VALUES('en',1373,'t');
INSERT INTO LANGUECHANSON VALUES('en',1374,'t');
INSERT INTO LANGUECHANSON VALUES('en',1375,'t');
INSERT INTO LANGUECHANSON VALUES('en',1376,'t');
INSERT INTO LANGUECHANSON VALUES('en',1377,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1378,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1379,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1380,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1381,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1382,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1383,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1384,'t');
INSERT INTO LANGUECHANSON VALUES('en',1385,'t');
INSERT INTO LANGUECHANSON VALUES('en',1386,'t');
INSERT INTO LANGUECHANSON VALUES('en',1388,'t');
INSERT INTO LANGUECHANSON VALUES('en',1390,'t');
INSERT INTO LANGUECHANSON VALUES('en',1391,'t');
INSERT INTO LANGUECHANSON VALUES('en',1392,'t');
INSERT INTO LANGUECHANSON VALUES('en',1393,'t');
INSERT INTO LANGUECHANSON VALUES('en',1394,'t');
INSERT INTO LANGUECHANSON VALUES('en',1395,'t');
INSERT INTO LANGUECHANSON VALUES('en',1397,'t');
INSERT INTO LANGUECHANSON VALUES('en',1398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1407,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1408,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1409,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1410,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1411,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1412,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1413,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1414,'t');
INSERT INTO LANGUECHANSON VALUES('en',1415,'t');
INSERT INTO LANGUECHANSON VALUES('en',1416,'t');
INSERT INTO LANGUECHANSON VALUES('en',1417,'t');
INSERT INTO LANGUECHANSON VALUES('en',1423,'t');
INSERT INTO LANGUECHANSON VALUES('en',1424,'t');
INSERT INTO LANGUECHANSON VALUES('en',1425,'t');
INSERT INTO LANGUECHANSON VALUES('en',1426,'t');
INSERT INTO LANGUECHANSON VALUES('en',1427,'t');
INSERT INTO LANGUECHANSON VALUES('en',1428,'t');
INSERT INTO LANGUECHANSON VALUES('en',1429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1440,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1441,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1443,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1444,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1445,'t');
INSERT INTO LANGUECHANSON VALUES('en',1446,'t');
INSERT INTO LANGUECHANSON VALUES('en',1447,'t');
INSERT INTO LANGUECHANSON VALUES('en',1448,'t');
INSERT INTO LANGUECHANSON VALUES('en',1450,'t');
INSERT INTO LANGUECHANSON VALUES('en',1451,'t');
INSERT INTO LANGUECHANSON VALUES('en',1452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1455,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1457,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1458,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1459,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1460,'t');
INSERT INTO LANGUECHANSON VALUES('en',1421,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1463,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1466,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1467,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1476,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1477,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1479,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1480,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1482,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1483,'t');
INSERT INTO LANGUECHANSON VALUES('en',1484,'t');
INSERT INTO LANGUECHANSON VALUES('en',1485,'t');
INSERT INTO LANGUECHANSON VALUES('en',1486,'t');
INSERT INTO LANGUECHANSON VALUES('en',1487,'t');
INSERT INTO LANGUECHANSON VALUES('en',1488,'t');
INSERT INTO LANGUECHANSON VALUES('en',1490,'t');
INSERT INTO LANGUECHANSON VALUES('en',1491,'t');
INSERT INTO LANGUECHANSON VALUES('en',1489,'t');
INSERT INTO LANGUECHANSON VALUES('en',1493,'t');
INSERT INTO LANGUECHANSON VALUES('en',1494,'t');
INSERT INTO LANGUECHANSON VALUES('en',1495,'t');
INSERT INTO LANGUECHANSON VALUES('en',1496,'t');
INSERT INTO LANGUECHANSON VALUES('en',1497,'t');
INSERT INTO LANGUECHANSON VALUES('en',1498,'t');
INSERT INTO LANGUECHANSON VALUES('en',1499,'t');
INSERT INTO LANGUECHANSON VALUES('en',1500,'t');
INSERT INTO LANGUECHANSON VALUES('en',1501,'t');
INSERT INTO LANGUECHANSON VALUES('en',1504,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1506,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1507,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1508,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1509,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1511,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1512,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1513,'t');
INSERT INTO LANGUECHANSON VALUES('en',1514,'t');
INSERT INTO LANGUECHANSON VALUES('en',1515,'t');
INSERT INTO LANGUECHANSON VALUES('en',1516,'t');
INSERT INTO LANGUECHANSON VALUES('en',1517,'t');
INSERT INTO LANGUECHANSON VALUES('en',1518,'t');
INSERT INTO LANGUECHANSON VALUES('en',1521,'t');
INSERT INTO LANGUECHANSON VALUES('en',1522,'t');
INSERT INTO LANGUECHANSON VALUES('en',1524,'t');
INSERT INTO LANGUECHANSON VALUES('en',1525,'t');
INSERT INTO LANGUECHANSON VALUES('en',1527,'t');
INSERT INTO LANGUECHANSON VALUES('en',1529,'t');
INSERT INTO LANGUECHANSON VALUES('en',1532,'t');
INSERT INTO LANGUECHANSON VALUES('en',1533,'t');
INSERT INTO LANGUECHANSON VALUES('en',1538,'t');
INSERT INTO LANGUECHANSON VALUES('en',1539,'t');
INSERT INTO LANGUECHANSON VALUES('en',1540,'t');
INSERT INTO LANGUECHANSON VALUES('en',1541,'t');
INSERT INTO LANGUECHANSON VALUES('en',1546,'t');
INSERT INTO LANGUECHANSON VALUES('en',1550,'t');
INSERT INTO LANGUECHANSON VALUES('en',1551,'t');
INSERT INTO LANGUECHANSON VALUES('en',1552,'t');
INSERT INTO LANGUECHANSON VALUES('en',1553,'t');
INSERT INTO LANGUECHANSON VALUES('en',1554,'t');
INSERT INTO LANGUECHANSON VALUES('en',1555,'t');
INSERT INTO LANGUECHANSON VALUES('en',1556,'t');
INSERT INTO LANGUECHANSON VALUES('en',1557,'t');
INSERT INTO LANGUECHANSON VALUES('en',1559,'t');
INSERT INTO LANGUECHANSON VALUES('en',1561,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1568,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1570,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1571,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1572,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1573,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1574,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1575,'t');
INSERT INTO LANGUECHANSON VALUES('en',1584,'t');
INSERT INTO LANGUECHANSON VALUES('en',1585,'t');
INSERT INTO LANGUECHANSON VALUES('en',1586,'t');
INSERT INTO LANGUECHANSON VALUES('en',1588,'t');
INSERT INTO LANGUECHANSON VALUES('en',1589,'t');
INSERT INTO LANGUECHANSON VALUES('en',1590,'t');
INSERT INTO LANGUECHANSON VALUES('en',1591,'t');
INSERT INTO LANGUECHANSON VALUES('en',1592,'t');
INSERT INTO LANGUECHANSON VALUES('en',1593,'t');
INSERT INTO LANGUECHANSON VALUES('en',1594,'t');
INSERT INTO LANGUECHANSON VALUES('en',1595,'t');
INSERT INTO LANGUECHANSON VALUES('en',1596,'t');
INSERT INTO LANGUECHANSON VALUES('en',1597,'t');
INSERT INTO LANGUECHANSON VALUES('en',1598,'t');
INSERT INTO LANGUECHANSON VALUES('en',1599,'t');
INSERT INTO LANGUECHANSON VALUES('en',1600,'t');
INSERT INTO LANGUECHANSON VALUES('en',1602,'t');
INSERT INTO LANGUECHANSON VALUES('en',1603,'t');
INSERT INTO LANGUECHANSON VALUES('en',1606,'t');
INSERT INTO LANGUECHANSON VALUES('en',1607,'t');
INSERT INTO LANGUECHANSON VALUES('en',1608,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1616,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1617,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1618,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1619,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1620,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1625,'t');
INSERT INTO LANGUECHANSON VALUES('en',1626,'t');
INSERT INTO LANGUECHANSON VALUES('en',1627,'t');
INSERT INTO LANGUECHANSON VALUES('en',1628,'t');
INSERT INTO LANGUECHANSON VALUES('en',1629,'t');
INSERT INTO LANGUECHANSON VALUES('en',1601,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11563,'t');
INSERT INTO LANGUECHANSON VALUES('en',1645,'t');
INSERT INTO LANGUECHANSON VALUES('en',1650,'t');
INSERT INTO LANGUECHANSON VALUES('en',1651,'t');
INSERT INTO LANGUECHANSON VALUES('en',1666,'t');
INSERT INTO LANGUECHANSON VALUES('en',1667,'t');
INSERT INTO LANGUECHANSON VALUES('en',1668,'t');
INSERT INTO LANGUECHANSON VALUES('en',1669,'t');
INSERT INTO LANGUECHANSON VALUES('en',1670,'t');
INSERT INTO LANGUECHANSON VALUES('en',1671,'t');
INSERT INTO LANGUECHANSON VALUES('en',1672,'t');
INSERT INTO LANGUECHANSON VALUES('en',1673,'t');
INSERT INTO LANGUECHANSON VALUES('en',1674,'t');
INSERT INTO LANGUECHANSON VALUES('en',1675,'t');
INSERT INTO LANGUECHANSON VALUES('en',1677,'t');
INSERT INTO LANGUECHANSON VALUES('en',1678,'t');
INSERT INTO LANGUECHANSON VALUES('en',1679,'t');
INSERT INTO LANGUECHANSON VALUES('en',1680,'t');
INSERT INTO LANGUECHANSON VALUES('en',1681,'t');
INSERT INTO LANGUECHANSON VALUES('en',1682,'t');
INSERT INTO LANGUECHANSON VALUES('en',1683,'t');
INSERT INTO LANGUECHANSON VALUES('en',1684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1687,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1688,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1689,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1690,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1691,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1692,'t');
INSERT INTO LANGUECHANSON VALUES('en',1693,'t');
INSERT INTO LANGUECHANSON VALUES('en',1694,'t');
INSERT INTO LANGUECHANSON VALUES('en',1695,'t');
INSERT INTO LANGUECHANSON VALUES('en',1696,'t');
INSERT INTO LANGUECHANSON VALUES('en',1697,'t');
INSERT INTO LANGUECHANSON VALUES('en',1698,'t');
INSERT INTO LANGUECHANSON VALUES('en',1699,'t');
INSERT INTO LANGUECHANSON VALUES('en',1700,'t');
INSERT INTO LANGUECHANSON VALUES('en',1703,'t');
INSERT INTO LANGUECHANSON VALUES('en',1705,'t');
INSERT INTO LANGUECHANSON VALUES('en',1711,'t');
INSERT INTO LANGUECHANSON VALUES('en',1712,'t');
INSERT INTO LANGUECHANSON VALUES('en',1713,'t');
INSERT INTO LANGUECHANSON VALUES('en',1714,'t');
INSERT INTO LANGUECHANSON VALUES('en',1715,'t');
INSERT INTO LANGUECHANSON VALUES('en',1716,'t');
INSERT INTO LANGUECHANSON VALUES('en',1717,'t');
INSERT INTO LANGUECHANSON VALUES('en',1719,'t');
INSERT INTO LANGUECHANSON VALUES('en',1720,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1721,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1722,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1723,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1724,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1725,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1726,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1727,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1728,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1729,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1730,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1731,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1732,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1733,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1734,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1735,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1736,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1737,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1738,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1739,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1741,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1742,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1743,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11564,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1745,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1746,'t');
INSERT INTO LANGUECHANSON VALUES('en',1748,'t');
INSERT INTO LANGUECHANSON VALUES('en',1749,'t');
INSERT INTO LANGUECHANSON VALUES('en',1750,'t');
INSERT INTO LANGUECHANSON VALUES('en',1751,'t');
INSERT INTO LANGUECHANSON VALUES('en',1752,'t');
INSERT INTO LANGUECHANSON VALUES('en',1753,'t');
INSERT INTO LANGUECHANSON VALUES('en',1754,'t');
INSERT INTO LANGUECHANSON VALUES('en',1755,'t');
INSERT INTO LANGUECHANSON VALUES('en',1756,'t');
INSERT INTO LANGUECHANSON VALUES('en',1757,'t');
INSERT INTO LANGUECHANSON VALUES('en',1758,'t');
INSERT INTO LANGUECHANSON VALUES('en',1759,'t');
INSERT INTO LANGUECHANSON VALUES('en',1760,'t');
INSERT INTO LANGUECHANSON VALUES('en',1762,'t');
INSERT INTO LANGUECHANSON VALUES('en',1763,'t');
INSERT INTO LANGUECHANSON VALUES('en',1764,'t');
INSERT INTO LANGUECHANSON VALUES('en',1765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1774,'t');
INSERT INTO LANGUECHANSON VALUES('en',1775,'t');
INSERT INTO LANGUECHANSON VALUES('en',1776,'t');
INSERT INTO LANGUECHANSON VALUES('en',1709,'t');
INSERT INTO LANGUECHANSON VALUES('en',1777,'t');
INSERT INTO LANGUECHANSON VALUES('en',1778,'t');
INSERT INTO LANGUECHANSON VALUES('en',1780,'t');
INSERT INTO LANGUECHANSON VALUES('en',1782,'t');
INSERT INTO LANGUECHANSON VALUES('en',1784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1786,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1791,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1792,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11565,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1795,'t');
INSERT INTO LANGUECHANSON VALUES('en',1796,'t');
INSERT INTO LANGUECHANSON VALUES('en',1797,'t');
INSERT INTO LANGUECHANSON VALUES('en',1798,'t');
INSERT INTO LANGUECHANSON VALUES('en',1799,'t');
INSERT INTO LANGUECHANSON VALUES('en',1800,'t');
INSERT INTO LANGUECHANSON VALUES('en',1801,'t');
INSERT INTO LANGUECHANSON VALUES('en',1802,'t');
INSERT INTO LANGUECHANSON VALUES('en',1804,'t');
INSERT INTO LANGUECHANSON VALUES('en',1805,'t');
INSERT INTO LANGUECHANSON VALUES('en',1806,'t');
INSERT INTO LANGUECHANSON VALUES('en',1807,'t');
INSERT INTO LANGUECHANSON VALUES('en',1809,'t');
INSERT INTO LANGUECHANSON VALUES('en',1810,'t');
INSERT INTO LANGUECHANSON VALUES('en',1811,'t');
INSERT INTO LANGUECHANSON VALUES('en',1812,'t');
INSERT INTO LANGUECHANSON VALUES('en',1813,'t');
INSERT INTO LANGUECHANSON VALUES('en',1814,'t');
INSERT INTO LANGUECHANSON VALUES('en',1817,'t');
INSERT INTO LANGUECHANSON VALUES('en',1818,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1820,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1822,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1823,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1824,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1825,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1826,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1827,'t');
INSERT INTO LANGUECHANSON VALUES('en',1828,'t');
INSERT INTO LANGUECHANSON VALUES('en',1829,'t');
INSERT INTO LANGUECHANSON VALUES('en',1830,'t');
INSERT INTO LANGUECHANSON VALUES('en',1831,'t');
INSERT INTO LANGUECHANSON VALUES('en',1832,'t');
INSERT INTO LANGUECHANSON VALUES('en',1833,'t');
INSERT INTO LANGUECHANSON VALUES('en',1834,'t');
INSERT INTO LANGUECHANSON VALUES('en',1835,'t');
INSERT INTO LANGUECHANSON VALUES('en',1836,'t');
INSERT INTO LANGUECHANSON VALUES('en',1837,'t');
INSERT INTO LANGUECHANSON VALUES('en',1838,'t');
INSERT INTO LANGUECHANSON VALUES('en',1840,'t');
INSERT INTO LANGUECHANSON VALUES('en',1841,'t');
INSERT INTO LANGUECHANSON VALUES('en',1842,'t');
INSERT INTO LANGUECHANSON VALUES('en',1843,'t');
INSERT INTO LANGUECHANSON VALUES('en',1844,'t');
INSERT INTO LANGUECHANSON VALUES('en',1845,'t');
INSERT INTO LANGUECHANSON VALUES('en',1846,'t');
INSERT INTO LANGUECHANSON VALUES('en',1781,'t');
INSERT INTO LANGUECHANSON VALUES('en',1816,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1850,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1851,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1852,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1853,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1857,'t');
INSERT INTO LANGUECHANSON VALUES('en',1858,'t');
INSERT INTO LANGUECHANSON VALUES('en',1859,'t');
INSERT INTO LANGUECHANSON VALUES('en',1862,'t');
INSERT INTO LANGUECHANSON VALUES('en',1863,'t');
INSERT INTO LANGUECHANSON VALUES('en',1864,'t');
INSERT INTO LANGUECHANSON VALUES('en',1865,'t');
INSERT INTO LANGUECHANSON VALUES('en',1866,'t');
INSERT INTO LANGUECHANSON VALUES('en',1867,'t');
INSERT INTO LANGUECHANSON VALUES('en',1868,'t');
INSERT INTO LANGUECHANSON VALUES('en',1869,'t');
INSERT INTO LANGUECHANSON VALUES('en',1870,'t');
INSERT INTO LANGUECHANSON VALUES('en',1871,'t');
INSERT INTO LANGUECHANSON VALUES('en',1872,'t');
INSERT INTO LANGUECHANSON VALUES('en',1873,'t');
INSERT INTO LANGUECHANSON VALUES('en',1874,'t');
INSERT INTO LANGUECHANSON VALUES('en',1875,'t');
INSERT INTO LANGUECHANSON VALUES('en',1876,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1877,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1878,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1879,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1880,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1881,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1882,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1883,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1884,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1885,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1886,'t');
INSERT INTO LANGUECHANSON VALUES('en',1887,'t');
INSERT INTO LANGUECHANSON VALUES('en',1888,'t');
INSERT INTO LANGUECHANSON VALUES('en',1889,'t');
INSERT INTO LANGUECHANSON VALUES('en',1890,'t');
INSERT INTO LANGUECHANSON VALUES('en',1891,'t');
INSERT INTO LANGUECHANSON VALUES('en',1892,'t');
INSERT INTO LANGUECHANSON VALUES('en',1893,'t');
INSERT INTO LANGUECHANSON VALUES('en',1894,'t');
INSERT INTO LANGUECHANSON VALUES('en',1895,'t');
INSERT INTO LANGUECHANSON VALUES('en',1896,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1901,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1902,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1903,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1904,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1905,'t');
INSERT INTO LANGUECHANSON VALUES('en',1909,'t');
INSERT INTO LANGUECHANSON VALUES('en',1912,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11566,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1919,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1920,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1921,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1922,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1923,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1924,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1925,'t');
INSERT INTO LANGUECHANSON VALUES('en',1926,'t');
INSERT INTO LANGUECHANSON VALUES('en',1928,'t');
INSERT INTO LANGUECHANSON VALUES('en',1930,'t');
INSERT INTO LANGUECHANSON VALUES('en',1931,'t');
INSERT INTO LANGUECHANSON VALUES('en',1932,'t');
INSERT INTO LANGUECHANSON VALUES('en',1933,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1935,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1936,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1941,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1942,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1943,'t');
INSERT INTO LANGUECHANSON VALUES('en',1929,'t');
INSERT INTO LANGUECHANSON VALUES('en',1949,'t');
INSERT INTO LANGUECHANSON VALUES('en',1950,'t');
INSERT INTO LANGUECHANSON VALUES('en',1951,'t');
INSERT INTO LANGUECHANSON VALUES('en',1952,'t');
INSERT INTO LANGUECHANSON VALUES('en',1953,'t');
INSERT INTO LANGUECHANSON VALUES('en',1954,'t');
INSERT INTO LANGUECHANSON VALUES('en',1956,'t');
INSERT INTO LANGUECHANSON VALUES('en',1957,'t');
INSERT INTO LANGUECHANSON VALUES('en',1958,'t');
INSERT INTO LANGUECHANSON VALUES('en',1959,'t');
INSERT INTO LANGUECHANSON VALUES('en',1960,'t');
INSERT INTO LANGUECHANSON VALUES('en',1961,'t');
INSERT INTO LANGUECHANSON VALUES('en',1962,'t');
INSERT INTO LANGUECHANSON VALUES('en',1963,'t');
INSERT INTO LANGUECHANSON VALUES('en',1964,'t');
INSERT INTO LANGUECHANSON VALUES('en',1965,'t');
INSERT INTO LANGUECHANSON VALUES('en',1967,'t');
INSERT INTO LANGUECHANSON VALUES('en',1968,'t');
INSERT INTO LANGUECHANSON VALUES('en',1969,'t');
INSERT INTO LANGUECHANSON VALUES('en',1970,'t');
INSERT INTO LANGUECHANSON VALUES('en',1971,'t');
INSERT INTO LANGUECHANSON VALUES('en',1972,'t');
INSERT INTO LANGUECHANSON VALUES('en',1973,'t');
INSERT INTO LANGUECHANSON VALUES('en',1974,'t');
INSERT INTO LANGUECHANSON VALUES('en',1975,'t');
INSERT INTO LANGUECHANSON VALUES('en',1976,'t');
INSERT INTO LANGUECHANSON VALUES('en',1989,'t');
INSERT INTO LANGUECHANSON VALUES('en',1990,'t');
INSERT INTO LANGUECHANSON VALUES('en',1991,'t');
INSERT INTO LANGUECHANSON VALUES('en',1992,'t');
INSERT INTO LANGUECHANSON VALUES('en',1994,'t');
INSERT INTO LANGUECHANSON VALUES('en',1995,'t');
INSERT INTO LANGUECHANSON VALUES('en',1996,'t');
INSERT INTO LANGUECHANSON VALUES('en',1997,'t');
INSERT INTO LANGUECHANSON VALUES('en',1998,'t');
INSERT INTO LANGUECHANSON VALUES('en',1999,'t');
INSERT INTO LANGUECHANSON VALUES('en',2000,'t');
INSERT INTO LANGUECHANSON VALUES('en',2001,'t');
INSERT INTO LANGUECHANSON VALUES('en',2002,'t');
INSERT INTO LANGUECHANSON VALUES('en',2003,'t');
INSERT INTO LANGUECHANSON VALUES('en',2004,'t');
INSERT INTO LANGUECHANSON VALUES('en',2006,'t');
INSERT INTO LANGUECHANSON VALUES('en',2007,'t');
INSERT INTO LANGUECHANSON VALUES('en',2008,'t');
INSERT INTO LANGUECHANSON VALUES('en',1982,'t');
INSERT INTO LANGUECHANSON VALUES('en',2021,'t');
INSERT INTO LANGUECHANSON VALUES('en',2024,'t');
INSERT INTO LANGUECHANSON VALUES('en',2026,'t');
INSERT INTO LANGUECHANSON VALUES('en',2027,'t');
INSERT INTO LANGUECHANSON VALUES('en',2028,'t');
INSERT INTO LANGUECHANSON VALUES('en',2029,'t');
INSERT INTO LANGUECHANSON VALUES('en',2030,'t');
INSERT INTO LANGUECHANSON VALUES('en',2031,'t');
INSERT INTO LANGUECHANSON VALUES('en',2032,'t');
INSERT INTO LANGUECHANSON VALUES('en',2033,'t');
INSERT INTO LANGUECHANSON VALUES('en',2034,'t');
INSERT INTO LANGUECHANSON VALUES('en',2035,'t');
INSERT INTO LANGUECHANSON VALUES('en',2036,'t');
INSERT INTO LANGUECHANSON VALUES('en',2037,'t');
INSERT INTO LANGUECHANSON VALUES('en',2038,'t');
INSERT INTO LANGUECHANSON VALUES('en',2039,'t');
INSERT INTO LANGUECHANSON VALUES('en',2040,'t');
INSERT INTO LANGUECHANSON VALUES('en',2041,'t');
INSERT INTO LANGUECHANSON VALUES('en',1979,'t');
INSERT INTO LANGUECHANSON VALUES('en',2042,'t');
INSERT INTO LANGUECHANSON VALUES('en',2044,'t');
INSERT INTO LANGUECHANSON VALUES('en',2045,'t');
INSERT INTO LANGUECHANSON VALUES('en',2046,'t');
INSERT INTO LANGUECHANSON VALUES('en',2047,'t');
INSERT INTO LANGUECHANSON VALUES('en',2048,'t');
INSERT INTO LANGUECHANSON VALUES('en',2049,'t');
INSERT INTO LANGUECHANSON VALUES('en',2051,'t');
INSERT INTO LANGUECHANSON VALUES('en',2052,'t');
INSERT INTO LANGUECHANSON VALUES('en',2053,'t');
INSERT INTO LANGUECHANSON VALUES('en',2056,'t');
INSERT INTO LANGUECHANSON VALUES('en',2057,'t');
INSERT INTO LANGUECHANSON VALUES('en',2058,'t');
INSERT INTO LANGUECHANSON VALUES('en',2059,'t');
INSERT INTO LANGUECHANSON VALUES('en',2061,'t');
INSERT INTO LANGUECHANSON VALUES('en',2062,'t');
INSERT INTO LANGUECHANSON VALUES('en',2063,'t');
INSERT INTO LANGUECHANSON VALUES('en',2064,'t');
INSERT INTO LANGUECHANSON VALUES('en',2065,'t');
INSERT INTO LANGUECHANSON VALUES('en',2066,'t');
INSERT INTO LANGUECHANSON VALUES('en',2067,'t');
INSERT INTO LANGUECHANSON VALUES('en',2068,'t');
INSERT INTO LANGUECHANSON VALUES('en',2069,'t');
INSERT INTO LANGUECHANSON VALUES('en',2071,'t');
INSERT INTO LANGUECHANSON VALUES('en',2072,'t');
INSERT INTO LANGUECHANSON VALUES('en',2073,'t');
INSERT INTO LANGUECHANSON VALUES('en',2074,'t');
INSERT INTO LANGUECHANSON VALUES('en',2075,'t');
INSERT INTO LANGUECHANSON VALUES('en',2076,'t');
INSERT INTO LANGUECHANSON VALUES('en',2078,'t');
INSERT INTO LANGUECHANSON VALUES('en',2079,'t');
INSERT INTO LANGUECHANSON VALUES('en',2080,'t');
INSERT INTO LANGUECHANSON VALUES('en',2081,'t');
INSERT INTO LANGUECHANSON VALUES('en',2082,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2083,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2084,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2085,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2086,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2087,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2088,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2089,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2090,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2091,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2092,'t');
INSERT INTO LANGUECHANSON VALUES('en',2093,'t');
INSERT INTO LANGUECHANSON VALUES('en',2094,'t');
INSERT INTO LANGUECHANSON VALUES('en',2095,'t');
INSERT INTO LANGUECHANSON VALUES('en',2096,'t');
INSERT INTO LANGUECHANSON VALUES('en',2097,'t');
INSERT INTO LANGUECHANSON VALUES('en',2099,'t');
INSERT INTO LANGUECHANSON VALUES('en',2100,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2102,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2103,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2105,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2106,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2107,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2108,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2109,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2110,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2111,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2112,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2113,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2114,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2115,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2116,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2117,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2118,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2119,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2121,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2122,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2125,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2126,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2127,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2128,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2129,'t');
INSERT INTO LANGUECHANSON VALUES('en',2132,'t');
INSERT INTO LANGUECHANSON VALUES('en',2133,'t');
INSERT INTO LANGUECHANSON VALUES('en',2134,'t');
INSERT INTO LANGUECHANSON VALUES('en',2135,'t');
INSERT INTO LANGUECHANSON VALUES('en',2136,'t');
INSERT INTO LANGUECHANSON VALUES('en',2137,'t');
INSERT INTO LANGUECHANSON VALUES('en',2138,'t');
INSERT INTO LANGUECHANSON VALUES('en',2139,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2124,'t');
INSERT INTO LANGUECHANSON VALUES('en',2140,'t');
INSERT INTO LANGUECHANSON VALUES('en',2141,'t');
INSERT INTO LANGUECHANSON VALUES('en',2142,'t');
INSERT INTO LANGUECHANSON VALUES('en',2143,'t');
INSERT INTO LANGUECHANSON VALUES('en',2144,'t');
INSERT INTO LANGUECHANSON VALUES('en',2145,'t');
INSERT INTO LANGUECHANSON VALUES('en',2146,'t');
INSERT INTO LANGUECHANSON VALUES('en',2147,'t');
INSERT INTO LANGUECHANSON VALUES('en',2149,'t');
INSERT INTO LANGUECHANSON VALUES('en',2150,'t');
INSERT INTO LANGUECHANSON VALUES('en',2151,'t');
INSERT INTO LANGUECHANSON VALUES('en',2152,'t');
INSERT INTO LANGUECHANSON VALUES('en',2153,'t');
INSERT INTO LANGUECHANSON VALUES('en',2154,'t');
INSERT INTO LANGUECHANSON VALUES('en',2155,'t');
INSERT INTO LANGUECHANSON VALUES('en',2156,'t');
INSERT INTO LANGUECHANSON VALUES('en',2157,'t');
INSERT INTO LANGUECHANSON VALUES('en',2158,'t');
INSERT INTO LANGUECHANSON VALUES('en',2159,'t');
INSERT INTO LANGUECHANSON VALUES('en',2160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2163,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2164,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2165,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2166,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2167,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2168,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2169,'t');
INSERT INTO LANGUECHANSON VALUES('en',2180,'t');
INSERT INTO LANGUECHANSON VALUES('en',2182,'t');
INSERT INTO LANGUECHANSON VALUES('en',2183,'t');
INSERT INTO LANGUECHANSON VALUES('en',2185,'t');
INSERT INTO LANGUECHANSON VALUES('en',2186,'t');
INSERT INTO LANGUECHANSON VALUES('en',2187,'t');
INSERT INTO LANGUECHANSON VALUES('en',2188,'t');
INSERT INTO LANGUECHANSON VALUES('en',2189,'t');
INSERT INTO LANGUECHANSON VALUES('en',2190,'t');
INSERT INTO LANGUECHANSON VALUES('en',2191,'t');
INSERT INTO LANGUECHANSON VALUES('en',2193,'t');
INSERT INTO LANGUECHANSON VALUES('en',2194,'t');
INSERT INTO LANGUECHANSON VALUES('en',2196,'t');
INSERT INTO LANGUECHANSON VALUES('en',2197,'t');
INSERT INTO LANGUECHANSON VALUES('en',2198,'t');
INSERT INTO LANGUECHANSON VALUES('en',2199,'t');
INSERT INTO LANGUECHANSON VALUES('en',2203,'t');
INSERT INTO LANGUECHANSON VALUES('en',2148,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2228,'t');
INSERT INTO LANGUECHANSON VALUES('en',2229,'t');
INSERT INTO LANGUECHANSON VALUES('en',2230,'t');
INSERT INTO LANGUECHANSON VALUES('en',2231,'t');
INSERT INTO LANGUECHANSON VALUES('en',2232,'t');
INSERT INTO LANGUECHANSON VALUES('en',2233,'t');
INSERT INTO LANGUECHANSON VALUES('en',2234,'t');
INSERT INTO LANGUECHANSON VALUES('en',2235,'t');
INSERT INTO LANGUECHANSON VALUES('en',2236,'t');
INSERT INTO LANGUECHANSON VALUES('en',2237,'t');
INSERT INTO LANGUECHANSON VALUES('en',2238,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2240,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2241,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2242,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2243,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2244,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2246,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2247,'t');
INSERT INTO LANGUECHANSON VALUES('en',2201,'t');
INSERT INTO LANGUECHANSON VALUES('en',2250,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2270,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2271,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2274,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2276,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2277,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2278,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2279,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2280,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2281,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2282,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2283,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2284,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2286,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2287,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2288,'t');
INSERT INTO LANGUECHANSON VALUES('en',2289,'t');
INSERT INTO LANGUECHANSON VALUES('en',2290,'t');
INSERT INTO LANGUECHANSON VALUES('en',2291,'t');
INSERT INTO LANGUECHANSON VALUES('en',2292,'t');
INSERT INTO LANGUECHANSON VALUES('en',2293,'t');
INSERT INTO LANGUECHANSON VALUES('en',2294,'t');
INSERT INTO LANGUECHANSON VALUES('en',2295,'t');
INSERT INTO LANGUECHANSON VALUES('en',2256,'t');
INSERT INTO LANGUECHANSON VALUES('en',2253,'t');
INSERT INTO LANGUECHANSON VALUES('en',2296,'t');
INSERT INTO LANGUECHANSON VALUES('en',2297,'t');
INSERT INTO LANGUECHANSON VALUES('en',2298,'t');
INSERT INTO LANGUECHANSON VALUES('en',2299,'t');
INSERT INTO LANGUECHANSON VALUES('en',2300,'t');
INSERT INTO LANGUECHANSON VALUES('en',2301,'t');
INSERT INTO LANGUECHANSON VALUES('en',2302,'t');
INSERT INTO LANGUECHANSON VALUES('en',2303,'t');
INSERT INTO LANGUECHANSON VALUES('en',2304,'t');
INSERT INTO LANGUECHANSON VALUES('en',2305,'t');
INSERT INTO LANGUECHANSON VALUES('en',2306,'t');
INSERT INTO LANGUECHANSON VALUES('en',2307,'t');
INSERT INTO LANGUECHANSON VALUES('en',2309,'t');
INSERT INTO LANGUECHANSON VALUES('en',2310,'t');
INSERT INTO LANGUECHANSON VALUES('en',2311,'t');
INSERT INTO LANGUECHANSON VALUES('en',2314,'t');
INSERT INTO LANGUECHANSON VALUES('en',2315,'t');
INSERT INTO LANGUECHANSON VALUES('en',2317,'t');
INSERT INTO LANGUECHANSON VALUES('en',2318,'t');
INSERT INTO LANGUECHANSON VALUES('en',2319,'t');
INSERT INTO LANGUECHANSON VALUES('en',2320,'t');
INSERT INTO LANGUECHANSON VALUES('en',2321,'t');
INSERT INTO LANGUECHANSON VALUES('en',2322,'t');
INSERT INTO LANGUECHANSON VALUES('en',2323,'t');
INSERT INTO LANGUECHANSON VALUES('en',2324,'t');
INSERT INTO LANGUECHANSON VALUES('en',2325,'t');
INSERT INTO LANGUECHANSON VALUES('en',2326,'t');
INSERT INTO LANGUECHANSON VALUES('en',2328,'t');
INSERT INTO LANGUECHANSON VALUES('en',2329,'t');
INSERT INTO LANGUECHANSON VALUES('en',2330,'t');
INSERT INTO LANGUECHANSON VALUES('en',2331,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2334,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2335,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2336,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2337,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2338,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2339,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2340,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2341,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2342,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2343,'t');
INSERT INTO LANGUECHANSON VALUES('en',2344,'t');
INSERT INTO LANGUECHANSON VALUES('en',2345,'t');
INSERT INTO LANGUECHANSON VALUES('en',2346,'t');
INSERT INTO LANGUECHANSON VALUES('en',2347,'t');
INSERT INTO LANGUECHANSON VALUES('en',2348,'t');
INSERT INTO LANGUECHANSON VALUES('en',2349,'t');
INSERT INTO LANGUECHANSON VALUES('en',2350,'t');
INSERT INTO LANGUECHANSON VALUES('en',2351,'t');
INSERT INTO LANGUECHANSON VALUES('en',2352,'t');
INSERT INTO LANGUECHANSON VALUES('en',2353,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2354,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2355,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2356,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2357,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2358,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2359,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2360,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2361,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2362,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2363,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2364,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2365,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2366,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2367,'t');
INSERT INTO LANGUECHANSON VALUES('en',2377,'t');
INSERT INTO LANGUECHANSON VALUES('en',2378,'t');
INSERT INTO LANGUECHANSON VALUES('en',2379,'t');
INSERT INTO LANGUECHANSON VALUES('en',2370,'t');
INSERT INTO LANGUECHANSON VALUES('en',2380,'t');
INSERT INTO LANGUECHANSON VALUES('en',2381,'t');
INSERT INTO LANGUECHANSON VALUES('en',2382,'t');
INSERT INTO LANGUECHANSON VALUES('en',2383,'t');
INSERT INTO LANGUECHANSON VALUES('en',2384,'t');
INSERT INTO LANGUECHANSON VALUES('en',2386,'t');
INSERT INTO LANGUECHANSON VALUES('en',2387,'t');
INSERT INTO LANGUECHANSON VALUES('en',2388,'t');
INSERT INTO LANGUECHANSON VALUES('en',2389,'t');
INSERT INTO LANGUECHANSON VALUES('en',2390,'t');
INSERT INTO LANGUECHANSON VALUES('en',2391,'t');
INSERT INTO LANGUECHANSON VALUES('en',2392,'t');
INSERT INTO LANGUECHANSON VALUES('en',2393,'t');
INSERT INTO LANGUECHANSON VALUES('en',2394,'t');
INSERT INTO LANGUECHANSON VALUES('en',2396,'t');
INSERT INTO LANGUECHANSON VALUES('en',2397,'t');
INSERT INTO LANGUECHANSON VALUES('en',2398,'t');
INSERT INTO LANGUECHANSON VALUES('en',2399,'t');
INSERT INTO LANGUECHANSON VALUES('en',2410,'t');
INSERT INTO LANGUECHANSON VALUES('en',2411,'t');
INSERT INTO LANGUECHANSON VALUES('en',2425,'t');
INSERT INTO LANGUECHANSON VALUES('en',2426,'t');
INSERT INTO LANGUECHANSON VALUES('en',2427,'t');
INSERT INTO LANGUECHANSON VALUES('en',2428,'t');
INSERT INTO LANGUECHANSON VALUES('en',2429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2440,'t');
INSERT INTO LANGUECHANSON VALUES('en',2441,'t');
INSERT INTO LANGUECHANSON VALUES('en',2442,'t');
INSERT INTO LANGUECHANSON VALUES('en',2443,'t');
INSERT INTO LANGUECHANSON VALUES('en',2444,'t');
INSERT INTO LANGUECHANSON VALUES('en',2445,'t');
INSERT INTO LANGUECHANSON VALUES('en',2446,'t');
INSERT INTO LANGUECHANSON VALUES('en',2447,'t');
INSERT INTO LANGUECHANSON VALUES('en',2448,'t');
INSERT INTO LANGUECHANSON VALUES('en',2449,'t');
INSERT INTO LANGUECHANSON VALUES('en',2451,'t');
INSERT INTO LANGUECHANSON VALUES('en',2452,'t');
INSERT INTO LANGUECHANSON VALUES('en',2457,'t');
INSERT INTO LANGUECHANSON VALUES('en',2462,'t');
INSERT INTO LANGUECHANSON VALUES('en',2463,'t');
INSERT INTO LANGUECHANSON VALUES('en',2464,'t');
INSERT INTO LANGUECHANSON VALUES('en',2465,'t');
INSERT INTO LANGUECHANSON VALUES('en',2466,'t');
INSERT INTO LANGUECHANSON VALUES('en',2467,'t');
INSERT INTO LANGUECHANSON VALUES('en',2468,'t');
INSERT INTO LANGUECHANSON VALUES('en',2469,'t');
INSERT INTO LANGUECHANSON VALUES('en',2470,'t');
INSERT INTO LANGUECHANSON VALUES('en',2473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2482,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2483,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2484,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2485,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2486,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2487,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2488,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2489,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2490,'t');
INSERT INTO LANGUECHANSON VALUES('en',2491,'t');
INSERT INTO LANGUECHANSON VALUES('en',2492,'t');
INSERT INTO LANGUECHANSON VALUES('en',2493,'t');
INSERT INTO LANGUECHANSON VALUES('en',2494,'t');
INSERT INTO LANGUECHANSON VALUES('en',2495,'t');
INSERT INTO LANGUECHANSON VALUES('en',2496,'t');
INSERT INTO LANGUECHANSON VALUES('en',2497,'t');
INSERT INTO LANGUECHANSON VALUES('en',2498,'t');
INSERT INTO LANGUECHANSON VALUES('en',2499,'t');
INSERT INTO LANGUECHANSON VALUES('en',2500,'t');
INSERT INTO LANGUECHANSON VALUES('en',2501,'t');
INSERT INTO LANGUECHANSON VALUES('en',2502,'t');
INSERT INTO LANGUECHANSON VALUES('en',2503,'t');
INSERT INTO LANGUECHANSON VALUES('en',2504,'t');
INSERT INTO LANGUECHANSON VALUES('en',2505,'t');
INSERT INTO LANGUECHANSON VALUES('en',2506,'t');
INSERT INTO LANGUECHANSON VALUES('en',2508,'t');
INSERT INTO LANGUECHANSON VALUES('en',2509,'t');
INSERT INTO LANGUECHANSON VALUES('en',2510,'t');
INSERT INTO LANGUECHANSON VALUES('en',2511,'t');
INSERT INTO LANGUECHANSON VALUES('en',2512,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2513,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2514,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2515,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2516,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2517,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2518,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2519,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2520,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2521,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2522,'t');
INSERT INTO LANGUECHANSON VALUES('en',2523,'t');
INSERT INTO LANGUECHANSON VALUES('en',2525,'t');
INSERT INTO LANGUECHANSON VALUES('en',2479,'t');
INSERT INTO LANGUECHANSON VALUES('en',2526,'t');
INSERT INTO LANGUECHANSON VALUES('en',2527,'t');
INSERT INTO LANGUECHANSON VALUES('en',2528,'t');
INSERT INTO LANGUECHANSON VALUES('en',2529,'t');
INSERT INTO LANGUECHANSON VALUES('en',2530,'t');
INSERT INTO LANGUECHANSON VALUES('en',2531,'t');
INSERT INTO LANGUECHANSON VALUES('en',2532,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2533,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2534,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2535,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2537,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2538,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2539,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2540,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2541,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2542,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2543,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2544,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2545,'t');
INSERT INTO LANGUECHANSON VALUES('en',2546,'t');
INSERT INTO LANGUECHANSON VALUES('en',2547,'t');
INSERT INTO LANGUECHANSON VALUES('en',2548,'t');
INSERT INTO LANGUECHANSON VALUES('en',2549,'t');
INSERT INTO LANGUECHANSON VALUES('en',2550,'t');
INSERT INTO LANGUECHANSON VALUES('en',2551,'t');
INSERT INTO LANGUECHANSON VALUES('en',2552,'t');
INSERT INTO LANGUECHANSON VALUES('en',2555,'t');
INSERT INTO LANGUECHANSON VALUES('en',2556,'t');
INSERT INTO LANGUECHANSON VALUES('en',2557,'t');
INSERT INTO LANGUECHANSON VALUES('en',2558,'t');
INSERT INTO LANGUECHANSON VALUES('en',2559,'t');
INSERT INTO LANGUECHANSON VALUES('en',2560,'t');
INSERT INTO LANGUECHANSON VALUES('en',2561,'t');
INSERT INTO LANGUECHANSON VALUES('en',2562,'t');
INSERT INTO LANGUECHANSON VALUES('en',2563,'t');
INSERT INTO LANGUECHANSON VALUES('en',2564,'t');
INSERT INTO LANGUECHANSON VALUES('en',2565,'t');
INSERT INTO LANGUECHANSON VALUES('en',2566,'t');
INSERT INTO LANGUECHANSON VALUES('en',2567,'t');
INSERT INTO LANGUECHANSON VALUES('en',2568,'t');
INSERT INTO LANGUECHANSON VALUES('en',2570,'t');
INSERT INTO LANGUECHANSON VALUES('en',2571,'t');
INSERT INTO LANGUECHANSON VALUES('en',2572,'t');
INSERT INTO LANGUECHANSON VALUES('en',2573,'t');
INSERT INTO LANGUECHANSON VALUES('en',2574,'t');
INSERT INTO LANGUECHANSON VALUES('en',2575,'t');
INSERT INTO LANGUECHANSON VALUES('en',2576,'t');
INSERT INTO LANGUECHANSON VALUES('en',2577,'t');
INSERT INTO LANGUECHANSON VALUES('en',2578,'t');
INSERT INTO LANGUECHANSON VALUES('en',2579,'t');
INSERT INTO LANGUECHANSON VALUES('en',2580,'t');
INSERT INTO LANGUECHANSON VALUES('en',2581,'t');
INSERT INTO LANGUECHANSON VALUES('en',2582,'t');
INSERT INTO LANGUECHANSON VALUES('en',2583,'t');
INSERT INTO LANGUECHANSON VALUES('en',2584,'t');
INSERT INTO LANGUECHANSON VALUES('en',2585,'t');
INSERT INTO LANGUECHANSON VALUES('en',2586,'t');
INSERT INTO LANGUECHANSON VALUES('en',2587,'t');
INSERT INTO LANGUECHANSON VALUES('en',2588,'t');
INSERT INTO LANGUECHANSON VALUES('en',2589,'t');
INSERT INTO LANGUECHANSON VALUES('en',2590,'t');
INSERT INTO LANGUECHANSON VALUES('en',2591,'t');
INSERT INTO LANGUECHANSON VALUES('en',2592,'t');
INSERT INTO LANGUECHANSON VALUES('en',2593,'t');
INSERT INTO LANGUECHANSON VALUES('en',2594,'t');
INSERT INTO LANGUECHANSON VALUES('en',2595,'t');
INSERT INTO LANGUECHANSON VALUES('en',2596,'t');
INSERT INTO LANGUECHANSON VALUES('en',2597,'t');
INSERT INTO LANGUECHANSON VALUES('en',2599,'t');
INSERT INTO LANGUECHANSON VALUES('en',2600,'t');
INSERT INTO LANGUECHANSON VALUES('en',2601,'t');
INSERT INTO LANGUECHANSON VALUES('en',2602,'t');
INSERT INTO LANGUECHANSON VALUES('en',2603,'t');
INSERT INTO LANGUECHANSON VALUES('en',2604,'t');
INSERT INTO LANGUECHANSON VALUES('en',2605,'t');
INSERT INTO LANGUECHANSON VALUES('en',2606,'t');
INSERT INTO LANGUECHANSON VALUES('en',2607,'t');
INSERT INTO LANGUECHANSON VALUES('en',2609,'t');
INSERT INTO LANGUECHANSON VALUES('en',2610,'t');
INSERT INTO LANGUECHANSON VALUES('en',2611,'t');
INSERT INTO LANGUECHANSON VALUES('en',2612,'t');
INSERT INTO LANGUECHANSON VALUES('en',2613,'t');
INSERT INTO LANGUECHANSON VALUES('en',2614,'t');
INSERT INTO LANGUECHANSON VALUES('en',2619,'t');
INSERT INTO LANGUECHANSON VALUES('en',2621,'t');
INSERT INTO LANGUECHANSON VALUES('en',2622,'t');
INSERT INTO LANGUECHANSON VALUES('en',2623,'t');
INSERT INTO LANGUECHANSON VALUES('en',2624,'t');
INSERT INTO LANGUECHANSON VALUES('en',2625,'t');
INSERT INTO LANGUECHANSON VALUES('en',2626,'t');
INSERT INTO LANGUECHANSON VALUES('en',2627,'t');
INSERT INTO LANGUECHANSON VALUES('en',2628,'t');
INSERT INTO LANGUECHANSON VALUES('en',2629,'t');
INSERT INTO LANGUECHANSON VALUES('en',2630,'t');
INSERT INTO LANGUECHANSON VALUES('en',2631,'t');
INSERT INTO LANGUECHANSON VALUES('en',2632,'t');
INSERT INTO LANGUECHANSON VALUES('en',2634,'t');
INSERT INTO LANGUECHANSON VALUES('en',2635,'t');
INSERT INTO LANGUECHANSON VALUES('en',2636,'t');
INSERT INTO LANGUECHANSON VALUES('en',2637,'t');
INSERT INTO LANGUECHANSON VALUES('en',2638,'t');
INSERT INTO LANGUECHANSON VALUES('en',2639,'t');
INSERT INTO LANGUECHANSON VALUES('en',2640,'t');
INSERT INTO LANGUECHANSON VALUES('en',2641,'t');
INSERT INTO LANGUECHANSON VALUES('en',2642,'t');
INSERT INTO LANGUECHANSON VALUES('en',2643,'t');
INSERT INTO LANGUECHANSON VALUES('en',2644,'t');
INSERT INTO LANGUECHANSON VALUES('en',2645,'t');
INSERT INTO LANGUECHANSON VALUES('en',2647,'t');
INSERT INTO LANGUECHANSON VALUES('en',2648,'t');
INSERT INTO LANGUECHANSON VALUES('en',2649,'t');
INSERT INTO LANGUECHANSON VALUES('en',2650,'t');
INSERT INTO LANGUECHANSON VALUES('en',2651,'t');
INSERT INTO LANGUECHANSON VALUES('en',2652,'t');
INSERT INTO LANGUECHANSON VALUES('en',2653,'t');
INSERT INTO LANGUECHANSON VALUES('en',2665,'t');
INSERT INTO LANGUECHANSON VALUES('en',2666,'t');
INSERT INTO LANGUECHANSON VALUES('en',2667,'t');
INSERT INTO LANGUECHANSON VALUES('en',2668,'t');
INSERT INTO LANGUECHANSON VALUES('en',2669,'t');
INSERT INTO LANGUECHANSON VALUES('en',2670,'t');
INSERT INTO LANGUECHANSON VALUES('en',2671,'t');
INSERT INTO LANGUECHANSON VALUES('en',2672,'t');
INSERT INTO LANGUECHANSON VALUES('en',2674,'t');
INSERT INTO LANGUECHANSON VALUES('en',2675,'t');
INSERT INTO LANGUECHANSON VALUES('en',2676,'t');
INSERT INTO LANGUECHANSON VALUES('en',2608,'t');
INSERT INTO LANGUECHANSON VALUES('en',2677,'t');
INSERT INTO LANGUECHANSON VALUES('en',2681,'t');
INSERT INTO LANGUECHANSON VALUES('en',2680,'t');
INSERT INTO LANGUECHANSON VALUES('en',2682,'t');
INSERT INTO LANGUECHANSON VALUES('en',2689,'t');
INSERT INTO LANGUECHANSON VALUES('en',2690,'t');
INSERT INTO LANGUECHANSON VALUES('en',2691,'t');
INSERT INTO LANGUECHANSON VALUES('en',2692,'t');
INSERT INTO LANGUECHANSON VALUES('en',2693,'t');
INSERT INTO LANGUECHANSON VALUES('en',2694,'t');
INSERT INTO LANGUECHANSON VALUES('en',2695,'t');
INSERT INTO LANGUECHANSON VALUES('en',2696,'t');
INSERT INTO LANGUECHANSON VALUES('en',2697,'t');
INSERT INTO LANGUECHANSON VALUES('en',2698,'t');
INSERT INTO LANGUECHANSON VALUES('en',2699,'t');
INSERT INTO LANGUECHANSON VALUES('en',2701,'t');
INSERT INTO LANGUECHANSON VALUES('en',2702,'t');
INSERT INTO LANGUECHANSON VALUES('en',2703,'t');
INSERT INTO LANGUECHANSON VALUES('en',2704,'t');
INSERT INTO LANGUECHANSON VALUES('en',2705,'t');
INSERT INTO LANGUECHANSON VALUES('en',2706,'t');
INSERT INTO LANGUECHANSON VALUES('en',2707,'t');
INSERT INTO LANGUECHANSON VALUES('en',2708,'t');
INSERT INTO LANGUECHANSON VALUES('en',2710,'t');
INSERT INTO LANGUECHANSON VALUES('en',2711,'t');
INSERT INTO LANGUECHANSON VALUES('en',2712,'t');
INSERT INTO LANGUECHANSON VALUES('en',2713,'t');
INSERT INTO LANGUECHANSON VALUES('en',2714,'t');
INSERT INTO LANGUECHANSON VALUES('en',2715,'t');
INSERT INTO LANGUECHANSON VALUES('en',2716,'t');
INSERT INTO LANGUECHANSON VALUES('en',2717,'t');
INSERT INTO LANGUECHANSON VALUES('en',2718,'t');
INSERT INTO LANGUECHANSON VALUES('en',2719,'t');
INSERT INTO LANGUECHANSON VALUES('en',2735,'t');
INSERT INTO LANGUECHANSON VALUES('en',2745,'t');
INSERT INTO LANGUECHANSON VALUES('en',2746,'t');
INSERT INTO LANGUECHANSON VALUES('en',2747,'t');
INSERT INTO LANGUECHANSON VALUES('en',2749,'t');
INSERT INTO LANGUECHANSON VALUES('en',2741,'t');
INSERT INTO LANGUECHANSON VALUES('en',2738,'t');
INSERT INTO LANGUECHANSON VALUES('en',2756,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2758,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2759,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2760,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2767,'t');
INSERT INTO LANGUECHANSON VALUES('en',2768,'t');
INSERT INTO LANGUECHANSON VALUES('en',2769,'t');
INSERT INTO LANGUECHANSON VALUES('en',2770,'t');
INSERT INTO LANGUECHANSON VALUES('en',2771,'t');
INSERT INTO LANGUECHANSON VALUES('en',2772,'t');
INSERT INTO LANGUECHANSON VALUES('en',2773,'t');
INSERT INTO LANGUECHANSON VALUES('en',2774,'t');
INSERT INTO LANGUECHANSON VALUES('en',2775,'t');
INSERT INTO LANGUECHANSON VALUES('en',2776,'t');
INSERT INTO LANGUECHANSON VALUES('en',2777,'t');
INSERT INTO LANGUECHANSON VALUES('en',2778,'t');
INSERT INTO LANGUECHANSON VALUES('en',2779,'t');
INSERT INTO LANGUECHANSON VALUES('en',2780,'t');
INSERT INTO LANGUECHANSON VALUES('en',2781,'t');
INSERT INTO LANGUECHANSON VALUES('en',2782,'t');
INSERT INTO LANGUECHANSON VALUES('en',2783,'t');
INSERT INTO LANGUECHANSON VALUES('en',2784,'t');
INSERT INTO LANGUECHANSON VALUES('en',2785,'t');
INSERT INTO LANGUECHANSON VALUES('en',2786,'t');
INSERT INTO LANGUECHANSON VALUES('en',2787,'t');
INSERT INTO LANGUECHANSON VALUES('en',2788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2791,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2792,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2796,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2797,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2799,'t');
INSERT INTO LANGUECHANSON VALUES('en',2800,'t');
INSERT INTO LANGUECHANSON VALUES('en',2801,'t');
INSERT INTO LANGUECHANSON VALUES('en',2802,'t');
INSERT INTO LANGUECHANSON VALUES('en',2803,'t');
INSERT INTO LANGUECHANSON VALUES('en',2805,'t');
INSERT INTO LANGUECHANSON VALUES('en',2806,'t');
INSERT INTO LANGUECHANSON VALUES('en',2807,'t');
INSERT INTO LANGUECHANSON VALUES('en',2808,'t');
INSERT INTO LANGUECHANSON VALUES('en',2809,'t');
INSERT INTO LANGUECHANSON VALUES('en',2810,'t');
INSERT INTO LANGUECHANSON VALUES('en',2811,'t');
INSERT INTO LANGUECHANSON VALUES('en',2812,'t');
INSERT INTO LANGUECHANSON VALUES('en',2813,'t');
INSERT INTO LANGUECHANSON VALUES('en',2814,'t');
INSERT INTO LANGUECHANSON VALUES('en',2815,'t');
INSERT INTO LANGUECHANSON VALUES('en',2816,'t');
INSERT INTO LANGUECHANSON VALUES('en',2817,'t');
INSERT INTO LANGUECHANSON VALUES('en',2819,'t');
INSERT INTO LANGUECHANSON VALUES('en',2820,'t');
INSERT INTO LANGUECHANSON VALUES('en',2821,'t');
INSERT INTO LANGUECHANSON VALUES('en',2822,'t');
INSERT INTO LANGUECHANSON VALUES('en',2823,'t');
INSERT INTO LANGUECHANSON VALUES('en',2824,'t');
INSERT INTO LANGUECHANSON VALUES('en',2825,'t');
INSERT INTO LANGUECHANSON VALUES('en',2826,'t');
INSERT INTO LANGUECHANSON VALUES('en',2827,'t');
INSERT INTO LANGUECHANSON VALUES('en',2828,'t');
INSERT INTO LANGUECHANSON VALUES('en',2829,'t');
INSERT INTO LANGUECHANSON VALUES('en',2831,'t');
INSERT INTO LANGUECHANSON VALUES('en',2832,'t');
INSERT INTO LANGUECHANSON VALUES('en',2833,'t');
INSERT INTO LANGUECHANSON VALUES('en',2834,'t');
INSERT INTO LANGUECHANSON VALUES('en',2836,'t');
INSERT INTO LANGUECHANSON VALUES('en',2840,'t');
INSERT INTO LANGUECHANSON VALUES('en',2841,'t');
INSERT INTO LANGUECHANSON VALUES('en',2842,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2845,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2846,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2850,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2851,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2852,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2858,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2860,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2861,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2862,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2863,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2864,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2865,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2866,'t');
INSERT INTO LANGUECHANSON VALUES('en',2867,'t');
INSERT INTO LANGUECHANSON VALUES('en',2868,'t');
INSERT INTO LANGUECHANSON VALUES('en',2869,'t');
INSERT INTO LANGUECHANSON VALUES('en',2870,'t');
INSERT INTO LANGUECHANSON VALUES('en',2872,'t');
INSERT INTO LANGUECHANSON VALUES('en',2873,'t');
INSERT INTO LANGUECHANSON VALUES('en',2874,'t');
INSERT INTO LANGUECHANSON VALUES('en',2875,'t');
INSERT INTO LANGUECHANSON VALUES('en',2876,'t');
INSERT INTO LANGUECHANSON VALUES('en',2877,'t');
INSERT INTO LANGUECHANSON VALUES('en',2878,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2879,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2880,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2881,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2882,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2883,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2884,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2885,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2887,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2888,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2889,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2890,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2891,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2892,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2893,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2894,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2896,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2897,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2899,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2919,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2920,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2921,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2922,'t');
INSERT INTO LANGUECHANSON VALUES('en',162,'t');
INSERT INTO LANGUECHANSON VALUES('en',1793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2923,'t');
INSERT INTO LANGUECHANSON VALUES('en',2924,'t');
INSERT INTO LANGUECHANSON VALUES('en',2925,'t');
INSERT INTO LANGUECHANSON VALUES('en',2926,'t');
INSERT INTO LANGUECHANSON VALUES('en',2927,'t');
INSERT INTO LANGUECHANSON VALUES('en',2928,'t');
INSERT INTO LANGUECHANSON VALUES('en',2929,'t');
INSERT INTO LANGUECHANSON VALUES('en',2930,'t');
INSERT INTO LANGUECHANSON VALUES('en',2931,'t');
INSERT INTO LANGUECHANSON VALUES('en',2932,'t');
INSERT INTO LANGUECHANSON VALUES('en',2933,'t');
INSERT INTO LANGUECHANSON VALUES('en',2934,'t');
INSERT INTO LANGUECHANSON VALUES('en',2935,'t');
INSERT INTO LANGUECHANSON VALUES('en',2936,'t');
INSERT INTO LANGUECHANSON VALUES('en',2939,'t');
INSERT INTO LANGUECHANSON VALUES('en',2948,'t');
INSERT INTO LANGUECHANSON VALUES('en',2960,'t');
INSERT INTO LANGUECHANSON VALUES('en',2961,'t');
INSERT INTO LANGUECHANSON VALUES('en',2963,'t');
INSERT INTO LANGUECHANSON VALUES('en',2964,'t');
INSERT INTO LANGUECHANSON VALUES('en',2965,'t');
INSERT INTO LANGUECHANSON VALUES('en',2966,'t');
INSERT INTO LANGUECHANSON VALUES('en',2967,'t');
INSERT INTO LANGUECHANSON VALUES('en',2968,'t');
INSERT INTO LANGUECHANSON VALUES('en',2969,'t');
INSERT INTO LANGUECHANSON VALUES('en',2970,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2971,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2975,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2978,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2982,'t');
INSERT INTO LANGUECHANSON VALUES('en',2983,'t');
INSERT INTO LANGUECHANSON VALUES('en',2984,'t');
INSERT INTO LANGUECHANSON VALUES('en',2985,'t');
INSERT INTO LANGUECHANSON VALUES('en',2947,'t');
INSERT INTO LANGUECHANSON VALUES('en',2986,'t');
INSERT INTO LANGUECHANSON VALUES('en',2988,'t');
INSERT INTO LANGUECHANSON VALUES('en',2989,'t');
INSERT INTO LANGUECHANSON VALUES('en',2990,'t');
INSERT INTO LANGUECHANSON VALUES('en',2991,'t');
INSERT INTO LANGUECHANSON VALUES('en',2992,'t');
INSERT INTO LANGUECHANSON VALUES('en',2993,'t');
INSERT INTO LANGUECHANSON VALUES('en',2994,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3007,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3008,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3009,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3010,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3011,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3013,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3017,'t');
INSERT INTO LANGUECHANSON VALUES('en',3018,'t');
INSERT INTO LANGUECHANSON VALUES('en',3019,'t');
INSERT INTO LANGUECHANSON VALUES('en',3020,'t');
INSERT INTO LANGUECHANSON VALUES('en',3021,'t');
INSERT INTO LANGUECHANSON VALUES('en',3022,'t');
INSERT INTO LANGUECHANSON VALUES('en',3023,'t');
INSERT INTO LANGUECHANSON VALUES('en',3024,'t');
INSERT INTO LANGUECHANSON VALUES('en',3025,'t');
INSERT INTO LANGUECHANSON VALUES('en',3026,'t');
INSERT INTO LANGUECHANSON VALUES('en',3027,'t');
INSERT INTO LANGUECHANSON VALUES('en',3029,'t');
INSERT INTO LANGUECHANSON VALUES('en',3036,'t');
INSERT INTO LANGUECHANSON VALUES('en',3037,'t');
INSERT INTO LANGUECHANSON VALUES('en',3038,'t');
INSERT INTO LANGUECHANSON VALUES('en',3039,'t');
INSERT INTO LANGUECHANSON VALUES('en',3040,'t');
INSERT INTO LANGUECHANSON VALUES('en',3041,'t');
INSERT INTO LANGUECHANSON VALUES('en',3042,'t');
INSERT INTO LANGUECHANSON VALUES('en',3043,'t');
INSERT INTO LANGUECHANSON VALUES('en',3044,'t');
INSERT INTO LANGUECHANSON VALUES('en',3045,'t');
INSERT INTO LANGUECHANSON VALUES('en',3046,'t');
INSERT INTO LANGUECHANSON VALUES('en',3047,'t');
INSERT INTO LANGUECHANSON VALUES('en',3048,'t');
INSERT INTO LANGUECHANSON VALUES('en',3049,'t');
INSERT INTO LANGUECHANSON VALUES('en',3050,'t');
INSERT INTO LANGUECHANSON VALUES('en',3051,'t');
INSERT INTO LANGUECHANSON VALUES('en',3052,'t');
INSERT INTO LANGUECHANSON VALUES('en',3053,'t');
INSERT INTO LANGUECHANSON VALUES('en',3054,'t');
INSERT INTO LANGUECHANSON VALUES('en',3055,'t');
INSERT INTO LANGUECHANSON VALUES('en',3056,'t');
INSERT INTO LANGUECHANSON VALUES('en',3057,'t');
INSERT INTO LANGUECHANSON VALUES('en',3058,'t');
INSERT INTO LANGUECHANSON VALUES('en',3059,'t');
INSERT INTO LANGUECHANSON VALUES('en',3060,'t');
INSERT INTO LANGUECHANSON VALUES('en',3061,'t');
INSERT INTO LANGUECHANSON VALUES('en',3062,'t');
INSERT INTO LANGUECHANSON VALUES('en',3063,'t');
INSERT INTO LANGUECHANSON VALUES('en',3064,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3065,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3066,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3067,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3068,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3069,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3070,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3071,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3072,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3073,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3074,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3075,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3076,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3078,'t');
INSERT INTO LANGUECHANSON VALUES('en',3005,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3079,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3080,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3081,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3082,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3083,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3084,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3085,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3086,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3087,'t');
INSERT INTO LANGUECHANSON VALUES('en',3088,'t');
INSERT INTO LANGUECHANSON VALUES('en',3089,'t');
INSERT INTO LANGUECHANSON VALUES('en',3090,'t');
INSERT INTO LANGUECHANSON VALUES('en',3091,'t');
INSERT INTO LANGUECHANSON VALUES('en',3092,'t');
INSERT INTO LANGUECHANSON VALUES('en',3093,'t');
INSERT INTO LANGUECHANSON VALUES('en',3094,'t');
INSERT INTO LANGUECHANSON VALUES('en',3095,'t');
INSERT INTO LANGUECHANSON VALUES('en',3096,'t');
INSERT INTO LANGUECHANSON VALUES('en',3097,'t');
INSERT INTO LANGUECHANSON VALUES('en',3098,'t');
INSERT INTO LANGUECHANSON VALUES('en',3099,'t');
INSERT INTO LANGUECHANSON VALUES('en',3100,'t');
INSERT INTO LANGUECHANSON VALUES('en',3101,'t');
INSERT INTO LANGUECHANSON VALUES('en',3102,'t');
INSERT INTO LANGUECHANSON VALUES('en',3103,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3104,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3105,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3106,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3107,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3108,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3109,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3110,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3111,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3112,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3113,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3114,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3116,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3117,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3118,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3119,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3120,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3121,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3122,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3123,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3124,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3125,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3126,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3127,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3128,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3129,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3130,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3131,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3132,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3133,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3135,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3136,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3137,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3138,'t');
INSERT INTO LANGUECHANSON VALUES('en',3139,'t');
INSERT INTO LANGUECHANSON VALUES('en',3140,'t');
INSERT INTO LANGUECHANSON VALUES('en',3141,'t');
INSERT INTO LANGUECHANSON VALUES('en',3142,'t');
INSERT INTO LANGUECHANSON VALUES('en',3143,'t');
INSERT INTO LANGUECHANSON VALUES('en',3144,'t');
INSERT INTO LANGUECHANSON VALUES('en',3145,'t');
INSERT INTO LANGUECHANSON VALUES('en',3146,'t');
INSERT INTO LANGUECHANSON VALUES('en',3147,'t');
INSERT INTO LANGUECHANSON VALUES('en',3148,'t');
INSERT INTO LANGUECHANSON VALUES('en',3149,'t');
INSERT INTO LANGUECHANSON VALUES('en',3150,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3151,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3152,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3153,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3154,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3155,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3156,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3157,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3158,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3159,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3162,'t');
INSERT INTO LANGUECHANSON VALUES('en',3164,'t');
INSERT INTO LANGUECHANSON VALUES('en',3165,'t');
INSERT INTO LANGUECHANSON VALUES('en',3166,'t');
INSERT INTO LANGUECHANSON VALUES('en',3168,'t');
INSERT INTO LANGUECHANSON VALUES('en',3169,'t');
INSERT INTO LANGUECHANSON VALUES('en',3170,'t');
INSERT INTO LANGUECHANSON VALUES('en',3171,'t');
INSERT INTO LANGUECHANSON VALUES('en',3172,'t');
INSERT INTO LANGUECHANSON VALUES('en',3173,'t');
INSERT INTO LANGUECHANSON VALUES('en',3174,'t');
INSERT INTO LANGUECHANSON VALUES('en',3175,'t');
INSERT INTO LANGUECHANSON VALUES('en',3176,'t');
INSERT INTO LANGUECHANSON VALUES('en',3177,'t');
INSERT INTO LANGUECHANSON VALUES('en',3178,'t');
INSERT INTO LANGUECHANSON VALUES('en',3179,'t');
INSERT INTO LANGUECHANSON VALUES('en',3180,'t');
INSERT INTO LANGUECHANSON VALUES('en',3181,'t');
INSERT INTO LANGUECHANSON VALUES('en',3182,'t');
INSERT INTO LANGUECHANSON VALUES('en',3183,'t');
INSERT INTO LANGUECHANSON VALUES('en',3184,'t');
INSERT INTO LANGUECHANSON VALUES('en',3185,'t');
INSERT INTO LANGUECHANSON VALUES('en',3186,'t');
INSERT INTO LANGUECHANSON VALUES('en',3187,'t');
INSERT INTO LANGUECHANSON VALUES('en',3188,'t');
INSERT INTO LANGUECHANSON VALUES('en',3189,'t');
INSERT INTO LANGUECHANSON VALUES('en',3190,'t');
INSERT INTO LANGUECHANSON VALUES('en',3191,'t');
INSERT INTO LANGUECHANSON VALUES('en',3192,'t');
INSERT INTO LANGUECHANSON VALUES('en',3193,'t');
INSERT INTO LANGUECHANSON VALUES('en',3194,'t');
INSERT INTO LANGUECHANSON VALUES('en',3195,'t');
INSERT INTO LANGUECHANSON VALUES('en',3196,'t');
INSERT INTO LANGUECHANSON VALUES('en',3197,'t');
INSERT INTO LANGUECHANSON VALUES('en',3198,'t');
INSERT INTO LANGUECHANSON VALUES('en',3199,'t');
INSERT INTO LANGUECHANSON VALUES('en',3201,'t');
INSERT INTO LANGUECHANSON VALUES('en',3212,'t');
INSERT INTO LANGUECHANSON VALUES('en',3213,'t');
INSERT INTO LANGUECHANSON VALUES('en',3214,'t');
INSERT INTO LANGUECHANSON VALUES('en',3215,'t');
INSERT INTO LANGUECHANSON VALUES('en',3216,'t');
INSERT INTO LANGUECHANSON VALUES('en',3217,'t');
INSERT INTO LANGUECHANSON VALUES('en',3218,'t');
INSERT INTO LANGUECHANSON VALUES('en',3219,'t');
INSERT INTO LANGUECHANSON VALUES('en',3220,'t');
INSERT INTO LANGUECHANSON VALUES('en',3221,'t');
INSERT INTO LANGUECHANSON VALUES('en',3222,'t');
INSERT INTO LANGUECHANSON VALUES('en',3235,'t');
INSERT INTO LANGUECHANSON VALUES('en',3236,'t');
INSERT INTO LANGUECHANSON VALUES('en',3237,'t');
INSERT INTO LANGUECHANSON VALUES('en',3238,'t');
INSERT INTO LANGUECHANSON VALUES('en',3239,'t');
INSERT INTO LANGUECHANSON VALUES('en',3229,'t');
INSERT INTO LANGUECHANSON VALUES('en',3227,'t');
INSERT INTO LANGUECHANSON VALUES('en',3233,'t');
INSERT INTO LANGUECHANSON VALUES('en',3204,'t');
INSERT INTO LANGUECHANSON VALUES('en',3230,'t');
INSERT INTO LANGUECHANSON VALUES('en',3228,'t');
INSERT INTO LANGUECHANSON VALUES('en',3231,'t');
INSERT INTO LANGUECHANSON VALUES('en',3240,'t');
INSERT INTO LANGUECHANSON VALUES('en',3243,'t');
INSERT INTO LANGUECHANSON VALUES('en',3245,'t');
INSERT INTO LANGUECHANSON VALUES('en',3246,'t');
INSERT INTO LANGUECHANSON VALUES('en',3247,'t');
INSERT INTO LANGUECHANSON VALUES('en',3248,'t');
INSERT INTO LANGUECHANSON VALUES('en',3249,'t');
INSERT INTO LANGUECHANSON VALUES('en',3250,'t');
INSERT INTO LANGUECHANSON VALUES('en',3251,'t');
INSERT INTO LANGUECHANSON VALUES('en',3252,'t');
INSERT INTO LANGUECHANSON VALUES('en',3253,'t');
INSERT INTO LANGUECHANSON VALUES('en',3254,'t');
INSERT INTO LANGUECHANSON VALUES('en',3255,'t');
INSERT INTO LANGUECHANSON VALUES('en',3256,'t');
INSERT INTO LANGUECHANSON VALUES('en',3257,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3258,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3259,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3260,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3261,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3262,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3263,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3264,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3265,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3266,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3269,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3274,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3276,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3277,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3278,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3279,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3280,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3281,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3282,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3283,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3284,'t');
INSERT INTO LANGUECHANSON VALUES('en',3286,'t');
INSERT INTO LANGUECHANSON VALUES('en',3287,'t');
INSERT INTO LANGUECHANSON VALUES('en',3288,'t');
INSERT INTO LANGUECHANSON VALUES('en',3289,'t');
INSERT INTO LANGUECHANSON VALUES('en',3290,'t');
INSERT INTO LANGUECHANSON VALUES('en',3291,'t');
INSERT INTO LANGUECHANSON VALUES('en',3292,'t');
INSERT INTO LANGUECHANSON VALUES('en',3293,'t');
INSERT INTO LANGUECHANSON VALUES('en',3294,'t');
INSERT INTO LANGUECHANSON VALUES('en',3296,'t');
INSERT INTO LANGUECHANSON VALUES('en',3297,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3298,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3299,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3300,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3301,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3302,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3306,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3308,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3309,'t');
INSERT INTO LANGUECHANSON VALUES('en',3310,'t');
INSERT INTO LANGUECHANSON VALUES('en',3312,'t');
INSERT INTO LANGUECHANSON VALUES('en',3313,'t');
INSERT INTO LANGUECHANSON VALUES('en',3314,'t');
INSERT INTO LANGUECHANSON VALUES('en',3315,'t');
INSERT INTO LANGUECHANSON VALUES('en',3316,'t');
INSERT INTO LANGUECHANSON VALUES('en',3317,'t');
INSERT INTO LANGUECHANSON VALUES('en',3318,'t');
INSERT INTO LANGUECHANSON VALUES('en',3319,'t');
INSERT INTO LANGUECHANSON VALUES('en',3320,'t');
INSERT INTO LANGUECHANSON VALUES('en',3321,'t');
INSERT INTO LANGUECHANSON VALUES('en',3322,'t');
INSERT INTO LANGUECHANSON VALUES('en',3324,'t');
INSERT INTO LANGUECHANSON VALUES('en',3325,'t');
INSERT INTO LANGUECHANSON VALUES('en',3326,'t');
INSERT INTO LANGUECHANSON VALUES('en',3327,'t');
INSERT INTO LANGUECHANSON VALUES('en',3328,'t');
INSERT INTO LANGUECHANSON VALUES('en',3329,'t');
INSERT INTO LANGUECHANSON VALUES('en',3330,'t');
INSERT INTO LANGUECHANSON VALUES('en',3331,'t');
INSERT INTO LANGUECHANSON VALUES('en',3332,'t');
INSERT INTO LANGUECHANSON VALUES('en',3333,'t');
INSERT INTO LANGUECHANSON VALUES('en',3334,'t');
INSERT INTO LANGUECHANSON VALUES('en',3335,'t');
INSERT INTO LANGUECHANSON VALUES('en',3338,'t');
INSERT INTO LANGUECHANSON VALUES('en',3339,'t');
INSERT INTO LANGUECHANSON VALUES('en',3349,'t');
INSERT INTO LANGUECHANSON VALUES('en',3350,'t');
INSERT INTO LANGUECHANSON VALUES('en',3351,'t');
INSERT INTO LANGUECHANSON VALUES('en',3352,'t');
INSERT INTO LANGUECHANSON VALUES('en',3353,'t');
INSERT INTO LANGUECHANSON VALUES('en',3354,'t');
INSERT INTO LANGUECHANSON VALUES('en',3355,'t');
INSERT INTO LANGUECHANSON VALUES('en',3357,'t');
INSERT INTO LANGUECHANSON VALUES('en',3358,'t');
INSERT INTO LANGUECHANSON VALUES('en',3359,'t');
INSERT INTO LANGUECHANSON VALUES('en',3360,'t');
INSERT INTO LANGUECHANSON VALUES('en',3361,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3362,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3363,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3364,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3365,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3366,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3367,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3368,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3369,'t');
INSERT INTO LANGUECHANSON VALUES('en',3340,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3370,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3395,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3396,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3397,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3399,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3408,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3409,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3410,'t');
INSERT INTO LANGUECHANSON VALUES('en',3411,'t');
INSERT INTO LANGUECHANSON VALUES('en',3412,'t');
INSERT INTO LANGUECHANSON VALUES('en',3413,'t');
INSERT INTO LANGUECHANSON VALUES('en',3414,'t');
INSERT INTO LANGUECHANSON VALUES('en',3378,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3407,'t');
INSERT INTO LANGUECHANSON VALUES('en',3415,'t');
INSERT INTO LANGUECHANSON VALUES('en',3416,'t');
INSERT INTO LANGUECHANSON VALUES('en',3417,'t');
INSERT INTO LANGUECHANSON VALUES('en',3419,'t');
INSERT INTO LANGUECHANSON VALUES('en',3420,'t');
INSERT INTO LANGUECHANSON VALUES('en',3421,'t');
INSERT INTO LANGUECHANSON VALUES('en',3422,'t');
INSERT INTO LANGUECHANSON VALUES('en',3423,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3426,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3428,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3436,'t');
INSERT INTO LANGUECHANSON VALUES('en',3437,'t');
INSERT INTO LANGUECHANSON VALUES('en',3438,'t');
INSERT INTO LANGUECHANSON VALUES('en',3439,'t');
INSERT INTO LANGUECHANSON VALUES('en',3452,'t');
INSERT INTO LANGUECHANSON VALUES('en',3457,'t');
INSERT INTO LANGUECHANSON VALUES('en',3458,'t');
INSERT INTO LANGUECHANSON VALUES('en',3459,'t');
INSERT INTO LANGUECHANSON VALUES('en',3460,'t');
INSERT INTO LANGUECHANSON VALUES('en',3461,'t');
INSERT INTO LANGUECHANSON VALUES('en',3462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3463,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3464,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3466,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3467,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3468,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3469,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3470,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3471,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3472,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3475,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3476,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3477,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3480,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3482,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3483,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3484,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3485,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3486,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3487,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3488,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3489,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3492,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3493,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3494,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3495,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3496,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3497,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3498,'t');
INSERT INTO LANGUECHANSON VALUES('en',3499,'t');
INSERT INTO LANGUECHANSON VALUES('en',3502,'t');
INSERT INTO LANGUECHANSON VALUES('en',3503,'t');
INSERT INTO LANGUECHANSON VALUES('en',3504,'t');
INSERT INTO LANGUECHANSON VALUES('en',3505,'t');
INSERT INTO LANGUECHANSON VALUES('en',3506,'t');
INSERT INTO LANGUECHANSON VALUES('en',3507,'t');
INSERT INTO LANGUECHANSON VALUES('en',3508,'t');
INSERT INTO LANGUECHANSON VALUES('en',3509,'t');
INSERT INTO LANGUECHANSON VALUES('en',3510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3513,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3514,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3517,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3518,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3519,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3520,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3521,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3522,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3523,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3524,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3525,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3526,'t');
INSERT INTO LANGUECHANSON VALUES('en',3527,'t');
INSERT INTO LANGUECHANSON VALUES('en',3528,'t');
INSERT INTO LANGUECHANSON VALUES('en',3529,'t');
INSERT INTO LANGUECHANSON VALUES('en',3530,'t');
INSERT INTO LANGUECHANSON VALUES('en',3531,'t');
INSERT INTO LANGUECHANSON VALUES('en',3532,'t');
INSERT INTO LANGUECHANSON VALUES('en',3533,'t');
INSERT INTO LANGUECHANSON VALUES('en',3535,'t');
INSERT INTO LANGUECHANSON VALUES('en',3536,'t');
INSERT INTO LANGUECHANSON VALUES('en',3538,'t');
INSERT INTO LANGUECHANSON VALUES('en',3539,'t');
INSERT INTO LANGUECHANSON VALUES('en',3540,'t');
INSERT INTO LANGUECHANSON VALUES('en',3554,'t');
INSERT INTO LANGUECHANSON VALUES('en',3556,'t');
INSERT INTO LANGUECHANSON VALUES('en',3557,'t');
INSERT INTO LANGUECHANSON VALUES('en',3558,'t');
INSERT INTO LANGUECHANSON VALUES('en',3559,'t');
INSERT INTO LANGUECHANSON VALUES('en',3560,'t');
INSERT INTO LANGUECHANSON VALUES('en',3561,'t');
INSERT INTO LANGUECHANSON VALUES('en',3563,'t');
INSERT INTO LANGUECHANSON VALUES('en',3564,'t');
INSERT INTO LANGUECHANSON VALUES('en',3565,'t');
INSERT INTO LANGUECHANSON VALUES('en',3566,'t');
INSERT INTO LANGUECHANSON VALUES('en',3567,'t');
INSERT INTO LANGUECHANSON VALUES('en',3568,'t');
INSERT INTO LANGUECHANSON VALUES('en',3569,'t');
INSERT INTO LANGUECHANSON VALUES('en',3570,'t');
INSERT INTO LANGUECHANSON VALUES('en',3571,'t');
INSERT INTO LANGUECHANSON VALUES('en',3572,'t');
INSERT INTO LANGUECHANSON VALUES('en',3573,'t');
INSERT INTO LANGUECHANSON VALUES('en',3574,'t');
INSERT INTO LANGUECHANSON VALUES('en',3576,'t');
INSERT INTO LANGUECHANSON VALUES('en',3577,'t');
INSERT INTO LANGUECHANSON VALUES('en',3578,'t');
INSERT INTO LANGUECHANSON VALUES('en',3579,'t');
INSERT INTO LANGUECHANSON VALUES('en',3580,'t');
INSERT INTO LANGUECHANSON VALUES('en',3582,'t');
INSERT INTO LANGUECHANSON VALUES('en',3583,'t');
INSERT INTO LANGUECHANSON VALUES('en',3584,'t');
INSERT INTO LANGUECHANSON VALUES('en',3585,'t');
INSERT INTO LANGUECHANSON VALUES('en',3586,'t');
INSERT INTO LANGUECHANSON VALUES('en',3587,'t');
INSERT INTO LANGUECHANSON VALUES('en',3588,'t');
INSERT INTO LANGUECHANSON VALUES('en',3589,'t');
INSERT INTO LANGUECHANSON VALUES('en',3590,'t');
INSERT INTO LANGUECHANSON VALUES('en',3591,'t');
INSERT INTO LANGUECHANSON VALUES('en',3592,'t');
INSERT INTO LANGUECHANSON VALUES('en',3593,'t');
INSERT INTO LANGUECHANSON VALUES('en',3594,'t');
INSERT INTO LANGUECHANSON VALUES('en',3595,'t');
INSERT INTO LANGUECHANSON VALUES('en',3596,'t');
INSERT INTO LANGUECHANSON VALUES('en',3597,'t');
INSERT INTO LANGUECHANSON VALUES('en',3598,'t');
INSERT INTO LANGUECHANSON VALUES('en',3599,'t');
INSERT INTO LANGUECHANSON VALUES('en',3600,'t');
INSERT INTO LANGUECHANSON VALUES('en',3601,'t');
INSERT INTO LANGUECHANSON VALUES('en',3602,'t');
INSERT INTO LANGUECHANSON VALUES('en',3603,'t');
INSERT INTO LANGUECHANSON VALUES('en',3604,'t');
INSERT INTO LANGUECHANSON VALUES('en',3605,'t');
INSERT INTO LANGUECHANSON VALUES('en',3606,'t');
INSERT INTO LANGUECHANSON VALUES('en',3607,'t');
INSERT INTO LANGUECHANSON VALUES('en',3608,'t');
INSERT INTO LANGUECHANSON VALUES('en',3609,'t');
INSERT INTO LANGUECHANSON VALUES('en',3610,'t');
INSERT INTO LANGUECHANSON VALUES('en',3611,'t');
INSERT INTO LANGUECHANSON VALUES('en',3612,'t');
INSERT INTO LANGUECHANSON VALUES('en',3613,'t');
INSERT INTO LANGUECHANSON VALUES('en',3614,'t');
INSERT INTO LANGUECHANSON VALUES('en',3615,'t');
INSERT INTO LANGUECHANSON VALUES('en',3616,'t');
INSERT INTO LANGUECHANSON VALUES('en',3617,'t');
INSERT INTO LANGUECHANSON VALUES('en',3618,'t');
INSERT INTO LANGUECHANSON VALUES('en',3619,'t');
INSERT INTO LANGUECHANSON VALUES('en',3621,'t');
INSERT INTO LANGUECHANSON VALUES('en',3622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3642,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3643,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3644,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3645,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3646,'t');
INSERT INTO LANGUECHANSON VALUES('en',3647,'t');
INSERT INTO LANGUECHANSON VALUES('en',3648,'t');
INSERT INTO LANGUECHANSON VALUES('en',3649,'t');
INSERT INTO LANGUECHANSON VALUES('en',3650,'t');
INSERT INTO LANGUECHANSON VALUES('en',3651,'t');
INSERT INTO LANGUECHANSON VALUES('en',3652,'t');
INSERT INTO LANGUECHANSON VALUES('en',3653,'t');
INSERT INTO LANGUECHANSON VALUES('en',3654,'t');
INSERT INTO LANGUECHANSON VALUES('en',3655,'t');
INSERT INTO LANGUECHANSON VALUES('en',3656,'t');
INSERT INTO LANGUECHANSON VALUES('en',3657,'t');
INSERT INTO LANGUECHANSON VALUES('en',3658,'t');
INSERT INTO LANGUECHANSON VALUES('en',3659,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3660,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3661,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3662,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3663,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3664,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3665,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3666,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3667,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3668,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3669,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3670,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3671,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3672,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3673,'t');
INSERT INTO LANGUECHANSON VALUES('en',3674,'t');
INSERT INTO LANGUECHANSON VALUES('en',3675,'t');
INSERT INTO LANGUECHANSON VALUES('en',3676,'t');
INSERT INTO LANGUECHANSON VALUES('en',3678,'t');
INSERT INTO LANGUECHANSON VALUES('en',3679,'t');
INSERT INTO LANGUECHANSON VALUES('en',3682,'t');
INSERT INTO LANGUECHANSON VALUES('en',3683,'t');
INSERT INTO LANGUECHANSON VALUES('en',3686,'t');
INSERT INTO LANGUECHANSON VALUES('en',3687,'t');
INSERT INTO LANGUECHANSON VALUES('en',3688,'t');
INSERT INTO LANGUECHANSON VALUES('en',3689,'t');
INSERT INTO LANGUECHANSON VALUES('en',3690,'t');
INSERT INTO LANGUECHANSON VALUES('en',3691,'t');
INSERT INTO LANGUECHANSON VALUES('en',3692,'t');
INSERT INTO LANGUECHANSON VALUES('en',3693,'t');
INSERT INTO LANGUECHANSON VALUES('en',3694,'t');
INSERT INTO LANGUECHANSON VALUES('en',3695,'t');
INSERT INTO LANGUECHANSON VALUES('en',3696,'t');
INSERT INTO LANGUECHANSON VALUES('en',3697,'t');
INSERT INTO LANGUECHANSON VALUES('en',3698,'t');
INSERT INTO LANGUECHANSON VALUES('en',3699,'t');
INSERT INTO LANGUECHANSON VALUES('en',3700,'t');
INSERT INTO LANGUECHANSON VALUES('en',3708,'t');
INSERT INTO LANGUECHANSON VALUES('en',3705,'t');
INSERT INTO LANGUECHANSON VALUES('en',3711,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3714,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3715,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3716,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3717,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3718,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3719,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3720,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3721,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3722,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3723,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3724,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3725,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3726,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3727,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3728,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3729,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11567,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3731,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3732,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3734,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3735,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3736,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3737,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3738,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3739,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3740,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3741,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3742,'t');
INSERT INTO LANGUECHANSON VALUES('en',3743,'t');
INSERT INTO LANGUECHANSON VALUES('en',3745,'t');
INSERT INTO LANGUECHANSON VALUES('en',3746,'t');
INSERT INTO LANGUECHANSON VALUES('en',3747,'t');
INSERT INTO LANGUECHANSON VALUES('en',3748,'t');
INSERT INTO LANGUECHANSON VALUES('en',3756,'t');
INSERT INTO LANGUECHANSON VALUES('en',3757,'t');
INSERT INTO LANGUECHANSON VALUES('en',3758,'t');
INSERT INTO LANGUECHANSON VALUES('en',3759,'t');
INSERT INTO LANGUECHANSON VALUES('en',3744,'t');
INSERT INTO LANGUECHANSON VALUES('en',3760,'t');
INSERT INTO LANGUECHANSON VALUES('en',3761,'t');
INSERT INTO LANGUECHANSON VALUES('en',3762,'t');
INSERT INTO LANGUECHANSON VALUES('en',3763,'t');
INSERT INTO LANGUECHANSON VALUES('en',3764,'t');
INSERT INTO LANGUECHANSON VALUES('en',3765,'t');
INSERT INTO LANGUECHANSON VALUES('en',3766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3767,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3771,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3774,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3776,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3778,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3780,'t');
INSERT INTO LANGUECHANSON VALUES('en',3782,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3796,'t');
INSERT INTO LANGUECHANSON VALUES('en',3783,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3797,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3799,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3800,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3801,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3802,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3804,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3805,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3806,'t');
INSERT INTO LANGUECHANSON VALUES('en',3807,'t');
INSERT INTO LANGUECHANSON VALUES('en',3808,'t');
INSERT INTO LANGUECHANSON VALUES('en',3809,'t');
INSERT INTO LANGUECHANSON VALUES('en',3810,'t');
INSERT INTO LANGUECHANSON VALUES('en',3811,'t');
INSERT INTO LANGUECHANSON VALUES('en',3812,'t');
INSERT INTO LANGUECHANSON VALUES('en',3813,'t');
INSERT INTO LANGUECHANSON VALUES('en',3814,'t');
INSERT INTO LANGUECHANSON VALUES('en',3815,'t');
INSERT INTO LANGUECHANSON VALUES('en',3816,'t');
INSERT INTO LANGUECHANSON VALUES('en',3817,'t');
INSERT INTO LANGUECHANSON VALUES('en',3818,'t');
INSERT INTO LANGUECHANSON VALUES('en',3819,'t');
INSERT INTO LANGUECHANSON VALUES('en',3820,'t');
INSERT INTO LANGUECHANSON VALUES('en',3821,'t');
INSERT INTO LANGUECHANSON VALUES('en',3822,'t');
INSERT INTO LANGUECHANSON VALUES('en',3823,'t');
INSERT INTO LANGUECHANSON VALUES('en',3824,'t');
INSERT INTO LANGUECHANSON VALUES('en',3825,'t');
INSERT INTO LANGUECHANSON VALUES('en',3826,'t');
INSERT INTO LANGUECHANSON VALUES('en',3827,'t');
INSERT INTO LANGUECHANSON VALUES('en',3828,'t');
INSERT INTO LANGUECHANSON VALUES('en',3829,'t');
INSERT INTO LANGUECHANSON VALUES('en',3830,'t');
INSERT INTO LANGUECHANSON VALUES('en',3831,'t');
INSERT INTO LANGUECHANSON VALUES('en',3833,'t');
INSERT INTO LANGUECHANSON VALUES('en',3834,'t');
INSERT INTO LANGUECHANSON VALUES('en',3835,'t');
INSERT INTO LANGUECHANSON VALUES('en',3837,'t');
INSERT INTO LANGUECHANSON VALUES('en',3838,'t');
INSERT INTO LANGUECHANSON VALUES('en',3839,'t');
INSERT INTO LANGUECHANSON VALUES('en',3840,'t');
INSERT INTO LANGUECHANSON VALUES('en',3841,'t');
INSERT INTO LANGUECHANSON VALUES('en',3842,'t');
INSERT INTO LANGUECHANSON VALUES('en',3843,'t');
INSERT INTO LANGUECHANSON VALUES('en',3844,'t');
INSERT INTO LANGUECHANSON VALUES('en',3845,'t');
INSERT INTO LANGUECHANSON VALUES('en',3846,'t');
INSERT INTO LANGUECHANSON VALUES('en',3847,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3851,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3852,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3853,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3856,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3857,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3858,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3859,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3860,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3861,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3862,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3863,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3864,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3865,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3866,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3867,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3868,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3869,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3870,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3884,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3885,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3887,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3888,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3889,'t');
INSERT INTO LANGUECHANSON VALUES('en',3892,'t');
INSERT INTO LANGUECHANSON VALUES('en',3904,'t');
INSERT INTO LANGUECHANSON VALUES('en',3906,'t');
INSERT INTO LANGUECHANSON VALUES('en',3907,'t');
INSERT INTO LANGUECHANSON VALUES('en',3908,'t');
INSERT INTO LANGUECHANSON VALUES('en',3909,'t');
INSERT INTO LANGUECHANSON VALUES('en',3910,'t');
INSERT INTO LANGUECHANSON VALUES('en',3911,'t');
INSERT INTO LANGUECHANSON VALUES('en',3912,'t');
INSERT INTO LANGUECHANSON VALUES('en',3913,'t');
INSERT INTO LANGUECHANSON VALUES('en',3914,'t');
INSERT INTO LANGUECHANSON VALUES('en',3901,'t');
INSERT INTO LANGUECHANSON VALUES('en',3915,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3933,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3934,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3935,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3936,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3941,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3942,'t');
INSERT INTO LANGUECHANSON VALUES('en',3944,'t');
INSERT INTO LANGUECHANSON VALUES('en',3945,'t');
INSERT INTO LANGUECHANSON VALUES('en',3947,'t');
INSERT INTO LANGUECHANSON VALUES('en',3948,'t');
INSERT INTO LANGUECHANSON VALUES('en',3950,'t');
INSERT INTO LANGUECHANSON VALUES('en',3951,'t');
INSERT INTO LANGUECHANSON VALUES('en',3952,'t');
INSERT INTO LANGUECHANSON VALUES('en',3953,'t');
INSERT INTO LANGUECHANSON VALUES('en',3954,'t');
INSERT INTO LANGUECHANSON VALUES('en',3955,'t');
INSERT INTO LANGUECHANSON VALUES('en',3956,'t');
INSERT INTO LANGUECHANSON VALUES('en',3957,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3973,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3974,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3975,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3977,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3978,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3979,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3980,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3982,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3983,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3984,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3985,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3986,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3987,'t');
INSERT INTO LANGUECHANSON VALUES('en',3988,'t');
INSERT INTO LANGUECHANSON VALUES('en',3989,'t');
INSERT INTO LANGUECHANSON VALUES('en',3990,'t');
INSERT INTO LANGUECHANSON VALUES('en',3991,'t');
INSERT INTO LANGUECHANSON VALUES('en',3992,'t');
INSERT INTO LANGUECHANSON VALUES('en',3993,'t');
INSERT INTO LANGUECHANSON VALUES('en',3994,'t');
INSERT INTO LANGUECHANSON VALUES('en',3995,'t');
INSERT INTO LANGUECHANSON VALUES('en',3996,'t');
INSERT INTO LANGUECHANSON VALUES('en',3997,'t');
INSERT INTO LANGUECHANSON VALUES('en',3998,'t');
INSERT INTO LANGUECHANSON VALUES('en',3999,'t');
INSERT INTO LANGUECHANSON VALUES('en',4000,'t');
INSERT INTO LANGUECHANSON VALUES('en',4001,'t');
INSERT INTO LANGUECHANSON VALUES('en',4002,'t');
INSERT INTO LANGUECHANSON VALUES('en',4003,'t');
INSERT INTO LANGUECHANSON VALUES('en',4004,'t');
INSERT INTO LANGUECHANSON VALUES('en',4005,'t');
INSERT INTO LANGUECHANSON VALUES('en',4006,'t');
INSERT INTO LANGUECHANSON VALUES('en',4007,'t');
INSERT INTO LANGUECHANSON VALUES('en',4008,'t');
INSERT INTO LANGUECHANSON VALUES('en',4009,'t');
INSERT INTO LANGUECHANSON VALUES('en',4010,'t');
INSERT INTO LANGUECHANSON VALUES('en',4011,'t');
INSERT INTO LANGUECHANSON VALUES('en',4012,'t');
INSERT INTO LANGUECHANSON VALUES('en',4013,'t');
INSERT INTO LANGUECHANSON VALUES('en',4014,'t');
INSERT INTO LANGUECHANSON VALUES('en',4015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4018,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4024,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4026,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4027,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4028,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4029,'t');
INSERT INTO LANGUECHANSON VALUES('en',4032,'t');
INSERT INTO LANGUECHANSON VALUES('en',4036,'t');
INSERT INTO LANGUECHANSON VALUES('en',4039,'t');
INSERT INTO LANGUECHANSON VALUES('en',3958,'t');
INSERT INTO LANGUECHANSON VALUES('en',4030,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4044,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4045,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4046,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4048,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4049,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4050,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4051,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4052,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4053,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4054,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4055,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4056,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4057,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4058,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4059,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4060,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4061,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4062,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4063,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4064,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4065,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4068,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4069,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4070,'t');
INSERT INTO LANGUECHANSON VALUES('en',4071,'t');
INSERT INTO LANGUECHANSON VALUES('en',4072,'t');
INSERT INTO LANGUECHANSON VALUES('en',4073,'t');
INSERT INTO LANGUECHANSON VALUES('en',4075,'t');
INSERT INTO LANGUECHANSON VALUES('en',4076,'t');
INSERT INTO LANGUECHANSON VALUES('en',4077,'t');
INSERT INTO LANGUECHANSON VALUES('en',4079,'t');
INSERT INTO LANGUECHANSON VALUES('en',4080,'t');
INSERT INTO LANGUECHANSON VALUES('en',4081,'t');
INSERT INTO LANGUECHANSON VALUES('en',4082,'t');
INSERT INTO LANGUECHANSON VALUES('en',4083,'t');
INSERT INTO LANGUECHANSON VALUES('en',4084,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4085,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4086,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4087,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4088,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4089,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4090,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4091,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4092,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4093,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4094,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4095,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4096,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4097,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4098,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4099,'t');
INSERT INTO LANGUECHANSON VALUES('en',4100,'t');
INSERT INTO LANGUECHANSON VALUES('en',4101,'t');
INSERT INTO LANGUECHANSON VALUES('en',4102,'t');
INSERT INTO LANGUECHANSON VALUES('en',4103,'t');
INSERT INTO LANGUECHANSON VALUES('en',4104,'t');
INSERT INTO LANGUECHANSON VALUES('en',4105,'t');
INSERT INTO LANGUECHANSON VALUES('en',4106,'t');
INSERT INTO LANGUECHANSON VALUES('en',4107,'t');
INSERT INTO LANGUECHANSON VALUES('en',4108,'t');
INSERT INTO LANGUECHANSON VALUES('en',4109,'t');
INSERT INTO LANGUECHANSON VALUES('en',4110,'t');
INSERT INTO LANGUECHANSON VALUES('en',4111,'t');
INSERT INTO LANGUECHANSON VALUES('en',4112,'t');
INSERT INTO LANGUECHANSON VALUES('en',4113,'t');
INSERT INTO LANGUECHANSON VALUES('en',4114,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4115,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4116,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4117,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4118,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4119,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4120,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4121,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4122,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4123,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4124,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4125,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4126,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4127,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4128,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4129,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4130,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4131,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4132,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4134,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4136,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4138,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4139,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4141,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4142,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4143,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4144,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4146,'t');
INSERT INTO LANGUECHANSON VALUES('en',4149,'t');
INSERT INTO LANGUECHANSON VALUES('en',4151,'t');
INSERT INTO LANGUECHANSON VALUES('en',4152,'t');
INSERT INTO LANGUECHANSON VALUES('en',4159,'t');
INSERT INTO LANGUECHANSON VALUES('en',4160,'t');
INSERT INTO LANGUECHANSON VALUES('en',4173,'t');
INSERT INTO LANGUECHANSON VALUES('en',4174,'t');
INSERT INTO LANGUECHANSON VALUES('en',4175,'t');
INSERT INTO LANGUECHANSON VALUES('en',4176,'t');
INSERT INTO LANGUECHANSON VALUES('en',4177,'t');
INSERT INTO LANGUECHANSON VALUES('en',4178,'t');
INSERT INTO LANGUECHANSON VALUES('en',4179,'t');
INSERT INTO LANGUECHANSON VALUES('en',4189,'t');
INSERT INTO LANGUECHANSON VALUES('en',4190,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4219,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4220,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4221,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4228,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4230,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4231,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4232,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4233,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4234,'t');
INSERT INTO LANGUECHANSON VALUES('en',4235,'t');
INSERT INTO LANGUECHANSON VALUES('en',4236,'t');
INSERT INTO LANGUECHANSON VALUES('en',4237,'t');
INSERT INTO LANGUECHANSON VALUES('en',4238,'t');
INSERT INTO LANGUECHANSON VALUES('en',4239,'t');
INSERT INTO LANGUECHANSON VALUES('en',4240,'t');
INSERT INTO LANGUECHANSON VALUES('en',4241,'t');
INSERT INTO LANGUECHANSON VALUES('en',4242,'t');
INSERT INTO LANGUECHANSON VALUES('en',4243,'t');
INSERT INTO LANGUECHANSON VALUES('en',4244,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4264,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4265,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4266,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4269,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4270,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4271,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4274,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4276,'t');
INSERT INTO LANGUECHANSON VALUES('en',4277,'t');
INSERT INTO LANGUECHANSON VALUES('en',4278,'t');
INSERT INTO LANGUECHANSON VALUES('en',4280,'t');
INSERT INTO LANGUECHANSON VALUES('en',4295,'t');
INSERT INTO LANGUECHANSON VALUES('en',4308,'t');
INSERT INTO LANGUECHANSON VALUES('en',4309,'t');
INSERT INTO LANGUECHANSON VALUES('en',4312,'t');
INSERT INTO LANGUECHANSON VALUES('en',4318,'t');
INSERT INTO LANGUECHANSON VALUES('en',4336,'t');
INSERT INTO LANGUECHANSON VALUES('en',4337,'t');
INSERT INTO LANGUECHANSON VALUES('en',4339,'t');
INSERT INTO LANGUECHANSON VALUES('en',4341,'t');
INSERT INTO LANGUECHANSON VALUES('en',4343,'t');
INSERT INTO LANGUECHANSON VALUES('en',4345,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4346,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4347,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4349,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4350,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4351,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4352,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4353,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4354,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4355,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4356,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4357,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4358,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4359,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4360,'t');
INSERT INTO LANGUECHANSON VALUES('en',4361,'t');
INSERT INTO LANGUECHANSON VALUES('en',4378,'t');
INSERT INTO LANGUECHANSON VALUES('en',4379,'t');
INSERT INTO LANGUECHANSON VALUES('en',4380,'t');
INSERT INTO LANGUECHANSON VALUES('en',4377,'t');
INSERT INTO LANGUECHANSON VALUES('en',4381,'t');
INSERT INTO LANGUECHANSON VALUES('en',4382,'t');
INSERT INTO LANGUECHANSON VALUES('en',4383,'t');
INSERT INTO LANGUECHANSON VALUES('en',4384,'t');
INSERT INTO LANGUECHANSON VALUES('en',4385,'t');
INSERT INTO LANGUECHANSON VALUES('en',4386,'t');
INSERT INTO LANGUECHANSON VALUES('en',4387,'t');
INSERT INTO LANGUECHANSON VALUES('en',4388,'t');
INSERT INTO LANGUECHANSON VALUES('en',4389,'t');
INSERT INTO LANGUECHANSON VALUES('en',4390,'t');
INSERT INTO LANGUECHANSON VALUES('en',4391,'t');
INSERT INTO LANGUECHANSON VALUES('en',4392,'t');
INSERT INTO LANGUECHANSON VALUES('en',4393,'t');
INSERT INTO LANGUECHANSON VALUES('en',4395,'t');
INSERT INTO LANGUECHANSON VALUES('en',4396,'t');
INSERT INTO LANGUECHANSON VALUES('en',4397,'t');
INSERT INTO LANGUECHANSON VALUES('en',4398,'t');
INSERT INTO LANGUECHANSON VALUES('en',4399,'t');
INSERT INTO LANGUECHANSON VALUES('en',4400,'t');
INSERT INTO LANGUECHANSON VALUES('en',4401,'t');
INSERT INTO LANGUECHANSON VALUES('en',4402,'t');
INSERT INTO LANGUECHANSON VALUES('en',4403,'t');
INSERT INTO LANGUECHANSON VALUES('en',4404,'t');
INSERT INTO LANGUECHANSON VALUES('en',4405,'t');
INSERT INTO LANGUECHANSON VALUES('en',4406,'t');
INSERT INTO LANGUECHANSON VALUES('en',4407,'t');
INSERT INTO LANGUECHANSON VALUES('en',4408,'t');
INSERT INTO LANGUECHANSON VALUES('en',4409,'t');
INSERT INTO LANGUECHANSON VALUES('en',4428,'t');
INSERT INTO LANGUECHANSON VALUES('en',4439,'t');
INSERT INTO LANGUECHANSON VALUES('en',4444,'t');
INSERT INTO LANGUECHANSON VALUES('en',4426,'t');
INSERT INTO LANGUECHANSON VALUES('en',4437,'t');
INSERT INTO LANGUECHANSON VALUES('en',4431,'t');
INSERT INTO LANGUECHANSON VALUES('en',4433,'t');
INSERT INTO LANGUECHANSON VALUES('en',4434,'t');
INSERT INTO LANGUECHANSON VALUES('en',4425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4457,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4458,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4459,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4460,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4461,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4462,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4463,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4464,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4465,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4466,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4467,'t');
INSERT INTO LANGUECHANSON VALUES('en',4468,'t');
INSERT INTO LANGUECHANSON VALUES('en',4469,'t');
INSERT INTO LANGUECHANSON VALUES('en',4470,'t');
INSERT INTO LANGUECHANSON VALUES('en',4471,'t');
INSERT INTO LANGUECHANSON VALUES('en',4472,'t');
INSERT INTO LANGUECHANSON VALUES('en',4473,'t');
INSERT INTO LANGUECHANSON VALUES('en',4475,'t');
INSERT INTO LANGUECHANSON VALUES('en',4476,'t');
INSERT INTO LANGUECHANSON VALUES('en',4477,'t');
INSERT INTO LANGUECHANSON VALUES('en',4478,'t');
INSERT INTO LANGUECHANSON VALUES('en',4479,'t');
INSERT INTO LANGUECHANSON VALUES('en',4480,'t');
INSERT INTO LANGUECHANSON VALUES('en',4481,'t');
INSERT INTO LANGUECHANSON VALUES('en',4482,'t');
INSERT INTO LANGUECHANSON VALUES('en',4483,'t');
INSERT INTO LANGUECHANSON VALUES('en',4484,'t');
INSERT INTO LANGUECHANSON VALUES('en',4497,'t');
INSERT INTO LANGUECHANSON VALUES('en',4498,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4501,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4502,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4503,'t');
INSERT INTO LANGUECHANSON VALUES('en',4489,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4504,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4505,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4506,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4507,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4508,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4509,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4511,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4512,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4513,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4514,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4515,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4516,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4517,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4518,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4524,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4525,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4526,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4529,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4531,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4532,'t');
INSERT INTO LANGUECHANSON VALUES('en',4550,'t');
INSERT INTO LANGUECHANSON VALUES('en',4551,'t');
INSERT INTO LANGUECHANSON VALUES('en',4552,'t');
INSERT INTO LANGUECHANSON VALUES('en',4553,'t');
INSERT INTO LANGUECHANSON VALUES('en',4554,'t');
INSERT INTO LANGUECHANSON VALUES('en',4555,'t');
INSERT INTO LANGUECHANSON VALUES('en',4556,'t');
INSERT INTO LANGUECHANSON VALUES('en',4557,'t');
INSERT INTO LANGUECHANSON VALUES('en',4558,'t');
INSERT INTO LANGUECHANSON VALUES('en',4559,'t');
INSERT INTO LANGUECHANSON VALUES('en',4560,'t');
INSERT INTO LANGUECHANSON VALUES('en',4561,'t');
INSERT INTO LANGUECHANSON VALUES('en',4562,'t');
INSERT INTO LANGUECHANSON VALUES('en',4563,'t');
INSERT INTO LANGUECHANSON VALUES('en',4564,'t');
INSERT INTO LANGUECHANSON VALUES('en',4565,'t');
INSERT INTO LANGUECHANSON VALUES('en',4566,'t');
INSERT INTO LANGUECHANSON VALUES('en',4587,'t');
INSERT INTO LANGUECHANSON VALUES('en',4589,'t');
INSERT INTO LANGUECHANSON VALUES('en',4604,'t');
INSERT INTO LANGUECHANSON VALUES('en',4605,'t');
INSERT INTO LANGUECHANSON VALUES('en',4606,'t');
INSERT INTO LANGUECHANSON VALUES('en',4607,'t');
INSERT INTO LANGUECHANSON VALUES('en',4608,'t');
INSERT INTO LANGUECHANSON VALUES('en',4609,'t');
INSERT INTO LANGUECHANSON VALUES('en',4610,'t');
INSERT INTO LANGUECHANSON VALUES('en',4611,'t');
INSERT INTO LANGUECHANSON VALUES('en',4612,'t');
INSERT INTO LANGUECHANSON VALUES('en',4613,'t');
INSERT INTO LANGUECHANSON VALUES('en',4614,'t');
INSERT INTO LANGUECHANSON VALUES('en',4615,'t');
INSERT INTO LANGUECHANSON VALUES('en',4616,'t');
INSERT INTO LANGUECHANSON VALUES('en',4617,'t');
INSERT INTO LANGUECHANSON VALUES('en',4618,'t');
INSERT INTO LANGUECHANSON VALUES('en',4619,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4621,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4624,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4626,'t');
INSERT INTO LANGUECHANSON VALUES('en',4599,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4627,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4629,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4630,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4631,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4636,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4637,'t');
INSERT INTO LANGUECHANSON VALUES('en',4638,'t');
INSERT INTO LANGUECHANSON VALUES('en',4639,'t');
INSERT INTO LANGUECHANSON VALUES('en',4640,'t');
INSERT INTO LANGUECHANSON VALUES('en',4641,'t');
INSERT INTO LANGUECHANSON VALUES('en',4642,'t');
INSERT INTO LANGUECHANSON VALUES('en',4643,'t');
INSERT INTO LANGUECHANSON VALUES('en',4644,'t');
INSERT INTO LANGUECHANSON VALUES('en',4645,'t');
INSERT INTO LANGUECHANSON VALUES('en',4646,'t');
INSERT INTO LANGUECHANSON VALUES('en',4647,'t');
INSERT INTO LANGUECHANSON VALUES('en',4648,'t');
INSERT INTO LANGUECHANSON VALUES('en',4649,'t');
INSERT INTO LANGUECHANSON VALUES('en',4650,'t');
INSERT INTO LANGUECHANSON VALUES('en',4651,'t');
INSERT INTO LANGUECHANSON VALUES('en',4652,'t');
INSERT INTO LANGUECHANSON VALUES('en',4653,'t');
INSERT INTO LANGUECHANSON VALUES('en',4654,'t');
INSERT INTO LANGUECHANSON VALUES('en',4655,'t');
INSERT INTO LANGUECHANSON VALUES('en',4656,'t');
INSERT INTO LANGUECHANSON VALUES('en',4657,'t');
INSERT INTO LANGUECHANSON VALUES('en',4658,'t');
INSERT INTO LANGUECHANSON VALUES('en',4659,'t');
INSERT INTO LANGUECHANSON VALUES('en',4660,'t');
INSERT INTO LANGUECHANSON VALUES('en',4661,'t');
INSERT INTO LANGUECHANSON VALUES('en',4662,'t');
INSERT INTO LANGUECHANSON VALUES('en',4663,'t');
INSERT INTO LANGUECHANSON VALUES('en',4664,'t');
INSERT INTO LANGUECHANSON VALUES('en',4665,'t');
INSERT INTO LANGUECHANSON VALUES('en',4666,'t');
INSERT INTO LANGUECHANSON VALUES('en',4667,'t');
INSERT INTO LANGUECHANSON VALUES('en',4668,'t');
INSERT INTO LANGUECHANSON VALUES('en',4669,'t');
INSERT INTO LANGUECHANSON VALUES('en',4670,'t');
INSERT INTO LANGUECHANSON VALUES('en',4673,'t');
INSERT INTO LANGUECHANSON VALUES('en',4677,'t');
INSERT INTO LANGUECHANSON VALUES('en',4708,'t');
INSERT INTO LANGUECHANSON VALUES('en',4709,'t');
INSERT INTO LANGUECHANSON VALUES('en',4712,'t');
INSERT INTO LANGUECHANSON VALUES('en',4715,'t');
INSERT INTO LANGUECHANSON VALUES('en',4717,'t');
INSERT INTO LANGUECHANSON VALUES('en',4718,'t');
INSERT INTO LANGUECHANSON VALUES('en',4719,'t');
INSERT INTO LANGUECHANSON VALUES('en',4720,'t');
INSERT INTO LANGUECHANSON VALUES('en',4721,'t');
INSERT INTO LANGUECHANSON VALUES('en',4722,'t');
INSERT INTO LANGUECHANSON VALUES('en',4723,'t');
INSERT INTO LANGUECHANSON VALUES('en',4724,'t');
INSERT INTO LANGUECHANSON VALUES('en',4725,'t');
INSERT INTO LANGUECHANSON VALUES('en',4726,'t');
INSERT INTO LANGUECHANSON VALUES('en',4727,'t');
INSERT INTO LANGUECHANSON VALUES('en',4728,'t');
INSERT INTO LANGUECHANSON VALUES('en',4729,'t');
INSERT INTO LANGUECHANSON VALUES('en',4730,'t');
INSERT INTO LANGUECHANSON VALUES('en',4731,'t');
INSERT INTO LANGUECHANSON VALUES('en',4732,'t');
INSERT INTO LANGUECHANSON VALUES('en',4733,'t');
INSERT INTO LANGUECHANSON VALUES('en',4735,'t');
INSERT INTO LANGUECHANSON VALUES('en',4736,'t');
INSERT INTO LANGUECHANSON VALUES('en',4737,'t');
INSERT INTO LANGUECHANSON VALUES('en',4743,'t');
INSERT INTO LANGUECHANSON VALUES('en',4744,'t');
INSERT INTO LANGUECHANSON VALUES('en',4747,'t');
INSERT INTO LANGUECHANSON VALUES('en',4748,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4753,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4754,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4755,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4756,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4757,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4758,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4759,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4760,'t');
INSERT INTO LANGUECHANSON VALUES('en',4763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4783,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4786,'t');
INSERT INTO LANGUECHANSON VALUES('en',4764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4791,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4796,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4799,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4801,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4811,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4814,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4822,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4829,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4836,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4856,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4858,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4867,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4868,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4869,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4870,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4871,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4873,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4874,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4875,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4876,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4877,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4878,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4879,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4880,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4882,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4883,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4884,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4887,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4889,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4891,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4893,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4894,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4896,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4897,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4902,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4904,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4906,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4907,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4914,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4915,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4917,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4918,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4919,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4903,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4971,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4973,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4975,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4978,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4980,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4982,'t');
INSERT INTO LANGUECHANSON VALUES('en',4991,'t');
INSERT INTO LANGUECHANSON VALUES('en',4992,'t');
INSERT INTO LANGUECHANSON VALUES('en',4993,'t');
INSERT INTO LANGUECHANSON VALUES('en',4994,'t');
INSERT INTO LANGUECHANSON VALUES('en',4995,'t');
INSERT INTO LANGUECHANSON VALUES('en',4996,'t');
INSERT INTO LANGUECHANSON VALUES('en',4997,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4998,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5000,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5001,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5002,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5003,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5004,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5005,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5006,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5007,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5008,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5009,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5010,'t');
INSERT INTO LANGUECHANSON VALUES('en',5011,'t');
INSERT INTO LANGUECHANSON VALUES('en',5012,'t');
INSERT INTO LANGUECHANSON VALUES('en',5013,'t');
INSERT INTO LANGUECHANSON VALUES('en',5014,'t');
INSERT INTO LANGUECHANSON VALUES('en',5015,'t');
INSERT INTO LANGUECHANSON VALUES('en',5016,'t');
INSERT INTO LANGUECHANSON VALUES('en',5017,'t');
INSERT INTO LANGUECHANSON VALUES('en',5018,'t');
INSERT INTO LANGUECHANSON VALUES('en',5019,'t');
INSERT INTO LANGUECHANSON VALUES('en',5020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5024,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5026,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5027,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5028,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5029,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5030,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5031,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5032,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5033,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5034,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5035,'t');
INSERT INTO LANGUECHANSON VALUES('en',5036,'t');
INSERT INTO LANGUECHANSON VALUES('en',5037,'t');
INSERT INTO LANGUECHANSON VALUES('en',5038,'t');
INSERT INTO LANGUECHANSON VALUES('en',5040,'t');
INSERT INTO LANGUECHANSON VALUES('en',5041,'t');
INSERT INTO LANGUECHANSON VALUES('en',5042,'t');
INSERT INTO LANGUECHANSON VALUES('en',5044,'t');
INSERT INTO LANGUECHANSON VALUES('en',5045,'t');
INSERT INTO LANGUECHANSON VALUES('en',5046,'t');
INSERT INTO LANGUECHANSON VALUES('en',5047,'t');
INSERT INTO LANGUECHANSON VALUES('en',5048,'t');
INSERT INTO LANGUECHANSON VALUES('en',5049,'t');
INSERT INTO LANGUECHANSON VALUES('en',5050,'t');
INSERT INTO LANGUECHANSON VALUES('en',5051,'t');
INSERT INTO LANGUECHANSON VALUES('en',5052,'t');
INSERT INTO LANGUECHANSON VALUES('en',5054,'t');
INSERT INTO LANGUECHANSON VALUES('en',5055,'t');
INSERT INTO LANGUECHANSON VALUES('en',5056,'t');
INSERT INTO LANGUECHANSON VALUES('en',5057,'t');
INSERT INTO LANGUECHANSON VALUES('en',5058,'t');
INSERT INTO LANGUECHANSON VALUES('en',5059,'t');
INSERT INTO LANGUECHANSON VALUES('en',5060,'t');
INSERT INTO LANGUECHANSON VALUES('en',5061,'t');
INSERT INTO LANGUECHANSON VALUES('en',5062,'t');
INSERT INTO LANGUECHANSON VALUES('en',5063,'t');
INSERT INTO LANGUECHANSON VALUES('en',5066,'t');
INSERT INTO LANGUECHANSON VALUES('en',5067,'t');
INSERT INTO LANGUECHANSON VALUES('en',5068,'t');
INSERT INTO LANGUECHANSON VALUES('en',5069,'t');
INSERT INTO LANGUECHANSON VALUES('en',5070,'t');
INSERT INTO LANGUECHANSON VALUES('en',5071,'t');
INSERT INTO LANGUECHANSON VALUES('en',5073,'t');
INSERT INTO LANGUECHANSON VALUES('en',5074,'t');
INSERT INTO LANGUECHANSON VALUES('en',5075,'t');
INSERT INTO LANGUECHANSON VALUES('en',5076,'t');
INSERT INTO LANGUECHANSON VALUES('en',5077,'t');
INSERT INTO LANGUECHANSON VALUES('en',5078,'t');
INSERT INTO LANGUECHANSON VALUES('en',5079,'t');
INSERT INTO LANGUECHANSON VALUES('en',5080,'t');
INSERT INTO LANGUECHANSON VALUES('en',5081,'t');
INSERT INTO LANGUECHANSON VALUES('en',5082,'t');
INSERT INTO LANGUECHANSON VALUES('en',5083,'t');
INSERT INTO LANGUECHANSON VALUES('en',5084,'t');
INSERT INTO LANGUECHANSON VALUES('en',5085,'t');
INSERT INTO LANGUECHANSON VALUES('en',5086,'t');
INSERT INTO LANGUECHANSON VALUES('en',5087,'t');
INSERT INTO LANGUECHANSON VALUES('en',5088,'t');
INSERT INTO LANGUECHANSON VALUES('en',5089,'t');
INSERT INTO LANGUECHANSON VALUES('en',5090,'t');
INSERT INTO LANGUECHANSON VALUES('en',5091,'t');
INSERT INTO LANGUECHANSON VALUES('en',5092,'t');
INSERT INTO LANGUECHANSON VALUES('en',5094,'t');
INSERT INTO LANGUECHANSON VALUES('en',5099,'t');
INSERT INTO LANGUECHANSON VALUES('en',5110,'t');
INSERT INTO LANGUECHANSON VALUES('en',5112,'t');
INSERT INTO LANGUECHANSON VALUES('en',5113,'t');
INSERT INTO LANGUECHANSON VALUES('en',5114,'t');
INSERT INTO LANGUECHANSON VALUES('en',5115,'t');
INSERT INTO LANGUECHANSON VALUES('en',5116,'t');
INSERT INTO LANGUECHANSON VALUES('en',5117,'t');
INSERT INTO LANGUECHANSON VALUES('en',5118,'t');
INSERT INTO LANGUECHANSON VALUES('en',5119,'t');
INSERT INTO LANGUECHANSON VALUES('en',5120,'t');
INSERT INTO LANGUECHANSON VALUES('en',5121,'t');
INSERT INTO LANGUECHANSON VALUES('en',5122,'t');
INSERT INTO LANGUECHANSON VALUES('en',5123,'t');
INSERT INTO LANGUECHANSON VALUES('en',5126,'t');
INSERT INTO LANGUECHANSON VALUES('en',5127,'t');
INSERT INTO LANGUECHANSON VALUES('en',5128,'t');
INSERT INTO LANGUECHANSON VALUES('en',5130,'t');
INSERT INTO LANGUECHANSON VALUES('en',5131,'t');
INSERT INTO LANGUECHANSON VALUES('en',5134,'t');
INSERT INTO LANGUECHANSON VALUES('en',5135,'t');
INSERT INTO LANGUECHANSON VALUES('en',5136,'t');
INSERT INTO LANGUECHANSON VALUES('en',5137,'t');
INSERT INTO LANGUECHANSON VALUES('en',5138,'t');
INSERT INTO LANGUECHANSON VALUES('en',5139,'t');
INSERT INTO LANGUECHANSON VALUES('en',5140,'t');
INSERT INTO LANGUECHANSON VALUES('en',5141,'t');
INSERT INTO LANGUECHANSON VALUES('en',5142,'t');
INSERT INTO LANGUECHANSON VALUES('en',5143,'t');
INSERT INTO LANGUECHANSON VALUES('en',5144,'t');
INSERT INTO LANGUECHANSON VALUES('en',5145,'t');
INSERT INTO LANGUECHANSON VALUES('en',5146,'t');
INSERT INTO LANGUECHANSON VALUES('en',5147,'t');
INSERT INTO LANGUECHANSON VALUES('en',5149,'t');
INSERT INTO LANGUECHANSON VALUES('en',5150,'t');
INSERT INTO LANGUECHANSON VALUES('en',5151,'t');
INSERT INTO LANGUECHANSON VALUES('en',5152,'t');
INSERT INTO LANGUECHANSON VALUES('en',5153,'t');
INSERT INTO LANGUECHANSON VALUES('en',5154,'t');
INSERT INTO LANGUECHANSON VALUES('en',5155,'t');
INSERT INTO LANGUECHANSON VALUES('en',5156,'t');
INSERT INTO LANGUECHANSON VALUES('en',5157,'t');
INSERT INTO LANGUECHANSON VALUES('en',5158,'t');
INSERT INTO LANGUECHANSON VALUES('en',5159,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5162,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5163,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5164,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5165,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5166,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5167,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5168,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5169,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5170,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5171,'t');
INSERT INTO LANGUECHANSON VALUES('en',5172,'t');
INSERT INTO LANGUECHANSON VALUES('en',5173,'t');
INSERT INTO LANGUECHANSON VALUES('en',5174,'t');
INSERT INTO LANGUECHANSON VALUES('en',5175,'t');
INSERT INTO LANGUECHANSON VALUES('en',5176,'t');
INSERT INTO LANGUECHANSON VALUES('en',5177,'t');
INSERT INTO LANGUECHANSON VALUES('en',5178,'t');
INSERT INTO LANGUECHANSON VALUES('en',5179,'t');
INSERT INTO LANGUECHANSON VALUES('en',5180,'t');
INSERT INTO LANGUECHANSON VALUES('en',5181,'t');
INSERT INTO LANGUECHANSON VALUES('en',5182,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5183,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5184,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5185,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5186,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5187,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5188,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5189,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5190,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5191,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5193,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5194,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5195,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5196,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5197,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5198,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5199,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5200,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5201,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5202,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5203,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5204,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5205,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5206,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5207,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5208,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5209,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5210,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5211,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5212,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5213,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5214,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5215,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5216,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5217,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5218,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5219,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5220,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5221,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5230,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5231,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5232,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5233,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5234,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5235,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5236,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5237,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5238,'t');
INSERT INTO LANGUECHANSON VALUES('en',5240,'t');
INSERT INTO LANGUECHANSON VALUES('en',5241,'t');
INSERT INTO LANGUECHANSON VALUES('en',5242,'t');
INSERT INTO LANGUECHANSON VALUES('en',5243,'t');
INSERT INTO LANGUECHANSON VALUES('en',5245,'t');
INSERT INTO LANGUECHANSON VALUES('en',5246,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5248,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5249,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5250,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5251,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5252,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5253,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5254,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5255,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5256,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5257,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5258,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5259,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5260,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5261,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5262,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5263,'t');
INSERT INTO LANGUECHANSON VALUES('en',5282,'t');
INSERT INTO LANGUECHANSON VALUES('en',5283,'t');
INSERT INTO LANGUECHANSON VALUES('en',5284,'t');
INSERT INTO LANGUECHANSON VALUES('en',5286,'t');
INSERT INTO LANGUECHANSON VALUES('en',5287,'t');
INSERT INTO LANGUECHANSON VALUES('en',5288,'t');
INSERT INTO LANGUECHANSON VALUES('en',5289,'t');
INSERT INTO LANGUECHANSON VALUES('en',5290,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5291,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5292,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5293,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5294,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5295,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5296,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5297,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5298,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5299,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5300,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5301,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5302,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5303,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5306,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5308,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5309,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5310,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5311,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5312,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5313,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5314,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5315,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5316,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5317,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5318,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5319,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5320,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5321,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5322,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5323,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5324,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5325,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5326,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5327,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5328,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5329,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5330,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5331,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5332,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5334,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5335,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5337,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5338,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5339,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11568,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5341,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5342,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5343,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5344,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5345,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5346,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5347,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5349,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5350,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5351,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5352,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5353,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5354,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5355,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5356,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5357,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5358,'t');
INSERT INTO LANGUECHANSON VALUES('en',5374,'t');
INSERT INTO LANGUECHANSON VALUES('en',5375,'t');
INSERT INTO LANGUECHANSON VALUES('en',5376,'t');
INSERT INTO LANGUECHANSON VALUES('en',5377,'t');
INSERT INTO LANGUECHANSON VALUES('en',5378,'t');
INSERT INTO LANGUECHANSON VALUES('en',5379,'t');
INSERT INTO LANGUECHANSON VALUES('en',5380,'t');
INSERT INTO LANGUECHANSON VALUES('en',5381,'t');
INSERT INTO LANGUECHANSON VALUES('en',5382,'t');
INSERT INTO LANGUECHANSON VALUES('en',5383,'t');
INSERT INTO LANGUECHANSON VALUES('en',5384,'t');
INSERT INTO LANGUECHANSON VALUES('en',5385,'t');
INSERT INTO LANGUECHANSON VALUES('en',5387,'t');
INSERT INTO LANGUECHANSON VALUES('en',5389,'t');
INSERT INTO LANGUECHANSON VALUES('en',5390,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5391,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5392,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5393,'t');
INSERT INTO LANGUECHANSON VALUES('en',5386,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5394,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5395,'t');
INSERT INTO LANGUECHANSON VALUES('en',5411,'t');
INSERT INTO LANGUECHANSON VALUES('en',5412,'t');
INSERT INTO LANGUECHANSON VALUES('en',5413,'t');
INSERT INTO LANGUECHANSON VALUES('en',5414,'t');
INSERT INTO LANGUECHANSON VALUES('en',5415,'t');
INSERT INTO LANGUECHANSON VALUES('en',5416,'t');
INSERT INTO LANGUECHANSON VALUES('en',5417,'t');
INSERT INTO LANGUECHANSON VALUES('en',5418,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5420,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5421,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5422,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5423,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5426,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5428,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5429,'t');
INSERT INTO LANGUECHANSON VALUES('en',1918,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5438,'t');
INSERT INTO LANGUECHANSON VALUES('en',5439,'t');
INSERT INTO LANGUECHANSON VALUES('en',5440,'t');
INSERT INTO LANGUECHANSON VALUES('en',5441,'t');
INSERT INTO LANGUECHANSON VALUES('en',5442,'t');
INSERT INTO LANGUECHANSON VALUES('en',5443,'t');
INSERT INTO LANGUECHANSON VALUES('en',5444,'t');
INSERT INTO LANGUECHANSON VALUES('en',5445,'t');
INSERT INTO LANGUECHANSON VALUES('en',5446,'t');
INSERT INTO LANGUECHANSON VALUES('en',5447,'t');
INSERT INTO LANGUECHANSON VALUES('en',5448,'t');
INSERT INTO LANGUECHANSON VALUES('en',5449,'t');
INSERT INTO LANGUECHANSON VALUES('en',5450,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5451,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5455,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5457,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5458,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5475,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5476,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5477,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5479,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5480,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5482,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5483,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5484,'t');
INSERT INTO LANGUECHANSON VALUES('en',5485,'t');
INSERT INTO LANGUECHANSON VALUES('en',5486,'t');
INSERT INTO LANGUECHANSON VALUES('en',5487,'t');
INSERT INTO LANGUECHANSON VALUES('en',5488,'t');
INSERT INTO LANGUECHANSON VALUES('en',5489,'t');
INSERT INTO LANGUECHANSON VALUES('en',5490,'t');
INSERT INTO LANGUECHANSON VALUES('en',5491,'t');
INSERT INTO LANGUECHANSON VALUES('en',5492,'t');
INSERT INTO LANGUECHANSON VALUES('en',5493,'t');
INSERT INTO LANGUECHANSON VALUES('en',5494,'t');
INSERT INTO LANGUECHANSON VALUES('en',5495,'t');
INSERT INTO LANGUECHANSON VALUES('en',5496,'t');
INSERT INTO LANGUECHANSON VALUES('en',5497,'t');
INSERT INTO LANGUECHANSON VALUES('en',5498,'t');
INSERT INTO LANGUECHANSON VALUES('en',5499,'t');
INSERT INTO LANGUECHANSON VALUES('en',5500,'t');
INSERT INTO LANGUECHANSON VALUES('en',5501,'t');
INSERT INTO LANGUECHANSON VALUES('en',5510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5535,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5536,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5537,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5538,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5539,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5540,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5541,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5543,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5544,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5545,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5547,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5568,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5569,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5570,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5571,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5572,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5573,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5574,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5575,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5577,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5578,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5576,'t');
INSERT INTO LANGUECHANSON VALUES('en',5581,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5590,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5591,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5592,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5593,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5594,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5595,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5597,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5598,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5599,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5602,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5604,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5605,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5612,'t');
INSERT INTO LANGUECHANSON VALUES('en',5614,'t');
INSERT INTO LANGUECHANSON VALUES('en',5615,'t');
INSERT INTO LANGUECHANSON VALUES('en',5616,'t');
INSERT INTO LANGUECHANSON VALUES('en',5617,'t');
INSERT INTO LANGUECHANSON VALUES('en',5618,'t');
INSERT INTO LANGUECHANSON VALUES('en',5619,'t');
INSERT INTO LANGUECHANSON VALUES('en',5620,'t');
INSERT INTO LANGUECHANSON VALUES('en',5621,'t');
INSERT INTO LANGUECHANSON VALUES('en',5622,'t');
INSERT INTO LANGUECHANSON VALUES('en',5623,'t');
INSERT INTO LANGUECHANSON VALUES('en',5624,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5626,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5627,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5629,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5630,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5631,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5636,'t');
INSERT INTO LANGUECHANSON VALUES('en',5637,'t');
INSERT INTO LANGUECHANSON VALUES('en',5638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5609,'t');
INSERT INTO LANGUECHANSON VALUES('en',5639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5648,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5649,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5650,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5652,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5653,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5654,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5655,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5656,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5657,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5658,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5659,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5677,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5678,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5679,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5680,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5681,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5682,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5683,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5685,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5687,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5688,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5689,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5692,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5693,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5694,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5695,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5696,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5697,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5698,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5699,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5700,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5701,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5702,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5703,'t');
INSERT INTO LANGUECHANSON VALUES('fn',5704,'t');
INSERT INTO LANGUECHANSON VALUES('en',5719,'t');
INSERT INTO LANGUECHANSON VALUES('en',5720,'t');
INSERT INTO LANGUECHANSON VALUES('en',5722,'t');
INSERT INTO LANGUECHANSON VALUES('en',5724,'t');
INSERT INTO LANGUECHANSON VALUES('en',5725,'t');
INSERT INTO LANGUECHANSON VALUES('en',5726,'t');
INSERT INTO LANGUECHANSON VALUES('en',5727,'t');
INSERT INTO LANGUECHANSON VALUES('en',5728,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5735,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5736,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5737,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5738,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5739,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5740,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5741,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5742,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5743,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5744,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5745,'t');
INSERT INTO LANGUECHANSON VALUES('en',5746,'t');
INSERT INTO LANGUECHANSON VALUES('en',5747,'t');
INSERT INTO LANGUECHANSON VALUES('en',5748,'t');
INSERT INTO LANGUECHANSON VALUES('en',5749,'t');
INSERT INTO LANGUECHANSON VALUES('en',5750,'t');
INSERT INTO LANGUECHANSON VALUES('en',5751,'t');
INSERT INTO LANGUECHANSON VALUES('en',5752,'t');
INSERT INTO LANGUECHANSON VALUES('en',5753,'t');
INSERT INTO LANGUECHANSON VALUES('en',5754,'t');
INSERT INTO LANGUECHANSON VALUES('en',5755,'t');
INSERT INTO LANGUECHANSON VALUES('en',5756,'t');
INSERT INTO LANGUECHANSON VALUES('en',5757,'t');
INSERT INTO LANGUECHANSON VALUES('en',5758,'t');
INSERT INTO LANGUECHANSON VALUES('en',5759,'t');
INSERT INTO LANGUECHANSON VALUES('en',5760,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5767,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5770,'t');
INSERT INTO LANGUECHANSON VALUES('en',5668,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5771,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5774,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5781,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5783,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5786,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5787,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5789,'t');
INSERT INTO LANGUECHANSON VALUES('en',5790,'t');
INSERT INTO LANGUECHANSON VALUES('en',5791,'t');
INSERT INTO LANGUECHANSON VALUES('en',5792,'t');
INSERT INTO LANGUECHANSON VALUES('en',5793,'t');
INSERT INTO LANGUECHANSON VALUES('en',5794,'t');
INSERT INTO LANGUECHANSON VALUES('en',5795,'t');
INSERT INTO LANGUECHANSON VALUES('en',5797,'t');
INSERT INTO LANGUECHANSON VALUES('en',5798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5788,'t');
INSERT INTO LANGUECHANSON VALUES('en',5796,'t');
INSERT INTO LANGUECHANSON VALUES('en',5799,'t');
INSERT INTO LANGUECHANSON VALUES('en',5800,'t');
INSERT INTO LANGUECHANSON VALUES('en',5801,'t');
INSERT INTO LANGUECHANSON VALUES('en',5803,'t');
INSERT INTO LANGUECHANSON VALUES('en',5804,'t');
INSERT INTO LANGUECHANSON VALUES('en',5805,'t');
INSERT INTO LANGUECHANSON VALUES('en',5806,'t');
INSERT INTO LANGUECHANSON VALUES('en',5807,'t');
INSERT INTO LANGUECHANSON VALUES('en',5812,'t');
INSERT INTO LANGUECHANSON VALUES('en',5813,'t');
INSERT INTO LANGUECHANSON VALUES('en',5815,'t');
INSERT INTO LANGUECHANSON VALUES('en',5816,'t');
INSERT INTO LANGUECHANSON VALUES('en',5817,'t');
INSERT INTO LANGUECHANSON VALUES('en',5818,'t');
INSERT INTO LANGUECHANSON VALUES('en',5819,'t');
INSERT INTO LANGUECHANSON VALUES('en',5820,'t');
INSERT INTO LANGUECHANSON VALUES('en',5822,'t');
INSERT INTO LANGUECHANSON VALUES('en',5823,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5824,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5825,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5826,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5830,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5831,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5832,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5833,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5835,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5836,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5838,'t');
INSERT INTO LANGUECHANSON VALUES('en',5808,'t');
INSERT INTO LANGUECHANSON VALUES('en',5809,'t');
INSERT INTO LANGUECHANSON VALUES('en',5810,'t');
INSERT INTO LANGUECHANSON VALUES('en',5811,'t');
INSERT INTO LANGUECHANSON VALUES('en',5821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5839,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5840,'t');
INSERT INTO LANGUECHANSON VALUES('en',5844,'t');
INSERT INTO LANGUECHANSON VALUES('en',5848,'t');
INSERT INTO LANGUECHANSON VALUES('en',5853,'t');
INSERT INTO LANGUECHANSON VALUES('en',5854,'t');
INSERT INTO LANGUECHANSON VALUES('en',5855,'t');
INSERT INTO LANGUECHANSON VALUES('en',5857,'t');
INSERT INTO LANGUECHANSON VALUES('en',5858,'t');
INSERT INTO LANGUECHANSON VALUES('en',5859,'t');
INSERT INTO LANGUECHANSON VALUES('en',5860,'t');
INSERT INTO LANGUECHANSON VALUES('en',5861,'t');
INSERT INTO LANGUECHANSON VALUES('en',5862,'t');
INSERT INTO LANGUECHANSON VALUES('en',5863,'t');
INSERT INTO LANGUECHANSON VALUES('en',5864,'t');
INSERT INTO LANGUECHANSON VALUES('en',5865,'t');
INSERT INTO LANGUECHANSON VALUES('en',5866,'t');
INSERT INTO LANGUECHANSON VALUES('en',5867,'t');
INSERT INTO LANGUECHANSON VALUES('en',5868,'t');
INSERT INTO LANGUECHANSON VALUES('en',5869,'t');
INSERT INTO LANGUECHANSON VALUES('en',5870,'t');
INSERT INTO LANGUECHANSON VALUES('en',5871,'t');
INSERT INTO LANGUECHANSON VALUES('en',5873,'t');
INSERT INTO LANGUECHANSON VALUES('en',5874,'t');
INSERT INTO LANGUECHANSON VALUES('en',5875,'t');
INSERT INTO LANGUECHANSON VALUES('en',5876,'t');
INSERT INTO LANGUECHANSON VALUES('en',5878,'t');
INSERT INTO LANGUECHANSON VALUES('en',5880,'t');
INSERT INTO LANGUECHANSON VALUES('en',5884,'t');
INSERT INTO LANGUECHANSON VALUES('en',5885,'t');
INSERT INTO LANGUECHANSON VALUES('en',5889,'t');
INSERT INTO LANGUECHANSON VALUES('en',5925,'t');
INSERT INTO LANGUECHANSON VALUES('en',5892,'t');
INSERT INTO LANGUECHANSON VALUES('en',5926,'t');
INSERT INTO LANGUECHANSON VALUES('en',5927,'t');
INSERT INTO LANGUECHANSON VALUES('en',5928,'t');
INSERT INTO LANGUECHANSON VALUES('en',5929,'t');
INSERT INTO LANGUECHANSON VALUES('en',5930,'t');
INSERT INTO LANGUECHANSON VALUES('en',5931,'t');
INSERT INTO LANGUECHANSON VALUES('en',5932,'t');
INSERT INTO LANGUECHANSON VALUES('en',5933,'t');
INSERT INTO LANGUECHANSON VALUES('en',5934,'t');
INSERT INTO LANGUECHANSON VALUES('en',5935,'t');
INSERT INTO LANGUECHANSON VALUES('en',5936,'t');
INSERT INTO LANGUECHANSON VALUES('en',5937,'t');
INSERT INTO LANGUECHANSON VALUES('en',5939,'t');
INSERT INTO LANGUECHANSON VALUES('en',5940,'t');
INSERT INTO LANGUECHANSON VALUES('en',5941,'t');
INSERT INTO LANGUECHANSON VALUES('en',5942,'t');
INSERT INTO LANGUECHANSON VALUES('en',5943,'t');
INSERT INTO LANGUECHANSON VALUES('en',5944,'t');
INSERT INTO LANGUECHANSON VALUES('en',5945,'t');
INSERT INTO LANGUECHANSON VALUES('en',5946,'t');
INSERT INTO LANGUECHANSON VALUES('en',5948,'t');
INSERT INTO LANGUECHANSON VALUES('en',5949,'t');
INSERT INTO LANGUECHANSON VALUES('en',5950,'t');
INSERT INTO LANGUECHANSON VALUES('en',5951,'t');
INSERT INTO LANGUECHANSON VALUES('en',5952,'t');
INSERT INTO LANGUECHANSON VALUES('en',5953,'t');
INSERT INTO LANGUECHANSON VALUES('en',5954,'t');
INSERT INTO LANGUECHANSON VALUES('en',5955,'t');
INSERT INTO LANGUECHANSON VALUES('en',5956,'t');
INSERT INTO LANGUECHANSON VALUES('en',5957,'t');
INSERT INTO LANGUECHANSON VALUES('en',5958,'t');
INSERT INTO LANGUECHANSON VALUES('en',5959,'t');
INSERT INTO LANGUECHANSON VALUES('en',5960,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5961,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5962,'t');
INSERT INTO LANGUECHANSON VALUES('en',5938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5965,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5966,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5967,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5969,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5971,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5973,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5974,'t');
INSERT INTO LANGUECHANSON VALUES('en',5978,'t');
INSERT INTO LANGUECHANSON VALUES('en',5979,'t');
INSERT INTO LANGUECHANSON VALUES('en',5980,'t');
INSERT INTO LANGUECHANSON VALUES('en',5981,'t');
INSERT INTO LANGUECHANSON VALUES('en',5982,'t');
INSERT INTO LANGUECHANSON VALUES('en',5983,'t');
INSERT INTO LANGUECHANSON VALUES('en',5984,'t');
INSERT INTO LANGUECHANSON VALUES('en',5986,'t');
INSERT INTO LANGUECHANSON VALUES('en',5987,'t');
INSERT INTO LANGUECHANSON VALUES('en',5988,'t');
INSERT INTO LANGUECHANSON VALUES('en',5989,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5992,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5993,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5994,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5995,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5996,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5997,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5998,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6000,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6001,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6002,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6003,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6004,'t');
INSERT INTO LANGUECHANSON VALUES('en',6005,'t');
INSERT INTO LANGUECHANSON VALUES('en',6006,'t');
INSERT INTO LANGUECHANSON VALUES('en',6007,'t');
INSERT INTO LANGUECHANSON VALUES('en',6008,'t');
INSERT INTO LANGUECHANSON VALUES('en',6009,'t');
INSERT INTO LANGUECHANSON VALUES('en',6010,'t');
INSERT INTO LANGUECHANSON VALUES('en',6011,'t');
INSERT INTO LANGUECHANSON VALUES('en',6012,'t');
INSERT INTO LANGUECHANSON VALUES('en',6013,'t');
INSERT INTO LANGUECHANSON VALUES('en',6014,'t');
INSERT INTO LANGUECHANSON VALUES('en',6015,'t');
INSERT INTO LANGUECHANSON VALUES('en',6016,'t');
INSERT INTO LANGUECHANSON VALUES('en',6017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6018,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6024,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6026,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6027,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6028,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6030,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6031,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6032,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6033,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6034,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6035,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6036,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6037,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6038,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6039,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6040,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6041,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6042,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6043,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6044,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6045,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6046,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6047,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6048,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6049,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6052,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6053,'t');
INSERT INTO LANGUECHANSON VALUES('en',5985,'t');
INSERT INTO LANGUECHANSON VALUES('en',6075,'t');
INSERT INTO LANGUECHANSON VALUES('en',6076,'t');
INSERT INTO LANGUECHANSON VALUES('en',6078,'t');
INSERT INTO LANGUECHANSON VALUES('en',6079,'t');
INSERT INTO LANGUECHANSON VALUES('en',6080,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6081,'t');
INSERT INTO LANGUECHANSON VALUES('en',6072,'t');
INSERT INTO LANGUECHANSON VALUES('en',6077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6083,'t');
INSERT INTO LANGUECHANSON VALUES('en',6066,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6095,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6097,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6098,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6099,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6104,'t');
INSERT INTO LANGUECHANSON VALUES('en',6175,'t');
INSERT INTO LANGUECHANSON VALUES('en',6176,'t');
INSERT INTO LANGUECHANSON VALUES('en',6177,'t');
INSERT INTO LANGUECHANSON VALUES('en',6178,'t');
INSERT INTO LANGUECHANSON VALUES('en',6179,'t');
INSERT INTO LANGUECHANSON VALUES('en',6180,'t');
INSERT INTO LANGUECHANSON VALUES('en',6181,'t');
INSERT INTO LANGUECHANSON VALUES('en',6182,'t');
INSERT INTO LANGUECHANSON VALUES('en',6183,'t');
INSERT INTO LANGUECHANSON VALUES('en',6184,'t');
INSERT INTO LANGUECHANSON VALUES('en',6185,'t');
INSERT INTO LANGUECHANSON VALUES('en',6186,'t');
INSERT INTO LANGUECHANSON VALUES('en',6187,'t');
INSERT INTO LANGUECHANSON VALUES('en',6188,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6189,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6190,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6191,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6193,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6194,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6195,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6197,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6198,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6199,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6200,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6201,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6202,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6217,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6218,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6219,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6220,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6221,'t');
INSERT INTO LANGUECHANSON VALUES('en',3709,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5900,'t');
INSERT INTO LANGUECHANSON VALUES('en',1907,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6228,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6230,'t');
INSERT INTO LANGUECHANSON VALUES('en',6231,'t');
INSERT INTO LANGUECHANSON VALUES('en',6232,'t');
INSERT INTO LANGUECHANSON VALUES('en',6233,'t');
INSERT INTO LANGUECHANSON VALUES('en',6234,'t');
INSERT INTO LANGUECHANSON VALUES('en',6235,'t');
INSERT INTO LANGUECHANSON VALUES('en',6236,'t');
INSERT INTO LANGUECHANSON VALUES('en',6237,'t');
INSERT INTO LANGUECHANSON VALUES('en',6238,'t');
INSERT INTO LANGUECHANSON VALUES('en',6239,'t');
INSERT INTO LANGUECHANSON VALUES('en',6240,'t');
INSERT INTO LANGUECHANSON VALUES('en',6243,'t');
INSERT INTO LANGUECHANSON VALUES('en',6245,'t');
INSERT INTO LANGUECHANSON VALUES('en',6247,'t');
INSERT INTO LANGUECHANSON VALUES('en',6248,'t');
INSERT INTO LANGUECHANSON VALUES('en',6249,'t');
INSERT INTO LANGUECHANSON VALUES('en',6251,'t');
INSERT INTO LANGUECHANSON VALUES('en',6252,'t');
INSERT INTO LANGUECHANSON VALUES('en',6254,'t');
INSERT INTO LANGUECHANSON VALUES('en',6255,'t');
INSERT INTO LANGUECHANSON VALUES('en',6258,'t');
INSERT INTO LANGUECHANSON VALUES('en',6259,'t');
INSERT INTO LANGUECHANSON VALUES('en',6265,'t');
INSERT INTO LANGUECHANSON VALUES('en',6266,'t');
INSERT INTO LANGUECHANSON VALUES('en',6267,'t');
INSERT INTO LANGUECHANSON VALUES('en',6268,'t');
INSERT INTO LANGUECHANSON VALUES('en',6269,'t');
INSERT INTO LANGUECHANSON VALUES('en',6270,'t');
INSERT INTO LANGUECHANSON VALUES('en',6271,'t');
INSERT INTO LANGUECHANSON VALUES('en',6272,'t');
INSERT INTO LANGUECHANSON VALUES('en',6273,'t');
INSERT INTO LANGUECHANSON VALUES('en',6274,'t');
INSERT INTO LANGUECHANSON VALUES('en',6275,'t');
INSERT INTO LANGUECHANSON VALUES('en',6276,'t');
INSERT INTO LANGUECHANSON VALUES('en',6277,'t');
INSERT INTO LANGUECHANSON VALUES('en',6278,'t');
INSERT INTO LANGUECHANSON VALUES('en',6279,'t');
INSERT INTO LANGUECHANSON VALUES('en',6280,'t');
INSERT INTO LANGUECHANSON VALUES('en',6281,'t');
INSERT INTO LANGUECHANSON VALUES('en',6282,'t');
INSERT INTO LANGUECHANSON VALUES('en',6283,'t');
INSERT INTO LANGUECHANSON VALUES('en',6284,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6286,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6287,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6288,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6289,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6290,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6291,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6292,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6293,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6294,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6295,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6296,'t');
INSERT INTO LANGUECHANSON VALUES('en',6297,'t');
INSERT INTO LANGUECHANSON VALUES('en',6299,'t');
INSERT INTO LANGUECHANSON VALUES('en',6300,'t');
INSERT INTO LANGUECHANSON VALUES('en',6301,'t');
INSERT INTO LANGUECHANSON VALUES('en',6302,'t');
INSERT INTO LANGUECHANSON VALUES('en',6303,'t');
INSERT INTO LANGUECHANSON VALUES('en',6304,'t');
INSERT INTO LANGUECHANSON VALUES('en',6305,'t');
INSERT INTO LANGUECHANSON VALUES('en',6306,'t');
INSERT INTO LANGUECHANSON VALUES('en',6307,'t');
INSERT INTO LANGUECHANSON VALUES('en',6308,'t');
INSERT INTO LANGUECHANSON VALUES('en',6309,'t');
INSERT INTO LANGUECHANSON VALUES('en',6310,'t');
INSERT INTO LANGUECHANSON VALUES('en',6311,'t');
INSERT INTO LANGUECHANSON VALUES('en',6312,'t');
INSERT INTO LANGUECHANSON VALUES('en',6313,'t');
INSERT INTO LANGUECHANSON VALUES('en',6315,'t');
INSERT INTO LANGUECHANSON VALUES('en',6316,'t');
INSERT INTO LANGUECHANSON VALUES('en',6318,'t');
INSERT INTO LANGUECHANSON VALUES('en',6319,'t');
INSERT INTO LANGUECHANSON VALUES('en',6323,'t');
INSERT INTO LANGUECHANSON VALUES('en',6324,'t');
INSERT INTO LANGUECHANSON VALUES('en',6325,'t');
INSERT INTO LANGUECHANSON VALUES('en',6327,'t');
INSERT INTO LANGUECHANSON VALUES('en',6328,'t');
INSERT INTO LANGUECHANSON VALUES('en',6329,'t');
INSERT INTO LANGUECHANSON VALUES('en',6330,'t');
INSERT INTO LANGUECHANSON VALUES('en',6331,'t');
INSERT INTO LANGUECHANSON VALUES('en',6332,'t');
INSERT INTO LANGUECHANSON VALUES('en',6333,'t');
INSERT INTO LANGUECHANSON VALUES('en',6334,'t');
INSERT INTO LANGUECHANSON VALUES('en',6335,'t');
INSERT INTO LANGUECHANSON VALUES('en',6336,'t');
INSERT INTO LANGUECHANSON VALUES('en',6337,'t');
INSERT INTO LANGUECHANSON VALUES('en',6338,'t');
INSERT INTO LANGUECHANSON VALUES('en',6339,'t');
INSERT INTO LANGUECHANSON VALUES('en',6342,'t');
INSERT INTO LANGUECHANSON VALUES('en',6343,'t');
INSERT INTO LANGUECHANSON VALUES('en',6344,'t');
INSERT INTO LANGUECHANSON VALUES('en',6345,'t');
INSERT INTO LANGUECHANSON VALUES('en',6346,'t');
INSERT INTO LANGUECHANSON VALUES('en',6347,'t');
INSERT INTO LANGUECHANSON VALUES('en',6348,'t');
INSERT INTO LANGUECHANSON VALUES('en',6349,'t');
INSERT INTO LANGUECHANSON VALUES('en',6350,'t');
INSERT INTO LANGUECHANSON VALUES('en',6351,'t');
INSERT INTO LANGUECHANSON VALUES('en',6352,'t');
INSERT INTO LANGUECHANSON VALUES('en',6353,'t');
INSERT INTO LANGUECHANSON VALUES('en',6354,'t');
INSERT INTO LANGUECHANSON VALUES('en',6355,'t');
INSERT INTO LANGUECHANSON VALUES('en',6356,'t');
INSERT INTO LANGUECHANSON VALUES('en',6357,'t');
INSERT INTO LANGUECHANSON VALUES('en',6358,'t');
INSERT INTO LANGUECHANSON VALUES('en',6359,'t');
INSERT INTO LANGUECHANSON VALUES('en',6360,'t');
INSERT INTO LANGUECHANSON VALUES('en',6361,'t');
INSERT INTO LANGUECHANSON VALUES('en',6362,'t');
INSERT INTO LANGUECHANSON VALUES('en',6365,'t');
INSERT INTO LANGUECHANSON VALUES('en',6366,'t');
INSERT INTO LANGUECHANSON VALUES('en',6367,'t');
INSERT INTO LANGUECHANSON VALUES('en',6368,'t');
INSERT INTO LANGUECHANSON VALUES('en',6369,'t');
INSERT INTO LANGUECHANSON VALUES('en',6371,'t');
INSERT INTO LANGUECHANSON VALUES('en',6372,'t');
INSERT INTO LANGUECHANSON VALUES('en',6377,'t');
INSERT INTO LANGUECHANSON VALUES('en',6378,'t');
INSERT INTO LANGUECHANSON VALUES('en',6379,'t');
INSERT INTO LANGUECHANSON VALUES('en',6381,'t');
INSERT INTO LANGUECHANSON VALUES('en',6382,'t');
INSERT INTO LANGUECHANSON VALUES('en',6383,'t');
INSERT INTO LANGUECHANSON VALUES('en',6384,'t');
INSERT INTO LANGUECHANSON VALUES('en',6385,'t');
INSERT INTO LANGUECHANSON VALUES('en',6386,'t');
INSERT INTO LANGUECHANSON VALUES('en',6387,'t');
INSERT INTO LANGUECHANSON VALUES('en',6388,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6389,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6390,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6391,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6392,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6393,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6394,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6395,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6396,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6397,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6399,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6407,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6408,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6409,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6410,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6411,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6412,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6413,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6414,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6415,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6416,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6417,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6419,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6421,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6422,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6423,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6431,'t');
INSERT INTO LANGUECHANSON VALUES('en',2663,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6440,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6441,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6442,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6443,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6444,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6445,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6446,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6447,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6448,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6449,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6450,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6451,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6453,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6454,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6455,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6456,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6457,'t');
INSERT INTO LANGUECHANSON VALUES('en',6477,'t');
INSERT INTO LANGUECHANSON VALUES('en',6478,'t');
INSERT INTO LANGUECHANSON VALUES('en',6479,'t');
INSERT INTO LANGUECHANSON VALUES('en',6480,'t');
INSERT INTO LANGUECHANSON VALUES('en',6481,'t');
INSERT INTO LANGUECHANSON VALUES('en',6482,'t');
INSERT INTO LANGUECHANSON VALUES('en',6483,'t');
INSERT INTO LANGUECHANSON VALUES('en',6484,'t');
INSERT INTO LANGUECHANSON VALUES('en',6485,'t');
INSERT INTO LANGUECHANSON VALUES('en',6486,'t');
INSERT INTO LANGUECHANSON VALUES('en',6487,'t');
INSERT INTO LANGUECHANSON VALUES('en',6488,'t');
INSERT INTO LANGUECHANSON VALUES('en',6489,'t');
INSERT INTO LANGUECHANSON VALUES('es',6503,'t');
INSERT INTO LANGUECHANSON VALUES('es',6504,'t');
INSERT INTO LANGUECHANSON VALUES('en',6461,'t');
INSERT INTO LANGUECHANSON VALUES('en',6460,'t');
INSERT INTO LANGUECHANSON VALUES('en',6466,'t');
INSERT INTO LANGUECHANSON VALUES('es',6505,'t');
INSERT INTO LANGUECHANSON VALUES('es',6506,'t');
INSERT INTO LANGUECHANSON VALUES('es',6507,'t');
INSERT INTO LANGUECHANSON VALUES('es',6508,'t');
INSERT INTO LANGUECHANSON VALUES('es',6509,'t');
INSERT INTO LANGUECHANSON VALUES('es',6510,'t');
INSERT INTO LANGUECHANSON VALUES('es',6511,'t');
INSERT INTO LANGUECHANSON VALUES('es',6512,'t');
INSERT INTO LANGUECHANSON VALUES('es',6513,'t');
INSERT INTO LANGUECHANSON VALUES('es',6514,'t');
INSERT INTO LANGUECHANSON VALUES('es',6515,'t');
INSERT INTO LANGUECHANSON VALUES('es',6516,'t');
INSERT INTO LANGUECHANSON VALUES('es',6517,'t');
INSERT INTO LANGUECHANSON VALUES('es',6518,'t');
INSERT INTO LANGUECHANSON VALUES('en',6519,'t');
INSERT INTO LANGUECHANSON VALUES('en',6523,'t');
INSERT INTO LANGUECHANSON VALUES('en',6525,'t');
INSERT INTO LANGUECHANSON VALUES('en',6527,'t');
INSERT INTO LANGUECHANSON VALUES('en',6529,'t');
INSERT INTO LANGUECHANSON VALUES('en',6532,'t');
INSERT INTO LANGUECHANSON VALUES('en',6534,'t');
INSERT INTO LANGUECHANSON VALUES('en',6535,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6536,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6537,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6538,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6539,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6540,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6541,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6542,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6543,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6544,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6545,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6546,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6547,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6548,'t');
INSERT INTO LANGUECHANSON VALUES('en',6549,'t');
INSERT INTO LANGUECHANSON VALUES('en',6550,'t');
INSERT INTO LANGUECHANSON VALUES('en',6551,'t');
INSERT INTO LANGUECHANSON VALUES('en',6553,'t');
INSERT INTO LANGUECHANSON VALUES('en',6555,'t');
INSERT INTO LANGUECHANSON VALUES('en',6556,'t');
INSERT INTO LANGUECHANSON VALUES('en',6557,'t');
INSERT INTO LANGUECHANSON VALUES('en',6558,'t');
INSERT INTO LANGUECHANSON VALUES('en',6559,'t');
INSERT INTO LANGUECHANSON VALUES('en',6560,'t');
INSERT INTO LANGUECHANSON VALUES('en',6570,'t');
INSERT INTO LANGUECHANSON VALUES('en',6571,'t');
INSERT INTO LANGUECHANSON VALUES('en',6572,'t');
INSERT INTO LANGUECHANSON VALUES('en',6573,'t');
INSERT INTO LANGUECHANSON VALUES('en',6574,'t');
INSERT INTO LANGUECHANSON VALUES('en',6575,'t');
INSERT INTO LANGUECHANSON VALUES('en',6576,'t');
INSERT INTO LANGUECHANSON VALUES('en',6577,'t');
INSERT INTO LANGUECHANSON VALUES('en',6578,'t');
INSERT INTO LANGUECHANSON VALUES('en',6579,'t');
INSERT INTO LANGUECHANSON VALUES('en',6580,'t');
INSERT INTO LANGUECHANSON VALUES('en',6582,'t');
INSERT INTO LANGUECHANSON VALUES('en',6583,'t');
INSERT INTO LANGUECHANSON VALUES('en',6584,'t');
INSERT INTO LANGUECHANSON VALUES('en',6586,'t');
INSERT INTO LANGUECHANSON VALUES('en',6587,'t');
INSERT INTO LANGUECHANSON VALUES('en',6588,'t');
INSERT INTO LANGUECHANSON VALUES('en',6589,'t');
INSERT INTO LANGUECHANSON VALUES('en',6592,'t');
INSERT INTO LANGUECHANSON VALUES('en',6593,'t');
INSERT INTO LANGUECHANSON VALUES('en',6595,'t');
INSERT INTO LANGUECHANSON VALUES('en',6597,'t');
INSERT INTO LANGUECHANSON VALUES('en',6598,'t');
INSERT INTO LANGUECHANSON VALUES('en',6599,'t');
INSERT INTO LANGUECHANSON VALUES('en',6600,'t');
INSERT INTO LANGUECHANSON VALUES('en',6601,'t');
INSERT INTO LANGUECHANSON VALUES('en',6602,'t');
INSERT INTO LANGUECHANSON VALUES('en',6603,'t');
INSERT INTO LANGUECHANSON VALUES('en',6604,'t');
INSERT INTO LANGUECHANSON VALUES('en',6605,'t');
INSERT INTO LANGUECHANSON VALUES('en',6606,'t');
INSERT INTO LANGUECHANSON VALUES('en',6607,'t');
INSERT INTO LANGUECHANSON VALUES('en',6608,'t');
INSERT INTO LANGUECHANSON VALUES('en',6609,'t');
INSERT INTO LANGUECHANSON VALUES('en',6610,'t');
INSERT INTO LANGUECHANSON VALUES('en',6611,'t');
INSERT INTO LANGUECHANSON VALUES('en',6612,'t');
INSERT INTO LANGUECHANSON VALUES('en',6613,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6636,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6640,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6641,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6642,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6643,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6644,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6646,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6661,'t');
INSERT INTO LANGUECHANSON VALUES('en',6662,'t');
INSERT INTO LANGUECHANSON VALUES('en',6663,'t');
INSERT INTO LANGUECHANSON VALUES('en',6664,'t');
INSERT INTO LANGUECHANSON VALUES('en',6665,'t');
INSERT INTO LANGUECHANSON VALUES('en',6666,'t');
INSERT INTO LANGUECHANSON VALUES('en',6667,'t');
INSERT INTO LANGUECHANSON VALUES('en',6668,'t');
INSERT INTO LANGUECHANSON VALUES('en',6669,'t');
INSERT INTO LANGUECHANSON VALUES('br',6683,'t');
INSERT INTO LANGUECHANSON VALUES('br',6685,'t');
INSERT INTO LANGUECHANSON VALUES('en',6590,'t');
INSERT INTO LANGUECHANSON VALUES('br',6686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6656,'t');
INSERT INTO LANGUECHANSON VALUES('br',6687,'t');
INSERT INTO LANGUECHANSON VALUES('br',6689,'t');
INSERT INTO LANGUECHANSON VALUES('br',6691,'t');
INSERT INTO LANGUECHANSON VALUES('br',6692,'t');
INSERT INTO LANGUECHANSON VALUES('br',6693,'t');
INSERT INTO LANGUECHANSON VALUES('br',6694,'t');
INSERT INTO LANGUECHANSON VALUES('br',6696,'t');
INSERT INTO LANGUECHANSON VALUES('br',6697,'t');
INSERT INTO LANGUECHANSON VALUES('br',6738,'t');
INSERT INTO LANGUECHANSON VALUES('br',6740,'t');
INSERT INTO LANGUECHANSON VALUES('br',6741,'t');
INSERT INTO LANGUECHANSON VALUES('br',6742,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6744,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6745,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6746,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6747,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6748,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6749,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6750,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6774,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6776,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6778,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6780,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6781,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6782,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6783,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6786,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6787,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6791,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6792,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6796,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6797,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6799,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6800,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6801,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6802,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6804,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6805,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6806,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6807,'t');
INSERT INTO LANGUECHANSON VALUES('br',6743,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6808,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6809,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6811,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6812,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6813,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6814,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6815,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6816,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6817,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6818,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6819,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6820,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6821,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6822,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6823,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6824,'t');
INSERT INTO LANGUECHANSON VALUES('en',6825,'t');
INSERT INTO LANGUECHANSON VALUES('en',6826,'t');
INSERT INTO LANGUECHANSON VALUES('en',6827,'t');
INSERT INTO LANGUECHANSON VALUES('en',6828,'t');
INSERT INTO LANGUECHANSON VALUES('en',6829,'t');
INSERT INTO LANGUECHANSON VALUES('en',6830,'t');
INSERT INTO LANGUECHANSON VALUES('en',6831,'t');
INSERT INTO LANGUECHANSON VALUES('en',6832,'t');
INSERT INTO LANGUECHANSON VALUES('en',6833,'t');
INSERT INTO LANGUECHANSON VALUES('en',6834,'t');
INSERT INTO LANGUECHANSON VALUES('en',6835,'t');
INSERT INTO LANGUECHANSON VALUES('en',6836,'t');
INSERT INTO LANGUECHANSON VALUES('en',6837,'t');
INSERT INTO LANGUECHANSON VALUES('en',6838,'t');
INSERT INTO LANGUECHANSON VALUES('en',6839,'t');
INSERT INTO LANGUECHANSON VALUES('en',6840,'t');
INSERT INTO LANGUECHANSON VALUES('en',6841,'t');
INSERT INTO LANGUECHANSON VALUES('en',6843,'t');
INSERT INTO LANGUECHANSON VALUES('en',6844,'t');
INSERT INTO LANGUECHANSON VALUES('en',6845,'t');
INSERT INTO LANGUECHANSON VALUES('en',6846,'t');
INSERT INTO LANGUECHANSON VALUES('en',6847,'t');
INSERT INTO LANGUECHANSON VALUES('en',6848,'t');
INSERT INTO LANGUECHANSON VALUES('en',6850,'t');
INSERT INTO LANGUECHANSON VALUES('en',6851,'t');
INSERT INTO LANGUECHANSON VALUES('en',6852,'t');
INSERT INTO LANGUECHANSON VALUES('en',6853,'t');
INSERT INTO LANGUECHANSON VALUES('en',6854,'t');
INSERT INTO LANGUECHANSON VALUES('en',6855,'t');
INSERT INTO LANGUECHANSON VALUES('en',6856,'t');
INSERT INTO LANGUECHANSON VALUES('en',6857,'t');
INSERT INTO LANGUECHANSON VALUES('en',6858,'t');
INSERT INTO LANGUECHANSON VALUES('en',6859,'t');
INSERT INTO LANGUECHANSON VALUES('en',6860,'t');
INSERT INTO LANGUECHANSON VALUES('en',6861,'t');
INSERT INTO LANGUECHANSON VALUES('en',6862,'t');
INSERT INTO LANGUECHANSON VALUES('en',6863,'t');
INSERT INTO LANGUECHANSON VALUES('en',6864,'t');
INSERT INTO LANGUECHANSON VALUES('be',6865,'t');
INSERT INTO LANGUECHANSON VALUES('be',6866,'t');
INSERT INTO LANGUECHANSON VALUES('be',6867,'t');
INSERT INTO LANGUECHANSON VALUES('be',6868,'t');
INSERT INTO LANGUECHANSON VALUES('be',6869,'t');
INSERT INTO LANGUECHANSON VALUES('be',6870,'t');
INSERT INTO LANGUECHANSON VALUES('be',6871,'t');
INSERT INTO LANGUECHANSON VALUES('be',6872,'t');
INSERT INTO LANGUECHANSON VALUES('be',6873,'t');
INSERT INTO LANGUECHANSON VALUES('be',6874,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6875,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6876,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6877,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6878,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6879,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6880,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6881,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6882,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6883,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6884,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6885,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6887,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6888,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6889,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6890,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6891,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6892,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6893,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6894,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6896,'t');
INSERT INTO LANGUECHANSON VALUES('en',6898,'t');
INSERT INTO LANGUECHANSON VALUES('en',6899,'t');
INSERT INTO LANGUECHANSON VALUES('en',6900,'t');
INSERT INTO LANGUECHANSON VALUES('en',6901,'t');
INSERT INTO LANGUECHANSON VALUES('en',6903,'t');
INSERT INTO LANGUECHANSON VALUES('en',6904,'t');
INSERT INTO LANGUECHANSON VALUES('en',6905,'t');
INSERT INTO LANGUECHANSON VALUES('en',6906,'t');
INSERT INTO LANGUECHANSON VALUES('en',6907,'t');
INSERT INTO LANGUECHANSON VALUES('br',6908,'t');
INSERT INTO LANGUECHANSON VALUES('br',6909,'t');
INSERT INTO LANGUECHANSON VALUES('br',6910,'t');
INSERT INTO LANGUECHANSON VALUES('br',6911,'t');
INSERT INTO LANGUECHANSON VALUES('br',6912,'t');
INSERT INTO LANGUECHANSON VALUES('br',6913,'t');
INSERT INTO LANGUECHANSON VALUES('br',6914,'t');
INSERT INTO LANGUECHANSON VALUES('br',6915,'t');
INSERT INTO LANGUECHANSON VALUES('br',6916,'t');
INSERT INTO LANGUECHANSON VALUES('br',6918,'t');
INSERT INTO LANGUECHANSON VALUES('br',6919,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6923,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6926,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6927,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6928,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6929,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6933,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6934,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6935,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6936,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6941,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6942,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6943,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6946,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6947,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6948,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6949,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6950,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6931,'t');
INSERT INTO LANGUECHANSON VALUES('en',6952,'t');
INSERT INTO LANGUECHANSON VALUES('en',6953,'t');
INSERT INTO LANGUECHANSON VALUES('en',6954,'t');
INSERT INTO LANGUECHANSON VALUES('en',6955,'t');
INSERT INTO LANGUECHANSON VALUES('en',6956,'t');
INSERT INTO LANGUECHANSON VALUES('en',6958,'t');
INSERT INTO LANGUECHANSON VALUES('en',6959,'t');
INSERT INTO LANGUECHANSON VALUES('en',6961,'t');
INSERT INTO LANGUECHANSON VALUES('en',6962,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6963,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6964,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6965,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6966,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6967,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6968,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6969,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6970,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6971,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6972,'t');
INSERT INTO LANGUECHANSON VALUES('ar',6973,'t');
INSERT INTO LANGUECHANSON VALUES('br',6974,'t');
INSERT INTO LANGUECHANSON VALUES('br',6975,'t');
INSERT INTO LANGUECHANSON VALUES('br',6977,'t');
INSERT INTO LANGUECHANSON VALUES('br',6978,'t');
INSERT INTO LANGUECHANSON VALUES('br',6979,'t');
INSERT INTO LANGUECHANSON VALUES('br',6981,'t');
INSERT INTO LANGUECHANSON VALUES('br',6982,'t');
INSERT INTO LANGUECHANSON VALUES('br',6976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6945,'t');
INSERT INTO LANGUECHANSON VALUES('br',6983,'t');
INSERT INTO LANGUECHANSON VALUES('br',6984,'t');
INSERT INTO LANGUECHANSON VALUES('br',6985,'t');
INSERT INTO LANGUECHANSON VALUES('en',6986,'t');
INSERT INTO LANGUECHANSON VALUES('en',6987,'t');
INSERT INTO LANGUECHANSON VALUES('en',6988,'t');
INSERT INTO LANGUECHANSON VALUES('en',6989,'t');
INSERT INTO LANGUECHANSON VALUES('en',6991,'t');
INSERT INTO LANGUECHANSON VALUES('en',6992,'t');
INSERT INTO LANGUECHANSON VALUES('en',6993,'t');
INSERT INTO LANGUECHANSON VALUES('en',6995,'t');
INSERT INTO LANGUECHANSON VALUES('en',6996,'t');
INSERT INTO LANGUECHANSON VALUES('en',6997,'t');
INSERT INTO LANGUECHANSON VALUES('en',6998,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7001,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7003,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7004,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7005,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7007,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7008,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7009,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7010,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7011,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7013,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7018,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7021,'t');
INSERT INTO LANGUECHANSON VALUES('en',7030,'t');
INSERT INTO LANGUECHANSON VALUES('br',7036,'t');
INSERT INTO LANGUECHANSON VALUES('br',7037,'t');
INSERT INTO LANGUECHANSON VALUES('br',7038,'t');
INSERT INTO LANGUECHANSON VALUES('br',7039,'t');
INSERT INTO LANGUECHANSON VALUES('br',7040,'t');
INSERT INTO LANGUECHANSON VALUES('br',7041,'t');
INSERT INTO LANGUECHANSON VALUES('br',7042,'t');
INSERT INTO LANGUECHANSON VALUES('br',7043,'t');
INSERT INTO LANGUECHANSON VALUES('br',7045,'t');
INSERT INTO LANGUECHANSON VALUES('en',7046,'t');
INSERT INTO LANGUECHANSON VALUES('en',7048,'t');
INSERT INTO LANGUECHANSON VALUES('en',7049,'t');
INSERT INTO LANGUECHANSON VALUES('en',7051,'t');
INSERT INTO LANGUECHANSON VALUES('en',7052,'t');
INSERT INTO LANGUECHANSON VALUES('en',7053,'t');
INSERT INTO LANGUECHANSON VALUES('en',7055,'t');
INSERT INTO LANGUECHANSON VALUES('en',7056,'t');
INSERT INTO LANGUECHANSON VALUES('en',7057,'t');
INSERT INTO LANGUECHANSON VALUES('en',7058,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7059,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7060,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7061,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7062,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7064,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7065,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7067,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7068,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7069,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7070,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7071,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7072,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7074,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7075,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7078,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7079,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7080,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7081,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7082,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7083,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7084,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7085,'t');
INSERT INTO LANGUECHANSON VALUES('br',7086,'t');
INSERT INTO LANGUECHANSON VALUES('br',7088,'t');
INSERT INTO LANGUECHANSON VALUES('br',7090,'t');
INSERT INTO LANGUECHANSON VALUES('br',7091,'t');
INSERT INTO LANGUECHANSON VALUES('br',7094,'t');
INSERT INTO LANGUECHANSON VALUES('br',7089,'t');
INSERT INTO LANGUECHANSON VALUES('br',7096,'t');
INSERT INTO LANGUECHANSON VALUES('br',7097,'t');
INSERT INTO LANGUECHANSON VALUES('es',7108,'t');
INSERT INTO LANGUECHANSON VALUES('es',7109,'t');
INSERT INTO LANGUECHANSON VALUES('es',7110,'t');
INSERT INTO LANGUECHANSON VALUES('es',7111,'t');
INSERT INTO LANGUECHANSON VALUES('es',7112,'t');
INSERT INTO LANGUECHANSON VALUES('es',7113,'t');
INSERT INTO LANGUECHANSON VALUES('es',7114,'t');
INSERT INTO LANGUECHANSON VALUES('br',7115,'t');
INSERT INTO LANGUECHANSON VALUES('br',7116,'t');
INSERT INTO LANGUECHANSON VALUES('br',7117,'t');
INSERT INTO LANGUECHANSON VALUES('br',7118,'t');
INSERT INTO LANGUECHANSON VALUES('br',7119,'t');
INSERT INTO LANGUECHANSON VALUES('br',7120,'t');
INSERT INTO LANGUECHANSON VALUES('br',7121,'t');
INSERT INTO LANGUECHANSON VALUES('br',7122,'t');
INSERT INTO LANGUECHANSON VALUES('br',7123,'t');
INSERT INTO LANGUECHANSON VALUES('br',7124,'t');
INSERT INTO LANGUECHANSON VALUES('br',7125,'t');
INSERT INTO LANGUECHANSON VALUES('br',7126,'t');
INSERT INTO LANGUECHANSON VALUES('br',7127,'t');
INSERT INTO LANGUECHANSON VALUES('br',7128,'t');
INSERT INTO LANGUECHANSON VALUES('br',7129,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7130,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7131,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7135,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7139,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7141,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7144,'t');
INSERT INTO LANGUECHANSON VALUES('en',7145,'t');
INSERT INTO LANGUECHANSON VALUES('en',7146,'t');
INSERT INTO LANGUECHANSON VALUES('en',7147,'t');
INSERT INTO LANGUECHANSON VALUES('en',7148,'t');
INSERT INTO LANGUECHANSON VALUES('en',7149,'t');
INSERT INTO LANGUECHANSON VALUES('en',7150,'t');
INSERT INTO LANGUECHANSON VALUES('en',7151,'t');
INSERT INTO LANGUECHANSON VALUES('en',7153,'t');
INSERT INTO LANGUECHANSON VALUES('en',7154,'t');
INSERT INTO LANGUECHANSON VALUES('en',7155,'t');
INSERT INTO LANGUECHANSON VALUES('en',7156,'t');
INSERT INTO LANGUECHANSON VALUES('en',7157,'t');
INSERT INTO LANGUECHANSON VALUES('en',7158,'t');
INSERT INTO LANGUECHANSON VALUES('en',7159,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7133,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7136,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7138,'t');
INSERT INTO LANGUECHANSON VALUES('en',7176,'t');
INSERT INTO LANGUECHANSON VALUES('en',7177,'t');
INSERT INTO LANGUECHANSON VALUES('en',7178,'t');
INSERT INTO LANGUECHANSON VALUES('en',7179,'t');
INSERT INTO LANGUECHANSON VALUES('en',7180,'t');
INSERT INTO LANGUECHANSON VALUES('en',7182,'t');
INSERT INTO LANGUECHANSON VALUES('en',7183,'t');
INSERT INTO LANGUECHANSON VALUES('en',7185,'t');
INSERT INTO LANGUECHANSON VALUES('en',7186,'t');
INSERT INTO LANGUECHANSON VALUES('en',7187,'t');
INSERT INTO LANGUECHANSON VALUES('en',7188,'t');
INSERT INTO LANGUECHANSON VALUES('en',7189,'t');
INSERT INTO LANGUECHANSON VALUES('en',7190,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11569,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7193,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7194,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7195,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7196,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7197,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7198,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7199,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7200,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7201,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7202,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7203,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7204,'t');
INSERT INTO LANGUECHANSON VALUES('ar',7205,'t');
INSERT INTO LANGUECHANSON VALUES('be',7206,'t');
INSERT INTO LANGUECHANSON VALUES('be',7207,'t');
INSERT INTO LANGUECHANSON VALUES('be',7208,'t');
INSERT INTO LANGUECHANSON VALUES('be',7209,'t');
INSERT INTO LANGUECHANSON VALUES('be',7210,'t');
INSERT INTO LANGUECHANSON VALUES('be',7211,'t');
INSERT INTO LANGUECHANSON VALUES('be',7212,'t');
INSERT INTO LANGUECHANSON VALUES('be',7213,'t');
INSERT INTO LANGUECHANSON VALUES('be',7214,'t');
INSERT INTO LANGUECHANSON VALUES('be',7215,'t');
INSERT INTO LANGUECHANSON VALUES('be',7216,'t');
INSERT INTO LANGUECHANSON VALUES('be',7217,'t');
INSERT INTO LANGUECHANSON VALUES('be',7218,'t');
INSERT INTO LANGUECHANSON VALUES('be',7219,'t');
INSERT INTO LANGUECHANSON VALUES('be',7220,'t');
INSERT INTO LANGUECHANSON VALUES('be',7221,'t');
INSERT INTO LANGUECHANSON VALUES('be',7222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7223,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7224,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7226,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7227,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7228,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7230,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7231,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7232,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7233,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7234,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7235,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7236,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7237,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7238,'t');
INSERT INTO LANGUECHANSON VALUES('br',7239,'t');
INSERT INTO LANGUECHANSON VALUES('br',7240,'t');
INSERT INTO LANGUECHANSON VALUES('br',7241,'t');
INSERT INTO LANGUECHANSON VALUES('br',7242,'t');
INSERT INTO LANGUECHANSON VALUES('br',7243,'t');
INSERT INTO LANGUECHANSON VALUES('br',7244,'t');
INSERT INTO LANGUECHANSON VALUES('br',7245,'t');
INSERT INTO LANGUECHANSON VALUES('br',7246,'t');
INSERT INTO LANGUECHANSON VALUES('br',7247,'t');
INSERT INTO LANGUECHANSON VALUES('br',7248,'t');
INSERT INTO LANGUECHANSON VALUES('br',7249,'t');
INSERT INTO LANGUECHANSON VALUES('br',7250,'t');
INSERT INTO LANGUECHANSON VALUES('br',7251,'t');
INSERT INTO LANGUECHANSON VALUES('br',7252,'t');
INSERT INTO LANGUECHANSON VALUES('br',7253,'t');
INSERT INTO LANGUECHANSON VALUES('br',7254,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7277,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7278,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7279,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7280,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7281,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7282,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7283,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7284,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7286,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7287,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7289,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7291,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7292,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7293,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7294,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7295,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7296,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7297,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7298,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7300,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7301,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7302,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7304,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7306,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7307,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7308,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7309,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7313,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7290,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7315,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7318,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7322,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7323,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7320,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7327,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7328,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7329,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7336,'t');
INSERT INTO LANGUECHANSON VALUES('br',7337,'t');
INSERT INTO LANGUECHANSON VALUES('br',7338,'t');
INSERT INTO LANGUECHANSON VALUES('br',7339,'t');
INSERT INTO LANGUECHANSON VALUES('br',7340,'t');
INSERT INTO LANGUECHANSON VALUES('br',7341,'t');
INSERT INTO LANGUECHANSON VALUES('br',7342,'t');
INSERT INTO LANGUECHANSON VALUES('br',7343,'t');
INSERT INTO LANGUECHANSON VALUES('br',7344,'t');
INSERT INTO LANGUECHANSON VALUES('br',7345,'t');
INSERT INTO LANGUECHANSON VALUES('br',7346,'t');
INSERT INTO LANGUECHANSON VALUES('br',7347,'t');
INSERT INTO LANGUECHANSON VALUES('br',7348,'t');
INSERT INTO LANGUECHANSON VALUES('br',7349,'t');
INSERT INTO LANGUECHANSON VALUES('br',7350,'t');
INSERT INTO LANGUECHANSON VALUES('br',7352,'t');
INSERT INTO LANGUECHANSON VALUES('br',7363,'t');
INSERT INTO LANGUECHANSON VALUES('br',7366,'t');
INSERT INTO LANGUECHANSON VALUES('br',7368,'t');
INSERT INTO LANGUECHANSON VALUES('br',7369,'t');
INSERT INTO LANGUECHANSON VALUES('br',7405,'t');
INSERT INTO LANGUECHANSON VALUES('br',7407,'t');
INSERT INTO LANGUECHANSON VALUES('br',7409,'t');
INSERT INTO LANGUECHANSON VALUES('br',7411,'t');
INSERT INTO LANGUECHANSON VALUES('br',7412,'t');
INSERT INTO LANGUECHANSON VALUES('br',7413,'t');
INSERT INTO LANGUECHANSON VALUES('br',7414,'t');
INSERT INTO LANGUECHANSON VALUES('br',7415,'t');
INSERT INTO LANGUECHANSON VALUES('br',7417,'t');
INSERT INTO LANGUECHANSON VALUES('br',7418,'t');
INSERT INTO LANGUECHANSON VALUES('br',7419,'t');
INSERT INTO LANGUECHANSON VALUES('br',7420,'t');
INSERT INTO LANGUECHANSON VALUES('br',7421,'t');
INSERT INTO LANGUECHANSON VALUES('br',7422,'t');
INSERT INTO LANGUECHANSON VALUES('br',7423,'t');
INSERT INTO LANGUECHANSON VALUES('br',7424,'t');
INSERT INTO LANGUECHANSON VALUES('br',7425,'t');
INSERT INTO LANGUECHANSON VALUES('br',7426,'t');
INSERT INTO LANGUECHANSON VALUES('br',7427,'t');
INSERT INTO LANGUECHANSON VALUES('br',7428,'t');
INSERT INTO LANGUECHANSON VALUES('br',7429,'t');
INSERT INTO LANGUECHANSON VALUES('br',7430,'t');
INSERT INTO LANGUECHANSON VALUES('br',7431,'t');
INSERT INTO LANGUECHANSON VALUES('br',7432,'t');
INSERT INTO LANGUECHANSON VALUES('br',7433,'t');
INSERT INTO LANGUECHANSON VALUES('br',7434,'t');
INSERT INTO LANGUECHANSON VALUES('br',7435,'t');
INSERT INTO LANGUECHANSON VALUES('br',7436,'t');
INSERT INTO LANGUECHANSON VALUES('br',7437,'t');
INSERT INTO LANGUECHANSON VALUES('br',7438,'t');
INSERT INTO LANGUECHANSON VALUES('br',7439,'t');
INSERT INTO LANGUECHANSON VALUES('br',7440,'t');
INSERT INTO LANGUECHANSON VALUES('br',7441,'t');
INSERT INTO LANGUECHANSON VALUES('br',7442,'t');
INSERT INTO LANGUECHANSON VALUES('br',7456,'t');
INSERT INTO LANGUECHANSON VALUES('br',7457,'t');
INSERT INTO LANGUECHANSON VALUES('br',7458,'t');
INSERT INTO LANGUECHANSON VALUES('br',7461,'t');
INSERT INTO LANGUECHANSON VALUES('br',7462,'t');
INSERT INTO LANGUECHANSON VALUES('br',7463,'t');
INSERT INTO LANGUECHANSON VALUES('br',7466,'t');
INSERT INTO LANGUECHANSON VALUES('br',7467,'t');
INSERT INTO LANGUECHANSON VALUES('br',7468,'t');
INSERT INTO LANGUECHANSON VALUES('br',7469,'t');
INSERT INTO LANGUECHANSON VALUES('br',7470,'t');
INSERT INTO LANGUECHANSON VALUES('br',7471,'t');
INSERT INTO LANGUECHANSON VALUES('br',7472,'t');
INSERT INTO LANGUECHANSON VALUES('br',7474,'t');
INSERT INTO LANGUECHANSON VALUES('br',7476,'t');
INSERT INTO LANGUECHANSON VALUES('br',7477,'t');
INSERT INTO LANGUECHANSON VALUES('br',7479,'t');
INSERT INTO LANGUECHANSON VALUES('br',7480,'t');
INSERT INTO LANGUECHANSON VALUES('br',7482,'t');
INSERT INTO LANGUECHANSON VALUES('br',7483,'t');
INSERT INTO LANGUECHANSON VALUES('br',7484,'t');
INSERT INTO LANGUECHANSON VALUES('br',7485,'t');
INSERT INTO LANGUECHANSON VALUES('br',7487,'t');
INSERT INTO LANGUECHANSON VALUES('br',7488,'t');
INSERT INTO LANGUECHANSON VALUES('br',7489,'t');
INSERT INTO LANGUECHANSON VALUES('br',7490,'t');
INSERT INTO LANGUECHANSON VALUES('br',7491,'t');
INSERT INTO LANGUECHANSON VALUES('br',7492,'t');
INSERT INTO LANGUECHANSON VALUES('br',7493,'t');
INSERT INTO LANGUECHANSON VALUES('br',7494,'t');
INSERT INTO LANGUECHANSON VALUES('br',7495,'t');
INSERT INTO LANGUECHANSON VALUES('br',7496,'t');
INSERT INTO LANGUECHANSON VALUES('br',7497,'t');
INSERT INTO LANGUECHANSON VALUES('br',7498,'t');
INSERT INTO LANGUECHANSON VALUES('br',7499,'t');
INSERT INTO LANGUECHANSON VALUES('br',7500,'t');
INSERT INTO LANGUECHANSON VALUES('br',7501,'t');
INSERT INTO LANGUECHANSON VALUES('br',7503,'t');
INSERT INTO LANGUECHANSON VALUES('br',7504,'t');
INSERT INTO LANGUECHANSON VALUES('br',7505,'t');
INSERT INTO LANGUECHANSON VALUES('br',7506,'t');
INSERT INTO LANGUECHANSON VALUES('br',7507,'t');
INSERT INTO LANGUECHANSON VALUES('br',7508,'t');
INSERT INTO LANGUECHANSON VALUES('br',7509,'t');
INSERT INTO LANGUECHANSON VALUES('br',7510,'t');
INSERT INTO LANGUECHANSON VALUES('br',7511,'t');
INSERT INTO LANGUECHANSON VALUES('br',7512,'t');
INSERT INTO LANGUECHANSON VALUES('br',7513,'t');
INSERT INTO LANGUECHANSON VALUES('br',7514,'t');
INSERT INTO LANGUECHANSON VALUES('br',7515,'t');
INSERT INTO LANGUECHANSON VALUES('br',7516,'t');
INSERT INTO LANGUECHANSON VALUES('br',7517,'t');
INSERT INTO LANGUECHANSON VALUES('br',7518,'t');
INSERT INTO LANGUECHANSON VALUES('br',7519,'t');
INSERT INTO LANGUECHANSON VALUES('br',7520,'t');
INSERT INTO LANGUECHANSON VALUES('br',7521,'t');
INSERT INTO LANGUECHANSON VALUES('br',7522,'t');
INSERT INTO LANGUECHANSON VALUES('br',7523,'t');
INSERT INTO LANGUECHANSON VALUES('br',7524,'t');
INSERT INTO LANGUECHANSON VALUES('br',7525,'t');
INSERT INTO LANGUECHANSON VALUES('br',7486,'t');
INSERT INTO LANGUECHANSON VALUES('br',7526,'t');
INSERT INTO LANGUECHANSON VALUES('br',7527,'t');
INSERT INTO LANGUECHANSON VALUES('br',7528,'t');
INSERT INTO LANGUECHANSON VALUES('br',7529,'t');
INSERT INTO LANGUECHANSON VALUES('br',7530,'t');
INSERT INTO LANGUECHANSON VALUES('br',7531,'t');
INSERT INTO LANGUECHANSON VALUES('br',7532,'t');
INSERT INTO LANGUECHANSON VALUES('br',7533,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7534,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7535,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7536,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7538,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7539,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7540,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7541,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7542,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7543,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7544,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7545,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7546,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7547,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7557,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7558,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7559,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7560,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7561,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7562,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7563,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7564,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7565,'t');
INSERT INTO LANGUECHANSON VALUES('br',7567,'t');
INSERT INTO LANGUECHANSON VALUES('br',7568,'t');
INSERT INTO LANGUECHANSON VALUES('br',7569,'t');
INSERT INTO LANGUECHANSON VALUES('br',7570,'t');
INSERT INTO LANGUECHANSON VALUES('br',7571,'t');
INSERT INTO LANGUECHANSON VALUES('br',7572,'t');
INSERT INTO LANGUECHANSON VALUES('br',7573,'t');
INSERT INTO LANGUECHANSON VALUES('br',7574,'t');
INSERT INTO LANGUECHANSON VALUES('br',7575,'t');
INSERT INTO LANGUECHANSON VALUES('br',7576,'t');
INSERT INTO LANGUECHANSON VALUES('br',7577,'t');
INSERT INTO LANGUECHANSON VALUES('br',7578,'t');
INSERT INTO LANGUECHANSON VALUES('br',7579,'t');
INSERT INTO LANGUECHANSON VALUES('br',7580,'t');
INSERT INTO LANGUECHANSON VALUES('br',7581,'t');
INSERT INTO LANGUECHANSON VALUES('br',7582,'t');
INSERT INTO LANGUECHANSON VALUES('br',7583,'t');
INSERT INTO LANGUECHANSON VALUES('br',7584,'t');
INSERT INTO LANGUECHANSON VALUES('br',7586,'t');
INSERT INTO LANGUECHANSON VALUES('br',7587,'t');
INSERT INTO LANGUECHANSON VALUES('br',7588,'t');
INSERT INTO LANGUECHANSON VALUES('br',7589,'t');
INSERT INTO LANGUECHANSON VALUES('br',7590,'t');
INSERT INTO LANGUECHANSON VALUES('br',7602,'t');
INSERT INTO LANGUECHANSON VALUES('br',7603,'t');
INSERT INTO LANGUECHANSON VALUES('br',7604,'t');
INSERT INTO LANGUECHANSON VALUES('br',7605,'t');
INSERT INTO LANGUECHANSON VALUES('br',7606,'t');
INSERT INTO LANGUECHANSON VALUES('br',7607,'t');
INSERT INTO LANGUECHANSON VALUES('br',7608,'t');
INSERT INTO LANGUECHANSON VALUES('br',7609,'t');
INSERT INTO LANGUECHANSON VALUES('br',7610,'t');
INSERT INTO LANGUECHANSON VALUES('br',7624,'t');
INSERT INTO LANGUECHANSON VALUES('br',7625,'t');
INSERT INTO LANGUECHANSON VALUES('br',7630,'t');
INSERT INTO LANGUECHANSON VALUES('br',7631,'t');
INSERT INTO LANGUECHANSON VALUES('br',7644,'t');
INSERT INTO LANGUECHANSON VALUES('br',7645,'t');
INSERT INTO LANGUECHANSON VALUES('br',7646,'t');
INSERT INTO LANGUECHANSON VALUES('br',7647,'t');
INSERT INTO LANGUECHANSON VALUES('br',7648,'t');
INSERT INTO LANGUECHANSON VALUES('br',7649,'t');
INSERT INTO LANGUECHANSON VALUES('br',7650,'t');
INSERT INTO LANGUECHANSON VALUES('br',7651,'t');
INSERT INTO LANGUECHANSON VALUES('br',7655,'t');
INSERT INTO LANGUECHANSON VALUES('br',7657,'t');
INSERT INTO LANGUECHANSON VALUES('br',7658,'t');
INSERT INTO LANGUECHANSON VALUES('br',7360,'t');
INSERT INTO LANGUECHANSON VALUES('br',7659,'t');
INSERT INTO LANGUECHANSON VALUES('br',7661,'t');
INSERT INTO LANGUECHANSON VALUES('br',7662,'t');
INSERT INTO LANGUECHANSON VALUES('br',7663,'t');
INSERT INTO LANGUECHANSON VALUES('br',7664,'t');
INSERT INTO LANGUECHANSON VALUES('br',7665,'t');
INSERT INTO LANGUECHANSON VALUES('br',7666,'t');
INSERT INTO LANGUECHANSON VALUES('br',7680,'t');
INSERT INTO LANGUECHANSON VALUES('br',7681,'t');
INSERT INTO LANGUECHANSON VALUES('br',7682,'t');
INSERT INTO LANGUECHANSON VALUES('br',7683,'t');
INSERT INTO LANGUECHANSON VALUES('br',7684,'t');
INSERT INTO LANGUECHANSON VALUES('br',7685,'t');
INSERT INTO LANGUECHANSON VALUES('br',7686,'t');
INSERT INTO LANGUECHANSON VALUES('br',7687,'t');
INSERT INTO LANGUECHANSON VALUES('br',7688,'t');
INSERT INTO LANGUECHANSON VALUES('br',7689,'t');
INSERT INTO LANGUECHANSON VALUES('br',7690,'t');
INSERT INTO LANGUECHANSON VALUES('br',7691,'t');
INSERT INTO LANGUECHANSON VALUES('br',7692,'t');
INSERT INTO LANGUECHANSON VALUES('br',7693,'t');
INSERT INTO LANGUECHANSON VALUES('br',7694,'t');
INSERT INTO LANGUECHANSON VALUES('br',7695,'t');
INSERT INTO LANGUECHANSON VALUES('br',7696,'t');
INSERT INTO LANGUECHANSON VALUES('br',7697,'t');
INSERT INTO LANGUECHANSON VALUES('br',7698,'t');
INSERT INTO LANGUECHANSON VALUES('br',7699,'t');
INSERT INTO LANGUECHANSON VALUES('br',7700,'t');
INSERT INTO LANGUECHANSON VALUES('br',7701,'t');
INSERT INTO LANGUECHANSON VALUES('br',7702,'t');
INSERT INTO LANGUECHANSON VALUES('br',7703,'t');
INSERT INTO LANGUECHANSON VALUES('br',7704,'t');
INSERT INTO LANGUECHANSON VALUES('br',7705,'t');
INSERT INTO LANGUECHANSON VALUES('br',7706,'t');
INSERT INTO LANGUECHANSON VALUES('br',7707,'t');
INSERT INTO LANGUECHANSON VALUES('br',7708,'t');
INSERT INTO LANGUECHANSON VALUES('br',7709,'t');
INSERT INTO LANGUECHANSON VALUES('br',7710,'t');
INSERT INTO LANGUECHANSON VALUES('br',7711,'t');
INSERT INTO LANGUECHANSON VALUES('br',7712,'t');
INSERT INTO LANGUECHANSON VALUES('br',7713,'t');
INSERT INTO LANGUECHANSON VALUES('br',7714,'t');
INSERT INTO LANGUECHANSON VALUES('br',7715,'t');
INSERT INTO LANGUECHANSON VALUES('br',7716,'t');
INSERT INTO LANGUECHANSON VALUES('br',7717,'t');
INSERT INTO LANGUECHANSON VALUES('br',7718,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7719,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7721,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7725,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11570,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7727,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7729,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7731,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7733,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7734,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7739,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7742,'t');
INSERT INTO LANGUECHANSON VALUES('br',7748,'t');
INSERT INTO LANGUECHANSON VALUES('br',7749,'t');
INSERT INTO LANGUECHANSON VALUES('br',7750,'t');
INSERT INTO LANGUECHANSON VALUES('br',7751,'t');
INSERT INTO LANGUECHANSON VALUES('br',7752,'t');
INSERT INTO LANGUECHANSON VALUES('br',7753,'t');
INSERT INTO LANGUECHANSON VALUES('br',7754,'t');
INSERT INTO LANGUECHANSON VALUES('br',7755,'t');
INSERT INTO LANGUECHANSON VALUES('br',7756,'t');
INSERT INTO LANGUECHANSON VALUES('br',7757,'t');
INSERT INTO LANGUECHANSON VALUES('br',7758,'t');
INSERT INTO LANGUECHANSON VALUES('br',7759,'t');
INSERT INTO LANGUECHANSON VALUES('br',7760,'t');
INSERT INTO LANGUECHANSON VALUES('br',7761,'t');
INSERT INTO LANGUECHANSON VALUES('br',7762,'t');
INSERT INTO LANGUECHANSON VALUES('br',7765,'t');
INSERT INTO LANGUECHANSON VALUES('br',7780,'t');
INSERT INTO LANGUECHANSON VALUES('br',7781,'t');
INSERT INTO LANGUECHANSON VALUES('br',7782,'t');
INSERT INTO LANGUECHANSON VALUES('br',7783,'t');
INSERT INTO LANGUECHANSON VALUES('br',7784,'t');
INSERT INTO LANGUECHANSON VALUES('br',7785,'t');
INSERT INTO LANGUECHANSON VALUES('br',7786,'t');
INSERT INTO LANGUECHANSON VALUES('br',7787,'t');
INSERT INTO LANGUECHANSON VALUES('br',7788,'t');
INSERT INTO LANGUECHANSON VALUES('br',7789,'t');
INSERT INTO LANGUECHANSON VALUES('br',7790,'t');
INSERT INTO LANGUECHANSON VALUES('br',7791,'t');
INSERT INTO LANGUECHANSON VALUES('br',7792,'t');
INSERT INTO LANGUECHANSON VALUES('br',7793,'t');
INSERT INTO LANGUECHANSON VALUES('br',7795,'t');
INSERT INTO LANGUECHANSON VALUES('br',7796,'t');
INSERT INTO LANGUECHANSON VALUES('br',7797,'t');
INSERT INTO LANGUECHANSON VALUES('br',7798,'t');
INSERT INTO LANGUECHANSON VALUES('br',7800,'t');
INSERT INTO LANGUECHANSON VALUES('br',7801,'t');
INSERT INTO LANGUECHANSON VALUES('br',7802,'t');
INSERT INTO LANGUECHANSON VALUES('br',7803,'t');
INSERT INTO LANGUECHANSON VALUES('br',7804,'t');
INSERT INTO LANGUECHANSON VALUES('br',7805,'t');
INSERT INTO LANGUECHANSON VALUES('br',7806,'t');
INSERT INTO LANGUECHANSON VALUES('br',7807,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7808,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7809,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7814,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7817,'t');
INSERT INTO LANGUECHANSON VALUES('br',7819,'t');
INSERT INTO LANGUECHANSON VALUES('br',7820,'t');
INSERT INTO LANGUECHANSON VALUES('br',7821,'t');
INSERT INTO LANGUECHANSON VALUES('br',7822,'t');
INSERT INTO LANGUECHANSON VALUES('br',7823,'t');
INSERT INTO LANGUECHANSON VALUES('br',7824,'t');
INSERT INTO LANGUECHANSON VALUES('br',7825,'t');
INSERT INTO LANGUECHANSON VALUES('br',7826,'t');
INSERT INTO LANGUECHANSON VALUES('br',7827,'t');
INSERT INTO LANGUECHANSON VALUES('br',7828,'t');
INSERT INTO LANGUECHANSON VALUES('br',7829,'t');
INSERT INTO LANGUECHANSON VALUES('br',7830,'t');
INSERT INTO LANGUECHANSON VALUES('br',7831,'t');
INSERT INTO LANGUECHANSON VALUES('br',7832,'t');
INSERT INTO LANGUECHANSON VALUES('br',7833,'t');
INSERT INTO LANGUECHANSON VALUES('br',7834,'t');
INSERT INTO LANGUECHANSON VALUES('br',7835,'t');
INSERT INTO LANGUECHANSON VALUES('br',7836,'t');
INSERT INTO LANGUECHANSON VALUES('br',7837,'t');
INSERT INTO LANGUECHANSON VALUES('br',7838,'t');
INSERT INTO LANGUECHANSON VALUES('br',7839,'t');
INSERT INTO LANGUECHANSON VALUES('br',7840,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7816,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7812,'t');
INSERT INTO LANGUECHANSON VALUES('br',7841,'t');
INSERT INTO LANGUECHANSON VALUES('br',7842,'t');
INSERT INTO LANGUECHANSON VALUES('br',7843,'t');
INSERT INTO LANGUECHANSON VALUES('br',7844,'t');
INSERT INTO LANGUECHANSON VALUES('br',7845,'t');
INSERT INTO LANGUECHANSON VALUES('br',7846,'t');
INSERT INTO LANGUECHANSON VALUES('br',7847,'t');
INSERT INTO LANGUECHANSON VALUES('br',7848,'t');
INSERT INTO LANGUECHANSON VALUES('br',7849,'t');
INSERT INTO LANGUECHANSON VALUES('br',7850,'t');
INSERT INTO LANGUECHANSON VALUES('br',7851,'t');
INSERT INTO LANGUECHANSON VALUES('br',7852,'t');
INSERT INTO LANGUECHANSON VALUES('br',7853,'t');
INSERT INTO LANGUECHANSON VALUES('br',7854,'t');
INSERT INTO LANGUECHANSON VALUES('br',7855,'t');
INSERT INTO LANGUECHANSON VALUES('br',7856,'t');
INSERT INTO LANGUECHANSON VALUES('br',7857,'t');
INSERT INTO LANGUECHANSON VALUES('br',7858,'t');
INSERT INTO LANGUECHANSON VALUES('br',7859,'t');
INSERT INTO LANGUECHANSON VALUES('br',7860,'t');
INSERT INTO LANGUECHANSON VALUES('br',7861,'t');
INSERT INTO LANGUECHANSON VALUES('br',7862,'t');
INSERT INTO LANGUECHANSON VALUES('br',7863,'t');
INSERT INTO LANGUECHANSON VALUES('br',7864,'t');
INSERT INTO LANGUECHANSON VALUES('br',7865,'t');
INSERT INTO LANGUECHANSON VALUES('br',7866,'t');
INSERT INTO LANGUECHANSON VALUES('br',7867,'t');
INSERT INTO LANGUECHANSON VALUES('br',7868,'t');
INSERT INTO LANGUECHANSON VALUES('br',7869,'t');
INSERT INTO LANGUECHANSON VALUES('br',7870,'t');
INSERT INTO LANGUECHANSON VALUES('br',7871,'t');
INSERT INTO LANGUECHANSON VALUES('br',7872,'t');
INSERT INTO LANGUECHANSON VALUES('br',7873,'t');
INSERT INTO LANGUECHANSON VALUES('br',7874,'t');
INSERT INTO LANGUECHANSON VALUES('br',7875,'t');
INSERT INTO LANGUECHANSON VALUES('br',7876,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7140,'t');
INSERT INTO LANGUECHANSON VALUES('br',7877,'t');
INSERT INTO LANGUECHANSON VALUES('br',7878,'t');
INSERT INTO LANGUECHANSON VALUES('br',7879,'t');
INSERT INTO LANGUECHANSON VALUES('br',7880,'t');
INSERT INTO LANGUECHANSON VALUES('br',7881,'t');
INSERT INTO LANGUECHANSON VALUES('br',7882,'t');
INSERT INTO LANGUECHANSON VALUES('br',7883,'t');
INSERT INTO LANGUECHANSON VALUES('br',7884,'t');
INSERT INTO LANGUECHANSON VALUES('br',7885,'t');
INSERT INTO LANGUECHANSON VALUES('br',7886,'t');
INSERT INTO LANGUECHANSON VALUES('br',7887,'t');
INSERT INTO LANGUECHANSON VALUES('br',7888,'t');
INSERT INTO LANGUECHANSON VALUES('br',7889,'t');
INSERT INTO LANGUECHANSON VALUES('br',7890,'t');
INSERT INTO LANGUECHANSON VALUES('br',7891,'t');
INSERT INTO LANGUECHANSON VALUES('br',7892,'t');
INSERT INTO LANGUECHANSON VALUES('br',7893,'t');
INSERT INTO LANGUECHANSON VALUES('br',7894,'t');
INSERT INTO LANGUECHANSON VALUES('br',7895,'t');
INSERT INTO LANGUECHANSON VALUES('br',7896,'t');
INSERT INTO LANGUECHANSON VALUES('br',7897,'t');
INSERT INTO LANGUECHANSON VALUES('br',7898,'t');
INSERT INTO LANGUECHANSON VALUES('br',7899,'t');
INSERT INTO LANGUECHANSON VALUES('br',7900,'t');
INSERT INTO LANGUECHANSON VALUES('br',7901,'t');
INSERT INTO LANGUECHANSON VALUES('br',7902,'t');
INSERT INTO LANGUECHANSON VALUES('br',7903,'t');
INSERT INTO LANGUECHANSON VALUES('br',7904,'t');
INSERT INTO LANGUECHANSON VALUES('br',7905,'t');
INSERT INTO LANGUECHANSON VALUES('br',7906,'t');
INSERT INTO LANGUECHANSON VALUES('br',7916,'t');
INSERT INTO LANGUECHANSON VALUES('br',7917,'t');
INSERT INTO LANGUECHANSON VALUES('br',7918,'t');
INSERT INTO LANGUECHANSON VALUES('br',7919,'t');
INSERT INTO LANGUECHANSON VALUES('br',7920,'t');
INSERT INTO LANGUECHANSON VALUES('br',7921,'t');
INSERT INTO LANGUECHANSON VALUES('br',7922,'t');
INSERT INTO LANGUECHANSON VALUES('br',7923,'t');
INSERT INTO LANGUECHANSON VALUES('br',7924,'t');
INSERT INTO LANGUECHANSON VALUES('br',7925,'t');
INSERT INTO LANGUECHANSON VALUES('br',7926,'t');
INSERT INTO LANGUECHANSON VALUES('br',7927,'t');
INSERT INTO LANGUECHANSON VALUES('br',7928,'t');
INSERT INTO LANGUECHANSON VALUES('br',7929,'t');
INSERT INTO LANGUECHANSON VALUES('br',7930,'t');
INSERT INTO LANGUECHANSON VALUES('br',7931,'t');
INSERT INTO LANGUECHANSON VALUES('br',7932,'t');
INSERT INTO LANGUECHANSON VALUES('br',7933,'t');
INSERT INTO LANGUECHANSON VALUES('br',7934,'t');
INSERT INTO LANGUECHANSON VALUES('br',7935,'t');
INSERT INTO LANGUECHANSON VALUES('br',7936,'t');
INSERT INTO LANGUECHANSON VALUES('br',7937,'t');
INSERT INTO LANGUECHANSON VALUES('br',7938,'t');
INSERT INTO LANGUECHANSON VALUES('br',7939,'t');
INSERT INTO LANGUECHANSON VALUES('br',7940,'t');
INSERT INTO LANGUECHANSON VALUES('br',7941,'t');
INSERT INTO LANGUECHANSON VALUES('br',7942,'t');
INSERT INTO LANGUECHANSON VALUES('br',7943,'t');
INSERT INTO LANGUECHANSON VALUES('br',7944,'t');
INSERT INTO LANGUECHANSON VALUES('br',7945,'t');
INSERT INTO LANGUECHANSON VALUES('br',7946,'t');
INSERT INTO LANGUECHANSON VALUES('br',7947,'t');
INSERT INTO LANGUECHANSON VALUES('br',7948,'t');
INSERT INTO LANGUECHANSON VALUES('br',7949,'t');
INSERT INTO LANGUECHANSON VALUES('br',7950,'t');
INSERT INTO LANGUECHANSON VALUES('br',7951,'t');
INSERT INTO LANGUECHANSON VALUES('br',7952,'t');
INSERT INTO LANGUECHANSON VALUES('br',7953,'t');
INSERT INTO LANGUECHANSON VALUES('br',7954,'t');
INSERT INTO LANGUECHANSON VALUES('br',7955,'t');
INSERT INTO LANGUECHANSON VALUES('br',7956,'t');
INSERT INTO LANGUECHANSON VALUES('br',7957,'t');
INSERT INTO LANGUECHANSON VALUES('br',7958,'t');
INSERT INTO LANGUECHANSON VALUES('br',7959,'t');
INSERT INTO LANGUECHANSON VALUES('br',7960,'t');
INSERT INTO LANGUECHANSON VALUES('br',7961,'t');
INSERT INTO LANGUECHANSON VALUES('br',7962,'t');
INSERT INTO LANGUECHANSON VALUES('br',7963,'t');
INSERT INTO LANGUECHANSON VALUES('br',7964,'t');
INSERT INTO LANGUECHANSON VALUES('br',7965,'t');
INSERT INTO LANGUECHANSON VALUES('br',7966,'t');
INSERT INTO LANGUECHANSON VALUES('br',7967,'t');
INSERT INTO LANGUECHANSON VALUES('br',7968,'t');
INSERT INTO LANGUECHANSON VALUES('br',7969,'t');
INSERT INTO LANGUECHANSON VALUES('br',7970,'t');
INSERT INTO LANGUECHANSON VALUES('br',7971,'t');
INSERT INTO LANGUECHANSON VALUES('br',7972,'t');
INSERT INTO LANGUECHANSON VALUES('br',7973,'t');
INSERT INTO LANGUECHANSON VALUES('br',7974,'t');
INSERT INTO LANGUECHANSON VALUES('br',7975,'t');
INSERT INTO LANGUECHANSON VALUES('br',7976,'t');
INSERT INTO LANGUECHANSON VALUES('br',7977,'t');
INSERT INTO LANGUECHANSON VALUES('br',7978,'t');
INSERT INTO LANGUECHANSON VALUES('br',7979,'t');
INSERT INTO LANGUECHANSON VALUES('br',7980,'t');
INSERT INTO LANGUECHANSON VALUES('br',7985,'t');
INSERT INTO LANGUECHANSON VALUES('br',7986,'t');
INSERT INTO LANGUECHANSON VALUES('br',7987,'t');
INSERT INTO LANGUECHANSON VALUES('br',8003,'t');
INSERT INTO LANGUECHANSON VALUES('br',8004,'t');
INSERT INTO LANGUECHANSON VALUES('br',8005,'t');
INSERT INTO LANGUECHANSON VALUES('br',8006,'t');
INSERT INTO LANGUECHANSON VALUES('br',8007,'t');
INSERT INTO LANGUECHANSON VALUES('br',8008,'t');
INSERT INTO LANGUECHANSON VALUES('br',8009,'t');
INSERT INTO LANGUECHANSON VALUES('br',8010,'t');
INSERT INTO LANGUECHANSON VALUES('br',8011,'t');
INSERT INTO LANGUECHANSON VALUES('br',8012,'t');
INSERT INTO LANGUECHANSON VALUES('br',8013,'t');
INSERT INTO LANGUECHANSON VALUES('br',8014,'t');
INSERT INTO LANGUECHANSON VALUES('br',8015,'t');
INSERT INTO LANGUECHANSON VALUES('br',8016,'t');
INSERT INTO LANGUECHANSON VALUES('br',8017,'t');
INSERT INTO LANGUECHANSON VALUES('br',8018,'t');
INSERT INTO LANGUECHANSON VALUES('br',8019,'t');
INSERT INTO LANGUECHANSON VALUES('br',8020,'t');
INSERT INTO LANGUECHANSON VALUES('br',8021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8022,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8024,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8027,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8028,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8029,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8031,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8032,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8033,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8034,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8035,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8036,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8037,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8038,'t');
INSERT INTO LANGUECHANSON VALUES('en',8039,'t');
INSERT INTO LANGUECHANSON VALUES('en',8040,'t');
INSERT INTO LANGUECHANSON VALUES('en',8041,'t');
INSERT INTO LANGUECHANSON VALUES('en',8042,'t');
INSERT INTO LANGUECHANSON VALUES('en',8043,'t');
INSERT INTO LANGUECHANSON VALUES('en',8044,'t');
INSERT INTO LANGUECHANSON VALUES('en',8045,'t');
INSERT INTO LANGUECHANSON VALUES('en',8046,'t');
INSERT INTO LANGUECHANSON VALUES('en',8047,'t');
INSERT INTO LANGUECHANSON VALUES('br',8060,'t');
INSERT INTO LANGUECHANSON VALUES('br',8061,'t');
INSERT INTO LANGUECHANSON VALUES('br',8062,'t');
INSERT INTO LANGUECHANSON VALUES('br',8063,'t');
INSERT INTO LANGUECHANSON VALUES('br',8064,'t');
INSERT INTO LANGUECHANSON VALUES('br',8065,'t');
INSERT INTO LANGUECHANSON VALUES('br',8066,'t');
INSERT INTO LANGUECHANSON VALUES('br',8067,'t');
INSERT INTO LANGUECHANSON VALUES('br',8068,'t');
INSERT INTO LANGUECHANSON VALUES('br',8069,'t');
INSERT INTO LANGUECHANSON VALUES('br',8070,'t');
INSERT INTO LANGUECHANSON VALUES('br',8071,'t');
INSERT INTO LANGUECHANSON VALUES('br',8072,'t');
INSERT INTO LANGUECHANSON VALUES('br',8073,'t');
INSERT INTO LANGUECHANSON VALUES('br',8084,'t');
INSERT INTO LANGUECHANSON VALUES('br',8085,'t');
INSERT INTO LANGUECHANSON VALUES('br',8086,'t');
INSERT INTO LANGUECHANSON VALUES('br',8087,'t');
INSERT INTO LANGUECHANSON VALUES('br',8088,'t');
INSERT INTO LANGUECHANSON VALUES('br',8089,'t');
INSERT INTO LANGUECHANSON VALUES('br',8090,'t');
INSERT INTO LANGUECHANSON VALUES('br',8091,'t');
INSERT INTO LANGUECHANSON VALUES('br',8092,'t');
INSERT INTO LANGUECHANSON VALUES('br',8093,'t');
INSERT INTO LANGUECHANSON VALUES('br',8094,'t');
INSERT INTO LANGUECHANSON VALUES('br',8095,'t');
INSERT INTO LANGUECHANSON VALUES('br',8096,'t');
INSERT INTO LANGUECHANSON VALUES('br',8097,'t');
INSERT INTO LANGUECHANSON VALUES('en',8099,'t');
INSERT INTO LANGUECHANSON VALUES('en',8100,'t');
INSERT INTO LANGUECHANSON VALUES('en',8101,'t');
INSERT INTO LANGUECHANSON VALUES('en',8102,'t');
INSERT INTO LANGUECHANSON VALUES('en',8103,'t');
INSERT INTO LANGUECHANSON VALUES('en',8104,'t');
INSERT INTO LANGUECHANSON VALUES('en',8105,'t');
INSERT INTO LANGUECHANSON VALUES('en',8106,'t');
INSERT INTO LANGUECHANSON VALUES('en',8107,'t');
INSERT INTO LANGUECHANSON VALUES('en',8108,'t');
INSERT INTO LANGUECHANSON VALUES('en',8109,'t');
INSERT INTO LANGUECHANSON VALUES('en',8110,'t');
INSERT INTO LANGUECHANSON VALUES('en',8113,'t');
INSERT INTO LANGUECHANSON VALUES('en',8114,'t');
INSERT INTO LANGUECHANSON VALUES('en',8115,'t');
INSERT INTO LANGUECHANSON VALUES('en',8116,'t');
INSERT INTO LANGUECHANSON VALUES('en',8117,'t');
INSERT INTO LANGUECHANSON VALUES('en',8118,'t');
INSERT INTO LANGUECHANSON VALUES('en',8119,'t');
INSERT INTO LANGUECHANSON VALUES('en',8120,'t');
INSERT INTO LANGUECHANSON VALUES('en',8121,'t');
INSERT INTO LANGUECHANSON VALUES('en',8122,'t');
INSERT INTO LANGUECHANSON VALUES('en',8123,'t');
INSERT INTO LANGUECHANSON VALUES('en',8124,'t');
INSERT INTO LANGUECHANSON VALUES('en',8125,'t');
INSERT INTO LANGUECHANSON VALUES('en',8126,'t');
INSERT INTO LANGUECHANSON VALUES('en',8127,'t');
INSERT INTO LANGUECHANSON VALUES('en',8128,'t');
INSERT INTO LANGUECHANSON VALUES('en',8129,'t');
INSERT INTO LANGUECHANSON VALUES('en',8141,'t');
INSERT INTO LANGUECHANSON VALUES('en',8142,'t');
INSERT INTO LANGUECHANSON VALUES('en',8143,'t');
INSERT INTO LANGUECHANSON VALUES('en',8144,'t');
INSERT INTO LANGUECHANSON VALUES('en',8145,'t');
INSERT INTO LANGUECHANSON VALUES('en',8146,'t');
INSERT INTO LANGUECHANSON VALUES('en',8147,'t');
INSERT INTO LANGUECHANSON VALUES('en',8148,'t');
INSERT INTO LANGUECHANSON VALUES('en',8150,'t');
INSERT INTO LANGUECHANSON VALUES('br',8151,'t');
INSERT INTO LANGUECHANSON VALUES('br',8152,'t');
INSERT INTO LANGUECHANSON VALUES('br',8153,'t');
INSERT INTO LANGUECHANSON VALUES('br',8154,'t');
INSERT INTO LANGUECHANSON VALUES('br',8156,'t');
INSERT INTO LANGUECHANSON VALUES('br',8157,'t');
INSERT INTO LANGUECHANSON VALUES('br',8158,'t');
INSERT INTO LANGUECHANSON VALUES('br',8159,'t');
INSERT INTO LANGUECHANSON VALUES('br',8160,'t');
INSERT INTO LANGUECHANSON VALUES('br',8161,'t');
INSERT INTO LANGUECHANSON VALUES('br',8162,'t');
INSERT INTO LANGUECHANSON VALUES('br',8164,'t');
INSERT INTO LANGUECHANSON VALUES('br',8165,'t');
INSERT INTO LANGUECHANSON VALUES('br',8166,'t');
INSERT INTO LANGUECHANSON VALUES('br',8167,'t');
INSERT INTO LANGUECHANSON VALUES('br',8168,'t');
INSERT INTO LANGUECHANSON VALUES('br',8173,'t');
INSERT INTO LANGUECHANSON VALUES('br',8178,'t');
INSERT INTO LANGUECHANSON VALUES('br',8181,'t');
INSERT INTO LANGUECHANSON VALUES('en',8188,'t');
INSERT INTO LANGUECHANSON VALUES('en',8189,'t');
INSERT INTO LANGUECHANSON VALUES('en',8191,'t');
INSERT INTO LANGUECHANSON VALUES('en',8193,'t');
INSERT INTO LANGUECHANSON VALUES('en',8195,'t');
INSERT INTO LANGUECHANSON VALUES('en',8196,'t');
INSERT INTO LANGUECHANSON VALUES('en',8197,'t');
INSERT INTO LANGUECHANSON VALUES('en',8198,'t');
INSERT INTO LANGUECHANSON VALUES('en',8199,'t');
INSERT INTO LANGUECHANSON VALUES('en',8200,'t');
INSERT INTO LANGUECHANSON VALUES('en',8201,'t');
INSERT INTO LANGUECHANSON VALUES('en',8202,'t');
INSERT INTO LANGUECHANSON VALUES('en',8203,'t');
INSERT INTO LANGUECHANSON VALUES('en',8204,'t');
INSERT INTO LANGUECHANSON VALUES('en',8205,'t');
INSERT INTO LANGUECHANSON VALUES('en',8206,'t');
INSERT INTO LANGUECHANSON VALUES('en',8207,'t');
INSERT INTO LANGUECHANSON VALUES('en',8208,'t');
INSERT INTO LANGUECHANSON VALUES('en',8209,'t');
INSERT INTO LANGUECHANSON VALUES('en',8210,'t');
INSERT INTO LANGUECHANSON VALUES('en',8211,'t');
INSERT INTO LANGUECHANSON VALUES('en',8212,'t');
INSERT INTO LANGUECHANSON VALUES('en',8213,'t');
INSERT INTO LANGUECHANSON VALUES('en',8214,'t');
INSERT INTO LANGUECHANSON VALUES('en',8215,'t');
INSERT INTO LANGUECHANSON VALUES('br',8225,'t');
INSERT INTO LANGUECHANSON VALUES('br',8226,'t');
INSERT INTO LANGUECHANSON VALUES('br',8228,'t');
INSERT INTO LANGUECHANSON VALUES('br',8231,'t');
INSERT INTO LANGUECHANSON VALUES('br',8232,'t');
INSERT INTO LANGUECHANSON VALUES('br',8238,'t');
INSERT INTO LANGUECHANSON VALUES('br',8242,'t');
INSERT INTO LANGUECHANSON VALUES('br',8243,'t');
INSERT INTO LANGUECHANSON VALUES('br',8227,'t');
INSERT INTO LANGUECHANSON VALUES('br',8229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8306,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8307,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8308,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8309,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8310,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8311,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8312,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8313,'t');
INSERT INTO LANGUECHANSON VALUES('en',8366,'t');
INSERT INTO LANGUECHANSON VALUES('en',8367,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8368,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8369,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8370,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8371,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8372,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8373,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8374,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8375,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8376,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8377,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8378,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8379,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8380,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8381,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8382,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8384,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8385,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8386,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8387,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8388,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8389,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8390,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8391,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8392,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8393,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8394,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8395,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8396,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8397,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8399,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8407,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8408,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8409,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8410,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8411,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8412,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8413,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8414,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8415,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8416,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8417,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8418,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8420,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8421,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8422,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8423,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8426,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8440,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8442,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8443,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8444,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8445,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8446,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8447,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8448,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8449,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8450,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8477,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8479,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8480,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8483,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8484,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8485,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8486,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8487,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8488,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8489,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8490,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8493,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8494,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8495,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8496,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8497,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8498,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8499,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8500,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8501,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8502,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8503,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8504,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8505,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8506,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8507,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8508,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8509,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8511,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8512,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8513,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8514,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8515,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8516,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8517,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8519,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8520,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8521,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8522,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8524,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8526,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8528,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8529,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8533,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8542,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8543,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8544,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8545,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8546,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8547,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8548,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8549,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8550,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8551,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8552,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8553,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8554,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8555,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8556,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8557,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8558,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8559,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8560,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8561,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8562,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8563,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8564,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7132,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8611,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8612,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8613,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8614,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8615,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8616,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8617,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8618,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8619,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8620,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8621,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8624,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8626,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8627,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8629,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8630,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8631,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8641,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8642,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8643,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8644,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8645,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8646,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8647,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8648,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8649,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8650,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8651,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8652,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8653,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8654,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8655,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8656,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8657,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8658,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8659,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8660,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8661,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8662,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8663,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8664,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8665,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8666,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8667,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8668,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8669,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8670,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8671,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8672,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8673,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8674,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8675,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8677,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8679,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8681,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8683,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8685,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8687,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8688,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8689,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8690,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8691,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8692,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8693,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8694,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8695,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8696,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8697,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8698,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8699,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8700,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8701,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8702,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8703,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8704,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8705,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8706,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8707,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8708,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8709,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8710,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8711,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8712,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8713,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8714,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8715,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8716,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8717,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8718,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8719,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8720,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8721,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8722,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8723,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8724,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8725,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8749,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8750,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8751,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8752,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8753,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8754,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8755,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8756,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8757,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8758,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8759,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8760,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8767,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8771,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8774,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8776,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8778,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8780,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8781,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8782,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8786,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8787,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8799,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8800,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8801,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8802,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8804,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8805,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8806,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8807,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8808,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8809,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8811,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8812,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8813,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8814,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8815,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8816,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8817,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8818,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8819,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8820,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8822,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8823,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8824,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8825,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8826,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8827,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8828,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8829,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8830,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8831,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8832,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8833,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8834,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8835,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8837,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8838,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8839,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8840,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8841,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8842,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8843,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8844,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8845,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8846,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8847,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8850,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8851,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8852,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8853,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8857,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8859,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8860,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8862,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8863,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8864,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8865,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8866,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8867,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8868,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8869,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8870,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8872,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8873,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8874,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8875,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8876,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8877,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8878,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8879,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8880,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8881,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8882,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8883,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8884,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8885,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8886,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8887,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8888,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8889,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8890,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8891,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8892,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8894,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8896,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8897,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8899,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8901,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8902,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8903,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8904,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8905,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8906,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8907,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8908,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8909,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8910,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8911,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8912,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8913,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8914,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8915,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8916,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8917,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8919,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8920,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8921,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8922,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8923,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8924,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8925,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8926,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8935,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8936,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8942,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8943,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8944,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8945,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8946,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8947,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8948,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8949,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8950,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8951,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8952,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8953,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8954,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8955,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8956,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8957,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8958,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8959,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8961,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8861,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8963,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8964,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8965,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8969,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8970,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8971,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8966,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8973,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8974,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8975,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8977,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8978,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8979,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8980,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8982,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8983,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8984,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8985,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8986,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8987,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8988,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8989,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8990,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8991,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8994,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8995,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8992,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8998,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9001,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9004,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9013,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9026,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9044,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9045,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9046,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9047,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9048,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9049,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9050,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9051,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9052,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9053,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9054,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9064,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9066,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9067,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9068,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9071,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9073,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9078,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9079,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9080,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9081,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9082,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9092,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9095,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9097,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9098,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9099,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9100,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9101,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9102,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9103,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9104,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9105,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9106,'t');
INSERT INTO LANGUECHANSON VALUES('nl',9107,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9109,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9112,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9126,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9127,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9128,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9131,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9134,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9135,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9136,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9137,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9138,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9139,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9140,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9141,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9142,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9143,'t');
INSERT INTO LANGUECHANSON VALUES('fn',9144,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9145,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9146,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9147,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9148,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9149,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9150,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9151,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9152,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9153,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9154,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9155,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9156,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9157,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9158,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9159,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9160,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9161,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9162,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9163,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9164,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9165,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9166,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9167,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9168,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9169,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9170,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9171,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9172,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9173,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9174,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9179,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9181,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9183,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9184,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9185,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9186,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9187,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9188,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9189,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9190,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9191,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9193,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9194,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9195,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9196,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9197,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9198,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9199,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9200,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9201,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9202,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9203,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9204,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9205,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9206,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9207,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9208,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9209,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9210,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9211,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9212,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9213,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9214,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9219,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9230,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9231,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9239,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9244,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9225,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9222,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9246,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9245,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9249,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9256,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9258,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9259,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9260,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9261,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9262,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9263,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9264,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9265,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9266,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9267,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9269,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9270,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9271,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9272,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9273,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9274,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9275,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9276,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9277,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9278,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9279,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9280,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9281,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9305,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9306,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9318,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9319,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9330,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9331,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9332,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9333,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9334,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9335,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9336,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9337,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9338,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8535,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7304,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9339,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9340,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9341,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9342,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9343,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9344,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9353,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9355,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9356,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9357,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9360,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9364,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9365,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9366,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9367,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9368,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9369,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9370,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9371,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9372,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9373,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9374,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9375,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9376,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9377,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9378,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9379,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9380,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9381,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9382,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9383,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9384,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9385,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9387,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9388,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9389,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9390,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9391,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9392,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9393,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9394,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9395,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9396,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9397,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9398,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9399,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9400,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9401,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9402,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9405,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9406,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9407,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9408,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9409,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9420,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9426,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9448,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9449,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9450,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9494,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9495,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9496,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9497,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9498,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9499,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9500,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9501,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9502,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9503,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9504,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9505,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9506,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9507,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9508,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9509,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9510,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9511,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9512,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9513,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9514,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9515,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9517,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9519,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9520,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9521,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9522,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9443,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9529,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9530,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9531,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9532,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9533,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9534,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9535,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9536,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9537,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9538,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9539,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9542,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9545,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9548,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9549,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9552,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9553,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9551,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9554,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9557,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9559,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9556,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9599,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9600,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9601,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9602,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9603,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9604,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9605,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9606,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9607,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9608,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9609,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9610,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9611,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9612,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9616,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9617,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9619,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9620,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9621,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9624,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9626,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9627,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9630,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9631,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9634,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9636,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9640,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9642,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9643,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9644,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9645,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9646,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9647,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9648,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9649,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9650,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9651,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9652,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9654,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9655,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9656,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9657,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9658,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9659,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9660,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9661,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9662,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9665,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9666,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9668,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9669,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9670,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9671,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9672,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9673,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9675,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9677,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9678,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9679,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9680,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9681,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9682,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9683,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9685,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9687,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9688,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9689,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9690,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9691,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9692,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9693,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9694,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9695,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9696,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9697,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9698,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9699,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9700,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9701,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9702,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9703,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9704,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9705,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9706,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9707,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9708,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9710,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9711,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9714,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9715,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9718,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9719,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9721,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9722,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9723,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9724,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9725,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9726,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9727,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9728,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9729,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9730,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9731,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9732,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9733,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9734,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9735,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9736,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9737,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9738,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9739,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9741,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9742,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9743,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9744,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9745,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9746,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9747,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9748,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9749,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9750,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9751,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9752,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9753,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9754,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9755,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9756,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9757,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9758,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9759,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9760,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9761,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9762,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9763,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9764,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9765,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9766,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9767,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9768,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9769,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9770,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9771,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9772,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9773,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9774,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9775,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9776,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9778,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9779,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9780,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9781,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9783,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9784,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9785,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9786,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9787,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9788,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9789,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9790,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9791,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9792,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9793,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9795,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9796,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9797,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9798,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9799,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9800,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9801,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9802,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9804,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9805,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9806,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9807,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9808,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9809,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9811,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9814,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9816,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9818,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9819,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9820,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9824,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9828,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9829,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9830,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9831,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9832,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9833,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9834,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9835,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9845,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9846,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9847,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9850,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9851,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9852,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9853,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9854,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9856,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9857,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9858,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9859,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9860,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9861,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9862,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9863,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9864,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9865,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9866,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9867,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9868,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9869,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9870,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9871,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9872,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9873,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9874,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9875,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9876,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9899,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9901,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9902,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9903,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9904,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9905,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9906,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9907,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9908,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9909,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9910,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9911,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9912,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9913,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9914,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9915,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9916,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9917,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9918,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9919,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9920,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9921,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9922,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9923,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9925,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9926,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9927,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9928,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9929,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9930,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9931,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9932,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9933,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9934,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9935,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9941,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9942,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9943,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9944,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9945,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9946,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9947,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9948,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9949,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9950,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9951,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9952,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9953,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9954,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9955,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9956,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9958,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9959,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9960,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9961,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9962,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9963,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9964,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9965,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9966,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9967,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9968,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9969,'t');
INSERT INTO LANGUECHANSON VALUES('en',9973,'t');
INSERT INTO LANGUECHANSON VALUES('en',9974,'t');
INSERT INTO LANGUECHANSON VALUES('en',9977,'t');
INSERT INTO LANGUECHANSON VALUES('en',9978,'t');
INSERT INTO LANGUECHANSON VALUES('en',9979,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9980,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9982,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9983,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9984,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9986,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9987,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9988,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9989,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9990,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9991,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9992,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9993,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9994,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9996,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9997,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9998,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10000,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10001,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10002,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10003,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10004,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10006,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10007,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10008,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10009,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10011,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10015,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10016,'t');
INSERT INTO LANGUECHANSON VALUES('en',10018,'t');
INSERT INTO LANGUECHANSON VALUES('en',10019,'t');
INSERT INTO LANGUECHANSON VALUES('en',10022,'t');
INSERT INTO LANGUECHANSON VALUES('en',10025,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11571,'t');
INSERT INTO LANGUECHANSON VALUES('en',10028,'t');
INSERT INTO LANGUECHANSON VALUES('en',10029,'t');
INSERT INTO LANGUECHANSON VALUES('en',10031,'t');
INSERT INTO LANGUECHANSON VALUES('en',10032,'t');
INSERT INTO LANGUECHANSON VALUES('en',10034,'t');
INSERT INTO LANGUECHANSON VALUES('en',10035,'t');
INSERT INTO LANGUECHANSON VALUES('en',10036,'t');
INSERT INTO LANGUECHANSON VALUES('en',10037,'t');
INSERT INTO LANGUECHANSON VALUES('en',10038,'t');
INSERT INTO LANGUECHANSON VALUES('en',10039,'t');
INSERT INTO LANGUECHANSON VALUES('en',10040,'t');
INSERT INTO LANGUECHANSON VALUES('en',10041,'t');
INSERT INTO LANGUECHANSON VALUES('en',10042,'t');
INSERT INTO LANGUECHANSON VALUES('en',10043,'t');
INSERT INTO LANGUECHANSON VALUES('en',10044,'t');
INSERT INTO LANGUECHANSON VALUES('en',10045,'t');
INSERT INTO LANGUECHANSON VALUES('en',10046,'t');
INSERT INTO LANGUECHANSON VALUES('en',10047,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10051,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10052,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10053,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10054,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10055,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10056,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10057,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10058,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10060,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10061,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10062,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10050,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10059,'t');
INSERT INTO LANGUECHANSON VALUES('en',10188,'t');
INSERT INTO LANGUECHANSON VALUES('en',10189,'t');
INSERT INTO LANGUECHANSON VALUES('en',10190,'t');
INSERT INTO LANGUECHANSON VALUES('en',10191,'t');
INSERT INTO LANGUECHANSON VALUES('en',10192,'t');
INSERT INTO LANGUECHANSON VALUES('en',10193,'t');
INSERT INTO LANGUECHANSON VALUES('en',10194,'t');
INSERT INTO LANGUECHANSON VALUES('en',10195,'t');
INSERT INTO LANGUECHANSON VALUES('en',10196,'t');
INSERT INTO LANGUECHANSON VALUES('en',10197,'t');
INSERT INTO LANGUECHANSON VALUES('en',10198,'t');
INSERT INTO LANGUECHANSON VALUES('en',10199,'t');
INSERT INTO LANGUECHANSON VALUES('en',10200,'t');
INSERT INTO LANGUECHANSON VALUES('en',10201,'t');
INSERT INTO LANGUECHANSON VALUES('en',10202,'t');
INSERT INTO LANGUECHANSON VALUES('en',10203,'t');
INSERT INTO LANGUECHANSON VALUES('en',10204,'t');
INSERT INTO LANGUECHANSON VALUES('en',10205,'t');
INSERT INTO LANGUECHANSON VALUES('en',10225,'t');
INSERT INTO LANGUECHANSON VALUES('en',10226,'t');
INSERT INTO LANGUECHANSON VALUES('en',10227,'t');
INSERT INTO LANGUECHANSON VALUES('en',10228,'t');
INSERT INTO LANGUECHANSON VALUES('en',10229,'t');
INSERT INTO LANGUECHANSON VALUES('en',10230,'t');
INSERT INTO LANGUECHANSON VALUES('en',10231,'t');
INSERT INTO LANGUECHANSON VALUES('en',10232,'t');
INSERT INTO LANGUECHANSON VALUES('en',10233,'t');
INSERT INTO LANGUECHANSON VALUES('en',10234,'t');
INSERT INTO LANGUECHANSON VALUES('en',10235,'t');
INSERT INTO LANGUECHANSON VALUES('en',10236,'t');
INSERT INTO LANGUECHANSON VALUES('en',10237,'t');
INSERT INTO LANGUECHANSON VALUES('en',10238,'t');
INSERT INTO LANGUECHANSON VALUES('en',10239,'t');
INSERT INTO LANGUECHANSON VALUES('en',10240,'t');
INSERT INTO LANGUECHANSON VALUES('en',10241,'t');
INSERT INTO LANGUECHANSON VALUES('en',10242,'t');
INSERT INTO LANGUECHANSON VALUES('en',10243,'t');
INSERT INTO LANGUECHANSON VALUES('en',10367,'t');
INSERT INTO LANGUECHANSON VALUES('en',10368,'t');
INSERT INTO LANGUECHANSON VALUES('en',10375,'t');
INSERT INTO LANGUECHANSON VALUES('en',10378,'t');
INSERT INTO LANGUECHANSON VALUES('en',10379,'t');
INSERT INTO LANGUECHANSON VALUES('en',10380,'t');
INSERT INTO LANGUECHANSON VALUES('en',10381,'t');
INSERT INTO LANGUECHANSON VALUES('en',10382,'t');
INSERT INTO LANGUECHANSON VALUES('en',10384,'t');
INSERT INTO LANGUECHANSON VALUES('en',10385,'t');
INSERT INTO LANGUECHANSON VALUES('en',10386,'t');
INSERT INTO LANGUECHANSON VALUES('en',10387,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10413,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10414,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10415,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10416,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10417,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10418,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10419,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10420,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10421,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10422,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10423,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10424,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10425,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10426,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10427,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10428,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10430,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10431,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10441,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10442,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10443,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10444,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10445,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10446,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10447,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10448,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10449,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10450,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10451,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10452,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10468,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10469,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10470,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10473,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10464,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10474,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10476,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10477,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10478,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10479,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10480,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10481,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10482,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10483,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10485,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10486,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10487,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10488,'t');
INSERT INTO LANGUECHANSON VALUES('en',10508,'t');
INSERT INTO LANGUECHANSON VALUES('en',10510,'t');
INSERT INTO LANGUECHANSON VALUES('en',10511,'t');
INSERT INTO LANGUECHANSON VALUES('en',10512,'t');
INSERT INTO LANGUECHANSON VALUES('en',10513,'t');
INSERT INTO LANGUECHANSON VALUES('en',10514,'t');
INSERT INTO LANGUECHANSON VALUES('en',10516,'t');
INSERT INTO LANGUECHANSON VALUES('en',10648,'t');
INSERT INTO LANGUECHANSON VALUES('en',10649,'t');
INSERT INTO LANGUECHANSON VALUES('en',10650,'t');
INSERT INTO LANGUECHANSON VALUES('en',10651,'t');
INSERT INTO LANGUECHANSON VALUES('en',10652,'t');
INSERT INTO LANGUECHANSON VALUES('en',10653,'t');
INSERT INTO LANGUECHANSON VALUES('en',10654,'t');
INSERT INTO LANGUECHANSON VALUES('en',10655,'t');
INSERT INTO LANGUECHANSON VALUES('en',10657,'t');
INSERT INTO LANGUECHANSON VALUES('en',10658,'t');
INSERT INTO LANGUECHANSON VALUES('en',10659,'t');
INSERT INTO LANGUECHANSON VALUES('en',10660,'t');
INSERT INTO LANGUECHANSON VALUES('en',10661,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10684,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10686,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10687,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10688,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10689,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10690,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10691,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10692,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10694,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10695,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10696,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10697,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10699,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10700,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10702,'t');
INSERT INTO LANGUECHANSON VALUES('en',2195,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10685,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10818,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10819,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10822,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10823,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10894,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10895,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10896,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10899,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10903,'t');
INSERT INTO LANGUECHANSON VALUES('en',10915,'t');
INSERT INTO LANGUECHANSON VALUES('en',10916,'t');
INSERT INTO LANGUECHANSON VALUES('en',10917,'t');
INSERT INTO LANGUECHANSON VALUES('en',10918,'t');
INSERT INTO LANGUECHANSON VALUES('en',10919,'t');
INSERT INTO LANGUECHANSON VALUES('en',10920,'t');
INSERT INTO LANGUECHANSON VALUES('en',10921,'t');
INSERT INTO LANGUECHANSON VALUES('en',10922,'t');
INSERT INTO LANGUECHANSON VALUES('en',10927,'t');
INSERT INTO LANGUECHANSON VALUES('en',10947,'t');
INSERT INTO LANGUECHANSON VALUES('en',10948,'t');
INSERT INTO LANGUECHANSON VALUES('en',10949,'t');
INSERT INTO LANGUECHANSON VALUES('en',10950,'t');
INSERT INTO LANGUECHANSON VALUES('en',10951,'t');
INSERT INTO LANGUECHANSON VALUES('en',10952,'t');
INSERT INTO LANGUECHANSON VALUES('en',10953,'t');
INSERT INTO LANGUECHANSON VALUES('en',10954,'t');
INSERT INTO LANGUECHANSON VALUES('en',10955,'t');
INSERT INTO LANGUECHANSON VALUES('en',10956,'t');
INSERT INTO LANGUECHANSON VALUES('en',10957,'t');
INSERT INTO LANGUECHANSON VALUES('en',10958,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10960,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10961,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10962,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10963,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10964,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10965,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10966,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10968,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10969,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10970,'t');
INSERT INTO LANGUECHANSON VALUES('en',1418,'t');
INSERT INTO LANGUECHANSON VALUES('en',3336,'t');
INSERT INTO LANGUECHANSON VALUES('en',2251,'t');
INSERT INTO LANGUECHANSON VALUES('en',2633,'t');
INSERT INTO LANGUECHANSON VALUES('en',2043,'t');
INSERT INTO LANGUECHANSON VALUES('en',5039,'t');
INSERT INTO LANGUECHANSON VALUES('en',6552,'t');
INSERT INTO LANGUECHANSON VALUES('en',1272,'t');
INSERT INTO LANGUECHANSON VALUES('en',2192,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7321,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1308,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1461,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1938,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2162,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2219,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2221,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2239,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2245,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2268,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2857,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3285,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3403,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3404,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4229,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4533,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4794,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4855,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4898,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4979,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5396,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5777,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5780,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5828,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5964,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5968,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5970,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5975,'t');
INSERT INTO LANGUECHANSON VALUES('br',6682,'t');
INSERT INTO LANGUECHANSON VALUES('br',6980,'t');
INSERT INTO LANGUECHANSON VALUES('br',7092,'t');
INSERT INTO LANGUECHANSON VALUES('br',7095,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7312,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7314,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7324,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7326,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7331,'t');
INSERT INTO LANGUECHANSON VALUES('br',7358,'t');
INSERT INTO LANGUECHANSON VALUES('br',7416,'t');
INSERT INTO LANGUECHANSON VALUES('br',7465,'t');
INSERT INTO LANGUECHANSON VALUES('br',7629,'t');
INSERT INTO LANGUECHANSON VALUES('br',7656,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8518,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8536,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8538,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8530,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8540,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8960,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8962,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8993,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9002,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9003,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8999,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9018,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9021,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9055,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9070,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9108,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9110,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9113,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9116,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9117,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9217,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9232,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9247,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9248,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9250,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9251,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9253,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9440,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9441,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9442,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9558,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9562,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10892,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10893,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10897,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10900,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10901,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10902,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10959,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10971,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4827,'t');
INSERT INTO LANGUECHANSON VALUES('en',3226,'t');
INSERT INTO LANGUECHANSON VALUES('en',1115,'t');
INSERT INTO LANGUECHANSON VALUES('en',3677,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10484,'t');
INSERT INTO LANGUECHANSON VALUES('en',4493,'t');
INSERT INTO LANGUECHANSON VALUES('en',4499,'t');
INSERT INTO LANGUECHANSON VALUES('en',2646,'t');
INSERT INTO LANGUECHANSON VALUES('en',4414,'t');
INSERT INTO LANGUECHANSON VALUES('en',4213,'t');
INSERT INTO LANGUECHANSON VALUES('en',4310,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4908,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4840,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4802,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4807,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4843,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4834,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4804,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4830,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4800,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4821,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4823,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4820,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4826,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4925,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4926,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4809,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4817,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4930,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4812,'t');
INSERT INTO LANGUECHANSON VALUES('en',1803,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5611,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5608,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5603,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5606,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5607,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5610,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5600,'t');
INSERT INTO LANGUECHANSON VALUES('fr',5601,'t');
INSERT INTO LANGUECHANSON VALUES('en',2736,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3303,'t');
INSERT INTO LANGUECHANSON VALUES('en',1419,'t');
INSERT INTO LANGUECHANSON VALUES('en',2838,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4934,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4818,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4939,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4940,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4815,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4848,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4806,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4962,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4963,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4824,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4965,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4966,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4968,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4969,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6920,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4872,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6922,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6930,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6932,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6924,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7132,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7142,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7813,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7815,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7724,'t');
INSERT INTO LANGUECHANSON VALUES('en',2987,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7143,'t');
INSERT INTO LANGUECHANSON VALUES('en',1576,'t');
INSERT INTO LANGUECHANSON VALUES('en',1396,'t');
INSERT INTO LANGUECHANSON VALUES('en',2475,'t');
INSERT INTO LANGUECHANSON VALUES('en',2184,'t');
INSERT INTO LANGUECHANSON VALUES('br',7044,'t');
INSERT INTO LANGUECHANSON VALUES('br',7660,'t');
INSERT INTO LANGUECHANSON VALUES('en',2316,'t');
INSERT INTO LANGUECHANSON VALUES('en',5053,'t');
INSERT INTO LANGUECHANSON VALUES('en',4034,'t');
INSERT INTO LANGUECHANSON VALUES('en',4042,'t');
INSERT INTO LANGUECHANSON VALUES('en',1116,'t');
INSERT INTO LANGUECHANSON VALUES('en',1563,'t');
INSERT INTO LANGUECHANSON VALUES('en',3963,'t');
INSERT INTO LANGUECHANSON VALUES('en',3916,'t');
INSERT INTO LANGUECHANSON VALUES('en',1761,'t');
INSERT INTO LANGUECHANSON VALUES('en',2729,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8026,'t');
INSERT INTO LANGUECHANSON VALUES('en',3575,'t');
INSERT INTO LANGUECHANSON VALUES('en',3968,'t');
INSERT INTO LANGUECHANSON VALUES('en',1779,'t');
INSERT INTO LANGUECHANSON VALUES('en',2458,'t');
INSERT INTO LANGUECHANSON VALUES('en',5881,'t');
INSERT INTO LANGUECHANSON VALUES('en',1567,'t');
INSERT INTO LANGUECHANSON VALUES('en',2050,'t');
INSERT INTO LANGUECHANSON VALUES('en',3581,'t');
INSERT INTO LANGUECHANSON VALUES('en',3633,'t');
INSERT INTO LANGUECHANSON VALUES('en',2450,'t');
INSERT INTO LANGUECHANSON VALUES('en',1815,'t');
INSERT INTO LANGUECHANSON VALUES('en',3512,'t');
INSERT INTO LANGUECHANSON VALUES('en',3200,'t');
INSERT INTO LANGUECHANSON VALUES('en',1099,'t');
INSERT INTO LANGUECHANSON VALUES('en',3202,'t');
INSERT INTO LANGUECHANSON VALUES('en',10515,'t');
INSERT INTO LANGUECHANSON VALUES('en',3548,'t');
INSERT INTO LANGUECHANSON VALUES('en',6340,'t');
INSERT INTO LANGUECHANSON VALUES('en',2060,'t');
INSERT INTO LANGUECHANSON VALUES('en',3167,'t');
INSERT INTO LANGUECHANSON VALUES('en',3786,'t');
INSERT INTO LANGUECHANSON VALUES('en',1605,'t');
INSERT INTO LANGUECHANSON VALUES('en',1502,'t');
INSERT INTO LANGUECHANSON VALUES('en',5883,'t');
INSERT INTO LANGUECHANSON VALUES('en',2257,'t');
INSERT INTO LANGUECHANSON VALUES('en',1915,'t');
INSERT INTO LANGUECHANSON VALUES('en',6070,'t');
INSERT INTO LANGUECHANSON VALUES('en',1908,'t');
INSERT INTO LANGUECHANSON VALUES('en',5660,'t');
INSERT INTO LANGUECHANSON VALUES('en',4150,'t');
INSERT INTO LANGUECHANSON VALUES('en',3552,'t');
INSERT INTO LANGUECHANSON VALUES('en',3781,'t');
INSERT INTO LANGUECHANSON VALUES('en',5882,'t');
INSERT INTO LANGUECHANSON VALUES('en',1910,'t');
INSERT INTO LANGUECHANSON VALUES('en',1196,'t');
INSERT INTO LANGUECHANSON VALUES('en',2205,'t');
INSERT INTO LANGUECHANSON VALUES('en',5890,'t');
INSERT INTO LANGUECHANSON VALUES('en',1860,'t');
INSERT INTO LANGUECHANSON VALUES('en',4485,'t');
INSERT INTO LANGUECHANSON VALUES('en',1861,'t');
INSERT INTO LANGUECHANSON VALUES('en',4492,'t');
INSERT INTO LANGUECHANSON VALUES('en',4313,'t');
INSERT INTO LANGUECHANSON VALUES('en',1916,'t');
INSERT INTO LANGUECHANSON VALUES('en',5879,'t');
INSERT INTO LANGUECHANSON VALUES('en',2954,'t');
INSERT INTO LANGUECHANSON VALUES('en',3710,'t');
INSERT INTO LANGUECHANSON VALUES('en',3547,'t');
INSERT INTO LANGUECHANSON VALUES('en',1604,'t');
INSERT INTO LANGUECHANSON VALUES('en',191,'t');
INSERT INTO LANGUECHANSON VALUES('en',2906,'t');
INSERT INTO LANGUECHANSON VALUES('en',3541,'t');
INSERT INTO LANGUECHANSON VALUES('en',4147,'t');
INSERT INTO LANGUECHANSON VALUES('en',2739,'t');
INSERT INTO LANGUECHANSON VALUES('en',4157,'t');
INSERT INTO LANGUECHANSON VALUES('en',4161,'t');
INSERT INTO LANGUECHANSON VALUES('en',1977,'t');
INSERT INTO LANGUECHANSON VALUES('en',2077,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1442,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8997,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9023,'t');
INSERT INTO LANGUECHANSON VALUES('fr',8523,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9069,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9072,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7311,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9115,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7319,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7332,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7335,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9303,'t');
INSERT INTO LANGUECHANSON VALUES('fr',9709,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7134,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7137,'t');
INSERT INTO LANGUECHANSON VALUES('nl',6921,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7299,'t');
INSERT INTO LANGUECHANSON VALUES('nl',7810,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4890,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4970,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4816,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2536,'t');
INSERT INTO LANGUECHANSON VALUES('fr',4905,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10984,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10981,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10972,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10973,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10974,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10977,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10979,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10980,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10982,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10975,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10976,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10978,'t');
INSERT INTO LANGUECHANSON VALUES('fr',10983,'t');
INSERT INTO LANGUECHANSON VALUES('en',2405,'t');
INSERT INTO LANGUECHANSON VALUES('en',5285,'t');
INSERT INTO LANGUECHANSON VALUES('en',1839,'t');
INSERT INTO LANGUECHANSON VALUES('en',2407,'t');
INSERT INTO LANGUECHANSON VALUES('en',1783,'t');
INSERT INTO LANGUECHANSON VALUES('en',5877,'t');
INSERT INTO LANGUECHANSON VALUES('en',4078,'t');
INSERT INTO LANGUECHANSON VALUES('en',4495,'t');
INSERT INTO LANGUECHANSON VALUES('en',1449,'t');
INSERT INTO LANGUECHANSON VALUES('en',9972,'t');
INSERT INTO LANGUECHANSON VALUES('en',5856,'t');
INSERT INTO LANGUECHANSON VALUES('en',6064,'t');
INSERT INTO LANGUECHANSON VALUES('en',5851,'t');
INSERT INTO LANGUECHANSON VALUES('en',5852,'t');
INSERT INTO LANGUECHANSON VALUES('en',5850,'t');
INSERT INTO LANGUECHANSON VALUES('en',1505,'t');
INSERT INTO LANGUECHANSON VALUES('en',1927,'t');
INSERT INTO LANGUECHANSON VALUES('en',4156,'t');
INSERT INTO LANGUECHANSON VALUES('en',5895,'t');
INSERT INTO LANGUECHANSON VALUES('en',3545,'t');
INSERT INTO LANGUECHANSON VALUES('en',1847,'t');
INSERT INTO LANGUECHANSON VALUES('en',1934,'t');
INSERT INTO LANGUECHANSON VALUES('en',1587,'t');
INSERT INTO LANGUECHANSON VALUES('en',2181,'t');
INSERT INTO LANGUECHANSON VALUES('en',1273,'t');
INSERT INTO LANGUECHANSON VALUES('en',2202,'t');
INSERT INTO LANGUECHANSON VALUES('en',1276,'t');
INSERT INTO LANGUECHANSON VALUES('en',4494,'t');
INSERT INTO LANGUECHANSON VALUES('en',2262,'t');
INSERT INTO LANGUECHANSON VALUES('en',5664,'t');
INSERT INTO LANGUECHANSON VALUES('en',5802,'t');
INSERT INTO LANGUECHANSON VALUES('en',1579,'t');
INSERT INTO LANGUECHANSON VALUES('en',5814,'t');
INSERT INTO LANGUECHANSON VALUES('en',4153,'t');
INSERT INTO LANGUECHANSON VALUES('en',4196,'t');
INSERT INTO LANGUECHANSON VALUES('en',2101,'t');
INSERT INTO LANGUECHANSON VALUES('en',1042,'t');
INSERT INTO LANGUECHANSON VALUES('en',1808,'t');
INSERT INTO LANGUECHANSON VALUES('en',5097,'t');
INSERT INTO LANGUECHANSON VALUES('en',5098,'t');
INSERT INTO LANGUECHANSON VALUES('en',5096,'t');
INSERT INTO LANGUECHANSON VALUES('en',5103,'t');
INSERT INTO LANGUECHANSON VALUES('en',5093,'t');
INSERT INTO LANGUECHANSON VALUES('en',5095,'t');
INSERT INTO LANGUECHANSON VALUES('en',5100,'t');
INSERT INTO LANGUECHANSON VALUES('en',5101,'t');
INSERT INTO LANGUECHANSON VALUES('en',5102,'t');
INSERT INTO LANGUECHANSON VALUES('en',5104,'t');
INSERT INTO LANGUECHANSON VALUES('en',5106,'t');
INSERT INTO LANGUECHANSON VALUES('en',5107,'t');
INSERT INTO LANGUECHANSON VALUES('en',5108,'t');
INSERT INTO LANGUECHANSON VALUES('en',5111,'t');
INSERT INTO LANGUECHANSON VALUES('en',3918,'t');
INSERT INTO LANGUECHANSON VALUES('en',3680,'t');
INSERT INTO LANGUECHANSON VALUES('br',6688,'t');
INSERT INTO LANGUECHANSON VALUES('en',2070,'t');
INSERT INTO LANGUECHANSON VALUES('en',3356,'t');
INSERT INTO LANGUECHANSON VALUES('en',2255,'t');
INSERT INTO LANGUECHANSON VALUES('en',2308,'t');
INSERT INTO LANGUECHANSON VALUES('en',3006,'t');
INSERT INTO LANGUECHANSON VALUES('en',3244,'t');
INSERT INTO LANGUECHANSON VALUES('en',2054,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6223,'t');
INSERT INTO LANGUECHANSON VALUES('en',2332,'t');
INSERT INTO LANGUECHANSON VALUES('en',2005,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2977,'t');
INSERT INTO LANGUECHANSON VALUES('en',5043,'t');
INSERT INTO LANGUECHANSON VALUES('en',1503,'t');
INSERT INTO LANGUECHANSON VALUES('en',9975,'t');
INSERT INTO LANGUECHANSON VALUES('en',2055,'t');
INSERT INTO LANGUECHANSON VALUES('en',2207,'t');
INSERT INTO LANGUECHANSON VALUES('en',1966,'t');
INSERT INTO LANGUECHANSON VALUES('en',31,'t');
INSERT INTO LANGUECHANSON VALUES('en',2818,'t');
INSERT INTO LANGUECHANSON VALUES('en',5148,'t');
INSERT INTO LANGUECHANSON VALUES('en',1718,'t');
INSERT INTO LANGUECHANSON VALUES('en',2553,'t');
INSERT INTO LANGUECHANSON VALUES('en',1558,'t');
INSERT INTO LANGUECHANSON VALUES('en',2218,'t');
INSERT INTO LANGUECHANSON VALUES('en',2312,'t');
INSERT INTO LANGUECHANSON VALUES('en',2673,'t');
INSERT INTO LANGUECHANSON VALUES('en',7184,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3134,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2123,'t');
INSERT INTO LANGUECHANSON VALUES('fr',2120,'t');
INSERT INTO LANGUECHANSON VALUES('en',3453,'t');
INSERT INTO LANGUECHANSON VALUES('en',6990,'t');
INSERT INTO LANGUECHANSON VALUES('en',1993,'t');
INSERT INTO LANGUECHANSON VALUES('en',6849,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3371,'t');
INSERT INTO LANGUECHANSON VALUES('en',2098,'t');
INSERT INTO LANGUECHANSON VALUES('fr',1740,'t');
INSERT INTO LANGUECHANSON VALUES('en',4216,'t');
INSERT INTO LANGUECHANSON VALUES('en',2554,'t');
INSERT INTO LANGUECHANSON VALUES('en',2395,'t');
INSERT INTO LANGUECHANSON VALUES('en',1565,'t');
INSERT INTO LANGUECHANSON VALUES('en',5872,'t');
INSERT INTO LANGUECHANSON VALUES('en',4594,'t');
INSERT INTO LANGUECHANSON VALUES('en',3208,'t');
INSERT INTO LANGUECHANSON VALUES('en',3311,'t');
INSERT INTO LANGUECHANSON VALUES('en',1535,'t');
INSERT INTO LANGUECHANSON VALUES('en',4597,'t');
INSERT INTO LANGUECHANSON VALUES('en',5672,'t');
INSERT INTO LANGUECHANSON VALUES('en',10988,'t');
INSERT INTO LANGUECHANSON VALUES('en',10989,'t');
INSERT INTO LANGUECHANSON VALUES('en',10991,'t');
INSERT INTO LANGUECHANSON VALUES('en',10993,'t');
INSERT INTO LANGUECHANSON VALUES('en',11001,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11010,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11012,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11014,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11016,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11017,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11019,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11020,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11021,'t');
INSERT INTO LANGUECHANSON VALUES('en',11022,'t');
INSERT INTO LANGUECHANSON VALUES('en',11024,'t');
INSERT INTO LANGUECHANSON VALUES('en',11026,'t');
INSERT INTO LANGUECHANSON VALUES('en',11028,'t');
INSERT INTO LANGUECHANSON VALUES('en',11029,'t');
INSERT INTO LANGUECHANSON VALUES('en',11031,'t');
INSERT INTO LANGUECHANSON VALUES('en',1633,'t');
INSERT INTO LANGUECHANSON VALUES('en',5888,'t');
INSERT INTO LANGUECHANSON VALUES('en',2454,'t');
INSERT INTO LANGUECHANSON VALUES('en',4202,'t');
INSERT INTO LANGUECHANSON VALUES('en',5891,'t');
INSERT INTO LANGUECHANSON VALUES('en',2937,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6648,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6649,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6650,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6651,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6652,'t');
INSERT INTO LANGUECHANSON VALUES('en',5670,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6653,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6654,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6655,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6657,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6658,'t');
INSERT INTO LANGUECHANSON VALUES('fr',6659,'t');
INSERT INTO LANGUECHANSON VALUES('en',5586,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11033,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11035,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11037,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11038,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11040,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11039,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11041,'t');
INSERT INTO LANGUECHANSON VALUES('nl',11042,'t');
INSERT INTO LANGUECHANSON VALUES('br',11322,'t');
INSERT INTO LANGUECHANSON VALUES('br',11323,'t');
INSERT INTO LANGUECHANSON VALUES('br',11324,'t');
INSERT INTO LANGUECHANSON VALUES('br',11325,'t');
INSERT INTO LANGUECHANSON VALUES('br',11326,'t');
INSERT INTO LANGUECHANSON VALUES('br',11327,'t');
INSERT INTO LANGUECHANSON VALUES('br',11329,'t');
INSERT INTO LANGUECHANSON VALUES('br',11330,'t');
INSERT INTO LANGUECHANSON VALUES('br',11331,'t');
INSERT INTO LANGUECHANSON VALUES('br',11332,'t');
INSERT INTO LANGUECHANSON VALUES('br',11333,'t');
INSERT INTO LANGUECHANSON VALUES('br',11334,'t');
INSERT INTO LANGUECHANSON VALUES('br',11335,'t');
INSERT INTO LANGUECHANSON VALUES('br',11328,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11336,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11337,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11338,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11339,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11340,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11341,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11342,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11343,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11344,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11345,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11346,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11347,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11348,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11349,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11350,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11351,'t');
INSERT INTO LANGUECHANSON VALUES('en',3242,'t');
INSERT INTO LANGUECHANSON VALUES('en',1955,'t');
INSERT INTO LANGUECHANSON VALUES('en',1948,'t');
INSERT INTO LANGUECHANSON VALUES('fr',3479,'t');
INSERT INTO LANGUECHANSON VALUES('en',2211,'t');
INSERT INTO LANGUECHANSON VALUES('en',2212,'t');
INSERT INTO LANGUECHANSON VALUES('en',2215,'t');
INSERT INTO LANGUECHANSON VALUES('en',7152,'t');
INSERT INTO LANGUECHANSON VALUES('br',11352,'t');
INSERT INTO LANGUECHANSON VALUES('br',11353,'t');
INSERT INTO LANGUECHANSON VALUES('br',11354,'t');
INSERT INTO LANGUECHANSON VALUES('br',11355,'t');
INSERT INTO LANGUECHANSON VALUES('br',11356,'t');
INSERT INTO LANGUECHANSON VALUES('br',11357,'t');
INSERT INTO LANGUECHANSON VALUES('br',11358,'t');
INSERT INTO LANGUECHANSON VALUES('br',11359,'t');
INSERT INTO LANGUECHANSON VALUES('br',11360,'t');
INSERT INTO LANGUECHANSON VALUES('br',11361,'t');
INSERT INTO LANGUECHANSON VALUES('br',11362,'t');
INSERT INTO LANGUECHANSON VALUES('en',11363,'t');
INSERT INTO LANGUECHANSON VALUES('en',11364,'t');
INSERT INTO LANGUECHANSON VALUES('en',11365,'t');
INSERT INTO LANGUECHANSON VALUES('en',11366,'t');
INSERT INTO LANGUECHANSON VALUES('en',11367,'t');
INSERT INTO LANGUECHANSON VALUES('en',11368,'t');
INSERT INTO LANGUECHANSON VALUES('en',11369,'t');
INSERT INTO LANGUECHANSON VALUES('en',11370,'t');
INSERT INTO LANGUECHANSON VALUES('en',11371,'t');
INSERT INTO LANGUECHANSON VALUES('en',11372,'t');
INSERT INTO LANGUECHANSON VALUES('en',11373,'t');
INSERT INTO LANGUECHANSON VALUES('en',11374,'t');
INSERT INTO LANGUECHANSON VALUES('en',11375,'t');
INSERT INTO LANGUECHANSON VALUES('en',11376,'t');
INSERT INTO LANGUECHANSON VALUES('en',11377,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11378,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11379,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11380,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11381,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11382,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11383,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11384,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11385,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11386,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11387,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11388,'t');
INSERT INTO LANGUECHANSON VALUES('en',11389,'t');
INSERT INTO LANGUECHANSON VALUES('en',11390,'t');
INSERT INTO LANGUECHANSON VALUES('en',11391,'t');
INSERT INTO LANGUECHANSON VALUES('en',11392,'t');
INSERT INTO LANGUECHANSON VALUES('en',11393,'t');
INSERT INTO LANGUECHANSON VALUES('en',11394,'t');
INSERT INTO LANGUECHANSON VALUES('en',11395,'t');
INSERT INTO LANGUECHANSON VALUES('en',11396,'t');
INSERT INTO LANGUECHANSON VALUES('en',11397,'t');
INSERT INTO LANGUECHANSON VALUES('en',11398,'t');
INSERT INTO LANGUECHANSON VALUES('en',11399,'t');
INSERT INTO LANGUECHANSON VALUES('en',11400,'t');
INSERT INTO LANGUECHANSON VALUES('en',11401,'t');
INSERT INTO LANGUECHANSON VALUES('en',11402,'t');
INSERT INTO LANGUECHANSON VALUES('en',11403,'t');
INSERT INTO LANGUECHANSON VALUES('en',11404,'t');
INSERT INTO LANGUECHANSON VALUES('en',11405,'t');
INSERT INTO LANGUECHANSON VALUES('en',11406,'t');
INSERT INTO LANGUECHANSON VALUES('en',11407,'t');
INSERT INTO LANGUECHANSON VALUES('en',11408,'t');
INSERT INTO LANGUECHANSON VALUES('en',11409,'t');
INSERT INTO LANGUECHANSON VALUES('en',11410,'t');
INSERT INTO LANGUECHANSON VALUES('en',11411,'t');
INSERT INTO LANGUECHANSON VALUES('en',11412,'t');
INSERT INTO LANGUECHANSON VALUES('en',11413,'t');
INSERT INTO LANGUECHANSON VALUES('en',11414,'t');
INSERT INTO LANGUECHANSON VALUES('en',11415,'t');
INSERT INTO LANGUECHANSON VALUES('en',11416,'t');
INSERT INTO LANGUECHANSON VALUES('en',11417,'t');
INSERT INTO LANGUECHANSON VALUES('en',11418,'t');
INSERT INTO LANGUECHANSON VALUES('en',11419,'t');
INSERT INTO LANGUECHANSON VALUES('en',11420,'t');
INSERT INTO LANGUECHANSON VALUES('en',11421,'t');
INSERT INTO LANGUECHANSON VALUES('en',11422,'t');
INSERT INTO LANGUECHANSON VALUES('en',11423,'t');
INSERT INTO LANGUECHANSON VALUES('en',11424,'t');
INSERT INTO LANGUECHANSON VALUES('en',11425,'t');
INSERT INTO LANGUECHANSON VALUES('en',11426,'t');
INSERT INTO LANGUECHANSON VALUES('en',11427,'t');
INSERT INTO LANGUECHANSON VALUES('en',11428,'t');
INSERT INTO LANGUECHANSON VALUES('en',11430,'t');
INSERT INTO LANGUECHANSON VALUES('en',11431,'t');
INSERT INTO LANGUECHANSON VALUES('en',11429,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11432,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11433,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11434,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11435,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11436,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11437,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11438,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11439,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11440,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11441,'t');
INSERT INTO LANGUECHANSON VALUES('en',11443,'t');
INSERT INTO LANGUECHANSON VALUES('en',11446,'t');
INSERT INTO LANGUECHANSON VALUES('en',11447,'t');
INSERT INTO LANGUECHANSON VALUES('en',11449,'t');
INSERT INTO LANGUECHANSON VALUES('en',11450,'t');
INSERT INTO LANGUECHANSON VALUES('en',11451,'t');
INSERT INTO LANGUECHANSON VALUES('en',11452,'t');
INSERT INTO LANGUECHANSON VALUES('en',11453,'t');
INSERT INTO LANGUECHANSON VALUES('en',11454,'t');
INSERT INTO LANGUECHANSON VALUES('br',11455,'t');
INSERT INTO LANGUECHANSON VALUES('br',11456,'t');
INSERT INTO LANGUECHANSON VALUES('br',11457,'t');
INSERT INTO LANGUECHANSON VALUES('br',11458,'t');
INSERT INTO LANGUECHANSON VALUES('br',11459,'t');
INSERT INTO LANGUECHANSON VALUES('br',11460,'t');
INSERT INTO LANGUECHANSON VALUES('br',11461,'t');
INSERT INTO LANGUECHANSON VALUES('br',11462,'t');
INSERT INTO LANGUECHANSON VALUES('br',11463,'t');
INSERT INTO LANGUECHANSON VALUES('br',11464,'t');
INSERT INTO LANGUECHANSON VALUES('br',11465,'t');
INSERT INTO LANGUECHANSON VALUES('br',11466,'t');
INSERT INTO LANGUECHANSON VALUES('br',11467,'t');
INSERT INTO LANGUECHANSON VALUES('br',11468,'t');
INSERT INTO LANGUECHANSON VALUES('en',11469,'t');
INSERT INTO LANGUECHANSON VALUES('en',11470,'t');
INSERT INTO LANGUECHANSON VALUES('en',11471,'t');
INSERT INTO LANGUECHANSON VALUES('en',11472,'t');
INSERT INTO LANGUECHANSON VALUES('en',11473,'t');
INSERT INTO LANGUECHANSON VALUES('en',11474,'t');
INSERT INTO LANGUECHANSON VALUES('en',11475,'t');
INSERT INTO LANGUECHANSON VALUES('en',11476,'t');
INSERT INTO LANGUECHANSON VALUES('en',11477,'t');
INSERT INTO LANGUECHANSON VALUES('en',11478,'t');
INSERT INTO LANGUECHANSON VALUES('en',11479,'t');
INSERT INTO LANGUECHANSON VALUES('en',11482,'t');
INSERT INTO LANGUECHANSON VALUES('en',11481,'t');
INSERT INTO LANGUECHANSON VALUES('en',11483,'t');
INSERT INTO LANGUECHANSON VALUES('en',11484,'t');
INSERT INTO LANGUECHANSON VALUES('en',11485,'t');
INSERT INTO LANGUECHANSON VALUES('en',11486,'t');
INSERT INTO LANGUECHANSON VALUES('en',11487,'t');
INSERT INTO LANGUECHANSON VALUES('en',11488,'t');
INSERT INTO LANGUECHANSON VALUES('en',11489,'t');
INSERT INTO LANGUECHANSON VALUES('en',11490,'t');
INSERT INTO LANGUECHANSON VALUES('en',11491,'t');
INSERT INTO LANGUECHANSON VALUES('en',11480,'t');
INSERT INTO LANGUECHANSON VALUES('en',11492,'t');
INSERT INTO LANGUECHANSON VALUES('en',11493,'t');
INSERT INTO LANGUECHANSON VALUES('en',11494,'t');
INSERT INTO LANGUECHANSON VALUES('en',11495,'t');
INSERT INTO LANGUECHANSON VALUES('en',11497,'t');
INSERT INTO LANGUECHANSON VALUES('en',11498,'t');
INSERT INTO LANGUECHANSON VALUES('en',11500,'t');
INSERT INTO LANGUECHANSON VALUES('en',11501,'t');
INSERT INTO LANGUECHANSON VALUES('en',11502,'t');
INSERT INTO LANGUECHANSON VALUES('en',11503,'t');
INSERT INTO LANGUECHANSON VALUES('en',11504,'t');
INSERT INTO LANGUECHANSON VALUES('en',11505,'t');
INSERT INTO LANGUECHANSON VALUES('en',11507,'t');
INSERT INTO LANGUECHANSON VALUES('en',11510,'t');
INSERT INTO LANGUECHANSON VALUES('en',11512,'t');
INSERT INTO LANGUECHANSON VALUES('en',11513,'t');
INSERT INTO LANGUECHANSON VALUES('en',11515,'t');
INSERT INTO LANGUECHANSON VALUES('en',11516,'t');
INSERT INTO LANGUECHANSON VALUES('en',11517,'t');
INSERT INTO LANGUECHANSON VALUES('en',11518,'t');
INSERT INTO LANGUECHANSON VALUES('en',11519,'t');
INSERT INTO LANGUECHANSON VALUES('en',11520,'t');
INSERT INTO LANGUECHANSON VALUES('en',11521,'t');
INSERT INTO LANGUECHANSON VALUES('en',11522,'t');
INSERT INTO LANGUECHANSON VALUES('en',11523,'t');
INSERT INTO LANGUECHANSON VALUES('en',11524,'t');
INSERT INTO LANGUECHANSON VALUES('en',11525,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11526,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11527,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11528,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11529,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11530,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11531,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11532,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11533,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11535,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11536,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11537,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11538,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11539,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11540,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11541,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11542,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11543,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11544,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11545,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11546,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11547,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11548,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11549,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11550,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11551,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11552,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11553,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11554,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11555,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11572,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11573,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11575,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11576,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11577,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11578,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11579,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11581,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11582,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11583,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11584,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11585,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11614,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11615,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11616,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11617,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11618,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11619,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11620,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11621,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11622,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11623,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11624,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11625,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11626,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11627,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11628,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11629,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11630,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11632,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11633,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11635,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11636,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11637,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11638,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11639,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11643,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11644,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11645,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11646,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11647,'t');
INSERT INTO LANGUECHANSON VALUES('en',1944,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11648,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11650,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11651,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11652,'t');
INSERT INTO LANGUECHANSON VALUES('fr',11654,'t');
INSERT INTO LANGUECHANSON VALUES('en',11659,'t');
INSERT INTO LANGUECHANSON VALUES('en',11663,'t');
INSERT INTO LANGUECHANSON VALUES('en',11669,'t');
INSERT INTO LANGUECHANSON VALUES('en',11670,'t');
INSERT INTO LANGUECHANSON VALUES('en',11674,'t');
INSERT INTO LANGUECHANSON VALUES('en',11676,'t');
INSERT INTO LANGUECHANSON VALUES('en',11677,'t');
INSERT INTO LANGUECHANSON VALUES('en',1744,'t');
INSERT INTO LANGUECHANSON VALUES('fr',7726,'t');
INSERT INTO MEMBRE VALUES(56,141,'1965','1970');
INSERT INTO MEMBRE VALUES(58,135,'1957','1970');
INSERT INTO MEMBRE VALUES(298,67,'1968','1980');
INSERT INTO MEMBRE VALUES(299,70,'1985','1991');
INSERT INTO MEMBRE VALUES(299,73,'0','0');
INSERT INTO MEMBRE VALUES(80,44,'1962','0');
INSERT INTO MEMBRE VALUES(100,44,'1962','0');
INSERT INTO MEMBRE VALUES(49,79,'1980','1986');
INSERT INTO MEMBRE VALUES(94,83,'1972','1983');
INSERT INTO MEMBRE VALUES(94,83,'2001','0');
INSERT INTO MEMBRE VALUES(115,93,'1976','1986');
INSERT INTO MEMBRE VALUES(116,93,'1976','1986');
INSERT INTO MEMBRE VALUES(52,118,'1988','1992');
INSERT INTO MEMBRE VALUES(197,200,'1998','1998');
INSERT INTO MEMBRE VALUES(124,62,'1970','1996');
INSERT INTO MEMBRE VALUES(124,62,'2007','0');
INSERT INTO MEMBRE VALUES(188,128,'1987','1994');
INSERT INTO MEMBRE VALUES(202,201,'1968','1969');
INSERT INTO MEMBRE VALUES(202,201,'1974','1974');
INSERT INTO MEMBRE VALUES(202,201,'1988','1988');
INSERT INTO MEMBRE VALUES(202,201,'1999','1999');
INSERT INTO MEMBRE VALUES(298,149,'1995','1998');
INSERT INTO MEMBRE VALUES(300,149,'1995','1998');
INSERT INTO MEMBRE VALUES(309,242,'0','0');
INSERT INTO MEMBRE VALUES(310,242,'0','0');
INSERT INTO MEMBRE VALUES(237,222,'0','0');
INSERT INTO MEMBRE VALUES(301,222,'0','0');
INSERT INTO MEMBRE VALUES(302,225,'0','0');
INSERT INTO MEMBRE VALUES(303,225,'0','0');
INSERT INTO MEMBRE VALUES(304,225,'0','0');
INSERT INTO MEMBRE VALUES(305,225,'0','0');
INSERT INTO MEMBRE VALUES(56,138,'0','0');
INSERT INTO MEMBRE VALUES(306,138,'0','0');
INSERT INTO MEMBRE VALUES(88,87,'0','0');
INSERT INTO MEMBRE VALUES(197,200,'0','0');
INSERT INTO MEMBRE VALUES(307,200,'0','0');
INSERT INTO MEMBRE VALUES(308,200,'0','0');
INSERT INTO MEMBRE VALUES(211,312,'0','0');
INSERT INTO MEMBRE VALUES(474,132,'0','0');
INSERT INTO MEMBRE VALUES(483,482,'0','0');
INSERT INTO MEMBRE VALUES(52,482,'0','0');
INSERT INTO DISQUE VALUES(0,'French Kiss (Bonus CD)',0,'1999','2b056004','2005',17.93,2,'f','2008-03-12 12:38:24');
INSERT INTO DISQUE VALUES(1,'Stiff''n Red',1,'1991','46046d06','2008',17.04,2,'f','2008-03-12 13:37:05');
INSERT INTO DISQUE VALUES(2,'This ain''t no jukebox...',2,'1991','6e090e0a','1997',11.86,2,'f','2008-03-12 19:17:42');
INSERT INTO DISQUE VALUES(3,'Sam Brown',3,'1999','7108b60a','2004',15.45,3,'f','2008-03-12 19:46:32');
INSERT INTO DISQUE VALUES(4,'Back In Black',4,'1980','7409d80a','1986',11.76,1,'f','2008-03-12 14:39:34');
INSERT INTO DISQUE VALUES(5,'Calvin Russell',3,'1996','7a0a1e0a','1997',15.05,1,'f','2008-03-12 18:28:03');
INSERT INTO DISQUE VALUES(6,'Smokin'' Gun',5,'1992','7b0b360b','2008',12.38,2,'f','2008-03-12 16:47:06');
INSERT INTO DISQUE VALUES(7,'Soldier',3,'1992','7c08db09','1993',19.38,1,'f','2008-06-02 14:15:23.423343');
INSERT INTO DISQUE VALUES(8,'Post',6,'1995','810ad70b','2001',11.22,2,'f','2008-03-12 09:05:07');
INSERT INTO DISQUE VALUES(9,'Dream of the Dog',3,'1995','880bca0b','2005',11.92,2,'f','2008-03-12 14:34:42');
INSERT INTO DISQUE VALUES(10,'Hell To Pay',7,'1990','8e0bc70b','2000',18.04,2,'f','2008-03-12 14:54:20');
INSERT INTO DISQUE VALUES(11,'Sounds from the fourth world',3,'1991','8f0b9b0b','2007',15.63,3,'f','2008-03-12 19:21:57');
INSERT INTO DISQUE VALUES(12,'The Blues Brothers',8,'1980','90099c0b','1992',13.16,2,'f','2008-03-12 08:17:15');
INSERT INTO DISQUE VALUES(13,'See The Light',7,'1989','9e0bac0c','1991',16.36,1,'f','2008-03-12 16:16:02');
INSERT INTO DISQUE VALUES(14,'Living with the Law',9,'1991','a30b030d','2003',15.79,2,'f','2008-03-12 11:51:41');
INSERT INTO DISQUE VALUES(15,'Mudcakes',0,'1993','a40be50c','2001',14.66,1,'t','2008-03-12 18:42:09');
INSERT INTO DISQUE VALUES(16,'Amnesty For Eve',0,'1999','a90d490c','2002',11.25,3,'f','2008-03-12 18:25:57');
INSERT INTO DISQUE VALUES(17,'Feel This',7,'1992','c30ff40e','1995',10.01,2,'f','2008-03-12 08:04:37');
INSERT INTO DISQUE VALUES(18,'A Crack In Time',3,'1990','cd0d380e','2001',18.39,3,'f','2008-06-02 14:15:46.057643');
INSERT INTO DISQUE VALUES(19,'Quelqu''un m''a dit',10,'2003','9608ca0c','2005',14.03,3,'f','2008-03-12 18:46:17');
INSERT INTO DISQUE VALUES(20,'A Day At The Races',11,'1976','760a6a0a','1986',16.54,1,'f','2008-03-12 14:18:11');
INSERT INTO DISQUE VALUES(21,'Hotel Vast Horizon',9,'2003','8f08ae0a','2007',17.63,1,'t','2008-03-12 18:14:33');
INSERT INTO DISQUE VALUES(22,'Terra Incognita',9,'1997','c40f990e','2001',17.14,1,'f','2008-03-12 18:15:50');
INSERT INTO DISQUE VALUES(23,'Creedence Clearwater Revival',12,'1968','110fb211','1999',17.35,2,'f','2008-03-12 09:58:07');
INSERT INTO DISQUE VALUES(24,'La femme chocolat',13,'2005','980c890d','2005',15.67,1,'f','2008-06-02 15:15:51.574339');
INSERT INTO DISQUE VALUES(25,'Bayou Country',12,'1969','53080007','1997',12.5,3,'f','2008-03-12 18:05:41');
INSERT INTO DISQUE VALUES(26,'The Bootleg Series Vol. 5: Live 1975 - The RollingThunder Revue (Disc 2)',14,'2002','9d0bee0b','2002',13.01,2,'f','2008-03-12 08:59:07');
INSERT INTO DISQUE VALUES(28,'Tosca CD1',15,'1956','070f5c13','1967',12.35,3,'f','2008-05-27 10:11:45.718642');
INSERT INTO DISQUE VALUES(29,'Symphonie n°6 "Tragique"',16,'1992','25128a04','2007',14.99,2,'f','2008-03-12 15:44:24');
INSERT INTO DISQUE VALUES(30,'Concerto n°1 en mi mineur',17,'1954','26099103','2005',12.08,2,'f','2008-03-12 11:37:11');
INSERT INTO DISQUE VALUES(31,'Symphonie n°6 en si mineur, op.74 "Pathétique"',18,'1987','340db604','1987',12.94,2,'f','2008-03-12 15:11:29');
INSERT INTO DISQUE VALUES(32,'Don Giovanni CD1',19,'1984','340ee817','1995',18.83,3,'f','2008-05-27 10:10:36.895627');
INSERT INTO DISQUE VALUES(33,'Symphonie n°5 in Do dièese mineur',16,'1990','370ed405','1996',14.66,1,'f','2008-03-12 12:59:59');
INSERT INTO DISQUE VALUES(34,'Symphonie Fantastique',20,'1988','390b7a05','2005',18.63,1,'f','2008-03-12 10:06:58');
INSERT INTO DISQUE VALUES(35,'Symphonie n°3 en mi bémol majeur (Eroica)',21,'1960','3a0bb604','1994',16.82,2,'f','2008-06-02 15:16:30.671973');
INSERT INTO DISQUE VALUES(36,'Symphonie n°1 en Ré-mineur ''Titan''',16,'1989','3a0c9904','2000',12.21,2,'f','2008-03-12 11:07:19');
INSERT INTO DISQUE VALUES(37,'Death and the Maiden',22,'1988','3c0bc605','2001',11.99,2,'f','2008-03-12 19:08:18');
INSERT INTO DISQUE VALUES(38,'Messe du couronnement',19,'1993','3d0c9104','2007',19.08,2,'f','2008-03-12 09:06:18');
INSERT INTO DISQUE VALUES(39,'Symphony No. 4 - Tragic',22,'1990','400d3405','2007',14.03,2,'f','2008-03-12 11:42:03');
INSERT INTO DISQUE VALUES(40,'Concertos n°1 et n°2',17,'1990','460fc406','1994',14.09,2,'f','2008-03-12 16:01:41');
INSERT INTO DISQUE VALUES(41,'Miklos Perenyi/Franz Liszt Chamber Orchestra / Cello ConcertosNo. 1 & 2',23,'1991','470be106','2005',16.42,2,'f','2008-03-12 18:36:52');
INSERT INTO DISQUE VALUES(42,'Concerto pour piano n°5 "l''empereur", Sonate pour piano n°17 "la tempête"',21,'1994','4a0e4506','1997',12.65,2,'f','2008-03-12 12:24:59');
INSERT INTO DISQUE VALUES(43,'Concertos 2 et 5 pour piano et orchestre',21,'1987','570faa06','1988',13.18,1,'t','2008-03-12 09:45:58');
INSERT INTO DISQUE VALUES(44,'Concerto Pour Flute Et Harpe / Lily Lashine J.F Paillard Th. Guschlbauer Jp Rampal',19,'1964','5a0ec507','1981',12.95,3,'f','2008-03-12 09:56:04');
INSERT INTO DISQUE VALUES(45,'Concerto pour violon et orchestre-Quatuor à cordes n°1',18,'1994','680e7e07','2006',12.13,1,'f','2008-03-12 08:15:21');
INSERT INTO DISQUE VALUES(46,'Préludes concerto fugue',24,'1994','6a0eb309','1994',11.03,2,'f','2008-03-12 11:32:28');
INSERT INTO DISQUE VALUES(47,'Concertos Brandenbourgeois 4,5,6',25,'1988','7a0d2a09','2001',11.3,2,'f','2008-03-12 15:31:36');
INSERT INTO DISQUE VALUES(48,'Symphonies 5 et 6',21,'1982','7b0f2c09','2008',10.92,2,'f','2008-03-12 19:37:43');
INSERT INTO DISQUE VALUES(49,'Adagio - Herbert Von Karajan',26,'1993','91127d0b','1997',16.04,1,'f','2008-03-12 10:54:25');
INSERT INTO DISQUE VALUES(50,'Concertos Brandenbourgeois 1,2,3',25,'1988','920ac80a','1995',15.03,1,'f','2008-03-12 11:36:26');
INSERT INTO DISQUE VALUES(51,'Les 4 Saisons - Nigel Kennedy',27,'1989','93098b0c','2001',12.92,2,'f','2008-03-12 19:28:03');
INSERT INTO DISQUE VALUES(52,'Bande originale du film la note bleue - Janusz Olejniczak',17,'1991','940e430c','2002',16.98,2,'f','2008-03-12 18:51:28');
INSERT INTO DISQUE VALUES(53,'Don Giovanni CD2',19,'1984','a10ef21e','1988',11.05,2,'f','2008-05-27 10:10:31.535427');
INSERT INTO DISQUE VALUES(54,'Requiem - Schreier',19,'1983','bd0bf90e','1985',17.73,2,'f','2008-03-12 17:02:10');
INSERT INTO DISQUE VALUES(55,'Albinoni: Adagio. Pachelbel: Canon',26,'1990','c10c8b0f','1998',18.35,1,'f','2008-03-12 18:06:25');
INSERT INTO DISQUE VALUES(56,'Don Giovanni CD3',19,'1984','c30a620f','2000',14.26,4,'f','2008-05-27 10:10:25.48384');
INSERT INTO DISQUE VALUES(57,'Romeo et Juliette CD2 - Gardiner, Orchestre Revolutionnaire Et Romantique',20,'1995','c810450e','2007',17.61,1,'f','2008-03-12 16:00:29');
INSERT INTO DISQUE VALUES(58,'Organ Trio Sonatas - Michel Chapuis',25,'1986','ce0d9b0f','1995',18,2,'f','2008-03-12 12:56:07');
INSERT INTO DISQUE VALUES(59,'Quatre quatuors - Quatuor Talich',26,'1992','d311e610','2000',13.23,2,'f','2008-03-12 08:10:01');
INSERT INTO DISQUE VALUES(60,'Musical Offering - Harnoncourt',25,'1970','ee0aee10','1979',10.99,2,'f','2008-03-12 13:29:37');
INSERT INTO DISQUE VALUES(61,'Tosca CD2',15,'1956','f40c4d0f','1996',15.28,1,'t','2008-05-27 10:11:41.24425');
INSERT INTO DISQUE VALUES(62,'Carmina Burana',28,'1989','700e4419','1993',16.23,2,'f','2008-03-12 08:20:57');
INSERT INTO DISQUE VALUES(63,'Die Zauberflöte CD1',19,'1987','12112d13','1989',18.96,2,'f','2008-05-27 10:10:46.079804');
INSERT INTO DISQUE VALUES(64,'Die Zauberflöte CD2',19,'1987','2e108216','2002',10.33,1,'f','2008-05-27 10:10:41.838976');
INSERT INTO DISQUE VALUES(65,'Die Walküre CD1',29,'1988','b70f2b0d','1988',17.96,2,'f','2008-05-27 10:15:40.625986');
INSERT INTO DISQUE VALUES(66,'Die Walküre CD4',29,'1988','ac10e80c','2003',17.52,2,'f','2008-05-27 10:15:27.171037');
INSERT INTO DISQUE VALUES(67,'Die Walküre CD2',29,'1988','7d0ccd0a','2005',15.01,3,'f','2008-05-27 10:15:35.743112');
INSERT INTO DISQUE VALUES(68,'Die Walküre CD3',29,'1988','5b096008','2004',12.38,1,'f','2008-05-27 10:15:31.964013');
INSERT INTO DISQUE VALUES(69,'Also Sprach Zarathustra - Don Juan',30,'1984','650cae0a','1991',14.5,1,'f','2008-03-12 18:22:37');
INSERT INTO DISQUE VALUES(70,'The Weirdness',31,'2007','9509620c','2007',15.72,2,'f','2008-03-12 18:52:06');
INSERT INTO DISQUE VALUES(71,'Also sprach Zaratustra (op30)-Don Juan(op20)',32,'1984','7d0cae0a','1988',18.39,1,'f','2008-03-12 14:48:35');
INSERT INTO DISQUE VALUES(72,'Canto Gregoriano CD1',33,'1993','ac0b120e','2000',11.05,2,'f','2008-06-02 14:30:36.138239');
INSERT INTO DISQUE VALUES(73,'Canto Gregoriano CD2',33,'1993','ea0b5112','2000',12.56,2,'f','2008-06-02 14:31:13.061874');
INSERT INTO DISQUE VALUES(85,'Solid Rock',40,'1997','ad0d4a0d','1998',10.01,1,'f','2008-03-12 14:46:35');
INSERT INTO DISQUE VALUES(86,'London Calling',41,'1979','080f7413','2000',10.39,1,'f','2008-03-12 16:21:45');
INSERT INTO DISQUE VALUES(87,'Europe et Haines',42,'1996','080fe112','2001',16.25,2,'f','2008-03-12 08:26:11');
INSERT INTO DISQUE VALUES(88,'The Proximity Effect (Mini CD)',43,'1998','0901b102','1999',11.6,2,'f','2008-03-12 11:00:23');
INSERT INTO DISQUE VALUES(89,'Highwire (mini single)',44,'1991','0e01b002','2000',12.68,2,'f','2008-03-12 18:02:27');
INSERT INTO DISQUE VALUES(90,'Tres Hombres + Fandango! (Sixpack Disc 2)',45,'1975','0e0fe013','1996',14.06,2,'f','2008-03-12 17:41:26');
INSERT INTO DISQUE VALUES(91,'18',46,'2002','1010c612','2002',12.92,2,'f','2008-03-12 15:27:57');
INSERT INTO DISQUE VALUES(92,'Macadam Massacre',47,'1984','140a2414','2005',14.13,2,'f','2008-03-12 10:48:06');
INSERT INTO DISQUE VALUES(93,'Tejas + El Loco (Sixpack Disc 3)',45,'1981','1710f614','1981',12.23,3,'f','2008-03-12 15:05:51');
INSERT INTO DISQUE VALUES(94,'The anthology',48,'1990','1a0d7712','1991',15.65,2,'f','2008-03-12 12:30:08');
INSERT INTO DISQUE VALUES(95,'Tracks From The Story',49,'1992','1c103012','1993',14.11,2,'f','2008-03-12 09:05:55');
INSERT INTO DISQUE VALUES(96,'Ummagumma CD1',50,'1969','1e094b04','1995',19.49,2,'f','2008-05-27 10:12:08.738597');
INSERT INTO DISQUE VALUES(97,'Prophètes et Nains de Jardin',51,'1996','200be716','1997',16.06,2,'t','2008-03-12 13:46:43');
INSERT INTO DISQUE VALUES(98,'1. Outside',52,'1995','21118913','1999',17.15,2,'f','2008-03-12 16:02:43');
INSERT INTO DISQUE VALUES(99,'Heathen (Bonus Disc)',52,'2002','2203fe04','2002',19.9,1,'f','2008-03-12 09:52:46');
INSERT INTO DISQUE VALUES(100,'Great balls of fire',53,'1989','220c1c16','1995',15.24,2,'f','2008-03-12 14:39:27');
INSERT INTO DISQUE VALUES(101,'Classic Tracks',54,'1972','2603a804','2004',16.98,1,'f','2008-03-12 19:14:54');
INSERT INTO DISQUE VALUES(102,'''Abracadaboum''',47,'1987','28105014','2006',15.07,2,'f','2008-03-12 19:27:43');
INSERT INTO DISQUE VALUES(103,'Cannonball',55,'1993','2a035a04','2000',15,2,'f','2008-03-12 08:07:48');
INSERT INTO DISQUE VALUES(104,'First Album + Rio Grande Mud (Sixpack Disc 1)',45,'1972','2b10b114','2008',19.01,1,'f','2008-03-12 18:31:19');
INSERT INTO DISQUE VALUES(105,'Highwire (CD Single)',44,'1991','2e03d404','2006',16.44,3,'f','2008-03-12 08:39:24');
INSERT INTO DISQUE VALUES(106,'Rock ''N'' Roll Animal',56,'1974','2f095905','1976',15.36,2,'f','2008-03-12 19:23:10');
INSERT INTO DISQUE VALUES(107,'Station To Station',52,'1976','3108dd06','2005',13.05,4,'f','2008-03-12 11:52:56');
INSERT INTO DISQUE VALUES(108,'Où veux-tu qu''je r''garde ?',57,'1987','36061606','2006',13.87,2,'f','2008-03-12 19:34:58');
INSERT INTO DISQUE VALUES(109,'The John Lennon Collection',58,'1989','3710c113','2003',10,3,'f','2008-03-12 16:39:51');
INSERT INTO DISQUE VALUES(110,'Pic À Glace',59,'1981','380e6a16','2008',16.19,1,'f','2008-03-12 14:12:30');
INSERT INTO DISQUE VALUES(111,'Atom Heart Mother',50,'1970','3a0c3605','1985',10.67,2,'f','2008-03-12 19:12:44');
INSERT INTO DISQUE VALUES(112,'Viva Bertaga (mini CD)',47,'1990','3b043e05','1999',10.18,2,'f','2008-03-12 18:08:12');
INSERT INTO DISQUE VALUES(113,'Viva Bertaga',47,'1990','3d11da16','1991',19.91,2,'f','2008-03-12 15:12:20');
INSERT INTO DISQUE VALUES(114,'Pour vivre heureux, vivons couchés',60,'1991','40043506','2008',14.87,2,'f','2008-03-12 12:07:51');
INSERT INTO DISQUE VALUES(115,'Meddle',50,'1971','430af206','2000',12.8,3,'f','2008-03-12 16:10:31');
INSERT INTO DISQUE VALUES(116,'Wish You Were Here',50,'1975','440a5905','1977',17.9,2,'f','2008-03-12 09:10:54');
INSERT INTO DISQUE VALUES(117,'Alambic/sortie sud',61,'1984','4b07f407','2005',18.03,3,'f','2008-03-12 11:26:47');
INSERT INTO DISQUE VALUES(118,'A Saucerful Of Secrets',50,'1968','4b094007','1972',19.44,1,'f','2008-03-12 11:26:22');
INSERT INTO DISQUE VALUES(119,'Nursery Crime',62,'1971','4c094707','2004',12.44,1,'f','2008-03-12 10:10:01');
INSERT INTO DISQUE VALUES(120,'Eros über Alles',61,'1988','4d087208','2002',18.63,3,'f','2008-03-12 09:40:13');
INSERT INTO DISQUE VALUES(121,'Par les fils de Mandrin',63,'1976','4d09b608','2003',14.99,2,'f','2008-03-12 15:38:26');
INSERT INTO DISQUE VALUES(122,'Deep Purple in Rock',64,'1970','4e0a3207','1987',16.64,2,'f','2008-03-12 12:30:34');
INSERT INTO DISQUE VALUES(123,'Greatest Hits CD2',65,'1991','54080208','2005',14.66,3,'f','2008-05-27 10:07:34.193914');
INSERT INTO DISQUE VALUES(124,'Caviar pour Les Autres',66,'1985','9109160a','1994',11.08,2,'f','2008-03-12 18:31:54');
INSERT INTO DISQUE VALUES(125,'Guet-apens',63,'1997','56098a06','2002',10.01,2,'f','2008-03-12 16:15:05');
INSERT INTO DISQUE VALUES(126,'In Through The Out Door',67,'1979','5609f907','2007',17.67,1,'t','2008-03-12 11:23:15');
INSERT INTO DISQUE VALUES(127,'En avant !!!',68,'1990','58051507','1993',16.11,2,'f','2008-03-12 10:42:42');
INSERT INTO DISQUE VALUES(128,'Soleil Cherche Futur',61,'1982','58083408','2002',16.45,2,'f','2008-03-12 19:57:08');
INSERT INTO DISQUE VALUES(129,'Young Americans',52,'1975','5a097808','1980',18.93,2,'f','2008-03-12 12:11:19');
INSERT INTO DISQUE VALUES(130,'Au-Delà Du Délire',63,'1974','5b08e808','1992',14.7,3,'f','2008-03-12 12:17:00');
INSERT INTO DISQUE VALUES(131,'Who Do We Think We Are',64,'1983','5c081d07','1990',13.23,2,'f','2008-03-12 15:52:38');
INSERT INTO DISQUE VALUES(132,'Made in Japan',64,'1972','5e11fc07','1983',19.35,2,'f','2008-03-12 08:12:09');
INSERT INTO DISQUE VALUES(133,'Let There Be Rock',4,'1977','5f099408','1998',18.11,3,'f','2008-03-12 15:45:16');
INSERT INTO DISQUE VALUES(134,'Higelin bbh75',66,'1974','60082408','2006',13.44,2,'f','2008-03-12 12:38:48');
INSERT INTO DISQUE VALUES(135,'Hail! Hail! Rock ''n'' Roll',69,'1988','a310721c','2007',12.62,2,'t','2008-03-12 11:23:03');
INSERT INTO DISQUE VALUES(136,'Love You Live CD2',44,'1977','61097e08','2006',16.33,2,'f','2008-05-27 10:11:31.974583');
INSERT INTO DISQUE VALUES(137,'Led Zeppelin II',67,'1969','6209c209','2007',16.25,1,'f','2008-06-02 15:20:42.645051');
INSERT INTO DISQUE VALUES(138,'Let It Bleed',44,'1969','620a3409','2006',17.02,3,'f','2008-03-12 12:48:07');
INSERT INTO DISQUE VALUES(139,'De l''amour de l''art ou du cochon',61,'1980','63088c08','1998',10.29,3,'f','2008-03-12 13:08:19');
INSERT INTO DISQUE VALUES(140,'Black and Blue',44,'1976','6309b408','1986',17.72,2,'f','2008-03-12 17:30:36');
INSERT INTO DISQUE VALUES(141,'G N'' R Lies',70,'1988','6507dc08','1989',17.73,3,'f','2008-03-12 17:06:28');
INSERT INTO DISQUE VALUES(142,'The Works',11,'1984','6508c609','1991',13.25,4,'f','2008-03-12 13:07:41');
INSERT INTO DISQUE VALUES(143,'IV',67,'1971','6509ff08','1991',14.02,3,'f','2008-03-16 15:44:27');
INSERT INTO DISQUE VALUES(144,'Woodstock CD2',8,'1970','65103907','1982',10.62,4,'f','2008-05-27 10:04:08.041629');
INSERT INTO DISQUE VALUES(145,'Arno',49,'1986','6608ae0a','1989',18.04,2,'f','2008-03-12 16:26:30');
INSERT INTO DISQUE VALUES(146,'Trash',71,'1989','6709720a','2005',16.99,2,'f','2008-03-12 17:49:09');
INSERT INTO DISQUE VALUES(147,'En attendant (Brouillard en Novembre...)',42,'1989','68082608','1991',17.9,2,'f','2008-03-12 10:27:00');
INSERT INTO DISQUE VALUES(148,'The Number Of The Beast',72,'1982','68097408','1993',13.55,2,'f','2008-03-12 12:48:48');
INSERT INTO DISQUE VALUES(149,'Woodstock CD1',8,'1970','c210370e','1976',16.03,4,'f','2008-05-27 10:04:01.360997');
INSERT INTO DISQUE VALUES(150,'Izzy Stradlin And The Ju Ju Hounds',73,'1992','6a0a370a','2001',11.17,2,'f','2008-03-12 18:06:27');
INSERT INTO DISQUE VALUES(151,'1984',74,'1983','6b07d309','1998',13.53,2,'t','2008-03-12 13:56:34');
INSERT INTO DISQUE VALUES(152,'Le Cimetière des Arlequins',63,'1973','6c086208','1977',19.12,4,'f','2008-03-12 18:24:42');
INSERT INTO DISQUE VALUES(153,'Raw Power',75,'1977','6d07eb08','1995',12.49,3,'f','2008-03-12 15:02:26');
INSERT INTO DISQUE VALUES(154,'''hours...''',52,'1999','6d0b080a','2001',11.84,2,'t','2008-03-12 08:57:35');
INSERT INTO DISQUE VALUES(155,'Songs of Leonard Cohen',76,'1968','6e09ae0a','1977',13.99,1,'f','2008-03-12 10:40:01');
INSERT INTO DISQUE VALUES(156,'Chroniques bluesymentales',61,'1999','6e0aa409','2001',15.54,2,'f','2008-03-12 16:27:51');
INSERT INTO DISQUE VALUES(157,'French Bazaar',49,'2004','f5117f12','2007',12.65,2,'f','2008-03-12 18:41:18');
INSERT INTO DISQUE VALUES(158,'Powerage',4,'1978','6f095a09','1982',17.3,2,'f','2008-03-12 18:04:07');
INSERT INTO DISQUE VALUES(159,'Dark Side Of The Moon',50,'1973','700a0f09','1999',12.96,2,'f','2008-03-12 15:35:24');
INSERT INTO DISQUE VALUES(160,'Météo für nada',61,'1986','72083f09','1989',11.12,2,'f','2008-03-12 15:25:31');
INSERT INTO DISQUE VALUES(161,'III',67,'1970','720a140a','1974',11.91,3,'f','2008-03-12 08:51:27');
INSERT INTO DISQUE VALUES(162,'Osez Joséphine',77,'1992','7409490b','1994',13.04,1,'f','2008-03-12 15:46:52');
INSERT INTO DISQUE VALUES(163,'Tommy',78,'1969','7411a218','1974',11.52,2,'f','2008-03-12 12:23:55');
INSERT INTO DISQUE VALUES(164,'Spécial jeux olympiques Séoul 88',51,'1988','75050308','1993',18.59,3,'f','2008-03-12 17:27:52');
INSERT INTO DISQUE VALUES(165,'T.C. Matic',79,'1991','7508700a','2004',18.69,2,'f','2008-03-12 12:38:33');
INSERT INTO DISQUE VALUES(166,'Highway To Hell',4,'1979','7609bb0a','1990',11.07,2,'f','2008-03-12 13:19:00');
INSERT INTO DISQUE VALUES(167,'Repression',42,'1980','7709770a','2005',19.1,1,'f','2008-03-12 11:10:41');
INSERT INTO DISQUE VALUES(168,'Billion Dollar Babies',71,'1973','7709a40a','1999',15.26,1,'f','2008-03-12 15:01:46');
INSERT INTO DISQUE VALUES(169,'She''s the Boss',80,'1985','770a1f09','2007',17.77,1,'f','2008-03-12 16:40:21');
INSERT INTO DISQUE VALUES(170,'Alertez les bébés',66,'1976','770adc0a','1989',11.09,2,'f','2008-03-12 09:17:47');
INSERT INTO DISQUE VALUES(171,'Blue Sky Mining',81,'1990','770afa0a','2008',17.05,1,'f','2008-03-12 15:22:38');
INSERT INTO DISQUE VALUES(172,'Ratata',49,'1990','7808580a','1991',11.67,1,'f','2008-03-12 09:01:25');
INSERT INTO DISQUE VALUES(173,'Aladdin Sane',52,'1973','7809bd0a','1982',17.23,1,'f','2008-03-12 19:23:48');
INSERT INTO DISQUE VALUES(174,'Enregistré en public',82,'1982','7a083209','1983',13.03,2,'f','2008-03-12 18:11:16');
INSERT INTO DISQUE VALUES(175,'Love It To Death',71,'1971','7a08b109','1986',10.96,1,'f','2008-03-12 17:35:55');
INSERT INTO DISQUE VALUES(176,'L''élite',42,'1979','7a09590b','1981',14.65,2,'f','2008-03-12 11:00:14');
INSERT INTO DISQUE VALUES(177,'A Momentary Lapse of Reason',50,'1987','7a0c010a','1994',15.19,3,'f','2008-03-12 12:17:24');
INSERT INTO DISQUE VALUES(178,'Avalon',83,'1982','7b08bf0a','2002',12.75,2,'f','2008-03-12 08:52:26');
INSERT INTO DISQUE VALUES(179,'Ballbreaker',4,'1995','ac0bb00b','2005',14.84,3,'f','2008-03-12 17:35:06');
INSERT INTO DISQUE VALUES(180,'December''s Children (And Everybody''s)',44,'1964','7c070e0c','1990',16.78,2,'f','2008-03-12 10:42:24');
INSERT INTO DISQUE VALUES(181,'Recycler',45,'1990','7c09590a','2000',11.24,1,'f','2008-03-12 19:21:46');
INSERT INTO DISQUE VALUES(182,'Naughty Little Doggie',84,'1996','7d09770a','2003',19.65,2,'f','2008-03-16 15:28:48');
INSERT INTO DISQUE VALUES(183,'Their Satanic Majesties Request',44,'1967','7d0a5c0a','1980',11.19,2,'f','2008-03-12 08:27:11');
INSERT INTO DISQUE VALUES(184,'In Ekstasy',85,'1985','7d0a890b','1990',18.36,2,'t','2008-03-12 18:21:23');
INSERT INTO DISQUE VALUES(185,'She''s So Unusual',86,'1983','7e090b0a','2007',15.62,2,'f','2008-03-12 09:07:58');
INSERT INTO DISQUE VALUES(186,'Easter',87,'1978','7e0b030c','1978',14.88,3,'f','2008-03-12 08:27:59');
INSERT INTO DISQUE VALUES(187,'Set the Twilight Reeling',56,'1996','7e0bf00b','2008',12.24,1,'f','2008-06-02 15:22:10.598691');
INSERT INTO DISQUE VALUES(188,'Peace And Noise',88,'1997','7e0c500a','2008',16.15,2,'f','2008-03-12 16:50:08');
INSERT INTO DISQUE VALUES(189,'Fly On The Wall',4,'1985','7f09720a','1990',17.8,2,'f','2008-03-16 09:38:43');
INSERT INTO DISQUE VALUES(190,'Irradié',66,'1975','7f0a240a','1983',19.94,2,'f','2008-03-12 10:48:26');
INSERT INTO DISQUE VALUES(191,'Who''s Next',78,'1971','7f0a2d09','1972',10.61,2,'f','2008-03-12 15:46:48');
INSERT INTO DISQUE VALUES(192,'Champagne pour tout le monde',66,'1979','80089109','1994',12.06,3,'f','2008-03-12 13:22:16');
INSERT INTO DISQUE VALUES(193,'No Man''s Land',66,'1978','80093008','1980',12.95,2,'f','2008-03-12 10:23:43');
INSERT INTO DISQUE VALUES(194,'The No Comprendo',89,'1986','800c190b','1991',14.35,2,'f','2008-03-12 13:14:05');
INSERT INTO DISQUE VALUES(195,'Sunsets On Empire (European Version)',90,'1997','800e550a','1997',17.78,3,'f','2008-03-12 18:21:12');
INSERT INTO DISQUE VALUES(196,'Promise',91,'1985','810cba0b','2007',15.74,1,'f','2008-03-12 17:24:40');
INSERT INTO DISQUE VALUES(197,'Body Wishes',92,'1983','8209b90a','1992',17.02,2,'f','2008-03-12 17:41:28');
INSERT INTO DISQUE VALUES(198,'Téléphone',93,'1977','83080d09','1992',15.95,2,'f','2008-03-12 08:23:19');
INSERT INTO DISQUE VALUES(199,'Lodger',52,'1979','8308490a','1991',17.42,3,'f','2008-03-12 10:31:58');
INSERT INTO DISQUE VALUES(200,'Greatest Hits CD1',65,'1991','83093009','1998',10.22,2,'f','2008-05-27 10:07:28.269456');
INSERT INTO DISQUE VALUES(201,'Let''s Stick Together',94,'1976','8708e20b','2004',13.1,2,'f','2008-03-12 12:24:33');
INSERT INTO DISQUE VALUES(202,'Sticky Fingers',44,'1970','830ae10a','2007',18.9,4,'t','2008-03-22 10:50:55');
INSERT INTO DISQUE VALUES(203,'Lust For Life',84,'1990','8409a209','2007',19.47,3,'f','2008-03-12 13:05:19');
INSERT INTO DISQUE VALUES(204,'Dure Limite',93,'1982','840a310a','1987',11.27,3,'f','2008-03-12 10:32:33');
INSERT INTO DISQUE VALUES(205,'Afterburner',45,'1985','8508ce0a','2006',12.65,2,'f','2008-03-12 11:22:55');
INSERT INTO DISQUE VALUES(206,'Aux héros de la voltige',66,'1994','85091b09','1998',11.62,1,'f','2008-03-12 13:11:19');
INSERT INTO DISQUE VALUES(207,'Earthling',52,'1997','850b7c09','2002',19.88,1,'f','2008-03-12 10:58:01');
INSERT INTO DISQUE VALUES(208,'It''s Only Rock And Roll',44,'1974','860b440a','1984',18.8,2,'f','2008-03-12 15:02:24');
INSERT INTO DISQUE VALUES(209,'Dernières balises (avant mutation)',61,'1981','8708d90a','1998',10.65,2,'f','2008-03-12 19:14:55');
INSERT INTO DISQUE VALUES(210,'Concert intégral à l''Olympia CD2',95,'1996','a10b5f0c','2003',12.33,2,'f','2008-05-27 10:06:11.324349');
INSERT INTO DISQUE VALUES(211,'Never Mind the Bollocks',96,'1977','8709040c','1988',17.45,2,'f','2008-03-12 16:33:05');
INSERT INTO DISQUE VALUES(212,'II',11,'1974','8709850b','1977',16.03,1,'f','2008-03-12 11:44:56');
INSERT INTO DISQUE VALUES(213,'Blow Up Your Video',4,'1988','870a120a','2006',10.16,2,'f','2008-03-12 10:12:02');
INSERT INTO DISQUE VALUES(214,'Together Alone',97,'1997','870a630b','2001',14.47,3,'f','2008-03-12 14:23:34');
INSERT INTO DISQUE VALUES(215,'Vacarmélite Ou La Nonne Bryante',98,'1992','88078f0b','2000',16.14,2,'f','2008-03-12 09:40:56');
INSERT INTO DISQUE VALUES(216,'L.A. Woman',99,'1971','880b810a','2004',17.05,1,'f','2008-03-12 08:09:07');
INSERT INTO DISQUE VALUES(217,'Concert intégral à l''Olympia CD1',95,'1996','b10b4d0e','2000',12.18,1,'f','2008-05-27 10:06:16.111063');
INSERT INTO DISQUE VALUES(218,'Tonight',52,'1984','89086709','1997',12.12,1,'f','2008-03-12 12:58:08');
INSERT INTO DISQUE VALUES(219,'Talk is Cheap',100,'1988','890b0a0b','2005',15.06,1,'f','2008-03-12 17:57:23');
INSERT INTO DISQUE VALUES(220,'Strange Days',99,'1969','8a08380a','1969',15.63,3,'t','2008-03-12 16:54:35');
INSERT INTO DISQUE VALUES(221,'Raise Your Fist and Yell',71,'1987','8a08ab0a','2002',14.18,3,'f','2008-03-12 12:38:08');
INSERT INTO DISQUE VALUES(222,'Never For Ever',101,'1980','8a08ca0b','1998',11.43,3,'f','2008-03-12 14:56:53');
INSERT INTO DISQUE VALUES(223,'Crazy World',102,'1990','8a0c770b','2006',14.01,2,'f','2008-03-12 13:09:06');
INSERT INTO DISQUE VALUES(224,'Le bonheur de la tentation',61,'1998','8a0c8c0b','2002',17.22,1,'f','2008-03-12 13:41:29');
INSERT INTO DISQUE VALUES(225,'Nina Hagen Band',103,'1978','8b09dd0b','1990',15.09,2,'f','2008-03-12 08:48:10');
INSERT INTO DISQUE VALUES(226,'Love You Live CD1',44,'1977','8b0a070a','1998',10.57,1,'f','2008-05-27 10:11:36.85576');
INSERT INTO DISQUE VALUES(227,'Denim and leather',104,'1981','8c08ee09','2002',18.5,1,'t','2008-03-12 09:12:39');
INSERT INTO DISQUE VALUES(228,'Beggars Banquet',44,'1968','8c09830a','2004',18.99,1,'f','2008-03-16 10:35:38');
INSERT INTO DISQUE VALUES(229,'Paradis Païen',66,'1998','8d0a290a','2008',10.86,1,'f','2008-03-12 12:22:35');
INSERT INTO DISQUE VALUES(230,'Mojo Box',105,'2004','a909ba0d','2007',15.13,1,'f','2008-03-12 17:05:29');
INSERT INTO DISQUE VALUES(231,'Brothers In Arms',106,'1985','8d0cf309','1990',16.92,1,'f','2008-03-16 12:29:08');
INSERT INTO DISQUE VALUES(232,'Crache ton venin',93,'1979','8e086f0a','2000',17.88,1,'f','2008-03-12 14:00:04');
INSERT INTO DISQUE VALUES(233,'Lionheart',101,'1978','8e08a80a','2006',12.85,3,'f','2008-03-12 13:27:13');
INSERT INTO DISQUE VALUES(234,'Pizza',77,'1981','8e09940d','2002',15.14,2,'f','2008-03-12 14:56:55');
INSERT INTO DISQUE VALUES(235,'Super Hits',107,'1971','8309790a','1997',13.19,2,'f','2008-03-12 08:59:43');
INSERT INTO DISQUE VALUES(236,'No One Is Innocent',108,'1994','8e0c580c','2005',11.23,1,'f','2008-03-12 10:59:33');
INSERT INTO DISQUE VALUES(237,'Soul Surfing',109,'2002','8e0cc30c','2007',11.43,2,'f','2008-03-12 14:07:45');
INSERT INTO DISQUE VALUES(238,'Eliminator',45,'1983','8f0aa10b','1995',18.74,2,'f','2008-03-12 09:22:20');
INSERT INTO DISQUE VALUES(239,'Ram It Down',110,'1988','8f0ba30a','1992',11.58,2,'f','2008-03-12 17:45:43');
INSERT INTO DISQUE VALUES(240,'Waiting for the Sun',99,'1968','9007c80b','1982',12.92,1,'f','2008-03-12 12:32:49');
INSERT INTO DISQUE VALUES(241,'Sheik Yerbouti',111,'1979','e810c712','1999',15.51,3,'f','2008-03-12 18:55:19');
INSERT INTO DISQUE VALUES(242,'Antenna',45,'1994','910cda0c','2002',19.52,2,'f','2008-03-12 08:26:19');
INSERT INTO DISQUE VALUES(243,'A Night at the Opera',11,'1975','920a1c0c','1994',15.58,3,'f','2008-03-12 09:51:46');
INSERT INTO DISQUE VALUES(244,'Stairway To Heaven/Highway To Hell',112,'1989','920ac80b','2004',16.24,2,'f','2008-03-12 11:22:42');
INSERT INTO DISQUE VALUES(245,'A night to remember',86,'1989','9309570c','1994',14.03,2,'f','2008-03-12 10:23:42');
INSERT INTO DISQUE VALUES(246,'Goats Head Soup',44,'1973','930b000a','1975',19.66,2,'f','2008-03-16 19:34:42');
INSERT INTO DISQUE VALUES(247,'Spread it all around',113,'1998','960a780c','2006',17.48,1,'f','2008-03-12 14:05:50');
INSERT INTO DISQUE VALUES(248,'Bringing it All Back Home',14,'1967','960b1d0b','1982',13.86,2,'f','2008-03-12 11:15:12');
INSERT INTO DISQUE VALUES(249,'Primitive Cool',80,'1987','960b900a','1988',11.54,2,'f','2008-03-12 15:03:58');
INSERT INTO DISQUE VALUES(250,'Got Live If You Want It!',44,'1966','97084f0c','2007',12.87,2,'f','2008-03-12 12:26:30');
INSERT INTO DISQUE VALUES(251,'Pin Ups',52,'1974','9709900e','1991',13.31,3,'f','2008-03-12 10:19:26');
INSERT INTO DISQUE VALUES(252,'The Doors',99,'1967','970a6d0b','2002',16.32,2,'f','2008-03-12 14:20:52');
INSERT INTO DISQUE VALUES(253,'Autorisation de délirer n°STE 26505',61,'1979','9809120b','1995',13.85,2,'f','2008-03-12 17:25:44');
INSERT INTO DISQUE VALUES(254,'Homogenic',6,'1997','8d0a370a','2000',13.31,1,'f','2008-03-12 15:44:06');
INSERT INTO DISQUE VALUES(255,'Little Village',114,'1992','980ade0b','2006',11.73,4,'f','2008-03-12 11:58:30');
INSERT INTO DISQUE VALUES(256,'Plâtre et ciment',115,'1987','980be30b','2002',18.31,2,'f','2008-03-12 08:56:04');
INSERT INTO DISQUE VALUES(257,'Rainy Season',109,'2000','980c7c0b','2004',19.04,3,'f','2008-03-12 16:28:10');
INSERT INTO DISQUE VALUES(258,'Gone Again',88,'1996','980d1b0b','2000',10.46,3,'f','2008-03-12 14:45:25');
INSERT INTO DISQUE VALUES(259,'Hey Stoopid',71,'1991','980d310c','1993',16.84,3,'f','2008-03-12 17:24:28');
INSERT INTO DISQUE VALUES(260,'Remasters CD2',67,'1990','9810ed0b','1990',15.16,2,'f','2008-05-27 10:08:55.583178');
INSERT INTO DISQUE VALUES(261,'Veuillez rendre L''âme (à qui elle appartient)',57,'1989','9908910b','2008',10.53,2,'f','2008-03-12 11:57:15');
INSERT INTO DISQUE VALUES(262,'Un autre monde',93,'1984','9909430b','2003',18.91,2,'f','2008-03-16 16:27:35');
INSERT INTO DISQUE VALUES(263,'The Spaghetti Incident?',70,'1993','990ad10c','2005',11.78,2,'f','2008-03-12 14:17:01');
INSERT INTO DISQUE VALUES(264,'Fantaisie militaire',77,'1998','990ba00c','2000',12.5,2,'f','2008-03-12 11:53:46');
INSERT INTO DISQUE VALUES(265,'Emile Jacotey',63,'1975','9a0a370a','2004',11.01,1,'f','2008-03-12 13:12:45');
INSERT INTO DISQUE VALUES(266,'Five is not enough CD2',44,'1993','9a0f5c0b','2007',19.74,2,'f','2008-05-27 10:12:59.033152');
INSERT INTO DISQUE VALUES(267,'Louis Bertignac et les Visiteurs',116,'1987','9b09730c','2007',12.36,1,'f','2008-03-12 08:58:10');
INSERT INTO DISQUE VALUES(268,'No Need To Argue',117,'1994','9b0bee0d','2002',10.65,3,'f','2008-03-12 10:32:56');
INSERT INTO DISQUE VALUES(269,'Dirty Work',44,'1986','9c09630b','1994',15.59,2,'f','2008-03-12 15:19:20');
INSERT INTO DISQUE VALUES(270,'Steel Wheels',44,'1989','9c0c6f0c','1991',18.82,4,'f','2008-03-12 09:04:06');
INSERT INTO DISQUE VALUES(271,'Morrison Hotel',99,'1970','9d08c60b','1992',19.58,3,'f','2008-03-12 08:21:04');
INSERT INTO DISQUE VALUES(272,'Souvent Fauché Toujours Marteau',47,'1989','9e08d40c','2002',12.99,2,'f','2008-03-12 11:03:32');
INSERT INTO DISQUE VALUES(273,'Ummagumma CD2',50,'1969','9e0b090c','1979',18.66,3,'f','2008-05-27 10:12:03.887515');
INSERT INTO DISQUE VALUES(274,'Tin Machine II',118,'1991','9e0b820c','2005',19.77,3,'f','2008-03-12 18:56:43');
INSERT INTO DISQUE VALUES(275,'Défloration13',61,'2001','9e0d660b','2008',17.5,3,'f','2008-03-12 15:22:56');
INSERT INTO DISQUE VALUES(276,'The Heart of Saturday Night',119,'1974','9f09be0b','1995',10.77,2,'f','2008-03-12 12:18:11');
INSERT INTO DISQUE VALUES(277,'Without You I''m Nothing',120,'1988','9f0f710c','1995',16.58,3,'f','2008-03-12 09:19:09');
INSERT INTO DISQUE VALUES(278,'Transformer',56,'1972','a008b30b','1993',16.53,2,'f','2008-03-12 11:30:42');
INSERT INTO DISQUE VALUES(279,'-Bleach-',121,'1989','a00a040d','1996',14.11,3,'f','2008-03-12 10:06:02');
INSERT INTO DISQUE VALUES(280,'Tango Massaï',68,'1995','a10a5b0b','2002',15.03,2,'f','2008-03-12 14:12:07');
INSERT INTO DISQUE VALUES(281,'Simple et tendre',122,'1993','a10b1b0c','1997',19.04,2,'f','2008-03-12 16:12:28');
INSERT INTO DISQUE VALUES(282,'No Substance',123,'1998','de09cf10','2005',15.14,2,'f','2008-03-12 16:28:31');
INSERT INTO DISQUE VALUES(283,'Tout corps vivant branché sur le secteur étant appelé à s''émouvoir',61,'1978','a308c30b','1985',19.72,3,'t','2008-03-12 11:19:09');
INSERT INTO DISQUE VALUES(284,'Au cœur de la nuit',93,'1980','a309c70d','1986',19.47,2,'f','2008-04-13 12:26:33');
INSERT INTO DISQUE VALUES(285,'Marc & Robert',89,'1988','a30a240b','1991',14.9,4,'f','2008-03-12 09:13:06');
INSERT INTO DISQUE VALUES(286,'Face Value',124,'1981','a30b340c','1991',19.55,3,'f','2008-03-12 18:52:29');
INSERT INTO DISQUE VALUES(287,'Moustaki',125,'2003','920bba0d','2005',10.19,3,'f','2008-03-12 17:17:47');
INSERT INTO DISQUE VALUES(288,'1916',126,'1991','a4093f0b','1992',13.2,3,'f','2008-03-12 19:24:07');
INSERT INTO DISQUE VALUES(289,'The Wall CD2',50,'1979','a409d00d','1990',11.51,1,'f','2008-05-27 10:11:51.109242');
INSERT INTO DISQUE VALUES(290,'Post Orgasmic Chill',127,'1999','a50bef0c','2008',15.02,2,'f','2008-03-12 18:55:44');
INSERT INTO DISQUE VALUES(291,'The Rolling Stones',44,'1964','a607d40c','2004',16.74,2,'f','2008-03-12 18:29:56');
INSERT INTO DISQUE VALUES(292,'Small Change',119,'1976','a60bb80b','2001',11.6,4,'f','2008-03-12 08:09:09');
INSERT INTO DISQUE VALUES(293,'Heroes',52,'1977','a80b1b0c','1994',14.01,2,'f','2008-03-12 14:54:38');
INSERT INTO DISQUE VALUES(294,'Stoosh',127,'1996','a80b260b','2001',11.93,4,'f','2008-03-12 08:11:57');
INSERT INTO DISQUE VALUES(295,'Nevermind',121,'1991','a80de90c','2001',17.31,2,'f','2008-03-12 10:18:10');
INSERT INTO DISQUE VALUES(296,'Patchanka',128,'1988','a909150e','1999',11.82,3,'f','2008-03-12 11:09:03');
INSERT INTO DISQUE VALUES(297,'King Of Bongo',128,'1991','a909a70e','2008',10.4,4,'f','2008-03-12 17:56:20');
INSERT INTO DISQUE VALUES(298,'Hounds Of Love',101,'1985','aa0b250c','1997',16.74,1,'f','2008-03-12 15:55:45');
INSERT INTO DISQUE VALUES(299,'Des visages des figures',57,'2001','aa10220c','2003',16.2,1,'f','2008-03-12 16:04:26');
INSERT INTO DISQUE VALUES(300,'Let Go',129,'2002','b611560e','2002',19.88,2,'f','2008-03-12 12:55:22');
INSERT INTO DISQUE VALUES(301,'Metallica',130,'1991','ab0ead0c','2008',13.28,2,'f','2008-03-12 09:49:51');
INSERT INTO DISQUE VALUES(302,'Bridges To Babylon',44,'1997','ac0ea30d','1999',14.01,2,'f','2008-03-12 08:51:01');
INSERT INTO DISQUE VALUES(303,'The Wall CD1',50,'1979','ad09290d','2001',16.08,2,'f','2008-05-27 10:11:59.490936');
INSERT INTO DISQUE VALUES(304,'666.667 Club',57,'1996','ad0bdd0d','1996',16.38,1,'f','2008-03-12 18:24:07');
INSERT INTO DISQUE VALUES(305,'Heathen',52,'2002','ad0c1f0c','2003',16.23,2,'f','2008-03-12 17:37:26');
INSERT INTO DISQUE VALUES(306,'Daho Live CD2',131,'2001','ad0cc00c','2007',16.72,4,'f','2008-05-27 10:07:03.705132');
INSERT INTO DISQUE VALUES(307,'Higelin, tombé du ciel',66,'1988','ad0f420c','1995',14.96,3,'t','2008-03-12 08:45:32');
INSERT INTO DISQUE VALUES(308,'Live ''75 - ''85 #1',132,'1986','ad113c0d','1995',19.83,3,'f','2008-03-12 12:22:27');
INSERT INTO DISQUE VALUES(309,'De toutes façons',133,'2000','ae0bdb0d','2006',14.32,3,'f','2008-03-12 09:06:31');
INSERT INTO DISQUE VALUES(310,'Appetite For Destruction',70,'1987','ae0c9d0c','1989',17.69,2,'f','2008-03-12 15:27:27');
INSERT INTO DISQUE VALUES(311,'Ecstasy',56,'2000','ae12220e','2006',16.55,2,'f','2008-03-12 19:33:16');
INSERT INTO DISQUE VALUES(312,'Twist',134,'1974','9907450c','1986',16.2,3,'f','2008-03-12 17:36:08');
INSERT INTO DISQUE VALUES(313,'Tostaky',57,'1998','af0ae60c','2007',19.8,2,'f','2008-03-12 18:49:30');
INSERT INTO DISQUE VALUES(314,'La tentation du bonheur',61,'1996','af0bcc0c','2000',19.76,4,'f','2008-03-12 17:39:55');
INSERT INTO DISQUE VALUES(315,'Live At Leeds',78,'1995','af12120e','2003',18.89,3,'f','2008-03-12 18:27:32');
INSERT INTO DISQUE VALUES(316,'Irrécupérables...',68,'1990','b00b300e','2002',18,2,'f','2008-03-12 12:26:29');
INSERT INTO DISQUE VALUES(317,'With the Beatles',135,'1963','b107d40e','1998',11.7,3,'f','2008-03-12 19:29:15');
INSERT INTO DISQUE VALUES(318,'The Man Who Sold The World',52,'1971','b10ca60d','1996',16.62,1,'f','2008-03-12 13:53:37');
INSERT INTO DISQUE VALUES(319,'Wandering Spirit',80,'1992','b10cae0e','1999',19.42,3,'f','2008-03-12 19:01:43');
INSERT INTO DISQUE VALUES(320,'New York',56,'1989','b10d560e','1998',17.35,1,'f','2008-03-12 13:37:11');
INSERT INTO DISQUE VALUES(321,'In Utero',121,'1993','b1102f0c','2008',14.12,2,'f','2008-03-12 18:35:45');
INSERT INTO DISQUE VALUES(322,'White Album CD2',135,'1968','b20b120d','2006',18.67,2,'f','2008-05-27 10:05:27.358588');
INSERT INTO DISQUE VALUES(323,'Urban Solitude',97,'1999','b20b920d','2007',10.9,1,'f','2008-03-12 11:15:11');
INSERT INTO DISQUE VALUES(324,'David Bowie',52,'1967','b309360e','1968',13.34,3,'f','2008-03-16 17:01:50');
INSERT INTO DISQUE VALUES(325,'À La Française',49,'1995','b40ac10d','2008',17.15,2,'f','2008-03-12 16:55:18');
INSERT INTO DISQUE VALUES(326,'The Proximity Effect',43,'1998','b50c800d','2005',11.09,2,'f','2008-03-12 11:16:45');
INSERT INTO DISQUE VALUES(327,'Système D',89,'1993','b50e5d0e','1999',17.57,1,'f','2008-03-12 17:11:14');
INSERT INTO DISQUE VALUES(328,'Money for nothing',106,'1988','b50f8f0c','1996',12.42,3,'f','2008-03-12 08:39:07');
INSERT INTO DISQUE VALUES(329,'No Control',123,'1989','b6062f0f','2001',13.93,2,'f','2008-03-12 15:35:09');
INSERT INTO DISQUE VALUES(330,'Diamond Dogs',52,'1974','b60ae20d','2005',14.41,2,'f','2008-03-12 12:02:46');
INSERT INTO DISQUE VALUES(331,'Fragments d''hébétude',61,'1993','b60fa30e','1996',18.39,3,'f','2008-03-12 14:55:22');
INSERT INTO DISQUE VALUES(332,'Charles Ernest',49,'2002','b70cad0f','2005',16,3,'f','2008-03-12 12:06:47');
INSERT INTO DISQUE VALUES(333,'Goddess in the doorway',80,'2001','b70d530c','2008',10.15,2,'f','2008-03-12 16:25:02');
INSERT INTO DISQUE VALUES(334,'Version 2.0',136,'1998','b90ba20c','2003',17.36,2,'f','2008-03-12 18:14:04');
INSERT INTO DISQUE VALUES(335,'*Rita Mitsouko*',89,'1984','ba0df90e','2006',13.73,2,'f','2008-03-12 16:58:00');
INSERT INTO DISQUE VALUES(336,'Space Oddity',52,'1972','bb0d550d','1986',17.5,3,'f','2008-03-12 08:16:16');
INSERT INTO DISQUE VALUES(337,'Labyrinthe',137,'1988','bd0c1b0d','2003',18.08,3,'f','2008-03-12 17:02:28');
INSERT INTO DISQUE VALUES(338,'Songs For Drella',138,'1990','bf0cdc0f','2000',11.94,1,'f','2008-03-12 08:04:07');
INSERT INTO DISQUE VALUES(339,'Live ''75 - ''85 #3',132,'1986','bf110d0d','1995',12.76,4,'f','2008-03-12 09:43:43');
INSERT INTO DISQUE VALUES(340,'Sgt. Pepper''s Lonely Hearts Club Band',135,'1967','c009560d','1986',15.89,2,'f','2008-03-12 11:07:45');
INSERT INTO DISQUE VALUES(341,'Du ciment sous les plaines',57,'1991','c00bd00e','1995',11.91,1,'f','2008-03-12 09:42:41');
INSERT INTO DISQUE VALUES(342,'Idiots Savants',49,'1993','c00be70d','1998',16.85,3,'f','2008-03-12 13:02:47');
INSERT INTO DISQUE VALUES(343,'La marmaille nue',139,'1993','c109d00f','2006',12.95,2,'f','2008-03-12 11:45:13');
INSERT INTO DISQUE VALUES(344,'Never Let Me Down (Japanese Version)',52,'1988','c10d4a0c','2001',14.19,2,'f','2008-03-12 11:38:27');
INSERT INTO DISQUE VALUES(345,'Last of the rockstars...and me and you: The Trio',109,'2003','8a0c290a','2007',19.83,3,'f','2008-03-12 12:22:26');
INSERT INTO DISQUE VALUES(346,'*Get A Grip*',140,'1993','c50f600f','1996',18.9,3,'f','2008-03-12 12:25:42');
INSERT INTO DISQUE VALUES(347,'Les Wampas... vous aiment',122,'1990','c6088510','2006',14.82,1,'f','2008-03-12 15:12:45');
INSERT INTO DISQUE VALUES(348,'The Best Of (Words And Music Of Lou Reed)',141,'1989','c60e9a0f','1990',12.74,3,'f','2008-03-12 09:14:49');
INSERT INTO DISQUE VALUES(349,'No Security',44,'1998','c60fe60e','2007',11.44,2,'f','2008-03-12 10:24:33');
INSERT INTO DISQUE VALUES(350,'Kiss...',122,'2000','c709af10','2003',11.27,2,'f','2008-03-12 19:43:40');
INSERT INTO DISQUE VALUES(351,'The Best Of 1980-1990',142,'1998','c70f5e0e','1998',14.45,2,'f','2008-03-12 16:49:22');
INSERT INTO DISQUE VALUES(352,'Revolver',135,'1966','c808330e','1968',16.1,2,'f','2008-03-12 12:17:25');
INSERT INTO DISQUE VALUES(353,'Boucan d''enfer',143,'2002','c90c710e','2002',16.24,3,'f','2008-03-12 10:32:10');
INSERT INTO DISQUE VALUES(354,'Black Tie White Noise',52,'1993','c90f950e','1998',19.72,2,'f','2008-03-12 12:49:48');
INSERT INTO DISQUE VALUES(355,'La Ouache',144,'1998','ca0b570d','2005',10.74,2,'f','2008-03-12 18:11:11');
INSERT INTO DISQUE VALUES(356,'Royaume de jeunesse',68,'1992','ca0bb30e','2006',19.98,2,'f','2008-03-12 11:33:37');
INSERT INTO DISQUE VALUES(357,'Use Your Illusion II',70,'1991','ca11cd0e','2003',16.09,1,'f','2008-03-12 08:11:50');
INSERT INTO DISQUE VALUES(358,'Trop Précieux',122,'1996','cb09b40f','2005',14.41,1,'f','2008-03-12 17:17:05');
INSERT INTO DISQUE VALUES(359,'B-Sides 1980-1990',142,'1998','cb0e090f','2008',15.5,4,'f','2008-03-12 15:31:29');
INSERT INTO DISQUE VALUES(360,'Houla la !',51,'1986','cd079e10','2005',17.08,2,'f','2008-03-12 09:28:12');
INSERT INTO DISQUE VALUES(361,'Concerto pour Détraqués',47,'1985','cd0c0110','1991',11.82,2,'f','2008-03-12 17:10:02');
INSERT INTO DISQUE VALUES(362,'Hunky Dory',52,'1971','cd0d6a0f','1992',15.57,2,'f','2008-03-12 10:33:19');
INSERT INTO DISQUE VALUES(363,'Up',145,'1998','cd0f1f0e','2007',11.74,1,'f','2008-03-12 15:44:51');
INSERT INTO DISQUE VALUES(364,'Live ''75 - ''85 #2',132,'1986','cd10590e','1996',18.16,2,'t','2008-03-12 17:08:41');
INSERT INTO DISQUE VALUES(365,'Voodoo Lounge',44,'1994','ce0e900f','2007',18.31,2,'f','2008-03-12 15:00:53');
INSERT INTO DISQUE VALUES(366,'Five is not enough CD1',44,'1993','ce11530e','2005',14.67,4,'f','2008-05-27 10:13:04.170877');
INSERT INTO DISQUE VALUES(367,'Aï',66,'1985','cf0e4610','2006',14.84,3,'f','2008-03-12 12:18:38');
INSERT INTO DISQUE VALUES(368,'Blur',146,'1997','d20d5b0e','2001',16.79,2,'f','2008-03-12 10:04:56');
INSERT INTO DISQUE VALUES(369,'Stars on Trash',112,'1988','d30ce40f','2004',11.5,3,'f','2008-03-12 11:40:27');
INSERT INTO DISQUE VALUES(370,'Dans mon lit',66,'1973','d408120d','1995',13.46,3,'f','2008-03-12 17:49:56');
INSERT INTO DISQUE VALUES(371,'Remasters CD1',67,'1990','d411160f','2007',18.73,2,'f','2008-05-27 10:09:01.043539');
INSERT INTO DISQUE VALUES(372,'Tin Machine',118,'1989','d60d500e','1992',12.58,1,'f','2008-03-12 08:50:41');
INSERT INTO DISQUE VALUES(373,'Scary Monsters',52,'1979','d60e400e','2004',17.91,3,'f','2008-03-12 12:27:26');
INSERT INTO DISQUE VALUES(374,'Stripped',44,'1995','d80df60e','2006',18.87,2,'f','2008-03-16 11:14:34');
INSERT INTO DISQUE VALUES(375,'Last of the rockstars...and me and you: The Band',109,'2003','9a0fee0c','2003',18.05,3,'f','2008-03-12 19:50:34');
INSERT INTO DISQUE VALUES(376,'Dragon libre',68,'1991','d90bc60f','2004',13.82,3,'f','2008-03-12 18:37:53');
INSERT INTO DISQUE VALUES(377,'Flashpoint',44,'1991','d9120211','1994',15.76,3,'f','2008-03-16 11:02:12');
INSERT INTO DISQUE VALUES(378,'When I Was Born For The 7th Time',147,'1997','da0cc20f','1998',13.06,4,'f','2008-03-12 19:17:16');
INSERT INTO DISQUE VALUES(379,'Greatest Hits 1973-1988',140,'1997','da102011','1998',13.05,1,'f','2008-03-12 18:37:57');
INSERT INTO DISQUE VALUES(380,'Bowie At The Beeb CD3',52,'2000','da11630f','2000',11.18,1,'f','2008-05-27 10:05:13.657496');
INSERT INTO DISQUE VALUES(381,'Low',52,'1977','db0bd60e','1978',15.48,1,'f','2008-03-12 11:29:25');
INSERT INTO DISQUE VALUES(382,'Soul Surfing Tour Live 2002',109,'2002','d0105d0d','2002',15.92,2,'f','2008-03-12 12:33:16');
INSERT INTO DISQUE VALUES(383,'Casa Babylon',128,'1994','e20b9610','1998',15.6,2,'f','2008-03-12 08:57:43');
INSERT INTO DISQUE VALUES(384,'White Album CD1',135,'1968','e30ade11','1987',12.5,2,'t','2008-05-27 10:05:20.765862');
INSERT INTO DISQUE VALUES(385,'Ziggy Stardust',52,'1972','e50d2710','2007',10.94,2,'f','2008-03-12 09:10:48');
INSERT INTO DISQUE VALUES(386,'Chicoutimi',122,'1998','e70a7912','2004',19.84,4,'f','2008-03-12 16:01:26');
INSERT INTO DISQUE VALUES(387,'En concert à Bercy CD1',61,'1999','e8106810','1999',14.53,2,'f','2008-05-27 10:14:07.414193');
INSERT INTO DISQUE VALUES(388,'Liberté De Circulation',112,'1999','ea11620f','2003',16.61,2,'f','2008-03-12 17:14:46');
INSERT INTO DISQUE VALUES(389,'American Caesar',84,'1993','ed11ca11','2004',14.72,3,'f','2008-03-12 08:06:23');
INSERT INTO DISQUE VALUES(390,'Bowie At The Beeb CD2',52,'2000','ef0fe813','2000',15.38,2,'f','2008-05-27 10:05:07.255582');
INSERT INTO DISQUE VALUES(391,'Exile On Main Street',44,'1972','f00f9812','1987',14.15,3,'f','2008-03-16 17:42:19');
INSERT INTO DISQUE VALUES(392,'The Star Collection',148,'1991','f10cb010','1997',12.78,2,'f','2008-03-12 10:05:53');
INSERT INTO DISQUE VALUES(393,'Puta''s Fever',128,'1989','f7098b12','1993',15.47,2,'f','2008-03-12 13:10:51');
INSERT INTO DISQUE VALUES(394,'Use Your Illusion I',70,'1991','fa11d510','2001',17.59,1,'f','2008-03-12 10:41:04');
INSERT INTO DISQUE VALUES(395,'Abbey Road',135,'1969','fb0b1c11','1984',18.76,2,'f','2008-03-12 09:46:15');
INSERT INTO DISQUE VALUES(396,'Bowie At The Beeb CD1',52,'2000','fb112c12','2007',15.47,1,'f','2008-05-27 10:04:58.856175');
INSERT INTO DISQUE VALUES(397,'Bar Aid',112,'1992','fc0fd113','1996',16.22,3,'f','2008-03-12 12:59:35');
INSERT INTO DISQUE VALUES(398,'The Borderline, live in London',109,'2003','730c0d09','2006',10.54,3,'f','2008-03-12 18:44:50');
INSERT INTO DISQUE VALUES(399,'Strings Of The Storm #2',109,'2003','940ca00b','2004',14.72,3,'f','2008-03-12 15:47:57');
INSERT INTO DISQUE VALUES(400,'Strings Of The Storm #1',109,'2003','840cd60b','2004',16.41,1,'f','2008-03-12 08:46:24');
INSERT INTO DISQUE VALUES(401,'No Quarter',149,'1994','d612aa0e','2002',11.23,1,'f','2008-03-12 18:32:06');
INSERT INTO DISQUE VALUES(402,'C''est beau une ville la nuit',150,'2002','690fe308','2003',14.43,2,'f','2008-03-12 10:44:12');
INSERT INTO DISQUE VALUES(403,'Reality CD1',52,'2003','8e0b930b','2008',13.28,1,'f','2008-03-12 09:12:23');
INSERT INTO DISQUE VALUES(404,'Reality CD2 Limited Edition',52,'2003','16026603','2004',16.94,3,'f','2008-03-12 19:23:04');
INSERT INTO DISQUE VALUES(405,'Ex Fan des Sixties',95,'2001','b209e90f','2002',12.12,2,'f','2008-03-12 08:33:50');
INSERT INTO DISQUE VALUES(406,'Ma gonzesse',143,'1979','72082b0a','2008',16.92,2,'f','2008-03-12 11:31:16');
INSERT INTO DISQUE VALUES(407,'Un Olympia pour moi tout seul CD2',143,'1982','7409e809','1984',12.76,2,'f','2008-05-27 10:12:47.166251');
INSERT INTO DISQUE VALUES(408,'Renaud Tour 89 : Visage pâle rencontrer public CD1',143,'1989','a50b9d0b','2006',14.06,4,'f','2008-05-27 10:12:42.92403');
INSERT INTO DISQUE VALUES(409,'Renaud Tour 89 : Visage pâle rencontrer public CD2',143,'1989','61092008','1998',12.75,2,'f','2008-05-27 10:12:38.215798');
INSERT INTO DISQUE VALUES(410,'Un Olympia pour moi tout seul CD1',143,'1982','770ad60a','1997',14.68,3,'f','2008-05-27 10:12:53.133113');
INSERT INTO DISQUE VALUES(411,'Le retour de Gérard Lambert',143,'1981','7a0a0f0b','2000',10.38,4,'f','2008-03-12 12:24:07');
INSERT INTO DISQUE VALUES(412,'Marche à l''ombre',143,'1980','90090c0a','1990',15.28,2,'f','2008-03-12 13:36:52');
INSERT INTO DISQUE VALUES(413,'Cante el'' Nord',143,'1993','9f0a6e0c','1998',14.47,1,'f','2008-03-12 16:42:04');
INSERT INTO DISQUE VALUES(414,'À la belle de Mai',143,'1994','a10b6c0c','1999',19.74,4,'f','2008-03-12 08:39:27');
INSERT INTO DISQUE VALUES(415,'Place de ma mob',143,'1977','a608450c','1996',13.38,2,'t','2008-03-12 09:40:00');
INSERT INTO DISQUE VALUES(416,'Amoureux de Paname',143,'1975','b708ac0d','2000',18.47,3,'f','2008-03-12 19:56:32');
INSERT INTO DISQUE VALUES(417,'Le P''tit Bal du Samedi Soir',143,'1981','c6088a0c','1996',16.21,2,'f','2008-03-12 11:30:27');
INSERT INTO DISQUE VALUES(418,'Putain De Camion',143,'1988','980c2a0c','2008',13.78,1,'f','2008-03-12 14:39:16');
INSERT INTO DISQUE VALUES(419,'Mistral Gagnant',143,'1985','a609c20b','2008',13.96,2,'f','2008-03-12 14:39:45');
INSERT INTO DISQUE VALUES(420,'Renaud à Bobino',143,'1980','f2111712','2007',15.66,1,'f','2008-03-12 12:36:16');
INSERT INTO DISQUE VALUES(421,'Morgane De Toi',143,'1983','7b0a470a','2005',14.18,2,'f','2008-03-12 19:58:40');
INSERT INTO DISQUE VALUES(422,'Marchand de cailloux',143,'1991','ce0c630e','1993',16.46,3,'f','2008-03-12 08:26:17');
INSERT INTO DISQUE VALUES(423,'Yield',151,'1998','a10b620d','2002',17.93,2,'f','2008-03-12 19:07:00');
INSERT INTO DISQUE VALUES(424,'La Femme Trombone',89,'2002','c30a380d','2007',10.72,3,'t','2008-03-12 08:11:39');
INSERT INTO DISQUE VALUES(425,'Ragged Glory',152,'1990','880eb20a','2007',15.27,3,'f','2008-03-12 13:19:19');
INSERT INTO DISQUE VALUES(426,'Never trust a guy who after having been a punk is now playing electro',122,'2003','c10ab20f','2003',19.9,2,'f','2008-03-12 14:18:16');
INSERT INTO DISQUE VALUES(427,'The Essential Lynyrd Skynyrd CD1',153,'1998','bc0ffd0d','2001',10.85,4,'f','2008-03-12 08:34:46');
INSERT INTO DISQUE VALUES(428,'The Essential Lynyrd Skynyrd CD2',153,'1998','9f0eb60c','2004',15.32,2,'f','2008-03-12 14:06:25');
INSERT INTO DISQUE VALUES(429,'The Great Rock N Roll Swindle',96,'1979','3211e017','2008',11.94,4,'f','2008-03-12 17:40:04');
INSERT INTO DISQUE VALUES(430,'Trans-Europe Express',154,'1977','510a0407','2004',19.52,1,'f','2008-03-12 14:02:41');
INSERT INTO DISQUE VALUES(431,'Journey (The Best Of)',155,'1996','1a10d515','2008',18.25,2,'f','2008-03-12 17:59:39');
INSERT INTO DISQUE VALUES(432,'The Secret Policeman Concert',156,'1982','910ba40b','2004',17.67,2,'f','2008-03-12 13:04:05');
INSERT INTO DISQUE VALUES(433,'Born to Boogie - The Collection',48,'2001','2a0cff12','2004',17.76,1,'f','2008-03-12 17:01:12');
INSERT INTO DISQUE VALUES(434,'The Concert In Central Park',157,'1982','0711ab13','1987',10.86,1,'f','2008-03-12 17:03:24');
INSERT INTO DISQUE VALUES(435,'Ni dieu ni maître',42,'2000','9b0ac00c','2006',10.21,2,'f','2008-03-12 13:33:43');
INSERT INTO DISQUE VALUES(436,'News Of The World',11,'1977','82093c0b','1993',14.31,2,'f','2008-03-12 17:03:02');
INSERT INTO DISQUE VALUES(437,'Cool Frenesie',89,'2000','b70f2f0e','2005',11.02,1,'f','2008-03-12 08:05:36');
INSERT INTO DISQUE VALUES(438,'Le poisson Rouge',158,'2000','33126314','2002',19.97,2,'f','2008-03-12 17:35:43');
INSERT INTO DISQUE VALUES(439,'Panique Celtique',159,'1998','6a0a520b','2005',17.56,2,'f','2008-03-12 10:22:23');
INSERT INTO DISQUE VALUES(440,'Brèves rencontres',160,'1995','74098f0b','2005',17.63,1,'f','2008-03-12 11:54:26');
INSERT INTO DISQUE VALUES(441,'Dire Straits',106,'1978','7c09b609','1994',19.42,1,'f','2008-03-12 19:42:26');
INSERT INTO DISQUE VALUES(442,'Pourquoi vous changez pas de nom?',161,'2000','7f074f0a','2006',11.97,2,'f','2008-03-12 15:10:30');
INSERT INTO DISQUE VALUES(443,'Les Sex Bidochons : On s''en bat les couilles',162,'1989','8c08c80c','1998',11.41,3,'f','2008-03-12 16:57:32');
INSERT INTO DISQUE VALUES(444,'Volume 1 Sound Magic',163,'1995','950f6f09','2007',19.94,3,'f','2008-03-12 19:44:36');
INSERT INTO DISQUE VALUES(445,'Stiff Upper Lip',4,'2000','9f0b090c','2003',19.38,2,'f','2008-03-12 12:11:09');
INSERT INTO DISQUE VALUES(446,'Le retour de la horde',164,'1986','a608320c','1991',10.28,1,'f','2008-03-12 08:56:12');
INSERT INTO DISQUE VALUES(447,'Les Beadochons : 4 Beadochons dans le vent',162,'1992','ab09640e','2002',15.46,2,'f','2008-03-12 09:59:18');
INSERT INTO DISQUE VALUES(448,'Bidophone: Cache ton machin',162,'1996','ac0ddd0e','1998',10.2,2,'f','2008-03-12 16:47:54');
INSERT INTO DISQUE VALUES(449,'À Poil Commercial',49,'1999','bc0b820d','2003',19.84,1,'f','2008-03-12 13:02:16');
INSERT INTO DISQUE VALUES(450,'Les Rolling Bidochons : Sales gueules',162,'1990','ca0cff0e','1994',19.39,2,'f','2008-03-12 18:20:10');
INSERT INTO DISQUE VALUES(451,'En concert à Bercy CD2',61,'1999','e8110310','2008',15.68,3,'f','2008-05-27 10:14:02.579624');
INSERT INTO DISQUE VALUES(452,'Radio One',165,'1988','e90df911','1995',14.55,2,'f','2008-03-12 16:59:03');
INSERT INTO DISQUE VALUES(453,'Volume 1',160,'1992','f80b7112','2007',18.03,2,'t','2008-03-12 10:43:01');
INSERT INTO DISQUE VALUES(454,'Hot Space',11,'1982','8c0a370b','1989',15.14,4,'f','2008-03-12 17:40:46');
INSERT INTO DISQUE VALUES(455,'IV',42,'1983','6f095009','2004',13.04,3,'f','2008-03-12 12:01:57');
INSERT INTO DISQUE VALUES(456,'Marche ou Crève',42,'1981','7d0a250a','2003',15.72,2,'f','2008-03-12 14:06:54');
INSERT INTO DISQUE VALUES(457,'A Kind Of Magic',11,'1986','9b0c960c','1991',16.12,1,'f','2008-03-12 16:13:53');
INSERT INTO DISQUE VALUES(458,'Rock''N''Roll',42,'1984','7b094109','2008',12.17,1,'f','2008-03-12 08:56:41');
INSERT INTO DISQUE VALUES(460,'Spanked',166,'2003','a20a5e0c','2008',12.32,4,'f','2008-03-12 10:14:04');
INSERT INTO DISQUE VALUES(461,'Crosby Nash CD1',167,'2004','860aa40b','2005',16.72,2,'t','2008-03-12 13:31:24');
INSERT INTO DISQUE VALUES(462,'Crosby Nash CD2',167,'2004','6a06cf09','2006',17.52,1,'f','2008-03-12 11:14:24');
INSERT INTO DISQUE VALUES(463,'Live Sticks CD2',44,'2004','b311560d','2006',13.56,2,'t','2008-03-12 12:28:08');
INSERT INTO DISQUE VALUES(464,'Live Sticks CD1',44,'2004','8711560c','2008',16.26,1,'f','2008-03-16 12:14:48');
INSERT INTO DISQUE VALUES(465,'Le Zenith De Gainsbourg',168,'1989','fe10c712','2003',16.07,1,'f','2008-03-12 09:37:50');
INSERT INTO DISQUE VALUES(466,'Rock & Folk - Monster CD N°9',112,'2004','16118a14','2006',18.64,2,'f','2008-03-12 09:09:57');
INSERT INTO DISQUE VALUES(467,'La fille qui rêve de moi',169,'1973','7c07a20b','1999',18.09,2,'f','2008-03-12 08:53:10');
INSERT INTO DISQUE VALUES(468,'Emotional Rescue',44,'1980','9509ac0a','2002',15.81,3,'f','2008-03-12 19:56:07');
INSERT INTO DISQUE VALUES(469,'Le Bal Des Laze',169,'1968','8a07b70b','2008',12.97,2,'f','2008-03-12 15:53:30');
INSERT INTO DISQUE VALUES(470,'Vaut mieux en rire que de s''en foutre',170,'2004','a708420e','2006',14.53,1,'f','2008-03-12 12:08:44');
INSERT INTO DISQUE VALUES(471,'The Film',171,'2005','760a300b','2007',15.82,2,'t','2008-03-12 12:33:15');
INSERT INTO DISQUE VALUES(472,'Va chercher la police',166,'2005','8a0a0d0c','2006',13.16,2,'f','2008-03-12 17:51:30');
INSERT INTO DISQUE VALUES(473,'Bleed Like Me',136,'2005','8e0a900b','2008',12.34,2,'f','2008-03-16 10:13:58');
INSERT INTO DISQUE VALUES(474,'Divine Rebel',0,'2003','980ca10c','2004',14.62,1,'f','2008-03-12 12:36:12');
INSERT INTO DISQUE VALUES(475,'A Bigger Bang',44,'2005','03115f11','2006',17.56,2,'f','2008-03-12 10:46:49');
INSERT INTO DISQUE VALUES(476,'Ideal Standard',115,'2005','d511560f','2005',12.98,2,'f','2008-03-12 08:54:58');
INSERT INTO DISQUE VALUES(477,'Hedningarna',172,'1998','960b4f0d','2002',11.19,1,'f','2008-03-12 19:55:52');
INSERT INTO DISQUE VALUES(478,'Senex Puer',173,'1998','b40d660e','2004',12.15,4,'f','2008-03-12 09:51:48');
INSERT INTO DISQUE VALUES(479,'Sladest',174,'1973','b60abe0e','2000',10.36,3,'f','2008-03-12 11:27:42');
INSERT INTO DISQUE VALUES(480,'Scandale Mélancolique',61,'2005','b90b7f0d','2007',10.92,1,'f','2008-03-12 17:47:50');
INSERT INTO DISQUE VALUES(481,'A Garage Dayz Nite - Beatallica',175,'2004','ce0ad40f','2006',11.28,1,'f','2008-03-12 14:12:24');
INSERT INTO DISQUE VALUES(482,'Les larmes du Dalaï Lama',63,'1992','7f0d0409','1993',11.8,1,'f','2008-03-12 17:01:15');
INSERT INTO DISQUE VALUES(483,'Youpii, Groovi, Heavii, Crazii, Sexii, Show !!! CD1',176,'2002','270e8614','2006',16.6,2,'f','2008-05-27 10:10:19.380524');
INSERT INTO DISQUE VALUES(484,'School''s Out',71,'1972','6d08aa09','1987',19.81,1,'f','2008-03-12 11:37:05');
INSERT INTO DISQUE VALUES(485,'The Eyes of Alice Cooper',71,'2003','b50a630d','2008',11.47,2,'f','2008-03-12 13:47:52');
INSERT INTO DISQUE VALUES(486,'Dragontown',71,'2001','840bee0c','2007',18.53,3,'f','2008-03-12 11:48:46');
INSERT INTO DISQUE VALUES(487,'Disez pas sans l''sachant',176,'1997','3c037604','2003',10.55,2,'f','2008-03-12 11:47:42');
INSERT INTO DISQUE VALUES(488,'Sale Bâtard',176,'1996','e70ab80e','2007',13.82,2,'f','2008-03-12 09:55:34');
INSERT INTO DISQUE VALUES(489,'Viva',83,'1976','5d0ad508','1988',16.36,2,'f','2008-03-12 19:11:01');
INSERT INTO DISQUE VALUES(490,'Welcome To My Nightmare',71,'1975','840a2c0b','1981',17.08,2,'t','2008-03-12 16:57:49');
INSERT INTO DISQUE VALUES(491,'A Trick Of The Tail',62,'1975','790c0008','1985',14.9,2,'f','2008-03-12 14:29:02');
INSERT INTO DISQUE VALUES(492,'Selling England By The Pound',62,'1973','590c9c08','1983',13.4,3,'f','2008-03-12 19:16:04');
INSERT INTO DISQUE VALUES(493,'Paint It Black - The Compilation of the Rolling Stones Cover Tracks',44,'2006','44114613','2007',12.51,2,'f','2008-03-16 10:33:19');
INSERT INTO DISQUE VALUES(494,'Youpii, Groovi, Heavii, Crazii, Sexii, Show !!! CD2',176,'2002','430fba06','2002',13.14,3,'f','2008-05-27 10:10:14.827594');
INSERT INTO DISQUE VALUES(495,'Rock & Folk - Monster CD N°16',112,'2006','3b110516','2006',15.36,1,'f','2008-03-12 17:16:44');
INSERT INTO DISQUE VALUES(496,'Abacab',62,'1981','730af109','1991',17.63,2,'f','2008-03-12 15:33:32');
INSERT INTO DISQUE VALUES(497,'Wind And Wuthering',62,'1977','720bf009','1995',16.84,2,'f','2008-03-12 13:50:20');
INSERT INTO DISQUE VALUES(498,'Love Blonde - The Best Of...',177,'1993','f5111813','2000',11.77,1,'f','2008-03-12 09:58:15');
INSERT INTO DISQUE VALUES(499,'Un pour tous... chacun MA gueule !',176,'2003','e20d3511','2006',13.6,1,'f','2008-03-12 16:56:27');
INSERT INTO DISQUE VALUES(500,'Contraband',178,'2004','cc11560e','2005',10.89,2,'f','2008-03-12 16:36:24');
INSERT INTO DISQUE VALUES(501,'Rouge Sang - CD2',143,'2006','c70c510d','2007',12.85,4,'f','2008-03-12 14:07:54');
INSERT INTO DISQUE VALUES(502,'Another Step',177,'1986','b70c440d','1990',11.28,3,'f','2008-03-12 15:03:10');
INSERT INTO DISQUE VALUES(503,'5:55 Edition Limitée',179,'2006','aa0c730c','2007',17.64,2,'f','2008-03-12 16:14:43');
INSERT INTO DISQUE VALUES(504,'Rouge Sang - CD1',143,'2006','9b0b5b0d','2006',11.72,3,'f','2008-03-12 08:53:32');
INSERT INTO DISQUE VALUES(505,'Amor Doloroso',66,'2006','910c0f0c','2007',11.06,3,'f','2008-03-12 19:39:48');
INSERT INTO DISQUE VALUES(506,'David Live CD1',52,'1974','820b820b','1974',18.55,2,'f','2008-05-27 10:04:42.416827');
INSERT INTO DISQUE VALUES(507,'David Live CD2',52,'1974','7809af09','1982',10.76,1,'f','2008-05-27 10:04:49.347878');
INSERT INTO DISQUE VALUES(508,'Foxtrot',62,'1972','510bfe06','1996',17.65,2,'f','2008-03-12 14:50:10');
INSERT INTO DISQUE VALUES(509,'Bornes To Be En Live!',176,'2005','6710fd18','2008',13.49,2,'t','2008-03-12 17:32:07');
INSERT INTO DISQUE VALUES(513,'Loose',180,'2006','d40f100f','2007',19.65,2,'f','2008-03-12 15:27:55');
INSERT INTO DISQUE VALUES(514,'The New America',123,'2000','b709eb0e','2002',14.88,1,'f','2008-03-12 17:08:09');
INSERT INTO DISQUE VALUES(515,'L''avenir est à ceux qui s''éléphanteau !',181,'1990','c408cc0e','1997',11.12,2,'f','2008-03-12 13:08:03');
INSERT INTO DISQUE VALUES(517,'Jus de box',49,'2007','c60c870e','2008',11.56,2,'f','2008-03-12 08:04:42');
INSERT INTO DISQUE VALUES(518,'Main Offender',100,'1992','770bb20a','2002',11.48,3,'f','2008-03-12 17:45:00');
INSERT INTO DISQUE VALUES(519,'Live CD2',83,'2003','8d11690c','2007',11.78,1,'f','2008-03-12 10:59:42');
INSERT INTO DISQUE VALUES(520,'Live at the Hot Point',109,'1989','b10e2b0c','2008',16.97,2,'f','2008-03-12 12:32:33');
INSERT INTO DISQUE VALUES(521,'Fab Forty (The Singles Collection 1964-1970) CD2',183,'1970','360f7a14','1981',11.17,3,'f','2008-05-27 10:09:07.090211');
INSERT INTO DISQUE VALUES(522,'Longtemps',184,'2005','9c0c080c','2006',10,2,'f','2008-03-12 16:38:23');
INSERT INTO DISQUE VALUES(523,'Fab Forty (The Singles Collection 1964-1970) CD1',183,'1970','fb0b6214','2008',15.22,4,'f','2008-05-27 10:09:12.574741');
INSERT INTO DISQUE VALUES(524,'For Your Pleasure',83,'1973','6609e308','2001',10.14,2,'f','2008-03-12 11:54:42');
INSERT INTO DISQUE VALUES(525,'Flesh + Blood',83,'1980','8709e30a','1982',16.32,3,'f','2008-03-12 10:40:51');
INSERT INTO DISQUE VALUES(526,'Siren',83,'1975','7b09e909','1993',13.67,2,'f','2008-03-12 12:09:59');
INSERT INTO DISQUE VALUES(527,'Between Heaven And Hell',185,'1995','e2120d0f','2003',13.11,3,'f','2008-03-12 12:11:04');
INSERT INTO DISQUE VALUES(528,'Paris New York CD1',109,'1992','d20f8f0f','1999',11.18,3,'f','2008-05-27 10:10:08.992594');
INSERT INTO DISQUE VALUES(529,'Paris New York CD2',109,'1992','c411550f','1995',13.45,4,'f','2008-05-27 10:10:00.734413');
INSERT INTO DISQUE VALUES(530,'Alors',186,'1900','ea0b580f','1949',14.75,2,'f','2008-03-12 18:36:21');
INSERT INTO DISQUE VALUES(531,'Pigalle',186,'1990','a506520d','1990',15.79,1,'f','2008-03-12 12:11:43');
INSERT INTO DISQUE VALUES(532,'Pigallive',186,'1992','5f116218','2007',14.5,1,'f','2008-03-12 14:52:21');
INSERT INTO DISQUE VALUES(533,'Rire et pleurer',186,'1993','d30d5111','2005',10.16,1,'f','2008-03-12 18:18:40');
INSERT INTO DISQUE VALUES(534,'The Buddha Of Suburbia',52,'1993','7b0d030a','1999',18.51,2,'f','2008-03-12 09:34:35');
INSERT INTO DISQUE VALUES(535,'Trust',42,'1983','6b095009','2002',15.81,2,'f','2008-03-12 18:46:15');
INSERT INTO DISQUE VALUES(536,'Coming home again',109,'2006','a80eaa0d','2007',17.97,2,'f','2008-03-12 16:08:25');
INSERT INTO DISQUE VALUES(537,'Live At The Hollywood Palladium Dec. 1988',187,'1991','ac0fd20d','2006',14.16,2,'f','2008-03-12 16:32:36');
INSERT INTO DISQUE VALUES(538,'Clandestino',188,'1998','ce0abd10','2003',19.96,3,'t','2008-03-12 17:39:37');
INSERT INTO DISQUE VALUES(539,'Le voyageur',3,'1993','f4105511','2006',13.45,2,'t','2008-06-02 15:24:42.257384');
INSERT INTO DISQUE VALUES(540,'The Ladies'' Second Song',208,'2007','a00b0c0d','2008',15.01,1,'f','2008-06-02 15:20:00.381964');
INSERT INTO DISQUE VALUES(541,'Kimono My House',191,'1974','a80a1e0c','1989',13.88,1,'f','2008-03-12 17:01:37');
INSERT INTO DISQUE VALUES(543,'Self Portrait',14,'1970','58116718','1985',19.2,1,'f','2008-03-12 13:32:29');
INSERT INTO DISQUE VALUES(544,'Highway 61 Revisited',14,'1965','810c1909','1974',15.57,1,'f','2008-03-12 18:26:47');
INSERT INTO DISQUE VALUES(545,'The Bootleg Series Vol. 5 : Live 1975 - The RollingThunder Revue (Disc 1)',14,'2002','a10bf40b','2006',13.1,1,'f','2008-03-12 14:35:22');
INSERT INTO DISQUE VALUES(548,'L''espoir',193,'2008','de0f4710','2008',15.12,1,'f','2008-03-12 09:27:09');
INSERT INTO DISQUE VALUES(549,'L''eau',194,'2006','a80cb10e','2007',16.48,2,'f','2008-03-29 12:09:18');
INSERT INTO DISQUE VALUES(550,'Street Legal',14,'1978','7e0bae09','1994',15.27,1,'f','2008-03-12 17:52:50');
INSERT INTO DISQUE VALUES(553,'Le Pelegrin',196,'2001','05100e11','2001',15.56,1,'f','2008-03-16 12:38:30');
INSERT INTO DISQUE VALUES(554,'St Patrick Spirit CD2',112,'1996','0b123214','2005',17.28,4,'f','2008-05-27 10:06:52.970534');
INSERT INTO DISQUE VALUES(555,'St Patrick Spirit CD1',112,'1996','2b11be14','1996',18.1,1,'f','2008-05-27 10:06:47.716351');
INSERT INTO DISQUE VALUES(556,'An heol a zo glaz - Le soleil est vert',196,'1981','3e09fe06','1987',19.24,2,'f','2008-03-16 11:26:57');
INSERT INTO DISQUE VALUES(557,'Carte Blanche CD2',197,'1997','4008bb05','2005',16.98,2,'f','2008-05-27 10:14:26.017119');
INSERT INTO DISQUE VALUES(558,'Ma France CD1',198,'1992','5c10c719','2004',17.97,2,'f','2008-05-27 10:07:51.388611');
INSERT INTO DISQUE VALUES(559,'Ma France CD2',198,'1992','62101d17','1999',12.42,3,'f','2008-05-27 10:07:58.717859');
INSERT INTO DISQUE VALUES(560,'Le monde bouge',199,'1974','6608c609','1993',12.2,1,'f','2008-06-02 15:17:40.947747');
INSERT INTO DISQUE VALUES(561,'Rachel',199,'1974','7008a509','1990',18.77,1,'f','2008-03-12 17:48:09');
INSERT INTO DISQUE VALUES(562,'1, 2, 3 Soleils CD1',200,'1998','790f510a','2008',13.15,2,'f','2008-05-27 10:14:16.352489');
INSERT INTO DISQUE VALUES(563,'Déjà Vu',201,'1970','81088f0a','1982',17,3,'f','2008-03-12 19:01:40');
INSERT INTO DISQUE VALUES(564,'Harvest',202,'1972','8208cc0a','1989',15.79,3,'f','2008-03-12 13:03:54');
INSERT INTO DISQUE VALUES(565,'Comes A Time',202,'1978','8a08ba0a','1992',15,2,'f','2008-03-12 16:55:34');
INSERT INTO DISQUE VALUES(566,'Live at the Whiskey Night',203,'2000','8b09200a','2003',17.27,2,'f','2008-03-12 16:13:00');
INSERT INTO DISQUE VALUES(567,'A yemma',204,'1990','8d0a940a','1994',11.06,1,'t','2008-03-12 15:09:56');
INSERT INTO DISQUE VALUES(568,'Eva',205,'1998','8e09ba0b','2007',18.55,1,'f','2008-03-12 09:34:42');
INSERT INTO DISQUE VALUES(569,'Vincent Delerm',206,'2002','9307fc0b','2006',13.97,2,'f','2008-03-12 09:48:01');
INSERT INTO DISQUE VALUES(570,'Bridge Over Troubled Water Water',157,'1970','9308cf0b','1975',10.92,3,'f','2008-03-12 15:24:26');
INSERT INTO DISQUE VALUES(571,'Olympia Concert',207,'1972','960a0e0c','2002',10.53,4,'f','2008-03-16 15:10:15');
INSERT INTO DISQUE VALUES(572,'Dorothea',208,'2000','960dd10d','2008',11.32,2,'f','2008-03-16 17:15:52');
INSERT INTO DISQUE VALUES(573,'The Best of',209,'2003','fa0dc012','2006',14.91,2,'f','2008-03-12 17:10:54');
INSERT INTO DISQUE VALUES(574,'Sounds Of Silence',157,'1968','9a077b0c','2003',16.22,1,'f','2008-03-12 13:36:58');
INSERT INTO DISQUE VALUES(575,'1, 2, 3 Soleils CD2',200,'1998','9a0e6f0b','2000',11.87,1,'f','2008-05-27 10:14:11.843669');
INSERT INTO DISQUE VALUES(576,'Café du bon coin',196,'1983','9b0a730c','1997',10.41,3,'f','2008-03-16 19:00:08');
INSERT INTO DISQUE VALUES(577,'Dear Heather',76,'2004','b90b970d','2004',18.87,2,'f','2008-03-12 19:38:17');
INSERT INTO DISQUE VALUES(578,'Diwan',197,'1998','a7103c0b','2003',12.86,3,'f','2008-03-12 18:47:52');
INSERT INTO DISQUE VALUES(579,'Geel en Swart',210,'1994','a80bb20c','2003',18.2,2,'f','2008-03-12 15:53:40');
INSERT INTO DISQUE VALUES(580,'April, a live album',109,'1999','a90e870c','2001',19.81,3,'f','2008-03-12 15:31:04');
INSERT INTO DISQUE VALUES(581,'Héritage des Celtes',211,'1994','ad0ab70c','2004',14.85,1,'f','2008-03-12 09:08:15');
INSERT INTO DISQUE VALUES(582,'Beauregard',109,'1998','ae0aea0d','2001',14.86,2,'f','2008-03-12 12:55:30');
INSERT INTO DISQUE VALUES(583,'All the best 2/2',205,'2001','b40d660e','2004',12.97,1,'f','2008-03-12 10:44:41');
INSERT INTO DISQUE VALUES(584,'Polnarévolution',169,'1989','b90a360d','2002',15.06,2,'f','2008-03-12 09:13:17');
INSERT INTO DISQUE VALUES(585,'La Découverte ou l''Ignorance',196,'1976','bc09fb0c','2006',10.27,1,'f','2008-03-16 09:37:37');
INSERT INTO DISQUE VALUES(586,'...proxima estacion... Esperanza',188,'2001','c50ab311','2001',17.72,2,'f','2008-03-12 08:35:37');
INSERT INTO DISQUE VALUES(587,'Renaissance de la harpe celtique',207,'1972','d308b70f','2004',13.2,2,'f','2008-03-12 09:34:16');
INSERT INTO DISQUE VALUES(588,'Laïs',208,'1998','d609e00f','2007',13.27,2,'f','2008-03-12 13:29:04');
INSERT INTO DISQUE VALUES(589,'Forgiven, Not Forgotten',212,'1995','db0b700f','2008',11.83,1,'f','2008-03-12 11:07:57');
INSERT INTO DISQUE VALUES(590,'Tibet Libre (CD1)',112,'2000','e010f710','2005',19.54,3,'f','2008-03-12 19:46:28');
INSERT INTO DISQUE VALUES(591,'If I Should Fall from Grace with God',213,'1988','e20c290f','1992',12.17,1,'f','2008-03-12 08:52:37');
INSERT INTO DISQUE VALUES(592,'Carte Blanche CD1',197,'1997','ea0fe10f','2005',15.62,4,'f','2008-05-27 10:14:43.616846');
INSERT INTO DISQUE VALUES(593,'A Vava Inouva',214,'1991','ec0e5711','1993',15.52,1,'f','2008-03-12 18:28:17');
INSERT INTO DISQUE VALUES(594,'Le meilleur de Beau Dommage',215,'1994','f00cfc10','2001',14.59,1,'f','2008-03-12 14:37:31');
INSERT INTO DISQUE VALUES(595,'Symphonie celtique - Tir na n-og',207,'1979','f4103510','2006',19.28,2,'f','2008-03-12 17:44:08');
INSERT INTO DISQUE VALUES(596,'Tibet Libre (CD2)',112,'2000','f911ec11','2002',11.44,2,'f','2008-03-12 13:46:44');
INSERT INTO DISQUE VALUES(597,'Rendez-Vous',95,'2004','e8115611','2005',19.1,2,'f','2008-03-12 08:55:18');
INSERT INTO DISQUE VALUES(598,'A La Capella',208,'2003','7b115609','2007',15.39,2,'t','2008-03-12 12:22:47');
INSERT INTO DISQUE VALUES(599,'Douce Victime',208,'2004','8d11560d','2004',12.73,3,'f','2008-03-12 13:42:54');
INSERT INTO DISQUE VALUES(600,'Le Mécréant',216,'1960','ab08070e','1994',15.17,1,'f','2008-03-12 12:41:40');
INSERT INTO DISQUE VALUES(601,'Les Trompettes de la Renommée',216,'1961','9707bd0c','1968',13.25,1,'f','2008-03-12 18:46:33');
INSERT INTO DISQUE VALUES(602,'Marines',196,'2004','bc0b8a0d','2004',11.23,2,'f','2008-03-16 13:07:47');
INSERT INTO DISQUE VALUES(603,'Le meilleur de Tri Yann',196,'1996','fc0fa514','2008',18.37,2,'f','2008-03-16 08:58:16');
INSERT INTO DISQUE VALUES(604,'Bagadoù - l''Anthologie CD1',112,'2004','f80f0611','2007',15.14,2,'f','2008-03-12 11:30:54');
INSERT INTO DISQUE VALUES(605,'Bagadoù - l''Anthologie CD2',112,'2004','fe0df111','2005',15.64,1,'f','2008-03-12 18:20:39');
INSERT INTO DISQUE VALUES(606,'Couleurs racines',217,'2005','xxxxxxxx','2005',14.45,3,'f','2008-03-12 19:47:25');
INSERT INTO DISQUE VALUES(607,'En Concert',196,'1996','d911ed11','2007',12.85,1,'f','2008-03-16 16:52:21');
INSERT INTO DISQUE VALUES(608,'Allez... gavotte',218,'1999','340df015','2001',14.2,1,'f','2008-03-12 08:13:43');
INSERT INTO DISQUE VALUES(609,'Dix ans',219,'2005','37075806','2006',19.5,2,'f','2008-03-12 17:39:26');
INSERT INTO DISQUE VALUES(610,'Hep diskrog',220,'1999','6b0f6207','2004',19.49,1,'f','2008-03-12 16:03:08');
INSERT INTO DISQUE VALUES(611,'Demolive',221,'2002','5c051d08','2003',12.97,2,'f','2008-03-12 12:55:54');
INSERT INTO DISQUE VALUES(612,'Live In Dublin',207,'1975','8307f80b','1977',19.75,2,'f','2008-03-12 19:24:01');
INSERT INTO DISQUE VALUES(613,'Again',207,'1993','ef0e4f11','2008',12.36,1,'f','2008-03-12 17:26:00');
INSERT INTO DISQUE VALUES(614,'An Dorn',222,'2005','d80ca40f','2005',11.96,4,'f','2008-03-12 08:45:31');
INSERT INTO DISQUE VALUES(615,'War-Raog',223,'2005','d30d8c0e','2006',15.09,2,'f','2008-03-12 19:36:51');
INSERT INTO DISQUE VALUES(616,'Noz-Live',224,'2000','c90e000d','2001',13.82,3,'f','2008-06-02 15:13:01.685777');
INSERT INTO DISQUE VALUES(617,'All the best 1/2',205,'2001','c20c870e','2007',11.42,3,'f','2008-03-12 08:19:31');
INSERT INTO DISQUE VALUES(618,'Binious et Bombardes',225,'1994','5e0a2209','1995',19.46,2,'f','2008-03-12 12:21:45');
INSERT INTO DISQUE VALUES(619,'Malicorne II',226,'1975','6d09ea0a','1992',14.2,1,'f','2008-03-16 09:10:24');
INSERT INTO DISQUE VALUES(620,'Degemer',227,'2001','d10c7910','2001',13.63,1,'f','2008-03-12 14:53:28');
INSERT INTO DISQUE VALUES(621,'Bretagnes à Bercy 1999 CD2',228,'1999','6e091609','2007',18.62,3,'f','2008-05-27 10:05:57.035542');
INSERT INTO DISQUE VALUES(622,'War an dachenn Volume 4',220,'1989','760ffd08','2002',10.25,1,'f','2008-03-12 14:15:47');
INSERT INTO DISQUE VALUES(623,'Belle et rebelle',196,'1990','8909a20b','2003',10.54,1,'f','2008-03-16 15:00:14');
INSERT INTO DISQUE VALUES(624,'Azeliz iza',220,'2001','8f0da90b','2003',15.94,3,'f','2008-03-12 15:02:59');
INSERT INTO DISQUE VALUES(625,'Bretagnes à Bercy 1999 CD2',228,'1999','900a880a','2002',17.19,2,'f','2008-05-27 10:06:06.2652');
INSERT INTO DISQUE VALUES(626,'Doue Lann',229,'1998','960d690c','2000',19.06,1,'f','2008-03-12 08:34:12');
INSERT INTO DISQUE VALUES(627,'Anniverscène',196,'1985','9e0aa70c','1997',11.21,2,'f','2008-03-16 15:35:32');
INSERT INTO DISQUE VALUES(628,'Les Albums De Jeunesse',230,'1992','9e0c5d0c','2001',15.04,2,'f','2008-03-12 10:57:53');
INSERT INTO DISQUE VALUES(629,'Ar mor Divent',231,'2000','aa0c210c','2002',13.96,3,'f','2008-03-12 19:02:03');
INSERT INTO DISQUE VALUES(630,'Glen River',223,'1989','ad0b820e','1991',10.47,1,'f','2008-03-12 12:34:57');
INSERT INTO DISQUE VALUES(631,'Les voix légendaires de Bretagne',232,'1990','ba0bc80d','1997',12.83,2,'f','2008-03-12 17:13:15');
INSERT INTO DISQUE VALUES(632,'N''eo ket echu',233,'2003','a50a7b0c','2003',11.67,1,'f','2008-03-12 10:48:30');
INSERT INTO DISQUE VALUES(633,'Documenta CD2',208,'2006','f7115611','2007',17.49,3,'f','2008-05-27 10:08:46.708168');
INSERT INTO DISQUE VALUES(634,'Documenta CD1',208,'2006','a211560c','2007',16.94,2,'f','2008-05-27 10:08:50.584639');
INSERT INTO DISQUE VALUES(635,'Aventures Celtiques',223,'1998','ec0f5b12','1998',18.2,2,'f','2008-03-12 10:09:33');
INSERT INTO DISQUE VALUES(636,'Kejadenn',234,'1993','cb0d6e0e','1996',18.6,2,'f','2008-06-02 15:14:10.380173');
INSERT INTO DISQUE VALUES(637,'Swing and Tears',235,'1994','c60c1b0d','2007',19.24,2,'f','2008-03-12 08:48:44');
INSERT INTO DISQUE VALUES(638,'Portraits',196,'1995','be0f3d0f','2008',11.71,3,'f','2008-03-12 15:58:41');
INSERT INTO DISQUE VALUES(639,'Documenta CD3',208,'2006','7911560b','2006',15.74,4,'f','2008-05-27 10:08:39.511989');
INSERT INTO DISQUE VALUES(640,'Back to Breizh',207,'2000','a00a690c','2005',18.32,1,'f','2008-03-12 14:14:18');
INSERT INTO DISQUE VALUES(641,'Vol. 1 : Les groupes à danser CD 1',236,'2005','0e116712','2006',13.17,2,'t','2008-03-12 14:02:31');
INSERT INTO DISQUE VALUES(642,'Kan ha Diskan',237,'1997','780e591b','1997',18.23,2,'f','2008-03-12 17:14:20');
INSERT INTO DISQUE VALUES(643,'Vol. 1 : Les groupes à danser CD 2',236,'2005','180f6c12','2005',19.9,2,'f','2008-03-12 11:14:44');
INSERT INTO DISQUE VALUES(644,'Un Galicien En Bretagne',238,'2003','bb0ad80d','2004',11.04,2,'f','2008-03-12 17:28:45');
INSERT INTO DISQUE VALUES(645,'Fleur de Sel',217,'2000','7a0aa509','2006',13.12,2,'f','2008-06-02 15:17:05.814079');
INSERT INTO DISQUE VALUES(646,'Mayo longo',238,'2000','cb0c420e','2002',13.35,2,'f','2008-03-12 19:32:04');
INSERT INTO DISQUE VALUES(647,'Os amores libres',238,'1999','ab0dbb0c','2002',13.28,1,'f','2008-03-12 08:35:52');
INSERT INTO DISQUE VALUES(648,'Brotherhood of Stars',238,'1997','a309c80c','1998',17.9,1,'f','2008-03-12 17:11:51');
INSERT INTO DISQUE VALUES(649,'Bemdez c''houlou',233,'2005','6f0a920a','2005',15.16,3,'f','2008-03-12 13:40:45');
INSERT INTO DISQUE VALUES(650,'Sous le ciel de cuivre et d''eau',230,'2005','9f0c3e0c','2005',11.54,1,'f','2008-03-12 10:14:00');
INSERT INTO DISQUE VALUES(651,'Sur les quais de Dublin',230,'1996','970c060c','1996',13.82,2,'f','2008-03-12 14:45:02');
INSERT INTO DISQUE VALUES(652,'Meslanges',240,'2003','db0bdf0f','2007',16.65,4,'f','2008-03-12 08:31:17');
INSERT INTO DISQUE VALUES(653,'Chenchet''n eus an amzer (Les temps changent)',235,'2000','0e0f2713','2003',10.46,1,'f','2008-03-12 12:48:32');
INSERT INTO DISQUE VALUES(654,'Vox',226,'1995','ed099011','2004',16.2,3,'f','2008-03-12 09:36:00');
INSERT INTO DISQUE VALUES(655,'Love & Rebellion',203,'2004','7a082b09','2008',18.57,2,'f','2008-03-12 18:58:42');
INSERT INTO DISQUE VALUES(656,'Les oies sauvages',241,'2006','9e0b710c','2008',13.51,1,'f','2008-03-12 17:54:14');
INSERT INTO DISQUE VALUES(657,'Le chant des sardinières',242,'2006','bf0bd90e','2006',17.06,2,'f','2008-03-12 18:59:49');
INSERT INTO DISQUE VALUES(659,'Abysses',196,'2007','b10e840f','2007',10.76,1,'f','2008-03-12 17:47:01');
INSERT INTO DISQUE VALUES(660,'John Wesley Harding',14,'1968','9d09060c','1982',14.62,2,'f','2008-03-12 15:17:42');
INSERT INTO DISQUE VALUES(661,'Blood On The Tracks',14,'1975','830c290a','1981',19.06,1,'f','2008-03-12 12:31:56');
INSERT INTO DISQUE VALUES(662,'Nashville Skyline',14,'1969','7f06580a','1987',16.79,1,'f','2008-03-12 12:02:41');
INSERT INTO DISQUE VALUES(664,'The Times They Are A-Changin''',14,'1964','7b0aae0a','1972',17.45,2,'f','2008-03-12 13:06:13');
INSERT INTO DISQUE VALUES(665,'Songbook 1',244,'2006','8f0abc0c','2008',19.46,1,'f','2008-06-02 15:18:16.364768');
INSERT INTO DISQUE VALUES(666,'Harpe Celtique & Chants Du Monde',244,'2004','3d05f806','2004',19.56,3,'f','2008-03-12 11:38:37');
INSERT INTO DISQUE VALUES(667,'Je vous emporte dans mon cœur CD2',230,'2006','f7116311','2006',17.99,2,'f','2008-06-02 15:11:47.828604');
INSERT INTO DISQUE VALUES(668,'Desire',14,'1975','6a0d2d09','1997',17.62,1,'f','2008-03-12 11:31:36');
INSERT INTO DISQUE VALUES(669,'Modern Times',14,'2006','930eb60a','2007',14.94,2,'f','2008-03-12 19:20:30');
INSERT INTO DISQUE VALUES(670,'Time Out Of Mind',14,'1997','8e11120b','2002',11.57,2,'f','2008-03-12 10:12:29');
INSERT INTO DISQUE VALUES(672,'Je vous emporte dans mon cœur CD1',230,'2006','0e10ad13','2008',16.51,3,'f','2008-06-02 15:12:18.738429');
INSERT INTO DISQUE VALUES(673,'Blues rags and boogies',246,'1988','150f5514','1991',18.11,3,'f','2008-03-12 08:57:17');
INSERT INTO DISQUE VALUES(674,'The Gold Collection CD1',247,'1995','1b0ede14','2006',14.25,3,'f','2008-05-27 10:07:40.372441');
INSERT INTO DISQUE VALUES(675,'The Gold Collection CD2',247,'1995','1f0ebf14','1996',15.83,3,'f','2008-05-27 10:07:45.558432');
INSERT INTO DISQUE VALUES(676,'En chair et en os',248,'1993','840d100a','2001',11.11,2,'f','2008-03-12 16:19:09');
INSERT INTO DISQUE VALUES(677,'The Quintessence (CD 2)',249,'1994','df0d3c12','1994',12.2,4,'f','2008-03-12 12:45:15');
INSERT INTO DISQUE VALUES(678,'Castel Del Monte',250,'2000','e2113e10','2003',10.24,2,'f','2008-03-12 15:28:45');
INSERT INTO DISQUE VALUES(679,'The Quintessence (CD 1)',249,'1994','ee0d5912','1998',10.52,2,'f','2008-03-12 15:43:24');
INSERT INTO DISQUE VALUES(680,'The Police (Digital Memories)',251,'1996','0f020202','1999',16.58,2,'f','2008-03-12 11:59:56');
INSERT INTO DISQUE VALUES(681,'02-La valse à mille temps',252,'1982','030c7b12','2008',13.28,1,'f','2008-03-12 18:56:16');
INSERT INTO DISQUE VALUES(682,'Essentielles',253,'1997','05109a14','2007',16.92,2,'f','2008-03-12 12:08:29');
INSERT INTO DISQUE VALUES(683,'Défoule sentimentale CD1',254,'1995','130e3b11','1999',16.03,2,'f','2008-05-27 10:13:40.914612');
INSERT INTO DISQUE VALUES(684,'Dutronc au casino',160,'1992','2110b913','2007',14.18,2,'t','2008-03-12 10:14:01');
INSERT INTO DISQUE VALUES(685,'Rue des cascades',255,'1996','220beb14','1998',16.03,2,'f','2008-03-12 17:59:59');
INSERT INTO DISQUE VALUES(686,'Best Of Bruxelles',256,'1974','250d6012','2002',16.67,2,'f','2008-03-12 18:41:18');
INSERT INTO DISQUE VALUES(687,'04-Initials B.B.',168,'1967','270d0015','1998',19.37,3,'f','2008-03-12 08:05:03');
INSERT INTO DISQUE VALUES(688,'Intégrale (2/2)',257,'1966','2c0cbc16','1976',18.09,2,'f','2008-03-12 08:21:15');
INSERT INTO DISQUE VALUES(689,'Auprès de mon arbre',216,'1954','2e0d6814','2000',10.7,3,'f','2008-03-12 13:38:14');
INSERT INTO DISQUE VALUES(690,'06-Je suis venu te dire que je m''en vais',168,'1973','2e0f7016','1992',17.68,2,'f','2008-03-12 12:31:11');
INSERT INTO DISQUE VALUES(691,'El Cabaret Galactic',258,'1995','2f0acb15','2000',19.82,3,'f','2008-03-12 16:55:20');
INSERT INTO DISQUE VALUES(692,'Haikus de Pianos',258,'1992','31082519','2007',10.1,1,'f','2008-03-12 09:49:31');
INSERT INTO DISQUE VALUES(693,'01-Grand Jacques',252,'1982','310d4b17','2002',13.94,3,'f','2008-03-12 15:00:45');
INSERT INTO DISQUE VALUES(694,'03-Les flamandes',252,'1982','330f1615','2002',10.14,3,'f','2008-03-12 15:47:45');
INSERT INTO DISQUE VALUES(695,'Les chroniques de la haine ordinaire (3)',259,'2001','2b111414','2003',16.72,1,'f','2008-03-12 15:39:27');
INSERT INTO DISQUE VALUES(696,'04-Le Plat Pays',252,'1982','380fc515','1983',14.12,2,'f','2008-03-12 19:41:32');
INSERT INTO DISQUE VALUES(697,'Un métèque en liberté CD1',125,'2000','3d11e717','2008',12.88,2,'f','2008-05-27 10:11:04.480302');
INSERT INTO DISQUE VALUES(698,'Matrice',260,'1989','4409ac07','1996',14.95,2,'f','2008-03-12 14:01:37');
INSERT INTO DISQUE VALUES(700,'01-Le poinçonneur des Lilas',168,'1958','480e1718','1997',19.5,2,'f','2008-03-12 08:53:47');
INSERT INTO DISQUE VALUES(701,'L''alternative',199,'1975','49085b06','1980',13.49,2,'f','2008-03-12 10:34:43');
INSERT INTO DISQUE VALUES(702,'Olympia 83',254,'1983','49118417','2001',14.1,1,'f','2008-03-12 14:44:32');
INSERT INTO DISQUE VALUES(703,'Lumières',260,'1985','4a092006','2007',17.45,1,'f','2008-03-12 09:21:32');
INSERT INTO DISQUE VALUES(704,'Revivre',260,'1991','4d09bc07','1999',10.56,2,'f','2008-03-12 18:00:19');
INSERT INTO DISQUE VALUES(705,'02-La Javanaise',168,'1961','4e0c3e16','2008',18.38,2,'f','2008-03-12 15:39:59');
INSERT INTO DISQUE VALUES(706,'03-Couleur Café',168,'1963','510d5d19','1989',14.12,2,'f','2008-03-12 08:35:40');
INSERT INTO DISQUE VALUES(707,'Un métèque en liberté CD2',125,'2000','5111ed16','2005',17.87,1,'f','2008-05-27 10:11:00.420362');
INSERT INTO DISQUE VALUES(708,'Prisonnier de l''inutile',260,'1986','52098207','1994',14.27,2,'f','2008-03-12 18:08:41');
INSERT INTO DISQUE VALUES(709,'Modes D''emploi',262,'1999','53046306','2003',18.81,2,'f','2008-03-12 13:56:10');
INSERT INTO DISQUE VALUES(710,'07-L''Homme à la tête de chou',168,'1976','59106617','1996',10.79,1,'f','2008-03-12 17:59:04');
INSERT INTO DISQUE VALUES(711,'Les Réquisitoires vol. zéro',259,'1993','5f0d2b07','2008',16.88,2,'f','2008-03-12 14:13:38');
INSERT INTO DISQUE VALUES(712,'Swing Slang Song',258,'1999','6603db08','2000',16.23,1,'f','2008-03-12 11:47:22');
INSERT INTO DISQUE VALUES(713,'10-Love on the beat',168,'1984','6808b908','2008',17.77,3,'f','2008-03-12 17:53:43');
INSERT INTO DISQUE VALUES(714,'Les Réquisitoires vol.1',259,'1993','680d9309','2008',16.04,3,'f','2008-03-12 12:44:44');
INSERT INTO DISQUE VALUES(715,'Comme un guerrier',260,'1988','6907bf08','2008',19.04,3,'f','2008-03-12 16:21:23');
INSERT INTO DISQUE VALUES(716,'Jeanne Cherhal',194,'2002','b20db10d','2008',17.56,3,'f','2008-03-12 16:25:59');
INSERT INTO DISQUE VALUES(717,'Les Réquisitoires vol.3',259,'1993','6c0eb108','2005',15.56,1,'f','2008-03-12 12:02:35');
INSERT INTO DISQUE VALUES(718,'Il Voyage En Solitaire',260,'1978','6f0ebe0a','1999',14.15,2,'f','2008-03-12 08:54:44');
INSERT INTO DISQUE VALUES(719,'La mauvaise réputation',216,'1952','be07a80e','1972',18.76,2,'f','2008-03-12 16:24:41');
INSERT INTO DISQUE VALUES(720,'Cocktail Collection',262,'1966','7406840a','1979',13.51,1,'f','2008-03-12 18:09:40');
INSERT INTO DISQUE VALUES(721,'Les amoureux des bancs publics',216,'1953','ec0a9013','1984',17.45,3,'f','2008-03-12 19:42:53');
INSERT INTO DISQUE VALUES(722,'Loin des yeux de l''occident',263,'1983','7a09c209','1998',12.17,2,'f','2008-03-12 15:58:41');
INSERT INTO DISQUE VALUES(723,'Lolita Go Home',95,'1975','7b07a80b','1984',18.49,1,'f','2008-03-12 19:47:35');
INSERT INTO DISQUE VALUES(724,'Chanson pour l''Auvergnat',216,'1954','2b0cba14','1978',10.14,2,'f','2008-03-12 16:08:20');
INSERT INTO DISQUE VALUES(725,'ça va chier',264,'1987','7b10c509','2005',10.64,1,'f','2008-03-12 13:49:41');
INSERT INTO DISQUE VALUES(726,'Je me suis fait tout petit',216,'1956','ab0a0c0e','1986',12.76,1,'f','2008-03-12 17:30:07');
INSERT INTO DISQUE VALUES(727,'IJdele Hoop',265,'2001','7c09b90b','2008',18.26,1,'f','2008-03-12 17:52:09');
INSERT INTO DISQUE VALUES(728,'Le Pornographe',216,'1958','dc0a6b10','1974',14.13,2,'f','2008-03-12 12:53:04');
INSERT INTO DISQUE VALUES(729,'11-You''re under arrest',168,'1987','7f091f0a','2000',17.56,2,'f','2008-03-12 09:35:28');
INSERT INTO DISQUE VALUES(730,'Ilmatar',266,'2000','860b0c0b','2008',11.24,2,'f','2008-03-12 17:28:38');
INSERT INTO DISQUE VALUES(731,'Czerkinsky',267,'1998','8709550a','2008',13.92,2,'t','2008-03-12 13:25:20');
INSERT INTO DISQUE VALUES(732,'Les Réquisitoires vol.2',259,'1993','870e9908','2000',10.81,1,'f','2008-03-12 12:00:19');
INSERT INTO DISQUE VALUES(733,'Bientt l''Europe',264,'1989','8810760b','2001',12.92,3,'t','2008-03-12 08:57:07');
INSERT INTO DISQUE VALUES(734,'C''est déjà ça',254,'1993','8909d20b','2008',15.79,2,'f','2008-03-12 16:38:15');
INSERT INTO DISQUE VALUES(735,'La Mort D''Orion',260,'1970','890a7d0a','1971',14.12,1,'f','2008-03-12 08:03:05');
INSERT INTO DISQUE VALUES(736,'Royaume de Siam',260,'1980','8b09930a','1984',15.59,3,'f','2008-03-12 16:52:36');
INSERT INTO DISQUE VALUES(737,'À la légère',95,'1998','8b0a630c','2005',10.19,2,'f','2008-03-12 17:40:29');
INSERT INTO DISQUE VALUES(738,'Tempête dans un bénitier',216,'1976','e30dd010','1992',18.97,2,'f','2008-03-12 19:03:22');
INSERT INTO DISQUE VALUES(739,'10-Ne me quitte pas',252,'1982','8d090f0b','2001',14.64,2,'f','2008-03-12 08:11:58');
INSERT INTO DISQUE VALUES(740,'Les Copains d''abord',216,'1964','9a0a780c','1983',16.65,2,'f','2008-03-12 14:00:27');
INSERT INTO DISQUE VALUES(741,'08-Aux Armes Et Caetera',168,'1979','9211701a','2008',16.13,4,'f','2008-03-12 10:30:52');
INSERT INTO DISQUE VALUES(742,'Défoule sentimentale CD2',254,'1995','930b140c','2000',10.23,2,'f','2008-05-27 10:13:36.04878');
INSERT INTO DISQUE VALUES(743,'Supplique pour être enterré à la plage de Sète',216,'1964','bc0d5a0e','2000',17.28,2,'f','2008-03-12 18:58:50');
INSERT INTO DISQUE VALUES(744,'Daho Live CD1',131,'2001','960a530b','2006',17.98,1,'f','2008-05-27 10:06:58.371872');
INSERT INTO DISQUE VALUES(745,'Intégrale (1/2)',257,'1966','9b0efe1c','1989',13.33,1,'f','2008-03-12 10:38:33');
INSERT INTO DISQUE VALUES(746,'Manquait plus qu''ça ...',268,'2005','9311560c','2006',17.31,2,'f','2008-03-12 11:20:25');
INSERT INTO DISQUE VALUES(747,'Comment te dire adieu',262,'1968','a6074f0c','1969',15.23,3,'f','2008-03-12 19:10:06');
INSERT INTO DISQUE VALUES(748,'Le Fil',269,'2005','cf129410','2008',17.35,1,'f','2008-03-12 13:09:10');
INSERT INTO DISQUE VALUES(749,'Le sac des filles',269,'2002','9a094b0b','2008',14.39,2,'f','2008-03-12 17:13:22');
INSERT INTO DISQUE VALUES(750,'À l''amour comme à la guerre',270,'1990','a70d660c','1991',10.56,2,'f','2008-03-12 17:45:23');
INSERT INTO DISQUE VALUES(751,'Versions Jane',95,'1996','b10ac00f','2002',11.61,2,'f','2008-03-12 10:55:53');
INSERT INTO DISQUE VALUES(752,'07-Les Marquises',252,'1982','ae0b530c','1983',12.16,2,'f','2008-03-12 09:27:47');
INSERT INTO DISQUE VALUES(753,'La non-demande en mariage',216,'1966','c60e040e','2006',18.24,2,'f','2008-03-12 19:18:46');
INSERT INTO DISQUE VALUES(754,'Romeo et Juliette  CD1 - Gardiner, Orchestre Revolutionnaire Et Romantique',20,'1995','b10f810d','2003',15.69,2,'f','2008-03-12 18:16:25');
INSERT INTO DISQUE VALUES(755,'Danses et Chants de Syldavie',258,'1993','b60be41e','1999',17.15,3,'f','2008-03-12 11:30:04');
INSERT INTO DISQUE VALUES(756,'Best of',271,'1991','c10e4e0e','2006',18.5,2,'f','2008-03-12 18:50:25');
INSERT INTO DISQUE VALUES(757,'Clair-Obscur',262,'2000','bc0b4c0d','2001',16.99,2,'f','2008-03-12 11:47:35');
INSERT INTO DISQUE VALUES(758,'Fidèle...',272,'1994','ca09d60f','1996',10.51,3,'t','2008-03-12 13:13:45');
INSERT INTO DISQUE VALUES(759,'09-Olympia 1964',252,'1982','c20b620f','1995',11.49,3,'f','2008-03-12 15:01:59');
INSERT INTO DISQUE VALUES(760,'Mourir pour des idées',216,'1972','fa0e6511','1972',17.23,2,'t','2008-03-12 19:49:44');
INSERT INTO DISQUE VALUES(761,'08-Olympia 1961',252,'1982','c80b590f','1995',17.16,2,'f','2008-03-12 12:03:40');
INSERT INTO DISQUE VALUES(762,'Chants of India',273,'1997','ca0ef210','2008',13.19,1,'f','2008-03-12 10:09:07');
INSERT INTO DISQUE VALUES(763,'La scène (Théâtre Fontaine janvier 1984)',259,'1995','cb0f980d','2005',19.05,2,'f','2008-03-12 08:09:26');
INSERT INTO DISQUE VALUES(764,'Volume 2',160,'1992','db0b5412','2008',12.19,3,'f','2008-03-12 17:59:42');
INSERT INTO DISQUE VALUES(765,'Ses plus belles chansons',272,'1994','dd0b0710','1996',15.57,2,'f','2008-03-12 10:19:13');
INSERT INTO DISQUE VALUES(766,'La valse des monstres',255,'1995','dd0a8311','2005',17.36,1,'f','2008-03-12 11:12:04');
INSERT INTO DISQUE VALUES(767,'05-Je t''aime... Moi non Plus',168,'1969','ea0cb810','2000',18.53,2,'f','2008-03-12 16:31:51');
INSERT INTO DISQUE VALUES(768,'La scène (Théâtre Grévin octobre 1986)',259,'1995','f510f711','2003',11.95,1,'f','2008-03-12 11:56:05');
INSERT INTO DISQUE VALUES(769,'Coluche Intégral CD1',274,'1996','aa0ed710','2004',12.68,2,'f','2008-03-12 09:32:07');
INSERT INTO DISQUE VALUES(770,'05-Jef',252,'1982','f50e8e11','1990',19.39,3,'f','2008-03-12 08:30:56');
INSERT INTO DISQUE VALUES(771,'Coluche Intégral CD2',274,'1996','d00e8d0f','2008',15.46,1,'f','2008-03-12 17:51:59');
INSERT INTO DISQUE VALUES(772,'Coluche Intégral CD3',274,'1996','b810270b','2005',13.3,2,'f','2008-03-12 13:06:09');
INSERT INTO DISQUE VALUES(773,'Coluche Intégral CD4',274,'1996','910f590a','2007',18.87,2,'f','2008-03-12 15:08:18');
INSERT INTO DISQUE VALUES(774,'06-J''arrive',252,'1982','fe103a13','2002',19.65,1,'f','2008-03-12 08:57:18');
INSERT INTO DISQUE VALUES(775,'Coluche Intégral CD5',274,'1996','58113408','2001',12.65,1,'f','2008-03-12 17:11:37');
INSERT INTO DISQUE VALUES(776,'Coluche Intégral CD6',274,'1996','070f3711','1996',16.25,1,'f','2008-03-12 08:30:50');
INSERT INTO DISQUE VALUES(777,'Coluche Intégral CD bonus (les inédits)',274,'1996','1601b903','1997',15.97,4,'f','2008-03-12 09:13:21');
INSERT INTO DISQUE VALUES(778,'Arabesque',95,'2002','e4115410','2005',17.02,2,'f','2008-03-12 19:33:18');
INSERT INTO DISQUE VALUES(779,'Réévolution',131,'2002','bc0ba70d','2002',13.56,4,'f','2008-03-12 08:38:50');
INSERT INTO DISQUE VALUES(780,'La vie Théodore',254,'2005','9409710b','2005',14.38,1,'f','2008-03-12 09:42:21');
INSERT INTO DISQUE VALUES(781,'Variety',89,'2007','bc0cdd0f','2007',19.28,2,'f','2008-06-02 15:25:03.680769');
INSERT INTO DISQUE VALUES(782,'Au ras des paquerettes',254,'1999','8e09da0a','2007',14.43,2,'f','2008-03-12 08:00:19');
INSERT INTO DISQUE VALUES(783,'Renaud chante Brassens',143,'1995','320e9617','2007',14.13,1,'f','2008-03-12 10:38:28');
INSERT INTO DISQUE VALUES(784,'Reprise des négociations',275,'2005','9c0bf40c','2007',15.15,2,'f','2008-03-12 14:42:26');
INSERT INTO DISQUE VALUES(785,'Les risques du métier',275,'2003','ac0af40d','2005',19.01,4,'f','2008-03-12 18:28:38');
INSERT INTO DISQUE VALUES(786,'Il faut tourner l''apache',181,'1998','24110621','2006',14.18,1,'f','2008-03-12 13:29:08');
INSERT INTO DISQUE VALUES(787,'Fictions',95,'2006','a10a1b0c','2007',14.81,2,'f','2008-03-12 11:34:22');
INSERT INTO DISQUE VALUES(789,'Killer',71,'1971','7408a708','2002',12.41,2,'f','2008-03-12 19:33:34');
INSERT INTO DISQUE VALUES(790,'Sttellla Live',181,'1997','430e5c25','2006',11.94,2,'f','2008-03-12 18:42:16');
INSERT INTO DISQUE VALUES(791,'Live CD1',83,'2003','8d0d9a0b','2008',16.3,2,'f','2008-03-12 10:48:48');
INSERT INTO DISQUE VALUES(792,'12',109,'1990','1f125b15','1991',19.99,2,'f','2008-03-12 13:53:49');
INSERT INTO DISQUE VALUES(793,'Francois détexte Topor',276,'1996','ba0a4e0e','2006',12.53,2,'f','2008-03-12 17:07:27');
INSERT INTO DISQUE VALUES(800,'33 bars',258,'1990','5a0e7618','2005',14.98,1,'f','2008-03-12 18:02:13');
INSERT INTO DISQUE VALUES(801,'El Primitivismo',258,'1988','f20a3513','1998',12.64,1,'f','2008-03-12 17:02:46');
INSERT INTO DISQUE VALUES(802,'Play',46,'1999','f90ed012','2005',14.18,2,'f','2008-03-12 12:53:29');
INSERT INTO DISQUE VALUES(805,'Radioactivity - Computer world',154,'1999','0e110213','2008',15.5,2,'f','2008-03-12 13:31:10');
INSERT INTO DISQUE VALUES(812,'Sladest - Slayed',174,'1972','52106915','1975',16.48,1,'f','2008-03-16 12:53:56');
INSERT INTO DISQUE VALUES(814,'n°1 (MJC des Mureaux-1978)',264,'1978','810c750a','2003',16.7,2,'f','2008-03-12 12:02:52');
INSERT INTO DISQUE VALUES(815,'n°3 (Messieurs "Plus"-1982)',264,'1982','820e150a','1983',16.36,2,'f','2008-03-12 18:41:58');
INSERT INTO DISQUE VALUES(816,'Le Rex',66,'1992','89114e0a','2002',11.25,1,'f','2008-03-12 09:08:30');
INSERT INTO DISQUE VALUES(817,'n°2 (Il finiront sur l''échafaud-1980)',264,'1980','9a0e8f0a','1995',12.19,1,'f','2008-03-12 11:24:47');
INSERT INTO DISQUE VALUES(818,'En route pour la joie (Extraits) CD 2',57,'1999','b30e370d','2008',19.7,2,'f','2008-05-27 10:09:49.091007');
INSERT INTO DISQUE VALUES(819,'En route pour la joie (Extraits) CD 1',57,'1999','b60d1d0d','2004',16.29,1,'f','2008-05-27 10:09:55.22495');
INSERT INTO DISQUE VALUES(821,'Roxy Music / Country Life',83,'1972','ca0f280f','2004',19.6,1,'f','2008-03-12 15:10:06');
INSERT INTO DISQUE VALUES(830,'Legend',282,'1984','c60eb40e','2000',17.7,2,'f','2008-03-12 13:01:34');
INSERT INTO DISQUE VALUES(831,'Love etc.',8,'1996','290afa16','2007',17.62,2,'f','2008-03-12 14:39:45');
INSERT INTO DISQUE VALUES(832,'Le fabuleux destin d''Amélie Poulain',255,'2001','4a0cbf14','2003',18.3,4,'f','2008-03-12 15:11:16');
INSERT INTO DISQUE VALUES(833,'Ma femme est une actrice (Brad Mehldau)',8,'2001','4c121e17','2001',16.53,2,'f','2008-03-12 15:39:22');
INSERT INTO DISQUE VALUES(834,'Philadelphia',8,'1993','8309830a','2006',13.13,3,'f','2008-03-12 11:07:48');
INSERT INTO DISQUE VALUES(835,'Labyrinth',8,'1986','9d0a3e0c','1994',16.03,3,'f','2008-03-12 08:29:06');
INSERT INTO DISQUE VALUES(836,'Out Of Africa',8,'1985','b207d90c','1998',14.45,2,'f','2008-03-12 12:49:31');
INSERT INTO DISQUE VALUES(837,'Mémoires d''immigrés',8,'1997','b510ae0e','1998',13.54,1,'f','2008-03-12 19:39:15');
INSERT INTO DISQUE VALUES(838,'Billy Elliot',8,'2000','ca0b5311','2001',17.86,2,'f','2008-03-12 18:16:36');
INSERT INTO DISQUE VALUES(839,'Trainspotting',8,'1996','cd11b80e','2000',18.52,1,'f','2008-03-12 18:12:32');
INSERT INTO DISQUE VALUES(840,'Les Bons Morceaux',283,'1994','f20d3712','1996',13.89,3,'f','2008-03-12 19:40:34');
INSERT INTO DISQUE VALUES(841,'Absolute Beginners',8,'1986','fe109712','2003',15.27,1,'f','2008-03-12 14:13:13');
INSERT INTO DISQUE VALUES(842,'Christiane F. (Wir Kinder vom Bahnhof Zoo)',52,'1981','7d09ce09','1986',13.4,2,'f','2008-03-12 11:52:24');
INSERT INTO DISQUE VALUES(843,'West Side Story (Leonard Bernstein)',8,'1960','1f122c12','2007',14.76,2,'f','2008-03-12 14:30:04');
INSERT INTO DISQUE VALUES(844,'Les Choristes (Bruno Coulais)',8,'2004','0c090e15','2007',12.47,3,'f','2008-03-12 19:49:12');
INSERT INTO DISQUE VALUES(845,'Tubular Bells (Remastered)',284,'2000','130b7902','2004',14.46,2,'f','2008-03-12 17:49:41');
INSERT INTO DISQUE VALUES(846,'Douze fois par an',194,'2004','a309c30c','2007',10.16,1,'f','2008-03-12 18:13:30');
INSERT INTO DISQUE VALUES(847,'Straus, Also sprach Zarathustra Op.30, Don Juan Op.20',285,'1984','650cae0a','1987',16.14,3,'f','2008-03-12 12:09:09');
INSERT INTO DISQUE VALUES(849,'Rebel Radio',3,'2001','ac0c820d','2003',13.07,3,'f','2008-06-02 15:24:36.901267');
INSERT INTO DISQUE VALUES(852,'Rock''n''roll Part 9',122,'2006','bd09190d','2006',18.12,2,'f','2008-03-30 11:55:39');
INSERT INTO DISQUE VALUES(853,'Bastards',126,'1993','b50b420c','1999',18.05,2,'f','2008-03-30 17:53:20');
INSERT INTO DISQUE VALUES(854,'Des roses et des orties',286,'2008','','2008',18.03,4,'f','2008-04-14 08:18:57');
INSERT INTO DISQUE VALUES(855,'Shine a Light CD1',44,'2007','ba0e0a0e','2007',12.54,3,'f','2008-05-23 14:15:59');
INSERT INTO DISQUE VALUES(856,'Shine a Light CD2',44,'2008','','2008',15.05,2,'f','2008-05-23 19:51:49');
INSERT INTO DISQUE VALUES(857,'Charlatan',49,'1988','b90b0e0d','2005',16.8,2,'f','2008-05-24 11:00:36');
INSERT INTO DISQUE VALUES(858,'Live at Monterey',165,'1967','6e0a200a','1968',11.23,2,'f','2008-05-25 16:54:59');
INSERT INTO DISQUE VALUES(859,'La paloma negra CD1',287,'2004','','2005',12.98,1,'f','2008-05-26 09:14:46');
INSERT INTO DISQUE VALUES(860,'La paloma negra CD2',287,'2004','','2005',11.17,3,'f','2008-05-27 06:33:20.115653');
INSERT INTO DISQUE VALUES(861,'Out of our heads',44,'1965','9207f70c','1968',14.87,2,'f','2008-06-01 16:14:10.333946');
INSERT INTO DISQUE VALUES(862,'Flowers',44,'1967','b908dc0c','1979',16.68,1,'f','2008-06-01 16:23:20.636124');
INSERT INTO DISQUE VALUES(863,'Aftermath',44,'1966','8e0a420b','1996',17.29,2,'f','2008-06-01 16:28:46.510603');
INSERT INTO DISQUE VALUES(864,'''Get Yer Ya-Ya''s Out''',44,'1970','870b2c0a','1989',14.22,1,'f','2008-06-01 16:35:23.529842');
INSERT INTO DISQUE VALUES(865,'Tattoo You',44,'1981','a40a680b','1995',15.34,1,'f','2008-06-01 16:45:44.497834');
INSERT INTO DISQUE VALUES(866,'Singles Collection (The London Years) CD1',44,'1989','520fb119','2004',19.9,2,'f','2008-06-01 17:15:26.381642');
INSERT INTO DISQUE VALUES(867,'Singles Collection (The London Years) CD2',44,'1989','20101614','2000',16.87,2,'f','2008-06-01 17:24:15.666039');
INSERT INTO DISQUE VALUES(868,'Singles Collection (The London Years) CD3',44,'1989','7f0ba90d','2002',16.6,1,'f','2008-06-01 17:29:43.278551');
INSERT INTO DISQUE VALUES(869,'Between The Buttons',44,'1967','9809030c','1975',19.2,2,'f','2008-06-02 08:59:43.83312');
INSERT INTO DISQUE VALUES(870,'Rarities 1971-2003',44,'2005','d612a210','2005',19.31,3,'f','2008-06-02 09:09:11.199264');
INSERT INTO DISQUE VALUES(871,'Pays',205,'2003','a20ade0c','2006',18.96,1,'f','2008-06-02 13:31:02.136497');
INSERT INTO DISQUE VALUES(872,'Des fourmis dans les jambes',288,'2006','b309990d','2008',19.99,1,'f','2008-06-02 13:50:57.99199');
INSERT INTO DISQUE VALUES(873,'Tous ces mots terribles',199,'2008','f70fd511','2008',10.67,3,'f','2008-06-02 14:02:44.766977');
INSERT INTO DISQUE VALUES(874,'Bleu Pétrole',77,'2008','8c0bcf0b','2008',16.21,2,'f','2008-06-02 14:11:37.481074');
INSERT INTO DISQUE VALUES(875,'Florilège Grégorien',289,'1985','440f1717','1992',15.36,2,'f','2008-06-02 14:45:10.351335');
INSERT INTO DISQUE VALUES(876,'Elève toi donc belle',290,'2004','','2005',10.73,3,'f','2008-06-02 15:05:02.914943');
INSERT INTO DISQUE VALUES(877,'Still Life',44,'1982','a9096d0c','2000',19.41,3,'f','2008-06-05 15:55:51.532378');
INSERT INTO DISQUE VALUES(878,'Undercover',44,'1983','810a8c0a','1997',16.13,1,'f','2008-06-05 16:07:12.578683');
INSERT INTO DISQUE VALUES(879,'The Rolling Stones, Now!',44,'1965','89086e0c','1999',16.48,1,'f','2008-06-05 16:16:31.270159');
INSERT INTO DISQUE VALUES(880,'Tri Men',291,'2007','cb0bfe0e','2008',17.16,2,'t','2008-07-09 09:40:09.051641');
INSERT INTO DISQUE VALUES(881,'Femmes Divines',292,'2006','d30afc10','2008',11.93,1,'f','2008-07-12 07:40:45.715726');
INSERT INTO DISQUE VALUES(882,'Dans an Diaoul',293,'2007','9f0ab50b','2008',13.59,2,'f','2009-02-15 16:46:28.649917');
INSERT INTO DISQUE VALUES(883,'Black Ice',4,'2008','c90d090f','2008',19.2,3,'f','2009-02-15 17:45:23.979481');
INSERT INTO DISQUE VALUES(884,'Le Jour Du Poisson',294,'1997','a309680b','2004',12.99,1,'f','2009-02-15 17:51:00.411317');
INSERT INTO DISQUE VALUES(885,'Unrepentant',3,'2007','7509a80a','2007',10.59,2,'f','2009-02-15 17:59:09.263084');
INSERT INTO DISQUE VALUES(886,'No sleep ''til Hammersmith',126,'1996','ca0c090e','1998',11.39,2,'f','2009-02-15 18:01:00.398343');
INSERT INTO DISQUE VALUES(887,'The Collection',295,'1995','16124813','1996',11.33,3,'f','2009-02-15 18:03:39.089861');
INSERT INTO DISQUE VALUES(888,'Dix vagues',0,'2008','8d0ad50a','2008',19.24,2,'f','2009-02-15 18:12:44.024448');
INSERT INTO DISQUE VALUES(889,'The Best Of',296,'1976','bc0a8f0d','1992',19.94,1,'f','2009-02-15 18:15:32.435071');
INSERT INTO DISQUE VALUES(890,'Enregistrement public',232,'1973','9d0a680e','1975',19.01,1,'f','2009-04-26 09:49:53.108705');
INSERT INTO DISQUE VALUES(891,'Along Came A Spider',71,'2008','950a660b','2008',16.12,2,'f','2009-04-26 09:52:14.616924');
INSERT INTO DISQUE VALUES(892,'The Razors Edge',4,'1990','ab0ae80c','1999',15.59,3,'f','2009-04-26 10:31:21.418353');
INSERT INTO DISQUE VALUES(893,'Dirty Deeds Done Dirt Cheap',4,'1976','5f097909','2001',16.04,1,'f','2009-04-26 10:37:24.497683');
INSERT INTO DISQUE VALUES(894,'''74 Jailbreak',4,'1975','3b05b705','1987',15.7,3,'f','2009-04-26 11:36:28.382811');
INSERT INTO DISQUE VALUES(895,'Just A Story From America',109,'1977','7b085509','1979',18.7,3,'f','2009-04-26 11:42:38.937625');
INSERT INTO DISQUE VALUES(896,'Notes From The Underground',109,'2008','840c2c0b','2008',17.2,3,'f','2009-04-26 11:47:58.603691');
INSERT INTO DISQUE VALUES(897,'Lemon Incest',179,'1986','7208cc09','2002',13.93,2,'f','2009-04-26 11:50:59.510414');
INSERT INTO DISQUE VALUES(898,'À Connarland (2/2)',264,'1992','390abd06','1999',10.5,1,'f','2009-04-26 11:54:30.680927');
INSERT INTO DISQUE VALUES(899,'À Connarland (1/2)',264,'1992','500aa906','1995',17.55,1,'f','2009-04-26 11:56:06.531688');
INSERT INTO DISQUE VALUES(900,'Vingt Ans de Finesse Vol.4',264,'1994','','1994',10.75,1,'f','2009-04-26 12:37:08.924444');
INSERT INTO DISQUE VALUES(901,'9-Anna',168,'1981','c8107f1c','1994',13.69,2,'f','2009-04-26 12:42:44.063006');
INSERT INTO DISQUE VALUES(902,'Nocturnes (1/2) - Maria Joao Pires',17,'1996','790bd50a','2003',10.95,2,'f','2009-04-26 12:50:52.031796');
INSERT INTO DISQUE VALUES(903,'Nocturnes (2/2) - Maria Joao Pires',17,'1996','8f0dc20b','2008',15.42,3,'f','2009-04-26 12:53:19.480895');
INSERT INTO DISQUE VALUES(904,'Boléro etc. - Charles Munch',297,'1968','500da807','1996',12.31,3,'f','2009-04-26 12:55:55.357653');
INSERT INTO DISQUE VALUES(905,'Volume IV : Joue pas avec mes nerfs - Article sans suite',199,'1980','aa10f80b','2007',14.06,2,'f','2009-06-04 17:19:32.399194');
INSERT INTO DISQUE VALUES(906,'François Béranger',199,'1992','4a079106','1996',16.81,2,'t','2009-06-04 17:22:12.383796');
INSERT INTO DISQUE VALUES(907,'En public 98 - Vol 1/2',199,'1998','b10e200d','2008',14.93,2,'f','2009-06-04 17:27:14.193876');
INSERT INTO DISQUE VALUES(908,'En public 98 - Vol 2/2',199,'1998','9c0bf90b','2008',15.02,2,'f','2009-06-04 17:28:52.302555');
INSERT INTO DISQUE VALUES(909,'AC/DC Live (CD1)',4,'1992','c1107b0c','2000',13.49,1,'f','2009-06-04 17:31:14.219477');
INSERT INTO DISQUE VALUES(910,'AC/DC Live (CD2)',4,'1992','960e760b','2004',16.41,1,'f','2009-06-04 17:33:12.77368');
INSERT INTO INTERPRETE VALUES(287,11043,860,1);
INSERT INTO INTERPRETE VALUES(44,11053,861,1);
INSERT INTO INTERPRETE VALUES(44,1914,869,1);
INSERT INTO INTERPRETE VALUES(44,11288,877,1);
INSERT INTO INTERPRETE VALUES(52,4488,385,4);
INSERT INTO INTERPRETE VALUES(287,11044,860,2);
INSERT INTO INTERPRETE VALUES(44,11054,861,2);
INSERT INTO INTERPRETE VALUES(44,11168,869,2);
INSERT INTO INTERPRETE VALUES(44,2720,877,2);
INSERT INTO INTERPRETE VALUES(52,4490,385,6);
INSERT INTO INTERPRETE VALUES(8,122,12,8);
INSERT INTO INTERPRETE VALUES(8,123,12,9);
INSERT INTO INTERPRETE VALUES(8,124,12,10);
INSERT INTO INTERPRETE VALUES(8,125,12,11);
INSERT INTO INTERPRETE VALUES(7,126,13,1);
INSERT INTO INTERPRETE VALUES(7,127,13,2);
INSERT INTO INTERPRETE VALUES(7,128,13,3);
INSERT INTO INTERPRETE VALUES(7,129,13,4);
INSERT INTO INTERPRETE VALUES(7,130,13,5);
INSERT INTO INTERPRETE VALUES(7,131,13,6);
INSERT INTO INTERPRETE VALUES(7,132,13,7);
INSERT INTO INTERPRETE VALUES(7,133,13,8);
INSERT INTO INTERPRETE VALUES(287,11045,860,4);
INSERT INTO INTERPRETE VALUES(44,2726,861,3);
INSERT INTO INTERPRETE VALUES(44,4366,869,3);
INSERT INTO INTERPRETE VALUES(44,1914,877,3);
INSERT INTO INTERPRETE VALUES(52,4500,385,16);
INSERT INTO INTERPRETE VALUES(287,11046,860,3);
INSERT INTO INTERPRETE VALUES(44,6501,869,4);
INSERT INTO INTERPRETE VALUES(44,4208,877,4);
INSERT INTO INTERPRETE VALUES(52,4490,390,18);
INSERT INTO INTERPRETE VALUES(15,323,28,18);
INSERT INTO INTERPRETE VALUES(44,1270,105,4);
INSERT INTO INTERPRETE VALUES(44,11171,869,5);
INSERT INTO INTERPRETE VALUES(44,4212,877,5);
INSERT INTO INTERPRETE VALUES(52,4491,385,7);
INSERT INTO INTERPRETE VALUES(44,11172,869,6);
INSERT INTO INTERPRETE VALUES(44,11293,877,6);
INSERT INTO INTERPRETE VALUES(52,4432,381,8);
INSERT INTO INTERPRETE VALUES(287,11032,859,1);
INSERT INTO INTERPRETE VALUES(44,5509,861,4);
INSERT INTO INTERPRETE VALUES(44,11173,869,7);
INSERT INTO INTERPRETE VALUES(44,4214,877,7);
INSERT INTO INTERPRETE VALUES(52,4435,381,11);
INSERT INTO INTERPRETE VALUES(44,1636,861,5);
INSERT INTO INTERPRETE VALUES(44,11174,869,8);
INSERT INTO INTERPRETE VALUES(44,2728,877,8);
INSERT INTO INTERPRETE VALUES(52,4436,381,12);
INSERT INTO INTERPRETE VALUES(287,11047,860,5);
INSERT INTO INTERPRETE VALUES(44,11175,869,9);
INSERT INTO INTERPRETE VALUES(44,11058,861,6);
INSERT INTO INTERPRETE VALUES(44,11296,877,9);
INSERT INTO INTERPRETE VALUES(52,3890,344,1);
INSERT INTO INTERPRETE VALUES(287,11048,860,6);
INSERT INTO INTERPRETE VALUES(44,2731,377,15);
INSERT INTO INTERPRETE VALUES(44,11176,869,10);
INSERT INTO INTERPRETE VALUES(44,2909,877,10);
INSERT INTO INTERPRETE VALUES(52,3891,344,2);
INSERT INTO INTERPRETE VALUES(287,11036,860,7);
INSERT INTO INTERPRETE VALUES(44,2731,861,7);
INSERT INTO INTERPRETE VALUES(44,11177,869,11);
INSERT INTO INTERPRETE VALUES(44,2731,877,11);
INSERT INTO INTERPRETE VALUES(52,3893,344,4);
INSERT INTO INTERPRETE VALUES(287,11050,860,8);
INSERT INTO INTERPRETE VALUES(44,11060,861,8);
INSERT INTO INTERPRETE VALUES(44,11178,869,12);
INSERT INTO INTERPRETE VALUES(44,11299,877,12);
INSERT INTO INTERPRETE VALUES(52,1175,98,2);
INSERT INTO INTERPRETE VALUES(44,1034,89,2);
INSERT INTO INTERPRETE VALUES(44,11061,861,9);
INSERT INTO INTERPRETE VALUES(44,11179,870,1);
INSERT INTO INTERPRETE VALUES(44,11300,878,1);
INSERT INTO INTERPRETE VALUES(52,1176,98,3);
INSERT INTO INTERPRETE VALUES(47,1232,102,10);
INSERT INTO INTERPRETE VALUES(287,11051,860,9);
INSERT INTO INTERPRETE VALUES(44,1270,861,10);
INSERT INTO INTERPRETE VALUES(44,11180,870,2);
INSERT INTO INTERPRETE VALUES(44,10987,878,2);
INSERT INTO INTERPRETE VALUES(52,1179,98,6);
INSERT INTO INTERPRETE VALUES(287,11052,860,10);
INSERT INTO INTERPRETE VALUES(44,4324,861,11);
INSERT INTO INTERPRETE VALUES(44,11181,870,3);
INSERT INTO INTERPRETE VALUES(44,11302,878,3);
INSERT INTO INTERPRETE VALUES(52,1179,380,12);
INSERT INTO INTERPRETE VALUES(44,2266,208,10);
INSERT INTO INTERPRETE VALUES(52,1180,98,7);
INSERT INTO INTERPRETE VALUES(44,11064,861,12);
INSERT INTO INTERPRETE VALUES(44,11182,870,4);
INSERT INTO INTERPRETE VALUES(44,11303,878,4);
INSERT INTO INTERPRETE VALUES(64,1420,122,6);
INSERT INTO INTERPRETE VALUES(65,1422,123,1);
INSERT INTO INTERPRETE VALUES(44,2266,226,8);
INSERT INTO INTERPRETE VALUES(44,4366,862,1);
INSERT INTO INTERPRETE VALUES(44,11183,870,5);
INSERT INTO INTERPRETE VALUES(44,11304,878,5);
INSERT INTO INTERPRETE VALUES(52,1181,98,8);
INSERT INTO INTERPRETE VALUES(44,4586,391,1);
INSERT INTO INTERPRETE VALUES(44,11184,870,6);
INSERT INTO INTERPRETE VALUES(69,1520,135,7);
INSERT INTO INTERPRETE VALUES(44,2730,862,2);
INSERT INTO INTERPRETE VALUES(44,11305,878,6);
INSERT INTO INTERPRETE VALUES(69,1519,135,6);
INSERT INTO INTERPRETE VALUES(44,4586,463,3);
INSERT INTO INTERPRETE VALUES(44,1914,862,3);
INSERT INTO INTERPRETE VALUES(44,11185,870,7);
INSERT INTO INTERPRETE VALUES(44,11306,878,7);
INSERT INTO INTERPRETE VALUES(52,1182,98,9);
INSERT INTO INTERPRETE VALUES(44,2949,270,2);
INSERT INTO INTERPRETE VALUES(44,2722,862,4);
INSERT INTO INTERPRETE VALUES(44,11186,870,8);
INSERT INTO INTERPRETE VALUES(44,11307,878,8);
INSERT INTO INTERPRETE VALUES(52,1183,98,10);
INSERT INTO INTERPRETE VALUES(71,1630,146,5);
INSERT INTO INTERPRETE VALUES(71,1631,146,6);
INSERT INTO INTERPRETE VALUES(71,1632,146,7);
INSERT INTO INTERPRETE VALUES(71,1634,146,9);
INSERT INTO INTERPRETE VALUES(71,1635,146,10);
INSERT INTO INTERPRETE VALUES(42,1636,147,1);
INSERT INTO INTERPRETE VALUES(42,1637,147,2);
INSERT INTO INTERPRETE VALUES(42,1638,147,3);
INSERT INTO INTERPRETE VALUES(42,1640,147,5);
INSERT INTO INTERPRETE VALUES(42,1641,147,6);
INSERT INTO INTERPRETE VALUES(42,1636,147,7);
INSERT INTO INTERPRETE VALUES(42,1643,147,8);
INSERT INTO INTERPRETE VALUES(72,1644,148,1);
INSERT INTO INTERPRETE VALUES(72,1646,148,3);
INSERT INTO INTERPRETE VALUES(72,1647,148,4);
INSERT INTO INTERPRETE VALUES(72,1648,148,5);
INSERT INTO INTERPRETE VALUES(72,1649,148,6);
INSERT INTO INTERPRETE VALUES(74,1676,151,1);
INSERT INTO INTERPRETE VALUES(44,11069,862,5);
INSERT INTO INTERPRETE VALUES(44,11187,870,9);
INSERT INTO INTERPRETE VALUES(44,11308,878,9);
INSERT INTO INTERPRETE VALUES(52,3550,318,10);
INSERT INTO INTERPRETE VALUES(44,11070,862,6);
INSERT INTO INTERPRETE VALUES(44,11188,870,10);
INSERT INTO INTERPRETE VALUES(44,11309,878,10);
INSERT INTO INTERPRETE VALUES(52,3551,318,11);
INSERT INTO INTERPRETE VALUES(77,1787,162,3);
INSERT INTO INTERPRETE VALUES(44,11071,862,7);
INSERT INTO INTERPRETE VALUES(44,11189,870,11);
INSERT INTO INTERPRETE VALUES(44,119,879,1);
INSERT INTO INTERPRETE VALUES(52,4486,385,2);
INSERT INTO INTERPRETE VALUES(44,11190,870,12);
INSERT INTO INTERPRETE VALUES(44,11072,862,8);
INSERT INTO INTERPRETE VALUES(44,11311,879,2);
INSERT INTO INTERPRETE VALUES(52,2175,199,6);
INSERT INTO INTERPRETE VALUES(42,1854,167,7);
INSERT INTO INTERPRETE VALUES(42,1856,167,9);
INSERT INTO INTERPRETE VALUES(44,3730,862,9);
INSERT INTO INTERPRETE VALUES(44,1534,870,13);
INSERT INTO INTERPRETE VALUES(44,1520,879,3);
INSERT INTO INTERPRETE VALUES(52,2176,199,7);
INSERT INTO INTERPRETE VALUES(52,1913,173,7);
INSERT INTO INTERPRETE VALUES(82,1917,174,1);
INSERT INTO INTERPRETE VALUES(44,11192,870,14);
INSERT INTO INTERPRETE VALUES(44,11074,862,10);
INSERT INTO INTERPRETE VALUES(44,11123,879,4);
INSERT INTO INTERPRETE VALUES(52,2177,199,8);
INSERT INTO INTERPRETE VALUES(50,1947,177,2);
INSERT INTO INTERPRETE VALUES(42,1944,176,10);
INSERT INTO INTERPRETE VALUES(42,1945,176,11);
INSERT INTO INTERPRETE VALUES(50,1946,177,1);
INSERT INTO INTERPRETE VALUES(44,1034,183,9);
INSERT INTO INTERPRETE VALUES(44,11193,870,15);
INSERT INTO INTERPRETE VALUES(44,11075,862,11);
INSERT INTO INTERPRETE VALUES(44,2015,183,7);
INSERT INTO INTERPRETE VALUES(44,2016,183,8);
INSERT INTO INTERPRETE VALUES(44,2018,183,10);
INSERT INTO INTERPRETE VALUES(44,11124,879,5);
INSERT INTO INTERPRETE VALUES(52,2177,842,4);
INSERT INTO INTERPRETE VALUES(85,2019,184,1);
INSERT INTO INTERPRETE VALUES(85,2020,184,2);
INSERT INTO INTERPRETE VALUES(85,2022,184,4);
INSERT INTO INTERPRETE VALUES(85,2023,184,5);
INSERT INTO INTERPRETE VALUES(85,2025,184,7);
INSERT INTO INTERPRETE VALUES(44,11076,862,12);
INSERT INTO INTERPRETE VALUES(44,11194,870,16);
INSERT INTO INTERPRETE VALUES(44,11315,879,6);
INSERT INTO INTERPRETE VALUES(52,2178,199,9);
INSERT INTO INTERPRETE VALUES(44,1639,863,1);
INSERT INTO INTERPRETE VALUES(44,3337,302,2);
INSERT INTO INTERPRETE VALUES(101,3295,298,10);
INSERT INTO INTERPRETE VALUES(52,2179,199,10);
INSERT INTO INTERPRETE VALUES(90,2130,195,1);
INSERT INTO INTERPRETE VALUES(90,2131,195,2);
INSERT INTO INTERPRETE VALUES(44,11078,863,2);
INSERT INTO INTERPRETE VALUES(44,3341,302,6);
INSERT INTO INTERPRETE VALUES(132,3832,339,11);
INSERT INTO INTERPRETE VALUES(52,4427,381,3);
INSERT INTO INTERPRETE VALUES(52,2173,199,4);
INSERT INTO INTERPRETE VALUES(93,2220,204,2);
INSERT INTO INTERPRETE VALUES(44,2722,863,3);
INSERT INTO INTERPRETE VALUES(44,2905,266,5);
INSERT INTO INTERPRETE VALUES(106,2507,231,4);
INSERT INTO INTERPRETE VALUES(52,4415,381,5);
INSERT INTO INTERPRETE VALUES(44,2720,863,4);
INSERT INTO INTERPRETE VALUES(100,2385,219,9);
INSERT INTO INTERPRETE VALUES(52,4415,380,6);
INSERT INTO INTERPRETE VALUES(97,2327,214,6);
INSERT INTO INTERPRETE VALUES(44,11081,863,5);
INSERT INTO INTERPRETE VALUES(44,4209,463,1);
INSERT INTO INTERPRETE VALUES(44,11316,879,7);
INSERT INTO INTERPRETE VALUES(52,4148,362,2);
INSERT INTO INTERPRETE VALUES(71,2400,221,3);
INSERT INTO INTERPRETE VALUES(71,2401,221,4);
INSERT INTO INTERPRETE VALUES(71,2402,221,5);
INSERT INTO INTERPRETE VALUES(71,2403,221,6);
INSERT INTO INTERPRETE VALUES(71,2404,221,7);
INSERT INTO INTERPRETE VALUES(71,2406,221,9);
INSERT INTO INTERPRETE VALUES(101,2408,222,1);
INSERT INTO INTERPRETE VALUES(101,2409,222,2);
INSERT INTO INTERPRETE VALUES(101,2412,222,5);
INSERT INTO INTERPRETE VALUES(101,2413,222,6);
INSERT INTO INTERPRETE VALUES(101,2414,222,7);
INSERT INTO INTERPRETE VALUES(101,2415,222,8);
INSERT INTO INTERPRETE VALUES(101,2416,222,9);
INSERT INTO INTERPRETE VALUES(101,2417,222,10);
INSERT INTO INTERPRETE VALUES(101,2418,222,11);
INSERT INTO INTERPRETE VALUES(102,2419,223,1);
INSERT INTO INTERPRETE VALUES(102,2420,223,2);
INSERT INTO INTERPRETE VALUES(102,2421,223,3);
INSERT INTO INTERPRETE VALUES(102,2422,223,4);
INSERT INTO INTERPRETE VALUES(102,2423,223,5);
INSERT INTO INTERPRETE VALUES(102,2424,223,6);
INSERT INTO INTERPRETE VALUES(44,3562,863,6);
INSERT INTO INTERPRETE VALUES(44,11122,879,8);
INSERT INTO INTERPRETE VALUES(52,4148,390,16);
INSERT INTO INTERPRETE VALUES(44,11083,863,7);
INSERT INTO INTERPRETE VALUES(44,11318,879,9);
INSERT INTO INTERPRETE VALUES(52,1184,98,11);
INSERT INTO INTERPRETE VALUES(44,5340,863,8);
INSERT INTO INTERPRETE VALUES(44,5515,463,11);
INSERT INTO INTERPRETE VALUES(44,11319,879,10);
INSERT INTO INTERPRETE VALUES(52,1186,98,13);
INSERT INTO INTERPRETE VALUES(44,11085,863,9);
INSERT INTO INTERPRETE VALUES(44,3342,349,14);
INSERT INTO INTERPRETE VALUES(44,1544,879,11);
INSERT INTO INTERPRETE VALUES(52,1187,98,14);
INSERT INTO INTERPRETE VALUES(111,2615,241,4);
INSERT INTO INTERPRETE VALUES(111,2616,241,5);
INSERT INTO INTERPRETE VALUES(111,2617,241,6);
INSERT INTO INTERPRETE VALUES(111,2618,241,7);
INSERT INTO INTERPRETE VALUES(111,2620,241,9);
INSERT INTO INTERPRETE VALUES(44,11086,863,10);
INSERT INTO INTERPRETE VALUES(44,3343,302,8);
INSERT INTO INTERPRETE VALUES(44,2683,246,7);
INSERT INTO INTERPRETE VALUES(44,2684,246,8);
INSERT INTO INTERPRETE VALUES(44,2685,246,9);
INSERT INTO INTERPRETE VALUES(52,1188,98,15);
INSERT INTO INTERPRETE VALUES(113,2687,247,1);
INSERT INTO INTERPRETE VALUES(113,2688,247,2);
INSERT INTO INTERPRETE VALUES(44,2728,250,9);
INSERT INTO INTERPRETE VALUES(44,11087,863,11);
INSERT INTO INTERPRETE VALUES(44,3343,349,7);
INSERT INTO INTERPRETE VALUES(44,2730,250,11);
INSERT INTO INTERPRETE VALUES(44,11156,879,12);
INSERT INTO INTERPRETE VALUES(52,1188,98,18);
INSERT INTO INTERPRETE VALUES(52,2734,251,3);
INSERT INTO INTERPRETE VALUES(44,10985,864,1);
INSERT INTO INTERPRETE VALUES(44,3344,302,9);
INSERT INTO INTERPRETE VALUES(52,1189,98,16);
INSERT INTO INTERPRETE VALUES(99,2751,252,6);
INSERT INTO INTERPRETE VALUES(99,1744,252,7);
INSERT INTO INTERPRETE VALUES(99,2753,252,8);
INSERT INTO INTERPRETE VALUES(99,2754,252,9);
INSERT INTO INTERPRETE VALUES(99,2755,252,10);
INSERT INTO INTERPRETE VALUES(44,3345,302,10);
INSERT INTO INTERPRETE VALUES(44,1528,864,2);
INSERT INTO INTERPRETE VALUES(52,1190,98,17);
INSERT INTO INTERPRETE VALUES(44,2478,864,3);
INSERT INTO INTERPRETE VALUES(44,3346,302,11);
INSERT INTO INTERPRETE VALUES(52,1192,534,6);
INSERT INTO INTERPRETE VALUES(71,2830,259,9);
INSERT INTO INTERPRETE VALUES(67,2835,260,2);
INSERT INTO INTERPRETE VALUES(67,2837,260,4);
INSERT INTO INTERPRETE VALUES(67,2839,260,6);
INSERT INTO INTERPRETE VALUES(44,1560,864,4);
INSERT INTO INTERPRETE VALUES(44,3347,302,12);
INSERT INTO INTERPRETE VALUES(52,1192,98,19);
INSERT INTO INTERPRETE VALUES(57,2847,261,3);
INSERT INTO INTERPRETE VALUES(44,1564,864,5);
INSERT INTO INTERPRETE VALUES(44,3347,349,12);
INSERT INTO INTERPRETE VALUES(52,1280,107,5);
INSERT INTO INTERPRETE VALUES(57,2853,261,9);
INSERT INTO INTERPRETE VALUES(57,2855,261,11);
INSERT INTO INTERPRETE VALUES(93,2856,262,1);
INSERT INTO INTERPRETE VALUES(93,2859,262,4);
INSERT INTO INTERPRETE VALUES(44,1549,864,6);
INSERT INTO INTERPRETE VALUES(44,3348,302,13);
INSERT INTO INTERPRETE VALUES(52,1280,842,8);
INSERT INTO INTERPRETE VALUES(116,2912,267,1);
INSERT INTO INTERPRETE VALUES(116,2913,267,2);
INSERT INTO INTERPRETE VALUES(116,2914,267,3);
INSERT INTO INTERPRETE VALUES(116,2915,267,4);
INSERT INTO INTERPRETE VALUES(116,2916,267,5);
INSERT INTO INTERPRETE VALUES(116,2917,267,6);
INSERT INTO INTERPRETE VALUES(116,2918,267,7);
INSERT INTO INTERPRETE VALUES(44,1562,864,7);
INSERT INTO INTERPRETE VALUES(44,1978,180,2);
INSERT INTO INTERPRETE VALUES(52,1280,380,11);
INSERT INTO INTERPRETE VALUES(99,2962,271,3);
INSERT INTO INTERPRETE VALUES(44,1209,864,8);
INSERT INTO INTERPRETE VALUES(69,1536,135,23);
INSERT INTO INTERPRETE VALUES(52,1281,380,1);
INSERT INTO INTERPRETE VALUES(119,3028,276,11);
INSERT INTO INTERPRETE VALUES(120,3030,277,2);
INSERT INTO INTERPRETE VALUES(120,3031,277,3);
INSERT INTO INTERPRETE VALUES(120,3032,277,4);
INSERT INTO INTERPRETE VALUES(120,3033,277,5);
INSERT INTO INTERPRETE VALUES(120,3034,277,6);
INSERT INTO INTERPRETE VALUES(120,3035,277,7);
INSERT INTO INTERPRETE VALUES(44,2453,864,9);
INSERT INTO INTERPRETE VALUES(52,3541,507,4);
INSERT INTO INTERPRETE VALUES(44,2476,864,10);
INSERT INTO INTERPRETE VALUES(44,2950,270,3);
INSERT INTO INTERPRETE VALUES(52,3542,318,2);
INSERT INTO INTERPRETE VALUES(44,2909,865,1);
INSERT INTO INTERPRETE VALUES(44,2951,270,4);
INSERT INTO INTERPRETE VALUES(52,3543,318,3);
INSERT INTO INTERPRETE VALUES(128,3270,296,13);
INSERT INTO INTERPRETE VALUES(128,3271,296,14);
INSERT INTO INTERPRETE VALUES(44,2905,865,2);
INSERT INTO INTERPRETE VALUES(44,2952,270,5);
INSERT INTO INTERPRETE VALUES(52,3544,318,4);
INSERT INTO INTERPRETE VALUES(44,11100,865,3);
INSERT INTO INTERPRETE VALUES(44,2953,270,6);
INSERT INTO INTERPRETE VALUES(52,3546,318,6);
INSERT INTO INTERPRETE VALUES(52,3385,305,11);
INSERT INTO INTERPRETE VALUES(52,3379,305,5);
INSERT INTO INTERPRETE VALUES(52,3384,305,10);
INSERT INTO INTERPRETE VALUES(52,3386,305,12);
INSERT INTO INTERPRETE VALUES(52,3383,305,9);
INSERT INTO INTERPRETE VALUES(57,3372,304,11);
INSERT INTO INTERPRETE VALUES(57,3373,304,12);
INSERT INTO INTERPRETE VALUES(57,3374,304,13);
INSERT INTO INTERPRETE VALUES(131,3387,306,1);
INSERT INTO INTERPRETE VALUES(131,3388,306,2);
INSERT INTO INTERPRETE VALUES(131,3389,306,3);
INSERT INTO INTERPRETE VALUES(131,3390,306,4);
INSERT INTO INTERPRETE VALUES(131,3391,306,5);
INSERT INTO INTERPRETE VALUES(131,3392,306,6);
INSERT INTO INTERPRETE VALUES(131,3393,306,7);
INSERT INTO INTERPRETE VALUES(131,3394,306,8);
INSERT INTO INTERPRETE VALUES(44,2902,865,4);
INSERT INTO INTERPRETE VALUES(44,2955,270,8);
INSERT INTO INTERPRETE VALUES(70,3440,310,4);
INSERT INTO INTERPRETE VALUES(70,3441,310,5);
INSERT INTO INTERPRETE VALUES(70,3442,310,6);
INSERT INTO INTERPRETE VALUES(70,3443,310,7);
INSERT INTO INTERPRETE VALUES(70,3444,310,8);
INSERT INTO INTERPRETE VALUES(70,3445,310,9);
INSERT INTO INTERPRETE VALUES(70,1590,310,10);
INSERT INTO INTERPRETE VALUES(70,3447,310,11);
INSERT INTO INTERPRETE VALUES(70,3448,310,12);
INSERT INTO INTERPRETE VALUES(56,3449,311,1);
INSERT INTO INTERPRETE VALUES(56,3450,311,2);
INSERT INTO INTERPRETE VALUES(56,3451,311,3);
INSERT INTO INTERPRETE VALUES(56,3454,311,6);
INSERT INTO INTERPRETE VALUES(56,3455,311,7);
INSERT INTO INTERPRETE VALUES(56,3456,311,8);
INSERT INTO INTERPRETE VALUES(44,4210,865,5);
INSERT INTO INTERPRETE VALUES(44,2955,377,9);
INSERT INTO INTERPRETE VALUES(44,4209,865,6);
INSERT INTO INTERPRETE VALUES(44,2956,270,9);
INSERT INTO INTERPRETE VALUES(44,5515,865,7);
INSERT INTO INTERPRETE VALUES(44,2957,270,10);
INSERT INTO INTERPRETE VALUES(52,2170,199,1);
INSERT INTO INTERPRETE VALUES(52,3630,324,11);
INSERT INTO INTERPRETE VALUES(52,3631,324,12);
INSERT INTO INTERPRETE VALUES(52,3632,324,13);
INSERT INTO INTERPRETE VALUES(49,3634,325,1);
INSERT INTO INTERPRETE VALUES(49,3635,325,2);
INSERT INTO INTERPRETE VALUES(49,3636,325,3);
INSERT INTO INTERPRETE VALUES(49,3637,325,4);
INSERT INTO INTERPRETE VALUES(49,1140,325,5);
INSERT INTO INTERPRETE VALUES(49,3639,325,6);
INSERT INTO INTERPRETE VALUES(49,3640,325,7);
INSERT INTO INTERPRETE VALUES(44,11105,865,8);
INSERT INTO INTERPRETE VALUES(44,2958,270,11);
INSERT INTO INTERPRETE VALUES(52,2171,199,2);
INSERT INTO INTERPRETE VALUES(52,3712,330,12);
INSERT INTO INTERPRETE VALUES(44,11106,865,9);
INSERT INTO INTERPRETE VALUES(44,1980,180,4);
INSERT INTO INTERPRETE VALUES(52,2172,199,3);
INSERT INTO INTERPRETE VALUES(80,3749,333,7);
INSERT INTO INTERPRETE VALUES(80,3750,333,8);
INSERT INTO INTERPRETE VALUES(80,3751,333,9);
INSERT INTO INTERPRETE VALUES(80,3752,333,10);
INSERT INTO INTERPRETE VALUES(80,3753,333,11);
INSERT INTO INTERPRETE VALUES(80,3754,333,12);
INSERT INTO INTERPRETE VALUES(136,3755,334,1);
INSERT INTO INTERPRETE VALUES(44,1981,180,5);
INSERT INTO INTERPRETE VALUES(44,11107,865,10);
INSERT INTO INTERPRETE VALUES(52,2174,199,5);
INSERT INTO INTERPRETE VALUES(44,1986,180,10);
INSERT INTO INTERPRETE VALUES(44,3965,865,11);
INSERT INTO INTERPRETE VALUES(44,11109,866,1);
INSERT INTO INTERPRETE VALUES(44,1987,180,11);
INSERT INTO INTERPRETE VALUES(84,2210,203,1);
INSERT INTO INTERPRETE VALUES(49,3871,342,10);
INSERT INTO INTERPRETE VALUES(49,3872,342,11);
INSERT INTO INTERPRETE VALUES(49,3873,342,12);
INSERT INTO INTERPRETE VALUES(49,3874,342,13);
INSERT INTO INTERPRETE VALUES(139,3875,343,1);
INSERT INTO INTERPRETE VALUES(139,3876,343,2);
INSERT INTO INTERPRETE VALUES(139,3877,343,3);
INSERT INTO INTERPRETE VALUES(139,3878,343,4);
INSERT INTO INTERPRETE VALUES(139,3879,343,5);
INSERT INTO INTERPRETE VALUES(139,3880,343,6);
INSERT INTO INTERPRETE VALUES(139,3881,343,7);
INSERT INTO INTERPRETE VALUES(139,3882,343,8);
INSERT INTO INTERPRETE VALUES(139,3883,343,9);
INSERT INTO INTERPRETE VALUES(44,11110,866,2);
INSERT INTO INTERPRETE VALUES(44,1988,180,12);
INSERT INTO INTERPRETE VALUES(52,4037,354,8);
INSERT INTO INTERPRETE VALUES(122,3932,347,6);
INSERT INTO INTERPRETE VALUES(140,3917,346,6);
INSERT INTO INTERPRETE VALUES(140,3919,346,8);
INSERT INTO INTERPRETE VALUES(140,3920,346,9);
INSERT INTO INTERPRETE VALUES(140,3921,346,10);
INSERT INTO INTERPRETE VALUES(140,3922,346,11);
INSERT INTO INTERPRETE VALUES(140,3923,346,12);
INSERT INTO INTERPRETE VALUES(140,3924,346,13);
INSERT INTO INTERPRETE VALUES(140,3925,346,14);
INSERT INTO INTERPRETE VALUES(140,3926,346,15);
INSERT INTO INTERPRETE VALUES(122,3927,347,1);
INSERT INTO INTERPRETE VALUES(122,3928,347,2);
INSERT INTO INTERPRETE VALUES(122,3929,347,3);
INSERT INTO INTERPRETE VALUES(122,3930,347,4);
INSERT INTO INTERPRETE VALUES(122,3931,347,5);
INSERT INTO INTERPRETE VALUES(44,11111,866,3);
INSERT INTO INTERPRETE VALUES(44,2938,269,2);
INSERT INTO INTERPRETE VALUES(52,3788,336,8);
INSERT INTO INTERPRETE VALUES(44,11112,866,4);
INSERT INTO INTERPRETE VALUES(44,2940,269,4);
INSERT INTO INTERPRETE VALUES(52,3788,396,13);
INSERT INTO INTERPRETE VALUES(68,4066,356,10);
INSERT INTO INTERPRETE VALUES(68,4067,356,11);
INSERT INTO INTERPRETE VALUES(44,2723,866,5);
INSERT INTO INTERPRETE VALUES(187,2941,537,4);
INSERT INTO INTERPRETE VALUES(52,3790,336,10);
INSERT INTO INTERPRETE VALUES(52,4154,362,8);
INSERT INTO INTERPRETE VALUES(52,4155,362,9);
INSERT INTO INTERPRETE VALUES(145,4162,363,1);
INSERT INTO INTERPRETE VALUES(145,4163,363,2);
INSERT INTO INTERPRETE VALUES(145,4164,363,3);
INSERT INTO INTERPRETE VALUES(145,4165,363,4);
INSERT INTO INTERPRETE VALUES(145,4166,363,5);
INSERT INTO INTERPRETE VALUES(145,4167,363,6);
INSERT INTO INTERPRETE VALUES(145,4168,363,7);
INSERT INTO INTERPRETE VALUES(145,4169,363,8);
INSERT INTO INTERPRETE VALUES(145,4170,363,9);
INSERT INTO INTERPRETE VALUES(145,4171,363,10);
INSERT INTO INTERPRETE VALUES(145,4172,363,11);
INSERT INTO INTERPRETE VALUES(44,2830,866,6);
INSERT INTO INTERPRETE VALUES(44,2941,269,5);
INSERT INTO INTERPRETE VALUES(52,3792,336,12);
INSERT INTO INTERPRETE VALUES(132,4181,364,6);
INSERT INTO INTERPRETE VALUES(132,4182,364,7);
INSERT INTO INTERPRETE VALUES(132,4183,364,8);
INSERT INTO INTERPRETE VALUES(132,4184,364,9);
INSERT INTO INTERPRETE VALUES(132,4185,364,10);
INSERT INTO INTERPRETE VALUES(132,4186,364,11);
INSERT INTO INTERPRETE VALUES(132,4187,364,12);
INSERT INTO INTERPRETE VALUES(132,4188,364,13);
INSERT INTO INTERPRETE VALUES(44,1136,866,7);
INSERT INTO INTERPRETE VALUES(44,2942,269,6);
INSERT INTO INTERPRETE VALUES(52,3793,336,13);
INSERT INTO INTERPRETE VALUES(146,4245,368,11);
INSERT INTO INTERPRETE VALUES(146,4246,368,12);
INSERT INTO INTERPRETE VALUES(146,4247,368,13);
INSERT INTO INTERPRETE VALUES(146,4248,368,14);
INSERT INTO INTERPRETE VALUES(44,4279,866,8);
INSERT INTO INTERPRETE VALUES(44,2943,269,7);
INSERT INTO INTERPRETE VALUES(52,3790,396,12);
INSERT INTO INTERPRETE VALUES(118,4299,372,8);
INSERT INTO INTERPRETE VALUES(118,4301,372,10);
INSERT INTO INTERPRETE VALUES(118,4297,372,6);
INSERT INTO INTERPRETE VALUES(118,4298,372,7);
INSERT INTO INTERPRETE VALUES(118,4296,372,5);
INSERT INTO INTERPRETE VALUES(44,11117,866,9);
INSERT INTO INTERPRETE VALUES(109,1544,375,2);
INSERT INTO INTERPRETE VALUES(44,2959,374,10);
INSERT INTO INTERPRETE VALUES(44,2944,269,8);
INSERT INTO INTERPRETE VALUES(44,2208,374,9);
INSERT INTO INTERPRETE VALUES(44,4321,374,2);
INSERT INTO INTERPRETE VALUES(109,3903,375,1);
INSERT INTO INTERPRETE VALUES(44,11118,866,10);
INSERT INTO INTERPRETE VALUES(44,2204,202,5);
INSERT INTO INTERPRETE VALUES(52,3791,336,11);
INSERT INTO INTERPRETE VALUES(44,2728,866,11);
INSERT INTO INTERPRETE VALUES(44,2204,226,9);
INSERT INTO INTERPRETE VALUES(52,1195,99,3);
INSERT INTO INTERPRETE VALUES(44,11120,866,12);
INSERT INTO INTERPRETE VALUES(44,2206,202,7);
INSERT INTO INTERPRETE VALUES(52,1277,107,2);
INSERT INTO INTERPRETE VALUES(109,4448,382,10);
INSERT INTO INTERPRETE VALUES(109,4449,382,11);
INSERT INTO INTERPRETE VALUES(109,2569,382,12);
INSERT INTO INTERPRETE VALUES(109,4338,382,13);
INSERT INTO INTERPRETE VALUES(128,4452,383,1);
INSERT INTO INTERPRETE VALUES(128,4453,383,2);
INSERT INTO INTERPRETE VALUES(128,4454,383,3);
INSERT INTO INTERPRETE VALUES(128,4455,383,4);
INSERT INTO INTERPRETE VALUES(44,1544,866,13);
INSERT INTO INTERPRETE VALUES(44,2208,202,9);
INSERT INTO INTERPRETE VALUES(52,1278,107,3);
INSERT INTO INTERPRETE VALUES(44,2209,202,10);
INSERT INTO INTERPRETE VALUES(44,11122,866,14);
INSERT INTO INTERPRETE VALUES(52,1279,107,4);
INSERT INTO INTERPRETE VALUES(14,4321,544,1);
INSERT INTO INTERPRETE VALUES(44,11123,866,15);
INSERT INTO INTERPRETE VALUES(52,1279,842,2);
INSERT INTO INTERPRETE VALUES(14,4321,543,12);
INSERT INTO INTERPRETE VALUES(44,11124,866,16);
INSERT INTO INTERPRETE VALUES(52,4158,362,12);
INSERT INTO INTERPRETE VALUES(44,2726,866,17);
INSERT INTO INTERPRETE VALUES(165,4321,858,4);
INSERT INTO INTERPRETE VALUES(52,4684,396,14);
INSERT INTO INTERPRETE VALUES(52,4771,403,11);
INSERT INTO INTERPRETE VALUES(52,4772,404,1);
INSERT INTO INTERPRETE VALUES(52,4773,404,2);
INSERT INTO INTERPRETE VALUES(52,3706,404,3);
INSERT INTO INTERPRETE VALUES(95,4775,405,1);
INSERT INTO INTERPRETE VALUES(95,4776,405,2);
INSERT INTO INTERPRETE VALUES(95,4777,405,3);
INSERT INTO INTERPRETE VALUES(95,4778,405,4);
INSERT INTO INTERPRETE VALUES(95,4779,405,5);
INSERT INTO INTERPRETE VALUES(95,4780,405,6);
INSERT INTO INTERPRETE VALUES(95,4781,405,7);
INSERT INTO INTERPRETE VALUES(95,4782,405,8);
INSERT INTO INTERPRETE VALUES(44,1270,866,18);
INSERT INTO INTERPRETE VALUES(44,4333,374,14);
INSERT INTO INTERPRETE VALUES(143,4797,406,8);
INSERT INTO INTERPRETE VALUES(44,2731,866,19);
INSERT INTO INTERPRETE VALUES(44,2678,246,2);
INSERT INTO INTERPRETE VALUES(44,11061,866,20);
INSERT INTO INTERPRETE VALUES(44,2679,246,3);
INSERT INTO INTERPRETE VALUES(143,4831,410,4);
INSERT INTO INTERPRETE VALUES(143,4833,410,6);
INSERT INTO INTERPRETE VALUES(143,4828,412,5);
INSERT INTO INTERPRETE VALUES(143,4808,412,3);
INSERT INTO INTERPRETE VALUES(52,4672,396,2);
INSERT INTO INTERPRETE VALUES(44,4324,866,21);
INSERT INTO INTERPRETE VALUES(44,2258,208,2);
INSERT INTO INTERPRETE VALUES(52,4685,396,15);
INSERT INTO INTERPRETE VALUES(143,4859,413,1);
INSERT INTO INTERPRETE VALUES(143,4860,413,2);
INSERT INTO INTERPRETE VALUES(143,4861,413,3);
INSERT INTO INTERPRETE VALUES(143,4862,413,4);
INSERT INTO INTERPRETE VALUES(143,4863,413,5);
INSERT INTO INTERPRETE VALUES(143,4864,413,6);
INSERT INTO INTERPRETE VALUES(143,4865,413,7);
INSERT INTO INTERPRETE VALUES(143,4866,413,8);
INSERT INTO INTERPRETE VALUES(44,1983,866,22);
INSERT INTO INTERPRETE VALUES(44,2260,208,4);
INSERT INTO INTERPRETE VALUES(52,4031,354,2);
INSERT INTO INTERPRETE VALUES(44,1983,180,7);
INSERT INTO INTERPRETE VALUES(52,4033,354,4);
INSERT INTO INTERPRETE VALUES(143,4881,414,11);
INSERT INTO INTERPRETE VALUES(44,1984,866,23);
INSERT INTO INTERPRETE VALUES(44,3965,366,13);
INSERT INTO INTERPRETE VALUES(52,1471,129,4);
INSERT INTO INTERPRETE VALUES(44,1981,866,24);
INSERT INTO INTERPRETE VALUES(44,3965,349,8);
INSERT INTO INTERPRETE VALUES(52,1472,129,5);
INSERT INTO INTERPRETE VALUES(44,1985,866,25);
INSERT INTO INTERPRETE VALUES(52,1473,129,6);
INSERT INTO INTERPRETE VALUES(143,4899,416,5);
INSERT INTO INTERPRETE VALUES(143,4901,416,7);
INSERT INTO INTERPRETE VALUES(44,1986,867,1);
INSERT INTO INTERPRETE VALUES(8,119,12,5);
INSERT INTO INTERPRETE VALUES(52,1474,129,7);
INSERT INTO INTERPRETE VALUES(143,4909,417,2);
INSERT INTO INTERPRETE VALUES(143,4910,417,3);
INSERT INTO INTERPRETE VALUES(143,4911,417,4);
INSERT INTO INTERPRETE VALUES(143,4912,417,5);
INSERT INTO INTERPRETE VALUES(143,4913,417,6);
INSERT INTO INTERPRETE VALUES(143,4916,417,9);
INSERT INTO INTERPRETE VALUES(44,2727,867,2);
INSERT INTO INTERPRETE VALUES(44,119,463,12);
INSERT INTO INTERPRETE VALUES(52,1475,129,8);
INSERT INTO INTERPRETE VALUES(143,4936,419,5);
INSERT INTO INTERPRETE VALUES(143,4941,419,10);
INSERT INTO INTERPRETE VALUES(143,4792,420,9);
INSERT INTO INTERPRETE VALUES(143,4888,420,10);
INSERT INTO INTERPRETE VALUES(143,4833,420,11);
INSERT INTO INTERPRETE VALUES(44,11136,867,3);
INSERT INTO INTERPRETE VALUES(52,1475,380,10);
INSERT INTO INTERPRETE VALUES(143,4901,420,7);
INSERT INTO INTERPRETE VALUES(44,1639,867,4);
INSERT INTO INTERPRETE VALUES(52,2217,218,5);
INSERT INTO INTERPRETE VALUES(143,4808,420,16);
INSERT INTO INTERPRETE VALUES(143,4967,421,7);
INSERT INTO INTERPRETE VALUES(143,4974,422,4);
INSERT INTO INTERPRETE VALUES(143,4977,422,7);
INSERT INTO INTERPRETE VALUES(44,11078,867,5);
INSERT INTO INTERPRETE VALUES(84,2217,203,8);
INSERT INTO INTERPRETE VALUES(143,4967,422,13);
INSERT INTO INTERPRETE VALUES(151,4985,423,1);
INSERT INTO INTERPRETE VALUES(151,4986,423,2);
INSERT INTO INTERPRETE VALUES(151,4987,423,3);
INSERT INTO INTERPRETE VALUES(151,4988,423,4);
INSERT INTO INTERPRETE VALUES(151,4989,423,5);
INSERT INTO INTERPRETE VALUES(151,4990,423,6);
INSERT INTO INTERPRETE VALUES(44,11139,867,6);
INSERT INTO INTERPRETE VALUES(52,2373,218,6);
INSERT INTO INTERPRETE VALUES(44,3730,867,7);
INSERT INTO INTERPRETE VALUES(52,2374,218,7);
INSERT INTO INTERPRETE VALUES(44,2722,867,8);
INSERT INTO INTERPRETE VALUES(52,2375,218,8);
INSERT INTO INTERPRETE VALUES(44,4598,391,13);
INSERT INTO INTERPRETE VALUES(44,2730,867,9);
INSERT INTO INTERPRETE VALUES(52,2376,218,9);
INSERT INTO INTERPRETE VALUES(162,5264,443,7);
INSERT INTO INTERPRETE VALUES(162,5266,443,9);
INSERT INTO INTERPRETE VALUES(162,5267,443,10);
INSERT INTO INTERPRETE VALUES(162,5268,443,11);
INSERT INTO INTERPRETE VALUES(162,5269,443,12);
INSERT INTO INTERPRETE VALUES(163,5270,444,1);
INSERT INTO INTERPRETE VALUES(163,5271,444,2);
INSERT INTO INTERPRETE VALUES(163,5272,444,3);
INSERT INTO INTERPRETE VALUES(163,5273,444,4);
INSERT INTO INTERPRETE VALUES(163,5274,444,5);
INSERT INTO INTERPRETE VALUES(163,5275,444,6);
INSERT INTO INTERPRETE VALUES(163,5276,444,7);
INSERT INTO INTERPRETE VALUES(163,5277,444,8);
INSERT INTO INTERPRETE VALUES(163,5278,444,9);
INSERT INTO INTERPRETE VALUES(4,5279,445,1);
INSERT INTO INTERPRETE VALUES(4,5280,445,2);
INSERT INTO INTERPRETE VALUES(4,5281,445,3);
INSERT INTO INTERPRETE VALUES(44,11143,867,10);
INSERT INTO INTERPRETE VALUES(44,4601,391,16);
INSERT INTO INTERPRETE VALUES(52,1468,129,1);
INSERT INTO INTERPRETE VALUES(61,5361,451,4);
INSERT INTO INTERPRETE VALUES(61,2267,451,5);
INSERT INTO INTERPRETE VALUES(61,5363,451,6);
INSERT INTO INTERPRETE VALUES(61,3490,451,7);
INSERT INTO INTERPRETE VALUES(61,2433,451,8);
INSERT INTO INTERPRETE VALUES(61,1569,451,9);
INSERT INTO INTERPRETE VALUES(61,5367,451,10);
INSERT INTO INTERPRETE VALUES(61,2269,451,11);
INSERT INTO INTERPRETE VALUES(61,5369,451,12);
INSERT INTO INTERPRETE VALUES(61,1771,451,13);
INSERT INTO INTERPRETE VALUES(61,1403,451,14);
INSERT INTO INTERPRETE VALUES(61,5372,451,15);
INSERT INTO INTERPRETE VALUES(44,1914,867,11);
INSERT INTO INTERPRETE VALUES(44,4603,391,18);
INSERT INTO INTERPRETE VALUES(52,1469,129,2);
INSERT INTO INTERPRETE VALUES(160,5397,453,7);
INSERT INTO INTERPRETE VALUES(160,5398,453,8);
INSERT INTO INTERPRETE VALUES(160,5399,453,9);
INSERT INTO INTERPRETE VALUES(160,5400,453,10);
INSERT INTO INTERPRETE VALUES(160,5401,453,11);
INSERT INTO INTERPRETE VALUES(160,5402,453,12);
INSERT INTO INTERPRETE VALUES(160,5403,453,13);
INSERT INTO INTERPRETE VALUES(160,5404,453,14);
INSERT INTO INTERPRETE VALUES(160,5405,453,15);
INSERT INTO INTERPRETE VALUES(160,5406,453,16);
INSERT INTO INTERPRETE VALUES(160,5407,453,17);
INSERT INTO INTERPRETE VALUES(160,5408,453,18);
INSERT INTO INTERPRETE VALUES(11,5409,454,1);
INSERT INTO INTERPRETE VALUES(11,5410,454,2);
INSERT INTO INTERPRETE VALUES(44,4366,867,12);
INSERT INTO INTERPRETE VALUES(44,1033,377,16);
INSERT INTO INTERPRETE VALUES(52,1470,129,3);
INSERT INTO INTERPRETE VALUES(44,11146,867,13);
INSERT INTO INTERPRETE VALUES(44,1267,105,1);
INSERT INTO INTERPRETE VALUES(52,3784,336,4);
INSERT INTO INTERPRETE VALUES(167,5502,462,7);
INSERT INTO INTERPRETE VALUES(167,5503,462,8);
INSERT INTO INTERPRETE VALUES(167,5504,462,9);
INSERT INTO INTERPRETE VALUES(44,11147,867,14);
INSERT INTO INTERPRETE VALUES(44,1268,105,2);
INSERT INTO INTERPRETE VALUES(44,2455,464,9);
INSERT INTO INTERPRETE VALUES(52,3787,336,7);
INSERT INTO INTERPRETE VALUES(168,5530,465,1);
INSERT INTO INTERPRETE VALUES(168,8494,465,2);
INSERT INTO INTERPRETE VALUES(168,5532,465,3);
INSERT INTO INTERPRETE VALUES(168,5533,465,4);
INSERT INTO INTERPRETE VALUES(168,8897,465,5);
INSERT INTO INTERPRETE VALUES(44,1033,89,1);
INSERT INTO INTERPRETE VALUES(44,2014,867,15);
INSERT INTO INTERPRETE VALUES(44,5583,468,5);
INSERT INTO INTERPRETE VALUES(52,3232,293,10);
INSERT INTO INTERPRETE VALUES(44,5580,468,2);
INSERT INTO INTERPRETE VALUES(44,1034,867,16);
INSERT INTO INTERPRETE VALUES(132,3418,308,8);
INSERT INTO INTERPRETE VALUES(136,5640,473,4);
INSERT INTO INTERPRETE VALUES(136,5641,473,5);
INSERT INTO INTERPRETE VALUES(136,5642,473,6);
INSERT INTO INTERPRETE VALUES(136,5643,473,7);
INSERT INTO INTERPRETE VALUES(136,5644,473,8);
INSERT INTO INTERPRETE VALUES(136,5645,473,9);
INSERT INTO INTERPRETE VALUES(136,5646,473,10);
INSERT INTO INTERPRETE VALUES(136,5647,473,11);
INSERT INTO INTERPRETE VALUES(44,2011,867,17);
INSERT INTO INTERPRETE VALUES(52,4496,385,12);
INSERT INTO INTERPRETE VALUES(174,5729,479,11);
INSERT INTO INTERPRETE VALUES(174,5730,479,12);
INSERT INTO INTERPRETE VALUES(174,5731,479,13);
INSERT INTO INTERPRETE VALUES(174,5732,479,14);
INSERT INTO INTERPRETE VALUES(61,5733,480,1);
INSERT INTO INTERPRETE VALUES(61,5734,480,2);
INSERT INTO INTERPRETE VALUES(44,2015,867,18);
INSERT INTO INTERPRETE VALUES(52,4035,354,6);
INSERT INTO INTERPRETE VALUES(176,5776,483,7);
INSERT INTO INTERPRETE VALUES(44,10985,867,19);
INSERT INTO INTERPRETE VALUES(52,4038,354,9);
INSERT INTO INTERPRETE VALUES(44,11153,867,20);
INSERT INTO INTERPRETE VALUES(44,2009,183,1);
INSERT INTO INTERPRETE VALUES(52,4040,354,11);
INSERT INTO INTERPRETE VALUES(83,5842,489,1);
INSERT INTO INTERPRETE VALUES(83,5843,489,2);
INSERT INTO INTERPRETE VALUES(83,5846,489,5);
INSERT INTO INTERPRETE VALUES(83,5849,489,8);
INSERT INTO INTERPRETE VALUES(44,2013,183,5);
INSERT INTO INTERPRETE VALUES(44,5887,493,11);
INSERT INTO INTERPRETE VALUES(44,2476,868,1);
INSERT INTO INTERPRETE VALUES(44,5894,493,18);
INSERT INTO INTERPRETE VALUES(44,5893,493,17);
INSERT INTO INTERPRETE VALUES(52,4041,354,12);
INSERT INTO INTERPRETE VALUES(44,5886,493,10);
INSERT INTO INTERPRETE VALUES(176,5834,494,1);
INSERT INTO INTERPRETE VALUES(176,5897,494,2);
INSERT INTO INTERPRETE VALUES(176,5898,494,3);
INSERT INTO INTERPRETE VALUES(176,5899,494,4);
INSERT INTO INTERPRETE VALUES(62,5924,496,1);
INSERT INTO INTERPRETE VALUES(44,2472,868,2);
INSERT INTO INTERPRETE VALUES(44,2010,183,2);
INSERT INTO INTERPRETE VALUES(52,4043,354,14);
INSERT INTO INTERPRETE VALUES(177,5947,498,6);
INSERT INTO INTERPRETE VALUES(44,11156,868,3);
INSERT INTO INTERPRETE VALUES(44,2012,183,4);
INSERT INTO INTERPRETE VALUES(52,3620,324,1);
INSERT INTO INTERPRETE VALUES(44,2453,868,4);
INSERT INTO INTERPRETE VALUES(44,2014,183,6);
INSERT INTO INTERPRETE VALUES(118,3003,274,9);
INSERT INTO INTERPRETE VALUES(66,6050,505,8);
INSERT INTO INTERPRETE VALUES(66,6051,505,9);
INSERT INTO INTERPRETE VALUES(44,2461,868,5);
INSERT INTO INTERPRETE VALUES(118,3004,274,10);
INSERT INTO INTERPRETE VALUES(176,5963,509,8);
INSERT INTO INTERPRETE VALUES(176,6090,509,10);
INSERT INTO INTERPRETE VALUES(176,5976,509,11);
INSERT INTO INTERPRETE VALUES(176,5834,509,12);
INSERT INTO INTERPRETE VALUES(176,6094,509,14);
INSERT INTO INTERPRETE VALUES(44,11159,868,6);
INSERT INTO INTERPRETE VALUES(52,2368,218,1);
INSERT INTO INTERPRETE VALUES(44,1248,868,7);
INSERT INTO INTERPRETE VALUES(178,2368,500,13);
INSERT INTO INTERPRETE VALUES(44,2202,868,8);
INSERT INTO INTERPRETE VALUES(44,3206,291,7);
INSERT INTO INTERPRETE VALUES(52,2369,218,2);
INSERT INTO INTERPRETE VALUES(44,11162,868,9);
INSERT INTO INTERPRETE VALUES(69,1528,135,15);
INSERT INTO INTERPRETE VALUES(52,2214,218,4);
INSERT INTO INTERPRETE VALUES(44,11163,868,10);
INSERT INTO INTERPRETE VALUES(44,1528,291,8);
INSERT INTO INTERPRETE VALUES(84,2214,203,5);
INSERT INTO INTERPRETE VALUES(44,11069,868,11);
INSERT INTO INTERPRETE VALUES(44,3209,291,10);
INSERT INTO INTERPRETE VALUES(52,4311,373,6);
INSERT INTO INTERPRETE VALUES(14,6670,550,9);
INSERT INTO INTERPRETE VALUES(196,6681,553,1);
INSERT INTO INTERPRETE VALUES(191,6554,541,6);
INSERT INTO INTERPRETE VALUES(196,6684,553,4);
INSERT INTO INTERPRETE VALUES(193,6634,548,3);
INSERT INTO INTERPRETE VALUES(193,6635,548,4);
INSERT INTO INTERPRETE VALUES(193,6638,548,7);
INSERT INTO INTERPRETE VALUES(193,6645,548,14);
INSERT INTO INTERPRETE VALUES(44,11165,868,12);
INSERT INTO INTERPRETE VALUES(44,3210,291,11);
INSERT INTO INTERPRETE VALUES(52,4315,373,10);
INSERT INTO INTERPRETE VALUES(196,6690,553,10);
INSERT INTO INTERPRETE VALUES(196,6695,553,15);
INSERT INTO INTERPRETE VALUES(44,1549,868,13);
INSERT INTO INTERPRETE VALUES(44,4332,391,6);
INSERT INTO INTERPRETE VALUES(52,2254,207,7);
INSERT INTO INTERPRETE VALUES(44,4332,374,13);
INSERT INTO INTERPRETE VALUES(52,3223,293,1);
INSERT INTO INTERPRETE VALUES(198,6751,558,3);
INSERT INTO INTERPRETE VALUES(198,6752,558,4);
INSERT INTO INTERPRETE VALUES(198,6753,558,5);
INSERT INTO INTERPRETE VALUES(198,6754,558,6);
INSERT INTO INTERPRETE VALUES(198,6755,558,7);
INSERT INTO INTERPRETE VALUES(198,6756,558,8);
INSERT INTO INTERPRETE VALUES(198,6757,558,9);
INSERT INTO INTERPRETE VALUES(198,6758,558,10);
INSERT INTO INTERPRETE VALUES(198,6759,558,11);
INSERT INTO INTERPRETE VALUES(198,6760,558,12);
INSERT INTO INTERPRETE VALUES(198,6761,558,13);
INSERT INTO INTERPRETE VALUES(198,6762,558,14);
INSERT INTO INTERPRETE VALUES(198,6763,558,15);
INSERT INTO INTERPRETE VALUES(198,6764,558,16);
INSERT INTO INTERPRETE VALUES(198,6765,558,17);
INSERT INTO INTERPRETE VALUES(198,6766,558,18);
INSERT INTO INTERPRETE VALUES(198,6767,558,19);
INSERT INTO INTERPRETE VALUES(198,6768,558,20);
INSERT INTO INTERPRETE VALUES(198,6769,558,21);
INSERT INTO INTERPRETE VALUES(198,6770,558,22);
INSERT INTO INTERPRETE VALUES(198,6771,558,23);
INSERT INTO INTERPRETE VALUES(44,1564,138,6);
INSERT INTO INTERPRETE VALUES(44,4592,391,7);
INSERT INTO INTERPRETE VALUES(52,3224,293,2);
INSERT INTO INTERPRETE VALUES(44,4203,365,14);
INSERT INTO INTERPRETE VALUES(44,4593,391,8);
INSERT INTO INTERPRETE VALUES(52,3224,293,12);
INSERT INTO INTERPRETE VALUES(44,4204,365,15);
INSERT INTO INTERPRETE VALUES(187,2455,537,11);
INSERT INTO INTERPRETE VALUES(52,3225,293,3);
INSERT INTO INTERPRETE VALUES(44,2455,391,10);
INSERT INTO INTERPRETE VALUES(52,10844,842,3);
INSERT INTO INTERPRETE VALUES(109,4344,580,10);
INSERT INTO INTERPRETE VALUES(109,7033,580,12);
INSERT INTO INTERPRETE VALUES(211,6719,581,1);
INSERT INTO INTERPRETE VALUES(211,7035,581,2);
INSERT INTO INTERPRETE VALUES(44,2261,208,5);
INSERT INTO INTERPRETE VALUES(44,2455,226,4);
INSERT INTO INTERPRETE VALUES(52,6073,507,8);
INSERT INTO INTERPRETE VALUES(188,7098,586,1);
INSERT INTO INTERPRETE VALUES(188,7099,586,2);
INSERT INTO INTERPRETE VALUES(188,7100,586,3);
INSERT INTO INTERPRETE VALUES(188,7101,586,4);
INSERT INTO INTERPRETE VALUES(188,7102,586,5);
INSERT INTO INTERPRETE VALUES(188,7103,586,6);
INSERT INTO INTERPRETE VALUES(188,7104,586,7);
INSERT INTO INTERPRETE VALUES(188,7105,586,8);
INSERT INTO INTERPRETE VALUES(188,7106,586,9);
INSERT INTO INTERPRETE VALUES(188,7107,586,10);
INSERT INTO INTERPRETE VALUES(44,2263,208,7);
INSERT INTO INTERPRETE VALUES(44,4596,391,11);
INSERT INTO INTERPRETE VALUES(52,3624,324,5);
INSERT INTO INTERPRETE VALUES(44,2264,208,8);
INSERT INTO INTERPRETE VALUES(52,3625,324,6);
INSERT INTO INTERPRETE VALUES(95,7272,597,1);
INSERT INTO INTERPRETE VALUES(95,7273,597,2);
INSERT INTO INTERPRETE VALUES(95,5848,597,3);
INSERT INTO INTERPRETE VALUES(95,7275,597,4);
INSERT INTO INTERPRETE VALUES(44,2265,208,9);
INSERT INTO INTERPRETE VALUES(52,3626,324,7);
INSERT INTO INTERPRETE VALUES(216,7316,600,6);
INSERT INTO INTERPRETE VALUES(44,1566,138,8);
INSERT INTO INTERPRETE VALUES(52,3628,324,9);
INSERT INTO INTERPRETE VALUES(216,7325,601,1);
INSERT INTO INTERPRETE VALUES(216,7330,601,6);
INSERT INTO INTERPRETE VALUES(216,7334,601,10);
INSERT INTO INTERPRETE VALUES(44,1566,463,2);
INSERT INTO INTERPRETE VALUES(52,3628,396,4);
INSERT INTO INTERPRETE VALUES(44,1542,136,1);
INSERT INTO INTERPRETE VALUES(44,3959,365,2);
INSERT INTO INTERPRETE VALUES(52,3629,324,10);
INSERT INTO INTERPRETE VALUES(196,7087,603,5);
INSERT INTO INTERPRETE VALUES(196,7094,603,15);
INSERT INTO INTERPRETE VALUES(196,7365,603,16);
INSERT INTO INTERPRETE VALUES(196,7093,603,18);
INSERT INTO INTERPRETE VALUES(44,1543,136,2);
INSERT INTO INTERPRETE VALUES(44,3959,349,2);
INSERT INTO INTERPRETE VALUES(118,2995,274,1);
INSERT INTO INTERPRETE VALUES(69,1526,135,13);
INSERT INTO INTERPRETE VALUES(44,4192,365,3);
INSERT INTO INTERPRETE VALUES(118,2996,274,2);
INSERT INTO INTERPRETE VALUES(196,7351,607,6);
INSERT INTO INTERPRETE VALUES(44,1526,136,4);
INSERT INTO INTERPRETE VALUES(44,4193,365,4);
INSERT INTO INTERPRETE VALUES(118,2997,274,3);
INSERT INTO INTERPRETE VALUES(44,4194,365,5);
INSERT INTO INTERPRETE VALUES(83,2998,821,3);
INSERT INTO INTERPRETE VALUES(221,7459,611,4);
INSERT INTO INTERPRETE VALUES(221,7460,611,5);
INSERT INTO INTERPRETE VALUES(207,7464,612,1);
INSERT INTO INTERPRETE VALUES(44,4195,365,6);
INSERT INTO INTERPRETE VALUES(83,2998,489,6);
INSERT INTO INTERPRETE VALUES(226,7566,619,10);
INSERT INTO INTERPRETE VALUES(187,2728,537,6);
INSERT INTO INTERPRETE VALUES(44,4197,365,8);
INSERT INTO INTERPRETE VALUES(83,2998,519,2);
INSERT INTO INTERPRETE VALUES(220,7616,624,6);
INSERT INTO INTERPRETE VALUES(220,7617,624,7);
INSERT INTO INTERPRETE VALUES(220,7618,624,8);
INSERT INTO INTERPRETE VALUES(220,7619,624,9);
INSERT INTO INTERPRETE VALUES(220,7620,624,10);
INSERT INTO INTERPRETE VALUES(220,7621,624,11);
INSERT INTO INTERPRETE VALUES(44,2728,366,11);
INSERT INTO INTERPRETE VALUES(44,4198,365,9);
INSERT INTO INTERPRETE VALUES(118,2998,274,4);
INSERT INTO INTERPRETE VALUES(44,4199,365,10);
INSERT INTO INTERPRETE VALUES(118,3000,274,6);
INSERT INTO INTERPRETE VALUES(49,1136,95,7);
INSERT INTO INTERPRETE VALUES(44,4200,365,11);
INSERT INTO INTERPRETE VALUES(118,3001,274,7);
INSERT INTO INTERPRETE VALUES(44,4201,365,12);
INSERT INTO INTERPRETE VALUES(118,3002,274,8);
INSERT INTO INTERPRETE VALUES(44,2945,269,9);
INSERT INTO INTERPRETE VALUES(52,2740,251,9);
INSERT INTO INTERPRETE VALUES(230,7981,651,6);
INSERT INTO INTERPRETE VALUES(230,8226,651,7);
INSERT INTO INTERPRETE VALUES(230,7478,651,8);
INSERT INTO INTERPRETE VALUES(230,7984,651,9);
INSERT INTO INTERPRETE VALUES(44,2946,269,10);
INSERT INTO INTERPRETE VALUES(52,2742,251,11);
INSERT INTO INTERPRETE VALUES(44,5579,468,1);
INSERT INTO INTERPRETE VALUES(52,2743,251,12);
INSERT INTO INTERPRETE VALUES(244,8155,665,5);
INSERT INTO INTERPRETE VALUES(12,254,23,6);
INSERT INTO INTERPRETE VALUES(183,2743,523,18);
INSERT INTO INTERPRETE VALUES(52,2744,251,13);
INSERT INTO INTERPRETE VALUES(249,8314,677,1);
INSERT INTO INTERPRETE VALUES(249,8315,677,2);
INSERT INTO INTERPRETE VALUES(249,8316,677,3);
INSERT INTO INTERPRETE VALUES(249,8317,677,4);
INSERT INTO INTERPRETE VALUES(249,8318,677,5);
INSERT INTO INTERPRETE VALUES(249,8319,677,6);
INSERT INTO INTERPRETE VALUES(249,8320,677,7);
INSERT INTO INTERPRETE VALUES(249,8321,677,8);
INSERT INTO INTERPRETE VALUES(44,5584,468,6);
INSERT INTO INTERPRETE VALUES(52,4306,373,1);
INSERT INTO INTERPRETE VALUES(44,2720,250,1);
INSERT INTO INTERPRETE VALUES(52,4307,373,2);
INSERT INTO INTERPRETE VALUES(255,8451,685,10);
INSERT INTO INTERPRETE VALUES(255,8452,685,11);
INSERT INTO INTERPRETE VALUES(255,8453,685,12);
INSERT INTO INTERPRETE VALUES(255,8454,685,13);
INSERT INTO INTERPRETE VALUES(255,8455,685,14);
INSERT INTO INTERPRETE VALUES(255,8456,685,15);
INSERT INTO INTERPRETE VALUES(255,8457,685,16);
INSERT INTO INTERPRETE VALUES(255,8458,685,17);
INSERT INTO INTERPRETE VALUES(255,8459,685,18);
INSERT INTO INTERPRETE VALUES(255,8460,685,19);
INSERT INTO INTERPRETE VALUES(255,8461,685,20);
INSERT INTO INTERPRETE VALUES(256,8462,686,1);
INSERT INTO INTERPRETE VALUES(256,8463,686,2);
INSERT INTO INTERPRETE VALUES(256,8464,686,3);
INSERT INTO INTERPRETE VALUES(256,8465,686,4);
INSERT INTO INTERPRETE VALUES(256,8466,686,5);
INSERT INTO INTERPRETE VALUES(256,8467,686,6);
INSERT INTO INTERPRETE VALUES(256,8468,686,7);
INSERT INTO INTERPRETE VALUES(256,8469,686,8);
INSERT INTO INTERPRETE VALUES(256,8470,686,9);
INSERT INTO INTERPRETE VALUES(256,8471,686,10);
INSERT INTO INTERPRETE VALUES(256,8472,686,11);
INSERT INTO INTERPRETE VALUES(256,8473,686,12);
INSERT INTO INTERPRETE VALUES(256,8474,686,13);
INSERT INTO INTERPRETE VALUES(256,8475,686,14);
INSERT INTO INTERPRETE VALUES(256,8476,686,15);
INSERT INTO INTERPRETE VALUES(44,2720,366,1);
INSERT INTO INTERPRETE VALUES(44,5585,468,7);
INSERT INTO INTERPRETE VALUES(52,2248,207,1);
INSERT INTO INTERPRETE VALUES(216,8525,689,3);
INSERT INTO INTERPRETE VALUES(52,2248,380,8);
INSERT INTO INTERPRETE VALUES(216,8531,689,9);
INSERT INTO INTERPRETE VALUES(216,8532,689,10);
INSERT INTO INTERPRETE VALUES(216,8534,689,12);
INSERT INTO INTERPRETE VALUES(52,2249,207,2);
INSERT INTO INTERPRETE VALUES(44,2904,468,9);
INSERT INTO INTERPRETE VALUES(52,2252,207,5);
INSERT INTO INTERPRETE VALUES(44,2904,266,4);
INSERT INTO INTERPRETE VALUES(52,3701,330,1);
INSERT INTO INTERPRETE VALUES(52,3702,507,2);
INSERT INTO INTERPRETE VALUES(125,8871,707,10);
INSERT INTO INTERPRETE VALUES(44,5588,468,10);
INSERT INTO INTERPRETE VALUES(52,3702,330,2);
INSERT INTO INTERPRETE VALUES(194,8967,716,8);
INSERT INTO INTERPRETE VALUES(194,8968,716,9);
INSERT INTO INTERPRETE VALUES(52,3555,506,4);
INSERT INTO INTERPRETE VALUES(44,1248,377,13);
INSERT INTO INTERPRETE VALUES(52,3555,330,3);
INSERT INTO INTERPRETE VALUES(262,9005,720,1);
INSERT INTO INTERPRETE VALUES(262,9006,720,2);
INSERT INTO INTERPRETE VALUES(262,9007,720,3);
INSERT INTO INTERPRETE VALUES(262,9008,720,4);
INSERT INTO INTERPRETE VALUES(262,9009,720,5);
INSERT INTO INTERPRETE VALUES(262,9010,720,6);
INSERT INTO INTERPRETE VALUES(262,9011,720,7);
INSERT INTO INTERPRETE VALUES(52,3713,330,13);
INSERT INTO INTERPRETE VALUES(216,9024,721,10);
INSERT INTO INTERPRETE VALUES(52,3704,330,4);
INSERT INTO INTERPRETE VALUES(263,9034,722,1);
INSERT INTO INTERPRETE VALUES(263,9035,722,2);
INSERT INTO INTERPRETE VALUES(263,9036,722,3);
INSERT INTO INTERPRETE VALUES(263,9037,722,4);
INSERT INTO INTERPRETE VALUES(263,9038,722,5);
INSERT INTO INTERPRETE VALUES(263,9039,722,6);
INSERT INTO INTERPRETE VALUES(263,9040,722,7);
INSERT INTO INTERPRETE VALUES(263,9041,722,8);
INSERT INTO INTERPRETE VALUES(263,9042,722,9);
INSERT INTO INTERPRETE VALUES(95,9043,723,1);
INSERT INTO INTERPRETE VALUES(44,3211,291,12);
INSERT INTO INTERPRETE VALUES(112,4299,388,6);
INSERT INTO INTERPRETE VALUES(44,5669,475,10);
INSERT INTO INTERPRETE VALUES(118,4300,372,9);
INSERT INTO INTERPRETE VALUES(264,9074,725,1);
INSERT INTO INTERPRETE VALUES(264,9075,725,2);
INSERT INTO INTERPRETE VALUES(264,9076,725,3);
INSERT INTO INTERPRETE VALUES(44,5661,475,2);
INSERT INTO INTERPRETE VALUES(118,4302,372,11);
INSERT INTO INTERPRETE VALUES(216,8537,726,3);
INSERT INTO INTERPRETE VALUES(216,8541,726,7);
INSERT INTO INTERPRETE VALUES(216,9093,726,11);
INSERT INTO INTERPRETE VALUES(216,9094,726,12);
INSERT INTO INTERPRETE VALUES(109,6262,520,10);
INSERT INTO INTERPRETE VALUES(44,3203,291,4);
INSERT INTO INTERPRETE VALUES(118,4304,372,13);
INSERT INTO INTERPRETE VALUES(216,9114,728,7);
INSERT INTO INTERPRETE VALUES(44,5675,475,16);
INSERT INTO INTERPRETE VALUES(118,4303,372,12);
INSERT INTO INTERPRETE VALUES(168,9130,729,7);
INSERT INTO INTERPRETE VALUES(44,5674,475,15);
INSERT INTO INTERPRETE VALUES(118,4305,372,14);
INSERT INTO INTERPRETE VALUES(95,9215,737,11);
INSERT INTO INTERPRETE VALUES(95,9216,737,12);
INSERT INTO INTERPRETE VALUES(216,9218,738,2);
INSERT INTO INTERPRETE VALUES(216,9220,738,4);
INSERT INTO INTERPRETE VALUES(216,9221,738,5);
INSERT INTO INTERPRETE VALUES(216,9223,738,7);
INSERT INTO INTERPRETE VALUES(216,9224,738,8);
INSERT INTO INTERPRETE VALUES(216,9226,738,10);
INSERT INTO INTERPRETE VALUES(216,9227,738,11);
INSERT INTO INTERPRETE VALUES(216,9228,738,12);
INSERT INTO INTERPRETE VALUES(44,5667,475,8);
INSERT INTO INTERPRETE VALUES(52,2733,251,2);
INSERT INTO INTERPRETE VALUES(44,4588,391,3);
INSERT INTO INTERPRETE VALUES(52,2656,251,6);
INSERT INTO INTERPRETE VALUES(254,8789,742,2);
INSERT INTO INTERPRETE VALUES(254,9284,742,3);
INSERT INTO INTERPRETE VALUES(254,9285,742,4);
INSERT INTO INTERPRETE VALUES(254,9176,742,5);
INSERT INTO INTERPRETE VALUES(254,9175,742,6);
INSERT INTO INTERPRETE VALUES(254,9288,742,7);
INSERT INTO INTERPRETE VALUES(254,9174,742,8);
INSERT INTO INTERPRETE VALUES(254,9290,742,9);
INSERT INTO INTERPRETE VALUES(254,9291,742,10);
INSERT INTO INTERPRETE VALUES(254,8779,742,11);
INSERT INTO INTERPRETE VALUES(254,9293,742,12);
INSERT INTO INTERPRETE VALUES(216,9254,743,8);
INSERT INTO INTERPRETE VALUES(216,9302,743,9);
INSERT INTO INTERPRETE VALUES(216,9307,743,14);
INSERT INTO INTERPRETE VALUES(131,9308,744,1);
INSERT INTO INTERPRETE VALUES(131,9309,744,2);
INSERT INTO INTERPRETE VALUES(131,9310,744,3);
INSERT INTO INTERPRETE VALUES(131,9311,744,4);
INSERT INTO INTERPRETE VALUES(131,9312,744,5);
INSERT INTO INTERPRETE VALUES(131,9313,744,6);
INSERT INTO INTERPRETE VALUES(131,9314,744,7);
INSERT INTO INTERPRETE VALUES(131,9315,744,8);
INSERT INTO INTERPRETE VALUES(131,9316,744,9);
INSERT INTO INTERPRETE VALUES(131,9317,744,10);
INSERT INTO INTERPRETE VALUES(78,2656,315,2);
INSERT INTO INTERPRETE VALUES(257,9320,745,2);
INSERT INTO INTERPRETE VALUES(257,9321,745,3);
INSERT INTO INTERPRETE VALUES(257,9322,745,4);
INSERT INTO INTERPRETE VALUES(257,9323,745,5);
INSERT INTO INTERPRETE VALUES(257,9324,745,6);
INSERT INTO INTERPRETE VALUES(257,9325,745,7);
INSERT INTO INTERPRETE VALUES(257,9326,745,8);
INSERT INTO INTERPRETE VALUES(257,9327,745,9);
INSERT INTO INTERPRETE VALUES(257,9328,745,10);
INSERT INTO INTERPRETE VALUES(257,9329,745,11);
INSERT INTO INTERPRETE VALUES(44,5665,475,6);
INSERT INTO INTERPRETE VALUES(84,2216,203,7);
INSERT INTO INTERPRETE VALUES(257,9345,745,27);
INSERT INTO INTERPRETE VALUES(257,9346,745,28);
INSERT INTO INTERPRETE VALUES(268,9347,746,1);
INSERT INTO INTERPRETE VALUES(268,9348,746,2);
INSERT INTO INTERPRETE VALUES(268,9349,746,3);
INSERT INTO INTERPRETE VALUES(268,9350,746,4);
INSERT INTO INTERPRETE VALUES(268,9351,746,5);
INSERT INTO INTERPRETE VALUES(268,9352,746,6);
INSERT INTO INTERPRETE VALUES(268,9022,746,8);
INSERT INTO INTERPRETE VALUES(44,2724,250,5);
INSERT INTO INTERPRETE VALUES(11,5419,454,11);
INSERT INTO INTERPRETE VALUES(216,9444,753,8);
INSERT INTO INTERPRETE VALUES(216,9445,753,9);
INSERT INTO INTERPRETE VALUES(216,9446,753,10);
INSERT INTO INTERPRETE VALUES(216,9447,753,11);
INSERT INTO INTERPRETE VALUES(44,2472,228,2);
INSERT INTO INTERPRETE VALUES(52,6465,534,8);
INSERT INTO INTERPRETE VALUES(272,9523,758,3);
INSERT INTO INTERPRETE VALUES(272,9524,758,4);
INSERT INTO INTERPRETE VALUES(272,9525,758,5);
INSERT INTO INTERPRETE VALUES(272,9526,758,6);
INSERT INTO INTERPRETE VALUES(272,9527,758,7);
INSERT INTO INTERPRETE VALUES(272,9528,758,8);
INSERT INTO INTERPRETE VALUES(44,2474,228,4);
INSERT INTO INTERPRETE VALUES(52,3943,390,6);
INSERT INTO INTERPRETE VALUES(216,9560,760,10);
INSERT INTO INTERPRETE VALUES(216,9561,760,11);
INSERT INTO INTERPRETE VALUES(216,9563,760,13);
INSERT INTO INTERPRETE VALUES(216,9564,760,14);
INSERT INTO INTERPRETE VALUES(216,9565,760,15);
INSERT INTO INTERPRETE VALUES(216,9566,760,16);
INSERT INTO INTERPRETE VALUES(216,9567,760,17);
INSERT INTO INTERPRETE VALUES(252,8640,761,1);
INSERT INTO INTERPRETE VALUES(252,8680,761,2);
INSERT INTO INTERPRETE VALUES(252,8682,761,3);
INSERT INTO INTERPRETE VALUES(252,8634,761,4);
INSERT INTO INTERPRETE VALUES(252,8678,761,5);
INSERT INTO INTERPRETE VALUES(252,8676,761,6);
INSERT INTO INTERPRETE VALUES(44,2477,228,7);
INSERT INTO INTERPRETE VALUES(44,5662,475,3);
INSERT INTO INTERPRETE VALUES(141,3943,348,1);
INSERT INTO INTERPRETE VALUES(160,9613,764,2);
INSERT INTO INTERPRETE VALUES(44,2480,228,10);
INSERT INTO INTERPRETE VALUES(44,5671,475,12);
INSERT INTO INTERPRETE VALUES(52,6464,534,7);
INSERT INTO INTERPRETE VALUES(44,3341,463,10);
INSERT INTO INTERPRETE VALUES(118,4292,372,1);
INSERT INTO INTERPRETE VALUES(274,9740,771,12);
INSERT INTO INTERPRETE VALUES(44,2725,250,6);
INSERT INTO INTERPRETE VALUES(44,5666,475,7);
INSERT INTO INTERPRETE VALUES(118,4293,372,2);
INSERT INTO INTERPRETE VALUES(131,9836,779,9);
INSERT INTO INTERPRETE VALUES(131,9837,779,10);
INSERT INTO INTERPRETE VALUES(131,9838,779,11);
INSERT INTO INTERPRETE VALUES(131,9839,779,12);
INSERT INTO INTERPRETE VALUES(254,9841,780,1);
INSERT INTO INTERPRETE VALUES(254,9842,780,2);
INSERT INTO INTERPRETE VALUES(254,9843,780,3);
INSERT INTO INTERPRETE VALUES(254,9844,780,4);
INSERT INTO INTERPRETE VALUES(78,2725,315,3);
INSERT INTO INTERPRETE VALUES(44,5663,475,4);
INSERT INTO INTERPRETE VALUES(118,4294,372,3);
INSERT INTO INTERPRETE VALUES(143,8532,783,12);
INSERT INTO INTERPRETE VALUES(143,9092,783,15);
INSERT INTO INTERPRETE VALUES(52,3894,344,5);
INSERT INTO INTERPRETE VALUES(44,5673,475,14);
INSERT INTO INTERPRETE VALUES(52,3895,344,6);
INSERT INTO INTERPRETE VALUES(181,9936,786,12);
INSERT INTO INTERPRETE VALUES(44,5509,463,5);
INSERT INTO INTERPRETE VALUES(44,5513,463,9);
INSERT INTO INTERPRETE VALUES(52,3896,344,7);
INSERT INTO INTERPRETE VALUES(44,2959,270,12);
INSERT INTO INTERPRETE VALUES(52,3897,344,8);
INSERT INTO INTERPRETE VALUES(258,10154,800,10);
INSERT INTO INTERPRETE VALUES(258,10155,800,11);
INSERT INTO INTERPRETE VALUES(258,10156,800,12);
INSERT INTO INTERPRETE VALUES(258,10157,800,13);
INSERT INTO INTERPRETE VALUES(258,1298,800,18);
INSERT INTO INTERPRETE VALUES(44,6501,855,14);
INSERT INTO INTERPRETE VALUES(205,11195,871,1);
INSERT INTO INTERPRETE VALUES(52,3898,344,9);
INSERT INTO INTERPRETE VALUES(44,1577,140,2);
INSERT INTO INTERPRETE VALUES(205,11196,871,2);
INSERT INTO INTERPRETE VALUES(52,3899,344,10);
INSERT INTO INTERPRETE VALUES(44,1578,140,3);
INSERT INTO INTERPRETE VALUES(205,11197,871,3);
INSERT INTO INTERPRETE VALUES(52,3900,344,11);
INSERT INTO INTERPRETE VALUES(264,10453,817,1);
INSERT INTO INTERPRETE VALUES(264,10454,817,2);
INSERT INTO INTERPRETE VALUES(264,10455,817,3);
INSERT INTO INTERPRETE VALUES(264,10456,817,4);
INSERT INTO INTERPRETE VALUES(264,10457,817,5);
INSERT INTO INTERPRETE VALUES(264,10458,817,6);
INSERT INTO INTERPRETE VALUES(264,10459,817,7);
INSERT INTO INTERPRETE VALUES(264,10460,817,8);
INSERT INTO INTERPRETE VALUES(264,10461,817,9);
INSERT INTO INTERPRETE VALUES(264,10462,817,10);
INSERT INTO INTERPRETE VALUES(57,10463,818,1);
INSERT INTO INTERPRETE VALUES(57,10465,818,3);
INSERT INTO INTERPRETE VALUES(57,10466,818,4);
INSERT INTO INTERPRETE VALUES(57,10467,818,5);
INSERT INTO INTERPRETE VALUES(57,10471,818,9);
INSERT INTO INTERPRETE VALUES(57,10472,818,10);
INSERT INTO INTERPRETE VALUES(44,1581,140,6);
INSERT INTO INTERPRETE VALUES(205,11198,871,4);
INSERT INTO INTERPRETE VALUES(84,2213,203,4);
INSERT INTO INTERPRETE VALUES(57,10475,818,13);
INSERT INTO INTERPRETE VALUES(44,1582,140,7);
INSERT INTO INTERPRETE VALUES(205,11199,871,5);
INSERT INTO INTERPRETE VALUES(52,4413,380,4);
INSERT INTO INTERPRETE VALUES(44,1544,136,3);
INSERT INTO INTERPRETE VALUES(205,11200,871,6);
INSERT INTO INTERPRETE VALUES(52,6062,506,8);
INSERT INTO INTERPRETE VALUES(205,11201,871,7);
INSERT INTO INTERPRETE VALUES(52,1178,98,5);
INSERT INTO INTERPRETE VALUES(205,11202,871,8);
INSERT INTO INTERPRETE VALUES(52,6462,534,5);
INSERT INTO INTERPRETE VALUES(283,10806,840,1);
INSERT INTO INTERPRETE VALUES(283,10807,840,2);
INSERT INTO INTERPRETE VALUES(283,10808,840,3);
INSERT INTO INTERPRETE VALUES(283,10809,840,4);
INSERT INTO INTERPRETE VALUES(283,10810,840,5);
INSERT INTO INTERPRETE VALUES(283,10811,840,6);
INSERT INTO INTERPRETE VALUES(283,10812,840,7);
INSERT INTO INTERPRETE VALUES(283,10813,840,8);
INSERT INTO INTERPRETE VALUES(283,10814,840,9);
INSERT INTO INTERPRETE VALUES(283,10815,840,10);
INSERT INTO INTERPRETE VALUES(283,10816,840,11);
INSERT INTO INTERPRETE VALUES(283,10817,840,12);
INSERT INTO INTERPRETE VALUES(283,10820,840,15);
INSERT INTO INTERPRETE VALUES(205,11203,871,9);
INSERT INTO INTERPRETE VALUES(52,6458,534,1);
INSERT INTO INTERPRETE VALUES(205,11204,871,10);
INSERT INTO INTERPRETE VALUES(52,6467,534,10);
INSERT INTO INTERPRETE VALUES(3,10923,849,9);
INSERT INTO INTERPRETE VALUES(3,10924,849,10);
INSERT INTO INTERPRETE VALUES(3,10925,849,11);
INSERT INTO INTERPRETE VALUES(3,10926,849,12);
INSERT INTO INTERPRETE VALUES(205,11205,871,11);
INSERT INTO INTERPRETE VALUES(44,4206,463,8);
INSERT INTO INTERPRETE VALUES(205,11206,871,12);
INSERT INTO INTERPRETE VALUES(52,3789,396,8);
INSERT INTO INTERPRETE VALUES(44,4211,855,8);
INSERT INTO INTERPRETE VALUES(288,11207,872,1);
INSERT INTO INTERPRETE VALUES(52,3553,390,3);
INSERT INTO INTERPRETE VALUES(122,10967,852,9);
INSERT INTO INTERPRETE VALUES(288,11208,872,2);
INSERT INTO INTERPRETE VALUES(52,3553,390,10);
INSERT INTO INTERPRETE VALUES(288,11209,872,3);
INSERT INTO INTERPRETE VALUES(282,10656,830,9);
INSERT INTO INTERPRETE VALUES(288,11210,872,4);
INSERT INTO INTERPRETE VALUES(101,2524,233,2);
INSERT INTO INTERPRETE VALUES(288,11211,872,5);
INSERT INTO INTERPRETE VALUES(208,7303,634,8);
INSERT INTO INTERPRETE VALUES(288,9724,872,6);
INSERT INTO INTERPRETE VALUES(57,3850,341,3);
INSERT INTO INTERPRETE VALUES(288,11213,872,7);
INSERT INTO INTERPRETE VALUES(106,5247,441,9);
INSERT INTO INTERPRETE VALUES(143,4808,407,9);
INSERT INTO INTERPRETE VALUES(143,4828,410,1);
INSERT INTO INTERPRETE VALUES(288,11214,872,8);
INSERT INTO INTERPRETE VALUES(52,1194,99,2);
INSERT INTO INTERPRETE VALUES(288,11215,872,9);
INSERT INTO INTERPRETE VALUES(69,1530,135,17);
INSERT INTO INTERPRETE VALUES(143,4984,422,14);
INSERT INTO INTERPRETE VALUES(288,11216,872,10);
INSERT INTO INTERPRETE VALUES(52,1530,396,16);
INSERT INTO INTERPRETE VALUES(288,11217,872,11);
INSERT INTO INTERPRETE VALUES(99,2748,252,3);
INSERT INTO INTERPRETE VALUES(288,11218,872,12);
INSERT INTO INTERPRETE VALUES(52,4767,403,7);
INSERT INTO INTERPRETE VALUES(196,6739,556,2);
INSERT INTO INTERPRETE VALUES(288,11219,872,13);
INSERT INTO INTERPRETE VALUES(52,3382,305,8);
INSERT INTO INTERPRETE VALUES(216,7317,600,7);
INSERT INTO INTERPRETE VALUES(276,10049,793,1);
INSERT INTO INTERPRETE VALUES(52,3627,324,8);
INSERT INTO INTERPRETE VALUES(196,6739,603,10);
INSERT INTO INTERPRETE VALUES(230,7667,628,12);
INSERT INTO INTERPRETE VALUES(52,3549,390,1);
INSERT INTO INTERPRETE VALUES(230,8241,672,17);
INSERT INTO INTERPRETE VALUES(52,3381,305,7);
INSERT INTO INTERPRETE VALUES(230,8182,667,14);
INSERT INTO INTERPRETE VALUES(52,3623,324,4);
INSERT INTO INTERPRETE VALUES(199,11220,873,1);
INSERT INTO INTERPRETE VALUES(52,4671,396,1);
INSERT INTO INTERPRETE VALUES(199,11221,873,2);
INSERT INTO INTERPRETE VALUES(52,1708,154,8);
INSERT INTO INTERPRETE VALUES(199,11222,873,3);
INSERT INTO INTERPRETE VALUES(52,4761,403,1);
INSERT INTO INTERPRETE VALUES(199,11223,873,4);
INSERT INTO INTERPRETE VALUES(52,4762,403,2);
INSERT INTO INTERPRETE VALUES(216,9091,726,14);
INSERT INTO INTERPRETE VALUES(199,11224,873,5);
INSERT INTO INTERPRETE VALUES(52,1701,154,1);
INSERT INTO INTERPRETE VALUES(216,9019,728,15);
INSERT INTO INTERPRETE VALUES(199,11225,873,6);
INSERT INTO INTERPRETE VALUES(52,1710,154,10);
INSERT INTO INTERPRETE VALUES(199,11226,873,7);
INSERT INTO INTERPRETE VALUES(52,4770,403,10);
INSERT INTO INTERPRETE VALUES(216,9252,740,9);
INSERT INTO INTERPRETE VALUES(199,11227,873,8);
INSERT INTO INTERPRETE VALUES(52,4766,403,6);
INSERT INTO INTERPRETE VALUES(199,11228,873,9);
INSERT INTO INTERPRETE VALUES(52,4769,403,9);
INSERT INTO INTERPRETE VALUES(199,11229,873,10);
INSERT INTO INTERPRETE VALUES(52,1704,154,4);
INSERT INTO INTERPRETE VALUES(216,9555,760,5);
INSERT INTO INTERPRETE VALUES(199,11230,873,11);
INSERT INTO INTERPRETE VALUES(52,4675,396,5);
INSERT INTO INTERPRETE VALUES(199,11231,873,12);
INSERT INTO INTERPRETE VALUES(52,2732,251,1);
INSERT INTO INTERPRETE VALUES(199,11232,873,13);
INSERT INTO INTERPRETE VALUES(52,6459,534,2);
INSERT INTO INTERPRETE VALUES(199,11233,873,14);
INSERT INTO INTERPRETE VALUES(52,3377,305,3);
INSERT INTO INTERPRETE VALUES(144,4047,355,4);
INSERT INTO INTERPRETE VALUES(199,11234,873,15);
INSERT INTO INTERPRETE VALUES(52,1702,154,2);
INSERT INTO INTERPRETE VALUES(199,11235,873,16);
INSERT INTO INTERPRETE VALUES(52,3375,305,1);
INSERT INTO INTERPRETE VALUES(118,2999,274,5);
INSERT INTO INTERPRETE VALUES(199,11236,873,17);
INSERT INTO INTERPRETE VALUES(52,1193,99,1);
INSERT INTO INTERPRETE VALUES(77,11237,874,1);
INSERT INTO INTERPRETE VALUES(52,1707,154,7);
INSERT INTO INTERPRETE VALUES(77,11238,874,2);
INSERT INTO INTERPRETE VALUES(52,1706,154,6);
INSERT INTO INTERPRETE VALUES(77,11239,874,3);
INSERT INTO INTERPRETE VALUES(52,3376,305,2);
INSERT INTO INTERPRETE VALUES(77,11240,874,4);
INSERT INTO INTERPRETE VALUES(52,4768,403,8);
INSERT INTO INTERPRETE VALUES(77,11241,874,5);
INSERT INTO INTERPRETE VALUES(52,3380,305,6);
INSERT INTO INTERPRETE VALUES(77,11242,874,6);
INSERT INTO INTERPRETE VALUES(52,4765,403,5);
INSERT INTO INTERPRETE VALUES(77,11243,874,7);
INSERT INTO INTERPRETE VALUES(52,3785,396,11);
INSERT INTO INTERPRETE VALUES(77,11244,874,8);
INSERT INTO INTERPRETE VALUES(77,1711,874,9);
INSERT INTO INTERPRETE VALUES(77,11246,874,10);
INSERT INTO INTERPRETE VALUES(77,8982,874,11);
INSERT INTO INTERPRETE VALUES(289,11248,875,1);
INSERT INTO INTERPRETE VALUES(143,4819,408,11);
INSERT INTO INTERPRETE VALUES(289,11249,875,2);
INSERT INTO INTERPRETE VALUES(289,11250,875,3);
INSERT INTO INTERPRETE VALUES(208,7305,634,1);
INSERT INTO INTERPRETE VALUES(272,9641,765,12);
INSERT INTO INTERPRETE VALUES(289,11251,875,4);
INSERT INTO INTERPRETE VALUES(208,6925,572,6);
INSERT INTO INTERPRETE VALUES(289,11252,875,5);
INSERT INTO INTERPRETE VALUES(289,11253,875,6);
INSERT INTO INTERPRETE VALUES(289,11254,875,7);
INSERT INTO INTERPRETE VALUES(289,11255,875,8);
INSERT INTO INTERPRETE VALUES(289,11256,875,9);
INSERT INTO INTERPRETE VALUES(44,1580,140,5);
INSERT INTO INTERPRETE VALUES(289,11257,875,10);
INSERT INTO INTERPRETE VALUES(52,4430,381,6);
INSERT INTO INTERPRETE VALUES(289,11258,875,11);
INSERT INTO INTERPRETE VALUES(289,11259,875,12);
INSERT INTO INTERPRETE VALUES(289,11260,875,13);
INSERT INTO INTERPRETE VALUES(289,11261,875,14);
INSERT INTO INTERPRETE VALUES(289,11262,875,15);
INSERT INTO INTERPRETE VALUES(289,11263,875,16);
INSERT INTO INTERPRETE VALUES(289,11264,875,17);
INSERT INTO INTERPRETE VALUES(289,11265,875,18);
INSERT INTO INTERPRETE VALUES(181,10010,790,31);
INSERT INTO INTERPRETE VALUES(289,11266,875,19);
INSERT INTO INTERPRETE VALUES(289,11267,875,20);
INSERT INTO INTERPRETE VALUES(289,11268,875,21);
INSERT INTO INTERPRETE VALUES(289,11269,875,22);
INSERT INTO INTERPRETE VALUES(289,11270,875,23);
INSERT INTO INTERPRETE VALUES(71,9976,789,5);
INSERT INTO INTERPRETE VALUES(290,11271,876,1);
INSERT INTO INTERPRETE VALUES(290,11272,876,2);
INSERT INTO INTERPRETE VALUES(290,11273,876,3);
INSERT INTO INTERPRETE VALUES(290,11274,876,4);
INSERT INTO INTERPRETE VALUES(52,1911,506,9);
INSERT INTO INTERPRETE VALUES(6,79,8,9);
INSERT INTO INTERPRETE VALUES(290,11275,876,5);
INSERT INTO INTERPRETE VALUES(290,7335,876,6);
INSERT INTO INTERPRETE VALUES(52,4314,373,9);
INSERT INTO INTERPRETE VALUES(290,11277,876,7);
INSERT INTO INTERPRETE VALUES(93,3115,284,1);
INSERT INTO INTERPRETE VALUES(290,11278,876,8);
INSERT INTO INTERPRETE VALUES(290,11279,876,9);
INSERT INTO INTERPRETE VALUES(290,11280,876,10);
INSERT INTO INTERPRETE VALUES(290,11281,876,11);
INSERT INTO INTERPRETE VALUES(290,11282,876,12);
INSERT INTO INTERPRETE VALUES(66,2104,192,3);
INSERT INTO INTERPRETE VALUES(290,11283,876,13);
INSERT INTO INTERPRETE VALUES(290,11284,876,14);
INSERT INTO INTERPRETE VALUES(290,11285,876,15);
INSERT INTO INTERPRETE VALUES(162,5265,443,8);
INSERT INTO INTERPRETE VALUES(290,11286,876,16);
INSERT INTO INTERPRETE VALUES(290,11287,876,17);
INSERT INTO INTERPRETE VALUES(52,4424,380,15);
INSERT INTO INTERPRETE VALUES(44,1583,140,8);
INSERT INTO INTERPRETE VALUES(226,8030,654,9);
INSERT INTO INTERPRETE VALUES(76,6994,577,9);
INSERT INTO INTERPRETE VALUES(127,3241,294,7);
INSERT INTO INTERPRETE VALUES(44,1985,855,6);
INSERT INTO INTERPRETE VALUES(44,10994,855,10);
INSERT INTO INTERPRETE VALUES(44,10996,855,12);
INSERT INTO INTERPRETE VALUES(44,10999,856,1);
INSERT INTO INTERPRETE VALUES(44,4323,856,10);
INSERT INTO INTERPRETE VALUES(49,1142,857,5);
INSERT INTO INTERPRETE VALUES(44,2011,183,3);
INSERT INTO INTERPRETE VALUES(194,6660,549,13);
INSERT INTO INTERPRETE VALUES(287,11034,859,3);
INSERT INTO INTERPRETE VALUES(0,1,0,1);
INSERT INTO INTERPRETE VALUES(0,2,0,2);
INSERT INTO INTERPRETE VALUES(0,3,0,3);
INSERT INTO INTERPRETE VALUES(0,4,0,4);
INSERT INTO INTERPRETE VALUES(1,5,1,1);
INSERT INTO INTERPRETE VALUES(1,6,1,2);
INSERT INTO INTERPRETE VALUES(1,7,1,3);
INSERT INTO INTERPRETE VALUES(1,8,1,4);
INSERT INTO INTERPRETE VALUES(1,9,1,5);
INSERT INTO INTERPRETE VALUES(1,10,1,6);
INSERT INTO INTERPRETE VALUES(2,11,2,1);
INSERT INTO INTERPRETE VALUES(2,12,2,2);
INSERT INTO INTERPRETE VALUES(2,13,2,3);
INSERT INTO INTERPRETE VALUES(2,14,2,4);
INSERT INTO INTERPRETE VALUES(2,15,2,5);
INSERT INTO INTERPRETE VALUES(2,16,2,6);
INSERT INTO INTERPRETE VALUES(2,17,2,7);
INSERT INTO INTERPRETE VALUES(2,18,2,8);
INSERT INTO INTERPRETE VALUES(2,19,2,9);
INSERT INTO INTERPRETE VALUES(2,20,2,10);
INSERT INTO INTERPRETE VALUES(3,21,3,1);
INSERT INTO INTERPRETE VALUES(3,22,3,2);
INSERT INTO INTERPRETE VALUES(3,23,3,3);
INSERT INTO INTERPRETE VALUES(3,24,3,4);
INSERT INTO INTERPRETE VALUES(3,25,3,5);
INSERT INTO INTERPRETE VALUES(3,26,3,6);
INSERT INTO INTERPRETE VALUES(3,27,3,7);
INSERT INTO INTERPRETE VALUES(3,28,3,8);
INSERT INTO INTERPRETE VALUES(3,29,3,9);
INSERT INTO INTERPRETE VALUES(3,30,3,10);
INSERT INTO INTERPRETE VALUES(4,32,4,2);
INSERT INTO INTERPRETE VALUES(4,33,4,3);
INSERT INTO INTERPRETE VALUES(4,34,4,4);
INSERT INTO INTERPRETE VALUES(4,35,4,5);
INSERT INTO INTERPRETE VALUES(4,36,4,6);
INSERT INTO INTERPRETE VALUES(4,37,4,7);
INSERT INTO INTERPRETE VALUES(4,38,4,8);
INSERT INTO INTERPRETE VALUES(4,39,4,9);
INSERT INTO INTERPRETE VALUES(4,40,4,10);
INSERT INTO INTERPRETE VALUES(3,41,5,1);
INSERT INTO INTERPRETE VALUES(3,42,5,2);
INSERT INTO INTERPRETE VALUES(3,43,5,3);
INSERT INTO INTERPRETE VALUES(3,44,5,4);
INSERT INTO INTERPRETE VALUES(3,45,5,5);
INSERT INTO INTERPRETE VALUES(3,46,5,6);
INSERT INTO INTERPRETE VALUES(3,47,5,7);
INSERT INTO INTERPRETE VALUES(3,48,5,8);
INSERT INTO INTERPRETE VALUES(3,49,5,9);
INSERT INTO INTERPRETE VALUES(3,50,5,10);
INSERT INTO INTERPRETE VALUES(5,51,6,1);
INSERT INTO INTERPRETE VALUES(5,52,6,2);
INSERT INTO INTERPRETE VALUES(5,53,6,3);
INSERT INTO INTERPRETE VALUES(5,54,6,4);
INSERT INTO INTERPRETE VALUES(5,55,6,5);
INSERT INTO INTERPRETE VALUES(5,56,6,6);
INSERT INTO INTERPRETE VALUES(5,57,6,7);
INSERT INTO INTERPRETE VALUES(5,58,6,8);
INSERT INTO INTERPRETE VALUES(5,59,6,9);
INSERT INTO INTERPRETE VALUES(5,60,6,10);
INSERT INTO INTERPRETE VALUES(5,61,6,11);
INSERT INTO INTERPRETE VALUES(3,62,7,1);
INSERT INTO INTERPRETE VALUES(3,63,7,2);
INSERT INTO INTERPRETE VALUES(3,64,7,3);
INSERT INTO INTERPRETE VALUES(3,65,7,4);
INSERT INTO INTERPRETE VALUES(3,66,7,5);
INSERT INTO INTERPRETE VALUES(3,67,7,6);
INSERT INTO INTERPRETE VALUES(3,68,7,7);
INSERT INTO INTERPRETE VALUES(3,69,7,8);
INSERT INTO INTERPRETE VALUES(3,70,7,9);
INSERT INTO INTERPRETE VALUES(6,71,8,1);
INSERT INTO INTERPRETE VALUES(6,72,8,2);
INSERT INTO INTERPRETE VALUES(6,73,8,3);
INSERT INTO INTERPRETE VALUES(6,74,8,4);
INSERT INTO INTERPRETE VALUES(6,75,8,5);
INSERT INTO INTERPRETE VALUES(6,76,8,6);
INSERT INTO INTERPRETE VALUES(6,77,8,7);
INSERT INTO INTERPRETE VALUES(6,78,8,8);
INSERT INTO INTERPRETE VALUES(6,80,8,10);
INSERT INTO INTERPRETE VALUES(6,81,8,11);
INSERT INTO INTERPRETE VALUES(3,82,9,1);
INSERT INTO INTERPRETE VALUES(3,83,9,2);
INSERT INTO INTERPRETE VALUES(3,84,9,3);
INSERT INTO INTERPRETE VALUES(3,85,9,4);
INSERT INTO INTERPRETE VALUES(3,86,9,5);
INSERT INTO INTERPRETE VALUES(3,87,9,6);
INSERT INTO INTERPRETE VALUES(3,88,9,7);
INSERT INTO INTERPRETE VALUES(3,89,9,8);
INSERT INTO INTERPRETE VALUES(3,90,9,9);
INSERT INTO INTERPRETE VALUES(3,91,9,10);
INSERT INTO INTERPRETE VALUES(3,92,9,11);
INSERT INTO INTERPRETE VALUES(7,93,10,1);
INSERT INTO INTERPRETE VALUES(7,94,10,2);
INSERT INTO INTERPRETE VALUES(7,95,10,3);
INSERT INTO INTERPRETE VALUES(7,96,10,4);
INSERT INTO INTERPRETE VALUES(7,97,10,5);
INSERT INTO INTERPRETE VALUES(7,98,10,6);
INSERT INTO INTERPRETE VALUES(7,99,10,7);
INSERT INTO INTERPRETE VALUES(7,100,10,8);
INSERT INTO INTERPRETE VALUES(7,101,10,9);
INSERT INTO INTERPRETE VALUES(7,102,10,10);
INSERT INTO INTERPRETE VALUES(7,103,10,11);
INSERT INTO INTERPRETE VALUES(3,104,11,1);
INSERT INTO INTERPRETE VALUES(3,105,11,2);
INSERT INTO INTERPRETE VALUES(3,106,11,3);
INSERT INTO INTERPRETE VALUES(3,107,11,4);
INSERT INTO INTERPRETE VALUES(3,6532,11,5);
INSERT INTO INTERPRETE VALUES(3,109,11,6);
INSERT INTO INTERPRETE VALUES(3,110,11,7);
INSERT INTO INTERPRETE VALUES(3,111,11,8);
INSERT INTO INTERPRETE VALUES(3,112,11,9);
INSERT INTO INTERPRETE VALUES(3,113,11,10);
INSERT INTO INTERPRETE VALUES(3,106,11,11);
INSERT INTO INTERPRETE VALUES(8,115,12,1);
INSERT INTO INTERPRETE VALUES(8,116,12,2);
INSERT INTO INTERPRETE VALUES(8,117,12,3);
INSERT INTO INTERPRETE VALUES(8,118,12,4);
INSERT INTO INTERPRETE VALUES(8,120,12,6);
INSERT INTO INTERPRETE VALUES(8,121,12,7);
INSERT INTO INTERPRETE VALUES(7,134,13,9);
INSERT INTO INTERPRETE VALUES(7,135,13,10);
INSERT INTO INTERPRETE VALUES(7,136,13,11);
INSERT INTO INTERPRETE VALUES(7,137,13,12);
INSERT INTO INTERPRETE VALUES(9,138,14,1);
INSERT INTO INTERPRETE VALUES(9,139,14,2);
INSERT INTO INTERPRETE VALUES(9,140,14,3);
INSERT INTO INTERPRETE VALUES(9,141,14,4);
INSERT INTO INTERPRETE VALUES(9,142,14,5);
INSERT INTO INTERPRETE VALUES(9,143,14,6);
INSERT INTO INTERPRETE VALUES(9,144,14,7);
INSERT INTO INTERPRETE VALUES(9,145,14,8);
INSERT INTO INTERPRETE VALUES(9,146,14,9);
INSERT INTO INTERPRETE VALUES(9,147,14,10);
INSERT INTO INTERPRETE VALUES(9,148,14,11);
INSERT INTO INTERPRETE VALUES(9,149,14,12);
INSERT INTO INTERPRETE VALUES(9,150,14,13);
INSERT INTO INTERPRETE VALUES(0,151,15,1);
INSERT INTO INTERPRETE VALUES(0,152,15,2);
INSERT INTO INTERPRETE VALUES(0,153,15,3);
INSERT INTO INTERPRETE VALUES(0,154,15,4);
INSERT INTO INTERPRETE VALUES(0,155,15,5);
INSERT INTO INTERPRETE VALUES(0,156,15,6);
INSERT INTO INTERPRETE VALUES(0,157,15,7);
INSERT INTO INTERPRETE VALUES(0,158,15,8);
INSERT INTO INTERPRETE VALUES(0,159,15,9);
INSERT INTO INTERPRETE VALUES(0,160,15,10);
INSERT INTO INTERPRETE VALUES(0,161,15,11);
INSERT INTO INTERPRETE VALUES(0,162,15,12);
INSERT INTO INTERPRETE VALUES(0,163,16,1);
INSERT INTO INTERPRETE VALUES(0,164,16,2);
INSERT INTO INTERPRETE VALUES(0,165,16,3);
INSERT INTO INTERPRETE VALUES(0,166,16,4);
INSERT INTO INTERPRETE VALUES(0,167,16,5);
INSERT INTO INTERPRETE VALUES(0,168,16,6);
INSERT INTO INTERPRETE VALUES(0,169,16,7);
INSERT INTO INTERPRETE VALUES(0,170,16,8);
INSERT INTO INTERPRETE VALUES(0,171,16,9);
INSERT INTO INTERPRETE VALUES(0,172,16,10);
INSERT INTO INTERPRETE VALUES(0,173,16,11);
INSERT INTO INTERPRETE VALUES(0,1,16,12);
INSERT INTO INTERPRETE VALUES(7,175,17,1);
INSERT INTO INTERPRETE VALUES(7,176,17,2);
INSERT INTO INTERPRETE VALUES(7,177,17,3);
INSERT INTO INTERPRETE VALUES(7,178,17,4);
INSERT INTO INTERPRETE VALUES(7,179,17,5);
INSERT INTO INTERPRETE VALUES(7,180,17,6);
INSERT INTO INTERPRETE VALUES(7,181,17,7);
INSERT INTO INTERPRETE VALUES(7,182,17,8);
INSERT INTO INTERPRETE VALUES(7,183,17,9);
INSERT INTO INTERPRETE VALUES(7,184,17,10);
INSERT INTO INTERPRETE VALUES(7,185,17,11);
INSERT INTO INTERPRETE VALUES(7,186,17,12);
INSERT INTO INTERPRETE VALUES(7,187,17,13);
INSERT INTO INTERPRETE VALUES(7,188,17,14);
INSERT INTO INTERPRETE VALUES(3,6523,18,1);
INSERT INTO INTERPRETE VALUES(3,190,18,2);
INSERT INTO INTERPRETE VALUES(3,192,18,4);
INSERT INTO INTERPRETE VALUES(3,193,18,5);
INSERT INTO INTERPRETE VALUES(3,194,18,6);
INSERT INTO INTERPRETE VALUES(3,195,18,7);
INSERT INTO INTERPRETE VALUES(3,196,18,8);
INSERT INTO INTERPRETE VALUES(3,197,18,9);
INSERT INTO INTERPRETE VALUES(3,198,18,10);
INSERT INTO INTERPRETE VALUES(3,199,18,11);
INSERT INTO INTERPRETE VALUES(3,200,18,12);
INSERT INTO INTERPRETE VALUES(3,201,18,13);
INSERT INTO INTERPRETE VALUES(3,202,18,14);
INSERT INTO INTERPRETE VALUES(10,203,19,1);
INSERT INTO INTERPRETE VALUES(10,204,19,2);
INSERT INTO INTERPRETE VALUES(10,205,19,3);
INSERT INTO INTERPRETE VALUES(10,206,19,4);
INSERT INTO INTERPRETE VALUES(10,207,19,5);
INSERT INTO INTERPRETE VALUES(10,208,19,6);
INSERT INTO INTERPRETE VALUES(10,209,19,7);
INSERT INTO INTERPRETE VALUES(10,210,19,8);
INSERT INTO INTERPRETE VALUES(10,211,19,9);
INSERT INTO INTERPRETE VALUES(10,212,19,10);
INSERT INTO INTERPRETE VALUES(10,213,19,11);
INSERT INTO INTERPRETE VALUES(10,214,19,12);
INSERT INTO INTERPRETE VALUES(11,215,20,1);
INSERT INTO INTERPRETE VALUES(11,216,20,2);
INSERT INTO INTERPRETE VALUES(11,217,20,3);
INSERT INTO INTERPRETE VALUES(11,218,20,4);
INSERT INTO INTERPRETE VALUES(11,219,20,5);
INSERT INTO INTERPRETE VALUES(11,220,20,6);
INSERT INTO INTERPRETE VALUES(11,221,20,7);
INSERT INTO INTERPRETE VALUES(11,222,20,8);
INSERT INTO INTERPRETE VALUES(11,223,20,9);
INSERT INTO INTERPRETE VALUES(11,224,20,10);
INSERT INTO INTERPRETE VALUES(9,225,21,1);
INSERT INTO INTERPRETE VALUES(9,226,21,2);
INSERT INTO INTERPRETE VALUES(9,227,21,3);
INSERT INTO INTERPRETE VALUES(9,228,21,4);
INSERT INTO INTERPRETE VALUES(9,229,21,5);
INSERT INTO INTERPRETE VALUES(9,230,21,6);
INSERT INTO INTERPRETE VALUES(9,231,21,7);
INSERT INTO INTERPRETE VALUES(9,232,21,8);
INSERT INTO INTERPRETE VALUES(9,233,21,9);
INSERT INTO INTERPRETE VALUES(9,234,21,10);
INSERT INTO INTERPRETE VALUES(9,235,22,1);
INSERT INTO INTERPRETE VALUES(9,236,22,2);
INSERT INTO INTERPRETE VALUES(9,237,22,3);
INSERT INTO INTERPRETE VALUES(9,238,22,4);
INSERT INTO INTERPRETE VALUES(9,239,22,5);
INSERT INTO INTERPRETE VALUES(9,240,22,6);
INSERT INTO INTERPRETE VALUES(9,241,22,7);
INSERT INTO INTERPRETE VALUES(9,242,22,8);
INSERT INTO INTERPRETE VALUES(9,243,22,9);
INSERT INTO INTERPRETE VALUES(9,244,22,10);
INSERT INTO INTERPRETE VALUES(9,245,22,11);
INSERT INTO INTERPRETE VALUES(9,246,22,12);
INSERT INTO INTERPRETE VALUES(9,247,22,13);
INSERT INTO INTERPRETE VALUES(9,248,22,14);
INSERT INTO INTERPRETE VALUES(12,249,23,1);
INSERT INTO INTERPRETE VALUES(12,250,23,2);
INSERT INTO INTERPRETE VALUES(12,251,23,3);
INSERT INTO INTERPRETE VALUES(12,252,23,4);
INSERT INTO INTERPRETE VALUES(12,253,23,5);
INSERT INTO INTERPRETE VALUES(12,255,23,7);
INSERT INTO INTERPRETE VALUES(12,256,23,8);
INSERT INTO INTERPRETE VALUES(12,257,23,9);
INSERT INTO INTERPRETE VALUES(12,258,23,10);
INSERT INTO INTERPRETE VALUES(12,259,23,11);
INSERT INTO INTERPRETE VALUES(12,260,23,12);
INSERT INTO INTERPRETE VALUES(12,261,23,13);
INSERT INTO INTERPRETE VALUES(12,262,23,14);
INSERT INTO INTERPRETE VALUES(12,263,23,15);
INSERT INTO INTERPRETE VALUES(12,264,23,16);
INSERT INTO INTERPRETE VALUES(12,265,23,17);
INSERT INTO INTERPRETE VALUES(13,266,24,1);
INSERT INTO INTERPRETE VALUES(13,267,24,2);
INSERT INTO INTERPRETE VALUES(13,268,24,3);
INSERT INTO INTERPRETE VALUES(13,269,24,4);
INSERT INTO INTERPRETE VALUES(13,270,24,5);
INSERT INTO INTERPRETE VALUES(13,271,24,6);
INSERT INTO INTERPRETE VALUES(13,272,24,7);
INSERT INTO INTERPRETE VALUES(13,273,24,8);
INSERT INTO INTERPRETE VALUES(13,274,24,9);
INSERT INTO INTERPRETE VALUES(13,275,24,10);
INSERT INTO INTERPRETE VALUES(13,276,24,11);
INSERT INTO INTERPRETE VALUES(13,277,24,12);
INSERT INTO INTERPRETE VALUES(13,278,24,13);
INSERT INTO INTERPRETE VALUES(12,252,25,1);
INSERT INTO INTERPRETE VALUES(12,280,25,2);
INSERT INTO INTERPRETE VALUES(12,281,25,3);
INSERT INTO INTERPRETE VALUES(12,282,25,4);
INSERT INTO INTERPRETE VALUES(12,283,25,5);
INSERT INTO INTERPRETE VALUES(12,250,25,6);
INSERT INTO INTERPRETE VALUES(12,285,25,7);
INSERT INTO INTERPRETE VALUES(14,286,26,1);
INSERT INTO INTERPRETE VALUES(14,287,26,2);
INSERT INTO INTERPRETE VALUES(14,288,26,3);
INSERT INTO INTERPRETE VALUES(14,289,26,4);
INSERT INTO INTERPRETE VALUES(14,290,26,5);
INSERT INTO INTERPRETE VALUES(14,291,26,6);
INSERT INTO INTERPRETE VALUES(14,292,26,7);
INSERT INTO INTERPRETE VALUES(14,293,26,8);
INSERT INTO INTERPRETE VALUES(14,294,26,9);
INSERT INTO INTERPRETE VALUES(14,295,26,10);
INSERT INTO INTERPRETE VALUES(14,296,26,11);
INSERT INTO INTERPRETE VALUES(15,306,28,1);
INSERT INTO INTERPRETE VALUES(15,307,28,2);
INSERT INTO INTERPRETE VALUES(15,308,28,3);
INSERT INTO INTERPRETE VALUES(15,309,28,4);
INSERT INTO INTERPRETE VALUES(15,310,28,5);
INSERT INTO INTERPRETE VALUES(15,311,28,6);
INSERT INTO INTERPRETE VALUES(15,312,28,7);
INSERT INTO INTERPRETE VALUES(15,313,28,8);
INSERT INTO INTERPRETE VALUES(15,314,28,9);
INSERT INTO INTERPRETE VALUES(15,315,28,10);
INSERT INTO INTERPRETE VALUES(15,316,28,11);
INSERT INTO INTERPRETE VALUES(15,317,28,12);
INSERT INTO INTERPRETE VALUES(15,318,28,13);
INSERT INTO INTERPRETE VALUES(15,319,28,14);
INSERT INTO INTERPRETE VALUES(15,320,28,15);
INSERT INTO INTERPRETE VALUES(15,321,28,16);
INSERT INTO INTERPRETE VALUES(15,322,28,17);
INSERT INTO INTERPRETE VALUES(15,324,28,19);
INSERT INTO INTERPRETE VALUES(16,325,29,1);
INSERT INTO INTERPRETE VALUES(16,326,29,2);
INSERT INTO INTERPRETE VALUES(16,327,29,3);
INSERT INTO INTERPRETE VALUES(16,328,29,4);
INSERT INTO INTERPRETE VALUES(17,329,30,1);
INSERT INTO INTERPRETE VALUES(17,330,30,2);
INSERT INTO INTERPRETE VALUES(17,331,30,3);
INSERT INTO INTERPRETE VALUES(18,332,31,1);
INSERT INTO INTERPRETE VALUES(18,333,31,2);
INSERT INTO INTERPRETE VALUES(18,334,31,3);
INSERT INTO INTERPRETE VALUES(18,335,31,4);
INSERT INTO INTERPRETE VALUES(19,336,32,1);
INSERT INTO INTERPRETE VALUES(19,337,32,2);
INSERT INTO INTERPRETE VALUES(19,338,32,3);
INSERT INTO INTERPRETE VALUES(19,339,32,4);
INSERT INTO INTERPRETE VALUES(19,340,32,5);
INSERT INTO INTERPRETE VALUES(19,341,32,6);
INSERT INTO INTERPRETE VALUES(19,342,32,7);
INSERT INTO INTERPRETE VALUES(19,343,32,8);
INSERT INTO INTERPRETE VALUES(19,344,32,9);
INSERT INTO INTERPRETE VALUES(19,345,32,10);
INSERT INTO INTERPRETE VALUES(19,346,32,11);
INSERT INTO INTERPRETE VALUES(19,347,32,12);
INSERT INTO INTERPRETE VALUES(19,348,32,13);
INSERT INTO INTERPRETE VALUES(19,349,32,14);
INSERT INTO INTERPRETE VALUES(19,350,32,15);
INSERT INTO INTERPRETE VALUES(19,351,32,16);
INSERT INTO INTERPRETE VALUES(19,352,32,17);
INSERT INTO INTERPRETE VALUES(19,353,32,18);
INSERT INTO INTERPRETE VALUES(19,354,32,19);
INSERT INTO INTERPRETE VALUES(19,355,32,20);
INSERT INTO INTERPRETE VALUES(19,356,32,21);
INSERT INTO INTERPRETE VALUES(19,357,32,22);
INSERT INTO INTERPRETE VALUES(19,358,32,23);
INSERT INTO INTERPRETE VALUES(16,359,33,1);
INSERT INTO INTERPRETE VALUES(16,360,33,2);
INSERT INTO INTERPRETE VALUES(16,361,33,3);
INSERT INTO INTERPRETE VALUES(16,362,33,4);
INSERT INTO INTERPRETE VALUES(16,363,33,5);
INSERT INTO INTERPRETE VALUES(20,364,34,1);
INSERT INTO INTERPRETE VALUES(20,365,34,2);
INSERT INTO INTERPRETE VALUES(20,366,34,3);
INSERT INTO INTERPRETE VALUES(20,367,34,4);
INSERT INTO INTERPRETE VALUES(20,368,34,5);
INSERT INTO INTERPRETE VALUES(21,369,35,1);
INSERT INTO INTERPRETE VALUES(21,370,35,2);
INSERT INTO INTERPRETE VALUES(21,371,35,3);
INSERT INTO INTERPRETE VALUES(21,372,35,4);
INSERT INTO INTERPRETE VALUES(16,373,36,1);
INSERT INTO INTERPRETE VALUES(16,374,36,2);
INSERT INTO INTERPRETE VALUES(16,375,36,3);
INSERT INTO INTERPRETE VALUES(16,376,36,4);
INSERT INTO INTERPRETE VALUES(22,377,37,1);
INSERT INTO INTERPRETE VALUES(22,378,37,2);
INSERT INTO INTERPRETE VALUES(22,379,37,3);
INSERT INTO INTERPRETE VALUES(22,380,37,4);
INSERT INTO INTERPRETE VALUES(22,381,37,5);
INSERT INTO INTERPRETE VALUES(19,382,38,1);
INSERT INTO INTERPRETE VALUES(19,383,38,2);
INSERT INTO INTERPRETE VALUES(19,384,38,3);
INSERT INTO INTERPRETE VALUES(19,385,38,4);
INSERT INTO INTERPRETE VALUES(22,386,39,1);
INSERT INTO INTERPRETE VALUES(22,387,39,2);
INSERT INTO INTERPRETE VALUES(22,388,39,3);
INSERT INTO INTERPRETE VALUES(22,389,39,4);
INSERT INTO INTERPRETE VALUES(22,390,39,5);
INSERT INTO INTERPRETE VALUES(17,391,40,1);
INSERT INTO INTERPRETE VALUES(17,392,40,2);
INSERT INTO INTERPRETE VALUES(17,393,40,3);
INSERT INTO INTERPRETE VALUES(17,394,40,4);
INSERT INTO INTERPRETE VALUES(17,395,40,5);
INSERT INTO INTERPRETE VALUES(17,396,40,6);
INSERT INTO INTERPRETE VALUES(23,397,41,1);
INSERT INTO INTERPRETE VALUES(23,398,41,2);
INSERT INTO INTERPRETE VALUES(23,399,41,3);
INSERT INTO INTERPRETE VALUES(23,400,41,4);
INSERT INTO INTERPRETE VALUES(23,401,41,5);
INSERT INTO INTERPRETE VALUES(23,402,41,6);
INSERT INTO INTERPRETE VALUES(21,403,42,1);
INSERT INTO INTERPRETE VALUES(21,404,42,2);
INSERT INTO INTERPRETE VALUES(21,405,42,3);
INSERT INTO INTERPRETE VALUES(21,406,42,4);
INSERT INTO INTERPRETE VALUES(21,407,42,5);
INSERT INTO INTERPRETE VALUES(21,408,42,6);
INSERT INTO INTERPRETE VALUES(21,409,43,1);
INSERT INTO INTERPRETE VALUES(21,410,43,2);
INSERT INTO INTERPRETE VALUES(21,411,43,3);
INSERT INTO INTERPRETE VALUES(21,412,43,4);
INSERT INTO INTERPRETE VALUES(21,413,43,5);
INSERT INTO INTERPRETE VALUES(21,414,43,6);
INSERT INTO INTERPRETE VALUES(19,415,44,1);
INSERT INTO INTERPRETE VALUES(19,416,44,2);
INSERT INTO INTERPRETE VALUES(19,417,44,3);
INSERT INTO INTERPRETE VALUES(19,418,44,4);
INSERT INTO INTERPRETE VALUES(19,419,44,5);
INSERT INTO INTERPRETE VALUES(19,420,44,6);
INSERT INTO INTERPRETE VALUES(19,421,44,7);
INSERT INTO INTERPRETE VALUES(18,422,45,1);
INSERT INTO INTERPRETE VALUES(18,423,45,2);
INSERT INTO INTERPRETE VALUES(18,424,45,3);
INSERT INTO INTERPRETE VALUES(18,425,45,4);
INSERT INTO INTERPRETE VALUES(18,426,45,5);
INSERT INTO INTERPRETE VALUES(18,427,45,6);
INSERT INTO INTERPRETE VALUES(18,428,45,7);
INSERT INTO INTERPRETE VALUES(24,429,46,1);
INSERT INTO INTERPRETE VALUES(24,430,46,2);
INSERT INTO INTERPRETE VALUES(24,431,46,3);
INSERT INTO INTERPRETE VALUES(24,432,46,4);
INSERT INTO INTERPRETE VALUES(24,433,46,5);
INSERT INTO INTERPRETE VALUES(24,434,46,6);
INSERT INTO INTERPRETE VALUES(24,435,46,7);
INSERT INTO INTERPRETE VALUES(24,436,46,8);
INSERT INTO INTERPRETE VALUES(24,437,46,9);
INSERT INTO INTERPRETE VALUES(25,438,47,1);
INSERT INTO INTERPRETE VALUES(25,439,47,2);
INSERT INTO INTERPRETE VALUES(25,440,47,3);
INSERT INTO INTERPRETE VALUES(25,441,47,4);
INSERT INTO INTERPRETE VALUES(25,442,47,5);
INSERT INTO INTERPRETE VALUES(25,443,47,6);
INSERT INTO INTERPRETE VALUES(25,444,47,7);
INSERT INTO INTERPRETE VALUES(25,445,47,8);
INSERT INTO INTERPRETE VALUES(25,446,47,9);
INSERT INTO INTERPRETE VALUES(21,447,48,1);
INSERT INTO INTERPRETE VALUES(21,448,48,2);
INSERT INTO INTERPRETE VALUES(21,449,48,3);
INSERT INTO INTERPRETE VALUES(21,450,48,4);
INSERT INTO INTERPRETE VALUES(21,451,48,5);
INSERT INTO INTERPRETE VALUES(21,452,48,6);
INSERT INTO INTERPRETE VALUES(21,453,48,7);
INSERT INTO INTERPRETE VALUES(21,454,48,8);
INSERT INTO INTERPRETE VALUES(21,455,48,9);
INSERT INTO INTERPRETE VALUES(26,456,49,1);
INSERT INTO INTERPRETE VALUES(26,457,49,2);
INSERT INTO INTERPRETE VALUES(26,458,49,3);
INSERT INTO INTERPRETE VALUES(26,459,49,4);
INSERT INTO INTERPRETE VALUES(26,460,49,5);
INSERT INTO INTERPRETE VALUES(26,461,49,6);
INSERT INTO INTERPRETE VALUES(26,462,49,7);
INSERT INTO INTERPRETE VALUES(26,463,49,8);
INSERT INTO INTERPRETE VALUES(26,464,49,9);
INSERT INTO INTERPRETE VALUES(26,465,49,10);
INSERT INTO INTERPRETE VALUES(26,466,49,11);
INSERT INTO INTERPRETE VALUES(25,467,50,1);
INSERT INTO INTERPRETE VALUES(25,468,50,2);
INSERT INTO INTERPRETE VALUES(25,469,50,3);
INSERT INTO INTERPRETE VALUES(25,470,50,4);
INSERT INTO INTERPRETE VALUES(25,471,50,5);
INSERT INTO INTERPRETE VALUES(25,472,50,6);
INSERT INTO INTERPRETE VALUES(25,473,50,7);
INSERT INTO INTERPRETE VALUES(25,474,50,8);
INSERT INTO INTERPRETE VALUES(25,475,50,9);
INSERT INTO INTERPRETE VALUES(25,476,50,10);
INSERT INTO INTERPRETE VALUES(27,477,51,1);
INSERT INTO INTERPRETE VALUES(27,478,51,2);
INSERT INTO INTERPRETE VALUES(27,479,51,3);
INSERT INTO INTERPRETE VALUES(27,480,51,4);
INSERT INTO INTERPRETE VALUES(27,481,51,5);
INSERT INTO INTERPRETE VALUES(27,482,51,6);
INSERT INTO INTERPRETE VALUES(27,483,51,7);
INSERT INTO INTERPRETE VALUES(27,484,51,8);
INSERT INTO INTERPRETE VALUES(27,485,51,9);
INSERT INTO INTERPRETE VALUES(27,486,51,10);
INSERT INTO INTERPRETE VALUES(27,487,51,11);
INSERT INTO INTERPRETE VALUES(27,488,51,12);
INSERT INTO INTERPRETE VALUES(17,489,52,1);
INSERT INTO INTERPRETE VALUES(17,490,52,2);
INSERT INTO INTERPRETE VALUES(17,491,52,3);
INSERT INTO INTERPRETE VALUES(17,492,52,4);
INSERT INTO INTERPRETE VALUES(17,493,52,5);
INSERT INTO INTERPRETE VALUES(17,494,52,6);
INSERT INTO INTERPRETE VALUES(17,495,52,7);
INSERT INTO INTERPRETE VALUES(17,496,52,8);
INSERT INTO INTERPRETE VALUES(17,497,52,9);
INSERT INTO INTERPRETE VALUES(17,498,52,10);
INSERT INTO INTERPRETE VALUES(17,499,52,11);
INSERT INTO INTERPRETE VALUES(17,500,52,12);
INSERT INTO INTERPRETE VALUES(19,501,53,1);
INSERT INTO INTERPRETE VALUES(19,502,53,2);
INSERT INTO INTERPRETE VALUES(19,503,53,3);
INSERT INTO INTERPRETE VALUES(19,504,53,4);
INSERT INTO INTERPRETE VALUES(19,505,53,5);
INSERT INTO INTERPRETE VALUES(19,506,53,6);
INSERT INTO INTERPRETE VALUES(19,507,53,7);
INSERT INTO INTERPRETE VALUES(19,508,53,8);
INSERT INTO INTERPRETE VALUES(19,509,53,9);
INSERT INTO INTERPRETE VALUES(19,510,53,10);
INSERT INTO INTERPRETE VALUES(19,511,53,11);
INSERT INTO INTERPRETE VALUES(19,512,53,12);
INSERT INTO INTERPRETE VALUES(19,513,53,13);
INSERT INTO INTERPRETE VALUES(19,514,53,14);
INSERT INTO INTERPRETE VALUES(19,515,53,15);
INSERT INTO INTERPRETE VALUES(19,516,53,16);
INSERT INTO INTERPRETE VALUES(19,517,53,17);
INSERT INTO INTERPRETE VALUES(19,518,53,18);
INSERT INTO INTERPRETE VALUES(19,519,53,19);
INSERT INTO INTERPRETE VALUES(19,520,53,20);
INSERT INTO INTERPRETE VALUES(19,521,53,21);
INSERT INTO INTERPRETE VALUES(19,522,53,22);
INSERT INTO INTERPRETE VALUES(19,523,53,23);
INSERT INTO INTERPRETE VALUES(19,524,53,24);
INSERT INTO INTERPRETE VALUES(19,525,53,25);
INSERT INTO INTERPRETE VALUES(19,526,53,26);
INSERT INTO INTERPRETE VALUES(19,527,53,27);
INSERT INTO INTERPRETE VALUES(19,528,53,28);
INSERT INTO INTERPRETE VALUES(19,529,53,29);
INSERT INTO INTERPRETE VALUES(19,530,53,30);
INSERT INTO INTERPRETE VALUES(19,531,54,1);
INSERT INTO INTERPRETE VALUES(19,532,54,2);
INSERT INTO INTERPRETE VALUES(19,533,54,3);
INSERT INTO INTERPRETE VALUES(19,534,54,4);
INSERT INTO INTERPRETE VALUES(19,535,54,5);
INSERT INTO INTERPRETE VALUES(19,536,54,6);
INSERT INTO INTERPRETE VALUES(19,537,54,7);
INSERT INTO INTERPRETE VALUES(19,538,54,8);
INSERT INTO INTERPRETE VALUES(19,539,54,9);
INSERT INTO INTERPRETE VALUES(19,540,54,10);
INSERT INTO INTERPRETE VALUES(19,541,54,11);
INSERT INTO INTERPRETE VALUES(19,542,54,12);
INSERT INTO INTERPRETE VALUES(19,543,54,13);
INSERT INTO INTERPRETE VALUES(19,544,54,14);
INSERT INTO INTERPRETE VALUES(26,545,55,1);
INSERT INTO INTERPRETE VALUES(26,546,55,2);
INSERT INTO INTERPRETE VALUES(26,547,55,3);
INSERT INTO INTERPRETE VALUES(26,548,55,4);
INSERT INTO INTERPRETE VALUES(26,549,55,5);
INSERT INTO INTERPRETE VALUES(26,550,55,6);
INSERT INTO INTERPRETE VALUES(26,551,55,7);
INSERT INTO INTERPRETE VALUES(26,552,55,8);
INSERT INTO INTERPRETE VALUES(26,553,55,9);
INSERT INTO INTERPRETE VALUES(26,554,55,10);
INSERT INTO INTERPRETE VALUES(26,555,55,11);
INSERT INTO INTERPRETE VALUES(26,556,55,12);
INSERT INTO INTERPRETE VALUES(26,557,55,13);
INSERT INTO INTERPRETE VALUES(26,558,55,14);
INSERT INTO INTERPRETE VALUES(26,559,55,15);
INSERT INTO INTERPRETE VALUES(19,560,56,1);
INSERT INTO INTERPRETE VALUES(19,561,56,2);
INSERT INTO INTERPRETE VALUES(19,562,56,3);
INSERT INTO INTERPRETE VALUES(19,563,56,4);
INSERT INTO INTERPRETE VALUES(19,564,56,5);
INSERT INTO INTERPRETE VALUES(19,565,56,6);
INSERT INTO INTERPRETE VALUES(19,566,56,7);
INSERT INTO INTERPRETE VALUES(19,567,56,8);
INSERT INTO INTERPRETE VALUES(19,568,56,9);
INSERT INTO INTERPRETE VALUES(19,569,56,10);
INSERT INTO INTERPRETE VALUES(19,570,56,11);
INSERT INTO INTERPRETE VALUES(19,571,56,12);
INSERT INTO INTERPRETE VALUES(19,572,56,13);
INSERT INTO INTERPRETE VALUES(19,573,56,14);
INSERT INTO INTERPRETE VALUES(19,574,56,15);
INSERT INTO INTERPRETE VALUES(20,575,57,1);
INSERT INTO INTERPRETE VALUES(20,576,57,2);
INSERT INTO INTERPRETE VALUES(20,577,57,3);
INSERT INTO INTERPRETE VALUES(20,578,57,4);
INSERT INTO INTERPRETE VALUES(20,579,57,5);
INSERT INTO INTERPRETE VALUES(20,580,57,6);
INSERT INTO INTERPRETE VALUES(20,581,57,7);
INSERT INTO INTERPRETE VALUES(20,582,57,8);
INSERT INTO INTERPRETE VALUES(20,583,57,9);
INSERT INTO INTERPRETE VALUES(20,584,57,10);
INSERT INTO INTERPRETE VALUES(20,585,57,11);
INSERT INTO INTERPRETE VALUES(20,586,57,12);
INSERT INTO INTERPRETE VALUES(20,587,57,13);
INSERT INTO INTERPRETE VALUES(20,588,57,14);
INSERT INTO INTERPRETE VALUES(25,589,58,1);
INSERT INTO INTERPRETE VALUES(25,590,58,2);
INSERT INTO INTERPRETE VALUES(25,591,58,3);
INSERT INTO INTERPRETE VALUES(25,592,58,4);
INSERT INTO INTERPRETE VALUES(25,593,58,5);
INSERT INTO INTERPRETE VALUES(25,594,58,6);
INSERT INTO INTERPRETE VALUES(25,595,58,7);
INSERT INTO INTERPRETE VALUES(25,596,58,8);
INSERT INTO INTERPRETE VALUES(25,597,58,9);
INSERT INTO INTERPRETE VALUES(25,598,58,10);
INSERT INTO INTERPRETE VALUES(25,599,58,11);
INSERT INTO INTERPRETE VALUES(25,600,58,12);
INSERT INTO INTERPRETE VALUES(25,601,58,13);
INSERT INTO INTERPRETE VALUES(25,602,58,14);
INSERT INTO INTERPRETE VALUES(25,603,58,15);
INSERT INTO INTERPRETE VALUES(26,604,59,1);
INSERT INTO INTERPRETE VALUES(26,605,59,2);
INSERT INTO INTERPRETE VALUES(26,606,59,3);
INSERT INTO INTERPRETE VALUES(26,607,59,4);
INSERT INTO INTERPRETE VALUES(26,608,59,5);
INSERT INTO INTERPRETE VALUES(26,609,59,6);
INSERT INTO INTERPRETE VALUES(26,610,59,7);
INSERT INTO INTERPRETE VALUES(26,611,59,8);
INSERT INTO INTERPRETE VALUES(26,612,59,9);
INSERT INTO INTERPRETE VALUES(26,613,59,10);
INSERT INTO INTERPRETE VALUES(26,614,59,11);
INSERT INTO INTERPRETE VALUES(26,615,59,12);
INSERT INTO INTERPRETE VALUES(26,616,59,13);
INSERT INTO INTERPRETE VALUES(26,617,59,14);
INSERT INTO INTERPRETE VALUES(26,618,59,15);
INSERT INTO INTERPRETE VALUES(26,619,59,16);
INSERT INTO INTERPRETE VALUES(25,620,60,1);
INSERT INTO INTERPRETE VALUES(25,621,60,2);
INSERT INTO INTERPRETE VALUES(25,622,60,3);
INSERT INTO INTERPRETE VALUES(25,623,60,4);
INSERT INTO INTERPRETE VALUES(25,624,60,5);
INSERT INTO INTERPRETE VALUES(25,625,60,6);
INSERT INTO INTERPRETE VALUES(25,626,60,7);
INSERT INTO INTERPRETE VALUES(25,627,60,8);
INSERT INTO INTERPRETE VALUES(25,628,60,9);
INSERT INTO INTERPRETE VALUES(25,629,60,10);
INSERT INTO INTERPRETE VALUES(25,630,60,11);
INSERT INTO INTERPRETE VALUES(25,631,60,12);
INSERT INTO INTERPRETE VALUES(25,632,60,13);
INSERT INTO INTERPRETE VALUES(25,633,60,14);
INSERT INTO INTERPRETE VALUES(25,634,60,15);
INSERT INTO INTERPRETE VALUES(25,635,60,16);
INSERT INTO INTERPRETE VALUES(15,636,61,1);
INSERT INTO INTERPRETE VALUES(15,637,61,2);
INSERT INTO INTERPRETE VALUES(15,638,61,3);
INSERT INTO INTERPRETE VALUES(15,639,61,4);
INSERT INTO INTERPRETE VALUES(15,640,61,5);
INSERT INTO INTERPRETE VALUES(15,641,61,6);
INSERT INTO INTERPRETE VALUES(15,642,61,7);
INSERT INTO INTERPRETE VALUES(15,643,61,8);
INSERT INTO INTERPRETE VALUES(15,644,61,9);
INSERT INTO INTERPRETE VALUES(15,645,61,10);
INSERT INTO INTERPRETE VALUES(15,646,61,11);
INSERT INTO INTERPRETE VALUES(15,647,61,12);
INSERT INTO INTERPRETE VALUES(15,648,61,13);
INSERT INTO INTERPRETE VALUES(15,649,61,14);
INSERT INTO INTERPRETE VALUES(15,650,61,15);
INSERT INTO INTERPRETE VALUES(28,651,62,1);
INSERT INTO INTERPRETE VALUES(28,652,62,2);
INSERT INTO INTERPRETE VALUES(28,653,62,3);
INSERT INTO INTERPRETE VALUES(28,654,62,4);
INSERT INTO INTERPRETE VALUES(28,655,62,5);
INSERT INTO INTERPRETE VALUES(28,656,62,6);
INSERT INTO INTERPRETE VALUES(28,657,62,7);
INSERT INTO INTERPRETE VALUES(28,658,62,8);
INSERT INTO INTERPRETE VALUES(28,659,62,9);
INSERT INTO INTERPRETE VALUES(28,660,62,10);
INSERT INTO INTERPRETE VALUES(28,661,62,11);
INSERT INTO INTERPRETE VALUES(28,662,62,12);
INSERT INTO INTERPRETE VALUES(28,663,62,13);
INSERT INTO INTERPRETE VALUES(28,664,62,14);
INSERT INTO INTERPRETE VALUES(28,665,62,15);
INSERT INTO INTERPRETE VALUES(28,666,62,16);
INSERT INTO INTERPRETE VALUES(28,667,62,17);
INSERT INTO INTERPRETE VALUES(28,668,62,18);
INSERT INTO INTERPRETE VALUES(28,669,62,19);
INSERT INTO INTERPRETE VALUES(28,670,62,20);
INSERT INTO INTERPRETE VALUES(28,671,62,21);
INSERT INTO INTERPRETE VALUES(28,672,62,22);
INSERT INTO INTERPRETE VALUES(28,673,62,23);
INSERT INTO INTERPRETE VALUES(28,674,62,24);
INSERT INTO INTERPRETE VALUES(28,675,62,25);
INSERT INTO INTERPRETE VALUES(19,676,63,1);
INSERT INTO INTERPRETE VALUES(19,677,63,2);
INSERT INTO INTERPRETE VALUES(19,678,63,3);
INSERT INTO INTERPRETE VALUES(19,679,63,4);
INSERT INTO INTERPRETE VALUES(19,680,63,5);
INSERT INTO INTERPRETE VALUES(19,681,63,6);
INSERT INTO INTERPRETE VALUES(19,682,63,7);
INSERT INTO INTERPRETE VALUES(19,683,63,8);
INSERT INTO INTERPRETE VALUES(19,684,63,9);
INSERT INTO INTERPRETE VALUES(19,685,63,10);
INSERT INTO INTERPRETE VALUES(19,686,63,11);
INSERT INTO INTERPRETE VALUES(19,687,63,12);
INSERT INTO INTERPRETE VALUES(19,688,63,13);
INSERT INTO INTERPRETE VALUES(19,689,63,14);
INSERT INTO INTERPRETE VALUES(19,690,63,15);
INSERT INTO INTERPRETE VALUES(19,691,63,16);
INSERT INTO INTERPRETE VALUES(19,692,63,17);
INSERT INTO INTERPRETE VALUES(19,693,63,18);
INSERT INTO INTERPRETE VALUES(19,694,63,19);
INSERT INTO INTERPRETE VALUES(19,695,64,1);
INSERT INTO INTERPRETE VALUES(19,696,64,2);
INSERT INTO INTERPRETE VALUES(19,697,64,3);
INSERT INTO INTERPRETE VALUES(19,698,64,4);
INSERT INTO INTERPRETE VALUES(19,699,64,5);
INSERT INTO INTERPRETE VALUES(19,700,64,6);
INSERT INTO INTERPRETE VALUES(19,701,64,7);
INSERT INTO INTERPRETE VALUES(19,702,64,8);
INSERT INTO INTERPRETE VALUES(19,703,64,9);
INSERT INTO INTERPRETE VALUES(19,704,64,10);
INSERT INTO INTERPRETE VALUES(19,705,64,11);
INSERT INTO INTERPRETE VALUES(19,706,64,12);
INSERT INTO INTERPRETE VALUES(19,707,64,13);
INSERT INTO INTERPRETE VALUES(19,708,64,14);
INSERT INTO INTERPRETE VALUES(19,709,64,15);
INSERT INTO INTERPRETE VALUES(19,710,64,16);
INSERT INTO INTERPRETE VALUES(19,711,64,17);
INSERT INTO INTERPRETE VALUES(19,712,64,18);
INSERT INTO INTERPRETE VALUES(19,713,64,19);
INSERT INTO INTERPRETE VALUES(19,714,64,20);
INSERT INTO INTERPRETE VALUES(19,715,64,21);
INSERT INTO INTERPRETE VALUES(19,716,64,22);
INSERT INTO INTERPRETE VALUES(29,717,65,1);
INSERT INTO INTERPRETE VALUES(29,718,65,2);
INSERT INTO INTERPRETE VALUES(29,719,65,3);
INSERT INTO INTERPRETE VALUES(29,720,65,4);
INSERT INTO INTERPRETE VALUES(29,721,65,5);
INSERT INTO INTERPRETE VALUES(29,722,65,6);
INSERT INTO INTERPRETE VALUES(29,723,65,7);
INSERT INTO INTERPRETE VALUES(29,724,65,8);
INSERT INTO INTERPRETE VALUES(29,725,65,9);
INSERT INTO INTERPRETE VALUES(29,726,65,10);
INSERT INTO INTERPRETE VALUES(29,727,65,11);
INSERT INTO INTERPRETE VALUES(29,728,65,12);
INSERT INTO INTERPRETE VALUES(29,729,65,13);
INSERT INTO INTERPRETE VALUES(29,730,66,1);
INSERT INTO INTERPRETE VALUES(29,731,66,2);
INSERT INTO INTERPRETE VALUES(29,732,66,3);
INSERT INTO INTERPRETE VALUES(29,733,66,4);
INSERT INTO INTERPRETE VALUES(29,734,66,5);
INSERT INTO INTERPRETE VALUES(29,735,66,6);
INSERT INTO INTERPRETE VALUES(29,736,66,7);
INSERT INTO INTERPRETE VALUES(29,737,66,8);
INSERT INTO INTERPRETE VALUES(29,738,66,9);
INSERT INTO INTERPRETE VALUES(29,739,66,10);
INSERT INTO INTERPRETE VALUES(29,740,66,11);
INSERT INTO INTERPRETE VALUES(29,741,66,12);
INSERT INTO INTERPRETE VALUES(29,742,67,1);
INSERT INTO INTERPRETE VALUES(29,743,67,2);
INSERT INTO INTERPRETE VALUES(29,744,67,3);
INSERT INTO INTERPRETE VALUES(29,745,67,4);
INSERT INTO INTERPRETE VALUES(29,746,67,5);
INSERT INTO INTERPRETE VALUES(29,747,67,6);
INSERT INTO INTERPRETE VALUES(29,748,67,7);
INSERT INTO INTERPRETE VALUES(29,749,67,8);
INSERT INTO INTERPRETE VALUES(29,750,67,9);
INSERT INTO INTERPRETE VALUES(29,751,67,10);
INSERT INTO INTERPRETE VALUES(29,752,68,1);
INSERT INTO INTERPRETE VALUES(29,753,68,2);
INSERT INTO INTERPRETE VALUES(29,754,68,3);
INSERT INTO INTERPRETE VALUES(29,755,68,4);
INSERT INTO INTERPRETE VALUES(29,756,68,5);
INSERT INTO INTERPRETE VALUES(29,757,68,6);
INSERT INTO INTERPRETE VALUES(29,758,68,7);
INSERT INTO INTERPRETE VALUES(29,759,68,8);
INSERT INTO INTERPRETE VALUES(30,760,69,1);
INSERT INTO INTERPRETE VALUES(30,761,69,2);
INSERT INTO INTERPRETE VALUES(30,762,69,3);
INSERT INTO INTERPRETE VALUES(30,763,69,4);
INSERT INTO INTERPRETE VALUES(30,764,69,5);
INSERT INTO INTERPRETE VALUES(30,765,69,6);
INSERT INTO INTERPRETE VALUES(30,766,69,7);
INSERT INTO INTERPRETE VALUES(30,767,69,8);
INSERT INTO INTERPRETE VALUES(30,768,69,9);
INSERT INTO INTERPRETE VALUES(30,769,69,10);
INSERT INTO INTERPRETE VALUES(31,770,70,1);
INSERT INTO INTERPRETE VALUES(31,771,70,2);
INSERT INTO INTERPRETE VALUES(31,772,70,3);
INSERT INTO INTERPRETE VALUES(31,773,70,4);
INSERT INTO INTERPRETE VALUES(31,774,70,5);
INSERT INTO INTERPRETE VALUES(31,775,70,6);
INSERT INTO INTERPRETE VALUES(31,776,70,7);
INSERT INTO INTERPRETE VALUES(31,777,70,8);
INSERT INTO INTERPRETE VALUES(31,778,70,9);
INSERT INTO INTERPRETE VALUES(31,779,70,10);
INSERT INTO INTERPRETE VALUES(31,780,70,11);
INSERT INTO INTERPRETE VALUES(31,781,70,12);
INSERT INTO INTERPRETE VALUES(32,782,71,1);
INSERT INTO INTERPRETE VALUES(32,783,71,2);
INSERT INTO INTERPRETE VALUES(32,784,71,3);
INSERT INTO INTERPRETE VALUES(32,785,71,4);
INSERT INTO INTERPRETE VALUES(32,786,71,5);
INSERT INTO INTERPRETE VALUES(32,787,71,6);
INSERT INTO INTERPRETE VALUES(32,788,71,7);
INSERT INTO INTERPRETE VALUES(32,789,71,8);
INSERT INTO INTERPRETE VALUES(32,790,71,9);
INSERT INTO INTERPRETE VALUES(32,791,71,10);
INSERT INTO INTERPRETE VALUES(33,792,72,1);
INSERT INTO INTERPRETE VALUES(33,793,72,2);
INSERT INTO INTERPRETE VALUES(33,794,72,3);
INSERT INTO INTERPRETE VALUES(33,795,72,4);
INSERT INTO INTERPRETE VALUES(33,796,72,5);
INSERT INTO INTERPRETE VALUES(33,797,72,6);
INSERT INTO INTERPRETE VALUES(33,798,72,7);
INSERT INTO INTERPRETE VALUES(33,799,72,8);
INSERT INTO INTERPRETE VALUES(33,800,72,9);
INSERT INTO INTERPRETE VALUES(33,801,72,10);
INSERT INTO INTERPRETE VALUES(33,802,72,11);
INSERT INTO INTERPRETE VALUES(33,803,72,12);
INSERT INTO INTERPRETE VALUES(33,804,72,13);
INSERT INTO INTERPRETE VALUES(33,805,72,14);
INSERT INTO INTERPRETE VALUES(33,806,73,1);
INSERT INTO INTERPRETE VALUES(33,807,73,2);
INSERT INTO INTERPRETE VALUES(33,808,73,3);
INSERT INTO INTERPRETE VALUES(33,809,73,4);
INSERT INTO INTERPRETE VALUES(33,810,73,5);
INSERT INTO INTERPRETE VALUES(33,811,73,6);
INSERT INTO INTERPRETE VALUES(33,812,73,7);
INSERT INTO INTERPRETE VALUES(33,813,73,8);
INSERT INTO INTERPRETE VALUES(33,814,73,9);
INSERT INTO INTERPRETE VALUES(33,815,73,10);
INSERT INTO INTERPRETE VALUES(33,816,73,11);
INSERT INTO INTERPRETE VALUES(33,817,73,12);
INSERT INTO INTERPRETE VALUES(33,818,73,13);
INSERT INTO INTERPRETE VALUES(33,819,73,14);
INSERT INTO INTERPRETE VALUES(33,820,73,15);
INSERT INTO INTERPRETE VALUES(33,821,73,16);
INSERT INTO INTERPRETE VALUES(33,822,73,17);
INSERT INTO INTERPRETE VALUES(33,823,73,18);
INSERT INTO INTERPRETE VALUES(40,981,85,1);
INSERT INTO INTERPRETE VALUES(40,982,85,2);
INSERT INTO INTERPRETE VALUES(40,983,85,3);
INSERT INTO INTERPRETE VALUES(40,984,85,4);
INSERT INTO INTERPRETE VALUES(40,985,85,5);
INSERT INTO INTERPRETE VALUES(40,986,85,6);
INSERT INTO INTERPRETE VALUES(40,987,85,7);
INSERT INTO INTERPRETE VALUES(40,988,85,8);
INSERT INTO INTERPRETE VALUES(40,989,85,9);
INSERT INTO INTERPRETE VALUES(40,990,85,10);
INSERT INTO INTERPRETE VALUES(40,991,85,11);
INSERT INTO INTERPRETE VALUES(40,992,85,12);
INSERT INTO INTERPRETE VALUES(40,993,85,13);
INSERT INTO INTERPRETE VALUES(41,994,86,1);
INSERT INTO INTERPRETE VALUES(41,995,86,2);
INSERT INTO INTERPRETE VALUES(41,996,86,3);
INSERT INTO INTERPRETE VALUES(41,997,86,4);
INSERT INTO INTERPRETE VALUES(41,998,86,5);
INSERT INTO INTERPRETE VALUES(41,999,86,6);
INSERT INTO INTERPRETE VALUES(41,1000,86,7);
INSERT INTO INTERPRETE VALUES(41,1001,86,8);
INSERT INTO INTERPRETE VALUES(41,1002,86,9);
INSERT INTO INTERPRETE VALUES(41,1003,86,10);
INSERT INTO INTERPRETE VALUES(41,1004,86,11);
INSERT INTO INTERPRETE VALUES(41,1005,86,12);
INSERT INTO INTERPRETE VALUES(41,1006,86,13);
INSERT INTO INTERPRETE VALUES(41,1007,86,14);
INSERT INTO INTERPRETE VALUES(41,1008,86,15);
INSERT INTO INTERPRETE VALUES(41,1009,86,16);
INSERT INTO INTERPRETE VALUES(41,1010,86,17);
INSERT INTO INTERPRETE VALUES(41,1011,86,18);
INSERT INTO INTERPRETE VALUES(41,1012,86,19);
INSERT INTO INTERPRETE VALUES(42,1013,87,1);
INSERT INTO INTERPRETE VALUES(42,1014,87,2);
INSERT INTO INTERPRETE VALUES(42,1015,87,3);
INSERT INTO INTERPRETE VALUES(42,1016,87,4);
INSERT INTO INTERPRETE VALUES(42,1017,87,5);
INSERT INTO INTERPRETE VALUES(42,1018,87,6);
INSERT INTO INTERPRETE VALUES(42,1019,87,7);
INSERT INTO INTERPRETE VALUES(42,1020,87,8);
INSERT INTO INTERPRETE VALUES(42,1021,87,9);
INSERT INTO INTERPRETE VALUES(42,1022,87,10);
INSERT INTO INTERPRETE VALUES(42,1023,87,11);
INSERT INTO INTERPRETE VALUES(42,1024,87,12);
INSERT INTO INTERPRETE VALUES(42,1025,87,13);
INSERT INTO INTERPRETE VALUES(42,1026,87,14);
INSERT INTO INTERPRETE VALUES(42,1027,87,15);
INSERT INTO INTERPRETE VALUES(42,1028,87,16);
INSERT INTO INTERPRETE VALUES(42,1029,87,17);
INSERT INTO INTERPRETE VALUES(42,1030,87,18);
INSERT INTO INTERPRETE VALUES(43,1031,88,1);
INSERT INTO INTERPRETE VALUES(43,1032,88,2);
INSERT INTO INTERPRETE VALUES(45,1035,90,1);
INSERT INTO INTERPRETE VALUES(45,1036,90,2);
INSERT INTO INTERPRETE VALUES(45,1037,90,3);
INSERT INTO INTERPRETE VALUES(45,1038,90,4);
INSERT INTO INTERPRETE VALUES(45,1039,90,5);
INSERT INTO INTERPRETE VALUES(45,1040,90,6);
INSERT INTO INTERPRETE VALUES(45,1041,90,7);
INSERT INTO INTERPRETE VALUES(45,1043,90,9);
INSERT INTO INTERPRETE VALUES(45,1044,90,10);
INSERT INTO INTERPRETE VALUES(45,1045,90,11);
INSERT INTO INTERPRETE VALUES(45,125,90,12);
INSERT INTO INTERPRETE VALUES(45,1047,90,13);
INSERT INTO INTERPRETE VALUES(45,1048,90,14);
INSERT INTO INTERPRETE VALUES(45,1049,90,15);
INSERT INTO INTERPRETE VALUES(45,1050,90,16);
INSERT INTO INTERPRETE VALUES(45,1051,90,17);
INSERT INTO INTERPRETE VALUES(45,1052,90,18);
INSERT INTO INTERPRETE VALUES(45,1053,90,19);
INSERT INTO INTERPRETE VALUES(46,1054,91,1);
INSERT INTO INTERPRETE VALUES(46,1055,91,2);
INSERT INTO INTERPRETE VALUES(46,1056,91,3);
INSERT INTO INTERPRETE VALUES(46,1057,91,4);
INSERT INTO INTERPRETE VALUES(46,1058,91,5);
INSERT INTO INTERPRETE VALUES(46,1059,91,6);
INSERT INTO INTERPRETE VALUES(46,1060,91,7);
INSERT INTO INTERPRETE VALUES(46,1061,91,8);
INSERT INTO INTERPRETE VALUES(46,1062,91,9);
INSERT INTO INTERPRETE VALUES(46,1063,91,10);
INSERT INTO INTERPRETE VALUES(46,1064,91,11);
INSERT INTO INTERPRETE VALUES(46,1065,91,12);
INSERT INTO INTERPRETE VALUES(46,1066,91,13);
INSERT INTO INTERPRETE VALUES(46,1067,91,14);
INSERT INTO INTERPRETE VALUES(46,1068,91,15);
INSERT INTO INTERPRETE VALUES(46,1069,91,16);
INSERT INTO INTERPRETE VALUES(46,1070,91,17);
INSERT INTO INTERPRETE VALUES(46,1071,91,18);
INSERT INTO INTERPRETE VALUES(47,1072,92,1);
INSERT INTO INTERPRETE VALUES(47,1073,92,2);
INSERT INTO INTERPRETE VALUES(47,1074,92,3);
INSERT INTO INTERPRETE VALUES(47,1075,92,4);
INSERT INTO INTERPRETE VALUES(47,1076,92,5);
INSERT INTO INTERPRETE VALUES(47,1077,92,6);
INSERT INTO INTERPRETE VALUES(47,1078,92,7);
INSERT INTO INTERPRETE VALUES(47,1079,92,8);
INSERT INTO INTERPRETE VALUES(47,1080,92,9);
INSERT INTO INTERPRETE VALUES(47,1081,92,10);
INSERT INTO INTERPRETE VALUES(47,1082,92,11);
INSERT INTO INTERPRETE VALUES(47,1083,92,12);
INSERT INTO INTERPRETE VALUES(47,1084,92,13);
INSERT INTO INTERPRETE VALUES(47,1085,92,14);
INSERT INTO INTERPRETE VALUES(47,1086,92,15);
INSERT INTO INTERPRETE VALUES(47,1087,92,16);
INSERT INTO INTERPRETE VALUES(47,1080,92,17);
INSERT INTO INTERPRETE VALUES(47,1089,92,18);
INSERT INTO INTERPRETE VALUES(47,1090,92,19);
INSERT INTO INTERPRETE VALUES(47,1091,92,20);
INSERT INTO INTERPRETE VALUES(45,1092,93,1);
INSERT INTO INTERPRETE VALUES(45,1093,93,2);
INSERT INTO INTERPRETE VALUES(45,1094,93,3);
INSERT INTO INTERPRETE VALUES(45,1095,93,4);
INSERT INTO INTERPRETE VALUES(45,1096,93,5);
INSERT INTO INTERPRETE VALUES(45,1097,93,6);
INSERT INTO INTERPRETE VALUES(45,1098,93,7);
INSERT INTO INTERPRETE VALUES(45,1100,93,9);
INSERT INTO INTERPRETE VALUES(45,1101,93,10);
INSERT INTO INTERPRETE VALUES(45,1102,93,11);
INSERT INTO INTERPRETE VALUES(45,1103,93,12);
INSERT INTO INTERPRETE VALUES(45,1104,93,13);
INSERT INTO INTERPRETE VALUES(45,1105,93,14);
INSERT INTO INTERPRETE VALUES(45,1106,93,15);
INSERT INTO INTERPRETE VALUES(45,1107,93,16);
INSERT INTO INTERPRETE VALUES(45,1108,93,17);
INSERT INTO INTERPRETE VALUES(45,1109,93,18);
INSERT INTO INTERPRETE VALUES(45,1110,93,19);
INSERT INTO INTERPRETE VALUES(45,1111,93,20);
INSERT INTO INTERPRETE VALUES(48,1112,94,1);
INSERT INTO INTERPRETE VALUES(48,1113,94,2);
INSERT INTO INTERPRETE VALUES(48,1114,94,3);
INSERT INTO INTERPRETE VALUES(48,1117,94,6);
INSERT INTO INTERPRETE VALUES(48,1118,94,7);
INSERT INTO INTERPRETE VALUES(48,1119,94,8);
INSERT INTO INTERPRETE VALUES(48,1120,94,9);
INSERT INTO INTERPRETE VALUES(48,1121,94,10);
INSERT INTO INTERPRETE VALUES(48,1122,94,11);
INSERT INTO INTERPRETE VALUES(48,1123,94,12);
INSERT INTO INTERPRETE VALUES(48,1124,94,13);
INSERT INTO INTERPRETE VALUES(48,1125,94,14);
INSERT INTO INTERPRETE VALUES(48,1126,94,15);
INSERT INTO INTERPRETE VALUES(48,1127,94,16);
INSERT INTO INTERPRETE VALUES(48,1128,94,17);
INSERT INTO INTERPRETE VALUES(48,1129,94,18);
INSERT INTO INTERPRETE VALUES(49,1130,95,1);
INSERT INTO INTERPRETE VALUES(49,1131,95,2);
INSERT INTO INTERPRETE VALUES(49,1132,95,3);
INSERT INTO INTERPRETE VALUES(49,1133,95,4);
INSERT INTO INTERPRETE VALUES(49,1134,95,5);
INSERT INTO INTERPRETE VALUES(49,1135,95,6);
INSERT INTO INTERPRETE VALUES(49,1137,95,8);
INSERT INTO INTERPRETE VALUES(49,1138,95,9);
INSERT INTO INTERPRETE VALUES(49,1139,95,10);
INSERT INTO INTERPRETE VALUES(49,1140,95,11);
INSERT INTO INTERPRETE VALUES(49,1141,95,12);
INSERT INTO INTERPRETE VALUES(49,1142,95,13);
INSERT INTO INTERPRETE VALUES(49,1143,95,14);
INSERT INTO INTERPRETE VALUES(49,1144,95,15);
INSERT INTO INTERPRETE VALUES(49,1145,95,16);
INSERT INTO INTERPRETE VALUES(49,1146,95,17);
INSERT INTO INTERPRETE VALUES(49,1147,95,18);
INSERT INTO INTERPRETE VALUES(50,1148,96,1);
INSERT INTO INTERPRETE VALUES(50,1149,96,2);
INSERT INTO INTERPRETE VALUES(50,1150,96,3);
INSERT INTO INTERPRETE VALUES(50,1151,96,4);
INSERT INTO INTERPRETE VALUES(51,1152,97,1);
INSERT INTO INTERPRETE VALUES(51,1153,97,2);
INSERT INTO INTERPRETE VALUES(51,1154,97,3);
INSERT INTO INTERPRETE VALUES(51,1155,97,4);
INSERT INTO INTERPRETE VALUES(51,1156,97,5);
INSERT INTO INTERPRETE VALUES(51,1157,97,6);
INSERT INTO INTERPRETE VALUES(51,1158,97,7);
INSERT INTO INTERPRETE VALUES(51,1159,97,8);
INSERT INTO INTERPRETE VALUES(51,1160,97,9);
INSERT INTO INTERPRETE VALUES(51,1161,97,10);
INSERT INTO INTERPRETE VALUES(51,1162,97,11);
INSERT INTO INTERPRETE VALUES(51,1163,97,12);
INSERT INTO INTERPRETE VALUES(51,1164,97,13);
INSERT INTO INTERPRETE VALUES(51,1165,97,14);
INSERT INTO INTERPRETE VALUES(51,1166,97,15);
INSERT INTO INTERPRETE VALUES(51,1167,97,16);
INSERT INTO INTERPRETE VALUES(51,1168,97,17);
INSERT INTO INTERPRETE VALUES(51,1169,97,18);
INSERT INTO INTERPRETE VALUES(51,1170,97,19);
INSERT INTO INTERPRETE VALUES(51,1171,97,20);
INSERT INTO INTERPRETE VALUES(51,1172,97,21);
INSERT INTO INTERPRETE VALUES(51,1173,97,22);
INSERT INTO INTERPRETE VALUES(52,1177,98,4);
INSERT INTO INTERPRETE VALUES(53,1197,100,1);
INSERT INTO INTERPRETE VALUES(53,1198,100,2);
INSERT INTO INTERPRETE VALUES(53,1199,100,3);
INSERT INTO INTERPRETE VALUES(53,1200,100,4);
INSERT INTO INTERPRETE VALUES(52,1185,98,12);
INSERT INTO INTERPRETE VALUES(52,1174,98,1);
INSERT INTO INTERPRETE VALUES(53,1201,100,5);
INSERT INTO INTERPRETE VALUES(53,1202,100,6);
INSERT INTO INTERPRETE VALUES(53,1203,100,7);
INSERT INTO INTERPRETE VALUES(53,1204,100,8);
INSERT INTO INTERPRETE VALUES(53,1205,100,9);
INSERT INTO INTERPRETE VALUES(53,1206,100,10);
INSERT INTO INTERPRETE VALUES(53,1207,100,11);
INSERT INTO INTERPRETE VALUES(53,1208,100,12);
INSERT INTO INTERPRETE VALUES(53,1210,100,14);
INSERT INTO INTERPRETE VALUES(53,1211,100,15);
INSERT INTO INTERPRETE VALUES(53,1212,100,16);
INSERT INTO INTERPRETE VALUES(53,1213,100,17);
INSERT INTO INTERPRETE VALUES(53,1214,100,18);
INSERT INTO INTERPRETE VALUES(53,125,100,19);
INSERT INTO INTERPRETE VALUES(53,1216,100,20);
INSERT INTO INTERPRETE VALUES(53,1217,100,21);
INSERT INTO INTERPRETE VALUES(53,1218,100,22);
INSERT INTO INTERPRETE VALUES(54,1219,101,1);
INSERT INTO INTERPRETE VALUES(54,1220,101,2);
INSERT INTO INTERPRETE VALUES(54,1221,101,3);
INSERT INTO INTERPRETE VALUES(54,1222,101,4);
INSERT INTO INTERPRETE VALUES(47,1223,102,1);
INSERT INTO INTERPRETE VALUES(47,1224,102,2);
INSERT INTO INTERPRETE VALUES(47,1225,102,3);
INSERT INTO INTERPRETE VALUES(47,1226,102,4);
INSERT INTO INTERPRETE VALUES(47,1227,102,5);
INSERT INTO INTERPRETE VALUES(47,1228,102,6);
INSERT INTO INTERPRETE VALUES(47,1229,102,7);
INSERT INTO INTERPRETE VALUES(47,1230,102,8);
INSERT INTO INTERPRETE VALUES(47,1231,102,9);
INSERT INTO INTERPRETE VALUES(47,1233,102,11);
INSERT INTO INTERPRETE VALUES(47,1234,102,12);
INSERT INTO INTERPRETE VALUES(47,1235,102,13);
INSERT INTO INTERPRETE VALUES(47,1236,102,14);
INSERT INTO INTERPRETE VALUES(47,1237,102,15);
INSERT INTO INTERPRETE VALUES(47,1238,102,16);
INSERT INTO INTERPRETE VALUES(47,1239,102,17);
INSERT INTO INTERPRETE VALUES(47,1240,102,18);
INSERT INTO INTERPRETE VALUES(47,1241,102,19);
INSERT INTO INTERPRETE VALUES(47,1242,102,20);
INSERT INTO INTERPRETE VALUES(55,1243,103,1);
INSERT INTO INTERPRETE VALUES(55,1244,103,2);
INSERT INTO INTERPRETE VALUES(55,1245,103,3);
INSERT INTO INTERPRETE VALUES(55,1246,103,4);
INSERT INTO INTERPRETE VALUES(45,1247,104,1);
INSERT INTO INTERPRETE VALUES(45,1248,104,2);
INSERT INTO INTERPRETE VALUES(45,1249,104,3);
INSERT INTO INTERPRETE VALUES(45,1250,104,4);
INSERT INTO INTERPRETE VALUES(45,1251,104,5);
INSERT INTO INTERPRETE VALUES(45,1252,104,6);
INSERT INTO INTERPRETE VALUES(45,1253,104,7);
INSERT INTO INTERPRETE VALUES(45,1254,104,8);
INSERT INTO INTERPRETE VALUES(45,1255,104,9);
INSERT INTO INTERPRETE VALUES(45,1256,104,10);
INSERT INTO INTERPRETE VALUES(45,1257,104,11);
INSERT INTO INTERPRETE VALUES(45,1258,104,12);
INSERT INTO INTERPRETE VALUES(45,1259,104,13);
INSERT INTO INTERPRETE VALUES(45,1260,104,14);
INSERT INTO INTERPRETE VALUES(45,1261,104,15);
INSERT INTO INTERPRETE VALUES(45,1262,104,16);
INSERT INTO INTERPRETE VALUES(45,1263,104,17);
INSERT INTO INTERPRETE VALUES(45,1264,104,18);
INSERT INTO INTERPRETE VALUES(45,1265,104,19);
INSERT INTO INTERPRETE VALUES(45,1266,104,20);
INSERT INTO INTERPRETE VALUES(44,1269,105,3);
INSERT INTO INTERPRETE VALUES(56,1271,106,1);
INSERT INTO INTERPRETE VALUES(56,1274,106,4);
INSERT INTO INTERPRETE VALUES(56,1275,106,5);
INSERT INTO INTERPRETE VALUES(57,1282,108,1);
INSERT INTO INTERPRETE VALUES(52,1281,107,6);
INSERT INTO INTERPRETE VALUES(57,1283,108,2);
INSERT INTO INTERPRETE VALUES(57,1284,108,3);
INSERT INTO INTERPRETE VALUES(57,1285,108,4);
INSERT INTO INTERPRETE VALUES(57,1286,108,5);
INSERT INTO INTERPRETE VALUES(57,1287,108,6);
INSERT INTO INTERPRETE VALUES(58,1288,109,1);
INSERT INTO INTERPRETE VALUES(58,1289,109,2);
INSERT INTO INTERPRETE VALUES(58,1290,109,3);
INSERT INTO INTERPRETE VALUES(58,1291,109,4);
INSERT INTO INTERPRETE VALUES(58,1292,109,5);
INSERT INTO INTERPRETE VALUES(58,1293,109,6);
INSERT INTO INTERPRETE VALUES(58,1294,109,7);
INSERT INTO INTERPRETE VALUES(58,1295,109,8);
INSERT INTO INTERPRETE VALUES(58,1297,109,10);
INSERT INTO INTERPRETE VALUES(58,1298,109,11);
INSERT INTO INTERPRETE VALUES(58,1299,109,12);
INSERT INTO INTERPRETE VALUES(58,1300,109,13);
INSERT INTO INTERPRETE VALUES(58,1301,109,14);
INSERT INTO INTERPRETE VALUES(58,1302,109,15);
INSERT INTO INTERPRETE VALUES(58,1303,109,16);
INSERT INTO INTERPRETE VALUES(58,1304,109,17);
INSERT INTO INTERPRETE VALUES(58,1305,109,18);
INSERT INTO INTERPRETE VALUES(58,1306,109,19);
INSERT INTO INTERPRETE VALUES(59,1307,110,1);
INSERT INTO INTERPRETE VALUES(59,1309,110,3);
INSERT INTO INTERPRETE VALUES(59,1310,110,4);
INSERT INTO INTERPRETE VALUES(59,1311,110,5);
INSERT INTO INTERPRETE VALUES(59,1312,110,6);
INSERT INTO INTERPRETE VALUES(59,1313,110,7);
INSERT INTO INTERPRETE VALUES(59,1314,110,8);
INSERT INTO INTERPRETE VALUES(59,1315,110,9);
INSERT INTO INTERPRETE VALUES(59,1316,110,10);
INSERT INTO INTERPRETE VALUES(59,1317,110,11);
INSERT INTO INTERPRETE VALUES(59,1318,110,12);
INSERT INTO INTERPRETE VALUES(59,1319,110,13);
INSERT INTO INTERPRETE VALUES(59,1320,110,14);
INSERT INTO INTERPRETE VALUES(59,1321,110,15);
INSERT INTO INTERPRETE VALUES(59,1322,110,16);
INSERT INTO INTERPRETE VALUES(59,1323,110,17);
INSERT INTO INTERPRETE VALUES(59,1324,110,18);
INSERT INTO INTERPRETE VALUES(59,1325,110,19);
INSERT INTO INTERPRETE VALUES(59,1326,110,20);
INSERT INTO INTERPRETE VALUES(59,1327,110,21);
INSERT INTO INTERPRETE VALUES(59,1328,110,22);
INSERT INTO INTERPRETE VALUES(50,1329,111,1);
INSERT INTO INTERPRETE VALUES(50,1330,111,2);
INSERT INTO INTERPRETE VALUES(50,1331,111,3);
INSERT INTO INTERPRETE VALUES(50,1332,111,4);
INSERT INTO INTERPRETE VALUES(50,1333,111,5);
INSERT INTO INTERPRETE VALUES(47,1334,112,1);
INSERT INTO INTERPRETE VALUES(47,1335,112,2);
INSERT INTO INTERPRETE VALUES(47,1336,112,3);
INSERT INTO INTERPRETE VALUES(47,1337,112,4);
INSERT INTO INTERPRETE VALUES(47,1338,112,5);
INSERT INTO INTERPRETE VALUES(47,1339,113,1);
INSERT INTO INTERPRETE VALUES(47,1076,113,2);
INSERT INTO INTERPRETE VALUES(47,1235,113,3);
INSERT INTO INTERPRETE VALUES(47,1239,113,4);
INSERT INTO INTERPRETE VALUES(47,1343,113,5);
INSERT INTO INTERPRETE VALUES(47,1344,113,6);
INSERT INTO INTERPRETE VALUES(47,1345,113,7);
INSERT INTO INTERPRETE VALUES(47,4142,113,8);
INSERT INTO INTERPRETE VALUES(47,1347,113,9);
INSERT INTO INTERPRETE VALUES(47,1348,113,10);
INSERT INTO INTERPRETE VALUES(47,1082,113,11);
INSERT INTO INTERPRETE VALUES(47,1350,113,12);
INSERT INTO INTERPRETE VALUES(47,1351,113,13);
INSERT INTO INTERPRETE VALUES(47,1080,113,14);
INSERT INTO INTERPRETE VALUES(47,1072,113,15);
INSERT INTO INTERPRETE VALUES(47,1226,113,16);
INSERT INTO INTERPRETE VALUES(47,1355,113,17);
INSERT INTO INTERPRETE VALUES(47,1356,113,18);
INSERT INTO INTERPRETE VALUES(47,1357,113,19);
INSERT INTO INTERPRETE VALUES(47,1358,113,20);
INSERT INTO INTERPRETE VALUES(47,1223,113,21);
INSERT INTO INTERPRETE VALUES(47,1360,113,22);
INSERT INTO INTERPRETE VALUES(60,1361,114,1);
INSERT INTO INTERPRETE VALUES(60,1362,114,2);
INSERT INTO INTERPRETE VALUES(60,1363,114,3);
INSERT INTO INTERPRETE VALUES(60,1364,114,4);
INSERT INTO INTERPRETE VALUES(60,1365,114,5);
INSERT INTO INTERPRETE VALUES(60,1366,114,6);
INSERT INTO INTERPRETE VALUES(50,1367,115,1);
INSERT INTO INTERPRETE VALUES(50,1368,115,2);
INSERT INTO INTERPRETE VALUES(50,1369,115,3);
INSERT INTO INTERPRETE VALUES(50,1370,115,4);
INSERT INTO INTERPRETE VALUES(50,1371,115,5);
INSERT INTO INTERPRETE VALUES(58,1296,109,9);
INSERT INTO INTERPRETE VALUES(50,1372,115,6);
INSERT INTO INTERPRETE VALUES(50,1373,116,1);
INSERT INTO INTERPRETE VALUES(50,1374,116,2);
INSERT INTO INTERPRETE VALUES(50,1375,116,3);
INSERT INTO INTERPRETE VALUES(50,1376,116,4);
INSERT INTO INTERPRETE VALUES(50,1377,116,5);
INSERT INTO INTERPRETE VALUES(61,1378,117,1);
INSERT INTO INTERPRETE VALUES(61,1379,117,2);
INSERT INTO INTERPRETE VALUES(61,1380,117,3);
INSERT INTO INTERPRETE VALUES(61,1381,117,4);
INSERT INTO INTERPRETE VALUES(61,1382,117,5);
INSERT INTO INTERPRETE VALUES(61,1383,117,6);
INSERT INTO INTERPRETE VALUES(61,1384,117,7);
INSERT INTO INTERPRETE VALUES(50,1385,118,1);
INSERT INTO INTERPRETE VALUES(50,1386,118,2);
INSERT INTO INTERPRETE VALUES(50,1150,118,3);
INSERT INTO INTERPRETE VALUES(50,1388,118,4);
INSERT INTO INTERPRETE VALUES(50,1151,118,5);
INSERT INTO INTERPRETE VALUES(50,1390,118,6);
INSERT INTO INTERPRETE VALUES(50,1391,118,7);
INSERT INTO INTERPRETE VALUES(62,1392,119,1);
INSERT INTO INTERPRETE VALUES(62,1393,119,2);
INSERT INTO INTERPRETE VALUES(62,1394,119,3);
INSERT INTO INTERPRETE VALUES(62,1395,119,4);
INSERT INTO INTERPRETE VALUES(62,1397,119,6);
INSERT INTO INTERPRETE VALUES(62,1398,119,7);
INSERT INTO INTERPRETE VALUES(61,5367,120,1);
INSERT INTO INTERPRETE VALUES(61,1400,120,2);
INSERT INTO INTERPRETE VALUES(61,1401,120,3);
INSERT INTO INTERPRETE VALUES(61,1402,120,4);
INSERT INTO INTERPRETE VALUES(61,1403,120,5);
INSERT INTO INTERPRETE VALUES(61,1404,120,6);
INSERT INTO INTERPRETE VALUES(61,1405,120,7);
INSERT INTO INTERPRETE VALUES(61,1406,120,8);
INSERT INTO INTERPRETE VALUES(63,1407,121,1);
INSERT INTO INTERPRETE VALUES(63,1408,121,2);
INSERT INTO INTERPRETE VALUES(63,1409,121,3);
INSERT INTO INTERPRETE VALUES(63,1410,121,4);
INSERT INTO INTERPRETE VALUES(63,1411,121,5);
INSERT INTO INTERPRETE VALUES(63,1412,121,6);
INSERT INTO INTERPRETE VALUES(63,1413,121,7);
INSERT INTO INTERPRETE VALUES(63,1414,121,8);
INSERT INTO INTERPRETE VALUES(64,1415,122,1);
INSERT INTO INTERPRETE VALUES(64,1416,122,2);
INSERT INTO INTERPRETE VALUES(64,1417,122,3);
INSERT INTO INTERPRETE VALUES(65,1423,123,2);
INSERT INTO INTERPRETE VALUES(65,1424,123,3);
INSERT INTO INTERPRETE VALUES(65,1425,123,4);
INSERT INTO INTERPRETE VALUES(65,1426,123,5);
INSERT INTO INTERPRETE VALUES(65,1427,123,6);
INSERT INTO INTERPRETE VALUES(65,1428,123,7);
INSERT INTO INTERPRETE VALUES(65,1429,123,8);
INSERT INTO INTERPRETE VALUES(66,1430,124,1);
INSERT INTO INTERPRETE VALUES(66,1431,124,2);
INSERT INTO INTERPRETE VALUES(66,1432,124,3);
INSERT INTO INTERPRETE VALUES(66,1433,124,4);
INSERT INTO INTERPRETE VALUES(66,1434,124,5);
INSERT INTO INTERPRETE VALUES(66,1435,124,6);
INSERT INTO INTERPRETE VALUES(66,1436,124,7);
INSERT INTO INTERPRETE VALUES(66,1437,124,8);
INSERT INTO INTERPRETE VALUES(66,1438,124,9);
INSERT INTO INTERPRETE VALUES(66,1439,124,10);
INSERT INTO INTERPRETE VALUES(63,1440,125,1);
INSERT INTO INTERPRETE VALUES(63,1441,125,2);
INSERT INTO INTERPRETE VALUES(63,1443,125,4);
INSERT INTO INTERPRETE VALUES(63,1444,125,5);
INSERT INTO INTERPRETE VALUES(63,1445,125,6);
INSERT INTO INTERPRETE VALUES(67,1446,126,1);
INSERT INTO INTERPRETE VALUES(67,1447,126,2);
INSERT INTO INTERPRETE VALUES(67,1448,126,3);
INSERT INTO INTERPRETE VALUES(67,1450,126,5);
INSERT INTO INTERPRETE VALUES(67,1451,126,6);
INSERT INTO INTERPRETE VALUES(67,1452,126,7);
INSERT INTO INTERPRETE VALUES(68,1453,127,1);
INSERT INTO INTERPRETE VALUES(68,1454,127,2);
INSERT INTO INTERPRETE VALUES(68,1455,127,3);
INSERT INTO INTERPRETE VALUES(68,1456,127,4);
INSERT INTO INTERPRETE VALUES(68,1457,127,5);
INSERT INTO INTERPRETE VALUES(68,1458,127,6);
INSERT INTO INTERPRETE VALUES(68,1459,127,7);
INSERT INTO INTERPRETE VALUES(61,1460,128,1);
INSERT INTO INTERPRETE VALUES(64,1421,122,7);
INSERT INTO INTERPRETE VALUES(61,1462,128,3);
INSERT INTO INTERPRETE VALUES(61,1463,128,4);
INSERT INTO INTERPRETE VALUES(61,4524,128,5);
INSERT INTO INTERPRETE VALUES(61,1465,128,6);
INSERT INTO INTERPRETE VALUES(61,1466,128,7);
INSERT INTO INTERPRETE VALUES(61,1467,128,8);
INSERT INTO INTERPRETE VALUES(63,1476,130,1);
INSERT INTO INTERPRETE VALUES(63,1477,130,2);
INSERT INTO INTERPRETE VALUES(63,1478,130,3);
INSERT INTO INTERPRETE VALUES(63,1479,130,4);
INSERT INTO INTERPRETE VALUES(63,1480,130,5);
INSERT INTO INTERPRETE VALUES(63,1481,130,6);
INSERT INTO INTERPRETE VALUES(63,1482,130,7);
INSERT INTO INTERPRETE VALUES(63,1483,130,8);
INSERT INTO INTERPRETE VALUES(64,1484,131,1);
INSERT INTO INTERPRETE VALUES(64,1485,131,2);
INSERT INTO INTERPRETE VALUES(64,1486,131,3);
INSERT INTO INTERPRETE VALUES(64,1487,131,4);
INSERT INTO INTERPRETE VALUES(64,1488,131,5);
INSERT INTO INTERPRETE VALUES(64,1490,131,7);
INSERT INTO INTERPRETE VALUES(64,1491,132,1);
INSERT INTO INTERPRETE VALUES(64,1417,132,2);
INSERT INTO INTERPRETE VALUES(64,1489,131,6);
INSERT INTO INTERPRETE VALUES(64,1493,132,3);
INSERT INTO INTERPRETE VALUES(64,1494,132,4);
INSERT INTO INTERPRETE VALUES(64,1495,132,5);
INSERT INTO INTERPRETE VALUES(64,1496,132,6);
INSERT INTO INTERPRETE VALUES(64,1497,132,7);
INSERT INTO INTERPRETE VALUES(4,1498,133,1);
INSERT INTO INTERPRETE VALUES(4,1499,133,2);
INSERT INTO INTERPRETE VALUES(4,1500,133,3);
INSERT INTO INTERPRETE VALUES(4,1501,133,4);
INSERT INTO INTERPRETE VALUES(4,1504,133,7);
INSERT INTO INTERPRETE VALUES(66,1506,134,1);
INSERT INTO INTERPRETE VALUES(66,1507,134,2);
INSERT INTO INTERPRETE VALUES(66,1508,134,3);
INSERT INTO INTERPRETE VALUES(66,1509,134,4);
INSERT INTO INTERPRETE VALUES(66,1510,134,5);
INSERT INTO INTERPRETE VALUES(66,1511,134,6);
INSERT INTO INTERPRETE VALUES(66,1512,134,7);
INSERT INTO INTERPRETE VALUES(66,1513,134,8);
INSERT INTO INTERPRETE VALUES(69,1514,135,1);
INSERT INTO INTERPRETE VALUES(69,1515,135,2);
INSERT INTO INTERPRETE VALUES(69,1516,135,3);
INSERT INTO INTERPRETE VALUES(69,1517,135,4);
INSERT INTO INTERPRETE VALUES(69,1518,135,5);
INSERT INTO INTERPRETE VALUES(69,1521,135,8);
INSERT INTO INTERPRETE VALUES(69,1522,135,9);
INSERT INTO INTERPRETE VALUES(69,1213,135,10);
INSERT INTO INTERPRETE VALUES(69,1524,135,11);
INSERT INTO INTERPRETE VALUES(69,1525,135,12);
INSERT INTO INTERPRETE VALUES(69,1527,135,14);
INSERT INTO INTERPRETE VALUES(69,1529,135,16);
INSERT INTO INTERPRETE VALUES(69,1532,135,19);
INSERT INTO INTERPRETE VALUES(69,1533,135,20);
INSERT INTO INTERPRETE VALUES(69,1538,135,25);
INSERT INTO INTERPRETE VALUES(69,1539,135,26);
INSERT INTO INTERPRETE VALUES(69,1540,135,27);
INSERT INTO INTERPRETE VALUES(69,1541,135,28);
INSERT INTO INTERPRETE VALUES(44,1546,136,5);
INSERT INTO INTERPRETE VALUES(44,1549,136,8);
INSERT INTO INTERPRETE VALUES(67,1550,137,1);
INSERT INTO INTERPRETE VALUES(67,1551,137,2);
INSERT INTO INTERPRETE VALUES(67,1552,137,3);
INSERT INTO INTERPRETE VALUES(67,1553,137,4);
INSERT INTO INTERPRETE VALUES(67,1554,137,5);
INSERT INTO INTERPRETE VALUES(67,1555,137,6);
INSERT INTO INTERPRETE VALUES(67,1556,137,7);
INSERT INTO INTERPRETE VALUES(67,1557,137,8);
INSERT INTO INTERPRETE VALUES(44,1559,138,1);
INSERT INTO INTERPRETE VALUES(44,1560,138,2);
INSERT INTO INTERPRETE VALUES(44,1561,138,3);
INSERT INTO INTERPRETE VALUES(61,1568,139,1);
INSERT INTO INTERPRETE VALUES(61,1569,139,2);
INSERT INTO INTERPRETE VALUES(61,1570,139,3);
INSERT INTO INTERPRETE VALUES(61,1571,139,4);
INSERT INTO INTERPRETE VALUES(61,1572,139,5);
INSERT INTO INTERPRETE VALUES(61,1573,139,6);
INSERT INTO INTERPRETE VALUES(61,1574,139,7);
INSERT INTO INTERPRETE VALUES(61,1575,139,8);
INSERT INTO INTERPRETE VALUES(70,1584,141,1);
INSERT INTO INTERPRETE VALUES(70,1585,141,2);
INSERT INTO INTERPRETE VALUES(70,1586,141,3);
INSERT INTO INTERPRETE VALUES(70,1588,141,5);
INSERT INTO INTERPRETE VALUES(70,1589,141,6);
INSERT INTO INTERPRETE VALUES(70,1590,141,7);
INSERT INTO INTERPRETE VALUES(70,1591,141,8);
INSERT INTO INTERPRETE VALUES(11,1592,142,1);
INSERT INTO INTERPRETE VALUES(11,1593,142,2);
INSERT INTO INTERPRETE VALUES(11,1594,142,3);
INSERT INTO INTERPRETE VALUES(11,1595,142,4);
INSERT INTO INTERPRETE VALUES(11,1596,142,5);
INSERT INTO INTERPRETE VALUES(11,1597,142,6);
INSERT INTO INTERPRETE VALUES(11,1598,142,7);
INSERT INTO INTERPRETE VALUES(11,1599,142,8);
INSERT INTO INTERPRETE VALUES(11,1600,142,9);
INSERT INTO INTERPRETE VALUES(67,1602,143,2);
INSERT INTO INTERPRETE VALUES(67,1603,143,3);
INSERT INTO INTERPRETE VALUES(67,1606,143,6);
INSERT INTO INTERPRETE VALUES(67,1607,143,7);
INSERT INTO INTERPRETE VALUES(67,1608,143,8);
INSERT INTO INTERPRETE VALUES(49,1616,145,1);
INSERT INTO INTERPRETE VALUES(49,1617,145,2);
INSERT INTO INTERPRETE VALUES(49,1618,145,3);
INSERT INTO INTERPRETE VALUES(49,1619,145,4);
INSERT INTO INTERPRETE VALUES(49,1620,145,5);
INSERT INTO INTERPRETE VALUES(49,1135,145,6);
INSERT INTO INTERPRETE VALUES(49,1622,145,7);
INSERT INTO INTERPRETE VALUES(49,1623,145,8);
INSERT INTO INTERPRETE VALUES(49,1144,145,9);
INSERT INTO INTERPRETE VALUES(49,1625,145,10);
INSERT INTO INTERPRETE VALUES(71,1626,146,1);
INSERT INTO INTERPRETE VALUES(71,1627,146,2);
INSERT INTO INTERPRETE VALUES(71,1628,146,3);
INSERT INTO INTERPRETE VALUES(71,1629,146,4);
INSERT INTO INTERPRETE VALUES(67,1601,143,1);
INSERT INTO INTERPRETE VALUES(42,1639,147,4);
INSERT INTO INTERPRETE VALUES(72,1645,148,2);
INSERT INTO INTERPRETE VALUES(72,1650,148,7);
INSERT INTO INTERPRETE VALUES(72,1651,148,8);
INSERT INTO INTERPRETE VALUES(73,1666,150,1);
INSERT INTO INTERPRETE VALUES(73,1667,150,2);
INSERT INTO INTERPRETE VALUES(73,1668,150,3);
INSERT INTO INTERPRETE VALUES(73,1669,150,4);
INSERT INTO INTERPRETE VALUES(73,1670,150,5);
INSERT INTO INTERPRETE VALUES(73,1671,150,6);
INSERT INTO INTERPRETE VALUES(73,1672,150,7);
INSERT INTO INTERPRETE VALUES(73,1673,150,8);
INSERT INTO INTERPRETE VALUES(73,1674,150,9);
INSERT INTO INTERPRETE VALUES(73,1675,150,10);
INSERT INTO INTERPRETE VALUES(74,1677,151,2);
INSERT INTO INTERPRETE VALUES(74,1678,151,3);
INSERT INTO INTERPRETE VALUES(74,1679,151,4);
INSERT INTO INTERPRETE VALUES(74,1680,151,5);
INSERT INTO INTERPRETE VALUES(74,1681,151,6);
INSERT INTO INTERPRETE VALUES(74,1682,151,7);
INSERT INTO INTERPRETE VALUES(74,1683,151,8);
INSERT INTO INTERPRETE VALUES(74,1684,151,9);
INSERT INTO INTERPRETE VALUES(63,9724,152,1);
INSERT INTO INTERPRETE VALUES(63,1686,152,2);
INSERT INTO INTERPRETE VALUES(63,1687,152,3);
INSERT INTO INTERPRETE VALUES(63,1688,152,4);
INSERT INTO INTERPRETE VALUES(63,1689,152,5);
INSERT INTO INTERPRETE VALUES(63,1690,152,6);
INSERT INTO INTERPRETE VALUES(63,1691,152,7);
INSERT INTO INTERPRETE VALUES(63,1692,152,8);
INSERT INTO INTERPRETE VALUES(75,1693,153,1);
INSERT INTO INTERPRETE VALUES(75,1694,153,2);
INSERT INTO INTERPRETE VALUES(75,1695,153,3);
INSERT INTO INTERPRETE VALUES(75,1696,153,4);
INSERT INTO INTERPRETE VALUES(75,1697,153,5);
INSERT INTO INTERPRETE VALUES(75,1698,153,6);
INSERT INTO INTERPRETE VALUES(75,1699,153,7);
INSERT INTO INTERPRETE VALUES(75,1700,153,8);
INSERT INTO INTERPRETE VALUES(52,1703,154,3);
INSERT INTO INTERPRETE VALUES(52,1705,154,5);
INSERT INTO INTERPRETE VALUES(76,1711,155,1);
INSERT INTO INTERPRETE VALUES(76,1712,155,2);
INSERT INTO INTERPRETE VALUES(76,1713,155,3);
INSERT INTO INTERPRETE VALUES(76,1714,155,4);
INSERT INTO INTERPRETE VALUES(76,1715,155,5);
INSERT INTO INTERPRETE VALUES(76,1716,155,6);
INSERT INTO INTERPRETE VALUES(76,1717,155,7);
INSERT INTO INTERPRETE VALUES(76,1719,155,9);
INSERT INTO INTERPRETE VALUES(76,1720,155,10);
INSERT INTO INTERPRETE VALUES(61,1721,156,1);
INSERT INTO INTERPRETE VALUES(61,1722,156,2);
INSERT INTO INTERPRETE VALUES(61,1723,156,3);
INSERT INTO INTERPRETE VALUES(61,1724,156,4);
INSERT INTO INTERPRETE VALUES(61,1725,156,5);
INSERT INTO INTERPRETE VALUES(61,1726,156,6);
INSERT INTO INTERPRETE VALUES(61,1727,156,7);
INSERT INTO INTERPRETE VALUES(61,1728,156,8);
INSERT INTO INTERPRETE VALUES(61,1729,156,9);
INSERT INTO INTERPRETE VALUES(49,1730,157,1);
INSERT INTO INTERPRETE VALUES(49,1731,157,2);
INSERT INTO INTERPRETE VALUES(49,1732,157,3);
INSERT INTO INTERPRETE VALUES(49,1733,157,4);
INSERT INTO INTERPRETE VALUES(49,1734,157,5);
INSERT INTO INTERPRETE VALUES(49,1735,157,6);
INSERT INTO INTERPRETE VALUES(49,1736,157,7);
INSERT INTO INTERPRETE VALUES(49,1737,157,8);
INSERT INTO INTERPRETE VALUES(49,1738,157,9);
INSERT INTO INTERPRETE VALUES(49,1739,157,10);
INSERT INTO INTERPRETE VALUES(49,1741,157,12);
INSERT INTO INTERPRETE VALUES(49,1742,157,13);
INSERT INTO INTERPRETE VALUES(49,1743,157,14);
INSERT INTO INTERPRETE VALUES(49,1744,157,15);
INSERT INTO INTERPRETE VALUES(49,1745,157,16);
INSERT INTO INTERPRETE VALUES(49,1746,157,17);
INSERT INTO INTERPRETE VALUES(4,1748,158,1);
INSERT INTO INTERPRETE VALUES(4,1749,158,2);
INSERT INTO INTERPRETE VALUES(4,1750,158,3);
INSERT INTO INTERPRETE VALUES(4,1751,158,4);
INSERT INTO INTERPRETE VALUES(4,1752,158,5);
INSERT INTO INTERPRETE VALUES(4,1753,158,6);
INSERT INTO INTERPRETE VALUES(4,1754,158,7);
INSERT INTO INTERPRETE VALUES(4,1755,158,8);
INSERT INTO INTERPRETE VALUES(4,1756,158,9);
INSERT INTO INTERPRETE VALUES(50,1757,159,1);
INSERT INTO INTERPRETE VALUES(50,1758,159,2);
INSERT INTO INTERPRETE VALUES(50,1759,159,3);
INSERT INTO INTERPRETE VALUES(50,1760,159,4);
INSERT INTO INTERPRETE VALUES(50,1762,159,6);
INSERT INTO INTERPRETE VALUES(50,1763,159,7);
INSERT INTO INTERPRETE VALUES(50,1764,159,8);
INSERT INTO INTERPRETE VALUES(50,1765,159,9);
INSERT INTO INTERPRETE VALUES(61,1766,160,1);
INSERT INTO INTERPRETE VALUES(61,4526,160,2);
INSERT INTO INTERPRETE VALUES(61,1768,160,3);
INSERT INTO INTERPRETE VALUES(61,1769,160,4);
INSERT INTO INTERPRETE VALUES(61,1770,160,5);
INSERT INTO INTERPRETE VALUES(61,1771,160,6);
INSERT INTO INTERPRETE VALUES(61,1772,160,7);
INSERT INTO INTERPRETE VALUES(61,1773,160,8);
INSERT INTO INTERPRETE VALUES(61,1774,160,9);
INSERT INTO INTERPRETE VALUES(67,1775,161,1);
INSERT INTO INTERPRETE VALUES(67,1776,161,2);
INSERT INTO INTERPRETE VALUES(52,1709,154,9);
INSERT INTO INTERPRETE VALUES(67,1777,161,3);
INSERT INTO INTERPRETE VALUES(67,1778,161,4);
INSERT INTO INTERPRETE VALUES(67,1780,161,6);
INSERT INTO INTERPRETE VALUES(67,1782,161,8);
INSERT INTO INTERPRETE VALUES(67,1784,161,10);
INSERT INTO INTERPRETE VALUES(77,1785,162,1);
INSERT INTO INTERPRETE VALUES(77,1786,162,2);
INSERT INTO INTERPRETE VALUES(77,1788,162,4);
INSERT INTO INTERPRETE VALUES(77,1789,162,5);
INSERT INTO INTERPRETE VALUES(77,1790,162,6);
INSERT INTO INTERPRETE VALUES(77,1791,162,7);
INSERT INTO INTERPRETE VALUES(77,1792,162,8);
INSERT INTO INTERPRETE VALUES(77,1793,162,9);
INSERT INTO INTERPRETE VALUES(77,1794,162,10);
INSERT INTO INTERPRETE VALUES(77,1795,162,11);
INSERT INTO INTERPRETE VALUES(78,1796,163,1);
INSERT INTO INTERPRETE VALUES(78,1797,163,2);
INSERT INTO INTERPRETE VALUES(78,1798,163,3);
INSERT INTO INTERPRETE VALUES(78,1799,163,4);
INSERT INTO INTERPRETE VALUES(78,1800,163,5);
INSERT INTO INTERPRETE VALUES(78,1801,163,6);
INSERT INTO INTERPRETE VALUES(78,1802,163,7);
INSERT INTO INTERPRETE VALUES(78,1804,163,9);
INSERT INTO INTERPRETE VALUES(78,1805,163,10);
INSERT INTO INTERPRETE VALUES(78,1806,163,11);
INSERT INTO INTERPRETE VALUES(78,1807,163,12);
INSERT INTO INTERPRETE VALUES(78,1809,163,14);
INSERT INTO INTERPRETE VALUES(78,1810,163,15);
INSERT INTO INTERPRETE VALUES(78,1811,163,16);
INSERT INTO INTERPRETE VALUES(78,1812,163,17);
INSERT INTO INTERPRETE VALUES(78,1813,163,18);
INSERT INTO INTERPRETE VALUES(78,1814,163,19);
INSERT INTO INTERPRETE VALUES(78,1817,163,22);
INSERT INTO INTERPRETE VALUES(78,1818,163,23);
INSERT INTO INTERPRETE VALUES(78,1664,163,24);
INSERT INTO INTERPRETE VALUES(51,1820,164,1);
INSERT INTO INTERPRETE VALUES(51,1821,164,2);
INSERT INTO INTERPRETE VALUES(51,1822,164,3);
INSERT INTO INTERPRETE VALUES(51,1823,164,4);
INSERT INTO INTERPRETE VALUES(51,1824,164,5);
INSERT INTO INTERPRETE VALUES(51,1825,164,6);
INSERT INTO INTERPRETE VALUES(51,1826,164,7);
INSERT INTO INTERPRETE VALUES(51,1827,164,8);
INSERT INTO INTERPRETE VALUES(79,1828,165,1);
INSERT INTO INTERPRETE VALUES(79,1829,165,2);
INSERT INTO INTERPRETE VALUES(79,1830,165,3);
INSERT INTO INTERPRETE VALUES(79,1831,165,4);
INSERT INTO INTERPRETE VALUES(79,1832,165,5);
INSERT INTO INTERPRETE VALUES(79,1833,165,6);
INSERT INTO INTERPRETE VALUES(79,1834,165,7);
INSERT INTO INTERPRETE VALUES(79,1835,165,8);
INSERT INTO INTERPRETE VALUES(79,1836,165,9);
INSERT INTO INTERPRETE VALUES(79,1837,165,10);
INSERT INTO INTERPRETE VALUES(4,1838,166,1);
INSERT INTO INTERPRETE VALUES(4,1840,166,3);
INSERT INTO INTERPRETE VALUES(4,1841,166,4);
INSERT INTO INTERPRETE VALUES(4,1842,166,5);
INSERT INTO INTERPRETE VALUES(4,1843,166,6);
INSERT INTO INTERPRETE VALUES(4,1844,166,7);
INSERT INTO INTERPRETE VALUES(4,1845,166,8);
INSERT INTO INTERPRETE VALUES(4,1846,166,9);
INSERT INTO INTERPRETE VALUES(67,1781,161,7);
INSERT INTO INTERPRETE VALUES(78,1816,163,21);
INSERT INTO INTERPRETE VALUES(42,1848,167,1);
INSERT INTO INTERPRETE VALUES(42,1849,167,2);
INSERT INTO INTERPRETE VALUES(42,1850,167,3);
INSERT INTO INTERPRETE VALUES(42,1851,167,4);
INSERT INTO INTERPRETE VALUES(42,1852,167,5);
INSERT INTO INTERPRETE VALUES(42,1853,167,6);
INSERT INTO INTERPRETE VALUES(42,1855,167,8);
INSERT INTO INTERPRETE VALUES(42,1857,167,10);
INSERT INTO INTERPRETE VALUES(71,1858,168,1);
INSERT INTO INTERPRETE VALUES(71,1859,168,2);
INSERT INTO INTERPRETE VALUES(71,1862,168,5);
INSERT INTO INTERPRETE VALUES(71,1863,168,6);
INSERT INTO INTERPRETE VALUES(71,1864,168,7);
INSERT INTO INTERPRETE VALUES(71,1865,168,8);
INSERT INTO INTERPRETE VALUES(71,1866,168,9);
INSERT INTO INTERPRETE VALUES(71,1867,168,10);
INSERT INTO INTERPRETE VALUES(80,1868,169,1);
INSERT INTO INTERPRETE VALUES(80,1869,169,2);
INSERT INTO INTERPRETE VALUES(80,1870,169,3);
INSERT INTO INTERPRETE VALUES(80,1871,169,4);
INSERT INTO INTERPRETE VALUES(80,1872,169,5);
INSERT INTO INTERPRETE VALUES(80,1873,169,6);
INSERT INTO INTERPRETE VALUES(80,1874,169,7);
INSERT INTO INTERPRETE VALUES(80,1875,169,8);
INSERT INTO INTERPRETE VALUES(80,1876,169,9);
INSERT INTO INTERPRETE VALUES(66,1877,170,1);
INSERT INTO INTERPRETE VALUES(66,1878,170,2);
INSERT INTO INTERPRETE VALUES(66,1879,170,3);
INSERT INTO INTERPRETE VALUES(66,1880,170,4);
INSERT INTO INTERPRETE VALUES(66,1881,170,5);
INSERT INTO INTERPRETE VALUES(66,1882,170,6);
INSERT INTO INTERPRETE VALUES(66,1883,170,7);
INSERT INTO INTERPRETE VALUES(66,1884,170,8);
INSERT INTO INTERPRETE VALUES(66,1885,170,9);
INSERT INTO INTERPRETE VALUES(66,1886,170,10);
INSERT INTO INTERPRETE VALUES(81,1887,171,1);
INSERT INTO INTERPRETE VALUES(81,1888,171,2);
INSERT INTO INTERPRETE VALUES(81,1889,171,3);
INSERT INTO INTERPRETE VALUES(81,1890,171,4);
INSERT INTO INTERPRETE VALUES(81,1891,171,5);
INSERT INTO INTERPRETE VALUES(81,1892,171,6);
INSERT INTO INTERPRETE VALUES(81,1893,171,7);
INSERT INTO INTERPRETE VALUES(81,1894,171,8);
INSERT INTO INTERPRETE VALUES(81,1895,171,9);
INSERT INTO INTERPRETE VALUES(81,1896,171,10);
INSERT INTO INTERPRETE VALUES(49,1132,172,1);
INSERT INTO INTERPRETE VALUES(49,1898,172,2);
INSERT INTO INTERPRETE VALUES(49,1133,172,3);
INSERT INTO INTERPRETE VALUES(49,1900,172,4);
INSERT INTO INTERPRETE VALUES(49,1901,172,5);
INSERT INTO INTERPRETE VALUES(49,1902,172,6);
INSERT INTO INTERPRETE VALUES(49,1903,172,7);
INSERT INTO INTERPRETE VALUES(49,1904,172,8);
INSERT INTO INTERPRETE VALUES(49,1905,172,9);
INSERT INTO INTERPRETE VALUES(49,1146,172,10);
INSERT INTO INTERPRETE VALUES(52,1909,173,3);
INSERT INTO INTERPRETE VALUES(52,1912,173,6);
INSERT INTO INTERPRETE VALUES(82,1918,174,2);
INSERT INTO INTERPRETE VALUES(82,1919,174,3);
INSERT INTO INTERPRETE VALUES(82,1920,174,4);
INSERT INTO INTERPRETE VALUES(82,1921,174,5);
INSERT INTO INTERPRETE VALUES(82,1922,174,6);
INSERT INTO INTERPRETE VALUES(82,1923,174,7);
INSERT INTO INTERPRETE VALUES(82,1924,174,8);
INSERT INTO INTERPRETE VALUES(82,1925,174,9);
INSERT INTO INTERPRETE VALUES(71,1926,175,1);
INSERT INTO INTERPRETE VALUES(71,1928,175,3);
INSERT INTO INTERPRETE VALUES(71,1930,175,5);
INSERT INTO INTERPRETE VALUES(71,1931,175,6);
INSERT INTO INTERPRETE VALUES(71,1932,175,7);
INSERT INTO INTERPRETE VALUES(71,1933,175,8);
INSERT INTO INTERPRETE VALUES(42,1935,176,1);
INSERT INTO INTERPRETE VALUES(42,1936,176,2);
INSERT INTO INTERPRETE VALUES(42,1937,176,3);
INSERT INTO INTERPRETE VALUES(42,1939,176,5);
INSERT INTO INTERPRETE VALUES(42,1940,176,6);
INSERT INTO INTERPRETE VALUES(42,1941,176,7);
INSERT INTO INTERPRETE VALUES(42,1942,176,8);
INSERT INTO INTERPRETE VALUES(42,1943,176,9);
INSERT INTO INTERPRETE VALUES(71,1929,175,4);
INSERT INTO INTERPRETE VALUES(50,1949,177,4);
INSERT INTO INTERPRETE VALUES(50,1950,177,5);
INSERT INTO INTERPRETE VALUES(50,1951,177,6);
INSERT INTO INTERPRETE VALUES(50,1952,177,7);
INSERT INTO INTERPRETE VALUES(50,1953,177,8);
INSERT INTO INTERPRETE VALUES(50,1954,177,9);
INSERT INTO INTERPRETE VALUES(83,1956,178,1);
INSERT INTO INTERPRETE VALUES(83,1957,178,2);
INSERT INTO INTERPRETE VALUES(83,1958,178,3);
INSERT INTO INTERPRETE VALUES(83,1959,178,4);
INSERT INTO INTERPRETE VALUES(83,1960,178,5);
INSERT INTO INTERPRETE VALUES(83,1961,178,6);
INSERT INTO INTERPRETE VALUES(83,1962,178,7);
INSERT INTO INTERPRETE VALUES(83,1963,178,8);
INSERT INTO INTERPRETE VALUES(83,1964,178,9);
INSERT INTO INTERPRETE VALUES(83,1965,178,10);
INSERT INTO INTERPRETE VALUES(4,1967,179,2);
INSERT INTO INTERPRETE VALUES(4,1968,179,3);
INSERT INTO INTERPRETE VALUES(4,1969,179,4);
INSERT INTO INTERPRETE VALUES(4,1970,179,5);
INSERT INTO INTERPRETE VALUES(4,1971,179,6);
INSERT INTO INTERPRETE VALUES(4,1972,179,7);
INSERT INTO INTERPRETE VALUES(4,1973,179,8);
INSERT INTO INTERPRETE VALUES(4,1974,179,9);
INSERT INTO INTERPRETE VALUES(4,1975,179,10);
INSERT INTO INTERPRETE VALUES(4,1976,179,11);
INSERT INTO INTERPRETE VALUES(45,1989,181,1);
INSERT INTO INTERPRETE VALUES(45,1990,181,2);
INSERT INTO INTERPRETE VALUES(45,1991,181,3);
INSERT INTO INTERPRETE VALUES(45,1992,181,4);
INSERT INTO INTERPRETE VALUES(45,1994,181,6);
INSERT INTO INTERPRETE VALUES(45,1995,181,7);
INSERT INTO INTERPRETE VALUES(45,1996,181,8);
INSERT INTO INTERPRETE VALUES(45,1997,181,9);
INSERT INTO INTERPRETE VALUES(45,1998,181,10);
INSERT INTO INTERPRETE VALUES(84,1999,182,1);
INSERT INTO INTERPRETE VALUES(84,2000,182,2);
INSERT INTO INTERPRETE VALUES(84,2001,182,3);
INSERT INTO INTERPRETE VALUES(84,2002,182,4);
INSERT INTO INTERPRETE VALUES(84,2003,182,5);
INSERT INTO INTERPRETE VALUES(84,2004,182,6);
INSERT INTO INTERPRETE VALUES(84,2006,182,8);
INSERT INTO INTERPRETE VALUES(84,2007,182,9);
INSERT INTO INTERPRETE VALUES(84,2008,182,10);
INSERT INTO INTERPRETE VALUES(44,1982,180,6);
INSERT INTO INTERPRETE VALUES(85,2021,184,3);
INSERT INTO INTERPRETE VALUES(85,2024,184,6);
INSERT INTO INTERPRETE VALUES(85,2026,184,8);
INSERT INTO INTERPRETE VALUES(85,2027,184,9);
INSERT INTO INTERPRETE VALUES(85,2028,184,10);
INSERT INTO INTERPRETE VALUES(85,2029,184,11);
INSERT INTO INTERPRETE VALUES(86,2030,185,1);
INSERT INTO INTERPRETE VALUES(86,2031,185,2);
INSERT INTO INTERPRETE VALUES(86,2032,185,3);
INSERT INTO INTERPRETE VALUES(86,2033,185,4);
INSERT INTO INTERPRETE VALUES(86,2034,185,5);
INSERT INTO INTERPRETE VALUES(86,2035,185,6);
INSERT INTO INTERPRETE VALUES(86,2036,185,7);
INSERT INTO INTERPRETE VALUES(86,2037,185,8);
INSERT INTO INTERPRETE VALUES(86,2038,185,9);
INSERT INTO INTERPRETE VALUES(86,2039,185,10);
INSERT INTO INTERPRETE VALUES(87,2040,186,1);
INSERT INTO INTERPRETE VALUES(87,2041,186,2);
INSERT INTO INTERPRETE VALUES(44,1979,180,3);
INSERT INTO INTERPRETE VALUES(87,2042,186,3);
INSERT INTO INTERPRETE VALUES(87,2044,186,5);
INSERT INTO INTERPRETE VALUES(87,2045,186,6);
INSERT INTO INTERPRETE VALUES(87,2046,186,7);
INSERT INTO INTERPRETE VALUES(87,2047,186,8);
INSERT INTO INTERPRETE VALUES(87,2048,186,9);
INSERT INTO INTERPRETE VALUES(87,2049,186,10);
INSERT INTO INTERPRETE VALUES(87,2051,186,12);
INSERT INTO INTERPRETE VALUES(56,2052,187,1);
INSERT INTO INTERPRETE VALUES(56,2053,187,2);
INSERT INTO INTERPRETE VALUES(56,2056,187,5);
INSERT INTO INTERPRETE VALUES(56,2057,187,6);
INSERT INTO INTERPRETE VALUES(56,2058,187,7);
INSERT INTO INTERPRETE VALUES(56,2059,187,8);
INSERT INTO INTERPRETE VALUES(56,2061,187,10);
INSERT INTO INTERPRETE VALUES(56,2062,187,11);
INSERT INTO INTERPRETE VALUES(88,2063,188,1);
INSERT INTO INTERPRETE VALUES(88,2064,188,2);
INSERT INTO INTERPRETE VALUES(88,2065,188,3);
INSERT INTO INTERPRETE VALUES(88,2066,188,4);
INSERT INTO INTERPRETE VALUES(88,2067,188,5);
INSERT INTO INTERPRETE VALUES(88,2068,188,6);
INSERT INTO INTERPRETE VALUES(88,2069,188,7);
INSERT INTO INTERPRETE VALUES(88,2071,188,9);
INSERT INTO INTERPRETE VALUES(88,2072,188,10);
INSERT INTO INTERPRETE VALUES(4,2073,189,1);
INSERT INTO INTERPRETE VALUES(4,2074,189,2);
INSERT INTO INTERPRETE VALUES(4,2075,189,3);
INSERT INTO INTERPRETE VALUES(4,2076,189,4);
INSERT INTO INTERPRETE VALUES(4,2078,189,6);
INSERT INTO INTERPRETE VALUES(4,2079,189,7);
INSERT INTO INTERPRETE VALUES(4,2080,189,8);
INSERT INTO INTERPRETE VALUES(4,2081,189,9);
INSERT INTO INTERPRETE VALUES(4,2082,189,10);
INSERT INTO INTERPRETE VALUES(66,2083,190,1);
INSERT INTO INTERPRETE VALUES(66,2084,190,2);
INSERT INTO INTERPRETE VALUES(66,2085,190,3);
INSERT INTO INTERPRETE VALUES(66,2086,190,4);
INSERT INTO INTERPRETE VALUES(66,2087,190,5);
INSERT INTO INTERPRETE VALUES(66,2088,190,6);
INSERT INTO INTERPRETE VALUES(66,2089,190,7);
INSERT INTO INTERPRETE VALUES(66,2090,190,8);
INSERT INTO INTERPRETE VALUES(66,2091,190,9);
INSERT INTO INTERPRETE VALUES(66,2092,190,10);
INSERT INTO INTERPRETE VALUES(78,2093,191,1);
INSERT INTO INTERPRETE VALUES(78,2094,191,2);
INSERT INTO INTERPRETE VALUES(78,2095,191,3);
INSERT INTO INTERPRETE VALUES(78,2096,191,4);
INSERT INTO INTERPRETE VALUES(78,2097,191,5);
INSERT INTO INTERPRETE VALUES(78,2099,191,7);
INSERT INTO INTERPRETE VALUES(78,2100,191,8);
INSERT INTO INTERPRETE VALUES(66,2102,192,1);
INSERT INTO INTERPRETE VALUES(66,2103,192,2);
INSERT INTO INTERPRETE VALUES(66,2105,192,4);
INSERT INTO INTERPRETE VALUES(66,2106,192,5);
INSERT INTO INTERPRETE VALUES(66,2107,192,6);
INSERT INTO INTERPRETE VALUES(66,2108,192,7);
INSERT INTO INTERPRETE VALUES(66,2109,192,8);
INSERT INTO INTERPRETE VALUES(66,2110,192,9);
INSERT INTO INTERPRETE VALUES(66,2111,193,1);
INSERT INTO INTERPRETE VALUES(66,2112,193,2);
INSERT INTO INTERPRETE VALUES(66,2113,193,3);
INSERT INTO INTERPRETE VALUES(66,2114,193,4);
INSERT INTO INTERPRETE VALUES(66,2115,193,5);
INSERT INTO INTERPRETE VALUES(66,2116,193,6);
INSERT INTO INTERPRETE VALUES(66,2117,193,7);
INSERT INTO INTERPRETE VALUES(66,2118,193,8);
INSERT INTO INTERPRETE VALUES(89,2119,194,1);
INSERT INTO INTERPRETE VALUES(89,2121,194,3);
INSERT INTO INTERPRETE VALUES(89,2122,194,4);
INSERT INTO INTERPRETE VALUES(89,2125,194,7);
INSERT INTO INTERPRETE VALUES(89,2126,194,8);
INSERT INTO INTERPRETE VALUES(89,2127,194,9);
INSERT INTO INTERPRETE VALUES(89,2128,194,10);
INSERT INTO INTERPRETE VALUES(89,2129,194,11);
INSERT INTO INTERPRETE VALUES(90,2132,195,3);
INSERT INTO INTERPRETE VALUES(90,2133,195,4);
INSERT INTO INTERPRETE VALUES(90,2134,195,5);
INSERT INTO INTERPRETE VALUES(90,2135,195,6);
INSERT INTO INTERPRETE VALUES(90,2136,195,7);
INSERT INTO INTERPRETE VALUES(90,2137,195,8);
INSERT INTO INTERPRETE VALUES(90,2138,195,9);
INSERT INTO INTERPRETE VALUES(90,2139,195,10);
INSERT INTO INTERPRETE VALUES(89,2124,194,6);
INSERT INTO INTERPRETE VALUES(91,2140,196,1);
INSERT INTO INTERPRETE VALUES(91,2141,196,2);
INSERT INTO INTERPRETE VALUES(91,2142,196,3);
INSERT INTO INTERPRETE VALUES(91,2143,196,4);
INSERT INTO INTERPRETE VALUES(91,2144,196,5);
INSERT INTO INTERPRETE VALUES(91,2145,196,6);
INSERT INTO INTERPRETE VALUES(91,2146,196,7);
INSERT INTO INTERPRETE VALUES(91,2147,196,8);
INSERT INTO INTERPRETE VALUES(91,2149,196,10);
INSERT INTO INTERPRETE VALUES(91,2150,196,11);
INSERT INTO INTERPRETE VALUES(92,2151,197,1);
INSERT INTO INTERPRETE VALUES(92,2152,197,2);
INSERT INTO INTERPRETE VALUES(92,2153,197,3);
INSERT INTO INTERPRETE VALUES(92,2154,197,4);
INSERT INTO INTERPRETE VALUES(92,2155,197,5);
INSERT INTO INTERPRETE VALUES(92,2156,197,6);
INSERT INTO INTERPRETE VALUES(92,2157,197,7);
INSERT INTO INTERPRETE VALUES(92,2158,197,8);
INSERT INTO INTERPRETE VALUES(92,2159,197,9);
INSERT INTO INTERPRETE VALUES(92,2160,197,10);
INSERT INTO INTERPRETE VALUES(93,2161,198,1);
INSERT INTO INTERPRETE VALUES(93,2163,198,3);
INSERT INTO INTERPRETE VALUES(93,2164,198,4);
INSERT INTO INTERPRETE VALUES(93,2165,198,5);
INSERT INTO INTERPRETE VALUES(93,2166,198,6);
INSERT INTO INTERPRETE VALUES(93,2167,198,7);
INSERT INTO INTERPRETE VALUES(93,2168,198,8);
INSERT INTO INTERPRETE VALUES(93,2169,198,9);
INSERT INTO INTERPRETE VALUES(65,2180,200,1);
INSERT INTO INTERPRETE VALUES(65,2182,200,3);
INSERT INTO INTERPRETE VALUES(65,2183,200,4);
INSERT INTO INTERPRETE VALUES(65,2185,200,6);
INSERT INTO INTERPRETE VALUES(65,2186,200,7);
INSERT INTO INTERPRETE VALUES(65,2187,200,8);
INSERT INTO INTERPRETE VALUES(65,2188,200,9);
INSERT INTO INTERPRETE VALUES(94,2189,201,1);
INSERT INTO INTERPRETE VALUES(94,2190,201,2);
INSERT INTO INTERPRETE VALUES(94,2191,201,3);
INSERT INTO INTERPRETE VALUES(94,2193,201,5);
INSERT INTO INTERPRETE VALUES(94,2194,201,6);
INSERT INTO INTERPRETE VALUES(94,2196,201,8);
INSERT INTO INTERPRETE VALUES(94,2197,201,9);
INSERT INTO INTERPRETE VALUES(94,2198,201,10);
INSERT INTO INTERPRETE VALUES(94,2199,201,11);
INSERT INTO INTERPRETE VALUES(44,2203,202,4);
INSERT INTO INTERPRETE VALUES(91,2148,196,9);
INSERT INTO INTERPRETE VALUES(93,2222,204,4);
INSERT INTO INTERPRETE VALUES(93,2223,204,5);
INSERT INTO INTERPRETE VALUES(93,2224,204,6);
INSERT INTO INTERPRETE VALUES(93,2225,204,7);
INSERT INTO INTERPRETE VALUES(93,2226,204,8);
INSERT INTO INTERPRETE VALUES(93,2227,204,9);
INSERT INTO INTERPRETE VALUES(93,2228,204,10);
INSERT INTO INTERPRETE VALUES(45,2229,205,1);
INSERT INTO INTERPRETE VALUES(45,2230,205,2);
INSERT INTO INTERPRETE VALUES(45,2231,205,3);
INSERT INTO INTERPRETE VALUES(45,2232,205,4);
INSERT INTO INTERPRETE VALUES(45,2233,205,5);
INSERT INTO INTERPRETE VALUES(45,2234,205,6);
INSERT INTO INTERPRETE VALUES(45,2235,205,7);
INSERT INTO INTERPRETE VALUES(45,2236,205,8);
INSERT INTO INTERPRETE VALUES(45,2237,205,9);
INSERT INTO INTERPRETE VALUES(45,2238,205,10);
INSERT INTO INTERPRETE VALUES(66,2240,206,2);
INSERT INTO INTERPRETE VALUES(66,2241,206,3);
INSERT INTO INTERPRETE VALUES(66,2242,206,4);
INSERT INTO INTERPRETE VALUES(66,2243,206,5);
INSERT INTO INTERPRETE VALUES(66,2244,206,6);
INSERT INTO INTERPRETE VALUES(66,2246,206,8);
INSERT INTO INTERPRETE VALUES(66,2247,206,9);
INSERT INTO INTERPRETE VALUES(44,2201,202,2);
INSERT INTO INTERPRETE VALUES(52,2250,207,3);
INSERT INTO INTERPRETE VALUES(44,1546,208,3);
INSERT INTO INTERPRETE VALUES(61,2267,209,1);
INSERT INTO INTERPRETE VALUES(61,2269,209,3);
INSERT INTO INTERPRETE VALUES(61,2270,209,4);
INSERT INTO INTERPRETE VALUES(61,2271,209,5);
INSERT INTO INTERPRETE VALUES(61,2272,209,6);
INSERT INTO INTERPRETE VALUES(61,2273,209,7);
INSERT INTO INTERPRETE VALUES(61,2274,209,8);
INSERT INTO INTERPRETE VALUES(61,2275,209,9);
INSERT INTO INTERPRETE VALUES(61,2276,209,10);
INSERT INTO INTERPRETE VALUES(95,2277,210,1);
INSERT INTO INTERPRETE VALUES(95,2278,210,2);
INSERT INTO INTERPRETE VALUES(95,2279,210,3);
INSERT INTO INTERPRETE VALUES(95,2280,210,4);
INSERT INTO INTERPRETE VALUES(95,2281,210,5);
INSERT INTO INTERPRETE VALUES(95,2282,210,6);
INSERT INTO INTERPRETE VALUES(95,2283,210,7);
INSERT INTO INTERPRETE VALUES(95,2284,210,8);
INSERT INTO INTERPRETE VALUES(95,2285,210,9);
INSERT INTO INTERPRETE VALUES(95,2286,210,10);
INSERT INTO INTERPRETE VALUES(95,2287,210,11);
INSERT INTO INTERPRETE VALUES(95,2288,210,12);
INSERT INTO INTERPRETE VALUES(96,2289,211,1);
INSERT INTO INTERPRETE VALUES(96,2290,211,2);
INSERT INTO INTERPRETE VALUES(96,2291,211,3);
INSERT INTO INTERPRETE VALUES(96,2292,211,4);
INSERT INTO INTERPRETE VALUES(96,2293,211,5);
INSERT INTO INTERPRETE VALUES(96,2294,211,6);
INSERT INTO INTERPRETE VALUES(96,2295,211,7);
INSERT INTO INTERPRETE VALUES(52,2256,207,9);
INSERT INTO INTERPRETE VALUES(52,2253,207,6);
INSERT INTO INTERPRETE VALUES(96,2296,211,8);
INSERT INTO INTERPRETE VALUES(96,2297,211,9);
INSERT INTO INTERPRETE VALUES(96,2298,211,10);
INSERT INTO INTERPRETE VALUES(96,2299,211,11);
INSERT INTO INTERPRETE VALUES(96,2300,211,12);
INSERT INTO INTERPRETE VALUES(11,2301,212,1);
INSERT INTO INTERPRETE VALUES(11,2302,212,2);
INSERT INTO INTERPRETE VALUES(11,2303,212,3);
INSERT INTO INTERPRETE VALUES(11,2304,212,4);
INSERT INTO INTERPRETE VALUES(11,2305,212,5);
INSERT INTO INTERPRETE VALUES(11,2306,212,6);
INSERT INTO INTERPRETE VALUES(11,2307,212,7);
INSERT INTO INTERPRETE VALUES(11,2309,212,9);
INSERT INTO INTERPRETE VALUES(11,2310,212,10);
INSERT INTO INTERPRETE VALUES(11,2311,212,11);
INSERT INTO INTERPRETE VALUES(4,11669,213,2);
INSERT INTO INTERPRETE VALUES(4,2314,213,3);
INSERT INTO INTERPRETE VALUES(4,2315,213,4);
INSERT INTO INTERPRETE VALUES(4,2317,213,6);
INSERT INTO INTERPRETE VALUES(4,2318,213,7);
INSERT INTO INTERPRETE VALUES(4,2319,213,8);
INSERT INTO INTERPRETE VALUES(4,2320,213,9);
INSERT INTO INTERPRETE VALUES(4,2321,213,10);
INSERT INTO INTERPRETE VALUES(97,2322,214,1);
INSERT INTO INTERPRETE VALUES(97,2323,214,2);
INSERT INTO INTERPRETE VALUES(97,2324,214,3);
INSERT INTO INTERPRETE VALUES(97,2325,214,4);
INSERT INTO INTERPRETE VALUES(97,2326,214,5);
INSERT INTO INTERPRETE VALUES(97,2328,214,7);
INSERT INTO INTERPRETE VALUES(97,2329,214,8);
INSERT INTO INTERPRETE VALUES(97,2330,214,9);
INSERT INTO INTERPRETE VALUES(97,2331,214,10);
INSERT INTO INTERPRETE VALUES(98,2333,215,1);
INSERT INTO INTERPRETE VALUES(98,2334,215,2);
INSERT INTO INTERPRETE VALUES(98,2335,215,3);
INSERT INTO INTERPRETE VALUES(98,2336,215,4);
INSERT INTO INTERPRETE VALUES(98,2337,215,5);
INSERT INTO INTERPRETE VALUES(98,2338,215,6);
INSERT INTO INTERPRETE VALUES(98,2339,215,7);
INSERT INTO INTERPRETE VALUES(98,2340,215,8);
INSERT INTO INTERPRETE VALUES(98,2341,215,9);
INSERT INTO INTERPRETE VALUES(98,2342,215,10);
INSERT INTO INTERPRETE VALUES(98,2343,215,11);
INSERT INTO INTERPRETE VALUES(99,2344,216,1);
INSERT INTO INTERPRETE VALUES(99,2345,216,2);
INSERT INTO INTERPRETE VALUES(99,2346,216,3);
INSERT INTO INTERPRETE VALUES(99,2347,216,4);
INSERT INTO INTERPRETE VALUES(99,2348,216,5);
INSERT INTO INTERPRETE VALUES(99,2349,216,6);
INSERT INTO INTERPRETE VALUES(99,2350,216,7);
INSERT INTO INTERPRETE VALUES(99,2351,216,8);
INSERT INTO INTERPRETE VALUES(99,2352,216,9);
INSERT INTO INTERPRETE VALUES(99,2353,216,10);
INSERT INTO INTERPRETE VALUES(95,2354,217,1);
INSERT INTO INTERPRETE VALUES(95,2355,217,2);
INSERT INTO INTERPRETE VALUES(95,2356,217,3);
INSERT INTO INTERPRETE VALUES(95,2357,217,4);
INSERT INTO INTERPRETE VALUES(95,2358,217,5);
INSERT INTO INTERPRETE VALUES(95,2359,217,6);
INSERT INTO INTERPRETE VALUES(95,2360,217,7);
INSERT INTO INTERPRETE VALUES(95,2361,217,8);
INSERT INTO INTERPRETE VALUES(95,2362,217,9);
INSERT INTO INTERPRETE VALUES(95,2363,217,10);
INSERT INTO INTERPRETE VALUES(95,2364,217,11);
INSERT INTO INTERPRETE VALUES(95,2365,217,12);
INSERT INTO INTERPRETE VALUES(95,2366,217,13);
INSERT INTO INTERPRETE VALUES(95,2367,217,14);
INSERT INTO INTERPRETE VALUES(100,2377,219,1);
INSERT INTO INTERPRETE VALUES(100,2378,219,2);
INSERT INTO INTERPRETE VALUES(100,2379,219,3);
INSERT INTO INTERPRETE VALUES(52,2370,218,3);
INSERT INTO INTERPRETE VALUES(100,2380,219,4);
INSERT INTO INTERPRETE VALUES(100,2381,219,5);
INSERT INTO INTERPRETE VALUES(100,2382,219,6);
INSERT INTO INTERPRETE VALUES(100,2383,219,7);
INSERT INTO INTERPRETE VALUES(100,2384,219,8);
INSERT INTO INTERPRETE VALUES(100,2386,219,10);
INSERT INTO INTERPRETE VALUES(100,2387,219,11);
INSERT INTO INTERPRETE VALUES(99,2388,220,1);
INSERT INTO INTERPRETE VALUES(99,2389,220,2);
INSERT INTO INTERPRETE VALUES(99,2390,220,3);
INSERT INTO INTERPRETE VALUES(99,2391,220,4);
INSERT INTO INTERPRETE VALUES(99,2392,220,5);
INSERT INTO INTERPRETE VALUES(99,2393,220,6);
INSERT INTO INTERPRETE VALUES(99,2394,220,7);
INSERT INTO INTERPRETE VALUES(99,2396,220,9);
INSERT INTO INTERPRETE VALUES(99,2397,220,10);
INSERT INTO INTERPRETE VALUES(71,2398,221,1);
INSERT INTO INTERPRETE VALUES(71,2399,221,2);
INSERT INTO INTERPRETE VALUES(101,2410,222,3);
INSERT INTO INTERPRETE VALUES(101,2411,222,4);
INSERT INTO INTERPRETE VALUES(102,2425,223,7);
INSERT INTO INTERPRETE VALUES(102,2426,223,8);
INSERT INTO INTERPRETE VALUES(102,2427,223,9);
INSERT INTO INTERPRETE VALUES(102,2428,223,10);
INSERT INTO INTERPRETE VALUES(102,2429,223,11);
INSERT INTO INTERPRETE VALUES(61,2430,224,1);
INSERT INTO INTERPRETE VALUES(61,2431,224,2);
INSERT INTO INTERPRETE VALUES(61,2432,224,3);
INSERT INTO INTERPRETE VALUES(61,2433,224,4);
INSERT INTO INTERPRETE VALUES(61,2434,224,5);
INSERT INTO INTERPRETE VALUES(61,2435,224,6);
INSERT INTO INTERPRETE VALUES(61,2436,224,7);
INSERT INTO INTERPRETE VALUES(61,2437,224,8);
INSERT INTO INTERPRETE VALUES(61,2438,224,9);
INSERT INTO INTERPRETE VALUES(61,2439,224,10);
INSERT INTO INTERPRETE VALUES(61,2440,224,11);
INSERT INTO INTERPRETE VALUES(103,2441,225,1);
INSERT INTO INTERPRETE VALUES(103,2442,225,2);
INSERT INTO INTERPRETE VALUES(103,2443,225,3);
INSERT INTO INTERPRETE VALUES(103,2444,225,4);
INSERT INTO INTERPRETE VALUES(103,2445,225,5);
INSERT INTO INTERPRETE VALUES(103,2446,225,6);
INSERT INTO INTERPRETE VALUES(103,2447,225,7);
INSERT INTO INTERPRETE VALUES(103,2448,225,8);
INSERT INTO INTERPRETE VALUES(103,2449,225,9);
INSERT INTO INTERPRETE VALUES(103,2451,225,11);
INSERT INTO INTERPRETE VALUES(44,2452,226,1);
INSERT INTO INTERPRETE VALUES(44,2457,226,6);
INSERT INTO INTERPRETE VALUES(104,2462,227,1);
INSERT INTO INTERPRETE VALUES(104,2463,227,2);
INSERT INTO INTERPRETE VALUES(104,2464,227,3);
INSERT INTO INTERPRETE VALUES(104,2465,227,4);
INSERT INTO INTERPRETE VALUES(104,2466,227,5);
INSERT INTO INTERPRETE VALUES(104,2467,227,6);
INSERT INTO INTERPRETE VALUES(104,2468,227,7);
INSERT INTO INTERPRETE VALUES(104,2469,227,8);
INSERT INTO INTERPRETE VALUES(104,2470,227,9);
INSERT INTO INTERPRETE VALUES(44,1549,228,1);
INSERT INTO INTERPRETE VALUES(44,2473,228,3);
INSERT INTO INTERPRETE VALUES(44,2476,228,6);
INSERT INTO INTERPRETE VALUES(66,2481,229,1);
INSERT INTO INTERPRETE VALUES(66,2482,229,2);
INSERT INTO INTERPRETE VALUES(66,2483,229,3);
INSERT INTO INTERPRETE VALUES(66,2484,229,4);
INSERT INTO INTERPRETE VALUES(66,2485,229,5);
INSERT INTO INTERPRETE VALUES(66,2486,229,6);
INSERT INTO INTERPRETE VALUES(66,2487,229,7);
INSERT INTO INTERPRETE VALUES(66,2488,229,8);
INSERT INTO INTERPRETE VALUES(66,2489,229,9);
INSERT INTO INTERPRETE VALUES(66,2490,229,10);
INSERT INTO INTERPRETE VALUES(105,2491,230,1);
INSERT INTO INTERPRETE VALUES(105,2492,230,2);
INSERT INTO INTERPRETE VALUES(105,2493,230,3);
INSERT INTO INTERPRETE VALUES(105,2494,230,4);
INSERT INTO INTERPRETE VALUES(105,2495,230,5);
INSERT INTO INTERPRETE VALUES(105,2496,230,6);
INSERT INTO INTERPRETE VALUES(105,2497,230,7);
INSERT INTO INTERPRETE VALUES(105,2498,230,8);
INSERT INTO INTERPRETE VALUES(105,2499,230,9);
INSERT INTO INTERPRETE VALUES(105,2500,230,10);
INSERT INTO INTERPRETE VALUES(105,2501,230,11);
INSERT INTO INTERPRETE VALUES(105,2502,230,12);
INSERT INTO INTERPRETE VALUES(105,2503,230,13);
INSERT INTO INTERPRETE VALUES(106,2504,231,1);
INSERT INTO INTERPRETE VALUES(106,2505,231,2);
INSERT INTO INTERPRETE VALUES(106,2506,231,3);
INSERT INTO INTERPRETE VALUES(106,2508,231,5);
INSERT INTO INTERPRETE VALUES(106,2509,231,6);
INSERT INTO INTERPRETE VALUES(106,2510,231,7);
INSERT INTO INTERPRETE VALUES(106,2511,231,8);
INSERT INTO INTERPRETE VALUES(106,2512,231,9);
INSERT INTO INTERPRETE VALUES(93,2513,232,1);
INSERT INTO INTERPRETE VALUES(93,2514,232,2);
INSERT INTO INTERPRETE VALUES(93,2515,232,3);
INSERT INTO INTERPRETE VALUES(93,2516,232,4);
INSERT INTO INTERPRETE VALUES(93,2517,232,5);
INSERT INTO INTERPRETE VALUES(93,2518,232,6);
INSERT INTO INTERPRETE VALUES(93,2519,232,7);
INSERT INTO INTERPRETE VALUES(93,2520,232,8);
INSERT INTO INTERPRETE VALUES(93,2521,232,9);
INSERT INTO INTERPRETE VALUES(93,2522,232,10);
INSERT INTO INTERPRETE VALUES(101,2523,233,1);
INSERT INTO INTERPRETE VALUES(101,2525,233,3);
INSERT INTO INTERPRETE VALUES(44,2479,228,9);
INSERT INTO INTERPRETE VALUES(101,2526,233,4);
INSERT INTO INTERPRETE VALUES(101,2527,233,5);
INSERT INTO INTERPRETE VALUES(101,2528,233,6);
INSERT INTO INTERPRETE VALUES(101,2529,233,7);
INSERT INTO INTERPRETE VALUES(101,2530,233,8);
INSERT INTO INTERPRETE VALUES(101,2531,233,9);
INSERT INTO INTERPRETE VALUES(101,2532,233,10);
INSERT INTO INTERPRETE VALUES(77,2533,234,1);
INSERT INTO INTERPRETE VALUES(77,2534,234,2);
INSERT INTO INTERPRETE VALUES(77,2535,234,3);
INSERT INTO INTERPRETE VALUES(77,2537,234,5);
INSERT INTO INTERPRETE VALUES(77,2538,234,6);
INSERT INTO INTERPRETE VALUES(77,2539,234,7);
INSERT INTO INTERPRETE VALUES(77,2540,234,8);
INSERT INTO INTERPRETE VALUES(77,2541,234,9);
INSERT INTO INTERPRETE VALUES(77,2542,234,10);
INSERT INTO INTERPRETE VALUES(77,2543,234,11);
INSERT INTO INTERPRETE VALUES(77,2544,234,12);
INSERT INTO INTERPRETE VALUES(77,2545,234,13);
INSERT INTO INTERPRETE VALUES(107,2546,235,1);
INSERT INTO INTERPRETE VALUES(107,2547,235,2);
INSERT INTO INTERPRETE VALUES(107,2548,235,3);
INSERT INTO INTERPRETE VALUES(107,2549,235,4);
INSERT INTO INTERPRETE VALUES(107,2550,235,5);
INSERT INTO INTERPRETE VALUES(107,2551,235,6);
INSERT INTO INTERPRETE VALUES(107,2552,235,7);
INSERT INTO INTERPRETE VALUES(107,2555,235,10);
INSERT INTO INTERPRETE VALUES(108,2556,236,1);
INSERT INTO INTERPRETE VALUES(108,2557,236,2);
INSERT INTO INTERPRETE VALUES(108,2558,236,3);
INSERT INTO INTERPRETE VALUES(108,2559,236,4);
INSERT INTO INTERPRETE VALUES(108,2560,236,5);
INSERT INTO INTERPRETE VALUES(108,2561,236,6);
INSERT INTO INTERPRETE VALUES(108,2562,236,7);
INSERT INTO INTERPRETE VALUES(108,2563,236,8);
INSERT INTO INTERPRETE VALUES(108,2564,236,9);
INSERT INTO INTERPRETE VALUES(108,2565,236,10);
INSERT INTO INTERPRETE VALUES(108,2566,236,11);
INSERT INTO INTERPRETE VALUES(108,2567,236,12);
INSERT INTO INTERPRETE VALUES(109,2568,237,1);
INSERT INTO INTERPRETE VALUES(109,2569,237,2);
INSERT INTO INTERPRETE VALUES(109,2570,237,3);
INSERT INTO INTERPRETE VALUES(109,2571,237,4);
INSERT INTO INTERPRETE VALUES(109,2572,237,5);
INSERT INTO INTERPRETE VALUES(109,2573,237,6);
INSERT INTO INTERPRETE VALUES(109,2574,237,7);
INSERT INTO INTERPRETE VALUES(109,2575,237,8);
INSERT INTO INTERPRETE VALUES(109,2576,237,9);
INSERT INTO INTERPRETE VALUES(109,2577,237,10);
INSERT INTO INTERPRETE VALUES(109,2578,237,11);
INSERT INTO INTERPRETE VALUES(109,2579,237,12);
INSERT INTO INTERPRETE VALUES(45,2580,238,1);
INSERT INTO INTERPRETE VALUES(45,2581,238,2);
INSERT INTO INTERPRETE VALUES(45,2582,238,3);
INSERT INTO INTERPRETE VALUES(45,2583,238,4);
INSERT INTO INTERPRETE VALUES(45,2584,238,5);
INSERT INTO INTERPRETE VALUES(45,2585,238,6);
INSERT INTO INTERPRETE VALUES(45,2586,238,7);
INSERT INTO INTERPRETE VALUES(45,2587,238,8);
INSERT INTO INTERPRETE VALUES(45,2588,238,9);
INSERT INTO INTERPRETE VALUES(45,2589,238,10);
INSERT INTO INTERPRETE VALUES(45,2590,238,11);
INSERT INTO INTERPRETE VALUES(110,2591,239,1);
INSERT INTO INTERPRETE VALUES(110,2592,239,2);
INSERT INTO INTERPRETE VALUES(110,2593,239,3);
INSERT INTO INTERPRETE VALUES(110,2594,239,4);
INSERT INTO INTERPRETE VALUES(110,2595,239,5);
INSERT INTO INTERPRETE VALUES(110,2596,239,6);
INSERT INTO INTERPRETE VALUES(110,2597,239,7);
INSERT INTO INTERPRETE VALUES(110,1525,239,8);
INSERT INTO INTERPRETE VALUES(110,2599,239,9);
INSERT INTO INTERPRETE VALUES(110,2600,239,10);
INSERT INTO INTERPRETE VALUES(99,2601,240,1);
INSERT INTO INTERPRETE VALUES(99,2602,240,2);
INSERT INTO INTERPRETE VALUES(99,2603,240,3);
INSERT INTO INTERPRETE VALUES(99,2604,240,4);
INSERT INTO INTERPRETE VALUES(99,2605,240,5);
INSERT INTO INTERPRETE VALUES(99,2606,240,6);
INSERT INTO INTERPRETE VALUES(99,2607,240,7);
INSERT INTO INTERPRETE VALUES(99,2609,240,9);
INSERT INTO INTERPRETE VALUES(99,2610,240,10);
INSERT INTO INTERPRETE VALUES(99,2611,240,11);
INSERT INTO INTERPRETE VALUES(111,2612,241,1);
INSERT INTO INTERPRETE VALUES(111,2613,241,2);
INSERT INTO INTERPRETE VALUES(111,2614,241,3);
INSERT INTO INTERPRETE VALUES(111,2619,241,8);
INSERT INTO INTERPRETE VALUES(111,2621,241,10);
INSERT INTO INTERPRETE VALUES(111,2622,241,11);
INSERT INTO INTERPRETE VALUES(111,2623,241,12);
INSERT INTO INTERPRETE VALUES(111,2624,241,13);
INSERT INTO INTERPRETE VALUES(111,2625,241,14);
INSERT INTO INTERPRETE VALUES(111,2626,241,15);
INSERT INTO INTERPRETE VALUES(111,2627,241,16);
INSERT INTO INTERPRETE VALUES(111,2628,241,17);
INSERT INTO INTERPRETE VALUES(111,2629,241,18);
INSERT INTO INTERPRETE VALUES(45,2630,242,1);
INSERT INTO INTERPRETE VALUES(45,2631,242,2);
INSERT INTO INTERPRETE VALUES(45,2632,242,3);
INSERT INTO INTERPRETE VALUES(45,2634,242,5);
INSERT INTO INTERPRETE VALUES(45,2635,242,6);
INSERT INTO INTERPRETE VALUES(45,2636,242,7);
INSERT INTO INTERPRETE VALUES(45,2637,242,8);
INSERT INTO INTERPRETE VALUES(45,2638,242,9);
INSERT INTO INTERPRETE VALUES(45,2639,242,10);
INSERT INTO INTERPRETE VALUES(45,2640,242,11);
INSERT INTO INTERPRETE VALUES(45,2641,242,12);
INSERT INTO INTERPRETE VALUES(11,2642,243,1);
INSERT INTO INTERPRETE VALUES(11,2643,243,2);
INSERT INTO INTERPRETE VALUES(11,2644,243,3);
INSERT INTO INTERPRETE VALUES(11,2645,243,4);
INSERT INTO INTERPRETE VALUES(11,2647,243,6);
INSERT INTO INTERPRETE VALUES(11,2648,243,7);
INSERT INTO INTERPRETE VALUES(11,2649,243,8);
INSERT INTO INTERPRETE VALUES(11,2650,243,9);
INSERT INTO INTERPRETE VALUES(11,2651,243,10);
INSERT INTO INTERPRETE VALUES(11,2652,243,11);
INSERT INTO INTERPRETE VALUES(11,2653,243,12);
INSERT INTO INTERPRETE VALUES(112,2662,244,9);
INSERT INTO INTERPRETE VALUES(112,2663,244,10);
INSERT INTO INTERPRETE VALUES(112,2664,244,11);
INSERT INTO INTERPRETE VALUES(86,2665,245,1);
INSERT INTO INTERPRETE VALUES(86,2666,245,2);
INSERT INTO INTERPRETE VALUES(86,2667,245,3);
INSERT INTO INTERPRETE VALUES(86,2668,245,4);
INSERT INTO INTERPRETE VALUES(86,2669,245,5);
INSERT INTO INTERPRETE VALUES(86,2670,245,6);
INSERT INTO INTERPRETE VALUES(86,2671,245,7);
INSERT INTO INTERPRETE VALUES(86,2672,245,8);
INSERT INTO INTERPRETE VALUES(86,2674,245,10);
INSERT INTO INTERPRETE VALUES(86,2675,245,11);
INSERT INTO INTERPRETE VALUES(86,2676,245,12);
INSERT INTO INTERPRETE VALUES(99,2608,240,8);
INSERT INTO INTERPRETE VALUES(44,2677,246,1);
INSERT INTO INTERPRETE VALUES(44,2681,246,5);
INSERT INTO INTERPRETE VALUES(44,2680,246,4);
INSERT INTO INTERPRETE VALUES(44,2682,246,6);
INSERT INTO INTERPRETE VALUES(44,2457,246,10);
INSERT INTO INTERPRETE VALUES(113,2689,247,3);
INSERT INTO INTERPRETE VALUES(113,2690,247,4);
INSERT INTO INTERPRETE VALUES(113,2691,247,5);
INSERT INTO INTERPRETE VALUES(113,2692,247,6);
INSERT INTO INTERPRETE VALUES(113,2693,247,7);
INSERT INTO INTERPRETE VALUES(113,2694,247,8);
INSERT INTO INTERPRETE VALUES(113,2695,247,9);
INSERT INTO INTERPRETE VALUES(113,2696,247,10);
INSERT INTO INTERPRETE VALUES(113,2697,247,11);
INSERT INTO INTERPRETE VALUES(113,2698,247,12);
INSERT INTO INTERPRETE VALUES(14,2699,248,1);
INSERT INTO INTERPRETE VALUES(14,1793,248,2);
INSERT INTO INTERPRETE VALUES(14,2701,248,3);
INSERT INTO INTERPRETE VALUES(14,2702,248,4);
INSERT INTO INTERPRETE VALUES(14,2703,248,5);
INSERT INTO INTERPRETE VALUES(14,2704,248,6);
INSERT INTO INTERPRETE VALUES(14,2705,248,7);
INSERT INTO INTERPRETE VALUES(14,2706,248,8);
INSERT INTO INTERPRETE VALUES(14,2707,248,9);
INSERT INTO INTERPRETE VALUES(14,2708,248,10);
INSERT INTO INTERPRETE VALUES(14,286,248,11);
INSERT INTO INTERPRETE VALUES(80,2710,249,1);
INSERT INTO INTERPRETE VALUES(80,2711,249,2);
INSERT INTO INTERPRETE VALUES(80,2712,249,3);
INSERT INTO INTERPRETE VALUES(80,2713,249,4);
INSERT INTO INTERPRETE VALUES(80,2714,249,5);
INSERT INTO INTERPRETE VALUES(80,2715,249,6);
INSERT INTO INTERPRETE VALUES(80,2716,249,7);
INSERT INTO INTERPRETE VALUES(80,2717,249,8);
INSERT INTO INTERPRETE VALUES(80,2718,249,9);
INSERT INTO INTERPRETE VALUES(80,2719,249,10);
INSERT INTO INTERPRETE VALUES(44,2722,250,3);
INSERT INTO INTERPRETE VALUES(44,2726,250,7);
INSERT INTO INTERPRETE VALUES(44,2727,250,8);
INSERT INTO INTERPRETE VALUES(44,2731,250,12);
INSERT INTO INTERPRETE VALUES(52,2735,251,4);
INSERT INTO INTERPRETE VALUES(52,2745,251,14);
INSERT INTO INTERPRETE VALUES(99,2746,252,1);
INSERT INTO INTERPRETE VALUES(99,2747,252,2);
INSERT INTO INTERPRETE VALUES(99,2749,252,4);
INSERT INTO INTERPRETE VALUES(52,2741,251,10);
INSERT INTO INTERPRETE VALUES(52,2738,251,7);
INSERT INTO INTERPRETE VALUES(99,162,252,5);
INSERT INTO INTERPRETE VALUES(99,2756,252,11);
INSERT INTO INTERPRETE VALUES(61,5369,253,1);
INSERT INTO INTERPRETE VALUES(61,2758,253,2);
INSERT INTO INTERPRETE VALUES(61,2759,253,3);
INSERT INTO INTERPRETE VALUES(61,2760,253,4);
INSERT INTO INTERPRETE VALUES(61,2761,253,5);
INSERT INTO INTERPRETE VALUES(61,2762,253,6);
INSERT INTO INTERPRETE VALUES(61,2763,253,7);
INSERT INTO INTERPRETE VALUES(61,2764,253,8);
INSERT INTO INTERPRETE VALUES(61,2765,253,9);
INSERT INTO INTERPRETE VALUES(61,2766,253,10);
INSERT INTO INTERPRETE VALUES(61,2767,253,11);
INSERT INTO INTERPRETE VALUES(6,2768,254,1);
INSERT INTO INTERPRETE VALUES(6,2769,254,2);
INSERT INTO INTERPRETE VALUES(6,2770,254,3);
INSERT INTO INTERPRETE VALUES(6,2771,254,4);
INSERT INTO INTERPRETE VALUES(6,2772,254,5);
INSERT INTO INTERPRETE VALUES(6,2773,254,6);
INSERT INTO INTERPRETE VALUES(6,2774,254,7);
INSERT INTO INTERPRETE VALUES(6,2775,254,8);
INSERT INTO INTERPRETE VALUES(6,2776,254,9);
INSERT INTO INTERPRETE VALUES(6,2777,254,10);
INSERT INTO INTERPRETE VALUES(114,2778,255,1);
INSERT INTO INTERPRETE VALUES(114,2779,255,2);
INSERT INTO INTERPRETE VALUES(114,2780,255,3);
INSERT INTO INTERPRETE VALUES(114,2781,255,4);
INSERT INTO INTERPRETE VALUES(114,2782,255,5);
INSERT INTO INTERPRETE VALUES(114,2783,255,6);
INSERT INTO INTERPRETE VALUES(114,2784,255,7);
INSERT INTO INTERPRETE VALUES(114,2785,255,8);
INSERT INTO INTERPRETE VALUES(114,2786,255,9);
INSERT INTO INTERPRETE VALUES(114,2787,255,10);
INSERT INTO INTERPRETE VALUES(114,2788,255,11);
INSERT INTO INTERPRETE VALUES(115,2789,256,1);
INSERT INTO INTERPRETE VALUES(115,2790,256,2);
INSERT INTO INTERPRETE VALUES(115,2791,256,3);
INSERT INTO INTERPRETE VALUES(115,2792,256,4);
INSERT INTO INTERPRETE VALUES(115,2793,256,5);
INSERT INTO INTERPRETE VALUES(115,2794,256,6);
INSERT INTO INTERPRETE VALUES(115,2795,256,7);
INSERT INTO INTERPRETE VALUES(115,2796,256,8);
INSERT INTO INTERPRETE VALUES(115,2797,256,9);
INSERT INTO INTERPRETE VALUES(115,2798,256,10);
INSERT INTO INTERPRETE VALUES(115,2799,256,11);
INSERT INTO INTERPRETE VALUES(109,2800,257,1);
INSERT INTO INTERPRETE VALUES(109,2801,257,2);
INSERT INTO INTERPRETE VALUES(109,2802,257,3);
INSERT INTO INTERPRETE VALUES(109,2803,257,4);
INSERT INTO INTERPRETE VALUES(109,2805,257,6);
INSERT INTO INTERPRETE VALUES(109,2806,257,7);
INSERT INTO INTERPRETE VALUES(109,2807,257,8);
INSERT INTO INTERPRETE VALUES(109,2808,257,9);
INSERT INTO INTERPRETE VALUES(109,2809,257,10);
INSERT INTO INTERPRETE VALUES(109,2810,257,11);
INSERT INTO INTERPRETE VALUES(88,2811,258,1);
INSERT INTO INTERPRETE VALUES(88,2812,258,2);
INSERT INTO INTERPRETE VALUES(88,2813,258,3);
INSERT INTO INTERPRETE VALUES(88,2814,258,4);
INSERT INTO INTERPRETE VALUES(88,2815,258,5);
INSERT INTO INTERPRETE VALUES(88,2816,258,6);
INSERT INTO INTERPRETE VALUES(88,2817,258,7);
INSERT INTO INTERPRETE VALUES(88,2819,258,9);
INSERT INTO INTERPRETE VALUES(88,2820,258,10);
INSERT INTO INTERPRETE VALUES(88,2821,258,11);
INSERT INTO INTERPRETE VALUES(71,2822,259,1);
INSERT INTO INTERPRETE VALUES(109,1544,257,5);
INSERT INTO INTERPRETE VALUES(71,2823,259,2);
INSERT INTO INTERPRETE VALUES(71,2824,259,3);
INSERT INTO INTERPRETE VALUES(71,2825,259,4);
INSERT INTO INTERPRETE VALUES(71,2826,259,5);
INSERT INTO INTERPRETE VALUES(71,2827,259,6);
INSERT INTO INTERPRETE VALUES(71,2828,259,7);
INSERT INTO INTERPRETE VALUES(71,2829,259,8);
INSERT INTO INTERPRETE VALUES(71,2831,259,10);
INSERT INTO INTERPRETE VALUES(71,2832,259,11);
INSERT INTO INTERPRETE VALUES(71,2833,259,12);
INSERT INTO INTERPRETE VALUES(67,2834,260,1);
INSERT INTO INTERPRETE VALUES(67,2836,260,3);
INSERT INTO INTERPRETE VALUES(67,2840,260,7);
INSERT INTO INTERPRETE VALUES(67,2841,260,8);
INSERT INTO INTERPRETE VALUES(67,2842,260,9);
INSERT INTO INTERPRETE VALUES(67,1451,260,10);
INSERT INTO INTERPRETE VALUES(67,1446,260,11);
INSERT INTO INTERPRETE VALUES(57,2845,261,1);
INSERT INTO INTERPRETE VALUES(57,2846,261,2);
INSERT INTO INTERPRETE VALUES(57,2849,261,5);
INSERT INTO INTERPRETE VALUES(57,2850,261,6);
INSERT INTO INTERPRETE VALUES(57,2851,261,7);
INSERT INTO INTERPRETE VALUES(57,2848,261,4);
INSERT INTO INTERPRETE VALUES(57,2852,261,8);
INSERT INTO INTERPRETE VALUES(57,2854,261,10);
INSERT INTO INTERPRETE VALUES(93,2858,262,3);
INSERT INTO INTERPRETE VALUES(93,2860,262,5);
INSERT INTO INTERPRETE VALUES(93,2861,262,6);
INSERT INTO INTERPRETE VALUES(93,2862,262,7);
INSERT INTO INTERPRETE VALUES(93,2863,262,8);
INSERT INTO INTERPRETE VALUES(93,2864,262,9);
INSERT INTO INTERPRETE VALUES(93,2865,262,10);
INSERT INTO INTERPRETE VALUES(93,2866,262,11);
INSERT INTO INTERPRETE VALUES(70,2867,263,1);
INSERT INTO INTERPRETE VALUES(70,2868,263,2);
INSERT INTO INTERPRETE VALUES(70,2869,263,3);
INSERT INTO INTERPRETE VALUES(70,2870,263,4);
INSERT INTO INTERPRETE VALUES(70,1697,263,5);
INSERT INTO INTERPRETE VALUES(70,2872,263,6);
INSERT INTO INTERPRETE VALUES(70,2873,263,7);
INSERT INTO INTERPRETE VALUES(70,2874,263,8);
INSERT INTO INTERPRETE VALUES(70,2875,263,9);
INSERT INTO INTERPRETE VALUES(70,2876,263,10);
INSERT INTO INTERPRETE VALUES(70,2877,263,11);
INSERT INTO INTERPRETE VALUES(70,2878,263,12);
INSERT INTO INTERPRETE VALUES(77,2879,264,1);
INSERT INTO INTERPRETE VALUES(77,2880,264,2);
INSERT INTO INTERPRETE VALUES(77,2881,264,3);
INSERT INTO INTERPRETE VALUES(77,2882,264,4);
INSERT INTO INTERPRETE VALUES(77,2883,264,5);
INSERT INTO INTERPRETE VALUES(77,2884,264,6);
INSERT INTO INTERPRETE VALUES(77,2885,264,7);
INSERT INTO INTERPRETE VALUES(77,2886,264,8);
INSERT INTO INTERPRETE VALUES(77,2887,264,9);
INSERT INTO INTERPRETE VALUES(77,2888,264,10);
INSERT INTO INTERPRETE VALUES(77,2889,264,11);
INSERT INTO INTERPRETE VALUES(77,2890,264,12);
INSERT INTO INTERPRETE VALUES(63,2891,265,1);
INSERT INTO INTERPRETE VALUES(63,2892,265,2);
INSERT INTO INTERPRETE VALUES(63,2893,265,3);
INSERT INTO INTERPRETE VALUES(63,2894,265,4);
INSERT INTO INTERPRETE VALUES(63,2895,265,5);
INSERT INTO INTERPRETE VALUES(63,2896,265,6);
INSERT INTO INTERPRETE VALUES(63,2897,265,7);
INSERT INTO INTERPRETE VALUES(63,2898,265,8);
INSERT INTO INTERPRETE VALUES(63,2899,265,9);
INSERT INTO INTERPRETE VALUES(63,2900,265,10);
INSERT INTO INTERPRETE VALUES(44,2909,266,9);
INSERT INTO INTERPRETE VALUES(44,2731,266,11);
INSERT INTO INTERPRETE VALUES(116,2919,267,8);
INSERT INTO INTERPRETE VALUES(116,2920,267,9);
INSERT INTO INTERPRETE VALUES(116,2921,267,10);
INSERT INTO INTERPRETE VALUES(116,2922,267,11);
INSERT INTO INTERPRETE VALUES(116,2923,267,12);
INSERT INTO INTERPRETE VALUES(117,2924,268,1);
INSERT INTO INTERPRETE VALUES(117,2925,268,2);
INSERT INTO INTERPRETE VALUES(117,2926,268,3);
INSERT INTO INTERPRETE VALUES(117,2927,268,4);
INSERT INTO INTERPRETE VALUES(117,2928,268,5);
INSERT INTO INTERPRETE VALUES(117,2929,268,6);
INSERT INTO INTERPRETE VALUES(117,2930,268,7);
INSERT INTO INTERPRETE VALUES(117,2931,268,8);
INSERT INTO INTERPRETE VALUES(117,2932,268,9);
INSERT INTO INTERPRETE VALUES(117,2933,268,10);
INSERT INTO INTERPRETE VALUES(117,2934,268,11);
INSERT INTO INTERPRETE VALUES(117,2935,268,12);
INSERT INTO INTERPRETE VALUES(117,2936,268,13);
INSERT INTO INTERPRETE VALUES(44,2939,269,3);
INSERT INTO INTERPRETE VALUES(44,2948,270,1);
INSERT INTO INTERPRETE VALUES(99,2960,271,1);
INSERT INTO INTERPRETE VALUES(99,2961,271,2);
INSERT INTO INTERPRETE VALUES(99,2963,271,4);
INSERT INTO INTERPRETE VALUES(99,2964,271,5);
INSERT INTO INTERPRETE VALUES(99,2965,271,6);
INSERT INTO INTERPRETE VALUES(99,2966,271,7);
INSERT INTO INTERPRETE VALUES(99,2967,271,8);
INSERT INTO INTERPRETE VALUES(99,2968,271,9);
INSERT INTO INTERPRETE VALUES(99,2969,271,10);
INSERT INTO INTERPRETE VALUES(99,2970,271,11);
INSERT INTO INTERPRETE VALUES(47,2971,272,1);
INSERT INTO INTERPRETE VALUES(47,2972,272,2);
INSERT INTO INTERPRETE VALUES(47,1339,272,3);
INSERT INTO INTERPRETE VALUES(47,1345,272,4);
INSERT INTO INTERPRETE VALUES(47,2975,272,5);
INSERT INTO INTERPRETE VALUES(47,2976,272,6);
INSERT INTO INTERPRETE VALUES(47,2978,272,8);
INSERT INTO INTERPRETE VALUES(47,1355,272,9);
INSERT INTO INTERPRETE VALUES(47,1337,272,10);
INSERT INTO INTERPRETE VALUES(47,2981,272,11);
INSERT INTO INTERPRETE VALUES(47,2982,272,12);
INSERT INTO INTERPRETE VALUES(50,2983,273,1);
INSERT INTO INTERPRETE VALUES(50,2984,273,2);
INSERT INTO INTERPRETE VALUES(50,2985,273,3);
INSERT INTO INTERPRETE VALUES(44,2947,269,11);
INSERT INTO INTERPRETE VALUES(50,2986,273,4);
INSERT INTO INTERPRETE VALUES(50,2988,273,6);
INSERT INTO INTERPRETE VALUES(50,2989,273,7);
INSERT INTO INTERPRETE VALUES(50,2990,273,8);
INSERT INTO INTERPRETE VALUES(50,2991,273,9);
INSERT INTO INTERPRETE VALUES(50,2992,273,10);
INSERT INTO INTERPRETE VALUES(50,2993,273,11);
INSERT INTO INTERPRETE VALUES(50,2994,273,12);
INSERT INTO INTERPRETE VALUES(61,3007,275,1);
INSERT INTO INTERPRETE VALUES(61,3008,275,2);
INSERT INTO INTERPRETE VALUES(61,3009,275,3);
INSERT INTO INTERPRETE VALUES(61,3010,275,4);
INSERT INTO INTERPRETE VALUES(61,3011,275,5);
INSERT INTO INTERPRETE VALUES(61,3012,275,6);
INSERT INTO INTERPRETE VALUES(61,3013,275,7);
INSERT INTO INTERPRETE VALUES(61,3014,275,8);
INSERT INTO INTERPRETE VALUES(61,3015,275,9);
INSERT INTO INTERPRETE VALUES(61,3016,275,10);
INSERT INTO INTERPRETE VALUES(61,3017,275,11);
INSERT INTO INTERPRETE VALUES(119,3018,276,1);
INSERT INTO INTERPRETE VALUES(119,3019,276,2);
INSERT INTO INTERPRETE VALUES(119,3020,276,3);
INSERT INTO INTERPRETE VALUES(119,3021,276,4);
INSERT INTO INTERPRETE VALUES(119,3022,276,5);
INSERT INTO INTERPRETE VALUES(119,3023,276,6);
INSERT INTO INTERPRETE VALUES(119,3024,276,7);
INSERT INTO INTERPRETE VALUES(119,3025,276,8);
INSERT INTO INTERPRETE VALUES(119,3026,276,9);
INSERT INTO INTERPRETE VALUES(119,3027,276,10);
INSERT INTO INTERPRETE VALUES(120,3029,277,1);
INSERT INTO INTERPRETE VALUES(120,3036,277,8);
INSERT INTO INTERPRETE VALUES(120,3037,277,9);
INSERT INTO INTERPRETE VALUES(120,3038,277,10);
INSERT INTO INTERPRETE VALUES(120,3039,277,11);
INSERT INTO INTERPRETE VALUES(120,3040,277,12);
INSERT INTO INTERPRETE VALUES(56,3041,278,1);
INSERT INTO INTERPRETE VALUES(56,3042,278,2);
INSERT INTO INTERPRETE VALUES(56,3043,278,3);
INSERT INTO INTERPRETE VALUES(56,3044,278,4);
INSERT INTO INTERPRETE VALUES(56,3045,278,5);
INSERT INTO INTERPRETE VALUES(56,3046,278,6);
INSERT INTO INTERPRETE VALUES(56,3047,278,7);
INSERT INTO INTERPRETE VALUES(56,3048,278,8);
INSERT INTO INTERPRETE VALUES(56,3049,278,9);
INSERT INTO INTERPRETE VALUES(56,3050,278,10);
INSERT INTO INTERPRETE VALUES(56,3051,278,11);
INSERT INTO INTERPRETE VALUES(121,3052,279,1);
INSERT INTO INTERPRETE VALUES(121,3053,279,2);
INSERT INTO INTERPRETE VALUES(121,3054,279,3);
INSERT INTO INTERPRETE VALUES(121,3055,279,4);
INSERT INTO INTERPRETE VALUES(121,3056,279,5);
INSERT INTO INTERPRETE VALUES(121,3057,279,6);
INSERT INTO INTERPRETE VALUES(121,3058,279,7);
INSERT INTO INTERPRETE VALUES(121,3059,279,8);
INSERT INTO INTERPRETE VALUES(121,3060,279,9);
INSERT INTO INTERPRETE VALUES(121,3061,279,10);
INSERT INTO INTERPRETE VALUES(121,3062,279,11);
INSERT INTO INTERPRETE VALUES(121,3063,279,12);
INSERT INTO INTERPRETE VALUES(121,3064,279,13);
INSERT INTO INTERPRETE VALUES(68,3065,280,1);
INSERT INTO INTERPRETE VALUES(68,3066,280,2);
INSERT INTO INTERPRETE VALUES(68,3067,280,3);
INSERT INTO INTERPRETE VALUES(68,3068,280,4);
INSERT INTO INTERPRETE VALUES(68,3069,280,5);
INSERT INTO INTERPRETE VALUES(68,3070,280,6);
INSERT INTO INTERPRETE VALUES(68,3071,280,7);
INSERT INTO INTERPRETE VALUES(68,3072,280,8);
INSERT INTO INTERPRETE VALUES(68,3073,280,9);
INSERT INTO INTERPRETE VALUES(68,3074,280,10);
INSERT INTO INTERPRETE VALUES(68,3075,280,11);
INSERT INTO INTERPRETE VALUES(122,3076,281,1);
INSERT INTO INTERPRETE VALUES(122,3077,281,2);
INSERT INTO INTERPRETE VALUES(122,3078,281,3);
INSERT INTO INTERPRETE VALUES(118,3005,274,11);
INSERT INTO INTERPRETE VALUES(122,3079,281,4);
INSERT INTO INTERPRETE VALUES(122,3080,281,5);
INSERT INTO INTERPRETE VALUES(122,3081,281,6);
INSERT INTO INTERPRETE VALUES(122,3082,281,7);
INSERT INTO INTERPRETE VALUES(122,3083,281,8);
INSERT INTO INTERPRETE VALUES(122,3084,281,9);
INSERT INTO INTERPRETE VALUES(122,3085,281,10);
INSERT INTO INTERPRETE VALUES(122,3086,281,11);
INSERT INTO INTERPRETE VALUES(122,3087,281,12);
INSERT INTO INTERPRETE VALUES(123,3088,282,1);
INSERT INTO INTERPRETE VALUES(123,3089,282,2);
INSERT INTO INTERPRETE VALUES(123,3090,282,3);
INSERT INTO INTERPRETE VALUES(123,3091,282,4);
INSERT INTO INTERPRETE VALUES(123,3092,282,5);
INSERT INTO INTERPRETE VALUES(123,3093,282,6);
INSERT INTO INTERPRETE VALUES(123,3094,282,7);
INSERT INTO INTERPRETE VALUES(123,3095,282,8);
INSERT INTO INTERPRETE VALUES(123,3096,282,9);
INSERT INTO INTERPRETE VALUES(123,3097,282,10);
INSERT INTO INTERPRETE VALUES(123,3098,282,11);
INSERT INTO INTERPRETE VALUES(123,3099,282,12);
INSERT INTO INTERPRETE VALUES(123,3100,282,13);
INSERT INTO INTERPRETE VALUES(123,3101,282,14);
INSERT INTO INTERPRETE VALUES(123,3102,282,15);
INSERT INTO INTERPRETE VALUES(123,3103,282,16);
INSERT INTO INTERPRETE VALUES(61,3104,283,1);
INSERT INTO INTERPRETE VALUES(61,3105,283,2);
INSERT INTO INTERPRETE VALUES(61,3106,283,3);
INSERT INTO INTERPRETE VALUES(61,3107,283,4);
INSERT INTO INTERPRETE VALUES(61,3108,283,5);
INSERT INTO INTERPRETE VALUES(61,3109,283,6);
INSERT INTO INTERPRETE VALUES(61,3110,283,7);
INSERT INTO INTERPRETE VALUES(61,3111,283,8);
INSERT INTO INTERPRETE VALUES(61,3112,283,9);
INSERT INTO INTERPRETE VALUES(61,3113,283,10);
INSERT INTO INTERPRETE VALUES(61,3114,283,11);
INSERT INTO INTERPRETE VALUES(93,3116,284,2);
INSERT INTO INTERPRETE VALUES(93,3117,284,3);
INSERT INTO INTERPRETE VALUES(93,3118,284,4);
INSERT INTO INTERPRETE VALUES(93,3119,284,5);
INSERT INTO INTERPRETE VALUES(93,3120,284,6);
INSERT INTO INTERPRETE VALUES(93,3121,284,7);
INSERT INTO INTERPRETE VALUES(93,3122,284,8);
INSERT INTO INTERPRETE VALUES(93,3123,284,9);
INSERT INTO INTERPRETE VALUES(93,3124,284,10);
INSERT INTO INTERPRETE VALUES(93,3125,284,11);
INSERT INTO INTERPRETE VALUES(93,3126,284,12);
INSERT INTO INTERPRETE VALUES(93,3127,284,13);
INSERT INTO INTERPRETE VALUES(89,3128,285,1);
INSERT INTO INTERPRETE VALUES(89,3129,285,2);
INSERT INTO INTERPRETE VALUES(89,3130,285,3);
INSERT INTO INTERPRETE VALUES(89,3131,285,4);
INSERT INTO INTERPRETE VALUES(89,3132,285,5);
INSERT INTO INTERPRETE VALUES(89,3133,285,6);
INSERT INTO INTERPRETE VALUES(89,3135,285,8);
INSERT INTO INTERPRETE VALUES(89,3136,285,9);
INSERT INTO INTERPRETE VALUES(89,3137,285,10);
INSERT INTO INTERPRETE VALUES(89,3138,285,11);
INSERT INTO INTERPRETE VALUES(124,3139,286,1);
INSERT INTO INTERPRETE VALUES(124,3140,286,2);
INSERT INTO INTERPRETE VALUES(124,3141,286,3);
INSERT INTO INTERPRETE VALUES(124,3142,286,4);
INSERT INTO INTERPRETE VALUES(124,3143,286,5);
INSERT INTO INTERPRETE VALUES(124,3144,286,6);
INSERT INTO INTERPRETE VALUES(124,3145,286,7);
INSERT INTO INTERPRETE VALUES(124,3146,286,8);
INSERT INTO INTERPRETE VALUES(124,3147,286,9);
INSERT INTO INTERPRETE VALUES(124,3148,286,10);
INSERT INTO INTERPRETE VALUES(124,3149,286,11);
INSERT INTO INTERPRETE VALUES(124,3150,286,12);
INSERT INTO INTERPRETE VALUES(125,3151,287,1);
INSERT INTO INTERPRETE VALUES(125,3152,287,2);
INSERT INTO INTERPRETE VALUES(125,3153,287,3);
INSERT INTO INTERPRETE VALUES(125,3154,287,4);
INSERT INTO INTERPRETE VALUES(125,3155,287,5);
INSERT INTO INTERPRETE VALUES(125,3156,287,6);
INSERT INTO INTERPRETE VALUES(125,3157,287,7);
INSERT INTO INTERPRETE VALUES(125,3158,287,8);
INSERT INTO INTERPRETE VALUES(125,3159,287,9);
INSERT INTO INTERPRETE VALUES(125,3160,287,10);
INSERT INTO INTERPRETE VALUES(125,3161,287,11);
INSERT INTO INTERPRETE VALUES(125,3162,287,12);
INSERT INTO INTERPRETE VALUES(126,3164,288,1);
INSERT INTO INTERPRETE VALUES(126,3165,288,2);
INSERT INTO INTERPRETE VALUES(126,3166,288,3);
INSERT INTO INTERPRETE VALUES(126,3168,288,5);
INSERT INTO INTERPRETE VALUES(126,3169,288,6);
INSERT INTO INTERPRETE VALUES(126,3170,288,7);
INSERT INTO INTERPRETE VALUES(126,3171,288,8);
INSERT INTO INTERPRETE VALUES(126,3172,288,9);
INSERT INTO INTERPRETE VALUES(126,3173,288,10);
INSERT INTO INTERPRETE VALUES(126,3174,288,11);
INSERT INTO INTERPRETE VALUES(50,3175,289,1);
INSERT INTO INTERPRETE VALUES(50,3176,289,2);
INSERT INTO INTERPRETE VALUES(50,3177,289,3);
INSERT INTO INTERPRETE VALUES(50,3178,289,4);
INSERT INTO INTERPRETE VALUES(50,3179,289,5);
INSERT INTO INTERPRETE VALUES(50,3180,289,6);
INSERT INTO INTERPRETE VALUES(50,3181,289,7);
INSERT INTO INTERPRETE VALUES(50,3182,289,8);
INSERT INTO INTERPRETE VALUES(50,3183,289,9);
INSERT INTO INTERPRETE VALUES(50,3184,289,10);
INSERT INTO INTERPRETE VALUES(50,3185,289,11);
INSERT INTO INTERPRETE VALUES(50,3186,289,12);
INSERT INTO INTERPRETE VALUES(50,3187,289,13);
INSERT INTO INTERPRETE VALUES(127,3188,290,1);
INSERT INTO INTERPRETE VALUES(127,3189,290,2);
INSERT INTO INTERPRETE VALUES(127,3190,290,3);
INSERT INTO INTERPRETE VALUES(127,3191,290,4);
INSERT INTO INTERPRETE VALUES(127,3192,290,5);
INSERT INTO INTERPRETE VALUES(127,3193,290,6);
INSERT INTO INTERPRETE VALUES(127,3194,290,7);
INSERT INTO INTERPRETE VALUES(127,3195,290,8);
INSERT INTO INTERPRETE VALUES(127,3196,290,9);
INSERT INTO INTERPRETE VALUES(127,3197,290,10);
INSERT INTO INTERPRETE VALUES(127,3198,290,11);
INSERT INTO INTERPRETE VALUES(127,3199,290,12);
INSERT INTO INTERPRETE VALUES(44,3201,291,2);
INSERT INTO INTERPRETE VALUES(119,3212,292,1);
INSERT INTO INTERPRETE VALUES(119,3213,292,2);
INSERT INTO INTERPRETE VALUES(119,3214,292,3);
INSERT INTO INTERPRETE VALUES(119,3215,292,4);
INSERT INTO INTERPRETE VALUES(119,3216,292,5);
INSERT INTO INTERPRETE VALUES(119,3217,292,6);
INSERT INTO INTERPRETE VALUES(119,3218,292,7);
INSERT INTO INTERPRETE VALUES(119,3219,292,8);
INSERT INTO INTERPRETE VALUES(119,3220,292,9);
INSERT INTO INTERPRETE VALUES(119,3221,292,10);
INSERT INTO INTERPRETE VALUES(119,3222,292,11);
INSERT INTO INTERPRETE VALUES(127,3235,294,1);
INSERT INTO INTERPRETE VALUES(127,3236,294,2);
INSERT INTO INTERPRETE VALUES(127,3237,294,3);
INSERT INTO INTERPRETE VALUES(127,3238,294,4);
INSERT INTO INTERPRETE VALUES(127,3239,294,5);
INSERT INTO INTERPRETE VALUES(52,3229,293,7);
INSERT INTO INTERPRETE VALUES(52,3227,293,5);
INSERT INTO INTERPRETE VALUES(52,3233,293,11);
INSERT INTO INTERPRETE VALUES(44,3204,291,5);
INSERT INTO INTERPRETE VALUES(52,3230,293,8);
INSERT INTO INTERPRETE VALUES(52,3228,293,6);
INSERT INTO INTERPRETE VALUES(52,3231,293,9);
INSERT INTO INTERPRETE VALUES(127,3240,294,6);
INSERT INTO INTERPRETE VALUES(127,3243,294,9);
INSERT INTO INTERPRETE VALUES(127,3245,294,11);
INSERT INTO INTERPRETE VALUES(121,3246,295,1);
INSERT INTO INTERPRETE VALUES(121,3247,295,2);
INSERT INTO INTERPRETE VALUES(121,3248,295,3);
INSERT INTO INTERPRETE VALUES(121,3249,295,4);
INSERT INTO INTERPRETE VALUES(121,3250,295,5);
INSERT INTO INTERPRETE VALUES(121,3251,295,6);
INSERT INTO INTERPRETE VALUES(121,3252,295,7);
INSERT INTO INTERPRETE VALUES(121,3253,295,8);
INSERT INTO INTERPRETE VALUES(121,3254,295,9);
INSERT INTO INTERPRETE VALUES(121,3255,295,10);
INSERT INTO INTERPRETE VALUES(121,3256,295,11);
INSERT INTO INTERPRETE VALUES(121,3257,295,12);
INSERT INTO INTERPRETE VALUES(128,3258,296,1);
INSERT INTO INTERPRETE VALUES(128,3259,296,2);
INSERT INTO INTERPRETE VALUES(128,3260,296,3);
INSERT INTO INTERPRETE VALUES(128,3261,296,4);
INSERT INTO INTERPRETE VALUES(128,3262,296,5);
INSERT INTO INTERPRETE VALUES(128,3263,296,6);
INSERT INTO INTERPRETE VALUES(128,3264,296,7);
INSERT INTO INTERPRETE VALUES(128,3265,296,8);
INSERT INTO INTERPRETE VALUES(128,3266,296,9);
INSERT INTO INTERPRETE VALUES(128,3267,296,10);
INSERT INTO INTERPRETE VALUES(128,3268,296,11);
INSERT INTO INTERPRETE VALUES(128,3269,296,12);
INSERT INTO INTERPRETE VALUES(128,3272,297,1);
INSERT INTO INTERPRETE VALUES(128,3273,297,2);
INSERT INTO INTERPRETE VALUES(128,3274,297,3);
INSERT INTO INTERPRETE VALUES(128,3275,297,4);
INSERT INTO INTERPRETE VALUES(128,3276,297,5);
INSERT INTO INTERPRETE VALUES(128,3277,297,6);
INSERT INTO INTERPRETE VALUES(128,3278,297,7);
INSERT INTO INTERPRETE VALUES(128,3279,297,8);
INSERT INTO INTERPRETE VALUES(128,3280,297,9);
INSERT INTO INTERPRETE VALUES(128,3281,297,10);
INSERT INTO INTERPRETE VALUES(128,3282,297,11);
INSERT INTO INTERPRETE VALUES(128,3283,297,12);
INSERT INTO INTERPRETE VALUES(128,3284,297,13);
INSERT INTO INTERPRETE VALUES(101,3286,298,1);
INSERT INTO INTERPRETE VALUES(101,3287,298,2);
INSERT INTO INTERPRETE VALUES(101,3288,298,3);
INSERT INTO INTERPRETE VALUES(101,3289,298,4);
INSERT INTO INTERPRETE VALUES(101,3290,298,5);
INSERT INTO INTERPRETE VALUES(101,3291,298,6);
INSERT INTO INTERPRETE VALUES(101,3292,298,7);
INSERT INTO INTERPRETE VALUES(101,3293,298,8);
INSERT INTO INTERPRETE VALUES(101,3294,298,9);
INSERT INTO INTERPRETE VALUES(101,3296,298,11);
INSERT INTO INTERPRETE VALUES(101,3297,298,12);
INSERT INTO INTERPRETE VALUES(57,3298,299,1);
INSERT INTO INTERPRETE VALUES(57,3299,299,2);
INSERT INTO INTERPRETE VALUES(57,3300,299,3);
INSERT INTO INTERPRETE VALUES(57,3301,299,4);
INSERT INTO INTERPRETE VALUES(57,3302,299,5);
INSERT INTO INTERPRETE VALUES(57,3304,299,7);
INSERT INTO INTERPRETE VALUES(57,3305,299,8);
INSERT INTO INTERPRETE VALUES(57,3306,299,9);
INSERT INTO INTERPRETE VALUES(57,3307,299,10);
INSERT INTO INTERPRETE VALUES(57,3308,299,11);
INSERT INTO INTERPRETE VALUES(57,3309,299,12);
INSERT INTO INTERPRETE VALUES(129,3310,300,1);
INSERT INTO INTERPRETE VALUES(129,3312,300,3);
INSERT INTO INTERPRETE VALUES(129,3313,300,4);
INSERT INTO INTERPRETE VALUES(129,3314,300,5);
INSERT INTO INTERPRETE VALUES(129,3315,300,6);
INSERT INTO INTERPRETE VALUES(129,3316,300,7);
INSERT INTO INTERPRETE VALUES(129,3317,300,8);
INSERT INTO INTERPRETE VALUES(129,3318,300,9);
INSERT INTO INTERPRETE VALUES(129,3319,300,10);
INSERT INTO INTERPRETE VALUES(129,3320,300,11);
INSERT INTO INTERPRETE VALUES(129,3321,300,12);
INSERT INTO INTERPRETE VALUES(129,3322,300,13);
INSERT INTO INTERPRETE VALUES(130,3324,301,1);
INSERT INTO INTERPRETE VALUES(130,3325,301,2);
INSERT INTO INTERPRETE VALUES(130,3326,301,3);
INSERT INTO INTERPRETE VALUES(130,3327,301,4);
INSERT INTO INTERPRETE VALUES(130,3328,301,5);
INSERT INTO INTERPRETE VALUES(130,3329,301,6);
INSERT INTO INTERPRETE VALUES(130,3330,301,7);
INSERT INTO INTERPRETE VALUES(130,3331,301,8);
INSERT INTO INTERPRETE VALUES(130,3332,301,9);
INSERT INTO INTERPRETE VALUES(130,3333,301,10);
INSERT INTO INTERPRETE VALUES(130,3334,301,11);
INSERT INTO INTERPRETE VALUES(130,3335,301,12);
INSERT INTO INTERPRETE VALUES(44,3338,302,3);
INSERT INTO INTERPRETE VALUES(44,3339,302,4);
INSERT INTO INTERPRETE VALUES(50,3349,303,1);
INSERT INTO INTERPRETE VALUES(50,3350,303,2);
INSERT INTO INTERPRETE VALUES(50,3351,303,3);
INSERT INTO INTERPRETE VALUES(50,3352,303,4);
INSERT INTO INTERPRETE VALUES(50,3353,303,5);
INSERT INTO INTERPRETE VALUES(50,3354,303,6);
INSERT INTO INTERPRETE VALUES(50,3355,303,7);
INSERT INTO INTERPRETE VALUES(50,3357,303,9);
INSERT INTO INTERPRETE VALUES(50,3358,303,10);
INSERT INTO INTERPRETE VALUES(50,3359,303,11);
INSERT INTO INTERPRETE VALUES(50,3360,303,12);
INSERT INTO INTERPRETE VALUES(50,3361,303,13);
INSERT INTO INTERPRETE VALUES(57,3362,304,1);
INSERT INTO INTERPRETE VALUES(57,3363,304,2);
INSERT INTO INTERPRETE VALUES(57,3364,304,3);
INSERT INTO INTERPRETE VALUES(57,3365,304,4);
INSERT INTO INTERPRETE VALUES(57,3366,304,5);
INSERT INTO INTERPRETE VALUES(44,3342,302,7);
INSERT INTO INTERPRETE VALUES(57,3367,304,6);
INSERT INTO INTERPRETE VALUES(57,3368,304,7);
INSERT INTO INTERPRETE VALUES(57,3369,304,8);
INSERT INTO INTERPRETE VALUES(44,3340,302,5);
INSERT INTO INTERPRETE VALUES(57,3370,304,9);
INSERT INTO INTERPRETE VALUES(131,3395,306,9);
INSERT INTO INTERPRETE VALUES(131,3396,306,10);
INSERT INTO INTERPRETE VALUES(131,3397,306,11);
INSERT INTO INTERPRETE VALUES(131,3398,306,12);
INSERT INTO INTERPRETE VALUES(66,3399,307,1);
INSERT INTO INTERPRETE VALUES(66,3400,307,2);
INSERT INTO INTERPRETE VALUES(66,3401,307,3);
INSERT INTO INTERPRETE VALUES(66,3402,307,4);
INSERT INTO INTERPRETE VALUES(66,3405,307,7);
INSERT INTO INTERPRETE VALUES(66,3406,307,8);
INSERT INTO INTERPRETE VALUES(66,3408,307,10);
INSERT INTO INTERPRETE VALUES(66,3409,307,11);
INSERT INTO INTERPRETE VALUES(66,3410,307,12);
INSERT INTO INTERPRETE VALUES(132,3411,308,1);
INSERT INTO INTERPRETE VALUES(132,3412,308,2);
INSERT INTO INTERPRETE VALUES(132,3413,308,3);
INSERT INTO INTERPRETE VALUES(132,3414,308,4);
INSERT INTO INTERPRETE VALUES(52,3378,305,4);
INSERT INTO INTERPRETE VALUES(66,3407,307,9);
INSERT INTO INTERPRETE VALUES(132,3415,308,5);
INSERT INTO INTERPRETE VALUES(132,3416,308,6);
INSERT INTO INTERPRETE VALUES(132,3417,308,7);
INSERT INTO INTERPRETE VALUES(132,3419,308,9);
INSERT INTO INTERPRETE VALUES(132,3420,308,10);
INSERT INTO INTERPRETE VALUES(132,3421,308,11);
INSERT INTO INTERPRETE VALUES(132,3422,308,12);
INSERT INTO INTERPRETE VALUES(132,3423,308,13);
INSERT INTO INTERPRETE VALUES(133,3424,309,1);
INSERT INTO INTERPRETE VALUES(133,3425,309,2);
INSERT INTO INTERPRETE VALUES(133,3426,309,3);
INSERT INTO INTERPRETE VALUES(133,3427,309,4);
INSERT INTO INTERPRETE VALUES(133,3428,309,5);
INSERT INTO INTERPRETE VALUES(133,3429,309,6);
INSERT INTO INTERPRETE VALUES(133,3430,309,7);
INSERT INTO INTERPRETE VALUES(133,3431,309,8);
INSERT INTO INTERPRETE VALUES(133,3432,309,9);
INSERT INTO INTERPRETE VALUES(133,3433,309,10);
INSERT INTO INTERPRETE VALUES(133,3434,309,11);
INSERT INTO INTERPRETE VALUES(133,3435,309,12);
INSERT INTO INTERPRETE VALUES(133,3436,309,13);
INSERT INTO INTERPRETE VALUES(70,3437,310,1);
INSERT INTO INTERPRETE VALUES(70,3438,310,2);
INSERT INTO INTERPRETE VALUES(70,3439,310,3);
INSERT INTO INTERPRETE VALUES(56,3452,311,4);
INSERT INTO INTERPRETE VALUES(56,3457,311,9);
INSERT INTO INTERPRETE VALUES(56,3458,311,10);
INSERT INTO INTERPRETE VALUES(56,3459,311,11);
INSERT INTO INTERPRETE VALUES(56,3460,311,12);
INSERT INTO INTERPRETE VALUES(56,3461,311,13);
INSERT INTO INTERPRETE VALUES(56,3462,311,14);
INSERT INTO INTERPRETE VALUES(134,3463,312,1);
INSERT INTO INTERPRETE VALUES(134,3464,312,2);
INSERT INTO INTERPRETE VALUES(134,3465,312,3);
INSERT INTO INTERPRETE VALUES(134,3466,312,4);
INSERT INTO INTERPRETE VALUES(134,3467,312,5);
INSERT INTO INTERPRETE VALUES(134,3468,312,6);
INSERT INTO INTERPRETE VALUES(134,3469,312,7);
INSERT INTO INTERPRETE VALUES(134,3470,312,8);
INSERT INTO INTERPRETE VALUES(134,3471,312,9);
INSERT INTO INTERPRETE VALUES(134,3472,312,10);
INSERT INTO INTERPRETE VALUES(134,3473,312,11);
INSERT INTO INTERPRETE VALUES(134,3474,312,12);
INSERT INTO INTERPRETE VALUES(57,3475,313,1);
INSERT INTO INTERPRETE VALUES(57,3476,313,2);
INSERT INTO INTERPRETE VALUES(57,3477,313,3);
INSERT INTO INTERPRETE VALUES(57,3478,313,4);
INSERT INTO INTERPRETE VALUES(57,3480,313,6);
INSERT INTO INTERPRETE VALUES(57,3481,313,7);
INSERT INTO INTERPRETE VALUES(57,3482,313,8);
INSERT INTO INTERPRETE VALUES(57,3483,313,9);
INSERT INTO INTERPRETE VALUES(57,3484,313,10);
INSERT INTO INTERPRETE VALUES(57,3485,313,11);
INSERT INTO INTERPRETE VALUES(57,3486,313,12);
INSERT INTO INTERPRETE VALUES(61,3487,314,1);
INSERT INTO INTERPRETE VALUES(61,3488,314,2);
INSERT INTO INTERPRETE VALUES(61,3489,314,3);
INSERT INTO INTERPRETE VALUES(61,3490,314,4);
INSERT INTO INTERPRETE VALUES(61,5372,314,5);
INSERT INTO INTERPRETE VALUES(61,3492,314,6);
INSERT INTO INTERPRETE VALUES(61,3493,314,7);
INSERT INTO INTERPRETE VALUES(61,3494,314,8);
INSERT INTO INTERPRETE VALUES(61,3495,314,9);
INSERT INTO INTERPRETE VALUES(61,3496,314,10);
INSERT INTO INTERPRETE VALUES(61,3497,314,11);
INSERT INTO INTERPRETE VALUES(61,3498,314,12);
INSERT INTO INTERPRETE VALUES(78,3499,315,1);
INSERT INTO INTERPRETE VALUES(78,3502,315,4);
INSERT INTO INTERPRETE VALUES(78,3503,315,5);
INSERT INTO INTERPRETE VALUES(78,3504,315,6);
INSERT INTO INTERPRETE VALUES(78,3505,315,7);
INSERT INTO INTERPRETE VALUES(78,3506,315,8);
INSERT INTO INTERPRETE VALUES(78,3507,315,9);
INSERT INTO INTERPRETE VALUES(78,3508,315,10);
INSERT INTO INTERPRETE VALUES(78,3509,315,11);
INSERT INTO INTERPRETE VALUES(78,3510,315,12);
INSERT INTO INTERPRETE VALUES(78,2654,315,13);
INSERT INTO INTERPRETE VALUES(68,3513,316,1);
INSERT INTO INTERPRETE VALUES(68,3514,316,2);
INSERT INTO INTERPRETE VALUES(68,1457,316,3);
INSERT INTO INTERPRETE VALUES(68,1459,316,4);
INSERT INTO INTERPRETE VALUES(68,3517,316,5);
INSERT INTO INTERPRETE VALUES(68,3518,316,6);
INSERT INTO INTERPRETE VALUES(68,3519,316,7);
INSERT INTO INTERPRETE VALUES(68,3520,316,8);
INSERT INTO INTERPRETE VALUES(68,3521,316,9);
INSERT INTO INTERPRETE VALUES(68,3522,316,10);
INSERT INTO INTERPRETE VALUES(68,3523,316,11);
INSERT INTO INTERPRETE VALUES(68,3524,316,12);
INSERT INTO INTERPRETE VALUES(68,3525,316,13);
INSERT INTO INTERPRETE VALUES(68,3526,316,14);
INSERT INTO INTERPRETE VALUES(135,3527,317,1);
INSERT INTO INTERPRETE VALUES(135,3528,317,2);
INSERT INTO INTERPRETE VALUES(135,3529,317,3);
INSERT INTO INTERPRETE VALUES(135,3530,317,4);
INSERT INTO INTERPRETE VALUES(135,3531,317,5);
INSERT INTO INTERPRETE VALUES(135,3532,317,6);
INSERT INTO INTERPRETE VALUES(135,3533,317,7);
INSERT INTO INTERPRETE VALUES(135,1517,317,8);
INSERT INTO INTERPRETE VALUES(135,3535,317,9);
INSERT INTO INTERPRETE VALUES(135,3536,317,10);
INSERT INTO INTERPRETE VALUES(135,3538,317,12);
INSERT INTO INTERPRETE VALUES(135,3539,317,13);
INSERT INTO INTERPRETE VALUES(135,3540,317,14);
INSERT INTO INTERPRETE VALUES(52,3549,318,9);
INSERT INTO INTERPRETE VALUES(80,3554,319,1);
INSERT INTO INTERPRETE VALUES(52,3553,318,13);
INSERT INTO INTERPRETE VALUES(80,3555,319,2);
INSERT INTO INTERPRETE VALUES(80,3556,319,3);
INSERT INTO INTERPRETE VALUES(80,3557,319,4);
INSERT INTO INTERPRETE VALUES(80,3558,319,5);
INSERT INTO INTERPRETE VALUES(80,3559,319,6);
INSERT INTO INTERPRETE VALUES(80,3560,319,7);
INSERT INTO INTERPRETE VALUES(80,3561,319,8);
INSERT INTO INTERPRETE VALUES(80,3562,319,9);
INSERT INTO INTERPRETE VALUES(80,3563,319,10);
INSERT INTO INTERPRETE VALUES(80,3564,319,11);
INSERT INTO INTERPRETE VALUES(80,3565,319,12);
INSERT INTO INTERPRETE VALUES(80,3566,319,13);
INSERT INTO INTERPRETE VALUES(80,3567,319,14);
INSERT INTO INTERPRETE VALUES(56,3568,320,1);
INSERT INTO INTERPRETE VALUES(56,3569,320,2);
INSERT INTO INTERPRETE VALUES(56,3570,320,3);
INSERT INTO INTERPRETE VALUES(56,3571,320,4);
INSERT INTO INTERPRETE VALUES(56,3572,320,5);
INSERT INTO INTERPRETE VALUES(56,3573,320,6);
INSERT INTO INTERPRETE VALUES(56,3574,320,7);
INSERT INTO INTERPRETE VALUES(56,3576,320,9);
INSERT INTO INTERPRETE VALUES(56,3577,320,10);
INSERT INTO INTERPRETE VALUES(56,3578,320,11);
INSERT INTO INTERPRETE VALUES(56,3579,320,12);
INSERT INTO INTERPRETE VALUES(56,3580,320,13);
INSERT INTO INTERPRETE VALUES(121,3582,321,1);
INSERT INTO INTERPRETE VALUES(121,3583,321,2);
INSERT INTO INTERPRETE VALUES(121,3584,321,3);
INSERT INTO INTERPRETE VALUES(121,3585,321,4);
INSERT INTO INTERPRETE VALUES(121,3586,321,5);
INSERT INTO INTERPRETE VALUES(121,3587,321,6);
INSERT INTO INTERPRETE VALUES(121,3588,321,7);
INSERT INTO INTERPRETE VALUES(121,3589,321,8);
INSERT INTO INTERPRETE VALUES(121,3590,321,9);
INSERT INTO INTERPRETE VALUES(121,3591,321,10);
INSERT INTO INTERPRETE VALUES(121,3592,321,11);
INSERT INTO INTERPRETE VALUES(121,3593,321,12);
INSERT INTO INTERPRETE VALUES(135,3594,322,1);
INSERT INTO INTERPRETE VALUES(135,3595,322,2);
INSERT INTO INTERPRETE VALUES(135,3596,322,3);
INSERT INTO INTERPRETE VALUES(135,3597,322,4);
INSERT INTO INTERPRETE VALUES(135,3598,322,5);
INSERT INTO INTERPRETE VALUES(135,3599,322,6);
INSERT INTO INTERPRETE VALUES(135,3600,322,7);
INSERT INTO INTERPRETE VALUES(135,3601,322,8);
INSERT INTO INTERPRETE VALUES(135,3602,322,9);
INSERT INTO INTERPRETE VALUES(135,3603,322,10);
INSERT INTO INTERPRETE VALUES(135,3604,322,11);
INSERT INTO INTERPRETE VALUES(135,3605,322,12);
INSERT INTO INTERPRETE VALUES(135,3606,322,13);
INSERT INTO INTERPRETE VALUES(97,3607,323,1);
INSERT INTO INTERPRETE VALUES(97,3608,323,2);
INSERT INTO INTERPRETE VALUES(97,3609,323,3);
INSERT INTO INTERPRETE VALUES(97,3610,323,4);
INSERT INTO INTERPRETE VALUES(97,3611,323,5);
INSERT INTO INTERPRETE VALUES(97,3612,323,6);
INSERT INTO INTERPRETE VALUES(97,3613,323,7);
INSERT INTO INTERPRETE VALUES(97,3614,323,8);
INSERT INTO INTERPRETE VALUES(97,3615,323,9);
INSERT INTO INTERPRETE VALUES(97,3616,323,10);
INSERT INTO INTERPRETE VALUES(97,3617,323,11);
INSERT INTO INTERPRETE VALUES(97,3618,323,12);
INSERT INTO INTERPRETE VALUES(97,3619,323,13);
INSERT INTO INTERPRETE VALUES(52,3621,324,2);
INSERT INTO INTERPRETE VALUES(52,3622,324,3);
INSERT INTO INTERPRETE VALUES(49,1142,325,8);
INSERT INTO INTERPRETE VALUES(49,3642,325,9);
INSERT INTO INTERPRETE VALUES(49,3643,325,10);
INSERT INTO INTERPRETE VALUES(49,3644,325,11);
INSERT INTO INTERPRETE VALUES(49,3645,325,12);
INSERT INTO INTERPRETE VALUES(49,3646,325,13);
INSERT INTO INTERPRETE VALUES(43,3647,326,1);
INSERT INTO INTERPRETE VALUES(43,3648,326,2);
INSERT INTO INTERPRETE VALUES(43,3649,326,3);
INSERT INTO INTERPRETE VALUES(43,3650,326,4);
INSERT INTO INTERPRETE VALUES(43,3651,326,5);
INSERT INTO INTERPRETE VALUES(43,3652,326,6);
INSERT INTO INTERPRETE VALUES(43,3653,326,7);
INSERT INTO INTERPRETE VALUES(43,3654,326,8);
INSERT INTO INTERPRETE VALUES(43,3655,326,9);
INSERT INTO INTERPRETE VALUES(43,3656,326,10);
INSERT INTO INTERPRETE VALUES(43,3657,326,11);
INSERT INTO INTERPRETE VALUES(43,3658,326,12);
INSERT INTO INTERPRETE VALUES(43,3659,326,13);
INSERT INTO INTERPRETE VALUES(89,3660,327,1);
INSERT INTO INTERPRETE VALUES(89,3661,327,2);
INSERT INTO INTERPRETE VALUES(89,3662,327,3);
INSERT INTO INTERPRETE VALUES(89,3663,327,4);
INSERT INTO INTERPRETE VALUES(89,3664,327,5);
INSERT INTO INTERPRETE VALUES(89,3665,327,6);
INSERT INTO INTERPRETE VALUES(89,3666,327,7);
INSERT INTO INTERPRETE VALUES(89,3667,327,8);
INSERT INTO INTERPRETE VALUES(89,3668,327,9);
INSERT INTO INTERPRETE VALUES(89,3669,327,10);
INSERT INTO INTERPRETE VALUES(89,3670,327,11);
INSERT INTO INTERPRETE VALUES(89,3671,327,12);
INSERT INTO INTERPRETE VALUES(89,3672,327,13);
INSERT INTO INTERPRETE VALUES(89,3673,327,14);
INSERT INTO INTERPRETE VALUES(106,3674,328,1);
INSERT INTO INTERPRETE VALUES(106,3675,328,2);
INSERT INTO INTERPRETE VALUES(106,3676,328,3);
INSERT INTO INTERPRETE VALUES(106,3678,328,5);
INSERT INTO INTERPRETE VALUES(106,3679,328,6);
INSERT INTO INTERPRETE VALUES(106,2506,328,8);
INSERT INTO INTERPRETE VALUES(106,3682,328,9);
INSERT INTO INTERPRETE VALUES(106,3683,328,10);
INSERT INTO INTERPRETE VALUES(106,2505,328,11);
INSERT INTO INTERPRETE VALUES(106,2512,328,12);
INSERT INTO INTERPRETE VALUES(123,3686,329,1);
INSERT INTO INTERPRETE VALUES(123,3687,329,2);
INSERT INTO INTERPRETE VALUES(123,3688,329,3);
INSERT INTO INTERPRETE VALUES(123,3689,329,4);
INSERT INTO INTERPRETE VALUES(123,3690,329,5);
INSERT INTO INTERPRETE VALUES(123,3691,329,6);
INSERT INTO INTERPRETE VALUES(123,3692,329,7);
INSERT INTO INTERPRETE VALUES(123,3693,329,8);
INSERT INTO INTERPRETE VALUES(123,3694,329,9);
INSERT INTO INTERPRETE VALUES(123,3695,329,10);
INSERT INTO INTERPRETE VALUES(123,3696,329,11);
INSERT INTO INTERPRETE VALUES(123,3697,329,12);
INSERT INTO INTERPRETE VALUES(123,3698,329,13);
INSERT INTO INTERPRETE VALUES(123,3699,329,14);
INSERT INTO INTERPRETE VALUES(123,3700,329,15);
INSERT INTO INTERPRETE VALUES(52,3706,330,6);
INSERT INTO INTERPRETE VALUES(52,3708,330,8);
INSERT INTO INTERPRETE VALUES(52,3705,330,5);
INSERT INTO INTERPRETE VALUES(52,3711,330,11);
INSERT INTO INTERPRETE VALUES(61,3714,331,1);
INSERT INTO INTERPRETE VALUES(61,3715,331,2);
INSERT INTO INTERPRETE VALUES(61,3716,331,3);
INSERT INTO INTERPRETE VALUES(61,3717,331,4);
INSERT INTO INTERPRETE VALUES(61,3718,331,5);
INSERT INTO INTERPRETE VALUES(61,3719,331,6);
INSERT INTO INTERPRETE VALUES(61,3720,331,7);
INSERT INTO INTERPRETE VALUES(61,3721,331,8);
INSERT INTO INTERPRETE VALUES(61,3722,331,9);
INSERT INTO INTERPRETE VALUES(61,3723,331,10);
INSERT INTO INTERPRETE VALUES(61,3724,331,11);
INSERT INTO INTERPRETE VALUES(61,3725,331,12);
INSERT INTO INTERPRETE VALUES(61,3726,331,13);
INSERT INTO INTERPRETE VALUES(61,3727,331,14);
INSERT INTO INTERPRETE VALUES(49,3728,332,1);
INSERT INTO INTERPRETE VALUES(49,3729,332,2);
INSERT INTO INTERPRETE VALUES(49,3730,332,3);
INSERT INTO INTERPRETE VALUES(49,3731,332,4);
INSERT INTO INTERPRETE VALUES(49,3732,332,5);
INSERT INTO INTERPRETE VALUES(49,2278,332,6);
INSERT INTO INTERPRETE VALUES(49,3734,332,7);
INSERT INTO INTERPRETE VALUES(49,3735,332,8);
INSERT INTO INTERPRETE VALUES(49,3736,332,9);
INSERT INTO INTERPRETE VALUES(49,3737,332,10);
INSERT INTO INTERPRETE VALUES(49,3738,332,11);
INSERT INTO INTERPRETE VALUES(49,3739,332,12);
INSERT INTO INTERPRETE VALUES(49,3740,332,13);
INSERT INTO INTERPRETE VALUES(49,3741,332,14);
INSERT INTO INTERPRETE VALUES(49,3742,332,15);
INSERT INTO INTERPRETE VALUES(80,3743,333,1);
INSERT INTO INTERPRETE VALUES(80,3745,333,3);
INSERT INTO INTERPRETE VALUES(80,3746,333,4);
INSERT INTO INTERPRETE VALUES(80,3747,333,5);
INSERT INTO INTERPRETE VALUES(80,3748,333,6);
INSERT INTO INTERPRETE VALUES(136,3756,334,2);
INSERT INTO INTERPRETE VALUES(136,3757,334,3);
INSERT INTO INTERPRETE VALUES(136,3758,334,4);
INSERT INTO INTERPRETE VALUES(136,3759,334,5);
INSERT INTO INTERPRETE VALUES(80,3744,333,2);
INSERT INTO INTERPRETE VALUES(136,3760,334,6);
INSERT INTO INTERPRETE VALUES(136,3761,334,7);
INSERT INTO INTERPRETE VALUES(136,3762,334,8);
INSERT INTO INTERPRETE VALUES(136,3763,334,9);
INSERT INTO INTERPRETE VALUES(136,3764,334,10);
INSERT INTO INTERPRETE VALUES(136,3765,334,11);
INSERT INTO INTERPRETE VALUES(136,3766,334,12);
INSERT INTO INTERPRETE VALUES(89,3767,335,1);
INSERT INTO INTERPRETE VALUES(89,3768,335,2);
INSERT INTO INTERPRETE VALUES(89,3769,335,3);
INSERT INTO INTERPRETE VALUES(89,3770,335,4);
INSERT INTO INTERPRETE VALUES(89,3771,335,5);
INSERT INTO INTERPRETE VALUES(89,3772,335,6);
INSERT INTO INTERPRETE VALUES(89,3773,335,7);
INSERT INTO INTERPRETE VALUES(89,3774,335,8);
INSERT INTO INTERPRETE VALUES(89,3775,335,9);
INSERT INTO INTERPRETE VALUES(89,3776,335,10);
INSERT INTO INTERPRETE VALUES(89,3777,335,11);
INSERT INTO INTERPRETE VALUES(89,3778,335,12);
INSERT INTO INTERPRETE VALUES(89,3779,335,13);
INSERT INTO INTERPRETE VALUES(89,3780,335,14);
INSERT INTO INTERPRETE VALUES(52,3782,336,2);
INSERT INTO INTERPRETE VALUES(137,3794,337,1);
INSERT INTO INTERPRETE VALUES(137,3795,337,2);
INSERT INTO INTERPRETE VALUES(137,3796,337,3);
INSERT INTO INTERPRETE VALUES(52,3783,336,3);
INSERT INTO INTERPRETE VALUES(137,3797,337,4);
INSERT INTO INTERPRETE VALUES(137,3798,337,5);
INSERT INTO INTERPRETE VALUES(137,3799,337,6);
INSERT INTO INTERPRETE VALUES(137,3800,337,7);
INSERT INTO INTERPRETE VALUES(137,3801,337,8);
INSERT INTO INTERPRETE VALUES(137,3802,337,9);
INSERT INTO INTERPRETE VALUES(137,3803,337,10);
INSERT INTO INTERPRETE VALUES(137,3804,337,11);
INSERT INTO INTERPRETE VALUES(137,3805,337,12);
INSERT INTO INTERPRETE VALUES(137,3806,337,13);
INSERT INTO INTERPRETE VALUES(138,3807,338,1);
INSERT INTO INTERPRETE VALUES(138,3808,338,2);
INSERT INTO INTERPRETE VALUES(138,3809,338,3);
INSERT INTO INTERPRETE VALUES(138,3810,338,4);
INSERT INTO INTERPRETE VALUES(138,3811,338,5);
INSERT INTO INTERPRETE VALUES(138,3812,338,6);
INSERT INTO INTERPRETE VALUES(138,3813,338,7);
INSERT INTO INTERPRETE VALUES(138,3814,338,8);
INSERT INTO INTERPRETE VALUES(138,3815,338,9);
INSERT INTO INTERPRETE VALUES(138,3816,338,10);
INSERT INTO INTERPRETE VALUES(138,3817,338,11);
INSERT INTO INTERPRETE VALUES(138,3818,338,12);
INSERT INTO INTERPRETE VALUES(138,3819,338,13);
INSERT INTO INTERPRETE VALUES(138,3820,338,14);
INSERT INTO INTERPRETE VALUES(138,3821,338,15);
INSERT INTO INTERPRETE VALUES(132,3822,339,1);
INSERT INTO INTERPRETE VALUES(132,3823,339,2);
INSERT INTO INTERPRETE VALUES(132,3824,339,3);
INSERT INTO INTERPRETE VALUES(132,3825,339,4);
INSERT INTO INTERPRETE VALUES(132,3826,339,5);
INSERT INTO INTERPRETE VALUES(132,3827,339,6);
INSERT INTO INTERPRETE VALUES(132,3828,339,7);
INSERT INTO INTERPRETE VALUES(132,3829,339,8);
INSERT INTO INTERPRETE VALUES(132,3830,339,9);
INSERT INTO INTERPRETE VALUES(132,3831,339,10);
INSERT INTO INTERPRETE VALUES(132,3833,339,12);
INSERT INTO INTERPRETE VALUES(132,3834,339,13);
INSERT INTO INTERPRETE VALUES(135,3835,340,1);
INSERT INTO INTERPRETE VALUES(135,1665,340,2);
INSERT INTO INTERPRETE VALUES(135,3837,340,3);
INSERT INTO INTERPRETE VALUES(135,3838,340,4);
INSERT INTO INTERPRETE VALUES(135,3839,340,5);
INSERT INTO INTERPRETE VALUES(135,3840,340,6);
INSERT INTO INTERPRETE VALUES(135,3841,340,7);
INSERT INTO INTERPRETE VALUES(135,3842,340,8);
INSERT INTO INTERPRETE VALUES(135,3843,340,9);
INSERT INTO INTERPRETE VALUES(135,3844,340,10);
INSERT INTO INTERPRETE VALUES(135,3845,340,11);
INSERT INTO INTERPRETE VALUES(135,3846,340,12);
INSERT INTO INTERPRETE VALUES(135,3847,340,13);
INSERT INTO INTERPRETE VALUES(57,3848,341,1);
INSERT INTO INTERPRETE VALUES(57,3849,341,2);
INSERT INTO INTERPRETE VALUES(57,3851,341,4);
INSERT INTO INTERPRETE VALUES(57,3852,341,5);
INSERT INTO INTERPRETE VALUES(57,3853,341,6);
INSERT INTO INTERPRETE VALUES(57,3854,341,7);
INSERT INTO INTERPRETE VALUES(57,3855,341,8);
INSERT INTO INTERPRETE VALUES(57,3856,341,9);
INSERT INTO INTERPRETE VALUES(57,3857,341,10);
INSERT INTO INTERPRETE VALUES(57,3858,341,11);
INSERT INTO INTERPRETE VALUES(57,3859,341,12);
INSERT INTO INTERPRETE VALUES(52,3785,336,5);
INSERT INTO INTERPRETE VALUES(57,3860,341,13);
INSERT INTO INTERPRETE VALUES(57,3861,341,14);
INSERT INTO INTERPRETE VALUES(49,3862,342,1);
INSERT INTO INTERPRETE VALUES(49,3863,342,2);
INSERT INTO INTERPRETE VALUES(49,3864,342,3);
INSERT INTO INTERPRETE VALUES(49,3865,342,4);
INSERT INTO INTERPRETE VALUES(49,3866,342,5);
INSERT INTO INTERPRETE VALUES(49,3867,342,6);
INSERT INTO INTERPRETE VALUES(49,3868,342,7);
INSERT INTO INTERPRETE VALUES(49,3869,342,8);
INSERT INTO INTERPRETE VALUES(49,3870,342,9);
INSERT INTO INTERPRETE VALUES(139,3884,343,10);
INSERT INTO INTERPRETE VALUES(139,3885,343,11);
INSERT INTO INTERPRETE VALUES(139,3886,343,12);
INSERT INTO INTERPRETE VALUES(139,3887,343,13);
INSERT INTO INTERPRETE VALUES(139,3888,343,14);
INSERT INTO INTERPRETE VALUES(139,3889,343,15);
INSERT INTO INTERPRETE VALUES(52,3892,344,3);
INSERT INTO INTERPRETE VALUES(109,2800,345,1);
INSERT INTO INTERPRETE VALUES(109,3903,345,2);
INSERT INTO INTERPRETE VALUES(109,3904,345,3);
INSERT INTO INTERPRETE VALUES(109,2807,345,4);
INSERT INTO INTERPRETE VALUES(109,3906,345,5);
INSERT INTO INTERPRETE VALUES(109,3907,345,6);
INSERT INTO INTERPRETE VALUES(109,3908,345,7);
INSERT INTO INTERPRETE VALUES(109,3909,345,8);
INSERT INTO INTERPRETE VALUES(109,3910,345,9);
INSERT INTO INTERPRETE VALUES(109,3911,345,10);
INSERT INTO INTERPRETE VALUES(140,3912,346,1);
INSERT INTO INTERPRETE VALUES(140,3913,346,2);
INSERT INTO INTERPRETE VALUES(140,3914,346,3);
INSERT INTO INTERPRETE VALUES(52,3901,344,12);
INSERT INTO INTERPRETE VALUES(140,3915,346,4);
INSERT INTO INTERPRETE VALUES(122,3933,347,7);
INSERT INTO INTERPRETE VALUES(122,3934,347,8);
INSERT INTO INTERPRETE VALUES(122,3935,347,9);
INSERT INTO INTERPRETE VALUES(122,3936,347,10);
INSERT INTO INTERPRETE VALUES(122,3937,347,11);
INSERT INTO INTERPRETE VALUES(122,3938,347,12);
INSERT INTO INTERPRETE VALUES(122,3939,347,13);
INSERT INTO INTERPRETE VALUES(122,3940,347,14);
INSERT INTO INTERPRETE VALUES(122,3941,347,15);
INSERT INTO INTERPRETE VALUES(122,3942,347,16);
INSERT INTO INTERPRETE VALUES(141,3944,348,2);
INSERT INTO INTERPRETE VALUES(141,3945,348,3);
INSERT INTO INTERPRETE VALUES(141,3947,348,5);
INSERT INTO INTERPRETE VALUES(141,3948,348,6);
INSERT INTO INTERPRETE VALUES(141,3950,348,8);
INSERT INTO INTERPRETE VALUES(141,3951,348,9);
INSERT INTO INTERPRETE VALUES(141,3952,348,10);
INSERT INTO INTERPRETE VALUES(141,3953,348,11);
INSERT INTO INTERPRETE VALUES(141,3954,348,12);
INSERT INTO INTERPRETE VALUES(141,3955,348,13);
INSERT INTO INTERPRETE VALUES(141,3956,348,14);
INSERT INTO INTERPRETE VALUES(141,3957,348,15);
INSERT INTO INTERPRETE VALUES(44,1559,349,3);
INSERT INTO INTERPRETE VALUES(44,2726,349,13);
INSERT INTO INTERPRETE VALUES(122,3972,350,1);
INSERT INTO INTERPRETE VALUES(122,3973,350,2);
INSERT INTO INTERPRETE VALUES(122,3974,350,3);
INSERT INTO INTERPRETE VALUES(122,3975,350,4);
INSERT INTO INTERPRETE VALUES(122,3976,350,5);
INSERT INTO INTERPRETE VALUES(122,3977,350,6);
INSERT INTO INTERPRETE VALUES(122,3978,350,7);
INSERT INTO INTERPRETE VALUES(122,3979,350,8);
INSERT INTO INTERPRETE VALUES(122,3980,350,9);
INSERT INTO INTERPRETE VALUES(122,3981,350,10);
INSERT INTO INTERPRETE VALUES(122,3982,350,11);
INSERT INTO INTERPRETE VALUES(122,3983,350,12);
INSERT INTO INTERPRETE VALUES(122,3984,350,13);
INSERT INTO INTERPRETE VALUES(122,3985,350,14);
INSERT INTO INTERPRETE VALUES(122,3986,350,15);
INSERT INTO INTERPRETE VALUES(122,3987,350,16);
INSERT INTO INTERPRETE VALUES(142,3988,351,1);
INSERT INTO INTERPRETE VALUES(142,3989,351,2);
INSERT INTO INTERPRETE VALUES(142,3990,351,3);
INSERT INTO INTERPRETE VALUES(142,3991,351,4);
INSERT INTO INTERPRETE VALUES(142,3992,351,5);
INSERT INTO INTERPRETE VALUES(142,3993,351,6);
INSERT INTO INTERPRETE VALUES(142,3994,351,7);
INSERT INTO INTERPRETE VALUES(142,3995,351,8);
INSERT INTO INTERPRETE VALUES(142,3996,351,9);
INSERT INTO INTERPRETE VALUES(142,3997,351,10);
INSERT INTO INTERPRETE VALUES(142,3998,351,11);
INSERT INTO INTERPRETE VALUES(142,3999,351,12);
INSERT INTO INTERPRETE VALUES(142,4000,351,13);
INSERT INTO INTERPRETE VALUES(142,4001,351,14);
INSERT INTO INTERPRETE VALUES(135,4002,352,1);
INSERT INTO INTERPRETE VALUES(135,4003,352,2);
INSERT INTO INTERPRETE VALUES(135,4004,352,3);
INSERT INTO INTERPRETE VALUES(135,4005,352,4);
INSERT INTO INTERPRETE VALUES(135,4006,352,5);
INSERT INTO INTERPRETE VALUES(135,4007,352,6);
INSERT INTO INTERPRETE VALUES(135,4008,352,7);
INSERT INTO INTERPRETE VALUES(135,4009,352,8);
INSERT INTO INTERPRETE VALUES(135,4010,352,9);
INSERT INTO INTERPRETE VALUES(135,4011,352,10);
INSERT INTO INTERPRETE VALUES(135,4012,352,11);
INSERT INTO INTERPRETE VALUES(135,4013,352,12);
INSERT INTO INTERPRETE VALUES(135,4014,352,13);
INSERT INTO INTERPRETE VALUES(135,4015,352,14);
INSERT INTO INTERPRETE VALUES(143,4016,353,1);
INSERT INTO INTERPRETE VALUES(143,4017,353,2);
INSERT INTO INTERPRETE VALUES(143,4018,353,3);
INSERT INTO INTERPRETE VALUES(143,4019,353,4);
INSERT INTO INTERPRETE VALUES(143,4020,353,5);
INSERT INTO INTERPRETE VALUES(143,4021,353,6);
INSERT INTO INTERPRETE VALUES(143,4022,353,7);
INSERT INTO INTERPRETE VALUES(143,4023,353,8);
INSERT INTO INTERPRETE VALUES(143,4024,353,9);
INSERT INTO INTERPRETE VALUES(143,4025,353,10);
INSERT INTO INTERPRETE VALUES(143,4026,353,11);
INSERT INTO INTERPRETE VALUES(143,4027,353,12);
INSERT INTO INTERPRETE VALUES(143,4028,353,13);
INSERT INTO INTERPRETE VALUES(143,4029,353,14);
INSERT INTO INTERPRETE VALUES(52,4032,354,3);
INSERT INTO INTERPRETE VALUES(52,4036,354,7);
INSERT INTO INTERPRETE VALUES(52,4039,354,10);
INSERT INTO INTERPRETE VALUES(44,3958,349,1);
INSERT INTO INTERPRETE VALUES(52,4030,354,1);
INSERT INTO INTERPRETE VALUES(144,4044,355,1);
INSERT INTO INTERPRETE VALUES(144,4045,355,2);
INSERT INTO INTERPRETE VALUES(144,4046,355,3);
INSERT INTO INTERPRETE VALUES(144,4048,355,5);
INSERT INTO INTERPRETE VALUES(144,4049,355,6);
INSERT INTO INTERPRETE VALUES(144,4050,355,7);
INSERT INTO INTERPRETE VALUES(144,4051,355,8);
INSERT INTO INTERPRETE VALUES(144,4052,355,9);
INSERT INTO INTERPRETE VALUES(144,4053,355,10);
INSERT INTO INTERPRETE VALUES(144,4054,355,11);
INSERT INTO INTERPRETE VALUES(144,4055,355,12);
INSERT INTO INTERPRETE VALUES(144,4056,355,13);
INSERT INTO INTERPRETE VALUES(68,4057,356,1);
INSERT INTO INTERPRETE VALUES(68,4058,356,2);
INSERT INTO INTERPRETE VALUES(68,4059,356,3);
INSERT INTO INTERPRETE VALUES(68,4060,356,4);
INSERT INTO INTERPRETE VALUES(68,4061,356,5);
INSERT INTO INTERPRETE VALUES(68,4062,356,6);
INSERT INTO INTERPRETE VALUES(68,4063,356,7);
INSERT INTO INTERPRETE VALUES(68,4064,356,8);
INSERT INTO INTERPRETE VALUES(68,4065,356,9);
INSERT INTO INTERPRETE VALUES(68,4068,356,12);
INSERT INTO INTERPRETE VALUES(68,4069,356,13);
INSERT INTO INTERPRETE VALUES(68,4070,356,14);
INSERT INTO INTERPRETE VALUES(70,4071,357,1);
INSERT INTO INTERPRETE VALUES(70,4072,357,2);
INSERT INTO INTERPRETE VALUES(70,4073,357,3);
INSERT INTO INTERPRETE VALUES(70,296,357,4);
INSERT INTO INTERPRETE VALUES(70,4075,357,5);
INSERT INTO INTERPRETE VALUES(70,4076,357,6);
INSERT INTO INTERPRETE VALUES(70,4077,357,7);
INSERT INTO INTERPRETE VALUES(70,4079,357,9);
INSERT INTO INTERPRETE VALUES(70,4080,357,10);
INSERT INTO INTERPRETE VALUES(70,4081,357,11);
INSERT INTO INTERPRETE VALUES(70,4082,357,12);
INSERT INTO INTERPRETE VALUES(70,4083,357,13);
INSERT INTO INTERPRETE VALUES(70,4084,357,14);
INSERT INTO INTERPRETE VALUES(122,4085,358,1);
INSERT INTO INTERPRETE VALUES(122,4086,358,2);
INSERT INTO INTERPRETE VALUES(122,4087,358,3);
INSERT INTO INTERPRETE VALUES(122,4088,358,4);
INSERT INTO INTERPRETE VALUES(122,4089,358,5);
INSERT INTO INTERPRETE VALUES(122,4090,358,6);
INSERT INTO INTERPRETE VALUES(122,4091,358,7);
INSERT INTO INTERPRETE VALUES(122,4092,358,8);
INSERT INTO INTERPRETE VALUES(122,4093,358,9);
INSERT INTO INTERPRETE VALUES(122,4094,358,10);
INSERT INTO INTERPRETE VALUES(122,4095,358,11);
INSERT INTO INTERPRETE VALUES(122,4096,358,12);
INSERT INTO INTERPRETE VALUES(122,4097,358,13);
INSERT INTO INTERPRETE VALUES(122,4098,358,14);
INSERT INTO INTERPRETE VALUES(122,4099,358,15);
INSERT INTO INTERPRETE VALUES(142,4100,359,1);
INSERT INTO INTERPRETE VALUES(142,4101,359,2);
INSERT INTO INTERPRETE VALUES(142,4102,359,3);
INSERT INTO INTERPRETE VALUES(142,4103,359,4);
INSERT INTO INTERPRETE VALUES(142,4104,359,5);
INSERT INTO INTERPRETE VALUES(142,4105,359,6);
INSERT INTO INTERPRETE VALUES(142,4106,359,7);
INSERT INTO INTERPRETE VALUES(142,4107,359,8);
INSERT INTO INTERPRETE VALUES(142,4108,359,9);
INSERT INTO INTERPRETE VALUES(142,4109,359,10);
INSERT INTO INTERPRETE VALUES(142,4110,359,11);
INSERT INTO INTERPRETE VALUES(142,4111,359,12);
INSERT INTO INTERPRETE VALUES(142,4112,359,13);
INSERT INTO INTERPRETE VALUES(142,4113,359,14);
INSERT INTO INTERPRETE VALUES(142,4114,359,15);
INSERT INTO INTERPRETE VALUES(51,4115,360,1);
INSERT INTO INTERPRETE VALUES(51,4116,360,2);
INSERT INTO INTERPRETE VALUES(51,4117,360,3);
INSERT INTO INTERPRETE VALUES(51,4118,360,4);
INSERT INTO INTERPRETE VALUES(51,4119,360,5);
INSERT INTO INTERPRETE VALUES(51,4120,360,6);
INSERT INTO INTERPRETE VALUES(51,4121,360,7);
INSERT INTO INTERPRETE VALUES(51,4122,360,8);
INSERT INTO INTERPRETE VALUES(51,4123,360,9);
INSERT INTO INTERPRETE VALUES(51,4124,360,10);
INSERT INTO INTERPRETE VALUES(51,4125,360,11);
INSERT INTO INTERPRETE VALUES(51,4126,360,12);
INSERT INTO INTERPRETE VALUES(51,4127,360,13);
INSERT INTO INTERPRETE VALUES(51,4128,360,14);
INSERT INTO INTERPRETE VALUES(51,4129,360,15);
INSERT INTO INTERPRETE VALUES(51,4130,360,16);
INSERT INTO INTERPRETE VALUES(47,4131,361,1);
INSERT INTO INTERPRETE VALUES(47,4132,361,2);
INSERT INTO INTERPRETE VALUES(47,1356,361,3);
INSERT INTO INTERPRETE VALUES(47,4134,361,4);
INSERT INTO INTERPRETE VALUES(47,1344,361,5);
INSERT INTO INTERPRETE VALUES(47,4136,361,6);
INSERT INTO INTERPRETE VALUES(47,1351,361,7);
INSERT INTO INTERPRETE VALUES(47,4138,361,8);
INSERT INTO INTERPRETE VALUES(47,4139,361,9);
INSERT INTO INTERPRETE VALUES(47,1335,361,10);
INSERT INTO INTERPRETE VALUES(47,4141,361,11);
INSERT INTO INTERPRETE VALUES(47,4142,361,12);
INSERT INTO INTERPRETE VALUES(47,4143,361,13);
INSERT INTO INTERPRETE VALUES(47,4144,361,14);
INSERT INTO INTERPRETE VALUES(47,1334,361,15);
INSERT INTO INTERPRETE VALUES(47,4146,361,16);
INSERT INTO INTERPRETE VALUES(52,4149,362,3);
INSERT INTO INTERPRETE VALUES(52,4151,362,5);
INSERT INTO INTERPRETE VALUES(52,4152,362,6);
INSERT INTO INTERPRETE VALUES(52,4159,362,13);
INSERT INTO INTERPRETE VALUES(52,4160,362,14);
INSERT INTO INTERPRETE VALUES(145,4173,363,12);
INSERT INTO INTERPRETE VALUES(145,4174,363,13);
INSERT INTO INTERPRETE VALUES(145,4175,363,14);
INSERT INTO INTERPRETE VALUES(132,4176,364,1);
INSERT INTO INTERPRETE VALUES(132,4177,364,2);
INSERT INTO INTERPRETE VALUES(132,4178,364,3);
INSERT INTO INTERPRETE VALUES(132,4179,364,4);
INSERT INTO INTERPRETE VALUES(132,2042,364,5);
INSERT INTO INTERPRETE VALUES(132,4189,364,14);
INSERT INTO INTERPRETE VALUES(44,4190,365,1);
INSERT INTO INTERPRETE VALUES(44,4206,366,2);
INSERT INTO INTERPRETE VALUES(66,4219,367,1);
INSERT INTO INTERPRETE VALUES(66,4220,367,2);
INSERT INTO INTERPRETE VALUES(66,4221,367,3);
INSERT INTO INTERPRETE VALUES(66,4222,367,4);
INSERT INTO INTERPRETE VALUES(66,4223,367,5);
INSERT INTO INTERPRETE VALUES(66,4224,367,6);
INSERT INTO INTERPRETE VALUES(66,4225,367,7);
INSERT INTO INTERPRETE VALUES(66,4226,367,8);
INSERT INTO INTERPRETE VALUES(66,4227,367,9);
INSERT INTO INTERPRETE VALUES(66,4228,367,10);
INSERT INTO INTERPRETE VALUES(66,4230,367,12);
INSERT INTO INTERPRETE VALUES(66,4231,367,13);
INSERT INTO INTERPRETE VALUES(66,4232,367,14);
INSERT INTO INTERPRETE VALUES(66,4233,367,15);
INSERT INTO INTERPRETE VALUES(66,4234,367,16);
INSERT INTO INTERPRETE VALUES(146,4235,368,1);
INSERT INTO INTERPRETE VALUES(146,4236,368,2);
INSERT INTO INTERPRETE VALUES(146,4237,368,3);
INSERT INTO INTERPRETE VALUES(146,4238,368,4);
INSERT INTO INTERPRETE VALUES(146,4239,368,5);
INSERT INTO INTERPRETE VALUES(146,4240,368,6);
INSERT INTO INTERPRETE VALUES(146,4241,368,7);
INSERT INTO INTERPRETE VALUES(146,4242,368,8);
INSERT INTO INTERPRETE VALUES(146,4243,368,9);
INSERT INTO INTERPRETE VALUES(146,4244,368,10);
INSERT INTO INTERPRETE VALUES(44,4209,366,5);
INSERT INTO INTERPRETE VALUES(44,4211,366,7);
INSERT INTO INTERPRETE VALUES(44,1914,366,3);
INSERT INTO INTERPRETE VALUES(66,4264,370,1);
INSERT INTO INTERPRETE VALUES(66,4265,370,2);
INSERT INTO INTERPRETE VALUES(66,4266,370,3);
INSERT INTO INTERPRETE VALUES(66,4267,370,4);
INSERT INTO INTERPRETE VALUES(66,4268,370,5);
INSERT INTO INTERPRETE VALUES(66,4269,370,6);
INSERT INTO INTERPRETE VALUES(66,4270,370,7);
INSERT INTO INTERPRETE VALUES(66,4271,370,8);
INSERT INTO INTERPRETE VALUES(66,4272,370,9);
INSERT INTO INTERPRETE VALUES(66,4273,370,10);
INSERT INTO INTERPRETE VALUES(66,4274,370,11);
INSERT INTO INTERPRETE VALUES(66,4275,370,12);
INSERT INTO INTERPRETE VALUES(66,4276,370,13);
INSERT INTO INTERPRETE VALUES(67,4277,371,1);
INSERT INTO INTERPRETE VALUES(67,4278,371,2);
INSERT INTO INTERPRETE VALUES(67,4279,371,3);
INSERT INTO INTERPRETE VALUES(67,4280,371,4);
INSERT INTO INTERPRETE VALUES(67,1550,371,5);
INSERT INTO INTERPRETE VALUES(67,1554,371,6);
INSERT INTO INTERPRETE VALUES(67,1556,371,7);
INSERT INTO INTERPRETE VALUES(67,1775,371,8);
INSERT INTO INTERPRETE VALUES(67,1777,371,9);
INSERT INTO INTERPRETE VALUES(67,1778,371,10);
INSERT INTO INTERPRETE VALUES(67,1602,371,12);
INSERT INTO INTERPRETE VALUES(67,1603,371,13);
INSERT INTO INTERPRETE VALUES(118,4295,372,4);
INSERT INTO INTERPRETE VALUES(52,4308,373,3);
INSERT INTO INTERPRETE VALUES(52,4309,373,4);
INSERT INTO INTERPRETE VALUES(52,4312,373,7);
INSERT INTO INTERPRETE VALUES(52,4318,373,13);
INSERT INTO INTERPRETE VALUES(52,162,373,14);
INSERT INTO INTERPRETE VALUES(44,2476,374,1);
INSERT INTO INTERPRETE VALUES(44,2681,374,11);
INSERT INTO INTERPRETE VALUES(44,1560,374,12);
INSERT INTO INTERPRETE VALUES(109,4336,375,3);
INSERT INTO INTERPRETE VALUES(109,4337,375,4);
INSERT INTO INTERPRETE VALUES(109,4338,375,5);
INSERT INTO INTERPRETE VALUES(109,4339,375,6);
INSERT INTO INTERPRETE VALUES(109,3906,375,7);
INSERT INTO INTERPRETE VALUES(109,4341,375,8);
INSERT INTO INTERPRETE VALUES(109,2810,375,9);
INSERT INTO INTERPRETE VALUES(109,4343,375,10);
INSERT INTO INTERPRETE VALUES(109,4344,375,11);
INSERT INTO INTERPRETE VALUES(109,4345,375,12);
INSERT INTO INTERPRETE VALUES(68,4346,376,1);
INSERT INTO INTERPRETE VALUES(68,4347,376,2);
INSERT INTO INTERPRETE VALUES(68,4348,376,3);
INSERT INTO INTERPRETE VALUES(68,4349,376,4);
INSERT INTO INTERPRETE VALUES(68,4350,376,5);
INSERT INTO INTERPRETE VALUES(68,4351,376,6);
INSERT INTO INTERPRETE VALUES(68,4352,376,7);
INSERT INTO INTERPRETE VALUES(68,4353,376,8);
INSERT INTO INTERPRETE VALUES(68,4354,376,9);
INSERT INTO INTERPRETE VALUES(68,4355,376,10);
INSERT INTO INTERPRETE VALUES(68,4356,376,11);
INSERT INTO INTERPRETE VALUES(68,4357,376,12);
INSERT INTO INTERPRETE VALUES(68,4358,376,13);
INSERT INTO INTERPRETE VALUES(68,4359,376,14);
INSERT INTO INTERPRETE VALUES(68,4360,376,15);
INSERT INTO INTERPRETE VALUES(44,4361,377,1);
INSERT INTO INTERPRETE VALUES(44,2909,377,2);
INSERT INTO INTERPRETE VALUES(44,2948,377,3);
INSERT INTO INTERPRETE VALUES(44,1639,377,11);
INSERT INTO INTERPRETE VALUES(44,1549,377,12);
INSERT INTO INTERPRETE VALUES(147,4378,378,1);
INSERT INTO INTERPRETE VALUES(147,4379,378,2);
INSERT INTO INTERPRETE VALUES(147,4380,378,3);
INSERT INTO INTERPRETE VALUES(44,1544,377,10);
INSERT INTO INTERPRETE VALUES(44,4377,377,17);
INSERT INTO INTERPRETE VALUES(147,4381,378,4);
INSERT INTO INTERPRETE VALUES(147,4382,378,5);
INSERT INTO INTERPRETE VALUES(147,4383,378,6);
INSERT INTO INTERPRETE VALUES(147,4384,378,7);
INSERT INTO INTERPRETE VALUES(147,4385,378,8);
INSERT INTO INTERPRETE VALUES(147,4386,378,9);
INSERT INTO INTERPRETE VALUES(147,4387,378,10);
INSERT INTO INTERPRETE VALUES(147,4388,378,11);
INSERT INTO INTERPRETE VALUES(147,4389,378,12);
INSERT INTO INTERPRETE VALUES(147,4390,378,13);
INSERT INTO INTERPRETE VALUES(147,4391,378,14);
INSERT INTO INTERPRETE VALUES(147,4392,378,15);
INSERT INTO INTERPRETE VALUES(140,4393,379,1);
INSERT INTO INTERPRETE VALUES(140,4395,379,3);
INSERT INTO INTERPRETE VALUES(140,4396,379,4);
INSERT INTO INTERPRETE VALUES(140,4397,379,5);
INSERT INTO INTERPRETE VALUES(140,4398,379,6);
INSERT INTO INTERPRETE VALUES(140,4399,379,7);
INSERT INTO INTERPRETE VALUES(140,4400,379,8);
INSERT INTO INTERPRETE VALUES(140,4401,379,9);
INSERT INTO INTERPRETE VALUES(140,4402,379,10);
INSERT INTO INTERPRETE VALUES(140,4403,379,11);
INSERT INTO INTERPRETE VALUES(140,4404,379,12);
INSERT INTO INTERPRETE VALUES(140,4405,379,13);
INSERT INTO INTERPRETE VALUES(140,4406,379,14);
INSERT INTO INTERPRETE VALUES(140,4407,379,15);
INSERT INTO INTERPRETE VALUES(140,4408,379,16);
INSERT INTO INTERPRETE VALUES(140,4409,379,17);
INSERT INTO INTERPRETE VALUES(52,4309,380,2);
INSERT INTO INTERPRETE VALUES(52,1705,380,3);
INSERT INTO INTERPRETE VALUES(52,1703,380,7);
INSERT INTO INTERPRETE VALUES(52,4428,381,4);
INSERT INTO INTERPRETE VALUES(52,4428,381,14);
INSERT INTO INTERPRETE VALUES(109,4439,382,1);
INSERT INTO INTERPRETE VALUES(109,2802,382,2);
INSERT INTO INTERPRETE VALUES(109,2573,382,3);
INSERT INTO INTERPRETE VALUES(109,2572,382,4);
INSERT INTO INTERPRETE VALUES(109,2570,382,5);
INSERT INTO INTERPRETE VALUES(109,4444,382,6);
INSERT INTO INTERPRETE VALUES(109,2571,382,7);
INSERT INTO INTERPRETE VALUES(109,2574,382,8);
INSERT INTO INTERPRETE VALUES(109,2801,382,9);
INSERT INTO INTERPRETE VALUES(52,4426,381,2);
INSERT INTO INTERPRETE VALUES(52,4437,381,13);
INSERT INTO INTERPRETE VALUES(52,4431,381,7);
INSERT INTO INTERPRETE VALUES(52,4433,381,9);
INSERT INTO INTERPRETE VALUES(52,4434,381,10);
INSERT INTO INTERPRETE VALUES(52,4425,381,1);
INSERT INTO INTERPRETE VALUES(128,4456,383,5);
INSERT INTO INTERPRETE VALUES(128,4457,383,6);
INSERT INTO INTERPRETE VALUES(128,4458,383,7);
INSERT INTO INTERPRETE VALUES(128,4459,383,8);
INSERT INTO INTERPRETE VALUES(128,4460,383,9);
INSERT INTO INTERPRETE VALUES(128,4461,383,10);
INSERT INTO INTERPRETE VALUES(128,4462,383,11);
INSERT INTO INTERPRETE VALUES(128,4463,383,12);
INSERT INTO INTERPRETE VALUES(128,4464,383,13);
INSERT INTO INTERPRETE VALUES(128,4465,383,14);
INSERT INTO INTERPRETE VALUES(128,4466,383,15);
INSERT INTO INTERPRETE VALUES(128,4467,383,16);
INSERT INTO INTERPRETE VALUES(135,4468,384,1);
INSERT INTO INTERPRETE VALUES(135,4469,384,2);
INSERT INTO INTERPRETE VALUES(135,4470,384,3);
INSERT INTO INTERPRETE VALUES(135,4471,384,4);
INSERT INTO INTERPRETE VALUES(135,4472,384,5);
INSERT INTO INTERPRETE VALUES(135,4473,384,6);
INSERT INTO INTERPRETE VALUES(135,99,384,7);
INSERT INTO INTERPRETE VALUES(135,4475,384,8);
INSERT INTO INTERPRETE VALUES(135,4476,384,9);
INSERT INTO INTERPRETE VALUES(135,4477,384,10);
INSERT INTO INTERPRETE VALUES(135,4478,384,11);
INSERT INTO INTERPRETE VALUES(135,4479,384,12);
INSERT INTO INTERPRETE VALUES(135,4480,384,13);
INSERT INTO INTERPRETE VALUES(135,4481,384,14);
INSERT INTO INTERPRETE VALUES(135,4482,384,15);
INSERT INTO INTERPRETE VALUES(135,4483,384,16);
INSERT INTO INTERPRETE VALUES(135,4484,384,17);
INSERT INTO INTERPRETE VALUES(52,4497,385,13);
INSERT INTO INTERPRETE VALUES(52,4498,385,14);
INSERT INTO INTERPRETE VALUES(122,4501,386,1);
INSERT INTO INTERPRETE VALUES(122,4502,386,2);
INSERT INTO INTERPRETE VALUES(122,4503,386,3);
INSERT INTO INTERPRETE VALUES(52,4489,385,5);
INSERT INTO INTERPRETE VALUES(122,4504,386,4);
INSERT INTO INTERPRETE VALUES(122,4505,386,5);
INSERT INTO INTERPRETE VALUES(122,4506,386,6);
INSERT INTO INTERPRETE VALUES(122,4507,386,7);
INSERT INTO INTERPRETE VALUES(122,4508,386,8);
INSERT INTO INTERPRETE VALUES(122,4509,386,9);
INSERT INTO INTERPRETE VALUES(122,4510,386,10);
INSERT INTO INTERPRETE VALUES(122,4511,386,11);
INSERT INTO INTERPRETE VALUES(122,4512,386,12);
INSERT INTO INTERPRETE VALUES(122,4513,386,13);
INSERT INTO INTERPRETE VALUES(122,4514,386,14);
INSERT INTO INTERPRETE VALUES(122,4515,386,15);
INSERT INTO INTERPRETE VALUES(122,4516,386,16);
INSERT INTO INTERPRETE VALUES(122,4517,386,17);
INSERT INTO INTERPRETE VALUES(122,4518,386,18);
INSERT INTO INTERPRETE VALUES(61,2431,387,1);
INSERT INTO INTERPRETE VALUES(61,3715,387,2);
INSERT INTO INTERPRETE VALUES(61,1723,387,3);
INSERT INTO INTERPRETE VALUES(61,2434,387,4);
INSERT INTO INTERPRETE VALUES(61,4524,387,6);
INSERT INTO INTERPRETE VALUES(61,4525,387,7);
INSERT INTO INTERPRETE VALUES(61,4526,387,8);
INSERT INTO INTERPRETE VALUES(61,3108,387,9);
INSERT INTO INTERPRETE VALUES(61,3497,387,10);
INSERT INTO INTERPRETE VALUES(61,4529,387,11);
INSERT INTO INTERPRETE VALUES(61,2439,387,12);
INSERT INTO INTERPRETE VALUES(61,4531,387,13);
INSERT INTO INTERPRETE VALUES(61,4532,387,14);
INSERT INTO INTERPRETE VALUES(61,3113,387,16);
INSERT INTO INTERPRETE VALUES(112,4535,388,1);
INSERT INTO INTERPRETE VALUES(112,4536,388,2);
INSERT INTO INTERPRETE VALUES(112,4537,388,3);
INSERT INTO INTERPRETE VALUES(112,4538,388,4);
INSERT INTO INTERPRETE VALUES(112,4539,388,5);
INSERT INTO INTERPRETE VALUES(112,4541,388,7);
INSERT INTO INTERPRETE VALUES(112,4542,388,8);
INSERT INTO INTERPRETE VALUES(112,4543,388,9);
INSERT INTO INTERPRETE VALUES(112,4544,388,10);
INSERT INTO INTERPRETE VALUES(112,4545,388,11);
INSERT INTO INTERPRETE VALUES(112,4546,388,12);
INSERT INTO INTERPRETE VALUES(112,4547,388,13);
INSERT INTO INTERPRETE VALUES(112,4548,388,14);
INSERT INTO INTERPRETE VALUES(112,4539,388,15);
INSERT INTO INTERPRETE VALUES(84,4550,389,1);
INSERT INTO INTERPRETE VALUES(84,4551,389,2);
INSERT INTO INTERPRETE VALUES(84,4552,389,3);
INSERT INTO INTERPRETE VALUES(84,4553,389,4);
INSERT INTO INTERPRETE VALUES(84,4554,389,5);
INSERT INTO INTERPRETE VALUES(84,4555,389,6);
INSERT INTO INTERPRETE VALUES(84,4556,389,7);
INSERT INTO INTERPRETE VALUES(84,4557,389,8);
INSERT INTO INTERPRETE VALUES(84,4558,389,9);
INSERT INTO INTERPRETE VALUES(84,4559,389,10);
INSERT INTO INTERPRETE VALUES(84,4560,389,11);
INSERT INTO INTERPRETE VALUES(84,4561,389,12);
INSERT INTO INTERPRETE VALUES(84,4562,389,13);
INSERT INTO INTERPRETE VALUES(84,4563,389,14);
INSERT INTO INTERPRETE VALUES(84,4564,389,15);
INSERT INTO INTERPRETE VALUES(84,4565,389,16);
INSERT INTO INTERPRETE VALUES(84,4566,389,17);
INSERT INTO INTERPRETE VALUES(52,4149,390,2);
INSERT INTO INTERPRETE VALUES(52,4154,390,17);
INSERT INTO INTERPRETE VALUES(44,4587,391,2);
INSERT INTO INTERPRETE VALUES(44,4589,391,4);
INSERT INTO INTERPRETE VALUES(148,4604,392,1);
INSERT INTO INTERPRETE VALUES(148,4605,392,2);
INSERT INTO INTERPRETE VALUES(148,4606,392,3);
INSERT INTO INTERPRETE VALUES(148,4607,392,4);
INSERT INTO INTERPRETE VALUES(148,4608,392,5);
INSERT INTO INTERPRETE VALUES(148,4609,392,6);
INSERT INTO INTERPRETE VALUES(148,4610,392,7);
INSERT INTO INTERPRETE VALUES(148,4611,392,8);
INSERT INTO INTERPRETE VALUES(148,4612,392,9);
INSERT INTO INTERPRETE VALUES(148,4613,392,10);
INSERT INTO INTERPRETE VALUES(148,4614,392,11);
INSERT INTO INTERPRETE VALUES(148,4615,392,12);
INSERT INTO INTERPRETE VALUES(148,4616,392,13);
INSERT INTO INTERPRETE VALUES(148,4617,392,14);
INSERT INTO INTERPRETE VALUES(148,4618,392,15);
INSERT INTO INTERPRETE VALUES(148,4619,392,16);
INSERT INTO INTERPRETE VALUES(128,3258,393,1);
INSERT INTO INTERPRETE VALUES(128,4621,393,2);
INSERT INTO INTERPRETE VALUES(128,4622,393,3);
INSERT INTO INTERPRETE VALUES(128,4623,393,4);
INSERT INTO INTERPRETE VALUES(128,4624,393,5);
INSERT INTO INTERPRETE VALUES(128,4625,393,6);
INSERT INTO INTERPRETE VALUES(128,4626,393,7);
INSERT INTO INTERPRETE VALUES(44,4599,391,14);
INSERT INTO INTERPRETE VALUES(128,4627,393,8);
INSERT INTO INTERPRETE VALUES(128,4628,393,9);
INSERT INTO INTERPRETE VALUES(128,4629,393,10);
INSERT INTO INTERPRETE VALUES(128,4630,393,11);
INSERT INTO INTERPRETE VALUES(128,4631,393,12);
INSERT INTO INTERPRETE VALUES(128,4632,393,13);
INSERT INTO INTERPRETE VALUES(128,4633,393,14);
INSERT INTO INTERPRETE VALUES(128,4634,393,15);
INSERT INTO INTERPRETE VALUES(128,4635,393,16);
INSERT INTO INTERPRETE VALUES(128,4636,393,17);
INSERT INTO INTERPRETE VALUES(128,4637,393,18);
INSERT INTO INTERPRETE VALUES(70,4638,394,1);
INSERT INTO INTERPRETE VALUES(70,4639,394,2);
INSERT INTO INTERPRETE VALUES(70,4640,394,3);
INSERT INTO INTERPRETE VALUES(70,4641,394,4);
INSERT INTO INTERPRETE VALUES(70,4642,394,5);
INSERT INTO INTERPRETE VALUES(70,4643,394,6);
INSERT INTO INTERPRETE VALUES(70,4644,394,7);
INSERT INTO INTERPRETE VALUES(70,4645,394,8);
INSERT INTO INTERPRETE VALUES(70,4646,394,9);
INSERT INTO INTERPRETE VALUES(70,4647,394,10);
INSERT INTO INTERPRETE VALUES(70,4648,394,11);
INSERT INTO INTERPRETE VALUES(70,4649,394,12);
INSERT INTO INTERPRETE VALUES(70,4650,394,13);
INSERT INTO INTERPRETE VALUES(70,4651,394,14);
INSERT INTO INTERPRETE VALUES(70,4652,394,15);
INSERT INTO INTERPRETE VALUES(70,4653,394,16);
INSERT INTO INTERPRETE VALUES(135,4654,395,1);
INSERT INTO INTERPRETE VALUES(135,4655,395,2);
INSERT INTO INTERPRETE VALUES(135,4656,395,3);
INSERT INTO INTERPRETE VALUES(135,4657,395,4);
INSERT INTO INTERPRETE VALUES(135,4658,395,5);
INSERT INTO INTERPRETE VALUES(135,4659,395,6);
INSERT INTO INTERPRETE VALUES(135,4660,395,7);
INSERT INTO INTERPRETE VALUES(135,4661,395,8);
INSERT INTO INTERPRETE VALUES(135,4662,395,9);
INSERT INTO INTERPRETE VALUES(135,4663,395,10);
INSERT INTO INTERPRETE VALUES(135,4664,395,11);
INSERT INTO INTERPRETE VALUES(135,4665,395,12);
INSERT INTO INTERPRETE VALUES(135,4666,395,13);
INSERT INTO INTERPRETE VALUES(135,4667,395,14);
INSERT INTO INTERPRETE VALUES(135,4668,395,15);
INSERT INTO INTERPRETE VALUES(135,4669,395,16);
INSERT INTO INTERPRETE VALUES(135,4670,395,17);
INSERT INTO INTERPRETE VALUES(52,4673,396,3);
INSERT INTO INTERPRETE VALUES(52,4677,396,7);
INSERT INTO INTERPRETE VALUES(52,3782,396,10);
INSERT INTO INTERPRETE VALUES(109,4708,398,1);
INSERT INTO INTERPRETE VALUES(109,4709,398,2);
INSERT INTO INTERPRETE VALUES(109,4449,398,3);
INSERT INTO INTERPRETE VALUES(109,3904,398,4);
INSERT INTO INTERPRETE VALUES(109,4712,398,5);
INSERT INTO INTERPRETE VALUES(109,2571,398,6);
INSERT INTO INTERPRETE VALUES(109,4341,398,7);
INSERT INTO INTERPRETE VALUES(109,4715,398,8);
INSERT INTO INTERPRETE VALUES(109,4344,398,9);
INSERT INTO INTERPRETE VALUES(109,4717,399,1);
INSERT INTO INTERPRETE VALUES(109,4718,399,2);
INSERT INTO INTERPRETE VALUES(109,4719,399,3);
INSERT INTO INTERPRETE VALUES(109,4720,399,4);
INSERT INTO INTERPRETE VALUES(109,4721,399,5);
INSERT INTO INTERPRETE VALUES(109,4722,399,6);
INSERT INTO INTERPRETE VALUES(109,4723,399,7);
INSERT INTO INTERPRETE VALUES(109,4724,399,8);
INSERT INTO INTERPRETE VALUES(109,4725,399,9);
INSERT INTO INTERPRETE VALUES(109,4726,399,10);
INSERT INTO INTERPRETE VALUES(109,4727,399,11);
INSERT INTO INTERPRETE VALUES(109,4728,400,1);
INSERT INTO INTERPRETE VALUES(109,4729,400,2);
INSERT INTO INTERPRETE VALUES(109,4730,400,3);
INSERT INTO INTERPRETE VALUES(109,4731,400,4);
INSERT INTO INTERPRETE VALUES(109,4732,400,5);
INSERT INTO INTERPRETE VALUES(109,4733,400,6);
INSERT INTO INTERPRETE VALUES(109,4708,400,7);
INSERT INTO INTERPRETE VALUES(109,4735,400,8);
INSERT INTO INTERPRETE VALUES(109,4736,400,9);
INSERT INTO INTERPRETE VALUES(109,4737,400,10);
INSERT INTO INTERPRETE VALUES(109,4709,400,11);
INSERT INTO INTERPRETE VALUES(149,2841,401,1);
INSERT INTO INTERPRETE VALUES(149,1553,401,2);
INSERT INTO INTERPRETE VALUES(149,2837,401,3);
INSERT INTO INTERPRETE VALUES(149,1776,401,4);
INSERT INTO INTERPRETE VALUES(149,4743,401,5);
INSERT INTO INTERPRETE VALUES(149,4744,401,6);
INSERT INTO INTERPRETE VALUES(149,1778,401,7);
INSERT INTO INTERPRETE VALUES(149,1603,401,8);
INSERT INTO INTERPRETE VALUES(149,4747,401,9);
INSERT INTO INTERPRETE VALUES(149,4748,401,10);
INSERT INTO INTERPRETE VALUES(149,1782,401,11);
INSERT INTO INTERPRETE VALUES(149,1780,401,12);
INSERT INTO INTERPRETE VALUES(149,1606,401,13);
INSERT INTO INTERPRETE VALUES(149,2839,401,14);
INSERT INTO INTERPRETE VALUES(150,4753,402,1);
INSERT INTO INTERPRETE VALUES(150,4754,402,2);
INSERT INTO INTERPRETE VALUES(150,4755,402,3);
INSERT INTO INTERPRETE VALUES(150,4756,402,4);
INSERT INTO INTERPRETE VALUES(150,4757,402,5);
INSERT INTO INTERPRETE VALUES(150,4758,402,6);
INSERT INTO INTERPRETE VALUES(150,4759,402,7);
INSERT INTO INTERPRETE VALUES(150,4760,402,8);
INSERT INTO INTERPRETE VALUES(52,4763,403,3);
INSERT INTO INTERPRETE VALUES(95,4783,405,9);
INSERT INTO INTERPRETE VALUES(95,4784,405,10);
INSERT INTO INTERPRETE VALUES(95,4785,405,11);
INSERT INTO INTERPRETE VALUES(95,4786,405,12);
INSERT INTO INTERPRETE VALUES(52,4764,403,4);
INSERT INTO INTERPRETE VALUES(95,4788,405,14);
INSERT INTO INTERPRETE VALUES(95,4789,405,15);
INSERT INTO INTERPRETE VALUES(143,4790,406,1);
INSERT INTO INTERPRETE VALUES(143,4791,406,2);
INSERT INTO INTERPRETE VALUES(143,4792,406,3);
INSERT INTO INTERPRETE VALUES(143,4793,406,4);
INSERT INTO INTERPRETE VALUES(143,4795,406,6);
INSERT INTO INTERPRETE VALUES(143,4796,406,7);
INSERT INTO INTERPRETE VALUES(143,4798,406,9);
INSERT INTO INTERPRETE VALUES(143,4803,407,4);
INSERT INTO INTERPRETE VALUES(143,4795,407,6);
INSERT INTO INTERPRETE VALUES(143,4799,406,10);
INSERT INTO INTERPRETE VALUES(143,4801,407,2);
INSERT INTO INTERPRETE VALUES(143,4811,408,3);
INSERT INTO INTERPRETE VALUES(143,4814,408,6);
INSERT INTO INTERPRETE VALUES(143,4822,409,3);
INSERT INTO INTERPRETE VALUES(143,4829,410,2);
INSERT INTO INTERPRETE VALUES(143,4836,410,9);
INSERT INTO INTERPRETE VALUES(143,4849,412,1);
INSERT INTO INTERPRETE VALUES(143,4829,412,2);
INSERT INTO INTERPRETE VALUES(143,4854,412,6);
INSERT INTO INTERPRETE VALUES(143,4856,412,8);
INSERT INTO INTERPRETE VALUES(143,4836,412,9);
INSERT INTO INTERPRETE VALUES(143,4858,412,10);
INSERT INTO INTERPRETE VALUES(143,4867,413,9);
INSERT INTO INTERPRETE VALUES(143,4868,413,10);
INSERT INTO INTERPRETE VALUES(143,4869,413,11);
INSERT INTO INTERPRETE VALUES(143,4870,413,12);
INSERT INTO INTERPRETE VALUES(143,4871,414,1);
INSERT INTO INTERPRETE VALUES(143,4873,414,3);
INSERT INTO INTERPRETE VALUES(143,4874,414,4);
INSERT INTO INTERPRETE VALUES(143,4875,414,5);
INSERT INTO INTERPRETE VALUES(143,4876,414,6);
INSERT INTO INTERPRETE VALUES(143,4877,414,7);
INSERT INTO INTERPRETE VALUES(143,4878,414,8);
INSERT INTO INTERPRETE VALUES(143,4879,414,9);
INSERT INTO INTERPRETE VALUES(143,4880,414,10);
INSERT INTO INTERPRETE VALUES(143,4882,414,12);
INSERT INTO INTERPRETE VALUES(143,4883,415,1);
INSERT INTO INTERPRETE VALUES(143,4884,415,2);
INSERT INTO INTERPRETE VALUES(143,4831,415,3);
INSERT INTO INTERPRETE VALUES(143,4886,415,4);
INSERT INTO INTERPRETE VALUES(143,4887,415,5);
INSERT INTO INTERPRETE VALUES(143,4888,415,6);
INSERT INTO INTERPRETE VALUES(143,4889,415,7);
INSERT INTO INTERPRETE VALUES(143,4891,415,9);
INSERT INTO INTERPRETE VALUES(143,4833,415,10);
INSERT INTO INTERPRETE VALUES(143,4893,415,11);
INSERT INTO INTERPRETE VALUES(143,4894,415,12);
INSERT INTO INTERPRETE VALUES(143,4895,416,1);
INSERT INTO INTERPRETE VALUES(143,4896,416,2);
INSERT INTO INTERPRETE VALUES(143,4897,416,3);
INSERT INTO INTERPRETE VALUES(143,4900,416,6);
INSERT INTO INTERPRETE VALUES(143,4902,416,8);
INSERT INTO INTERPRETE VALUES(143,4904,416,10);
INSERT INTO INTERPRETE VALUES(143,4906,416,12);
INSERT INTO INTERPRETE VALUES(143,4907,416,13);
INSERT INTO INTERPRETE VALUES(143,4914,417,7);
INSERT INTO INTERPRETE VALUES(143,4915,417,8);
INSERT INTO INTERPRETE VALUES(143,4917,417,10);
INSERT INTO INTERPRETE VALUES(143,4918,417,11);
INSERT INTO INTERPRETE VALUES(143,4919,417,12);
INSERT INTO INTERPRETE VALUES(143,4903,416,9);
INSERT INTO INTERPRETE VALUES(143,4811,419,1);
INSERT INTO INTERPRETE VALUES(143,4896,420,1);
INSERT INTO INTERPRETE VALUES(143,4831,420,2);
INSERT INTO INTERPRETE VALUES(143,4894,420,3);
INSERT INTO INTERPRETE VALUES(143,4790,420,4);
INSERT INTO INTERPRETE VALUES(143,4829,420,5);
INSERT INTO INTERPRETE VALUES(143,4937,419,6);
INSERT INTO INTERPRETE VALUES(143,4836,420,12);
INSERT INTO INTERPRETE VALUES(143,4854,420,13);
INSERT INTO INTERPRETE VALUES(143,4856,420,14);
INSERT INTO INTERPRETE VALUES(143,4801,420,6);
INSERT INTO INTERPRETE VALUES(143,4797,420,8);
INSERT INTO INTERPRETE VALUES(143,4849,420,15);
INSERT INTO INTERPRETE VALUES(143,4858,420,17);
INSERT INTO INTERPRETE VALUES(143,4971,422,1);
INSERT INTO INTERPRETE VALUES(143,4972,422,2);
INSERT INTO INTERPRETE VALUES(143,4973,422,3);
INSERT INTO INTERPRETE VALUES(143,4975,422,5);
INSERT INTO INTERPRETE VALUES(143,4978,422,8);
INSERT INTO INTERPRETE VALUES(143,4980,422,10);
INSERT INTO INTERPRETE VALUES(143,4982,422,12);
INSERT INTO INTERPRETE VALUES(151,4991,423,7);
INSERT INTO INTERPRETE VALUES(151,4992,423,8);
INSERT INTO INTERPRETE VALUES(151,4993,423,9);
INSERT INTO INTERPRETE VALUES(151,4994,423,10);
INSERT INTO INTERPRETE VALUES(151,4995,423,11);
INSERT INTO INTERPRETE VALUES(151,4996,423,12);
INSERT INTO INTERPRETE VALUES(151,4997,423,13);
INSERT INTO INTERPRETE VALUES(89,4998,424,1);
INSERT INTO INTERPRETE VALUES(89,4999,424,2);
INSERT INTO INTERPRETE VALUES(89,5000,424,3);
INSERT INTO INTERPRETE VALUES(89,5001,424,4);
INSERT INTO INTERPRETE VALUES(89,5002,424,5);
INSERT INTO INTERPRETE VALUES(89,5003,424,6);
INSERT INTO INTERPRETE VALUES(89,5004,424,7);
INSERT INTO INTERPRETE VALUES(89,5005,424,8);
INSERT INTO INTERPRETE VALUES(89,5006,424,9);
INSERT INTO INTERPRETE VALUES(89,5007,424,10);
INSERT INTO INTERPRETE VALUES(89,5008,424,11);
INSERT INTO INTERPRETE VALUES(89,5009,424,12);
INSERT INTO INTERPRETE VALUES(89,5010,424,13);
INSERT INTO INTERPRETE VALUES(152,5011,425,1);
INSERT INTO INTERPRETE VALUES(152,5012,425,2);
INSERT INTO INTERPRETE VALUES(152,5013,425,3);
INSERT INTO INTERPRETE VALUES(152,5014,425,4);
INSERT INTO INTERPRETE VALUES(152,5015,425,5);
INSERT INTO INTERPRETE VALUES(152,5016,425,6);
INSERT INTO INTERPRETE VALUES(152,5017,425,7);
INSERT INTO INTERPRETE VALUES(152,5018,425,8);
INSERT INTO INTERPRETE VALUES(152,5019,425,9);
INSERT INTO INTERPRETE VALUES(152,5020,425,10);
INSERT INTO INTERPRETE VALUES(122,5021,426,1);
INSERT INTO INTERPRETE VALUES(122,5022,426,2);
INSERT INTO INTERPRETE VALUES(122,5023,426,3);
INSERT INTO INTERPRETE VALUES(122,5024,426,4);
INSERT INTO INTERPRETE VALUES(122,5025,426,5);
INSERT INTO INTERPRETE VALUES(122,5026,426,6);
INSERT INTO INTERPRETE VALUES(122,5027,426,7);
INSERT INTO INTERPRETE VALUES(122,5028,426,8);
INSERT INTO INTERPRETE VALUES(122,5029,426,9);
INSERT INTO INTERPRETE VALUES(122,5030,426,10);
INSERT INTO INTERPRETE VALUES(122,5031,426,11);
INSERT INTO INTERPRETE VALUES(122,5032,426,12);
INSERT INTO INTERPRETE VALUES(122,5033,426,13);
INSERT INTO INTERPRETE VALUES(122,5034,426,14);
INSERT INTO INTERPRETE VALUES(122,5035,426,15);
INSERT INTO INTERPRETE VALUES(153,5036,427,1);
INSERT INTO INTERPRETE VALUES(153,5037,427,2);
INSERT INTO INTERPRETE VALUES(153,5038,427,3);
INSERT INTO INTERPRETE VALUES(153,5040,427,5);
INSERT INTO INTERPRETE VALUES(153,5041,427,6);
INSERT INTO INTERPRETE VALUES(153,5042,427,7);
INSERT INTO INTERPRETE VALUES(153,5044,427,9);
INSERT INTO INTERPRETE VALUES(153,5045,427,10);
INSERT INTO INTERPRETE VALUES(153,5046,427,11);
INSERT INTO INTERPRETE VALUES(153,5047,427,12);
INSERT INTO INTERPRETE VALUES(153,5048,427,13);
INSERT INTO INTERPRETE VALUES(153,5049,428,1);
INSERT INTO INTERPRETE VALUES(153,5050,428,2);
INSERT INTO INTERPRETE VALUES(153,5051,428,3);
INSERT INTO INTERPRETE VALUES(153,5052,428,4);
INSERT INTO INTERPRETE VALUES(153,5054,428,6);
INSERT INTO INTERPRETE VALUES(153,5055,428,7);
INSERT INTO INTERPRETE VALUES(153,5056,428,8);
INSERT INTO INTERPRETE VALUES(153,5057,428,9);
INSERT INTO INTERPRETE VALUES(153,5058,428,10);
INSERT INTO INTERPRETE VALUES(153,5059,428,11);
INSERT INTO INTERPRETE VALUES(153,5060,428,12);
INSERT INTO INTERPRETE VALUES(96,5061,429,1);
INSERT INTO INTERPRETE VALUES(96,5062,429,2);
INSERT INTO INTERPRETE VALUES(96,5063,429,3);
INSERT INTO INTERPRETE VALUES(96,2296,429,4);
INSERT INTO INTERPRETE VALUES(96,3504,429,5);
INSERT INTO INTERPRETE VALUES(96,5066,429,6);
INSERT INTO INTERPRETE VALUES(96,5067,429,7);
INSERT INTO INTERPRETE VALUES(96,5068,429,8);
INSERT INTO INTERPRETE VALUES(96,5069,429,9);
INSERT INTO INTERPRETE VALUES(96,5070,429,10);
INSERT INTO INTERPRETE VALUES(96,5071,429,11);
INSERT INTO INTERPRETE VALUES(96,2022,429,12);
INSERT INTO INTERPRETE VALUES(96,5073,429,13);
INSERT INTO INTERPRETE VALUES(96,5074,429,14);
INSERT INTO INTERPRETE VALUES(96,5075,429,15);
INSERT INTO INTERPRETE VALUES(96,5076,429,16);
INSERT INTO INTERPRETE VALUES(96,5077,429,17);
INSERT INTO INTERPRETE VALUES(96,5078,429,18);
INSERT INTO INTERPRETE VALUES(96,5079,429,19);
INSERT INTO INTERPRETE VALUES(96,5080,429,20);
INSERT INTO INTERPRETE VALUES(96,5081,429,21);
INSERT INTO INTERPRETE VALUES(96,5082,429,22);
INSERT INTO INTERPRETE VALUES(96,5083,429,23);
INSERT INTO INTERPRETE VALUES(154,5084,430,1);
INSERT INTO INTERPRETE VALUES(154,5085,430,2);
INSERT INTO INTERPRETE VALUES(154,5086,430,3);
INSERT INTO INTERPRETE VALUES(154,5087,430,4);
INSERT INTO INTERPRETE VALUES(154,5088,430,5);
INSERT INTO INTERPRETE VALUES(154,5089,430,6);
INSERT INTO INTERPRETE VALUES(154,5090,430,7);
INSERT INTO INTERPRETE VALUES(155,5091,431,1);
INSERT INTO INTERPRETE VALUES(155,5092,431,2);
INSERT INTO INTERPRETE VALUES(155,5094,431,4);
INSERT INTO INTERPRETE VALUES(155,5099,431,9);
INSERT INTO INTERPRETE VALUES(155,1611,431,15);
INSERT INTO INTERPRETE VALUES(155,5110,431,20);
INSERT INTO INTERPRETE VALUES(156,5112,432,1);
INSERT INTO INTERPRETE VALUES(156,5113,432,2);
INSERT INTO INTERPRETE VALUES(156,5114,432,3);
INSERT INTO INTERPRETE VALUES(156,5115,432,4);
INSERT INTO INTERPRETE VALUES(156,5116,432,5);
INSERT INTO INTERPRETE VALUES(156,5117,432,6);
INSERT INTO INTERPRETE VALUES(156,5118,432,7);
INSERT INTO INTERPRETE VALUES(156,5119,432,8);
INSERT INTO INTERPRETE VALUES(156,5120,432,9);
INSERT INTO INTERPRETE VALUES(156,5121,432,10);
INSERT INTO INTERPRETE VALUES(156,5122,432,11);
INSERT INTO INTERPRETE VALUES(48,5123,433,1);
INSERT INTO INTERPRETE VALUES(48,1113,433,2);
INSERT INTO INTERPRETE VALUES(48,1117,433,3);
INSERT INTO INTERPRETE VALUES(48,5126,433,4);
INSERT INTO INTERPRETE VALUES(48,5127,433,5);
INSERT INTO INTERPRETE VALUES(48,5128,433,6);
INSERT INTO INTERPRETE VALUES(48,5130,433,8);
INSERT INTO INTERPRETE VALUES(48,5131,433,9);
INSERT INTO INTERPRETE VALUES(48,1120,433,10);
INSERT INTO INTERPRETE VALUES(48,1127,433,11);
INSERT INTO INTERPRETE VALUES(48,5134,433,12);
INSERT INTO INTERPRETE VALUES(48,5135,433,13);
INSERT INTO INTERPRETE VALUES(48,5136,433,14);
INSERT INTO INTERPRETE VALUES(48,5137,433,15);
INSERT INTO INTERPRETE VALUES(48,5138,433,16);
INSERT INTO INTERPRETE VALUES(48,5139,433,17);
INSERT INTO INTERPRETE VALUES(48,5140,433,18);
INSERT INTO INTERPRETE VALUES(157,5141,434,1);
INSERT INTO INTERPRETE VALUES(157,5142,434,2);
INSERT INTO INTERPRETE VALUES(157,5143,434,3);
INSERT INTO INTERPRETE VALUES(157,5144,434,4);
INSERT INTO INTERPRETE VALUES(157,5145,434,5);
INSERT INTO INTERPRETE VALUES(157,5146,434,6);
INSERT INTO INTERPRETE VALUES(157,5147,434,7);
INSERT INTO INTERPRETE VALUES(157,5149,434,9);
INSERT INTO INTERPRETE VALUES(157,5150,434,10);
INSERT INTO INTERPRETE VALUES(157,5151,434,11);
INSERT INTO INTERPRETE VALUES(157,5152,434,12);
INSERT INTO INTERPRETE VALUES(157,5153,434,13);
INSERT INTO INTERPRETE VALUES(157,5154,434,14);
INSERT INTO INTERPRETE VALUES(157,5155,434,15);
INSERT INTO INTERPRETE VALUES(157,5156,434,16);
INSERT INTO INTERPRETE VALUES(157,5157,434,17);
INSERT INTO INTERPRETE VALUES(157,5158,434,18);
INSERT INTO INTERPRETE VALUES(157,5159,434,19);
INSERT INTO INTERPRETE VALUES(42,5160,435,1);
INSERT INTO INTERPRETE VALUES(42,5161,435,2);
INSERT INTO INTERPRETE VALUES(42,5162,435,3);
INSERT INTO INTERPRETE VALUES(42,5163,435,4);
INSERT INTO INTERPRETE VALUES(42,5164,435,5);
INSERT INTO INTERPRETE VALUES(42,5165,435,6);
INSERT INTO INTERPRETE VALUES(42,5166,435,7);
INSERT INTO INTERPRETE VALUES(42,5167,435,8);
INSERT INTO INTERPRETE VALUES(42,5168,435,9);
INSERT INTO INTERPRETE VALUES(42,5169,435,10);
INSERT INTO INTERPRETE VALUES(42,5170,435,11);
INSERT INTO INTERPRETE VALUES(42,5171,435,12);
INSERT INTO INTERPRETE VALUES(11,5172,436,1);
INSERT INTO INTERPRETE VALUES(11,5173,436,2);
INSERT INTO INTERPRETE VALUES(11,5174,436,3);
INSERT INTO INTERPRETE VALUES(11,5175,436,4);
INSERT INTO INTERPRETE VALUES(11,5176,436,5);
INSERT INTO INTERPRETE VALUES(11,5177,436,6);
INSERT INTO INTERPRETE VALUES(11,5178,436,7);
INSERT INTO INTERPRETE VALUES(11,5179,436,8);
INSERT INTO INTERPRETE VALUES(11,5180,436,9);
INSERT INTO INTERPRETE VALUES(11,5181,436,10);
INSERT INTO INTERPRETE VALUES(11,5182,436,11);
INSERT INTO INTERPRETE VALUES(89,5183,437,1);
INSERT INTO INTERPRETE VALUES(89,5184,437,2);
INSERT INTO INTERPRETE VALUES(89,5185,437,3);
INSERT INTO INTERPRETE VALUES(89,5186,437,4);
INSERT INTO INTERPRETE VALUES(89,5187,437,5);
INSERT INTO INTERPRETE VALUES(89,5188,437,6);
INSERT INTO INTERPRETE VALUES(89,5189,437,7);
INSERT INTO INTERPRETE VALUES(89,5190,437,8);
INSERT INTO INTERPRETE VALUES(89,5191,437,9);
INSERT INTO INTERPRETE VALUES(89,5192,437,10);
INSERT INTO INTERPRETE VALUES(89,5193,437,11);
INSERT INTO INTERPRETE VALUES(89,5194,437,12);
INSERT INTO INTERPRETE VALUES(89,5195,437,13);
INSERT INTO INTERPRETE VALUES(89,5196,437,14);
INSERT INTO INTERPRETE VALUES(158,5197,438,1);
INSERT INTO INTERPRETE VALUES(158,5198,438,2);
INSERT INTO INTERPRETE VALUES(158,5199,438,3);
INSERT INTO INTERPRETE VALUES(158,5200,438,4);
INSERT INTO INTERPRETE VALUES(158,5201,438,5);
INSERT INTO INTERPRETE VALUES(158,5202,438,6);
INSERT INTO INTERPRETE VALUES(158,5203,438,7);
INSERT INTO INTERPRETE VALUES(158,5204,438,8);
INSERT INTO INTERPRETE VALUES(158,5205,438,9);
INSERT INTO INTERPRETE VALUES(158,5206,438,10);
INSERT INTO INTERPRETE VALUES(158,5207,438,11);
INSERT INTO INTERPRETE VALUES(158,5208,438,12);
INSERT INTO INTERPRETE VALUES(158,5209,438,13);
INSERT INTO INTERPRETE VALUES(158,5210,438,14);
INSERT INTO INTERPRETE VALUES(158,5211,438,15);
INSERT INTO INTERPRETE VALUES(158,5212,438,16);
INSERT INTO INTERPRETE VALUES(158,5213,438,17);
INSERT INTO INTERPRETE VALUES(158,5214,438,18);
INSERT INTO INTERPRETE VALUES(158,5215,438,19);
INSERT INTO INTERPRETE VALUES(158,5216,438,20);
INSERT INTO INTERPRETE VALUES(159,5217,439,1);
INSERT INTO INTERPRETE VALUES(159,5218,439,2);
INSERT INTO INTERPRETE VALUES(159,5219,439,3);
INSERT INTO INTERPRETE VALUES(159,5220,439,4);
INSERT INTO INTERPRETE VALUES(159,5221,439,5);
INSERT INTO INTERPRETE VALUES(159,5222,439,6);
INSERT INTO INTERPRETE VALUES(159,5223,439,7);
INSERT INTO INTERPRETE VALUES(159,5224,439,8);
INSERT INTO INTERPRETE VALUES(159,5225,439,9);
INSERT INTO INTERPRETE VALUES(159,5226,439,10);
INSERT INTO INTERPRETE VALUES(159,5227,439,11);
INSERT INTO INTERPRETE VALUES(160,8436,440,1);
INSERT INTO INTERPRETE VALUES(160,5229,440,2);
INSERT INTO INTERPRETE VALUES(160,5230,440,3);
INSERT INTO INTERPRETE VALUES(160,5231,440,4);
INSERT INTO INTERPRETE VALUES(160,5232,440,5);
INSERT INTO INTERPRETE VALUES(160,5233,440,6);
INSERT INTO INTERPRETE VALUES(160,5234,440,7);
INSERT INTO INTERPRETE VALUES(160,5235,440,8);
INSERT INTO INTERPRETE VALUES(160,5236,440,9);
INSERT INTO INTERPRETE VALUES(160,5237,440,10);
INSERT INTO INTERPRETE VALUES(160,5238,440,11);
INSERT INTO INTERPRETE VALUES(106,3675,441,1);
INSERT INTO INTERPRETE VALUES(106,5240,441,2);
INSERT INTO INTERPRETE VALUES(106,5241,441,3);
INSERT INTO INTERPRETE VALUES(106,5242,441,4);
INSERT INTO INTERPRETE VALUES(106,5243,441,5);
INSERT INTO INTERPRETE VALUES(106,3674,441,6);
INSERT INTO INTERPRETE VALUES(106,5245,441,7);
INSERT INTO INTERPRETE VALUES(106,5246,441,8);
INSERT INTO INTERPRETE VALUES(161,5248,442,1);
INSERT INTO INTERPRETE VALUES(161,5249,442,2);
INSERT INTO INTERPRETE VALUES(161,5250,442,3);
INSERT INTO INTERPRETE VALUES(161,5251,442,4);
INSERT INTO INTERPRETE VALUES(161,5252,442,5);
INSERT INTO INTERPRETE VALUES(161,5253,442,6);
INSERT INTO INTERPRETE VALUES(161,5254,442,7);
INSERT INTO INTERPRETE VALUES(161,5255,442,8);
INSERT INTO INTERPRETE VALUES(161,5256,442,9);
INSERT INTO INTERPRETE VALUES(161,5257,442,10);
INSERT INTO INTERPRETE VALUES(162,5258,443,1);
INSERT INTO INTERPRETE VALUES(162,5259,443,2);
INSERT INTO INTERPRETE VALUES(162,5260,443,3);
INSERT INTO INTERPRETE VALUES(162,5261,443,4);
INSERT INTO INTERPRETE VALUES(162,5262,443,5);
INSERT INTO INTERPRETE VALUES(162,5263,443,6);
INSERT INTO INTERPRETE VALUES(4,5282,445,4);
INSERT INTO INTERPRETE VALUES(4,5283,445,5);
INSERT INTO INTERPRETE VALUES(4,5284,445,6);
INSERT INTO INTERPRETE VALUES(4,5286,445,8);
INSERT INTO INTERPRETE VALUES(4,5287,445,9);
INSERT INTO INTERPRETE VALUES(4,5288,445,10);
INSERT INTO INTERPRETE VALUES(4,5289,445,11);
INSERT INTO INTERPRETE VALUES(4,5290,445,12);
INSERT INTO INTERPRETE VALUES(164,5291,446,1);
INSERT INTO INTERPRETE VALUES(164,5292,446,2);
INSERT INTO INTERPRETE VALUES(164,5293,446,3);
INSERT INTO INTERPRETE VALUES(164,5294,446,4);
INSERT INTO INTERPRETE VALUES(164,5295,446,5);
INSERT INTO INTERPRETE VALUES(164,5296,446,6);
INSERT INTO INTERPRETE VALUES(164,5297,446,7);
INSERT INTO INTERPRETE VALUES(164,5298,446,8);
INSERT INTO INTERPRETE VALUES(164,5299,446,9);
INSERT INTO INTERPRETE VALUES(164,5300,446,10);
INSERT INTO INTERPRETE VALUES(164,5301,446,11);
INSERT INTO INTERPRETE VALUES(164,5302,446,12);
INSERT INTO INTERPRETE VALUES(162,5303,447,1);
INSERT INTO INTERPRETE VALUES(162,5304,447,2);
INSERT INTO INTERPRETE VALUES(162,5305,447,3);
INSERT INTO INTERPRETE VALUES(162,5306,447,4);
INSERT INTO INTERPRETE VALUES(162,5307,447,5);
INSERT INTO INTERPRETE VALUES(162,5308,447,6);
INSERT INTO INTERPRETE VALUES(162,5309,447,7);
INSERT INTO INTERPRETE VALUES(162,5310,447,8);
INSERT INTO INTERPRETE VALUES(162,5311,447,9);
INSERT INTO INTERPRETE VALUES(162,5312,447,10);
INSERT INTO INTERPRETE VALUES(162,5313,447,11);
INSERT INTO INTERPRETE VALUES(162,5314,447,12);
INSERT INTO INTERPRETE VALUES(162,5315,447,13);
INSERT INTO INTERPRETE VALUES(162,5316,447,14);
INSERT INTO INTERPRETE VALUES(162,5317,448,1);
INSERT INTO INTERPRETE VALUES(162,5318,448,2);
INSERT INTO INTERPRETE VALUES(162,5319,448,3);
INSERT INTO INTERPRETE VALUES(162,5320,448,4);
INSERT INTO INTERPRETE VALUES(162,5321,448,5);
INSERT INTO INTERPRETE VALUES(162,5322,448,6);
INSERT INTO INTERPRETE VALUES(162,5323,448,7);
INSERT INTO INTERPRETE VALUES(162,5324,448,8);
INSERT INTO INTERPRETE VALUES(162,5325,448,9);
INSERT INTO INTERPRETE VALUES(162,5326,448,10);
INSERT INTO INTERPRETE VALUES(162,5327,448,11);
INSERT INTO INTERPRETE VALUES(162,5328,448,12);
INSERT INTO INTERPRETE VALUES(162,5329,448,13);
INSERT INTO INTERPRETE VALUES(162,5330,448,14);
INSERT INTO INTERPRETE VALUES(49,5331,449,1);
INSERT INTO INTERPRETE VALUES(49,5332,449,2);
INSERT INTO INTERPRETE VALUES(49,5333,449,3);
INSERT INTO INTERPRETE VALUES(49,5334,449,4);
INSERT INTO INTERPRETE VALUES(49,5335,449,5);
INSERT INTO INTERPRETE VALUES(49,1137,449,6);
INSERT INTO INTERPRETE VALUES(49,5337,449,7);
INSERT INTO INTERPRETE VALUES(49,5338,449,8);
INSERT INTO INTERPRETE VALUES(49,5339,449,9);
INSERT INTO INTERPRETE VALUES(49,5340,449,10);
INSERT INTO INTERPRETE VALUES(49,5341,449,11);
INSERT INTO INTERPRETE VALUES(49,5342,449,12);
INSERT INTO INTERPRETE VALUES(49,5343,449,13);
INSERT INTO INTERPRETE VALUES(162,5344,450,1);
INSERT INTO INTERPRETE VALUES(162,5345,450,2);
INSERT INTO INTERPRETE VALUES(162,5346,450,3);
INSERT INTO INTERPRETE VALUES(162,5347,450,4);
INSERT INTO INTERPRETE VALUES(162,5348,450,5);
INSERT INTO INTERPRETE VALUES(162,5349,450,6);
INSERT INTO INTERPRETE VALUES(162,5350,450,7);
INSERT INTO INTERPRETE VALUES(162,5351,450,8);
INSERT INTO INTERPRETE VALUES(162,5352,450,9);
INSERT INTO INTERPRETE VALUES(162,5353,450,10);
INSERT INTO INTERPRETE VALUES(162,5354,450,11);
INSERT INTO INTERPRETE VALUES(162,5355,450,12);
INSERT INTO INTERPRETE VALUES(162,5356,450,13);
INSERT INTO INTERPRETE VALUES(162,5357,450,14);
INSERT INTO INTERPRETE VALUES(61,5358,451,1);
INSERT INTO INTERPRETE VALUES(61,2275,451,2);
INSERT INTO INTERPRETE VALUES(61,1462,451,3);
INSERT INTO INTERPRETE VALUES(61,3106,451,16);
INSERT INTO INTERPRETE VALUES(165,5374,452,1);
INSERT INTO INTERPRETE VALUES(165,5375,452,2);
INSERT INTO INTERPRETE VALUES(165,5376,452,3);
INSERT INTO INTERPRETE VALUES(165,5377,452,4);
INSERT INTO INTERPRETE VALUES(165,5378,452,5);
INSERT INTO INTERPRETE VALUES(165,5379,452,6);
INSERT INTO INTERPRETE VALUES(165,5380,452,7);
INSERT INTO INTERPRETE VALUES(165,5381,452,8);
INSERT INTO INTERPRETE VALUES(165,5382,452,9);
INSERT INTO INTERPRETE VALUES(165,5383,452,10);
INSERT INTO INTERPRETE VALUES(165,5384,452,11);
INSERT INTO INTERPRETE VALUES(165,5385,452,12);
INSERT INTO INTERPRETE VALUES(165,5387,452,14);
INSERT INTO INTERPRETE VALUES(165,1918,452,15);
INSERT INTO INTERPRETE VALUES(165,5389,452,16);
INSERT INTO INTERPRETE VALUES(165,5390,452,17);
INSERT INTO INTERPRETE VALUES(160,5391,453,1);
INSERT INTO INTERPRETE VALUES(160,5392,453,2);
INSERT INTO INTERPRETE VALUES(160,5393,453,3);
INSERT INTO INTERPRETE VALUES(165,5386,452,13);
INSERT INTO INTERPRETE VALUES(160,5394,453,4);
INSERT INTO INTERPRETE VALUES(160,5395,453,5);
INSERT INTO INTERPRETE VALUES(11,5411,454,3);
INSERT INTO INTERPRETE VALUES(11,5412,454,4);
INSERT INTO INTERPRETE VALUES(11,5413,454,5);
INSERT INTO INTERPRETE VALUES(11,5414,454,6);
INSERT INTO INTERPRETE VALUES(11,5415,454,7);
INSERT INTO INTERPRETE VALUES(11,5416,454,8);
INSERT INTO INTERPRETE VALUES(11,5417,454,9);
INSERT INTO INTERPRETE VALUES(11,5418,454,10);
INSERT INTO INTERPRETE VALUES(42,5420,455,1);
INSERT INTO INTERPRETE VALUES(42,5421,455,2);
INSERT INTO INTERPRETE VALUES(42,5422,455,3);
INSERT INTO INTERPRETE VALUES(42,5423,455,4);
INSERT INTO INTERPRETE VALUES(42,5424,455,5);
INSERT INTO INTERPRETE VALUES(42,5425,455,6);
INSERT INTO INTERPRETE VALUES(42,5426,455,7);
INSERT INTO INTERPRETE VALUES(42,5427,455,8);
INSERT INTO INTERPRETE VALUES(42,5428,455,9);
INSERT INTO INTERPRETE VALUES(42,5429,456,1);
INSERT INTO INTERPRETE VALUES(42,5430,456,2);
INSERT INTO INTERPRETE VALUES(42,5431,456,3);
INSERT INTO INTERPRETE VALUES(42,5432,456,4);
INSERT INTO INTERPRETE VALUES(42,5433,456,5);
INSERT INTO INTERPRETE VALUES(42,5434,456,6);
INSERT INTO INTERPRETE VALUES(42,5435,456,7);
INSERT INTO INTERPRETE VALUES(42,5436,456,8);
INSERT INTO INTERPRETE VALUES(42,5437,456,9);
INSERT INTO INTERPRETE VALUES(42,5438,456,10);
INSERT INTO INTERPRETE VALUES(11,5439,457,1);
INSERT INTO INTERPRETE VALUES(11,5440,457,2);
INSERT INTO INTERPRETE VALUES(11,5441,457,3);
INSERT INTO INTERPRETE VALUES(11,5442,457,4);
INSERT INTO INTERPRETE VALUES(11,5443,457,5);
INSERT INTO INTERPRETE VALUES(11,5444,457,6);
INSERT INTO INTERPRETE VALUES(11,5445,457,7);
INSERT INTO INTERPRETE VALUES(11,5446,457,8);
INSERT INTO INTERPRETE VALUES(11,5447,457,9);
INSERT INTO INTERPRETE VALUES(11,5448,457,10);
INSERT INTO INTERPRETE VALUES(11,5449,457,11);
INSERT INTO INTERPRETE VALUES(11,5450,457,12);
INSERT INTO INTERPRETE VALUES(42,5451,458,1);
INSERT INTO INTERPRETE VALUES(42,5452,458,2);
INSERT INTO INTERPRETE VALUES(42,5453,458,3);
INSERT INTO INTERPRETE VALUES(42,5454,458,4);
INSERT INTO INTERPRETE VALUES(42,5455,458,5);
INSERT INTO INTERPRETE VALUES(42,5456,458,6);
INSERT INTO INTERPRETE VALUES(42,5457,458,7);
INSERT INTO INTERPRETE VALUES(42,5458,458,8);
INSERT INTO INTERPRETE VALUES(42,1641,458,9);
INSERT INTO INTERPRETE VALUES(166,5473,460,1);
INSERT INTO INTERPRETE VALUES(166,5474,460,2);
INSERT INTO INTERPRETE VALUES(166,5475,460,3);
INSERT INTO INTERPRETE VALUES(166,5476,460,4);
INSERT INTO INTERPRETE VALUES(166,5477,460,5);
INSERT INTO INTERPRETE VALUES(166,5478,460,6);
INSERT INTO INTERPRETE VALUES(166,5479,460,7);
INSERT INTO INTERPRETE VALUES(166,5480,460,8);
INSERT INTO INTERPRETE VALUES(166,5481,460,9);
INSERT INTO INTERPRETE VALUES(166,5482,460,10);
INSERT INTO INTERPRETE VALUES(166,5483,460,11);
INSERT INTO INTERPRETE VALUES(166,5484,460,12);
INSERT INTO INTERPRETE VALUES(167,5485,461,1);
INSERT INTO INTERPRETE VALUES(167,5486,461,2);
INSERT INTO INTERPRETE VALUES(167,5487,461,3);
INSERT INTO INTERPRETE VALUES(167,5488,461,4);
INSERT INTO INTERPRETE VALUES(167,5489,461,5);
INSERT INTO INTERPRETE VALUES(167,5490,461,6);
INSERT INTO INTERPRETE VALUES(167,5491,461,7);
INSERT INTO INTERPRETE VALUES(167,5492,461,8);
INSERT INTO INTERPRETE VALUES(167,5493,461,9);
INSERT INTO INTERPRETE VALUES(167,5494,461,10);
INSERT INTO INTERPRETE VALUES(167,5495,461,11);
INSERT INTO INTERPRETE VALUES(167,5496,462,1);
INSERT INTO INTERPRETE VALUES(167,5497,462,2);
INSERT INTO INTERPRETE VALUES(167,5498,462,3);
INSERT INTO INTERPRETE VALUES(167,5499,462,4);
INSERT INTO INTERPRETE VALUES(167,5500,462,5);
INSERT INTO INTERPRETE VALUES(167,5501,462,6);
INSERT INTO INTERPRETE VALUES(44,2203,463,4);
INSERT INTO INTERPRETE VALUES(44,2476,464,2);
INSERT INTO INTERPRETE VALUES(44,1639,464,3);
INSERT INTO INTERPRETE VALUES(44,2909,464,5);
INSERT INTO INTERPRETE VALUES(44,1546,464,6);
INSERT INTO INTERPRETE VALUES(44,5510,463,6);
INSERT INTO INTERPRETE VALUES(44,2681,464,7);
INSERT INTO INTERPRETE VALUES(44,1559,464,10);
INSERT INTO INTERPRETE VALUES(44,2731,464,11);
INSERT INTO INTERPRETE VALUES(168,5535,465,6);
INSERT INTO INTERPRETE VALUES(168,5536,465,7);
INSERT INTO INTERPRETE VALUES(168,5537,465,8);
INSERT INTO INTERPRETE VALUES(168,5538,465,9);
INSERT INTO INTERPRETE VALUES(168,5539,465,10);
INSERT INTO INTERPRETE VALUES(168,5540,465,11);
INSERT INTO INTERPRETE VALUES(168,5541,465,12);
INSERT INTO INTERPRETE VALUES(168,9128,465,13);
INSERT INTO INTERPRETE VALUES(168,5543,465,14);
INSERT INTO INTERPRETE VALUES(168,5544,465,15);
INSERT INTO INTERPRETE VALUES(168,5545,465,16);
INSERT INTO INTERPRETE VALUES(168,2277,465,17);
INSERT INTO INTERPRETE VALUES(168,5547,465,18);
INSERT INTO INTERPRETE VALUES(169,5568,467,1);
INSERT INTO INTERPRETE VALUES(169,5569,467,2);
INSERT INTO INTERPRETE VALUES(169,5570,467,3);
INSERT INTO INTERPRETE VALUES(169,5571,467,4);
INSERT INTO INTERPRETE VALUES(169,5572,467,5);
INSERT INTO INTERPRETE VALUES(169,5573,467,6);
INSERT INTO INTERPRETE VALUES(169,5574,467,7);
INSERT INTO INTERPRETE VALUES(169,5575,467,8);
INSERT INTO INTERPRETE VALUES(169,5577,467,10);
INSERT INTO INTERPRETE VALUES(169,5578,467,11);
INSERT INTO INTERPRETE VALUES(169,5576,467,9);
INSERT INTO INTERPRETE VALUES(44,5581,468,3);
INSERT INTO INTERPRETE VALUES(169,2894,469,1);
INSERT INTO INTERPRETE VALUES(169,5590,469,2);
INSERT INTO INTERPRETE VALUES(169,5591,469,3);
INSERT INTO INTERPRETE VALUES(169,5592,469,4);
INSERT INTO INTERPRETE VALUES(169,5593,469,5);
INSERT INTO INTERPRETE VALUES(169,5594,469,6);
INSERT INTO INTERPRETE VALUES(169,5595,469,7);
INSERT INTO INTERPRETE VALUES(169,7078,469,8);
INSERT INTO INTERPRETE VALUES(169,5597,469,9);
INSERT INTO INTERPRETE VALUES(169,5598,469,10);
INSERT INTO INTERPRETE VALUES(169,5599,469,11);
INSERT INTO INTERPRETE VALUES(170,5602,470,3);
INSERT INTO INTERPRETE VALUES(170,5604,470,5);
INSERT INTO INTERPRETE VALUES(170,5605,470,6);
INSERT INTO INTERPRETE VALUES(170,5612,470,13);
INSERT INTO INTERPRETE VALUES(171,5614,471,1);
INSERT INTO INTERPRETE VALUES(171,5615,471,2);
INSERT INTO INTERPRETE VALUES(171,5616,471,3);
INSERT INTO INTERPRETE VALUES(171,5617,471,4);
INSERT INTO INTERPRETE VALUES(171,5618,471,5);
INSERT INTO INTERPRETE VALUES(171,5619,471,6);
INSERT INTO INTERPRETE VALUES(171,5620,471,7);
INSERT INTO INTERPRETE VALUES(171,5621,471,8);
INSERT INTO INTERPRETE VALUES(171,5622,471,9);
INSERT INTO INTERPRETE VALUES(171,5623,471,10);
INSERT INTO INTERPRETE VALUES(171,5624,471,11);
INSERT INTO INTERPRETE VALUES(166,5625,472,1);
INSERT INTO INTERPRETE VALUES(166,5626,472,2);
INSERT INTO INTERPRETE VALUES(166,5627,472,3);
INSERT INTO INTERPRETE VALUES(166,5628,472,4);
INSERT INTO INTERPRETE VALUES(166,5629,472,5);
INSERT INTO INTERPRETE VALUES(166,5630,472,6);
INSERT INTO INTERPRETE VALUES(166,5631,472,7);
INSERT INTO INTERPRETE VALUES(166,5632,472,8);
INSERT INTO INTERPRETE VALUES(166,5633,472,9);
INSERT INTO INTERPRETE VALUES(166,5634,472,10);
INSERT INTO INTERPRETE VALUES(166,5635,472,11);
INSERT INTO INTERPRETE VALUES(166,5636,472,12);
INSERT INTO INTERPRETE VALUES(136,5637,473,1);
INSERT INTO INTERPRETE VALUES(136,5638,473,2);
INSERT INTO INTERPRETE VALUES(170,5609,470,10);
INSERT INTO INTERPRETE VALUES(136,5639,473,3);
INSERT INTO INTERPRETE VALUES(0,5648,474,1);
INSERT INTO INTERPRETE VALUES(0,5649,474,2);
INSERT INTO INTERPRETE VALUES(0,5650,474,3);
INSERT INTO INTERPRETE VALUES(0,1795,474,4);
INSERT INTO INTERPRETE VALUES(0,5652,474,5);
INSERT INTO INTERPRETE VALUES(0,5653,474,6);
INSERT INTO INTERPRETE VALUES(0,5654,474,7);
INSERT INTO INTERPRETE VALUES(0,5655,474,8);
INSERT INTO INTERPRETE VALUES(0,5656,474,9);
INSERT INTO INTERPRETE VALUES(0,5657,474,10);
INSERT INTO INTERPRETE VALUES(0,5658,474,11);
INSERT INTO INTERPRETE VALUES(0,5659,474,12);
INSERT INTO INTERPRETE VALUES(115,5677,476,1);
INSERT INTO INTERPRETE VALUES(115,5678,476,2);
INSERT INTO INTERPRETE VALUES(115,5679,476,3);
INSERT INTO INTERPRETE VALUES(115,5680,476,4);
INSERT INTO INTERPRETE VALUES(115,5681,476,5);
INSERT INTO INTERPRETE VALUES(115,5682,476,6);
INSERT INTO INTERPRETE VALUES(115,5683,476,7);
INSERT INTO INTERPRETE VALUES(115,5684,476,8);
INSERT INTO INTERPRETE VALUES(115,5685,476,9);
INSERT INTO INTERPRETE VALUES(115,5686,476,10);
INSERT INTO INTERPRETE VALUES(115,5687,476,11);
INSERT INTO INTERPRETE VALUES(115,5688,476,12);
INSERT INTO INTERPRETE VALUES(115,5689,476,13);
INSERT INTO INTERPRETE VALUES(172,5692,477,1);
INSERT INTO INTERPRETE VALUES(172,5693,477,2);
INSERT INTO INTERPRETE VALUES(172,5694,477,3);
INSERT INTO INTERPRETE VALUES(172,5695,477,4);
INSERT INTO INTERPRETE VALUES(172,5696,477,5);
INSERT INTO INTERPRETE VALUES(172,5697,477,6);
INSERT INTO INTERPRETE VALUES(172,5698,477,7);
INSERT INTO INTERPRETE VALUES(172,5699,477,8);
INSERT INTO INTERPRETE VALUES(172,5700,477,9);
INSERT INTO INTERPRETE VALUES(172,5701,477,10);
INSERT INTO INTERPRETE VALUES(172,5702,477,11);
INSERT INTO INTERPRETE VALUES(172,5703,477,12);
INSERT INTO INTERPRETE VALUES(172,5704,477,13);
INSERT INTO INTERPRETE VALUES(173,5705,478,1);
INSERT INTO INTERPRETE VALUES(173,5706,478,2);
INSERT INTO INTERPRETE VALUES(173,5707,478,3);
INSERT INTO INTERPRETE VALUES(173,5708,478,4);
INSERT INTO INTERPRETE VALUES(173,5709,478,5);
INSERT INTO INTERPRETE VALUES(173,5710,478,6);
INSERT INTO INTERPRETE VALUES(173,5711,478,7);
INSERT INTO INTERPRETE VALUES(173,5712,478,8);
INSERT INTO INTERPRETE VALUES(173,5713,478,9);
INSERT INTO INTERPRETE VALUES(173,5714,478,10);
INSERT INTO INTERPRETE VALUES(173,5715,478,11);
INSERT INTO INTERPRETE VALUES(173,5716,478,12);
INSERT INTO INTERPRETE VALUES(173,5717,478,13);
INSERT INTO INTERPRETE VALUES(173,5718,478,14);
INSERT INTO INTERPRETE VALUES(174,5719,479,1);
INSERT INTO INTERPRETE VALUES(174,5720,479,2);
INSERT INTO INTERPRETE VALUES(174,10384,479,3);
INSERT INTO INTERPRETE VALUES(174,5722,479,4);
INSERT INTO INTERPRETE VALUES(174,10378,479,5);
INSERT INTO INTERPRETE VALUES(174,5724,479,6);
INSERT INTO INTERPRETE VALUES(174,5725,479,7);
INSERT INTO INTERPRETE VALUES(174,5726,479,8);
INSERT INTO INTERPRETE VALUES(174,5727,479,9);
INSERT INTO INTERPRETE VALUES(174,5728,479,10);
INSERT INTO INTERPRETE VALUES(61,5735,480,3);
INSERT INTO INTERPRETE VALUES(61,5736,480,4);
INSERT INTO INTERPRETE VALUES(61,5737,480,5);
INSERT INTO INTERPRETE VALUES(61,5738,480,6);
INSERT INTO INTERPRETE VALUES(61,5739,480,7);
INSERT INTO INTERPRETE VALUES(61,5740,480,8);
INSERT INTO INTERPRETE VALUES(61,5741,480,9);
INSERT INTO INTERPRETE VALUES(61,5742,480,10);
INSERT INTO INTERPRETE VALUES(61,5743,480,11);
INSERT INTO INTERPRETE VALUES(61,5744,480,12);
INSERT INTO INTERPRETE VALUES(61,5745,480,13);
INSERT INTO INTERPRETE VALUES(175,5746,481,1);
INSERT INTO INTERPRETE VALUES(175,5747,481,2);
INSERT INTO INTERPRETE VALUES(175,5748,481,3);
INSERT INTO INTERPRETE VALUES(175,5749,481,4);
INSERT INTO INTERPRETE VALUES(175,5750,481,5);
INSERT INTO INTERPRETE VALUES(175,5751,481,6);
INSERT INTO INTERPRETE VALUES(175,5752,481,7);
INSERT INTO INTERPRETE VALUES(175,5753,481,8);
INSERT INTO INTERPRETE VALUES(175,5754,481,9);
INSERT INTO INTERPRETE VALUES(175,5755,481,10);
INSERT INTO INTERPRETE VALUES(175,5756,481,11);
INSERT INTO INTERPRETE VALUES(175,5757,481,12);
INSERT INTO INTERPRETE VALUES(175,5758,481,13);
INSERT INTO INTERPRETE VALUES(175,5759,481,14);
INSERT INTO INTERPRETE VALUES(175,5760,481,15);
INSERT INTO INTERPRETE VALUES(63,5761,482,1);
INSERT INTO INTERPRETE VALUES(63,5762,482,2);
INSERT INTO INTERPRETE VALUES(63,5763,482,3);
INSERT INTO INTERPRETE VALUES(63,5764,482,4);
INSERT INTO INTERPRETE VALUES(63,5765,482,5);
INSERT INTO INTERPRETE VALUES(63,5766,482,6);
INSERT INTO INTERPRETE VALUES(63,5767,482,7);
INSERT INTO INTERPRETE VALUES(63,5768,482,8);
INSERT INTO INTERPRETE VALUES(63,5769,482,9);
INSERT INTO INTERPRETE VALUES(176,5770,483,1);
INSERT INTO INTERPRETE VALUES(44,5668,475,9);
INSERT INTO INTERPRETE VALUES(176,5771,483,2);
INSERT INTO INTERPRETE VALUES(176,5772,483,3);
INSERT INTO INTERPRETE VALUES(176,5773,483,4);
INSERT INTO INTERPRETE VALUES(176,5774,483,5);
INSERT INTO INTERPRETE VALUES(176,5775,483,6);
INSERT INTO INTERPRETE VALUES(176,5776,483,9);
INSERT INTO INTERPRETE VALUES(176,5779,483,10);
INSERT INTO INTERPRETE VALUES(176,5781,483,12);
INSERT INTO INTERPRETE VALUES(176,5776,483,13);
INSERT INTO INTERPRETE VALUES(176,5783,483,14);
INSERT INTO INTERPRETE VALUES(176,5784,483,15);
INSERT INTO INTERPRETE VALUES(176,5786,483,17);
INSERT INTO INTERPRETE VALUES(176,5787,483,18);
INSERT INTO INTERPRETE VALUES(176,5785,483,16);
INSERT INTO INTERPRETE VALUES(176,5789,483,20);
INSERT INTO INTERPRETE VALUES(71,5790,484,1);
INSERT INTO INTERPRETE VALUES(71,5791,484,2);
INSERT INTO INTERPRETE VALUES(71,5792,484,3);
INSERT INTO INTERPRETE VALUES(71,5793,484,4);
INSERT INTO INTERPRETE VALUES(71,5794,484,5);
INSERT INTO INTERPRETE VALUES(71,5795,484,6);
INSERT INTO INTERPRETE VALUES(71,5797,484,8);
INSERT INTO INTERPRETE VALUES(71,5798,484,9);
INSERT INTO INTERPRETE VALUES(176,5788,483,19);
INSERT INTO INTERPRETE VALUES(71,5796,484,7);
INSERT INTO INTERPRETE VALUES(71,5799,485,1);
INSERT INTO INTERPRETE VALUES(71,5800,485,2);
INSERT INTO INTERPRETE VALUES(71,5801,485,3);
INSERT INTO INTERPRETE VALUES(71,5803,485,5);
INSERT INTO INTERPRETE VALUES(71,5804,485,6);
INSERT INTO INTERPRETE VALUES(71,5805,485,7);
INSERT INTO INTERPRETE VALUES(71,5806,485,8);
INSERT INTO INTERPRETE VALUES(71,5807,485,9);
INSERT INTO INTERPRETE VALUES(71,5812,486,1);
INSERT INTO INTERPRETE VALUES(71,5813,486,2);
INSERT INTO INTERPRETE VALUES(71,5815,486,4);
INSERT INTO INTERPRETE VALUES(71,5816,486,5);
INSERT INTO INTERPRETE VALUES(71,5817,486,6);
INSERT INTO INTERPRETE VALUES(71,5818,486,7);
INSERT INTO INTERPRETE VALUES(71,5819,486,8);
INSERT INTO INTERPRETE VALUES(71,5820,486,9);
INSERT INTO INTERPRETE VALUES(71,5822,486,11);
INSERT INTO INTERPRETE VALUES(71,5823,486,12);
INSERT INTO INTERPRETE VALUES(176,5824,487,1);
INSERT INTO INTERPRETE VALUES(176,5825,487,2);
INSERT INTO INTERPRETE VALUES(176,5826,487,3);
INSERT INTO INTERPRETE VALUES(176,5786,487,4);
INSERT INTO INTERPRETE VALUES(176,5781,488,2);
INSERT INTO INTERPRETE VALUES(176,5830,488,3);
INSERT INTO INTERPRETE VALUES(176,5831,488,4);
INSERT INTO INTERPRETE VALUES(176,5832,488,5);
INSERT INTO INTERPRETE VALUES(176,5833,488,6);
INSERT INTO INTERPRETE VALUES(176,5834,488,7);
INSERT INTO INTERPRETE VALUES(176,5835,488,8);
INSERT INTO INTERPRETE VALUES(176,5836,488,9);
INSERT INTO INTERPRETE VALUES(176,5832,488,10);
INSERT INTO INTERPRETE VALUES(176,5838,488,11);
INSERT INTO INTERPRETE VALUES(71,5808,485,10);
INSERT INTO INTERPRETE VALUES(71,5809,485,11);
INSERT INTO INTERPRETE VALUES(71,5810,485,12);
INSERT INTO INTERPRETE VALUES(71,5811,485,13);
INSERT INTO INTERPRETE VALUES(71,5821,486,10);
INSERT INTO INTERPRETE VALUES(176,5839,488,12);
INSERT INTO INTERPRETE VALUES(176,5840,488,13);
INSERT INTO INTERPRETE VALUES(176,5832,488,14);
INSERT INTO INTERPRETE VALUES(83,5844,489,3);
INSERT INTO INTERPRETE VALUES(83,5848,489,7);
INSERT INTO INTERPRETE VALUES(71,5853,490,4);
INSERT INTO INTERPRETE VALUES(71,5854,490,5);
INSERT INTO INTERPRETE VALUES(71,5855,490,6);
INSERT INTO INTERPRETE VALUES(71,5857,490,8);
INSERT INTO INTERPRETE VALUES(71,5858,490,9);
INSERT INTO INTERPRETE VALUES(71,5859,490,10);
INSERT INTO INTERPRETE VALUES(71,5860,490,11);
INSERT INTO INTERPRETE VALUES(62,5861,491,1);
INSERT INTO INTERPRETE VALUES(62,5862,491,2);
INSERT INTO INTERPRETE VALUES(62,5863,491,3);
INSERT INTO INTERPRETE VALUES(62,5864,491,4);
INSERT INTO INTERPRETE VALUES(62,5865,491,5);
INSERT INTO INTERPRETE VALUES(62,5866,491,6);
INSERT INTO INTERPRETE VALUES(62,5867,491,7);
INSERT INTO INTERPRETE VALUES(62,5868,491,8);
INSERT INTO INTERPRETE VALUES(62,5869,492,1);
INSERT INTO INTERPRETE VALUES(62,5870,492,2);
INSERT INTO INTERPRETE VALUES(62,5871,492,3);
INSERT INTO INTERPRETE VALUES(62,5873,492,5);
INSERT INTO INTERPRETE VALUES(62,5874,492,6);
INSERT INTO INTERPRETE VALUES(62,5875,492,7);
INSERT INTO INTERPRETE VALUES(62,5876,492,8);
INSERT INTO INTERPRETE VALUES(44,5878,493,2);
INSERT INTO INTERPRETE VALUES(44,5880,493,4);
INSERT INTO INTERPRETE VALUES(44,5884,493,8);
INSERT INTO INTERPRETE VALUES(44,5885,493,9);
INSERT INTO INTERPRETE VALUES(44,5889,493,13);
INSERT INTO INTERPRETE VALUES(62,5925,496,2);
INSERT INTO INTERPRETE VALUES(44,5892,493,16);
INSERT INTO INTERPRETE VALUES(62,5926,496,3);
INSERT INTO INTERPRETE VALUES(62,5927,496,4);
INSERT INTO INTERPRETE VALUES(62,5928,496,5);
INSERT INTO INTERPRETE VALUES(62,5929,496,6);
INSERT INTO INTERPRETE VALUES(62,5930,496,7);
INSERT INTO INTERPRETE VALUES(62,5931,496,8);
INSERT INTO INTERPRETE VALUES(62,5932,496,9);
INSERT INTO INTERPRETE VALUES(62,5933,497,1);
INSERT INTO INTERPRETE VALUES(62,5934,497,2);
INSERT INTO INTERPRETE VALUES(62,5935,497,3);
INSERT INTO INTERPRETE VALUES(62,5936,497,4);
INSERT INTO INTERPRETE VALUES(62,5937,497,5);
INSERT INTO INTERPRETE VALUES(62,5939,497,7);
INSERT INTO INTERPRETE VALUES(62,5940,497,8);
INSERT INTO INTERPRETE VALUES(62,5941,497,9);
INSERT INTO INTERPRETE VALUES(177,5942,498,1);
INSERT INTO INTERPRETE VALUES(177,5943,498,2);
INSERT INTO INTERPRETE VALUES(177,5944,498,3);
INSERT INTO INTERPRETE VALUES(177,5945,498,4);
INSERT INTO INTERPRETE VALUES(177,5946,498,5);
INSERT INTO INTERPRETE VALUES(177,5948,498,7);
INSERT INTO INTERPRETE VALUES(177,5949,498,8);
INSERT INTO INTERPRETE VALUES(177,5950,498,9);
INSERT INTO INTERPRETE VALUES(177,5951,498,10);
INSERT INTO INTERPRETE VALUES(177,5952,498,11);
INSERT INTO INTERPRETE VALUES(177,5953,498,12);
INSERT INTO INTERPRETE VALUES(177,5954,498,13);
INSERT INTO INTERPRETE VALUES(177,5955,498,14);
INSERT INTO INTERPRETE VALUES(177,5956,498,15);
INSERT INTO INTERPRETE VALUES(177,5957,498,16);
INSERT INTO INTERPRETE VALUES(177,5958,498,17);
INSERT INTO INTERPRETE VALUES(177,5959,498,18);
INSERT INTO INTERPRETE VALUES(177,5960,498,19);
INSERT INTO INTERPRETE VALUES(176,5961,499,1);
INSERT INTO INTERPRETE VALUES(176,5962,499,2);
INSERT INTO INTERPRETE VALUES(176,5963,499,3);
INSERT INTO INTERPRETE VALUES(62,5938,497,6);
INSERT INTO INTERPRETE VALUES(176,5965,499,5);
INSERT INTO INTERPRETE VALUES(176,5966,499,6);
INSERT INTO INTERPRETE VALUES(176,5967,499,7);
INSERT INTO INTERPRETE VALUES(176,5969,499,9);
INSERT INTO INTERPRETE VALUES(176,5971,499,11);
INSERT INTO INTERPRETE VALUES(176,5972,499,12);
INSERT INTO INTERPRETE VALUES(176,5973,499,13);
INSERT INTO INTERPRETE VALUES(176,5974,499,14);
INSERT INTO INTERPRETE VALUES(178,5978,500,1);
INSERT INTO INTERPRETE VALUES(178,5979,500,2);
INSERT INTO INTERPRETE VALUES(178,5980,500,3);
INSERT INTO INTERPRETE VALUES(178,5981,500,4);
INSERT INTO INTERPRETE VALUES(178,5982,500,5);
INSERT INTO INTERPRETE VALUES(178,5983,500,6);
INSERT INTO INTERPRETE VALUES(178,5984,500,7);
INSERT INTO INTERPRETE VALUES(178,5986,500,9);
INSERT INTO INTERPRETE VALUES(178,5987,500,10);
INSERT INTO INTERPRETE VALUES(178,5988,500,11);
INSERT INTO INTERPRETE VALUES(178,5989,500,12);
INSERT INTO INTERPRETE VALUES(143,5992,501,1);
INSERT INTO INTERPRETE VALUES(143,5993,501,2);
INSERT INTO INTERPRETE VALUES(143,5994,501,3);
INSERT INTO INTERPRETE VALUES(143,5995,501,4);
INSERT INTO INTERPRETE VALUES(143,5996,501,5);
INSERT INTO INTERPRETE VALUES(143,5997,501,6);
INSERT INTO INTERPRETE VALUES(143,5998,501,7);
INSERT INTO INTERPRETE VALUES(143,5999,501,8);
INSERT INTO INTERPRETE VALUES(143,6000,501,9);
INSERT INTO INTERPRETE VALUES(143,6001,501,10);
INSERT INTO INTERPRETE VALUES(143,6002,501,11);
INSERT INTO INTERPRETE VALUES(143,6003,501,12);
INSERT INTO INTERPRETE VALUES(143,6004,501,13);
INSERT INTO INTERPRETE VALUES(177,6005,502,1);
INSERT INTO INTERPRETE VALUES(177,6006,502,2);
INSERT INTO INTERPRETE VALUES(177,6007,502,3);
INSERT INTO INTERPRETE VALUES(177,6008,502,4);
INSERT INTO INTERPRETE VALUES(177,6009,502,5);
INSERT INTO INTERPRETE VALUES(177,6010,502,6);
INSERT INTO INTERPRETE VALUES(177,6011,502,7);
INSERT INTO INTERPRETE VALUES(177,6012,502,8);
INSERT INTO INTERPRETE VALUES(177,6013,502,9);
INSERT INTO INTERPRETE VALUES(177,6014,502,10);
INSERT INTO INTERPRETE VALUES(177,6015,502,11);
INSERT INTO INTERPRETE VALUES(177,6016,502,12);
INSERT INTO INTERPRETE VALUES(177,6017,502,13);
INSERT INTO INTERPRETE VALUES(179,6018,503,1);
INSERT INTO INTERPRETE VALUES(179,6019,503,2);
INSERT INTO INTERPRETE VALUES(179,6020,503,3);
INSERT INTO INTERPRETE VALUES(179,6021,503,4);
INSERT INTO INTERPRETE VALUES(179,6022,503,5);
INSERT INTO INTERPRETE VALUES(179,6023,503,6);
INSERT INTO INTERPRETE VALUES(179,6024,503,7);
INSERT INTO INTERPRETE VALUES(179,6025,503,8);
INSERT INTO INTERPRETE VALUES(179,6026,503,9);
INSERT INTO INTERPRETE VALUES(179,6027,503,10);
INSERT INTO INTERPRETE VALUES(179,6028,503,11);
INSERT INTO INTERPRETE VALUES(143,6030,504,1);
INSERT INTO INTERPRETE VALUES(143,6031,504,2);
INSERT INTO INTERPRETE VALUES(143,6032,504,3);
INSERT INTO INTERPRETE VALUES(143,6033,504,4);
INSERT INTO INTERPRETE VALUES(143,6034,504,5);
INSERT INTO INTERPRETE VALUES(143,6035,504,6);
INSERT INTO INTERPRETE VALUES(143,6036,504,7);
INSERT INTO INTERPRETE VALUES(143,6037,504,8);
INSERT INTO INTERPRETE VALUES(143,6038,504,9);
INSERT INTO INTERPRETE VALUES(143,6039,504,10);
INSERT INTO INTERPRETE VALUES(143,6040,504,11);
INSERT INTO INTERPRETE VALUES(143,6041,504,12);
INSERT INTO INTERPRETE VALUES(143,6042,504,13);
INSERT INTO INTERPRETE VALUES(66,6043,505,1);
INSERT INTO INTERPRETE VALUES(66,6044,505,2);
INSERT INTO INTERPRETE VALUES(66,6045,505,3);
INSERT INTO INTERPRETE VALUES(66,6046,505,4);
INSERT INTO INTERPRETE VALUES(66,6047,505,5);
INSERT INTO INTERPRETE VALUES(66,6048,505,6);
INSERT INTO INTERPRETE VALUES(66,6049,505,7);
INSERT INTO INTERPRETE VALUES(66,6052,505,10);
INSERT INTO INTERPRETE VALUES(66,6053,505,11);
INSERT INTO INTERPRETE VALUES(52,3709,506,1);
INSERT INTO INTERPRETE VALUES(178,5985,500,8);
INSERT INTO INTERPRETE VALUES(52,3706,506,2);
INSERT INTO INTERPRETE VALUES(52,1912,507,9);
INSERT INTO INTERPRETE VALUES(62,6075,508,1);
INSERT INTO INTERPRETE VALUES(62,6076,508,2);
INSERT INTO INTERPRETE VALUES(62,6078,508,4);
INSERT INTO INTERPRETE VALUES(62,6079,508,5);
INSERT INTO INTERPRETE VALUES(62,6080,508,6);
INSERT INTO INTERPRETE VALUES(176,6081,509,1);
INSERT INTO INTERPRETE VALUES(52,6072,507,7);
INSERT INTO INTERPRETE VALUES(62,6077,508,3);
INSERT INTO INTERPRETE VALUES(176,5962,509,2);
INSERT INTO INTERPRETE VALUES(176,6083,509,3);
INSERT INTO INTERPRETE VALUES(176,5786,509,4);
INSERT INTO INTERPRETE VALUES(52,1907,506,11);
INSERT INTO INTERPRETE VALUES(52,6066,507,1);
INSERT INTO INTERPRETE VALUES(176,5789,509,6);
INSERT INTO INTERPRETE VALUES(176,5774,509,13);
INSERT INTO INTERPRETE VALUES(176,6095,509,15);
INSERT INTO INTERPRETE VALUES(176,6097,509,17);
INSERT INTO INTERPRETE VALUES(176,6098,509,18);
INSERT INTO INTERPRETE VALUES(176,6099,509,19);
INSERT INTO INTERPRETE VALUES(176,5969,509,20);
INSERT INTO INTERPRETE VALUES(176,5770,509,21);
INSERT INTO INTERPRETE VALUES(176,5825,509,22);
INSERT INTO INTERPRETE VALUES(176,6104,509,24);
INSERT INTO INTERPRETE VALUES(176,5900,509,23);
INSERT INTO INTERPRETE VALUES(180,6160,513,1);
INSERT INTO INTERPRETE VALUES(180,6161,513,2);
INSERT INTO INTERPRETE VALUES(180,6162,513,3);
INSERT INTO INTERPRETE VALUES(180,6163,513,4);
INSERT INTO INTERPRETE VALUES(180,6164,513,5);
INSERT INTO INTERPRETE VALUES(180,6165,513,6);
INSERT INTO INTERPRETE VALUES(180,6166,513,7);
INSERT INTO INTERPRETE VALUES(180,6167,513,8);
INSERT INTO INTERPRETE VALUES(180,6168,513,9);
INSERT INTO INTERPRETE VALUES(180,6169,513,10);
INSERT INTO INTERPRETE VALUES(180,6170,513,11);
INSERT INTO INTERPRETE VALUES(180,6171,513,12);
INSERT INTO INTERPRETE VALUES(180,6172,513,13);
INSERT INTO INTERPRETE VALUES(180,6173,513,14);
INSERT INTO INTERPRETE VALUES(180,6174,513,15);
INSERT INTO INTERPRETE VALUES(123,6175,514,1);
INSERT INTO INTERPRETE VALUES(123,6176,514,2);
INSERT INTO INTERPRETE VALUES(123,6177,514,3);
INSERT INTO INTERPRETE VALUES(123,6178,514,4);
INSERT INTO INTERPRETE VALUES(123,6179,514,5);
INSERT INTO INTERPRETE VALUES(123,6180,514,6);
INSERT INTO INTERPRETE VALUES(123,6181,514,7);
INSERT INTO INTERPRETE VALUES(123,6182,514,8);
INSERT INTO INTERPRETE VALUES(123,6183,514,9);
INSERT INTO INTERPRETE VALUES(123,6184,514,10);
INSERT INTO INTERPRETE VALUES(123,6185,514,11);
INSERT INTO INTERPRETE VALUES(123,6186,514,12);
INSERT INTO INTERPRETE VALUES(123,6187,514,13);
INSERT INTO INTERPRETE VALUES(123,6188,514,14);
INSERT INTO INTERPRETE VALUES(181,6189,515,1);
INSERT INTO INTERPRETE VALUES(181,6190,515,2);
INSERT INTO INTERPRETE VALUES(181,6191,515,3);
INSERT INTO INTERPRETE VALUES(181,6192,515,4);
INSERT INTO INTERPRETE VALUES(181,6193,515,5);
INSERT INTO INTERPRETE VALUES(181,6194,515,6);
INSERT INTO INTERPRETE VALUES(181,6195,515,7);
INSERT INTO INTERPRETE VALUES(181,9991,515,8);
INSERT INTO INTERPRETE VALUES(181,6197,515,9);
INSERT INTO INTERPRETE VALUES(181,6198,515,10);
INSERT INTO INTERPRETE VALUES(181,6199,515,11);
INSERT INTO INTERPRETE VALUES(181,6200,515,12);
INSERT INTO INTERPRETE VALUES(181,6201,515,13);
INSERT INTO INTERPRETE VALUES(181,6202,515,14);
INSERT INTO INTERPRETE VALUES(49,6217,517,1);
INSERT INTO INTERPRETE VALUES(49,6218,517,2);
INSERT INTO INTERPRETE VALUES(49,6219,517,3);
INSERT INTO INTERPRETE VALUES(49,6220,517,4);
INSERT INTO INTERPRETE VALUES(49,6221,517,5);
INSERT INTO INTERPRETE VALUES(49,6222,517,6);
INSERT INTO INTERPRETE VALUES(49,6224,517,8);
INSERT INTO INTERPRETE VALUES(49,6225,517,9);
INSERT INTO INTERPRETE VALUES(49,6226,517,10);
INSERT INTO INTERPRETE VALUES(49,6227,517,11);
INSERT INTO INTERPRETE VALUES(49,6228,517,12);
INSERT INTO INTERPRETE VALUES(49,6229,517,13);
INSERT INTO INTERPRETE VALUES(49,6230,517,14);
INSERT INTO INTERPRETE VALUES(100,6231,518,1);
INSERT INTO INTERPRETE VALUES(100,6232,518,2);
INSERT INTO INTERPRETE VALUES(100,6233,518,3);
INSERT INTO INTERPRETE VALUES(100,6234,518,4);
INSERT INTO INTERPRETE VALUES(100,6235,518,5);
INSERT INTO INTERPRETE VALUES(100,6236,518,6);
INSERT INTO INTERPRETE VALUES(100,6237,518,7);
INSERT INTO INTERPRETE VALUES(100,6238,518,8);
INSERT INTO INTERPRETE VALUES(100,6239,518,9);
INSERT INTO INTERPRETE VALUES(100,6240,518,10);
INSERT INTO INTERPRETE VALUES(83,1956,519,1);
INSERT INTO INTERPRETE VALUES(83,6243,519,3);
INSERT INTO INTERPRETE VALUES(83,1958,519,4);
INSERT INTO INTERPRETE VALUES(83,6245,519,5);
INSERT INTO INTERPRETE VALUES(83,1297,519,6);
INSERT INTO INTERPRETE VALUES(83,6247,519,7);
INSERT INTO INTERPRETE VALUES(83,6248,519,8);
INSERT INTO INTERPRETE VALUES(83,6249,519,9);
INSERT INTO INTERPRETE VALUES(83,5849,519,10);
INSERT INTO INTERPRETE VALUES(83,6251,519,11);
INSERT INTO INTERPRETE VALUES(83,6252,519,12);
INSERT INTO INTERPRETE VALUES(109,4449,520,1);
INSERT INTO INTERPRETE VALUES(109,6254,520,2);
INSERT INTO INTERPRETE VALUES(109,6255,520,3);
INSERT INTO INTERPRETE VALUES(109,3910,520,4);
INSERT INTO INTERPRETE VALUES(109,4344,520,5);
INSERT INTO INTERPRETE VALUES(109,6258,520,6);
INSERT INTO INTERPRETE VALUES(109,6259,520,7);
INSERT INTO INTERPRETE VALUES(109,4341,520,8);
INSERT INTO INTERPRETE VALUES(109,4338,520,9);
INSERT INTO INTERPRETE VALUES(109,4715,520,11);
INSERT INTO INTERPRETE VALUES(183,6265,521,1);
INSERT INTO INTERPRETE VALUES(183,6266,521,2);
INSERT INTO INTERPRETE VALUES(183,6267,521,3);
INSERT INTO INTERPRETE VALUES(183,6268,521,4);
INSERT INTO INTERPRETE VALUES(183,6269,521,5);
INSERT INTO INTERPRETE VALUES(183,6270,521,6);
INSERT INTO INTERPRETE VALUES(183,6271,521,7);
INSERT INTO INTERPRETE VALUES(183,6272,521,8);
INSERT INTO INTERPRETE VALUES(183,6273,521,9);
INSERT INTO INTERPRETE VALUES(183,6274,521,10);
INSERT INTO INTERPRETE VALUES(183,6275,521,11);
INSERT INTO INTERPRETE VALUES(183,6276,521,12);
INSERT INTO INTERPRETE VALUES(183,6277,521,13);
INSERT INTO INTERPRETE VALUES(183,6278,521,14);
INSERT INTO INTERPRETE VALUES(183,6279,521,15);
INSERT INTO INTERPRETE VALUES(183,6280,521,16);
INSERT INTO INTERPRETE VALUES(183,6281,521,17);
INSERT INTO INTERPRETE VALUES(183,6282,521,18);
INSERT INTO INTERPRETE VALUES(183,6283,521,19);
INSERT INTO INTERPRETE VALUES(183,6284,521,20);
INSERT INTO INTERPRETE VALUES(184,6285,522,1);
INSERT INTO INTERPRETE VALUES(184,6286,522,2);
INSERT INTO INTERPRETE VALUES(184,6287,522,3);
INSERT INTO INTERPRETE VALUES(184,6288,522,4);
INSERT INTO INTERPRETE VALUES(184,6289,522,5);
INSERT INTO INTERPRETE VALUES(184,6290,522,6);
INSERT INTO INTERPRETE VALUES(184,6291,522,7);
INSERT INTO INTERPRETE VALUES(184,6292,522,8);
INSERT INTO INTERPRETE VALUES(184,6293,522,9);
INSERT INTO INTERPRETE VALUES(184,6294,522,10);
INSERT INTO INTERPRETE VALUES(184,6295,522,11);
INSERT INTO INTERPRETE VALUES(184,6296,522,12);
INSERT INTO INTERPRETE VALUES(183,6297,523,1);
INSERT INTO INTERPRETE VALUES(183,2663,523,2);
INSERT INTO INTERPRETE VALUES(183,6299,523,3);
INSERT INTO INTERPRETE VALUES(183,6300,523,4);
INSERT INTO INTERPRETE VALUES(183,6301,523,5);
INSERT INTO INTERPRETE VALUES(183,6302,523,6);
INSERT INTO INTERPRETE VALUES(183,6303,523,7);
INSERT INTO INTERPRETE VALUES(183,6304,523,8);
INSERT INTO INTERPRETE VALUES(183,6305,523,9);
INSERT INTO INTERPRETE VALUES(183,6306,523,10);
INSERT INTO INTERPRETE VALUES(183,6307,523,11);
INSERT INTO INTERPRETE VALUES(183,6308,523,12);
INSERT INTO INTERPRETE VALUES(183,6309,523,13);
INSERT INTO INTERPRETE VALUES(183,6310,523,14);
INSERT INTO INTERPRETE VALUES(183,6311,523,15);
INSERT INTO INTERPRETE VALUES(183,6312,523,16);
INSERT INTO INTERPRETE VALUES(183,6313,523,17);
INSERT INTO INTERPRETE VALUES(183,6315,523,19);
INSERT INTO INTERPRETE VALUES(183,6316,523,20);
INSERT INTO INTERPRETE VALUES(83,5849,524,1);
INSERT INTO INTERPRETE VALUES(83,6318,524,2);
INSERT INTO INTERPRETE VALUES(83,6319,524,3);
INSERT INTO INTERPRETE VALUES(83,6247,524,4);
INSERT INTO INTERPRETE VALUES(83,5848,524,5);
INSERT INTO INTERPRETE VALUES(83,5844,524,6);
INSERT INTO INTERPRETE VALUES(83,6323,524,7);
INSERT INTO INTERPRETE VALUES(83,6324,524,8);
INSERT INTO INTERPRETE VALUES(83,6325,525,1);
INSERT INTO INTERPRETE VALUES(83,10025,525,2);
INSERT INTO INTERPRETE VALUES(83,6327,525,3);
INSERT INTO INTERPRETE VALUES(83,6328,525,4);
INSERT INTO INTERPRETE VALUES(83,6329,525,5);
INSERT INTO INTERPRETE VALUES(83,6330,525,6);
INSERT INTO INTERPRETE VALUES(83,6331,525,7);
INSERT INTO INTERPRETE VALUES(83,6332,525,8);
INSERT INTO INTERPRETE VALUES(83,6333,525,9);
INSERT INTO INTERPRETE VALUES(83,6334,525,10);
INSERT INTO INTERPRETE VALUES(83,6335,526,1);
INSERT INTO INTERPRETE VALUES(83,6336,526,2);
INSERT INTO INTERPRETE VALUES(83,6337,526,3);
INSERT INTO INTERPRETE VALUES(83,6338,526,4);
INSERT INTO INTERPRETE VALUES(83,6339,526,5);
INSERT INTO INTERPRETE VALUES(83,5846,526,7);
INSERT INTO INTERPRETE VALUES(83,6342,526,8);
INSERT INTO INTERPRETE VALUES(83,6343,526,9);
INSERT INTO INTERPRETE VALUES(185,6344,527,1);
INSERT INTO INTERPRETE VALUES(185,6345,527,2);
INSERT INTO INTERPRETE VALUES(185,6346,527,3);
INSERT INTO INTERPRETE VALUES(185,6347,527,4);
INSERT INTO INTERPRETE VALUES(185,6348,527,5);
INSERT INTO INTERPRETE VALUES(185,6349,527,6);
INSERT INTO INTERPRETE VALUES(185,6350,527,7);
INSERT INTO INTERPRETE VALUES(185,6351,527,8);
INSERT INTO INTERPRETE VALUES(185,6352,527,9);
INSERT INTO INTERPRETE VALUES(185,6353,527,10);
INSERT INTO INTERPRETE VALUES(185,6354,527,11);
INSERT INTO INTERPRETE VALUES(185,6355,527,12);
INSERT INTO INTERPRETE VALUES(185,6356,527,13);
INSERT INTO INTERPRETE VALUES(185,6357,527,14);
INSERT INTO INTERPRETE VALUES(185,6358,527,15);
INSERT INTO INTERPRETE VALUES(109,6359,528,1);
INSERT INTO INTERPRETE VALUES(109,6360,528,2);
INSERT INTO INTERPRETE VALUES(109,6361,528,3);
INSERT INTO INTERPRETE VALUES(109,6362,528,4);
INSERT INTO INTERPRETE VALUES(109,3910,528,5);
INSERT INTO INTERPRETE VALUES(109,6254,528,6);
INSERT INTO INTERPRETE VALUES(109,6365,528,7);
INSERT INTO INTERPRETE VALUES(109,6366,528,8);
INSERT INTO INTERPRETE VALUES(109,6367,528,9);
INSERT INTO INTERPRETE VALUES(109,6368,528,10);
INSERT INTO INTERPRETE VALUES(109,6369,528,11);
INSERT INTO INTERPRETE VALUES(109,3909,528,12);
INSERT INTO INTERPRETE VALUES(109,6371,528,13);
INSERT INTO INTERPRETE VALUES(109,6372,528,14);
INSERT INTO INTERPRETE VALUES(109,4449,528,15);
INSERT INTO INTERPRETE VALUES(109,6255,529,1);
INSERT INTO INTERPRETE VALUES(109,4344,529,2);
INSERT INTO INTERPRETE VALUES(109,4341,529,3);
INSERT INTO INTERPRETE VALUES(109,6377,529,4);
INSERT INTO INTERPRETE VALUES(109,6378,529,5);
INSERT INTO INTERPRETE VALUES(109,6379,529,6);
INSERT INTO INTERPRETE VALUES(109,3904,529,7);
INSERT INTO INTERPRETE VALUES(109,6381,529,8);
INSERT INTO INTERPRETE VALUES(109,6382,529,9);
INSERT INTO INTERPRETE VALUES(109,6383,529,10);
INSERT INTO INTERPRETE VALUES(109,6384,529,11);
INSERT INTO INTERPRETE VALUES(109,6385,529,12);
INSERT INTO INTERPRETE VALUES(109,6386,529,13);
INSERT INTO INTERPRETE VALUES(109,6387,529,14);
INSERT INTO INTERPRETE VALUES(109,6388,529,15);
INSERT INTO INTERPRETE VALUES(186,6389,530,1);
INSERT INTO INTERPRETE VALUES(186,6390,530,2);
INSERT INTO INTERPRETE VALUES(186,6391,530,3);
INSERT INTO INTERPRETE VALUES(186,6392,530,4);
INSERT INTO INTERPRETE VALUES(186,6393,530,5);
INSERT INTO INTERPRETE VALUES(186,6394,530,6);
INSERT INTO INTERPRETE VALUES(186,6395,530,7);
INSERT INTO INTERPRETE VALUES(186,6396,530,8);
INSERT INTO INTERPRETE VALUES(186,6397,530,9);
INSERT INTO INTERPRETE VALUES(186,6398,530,10);
INSERT INTO INTERPRETE VALUES(186,6399,530,11);
INSERT INTO INTERPRETE VALUES(186,6400,530,12);
INSERT INTO INTERPRETE VALUES(186,6401,530,13);
INSERT INTO INTERPRETE VALUES(186,6402,530,14);
INSERT INTO INTERPRETE VALUES(186,6403,530,15);
INSERT INTO INTERPRETE VALUES(186,6404,531,1);
INSERT INTO INTERPRETE VALUES(186,6405,531,2);
INSERT INTO INTERPRETE VALUES(186,6406,531,3);
INSERT INTO INTERPRETE VALUES(186,6407,531,4);
INSERT INTO INTERPRETE VALUES(186,6408,531,5);
INSERT INTO INTERPRETE VALUES(186,6409,531,6);
INSERT INTO INTERPRETE VALUES(186,6410,531,7);
INSERT INTO INTERPRETE VALUES(186,6411,531,8);
INSERT INTO INTERPRETE VALUES(186,6412,531,9);
INSERT INTO INTERPRETE VALUES(186,6413,531,10);
INSERT INTO INTERPRETE VALUES(186,6414,531,11);
INSERT INTO INTERPRETE VALUES(186,6415,531,12);
INSERT INTO INTERPRETE VALUES(186,6416,531,13);
INSERT INTO INTERPRETE VALUES(186,6417,532,1);
INSERT INTO INTERPRETE VALUES(186,6410,532,2);
INSERT INTO INTERPRETE VALUES(186,6419,532,3);
INSERT INTO INTERPRETE VALUES(186,6406,532,4);
INSERT INTO INTERPRETE VALUES(186,6421,532,5);
INSERT INTO INTERPRETE VALUES(186,6422,532,6);
INSERT INTO INTERPRETE VALUES(186,6423,532,7);
INSERT INTO INTERPRETE VALUES(186,6424,532,8);
INSERT INTO INTERPRETE VALUES(186,6425,532,9);
INSERT INTO INTERPRETE VALUES(186,6409,532,10);
INSERT INTO INTERPRETE VALUES(186,6427,532,11);
INSERT INTO INTERPRETE VALUES(186,6405,532,12);
INSERT INTO INTERPRETE VALUES(186,6416,532,13);
INSERT INTO INTERPRETE VALUES(186,6430,532,14);
INSERT INTO INTERPRETE VALUES(186,6431,532,15);
INSERT INTO INTERPRETE VALUES(186,6432,532,16);
INSERT INTO INTERPRETE VALUES(186,6413,532,17);
INSERT INTO INTERPRETE VALUES(186,6434,532,18);
INSERT INTO INTERPRETE VALUES(186,6435,532,19);
INSERT INTO INTERPRETE VALUES(186,6436,532,20);
INSERT INTO INTERPRETE VALUES(186,6414,532,21);
INSERT INTO INTERPRETE VALUES(186,6438,532,22);
INSERT INTO INTERPRETE VALUES(186,6439,532,23);
INSERT INTO INTERPRETE VALUES(186,6440,532,24);
INSERT INTO INTERPRETE VALUES(186,6441,533,1);
INSERT INTO INTERPRETE VALUES(186,6442,533,2);
INSERT INTO INTERPRETE VALUES(186,6443,533,3);
INSERT INTO INTERPRETE VALUES(186,6444,533,4);
INSERT INTO INTERPRETE VALUES(186,6445,533,5);
INSERT INTO INTERPRETE VALUES(186,6446,533,6);
INSERT INTO INTERPRETE VALUES(186,6447,533,7);
INSERT INTO INTERPRETE VALUES(186,6448,533,8);
INSERT INTO INTERPRETE VALUES(186,6449,533,9);
INSERT INTO INTERPRETE VALUES(186,6450,533,10);
INSERT INTO INTERPRETE VALUES(186,6451,533,11);
INSERT INTO INTERPRETE VALUES(186,6452,533,12);
INSERT INTO INTERPRETE VALUES(186,6453,533,13);
INSERT INTO INTERPRETE VALUES(186,6454,533,14);
INSERT INTO INTERPRETE VALUES(186,6455,533,15);
INSERT INTO INTERPRETE VALUES(186,6456,533,16);
INSERT INTO INTERPRETE VALUES(186,6457,533,17);
INSERT INTO INTERPRETE VALUES(42,5420,535,1);
INSERT INTO INTERPRETE VALUES(42,5421,535,2);
INSERT INTO INTERPRETE VALUES(42,5422,535,3);
INSERT INTO INTERPRETE VALUES(42,5423,535,4);
INSERT INTO INTERPRETE VALUES(42,5424,535,5);
INSERT INTO INTERPRETE VALUES(42,5425,535,6);
INSERT INTO INTERPRETE VALUES(42,5426,535,7);
INSERT INTO INTERPRETE VALUES(42,5427,535,8);
INSERT INTO INTERPRETE VALUES(42,5428,535,9);
INSERT INTO INTERPRETE VALUES(109,6477,536,1);
INSERT INTO INTERPRETE VALUES(109,6478,536,2);
INSERT INTO INTERPRETE VALUES(109,6479,536,3);
INSERT INTO INTERPRETE VALUES(109,6480,536,4);
INSERT INTO INTERPRETE VALUES(109,6481,536,5);
INSERT INTO INTERPRETE VALUES(109,6482,536,6);
INSERT INTO INTERPRETE VALUES(109,6483,536,7);
INSERT INTO INTERPRETE VALUES(109,6484,536,8);
INSERT INTO INTERPRETE VALUES(109,6485,536,9);
INSERT INTO INTERPRETE VALUES(109,6486,536,10);
INSERT INTO INTERPRETE VALUES(109,6487,536,11);
INSERT INTO INTERPRETE VALUES(109,6488,536,12);
INSERT INTO INTERPRETE VALUES(109,6489,536,13);
INSERT INTO INTERPRETE VALUES(187,2378,537,1);
INSERT INTO INTERPRETE VALUES(187,2383,537,2);
INSERT INTO INTERPRETE VALUES(187,2380,537,3);
INSERT INTO INTERPRETE VALUES(187,2381,537,5);
INSERT INTO INTERPRETE VALUES(187,2377,537,7);
INSERT INTO INTERPRETE VALUES(187,2385,537,8);
INSERT INTO INTERPRETE VALUES(187,2386,537,9);
INSERT INTO INTERPRETE VALUES(187,2379,537,10);
INSERT INTO INTERPRETE VALUES(187,2384,537,13);
INSERT INTO INTERPRETE VALUES(188,6503,538,1);
INSERT INTO INTERPRETE VALUES(188,6504,538,2);
INSERT INTO INTERPRETE VALUES(52,6461,534,4);
INSERT INTO INTERPRETE VALUES(52,6460,534,3);
INSERT INTO INTERPRETE VALUES(52,6466,534,9);
INSERT INTO INTERPRETE VALUES(188,6505,538,3);
INSERT INTO INTERPRETE VALUES(188,6506,538,4);
INSERT INTO INTERPRETE VALUES(188,6507,538,5);
INSERT INTO INTERPRETE VALUES(188,6508,538,6);
INSERT INTO INTERPRETE VALUES(188,6509,538,7);
INSERT INTO INTERPRETE VALUES(188,6510,538,8);
INSERT INTO INTERPRETE VALUES(188,6511,538,9);
INSERT INTO INTERPRETE VALUES(188,6512,538,10);
INSERT INTO INTERPRETE VALUES(188,6513,538,11);
INSERT INTO INTERPRETE VALUES(188,6514,538,12);
INSERT INTO INTERPRETE VALUES(188,6515,538,13);
INSERT INTO INTERPRETE VALUES(188,6516,538,14);
INSERT INTO INTERPRETE VALUES(188,6517,538,15);
INSERT INTO INTERPRETE VALUES(188,6518,538,16);
INSERT INTO INTERPRETE VALUES(3,6519,539,1);
INSERT INTO INTERPRETE VALUES(3,64,539,2);
INSERT INTO INTERPRETE VALUES(3,194,539,3);
INSERT INTO INTERPRETE VALUES(3,106,539,4);
INSERT INTO INTERPRETE VALUES(3,6523,539,5);
INSERT INTO INTERPRETE VALUES(3,107,539,6);
INSERT INTO INTERPRETE VALUES(3,6525,539,7);
INSERT INTO INTERPRETE VALUES(3,112,539,8);
INSERT INTO INTERPRETE VALUES(3,6527,539,9);
INSERT INTO INTERPRETE VALUES(3,109,539,10);
INSERT INTO INTERPRETE VALUES(3,6529,539,11);
INSERT INTO INTERPRETE VALUES(3,67,539,12);
INSERT INTO INTERPRETE VALUES(3,199,539,13);
INSERT INTO INTERPRETE VALUES(3,6532,539,14);
INSERT INTO INTERPRETE VALUES(3,105,539,15);
INSERT INTO INTERPRETE VALUES(3,6534,539,16);
INSERT INTO INTERPRETE VALUES(3,6535,539,17);
INSERT INTO INTERPRETE VALUES(208,6536,540,1);
INSERT INTO INTERPRETE VALUES(208,6537,540,2);
INSERT INTO INTERPRETE VALUES(208,6538,540,3);
INSERT INTO INTERPRETE VALUES(208,6539,540,4);
INSERT INTO INTERPRETE VALUES(208,6540,540,5);
INSERT INTO INTERPRETE VALUES(208,6541,540,6);
INSERT INTO INTERPRETE VALUES(208,6542,540,7);
INSERT INTO INTERPRETE VALUES(208,6543,540,8);
INSERT INTO INTERPRETE VALUES(208,6544,540,9);
INSERT INTO INTERPRETE VALUES(208,6545,540,10);
INSERT INTO INTERPRETE VALUES(208,6546,540,11);
INSERT INTO INTERPRETE VALUES(208,6547,540,12);
INSERT INTO INTERPRETE VALUES(208,6548,540,13);
INSERT INTO INTERPRETE VALUES(191,6549,541,1);
INSERT INTO INTERPRETE VALUES(191,6550,541,2);
INSERT INTO INTERPRETE VALUES(191,6551,541,3);
INSERT INTO INTERPRETE VALUES(191,6553,541,5);
INSERT INTO INTERPRETE VALUES(191,6555,541,7);
INSERT INTO INTERPRETE VALUES(191,6556,541,8);
INSERT INTO INTERPRETE VALUES(191,6557,541,9);
INSERT INTO INTERPRETE VALUES(191,6558,541,10);
INSERT INTO INTERPRETE VALUES(191,6559,541,11);
INSERT INTO INTERPRETE VALUES(191,6560,541,12);
INSERT INTO INTERPRETE VALUES(14,6570,543,1);
INSERT INTO INTERPRETE VALUES(14,6571,543,2);
INSERT INTO INTERPRETE VALUES(14,6572,543,3);
INSERT INTO INTERPRETE VALUES(14,6573,543,4);
INSERT INTO INTERPRETE VALUES(14,6574,543,5);
INSERT INTO INTERPRETE VALUES(14,6575,543,6);
INSERT INTO INTERPRETE VALUES(14,6576,543,7);
INSERT INTO INTERPRETE VALUES(14,6577,543,8);
INSERT INTO INTERPRETE VALUES(14,6578,543,9);
INSERT INTO INTERPRETE VALUES(14,6579,543,10);
INSERT INTO INTERPRETE VALUES(14,6580,543,11);
INSERT INTO INTERPRETE VALUES(14,6582,543,13);
INSERT INTO INTERPRETE VALUES(14,6583,543,14);
INSERT INTO INTERPRETE VALUES(14,6584,543,15);
INSERT INTO INTERPRETE VALUES(14,5156,543,16);
INSERT INTO INTERPRETE VALUES(14,6586,543,17);
INSERT INTO INTERPRETE VALUES(14,6587,543,18);
INSERT INTO INTERPRETE VALUES(14,6588,543,19);
INSERT INTO INTERPRETE VALUES(14,6589,543,20);
INSERT INTO INTERPRETE VALUES(14,1793,543,22);
INSERT INTO INTERPRETE VALUES(14,6592,543,23);
INSERT INTO INTERPRETE VALUES(14,6593,543,24);
INSERT INTO INTERPRETE VALUES(14,6595,544,2);
INSERT INTO INTERPRETE VALUES(14,290,544,3);
INSERT INTO INTERPRETE VALUES(14,6597,544,4);
INSERT INTO INTERPRETE VALUES(14,6598,544,5);
INSERT INTO INTERPRETE VALUES(14,6599,544,6);
INSERT INTO INTERPRETE VALUES(14,6600,544,7);
INSERT INTO INTERPRETE VALUES(14,6601,544,8);
INSERT INTO INTERPRETE VALUES(14,6602,544,9);
INSERT INTO INTERPRETE VALUES(14,6603,545,1);
INSERT INTO INTERPRETE VALUES(14,6604,545,2);
INSERT INTO INTERPRETE VALUES(14,6605,545,3);
INSERT INTO INTERPRETE VALUES(14,6606,545,4);
INSERT INTO INTERPRETE VALUES(14,6607,545,5);
INSERT INTO INTERPRETE VALUES(14,6608,545,6);
INSERT INTO INTERPRETE VALUES(14,6609,545,7);
INSERT INTO INTERPRETE VALUES(14,6610,545,8);
INSERT INTO INTERPRETE VALUES(14,6611,545,9);
INSERT INTO INTERPRETE VALUES(14,6612,545,10);
INSERT INTO INTERPRETE VALUES(14,6613,545,11);
INSERT INTO INTERPRETE VALUES(193,6632,548,1);
INSERT INTO INTERPRETE VALUES(193,6633,548,2);
INSERT INTO INTERPRETE VALUES(193,6636,548,5);
INSERT INTO INTERPRETE VALUES(193,6637,548,6);
INSERT INTO INTERPRETE VALUES(193,6639,548,8);
INSERT INTO INTERPRETE VALUES(193,6640,548,9);
INSERT INTO INTERPRETE VALUES(193,6641,548,10);
INSERT INTO INTERPRETE VALUES(193,6642,548,11);
INSERT INTO INTERPRETE VALUES(193,6643,548,12);
INSERT INTO INTERPRETE VALUES(193,6644,548,13);
INSERT INTO INTERPRETE VALUES(193,6646,548,15);
INSERT INTO INTERPRETE VALUES(194,6661,549,14);
INSERT INTO INTERPRETE VALUES(14,6662,550,1);
INSERT INTO INTERPRETE VALUES(14,6663,550,2);
INSERT INTO INTERPRETE VALUES(14,6664,550,3);
INSERT INTO INTERPRETE VALUES(14,6665,550,4);
INSERT INTO INTERPRETE VALUES(14,6666,550,5);
INSERT INTO INTERPRETE VALUES(14,6667,550,6);
INSERT INTO INTERPRETE VALUES(14,6668,550,7);
INSERT INTO INTERPRETE VALUES(14,6669,550,8);
INSERT INTO INTERPRETE VALUES(196,6683,553,3);
INSERT INTO INTERPRETE VALUES(196,6685,553,5);
INSERT INTO INTERPRETE VALUES(14,6590,543,21);
INSERT INTO INTERPRETE VALUES(196,6686,553,6);
INSERT INTO INTERPRETE VALUES(194,6656,549,9);
INSERT INTO INTERPRETE VALUES(196,6687,553,7);
INSERT INTO INTERPRETE VALUES(196,6689,553,9);
INSERT INTO INTERPRETE VALUES(196,6691,553,11);
INSERT INTO INTERPRETE VALUES(196,6692,553,12);
INSERT INTO INTERPRETE VALUES(196,6693,553,13);
INSERT INTO INTERPRETE VALUES(196,6694,553,14);
INSERT INTO INTERPRETE VALUES(196,6696,553,16);
INSERT INTO INTERPRETE VALUES(196,6697,553,17);
INSERT INTO INTERPRETE VALUES(196,6738,556,1);
INSERT INTO INTERPRETE VALUES(196,6740,556,3);
INSERT INTO INTERPRETE VALUES(196,6741,556,4);
INSERT INTO INTERPRETE VALUES(196,6742,556,5);
INSERT INTO INTERPRETE VALUES(197,6744,557,1);
INSERT INTO INTERPRETE VALUES(197,6745,557,2);
INSERT INTO INTERPRETE VALUES(197,6746,557,3);
INSERT INTO INTERPRETE VALUES(197,6747,557,4);
INSERT INTO INTERPRETE VALUES(197,6748,557,5);
INSERT INTO INTERPRETE VALUES(198,6749,558,1);
INSERT INTO INTERPRETE VALUES(198,6750,558,2);
INSERT INTO INTERPRETE VALUES(198,6772,558,24);
INSERT INTO INTERPRETE VALUES(198,6773,558,25);
INSERT INTO INTERPRETE VALUES(198,6774,559,1);
INSERT INTO INTERPRETE VALUES(198,6775,559,2);
INSERT INTO INTERPRETE VALUES(198,6776,559,3);
INSERT INTO INTERPRETE VALUES(198,6777,559,4);
INSERT INTO INTERPRETE VALUES(198,6778,559,5);
INSERT INTO INTERPRETE VALUES(198,6779,559,6);
INSERT INTO INTERPRETE VALUES(198,6780,559,7);
INSERT INTO INTERPRETE VALUES(198,6781,559,8);
INSERT INTO INTERPRETE VALUES(198,6782,559,9);
INSERT INTO INTERPRETE VALUES(198,6783,559,10);
INSERT INTO INTERPRETE VALUES(198,6784,559,11);
INSERT INTO INTERPRETE VALUES(198,6785,559,12);
INSERT INTO INTERPRETE VALUES(198,6786,559,13);
INSERT INTO INTERPRETE VALUES(198,6787,559,14);
INSERT INTO INTERPRETE VALUES(198,6788,559,15);
INSERT INTO INTERPRETE VALUES(198,6789,559,16);
INSERT INTO INTERPRETE VALUES(198,6790,559,17);
INSERT INTO INTERPRETE VALUES(198,6791,559,18);
INSERT INTO INTERPRETE VALUES(198,6792,559,19);
INSERT INTO INTERPRETE VALUES(198,6793,559,20);
INSERT INTO INTERPRETE VALUES(198,6794,559,21);
INSERT INTO INTERPRETE VALUES(198,6795,559,22);
INSERT INTO INTERPRETE VALUES(198,6796,559,23);
INSERT INTO INTERPRETE VALUES(199,6797,560,1);
INSERT INTO INTERPRETE VALUES(199,6798,560,2);
INSERT INTO INTERPRETE VALUES(199,6799,560,3);
INSERT INTO INTERPRETE VALUES(199,6800,560,4);
INSERT INTO INTERPRETE VALUES(199,6801,560,5);
INSERT INTO INTERPRETE VALUES(199,6802,560,6);
INSERT INTO INTERPRETE VALUES(199,6803,560,7);
INSERT INTO INTERPRETE VALUES(199,6804,560,8);
INSERT INTO INTERPRETE VALUES(199,6805,560,9);
INSERT INTO INTERPRETE VALUES(199,6806,561,1);
INSERT INTO INTERPRETE VALUES(199,6807,561,2);
INSERT INTO INTERPRETE VALUES(196,6743,556,6);
INSERT INTO INTERPRETE VALUES(199,6808,561,3);
INSERT INTO INTERPRETE VALUES(199,6809,561,4);
INSERT INTO INTERPRETE VALUES(199,6810,561,5);
INSERT INTO INTERPRETE VALUES(199,6811,561,6);
INSERT INTO INTERPRETE VALUES(199,6812,561,7);
INSERT INTO INTERPRETE VALUES(199,6813,561,8);
INSERT INTO INTERPRETE VALUES(199,6814,561,9);
INSERT INTO INTERPRETE VALUES(200,6815,562,1);
INSERT INTO INTERPRETE VALUES(200,6816,562,2);
INSERT INTO INTERPRETE VALUES(200,6817,562,3);
INSERT INTO INTERPRETE VALUES(200,6818,562,4);
INSERT INTO INTERPRETE VALUES(200,6819,562,5);
INSERT INTO INTERPRETE VALUES(200,6820,562,6);
INSERT INTO INTERPRETE VALUES(200,6821,562,7);
INSERT INTO INTERPRETE VALUES(200,6822,562,8);
INSERT INTO INTERPRETE VALUES(200,6823,562,9);
INSERT INTO INTERPRETE VALUES(200,6824,562,10);
INSERT INTO INTERPRETE VALUES(201,6825,563,1);
INSERT INTO INTERPRETE VALUES(201,6826,563,2);
INSERT INTO INTERPRETE VALUES(201,6827,563,3);
INSERT INTO INTERPRETE VALUES(201,6828,563,4);
INSERT INTO INTERPRETE VALUES(201,6829,563,5);
INSERT INTO INTERPRETE VALUES(201,6830,563,6);
INSERT INTO INTERPRETE VALUES(201,6831,563,7);
INSERT INTO INTERPRETE VALUES(201,6832,563,8);
INSERT INTO INTERPRETE VALUES(201,6833,563,9);
INSERT INTO INTERPRETE VALUES(201,6834,563,10);
INSERT INTO INTERPRETE VALUES(202,6835,564,1);
INSERT INTO INTERPRETE VALUES(202,6836,564,2);
INSERT INTO INTERPRETE VALUES(202,6837,564,3);
INSERT INTO INTERPRETE VALUES(202,6838,564,4);
INSERT INTO INTERPRETE VALUES(202,6839,564,5);
INSERT INTO INTERPRETE VALUES(202,6840,564,6);
INSERT INTO INTERPRETE VALUES(202,6841,564,7);
INSERT INTO INTERPRETE VALUES(202,162,564,8);
INSERT INTO INTERPRETE VALUES(202,6843,564,9);
INSERT INTO INTERPRETE VALUES(202,6844,564,10);
INSERT INTO INTERPRETE VALUES(202,6845,565,1);
INSERT INTO INTERPRETE VALUES(202,6846,565,2);
INSERT INTO INTERPRETE VALUES(202,6847,565,3);
INSERT INTO INTERPRETE VALUES(202,6848,565,4);
INSERT INTO INTERPRETE VALUES(202,6850,565,6);
INSERT INTO INTERPRETE VALUES(202,6851,565,7);
INSERT INTO INTERPRETE VALUES(202,6852,565,8);
INSERT INTO INTERPRETE VALUES(202,6853,565,9);
INSERT INTO INTERPRETE VALUES(202,6854,565,10);
INSERT INTO INTERPRETE VALUES(203,6855,566,1);
INSERT INTO INTERPRETE VALUES(203,6856,566,2);
INSERT INTO INTERPRETE VALUES(203,6857,566,3);
INSERT INTO INTERPRETE VALUES(203,6858,566,4);
INSERT INTO INTERPRETE VALUES(203,6859,566,5);
INSERT INTO INTERPRETE VALUES(203,6860,566,6);
INSERT INTO INTERPRETE VALUES(203,6861,566,7);
INSERT INTO INTERPRETE VALUES(203,6862,566,8);
INSERT INTO INTERPRETE VALUES(203,6863,566,9);
INSERT INTO INTERPRETE VALUES(203,6864,566,10);
INSERT INTO INTERPRETE VALUES(204,6865,567,1);
INSERT INTO INTERPRETE VALUES(204,6866,567,2);
INSERT INTO INTERPRETE VALUES(204,6867,567,3);
INSERT INTO INTERPRETE VALUES(204,6868,567,4);
INSERT INTO INTERPRETE VALUES(204,6869,567,5);
INSERT INTO INTERPRETE VALUES(204,6870,567,6);
INSERT INTO INTERPRETE VALUES(204,6871,567,7);
INSERT INTO INTERPRETE VALUES(204,6872,567,8);
INSERT INTO INTERPRETE VALUES(204,6873,567,9);
INSERT INTO INTERPRETE VALUES(204,6874,567,10);
INSERT INTO INTERPRETE VALUES(205,6875,568,1);
INSERT INTO INTERPRETE VALUES(205,6876,568,2);
INSERT INTO INTERPRETE VALUES(205,6877,568,3);
INSERT INTO INTERPRETE VALUES(205,6878,568,4);
INSERT INTO INTERPRETE VALUES(205,6879,568,5);
INSERT INTO INTERPRETE VALUES(205,6880,568,6);
INSERT INTO INTERPRETE VALUES(205,6881,568,7);
INSERT INTO INTERPRETE VALUES(205,6882,568,8);
INSERT INTO INTERPRETE VALUES(205,6883,568,9);
INSERT INTO INTERPRETE VALUES(205,6884,568,10);
INSERT INTO INTERPRETE VALUES(205,6885,568,11);
INSERT INTO INTERPRETE VALUES(206,6886,569,1);
INSERT INTO INTERPRETE VALUES(206,6887,569,2);
INSERT INTO INTERPRETE VALUES(206,6888,569,3);
INSERT INTO INTERPRETE VALUES(206,6889,569,4);
INSERT INTO INTERPRETE VALUES(206,6890,569,5);
INSERT INTO INTERPRETE VALUES(206,6891,569,6);
INSERT INTO INTERPRETE VALUES(206,6892,569,7);
INSERT INTO INTERPRETE VALUES(206,6893,569,8);
INSERT INTO INTERPRETE VALUES(206,6894,569,9);
INSERT INTO INTERPRETE VALUES(206,6895,569,10);
INSERT INTO INTERPRETE VALUES(206,6896,569,11);
INSERT INTO INTERPRETE VALUES(157,5154,570,1);
INSERT INTO INTERPRETE VALUES(157,6898,570,2);
INSERT INTO INTERPRETE VALUES(157,6899,570,3);
INSERT INTO INTERPRETE VALUES(157,6900,570,4);
INSERT INTO INTERPRETE VALUES(157,6901,570,5);
INSERT INTO INTERPRETE VALUES(157,5156,570,6);
INSERT INTO INTERPRETE VALUES(157,6903,570,7);
INSERT INTO INTERPRETE VALUES(157,6904,570,8);
INSERT INTO INTERPRETE VALUES(157,6905,570,9);
INSERT INTO INTERPRETE VALUES(157,6906,570,10);
INSERT INTO INTERPRETE VALUES(157,6907,570,11);
INSERT INTO INTERPRETE VALUES(207,6908,571,1);
INSERT INTO INTERPRETE VALUES(207,6909,571,2);
INSERT INTO INTERPRETE VALUES(207,6910,571,3);
INSERT INTO INTERPRETE VALUES(207,6911,571,4);
INSERT INTO INTERPRETE VALUES(207,6912,571,5);
INSERT INTO INTERPRETE VALUES(207,6913,571,6);
INSERT INTO INTERPRETE VALUES(207,6914,571,7);
INSERT INTO INTERPRETE VALUES(207,6915,571,8);
INSERT INTO INTERPRETE VALUES(207,6916,571,9);
INSERT INTO INTERPRETE VALUES(207,7491,571,10);
INSERT INTO INTERPRETE VALUES(207,6918,571,11);
INSERT INTO INTERPRETE VALUES(207,6919,571,12);
INSERT INTO INTERPRETE VALUES(208,6923,572,4);
INSERT INTO INTERPRETE VALUES(208,6926,572,7);
INSERT INTO INTERPRETE VALUES(208,6927,572,8);
INSERT INTO INTERPRETE VALUES(208,6928,572,9);
INSERT INTO INTERPRETE VALUES(208,6929,572,10);
INSERT INTO INTERPRETE VALUES(209,6933,573,1);
INSERT INTO INTERPRETE VALUES(209,6934,573,2);
INSERT INTO INTERPRETE VALUES(209,6935,573,3);
INSERT INTO INTERPRETE VALUES(209,6936,573,4);
INSERT INTO INTERPRETE VALUES(209,6937,573,5);
INSERT INTO INTERPRETE VALUES(209,6938,573,6);
INSERT INTO INTERPRETE VALUES(209,6940,573,8);
INSERT INTO INTERPRETE VALUES(209,6941,573,9);
INSERT INTO INTERPRETE VALUES(209,6942,573,10);
INSERT INTO INTERPRETE VALUES(209,6943,573,11);
INSERT INTO INTERPRETE VALUES(209,1711,573,12);
INSERT INTO INTERPRETE VALUES(209,6946,573,14);
INSERT INTO INTERPRETE VALUES(209,6947,573,15);
INSERT INTO INTERPRETE VALUES(209,6948,573,16);
INSERT INTO INTERPRETE VALUES(209,6949,573,17);
INSERT INTO INTERPRETE VALUES(209,6950,573,18);
INSERT INTO INTERPRETE VALUES(157,5159,574,1);
INSERT INTO INTERPRETE VALUES(208,6931,572,12);
INSERT INTO INTERPRETE VALUES(157,6952,574,2);
INSERT INTO INTERPRETE VALUES(157,6953,574,3);
INSERT INTO INTERPRETE VALUES(157,6954,574,4);
INSERT INTO INTERPRETE VALUES(157,6955,574,5);
INSERT INTO INTERPRETE VALUES(157,6956,574,6);
INSERT INTO INTERPRETE VALUES(157,5142,574,7);
INSERT INTO INTERPRETE VALUES(157,6958,574,8);
INSERT INTO INTERPRETE VALUES(157,6959,574,9);
INSERT INTO INTERPRETE VALUES(157,5146,574,10);
INSERT INTO INTERPRETE VALUES(157,6961,574,11);
INSERT INTO INTERPRETE VALUES(157,6962,574,12);
INSERT INTO INTERPRETE VALUES(200,6963,575,1);
INSERT INTO INTERPRETE VALUES(200,6964,575,2);
INSERT INTO INTERPRETE VALUES(200,6965,575,3);
INSERT INTO INTERPRETE VALUES(200,6966,575,4);
INSERT INTO INTERPRETE VALUES(200,6967,575,5);
INSERT INTO INTERPRETE VALUES(200,6968,575,6);
INSERT INTO INTERPRETE VALUES(200,6969,575,7);
INSERT INTO INTERPRETE VALUES(200,6970,575,8);
INSERT INTO INTERPRETE VALUES(200,6971,575,9);
INSERT INTO INTERPRETE VALUES(200,6972,575,10);
INSERT INTO INTERPRETE VALUES(200,6973,575,11);
INSERT INTO INTERPRETE VALUES(196,6974,576,1);
INSERT INTO INTERPRETE VALUES(196,6975,576,2);
INSERT INTO INTERPRETE VALUES(196,6977,576,4);
INSERT INTO INTERPRETE VALUES(196,6978,576,5);
INSERT INTO INTERPRETE VALUES(196,6979,576,6);
INSERT INTO INTERPRETE VALUES(196,6981,576,8);
INSERT INTO INTERPRETE VALUES(196,6982,576,9);
INSERT INTO INTERPRETE VALUES(196,6976,576,3);
INSERT INTO INTERPRETE VALUES(209,6939,573,7);
INSERT INTO INTERPRETE VALUES(209,6945,573,13);
INSERT INTO INTERPRETE VALUES(196,6983,576,10);
INSERT INTO INTERPRETE VALUES(196,6984,576,11);
INSERT INTO INTERPRETE VALUES(196,6985,576,12);
INSERT INTO INTERPRETE VALUES(76,6986,577,1);
INSERT INTO INTERPRETE VALUES(76,6987,577,2);
INSERT INTO INTERPRETE VALUES(76,6988,577,3);
INSERT INTO INTERPRETE VALUES(76,6989,577,4);
INSERT INTO INTERPRETE VALUES(76,6991,577,6);
INSERT INTO INTERPRETE VALUES(76,6992,577,7);
INSERT INTO INTERPRETE VALUES(76,6993,577,8);
INSERT INTO INTERPRETE VALUES(76,6995,577,10);
INSERT INTO INTERPRETE VALUES(76,6996,577,11);
INSERT INTO INTERPRETE VALUES(76,6997,577,12);
INSERT INTO INTERPRETE VALUES(76,6998,577,13);
INSERT INTO INTERPRETE VALUES(197,6824,578,1);
INSERT INTO INTERPRETE VALUES(197,6967,578,2);
INSERT INTO INTERPRETE VALUES(197,7001,578,3);
INSERT INTO INTERPRETE VALUES(197,6820,578,4);
INSERT INTO INTERPRETE VALUES(197,7003,578,5);
INSERT INTO INTERPRETE VALUES(197,7004,578,6);
INSERT INTO INTERPRETE VALUES(197,7005,578,7);
INSERT INTO INTERPRETE VALUES(197,6964,578,8);
INSERT INTO INTERPRETE VALUES(197,7007,578,9);
INSERT INTO INTERPRETE VALUES(197,7008,578,10);
INSERT INTO INTERPRETE VALUES(197,7009,578,11);
INSERT INTO INTERPRETE VALUES(210,7010,579,1);
INSERT INTO INTERPRETE VALUES(210,7011,579,2);
INSERT INTO INTERPRETE VALUES(210,7012,579,3);
INSERT INTO INTERPRETE VALUES(210,7013,579,4);
INSERT INTO INTERPRETE VALUES(210,7014,579,5);
INSERT INTO INTERPRETE VALUES(210,7015,579,6);
INSERT INTO INTERPRETE VALUES(210,7016,579,7);
INSERT INTO INTERPRETE VALUES(210,7017,579,8);
INSERT INTO INTERPRETE VALUES(210,7018,579,9);
INSERT INTO INTERPRETE VALUES(210,7019,579,10);
INSERT INTO INTERPRETE VALUES(210,7020,579,11);
INSERT INTO INTERPRETE VALUES(210,7021,579,12);
INSERT INTO INTERPRETE VALUES(109,4449,580,1);
INSERT INTO INTERPRETE VALUES(109,6379,580,2);
INSERT INTO INTERPRETE VALUES(109,4336,580,3);
INSERT INTO INTERPRETE VALUES(109,4337,580,4);
INSERT INTO INTERPRETE VALUES(109,4338,580,5);
INSERT INTO INTERPRETE VALUES(109,3904,580,6);
INSERT INTO INTERPRETE VALUES(109,3906,580,7);
INSERT INTO INTERPRETE VALUES(109,4341,580,8);
INSERT INTO INTERPRETE VALUES(109,7030,580,9);
INSERT INTO INTERPRETE VALUES(211,7036,581,3);
INSERT INTO INTERPRETE VALUES(211,7037,581,4);
INSERT INTO INTERPRETE VALUES(211,7038,581,5);
INSERT INTO INTERPRETE VALUES(211,7039,581,6);
INSERT INTO INTERPRETE VALUES(211,7040,581,7);
INSERT INTO INTERPRETE VALUES(211,7041,581,8);
INSERT INTO INTERPRETE VALUES(211,7042,581,9);
INSERT INTO INTERPRETE VALUES(211,7043,581,10);
INSERT INTO INTERPRETE VALUES(211,7045,581,12);
INSERT INTO INTERPRETE VALUES(109,7046,582,1);
INSERT INTO INTERPRETE VALUES(109,4339,582,2);
INSERT INTO INTERPRETE VALUES(109,7048,582,3);
INSERT INTO INTERPRETE VALUES(109,7049,582,4);
INSERT INTO INTERPRETE VALUES(109,4337,582,5);
INSERT INTO INTERPRETE VALUES(109,7051,582,6);
INSERT INTO INTERPRETE VALUES(109,7052,582,7);
INSERT INTO INTERPRETE VALUES(109,7053,582,8);
INSERT INTO INTERPRETE VALUES(109,4439,582,9);
INSERT INTO INTERPRETE VALUES(109,7055,582,10);
INSERT INTO INTERPRETE VALUES(109,7056,582,11);
INSERT INTO INTERPRETE VALUES(109,7057,582,12);
INSERT INTO INTERPRETE VALUES(109,7058,582,13);
INSERT INTO INTERPRETE VALUES(205,7059,583,1);
INSERT INTO INTERPRETE VALUES(205,7060,583,2);
INSERT INTO INTERPRETE VALUES(205,7061,583,3);
INSERT INTO INTERPRETE VALUES(205,7062,583,4);
INSERT INTO INTERPRETE VALUES(205,6875,583,5);
INSERT INTO INTERPRETE VALUES(205,7064,583,6);
INSERT INTO INTERPRETE VALUES(205,7065,583,7);
INSERT INTO INTERPRETE VALUES(205,6880,583,8);
INSERT INTO INTERPRETE VALUES(205,7067,583,9);
INSERT INTO INTERPRETE VALUES(205,7068,583,10);
INSERT INTO INTERPRETE VALUES(205,7069,583,11);
INSERT INTO INTERPRETE VALUES(205,7070,583,12);
INSERT INTO INTERPRETE VALUES(205,7071,583,13);
INSERT INTO INTERPRETE VALUES(205,7072,583,14);
INSERT INTO INTERPRETE VALUES(169,5598,584,1);
INSERT INTO INTERPRETE VALUES(169,7074,584,2);
INSERT INTO INTERPRETE VALUES(169,7075,584,3);
INSERT INTO INTERPRETE VALUES(169,7726,584,4);
INSERT INTO INTERPRETE VALUES(169,7077,584,5);
INSERT INTO INTERPRETE VALUES(169,7078,584,6);
INSERT INTO INTERPRETE VALUES(169,7079,584,7);
INSERT INTO INTERPRETE VALUES(169,7080,584,8);
INSERT INTO INTERPRETE VALUES(169,7081,584,9);
INSERT INTO INTERPRETE VALUES(169,7082,584,10);
INSERT INTO INTERPRETE VALUES(169,7083,584,11);
INSERT INTO INTERPRETE VALUES(169,7084,584,12);
INSERT INTO INTERPRETE VALUES(169,7085,584,13);
INSERT INTO INTERPRETE VALUES(196,7086,585,1);
INSERT INTO INTERPRETE VALUES(196,7087,585,2);
INSERT INTO INTERPRETE VALUES(196,7088,585,3);
INSERT INTO INTERPRETE VALUES(196,7090,585,5);
INSERT INTO INTERPRETE VALUES(196,7091,585,6);
INSERT INTO INTERPRETE VALUES(196,7093,585,8);
INSERT INTO INTERPRETE VALUES(196,7094,585,9);
INSERT INTO INTERPRETE VALUES(196,7089,585,4);
INSERT INTO INTERPRETE VALUES(196,7096,585,11);
INSERT INTO INTERPRETE VALUES(196,7097,585,12);
INSERT INTO INTERPRETE VALUES(188,7108,586,11);
INSERT INTO INTERPRETE VALUES(188,7109,586,12);
INSERT INTO INTERPRETE VALUES(188,7110,586,13);
INSERT INTO INTERPRETE VALUES(188,7111,586,14);
INSERT INTO INTERPRETE VALUES(188,7112,586,15);
INSERT INTO INTERPRETE VALUES(188,7113,586,16);
INSERT INTO INTERPRETE VALUES(188,7114,586,17);
INSERT INTO INTERPRETE VALUES(207,7115,587,1);
INSERT INTO INTERPRETE VALUES(207,7116,587,2);
INSERT INTO INTERPRETE VALUES(207,7117,587,3);
INSERT INTO INTERPRETE VALUES(207,7118,587,4);
INSERT INTO INTERPRETE VALUES(207,7119,587,5);
INSERT INTO INTERPRETE VALUES(207,7120,587,6);
INSERT INTO INTERPRETE VALUES(207,7121,587,7);
INSERT INTO INTERPRETE VALUES(207,7122,587,8);
INSERT INTO INTERPRETE VALUES(207,7123,587,9);
INSERT INTO INTERPRETE VALUES(207,7124,587,10);
INSERT INTO INTERPRETE VALUES(207,7125,587,11);
INSERT INTO INTERPRETE VALUES(207,7126,587,12);
INSERT INTO INTERPRETE VALUES(207,7127,587,13);
INSERT INTO INTERPRETE VALUES(207,7128,587,14);
INSERT INTO INTERPRETE VALUES(207,7129,587,15);
INSERT INTO INTERPRETE VALUES(208,7130,588,1);
INSERT INTO INTERPRETE VALUES(208,7131,588,2);
INSERT INTO INTERPRETE VALUES(208,7135,588,6);
INSERT INTO INTERPRETE VALUES(208,7139,588,10);
INSERT INTO INTERPRETE VALUES(208,7141,588,12);
INSERT INTO INTERPRETE VALUES(208,7144,588,15);
INSERT INTO INTERPRETE VALUES(212,7145,589,1);
INSERT INTO INTERPRETE VALUES(212,7146,589,2);
INSERT INTO INTERPRETE VALUES(212,7147,589,3);
INSERT INTO INTERPRETE VALUES(212,7148,589,4);
INSERT INTO INTERPRETE VALUES(212,7149,589,5);
INSERT INTO INTERPRETE VALUES(212,7150,589,6);
INSERT INTO INTERPRETE VALUES(212,7151,589,7);
INSERT INTO INTERPRETE VALUES(212,7153,589,9);
INSERT INTO INTERPRETE VALUES(212,7154,589,10);
INSERT INTO INTERPRETE VALUES(212,7155,589,11);
INSERT INTO INTERPRETE VALUES(212,7156,589,12);
INSERT INTO INTERPRETE VALUES(212,7157,589,13);
INSERT INTO INTERPRETE VALUES(212,7158,589,14);
INSERT INTO INTERPRETE VALUES(212,7159,589,15);
INSERT INTO INTERPRETE VALUES(112,7160,590,1);
INSERT INTO INTERPRETE VALUES(112,7161,590,2);
INSERT INTO INTERPRETE VALUES(112,7162,590,3);
INSERT INTO INTERPRETE VALUES(112,7163,590,4);
INSERT INTO INTERPRETE VALUES(112,7164,590,5);
INSERT INTO INTERPRETE VALUES(112,7165,590,6);
INSERT INTO INTERPRETE VALUES(112,7166,590,7);
INSERT INTO INTERPRETE VALUES(112,7167,590,8);
INSERT INTO INTERPRETE VALUES(112,7168,590,9);
INSERT INTO INTERPRETE VALUES(208,7133,588,4);
INSERT INTO INTERPRETE VALUES(208,7136,588,7);
INSERT INTO INTERPRETE VALUES(208,7138,588,9);
INSERT INTO INTERPRETE VALUES(112,7169,590,10);
INSERT INTO INTERPRETE VALUES(112,7170,590,11);
INSERT INTO INTERPRETE VALUES(112,7171,590,12);
INSERT INTO INTERPRETE VALUES(112,7172,590,13);
INSERT INTO INTERPRETE VALUES(112,7173,590,14);
INSERT INTO INTERPRETE VALUES(112,7174,590,15);
INSERT INTO INTERPRETE VALUES(112,7175,590,16);
INSERT INTO INTERPRETE VALUES(213,7176,591,1);
INSERT INTO INTERPRETE VALUES(213,7177,591,2);
INSERT INTO INTERPRETE VALUES(213,7178,591,3);
INSERT INTO INTERPRETE VALUES(213,7179,591,4);
INSERT INTO INTERPRETE VALUES(213,7180,591,5);
INSERT INTO INTERPRETE VALUES(213,6857,591,6);
INSERT INTO INTERPRETE VALUES(213,7182,591,7);
INSERT INTO INTERPRETE VALUES(213,7183,591,8);
INSERT INTO INTERPRETE VALUES(213,7185,591,10);
INSERT INTO INTERPRETE VALUES(213,7186,591,11);
INSERT INTO INTERPRETE VALUES(213,7187,591,12);
INSERT INTO INTERPRETE VALUES(213,7188,591,13);
INSERT INTO INTERPRETE VALUES(213,7189,591,14);
INSERT INTO INTERPRETE VALUES(213,7190,591,15);
INSERT INTO INTERPRETE VALUES(197,6824,592,1);
INSERT INTO INTERPRETE VALUES(197,7192,592,2);
INSERT INTO INTERPRETE VALUES(197,7193,592,3);
INSERT INTO INTERPRETE VALUES(197,7194,592,4);
INSERT INTO INTERPRETE VALUES(197,7195,592,5);
INSERT INTO INTERPRETE VALUES(197,7196,592,6);
INSERT INTO INTERPRETE VALUES(197,7197,592,7);
INSERT INTO INTERPRETE VALUES(197,7198,592,8);
INSERT INTO INTERPRETE VALUES(197,7199,592,9);
INSERT INTO INTERPRETE VALUES(197,7200,592,10);
INSERT INTO INTERPRETE VALUES(197,7201,592,11);
INSERT INTO INTERPRETE VALUES(197,7202,592,12);
INSERT INTO INTERPRETE VALUES(197,7203,592,13);
INSERT INTO INTERPRETE VALUES(197,7204,592,14);
INSERT INTO INTERPRETE VALUES(197,7205,592,15);
INSERT INTO INTERPRETE VALUES(214,7206,593,1);
INSERT INTO INTERPRETE VALUES(214,7207,593,2);
INSERT INTO INTERPRETE VALUES(214,7208,593,3);
INSERT INTO INTERPRETE VALUES(214,7209,593,4);
INSERT INTO INTERPRETE VALUES(214,7210,593,5);
INSERT INTO INTERPRETE VALUES(214,7211,593,6);
INSERT INTO INTERPRETE VALUES(214,7212,593,7);
INSERT INTO INTERPRETE VALUES(214,7213,593,8);
INSERT INTO INTERPRETE VALUES(214,7214,593,9);
INSERT INTO INTERPRETE VALUES(214,7215,593,10);
INSERT INTO INTERPRETE VALUES(214,7216,593,11);
INSERT INTO INTERPRETE VALUES(214,7217,593,12);
INSERT INTO INTERPRETE VALUES(214,7218,593,13);
INSERT INTO INTERPRETE VALUES(214,7219,593,14);
INSERT INTO INTERPRETE VALUES(214,7220,593,15);
INSERT INTO INTERPRETE VALUES(214,7221,593,16);
INSERT INTO INTERPRETE VALUES(214,7222,593,17);
INSERT INTO INTERPRETE VALUES(215,7223,594,1);
INSERT INTO INTERPRETE VALUES(215,7224,594,2);
INSERT INTO INTERPRETE VALUES(215,7225,594,3);
INSERT INTO INTERPRETE VALUES(215,7226,594,4);
INSERT INTO INTERPRETE VALUES(215,7227,594,5);
INSERT INTO INTERPRETE VALUES(215,7228,594,6);
INSERT INTO INTERPRETE VALUES(215,7229,594,7);
INSERT INTO INTERPRETE VALUES(215,7230,594,8);
INSERT INTO INTERPRETE VALUES(215,7231,594,9);
INSERT INTO INTERPRETE VALUES(215,7232,594,10);
INSERT INTO INTERPRETE VALUES(215,7233,594,11);
INSERT INTO INTERPRETE VALUES(215,7234,594,12);
INSERT INTO INTERPRETE VALUES(215,7235,594,13);
INSERT INTO INTERPRETE VALUES(215,7236,594,14);
INSERT INTO INTERPRETE VALUES(215,7237,594,15);
INSERT INTO INTERPRETE VALUES(215,7238,594,16);
INSERT INTO INTERPRETE VALUES(207,7239,595,1);
INSERT INTO INTERPRETE VALUES(207,7240,595,2);
INSERT INTO INTERPRETE VALUES(207,7241,595,3);
INSERT INTO INTERPRETE VALUES(207,7242,595,4);
INSERT INTO INTERPRETE VALUES(207,7243,595,5);
INSERT INTO INTERPRETE VALUES(207,7244,595,6);
INSERT INTO INTERPRETE VALUES(207,7245,595,7);
INSERT INTO INTERPRETE VALUES(207,7246,595,8);
INSERT INTO INTERPRETE VALUES(207,7247,595,9);
INSERT INTO INTERPRETE VALUES(207,7248,595,10);
INSERT INTO INTERPRETE VALUES(207,7249,595,11);
INSERT INTO INTERPRETE VALUES(207,7250,595,12);
INSERT INTO INTERPRETE VALUES(207,7251,595,13);
INSERT INTO INTERPRETE VALUES(207,7252,595,14);
INSERT INTO INTERPRETE VALUES(207,7253,595,15);
INSERT INTO INTERPRETE VALUES(207,7254,595,16);
INSERT INTO INTERPRETE VALUES(95,4276,597,5);
INSERT INTO INTERPRETE VALUES(95,7277,597,6);
INSERT INTO INTERPRETE VALUES(95,7278,597,7);
INSERT INTO INTERPRETE VALUES(95,7279,597,8);
INSERT INTO INTERPRETE VALUES(95,7280,597,9);
INSERT INTO INTERPRETE VALUES(95,7281,597,10);
INSERT INTO INTERPRETE VALUES(95,7282,597,11);
INSERT INTO INTERPRETE VALUES(95,7283,597,12);
INSERT INTO INTERPRETE VALUES(95,7284,597,13);
INSERT INTO INTERPRETE VALUES(95,7285,597,14);
INSERT INTO INTERPRETE VALUES(95,7286,597,15);
INSERT INTO INTERPRETE VALUES(95,7287,597,16);
INSERT INTO INTERPRETE VALUES(208,7289,598,1);
INSERT INTO INTERPRETE VALUES(208,7291,598,3);
INSERT INTO INTERPRETE VALUES(208,7292,598,4);
INSERT INTO INTERPRETE VALUES(208,7293,598,5);
INSERT INTO INTERPRETE VALUES(208,7294,598,6);
INSERT INTO INTERPRETE VALUES(208,7295,598,7);
INSERT INTO INTERPRETE VALUES(208,7296,598,8);
INSERT INTO INTERPRETE VALUES(208,7297,598,9);
INSERT INTO INTERPRETE VALUES(208,7298,599,1);
INSERT INTO INTERPRETE VALUES(208,7300,599,3);
INSERT INTO INTERPRETE VALUES(208,7301,599,4);
INSERT INTO INTERPRETE VALUES(208,7302,599,5);
INSERT INTO INTERPRETE VALUES(208,7304,599,7);
INSERT INTO INTERPRETE VALUES(208,7305,599,8);
INSERT INTO INTERPRETE VALUES(208,7306,599,9);
INSERT INTO INTERPRETE VALUES(208,7307,599,10);
INSERT INTO INTERPRETE VALUES(208,7308,599,11);
INSERT INTO INTERPRETE VALUES(208,7309,599,12);
INSERT INTO INTERPRETE VALUES(208,7303,599,6);
INSERT INTO INTERPRETE VALUES(216,7313,600,3);
INSERT INTO INTERPRETE VALUES(208,7290,598,2);
INSERT INTO INTERPRETE VALUES(216,7315,600,5);
INSERT INTO INTERPRETE VALUES(216,7318,600,8);
INSERT INTO INTERPRETE VALUES(216,7322,600,12);
INSERT INTO INTERPRETE VALUES(216,7323,600,13);
INSERT INTO INTERPRETE VALUES(216,7320,600,10);
INSERT INTO INTERPRETE VALUES(216,7327,601,3);
INSERT INTO INTERPRETE VALUES(216,7328,601,4);
INSERT INTO INTERPRETE VALUES(216,7329,601,5);
INSERT INTO INTERPRETE VALUES(216,7333,601,9);
INSERT INTO INTERPRETE VALUES(216,7336,601,12);
INSERT INTO INTERPRETE VALUES(196,7337,602,1);
INSERT INTO INTERPRETE VALUES(196,7338,602,2);
INSERT INTO INTERPRETE VALUES(196,7339,602,3);
INSERT INTO INTERPRETE VALUES(196,7340,602,4);
INSERT INTO INTERPRETE VALUES(196,7341,602,5);
INSERT INTO INTERPRETE VALUES(196,7342,602,6);
INSERT INTO INTERPRETE VALUES(196,7343,602,7);
INSERT INTO INTERPRETE VALUES(196,7344,602,8);
INSERT INTO INTERPRETE VALUES(196,7345,602,9);
INSERT INTO INTERPRETE VALUES(196,7346,602,10);
INSERT INTO INTERPRETE VALUES(196,7347,602,11);
INSERT INTO INTERPRETE VALUES(196,7348,602,12);
INSERT INTO INTERPRETE VALUES(196,7349,602,13);
INSERT INTO INTERPRETE VALUES(196,7350,603,1);
INSERT INTO INTERPRETE VALUES(196,7351,603,2);
INSERT INTO INTERPRETE VALUES(196,7352,603,3);
INSERT INTO INTERPRETE VALUES(196,7086,603,4);
INSERT INTO INTERPRETE VALUES(196,6984,603,7);
INSERT INTO INTERPRETE VALUES(196,6975,603,8);
INSERT INTO INTERPRETE VALUES(196,7097,603,13);
INSERT INTO INTERPRETE VALUES(196,7363,603,14);
INSERT INTO INTERPRETE VALUES(196,7366,603,17);
INSERT INTO INTERPRETE VALUES(196,7368,603,19);
INSERT INTO INTERPRETE VALUES(196,7369,603,20);
INSERT INTO INTERPRETE VALUES(196,7405,607,1);
INSERT INTO INTERPRETE VALUES(196,7407,607,3);
INSERT INTO INTERPRETE VALUES(196,7409,607,5);
INSERT INTO INTERPRETE VALUES(196,7411,607,7);
INSERT INTO INTERPRETE VALUES(196,7412,607,8);
INSERT INTO INTERPRETE VALUES(196,7413,607,9);
INSERT INTO INTERPRETE VALUES(196,7414,607,10);
INSERT INTO INTERPRETE VALUES(196,7415,607,11);
INSERT INTO INTERPRETE VALUES(196,7417,607,13);
INSERT INTO INTERPRETE VALUES(196,7418,607,14);
INSERT INTO INTERPRETE VALUES(196,7419,607,15);
INSERT INTO INTERPRETE VALUES(196,7420,607,16);
INSERT INTO INTERPRETE VALUES(196,7421,607,17);
INSERT INTO INTERPRETE VALUES(218,7422,608,1);
INSERT INTO INTERPRETE VALUES(218,7423,608,2);
INSERT INTO INTERPRETE VALUES(218,7424,608,3);
INSERT INTO INTERPRETE VALUES(218,7425,608,4);
INSERT INTO INTERPRETE VALUES(218,7426,608,5);
INSERT INTO INTERPRETE VALUES(218,7427,608,6);
INSERT INTO INTERPRETE VALUES(218,7428,608,7);
INSERT INTO INTERPRETE VALUES(218,7429,608,8);
INSERT INTO INTERPRETE VALUES(218,7430,608,9);
INSERT INTO INTERPRETE VALUES(218,7431,608,10);
INSERT INTO INTERPRETE VALUES(218,7432,608,11);
INSERT INTO INTERPRETE VALUES(218,7433,608,12);
INSERT INTO INTERPRETE VALUES(218,7434,608,13);
INSERT INTO INTERPRETE VALUES(218,7435,608,14);
INSERT INTO INTERPRETE VALUES(218,7436,608,15);
INSERT INTO INTERPRETE VALUES(218,7437,608,16);
INSERT INTO INTERPRETE VALUES(218,7438,608,17);
INSERT INTO INTERPRETE VALUES(218,7439,608,18);
INSERT INTO INTERPRETE VALUES(218,7440,608,19);
INSERT INTO INTERPRETE VALUES(218,7441,608,20);
INSERT INTO INTERPRETE VALUES(218,7442,608,21);
INSERT INTO INTERPRETE VALUES(219,7443,609,1);
INSERT INTO INTERPRETE VALUES(219,7444,609,2);
INSERT INTO INTERPRETE VALUES(219,7445,609,3);
INSERT INTO INTERPRETE VALUES(219,7446,609,4);
INSERT INTO INTERPRETE VALUES(219,7447,609,5);
INSERT INTO INTERPRETE VALUES(219,7448,609,6);
INSERT INTO INTERPRETE VALUES(220,7449,610,1);
INSERT INTO INTERPRETE VALUES(220,7450,610,2);
INSERT INTO INTERPRETE VALUES(220,7451,610,3);
INSERT INTO INTERPRETE VALUES(220,7452,610,4);
INSERT INTO INTERPRETE VALUES(220,7118,610,5);
INSERT INTO INTERPRETE VALUES(220,7454,610,6);
INSERT INTO INTERPRETE VALUES(220,7455,610,7);
INSERT INTO INTERPRETE VALUES(221,7456,611,1);
INSERT INTO INTERPRETE VALUES(221,7457,611,2);
INSERT INTO INTERPRETE VALUES(221,7458,611,3);
INSERT INTO INTERPRETE VALUES(221,7461,611,6);
INSERT INTO INTERPRETE VALUES(221,7462,611,7);
INSERT INTO INTERPRETE VALUES(221,7463,611,8);
INSERT INTO INTERPRETE VALUES(207,7466,612,3);
INSERT INTO INTERPRETE VALUES(207,7467,612,4);
INSERT INTO INTERPRETE VALUES(207,7468,612,5);
INSERT INTO INTERPRETE VALUES(207,7469,612,6);
INSERT INTO INTERPRETE VALUES(207,7470,612,7);
INSERT INTO INTERPRETE VALUES(207,7471,612,8);
INSERT INTO INTERPRETE VALUES(207,7472,612,9);
INSERT INTO INTERPRETE VALUES(207,7488,612,10);
INSERT INTO INTERPRETE VALUES(207,7474,612,11);
INSERT INTO INTERPRETE VALUES(207,6919,613,1);
INSERT INTO INTERPRETE VALUES(207,7476,613,2);
INSERT INTO INTERPRETE VALUES(207,7477,613,3);
INSERT INTO INTERPRETE VALUES(207,7478,613,4);
INSERT INTO INTERPRETE VALUES(207,7479,613,5);
INSERT INTO INTERPRETE VALUES(207,7480,613,6);
INSERT INTO INTERPRETE VALUES(207,7464,613,7);
INSERT INTO INTERPRETE VALUES(207,7482,613,8);
INSERT INTO INTERPRETE VALUES(207,7483,613,9);
INSERT INTO INTERPRETE VALUES(207,7484,613,10);
INSERT INTO INTERPRETE VALUES(207,7485,613,11);
INSERT INTO INTERPRETE VALUES(207,7487,613,13);
INSERT INTO INTERPRETE VALUES(207,7488,613,14);
INSERT INTO INTERPRETE VALUES(207,7489,613,15);
INSERT INTO INTERPRETE VALUES(207,7490,613,16);
INSERT INTO INTERPRETE VALUES(207,7491,613,17);
INSERT INTO INTERPRETE VALUES(222,7492,614,1);
INSERT INTO INTERPRETE VALUES(222,7493,614,2);
INSERT INTO INTERPRETE VALUES(222,7494,614,3);
INSERT INTO INTERPRETE VALUES(222,7495,614,4);
INSERT INTO INTERPRETE VALUES(222,7496,614,5);
INSERT INTO INTERPRETE VALUES(222,7497,614,6);
INSERT INTO INTERPRETE VALUES(222,7498,614,7);
INSERT INTO INTERPRETE VALUES(222,7499,614,8);
INSERT INTO INTERPRETE VALUES(222,7500,614,9);
INSERT INTO INTERPRETE VALUES(222,7501,614,10);
INSERT INTO INTERPRETE VALUES(222,7503,614,12);
INSERT INTO INTERPRETE VALUES(222,7504,614,13);
INSERT INTO INTERPRETE VALUES(222,7505,614,14);
INSERT INTO INTERPRETE VALUES(222,7506,614,15);
INSERT INTO INTERPRETE VALUES(223,7507,615,1);
INSERT INTO INTERPRETE VALUES(223,7508,615,2);
INSERT INTO INTERPRETE VALUES(223,7509,615,3);
INSERT INTO INTERPRETE VALUES(223,7510,615,4);
INSERT INTO INTERPRETE VALUES(223,7511,615,5);
INSERT INTO INTERPRETE VALUES(223,7512,615,6);
INSERT INTO INTERPRETE VALUES(223,7513,615,7);
INSERT INTO INTERPRETE VALUES(223,7514,615,8);
INSERT INTO INTERPRETE VALUES(223,7515,615,9);
INSERT INTO INTERPRETE VALUES(223,7516,615,10);
INSERT INTO INTERPRETE VALUES(223,7517,615,11);
INSERT INTO INTERPRETE VALUES(223,7518,615,12);
INSERT INTO INTERPRETE VALUES(223,7519,615,13);
INSERT INTO INTERPRETE VALUES(223,7520,615,14);
INSERT INTO INTERPRETE VALUES(224,7521,616,1);
INSERT INTO INTERPRETE VALUES(224,7522,616,2);
INSERT INTO INTERPRETE VALUES(224,7523,616,3);
INSERT INTO INTERPRETE VALUES(224,7524,616,4);
INSERT INTO INTERPRETE VALUES(224,7525,616,5);
INSERT INTO INTERPRETE VALUES(207,7486,613,12);
INSERT INTO INTERPRETE VALUES(224,7526,616,6);
INSERT INTO INTERPRETE VALUES(224,7527,616,7);
INSERT INTO INTERPRETE VALUES(224,7528,616,8);
INSERT INTO INTERPRETE VALUES(224,7529,616,9);
INSERT INTO INTERPRETE VALUES(224,7530,616,10);
INSERT INTO INTERPRETE VALUES(224,7531,616,11);
INSERT INTO INTERPRETE VALUES(224,7532,616,12);
INSERT INTO INTERPRETE VALUES(224,7533,616,13);
INSERT INTO INTERPRETE VALUES(205,7534,617,1);
INSERT INTO INTERPRETE VALUES(205,7535,617,2);
INSERT INTO INTERPRETE VALUES(205,7536,617,3);
INSERT INTO INTERPRETE VALUES(205,6883,617,4);
INSERT INTO INTERPRETE VALUES(205,7538,617,5);
INSERT INTO INTERPRETE VALUES(205,7539,617,6);
INSERT INTO INTERPRETE VALUES(205,7540,617,7);
INSERT INTO INTERPRETE VALUES(205,7541,617,8);
INSERT INTO INTERPRETE VALUES(205,7542,617,9);
INSERT INTO INTERPRETE VALUES(205,7543,617,10);
INSERT INTO INTERPRETE VALUES(205,7544,617,11);
INSERT INTO INTERPRETE VALUES(205,7545,617,12);
INSERT INTO INTERPRETE VALUES(205,7546,617,13);
INSERT INTO INTERPRETE VALUES(205,7547,617,14);
INSERT INTO INTERPRETE VALUES(225,7548,618,1);
INSERT INTO INTERPRETE VALUES(225,7549,618,2);
INSERT INTO INTERPRETE VALUES(225,7550,618,3);
INSERT INTO INTERPRETE VALUES(225,7551,618,4);
INSERT INTO INTERPRETE VALUES(225,7552,618,5);
INSERT INTO INTERPRETE VALUES(225,7553,618,6);
INSERT INTO INTERPRETE VALUES(225,7554,618,7);
INSERT INTO INTERPRETE VALUES(225,7555,618,8);
INSERT INTO INTERPRETE VALUES(225,7556,618,9);
INSERT INTO INTERPRETE VALUES(226,7557,619,1);
INSERT INTO INTERPRETE VALUES(226,7558,619,2);
INSERT INTO INTERPRETE VALUES(226,7559,619,3);
INSERT INTO INTERPRETE VALUES(226,7560,619,4);
INSERT INTO INTERPRETE VALUES(226,7561,619,5);
INSERT INTO INTERPRETE VALUES(226,7562,619,6);
INSERT INTO INTERPRETE VALUES(226,7563,619,7);
INSERT INTO INTERPRETE VALUES(226,7564,619,8);
INSERT INTO INTERPRETE VALUES(226,7565,619,9);
INSERT INTO INTERPRETE VALUES(227,7567,620,1);
INSERT INTO INTERPRETE VALUES(227,7568,620,2);
INSERT INTO INTERPRETE VALUES(227,7569,620,3);
INSERT INTO INTERPRETE VALUES(227,7570,620,4);
INSERT INTO INTERPRETE VALUES(227,7571,620,5);
INSERT INTO INTERPRETE VALUES(227,7572,620,6);
INSERT INTO INTERPRETE VALUES(227,7573,620,7);
INSERT INTO INTERPRETE VALUES(227,7574,620,8);
INSERT INTO INTERPRETE VALUES(227,7575,620,9);
INSERT INTO INTERPRETE VALUES(227,7576,620,10);
INSERT INTO INTERPRETE VALUES(227,7577,620,11);
INSERT INTO INTERPRETE VALUES(227,7578,620,12);
INSERT INTO INTERPRETE VALUES(227,7579,620,13);
INSERT INTO INTERPRETE VALUES(227,7580,620,14);
INSERT INTO INTERPRETE VALUES(227,7581,620,15);
INSERT INTO INTERPRETE VALUES(227,7582,620,16);
INSERT INTO INTERPRETE VALUES(220,7592,622,1);
INSERT INTO INTERPRETE VALUES(220,7593,622,2);
INSERT INTO INTERPRETE VALUES(220,7594,622,3);
INSERT INTO INTERPRETE VALUES(220,7595,622,4);
INSERT INTO INTERPRETE VALUES(220,7596,622,5);
INSERT INTO INTERPRETE VALUES(220,7597,622,6);
INSERT INTO INTERPRETE VALUES(220,7598,622,7);
INSERT INTO INTERPRETE VALUES(220,7599,622,8);
INSERT INTO INTERPRETE VALUES(196,7363,623,2);
INSERT INTO INTERPRETE VALUES(196,7602,623,3);
INSERT INTO INTERPRETE VALUES(196,7603,623,4);
INSERT INTO INTERPRETE VALUES(196,7604,623,5);
INSERT INTO INTERPRETE VALUES(196,7605,623,6);
INSERT INTO INTERPRETE VALUES(196,7606,623,7);
INSERT INTO INTERPRETE VALUES(196,7607,623,8);
INSERT INTO INTERPRETE VALUES(196,7608,623,9);
INSERT INTO INTERPRETE VALUES(196,7609,623,10);
INSERT INTO INTERPRETE VALUES(196,7610,623,11);
INSERT INTO INTERPRETE VALUES(220,7118,624,1);
INSERT INTO INTERPRETE VALUES(220,7612,624,2);
INSERT INTO INTERPRETE VALUES(220,7254,624,3);
INSERT INTO INTERPRETE VALUES(220,7614,624,4);
INSERT INTO INTERPRETE VALUES(220,7615,624,5);
INSERT INTO INTERPRETE VALUES(196,7360,623,1);
INSERT INTO INTERPRETE VALUES(229,7632,626,1);
INSERT INTO INTERPRETE VALUES(229,7633,626,2);
INSERT INTO INTERPRETE VALUES(229,7634,626,3);
INSERT INTO INTERPRETE VALUES(229,7635,626,4);
INSERT INTO INTERPRETE VALUES(229,7636,626,5);
INSERT INTO INTERPRETE VALUES(229,7637,626,6);
INSERT INTO INTERPRETE VALUES(229,7638,626,7);
INSERT INTO INTERPRETE VALUES(229,7639,626,8);
INSERT INTO INTERPRETE VALUES(229,7640,626,9);
INSERT INTO INTERPRETE VALUES(229,7641,626,10);
INSERT INTO INTERPRETE VALUES(229,7642,626,11);
INSERT INTO INTERPRETE VALUES(229,7643,626,12);
INSERT INTO INTERPRETE VALUES(196,7644,627,1);
INSERT INTO INTERPRETE VALUES(196,7645,627,2);
INSERT INTO INTERPRETE VALUES(196,7646,627,3);
INSERT INTO INTERPRETE VALUES(196,7647,627,4);
INSERT INTO INTERPRETE VALUES(196,7648,627,5);
INSERT INTO INTERPRETE VALUES(196,7649,627,6);
INSERT INTO INTERPRETE VALUES(196,7650,627,7);
INSERT INTO INTERPRETE VALUES(196,7651,627,8);
INSERT INTO INTERPRETE VALUES(196,6985,627,9);
INSERT INTO INTERPRETE VALUES(196,7413,627,10);
INSERT INTO INTERPRETE VALUES(196,7090,627,11);
INSERT INTO INTERPRETE VALUES(196,7655,627,12);
INSERT INTO INTERPRETE VALUES(230,7657,628,2);
INSERT INTO INTERPRETE VALUES(230,7658,628,3);
INSERT INTO INTERPRETE VALUES(230,7659,628,4);
INSERT INTO INTERPRETE VALUES(230,7661,628,6);
INSERT INTO INTERPRETE VALUES(230,7662,628,7);
INSERT INTO INTERPRETE VALUES(230,7663,628,8);
INSERT INTO INTERPRETE VALUES(230,7664,628,9);
INSERT INTO INTERPRETE VALUES(230,7665,628,10);
INSERT INTO INTERPRETE VALUES(230,7666,628,11);
INSERT INTO INTERPRETE VALUES(231,7668,629,1);
INSERT INTO INTERPRETE VALUES(231,7669,629,2);
INSERT INTO INTERPRETE VALUES(231,7634,629,3);
INSERT INTO INTERPRETE VALUES(231,7671,629,4);
INSERT INTO INTERPRETE VALUES(231,7672,629,5);
INSERT INTO INTERPRETE VALUES(231,7673,629,6);
INSERT INTO INTERPRETE VALUES(231,7674,629,7);
INSERT INTO INTERPRETE VALUES(231,7675,629,8);
INSERT INTO INTERPRETE VALUES(231,7676,629,9);
INSERT INTO INTERPRETE VALUES(231,7677,629,10);
INSERT INTO INTERPRETE VALUES(231,7678,629,11);
INSERT INTO INTERPRETE VALUES(231,7679,629,12);
INSERT INTO INTERPRETE VALUES(223,7680,630,1);
INSERT INTO INTERPRETE VALUES(223,7681,630,2);
INSERT INTO INTERPRETE VALUES(223,7682,630,3);
INSERT INTO INTERPRETE VALUES(223,7683,630,4);
INSERT INTO INTERPRETE VALUES(223,7684,630,5);
INSERT INTO INTERPRETE VALUES(223,7685,630,6);
INSERT INTO INTERPRETE VALUES(223,7686,630,7);
INSERT INTO INTERPRETE VALUES(223,7687,630,8);
INSERT INTO INTERPRETE VALUES(223,7688,630,9);
INSERT INTO INTERPRETE VALUES(223,7689,630,10);
INSERT INTO INTERPRETE VALUES(223,7690,630,11);
INSERT INTO INTERPRETE VALUES(223,7691,630,12);
INSERT INTO INTERPRETE VALUES(223,7692,630,13);
INSERT INTO INTERPRETE VALUES(223,7693,630,14);
INSERT INTO INTERPRETE VALUES(232,7694,631,1);
INSERT INTO INTERPRETE VALUES(232,7695,631,2);
INSERT INTO INTERPRETE VALUES(232,7696,631,3);
INSERT INTO INTERPRETE VALUES(232,7697,631,4);
INSERT INTO INTERPRETE VALUES(232,7698,631,5);
INSERT INTO INTERPRETE VALUES(232,7699,631,6);
INSERT INTO INTERPRETE VALUES(232,7700,631,7);
INSERT INTO INTERPRETE VALUES(232,7701,631,8);
INSERT INTO INTERPRETE VALUES(232,7702,631,9);
INSERT INTO INTERPRETE VALUES(232,7703,631,10);
INSERT INTO INTERPRETE VALUES(232,7704,631,11);
INSERT INTO INTERPRETE VALUES(232,7705,631,12);
INSERT INTO INTERPRETE VALUES(232,7706,631,13);
INSERT INTO INTERPRETE VALUES(233,7707,632,1);
INSERT INTO INTERPRETE VALUES(233,7708,632,2);
INSERT INTO INTERPRETE VALUES(233,7709,632,3);
INSERT INTO INTERPRETE VALUES(233,7710,632,4);
INSERT INTO INTERPRETE VALUES(233,7711,632,5);
INSERT INTO INTERPRETE VALUES(233,7712,632,6);
INSERT INTO INTERPRETE VALUES(233,7713,632,7);
INSERT INTO INTERPRETE VALUES(233,7714,632,8);
INSERT INTO INTERPRETE VALUES(233,7715,632,9);
INSERT INTO INTERPRETE VALUES(233,7716,632,10);
INSERT INTO INTERPRETE VALUES(233,7717,632,11);
INSERT INTO INTERPRETE VALUES(233,7718,632,12);
INSERT INTO INTERPRETE VALUES(208,7719,633,1);
INSERT INTO INTERPRETE VALUES(208,7308,633,2);
INSERT INTO INTERPRETE VALUES(208,7721,633,3);
INSERT INTO INTERPRETE VALUES(208,7302,633,4);
INSERT INTO INTERPRETE VALUES(208,7298,633,5);
INSERT INTO INTERPRETE VALUES(208,7725,633,7);
INSERT INTO INTERPRETE VALUES(208,7726,633,8);
INSERT INTO INTERPRETE VALUES(208,7727,633,9);
INSERT INTO INTERPRETE VALUES(208,7729,633,11);
INSERT INTO INTERPRETE VALUES(208,7731,633,13);
INSERT INTO INTERPRETE VALUES(208,7301,633,14);
INSERT INTO INTERPRETE VALUES(208,7733,633,15);
INSERT INTO INTERPRETE VALUES(208,7734,633,16);
INSERT INTO INTERPRETE VALUES(208,7308,634,2);
INSERT INTO INTERPRETE VALUES(208,7739,634,4);
INSERT INTO INTERPRETE VALUES(208,7742,634,7);
INSERT INTO INTERPRETE VALUES(208,7302,634,10);
INSERT INTO INTERPRETE VALUES(208,7131,634,11);
INSERT INTO INTERPRETE VALUES(223,7748,635,1);
INSERT INTO INTERPRETE VALUES(223,7749,635,2);
INSERT INTO INTERPRETE VALUES(223,7750,635,3);
INSERT INTO INTERPRETE VALUES(223,7751,635,4);
INSERT INTO INTERPRETE VALUES(223,7752,635,5);
INSERT INTO INTERPRETE VALUES(223,7753,635,6);
INSERT INTO INTERPRETE VALUES(223,7754,635,7);
INSERT INTO INTERPRETE VALUES(223,7755,635,8);
INSERT INTO INTERPRETE VALUES(223,7756,635,9);
INSERT INTO INTERPRETE VALUES(223,7757,635,10);
INSERT INTO INTERPRETE VALUES(223,7758,635,11);
INSERT INTO INTERPRETE VALUES(223,7759,635,12);
INSERT INTO INTERPRETE VALUES(223,7760,635,13);
INSERT INTO INTERPRETE VALUES(223,7761,635,14);
INSERT INTO INTERPRETE VALUES(223,7762,635,15);
INSERT INTO INTERPRETE VALUES(223,7682,635,16);
INSERT INTO INTERPRETE VALUES(223,7687,635,17);
INSERT INTO INTERPRETE VALUES(208,7305,633,12);
INSERT INTO INTERPRETE VALUES(208,7140,634,9);
INSERT INTO INTERPRETE VALUES(223,7765,635,18);
INSERT INTO INTERPRETE VALUES(234,7640,636,1);
INSERT INTO INTERPRETE VALUES(234,7767,636,2);
INSERT INTO INTERPRETE VALUES(234,7768,636,3);
INSERT INTO INTERPRETE VALUES(234,7634,636,4);
INSERT INTO INTERPRETE VALUES(234,7770,636,5);
INSERT INTO INTERPRETE VALUES(234,7771,636,6);
INSERT INTO INTERPRETE VALUES(234,7772,636,7);
INSERT INTO INTERPRETE VALUES(234,7773,636,8);
INSERT INTO INTERPRETE VALUES(234,7774,636,9);
INSERT INTO INTERPRETE VALUES(234,7775,636,10);
INSERT INTO INTERPRETE VALUES(234,7776,636,11);
INSERT INTO INTERPRETE VALUES(234,7777,636,12);
INSERT INTO INTERPRETE VALUES(234,7778,636,13);
INSERT INTO INTERPRETE VALUES(234,7779,636,14);
INSERT INTO INTERPRETE VALUES(235,7780,637,1);
INSERT INTO INTERPRETE VALUES(235,7781,637,2);
INSERT INTO INTERPRETE VALUES(235,7782,637,3);
INSERT INTO INTERPRETE VALUES(235,7783,637,4);
INSERT INTO INTERPRETE VALUES(235,7784,637,5);
INSERT INTO INTERPRETE VALUES(235,7785,637,6);
INSERT INTO INTERPRETE VALUES(235,7786,637,7);
INSERT INTO INTERPRETE VALUES(235,7787,637,8);
INSERT INTO INTERPRETE VALUES(235,7788,637,9);
INSERT INTO INTERPRETE VALUES(235,7789,637,10);
INSERT INTO INTERPRETE VALUES(235,7790,637,11);
INSERT INTO INTERPRETE VALUES(235,7791,637,12);
INSERT INTO INTERPRETE VALUES(235,7792,637,13);
INSERT INTO INTERPRETE VALUES(196,7793,638,1);
INSERT INTO INTERPRETE VALUES(196,7419,638,2);
INSERT INTO INTERPRETE VALUES(196,7795,638,3);
INSERT INTO INTERPRETE VALUES(196,7796,638,4);
INSERT INTO INTERPRETE VALUES(196,7797,638,5);
INSERT INTO INTERPRETE VALUES(196,7798,638,6);
INSERT INTO INTERPRETE VALUES(196,7414,638,7);
INSERT INTO INTERPRETE VALUES(196,7800,638,8);
INSERT INTO INTERPRETE VALUES(196,7801,638,9);
INSERT INTO INTERPRETE VALUES(196,7802,638,10);
INSERT INTO INTERPRETE VALUES(196,7803,638,11);
INSERT INTO INTERPRETE VALUES(196,7804,638,12);
INSERT INTO INTERPRETE VALUES(196,7805,638,13);
INSERT INTO INTERPRETE VALUES(196,7806,638,14);
INSERT INTO INTERPRETE VALUES(196,7807,638,15);
INSERT INTO INTERPRETE VALUES(208,7808,639,1);
INSERT INTO INTERPRETE VALUES(208,7809,639,2);
INSERT INTO INTERPRETE VALUES(208,7814,639,7);
INSERT INTO INTERPRETE VALUES(208,7817,639,10);
INSERT INTO INTERPRETE VALUES(207,7819,640,1);
INSERT INTO INTERPRETE VALUES(207,7820,640,2);
INSERT INTO INTERPRETE VALUES(207,7821,640,3);
INSERT INTO INTERPRETE VALUES(207,7822,640,4);
INSERT INTO INTERPRETE VALUES(207,7823,640,5);
INSERT INTO INTERPRETE VALUES(207,7824,640,6);
INSERT INTO INTERPRETE VALUES(207,7825,640,7);
INSERT INTO INTERPRETE VALUES(207,7826,640,8);
INSERT INTO INTERPRETE VALUES(207,7827,640,9);
INSERT INTO INTERPRETE VALUES(207,7828,640,10);
INSERT INTO INTERPRETE VALUES(207,7829,640,11);
INSERT INTO INTERPRETE VALUES(207,7830,640,12);
INSERT INTO INTERPRETE VALUES(236,7831,641,1);
INSERT INTO INTERPRETE VALUES(236,7832,641,2);
INSERT INTO INTERPRETE VALUES(236,7833,641,3);
INSERT INTO INTERPRETE VALUES(236,7834,641,4);
INSERT INTO INTERPRETE VALUES(236,7835,641,5);
INSERT INTO INTERPRETE VALUES(236,7836,641,6);
INSERT INTO INTERPRETE VALUES(236,7837,641,7);
INSERT INTO INTERPRETE VALUES(236,7838,641,8);
INSERT INTO INTERPRETE VALUES(236,7839,641,9);
INSERT INTO INTERPRETE VALUES(236,7840,641,10);
INSERT INTO INTERPRETE VALUES(208,7816,639,9);
INSERT INTO INTERPRETE VALUES(208,7812,639,5);
INSERT INTO INTERPRETE VALUES(236,7841,641,11);
INSERT INTO INTERPRETE VALUES(236,7842,641,12);
INSERT INTO INTERPRETE VALUES(236,7843,641,13);
INSERT INTO INTERPRETE VALUES(236,7844,641,14);
INSERT INTO INTERPRETE VALUES(236,7845,641,15);
INSERT INTO INTERPRETE VALUES(236,7846,641,16);
INSERT INTO INTERPRETE VALUES(236,7847,641,17);
INSERT INTO INTERPRETE VALUES(236,7848,641,18);
INSERT INTO INTERPRETE VALUES(237,7849,642,1);
INSERT INTO INTERPRETE VALUES(237,7850,642,2);
INSERT INTO INTERPRETE VALUES(237,7851,642,3);
INSERT INTO INTERPRETE VALUES(237,7852,642,4);
INSERT INTO INTERPRETE VALUES(237,7853,642,5);
INSERT INTO INTERPRETE VALUES(237,7854,642,6);
INSERT INTO INTERPRETE VALUES(237,7855,642,7);
INSERT INTO INTERPRETE VALUES(237,7856,642,8);
INSERT INTO INTERPRETE VALUES(237,7857,642,9);
INSERT INTO INTERPRETE VALUES(237,7858,642,10);
INSERT INTO INTERPRETE VALUES(237,7859,642,11);
INSERT INTO INTERPRETE VALUES(237,7860,642,12);
INSERT INTO INTERPRETE VALUES(237,7861,642,13);
INSERT INTO INTERPRETE VALUES(237,7862,642,14);
INSERT INTO INTERPRETE VALUES(237,7863,642,15);
INSERT INTO INTERPRETE VALUES(237,7864,642,16);
INSERT INTO INTERPRETE VALUES(237,7865,642,17);
INSERT INTO INTERPRETE VALUES(237,7866,642,18);
INSERT INTO INTERPRETE VALUES(237,7867,642,19);
INSERT INTO INTERPRETE VALUES(237,7868,642,20);
INSERT INTO INTERPRETE VALUES(237,7869,642,21);
INSERT INTO INTERPRETE VALUES(237,7870,642,22);
INSERT INTO INTERPRETE VALUES(237,7871,642,23);
INSERT INTO INTERPRETE VALUES(237,7872,642,24);
INSERT INTO INTERPRETE VALUES(237,7873,642,25);
INSERT INTO INTERPRETE VALUES(237,7874,642,26);
INSERT INTO INTERPRETE VALUES(237,7875,642,27);
INSERT INTO INTERPRETE VALUES(236,7876,643,1);
INSERT INTO INTERPRETE VALUES(236,7877,643,2);
INSERT INTO INTERPRETE VALUES(236,7878,643,3);
INSERT INTO INTERPRETE VALUES(236,7879,643,4);
INSERT INTO INTERPRETE VALUES(236,7880,643,5);
INSERT INTO INTERPRETE VALUES(236,7881,643,6);
INSERT INTO INTERPRETE VALUES(236,7882,643,7);
INSERT INTO INTERPRETE VALUES(236,7883,643,8);
INSERT INTO INTERPRETE VALUES(236,7884,643,9);
INSERT INTO INTERPRETE VALUES(236,7885,643,10);
INSERT INTO INTERPRETE VALUES(236,7886,643,11);
INSERT INTO INTERPRETE VALUES(236,7887,643,12);
INSERT INTO INTERPRETE VALUES(236,7888,643,13);
INSERT INTO INTERPRETE VALUES(236,7889,643,14);
INSERT INTO INTERPRETE VALUES(236,7890,643,15);
INSERT INTO INTERPRETE VALUES(236,7891,643,16);
INSERT INTO INTERPRETE VALUES(236,7892,643,17);
INSERT INTO INTERPRETE VALUES(236,7893,643,18);
INSERT INTO INTERPRETE VALUES(238,7894,644,1);
INSERT INTO INTERPRETE VALUES(238,7895,644,2);
INSERT INTO INTERPRETE VALUES(238,7896,644,3);
INSERT INTO INTERPRETE VALUES(238,7897,644,4);
INSERT INTO INTERPRETE VALUES(238,7898,644,5);
INSERT INTO INTERPRETE VALUES(238,7899,644,6);
INSERT INTO INTERPRETE VALUES(238,7900,644,7);
INSERT INTO INTERPRETE VALUES(238,7901,644,8);
INSERT INTO INTERPRETE VALUES(238,7902,644,9);
INSERT INTO INTERPRETE VALUES(238,7903,644,10);
INSERT INTO INTERPRETE VALUES(238,7904,644,11);
INSERT INTO INTERPRETE VALUES(238,7905,644,12);
INSERT INTO INTERPRETE VALUES(238,7906,644,13);
INSERT INTO INTERPRETE VALUES(217,7907,645,1);
INSERT INTO INTERPRETE VALUES(217,7908,645,2);
INSERT INTO INTERPRETE VALUES(217,7909,645,3);
INSERT INTO INTERPRETE VALUES(217,7910,645,4);
INSERT INTO INTERPRETE VALUES(217,7911,645,5);
INSERT INTO INTERPRETE VALUES(217,7912,645,6);
INSERT INTO INTERPRETE VALUES(217,7913,645,7);
INSERT INTO INTERPRETE VALUES(217,7914,645,8);
INSERT INTO INTERPRETE VALUES(217,7915,645,9);
INSERT INTO INTERPRETE VALUES(238,7916,646,1);
INSERT INTO INTERPRETE VALUES(238,7917,646,2);
INSERT INTO INTERPRETE VALUES(238,7918,646,3);
INSERT INTO INTERPRETE VALUES(238,7919,646,4);
INSERT INTO INTERPRETE VALUES(238,7920,646,5);
INSERT INTO INTERPRETE VALUES(238,7921,646,6);
INSERT INTO INTERPRETE VALUES(238,7922,646,7);
INSERT INTO INTERPRETE VALUES(238,7923,646,8);
INSERT INTO INTERPRETE VALUES(238,7924,646,9);
INSERT INTO INTERPRETE VALUES(238,7925,646,10);
INSERT INTO INTERPRETE VALUES(238,7926,646,11);
INSERT INTO INTERPRETE VALUES(238,7927,646,12);
INSERT INTO INTERPRETE VALUES(238,7928,646,13);
INSERT INTO INTERPRETE VALUES(238,7929,646,14);
INSERT INTO INTERPRETE VALUES(238,7930,647,1);
INSERT INTO INTERPRETE VALUES(238,7931,647,2);
INSERT INTO INTERPRETE VALUES(238,7932,647,3);
INSERT INTO INTERPRETE VALUES(238,7933,647,4);
INSERT INTO INTERPRETE VALUES(238,7934,647,5);
INSERT INTO INTERPRETE VALUES(238,7935,647,6);
INSERT INTO INTERPRETE VALUES(238,7936,647,7);
INSERT INTO INTERPRETE VALUES(238,7937,647,8);
INSERT INTO INTERPRETE VALUES(238,7938,647,9);
INSERT INTO INTERPRETE VALUES(238,7939,647,10);
INSERT INTO INTERPRETE VALUES(238,7940,647,11);
INSERT INTO INTERPRETE VALUES(238,7941,647,12);
INSERT INTO INTERPRETE VALUES(238,7942,648,1);
INSERT INTO INTERPRETE VALUES(238,7943,648,2);
INSERT INTO INTERPRETE VALUES(238,7944,648,3);
INSERT INTO INTERPRETE VALUES(238,7945,648,4);
INSERT INTO INTERPRETE VALUES(238,7946,648,5);
INSERT INTO INTERPRETE VALUES(238,7947,648,6);
INSERT INTO INTERPRETE VALUES(238,7948,648,7);
INSERT INTO INTERPRETE VALUES(238,7949,648,8);
INSERT INTO INTERPRETE VALUES(238,7950,648,9);
INSERT INTO INTERPRETE VALUES(238,7951,648,10);
INSERT INTO INTERPRETE VALUES(238,7952,648,11);
INSERT INTO INTERPRETE VALUES(238,7953,648,12);
INSERT INTO INTERPRETE VALUES(233,7954,649,1);
INSERT INTO INTERPRETE VALUES(233,7955,649,2);
INSERT INTO INTERPRETE VALUES(233,7956,649,3);
INSERT INTO INTERPRETE VALUES(233,7957,649,4);
INSERT INTO INTERPRETE VALUES(233,7958,649,5);
INSERT INTO INTERPRETE VALUES(233,7959,649,6);
INSERT INTO INTERPRETE VALUES(233,7960,649,7);
INSERT INTO INTERPRETE VALUES(233,7961,649,8);
INSERT INTO INTERPRETE VALUES(233,7962,649,9);
INSERT INTO INTERPRETE VALUES(233,7963,649,10);
INSERT INTO INTERPRETE VALUES(230,7964,650,1);
INSERT INTO INTERPRETE VALUES(230,7965,650,2);
INSERT INTO INTERPRETE VALUES(230,7966,650,3);
INSERT INTO INTERPRETE VALUES(230,7967,650,4);
INSERT INTO INTERPRETE VALUES(230,7968,650,5);
INSERT INTO INTERPRETE VALUES(230,7969,650,6);
INSERT INTO INTERPRETE VALUES(230,7970,650,7);
INSERT INTO INTERPRETE VALUES(230,7971,650,8);
INSERT INTO INTERPRETE VALUES(230,7972,650,9);
INSERT INTO INTERPRETE VALUES(230,7973,650,10);
INSERT INTO INTERPRETE VALUES(230,7974,650,11);
INSERT INTO INTERPRETE VALUES(230,7975,650,12);
INSERT INTO INTERPRETE VALUES(230,7976,651,1);
INSERT INTO INTERPRETE VALUES(230,7977,651,2);
INSERT INTO INTERPRETE VALUES(230,7978,651,3);
INSERT INTO INTERPRETE VALUES(230,7979,651,4);
INSERT INTO INTERPRETE VALUES(230,7980,651,5);
INSERT INTO INTERPRETE VALUES(230,7985,651,10);
INSERT INTO INTERPRETE VALUES(230,7986,651,11);
INSERT INTO INTERPRETE VALUES(230,7987,651,12);
INSERT INTO INTERPRETE VALUES(240,7988,652,1);
INSERT INTO INTERPRETE VALUES(240,7989,652,2);
INSERT INTO INTERPRETE VALUES(240,7990,652,3);
INSERT INTO INTERPRETE VALUES(240,7991,652,4);
INSERT INTO INTERPRETE VALUES(240,7992,652,5);
INSERT INTO INTERPRETE VALUES(240,7993,652,6);
INSERT INTO INTERPRETE VALUES(240,7994,652,7);
INSERT INTO INTERPRETE VALUES(240,7995,652,8);
INSERT INTO INTERPRETE VALUES(240,7996,652,9);
INSERT INTO INTERPRETE VALUES(240,7997,652,10);
INSERT INTO INTERPRETE VALUES(240,7998,652,11);
INSERT INTO INTERPRETE VALUES(240,7999,652,12);
INSERT INTO INTERPRETE VALUES(240,8000,652,13);
INSERT INTO INTERPRETE VALUES(240,8001,652,14);
INSERT INTO INTERPRETE VALUES(240,8002,652,15);
INSERT INTO INTERPRETE VALUES(235,8003,653,1);
INSERT INTO INTERPRETE VALUES(235,8004,653,2);
INSERT INTO INTERPRETE VALUES(235,8005,653,3);
INSERT INTO INTERPRETE VALUES(235,8006,653,4);
INSERT INTO INTERPRETE VALUES(235,8007,653,5);
INSERT INTO INTERPRETE VALUES(235,8008,653,6);
INSERT INTO INTERPRETE VALUES(235,8009,653,7);
INSERT INTO INTERPRETE VALUES(235,8010,653,8);
INSERT INTO INTERPRETE VALUES(235,8011,653,9);
INSERT INTO INTERPRETE VALUES(235,8012,653,10);
INSERT INTO INTERPRETE VALUES(235,8013,653,11);
INSERT INTO INTERPRETE VALUES(235,8014,653,12);
INSERT INTO INTERPRETE VALUES(235,8015,653,13);
INSERT INTO INTERPRETE VALUES(235,8016,653,14);
INSERT INTO INTERPRETE VALUES(235,8017,653,15);
INSERT INTO INTERPRETE VALUES(235,8018,653,16);
INSERT INTO INTERPRETE VALUES(235,8019,653,17);
INSERT INTO INTERPRETE VALUES(235,8020,653,18);
INSERT INTO INTERPRETE VALUES(235,8021,653,19);
INSERT INTO INTERPRETE VALUES(226,8022,654,1);
INSERT INTO INTERPRETE VALUES(226,8023,654,2);
INSERT INTO INTERPRETE VALUES(226,8024,654,3);
INSERT INTO INTERPRETE VALUES(226,8025,654,4);
INSERT INTO INTERPRETE VALUES(226,8027,654,6);
INSERT INTO INTERPRETE VALUES(226,8028,654,7);
INSERT INTO INTERPRETE VALUES(226,8029,654,8);
INSERT INTO INTERPRETE VALUES(226,8031,654,10);
INSERT INTO INTERPRETE VALUES(226,8032,654,11);
INSERT INTO INTERPRETE VALUES(226,8033,654,12);
INSERT INTO INTERPRETE VALUES(226,8034,654,13);
INSERT INTO INTERPRETE VALUES(226,8035,654,14);
INSERT INTO INTERPRETE VALUES(226,8036,654,15);
INSERT INTO INTERPRETE VALUES(226,8037,654,16);
INSERT INTO INTERPRETE VALUES(226,8038,654,17);
INSERT INTO INTERPRETE VALUES(203,8039,655,1);
INSERT INTO INTERPRETE VALUES(203,8040,655,2);
INSERT INTO INTERPRETE VALUES(203,8041,655,3);
INSERT INTO INTERPRETE VALUES(203,8042,655,4);
INSERT INTO INTERPRETE VALUES(203,8043,655,5);
INSERT INTO INTERPRETE VALUES(203,8044,655,6);
INSERT INTO INTERPRETE VALUES(203,8045,655,7);
INSERT INTO INTERPRETE VALUES(203,8046,655,8);
INSERT INTO INTERPRETE VALUES(203,8047,655,9);
INSERT INTO INTERPRETE VALUES(241,8049,656,2);
INSERT INTO INTERPRETE VALUES(241,8051,656,4);
INSERT INTO INTERPRETE VALUES(241,8052,656,5);
INSERT INTO INTERPRETE VALUES(241,8053,656,6);
INSERT INTO INTERPRETE VALUES(241,8054,656,7);
INSERT INTO INTERPRETE VALUES(241,8055,656,8);
INSERT INTO INTERPRETE VALUES(241,8057,656,10);
INSERT INTO INTERPRETE VALUES(241,8058,656,11);
INSERT INTO INTERPRETE VALUES(241,8059,656,12);
INSERT INTO INTERPRETE VALUES(242,8060,657,1);
INSERT INTO INTERPRETE VALUES(242,8061,657,2);
INSERT INTO INTERPRETE VALUES(242,8062,657,3);
INSERT INTO INTERPRETE VALUES(242,8063,657,4);
INSERT INTO INTERPRETE VALUES(242,8064,657,5);
INSERT INTO INTERPRETE VALUES(242,8065,657,6);
INSERT INTO INTERPRETE VALUES(242,8066,657,7);
INSERT INTO INTERPRETE VALUES(242,8067,657,8);
INSERT INTO INTERPRETE VALUES(242,8068,657,9);
INSERT INTO INTERPRETE VALUES(242,8069,657,10);
INSERT INTO INTERPRETE VALUES(242,8070,657,11);
INSERT INTO INTERPRETE VALUES(242,8071,657,12);
INSERT INTO INTERPRETE VALUES(242,8072,657,13);
INSERT INTO INTERPRETE VALUES(242,8073,657,14);
INSERT INTO INTERPRETE VALUES(196,8084,659,1);
INSERT INTO INTERPRETE VALUES(196,8085,659,2);
INSERT INTO INTERPRETE VALUES(196,8086,659,3);
INSERT INTO INTERPRETE VALUES(196,8087,659,4);
INSERT INTO INTERPRETE VALUES(196,8088,659,5);
INSERT INTO INTERPRETE VALUES(196,8089,659,6);
INSERT INTO INTERPRETE VALUES(196,8090,659,7);
INSERT INTO INTERPRETE VALUES(196,8091,659,8);
INSERT INTO INTERPRETE VALUES(196,8092,659,9);
INSERT INTO INTERPRETE VALUES(196,8093,659,10);
INSERT INTO INTERPRETE VALUES(196,8094,659,11);
INSERT INTO INTERPRETE VALUES(196,8095,659,12);
INSERT INTO INTERPRETE VALUES(196,8096,659,13);
INSERT INTO INTERPRETE VALUES(196,8097,659,14);
INSERT INTO INTERPRETE VALUES(14,8099,660,1);
INSERT INTO INTERPRETE VALUES(14,8100,660,2);
INSERT INTO INTERPRETE VALUES(14,8101,660,3);
INSERT INTO INTERPRETE VALUES(14,8102,660,4);
INSERT INTO INTERPRETE VALUES(14,8103,660,5);
INSERT INTO INTERPRETE VALUES(14,8104,660,6);
INSERT INTO INTERPRETE VALUES(14,8105,660,7);
INSERT INTO INTERPRETE VALUES(14,8106,660,8);
INSERT INTO INTERPRETE VALUES(14,8107,660,9);
INSERT INTO INTERPRETE VALUES(14,8108,660,10);
INSERT INTO INTERPRETE VALUES(14,8109,660,11);
INSERT INTO INTERPRETE VALUES(14,8110,660,12);
INSERT INTO INTERPRETE VALUES(14,288,661,1);
INSERT INTO INTERPRETE VALUES(14,6610,661,2);
INSERT INTO INTERPRETE VALUES(14,8113,661,3);
INSERT INTO INTERPRETE VALUES(14,8114,661,4);
INSERT INTO INTERPRETE VALUES(14,8115,661,5);
INSERT INTO INTERPRETE VALUES(14,8116,661,6);
INSERT INTO INTERPRETE VALUES(14,8117,661,7);
INSERT INTO INTERPRETE VALUES(14,8118,661,8);
INSERT INTO INTERPRETE VALUES(14,8119,661,9);
INSERT INTO INTERPRETE VALUES(14,8120,661,10);
INSERT INTO INTERPRETE VALUES(14,8121,662,1);
INSERT INTO INTERPRETE VALUES(14,8122,662,2);
INSERT INTO INTERPRETE VALUES(14,8123,662,3);
INSERT INTO INTERPRETE VALUES(14,8124,662,4);
INSERT INTO INTERPRETE VALUES(14,8125,662,5);
INSERT INTO INTERPRETE VALUES(14,8126,662,6);
INSERT INTO INTERPRETE VALUES(14,8127,662,7);
INSERT INTO INTERPRETE VALUES(14,8128,662,8);
INSERT INTO INTERPRETE VALUES(14,8129,662,9);
INSERT INTO INTERPRETE VALUES(14,6603,662,10);
INSERT INTO INTERPRETE VALUES(14,8141,664,1);
INSERT INTO INTERPRETE VALUES(14,8142,664,2);
INSERT INTO INTERPRETE VALUES(14,8143,664,3);
INSERT INTO INTERPRETE VALUES(14,8144,664,4);
INSERT INTO INTERPRETE VALUES(14,8145,664,5);
INSERT INTO INTERPRETE VALUES(14,8146,664,6);
INSERT INTO INTERPRETE VALUES(14,8147,664,7);
INSERT INTO INTERPRETE VALUES(14,8148,664,8);
INSERT INTO INTERPRETE VALUES(14,6606,664,9);
INSERT INTO INTERPRETE VALUES(14,8150,664,10);
INSERT INTO INTERPRETE VALUES(244,8151,665,1);
INSERT INTO INTERPRETE VALUES(244,8152,665,2);
INSERT INTO INTERPRETE VALUES(244,8153,665,3);
INSERT INTO INTERPRETE VALUES(244,8154,665,4);
INSERT INTO INTERPRETE VALUES(244,8156,665,6);
INSERT INTO INTERPRETE VALUES(244,8157,665,7);
INSERT INTO INTERPRETE VALUES(244,8158,665,8);
INSERT INTO INTERPRETE VALUES(244,8159,665,9);
INSERT INTO INTERPRETE VALUES(244,8160,665,10);
INSERT INTO INTERPRETE VALUES(244,8161,665,11);
INSERT INTO INTERPRETE VALUES(244,8162,665,12);
INSERT INTO INTERPRETE VALUES(244,7900,666,1);
INSERT INTO INTERPRETE VALUES(244,8164,666,2);
INSERT INTO INTERPRETE VALUES(244,8165,666,3);
INSERT INTO INTERPRETE VALUES(244,8166,666,4);
INSERT INTO INTERPRETE VALUES(244,8167,666,5);
INSERT INTO INTERPRETE VALUES(244,8168,666,6);
INSERT INTO INTERPRETE VALUES(241,8048,656,1);
INSERT INTO INTERPRETE VALUES(241,8050,656,3);
INSERT INTO INTERPRETE VALUES(241,8056,656,9);
INSERT INTO INTERPRETE VALUES(230,7658,667,1);
INSERT INTO INTERPRETE VALUES(230,7969,667,3);
INSERT INTO INTERPRETE VALUES(230,7966,667,4);
INSERT INTO INTERPRETE VALUES(230,8173,667,5);
INSERT INTO INTERPRETE VALUES(230,7663,667,6);
INSERT INTO INTERPRETE VALUES(230,7967,667,7);
INSERT INTO INTERPRETE VALUES(230,7038,667,9);
INSERT INTO INTERPRETE VALUES(230,8178,667,10);
INSERT INTO INTERPRETE VALUES(230,7659,667,11);
INSERT INTO INTERPRETE VALUES(230,7662,667,12);
INSERT INTO INTERPRETE VALUES(230,8181,667,13);
INSERT INTO INTERPRETE VALUES(230,7965,667,15);
INSERT INTO INTERPRETE VALUES(230,7975,667,8);
INSERT INTO INTERPRETE VALUES(14,292,668,1);
INSERT INTO INTERPRETE VALUES(14,6608,668,2);
INSERT INTO INTERPRETE VALUES(14,8188,668,3);
INSERT INTO INTERPRETE VALUES(14,8189,668,4);
INSERT INTO INTERPRETE VALUES(14,291,668,5);
INSERT INTO INTERPRETE VALUES(14,8191,668,6);
INSERT INTO INTERPRETE VALUES(14,6607,668,7);
INSERT INTO INTERPRETE VALUES(14,8193,668,8);
INSERT INTO INTERPRETE VALUES(14,294,668,9);
INSERT INTO INTERPRETE VALUES(14,8195,669,1);
INSERT INTO INTERPRETE VALUES(14,8196,669,2);
INSERT INTO INTERPRETE VALUES(14,8197,669,3);
INSERT INTO INTERPRETE VALUES(14,8198,669,4);
INSERT INTO INTERPRETE VALUES(14,8199,669,5);
INSERT INTO INTERPRETE VALUES(14,8200,669,6);
INSERT INTO INTERPRETE VALUES(14,8201,669,7);
INSERT INTO INTERPRETE VALUES(14,8202,669,8);
INSERT INTO INTERPRETE VALUES(14,8203,669,9);
INSERT INTO INTERPRETE VALUES(14,8204,669,10);
INSERT INTO INTERPRETE VALUES(14,8205,670,1);
INSERT INTO INTERPRETE VALUES(14,8206,670,2);
INSERT INTO INTERPRETE VALUES(14,8207,670,3);
INSERT INTO INTERPRETE VALUES(14,8208,670,4);
INSERT INTO INTERPRETE VALUES(14,8209,670,5);
INSERT INTO INTERPRETE VALUES(14,8210,670,6);
INSERT INTO INTERPRETE VALUES(14,8211,670,7);
INSERT INTO INTERPRETE VALUES(14,8212,670,8);
INSERT INTO INTERPRETE VALUES(14,8213,670,9);
INSERT INTO INTERPRETE VALUES(14,8214,670,10);
INSERT INTO INTERPRETE VALUES(14,8215,670,11);
INSERT INTO INTERPRETE VALUES(230,8225,672,1);
INSERT INTO INTERPRETE VALUES(230,8226,672,2);
INSERT INTO INTERPRETE VALUES(230,8228,672,4);
INSERT INTO INTERPRETE VALUES(230,7981,672,6);
INSERT INTO INTERPRETE VALUES(230,8231,672,7);
INSERT INTO INTERPRETE VALUES(230,8232,672,8);
INSERT INTO INTERPRETE VALUES(230,7984,672,9);
INSERT INTO INTERPRETE VALUES(230,7973,672,10);
INSERT INTO INTERPRETE VALUES(230,7964,672,12);
INSERT INTO INTERPRETE VALUES(230,7978,672,13);
INSERT INTO INTERPRETE VALUES(230,8238,672,14);
INSERT INTO INTERPRETE VALUES(230,7625,672,15);
INSERT INTO INTERPRETE VALUES(230,7980,672,16);
INSERT INTO INTERPRETE VALUES(230,8242,672,18);
INSERT INTO INTERPRETE VALUES(230,8243,672,19);
INSERT INTO INTERPRETE VALUES(246,8244,673,1);
INSERT INTO INTERPRETE VALUES(246,8245,673,2);
INSERT INTO INTERPRETE VALUES(246,8246,673,3);
INSERT INTO INTERPRETE VALUES(246,8247,673,4);
INSERT INTO INTERPRETE VALUES(246,8248,673,5);
INSERT INTO INTERPRETE VALUES(246,8249,673,6);
INSERT INTO INTERPRETE VALUES(246,8250,673,7);
INSERT INTO INTERPRETE VALUES(246,8251,673,8);
INSERT INTO INTERPRETE VALUES(246,8252,673,9);
INSERT INTO INTERPRETE VALUES(246,8253,673,10);
INSERT INTO INTERPRETE VALUES(246,8254,673,11);
INSERT INTO INTERPRETE VALUES(246,8255,673,12);
INSERT INTO INTERPRETE VALUES(246,8256,673,13);
INSERT INTO INTERPRETE VALUES(246,8257,673,14);
INSERT INTO INTERPRETE VALUES(246,8258,673,15);
INSERT INTO INTERPRETE VALUES(246,8259,673,16);
INSERT INTO INTERPRETE VALUES(246,8260,673,17);
INSERT INTO INTERPRETE VALUES(246,8261,673,18);
INSERT INTO INTERPRETE VALUES(246,8262,673,19);
INSERT INTO INTERPRETE VALUES(246,8263,673,20);
INSERT INTO INTERPRETE VALUES(247,8264,674,1);
INSERT INTO INTERPRETE VALUES(247,8265,674,2);
INSERT INTO INTERPRETE VALUES(247,8266,674,3);
INSERT INTO INTERPRETE VALUES(247,8267,674,4);
INSERT INTO INTERPRETE VALUES(247,8268,674,5);
INSERT INTO INTERPRETE VALUES(247,8269,674,6);
INSERT INTO INTERPRETE VALUES(230,8227,672,3);
INSERT INTO INTERPRETE VALUES(230,8229,672,5);
INSERT INTO INTERPRETE VALUES(230,7977,672,11);
INSERT INTO INTERPRETE VALUES(230,7667,667,17);
INSERT INTO INTERPRETE VALUES(247,8270,674,7);
INSERT INTO INTERPRETE VALUES(247,8271,674,8);
INSERT INTO INTERPRETE VALUES(247,8272,674,9);
INSERT INTO INTERPRETE VALUES(247,8273,674,10);
INSERT INTO INTERPRETE VALUES(247,8274,674,11);
INSERT INTO INTERPRETE VALUES(247,8275,674,12);
INSERT INTO INTERPRETE VALUES(247,8276,674,13);
INSERT INTO INTERPRETE VALUES(247,8277,674,14);
INSERT INTO INTERPRETE VALUES(247,8278,674,15);
INSERT INTO INTERPRETE VALUES(247,8279,674,16);
INSERT INTO INTERPRETE VALUES(247,8280,674,17);
INSERT INTO INTERPRETE VALUES(247,8281,674,18);
INSERT INTO INTERPRETE VALUES(247,8282,674,19);
INSERT INTO INTERPRETE VALUES(247,8283,674,20);
INSERT INTO INTERPRETE VALUES(247,8284,675,1);
INSERT INTO INTERPRETE VALUES(247,8285,675,2);
INSERT INTO INTERPRETE VALUES(247,8286,675,3);
INSERT INTO INTERPRETE VALUES(247,8287,675,4);
INSERT INTO INTERPRETE VALUES(247,8288,675,5);
INSERT INTO INTERPRETE VALUES(247,8289,675,6);
INSERT INTO INTERPRETE VALUES(247,8290,675,7);
INSERT INTO INTERPRETE VALUES(247,8291,675,8);
INSERT INTO INTERPRETE VALUES(247,8292,675,9);
INSERT INTO INTERPRETE VALUES(247,8293,675,10);
INSERT INTO INTERPRETE VALUES(247,8294,675,11);
INSERT INTO INTERPRETE VALUES(247,8295,675,12);
INSERT INTO INTERPRETE VALUES(247,8296,675,13);
INSERT INTO INTERPRETE VALUES(247,8297,675,14);
INSERT INTO INTERPRETE VALUES(247,8298,675,15);
INSERT INTO INTERPRETE VALUES(247,8299,675,16);
INSERT INTO INTERPRETE VALUES(247,8300,675,17);
INSERT INTO INTERPRETE VALUES(247,8301,675,18);
INSERT INTO INTERPRETE VALUES(247,8302,675,19);
INSERT INTO INTERPRETE VALUES(247,8303,675,20);
INSERT INTO INTERPRETE VALUES(248,8304,676,1);
INSERT INTO INTERPRETE VALUES(248,8305,676,2);
INSERT INTO INTERPRETE VALUES(248,8306,676,3);
INSERT INTO INTERPRETE VALUES(248,8307,676,4);
INSERT INTO INTERPRETE VALUES(248,8308,676,5);
INSERT INTO INTERPRETE VALUES(248,8309,676,6);
INSERT INTO INTERPRETE VALUES(248,8310,676,7);
INSERT INTO INTERPRETE VALUES(248,8311,676,8);
INSERT INTO INTERPRETE VALUES(248,8312,676,9);
INSERT INTO INTERPRETE VALUES(248,8313,676,10);
INSERT INTO INTERPRETE VALUES(249,8322,677,9);
INSERT INTO INTERPRETE VALUES(249,8323,677,10);
INSERT INTO INTERPRETE VALUES(249,8324,677,11);
INSERT INTO INTERPRETE VALUES(249,8325,677,12);
INSERT INTO INTERPRETE VALUES(249,8326,677,13);
INSERT INTO INTERPRETE VALUES(249,8327,677,14);
INSERT INTO INTERPRETE VALUES(249,8328,677,15);
INSERT INTO INTERPRETE VALUES(249,8329,677,16);
INSERT INTO INTERPRETE VALUES(249,8330,677,17);
INSERT INTO INTERPRETE VALUES(249,8331,677,18);
INSERT INTO INTERPRETE VALUES(250,8332,678,1);
INSERT INTO INTERPRETE VALUES(250,8333,678,2);
INSERT INTO INTERPRETE VALUES(250,8334,678,3);
INSERT INTO INTERPRETE VALUES(250,8335,678,4);
INSERT INTO INTERPRETE VALUES(250,8336,678,5);
INSERT INTO INTERPRETE VALUES(250,8337,678,6);
INSERT INTO INTERPRETE VALUES(250,8338,678,7);
INSERT INTO INTERPRETE VALUES(250,8339,678,8);
INSERT INTO INTERPRETE VALUES(250,8340,678,9);
INSERT INTO INTERPRETE VALUES(250,8341,678,10);
INSERT INTO INTERPRETE VALUES(250,8342,678,11);
INSERT INTO INTERPRETE VALUES(250,8343,678,12);
INSERT INTO INTERPRETE VALUES(250,8344,678,13);
INSERT INTO INTERPRETE VALUES(250,8345,678,14);
INSERT INTO INTERPRETE VALUES(250,8346,678,15);
INSERT INTO INTERPRETE VALUES(250,8347,678,16);
INSERT INTO INTERPRETE VALUES(249,8348,679,1);
INSERT INTO INTERPRETE VALUES(249,8349,679,2);
INSERT INTO INTERPRETE VALUES(249,8350,679,3);
INSERT INTO INTERPRETE VALUES(249,8351,679,4);
INSERT INTO INTERPRETE VALUES(249,8352,679,5);
INSERT INTO INTERPRETE VALUES(249,8330,679,6);
INSERT INTO INTERPRETE VALUES(249,8354,679,7);
INSERT INTO INTERPRETE VALUES(249,8355,679,8);
INSERT INTO INTERPRETE VALUES(249,8356,679,9);
INSERT INTO INTERPRETE VALUES(249,8357,679,10);
INSERT INTO INTERPRETE VALUES(249,8358,679,11);
INSERT INTO INTERPRETE VALUES(249,8359,679,12);
INSERT INTO INTERPRETE VALUES(249,8360,679,13);
INSERT INTO INTERPRETE VALUES(249,8361,679,14);
INSERT INTO INTERPRETE VALUES(249,8362,679,15);
INSERT INTO INTERPRETE VALUES(249,8363,679,16);
INSERT INTO INTERPRETE VALUES(249,8364,679,17);
INSERT INTO INTERPRETE VALUES(249,8365,679,18);
INSERT INTO INTERPRETE VALUES(251,8366,680,1);
INSERT INTO INTERPRETE VALUES(251,8367,680,2);
INSERT INTO INTERPRETE VALUES(252,8368,681,1);
INSERT INTO INTERPRETE VALUES(252,8369,681,2);
INSERT INTO INTERPRETE VALUES(252,8370,681,3);
INSERT INTO INTERPRETE VALUES(252,8371,681,4);
INSERT INTO INTERPRETE VALUES(252,8372,681,5);
INSERT INTO INTERPRETE VALUES(252,8373,681,6);
INSERT INTO INTERPRETE VALUES(252,8374,681,7);
INSERT INTO INTERPRETE VALUES(252,8375,681,8);
INSERT INTO INTERPRETE VALUES(252,8376,681,9);
INSERT INTO INTERPRETE VALUES(252,8377,681,10);
INSERT INTO INTERPRETE VALUES(252,8378,681,11);
INSERT INTO INTERPRETE VALUES(252,8379,681,12);
INSERT INTO INTERPRETE VALUES(252,8380,681,13);
INSERT INTO INTERPRETE VALUES(252,8381,681,14);
INSERT INTO INTERPRETE VALUES(252,8382,681,15);
INSERT INTO INTERPRETE VALUES(252,7132,681,16);
INSERT INTO INTERPRETE VALUES(252,8384,681,17);
INSERT INTO INTERPRETE VALUES(252,8385,681,18);
INSERT INTO INTERPRETE VALUES(253,8386,682,1);
INSERT INTO INTERPRETE VALUES(253,8387,682,2);
INSERT INTO INTERPRETE VALUES(253,8388,682,3);
INSERT INTO INTERPRETE VALUES(253,8389,682,4);
INSERT INTO INTERPRETE VALUES(253,8390,682,5);
INSERT INTO INTERPRETE VALUES(253,8391,682,6);
INSERT INTO INTERPRETE VALUES(253,8392,682,7);
INSERT INTO INTERPRETE VALUES(253,8393,682,8);
INSERT INTO INTERPRETE VALUES(253,8394,682,9);
INSERT INTO INTERPRETE VALUES(253,8395,682,10);
INSERT INTO INTERPRETE VALUES(253,8396,682,11);
INSERT INTO INTERPRETE VALUES(253,8397,682,12);
INSERT INTO INTERPRETE VALUES(253,8398,682,13);
INSERT INTO INTERPRETE VALUES(253,8399,682,14);
INSERT INTO INTERPRETE VALUES(253,8400,682,15);
INSERT INTO INTERPRETE VALUES(253,8401,682,16);
INSERT INTO INTERPRETE VALUES(253,8402,682,17);
INSERT INTO INTERPRETE VALUES(253,8403,682,18);
INSERT INTO INTERPRETE VALUES(253,8404,682,19);
INSERT INTO INTERPRETE VALUES(253,8405,682,20);
INSERT INTO INTERPRETE VALUES(254,8406,683,1);
INSERT INTO INTERPRETE VALUES(254,8407,683,2);
INSERT INTO INTERPRETE VALUES(254,8408,683,3);
INSERT INTO INTERPRETE VALUES(254,8409,683,4);
INSERT INTO INTERPRETE VALUES(254,8410,683,5);
INSERT INTO INTERPRETE VALUES(254,8411,683,6);
INSERT INTO INTERPRETE VALUES(254,8412,683,7);
INSERT INTO INTERPRETE VALUES(254,8413,683,8);
INSERT INTO INTERPRETE VALUES(254,8414,683,9);
INSERT INTO INTERPRETE VALUES(254,8415,683,10);
INSERT INTO INTERPRETE VALUES(254,8416,683,11);
INSERT INTO INTERPRETE VALUES(254,8417,683,12);
INSERT INTO INTERPRETE VALUES(254,8418,683,13);
INSERT INTO INTERPRETE VALUES(254,9184,683,14);
INSERT INTO INTERPRETE VALUES(254,8420,683,15);
INSERT INTO INTERPRETE VALUES(254,8421,683,16);
INSERT INTO INTERPRETE VALUES(254,8422,683,17);
INSERT INTO INTERPRETE VALUES(160,8423,684,1);
INSERT INTO INTERPRETE VALUES(160,8424,684,2);
INSERT INTO INTERPRETE VALUES(160,8426,684,4);
INSERT INTO INTERPRETE VALUES(160,8427,684,5);
INSERT INTO INTERPRETE VALUES(160,8429,684,7);
INSERT INTO INTERPRETE VALUES(160,8430,684,8);
INSERT INTO INTERPRETE VALUES(160,8431,684,9);
INSERT INTO INTERPRETE VALUES(160,8432,684,10);
INSERT INTO INTERPRETE VALUES(160,8433,684,11);
INSERT INTO INTERPRETE VALUES(160,8434,684,12);
INSERT INTO INTERPRETE VALUES(160,5232,684,13);
INSERT INTO INTERPRETE VALUES(160,8436,684,14);
INSERT INTO INTERPRETE VALUES(160,8437,684,15);
INSERT INTO INTERPRETE VALUES(160,8438,684,16);
INSERT INTO INTERPRETE VALUES(160,8439,684,17);
INSERT INTO INTERPRETE VALUES(160,8440,684,18);
INSERT INTO INTERPRETE VALUES(160,5391,684,19);
INSERT INTO INTERPRETE VALUES(255,8442,685,1);
INSERT INTO INTERPRETE VALUES(255,8443,685,2);
INSERT INTO INTERPRETE VALUES(255,8444,685,3);
INSERT INTO INTERPRETE VALUES(255,8445,685,4);
INSERT INTO INTERPRETE VALUES(255,8446,685,5);
INSERT INTO INTERPRETE VALUES(255,8447,685,6);
INSERT INTO INTERPRETE VALUES(255,8448,685,7);
INSERT INTO INTERPRETE VALUES(255,8449,685,8);
INSERT INTO INTERPRETE VALUES(255,8450,685,9);
INSERT INTO INTERPRETE VALUES(256,8477,686,16);
INSERT INTO INTERPRETE VALUES(256,8478,686,17);
INSERT INTO INTERPRETE VALUES(256,8479,686,18);
INSERT INTO INTERPRETE VALUES(168,8480,687,1);
INSERT INTO INTERPRETE VALUES(168,8481,687,2);
INSERT INTO INTERPRETE VALUES(168,5535,687,3);
INSERT INTO INTERPRETE VALUES(168,8483,687,4);
INSERT INTO INTERPRETE VALUES(168,8484,687,5);
INSERT INTO INTERPRETE VALUES(168,8485,687,6);
INSERT INTO INTERPRETE VALUES(168,8486,687,7);
INSERT INTO INTERPRETE VALUES(168,8487,687,8);
INSERT INTO INTERPRETE VALUES(168,8488,687,9);
INSERT INTO INTERPRETE VALUES(168,8489,687,10);
INSERT INTO INTERPRETE VALUES(168,8490,687,11);
INSERT INTO INTERPRETE VALUES(168,2363,687,12);
INSERT INTO INTERPRETE VALUES(168,5541,687,13);
INSERT INTO INTERPRETE VALUES(168,8493,687,14);
INSERT INTO INTERPRETE VALUES(168,8494,687,15);
INSERT INTO INTERPRETE VALUES(168,8495,687,16);
INSERT INTO INTERPRETE VALUES(168,8496,687,17);
INSERT INTO INTERPRETE VALUES(168,8497,687,18);
INSERT INTO INTERPRETE VALUES(168,8498,687,19);
INSERT INTO INTERPRETE VALUES(168,8499,687,20);
INSERT INTO INTERPRETE VALUES(168,8500,687,21);
INSERT INTO INTERPRETE VALUES(257,8501,688,1);
INSERT INTO INTERPRETE VALUES(257,8502,688,2);
INSERT INTO INTERPRETE VALUES(257,8503,688,3);
INSERT INTO INTERPRETE VALUES(257,8504,688,4);
INSERT INTO INTERPRETE VALUES(257,8505,688,5);
INSERT INTO INTERPRETE VALUES(257,8506,688,6);
INSERT INTO INTERPRETE VALUES(257,8507,688,7);
INSERT INTO INTERPRETE VALUES(257,8508,688,8);
INSERT INTO INTERPRETE VALUES(257,8509,688,9);
INSERT INTO INTERPRETE VALUES(257,8510,688,10);
INSERT INTO INTERPRETE VALUES(257,8511,688,11);
INSERT INTO INTERPRETE VALUES(257,8512,688,12);
INSERT INTO INTERPRETE VALUES(257,8513,688,13);
INSERT INTO INTERPRETE VALUES(257,8514,688,14);
INSERT INTO INTERPRETE VALUES(257,8515,688,15);
INSERT INTO INTERPRETE VALUES(257,8516,688,16);
INSERT INTO INTERPRETE VALUES(257,8517,688,17);
INSERT INTO INTERPRETE VALUES(257,8519,688,19);
INSERT INTO INTERPRETE VALUES(257,8520,688,20);
INSERT INTO INTERPRETE VALUES(257,8521,688,21);
INSERT INTO INTERPRETE VALUES(257,8522,688,22);
INSERT INTO INTERPRETE VALUES(216,8524,689,2);
INSERT INTO INTERPRETE VALUES(216,8526,689,4);
INSERT INTO INTERPRETE VALUES(216,8897,689,5);
INSERT INTO INTERPRETE VALUES(216,8528,689,6);
INSERT INTO INTERPRETE VALUES(216,8529,689,7);
INSERT INTO INTERPRETE VALUES(216,8533,689,11);
INSERT INTO INTERPRETE VALUES(216,8537,689,15);
INSERT INTO INTERPRETE VALUES(216,8542,689,20);
INSERT INTO INTERPRETE VALUES(168,8543,690,1);
INSERT INTO INTERPRETE VALUES(168,8544,690,2);
INSERT INTO INTERPRETE VALUES(168,8545,690,3);
INSERT INTO INTERPRETE VALUES(168,8546,690,4);
INSERT INTO INTERPRETE VALUES(168,8547,690,5);
INSERT INTO INTERPRETE VALUES(168,8548,690,6);
INSERT INTO INTERPRETE VALUES(168,8549,690,7);
INSERT INTO INTERPRETE VALUES(168,8550,690,8);
INSERT INTO INTERPRETE VALUES(168,8551,690,9);
INSERT INTO INTERPRETE VALUES(168,8552,690,10);
INSERT INTO INTERPRETE VALUES(168,8553,690,11);
INSERT INTO INTERPRETE VALUES(168,8554,690,12);
INSERT INTO INTERPRETE VALUES(168,8555,690,13);
INSERT INTO INTERPRETE VALUES(168,8556,690,14);
INSERT INTO INTERPRETE VALUES(168,8557,690,15);
INSERT INTO INTERPRETE VALUES(168,8558,690,16);
INSERT INTO INTERPRETE VALUES(168,8559,690,17);
INSERT INTO INTERPRETE VALUES(168,8560,690,18);
INSERT INTO INTERPRETE VALUES(168,8561,690,19);
INSERT INTO INTERPRETE VALUES(168,8562,690,20);
INSERT INTO INTERPRETE VALUES(168,8563,690,21);
INSERT INTO INTERPRETE VALUES(168,8564,690,22);
INSERT INTO INTERPRETE VALUES(258,8565,691,1);
INSERT INTO INTERPRETE VALUES(258,8566,691,2);
INSERT INTO INTERPRETE VALUES(258,8567,691,3);
INSERT INTO INTERPRETE VALUES(258,8568,691,4);
INSERT INTO INTERPRETE VALUES(258,8569,691,5);
INSERT INTO INTERPRETE VALUES(258,8570,691,6);
INSERT INTO INTERPRETE VALUES(258,8571,691,7);
INSERT INTO INTERPRETE VALUES(258,8572,691,8);
INSERT INTO INTERPRETE VALUES(258,8573,691,9);
INSERT INTO INTERPRETE VALUES(258,8574,691,10);
INSERT INTO INTERPRETE VALUES(258,8575,691,11);
INSERT INTO INTERPRETE VALUES(258,8576,691,12);
INSERT INTO INTERPRETE VALUES(258,8577,691,13);
INSERT INTO INTERPRETE VALUES(258,8578,691,14);
INSERT INTO INTERPRETE VALUES(258,8579,691,15);
INSERT INTO INTERPRETE VALUES(258,8580,691,16);
INSERT INTO INTERPRETE VALUES(258,8581,691,17);
INSERT INTO INTERPRETE VALUES(258,8582,691,18);
INSERT INTO INTERPRETE VALUES(258,8583,691,19);
INSERT INTO INTERPRETE VALUES(258,8584,691,20);
INSERT INTO INTERPRETE VALUES(258,8585,691,21);
INSERT INTO INTERPRETE VALUES(258,8586,692,1);
INSERT INTO INTERPRETE VALUES(258,1493,692,2);
INSERT INTO INTERPRETE VALUES(258,8588,692,3);
INSERT INTO INTERPRETE VALUES(258,8589,692,4);
INSERT INTO INTERPRETE VALUES(258,8590,692,5);
INSERT INTO INTERPRETE VALUES(258,8591,692,6);
INSERT INTO INTERPRETE VALUES(258,8592,692,7);
INSERT INTO INTERPRETE VALUES(258,8593,692,8);
INSERT INTO INTERPRETE VALUES(258,8594,692,9);
INSERT INTO INTERPRETE VALUES(258,8595,692,10);
INSERT INTO INTERPRETE VALUES(258,8596,692,11);
INSERT INTO INTERPRETE VALUES(258,8597,692,12);
INSERT INTO INTERPRETE VALUES(258,8598,692,13);
INSERT INTO INTERPRETE VALUES(258,8599,692,14);
INSERT INTO INTERPRETE VALUES(258,8600,692,15);
INSERT INTO INTERPRETE VALUES(258,8601,692,16);
INSERT INTO INTERPRETE VALUES(258,8602,692,17);
INSERT INTO INTERPRETE VALUES(258,8603,692,18);
INSERT INTO INTERPRETE VALUES(258,8604,692,19);
INSERT INTO INTERPRETE VALUES(258,8605,692,20);
INSERT INTO INTERPRETE VALUES(258,8606,692,21);
INSERT INTO INTERPRETE VALUES(258,8607,692,22);
INSERT INTO INTERPRETE VALUES(258,8608,692,23);
INSERT INTO INTERPRETE VALUES(258,8609,692,24);
INSERT INTO INTERPRETE VALUES(258,8610,692,25);
INSERT INTO INTERPRETE VALUES(252,8611,693,1);
INSERT INTO INTERPRETE VALUES(252,8612,693,2);
INSERT INTO INTERPRETE VALUES(252,8613,693,3);
INSERT INTO INTERPRETE VALUES(252,8614,693,4);
INSERT INTO INTERPRETE VALUES(252,8615,693,5);
INSERT INTO INTERPRETE VALUES(252,8616,693,6);
INSERT INTO INTERPRETE VALUES(252,8617,693,7);
INSERT INTO INTERPRETE VALUES(252,8618,693,8);
INSERT INTO INTERPRETE VALUES(252,8619,693,9);
INSERT INTO INTERPRETE VALUES(252,8620,693,10);
INSERT INTO INTERPRETE VALUES(252,8621,693,11);
INSERT INTO INTERPRETE VALUES(252,8622,693,12);
INSERT INTO INTERPRETE VALUES(252,8623,693,13);
INSERT INTO INTERPRETE VALUES(252,8624,693,14);
INSERT INTO INTERPRETE VALUES(252,8625,693,15);
INSERT INTO INTERPRETE VALUES(252,8626,693,16);
INSERT INTO INTERPRETE VALUES(252,8627,693,17);
INSERT INTO INTERPRETE VALUES(252,8628,693,18);
INSERT INTO INTERPRETE VALUES(252,8629,693,19);
INSERT INTO INTERPRETE VALUES(252,8630,693,20);
INSERT INTO INTERPRETE VALUES(252,8631,693,21);
INSERT INTO INTERPRETE VALUES(252,8632,693,22);
INSERT INTO INTERPRETE VALUES(252,8633,693,23);
INSERT INTO INTERPRETE VALUES(252,8634,694,1);
INSERT INTO INTERPRETE VALUES(252,8635,694,2);
INSERT INTO INTERPRETE VALUES(252,7304,694,3);
INSERT INTO INTERPRETE VALUES(252,8637,694,4);
INSERT INTO INTERPRETE VALUES(252,8638,694,5);
INSERT INTO INTERPRETE VALUES(252,8639,694,6);
INSERT INTO INTERPRETE VALUES(252,8640,694,7);
INSERT INTO INTERPRETE VALUES(252,8641,694,8);
INSERT INTO INTERPRETE VALUES(252,8642,694,9);
INSERT INTO INTERPRETE VALUES(252,8643,694,10);
INSERT INTO INTERPRETE VALUES(252,8644,694,11);
INSERT INTO INTERPRETE VALUES(252,8645,694,12);
INSERT INTO INTERPRETE VALUES(252,8646,694,13);
INSERT INTO INTERPRETE VALUES(252,8647,694,14);
INSERT INTO INTERPRETE VALUES(252,8648,694,15);
INSERT INTO INTERPRETE VALUES(252,8649,694,16);
INSERT INTO INTERPRETE VALUES(252,8650,694,17);
INSERT INTO INTERPRETE VALUES(252,8651,694,18);
INSERT INTO INTERPRETE VALUES(252,8652,694,19);
INSERT INTO INTERPRETE VALUES(252,8653,694,20);
INSERT INTO INTERPRETE VALUES(252,8654,694,21);
INSERT INTO INTERPRETE VALUES(259,8655,695,1);
INSERT INTO INTERPRETE VALUES(259,8656,695,2);
INSERT INTO INTERPRETE VALUES(259,8657,695,3);
INSERT INTO INTERPRETE VALUES(259,8658,695,4);
INSERT INTO INTERPRETE VALUES(259,8659,695,5);
INSERT INTO INTERPRETE VALUES(259,8660,695,6);
INSERT INTO INTERPRETE VALUES(259,8661,695,7);
INSERT INTO INTERPRETE VALUES(259,8662,695,8);
INSERT INTO INTERPRETE VALUES(259,8663,695,9);
INSERT INTO INTERPRETE VALUES(259,8664,695,10);
INSERT INTO INTERPRETE VALUES(259,8665,695,11);
INSERT INTO INTERPRETE VALUES(259,8666,695,12);
INSERT INTO INTERPRETE VALUES(259,8667,695,13);
INSERT INTO INTERPRETE VALUES(259,8668,695,14);
INSERT INTO INTERPRETE VALUES(259,8669,695,15);
INSERT INTO INTERPRETE VALUES(259,8670,695,16);
INSERT INTO INTERPRETE VALUES(259,8671,695,17);
INSERT INTO INTERPRETE VALUES(259,8672,695,18);
INSERT INTO INTERPRETE VALUES(259,8673,695,19);
INSERT INTO INTERPRETE VALUES(259,8674,695,20);
INSERT INTO INTERPRETE VALUES(252,8675,696,1);
INSERT INTO INTERPRETE VALUES(252,8676,696,2);
INSERT INTO INTERPRETE VALUES(252,8677,696,3);
INSERT INTO INTERPRETE VALUES(252,8678,696,4);
INSERT INTO INTERPRETE VALUES(252,8679,696,5);
INSERT INTO INTERPRETE VALUES(252,8680,696,6);
INSERT INTO INTERPRETE VALUES(252,8681,696,7);
INSERT INTO INTERPRETE VALUES(252,8682,696,8);
INSERT INTO INTERPRETE VALUES(252,8683,696,9);
INSERT INTO INTERPRETE VALUES(252,8684,696,10);
INSERT INTO INTERPRETE VALUES(252,8685,696,11);
INSERT INTO INTERPRETE VALUES(252,8686,696,12);
INSERT INTO INTERPRETE VALUES(252,8687,696,13);
INSERT INTO INTERPRETE VALUES(252,8688,696,14);
INSERT INTO INTERPRETE VALUES(252,8689,696,15);
INSERT INTO INTERPRETE VALUES(252,8690,696,16);
INSERT INTO INTERPRETE VALUES(252,8691,696,17);
INSERT INTO INTERPRETE VALUES(252,8692,696,18);
INSERT INTO INTERPRETE VALUES(252,8693,696,19);
INSERT INTO INTERPRETE VALUES(252,8694,696,20);
INSERT INTO INTERPRETE VALUES(252,8695,696,21);
INSERT INTO INTERPRETE VALUES(125,8696,697,1);
INSERT INTO INTERPRETE VALUES(125,8697,697,2);
INSERT INTO INTERPRETE VALUES(125,8698,697,3);
INSERT INTO INTERPRETE VALUES(125,8699,697,4);
INSERT INTO INTERPRETE VALUES(125,8700,697,5);
INSERT INTO INTERPRETE VALUES(125,8701,697,6);
INSERT INTO INTERPRETE VALUES(125,8702,697,7);
INSERT INTO INTERPRETE VALUES(125,8703,697,8);
INSERT INTO INTERPRETE VALUES(125,8704,697,9);
INSERT INTO INTERPRETE VALUES(125,8705,697,10);
INSERT INTO INTERPRETE VALUES(125,8706,697,11);
INSERT INTO INTERPRETE VALUES(125,8707,697,12);
INSERT INTO INTERPRETE VALUES(125,8708,697,13);
INSERT INTO INTERPRETE VALUES(125,8709,697,14);
INSERT INTO INTERPRETE VALUES(125,8710,697,15);
INSERT INTO INTERPRETE VALUES(125,8711,697,16);
INSERT INTO INTERPRETE VALUES(125,8712,697,17);
INSERT INTO INTERPRETE VALUES(125,8713,697,18);
INSERT INTO INTERPRETE VALUES(125,8714,697,19);
INSERT INTO INTERPRETE VALUES(125,8715,697,20);
INSERT INTO INTERPRETE VALUES(125,8716,697,21);
INSERT INTO INTERPRETE VALUES(125,8717,697,22);
INSERT INTO INTERPRETE VALUES(125,8718,697,23);
INSERT INTO INTERPRETE VALUES(260,8719,698,1);
INSERT INTO INTERPRETE VALUES(260,8720,698,2);
INSERT INTO INTERPRETE VALUES(260,8721,698,3);
INSERT INTO INTERPRETE VALUES(260,8722,698,4);
INSERT INTO INTERPRETE VALUES(260,8723,698,5);
INSERT INTO INTERPRETE VALUES(260,8724,698,6);
INSERT INTO INTERPRETE VALUES(260,8725,698,7);
INSERT INTO INTERPRETE VALUES(168,8749,700,1);
INSERT INTO INTERPRETE VALUES(168,8750,700,2);
INSERT INTO INTERPRETE VALUES(168,8751,700,3);
INSERT INTO INTERPRETE VALUES(168,8752,700,4);
INSERT INTO INTERPRETE VALUES(168,8753,700,5);
INSERT INTO INTERPRETE VALUES(168,8754,700,6);
INSERT INTO INTERPRETE VALUES(168,8755,700,7);
INSERT INTO INTERPRETE VALUES(168,8756,700,8);
INSERT INTO INTERPRETE VALUES(168,8757,700,9);
INSERT INTO INTERPRETE VALUES(168,8758,700,10);
INSERT INTO INTERPRETE VALUES(168,8759,700,11);
INSERT INTO INTERPRETE VALUES(168,8760,700,12);
INSERT INTO INTERPRETE VALUES(168,8761,700,13);
INSERT INTO INTERPRETE VALUES(168,8762,700,14);
INSERT INTO INTERPRETE VALUES(168,8763,700,15);
INSERT INTO INTERPRETE VALUES(168,8764,700,16);
INSERT INTO INTERPRETE VALUES(168,8765,700,17);
INSERT INTO INTERPRETE VALUES(168,8766,700,18);
INSERT INTO INTERPRETE VALUES(168,8767,700,19);
INSERT INTO INTERPRETE VALUES(168,8768,700,20);
INSERT INTO INTERPRETE VALUES(168,8769,700,21);
INSERT INTO INTERPRETE VALUES(168,8770,700,22);
INSERT INTO INTERPRETE VALUES(168,8771,700,23);
INSERT INTO INTERPRETE VALUES(168,8772,700,24);
INSERT INTO INTERPRETE VALUES(199,8773,701,1);
INSERT INTO INTERPRETE VALUES(199,8774,701,2);
INSERT INTO INTERPRETE VALUES(199,8775,701,3);
INSERT INTO INTERPRETE VALUES(199,8776,701,4);
INSERT INTO INTERPRETE VALUES(199,8777,701,5);
INSERT INTO INTERPRETE VALUES(199,8778,701,6);
INSERT INTO INTERPRETE VALUES(254,8779,702,1);
INSERT INTO INTERPRETE VALUES(254,8780,702,2);
INSERT INTO INTERPRETE VALUES(254,8781,702,3);
INSERT INTO INTERPRETE VALUES(254,8782,702,4);
INSERT INTO INTERPRETE VALUES(254,8407,702,5);
INSERT INTO INTERPRETE VALUES(254,8784,702,6);
INSERT INTO INTERPRETE VALUES(254,8785,702,7);
INSERT INTO INTERPRETE VALUES(254,8786,702,8);
INSERT INTO INTERPRETE VALUES(254,8787,702,9);
INSERT INTO INTERPRETE VALUES(254,8788,702,10);
INSERT INTO INTERPRETE VALUES(254,8789,702,11);
INSERT INTO INTERPRETE VALUES(254,8790,702,12);
INSERT INTO INTERPRETE VALUES(254,9284,702,13);
INSERT INTO INTERPRETE VALUES(254,8416,702,14);
INSERT INTO INTERPRETE VALUES(254,8793,702,15);
INSERT INTO INTERPRETE VALUES(254,8794,702,16);
INSERT INTO INTERPRETE VALUES(254,8795,702,17);
INSERT INTO INTERPRETE VALUES(254,8414,702,18);
INSERT INTO INTERPRETE VALUES(254,8408,702,19);
INSERT INTO INTERPRETE VALUES(254,8418,702,20);
INSERT INTO INTERPRETE VALUES(254,8799,702,21);
INSERT INTO INTERPRETE VALUES(254,8800,702,22);
INSERT INTO INTERPRETE VALUES(254,8801,702,23);
INSERT INTO INTERPRETE VALUES(260,8802,703,1);
INSERT INTO INTERPRETE VALUES(260,8803,703,2);
INSERT INTO INTERPRETE VALUES(260,8804,703,3);
INSERT INTO INTERPRETE VALUES(260,8805,703,4);
INSERT INTO INTERPRETE VALUES(260,8806,703,5);
INSERT INTO INTERPRETE VALUES(260,8807,703,6);
INSERT INTO INTERPRETE VALUES(260,8808,704,1);
INSERT INTO INTERPRETE VALUES(260,8809,704,2);
INSERT INTO INTERPRETE VALUES(260,8810,704,3);
INSERT INTO INTERPRETE VALUES(260,8811,704,4);
INSERT INTO INTERPRETE VALUES(260,8812,704,5);
INSERT INTO INTERPRETE VALUES(260,8813,704,6);
INSERT INTO INTERPRETE VALUES(260,8814,704,7);
INSERT INTO INTERPRETE VALUES(168,8815,705,1);
INSERT INTO INTERPRETE VALUES(168,8816,705,2);
INSERT INTO INTERPRETE VALUES(168,8817,705,3);
INSERT INTO INTERPRETE VALUES(168,8818,705,4);
INSERT INTO INTERPRETE VALUES(168,8819,705,5);
INSERT INTO INTERPRETE VALUES(168,8820,705,6);
INSERT INTO INTERPRETE VALUES(168,8821,705,7);
INSERT INTO INTERPRETE VALUES(168,8822,705,8);
INSERT INTO INTERPRETE VALUES(168,8823,705,9);
INSERT INTO INTERPRETE VALUES(168,8824,705,10);
INSERT INTO INTERPRETE VALUES(168,8825,705,11);
INSERT INTO INTERPRETE VALUES(168,8826,705,12);
INSERT INTO INTERPRETE VALUES(168,8827,705,13);
INSERT INTO INTERPRETE VALUES(168,8828,705,14);
INSERT INTO INTERPRETE VALUES(168,8829,705,15);
INSERT INTO INTERPRETE VALUES(168,8830,705,16);
INSERT INTO INTERPRETE VALUES(168,8831,705,17);
INSERT INTO INTERPRETE VALUES(168,8832,705,18);
INSERT INTO INTERPRETE VALUES(168,8833,705,19);
INSERT INTO INTERPRETE VALUES(168,8834,705,20);
INSERT INTO INTERPRETE VALUES(168,8835,705,21);
INSERT INTO INTERPRETE VALUES(168,2288,705,22);
INSERT INTO INTERPRETE VALUES(168,8837,706,1);
INSERT INTO INTERPRETE VALUES(168,8838,706,2);
INSERT INTO INTERPRETE VALUES(168,8839,706,3);
INSERT INTO INTERPRETE VALUES(168,8840,706,4);
INSERT INTO INTERPRETE VALUES(168,8841,706,5);
INSERT INTO INTERPRETE VALUES(168,8842,706,6);
INSERT INTO INTERPRETE VALUES(168,8843,706,7);
INSERT INTO INTERPRETE VALUES(168,8844,706,8);
INSERT INTO INTERPRETE VALUES(168,8845,706,9);
INSERT INTO INTERPRETE VALUES(168,8846,706,10);
INSERT INTO INTERPRETE VALUES(168,8847,706,11);
INSERT INTO INTERPRETE VALUES(168,8848,706,12);
INSERT INTO INTERPRETE VALUES(168,8849,706,13);
INSERT INTO INTERPRETE VALUES(168,8850,706,14);
INSERT INTO INTERPRETE VALUES(168,8851,706,15);
INSERT INTO INTERPRETE VALUES(168,8852,706,16);
INSERT INTO INTERPRETE VALUES(168,8853,706,17);
INSERT INTO INTERPRETE VALUES(168,8854,706,18);
INSERT INTO INTERPRETE VALUES(168,8855,706,19);
INSERT INTO INTERPRETE VALUES(168,5543,706,20);
INSERT INTO INTERPRETE VALUES(168,8857,706,21);
INSERT INTO INTERPRETE VALUES(168,2355,706,22);
INSERT INTO INTERPRETE VALUES(168,8859,706,23);
INSERT INTO INTERPRETE VALUES(168,8860,706,24);
INSERT INTO INTERPRETE VALUES(125,8862,707,1);
INSERT INTO INTERPRETE VALUES(125,8863,707,2);
INSERT INTO INTERPRETE VALUES(125,8864,707,3);
INSERT INTO INTERPRETE VALUES(125,8865,707,4);
INSERT INTO INTERPRETE VALUES(125,8866,707,5);
INSERT INTO INTERPRETE VALUES(125,8867,707,6);
INSERT INTO INTERPRETE VALUES(125,8868,707,7);
INSERT INTO INTERPRETE VALUES(125,8869,707,8);
INSERT INTO INTERPRETE VALUES(125,8870,707,9);
INSERT INTO INTERPRETE VALUES(125,8872,707,11);
INSERT INTO INTERPRETE VALUES(125,8873,707,12);
INSERT INTO INTERPRETE VALUES(125,8874,707,13);
INSERT INTO INTERPRETE VALUES(125,8875,707,14);
INSERT INTO INTERPRETE VALUES(125,8876,707,15);
INSERT INTO INTERPRETE VALUES(125,8877,707,16);
INSERT INTO INTERPRETE VALUES(125,8878,707,17);
INSERT INTO INTERPRETE VALUES(125,8879,707,18);
INSERT INTO INTERPRETE VALUES(125,8880,707,19);
INSERT INTO INTERPRETE VALUES(125,8881,707,20);
INSERT INTO INTERPRETE VALUES(125,8882,707,21);
INSERT INTO INTERPRETE VALUES(125,8883,707,22);
INSERT INTO INTERPRETE VALUES(260,8884,708,1);
INSERT INTO INTERPRETE VALUES(260,8885,708,2);
INSERT INTO INTERPRETE VALUES(260,8886,708,3);
INSERT INTO INTERPRETE VALUES(260,8887,708,4);
INSERT INTO INTERPRETE VALUES(260,8888,708,5);
INSERT INTO INTERPRETE VALUES(260,8889,708,6);
INSERT INTO INTERPRETE VALUES(260,8890,708,7);
INSERT INTO INTERPRETE VALUES(262,8891,709,1);
INSERT INTO INTERPRETE VALUES(262,8892,709,2);
INSERT INTO INTERPRETE VALUES(262,2287,709,3);
INSERT INTO INTERPRETE VALUES(262,8894,709,4);
INSERT INTO INTERPRETE VALUES(262,8895,709,5);
INSERT INTO INTERPRETE VALUES(262,8896,709,6);
INSERT INTO INTERPRETE VALUES(168,8897,710,1);
INSERT INTO INTERPRETE VALUES(168,8898,710,2);
INSERT INTO INTERPRETE VALUES(168,8899,710,3);
INSERT INTO INTERPRETE VALUES(168,8900,710,4);
INSERT INTO INTERPRETE VALUES(168,8901,710,5);
INSERT INTO INTERPRETE VALUES(168,8902,710,6);
INSERT INTO INTERPRETE VALUES(168,8903,710,7);
INSERT INTO INTERPRETE VALUES(168,8904,710,8);
INSERT INTO INTERPRETE VALUES(168,8905,710,9);
INSERT INTO INTERPRETE VALUES(168,8906,710,10);
INSERT INTO INTERPRETE VALUES(168,8907,710,11);
INSERT INTO INTERPRETE VALUES(168,8908,710,12);
INSERT INTO INTERPRETE VALUES(168,8909,710,13);
INSERT INTO INTERPRETE VALUES(168,8910,710,14);
INSERT INTO INTERPRETE VALUES(168,8911,710,15);
INSERT INTO INTERPRETE VALUES(168,8912,710,16);
INSERT INTO INTERPRETE VALUES(168,8913,710,17);
INSERT INTO INTERPRETE VALUES(168,8914,710,18);
INSERT INTO INTERPRETE VALUES(168,8915,710,19);
INSERT INTO INTERPRETE VALUES(168,8916,710,20);
INSERT INTO INTERPRETE VALUES(168,8917,710,21);
INSERT INTO INTERPRETE VALUES(168,2355,710,22);
INSERT INTO INTERPRETE VALUES(168,8919,710,23);
INSERT INTO INTERPRETE VALUES(259,8920,711,1);
INSERT INTO INTERPRETE VALUES(259,8921,711,2);
INSERT INTO INTERPRETE VALUES(259,8922,711,3);
INSERT INTO INTERPRETE VALUES(259,8923,711,4);
INSERT INTO INTERPRETE VALUES(259,8924,711,5);
INSERT INTO INTERPRETE VALUES(259,8925,711,6);
INSERT INTO INTERPRETE VALUES(259,8926,711,7);
INSERT INTO INTERPRETE VALUES(258,8927,712,1);
INSERT INTO INTERPRETE VALUES(258,8928,712,2);
INSERT INTO INTERPRETE VALUES(258,8929,712,3);
INSERT INTO INTERPRETE VALUES(258,8930,712,4);
INSERT INTO INTERPRETE VALUES(258,8931,712,5);
INSERT INTO INTERPRETE VALUES(258,8932,712,6);
INSERT INTO INTERPRETE VALUES(258,8933,712,7);
INSERT INTO INTERPRETE VALUES(258,8934,712,8);
INSERT INTO INTERPRETE VALUES(168,8935,713,1);
INSERT INTO INTERPRETE VALUES(168,8936,713,2);
INSERT INTO INTERPRETE VALUES(168,8937,713,3);
INSERT INTO INTERPRETE VALUES(168,8938,713,4);
INSERT INTO INTERPRETE VALUES(168,8939,713,5);
INSERT INTO INTERPRETE VALUES(168,8940,713,6);
INSERT INTO INTERPRETE VALUES(168,5538,713,7);
INSERT INTO INTERPRETE VALUES(168,8942,713,8);
INSERT INTO INTERPRETE VALUES(259,8943,714,1);
INSERT INTO INTERPRETE VALUES(259,8944,714,2);
INSERT INTO INTERPRETE VALUES(259,8945,714,3);
INSERT INTO INTERPRETE VALUES(259,8946,714,4);
INSERT INTO INTERPRETE VALUES(259,8947,714,5);
INSERT INTO INTERPRETE VALUES(259,8948,714,6);
INSERT INTO INTERPRETE VALUES(259,8949,714,7);
INSERT INTO INTERPRETE VALUES(259,8950,714,8);
INSERT INTO INTERPRETE VALUES(259,8951,714,9);
INSERT INTO INTERPRETE VALUES(260,8952,715,1);
INSERT INTO INTERPRETE VALUES(260,8953,715,2);
INSERT INTO INTERPRETE VALUES(260,8954,715,3);
INSERT INTO INTERPRETE VALUES(260,8955,715,4);
INSERT INTO INTERPRETE VALUES(260,8956,715,5);
INSERT INTO INTERPRETE VALUES(260,8957,715,6);
INSERT INTO INTERPRETE VALUES(260,8958,715,7);
INSERT INTO INTERPRETE VALUES(260,8959,715,8);
INSERT INTO INTERPRETE VALUES(194,8961,716,2);
INSERT INTO INTERPRETE VALUES(168,8861,706,25);
INSERT INTO INTERPRETE VALUES(194,8963,716,4);
INSERT INTO INTERPRETE VALUES(194,8964,716,5);
INSERT INTO INTERPRETE VALUES(194,8965,716,6);
INSERT INTO INTERPRETE VALUES(194,8969,716,10);
INSERT INTO INTERPRETE VALUES(194,8970,716,11);
INSERT INTO INTERPRETE VALUES(194,8971,716,12);
INSERT INTO INTERPRETE VALUES(194,8966,716,7);
INSERT INTO INTERPRETE VALUES(259,8973,717,1);
INSERT INTO INTERPRETE VALUES(259,8974,717,2);
INSERT INTO INTERPRETE VALUES(259,8975,717,3);
INSERT INTO INTERPRETE VALUES(259,8976,717,4);
INSERT INTO INTERPRETE VALUES(259,8977,717,5);
INSERT INTO INTERPRETE VALUES(259,8978,717,6);
INSERT INTO INTERPRETE VALUES(259,8979,717,7);
INSERT INTO INTERPRETE VALUES(259,8980,717,8);
INSERT INTO INTERPRETE VALUES(260,8981,718,1);
INSERT INTO INTERPRETE VALUES(260,8982,718,2);
INSERT INTO INTERPRETE VALUES(260,8983,718,3);
INSERT INTO INTERPRETE VALUES(260,8984,718,4);
INSERT INTO INTERPRETE VALUES(260,8985,718,5);
INSERT INTO INTERPRETE VALUES(260,8986,718,6);
INSERT INTO INTERPRETE VALUES(260,8987,718,7);
INSERT INTO INTERPRETE VALUES(260,8988,718,8);
INSERT INTO INTERPRETE VALUES(260,8989,718,9);
INSERT INTO INTERPRETE VALUES(260,8990,718,10);
INSERT INTO INTERPRETE VALUES(216,8991,719,1);
INSERT INTO INTERPRETE VALUES(216,8994,719,4);
INSERT INTO INTERPRETE VALUES(216,8995,719,5);
INSERT INTO INTERPRETE VALUES(216,8992,719,2);
INSERT INTO INTERPRETE VALUES(216,8526,719,6);
INSERT INTO INTERPRETE VALUES(216,8998,719,8);
INSERT INTO INTERPRETE VALUES(216,8528,719,10);
INSERT INTO INTERPRETE VALUES(216,9001,719,11);
INSERT INTO INTERPRETE VALUES(216,9004,719,14);
INSERT INTO INTERPRETE VALUES(262,9012,720,8);
INSERT INTO INTERPRETE VALUES(262,9013,720,9);
INSERT INTO INTERPRETE VALUES(262,9014,720,10);
INSERT INTO INTERPRETE VALUES(216,9015,721,1);
INSERT INTO INTERPRETE VALUES(216,9017,721,3);
INSERT INTO INTERPRETE VALUES(216,9016,721,2);
INSERT INTO INTERPRETE VALUES(216,9020,721,6);
INSERT INTO INTERPRETE VALUES(216,9022,721,8);
INSERT INTO INTERPRETE VALUES(216,9004,721,11);
INSERT INTO INTERPRETE VALUES(216,9026,721,12);
INSERT INTO INTERPRETE VALUES(216,9017,721,14);
INSERT INTO INTERPRETE VALUES(216,9004,721,18);
INSERT INTO INTERPRETE VALUES(216,9024,721,16);
INSERT INTO INTERPRETE VALUES(216,9024,721,17);
INSERT INTO INTERPRETE VALUES(95,9044,723,2);
INSERT INTO INTERPRETE VALUES(95,9045,723,3);
INSERT INTO INTERPRETE VALUES(95,9046,723,4);
INSERT INTO INTERPRETE VALUES(95,9047,723,5);
INSERT INTO INTERPRETE VALUES(95,9048,723,6);
INSERT INTO INTERPRETE VALUES(95,9049,723,7);
INSERT INTO INTERPRETE VALUES(95,9050,723,8);
INSERT INTO INTERPRETE VALUES(95,9051,723,9);
INSERT INTO INTERPRETE VALUES(95,9052,723,10);
INSERT INTO INTERPRETE VALUES(95,9053,723,11);
INSERT INTO INTERPRETE VALUES(216,9054,724,1);
INSERT INTO INTERPRETE VALUES(216,8529,724,3);
INSERT INTO INTERPRETE VALUES(216,8531,724,6);
INSERT INTO INTERPRETE VALUES(216,8524,724,8);
INSERT INTO INTERPRETE VALUES(216,8533,724,9);
INSERT INTO INTERPRETE VALUES(216,8525,724,10);
INSERT INTO INTERPRETE VALUES(216,9064,724,11);
INSERT INTO INTERPRETE VALUES(216,9066,724,13);
INSERT INTO INTERPRETE VALUES(216,9067,724,14);
INSERT INTO INTERPRETE VALUES(216,9068,724,15);
INSERT INTO INTERPRETE VALUES(216,8535,724,12);
INSERT INTO INTERPRETE VALUES(216,9071,724,18);
INSERT INTO INTERPRETE VALUES(216,9073,724,20);
INSERT INTO INTERPRETE VALUES(264,9077,725,4);
INSERT INTO INTERPRETE VALUES(264,9078,725,5);
INSERT INTO INTERPRETE VALUES(264,9079,725,6);
INSERT INTO INTERPRETE VALUES(264,9080,725,7);
INSERT INTO INTERPRETE VALUES(264,9081,725,8);
INSERT INTO INTERPRETE VALUES(264,9082,725,9);
INSERT INTO INTERPRETE VALUES(216,8534,726,1);
INSERT INTO INTERPRETE VALUES(216,8542,726,8);
INSERT INTO INTERPRETE VALUES(216,9092,726,10);
INSERT INTO INTERPRETE VALUES(216,9095,726,13);
INSERT INTO INTERPRETE VALUES(265,9097,727,1);
INSERT INTO INTERPRETE VALUES(265,9098,727,2);
INSERT INTO INTERPRETE VALUES(265,9099,727,3);
INSERT INTO INTERPRETE VALUES(265,9100,727,4);
INSERT INTO INTERPRETE VALUES(265,9101,727,5);
INSERT INTO INTERPRETE VALUES(265,9102,727,6);
INSERT INTO INTERPRETE VALUES(265,9103,727,7);
INSERT INTO INTERPRETE VALUES(265,9104,727,8);
INSERT INTO INTERPRETE VALUES(265,9105,727,9);
INSERT INTO INTERPRETE VALUES(265,9106,727,10);
INSERT INTO INTERPRETE VALUES(265,9107,727,11);
INSERT INTO INTERPRETE VALUES(216,9109,728,2);
INSERT INTO INTERPRETE VALUES(216,5971,728,4);
INSERT INTO INTERPRETE VALUES(216,9112,728,5);
INSERT INTO INTERPRETE VALUES(216,8991,728,12);
INSERT INTO INTERPRETE VALUES(216,8526,728,14);
INSERT INTO INTERPRETE VALUES(216,9001,728,16);
INSERT INTO INTERPRETE VALUES(168,5530,729,1);
INSERT INTO INTERPRETE VALUES(168,5532,729,2);
INSERT INTO INTERPRETE VALUES(168,9126,729,3);
INSERT INTO INTERPRETE VALUES(168,9127,729,4);
INSERT INTO INTERPRETE VALUES(168,9128,729,5);
INSERT INTO INTERPRETE VALUES(168,5545,729,6);
INSERT INTO INTERPRETE VALUES(168,9131,729,8);
INSERT INTO INTERPRETE VALUES(168,5537,729,9);
INSERT INTO INTERPRETE VALUES(168,5547,729,10);
INSERT INTO INTERPRETE VALUES(266,9134,730,1);
INSERT INTO INTERPRETE VALUES(266,9135,730,2);
INSERT INTO INTERPRETE VALUES(266,9136,730,3);
INSERT INTO INTERPRETE VALUES(266,9137,730,4);
INSERT INTO INTERPRETE VALUES(266,9138,730,5);
INSERT INTO INTERPRETE VALUES(266,9139,730,6);
INSERT INTO INTERPRETE VALUES(266,9140,730,7);
INSERT INTO INTERPRETE VALUES(266,9141,730,8);
INSERT INTO INTERPRETE VALUES(266,9142,730,9);
INSERT INTO INTERPRETE VALUES(266,9143,730,10);
INSERT INTO INTERPRETE VALUES(266,9144,730,11);
INSERT INTO INTERPRETE VALUES(267,9145,731,1);
INSERT INTO INTERPRETE VALUES(267,9146,731,2);
INSERT INTO INTERPRETE VALUES(267,9147,731,3);
INSERT INTO INTERPRETE VALUES(267,9148,731,4);
INSERT INTO INTERPRETE VALUES(267,9149,731,5);
INSERT INTO INTERPRETE VALUES(267,9150,731,6);
INSERT INTO INTERPRETE VALUES(267,9151,731,7);
INSERT INTO INTERPRETE VALUES(267,9152,731,8);
INSERT INTO INTERPRETE VALUES(267,9153,731,9);
INSERT INTO INTERPRETE VALUES(267,9154,731,10);
INSERT INTO INTERPRETE VALUES(259,9155,732,1);
INSERT INTO INTERPRETE VALUES(259,9156,732,2);
INSERT INTO INTERPRETE VALUES(259,9157,732,3);
INSERT INTO INTERPRETE VALUES(259,9158,732,4);
INSERT INTO INTERPRETE VALUES(259,9159,732,5);
INSERT INTO INTERPRETE VALUES(259,9160,732,6);
INSERT INTO INTERPRETE VALUES(259,9161,732,7);
INSERT INTO INTERPRETE VALUES(259,9162,732,8);
INSERT INTO INTERPRETE VALUES(264,9163,733,1);
INSERT INTO INTERPRETE VALUES(264,9164,733,2);
INSERT INTO INTERPRETE VALUES(264,9165,733,3);
INSERT INTO INTERPRETE VALUES(264,9166,733,4);
INSERT INTO INTERPRETE VALUES(264,9167,733,5);
INSERT INTO INTERPRETE VALUES(264,9168,733,6);
INSERT INTO INTERPRETE VALUES(264,9169,733,7);
INSERT INTO INTERPRETE VALUES(264,9170,733,8);
INSERT INTO INTERPRETE VALUES(264,9171,733,9);
INSERT INTO INTERPRETE VALUES(264,9172,733,10);
INSERT INTO INTERPRETE VALUES(264,9173,733,11);
INSERT INTO INTERPRETE VALUES(254,9174,734,1);
INSERT INTO INTERPRETE VALUES(254,9175,734,2);
INSERT INTO INTERPRETE VALUES(254,9176,734,3);
INSERT INTO INTERPRETE VALUES(254,8409,734,4);
INSERT INTO INTERPRETE VALUES(254,9293,734,5);
INSERT INTO INTERPRETE VALUES(254,9179,734,6);
INSERT INTO INTERPRETE VALUES(254,8406,734,7);
INSERT INTO INTERPRETE VALUES(254,9181,734,8);
INSERT INTO INTERPRETE VALUES(254,8422,734,9);
INSERT INTO INTERPRETE VALUES(254,9183,734,10);
INSERT INTO INTERPRETE VALUES(254,9184,734,11);
INSERT INTO INTERPRETE VALUES(260,9185,735,1);
INSERT INTO INTERPRETE VALUES(260,9186,735,2);
INSERT INTO INTERPRETE VALUES(260,9187,735,3);
INSERT INTO INTERPRETE VALUES(260,9188,735,4);
INSERT INTO INTERPRETE VALUES(260,9189,735,5);
INSERT INTO INTERPRETE VALUES(260,9190,735,6);
INSERT INTO INTERPRETE VALUES(260,9191,735,7);
INSERT INTO INTERPRETE VALUES(260,9192,735,8);
INSERT INTO INTERPRETE VALUES(260,9193,735,9);
INSERT INTO INTERPRETE VALUES(260,9194,735,10);
INSERT INTO INTERPRETE VALUES(260,9195,736,1);
INSERT INTO INTERPRETE VALUES(260,9196,736,2);
INSERT INTO INTERPRETE VALUES(260,9197,736,3);
INSERT INTO INTERPRETE VALUES(260,9198,736,4);
INSERT INTO INTERPRETE VALUES(260,9199,736,5);
INSERT INTO INTERPRETE VALUES(260,9200,736,6);
INSERT INTO INTERPRETE VALUES(260,9201,736,7);
INSERT INTO INTERPRETE VALUES(260,9202,736,8);
INSERT INTO INTERPRETE VALUES(260,9203,736,9);
INSERT INTO INTERPRETE VALUES(260,9204,736,10);
INSERT INTO INTERPRETE VALUES(95,9205,737,1);
INSERT INTO INTERPRETE VALUES(95,9206,737,2);
INSERT INTO INTERPRETE VALUES(95,9207,737,3);
INSERT INTO INTERPRETE VALUES(95,9208,737,4);
INSERT INTO INTERPRETE VALUES(95,9209,737,5);
INSERT INTO INTERPRETE VALUES(95,9210,737,6);
INSERT INTO INTERPRETE VALUES(95,9211,737,7);
INSERT INTO INTERPRETE VALUES(95,9212,737,8);
INSERT INTO INTERPRETE VALUES(95,9213,737,9);
INSERT INTO INTERPRETE VALUES(95,9214,737,10);
INSERT INTO INTERPRETE VALUES(216,9219,738,3);
INSERT INTO INTERPRETE VALUES(216,9229,738,13);
INSERT INTO INTERPRETE VALUES(216,9230,738,14);
INSERT INTO INTERPRETE VALUES(216,9231,738,15);
INSERT INTO INTERPRETE VALUES(252,8382,739,1);
INSERT INTO INTERPRETE VALUES(252,7304,739,2);
INSERT INTO INTERPRETE VALUES(252,8642,739,3);
INSERT INTO INTERPRETE VALUES(252,8634,739,4);
INSERT INTO INTERPRETE VALUES(252,8640,739,5);
INSERT INTO INTERPRETE VALUES(252,8628,739,6);
INSERT INTO INTERPRETE VALUES(252,9239,739,7);
INSERT INTO INTERPRETE VALUES(252,8638,739,8);
INSERT INTO INTERPRETE VALUES(252,8637,739,9);
INSERT INTO INTERPRETE VALUES(252,8380,739,10);
INSERT INTO INTERPRETE VALUES(252,8369,739,11);
INSERT INTO INTERPRETE VALUES(216,9244,740,1);
INSERT INTO INTERPRETE VALUES(216,9225,738,9);
INSERT INTO INTERPRETE VALUES(216,9222,738,6);
INSERT INTO INTERPRETE VALUES(216,9246,740,3);
INSERT INTO INTERPRETE VALUES(216,9245,740,2);
INSERT INTO INTERPRETE VALUES(216,9249,740,6);
INSERT INTO INTERPRETE VALUES(216,9254,740,11);
INSERT INTO INTERPRETE VALUES(216,9244,740,12);
INSERT INTO INTERPRETE VALUES(168,9256,741,1);
INSERT INTO INTERPRETE VALUES(168,5544,741,2);
INSERT INTO INTERPRETE VALUES(168,9258,741,3);
INSERT INTO INTERPRETE VALUES(168,9259,741,4);
INSERT INTO INTERPRETE VALUES(168,9260,741,5);
INSERT INTO INTERPRETE VALUES(168,9261,741,6);
INSERT INTO INTERPRETE VALUES(168,9262,741,7);
INSERT INTO INTERPRETE VALUES(168,9263,741,8);
INSERT INTO INTERPRETE VALUES(168,9264,741,9);
INSERT INTO INTERPRETE VALUES(168,9265,741,10);
INSERT INTO INTERPRETE VALUES(168,9266,741,11);
INSERT INTO INTERPRETE VALUES(168,9267,741,12);
INSERT INTO INTERPRETE VALUES(168,9268,741,13);
INSERT INTO INTERPRETE VALUES(168,9269,741,14);
INSERT INTO INTERPRETE VALUES(168,9270,741,15);
INSERT INTO INTERPRETE VALUES(168,9271,741,16);
INSERT INTO INTERPRETE VALUES(168,9272,741,17);
INSERT INTO INTERPRETE VALUES(168,9273,741,18);
INSERT INTO INTERPRETE VALUES(168,9274,741,19);
INSERT INTO INTERPRETE VALUES(168,9275,741,20);
INSERT INTO INTERPRETE VALUES(168,9276,741,21);
INSERT INTO INTERPRETE VALUES(168,9277,741,22);
INSERT INTO INTERPRETE VALUES(168,9278,741,23);
INSERT INTO INTERPRETE VALUES(168,9279,741,24);
INSERT INTO INTERPRETE VALUES(168,9280,741,25);
INSERT INTO INTERPRETE VALUES(168,9281,741,26);
INSERT INTO INTERPRETE VALUES(254,9181,742,1);
INSERT INTO INTERPRETE VALUES(216,9249,743,1);
INSERT INTO INTERPRETE VALUES(216,9305,743,12);
INSERT INTO INTERPRETE VALUES(216,9306,743,13);
INSERT INTO INTERPRETE VALUES(131,9318,744,11);
INSERT INTO INTERPRETE VALUES(257,9319,745,1);
INSERT INTO INTERPRETE VALUES(216,9304,743,11);
INSERT INTO INTERPRETE VALUES(257,9330,745,12);
INSERT INTO INTERPRETE VALUES(257,9331,745,13);
INSERT INTO INTERPRETE VALUES(257,9332,745,14);
INSERT INTO INTERPRETE VALUES(257,9333,745,15);
INSERT INTO INTERPRETE VALUES(257,9334,745,16);
INSERT INTO INTERPRETE VALUES(257,9335,745,17);
INSERT INTO INTERPRETE VALUES(257,9336,745,18);
INSERT INTO INTERPRETE VALUES(257,9337,745,19);
INSERT INTO INTERPRETE VALUES(257,9338,745,20);
INSERT INTO INTERPRETE VALUES(257,9339,745,21);
INSERT INTO INTERPRETE VALUES(257,9340,745,22);
INSERT INTO INTERPRETE VALUES(257,9341,745,23);
INSERT INTO INTERPRETE VALUES(257,9342,745,24);
INSERT INTO INTERPRETE VALUES(257,9343,745,25);
INSERT INTO INTERPRETE VALUES(257,9344,745,26);
INSERT INTO INTERPRETE VALUES(268,9353,746,7);
INSERT INTO INTERPRETE VALUES(268,9355,746,9);
INSERT INTO INTERPRETE VALUES(268,9356,746,10);
INSERT INTO INTERPRETE VALUES(268,9357,746,11);
INSERT INTO INTERPRETE VALUES(262,2287,747,1);
INSERT INTO INTERPRETE VALUES(262,9360,747,2);
INSERT INTO INTERPRETE VALUES(262,2280,747,3);
INSERT INTO INTERPRETE VALUES(262,1711,747,4);
INSERT INTO INTERPRETE VALUES(262,9364,747,6);
INSERT INTO INTERPRETE VALUES(262,9365,747,7);
INSERT INTO INTERPRETE VALUES(262,9366,747,8);
INSERT INTO INTERPRETE VALUES(262,9367,747,9);
INSERT INTO INTERPRETE VALUES(262,9368,747,10);
INSERT INTO INTERPRETE VALUES(262,9369,747,11);
INSERT INTO INTERPRETE VALUES(262,9370,747,12);
INSERT INTO INTERPRETE VALUES(269,9371,748,1);
INSERT INTO INTERPRETE VALUES(269,9372,748,2);
INSERT INTO INTERPRETE VALUES(269,9373,748,3);
INSERT INTO INTERPRETE VALUES(269,9374,748,4);
INSERT INTO INTERPRETE VALUES(269,9375,748,5);
INSERT INTO INTERPRETE VALUES(269,9376,748,6);
INSERT INTO INTERPRETE VALUES(269,9377,748,7);
INSERT INTO INTERPRETE VALUES(269,9378,748,8);
INSERT INTO INTERPRETE VALUES(269,9379,748,9);
INSERT INTO INTERPRETE VALUES(269,9380,748,10);
INSERT INTO INTERPRETE VALUES(269,9381,748,11);
INSERT INTO INTERPRETE VALUES(269,9382,748,12);
INSERT INTO INTERPRETE VALUES(269,9383,748,13);
INSERT INTO INTERPRETE VALUES(269,9384,748,14);
INSERT INTO INTERPRETE VALUES(269,9385,748,15);
INSERT INTO INTERPRETE VALUES(269,9387,749,1);
INSERT INTO INTERPRETE VALUES(269,9388,749,2);
INSERT INTO INTERPRETE VALUES(269,9389,749,3);
INSERT INTO INTERPRETE VALUES(269,9390,749,4);
INSERT INTO INTERPRETE VALUES(269,9391,749,5);
INSERT INTO INTERPRETE VALUES(269,9392,749,6);
INSERT INTO INTERPRETE VALUES(269,9393,749,7);
INSERT INTO INTERPRETE VALUES(269,9394,749,8);
INSERT INTO INTERPRETE VALUES(269,9395,749,9);
INSERT INTO INTERPRETE VALUES(269,9396,749,10);
INSERT INTO INTERPRETE VALUES(269,9397,749,11);
INSERT INTO INTERPRETE VALUES(270,9398,750,1);
INSERT INTO INTERPRETE VALUES(270,9399,750,2);
INSERT INTO INTERPRETE VALUES(270,9400,750,3);
INSERT INTO INTERPRETE VALUES(270,9401,750,4);
INSERT INTO INTERPRETE VALUES(270,9402,750,5);
INSERT INTO INTERPRETE VALUES(270,9403,750,6);
INSERT INTO INTERPRETE VALUES(270,9404,750,7);
INSERT INTO INTERPRETE VALUES(270,9405,750,8);
INSERT INTO INTERPRETE VALUES(270,9406,750,9);
INSERT INTO INTERPRETE VALUES(270,9407,750,10);
INSERT INTO INTERPRETE VALUES(270,9408,750,11);
INSERT INTO INTERPRETE VALUES(270,9409,750,12);
INSERT INTO INTERPRETE VALUES(95,2355,751,1);
INSERT INTO INTERPRETE VALUES(95,2284,751,2);
INSERT INTO INTERPRETE VALUES(95,2285,751,3);
INSERT INTO INTERPRETE VALUES(95,8753,751,4);
INSERT INTO INTERPRETE VALUES(95,8936,751,5);
INSERT INTO INTERPRETE VALUES(95,2278,751,6);
INSERT INTO INTERPRETE VALUES(95,4777,751,7);
INSERT INTO INTERPRETE VALUES(95,2280,751,8);
INSERT INTO INTERPRETE VALUES(95,8842,751,9);
INSERT INTO INTERPRETE VALUES(95,5545,751,10);
INSERT INTO INTERPRETE VALUES(95,9420,751,11);
INSERT INTO INTERPRETE VALUES(95,2363,751,12);
INSERT INTO INTERPRETE VALUES(95,5543,751,13);
INSERT INTO INTERPRETE VALUES(95,2287,751,14);
INSERT INTO INTERPRETE VALUES(95,9424,751,15);
INSERT INTO INTERPRETE VALUES(252,9425,752,1);
INSERT INTO INTERPRETE VALUES(252,9426,752,2);
INSERT INTO INTERPRETE VALUES(252,9427,752,3);
INSERT INTO INTERPRETE VALUES(252,1142,752,4);
INSERT INTO INTERPRETE VALUES(252,9429,752,5);
INSERT INTO INTERPRETE VALUES(252,9430,752,6);
INSERT INTO INTERPRETE VALUES(252,9431,752,7);
INSERT INTO INTERPRETE VALUES(252,1741,752,8);
INSERT INTO INTERPRETE VALUES(252,9433,752,9);
INSERT INTO INTERPRETE VALUES(252,9434,752,10);
INSERT INTO INTERPRETE VALUES(252,9435,752,11);
INSERT INTO INTERPRETE VALUES(252,9436,752,12);
INSERT INTO INTERPRETE VALUES(216,9438,753,2);
INSERT INTO INTERPRETE VALUES(216,9448,753,12);
INSERT INTO INTERPRETE VALUES(216,9449,753,13);
INSERT INTO INTERPRETE VALUES(216,9450,753,14);
INSERT INTO INTERPRETE VALUES(20,9451,754,1);
INSERT INTO INTERPRETE VALUES(20,9452,754,2);
INSERT INTO INTERPRETE VALUES(20,9453,754,3);
INSERT INTO INTERPRETE VALUES(20,9454,754,4);
INSERT INTO INTERPRETE VALUES(20,9455,754,5);
INSERT INTO INTERPRETE VALUES(20,9456,754,6);
INSERT INTO INTERPRETE VALUES(20,9457,754,7);
INSERT INTO INTERPRETE VALUES(20,9458,754,8);
INSERT INTO INTERPRETE VALUES(20,9459,754,9);
INSERT INTO INTERPRETE VALUES(20,9460,754,10);
INSERT INTO INTERPRETE VALUES(20,9461,754,11);
INSERT INTO INTERPRETE VALUES(20,9462,754,12);
INSERT INTO INTERPRETE VALUES(20,9463,754,13);
INSERT INTO INTERPRETE VALUES(258,2453,755,1);
INSERT INTO INTERPRETE VALUES(258,9465,755,2);
INSERT INTO INTERPRETE VALUES(258,9466,755,3);
INSERT INTO INTERPRETE VALUES(258,286,755,4);
INSERT INTO INTERPRETE VALUES(258,995,755,5);
INSERT INTO INTERPRETE VALUES(258,9469,755,6);
INSERT INTO INTERPRETE VALUES(258,8588,755,7);
INSERT INTO INTERPRETE VALUES(258,9471,755,8);
INSERT INTO INTERPRETE VALUES(258,9472,755,9);
INSERT INTO INTERPRETE VALUES(258,9473,755,10);
INSERT INTO INTERPRETE VALUES(258,9474,755,11);
INSERT INTO INTERPRETE VALUES(258,9475,755,12);
INSERT INTO INTERPRETE VALUES(258,8985,755,13);
INSERT INTO INTERPRETE VALUES(258,8596,755,14);
INSERT INTO INTERPRETE VALUES(258,9478,755,15);
INSERT INTO INTERPRETE VALUES(258,9479,755,16);
INSERT INTO INTERPRETE VALUES(258,9480,755,17);
INSERT INTO INTERPRETE VALUES(258,9481,755,18);
INSERT INTO INTERPRETE VALUES(258,9482,755,19);
INSERT INTO INTERPRETE VALUES(258,9483,755,20);
INSERT INTO INTERPRETE VALUES(258,8608,755,21);
INSERT INTO INTERPRETE VALUES(258,9485,755,22);
INSERT INTO INTERPRETE VALUES(258,8599,755,23);
INSERT INTO INTERPRETE VALUES(258,9487,755,24);
INSERT INTO INTERPRETE VALUES(258,8593,755,25);
INSERT INTO INTERPRETE VALUES(258,8607,755,26);
INSERT INTO INTERPRETE VALUES(258,9490,755,27);
INSERT INTO INTERPRETE VALUES(258,9491,755,28);
INSERT INTO INTERPRETE VALUES(258,6589,755,29);
INSERT INTO INTERPRETE VALUES(258,262,755,30);
INSERT INTO INTERPRETE VALUES(271,9494,756,1);
INSERT INTO INTERPRETE VALUES(271,9495,756,2);
INSERT INTO INTERPRETE VALUES(271,9496,756,3);
INSERT INTO INTERPRETE VALUES(271,9497,756,4);
INSERT INTO INTERPRETE VALUES(271,9498,756,5);
INSERT INTO INTERPRETE VALUES(271,9499,756,6);
INSERT INTO INTERPRETE VALUES(271,9500,756,7);
INSERT INTO INTERPRETE VALUES(271,9501,756,8);
INSERT INTO INTERPRETE VALUES(271,9502,756,9);
INSERT INTO INTERPRETE VALUES(271,9503,756,10);
INSERT INTO INTERPRETE VALUES(271,9504,756,11);
INSERT INTO INTERPRETE VALUES(271,9505,756,12);
INSERT INTO INTERPRETE VALUES(271,9506,756,13);
INSERT INTO INTERPRETE VALUES(271,9507,756,14);
INSERT INTO INTERPRETE VALUES(262,9508,757,1);
INSERT INTO INTERPRETE VALUES(262,9509,757,2);
INSERT INTO INTERPRETE VALUES(262,9510,757,3);
INSERT INTO INTERPRETE VALUES(262,9511,757,4);
INSERT INTO INTERPRETE VALUES(262,9512,757,5);
INSERT INTO INTERPRETE VALUES(262,9513,757,6);
INSERT INTO INTERPRETE VALUES(262,9514,757,7);
INSERT INTO INTERPRETE VALUES(262,9515,757,8);
INSERT INTO INTERPRETE VALUES(262,9214,757,9);
INSERT INTO INTERPRETE VALUES(262,9517,757,10);
INSERT INTO INTERPRETE VALUES(262,8841,757,11);
INSERT INTO INTERPRETE VALUES(262,9519,757,12);
INSERT INTO INTERPRETE VALUES(262,9520,757,13);
INSERT INTO INTERPRETE VALUES(272,9521,758,1);
INSERT INTO INTERPRETE VALUES(272,9522,758,2);
INSERT INTO INTERPRETE VALUES(216,9443,753,7);
INSERT INTO INTERPRETE VALUES(272,9529,758,9);
INSERT INTO INTERPRETE VALUES(272,9530,758,10);
INSERT INTO INTERPRETE VALUES(272,9531,758,11);
INSERT INTO INTERPRETE VALUES(272,9532,758,12);
INSERT INTO INTERPRETE VALUES(272,9533,758,13);
INSERT INTO INTERPRETE VALUES(272,9534,758,14);
INSERT INTO INTERPRETE VALUES(272,9535,758,15);
INSERT INTO INTERPRETE VALUES(252,9536,759,1);
INSERT INTO INTERPRETE VALUES(252,9537,759,2);
INSERT INTO INTERPRETE VALUES(252,9538,759,3);
INSERT INTO INTERPRETE VALUES(252,9539,759,4);
INSERT INTO INTERPRETE VALUES(252,8687,759,5);
INSERT INTO INTERPRETE VALUES(252,8689,759,6);
INSERT INTO INTERPRETE VALUES(252,9542,759,7);
INSERT INTO INTERPRETE VALUES(252,8675,759,8);
INSERT INTO INTERPRETE VALUES(252,8695,759,9);
INSERT INTO INTERPRETE VALUES(252,9545,759,10);
INSERT INTO INTERPRETE VALUES(252,8686,759,11);
INSERT INTO INTERPRETE VALUES(252,8680,759,12);
INSERT INTO INTERPRETE VALUES(252,9548,759,13);
INSERT INTO INTERPRETE VALUES(252,9549,759,14);
INSERT INTO INTERPRETE VALUES(252,8681,759,15);
INSERT INTO INTERPRETE VALUES(216,9552,760,2);
INSERT INTO INTERPRETE VALUES(216,9553,760,3);
INSERT INTO INTERPRETE VALUES(216,9551,760,1);
INSERT INTO INTERPRETE VALUES(216,9554,760,4);
INSERT INTO INTERPRETE VALUES(216,9557,760,7);
INSERT INTO INTERPRETE VALUES(216,9559,760,9);
INSERT INTO INTERPRETE VALUES(252,7304,761,7);
INSERT INTO INTERPRETE VALUES(252,9239,761,8);
INSERT INTO INTERPRETE VALUES(252,8681,761,9);
INSERT INTO INTERPRETE VALUES(252,8643,761,10);
INSERT INTO INTERPRETE VALUES(252,8635,761,11);
INSERT INTO INTERPRETE VALUES(252,8380,761,12);
INSERT INTO INTERPRETE VALUES(252,8382,761,13);
INSERT INTO INTERPRETE VALUES(252,8637,761,14);
INSERT INTO INTERPRETE VALUES(252,8628,761,15);
INSERT INTO INTERPRETE VALUES(273,9583,762,1);
INSERT INTO INTERPRETE VALUES(273,9584,762,2);
INSERT INTO INTERPRETE VALUES(273,9585,762,3);
INSERT INTO INTERPRETE VALUES(273,9586,762,4);
INSERT INTO INTERPRETE VALUES(273,9587,762,5);
INSERT INTO INTERPRETE VALUES(273,9588,762,6);
INSERT INTO INTERPRETE VALUES(273,9589,762,7);
INSERT INTO INTERPRETE VALUES(216,9556,760,6);
INSERT INTO INTERPRETE VALUES(273,9590,762,8);
INSERT INTO INTERPRETE VALUES(273,9591,762,9);
INSERT INTO INTERPRETE VALUES(273,9592,762,10);
INSERT INTO INTERPRETE VALUES(273,9593,762,11);
INSERT INTO INTERPRETE VALUES(273,9594,762,12);
INSERT INTO INTERPRETE VALUES(273,9595,762,13);
INSERT INTO INTERPRETE VALUES(273,9596,762,14);
INSERT INTO INTERPRETE VALUES(273,9597,762,15);
INSERT INTO INTERPRETE VALUES(273,9598,762,16);
INSERT INTO INTERPRETE VALUES(259,9599,763,1);
INSERT INTO INTERPRETE VALUES(259,9600,763,2);
INSERT INTO INTERPRETE VALUES(259,9601,763,3);
INSERT INTO INTERPRETE VALUES(259,9602,763,4);
INSERT INTO INTERPRETE VALUES(259,9603,763,5);
INSERT INTO INTERPRETE VALUES(259,9604,763,6);
INSERT INTO INTERPRETE VALUES(259,9605,763,7);
INSERT INTO INTERPRETE VALUES(259,9606,763,8);
INSERT INTO INTERPRETE VALUES(259,9607,763,9);
INSERT INTO INTERPRETE VALUES(259,9608,763,10);
INSERT INTO INTERPRETE VALUES(259,9609,763,11);
INSERT INTO INTERPRETE VALUES(259,9610,763,12);
INSERT INTO INTERPRETE VALUES(259,9611,763,13);
INSERT INTO INTERPRETE VALUES(160,9612,764,1);
INSERT INTO INTERPRETE VALUES(160,8439,764,4);
INSERT INTO INTERPRETE VALUES(160,9616,764,5);
INSERT INTO INTERPRETE VALUES(160,9617,764,6);
INSERT INTO INTERPRETE VALUES(160,8424,764,7);
INSERT INTO INTERPRETE VALUES(160,9619,764,8);
INSERT INTO INTERPRETE VALUES(160,9620,764,9);
INSERT INTO INTERPRETE VALUES(160,9621,764,10);
INSERT INTO INTERPRETE VALUES(160,9622,764,11);
INSERT INTO INTERPRETE VALUES(160,9623,764,12);
INSERT INTO INTERPRETE VALUES(160,9624,764,13);
INSERT INTO INTERPRETE VALUES(160,9625,764,14);
INSERT INTO INTERPRETE VALUES(160,9626,764,15);
INSERT INTO INTERPRETE VALUES(160,9627,764,16);
INSERT INTO INTERPRETE VALUES(160,9628,764,17);
INSERT INTO INTERPRETE VALUES(160,8423,764,18);
INSERT INTO INTERPRETE VALUES(272,9630,765,1);
INSERT INTO INTERPRETE VALUES(272,9631,765,2);
INSERT INTO INTERPRETE VALUES(272,9632,765,3);
INSERT INTO INTERPRETE VALUES(272,9633,765,4);
INSERT INTO INTERPRETE VALUES(272,9634,765,5);
INSERT INTO INTERPRETE VALUES(272,7192,765,6);
INSERT INTO INTERPRETE VALUES(272,9636,765,7);
INSERT INTO INTERPRETE VALUES(272,9637,765,8);
INSERT INTO INTERPRETE VALUES(272,9638,765,9);
INSERT INTO INTERPRETE VALUES(272,9639,765,10);
INSERT INTO INTERPRETE VALUES(272,9640,765,11);
INSERT INTO INTERPRETE VALUES(272,9642,765,13);
INSERT INTO INTERPRETE VALUES(272,9643,765,14);
INSERT INTO INTERPRETE VALUES(272,9644,765,15);
INSERT INTO INTERPRETE VALUES(272,9645,765,16);
INSERT INTO INTERPRETE VALUES(255,9646,766,1);
INSERT INTO INTERPRETE VALUES(255,9647,766,2);
INSERT INTO INTERPRETE VALUES(255,9648,766,3);
INSERT INTO INTERPRETE VALUES(255,9649,766,4);
INSERT INTO INTERPRETE VALUES(255,9650,766,5);
INSERT INTO INTERPRETE VALUES(255,9651,766,6);
INSERT INTO INTERPRETE VALUES(255,9652,766,7);
INSERT INTO INTERPRETE VALUES(255,9647,766,8);
INSERT INTO INTERPRETE VALUES(255,9654,766,9);
INSERT INTO INTERPRETE VALUES(255,9655,766,10);
INSERT INTO INTERPRETE VALUES(255,9656,766,11);
INSERT INTO INTERPRETE VALUES(255,9657,766,12);
INSERT INTO INTERPRETE VALUES(255,9658,766,13);
INSERT INTO INTERPRETE VALUES(255,9659,766,14);
INSERT INTO INTERPRETE VALUES(255,9660,766,15);
INSERT INTO INTERPRETE VALUES(255,9661,766,16);
INSERT INTO INTERPRETE VALUES(255,9662,766,17);
INSERT INTO INTERPRETE VALUES(168,8500,767,1);
INSERT INTO INTERPRETE VALUES(168,2280,767,2);
INSERT INTO INTERPRETE VALUES(168,9665,767,3);
INSERT INTO INTERPRETE VALUES(168,9666,767,4);
INSERT INTO INTERPRETE VALUES(168,2278,767,5);
INSERT INTO INTERPRETE VALUES(168,9668,767,6);
INSERT INTO INTERPRETE VALUES(168,9669,767,7);
INSERT INTO INTERPRETE VALUES(168,9670,767,8);
INSERT INTO INTERPRETE VALUES(168,9671,767,9);
INSERT INTO INTERPRETE VALUES(168,9672,767,10);
INSERT INTO INTERPRETE VALUES(168,9673,767,11);
INSERT INTO INTERPRETE VALUES(168,5536,767,12);
INSERT INTO INTERPRETE VALUES(168,9675,767,13);
INSERT INTO INTERPRETE VALUES(168,3665,767,14);
INSERT INTO INTERPRETE VALUES(168,9677,767,15);
INSERT INTO INTERPRETE VALUES(168,9678,767,16);
INSERT INTO INTERPRETE VALUES(259,9679,768,1);
INSERT INTO INTERPRETE VALUES(259,9680,768,2);
INSERT INTO INTERPRETE VALUES(259,9681,768,3);
INSERT INTO INTERPRETE VALUES(259,9682,768,4);
INSERT INTO INTERPRETE VALUES(259,9683,768,5);
INSERT INTO INTERPRETE VALUES(259,9684,768,6);
INSERT INTO INTERPRETE VALUES(259,9685,768,7);
INSERT INTO INTERPRETE VALUES(259,9686,768,8);
INSERT INTO INTERPRETE VALUES(259,9687,768,9);
INSERT INTO INTERPRETE VALUES(259,9688,768,10);
INSERT INTO INTERPRETE VALUES(259,9689,768,11);
INSERT INTO INTERPRETE VALUES(259,9690,768,12);
INSERT INTO INTERPRETE VALUES(259,9691,768,13);
INSERT INTO INTERPRETE VALUES(259,9692,768,14);
INSERT INTO INTERPRETE VALUES(259,9693,768,15);
INSERT INTO INTERPRETE VALUES(259,9694,768,16);
INSERT INTO INTERPRETE VALUES(259,9695,768,17);
INSERT INTO INTERPRETE VALUES(274,9696,769,1);
INSERT INTO INTERPRETE VALUES(274,9697,769,2);
INSERT INTO INTERPRETE VALUES(274,9698,769,3);
INSERT INTO INTERPRETE VALUES(274,9699,769,4);
INSERT INTO INTERPRETE VALUES(274,9700,769,5);
INSERT INTO INTERPRETE VALUES(274,9701,769,6);
INSERT INTO INTERPRETE VALUES(274,9702,769,7);
INSERT INTO INTERPRETE VALUES(274,9703,769,8);
INSERT INTO INTERPRETE VALUES(274,9704,769,9);
INSERT INTO INTERPRETE VALUES(274,9705,769,10);
INSERT INTO INTERPRETE VALUES(274,9706,769,11);
INSERT INTO INTERPRETE VALUES(274,9707,769,12);
INSERT INTO INTERPRETE VALUES(274,9708,769,13);
INSERT INTO INTERPRETE VALUES(274,9710,769,15);
INSERT INTO INTERPRETE VALUES(274,9711,769,16);
INSERT INTO INTERPRETE VALUES(252,9548,770,1);
INSERT INTO INTERPRETE VALUES(252,9542,770,2);
INSERT INTO INTERPRETE VALUES(252,9714,770,3);
INSERT INTO INTERPRETE VALUES(252,9715,770,4);
INSERT INTO INTERPRETE VALUES(252,9545,770,5);
INSERT INTO INTERPRETE VALUES(252,9549,770,6);
INSERT INTO INTERPRETE VALUES(252,9718,770,7);
INSERT INTO INTERPRETE VALUES(252,9719,770,8);
INSERT INTO INTERPRETE VALUES(252,9538,770,9);
INSERT INTO INTERPRETE VALUES(252,9721,770,10);
INSERT INTO INTERPRETE VALUES(252,9722,770,11);
INSERT INTO INTERPRETE VALUES(252,9723,770,12);
INSERT INTO INTERPRETE VALUES(252,9724,770,13);
INSERT INTO INTERPRETE VALUES(252,9725,770,14);
INSERT INTO INTERPRETE VALUES(252,9726,770,15);
INSERT INTO INTERPRETE VALUES(252,9727,770,16);
INSERT INTO INTERPRETE VALUES(252,9728,770,17);
INSERT INTO INTERPRETE VALUES(274,9729,771,1);
INSERT INTO INTERPRETE VALUES(274,9730,771,2);
INSERT INTO INTERPRETE VALUES(274,9731,771,3);
INSERT INTO INTERPRETE VALUES(274,9732,771,4);
INSERT INTO INTERPRETE VALUES(274,9733,771,5);
INSERT INTO INTERPRETE VALUES(274,9734,771,6);
INSERT INTO INTERPRETE VALUES(274,9735,771,7);
INSERT INTO INTERPRETE VALUES(274,9736,771,8);
INSERT INTO INTERPRETE VALUES(274,9737,771,9);
INSERT INTO INTERPRETE VALUES(274,9738,771,10);
INSERT INTO INTERPRETE VALUES(274,9739,771,11);
INSERT INTO INTERPRETE VALUES(274,9741,771,13);
INSERT INTO INTERPRETE VALUES(274,9742,771,14);
INSERT INTO INTERPRETE VALUES(274,9743,771,15);
INSERT INTO INTERPRETE VALUES(274,9744,772,1);
INSERT INTO INTERPRETE VALUES(274,9745,772,2);
INSERT INTO INTERPRETE VALUES(274,9746,772,3);
INSERT INTO INTERPRETE VALUES(274,9747,772,4);
INSERT INTO INTERPRETE VALUES(274,9748,772,5);
INSERT INTO INTERPRETE VALUES(274,9749,772,6);
INSERT INTO INTERPRETE VALUES(274,9750,772,7);
INSERT INTO INTERPRETE VALUES(274,9751,772,8);
INSERT INTO INTERPRETE VALUES(274,9752,772,9);
INSERT INTO INTERPRETE VALUES(274,9753,772,10);
INSERT INTO INTERPRETE VALUES(274,9754,772,11);
INSERT INTO INTERPRETE VALUES(274,9755,773,1);
INSERT INTO INTERPRETE VALUES(274,9756,773,2);
INSERT INTO INTERPRETE VALUES(274,9757,773,3);
INSERT INTO INTERPRETE VALUES(274,9758,773,4);
INSERT INTO INTERPRETE VALUES(274,9759,773,5);
INSERT INTO INTERPRETE VALUES(274,9760,773,6);
INSERT INTO INTERPRETE VALUES(274,9761,773,7);
INSERT INTO INTERPRETE VALUES(274,9762,773,8);
INSERT INTO INTERPRETE VALUES(274,9763,773,9);
INSERT INTO INTERPRETE VALUES(274,9764,773,10);
INSERT INTO INTERPRETE VALUES(252,9765,774,1);
INSERT INTO INTERPRETE VALUES(252,9766,774,2);
INSERT INTO INTERPRETE VALUES(252,9767,774,3);
INSERT INTO INTERPRETE VALUES(252,9768,774,4);
INSERT INTO INTERPRETE VALUES(252,9769,774,5);
INSERT INTO INTERPRETE VALUES(252,9770,774,6);
INSERT INTO INTERPRETE VALUES(252,9771,774,7);
INSERT INTO INTERPRETE VALUES(252,9772,774,8);
INSERT INTO INTERPRETE VALUES(252,9773,774,9);
INSERT INTO INTERPRETE VALUES(252,9774,774,10);
INSERT INTO INTERPRETE VALUES(252,9775,774,11);
INSERT INTO INTERPRETE VALUES(252,9776,774,12);
INSERT INTO INTERPRETE VALUES(252,9777,774,13);
INSERT INTO INTERPRETE VALUES(252,9778,774,14);
INSERT INTO INTERPRETE VALUES(252,9779,774,15);
INSERT INTO INTERPRETE VALUES(252,9780,774,16);
INSERT INTO INTERPRETE VALUES(252,9781,774,17);
INSERT INTO INTERPRETE VALUES(252,8679,774,18);
INSERT INTO INTERPRETE VALUES(252,9783,774,19);
INSERT INTO INTERPRETE VALUES(274,9784,775,1);
INSERT INTO INTERPRETE VALUES(274,9785,775,2);
INSERT INTO INTERPRETE VALUES(274,9786,775,3);
INSERT INTO INTERPRETE VALUES(274,9787,775,4);
INSERT INTO INTERPRETE VALUES(274,9788,775,5);
INSERT INTO INTERPRETE VALUES(274,9789,775,6);
INSERT INTO INTERPRETE VALUES(274,9790,775,7);
INSERT INTO INTERPRETE VALUES(274,9791,775,8);
INSERT INTO INTERPRETE VALUES(274,9792,776,1);
INSERT INTO INTERPRETE VALUES(274,9793,776,2);
INSERT INTO INTERPRETE VALUES(274,9794,776,3);
INSERT INTO INTERPRETE VALUES(274,9795,776,4);
INSERT INTO INTERPRETE VALUES(274,9796,776,5);
INSERT INTO INTERPRETE VALUES(274,9797,776,6);
INSERT INTO INTERPRETE VALUES(274,9798,776,7);
INSERT INTO INTERPRETE VALUES(274,9799,776,8);
INSERT INTO INTERPRETE VALUES(274,9800,776,9);
INSERT INTO INTERPRETE VALUES(274,9801,776,10);
INSERT INTO INTERPRETE VALUES(274,9802,776,11);
INSERT INTO INTERPRETE VALUES(274,9803,776,12);
INSERT INTO INTERPRETE VALUES(274,9804,776,13);
INSERT INTO INTERPRETE VALUES(274,9805,776,14);
INSERT INTO INTERPRETE VALUES(274,9806,776,15);
INSERT INTO INTERPRETE VALUES(274,9807,776,16);
INSERT INTO INTERPRETE VALUES(274,9808,776,17);
INSERT INTO INTERPRETE VALUES(274,9809,777,1);
INSERT INTO INTERPRETE VALUES(274,9810,777,2);
INSERT INTO INTERPRETE VALUES(274,9811,777,3);
INSERT INTO INTERPRETE VALUES(95,2278,778,1);
INSERT INTO INTERPRETE VALUES(95,2286,778,2);
INSERT INTO INTERPRETE VALUES(95,9814,778,3);
INSERT INTO INTERPRETE VALUES(95,5543,778,4);
INSERT INTO INTERPRETE VALUES(95,9816,778,5);
INSERT INTO INTERPRETE VALUES(95,2285,778,6);
INSERT INTO INTERPRETE VALUES(95,9818,778,7);
INSERT INTO INTERPRETE VALUES(95,9819,778,8);
INSERT INTO INTERPRETE VALUES(95,9820,778,9);
INSERT INTO INTERPRETE VALUES(95,9821,778,10);
INSERT INTO INTERPRETE VALUES(95,2277,778,11);
INSERT INTO INTERPRETE VALUES(95,9205,778,12);
INSERT INTO INTERPRETE VALUES(95,9824,778,13);
INSERT INTO INTERPRETE VALUES(95,2287,778,14);
INSERT INTO INTERPRETE VALUES(95,2364,778,15);
INSERT INTO INTERPRETE VALUES(95,2288,778,16);
INSERT INTO INTERPRETE VALUES(131,9828,779,1);
INSERT INTO INTERPRETE VALUES(131,9829,779,2);
INSERT INTO INTERPRETE VALUES(131,9830,779,3);
INSERT INTO INTERPRETE VALUES(131,9831,779,4);
INSERT INTO INTERPRETE VALUES(131,9832,779,5);
INSERT INTO INTERPRETE VALUES(131,9833,779,6);
INSERT INTO INTERPRETE VALUES(131,9834,779,7);
INSERT INTO INTERPRETE VALUES(131,9835,779,8);
INSERT INTO INTERPRETE VALUES(254,9845,780,5);
INSERT INTO INTERPRETE VALUES(254,9846,780,6);
INSERT INTO INTERPRETE VALUES(254,9847,780,7);
INSERT INTO INTERPRETE VALUES(254,9848,780,8);
INSERT INTO INTERPRETE VALUES(254,9849,780,9);
INSERT INTO INTERPRETE VALUES(254,9850,780,10);
INSERT INTO INTERPRETE VALUES(254,9851,780,11);
INSERT INTO INTERPRETE VALUES(89,9852,781,1);
INSERT INTO INTERPRETE VALUES(89,9853,781,2);
INSERT INTO INTERPRETE VALUES(89,9854,781,3);
INSERT INTO INTERPRETE VALUES(89,9855,781,4);
INSERT INTO INTERPRETE VALUES(89,9856,781,5);
INSERT INTO INTERPRETE VALUES(89,9857,781,6);
INSERT INTO INTERPRETE VALUES(89,9858,781,7);
INSERT INTO INTERPRETE VALUES(89,9859,781,8);
INSERT INTO INTERPRETE VALUES(89,9860,781,9);
INSERT INTO INTERPRETE VALUES(89,9861,781,10);
INSERT INTO INTERPRETE VALUES(89,9862,781,11);
INSERT INTO INTERPRETE VALUES(89,9863,781,12);
INSERT INTO INTERPRETE VALUES(89,9864,781,13);
INSERT INTO INTERPRETE VALUES(89,9865,781,14);
INSERT INTO INTERPRETE VALUES(89,9866,781,15);
INSERT INTO INTERPRETE VALUES(254,9867,782,1);
INSERT INTO INTERPRETE VALUES(254,9868,782,2);
INSERT INTO INTERPRETE VALUES(254,9869,782,3);
INSERT INTO INTERPRETE VALUES(254,9870,782,4);
INSERT INTO INTERPRETE VALUES(254,9871,782,5);
INSERT INTO INTERPRETE VALUES(254,9872,782,6);
INSERT INTO INTERPRETE VALUES(254,9873,782,7);
INSERT INTO INTERPRETE VALUES(254,9874,782,8);
INSERT INTO INTERPRETE VALUES(254,9875,782,9);
INSERT INTO INTERPRETE VALUES(254,9876,782,10);
INSERT INTO INTERPRETE VALUES(143,9020,783,1);
INSERT INTO INTERPRETE VALUES(143,9015,783,6);
INSERT INTO INTERPRETE VALUES(143,8526,783,8);
INSERT INTO INTERPRETE VALUES(143,9004,783,10);
INSERT INTO INTERPRETE VALUES(143,9016,783,7);
INSERT INTO INTERPRETE VALUES(143,9024,783,9);
INSERT INTO INTERPRETE VALUES(143,8524,783,13);
INSERT INTO INTERPRETE VALUES(143,9112,783,17);
INSERT INTO INTERPRETE VALUES(143,7313,783,19);
INSERT INTO INTERPRETE VALUES(143,9898,783,22);
INSERT INTO INTERPRETE VALUES(143,9899,783,23);
INSERT INTO INTERPRETE VALUES(275,9900,784,1);
INSERT INTO INTERPRETE VALUES(275,9901,784,2);
INSERT INTO INTERPRETE VALUES(275,9902,784,3);
INSERT INTO INTERPRETE VALUES(275,9903,784,4);
INSERT INTO INTERPRETE VALUES(275,9904,784,5);
INSERT INTO INTERPRETE VALUES(275,9905,784,6);
INSERT INTO INTERPRETE VALUES(275,9906,784,7);
INSERT INTO INTERPRETE VALUES(275,9907,784,8);
INSERT INTO INTERPRETE VALUES(275,9908,784,9);
INSERT INTO INTERPRETE VALUES(275,9909,784,10);
INSERT INTO INTERPRETE VALUES(275,9910,784,11);
INSERT INTO INTERPRETE VALUES(275,9911,784,12);
INSERT INTO INTERPRETE VALUES(275,9912,785,1);
INSERT INTO INTERPRETE VALUES(275,9913,785,2);
INSERT INTO INTERPRETE VALUES(275,9914,785,3);
INSERT INTO INTERPRETE VALUES(275,9915,785,4);
INSERT INTO INTERPRETE VALUES(275,9916,785,5);
INSERT INTO INTERPRETE VALUES(275,9917,785,6);
INSERT INTO INTERPRETE VALUES(275,9918,785,7);
INSERT INTO INTERPRETE VALUES(275,9919,785,8);
INSERT INTO INTERPRETE VALUES(275,9920,785,9);
INSERT INTO INTERPRETE VALUES(275,9921,785,10);
INSERT INTO INTERPRETE VALUES(275,9922,785,11);
INSERT INTO INTERPRETE VALUES(275,9923,785,12);
INSERT INTO INTERPRETE VALUES(181,9925,786,1);
INSERT INTO INTERPRETE VALUES(181,9926,786,2);
INSERT INTO INTERPRETE VALUES(181,9927,786,3);
INSERT INTO INTERPRETE VALUES(181,9928,786,4);
INSERT INTO INTERPRETE VALUES(181,9929,786,5);
INSERT INTO INTERPRETE VALUES(181,9930,786,6);
INSERT INTO INTERPRETE VALUES(181,9931,786,7);
INSERT INTO INTERPRETE VALUES(181,9932,786,8);
INSERT INTO INTERPRETE VALUES(181,9933,786,9);
INSERT INTO INTERPRETE VALUES(181,9934,786,10);
INSERT INTO INTERPRETE VALUES(181,9935,786,11);
INSERT INTO INTERPRETE VALUES(181,9937,786,13);
INSERT INTO INTERPRETE VALUES(181,9938,786,14);
INSERT INTO INTERPRETE VALUES(181,9939,786,15);
INSERT INTO INTERPRETE VALUES(181,9940,786,16);
INSERT INTO INTERPRETE VALUES(181,9941,786,17);
INSERT INTO INTERPRETE VALUES(181,9942,786,18);
INSERT INTO INTERPRETE VALUES(181,9943,786,19);
INSERT INTO INTERPRETE VALUES(181,9944,786,20);
INSERT INTO INTERPRETE VALUES(181,9945,786,21);
INSERT INTO INTERPRETE VALUES(181,9946,786,22);
INSERT INTO INTERPRETE VALUES(181,9947,786,23);
INSERT INTO INTERPRETE VALUES(181,9948,786,24);
INSERT INTO INTERPRETE VALUES(181,9949,786,25);
INSERT INTO INTERPRETE VALUES(181,9950,786,26);
INSERT INTO INTERPRETE VALUES(181,9951,786,27);
INSERT INTO INTERPRETE VALUES(181,9952,786,28);
INSERT INTO INTERPRETE VALUES(181,9953,786,29);
INSERT INTO INTERPRETE VALUES(181,9954,786,30);
INSERT INTO INTERPRETE VALUES(181,9955,786,31);
INSERT INTO INTERPRETE VALUES(181,9956,786,32);
INSERT INTO INTERPRETE VALUES(95,9958,787,1);
INSERT INTO INTERPRETE VALUES(95,9959,787,2);
INSERT INTO INTERPRETE VALUES(95,9960,787,3);
INSERT INTO INTERPRETE VALUES(95,9961,787,4);
INSERT INTO INTERPRETE VALUES(95,9962,787,5);
INSERT INTO INTERPRETE VALUES(95,9963,787,6);
INSERT INTO INTERPRETE VALUES(95,9964,787,7);
INSERT INTO INTERPRETE VALUES(95,9965,787,8);
INSERT INTO INTERPRETE VALUES(95,9966,787,9);
INSERT INTO INTERPRETE VALUES(95,9967,787,10);
INSERT INTO INTERPRETE VALUES(95,9968,787,11);
INSERT INTO INTERPRETE VALUES(95,9969,787,12);
INSERT INTO INTERPRETE VALUES(71,9973,789,2);
INSERT INTO INTERPRETE VALUES(71,9974,789,3);
INSERT INTO INTERPRETE VALUES(71,9977,789,6);
INSERT INTO INTERPRETE VALUES(71,9978,789,7);
INSERT INTO INTERPRETE VALUES(71,9979,789,8);
INSERT INTO INTERPRETE VALUES(181,9980,790,1);
INSERT INTO INTERPRETE VALUES(181,9981,790,2);
INSERT INTO INTERPRETE VALUES(181,9982,790,3);
INSERT INTO INTERPRETE VALUES(181,9983,790,4);
INSERT INTO INTERPRETE VALUES(181,9984,790,5);
INSERT INTO INTERPRETE VALUES(181,9986,790,7);
INSERT INTO INTERPRETE VALUES(181,9987,790,8);
INSERT INTO INTERPRETE VALUES(181,9988,790,9);
INSERT INTO INTERPRETE VALUES(181,9989,790,10);
INSERT INTO INTERPRETE VALUES(181,9990,790,11);
INSERT INTO INTERPRETE VALUES(181,9991,790,12);
INSERT INTO INTERPRETE VALUES(181,9992,790,13);
INSERT INTO INTERPRETE VALUES(181,9993,790,14);
INSERT INTO INTERPRETE VALUES(181,9994,790,15);
INSERT INTO INTERPRETE VALUES(181,6193,790,16);
INSERT INTO INTERPRETE VALUES(181,9996,790,17);
INSERT INTO INTERPRETE VALUES(181,9997,790,18);
INSERT INTO INTERPRETE VALUES(181,9998,790,19);
INSERT INTO INTERPRETE VALUES(181,9999,790,20);
INSERT INTO INTERPRETE VALUES(181,10000,790,21);
INSERT INTO INTERPRETE VALUES(181,10001,790,22);
INSERT INTO INTERPRETE VALUES(181,10002,790,23);
INSERT INTO INTERPRETE VALUES(181,10003,790,24);
INSERT INTO INTERPRETE VALUES(181,10004,790,25);
INSERT INTO INTERPRETE VALUES(181,3509,790,26);
INSERT INTO INTERPRETE VALUES(181,10006,790,27);
INSERT INTO INTERPRETE VALUES(181,10007,790,28);
INSERT INTO INTERPRETE VALUES(181,10008,790,29);
INSERT INTO INTERPRETE VALUES(181,10009,790,30);
INSERT INTO INTERPRETE VALUES(181,10011,790,32);
INSERT INTO INTERPRETE VALUES(181,10012,790,33);
INSERT INTO INTERPRETE VALUES(181,6201,790,34);
INSERT INTO INTERPRETE VALUES(181,10014,790,35);
INSERT INTO INTERPRETE VALUES(181,10015,790,36);
INSERT INTO INTERPRETE VALUES(181,10016,790,37);
INSERT INTO INTERPRETE VALUES(83,2198,791,1);
INSERT INTO INTERPRETE VALUES(181,6190,790,6);
INSERT INTO INTERPRETE VALUES(83,10018,791,2);
INSERT INTO INTERPRETE VALUES(83,10019,791,3);
INSERT INTO INTERPRETE VALUES(83,1960,791,4);
INSERT INTO INTERPRETE VALUES(83,5842,791,5);
INSERT INTO INTERPRETE VALUES(83,10022,791,6);
INSERT INTO INTERPRETE VALUES(83,6329,791,7);
INSERT INTO INTERPRETE VALUES(83,5848,791,8);
INSERT INTO INTERPRETE VALUES(83,10025,791,9);
INSERT INTO INTERPRETE VALUES(83,5846,791,10);
INSERT INTO INTERPRETE VALUES(83,1965,791,11);
INSERT INTO INTERPRETE VALUES(109,10028,792,1);
INSERT INTO INTERPRETE VALUES(109,10029,792,2);
INSERT INTO INTERPRETE VALUES(109,6386,792,3);
INSERT INTO INTERPRETE VALUES(109,10031,792,4);
INSERT INTO INTERPRETE VALUES(109,10032,792,5);
INSERT INTO INTERPRETE VALUES(109,3904,792,6);
INSERT INTO INTERPRETE VALUES(109,10034,792,7);
INSERT INTO INTERPRETE VALUES(109,10035,792,8);
INSERT INTO INTERPRETE VALUES(109,10036,792,9);
INSERT INTO INTERPRETE VALUES(109,10037,792,10);
INSERT INTO INTERPRETE VALUES(109,10038,792,11);
INSERT INTO INTERPRETE VALUES(109,10039,792,12);
INSERT INTO INTERPRETE VALUES(109,10040,792,13);
INSERT INTO INTERPRETE VALUES(109,10041,792,14);
INSERT INTO INTERPRETE VALUES(109,10042,792,15);
INSERT INTO INTERPRETE VALUES(109,10043,792,16);
INSERT INTO INTERPRETE VALUES(109,10044,792,17);
INSERT INTO INTERPRETE VALUES(109,10045,792,18);
INSERT INTO INTERPRETE VALUES(109,10046,792,19);
INSERT INTO INTERPRETE VALUES(109,10047,792,20);
INSERT INTO INTERPRETE VALUES(109,6385,792,21);
INSERT INTO INTERPRETE VALUES(276,10051,793,3);
INSERT INTO INTERPRETE VALUES(276,10052,793,4);
INSERT INTO INTERPRETE VALUES(276,10053,793,5);
INSERT INTO INTERPRETE VALUES(276,10054,793,6);
INSERT INTO INTERPRETE VALUES(276,10055,793,7);
INSERT INTO INTERPRETE VALUES(276,10056,793,8);
INSERT INTO INTERPRETE VALUES(276,10057,793,9);
INSERT INTO INTERPRETE VALUES(276,10058,793,10);
INSERT INTO INTERPRETE VALUES(276,10060,793,12);
INSERT INTO INTERPRETE VALUES(276,10061,793,13);
INSERT INTO INTERPRETE VALUES(276,10062,793,14);
INSERT INTO INTERPRETE VALUES(276,10050,793,2);
INSERT INTO INTERPRETE VALUES(276,10059,793,11);
INSERT INTO INTERPRETE VALUES(258,10145,800,1);
INSERT INTO INTERPRETE VALUES(258,10146,800,2);
INSERT INTO INTERPRETE VALUES(258,8604,800,3);
INSERT INTO INTERPRETE VALUES(258,8586,800,4);
INSERT INTO INTERPRETE VALUES(258,10149,800,5);
INSERT INTO INTERPRETE VALUES(258,10150,800,6);
INSERT INTO INTERPRETE VALUES(258,10151,800,7);
INSERT INTO INTERPRETE VALUES(258,10152,800,8);
INSERT INTO INTERPRETE VALUES(258,10153,800,9);
INSERT INTO INTERPRETE VALUES(258,10158,800,14);
INSERT INTO INTERPRETE VALUES(258,10159,800,15);
INSERT INTO INTERPRETE VALUES(258,10160,800,16);
INSERT INTO INTERPRETE VALUES(258,10161,800,17);
INSERT INTO INTERPRETE VALUES(258,250,800,19);
INSERT INTO INTERPRETE VALUES(258,10164,800,20);
INSERT INTO INTERPRETE VALUES(258,10165,800,21);
INSERT INTO INTERPRETE VALUES(258,10166,800,22);
INSERT INTO INTERPRETE VALUES(258,10167,800,23);
INSERT INTO INTERPRETE VALUES(258,10168,800,24);
INSERT INTO INTERPRETE VALUES(258,10169,801,1);
INSERT INTO INTERPRETE VALUES(258,10170,801,2);
INSERT INTO INTERPRETE VALUES(258,10171,801,3);
INSERT INTO INTERPRETE VALUES(258,10172,801,4);
INSERT INTO INTERPRETE VALUES(258,8591,801,5);
INSERT INTO INTERPRETE VALUES(258,10174,801,6);
INSERT INTO INTERPRETE VALUES(258,10175,801,7);
INSERT INTO INTERPRETE VALUES(258,10176,801,8);
INSERT INTO INTERPRETE VALUES(258,10177,801,9);
INSERT INTO INTERPRETE VALUES(258,8606,801,10);
INSERT INTO INTERPRETE VALUES(258,10179,801,11);
INSERT INTO INTERPRETE VALUES(258,8592,801,12);
INSERT INTO INTERPRETE VALUES(258,10181,801,13);
INSERT INTO INTERPRETE VALUES(258,1213,801,14);
INSERT INTO INTERPRETE VALUES(258,10183,801,15);
INSERT INTO INTERPRETE VALUES(258,10184,801,16);
INSERT INTO INTERPRETE VALUES(258,10185,801,17);
INSERT INTO INTERPRETE VALUES(258,10186,801,18);
INSERT INTO INTERPRETE VALUES(258,10187,801,19);
INSERT INTO INTERPRETE VALUES(46,10188,802,1);
INSERT INTO INTERPRETE VALUES(46,10189,802,2);
INSERT INTO INTERPRETE VALUES(46,10190,802,3);
INSERT INTO INTERPRETE VALUES(46,10191,802,4);
INSERT INTO INTERPRETE VALUES(46,10192,802,5);
INSERT INTO INTERPRETE VALUES(46,10193,802,6);
INSERT INTO INTERPRETE VALUES(46,10194,802,7);
INSERT INTO INTERPRETE VALUES(46,10195,802,8);
INSERT INTO INTERPRETE VALUES(46,10196,802,9);
INSERT INTO INTERPRETE VALUES(46,10197,802,10);
INSERT INTO INTERPRETE VALUES(46,10198,802,11);
INSERT INTO INTERPRETE VALUES(46,10199,802,12);
INSERT INTO INTERPRETE VALUES(46,10200,802,13);
INSERT INTO INTERPRETE VALUES(46,10201,802,14);
INSERT INTO INTERPRETE VALUES(46,10202,802,15);
INSERT INTO INTERPRETE VALUES(46,10203,802,16);
INSERT INTO INTERPRETE VALUES(46,10204,802,17);
INSERT INTO INTERPRETE VALUES(46,10205,802,18);
INSERT INTO INTERPRETE VALUES(154,10225,805,1);
INSERT INTO INTERPRETE VALUES(154,10226,805,2);
INSERT INTO INTERPRETE VALUES(154,10227,805,3);
INSERT INTO INTERPRETE VALUES(154,10228,805,4);
INSERT INTO INTERPRETE VALUES(154,10229,805,5);
INSERT INTO INTERPRETE VALUES(154,10230,805,6);
INSERT INTO INTERPRETE VALUES(154,10231,805,7);
INSERT INTO INTERPRETE VALUES(154,10232,805,8);
INSERT INTO INTERPRETE VALUES(154,10233,805,9);
INSERT INTO INTERPRETE VALUES(154,10234,805,10);
INSERT INTO INTERPRETE VALUES(154,10235,805,11);
INSERT INTO INTERPRETE VALUES(154,10236,805,12);
INSERT INTO INTERPRETE VALUES(154,10237,805,13);
INSERT INTO INTERPRETE VALUES(154,10238,805,14);
INSERT INTO INTERPRETE VALUES(154,10239,805,15);
INSERT INTO INTERPRETE VALUES(154,10240,805,16);
INSERT INTO INTERPRETE VALUES(154,10241,805,17);
INSERT INTO INTERPRETE VALUES(154,10242,805,18);
INSERT INTO INTERPRETE VALUES(154,10243,805,19);
INSERT INTO INTERPRETE VALUES(174,10367,812,1);
INSERT INTO INTERPRETE VALUES(174,10368,812,2);
INSERT INTO INTERPRETE VALUES(174,5729,812,3);
INSERT INTO INTERPRETE VALUES(174,5724,812,4);
INSERT INTO INTERPRETE VALUES(174,5722,812,5);
INSERT INTO INTERPRETE VALUES(174,5730,812,6);
INSERT INTO INTERPRETE VALUES(174,5727,812,7);
INSERT INTO INTERPRETE VALUES(174,5720,812,8);
INSERT INTO INTERPRETE VALUES(174,10375,812,9);
INSERT INTO INTERPRETE VALUES(174,5732,812,10);
INSERT INTO INTERPRETE VALUES(174,5719,812,11);
INSERT INTO INTERPRETE VALUES(174,10378,812,12);
INSERT INTO INTERPRETE VALUES(174,10379,812,13);
INSERT INTO INTERPRETE VALUES(174,10380,812,14);
INSERT INTO INTERPRETE VALUES(174,10381,812,15);
INSERT INTO INTERPRETE VALUES(174,10382,812,16);
INSERT INTO INTERPRETE VALUES(174,2551,812,17);
INSERT INTO INTERPRETE VALUES(174,10384,812,18);
INSERT INTO INTERPRETE VALUES(174,10385,812,19);
INSERT INTO INTERPRETE VALUES(174,10386,812,20);
INSERT INTO INTERPRETE VALUES(174,10387,812,21);
INSERT INTO INTERPRETE VALUES(264,10413,814,1);
INSERT INTO INTERPRETE VALUES(264,10414,814,2);
INSERT INTO INTERPRETE VALUES(264,10415,814,3);
INSERT INTO INTERPRETE VALUES(264,10416,814,4);
INSERT INTO INTERPRETE VALUES(264,10417,814,5);
INSERT INTO INTERPRETE VALUES(264,10418,814,6);
INSERT INTO INTERPRETE VALUES(264,10419,814,7);
INSERT INTO INTERPRETE VALUES(264,10420,814,8);
INSERT INTO INTERPRETE VALUES(264,10421,814,9);
INSERT INTO INTERPRETE VALUES(264,10422,814,10);
INSERT INTO INTERPRETE VALUES(264,10423,815,1);
INSERT INTO INTERPRETE VALUES(264,10424,815,2);
INSERT INTO INTERPRETE VALUES(264,10425,815,3);
INSERT INTO INTERPRETE VALUES(264,10426,815,4);
INSERT INTO INTERPRETE VALUES(264,10427,815,5);
INSERT INTO INTERPRETE VALUES(264,10428,815,6);
INSERT INTO INTERPRETE VALUES(264,10429,815,7);
INSERT INTO INTERPRETE VALUES(264,10430,815,8);
INSERT INTO INTERPRETE VALUES(264,10431,815,9);
INSERT INTO INTERPRETE VALUES(264,10432,815,10);
INSERT INTO INTERPRETE VALUES(66,4219,816,1);
INSERT INTO INTERPRETE VALUES(66,10434,816,2);
INSERT INTO INTERPRETE VALUES(66,10435,816,3);
INSERT INTO INTERPRETE VALUES(66,2083,816,4);
INSERT INTO INTERPRETE VALUES(66,10437,816,5);
INSERT INTO INTERPRETE VALUES(66,10438,816,6);
INSERT INTO INTERPRETE VALUES(66,10439,816,7);
INSERT INTO INTERPRETE VALUES(66,2102,816,8);
INSERT INTO INTERPRETE VALUES(66,10441,816,9);
INSERT INTO INTERPRETE VALUES(66,10442,816,10);
INSERT INTO INTERPRETE VALUES(66,10443,816,11);
INSERT INTO INTERPRETE VALUES(66,10444,816,12);
INSERT INTO INTERPRETE VALUES(66,10445,816,13);
INSERT INTO INTERPRETE VALUES(66,10446,816,14);
INSERT INTO INTERPRETE VALUES(66,10447,816,15);
INSERT INTO INTERPRETE VALUES(66,10448,816,16);
INSERT INTO INTERPRETE VALUES(66,10449,816,17);
INSERT INTO INTERPRETE VALUES(66,10450,816,18);
INSERT INTO INTERPRETE VALUES(66,10451,816,19);
INSERT INTO INTERPRETE VALUES(66,10452,816,20);
INSERT INTO INTERPRETE VALUES(57,10468,818,6);
INSERT INTO INTERPRETE VALUES(57,10469,818,7);
INSERT INTO INTERPRETE VALUES(57,10470,818,8);
INSERT INTO INTERPRETE VALUES(57,10473,818,11);
INSERT INTO INTERPRETE VALUES(57,10464,818,2);
INSERT INTO INTERPRETE VALUES(57,10474,818,12);
INSERT INTO INTERPRETE VALUES(57,10476,819,1);
INSERT INTO INTERPRETE VALUES(57,10477,819,2);
INSERT INTO INTERPRETE VALUES(57,10478,819,3);
INSERT INTO INTERPRETE VALUES(57,10479,819,4);
INSERT INTO INTERPRETE VALUES(57,10480,819,5);
INSERT INTO INTERPRETE VALUES(57,10481,819,6);
INSERT INTO INTERPRETE VALUES(57,10482,819,7);
INSERT INTO INTERPRETE VALUES(57,10483,819,8);
INSERT INTO INTERPRETE VALUES(57,10485,819,10);
INSERT INTO INTERPRETE VALUES(57,10486,819,11);
INSERT INTO INTERPRETE VALUES(57,10487,819,12);
INSERT INTO INTERPRETE VALUES(57,10488,819,13);
INSERT INTO INTERPRETE VALUES(83,2198,821,1);
INSERT INTO INTERPRETE VALUES(83,10019,821,2);
INSERT INTO INTERPRETE VALUES(83,2193,821,4);
INSERT INTO INTERPRETE VALUES(83,10508,821,6);
INSERT INTO INTERPRETE VALUES(83,2191,821,7);
INSERT INTO INTERPRETE VALUES(83,10510,821,8);
INSERT INTO INTERPRETE VALUES(83,10511,821,9);
INSERT INTO INTERPRETE VALUES(83,10512,821,10);
INSERT INTO INTERPRETE VALUES(83,10513,821,11);
INSERT INTO INTERPRETE VALUES(83,10514,821,12);
INSERT INTO INTERPRETE VALUES(83,2190,821,15);
INSERT INTO INTERPRETE VALUES(83,2195,821,5);
INSERT INTO INTERPRETE VALUES(83,10516,821,14);
INSERT INTO INTERPRETE VALUES(282,10648,830,1);
INSERT INTO INTERPRETE VALUES(282,10649,830,2);
INSERT INTO INTERPRETE VALUES(282,10650,830,3);
INSERT INTO INTERPRETE VALUES(282,10651,830,4);
INSERT INTO INTERPRETE VALUES(282,10652,830,5);
INSERT INTO INTERPRETE VALUES(282,10653,830,6);
INSERT INTO INTERPRETE VALUES(282,10654,830,7);
INSERT INTO INTERPRETE VALUES(282,10655,830,8);
INSERT INTO INTERPRETE VALUES(282,10657,830,10);
INSERT INTO INTERPRETE VALUES(282,10658,830,11);
INSERT INTO INTERPRETE VALUES(282,10659,830,12);
INSERT INTO INTERPRETE VALUES(282,10660,830,13);
INSERT INTO INTERPRETE VALUES(282,10661,830,14);
INSERT INTO INTERPRETE VALUES(8,10662,831,1);
INSERT INTO INTERPRETE VALUES(8,10663,831,2);
INSERT INTO INTERPRETE VALUES(8,10664,831,3);
INSERT INTO INTERPRETE VALUES(8,10665,831,4);
INSERT INTO INTERPRETE VALUES(8,10666,831,5);
INSERT INTO INTERPRETE VALUES(8,10667,831,6);
INSERT INTO INTERPRETE VALUES(8,10668,831,7);
INSERT INTO INTERPRETE VALUES(8,10669,831,8);
INSERT INTO INTERPRETE VALUES(8,10670,831,9);
INSERT INTO INTERPRETE VALUES(8,10671,831,10);
INSERT INTO INTERPRETE VALUES(8,10672,831,11);
INSERT INTO INTERPRETE VALUES(8,10673,831,12);
INSERT INTO INTERPRETE VALUES(8,10674,831,13);
INSERT INTO INTERPRETE VALUES(8,10675,831,14);
INSERT INTO INTERPRETE VALUES(8,10676,831,15);
INSERT INTO INTERPRETE VALUES(8,10677,831,16);
INSERT INTO INTERPRETE VALUES(8,10678,831,17);
INSERT INTO INTERPRETE VALUES(8,10679,831,18);
INSERT INTO INTERPRETE VALUES(8,10680,831,19);
INSERT INTO INTERPRETE VALUES(8,10681,831,20);
INSERT INTO INTERPRETE VALUES(8,10682,831,21);
INSERT INTO INTERPRETE VALUES(8,10683,831,22);
INSERT INTO INTERPRETE VALUES(255,10684,832,1);
INSERT INTO INTERPRETE VALUES(255,10686,832,3);
INSERT INTO INTERPRETE VALUES(255,10687,832,4);
INSERT INTO INTERPRETE VALUES(255,10688,832,5);
INSERT INTO INTERPRETE VALUES(255,10689,832,6);
INSERT INTO INTERPRETE VALUES(255,10690,832,7);
INSERT INTO INTERPRETE VALUES(255,10691,832,8);
INSERT INTO INTERPRETE VALUES(255,10692,832,9);
INSERT INTO INTERPRETE VALUES(255,8444,832,10);
INSERT INTO INTERPRETE VALUES(255,10694,832,11);
INSERT INTO INTERPRETE VALUES(255,10695,832,12);
INSERT INTO INTERPRETE VALUES(255,10696,832,13);
INSERT INTO INTERPRETE VALUES(255,10697,832,14);
INSERT INTO INTERPRETE VALUES(255,8452,832,15);
INSERT INTO INTERPRETE VALUES(255,10699,832,16);
INSERT INTO INTERPRETE VALUES(255,10700,832,17);
INSERT INTO INTERPRETE VALUES(255,9654,832,18);
INSERT INTO INTERPRETE VALUES(255,10702,832,19);
INSERT INTO INTERPRETE VALUES(255,9647,832,20);
INSERT INTO INTERPRETE VALUES(8,10704,833,1);
INSERT INTO INTERPRETE VALUES(8,10705,833,2);
INSERT INTO INTERPRETE VALUES(8,10706,833,3);
INSERT INTO INTERPRETE VALUES(8,10707,833,4);
INSERT INTO INTERPRETE VALUES(8,10708,833,5);
INSERT INTO INTERPRETE VALUES(8,10709,833,6);
INSERT INTO INTERPRETE VALUES(8,10710,833,7);
INSERT INTO INTERPRETE VALUES(8,10711,833,8);
INSERT INTO INTERPRETE VALUES(8,10712,833,9);
INSERT INTO INTERPRETE VALUES(8,10713,833,10);
INSERT INTO INTERPRETE VALUES(8,10714,833,11);
INSERT INTO INTERPRETE VALUES(8,10715,833,12);
INSERT INTO INTERPRETE VALUES(8,10716,833,13);
INSERT INTO INTERPRETE VALUES(8,10717,833,14);
INSERT INTO INTERPRETE VALUES(8,10718,833,15);
INSERT INTO INTERPRETE VALUES(8,10719,833,16);
INSERT INTO INTERPRETE VALUES(8,10720,833,17);
INSERT INTO INTERPRETE VALUES(8,10721,833,18);
INSERT INTO INTERPRETE VALUES(8,10722,833,19);
INSERT INTO INTERPRETE VALUES(8,10723,833,20);
INSERT INTO INTERPRETE VALUES(8,10724,833,21);
INSERT INTO INTERPRETE VALUES(8,10725,833,22);
INSERT INTO INTERPRETE VALUES(8,10726,833,23);
INSERT INTO INTERPRETE VALUES(255,10685,832,2);
INSERT INTO INTERPRETE VALUES(8,10749,836,1);
INSERT INTO INTERPRETE VALUES(8,10750,836,2);
INSERT INTO INTERPRETE VALUES(8,10751,836,3);
INSERT INTO INTERPRETE VALUES(8,10752,836,4);
INSERT INTO INTERPRETE VALUES(8,10753,836,5);
INSERT INTO INTERPRETE VALUES(8,10754,836,6);
INSERT INTO INTERPRETE VALUES(8,10755,836,7);
INSERT INTO INTERPRETE VALUES(8,10756,836,8);
INSERT INTO INTERPRETE VALUES(8,10757,836,9);
INSERT INTO INTERPRETE VALUES(8,10758,836,10);
INSERT INTO INTERPRETE VALUES(8,10759,836,11);
INSERT INTO INTERPRETE VALUES(8,10760,836,12);
INSERT INTO INTERPRETE VALUES(8,10776,838,2);
INSERT INTO INTERPRETE VALUES(8,10778,838,4);
INSERT INTO INTERPRETE VALUES(8,10781,838,7);
INSERT INTO INTERPRETE VALUES(8,10784,838,10);
INSERT INTO INTERPRETE VALUES(8,10787,838,13);
INSERT INTO INTERPRETE VALUES(283,10818,840,13);
INSERT INTO INTERPRETE VALUES(283,10819,840,14);
INSERT INTO INTERPRETE VALUES(283,10821,840,16);
INSERT INTO INTERPRETE VALUES(283,10822,840,17);
INSERT INTO INTERPRETE VALUES(283,10823,840,18);
INSERT INTO INTERPRETE VALUES(8,10825,841,2);
INSERT INTO INTERPRETE VALUES(8,10826,841,3);
INSERT INTO INTERPRETE VALUES(8,10827,841,4);
INSERT INTO INTERPRETE VALUES(8,10828,841,5);
INSERT INTO INTERPRETE VALUES(8,10830,841,7);
INSERT INTO INTERPRETE VALUES(8,10831,841,8);
INSERT INTO INTERPRETE VALUES(8,10832,841,9);
INSERT INTO INTERPRETE VALUES(8,10833,841,10);
INSERT INTO INTERPRETE VALUES(8,10834,841,11);
INSERT INTO INTERPRETE VALUES(8,10835,841,12);
INSERT INTO INTERPRETE VALUES(8,10836,841,13);
INSERT INTO INTERPRETE VALUES(8,10837,841,14);
INSERT INTO INTERPRETE VALUES(8,10838,841,15);
INSERT INTO INTERPRETE VALUES(8,10839,841,16);
INSERT INTO INTERPRETE VALUES(8,10840,841,17);
INSERT INTO INTERPRETE VALUES(52,3228,842,1);
INSERT INTO INTERPRETE VALUES(8,10851,843,1);
INSERT INTO INTERPRETE VALUES(8,10852,843,2);
INSERT INTO INTERPRETE VALUES(8,10853,843,3);
INSERT INTO INTERPRETE VALUES(8,10854,843,4);
INSERT INTO INTERPRETE VALUES(8,10855,843,5);
INSERT INTO INTERPRETE VALUES(8,10856,843,6);
INSERT INTO INTERPRETE VALUES(8,10857,843,7);
INSERT INTO INTERPRETE VALUES(8,10858,843,8);
INSERT INTO INTERPRETE VALUES(8,10859,843,9);
INSERT INTO INTERPRETE VALUES(8,10860,843,10);
INSERT INTO INTERPRETE VALUES(8,10861,843,11);
INSERT INTO INTERPRETE VALUES(8,10862,843,12);
INSERT INTO INTERPRETE VALUES(8,10863,843,13);
INSERT INTO INTERPRETE VALUES(8,10864,843,14);
INSERT INTO INTERPRETE VALUES(8,10865,843,15);
INSERT INTO INTERPRETE VALUES(8,10866,843,16);
INSERT INTO INTERPRETE VALUES(8,10867,843,17);
INSERT INTO INTERPRETE VALUES(8,10868,843,18);
INSERT INTO INTERPRETE VALUES(8,10869,844,1);
INSERT INTO INTERPRETE VALUES(8,10870,844,2);
INSERT INTO INTERPRETE VALUES(8,10871,844,3);
INSERT INTO INTERPRETE VALUES(8,10872,844,4);
INSERT INTO INTERPRETE VALUES(8,10873,844,5);
INSERT INTO INTERPRETE VALUES(8,10874,844,6);
INSERT INTO INTERPRETE VALUES(8,10875,844,7);
INSERT INTO INTERPRETE VALUES(8,10876,844,8);
INSERT INTO INTERPRETE VALUES(8,10877,844,9);
INSERT INTO INTERPRETE VALUES(8,10878,844,10);
INSERT INTO INTERPRETE VALUES(8,10879,844,11);
INSERT INTO INTERPRETE VALUES(8,10880,844,12);
INSERT INTO INTERPRETE VALUES(8,10881,844,13);
INSERT INTO INTERPRETE VALUES(8,10882,844,14);
INSERT INTO INTERPRETE VALUES(8,10883,844,15);
INSERT INTO INTERPRETE VALUES(8,10884,844,16);
INSERT INTO INTERPRETE VALUES(8,10885,844,17);
INSERT INTO INTERPRETE VALUES(8,10886,844,18);
INSERT INTO INTERPRETE VALUES(8,10887,844,19);
INSERT INTO INTERPRETE VALUES(8,10888,844,20);
INSERT INTO INTERPRETE VALUES(8,10889,844,21);
INSERT INTO INTERPRETE VALUES(284,10890,845,1);
INSERT INTO INTERPRETE VALUES(284,10891,845,2);
INSERT INTO INTERPRETE VALUES(194,10894,846,3);
INSERT INTO INTERPRETE VALUES(194,10895,846,4);
INSERT INTO INTERPRETE VALUES(52,2176,842,7);
INSERT INTO INTERPRETE VALUES(52,4432,842,9);
INSERT INTO INTERPRETE VALUES(52,3229,842,5);
INSERT INTO INTERPRETE VALUES(194,10896,846,5);
INSERT INTO INTERPRETE VALUES(194,10898,846,7);
INSERT INTO INTERPRETE VALUES(194,10899,846,8);
INSERT INTO INTERPRETE VALUES(194,10903,846,12);
INSERT INTO INTERPRETE VALUES(285,10904,847,1);
INSERT INTO INTERPRETE VALUES(285,10905,847,2);
INSERT INTO INTERPRETE VALUES(285,10906,847,3);
INSERT INTO INTERPRETE VALUES(285,10907,847,4);
INSERT INTO INTERPRETE VALUES(285,10908,847,5);
INSERT INTO INTERPRETE VALUES(285,10909,847,6);
INSERT INTO INTERPRETE VALUES(285,10910,847,7);
INSERT INTO INTERPRETE VALUES(285,10911,847,8);
INSERT INTO INTERPRETE VALUES(285,10912,847,9);
INSERT INTO INTERPRETE VALUES(285,10913,847,10);
INSERT INTO INTERPRETE VALUES(3,10915,849,1);
INSERT INTO INTERPRETE VALUES(3,10916,849,2);
INSERT INTO INTERPRETE VALUES(3,10917,849,3);
INSERT INTO INTERPRETE VALUES(3,10918,849,4);
INSERT INTO INTERPRETE VALUES(3,10919,849,5);
INSERT INTO INTERPRETE VALUES(3,10920,849,6);
INSERT INTO INTERPRETE VALUES(3,10921,849,7);
INSERT INTO INTERPRETE VALUES(3,10922,849,8);
INSERT INTO INTERPRETE VALUES(3,10927,849,13);
INSERT INTO INTERPRETE VALUES(126,10947,853,1);
INSERT INTO INTERPRETE VALUES(126,10948,853,2);
INSERT INTO INTERPRETE VALUES(126,10949,853,3);
INSERT INTO INTERPRETE VALUES(126,10950,853,4);
INSERT INTO INTERPRETE VALUES(126,10951,853,5);
INSERT INTO INTERPRETE VALUES(126,10952,853,6);
INSERT INTO INTERPRETE VALUES(126,10953,853,7);
INSERT INTO INTERPRETE VALUES(126,10954,853,8);
INSERT INTO INTERPRETE VALUES(126,10955,853,9);
INSERT INTO INTERPRETE VALUES(126,10956,853,10);
INSERT INTO INTERPRETE VALUES(126,10957,853,11);
INSERT INTO INTERPRETE VALUES(126,10958,853,12);
INSERT INTO INTERPRETE VALUES(122,10960,852,2);
INSERT INTO INTERPRETE VALUES(122,10961,852,3);
INSERT INTO INTERPRETE VALUES(122,10962,852,4);
INSERT INTO INTERPRETE VALUES(122,10963,852,5);
INSERT INTO INTERPRETE VALUES(122,10964,852,6);
INSERT INTO INTERPRETE VALUES(122,10965,852,7);
INSERT INTO INTERPRETE VALUES(122,10966,852,8);
INSERT INTO INTERPRETE VALUES(122,10968,852,10);
INSERT INTO INTERPRETE VALUES(122,10969,852,11);
INSERT INTO INTERPRETE VALUES(122,10970,852,12);
INSERT INTO INTERPRETE VALUES(64,1418,122,4);
INSERT INTO INTERPRETE VALUES(44,3336,302,1);
INSERT INTO INTERPRETE VALUES(44,3336,349,4);
INSERT INTO INTERPRETE VALUES(52,2251,207,4);
INSERT INTO INTERPRETE VALUES(45,2633,242,4);
INSERT INTO INTERPRETE VALUES(87,2043,186,4);
INSERT INTO INTERPRETE VALUES(153,5039,427,4);
INSERT INTO INTERPRETE VALUES(191,6552,541,4);
INSERT INTO INTERPRETE VALUES(56,1272,106,2);
INSERT INTO INTERPRETE VALUES(141,1272,348,4);
INSERT INTO INTERPRETE VALUES(94,2192,201,4);
INSERT INTO INTERPRETE VALUES(216,7321,600,11);
INSERT INTO INTERPRETE VALUES(59,1308,110,2);
INSERT INTO INTERPRETE VALUES(61,1461,128,2);
INSERT INTO INTERPRETE VALUES(42,1938,176,4);
INSERT INTO INTERPRETE VALUES(93,2162,198,2);
INSERT INTO INTERPRETE VALUES(93,2219,204,1);
INSERT INTO INTERPRETE VALUES(93,2221,204,3);
INSERT INTO INTERPRETE VALUES(66,2239,206,1);
INSERT INTO INTERPRETE VALUES(66,2245,206,7);
INSERT INTO INTERPRETE VALUES(61,2268,209,2);
INSERT INTO INTERPRETE VALUES(93,2857,262,2);
INSERT INTO INTERPRETE VALUES(128,3285,297,14);
INSERT INTO INTERPRETE VALUES(66,3403,307,5);
INSERT INTO INTERPRETE VALUES(66,3404,307,6);
INSERT INTO INTERPRETE VALUES(66,4229,367,11);
INSERT INTO INTERPRETE VALUES(61,2268,387,5);
INSERT INTO INTERPRETE VALUES(61,4533,387,15);
INSERT INTO INTERPRETE VALUES(95,2367,405,13);
INSERT INTO INTERPRETE VALUES(143,4794,406,5);
INSERT INTO INTERPRETE VALUES(143,4801,412,4);
INSERT INTO INTERPRETE VALUES(143,4855,412,7);
INSERT INTO INTERPRETE VALUES(143,4898,416,4);
INSERT INTO INTERPRETE VALUES(143,4855,420,18);
INSERT INTO INTERPRETE VALUES(143,4976,422,6);
INSERT INTO INTERPRETE VALUES(143,4979,422,9);
INSERT INTO INTERPRETE VALUES(143,4981,422,11);
INSERT INTO INTERPRETE VALUES(160,5396,453,6);
INSERT INTO INTERPRETE VALUES(176,5777,483,8);
INSERT INTO INTERPRETE VALUES(176,5780,483,11);
INSERT INTO INTERPRETE VALUES(176,5828,488,1);
INSERT INTO INTERPRETE VALUES(176,5964,499,4);
INSERT INTO INTERPRETE VALUES(176,5968,499,8);
INSERT INTO INTERPRETE VALUES(176,5970,499,10);
INSERT INTO INTERPRETE VALUES(176,5975,499,15);
INSERT INTO INTERPRETE VALUES(176,5976,499,16);
INSERT INTO INTERPRETE VALUES(176,5964,509,5);
INSERT INTO INTERPRETE VALUES(176,5975,509,7);
INSERT INTO INTERPRETE VALUES(176,5970,509,9);
INSERT INTO INTERPRETE VALUES(196,6682,553,2);
INSERT INTO INTERPRETE VALUES(196,6980,576,7);
INSERT INTO INTERPRETE VALUES(196,7092,585,7);
INSERT INTO INTERPRETE VALUES(196,7095,585,10);
INSERT INTO INTERPRETE VALUES(216,7312,600,2);
INSERT INTO INTERPRETE VALUES(216,7314,600,4);
INSERT INTO INTERPRETE VALUES(216,7324,600,14);
INSERT INTO INTERPRETE VALUES(216,7326,601,2);
INSERT INTO INTERPRETE VALUES(216,7331,601,7);
INSERT INTO INTERPRETE VALUES(196,7089,603,6);
INSERT INTO INTERPRETE VALUES(196,7358,603,9);
INSERT INTO INTERPRETE VALUES(196,7360,603,11);
INSERT INTO INTERPRETE VALUES(196,6976,603,12);
INSERT INTO INTERPRETE VALUES(196,6739,607,2);
INSERT INTO INTERPRETE VALUES(196,7358,607,4);
INSERT INTO INTERPRETE VALUES(196,7416,607,12);
INSERT INTO INTERPRETE VALUES(207,7465,612,2);
INSERT INTO INTERPRETE VALUES(230,7656,628,1);
INSERT INTO INTERPRETE VALUES(230,7656,667,16);
INSERT INTO INTERPRETE VALUES(160,1308,684,3);
INSERT INTO INTERPRETE VALUES(160,5396,684,6);
INSERT INTO INTERPRETE VALUES(257,8518,688,18);
INSERT INTO INTERPRETE VALUES(216,8536,689,14);
INSERT INTO INTERPRETE VALUES(216,8538,689,16);
INSERT INTO INTERPRETE VALUES(216,8530,689,8);
INSERT INTO INTERPRETE VALUES(216,8535,689,13);
INSERT INTO INTERPRETE VALUES(216,6784,689,17);
INSERT INTO INTERPRETE VALUES(216,8540,689,18);
INSERT INTO INTERPRETE VALUES(194,8960,716,1);
INSERT INTO INTERPRETE VALUES(194,8962,716,3);
INSERT INTO INTERPRETE VALUES(194,8972,716,13);
INSERT INTO INTERPRETE VALUES(216,8993,719,3);
INSERT INTO INTERPRETE VALUES(216,9002,719,12);
INSERT INTO INTERPRETE VALUES(216,9003,719,13);
INSERT INTO INTERPRETE VALUES(216,8999,719,9);
INSERT INTO INTERPRETE VALUES(216,9018,721,4);
INSERT INTO INTERPRETE VALUES(216,9019,721,5);
INSERT INTO INTERPRETE VALUES(216,9021,721,7);
INSERT INTO INTERPRETE VALUES(216,9019,721,13);
INSERT INTO INTERPRETE VALUES(216,9055,724,2);
INSERT INTO INTERPRETE VALUES(216,8530,724,5);
INSERT INTO INTERPRETE VALUES(216,8532,724,7);
INSERT INTO INTERPRETE VALUES(216,9070,724,17);
INSERT INTO INTERPRETE VALUES(216,8536,726,2);
INSERT INTO INTERPRETE VALUES(216,8538,726,4);
INSERT INTO INTERPRETE VALUES(216,6784,726,5);
INSERT INTO INTERPRETE VALUES(216,8540,726,6);
INSERT INTO INTERPRETE VALUES(216,9091,726,9);
INSERT INTO INTERPRETE VALUES(216,9108,728,1);
INSERT INTO INTERPRETE VALUES(216,9110,728,3);
INSERT INTO INTERPRETE VALUES(216,9113,728,6);
INSERT INTO INTERPRETE VALUES(216,9116,728,9);
INSERT INTO INTERPRETE VALUES(216,9117,728,10);
INSERT INTO INTERPRETE VALUES(216,9002,728,13);
INSERT INTO INTERPRETE VALUES(216,9217,738,1);
INSERT INTO INTERPRETE VALUES(216,9232,738,16);
INSERT INTO INTERPRETE VALUES(216,9247,740,4);
INSERT INTO INTERPRETE VALUES(216,9248,740,5);
INSERT INTO INTERPRETE VALUES(216,9250,740,7);
INSERT INTO INTERPRETE VALUES(216,9251,740,8);
INSERT INTO INTERPRETE VALUES(216,9253,740,10);
INSERT INTO INTERPRETE VALUES(216,9248,743,2);
INSERT INTO INTERPRETE VALUES(216,9247,743,3);
INSERT INTO INTERPRETE VALUES(216,9250,743,4);
INSERT INTO INTERPRETE VALUES(216,9251,743,5);
INSERT INTO INTERPRETE VALUES(216,9252,743,6);
INSERT INTO INTERPRETE VALUES(216,9253,743,7);
INSERT INTO INTERPRETE VALUES(216,9437,753,1);
INSERT INTO INTERPRETE VALUES(216,9439,753,3);
INSERT INTO INTERPRETE VALUES(216,9440,753,4);
INSERT INTO INTERPRETE VALUES(216,9441,753,5);
INSERT INTO INTERPRETE VALUES(216,9442,753,6);
INSERT INTO INTERPRETE VALUES(216,9558,760,8);
INSERT INTO INTERPRETE VALUES(216,9562,760,12);
INSERT INTO INTERPRETE VALUES(160,1308,764,3);
INSERT INTO INTERPRETE VALUES(143,8993,783,3);
INSERT INTO INTERPRETE VALUES(143,9002,783,5);
INSERT INTO INTERPRETE VALUES(143,8997,783,4);
INSERT INTO INTERPRETE VALUES(143,9108,783,16);
INSERT INTO INTERPRETE VALUES(143,9113,783,18);
INSERT INTO INTERPRETE VALUES(143,7320,783,20);
INSERT INTO INTERPRETE VALUES(143,8535,783,14);
INSERT INTO INTERPRETE VALUES(143,7326,783,21);
INSERT INTO INTERPRETE VALUES(194,10892,846,1);
INSERT INTO INTERPRETE VALUES(194,10893,846,2);
INSERT INTO INTERPRETE VALUES(194,10897,846,6);
INSERT INTO INTERPRETE VALUES(194,10900,846,9);
INSERT INTO INTERPRETE VALUES(194,10901,846,10);
INSERT INTO INTERPRETE VALUES(194,10902,846,11);
INSERT INTO INTERPRETE VALUES(122,10959,852,1);
INSERT INTO INTERPRETE VALUES(122,10971,852,13);
INSERT INTO INTERPRETE VALUES(143,4827,418,1);
INSERT INTO INTERPRETE VALUES(143,4827,409,8);
INSERT INTO INTERPRETE VALUES(52,3226,293,4);
INSERT INTO INTERPRETE VALUES(48,1115,94,4);
INSERT INTO INTERPRETE VALUES(44,4212,366,8);
INSERT INTO INTERPRETE VALUES(106,3677,328,4);
INSERT INTO INTERPRETE VALUES(57,10484,819,9);
INSERT INTO INTERPRETE VALUES(52,4493,385,9);
INSERT INTO INTERPRETE VALUES(52,4499,385,15);
INSERT INTO INTERPRETE VALUES(52,4493,390,4);
INSERT INTO INTERPRETE VALUES(52,4493,390,12);
INSERT INTO INTERPRETE VALUES(11,2646,243,5);
INSERT INTO INTERPRETE VALUES(8,10841,841,18);
INSERT INTO INTERPRETE VALUES(8,4414,841,1);
INSERT INTO INTERPRETE VALUES(52,4414,380,5);
INSERT INTO INTERPRETE VALUES(44,4213,366,9);
INSERT INTO INTERPRETE VALUES(52,4310,373,5);
INSERT INTO INTERPRETE VALUES(143,4908,417,1);
INSERT INTO INTERPRETE VALUES(143,4840,411,3);
INSERT INTO INTERPRETE VALUES(143,4806,411,2);
INSERT INTO INTERPRETE VALUES(143,4806,409,6);
INSERT INTO INTERPRETE VALUES(143,4840,410,10);
INSERT INTO INTERPRETE VALUES(143,4802,411,4);
INSERT INTO INTERPRETE VALUES(143,4802,407,3);
INSERT INTO INTERPRETE VALUES(143,4807,411,5);
INSERT INTO INTERPRETE VALUES(143,4807,407,8);
INSERT INTO INTERPRETE VALUES(143,4843,411,6);
INSERT INTO INTERPRETE VALUES(143,4834,411,7);
INSERT INTO INTERPRETE VALUES(143,4834,410,7);
INSERT INTO INTERPRETE VALUES(143,4804,411,8);
INSERT INTO INTERPRETE VALUES(143,4804,407,5);
INSERT INTO INTERPRETE VALUES(143,4830,411,9);
INSERT INTO INTERPRETE VALUES(143,4830,410,3);
INSERT INTO INTERPRETE VALUES(143,4800,411,10);
INSERT INTO INTERPRETE VALUES(143,4800,407,1);
INSERT INTO INTERPRETE VALUES(143,4821,409,2);
INSERT INTO INTERPRETE VALUES(143,4823,409,4);
INSERT INTO INTERPRETE VALUES(143,4822,418,12);
INSERT INTO INTERPRETE VALUES(143,4821,418,2);
INSERT INTO INTERPRETE VALUES(143,4823,418,3);
INSERT INTO INTERPRETE VALUES(143,4820,418,4);
INSERT INTO INTERPRETE VALUES(143,4820,409,1);
INSERT INTO INTERPRETE VALUES(143,4826,418,5);
INSERT INTO INTERPRETE VALUES(143,4826,409,7);
INSERT INTO INTERPRETE VALUES(143,4925,418,6);
INSERT INTO INTERPRETE VALUES(143,4926,418,7);
INSERT INTO INTERPRETE VALUES(143,4809,418,8);
INSERT INTO INTERPRETE VALUES(143,4809,408,1);
INSERT INTO INTERPRETE VALUES(143,4817,418,9);
INSERT INTO INTERPRETE VALUES(143,4817,408,9);
INSERT INTO INTERPRETE VALUES(143,4797,410,5);
INSERT INTO INTERPRETE VALUES(143,4930,418,11);
INSERT INTO INTERPRETE VALUES(143,4812,408,4);
INSERT INTO INTERPRETE VALUES(78,1803,163,8);
INSERT INTO INTERPRETE VALUES(170,5611,470,12);
INSERT INTO INTERPRETE VALUES(170,5608,470,9);
INSERT INTO INTERPRETE VALUES(170,5603,470,4);
INSERT INTO INTERPRETE VALUES(170,5606,470,7);
INSERT INTO INTERPRETE VALUES(170,5607,470,8);
INSERT INTO INTERPRETE VALUES(170,5610,470,11);
INSERT INTO INTERPRETE VALUES(170,5600,470,1);
INSERT INTO INTERPRETE VALUES(170,5601,470,2);
INSERT INTO INTERPRETE VALUES(52,2736,251,5);
INSERT INTO INTERPRETE VALUES(57,3303,299,6);
INSERT INTO INTERPRETE VALUES(64,1419,122,5);
INSERT INTO INTERPRETE VALUES(67,2838,260,5);
INSERT INTO INTERPRETE VALUES(143,4934,419,3);
INSERT INTO INTERPRETE VALUES(143,4818,419,4);
INSERT INTO INTERPRETE VALUES(143,4818,408,10);
INSERT INTO INTERPRETE VALUES(143,4937,408,5);
INSERT INTO INTERPRETE VALUES(143,4939,419,8);
INSERT INTO INTERPRETE VALUES(143,4940,419,9);
INSERT INTO INTERPRETE VALUES(143,4815,408,7);
INSERT INTO INTERPRETE VALUES(143,4848,411,11);
INSERT INTO INTERPRETE VALUES(143,4848,410,8);
INSERT INTO INTERPRETE VALUES(143,4810,408,2);
INSERT INTO INTERPRETE VALUES(143,4962,421,2);
INSERT INTO INTERPRETE VALUES(143,4963,421,3);
INSERT INTO INTERPRETE VALUES(143,4824,421,4);
INSERT INTO INTERPRETE VALUES(143,4824,409,5);
INSERT INTO INTERPRETE VALUES(143,4965,421,5);
INSERT INTO INTERPRETE VALUES(143,4966,421,6);
INSERT INTO INTERPRETE VALUES(143,4968,421,8);
INSERT INTO INTERPRETE VALUES(143,4969,421,9);
INSERT INTO INTERPRETE VALUES(208,6920,572,1);
INSERT INTO INTERPRETE VALUES(208,6920,634,3);
INSERT INTO INTERPRETE VALUES(143,4872,414,2);
INSERT INTO INTERPRETE VALUES(208,6922,572,3);
INSERT INTO INTERPRETE VALUES(208,6930,572,11);
INSERT INTO INTERPRETE VALUES(208,6930,633,10);
INSERT INTO INTERPRETE VALUES(208,6932,572,13);
INSERT INTO INTERPRETE VALUES(208,6924,572,5);
INSERT INTO INTERPRETE VALUES(208,6925,634,6);
INSERT INTO INTERPRETE VALUES(208,7132,588,3);
INSERT INTO INTERPRETE VALUES(208,7136,639,4);
INSERT INTO INTERPRETE VALUES(208,7140,588,11);
INSERT INTO INTERPRETE VALUES(208,7142,588,13);
INSERT INTO INTERPRETE VALUES(208,7813,639,6);
INSERT INTO INTERPRETE VALUES(208,7815,639,8);
INSERT INTO INTERPRETE VALUES(208,7724,633,6);
INSERT INTO INTERPRETE VALUES(50,2987,273,5);
INSERT INTO INTERPRETE VALUES(208,7143,588,14);
INSERT INTO INTERPRETE VALUES(52,4151,396,17);
INSERT INTO INTERPRETE VALUES(44,1576,140,1);
INSERT INTO INTERPRETE VALUES(44,1576,226,5);
INSERT INTO INTERPRETE VALUES(62,1396,119,5);
INSERT INTO INTERPRETE VALUES(44,2475,228,5);
INSERT INTO INTERPRETE VALUES(65,2184,200,5);
INSERT INTO INTERPRETE VALUES(52,4489,396,18);
INSERT INTO INTERPRETE VALUES(211,7044,581,11);
INSERT INTO INTERPRETE VALUES(222,7044,614,11);
INSERT INTO INTERPRETE VALUES(230,7660,628,5);
INSERT INTO INTERPRETE VALUES(230,7044,667,2);
INSERT INTO INTERPRETE VALUES(4,2316,213,5);
INSERT INTO INTERPRETE VALUES(153,5053,428,5);
INSERT INTO INTERPRETE VALUES(52,4034,354,5);
INSERT INTO INTERPRETE VALUES(52,4042,354,13);
INSERT INTO INTERPRETE VALUES(48,1116,94,5);
INSERT INTO INTERPRETE VALUES(48,1116,433,7);
INSERT INTO INTERPRETE VALUES(44,1563,374,8);
INSERT INTO INTERPRETE VALUES(44,1563,138,5);
INSERT INTO INTERPRETE VALUES(44,1563,366,14);
INSERT INTO INTERPRETE VALUES(44,3963,349,6);
INSERT INTO INTERPRETE VALUES(140,3916,346,5);
INSERT INTO INTERPRETE VALUES(50,1761,159,5);
INSERT INTO INTERPRETE VALUES(44,2729,250,10);
INSERT INTO INTERPRETE VALUES(226,8026,654,5);
INSERT INTO INTERPRETE VALUES(56,3575,320,8);
INSERT INTO INTERPRETE VALUES(44,3968,349,11);
INSERT INTO INTERPRETE VALUES(67,1779,161,5);
INSERT INTO INTERPRETE VALUES(44,2458,391,5);
INSERT INTO INTERPRETE VALUES(44,2458,226,7);
INSERT INTO INTERPRETE VALUES(44,2458,266,3);
INSERT INTO INTERPRETE VALUES(44,5881,493,5);
INSERT INTO INTERPRETE VALUES(44,1567,138,9);
INSERT INTO INTERPRETE VALUES(44,2461,226,10);
INSERT INTO INTERPRETE VALUES(44,2461,377,7);
INSERT INTO INTERPRETE VALUES(44,2461,266,1);
INSERT INTO INTERPRETE VALUES(44,2461,464,4);
INSERT INTO INTERPRETE VALUES(52,1907,173,1);
INSERT INTO INTERPRETE VALUES(87,2050,186,11);
INSERT INTO INTERPRETE VALUES(56,3581,320,14);
INSERT INTO INTERPRETE VALUES(52,3633,324,14);
INSERT INTO INTERPRETE VALUES(103,2450,225,10);
INSERT INTO INTERPRETE VALUES(78,1815,163,20);
INSERT INTO INTERPRETE VALUES(78,3512,315,14);
INSERT INTO INTERPRETE VALUES(176,5900,494,5);
INSERT INTO INTERPRETE VALUES(109,3200,520,12);
INSERT INTO INTERPRETE VALUES(44,3200,291,1);
INSERT INTO INTERPRETE VALUES(8,10829,841,6);
INSERT INTO INTERPRETE VALUES(45,1099,93,8);
INSERT INTO INTERPRETE VALUES(44,3202,291,3);
INSERT INTO INTERPRETE VALUES(83,10515,821,13);
INSERT INTO INTERPRETE VALUES(52,3548,318,8);
INSERT INTO INTERPRETE VALUES(52,3548,380,9);
INSERT INTO INTERPRETE VALUES(44,4324,374,5);
INSERT INTO INTERPRETE VALUES(83,6340,526,6);
INSERT INTO INTERPRETE VALUES(56,2060,187,9);
INSERT INTO INTERPRETE VALUES(126,3167,288,4);
INSERT INTO INTERPRETE VALUES(52,3786,336,6);
INSERT INTO INTERPRETE VALUES(52,3786,396,6);
INSERT INTO INTERPRETE VALUES(67,1605,143,5);
INSERT INTO INTERPRETE VALUES(67,1605,371,14);
INSERT INTO INTERPRETE VALUES(4,1502,133,5);
INSERT INTO INTERPRETE VALUES(44,5883,493,7);
INSERT INTO INTERPRETE VALUES(44,2257,208,1);
INSERT INTO INTERPRETE VALUES(52,1915,173,9);
INSERT INTO INTERPRETE VALUES(52,6070,507,5);
INSERT INTO INTERPRETE VALUES(52,3709,330,9);
INSERT INTO INTERPRETE VALUES(52,1908,173,2);
INSERT INTO INTERPRETE VALUES(52,1908,506,7);
INSERT INTO INTERPRETE VALUES(44,5660,475,1);
INSERT INTO INTERPRETE VALUES(52,4150,362,4);
INSERT INTO INTERPRETE VALUES(52,3552,318,12);
INSERT INTO INTERPRETE VALUES(52,3552,385,3);
INSERT INTO INTERPRETE VALUES(52,3552,506,3);
INSERT INTO INTERPRETE VALUES(52,3552,390,9);
INSERT INTO INTERPRETE VALUES(44,2478,228,8);
INSERT INTO INTERPRETE VALUES(52,3781,336,1);
INSERT INTO INTERPRETE VALUES(52,3781,373,11);
INSERT INTO INTERPRETE VALUES(52,3781,390,14);
INSERT INTO INTERPRETE VALUES(44,2453,226,2);
INSERT INTO INTERPRETE VALUES(44,2453,266,7);
INSERT INTO INTERPRETE VALUES(44,2453,464,8);
INSERT INTO INTERPRETE VALUES(44,5882,493,6);
INSERT INTO INTERPRETE VALUES(52,1910,173,4);
INSERT INTO INTERPRETE VALUES(52,1910,373,12);
INSERT INTO INTERPRETE VALUES(52,1196,99,4);
INSERT INTO INTERPRETE VALUES(44,2205,202,6);
INSERT INTO INTERPRETE VALUES(44,5890,493,14);
INSERT INTO INTERPRETE VALUES(71,1860,168,3);
INSERT INTO INTERPRETE VALUES(52,4485,385,1);
INSERT INTO INTERPRETE VALUES(52,4485,390,7);
INSERT INTO INTERPRETE VALUES(71,1861,168,4);
INSERT INTO INTERPRETE VALUES(52,4492,385,8);
INSERT INTO INTERPRETE VALUES(52,4313,373,8);
INSERT INTO INTERPRETE VALUES(52,1916,173,10);
INSERT INTO INTERPRETE VALUES(69,1209,135,18);
INSERT INTO INTERPRETE VALUES(53,1209,100,13);
INSERT INTO INTERPRETE VALUES(44,10985,136,7);
INSERT INTO INTERPRETE VALUES(44,10985,377,14);
INSERT INTO INTERPRETE VALUES(44,10985,266,10);
INSERT INTO INTERPRETE VALUES(44,5879,493,3);
INSERT INTO INTERPRETE VALUES(44,2954,270,7);
INSERT INTO INTERPRETE VALUES(44,2954,377,5);
INSERT INTO INTERPRETE VALUES(52,3710,507,3);
INSERT INTO INTERPRETE VALUES(52,3710,330,10);
INSERT INTO INTERPRETE VALUES(52,1911,173,5);
INSERT INTO INTERPRETE VALUES(52,1911,380,13);
INSERT INTO INTERPRETE VALUES(52,3547,318,7);
INSERT INTO INTERPRETE VALUES(67,1604,143,4);
INSERT INTO INTERPRETE VALUES(3,191,18,3);
INSERT INTO INTERPRETE VALUES(67,1604,371,15);
INSERT INTO INTERPRETE VALUES(44,2906,377,4);
INSERT INTO INTERPRETE VALUES(44,2906,266,6);
INSERT INTO INTERPRETE VALUES(52,3541,318,1);
INSERT INTO INTERPRETE VALUES(52,3541,396,9);
INSERT INTO INTERPRETE VALUES(52,4147,362,1);
INSERT INTO INTERPRETE VALUES(52,4147,506,5);
INSERT INTO INTERPRETE VALUES(52,4147,390,15);
INSERT INTO INTERPRETE VALUES(52,2739,251,8);
INSERT INTO INTERPRETE VALUES(52,4157,362,11);
INSERT INTO INTERPRETE VALUES(52,4161,362,15);
INSERT INTO INTERPRETE VALUES(44,1977,180,1);
INSERT INTO INTERPRETE VALUES(4,2077,189,5);
INSERT INTO INTERPRETE VALUES(63,1442,125,3);
INSERT INTO INTERPRETE VALUES(216,8997,719,7);
INSERT INTO INTERPRETE VALUES(216,9023,721,9);
INSERT INTO INTERPRETE VALUES(216,9016,721,15);
INSERT INTO INTERPRETE VALUES(216,9026,721,19);
INSERT INTO INTERPRETE VALUES(216,8523,689,1);
INSERT INTO INTERPRETE VALUES(216,8523,724,4);
INSERT INTO INTERPRETE VALUES(216,9069,724,16);
INSERT INTO INTERPRETE VALUES(216,9072,724,19);
INSERT INTO INTERPRETE VALUES(216,7311,600,1);
INSERT INTO INTERPRETE VALUES(216,9115,728,8);
INSERT INTO INTERPRETE VALUES(216,8999,728,11);
INSERT INTO INTERPRETE VALUES(216,7319,600,9);
INSERT INTO INTERPRETE VALUES(216,7332,601,8);
INSERT INTO INTERPRETE VALUES(216,7335,601,11);
INSERT INTO INTERPRETE VALUES(216,9303,743,10);
INSERT INTO INTERPRETE VALUES(274,9709,769,14);
INSERT INTO INTERPRETE VALUES(262,9023,747,5);
INSERT INTO INTERPRETE VALUES(208,7134,588,5);
INSERT INTO INTERPRETE VALUES(208,7137,588,8);
INSERT INTO INTERPRETE VALUES(208,6921,572,2);
INSERT INTO INTERPRETE VALUES(208,7299,599,2);
INSERT INTO INTERPRETE VALUES(208,7299,634,5);
INSERT INTO INTERPRETE VALUES(208,7810,639,3);
INSERT INTO INTERPRETE VALUES(143,4890,415,8);
INSERT INTO INTERPRETE VALUES(143,4803,411,1);
INSERT INTO INTERPRETE VALUES(143,4806,407,7);
INSERT INTO INTERPRETE VALUES(143,4819,421,1);
INSERT INTO INTERPRETE VALUES(143,4970,421,10);
INSERT INTO INTERPRETE VALUES(143,4816,419,2);
INSERT INTO INTERPRETE VALUES(143,4815,419,7);
INSERT INTO INTERPRETE VALUES(143,4810,419,11);
INSERT INTO INTERPRETE VALUES(143,4812,418,10);
INSERT INTO INTERPRETE VALUES(143,4816,408,8);
INSERT INTO INTERPRETE VALUES(143,8999,783,2);
INSERT INTO INTERPRETE VALUES(143,8530,783,11);
INSERT INTO INTERPRETE VALUES(77,2536,234,4);
INSERT INTO INTERPRETE VALUES(216,8541,689,19);
INSERT INTO INTERPRETE VALUES(143,4905,416,11);
INSERT INTO INTERPRETE VALUES(286,10984,854,13);
INSERT INTO INTERPRETE VALUES(286,10981,854,10);
INSERT INTO INTERPRETE VALUES(286,10972,854,1);
INSERT INTO INTERPRETE VALUES(286,10973,854,2);
INSERT INTO INTERPRETE VALUES(286,10974,854,3);
INSERT INTO INTERPRETE VALUES(286,10977,854,6);
INSERT INTO INTERPRETE VALUES(286,10979,854,8);
INSERT INTO INTERPRETE VALUES(286,10980,854,9);
INSERT INTO INTERPRETE VALUES(286,10982,854,11);
INSERT INTO INTERPRETE VALUES(286,10975,854,4);
INSERT INTO INTERPRETE VALUES(286,10976,854,5);
INSERT INTO INTERPRETE VALUES(286,10978,854,7);
INSERT INTO INTERPRETE VALUES(286,10983,854,12);
INSERT INTO INTERPRETE VALUES(71,2405,221,8);
INSERT INTO INTERPRETE VALUES(4,5285,445,7);
INSERT INTO INTERPRETE VALUES(4,1839,166,2);
INSERT INTO INTERPRETE VALUES(71,2407,221,10);
INSERT INTO INTERPRETE VALUES(67,1783,161,9);
INSERT INTO INTERPRETE VALUES(52,1914,173,8);
INSERT INTO INTERPRETE VALUES(44,5877,493,1);
INSERT INTO INTERPRETE VALUES(70,4078,357,8);
INSERT INTO INTERPRETE VALUES(52,4495,385,11);
INSERT INTO INTERPRETE VALUES(52,4495,507,6);
INSERT INTO INTERPRETE VALUES(52,4495,390,19);
INSERT INTO INTERPRETE VALUES(67,1449,126,4);
INSERT INTO INTERPRETE VALUES(71,9972,789,1);
INSERT INTO INTERPRETE VALUES(71,5856,490,7);
INSERT INTO INTERPRETE VALUES(52,6064,506,10);
INSERT INTO INTERPRETE VALUES(52,6064,330,7);
INSERT INTO INTERPRETE VALUES(71,5851,490,2);
INSERT INTO INTERPRETE VALUES(71,5852,490,3);
INSERT INTO INTERPRETE VALUES(71,5850,490,1);
INSERT INTO INTERPRETE VALUES(67,1601,371,11);
INSERT INTO INTERPRETE VALUES(4,1505,133,8);
INSERT INTO INTERPRETE VALUES(71,1927,175,2);
INSERT INTO INTERPRETE VALUES(52,4156,362,10);
INSERT INTO INTERPRETE VALUES(52,4156,390,5);
INSERT INTO INTERPRETE VALUES(44,1248,202,1);
INSERT INTO INTERPRETE VALUES(44,1248,136,6);
INSERT INTO INTERPRETE VALUES(44,1248,266,8);
INSERT INTO INTERPRETE VALUES(44,1248,464,1);
INSERT INTO INTERPRETE VALUES(44,5895,493,19);
INSERT INTO INTERPRETE VALUES(52,3545,318,5);
INSERT INTO INTERPRETE VALUES(4,1847,166,10);
INSERT INTO INTERPRETE VALUES(71,1934,175,9);
INSERT INTO INTERPRETE VALUES(140,1587,379,2);
INSERT INTO INTERPRETE VALUES(52,4488,390,13);
INSERT INTO INTERPRETE VALUES(70,1587,141,4);
INSERT INTO INTERPRETE VALUES(65,2181,200,2);
INSERT INTO INTERPRETE VALUES(52,1273,390,8);
INSERT INTO INTERPRETE VALUES(56,1273,106,3);
INSERT INTO INTERPRETE VALUES(141,1273,348,7);
INSERT INTO INTERPRETE VALUES(109,2202,580,11);
INSERT INTO INTERPRETE VALUES(44,2202,202,3);
INSERT INTO INTERPRETE VALUES(44,2202,374,7);
INSERT INTO INTERPRETE VALUES(52,1276,107,1);
INSERT INTO INTERPRETE VALUES(52,1276,842,6);
INSERT INTO INTERPRETE VALUES(52,4494,385,10);
INSERT INTO INTERPRETE VALUES(52,4494,506,6);
INSERT INTO INTERPRETE VALUES(52,4494,390,11);
INSERT INTO INTERPRETE VALUES(44,2262,208,6);
INSERT INTO INTERPRETE VALUES(44,5664,475,5);
INSERT INTO INTERPRETE VALUES(71,5802,485,4);
INSERT INTO INTERPRETE VALUES(44,1579,140,4);
INSERT INTO INTERPRETE VALUES(44,1579,349,5);
INSERT INTO INTERPRETE VALUES(71,5814,486,3);
INSERT INTO INTERPRETE VALUES(52,4153,362,7);
INSERT INTO INTERPRETE VALUES(44,4196,365,7);
INSERT INTO INTERPRETE VALUES(78,2101,191,9);
INSERT INTO INTERPRETE VALUES(45,1042,90,8);
INSERT INTO INTERPRETE VALUES(78,1808,163,13);
INSERT INTO INTERPRETE VALUES(155,5097,431,7);
INSERT INTO INTERPRETE VALUES(155,5098,431,8);
INSERT INTO INTERPRETE VALUES(155,5096,431,6);
INSERT INTO INTERPRETE VALUES(155,5103,431,13);
INSERT INTO INTERPRETE VALUES(155,5093,431,3);
INSERT INTO INTERPRETE VALUES(155,5095,431,5);
INSERT INTO INTERPRETE VALUES(155,5100,431,10);
INSERT INTO INTERPRETE VALUES(155,5101,431,11);
INSERT INTO INTERPRETE VALUES(155,5102,431,12);
INSERT INTO INTERPRETE VALUES(155,5104,431,14);
INSERT INTO INTERPRETE VALUES(155,5106,431,16);
INSERT INTO INTERPRETE VALUES(155,5107,431,17);
INSERT INTO INTERPRETE VALUES(155,5108,431,18);
INSERT INTO INTERPRETE VALUES(155,1663,431,19);
INSERT INTO INTERPRETE VALUES(155,5111,431,21);
INSERT INTO INTERPRETE VALUES(140,3918,346,7);
INSERT INTO INTERPRETE VALUES(106,3680,328,7);
INSERT INTO INTERPRETE VALUES(196,6688,553,8);
INSERT INTO INTERPRETE VALUES(88,2070,188,8);
INSERT INTO INTERPRETE VALUES(50,3356,303,8);
INSERT INTO INTERPRETE VALUES(52,2255,207,8);
INSERT INTO INTERPRETE VALUES(52,2255,380,14);
INSERT INTO INTERPRETE VALUES(11,2308,212,8);
INSERT INTO INTERPRETE VALUES(118,3006,274,12);
INSERT INTO INTERPRETE VALUES(127,3244,294,10);
INSERT INTO INTERPRETE VALUES(56,2054,187,3);
INSERT INTO INTERPRETE VALUES(69,1534,135,21);
INSERT INTO INTERPRETE VALUES(44,4210,366,6);
INSERT INTO INTERPRETE VALUES(49,6223,517,7);
INSERT INTO INTERPRETE VALUES(97,2332,214,11);
INSERT INTO INTERPRETE VALUES(84,2005,182,7);
INSERT INTO INTERPRETE VALUES(47,2977,272,7);
INSERT INTO INTERPRETE VALUES(153,5043,427,8);
INSERT INTO INTERPRETE VALUES(4,1503,133,6);
INSERT INTO INTERPRETE VALUES(71,9975,789,4);
INSERT INTO INTERPRETE VALUES(56,2055,187,4);
INSERT INTO INTERPRETE VALUES(44,2207,202,8);
INSERT INTO INTERPRETE VALUES(44,2207,349,9);
INSERT INTO INTERPRETE VALUES(4,1966,179,1);
INSERT INTO INTERPRETE VALUES(4,31,4,1);
INSERT INTO INTERPRETE VALUES(88,2818,258,8);
INSERT INTO INTERPRETE VALUES(157,5148,434,8);
INSERT INTO INTERPRETE VALUES(76,1718,155,8);
INSERT INTO INTERPRETE VALUES(107,2553,235,8);
INSERT INTO INTERPRETE VALUES(67,1558,137,9);
INSERT INTO INTERPRETE VALUES(84,2218,203,9);
INSERT INTO INTERPRETE VALUES(44,2479,377,8);
INSERT INTO INTERPRETE VALUES(52,3789,336,9);
INSERT INTO INTERPRETE VALUES(4,2312,213,1);
INSERT INTO INTERPRETE VALUES(86,2673,245,9);
INSERT INTO INTERPRETE VALUES(213,7184,591,9);
INSERT INTO INTERPRETE VALUES(89,3134,285,7);
INSERT INTO INTERPRETE VALUES(89,2123,194,5);
INSERT INTO INTERPRETE VALUES(89,2120,194,2);
INSERT INTO INTERPRETE VALUES(56,3453,311,5);
INSERT INTO INTERPRETE VALUES(76,6990,577,5);
INSERT INTO INTERPRETE VALUES(45,1993,181,5);
INSERT INTO INTERPRETE VALUES(202,6849,565,5);
INSERT INTO INTERPRETE VALUES(57,3371,304,10);
INSERT INTO INTERPRETE VALUES(78,2098,191,6);
INSERT INTO INTERPRETE VALUES(49,1740,157,11);
INSERT INTO INTERPRETE VALUES(44,4216,366,12);
INSERT INTO INTERPRETE VALUES(44,4216,463,7);
INSERT INTO INTERPRETE VALUES(107,2554,235,9);
INSERT INTO INTERPRETE VALUES(99,2395,220,8);
INSERT INTO INTERPRETE VALUES(44,4208,366,4);
INSERT INTO INTERPRETE VALUES(44,4323,391,17);
INSERT INTO INTERPRETE VALUES(44,4323,374,4);
INSERT INTO INTERPRETE VALUES(44,1565,138,7);
INSERT INTO INTERPRETE VALUES(44,1984,180,8);
INSERT INTO INTERPRETE VALUES(44,1984,374,6);
INSERT INTO INTERPRETE VALUES(62,5872,492,4);
INSERT INTO INTERPRETE VALUES(94,2195,201,7);
INSERT INTO INTERPRETE VALUES(83,2195,489,4);
INSERT INTO INTERPRETE VALUES(44,4214,468,4);
INSERT INTO INTERPRETE VALUES(44,4214,366,10);
INSERT INTO INTERPRETE VALUES(44,5588,391,15);
INSERT INTO INTERPRETE VALUES(44,4594,391,9);
INSERT INTO INTERPRETE VALUES(69,11109,135,24);
INSERT INTO INTERPRETE VALUES(135,11111,317,11);
INSERT INTO INTERPRETE VALUES(44,2830,291,6);
INSERT INTO INTERPRETE VALUES(44,2723,250,4);
INSERT INTO INTERPRETE VALUES(44,2723,374,3);
INSERT INTO INTERPRETE VALUES(44,3208,291,9);
INSERT INTO INTERPRETE VALUES(129,3311,300,2);
INSERT INTO INTERPRETE VALUES(69,1535,135,22);
INSERT INTO INTERPRETE VALUES(44,4366,377,6);
INSERT INTO INTERPRETE VALUES(44,4597,391,12);
INSERT INTO INTERPRETE VALUES(44,5672,475,13);
INSERT INTO INTERPRETE VALUES(44,10985,855,1);
INSERT INTO INTERPRETE VALUES(44,4208,855,2);
INSERT INTO INTERPRETE VALUES(44,10988,855,4);
INSERT INTO INTERPRETE VALUES(44,10987,855,3);
INSERT INTO INTERPRETE VALUES(44,10989,855,5);
INSERT INTO INTERPRETE VALUES(44,1985,180,9);
INSERT INTO INTERPRETE VALUES(44,10991,855,7);
INSERT INTO INTERPRETE VALUES(44,10993,855,9);
INSERT INTO INTERPRETE VALUES(44,2458,855,11);
INSERT INTO INTERPRETE VALUES(44,1565,855,13);
INSERT INTO INTERPRETE VALUES(187,6501,537,12);
INSERT INTO INTERPRETE VALUES(44,1562,138,4);
INSERT INTO INTERPRETE VALUES(44,1562,349,10);
INSERT INTO INTERPRETE VALUES(44,11001,856,3);
INSERT INTO INTERPRETE VALUES(44,2909,856,4);
INSERT INTO INTERPRETE VALUES(44,1248,856,5);
INSERT INTO INTERPRETE VALUES(44,2731,856,6);
INSERT INTO INTERPRETE VALUES(44,1639,856,7);
INSERT INTO INTERPRETE VALUES(44,2902,856,8);
INSERT INTO INTERPRETE VALUES(44,2902,266,2);
INSERT INTO INTERPRETE VALUES(44,1984,856,9);
INSERT INTO INTERPRETE VALUES(49,1130,857,1);
INSERT INTO INTERPRETE VALUES(49,11010,857,2);
INSERT INTO INTERPRETE VALUES(49,1139,857,3);
INSERT INTO INTERPRETE VALUES(49,11012,857,4);
INSERT INTO INTERPRETE VALUES(49,11014,857,6);
INSERT INTO INTERPRETE VALUES(49,1145,857,7);
INSERT INTO INTERPRETE VALUES(49,11016,857,8);
INSERT INTO INTERPRETE VALUES(49,11017,857,9);
INSERT INTO INTERPRETE VALUES(49,1138,857,10);
INSERT INTO INTERPRETE VALUES(49,11019,857,11);
INSERT INTO INTERPRETE VALUES(49,11020,857,12);
INSERT INTO INTERPRETE VALUES(49,11021,857,13);
INSERT INTO INTERPRETE VALUES(165,11022,858,1);
INSERT INTO INTERPRETE VALUES(165,5377,858,2);
INSERT INTO INTERPRETE VALUES(165,11024,858,3);
INSERT INTO INTERPRETE VALUES(165,11026,858,5);
INSERT INTO INTERPRETE VALUES(165,1918,858,6);
INSERT INTO INTERPRETE VALUES(165,11028,858,7);
INSERT INTO INTERPRETE VALUES(165,11029,858,8);
INSERT INTO INTERPRETE VALUES(165,5386,858,9);
INSERT INTO INTERPRETE VALUES(165,11031,858,10);
INSERT INTO INTERPRETE VALUES(71,1633,146,8);
INSERT INTO INTERPRETE VALUES(44,1983,250,2);
INSERT INTO INTERPRETE VALUES(44,5888,493,12);
INSERT INTO INTERPRETE VALUES(44,2454,226,3);
INSERT INTO INTERPRETE VALUES(44,4202,365,13);
INSERT INTO INTERPRETE VALUES(44,5891,493,15);
INSERT INTO INTERPRETE VALUES(44,2937,269,1);
INSERT INTO INTERPRETE VALUES(194,6648,549,1);
INSERT INTO INTERPRETE VALUES(194,6649,549,2);
INSERT INTO INTERPRETE VALUES(194,6650,549,3);
INSERT INTO INTERPRETE VALUES(194,6651,549,4);
INSERT INTO INTERPRETE VALUES(194,6652,549,5);
INSERT INTO INTERPRETE VALUES(44,5670,475,11);
INSERT INTO INTERPRETE VALUES(194,6653,549,6);
INSERT INTO INTERPRETE VALUES(194,6654,549,7);
INSERT INTO INTERPRETE VALUES(194,6655,549,8);
INSERT INTO INTERPRETE VALUES(194,6657,549,10);
INSERT INTO INTERPRETE VALUES(194,6658,549,11);
INSERT INTO INTERPRETE VALUES(194,6659,549,12);
INSERT INTO INTERPRETE VALUES(44,5586,468,8);
INSERT INTO INTERPRETE VALUES(287,11033,859,2);
INSERT INTO INTERPRETE VALUES(287,11035,859,4);
INSERT INTO INTERPRETE VALUES(287,11037,859,6);
INSERT INTO INTERPRETE VALUES(287,11038,859,7);
INSERT INTO INTERPRETE VALUES(287,11040,859,9);
INSERT INTO INTERPRETE VALUES(287,11036,859,5);
INSERT INTO INTERPRETE VALUES(287,11039,859,8);
INSERT INTO INTERPRETE VALUES(287,11041,859,10);
INSERT INTO INTERPRETE VALUES(287,11042,859,11);
INSERT INTO INTERPRETE VALUES(291,11322,880,1);
INSERT INTO INTERPRETE VALUES(291,11323,880,2);
INSERT INTO INTERPRETE VALUES(291,11324,880,3);
INSERT INTO INTERPRETE VALUES(291,11325,880,4);
INSERT INTO INTERPRETE VALUES(291,11326,880,5);
INSERT INTO INTERPRETE VALUES(291,11327,880,6);
INSERT INTO INTERPRETE VALUES(291,11329,880,8);
INSERT INTO INTERPRETE VALUES(291,11330,880,9);
INSERT INTO INTERPRETE VALUES(291,11331,880,10);
INSERT INTO INTERPRETE VALUES(291,11332,880,11);
INSERT INTO INTERPRETE VALUES(291,11333,880,12);
INSERT INTO INTERPRETE VALUES(291,11334,880,13);
INSERT INTO INTERPRETE VALUES(291,11335,880,14);
INSERT INTO INTERPRETE VALUES(291,11328,880,7);
INSERT INTO INTERPRETE VALUES(292,11336,881,1);
INSERT INTO INTERPRETE VALUES(292,11337,881,2);
INSERT INTO INTERPRETE VALUES(292,11338,881,3);
INSERT INTO INTERPRETE VALUES(176,5785,509,16);
INSERT INTO INTERPRETE VALUES(292,11339,881,4);
INSERT INTO INTERPRETE VALUES(292,11340,881,5);
INSERT INTO INTERPRETE VALUES(292,11341,881,6);
INSERT INTO INTERPRETE VALUES(292,11342,881,7);
INSERT INTO INTERPRETE VALUES(292,11343,881,8);
INSERT INTO INTERPRETE VALUES(292,11344,881,9);
INSERT INTO INTERPRETE VALUES(292,11345,881,10);
INSERT INTO INTERPRETE VALUES(292,11346,881,11);
INSERT INTO INTERPRETE VALUES(292,11347,881,12);
INSERT INTO INTERPRETE VALUES(292,11348,881,13);
INSERT INTO INTERPRETE VALUES(292,11349,881,14);
INSERT INTO INTERPRETE VALUES(292,11350,881,15);
INSERT INTO INTERPRETE VALUES(292,11351,881,16);
INSERT INTO INTERPRETE VALUES(127,3242,294,8);
INSERT INTO INTERPRETE VALUES(50,1955,177,10);
INSERT INTO INTERPRETE VALUES(50,1948,177,3);
INSERT INTO INTERPRETE VALUES(57,3479,313,5);
INSERT INTO INTERPRETE VALUES(84,2211,203,2);
INSERT INTO INTERPRETE VALUES(84,2212,203,3);
INSERT INTO INTERPRETE VALUES(84,2215,203,6);
INSERT INTO INTERPRETE VALUES(212,7152,589,8);
INSERT INTO INTERPRETE VALUES(293,11352,882,1);
INSERT INTO INTERPRETE VALUES(293,11353,882,2);
INSERT INTO INTERPRETE VALUES(293,11354,882,3);
INSERT INTO INTERPRETE VALUES(293,11355,882,4);
INSERT INTO INTERPRETE VALUES(293,11356,882,5);
INSERT INTO INTERPRETE VALUES(293,11357,882,6);
INSERT INTO INTERPRETE VALUES(293,11358,882,7);
INSERT INTO INTERPRETE VALUES(293,11359,882,8);
INSERT INTO INTERPRETE VALUES(293,11360,882,9);
INSERT INTO INTERPRETE VALUES(293,11361,882,10);
INSERT INTO INTERPRETE VALUES(293,11362,882,11);
INSERT INTO INTERPRETE VALUES(4,11363,883,1);
INSERT INTO INTERPRETE VALUES(4,11364,883,2);
INSERT INTO INTERPRETE VALUES(4,11365,883,3);
INSERT INTO INTERPRETE VALUES(4,11366,883,4);
INSERT INTO INTERPRETE VALUES(4,11367,883,5);
INSERT INTO INTERPRETE VALUES(4,11368,883,6);
INSERT INTO INTERPRETE VALUES(4,11369,883,7);
INSERT INTO INTERPRETE VALUES(4,11370,883,8);
INSERT INTO INTERPRETE VALUES(4,11371,883,9);
INSERT INTO INTERPRETE VALUES(4,11372,883,10);
INSERT INTO INTERPRETE VALUES(4,11373,883,11);
INSERT INTO INTERPRETE VALUES(4,11374,883,12);
INSERT INTO INTERPRETE VALUES(4,11375,883,13);
INSERT INTO INTERPRETE VALUES(4,11376,883,14);
INSERT INTO INTERPRETE VALUES(4,11377,883,15);
INSERT INTO INTERPRETE VALUES(294,11378,884,1);
INSERT INTO INTERPRETE VALUES(294,11379,884,2);
INSERT INTO INTERPRETE VALUES(294,11380,884,3);
INSERT INTO INTERPRETE VALUES(294,11381,884,4);
INSERT INTO INTERPRETE VALUES(294,11382,884,5);
INSERT INTO INTERPRETE VALUES(294,11383,884,6);
INSERT INTO INTERPRETE VALUES(294,11384,884,7);
INSERT INTO INTERPRETE VALUES(294,11385,884,8);
INSERT INTO INTERPRETE VALUES(294,11386,884,9);
INSERT INTO INTERPRETE VALUES(294,11387,884,10);
INSERT INTO INTERPRETE VALUES(294,11388,884,11);
INSERT INTO INTERPRETE VALUES(3,11389,885,1);
INSERT INTO INTERPRETE VALUES(3,11390,885,2);
INSERT INTO INTERPRETE VALUES(3,11391,885,3);
INSERT INTO INTERPRETE VALUES(3,11392,885,4);
INSERT INTO INTERPRETE VALUES(3,11393,885,5);
INSERT INTO INTERPRETE VALUES(3,11394,885,6);
INSERT INTO INTERPRETE VALUES(3,11395,885,7);
INSERT INTO INTERPRETE VALUES(3,11396,885,8);
INSERT INTO INTERPRETE VALUES(3,11397,885,9);
INSERT INTO INTERPRETE VALUES(3,11398,885,10);
INSERT INTO INTERPRETE VALUES(126,11399,886,1);
INSERT INTO INTERPRETE VALUES(126,11400,886,2);
INSERT INTO INTERPRETE VALUES(126,11401,886,3);
INSERT INTO INTERPRETE VALUES(126,11402,886,4);
INSERT INTO INTERPRETE VALUES(126,11403,886,5);
INSERT INTO INTERPRETE VALUES(126,11404,886,6);
INSERT INTO INTERPRETE VALUES(126,11405,886,7);
INSERT INTO INTERPRETE VALUES(126,11406,886,8);
INSERT INTO INTERPRETE VALUES(126,11407,886,9);
INSERT INTO INTERPRETE VALUES(126,11408,886,10);
INSERT INTO INTERPRETE VALUES(126,11409,886,11);
INSERT INTO INTERPRETE VALUES(126,11410,886,12);
INSERT INTO INTERPRETE VALUES(126,11411,886,13);
INSERT INTO INTERPRETE VALUES(126,11412,886,14);
INSERT INTO INTERPRETE VALUES(295,11413,887,1);
INSERT INTO INTERPRETE VALUES(295,11414,887,2);
INSERT INTO INTERPRETE VALUES(295,11415,887,3);
INSERT INTO INTERPRETE VALUES(295,11416,887,4);
INSERT INTO INTERPRETE VALUES(295,11417,887,5);
INSERT INTO INTERPRETE VALUES(295,11418,887,6);
INSERT INTO INTERPRETE VALUES(295,11419,887,7);
INSERT INTO INTERPRETE VALUES(295,11420,887,8);
INSERT INTO INTERPRETE VALUES(295,11421,887,9);
INSERT INTO INTERPRETE VALUES(295,11422,887,10);
INSERT INTO INTERPRETE VALUES(295,11423,887,11);
INSERT INTO INTERPRETE VALUES(295,11424,887,12);
INSERT INTO INTERPRETE VALUES(295,11425,887,13);
INSERT INTO INTERPRETE VALUES(295,11426,887,14);
INSERT INTO INTERPRETE VALUES(295,11427,887,15);
INSERT INTO INTERPRETE VALUES(295,11428,887,16);
INSERT INTO INTERPRETE VALUES(295,11430,887,18);
INSERT INTO INTERPRETE VALUES(295,11431,887,19);
INSERT INTO INTERPRETE VALUES(295,11429,887,17);
INSERT INTO INTERPRETE VALUES(0,11432,888,1);
INSERT INTO INTERPRETE VALUES(0,11433,888,2);
INSERT INTO INTERPRETE VALUES(0,11434,888,3);
INSERT INTO INTERPRETE VALUES(0,11435,888,4);
INSERT INTO INTERPRETE VALUES(0,11436,888,5);
INSERT INTO INTERPRETE VALUES(0,11437,888,6);
INSERT INTO INTERPRETE VALUES(0,11438,888,7);
INSERT INTO INTERPRETE VALUES(0,11439,888,8);
INSERT INTO INTERPRETE VALUES(0,11440,888,9);
INSERT INTO INTERPRETE VALUES(0,11441,888,10);
INSERT INTO INTERPRETE VALUES(296,4655,889,1);
INSERT INTO INTERPRETE VALUES(296,11443,889,2);
INSERT INTO INTERPRETE VALUES(296,4660,889,3);
INSERT INTO INTERPRETE VALUES(296,4002,889,4);
INSERT INTO INTERPRETE VALUES(296,11446,889,5);
INSERT INTO INTERPRETE VALUES(296,11447,889,6);
INSERT INTO INTERPRETE VALUES(296,99,889,7);
INSERT INTO INTERPRETE VALUES(296,11449,889,8);
INSERT INTO INTERPRETE VALUES(296,11450,889,9);
INSERT INTO INTERPRETE VALUES(296,11451,889,10);
INSERT INTO INTERPRETE VALUES(296,11452,889,11);
INSERT INTO INTERPRETE VALUES(296,11453,889,12);
INSERT INTO INTERPRETE VALUES(296,11454,889,13);
INSERT INTO INTERPRETE VALUES(232,11455,890,1);
INSERT INTO INTERPRETE VALUES(232,11456,890,2);
INSERT INTO INTERPRETE VALUES(232,11457,890,3);
INSERT INTO INTERPRETE VALUES(232,11458,890,4);
INSERT INTO INTERPRETE VALUES(232,11459,890,5);
INSERT INTO INTERPRETE VALUES(232,11460,890,6);
INSERT INTO INTERPRETE VALUES(232,11461,890,7);
INSERT INTO INTERPRETE VALUES(232,11462,890,8);
INSERT INTO INTERPRETE VALUES(232,11463,890,9);
INSERT INTO INTERPRETE VALUES(232,11464,890,10);
INSERT INTO INTERPRETE VALUES(232,11465,890,11);
INSERT INTO INTERPRETE VALUES(232,11466,890,12);
INSERT INTO INTERPRETE VALUES(232,11467,890,13);
INSERT INTO INTERPRETE VALUES(232,11468,890,14);
INSERT INTO INTERPRETE VALUES(71,11469,891,1);
INSERT INTO INTERPRETE VALUES(71,11470,891,2);
INSERT INTO INTERPRETE VALUES(71,11471,891,3);
INSERT INTO INTERPRETE VALUES(71,11472,891,4);
INSERT INTO INTERPRETE VALUES(71,11473,891,5);
INSERT INTO INTERPRETE VALUES(71,11474,891,6);
INSERT INTO INTERPRETE VALUES(71,11475,891,7);
INSERT INTO INTERPRETE VALUES(71,11476,891,8);
INSERT INTO INTERPRETE VALUES(71,11477,891,9);
INSERT INTO INTERPRETE VALUES(71,11478,891,10);
INSERT INTO INTERPRETE VALUES(71,11479,891,11);
INSERT INTO INTERPRETE VALUES(4,11482,892,3);
INSERT INTO INTERPRETE VALUES(4,11481,892,2);
INSERT INTO INTERPRETE VALUES(4,11483,892,4);
INSERT INTO INTERPRETE VALUES(4,11484,892,5);
INSERT INTO INTERPRETE VALUES(4,11485,892,6);
INSERT INTO INTERPRETE VALUES(4,11486,892,7);
INSERT INTO INTERPRETE VALUES(4,11487,892,8);
INSERT INTO INTERPRETE VALUES(4,11488,892,9);
INSERT INTO INTERPRETE VALUES(4,11489,892,10);
INSERT INTO INTERPRETE VALUES(4,11490,892,11);
INSERT INTO INTERPRETE VALUES(4,11491,892,12);
INSERT INTO INTERPRETE VALUES(4,11480,892,1);
INSERT INTO INTERPRETE VALUES(4,11492,893,1);
INSERT INTO INTERPRETE VALUES(4,11493,893,2);
INSERT INTO INTERPRETE VALUES(4,11494,893,3);
INSERT INTO INTERPRETE VALUES(4,11495,893,4);
INSERT INTO INTERPRETE VALUES(4,1502,893,5);
INSERT INTO INTERPRETE VALUES(4,11497,893,6);
INSERT INTO INTERPRETE VALUES(4,11498,893,7);
INSERT INTO INTERPRETE VALUES(4,1944,893,8);
INSERT INTO INTERPRETE VALUES(4,11500,893,9);
INSERT INTO INTERPRETE VALUES(4,11501,894,1);
INSERT INTO INTERPRETE VALUES(4,11502,894,2);
INSERT INTO INTERPRETE VALUES(4,11503,894,3);
INSERT INTO INTERPRETE VALUES(4,11504,894,4);
INSERT INTO INTERPRETE VALUES(4,11505,894,5);
INSERT INTO INTERPRETE VALUES(109,4338,895,1);
INSERT INTO INTERPRETE VALUES(109,11507,895,2);
INSERT INTO INTERPRETE VALUES(109,4715,895,3);
INSERT INTO INTERPRETE VALUES(109,4344,895,4);
INSERT INTO INTERPRETE VALUES(109,11510,895,5);
INSERT INTO INTERPRETE VALUES(109,3908,895,6);
INSERT INTO INTERPRETE VALUES(109,11512,895,7);
INSERT INTO INTERPRETE VALUES(109,11513,895,8);
INSERT INTO INTERPRETE VALUES(109,3906,895,9);
INSERT INTO INTERPRETE VALUES(109,11515,896,1);
INSERT INTO INTERPRETE VALUES(109,11516,896,2);
INSERT INTO INTERPRETE VALUES(109,11517,896,3);
INSERT INTO INTERPRETE VALUES(109,11518,896,4);
INSERT INTO INTERPRETE VALUES(109,11519,896,5);
INSERT INTO INTERPRETE VALUES(109,11520,896,6);
INSERT INTO INTERPRETE VALUES(109,11521,896,7);
INSERT INTO INTERPRETE VALUES(109,11522,896,8);
INSERT INTO INTERPRETE VALUES(109,11523,896,9);
INSERT INTO INTERPRETE VALUES(109,11524,896,10);
INSERT INTO INTERPRETE VALUES(109,11525,896,11);
INSERT INTO INTERPRETE VALUES(179,11526,897,1);
INSERT INTO INTERPRETE VALUES(179,11527,897,2);
INSERT INTO INTERPRETE VALUES(179,11528,897,3);
INSERT INTO INTERPRETE VALUES(179,11529,897,4);
INSERT INTO INTERPRETE VALUES(179,11530,897,5);
INSERT INTO INTERPRETE VALUES(179,11531,897,6);
INSERT INTO INTERPRETE VALUES(179,11532,897,7);
INSERT INTO INTERPRETE VALUES(179,11533,897,8);
INSERT INTO INTERPRETE VALUES(179,8942,897,9);
INSERT INTO INTERPRETE VALUES(264,11535,898,1);
INSERT INTO INTERPRETE VALUES(264,11536,898,2);
INSERT INTO INTERPRETE VALUES(264,11537,898,3);
INSERT INTO INTERPRETE VALUES(264,11538,898,4);
INSERT INTO INTERPRETE VALUES(264,11539,898,5);
INSERT INTO INTERPRETE VALUES(264,11540,898,6);
INSERT INTO INTERPRETE VALUES(264,11541,899,1);
INSERT INTO INTERPRETE VALUES(264,11542,899,2);
INSERT INTO INTERPRETE VALUES(264,11543,899,3);
INSERT INTO INTERPRETE VALUES(264,11544,899,4);
INSERT INTO INTERPRETE VALUES(264,11545,899,5);
INSERT INTO INTERPRETE VALUES(264,11546,899,6);
INSERT INTO INTERPRETE VALUES(264,11547,900,1);
INSERT INTO INTERPRETE VALUES(264,11548,900,2);
INSERT INTO INTERPRETE VALUES(264,11549,900,3);
INSERT INTO INTERPRETE VALUES(264,11550,900,4);
INSERT INTO INTERPRETE VALUES(264,11551,900,5);
INSERT INTO INTERPRETE VALUES(264,11552,900,6);
INSERT INTO INTERPRETE VALUES(264,11553,900,7);
INSERT INTO INTERPRETE VALUES(264,11554,900,8);
INSERT INTO INTERPRETE VALUES(264,11555,900,9);
INSERT INTO INTERPRETE VALUES(264,11556,900,10);
INSERT INTO INTERPRETE VALUES(264,11557,900,11);
INSERT INTO INTERPRETE VALUES(168,11558,901,1);
INSERT INTO INTERPRETE VALUES(168,9665,901,2);
INSERT INTO INTERPRETE VALUES(168,11560,901,3);
INSERT INTO INTERPRETE VALUES(168,11561,901,4);
INSERT INTO INTERPRETE VALUES(168,11562,901,5);
INSERT INTO INTERPRETE VALUES(168,11563,901,6);
INSERT INTO INTERPRETE VALUES(168,11564,901,7);
INSERT INTO INTERPRETE VALUES(168,11565,901,8);
INSERT INTO INTERPRETE VALUES(168,11566,901,9);
INSERT INTO INTERPRETE VALUES(168,11567,901,10);
INSERT INTO INTERPRETE VALUES(168,11568,901,11);
INSERT INTO INTERPRETE VALUES(168,11569,901,12);
INSERT INTO INTERPRETE VALUES(168,11570,901,13);
INSERT INTO INTERPRETE VALUES(168,11571,901,14);
INSERT INTO INTERPRETE VALUES(168,11572,901,15);
INSERT INTO INTERPRETE VALUES(168,11573,901,16);
INSERT INTO INTERPRETE VALUES(168,2367,901,17);
INSERT INTO INTERPRETE VALUES(168,11575,901,18);
INSERT INTO INTERPRETE VALUES(168,11576,901,19);
INSERT INTO INTERPRETE VALUES(168,11577,901,20);
INSERT INTO INTERPRETE VALUES(168,11578,901,21);
INSERT INTO INTERPRETE VALUES(168,11579,901,22);
INSERT INTO INTERPRETE VALUES(168,8500,901,23);
INSERT INTO INTERPRETE VALUES(168,11581,901,24);
INSERT INTO INTERPRETE VALUES(168,11582,901,25);
INSERT INTO INTERPRETE VALUES(168,11583,901,26);
INSERT INTO INTERPRETE VALUES(168,11584,901,27);
INSERT INTO INTERPRETE VALUES(168,11585,901,28);
INSERT INTO INTERPRETE VALUES(17,11586,902,1);
INSERT INTO INTERPRETE VALUES(17,11587,902,2);
INSERT INTO INTERPRETE VALUES(17,11588,902,3);
INSERT INTO INTERPRETE VALUES(17,11589,902,4);
INSERT INTO INTERPRETE VALUES(17,11590,902,5);
INSERT INTO INTERPRETE VALUES(17,11591,902,6);
INSERT INTO INTERPRETE VALUES(17,11592,902,7);
INSERT INTO INTERPRETE VALUES(17,11593,902,8);
INSERT INTO INTERPRETE VALUES(17,11594,902,9);
INSERT INTO INTERPRETE VALUES(17,11595,902,10);
INSERT INTO INTERPRETE VALUES(17,11596,903,1);
INSERT INTO INTERPRETE VALUES(17,11597,903,2);
INSERT INTO INTERPRETE VALUES(17,11598,903,3);
INSERT INTO INTERPRETE VALUES(17,11599,903,4);
INSERT INTO INTERPRETE VALUES(17,11600,903,5);
INSERT INTO INTERPRETE VALUES(17,11601,903,6);
INSERT INTO INTERPRETE VALUES(17,11602,903,7);
INSERT INTO INTERPRETE VALUES(17,11603,903,8);
INSERT INTO INTERPRETE VALUES(17,11604,903,9);
INSERT INTO INTERPRETE VALUES(17,11605,903,10);
INSERT INTO INTERPRETE VALUES(17,11606,903,11);
INSERT INTO INTERPRETE VALUES(297,11607,904,1);
INSERT INTO INTERPRETE VALUES(297,11608,904,2);
INSERT INTO INTERPRETE VALUES(297,11609,904,3);
INSERT INTO INTERPRETE VALUES(297,11610,904,4);
INSERT INTO INTERPRETE VALUES(297,11611,904,5);
INSERT INTO INTERPRETE VALUES(297,11612,904,6);
INSERT INTO INTERPRETE VALUES(297,11613,904,7);
INSERT INTO INTERPRETE VALUES(199,11614,905,1);
INSERT INTO INTERPRETE VALUES(199,11615,905,2);
INSERT INTO INTERPRETE VALUES(199,11616,905,3);
INSERT INTO INTERPRETE VALUES(199,11617,905,4);
INSERT INTO INTERPRETE VALUES(199,11618,905,5);
INSERT INTO INTERPRETE VALUES(199,11619,905,6);
INSERT INTO INTERPRETE VALUES(199,11620,905,7);
INSERT INTO INTERPRETE VALUES(199,11621,905,8);
INSERT INTO INTERPRETE VALUES(199,11622,905,9);
INSERT INTO INTERPRETE VALUES(199,11623,905,10);
INSERT INTO INTERPRETE VALUES(199,11624,905,11);
INSERT INTO INTERPRETE VALUES(199,11625,906,1);
INSERT INTO INTERPRETE VALUES(199,11626,906,2);
INSERT INTO INTERPRETE VALUES(199,11627,906,3);
INSERT INTO INTERPRETE VALUES(199,11628,906,4);
INSERT INTO INTERPRETE VALUES(199,11629,906,5);
INSERT INTO INTERPRETE VALUES(199,11630,906,6);
INSERT INTO INTERPRETE VALUES(199,8774,907,1);
INSERT INTO INTERPRETE VALUES(199,11632,907,2);
INSERT INTO INTERPRETE VALUES(199,11633,907,3);
INSERT INTO INTERPRETE VALUES(199,6809,907,4);
INSERT INTO INTERPRETE VALUES(199,11635,907,5);
INSERT INTO INTERPRETE VALUES(199,11636,907,6);
INSERT INTO INTERPRETE VALUES(199,11637,907,7);
INSERT INTO INTERPRETE VALUES(199,11638,907,8);
INSERT INTO INTERPRETE VALUES(199,11639,907,9);
INSERT INTO INTERPRETE VALUES(199,11639,907,10);
INSERT INTO INTERPRETE VALUES(199,6807,907,11);
INSERT INTO INTERPRETE VALUES(199,6808,907,12);
INSERT INTO INTERPRETE VALUES(199,11643,907,13);
INSERT INTO INTERPRETE VALUES(199,11644,908,1);
INSERT INTO INTERPRETE VALUES(199,11645,908,2);
INSERT INTO INTERPRETE VALUES(199,11646,908,3);
INSERT INTO INTERPRETE VALUES(199,11647,908,4);
INSERT INTO INTERPRETE VALUES(199,11648,908,5);
INSERT INTO INTERPRETE VALUES(199,11628,908,6);
INSERT INTO INTERPRETE VALUES(199,11650,908,7);
INSERT INTO INTERPRETE VALUES(199,11651,908,8);
INSERT INTO INTERPRETE VALUES(199,11652,908,9);
INSERT INTO INTERPRETE VALUES(199,11627,908,10);
INSERT INTO INTERPRETE VALUES(199,11654,908,11);
INSERT INTO INTERPRETE VALUES(4,11480,909,1);
INSERT INTO INTERPRETE VALUES(4,32,909,2);
INSERT INTO INTERPRETE VALUES(4,36,909,3);
INSERT INTO INTERPRETE VALUES(4,1752,909,4);
INSERT INTO INTERPRETE VALUES(4,11659,909,5);
INSERT INTO INTERPRETE VALUES(4,2312,909,6);
INSERT INTO INTERPRETE VALUES(4,11481,909,7);
INSERT INTO INTERPRETE VALUES(4,11501,909,8);
INSERT INTO INTERPRETE VALUES(4,11663,909,9);
INSERT INTO INTERPRETE VALUES(4,11483,909,10);
INSERT INTO INTERPRETE VALUES(4,11492,909,11);
INSERT INTO INTERPRETE VALUES(4,11482,909,12);
INSERT INTO INTERPRETE VALUES(4,31,910,1);
INSERT INTO INTERPRETE VALUES(4,11486,910,2);
INSERT INTO INTERPRETE VALUES(4,11669,910,3);
INSERT INTO INTERPRETE VALUES(4,11670,910,4);
INSERT INTO INTERPRETE VALUES(4,37,910,5);
INSERT INTO INTERPRETE VALUES(4,1505,910,6);
INSERT INTO INTERPRETE VALUES(4,1500,910,7);
INSERT INTO INTERPRETE VALUES(4,11674,910,8);
INSERT INTO INTERPRETE VALUES(4,1838,910,9);
INSERT INTO INTERPRETE VALUES(4,11676,910,10);
INSERT INTO INTERPRETE VALUES(4,11677,910,11);
INSERT INTO INTERPRETE VALUES(312,7583,621,1);
INSERT INTO INTERPRETE VALUES(312,7584,621,2);
INSERT INTO INTERPRETE VALUES(312,6914,621,3);
INSERT INTO INTERPRETE VALUES(207,6914,621,3);
INSERT INTO INTERPRETE VALUES(312,7586,621,4);
INSERT INTO INTERPRETE VALUES(207,7586,621,4);
INSERT INTO INTERPRETE VALUES(312,7587,621,5);
INSERT INTO INTERPRETE VALUES(207,7587,621,5);
INSERT INTO INTERPRETE VALUES(207,7588,621,6);
INSERT INTO INTERPRETE VALUES(312,7588,621,6);
INSERT INTO INTERPRETE VALUES(230,7589,621,7);
INSERT INTO INTERPRETE VALUES(312,7589,621,7);
INSERT INTO INTERPRETE VALUES(196,7589,621,7);
INSERT INTO INTERPRETE VALUES(230,7590,621,8);
INSERT INTO INTERPRETE VALUES(312,7590,621,8);
INSERT INTO INTERPRETE VALUES(196,7590,621,8);
INSERT INTO INTERPRETE VALUES(230,7037,621,9);
INSERT INTO INTERPRETE VALUES(312,7037,621,9);
INSERT INTO INTERPRETE VALUES(196,7037,621,9);
INSERT INTO INTERPRETE VALUES(311,7622,625,1);
INSERT INTO INTERPRETE VALUES(311,7623,625,2);
INSERT INTO INTERPRETE VALUES(230,7624,625,3);
INSERT INTO INTERPRETE VALUES(230,7625,625,4);
INSERT INTO INTERPRETE VALUES(230,7626,625,5);
INSERT INTO INTERPRETE VALUES(207,7414,625,6);
INSERT INTO INTERPRETE VALUES(207,6919,625,7);
INSERT INTO INTERPRETE VALUES(196,7629,625,8);
INSERT INTO INTERPRETE VALUES(196,7630,625,9);
INSERT INTO INTERPRETE VALUES(196,7631,625,10);
INSERT INTO INTERPRETE VALUES(313,2654,244,1);
INSERT INTO INTERPRETE VALUES(314,2655,244,2);
INSERT INTO INTERPRETE VALUES(102,2656,244,3);
INSERT INTO INTERPRETE VALUES(315,5386,244,4);
INSERT INTO INTERPRETE VALUES(316,2658,244,5);
INSERT INTO INTERPRETE VALUES(317,2659,244,6);
INSERT INTO INTERPRETE VALUES(318,2551,244,7);
INSERT INTO INTERPRETE VALUES(319,1557,244,8);
INSERT INTO INTERPRETE VALUES(320,4249,369,1);
INSERT INTO INTERPRETE VALUES(321,4250,369,2);
INSERT INTO INTERPRETE VALUES(322,4251,369,3);
INSERT INTO INTERPRETE VALUES(323,4252,369,4);
INSERT INTO INTERPRETE VALUES(324,4253,369,5);
INSERT INTO INTERPRETE VALUES(325,4254,369,6);
INSERT INTO INTERPRETE VALUES(326,4255,369,7);
INSERT INTO INTERPRETE VALUES(327,4256,369,8);
INSERT INTO INTERPRETE VALUES(328,4257,369,9);
INSERT INTO INTERPRETE VALUES(329,4258,369,10);
INSERT INTO INTERPRETE VALUES(330,4259,369,11);
INSERT INTO INTERPRETE VALUES(331,4260,369,12);
INSERT INTO INTERPRETE VALUES(332,4261,369,13);
INSERT INTO INTERPRETE VALUES(333,4262,369,14);
INSERT INTO INTERPRETE VALUES(334,4263,369,15);
INSERT INTO INTERPRETE VALUES(335,4689,397,1);
INSERT INTO INTERPRETE VALUES(1,5,397,2);
INSERT INTO INTERPRETE VALUES(336,4691,397,3);
INSERT INTO INTERPRETE VALUES(459,4692,397,4);
INSERT INTO INTERPRETE VALUES(337,4693,397,5);
INSERT INTO INTERPRETE VALUES(338,4694,397,6);
INSERT INTO INTERPRETE VALUES(341,4695,397,7);
INSERT INTO INTERPRETE VALUES(339,4696,397,8);
INSERT INTO INTERPRETE VALUES(340,4697,397,9);
INSERT INTO INTERPRETE VALUES(342,4698,397,10);
INSERT INTO INTERPRETE VALUES(343,4699,397,11);
INSERT INTO INTERPRETE VALUES(344,4700,397,12);
INSERT INTO INTERPRETE VALUES(345,4701,397,13);
INSERT INTO INTERPRETE VALUES(346,4702,397,14);
INSERT INTO INTERPRETE VALUES(347,4703,397,15);
INSERT INTO INTERPRETE VALUES(348,4704,397,16);
INSERT INTO INTERPRETE VALUES(349,4705,397,17);
INSERT INTO INTERPRETE VALUES(350,4706,397,18);
INSERT INTO INTERPRETE VALUES(351,4707,397,19);
INSERT INTO INTERPRETE VALUES(352,5548,466,1);
INSERT INTO INTERPRETE VALUES(353,5549,466,2);
INSERT INTO INTERPRETE VALUES(354,5550,466,3);
INSERT INTO INTERPRETE VALUES(355,5551,466,4);
INSERT INTO INTERPRETE VALUES(357,5552,466,5);
INSERT INTO INTERPRETE VALUES(356,5553,466,6);
INSERT INTO INTERPRETE VALUES(358,5554,466,7);
INSERT INTO INTERPRETE VALUES(359,5555,466,8);
INSERT INTO INTERPRETE VALUES(360,5556,466,9);
INSERT INTO INTERPRETE VALUES(361,5557,466,10);
INSERT INTO INTERPRETE VALUES(362,5558,466,11);
INSERT INTO INTERPRETE VALUES(363,5559,466,12);
INSERT INTO INTERPRETE VALUES(364,5560,466,13);
INSERT INTO INTERPRETE VALUES(365,5561,466,14);
INSERT INTO INTERPRETE VALUES(366,5562,466,15);
INSERT INTO INTERPRETE VALUES(367,5563,466,16);
INSERT INTO INTERPRETE VALUES(368,5564,466,17);
INSERT INTO INTERPRETE VALUES(369,5565,466,18);
INSERT INTO INTERPRETE VALUES(370,5566,466,19);
INSERT INTO INTERPRETE VALUES(371,5567,466,20);
INSERT INTO INTERPRETE VALUES(372,5902,495,1);
INSERT INTO INTERPRETE VALUES(373,5903,495,2);
INSERT INTO INTERPRETE VALUES(374,5904,495,3);
INSERT INTO INTERPRETE VALUES(375,5905,495,4);
INSERT INTO INTERPRETE VALUES(376,5906,495,5);
INSERT INTO INTERPRETE VALUES(377,5907,495,6);
INSERT INTO INTERPRETE VALUES(378,5908,495,7);
INSERT INTO INTERPRETE VALUES(379,5909,495,8);
INSERT INTO INTERPRETE VALUES(357,5910,495,9);
INSERT INTO INTERPRETE VALUES(380,5911,495,10);
INSERT INTO INTERPRETE VALUES(381,5912,495,11);
INSERT INTO INTERPRETE VALUES(382,5913,495,12);
INSERT INTO INTERPRETE VALUES(383,5914,495,13);
INSERT INTO INTERPRETE VALUES(126,5915,495,14);
INSERT INTO INTERPRETE VALUES(384,5916,495,15);
INSERT INTO INTERPRETE VALUES(385,5917,495,16);
INSERT INTO INTERPRETE VALUES(361,5918,495,17);
INSERT INTO INTERPRETE VALUES(386,5919,495,18);
INSERT INTO INTERPRETE VALUES(387,5920,495,19);
INSERT INTO INTERPRETE VALUES(388,5921,495,20);
INSERT INTO INTERPRETE VALUES(389,5922,495,21);
INSERT INTO INTERPRETE VALUES(390,5923,495,22);
INSERT INTO INTERPRETE VALUES(391,7255,596,1);
INSERT INTO INTERPRETE VALUES(392,7256,596,2);
INSERT INTO INTERPRETE VALUES(393,7257,596,3);
INSERT INTO INTERPRETE VALUES(394,7258,596,4);
INSERT INTO INTERPRETE VALUES(395,7259,596,5);
INSERT INTO INTERPRETE VALUES(396,7260,596,6);
INSERT INTO INTERPRETE VALUES(397,7261,596,7);
INSERT INTO INTERPRETE VALUES(398,7262,596,8);
INSERT INTO INTERPRETE VALUES(399,7263,596,9);
INSERT INTO INTERPRETE VALUES(400,7264,596,10);
INSERT INTO INTERPRETE VALUES(401,7265,596,11);
INSERT INTO INTERPRETE VALUES(402,7266,596,12);
INSERT INTO INTERPRETE VALUES(403,7267,596,13);
INSERT INTO INTERPRETE VALUES(404,7268,596,14);
INSERT INTO INTERPRETE VALUES(405,7269,596,15);
INSERT INTO INTERPRETE VALUES(406,7270,596,16);
INSERT INTO INTERPRETE VALUES(407,7271,596,17);
INSERT INTO INTERPRETE VALUES(220,7370,604,1);
INSERT INTO INTERPRETE VALUES(408,7371,604,2);
INSERT INTO INTERPRETE VALUES(408,7372,604,3);
INSERT INTO INTERPRETE VALUES(409,7373,604,4);
INSERT INTO INTERPRETE VALUES(409,7374,604,5);
INSERT INTO INTERPRETE VALUES(410,7375,604,6);
INSERT INTO INTERPRETE VALUES(410,7376,604,7);
INSERT INTO INTERPRETE VALUES(411,7118,604,8);
INSERT INTO INTERPRETE VALUES(411,7378,604,9);
INSERT INTO INTERPRETE VALUES(412,7379,604,10);
INSERT INTO INTERPRETE VALUES(413,7380,604,11);
INSERT INTO INTERPRETE VALUES(413,7381,604,12);
INSERT INTO INTERPRETE VALUES(413,7382,604,13);
INSERT INTO INTERPRETE VALUES(414,7383,604,14);
INSERT INTO INTERPRETE VALUES(415,7384,604,15);
INSERT INTO INTERPRETE VALUES(415,7385,604,16);
INSERT INTO INTERPRETE VALUES(415,7386,604,17);
INSERT INTO INTERPRETE VALUES(416,7387,605,1);
INSERT INTO INTERPRETE VALUES(416,7388,605,2);
INSERT INTO INTERPRETE VALUES(416,7389,605,3);
INSERT INTO INTERPRETE VALUES(416,7390,605,4);
INSERT INTO INTERPRETE VALUES(417,7391,605,5);
INSERT INTO INTERPRETE VALUES(417,7392,605,6);
INSERT INTO INTERPRETE VALUES(418,7393,605,7);
INSERT INTO INTERPRETE VALUES(440,7393,605,7);
INSERT INTO INTERPRETE VALUES(419,7394,605,8);
INSERT INTO INTERPRETE VALUES(419,7395,605,9);
INSERT INTO INTERPRETE VALUES(420,7396,605,10);
INSERT INTO INTERPRETE VALUES(421,7397,605,11);
INSERT INTO INTERPRETE VALUES(422,7398,605,12);
INSERT INTO INTERPRETE VALUES(422,7399,605,13);
INSERT INTO INTERPRETE VALUES(231,7400,605,14);
INSERT INTO INTERPRETE VALUES(423,7401,605,15);
INSERT INTO INTERPRETE VALUES(424,7402,605,16);
INSERT INTO INTERPRETE VALUES(424,7403,605,17);
INSERT INTO INTERPRETE VALUES(213,6718,555,1);
INSERT INTO INTERPRETE VALUES(211,6719,555,2);
INSERT INTO INTERPRETE VALUES(425,6720,555,3);
INSERT INTO INTERPRETE VALUES(426,6721,555,4);
INSERT INTO INTERPRETE VALUES(427,6722,555,5);
INSERT INTO INTERPRETE VALUES(230,6723,555,6);
INSERT INTO INTERPRETE VALUES(237,6723,555,6);
INSERT INTO INTERPRETE VALUES(428,6724,555,7);
INSERT INTO INTERPRETE VALUES(429,6725,555,8);
INSERT INTO INTERPRETE VALUES(207,6726,555,9);
INSERT INTO INTERPRETE VALUES(430,6726,555,9);
INSERT INTO INTERPRETE VALUES(431,6727,555,10);
INSERT INTO INTERPRETE VALUES(432,6728,555,11);
INSERT INTO INTERPRETE VALUES(433,6729,555,12);
INSERT INTO INTERPRETE VALUES(224,6730,555,13);
INSERT INTO INTERPRETE VALUES(434,6731,555,14);
INSERT INTO INTERPRETE VALUES(435,6732,555,15);
INSERT INTO INTERPRETE VALUES(436,6733,555,16);
INSERT INTO INTERPRETE VALUES(437,6734,555,17);
INSERT INTO INTERPRETE VALUES(223,6735,555,18);
INSERT INTO INTERPRETE VALUES(438,6736,555,19);
INSERT INTO INTERPRETE VALUES(439,6737,555,20);
INSERT INTO INTERPRETE VALUES(441,6698,554,1);
INSERT INTO INTERPRETE VALUES(442,6699,554,2);
INSERT INTO INTERPRETE VALUES(443,6700,554,3);
INSERT INTO INTERPRETE VALUES(444,6701,554,4);
INSERT INTO INTERPRETE VALUES(445,6702,554,5);
INSERT INTO INTERPRETE VALUES(446,6703,554,6);
INSERT INTO INTERPRETE VALUES(447,6704,554,7);
INSERT INTO INTERPRETE VALUES(448,6705,554,8);
INSERT INTO INTERPRETE VALUES(449,6706,554,9);
INSERT INTO INTERPRETE VALUES(450,6707,554,10);
INSERT INTO INTERPRETE VALUES(451,6708,554,11);
INSERT INTO INTERPRETE VALUES(452,6709,554,12);
INSERT INTO INTERPRETE VALUES(453,6710,554,13);
INSERT INTO INTERPRETE VALUES(454,6711,554,14);
INSERT INTO INTERPRETE VALUES(455,6712,554,15);
INSERT INTO INTERPRETE VALUES(456,6713,554,16);
INSERT INTO INTERPRETE VALUES(457,6714,554,17);
INSERT INTO INTERPRETE VALUES(458,6715,554,18);
INSERT INTO INTERPRETE VALUES(460,6716,554,19);
INSERT INTO INTERPRETE VALUES(461,6717,554,20);
INSERT INTO INTERPRETE VALUES(462,1652,149,1);
INSERT INTO INTERPRETE VALUES(463,1653,149,2);
INSERT INTO INTERPRETE VALUES(464,1654,149,3);
INSERT INTO INTERPRETE VALUES(465,1655,149,4);
INSERT INTO INTERPRETE VALUES(467,1656,149,5);
INSERT INTO INTERPRETE VALUES(468,1657,149,6);
INSERT INTO INTERPRETE VALUES(466,1658,149,7);
INSERT INTO INTERPRETE VALUES(469,1659,149,8);
INSERT INTO INTERPRETE VALUES(470,1660,149,9);
INSERT INTO INTERPRETE VALUES(471,1661,149,10);
INSERT INTO INTERPRETE VALUES(201,1662,149,11);
INSERT INTO INTERPRETE VALUES(201,1663,149,12);
INSERT INTO INTERPRETE VALUES(78,1664,149,13);
INSERT INTO INTERPRETE VALUES(508,1665,149,14);
INSERT INTO INTERPRETE VALUES(473,1609,144,1);
INSERT INTO INTERPRETE VALUES(472,1610,144,2);
INSERT INTO INTERPRETE VALUES(155,1611,144,3);
INSERT INTO INTERPRETE VALUES(509,1612,144,4);
INSERT INTO INTERPRETE VALUES(462,1613,144,5);
INSERT INTO INTERPRETE VALUES(510,1614,144,6);
INSERT INTO INTERPRETE VALUES(165,1615,144,7);
INSERT INTO INTERPRETE VALUES(474,10727,834,1);
INSERT INTO INTERPRETE VALUES(475,10728,834,2);
INSERT INTO INTERPRETE VALUES(476,10729,834,3);
INSERT INTO INTERPRETE VALUES(477,10730,834,4);
INSERT INTO INTERPRETE VALUES(91,10731,834,5);
INSERT INTO INTERPRETE VALUES(478,10732,834,6);
INSERT INTO INTERPRETE VALUES(479,10733,834,7);
INSERT INTO INTERPRETE VALUES(480,10734,834,8);
INSERT INTO INTERPRETE VALUES(202,10735,834,9);
INSERT INTO INTERPRETE VALUES(481,10736,834,10);
INSERT INTO INTERPRETE VALUES(482,10737,835,1);
INSERT INTO INTERPRETE VALUES(483,10738,835,2);
INSERT INTO INTERPRETE VALUES(52,10739,835,3);
INSERT INTO INTERPRETE VALUES(483,10740,835,4);
INSERT INTO INTERPRETE VALUES(52,10741,835,5);
INSERT INTO INTERPRETE VALUES(483,10742,835,6);
INSERT INTO INTERPRETE VALUES(52,10743,835,7);
INSERT INTO INTERPRETE VALUES(483,10744,835,8);
INSERT INTO INTERPRETE VALUES(52,10745,835,9);
INSERT INTO INTERPRETE VALUES(483,10746,835,10);
INSERT INTO INTERPRETE VALUES(483,10747,835,11);
INSERT INTO INTERPRETE VALUES(52,10748,835,12);
INSERT INTO INTERPRETE VALUES(484,6824,837,1);
INSERT INTO INTERPRETE VALUES(485,10762,837,2);
INSERT INTO INTERPRETE VALUES(214,10763,837,3);
INSERT INTO INTERPRETE VALUES(485,10764,837,4);
INSERT INTO INTERPRETE VALUES(486,10765,837,5);
INSERT INTO INTERPRETE VALUES(214,10766,837,6);
INSERT INTO INTERPRETE VALUES(487,10767,837,7);
INSERT INTO INTERPRETE VALUES(488,10768,837,8);
INSERT INTO INTERPRETE VALUES(489,10769,837,9);
INSERT INTO INTERPRETE VALUES(490,10770,837,10);
INSERT INTO INTERPRETE VALUES(491,10771,837,11);
INSERT INTO INTERPRETE VALUES(492,10772,837,12);
INSERT INTO INTERPRETE VALUES(493,10773,837,13);
INSERT INTO INTERPRETE VALUES(197,10774,837,14);
INSERT INTO INTERPRETE VALUES(48,5137,838,1);
INSERT INTO INTERPRETE VALUES(48,5123,838,3);
INSERT INTO INTERPRETE VALUES(494,10779,838,5);
INSERT INTO INTERPRETE VALUES(495,10780,838,6);
INSERT INTO INTERPRETE VALUES(48,10782,838,8);
INSERT INTO INTERPRETE VALUES(496,10783,838,9);
INSERT INTO INTERPRETE VALUES(41,994,838,11);
INSERT INTO INTERPRETE VALUES(48,10786,838,12);
INSERT INTO INTERPRETE VALUES(497,10788,838,14);
INSERT INTO INTERPRETE VALUES(497,10789,838,15);
INSERT INTO INTERPRETE VALUES(48,10790,838,16);
INSERT INTO INTERPRETE VALUES(48,10791,838,17);
INSERT INTO INTERPRETE VALUES(84,2210,839,1);
INSERT INTO INTERPRETE VALUES(498,10793,839,2);
INSERT INTO INTERPRETE VALUES(499,10794,839,3);
INSERT INTO INTERPRETE VALUES(500,10795,839,4);
INSERT INTO INTERPRETE VALUES(501,10796,839,5);
INSERT INTO INTERPRETE VALUES(84,10797,839,6);
INSERT INTO INTERPRETE VALUES(146,10798,839,7);
INSERT INTO INTERPRETE VALUES(56,3043,839,8);
INSERT INTO INTERPRETE VALUES(502,10800,839,9);
INSERT INTO INTERPRETE VALUES(503,10801,839,10);
INSERT INTO INTERPRETE VALUES(504,10802,839,11);
INSERT INTO INTERPRETE VALUES(505,10803,839,12);
INSERT INTO INTERPRETE VALUES(506,10804,839,13);
INSERT INTO INTERPRETE VALUES(507,10805,839,14);
INSERT INTO INTERPRETE VALUES(511,3393,306,7);
INSERT INTO INTERPRETE VALUES(512,119,463,12);
INSERT INTO INTERPRETE VALUES(513,6467,534,10);
INSERT INTO INTERPRETE VALUES(514,1173,97,22);
INSERT INTO INTERPRETE VALUES(515,5209,438,13);
INSERT INTO INTERPRETE VALUES(516,5210,438,14);
INSERT INTO INTERPRETE VALUES(517,5214,438,18);
INSERT INTO INTERPRETE VALUES(518,6160,513,1);
INSERT INTO INTERPRETE VALUES(519,6162,513,3);
INSERT INTO INTERPRETE VALUES(520,6166,513,7);
INSERT INTO INTERPRETE VALUES(13,6633,548,2);
INSERT INTO INTERPRETE VALUES(521,6640,548,9);
INSERT INTO INTERPRETE VALUES(521,6646,548,15);
INSERT INTO INTERPRETE VALUES(522,9948,786,24);
INSERT INTO INTERPRETE VALUES(523,9955,786,31);
INSERT INTO INTERPRETE VALUES(524,9955,786,31);
INSERT INTO INTERPRETE VALUES(525,10994,855,10);
INSERT INTO INTERPRETE VALUES(95,2278,332,6);
INSERT INTO INTERPRETE VALUES(526,3739,332,12);
INSERT INTO INTERPRETE VALUES(527,5652,474,5);
INSERT INTO INTERPRETE VALUES(528,5653,474,6);
INSERT INTO INTERPRETE VALUES(529,6218,517,2);
INSERT INTO INTERPRETE VALUES(530,8121,662,1);
INSERT INTO INTERPRETE VALUES(531,10989,855,5);
INSERT INTO INTERPRETE VALUES(532,11001,856,3);
INSERT INTO INTERPRETE VALUES(533,9838,779,11);
INSERT INTO INTERPRETE VALUES(534,3398,306,12);
INSERT INTO INTERPRETE VALUES(535,4020,353,5);
INSERT INTO INTERPRETE VALUES(536,8500,687,21);
INSERT INTO INTERPRETE VALUES(179,9831,779,4);
INSERT INTO INTERPRETE VALUES(537,9863,781,12);
INSERT INTO INTERPRETE VALUES(66,10903,846,12);


INSERT INTO ECRIT VALUES(80,1033);
INSERT INTO ECRIT VALUES(100,1033);
INSERT INTO ECRIT VALUES(80,1034);
INSERT INTO ECRIT VALUES(100,1034);
INSERT INTO ECRIT VALUES(80,1136);
INSERT INTO ECRIT VALUES(100,1136);
INSERT INTO ECRIT VALUES(252,1142);
INSERT INTO ECRIT VALUES(52,1174);
INSERT INTO ECRIT VALUES(52,1175);
INSERT INTO ECRIT VALUES(52,1176);
INSERT INTO ECRIT VALUES(52,1177);
INSERT INTO ECRIT VALUES(52,1178);
INSERT INTO ECRIT VALUES(52,1179);
INSERT INTO ECRIT VALUES(52,1180);
INSERT INTO ECRIT VALUES(52,1181);
INSERT INTO ECRIT VALUES(52,1182);
INSERT INTO ECRIT VALUES(52,1183);
INSERT INTO ECRIT VALUES(52,1184);
INSERT INTO ECRIT VALUES(52,1185);
INSERT INTO ECRIT VALUES(52,1186);
INSERT INTO ECRIT VALUES(52,1187);
INSERT INTO ECRIT VALUES(52,1188);
INSERT INTO ECRIT VALUES(52,1189);
INSERT INTO ECRIT VALUES(52,1190);
INSERT INTO ECRIT VALUES(52,1192);
INSERT INTO ECRIT VALUES(52,1193);
INSERT INTO ECRIT VALUES(52,1194);
INSERT INTO ECRIT VALUES(52,1195);
INSERT INTO ECRIT VALUES(52,1196);
INSERT INTO ECRIT VALUES(80,1267);
INSERT INTO ECRIT VALUES(100,1267);
INSERT INTO ECRIT VALUES(80,1268);
INSERT INTO ECRIT VALUES(100,1268);
INSERT INTO ECRIT VALUES(80,1269);
INSERT INTO ECRIT VALUES(100,1269);
INSERT INTO ECRIT VALUES(56,1271);
INSERT INTO ECRIT VALUES(56,1272);
INSERT INTO ECRIT VALUES(56,1273);
INSERT INTO ECRIT VALUES(56,1274);
INSERT INTO ECRIT VALUES(56,1275);
INSERT INTO ECRIT VALUES(52,1276);
INSERT INTO ECRIT VALUES(52,1277);
INSERT INTO ECRIT VALUES(52,1278);
INSERT INTO ECRIT VALUES(52,1279);
INSERT INTO ECRIT VALUES(52,1280);
INSERT INTO ECRIT VALUES(52,1281);
INSERT INTO ECRIT VALUES(52,1468);
INSERT INTO ECRIT VALUES(52,1469);
INSERT INTO ECRIT VALUES(52,1470);
INSERT INTO ECRIT VALUES(52,1471);
INSERT INTO ECRIT VALUES(52,1472);
INSERT INTO ECRIT VALUES(52,1474);
INSERT INTO ECRIT VALUES(52,1475);
INSERT INTO ECRIT VALUES(80,1546);
INSERT INTO ECRIT VALUES(100,1546);
INSERT INTO ECRIT VALUES(80,1549);
INSERT INTO ECRIT VALUES(100,1549);
INSERT INTO ECRIT VALUES(80,1559);
INSERT INTO ECRIT VALUES(100,1559);
INSERT INTO ECRIT VALUES(80,1560);
INSERT INTO ECRIT VALUES(100,1560);
INSERT INTO ECRIT VALUES(80,1561);
INSERT INTO ECRIT VALUES(100,1561);
INSERT INTO ECRIT VALUES(80,1562);
INSERT INTO ECRIT VALUES(100,1562);
INSERT INTO ECRIT VALUES(80,1563);
INSERT INTO ECRIT VALUES(100,1563);
INSERT INTO ECRIT VALUES(80,1564);
INSERT INTO ECRIT VALUES(100,1564);
INSERT INTO ECRIT VALUES(80,1565);
INSERT INTO ECRIT VALUES(100,1565);
INSERT INTO ECRIT VALUES(80,1566);
INSERT INTO ECRIT VALUES(100,1566);
INSERT INTO ECRIT VALUES(80,1567);
INSERT INTO ECRIT VALUES(100,1567);
INSERT INTO ECRIT VALUES(80,1576);
INSERT INTO ECRIT VALUES(100,1576);
INSERT INTO ECRIT VALUES(80,1577);
INSERT INTO ECRIT VALUES(100,1577);
INSERT INTO ECRIT VALUES(80,1578);
INSERT INTO ECRIT VALUES(100,1578);
INSERT INTO ECRIT VALUES(80,1579);
INSERT INTO ECRIT VALUES(100,1579);
INSERT INTO ECRIT VALUES(80,1580);
INSERT INTO ECRIT VALUES(100,1580);
INSERT INTO ECRIT VALUES(80,1581);
INSERT INTO ECRIT VALUES(100,1581);
INSERT INTO ECRIT VALUES(80,1582);
INSERT INTO ECRIT VALUES(100,1582);
INSERT INTO ECRIT VALUES(80,1583);
INSERT INTO ECRIT VALUES(100,1583);
INSERT INTO ECRIT VALUES(80,1639);
INSERT INTO ECRIT VALUES(100,1639);
INSERT INTO ECRIT VALUES(52,1701);
INSERT INTO ECRIT VALUES(52,1702);
INSERT INTO ECRIT VALUES(52,1703);
INSERT INTO ECRIT VALUES(52,1704);
INSERT INTO ECRIT VALUES(52,1705);
INSERT INTO ECRIT VALUES(52,1706);
INSERT INTO ECRIT VALUES(52,1707);
INSERT INTO ECRIT VALUES(52,1708);
INSERT INTO ECRIT VALUES(52,1709);
INSERT INTO ECRIT VALUES(52,1710);
INSERT INTO ECRIT VALUES(252,1741);
INSERT INTO ECRIT VALUES(52,1907);
INSERT INTO ECRIT VALUES(52,1908);
INSERT INTO ECRIT VALUES(52,1909);
INSERT INTO ECRIT VALUES(52,1910);
INSERT INTO ECRIT VALUES(52,1911);
INSERT INTO ECRIT VALUES(52,1912);
INSERT INTO ECRIT VALUES(52,1913);
INSERT INTO ECRIT VALUES(80,1914);
INSERT INTO ECRIT VALUES(100,1914);
INSERT INTO ECRIT VALUES(52,1915);
INSERT INTO ECRIT VALUES(52,1916);
INSERT INTO ECRIT VALUES(165,1918);
INSERT INTO ECRIT VALUES(80,1977);
INSERT INTO ECRIT VALUES(100,1977);
INSERT INTO ECRIT VALUES(80,1978);
INSERT INTO ECRIT VALUES(100,1978);
INSERT INTO ECRIT VALUES(80,1979);
INSERT INTO ECRIT VALUES(100,1979);
INSERT INTO ECRIT VALUES(80,1980);
INSERT INTO ECRIT VALUES(100,1980);
INSERT INTO ECRIT VALUES(80,1981);
INSERT INTO ECRIT VALUES(100,1981);
INSERT INTO ECRIT VALUES(80,1983);
INSERT INTO ECRIT VALUES(100,1983);
INSERT INTO ECRIT VALUES(80,1984);
INSERT INTO ECRIT VALUES(100,1984);
INSERT INTO ECRIT VALUES(80,1985);
INSERT INTO ECRIT VALUES(100,1985);
INSERT INTO ECRIT VALUES(80,1986);
INSERT INTO ECRIT VALUES(100,1986);
INSERT INTO ECRIT VALUES(80,1987);
INSERT INTO ECRIT VALUES(100,1987);
INSERT INTO ECRIT VALUES(80,1988);
INSERT INTO ECRIT VALUES(100,1988);
INSERT INTO ECRIT VALUES(80,2009);
INSERT INTO ECRIT VALUES(100,2009);
INSERT INTO ECRIT VALUES(80,2010);
INSERT INTO ECRIT VALUES(100,2010);
INSERT INTO ECRIT VALUES(80,2011);
INSERT INTO ECRIT VALUES(100,2011);
INSERT INTO ECRIT VALUES(80,2012);
INSERT INTO ECRIT VALUES(100,2012);
INSERT INTO ECRIT VALUES(80,2013);
INSERT INTO ECRIT VALUES(100,2013);
INSERT INTO ECRIT VALUES(80,2014);
INSERT INTO ECRIT VALUES(100,2014);
INSERT INTO ECRIT VALUES(80,2015);
INSERT INTO ECRIT VALUES(100,2015);
INSERT INTO ECRIT VALUES(80,2016);
INSERT INTO ECRIT VALUES(100,2016);
INSERT INTO ECRIT VALUES(80,2018);
INSERT INTO ECRIT VALUES(100,2018);
INSERT INTO ECRIT VALUES(56,2052);
INSERT INTO ECRIT VALUES(56,2053);
INSERT INTO ECRIT VALUES(56,2054);
INSERT INTO ECRIT VALUES(56,2055);
INSERT INTO ECRIT VALUES(56,2056);
INSERT INTO ECRIT VALUES(56,2057);
INSERT INTO ECRIT VALUES(56,2058);
INSERT INTO ECRIT VALUES(56,2059);
INSERT INTO ECRIT VALUES(56,2060);
INSERT INTO ECRIT VALUES(56,2061);
INSERT INTO ECRIT VALUES(56,2062);
INSERT INTO ECRIT VALUES(52,2170);
INSERT INTO ECRIT VALUES(52,2171);
INSERT INTO ECRIT VALUES(52,2172);
INSERT INTO ECRIT VALUES(52,2173);
INSERT INTO ECRIT VALUES(52,2174);
INSERT INTO ECRIT VALUES(52,2175);
INSERT INTO ECRIT VALUES(52,2176);
INSERT INTO ECRIT VALUES(52,2177);
INSERT INTO ECRIT VALUES(52,2178);
INSERT INTO ECRIT VALUES(52,2179);
INSERT INTO ECRIT VALUES(80,2201);
INSERT INTO ECRIT VALUES(100,2201);
INSERT INTO ECRIT VALUES(80,2202);
INSERT INTO ECRIT VALUES(100,2202);
INSERT INTO ECRIT VALUES(80,2203);
INSERT INTO ECRIT VALUES(100,2203);
INSERT INTO ECRIT VALUES(80,2204);
INSERT INTO ECRIT VALUES(100,2204);
INSERT INTO ECRIT VALUES(80,2205);
INSERT INTO ECRIT VALUES(100,2205);
INSERT INTO ECRIT VALUES(80,2206);
INSERT INTO ECRIT VALUES(100,2206);
INSERT INTO ECRIT VALUES(80,2207);
INSERT INTO ECRIT VALUES(100,2207);
INSERT INTO ECRIT VALUES(80,2208);
INSERT INTO ECRIT VALUES(100,2208);
INSERT INTO ECRIT VALUES(80,2209);
INSERT INTO ECRIT VALUES(100,2209);
INSERT INTO ECRIT VALUES(52,2214);
INSERT INTO ECRIT VALUES(52,2217);
INSERT INTO ECRIT VALUES(52,2248);
INSERT INTO ECRIT VALUES(52,2249);
INSERT INTO ECRIT VALUES(52,2250);
INSERT INTO ECRIT VALUES(52,2251);
INSERT INTO ECRIT VALUES(52,2252);
INSERT INTO ECRIT VALUES(52,2253);
INSERT INTO ECRIT VALUES(52,2254);
INSERT INTO ECRIT VALUES(52,2255);
INSERT INTO ECRIT VALUES(52,2256);
INSERT INTO ECRIT VALUES(80,2257);
INSERT INTO ECRIT VALUES(100,2257);
INSERT INTO ECRIT VALUES(80,2258);
INSERT INTO ECRIT VALUES(100,2258);
INSERT INTO ECRIT VALUES(80,2260);
INSERT INTO ECRIT VALUES(100,2260);
INSERT INTO ECRIT VALUES(80,2261);
INSERT INTO ECRIT VALUES(100,2261);
INSERT INTO ECRIT VALUES(80,2262);
INSERT INTO ECRIT VALUES(100,2262);
INSERT INTO ECRIT VALUES(80,2263);
INSERT INTO ECRIT VALUES(100,2263);
INSERT INTO ECRIT VALUES(80,2264);
INSERT INTO ECRIT VALUES(100,2264);
INSERT INTO ECRIT VALUES(80,2265);
INSERT INTO ECRIT VALUES(100,2265);
INSERT INTO ECRIT VALUES(80,2266);
INSERT INTO ECRIT VALUES(100,2266);
INSERT INTO ECRIT VALUES(168,2277);
INSERT INTO ECRIT VALUES(168,2278);
INSERT INTO ECRIT VALUES(168,2280);
INSERT INTO ECRIT VALUES(168,2288);
INSERT INTO ECRIT VALUES(168,2355);
INSERT INTO ECRIT VALUES(168,2363);
INSERT INTO ECRIT VALUES(168,2367);
INSERT INTO ECRIT VALUES(52,2368);
INSERT INTO ECRIT VALUES(52,2369);
INSERT INTO ECRIT VALUES(52,2370);
INSERT INTO ECRIT VALUES(52,2373);
INSERT INTO ECRIT VALUES(52,2374);
INSERT INTO ECRIT VALUES(52,2375);
INSERT INTO ECRIT VALUES(52,2376);
INSERT INTO ECRIT VALUES(80,2453);
INSERT INTO ECRIT VALUES(100,2453);
INSERT INTO ECRIT VALUES(80,2454);
INSERT INTO ECRIT VALUES(100,2454);
INSERT INTO ECRIT VALUES(80,2455);
INSERT INTO ECRIT VALUES(100,2455);
INSERT INTO ECRIT VALUES(80,2457);
INSERT INTO ECRIT VALUES(100,2457);
INSERT INTO ECRIT VALUES(80,2458);
INSERT INTO ECRIT VALUES(100,2458);
INSERT INTO ECRIT VALUES(80,2472);
INSERT INTO ECRIT VALUES(100,2472);
INSERT INTO ECRIT VALUES(80,2473);
INSERT INTO ECRIT VALUES(100,2473);
INSERT INTO ECRIT VALUES(80,2474);
INSERT INTO ECRIT VALUES(100,2474);
INSERT INTO ECRIT VALUES(80,2475);
INSERT INTO ECRIT VALUES(100,2475);
INSERT INTO ECRIT VALUES(80,2476);
INSERT INTO ECRIT VALUES(100,2476);
INSERT INTO ECRIT VALUES(80,2477);
INSERT INTO ECRIT VALUES(100,2477);
INSERT INTO ECRIT VALUES(80,2478);
INSERT INTO ECRIT VALUES(100,2478);
INSERT INTO ECRIT VALUES(80,2479);
INSERT INTO ECRIT VALUES(100,2479);
INSERT INTO ECRIT VALUES(80,2480);
INSERT INTO ECRIT VALUES(100,2480);
INSERT INTO ECRIT VALUES(80,2677);
INSERT INTO ECRIT VALUES(100,2677);
INSERT INTO ECRIT VALUES(80,2678);
INSERT INTO ECRIT VALUES(100,2678);
INSERT INTO ECRIT VALUES(80,2679);
INSERT INTO ECRIT VALUES(100,2679);
INSERT INTO ECRIT VALUES(80,2680);
INSERT INTO ECRIT VALUES(100,2680);
INSERT INTO ECRIT VALUES(80,2681);
INSERT INTO ECRIT VALUES(100,2681);
INSERT INTO ECRIT VALUES(80,2682);
INSERT INTO ECRIT VALUES(100,2682);
INSERT INTO ECRIT VALUES(80,2683);
INSERT INTO ECRIT VALUES(100,2683);
INSERT INTO ECRIT VALUES(80,2684);
INSERT INTO ECRIT VALUES(100,2684);
INSERT INTO ECRIT VALUES(80,2685);
INSERT INTO ECRIT VALUES(100,2685);
INSERT INTO ECRIT VALUES(80,2720);
INSERT INTO ECRIT VALUES(100,2720);
INSERT INTO ECRIT VALUES(80,2722);
INSERT INTO ECRIT VALUES(100,2722);
INSERT INTO ECRIT VALUES(80,2723);
INSERT INTO ECRIT VALUES(100,2723);
INSERT INTO ECRIT VALUES(80,2724);
INSERT INTO ECRIT VALUES(100,2724);
INSERT INTO ECRIT VALUES(80,2727);
INSERT INTO ECRIT VALUES(100,2727);
INSERT INTO ECRIT VALUES(80,2728);
INSERT INTO ECRIT VALUES(100,2728);
INSERT INTO ECRIT VALUES(80,2729);
INSERT INTO ECRIT VALUES(100,2729);
INSERT INTO ECRIT VALUES(80,2730);
INSERT INTO ECRIT VALUES(100,2730);
INSERT INTO ECRIT VALUES(80,2731);
INSERT INTO ECRIT VALUES(100,2731);
INSERT INTO ECRIT VALUES(80,2902);
INSERT INTO ECRIT VALUES(100,2902);
INSERT INTO ECRIT VALUES(80,2904);
INSERT INTO ECRIT VALUES(100,2904);
INSERT INTO ECRIT VALUES(80,2905);
INSERT INTO ECRIT VALUES(100,2905);
INSERT INTO ECRIT VALUES(80,2906);
INSERT INTO ECRIT VALUES(100,2906);
INSERT INTO ECRIT VALUES(80,2909);
INSERT INTO ECRIT VALUES(100,2909);
INSERT INTO ECRIT VALUES(80,2937);
INSERT INTO ECRIT VALUES(100,2937);
INSERT INTO ECRIT VALUES(80,2938);
INSERT INTO ECRIT VALUES(100,2938);
INSERT INTO ECRIT VALUES(80,2940);
INSERT INTO ECRIT VALUES(100,2940);
INSERT INTO ECRIT VALUES(80,2941);
INSERT INTO ECRIT VALUES(100,2941);
INSERT INTO ECRIT VALUES(80,2942);
INSERT INTO ECRIT VALUES(100,2942);
INSERT INTO ECRIT VALUES(80,2943);
INSERT INTO ECRIT VALUES(100,2943);
INSERT INTO ECRIT VALUES(80,2944);
INSERT INTO ECRIT VALUES(100,2944);
INSERT INTO ECRIT VALUES(80,2945);
INSERT INTO ECRIT VALUES(100,2945);
INSERT INTO ECRIT VALUES(80,2946);
INSERT INTO ECRIT VALUES(100,2946);
INSERT INTO ECRIT VALUES(80,2948);
INSERT INTO ECRIT VALUES(100,2948);
INSERT INTO ECRIT VALUES(80,2949);
INSERT INTO ECRIT VALUES(100,2949);
INSERT INTO ECRIT VALUES(80,2950);
INSERT INTO ECRIT VALUES(100,2950);
INSERT INTO ECRIT VALUES(80,2951);
INSERT INTO ECRIT VALUES(100,2951);
INSERT INTO ECRIT VALUES(80,2952);
INSERT INTO ECRIT VALUES(100,2952);
INSERT INTO ECRIT VALUES(80,2953);
INSERT INTO ECRIT VALUES(100,2953);
INSERT INTO ECRIT VALUES(80,2954);
INSERT INTO ECRIT VALUES(100,2954);
INSERT INTO ECRIT VALUES(80,2955);
INSERT INTO ECRIT VALUES(100,2955);
INSERT INTO ECRIT VALUES(80,2956);
INSERT INTO ECRIT VALUES(100,2956);
INSERT INTO ECRIT VALUES(80,2957);
INSERT INTO ECRIT VALUES(100,2957);
INSERT INTO ECRIT VALUES(80,2958);
INSERT INTO ECRIT VALUES(100,2958);
INSERT INTO ECRIT VALUES(80,2959);
INSERT INTO ECRIT VALUES(100,2959);
INSERT INTO ECRIT VALUES(56,3041);
INSERT INTO ECRIT VALUES(56,3042);
INSERT INTO ECRIT VALUES(56,3043);
INSERT INTO ECRIT VALUES(56,3044);
INSERT INTO ECRIT VALUES(56,3045);
INSERT INTO ECRIT VALUES(56,3046);
INSERT INTO ECRIT VALUES(56,3047);
INSERT INTO ECRIT VALUES(56,3048);
INSERT INTO ECRIT VALUES(56,3049);
INSERT INTO ECRIT VALUES(56,3050);
INSERT INTO ECRIT VALUES(56,3051);
INSERT INTO ECRIT VALUES(80,3201);
INSERT INTO ECRIT VALUES(100,3201);
INSERT INTO ECRIT VALUES(80,3204);
INSERT INTO ECRIT VALUES(100,3204);
INSERT INTO ECRIT VALUES(80,3206);
INSERT INTO ECRIT VALUES(100,3206);
INSERT INTO ECRIT VALUES(80,3208);
INSERT INTO ECRIT VALUES(100,3208);
INSERT INTO ECRIT VALUES(80,3210);
INSERT INTO ECRIT VALUES(100,3210);
INSERT INTO ECRIT VALUES(80,3211);
INSERT INTO ECRIT VALUES(100,3211);
INSERT INTO ECRIT VALUES(52,3223);
INSERT INTO ECRIT VALUES(52,3224);
INSERT INTO ECRIT VALUES(52,3225);
INSERT INTO ECRIT VALUES(52,3226);
INSERT INTO ECRIT VALUES(52,3227);
INSERT INTO ECRIT VALUES(52,3228);
INSERT INTO ECRIT VALUES(52,3229);
INSERT INTO ECRIT VALUES(52,3230);
INSERT INTO ECRIT VALUES(52,3231);
INSERT INTO ECRIT VALUES(52,3232);
INSERT INTO ECRIT VALUES(52,3233);
INSERT INTO ECRIT VALUES(80,3336);
INSERT INTO ECRIT VALUES(100,3336);
INSERT INTO ECRIT VALUES(80,3337);
INSERT INTO ECRIT VALUES(100,3337);
INSERT INTO ECRIT VALUES(80,3338);
INSERT INTO ECRIT VALUES(100,3338);
INSERT INTO ECRIT VALUES(80,3339);
INSERT INTO ECRIT VALUES(100,3339);
INSERT INTO ECRIT VALUES(80,3340);
INSERT INTO ECRIT VALUES(100,3340);
INSERT INTO ECRIT VALUES(80,3341);
INSERT INTO ECRIT VALUES(100,3341);
INSERT INTO ECRIT VALUES(80,3342);
INSERT INTO ECRIT VALUES(100,3342);
INSERT INTO ECRIT VALUES(80,3343);
INSERT INTO ECRIT VALUES(100,3343);
INSERT INTO ECRIT VALUES(80,3344);
INSERT INTO ECRIT VALUES(100,3344);
INSERT INTO ECRIT VALUES(80,3345);
INSERT INTO ECRIT VALUES(100,3345);
INSERT INTO ECRIT VALUES(80,3346);
INSERT INTO ECRIT VALUES(100,3346);
INSERT INTO ECRIT VALUES(80,3347);
INSERT INTO ECRIT VALUES(100,3347);
INSERT INTO ECRIT VALUES(80,3348);
INSERT INTO ECRIT VALUES(100,3348);
INSERT INTO ECRIT VALUES(52,3375);
INSERT INTO ECRIT VALUES(52,3376);
INSERT INTO ECRIT VALUES(52,3377);
INSERT INTO ECRIT VALUES(52,3378);
INSERT INTO ECRIT VALUES(52,3379);
INSERT INTO ECRIT VALUES(52,3380);
INSERT INTO ECRIT VALUES(52,3381);
INSERT INTO ECRIT VALUES(52,3382);
INSERT INTO ECRIT VALUES(52,3383);
INSERT INTO ECRIT VALUES(52,3384);
INSERT INTO ECRIT VALUES(52,3385);
INSERT INTO ECRIT VALUES(52,3386);
INSERT INTO ECRIT VALUES(56,3449);
INSERT INTO ECRIT VALUES(56,3450);
INSERT INTO ECRIT VALUES(56,3451);
INSERT INTO ECRIT VALUES(56,3452);
INSERT INTO ECRIT VALUES(56,3453);
INSERT INTO ECRIT VALUES(56,3454);
INSERT INTO ECRIT VALUES(56,3455);
INSERT INTO ECRIT VALUES(56,3456);
INSERT INTO ECRIT VALUES(56,3457);
INSERT INTO ECRIT VALUES(56,3458);
INSERT INTO ECRIT VALUES(56,3459);
INSERT INTO ECRIT VALUES(56,3460);
INSERT INTO ECRIT VALUES(56,3461);
INSERT INTO ECRIT VALUES(56,3462);
INSERT INTO ECRIT VALUES(52,3541);
INSERT INTO ECRIT VALUES(52,3542);
INSERT INTO ECRIT VALUES(52,3543);
INSERT INTO ECRIT VALUES(52,3544);
INSERT INTO ECRIT VALUES(52,3545);
INSERT INTO ECRIT VALUES(52,3546);
INSERT INTO ECRIT VALUES(52,3547);
INSERT INTO ECRIT VALUES(52,3548);
INSERT INTO ECRIT VALUES(52,3549);
INSERT INTO ECRIT VALUES(52,3550);
INSERT INTO ECRIT VALUES(52,3551);
INSERT INTO ECRIT VALUES(52,3552);
INSERT INTO ECRIT VALUES(52,3553);
INSERT INTO ECRIT VALUES(52,3555);
INSERT INTO ECRIT VALUES(80,3562);
INSERT INTO ECRIT VALUES(100,3562);
INSERT INTO ECRIT VALUES(56,3568);
INSERT INTO ECRIT VALUES(56,3569);
INSERT INTO ECRIT VALUES(56,3570);
INSERT INTO ECRIT VALUES(56,3571);
INSERT INTO ECRIT VALUES(56,3572);
INSERT INTO ECRIT VALUES(56,3573);
INSERT INTO ECRIT VALUES(56,3574);
INSERT INTO ECRIT VALUES(56,3575);
INSERT INTO ECRIT VALUES(56,3576);
INSERT INTO ECRIT VALUES(56,3577);
INSERT INTO ECRIT VALUES(56,3578);
INSERT INTO ECRIT VALUES(56,3579);
INSERT INTO ECRIT VALUES(56,3580);
INSERT INTO ECRIT VALUES(56,3581);
INSERT INTO ECRIT VALUES(52,3620);
INSERT INTO ECRIT VALUES(52,3621);
INSERT INTO ECRIT VALUES(52,3622);
INSERT INTO ECRIT VALUES(52,3623);
INSERT INTO ECRIT VALUES(52,3624);
INSERT INTO ECRIT VALUES(52,3625);
INSERT INTO ECRIT VALUES(52,3626);
INSERT INTO ECRIT VALUES(52,3627);
INSERT INTO ECRIT VALUES(52,3628);
INSERT INTO ECRIT VALUES(52,3629);
INSERT INTO ECRIT VALUES(52,3630);
INSERT INTO ECRIT VALUES(52,3631);
INSERT INTO ECRIT VALUES(52,3632);
INSERT INTO ECRIT VALUES(52,3633);
INSERT INTO ECRIT VALUES(168,3665);
INSERT INTO ECRIT VALUES(52,3701);
INSERT INTO ECRIT VALUES(52,3702);
INSERT INTO ECRIT VALUES(52,3704);
INSERT INTO ECRIT VALUES(52,3705);
INSERT INTO ECRIT VALUES(52,3706);
INSERT INTO ECRIT VALUES(52,3708);
INSERT INTO ECRIT VALUES(52,3709);
INSERT INTO ECRIT VALUES(52,3710);
INSERT INTO ECRIT VALUES(52,3711);
INSERT INTO ECRIT VALUES(52,3712);
INSERT INTO ECRIT VALUES(52,3713);
INSERT INTO ECRIT VALUES(80,3730);
INSERT INTO ECRIT VALUES(100,3730);
INSERT INTO ECRIT VALUES(52,3781);
INSERT INTO ECRIT VALUES(52,3782);
INSERT INTO ECRIT VALUES(52,3783);
INSERT INTO ECRIT VALUES(52,3784);
INSERT INTO ECRIT VALUES(52,3785);
INSERT INTO ECRIT VALUES(52,3786);
INSERT INTO ECRIT VALUES(52,3787);
INSERT INTO ECRIT VALUES(52,3788);
INSERT INTO ECRIT VALUES(52,3789);
INSERT INTO ECRIT VALUES(52,3790);
INSERT INTO ECRIT VALUES(52,3791);
INSERT INTO ECRIT VALUES(52,3792);
INSERT INTO ECRIT VALUES(52,3793);
INSERT INTO ECRIT VALUES(52,3891);
INSERT INTO ECRIT VALUES(52,3892);
INSERT INTO ECRIT VALUES(52,3893);
INSERT INTO ECRIT VALUES(52,3894);
INSERT INTO ECRIT VALUES(52,3895);
INSERT INTO ECRIT VALUES(52,3896);
INSERT INTO ECRIT VALUES(52,3897);
INSERT INTO ECRIT VALUES(52,3898);
INSERT INTO ECRIT VALUES(52,3899);
INSERT INTO ECRIT VALUES(52,3900);
INSERT INTO ECRIT VALUES(52,3901);
INSERT INTO ECRIT VALUES(52,3943);
INSERT INTO ECRIT VALUES(80,3959);
INSERT INTO ECRIT VALUES(100,3959);
INSERT INTO ECRIT VALUES(80,3965);
INSERT INTO ECRIT VALUES(100,3965);
INSERT INTO ECRIT VALUES(80,3968);
INSERT INTO ECRIT VALUES(100,3968);
INSERT INTO ECRIT VALUES(143,4016);
INSERT INTO ECRIT VALUES(143,4017);
INSERT INTO ECRIT VALUES(143,4018);
INSERT INTO ECRIT VALUES(143,4019);
INSERT INTO ECRIT VALUES(143,4020);
INSERT INTO ECRIT VALUES(143,4021);
INSERT INTO ECRIT VALUES(143,4022);
INSERT INTO ECRIT VALUES(143,4023);
INSERT INTO ECRIT VALUES(143,4024);
INSERT INTO ECRIT VALUES(143,4025);
INSERT INTO ECRIT VALUES(143,4026);
INSERT INTO ECRIT VALUES(143,4027);
INSERT INTO ECRIT VALUES(143,4028);
INSERT INTO ECRIT VALUES(143,4029);
INSERT INTO ECRIT VALUES(52,4030);
INSERT INTO ECRIT VALUES(52,4031);
INSERT INTO ECRIT VALUES(52,4032);
INSERT INTO ECRIT VALUES(52,4033);
INSERT INTO ECRIT VALUES(52,4034);
INSERT INTO ECRIT VALUES(52,4035);
INSERT INTO ECRIT VALUES(52,4036);
INSERT INTO ECRIT VALUES(52,4037);
INSERT INTO ECRIT VALUES(52,4038);
INSERT INTO ECRIT VALUES(52,4039);
INSERT INTO ECRIT VALUES(52,4040);
INSERT INTO ECRIT VALUES(52,4041);
INSERT INTO ECRIT VALUES(52,4042);
INSERT INTO ECRIT VALUES(52,4043);
INSERT INTO ECRIT VALUES(52,4147);
INSERT INTO ECRIT VALUES(52,4148);
INSERT INTO ECRIT VALUES(52,4149);
INSERT INTO ECRIT VALUES(52,4150);
INSERT INTO ECRIT VALUES(52,4151);
INSERT INTO ECRIT VALUES(52,4152);
INSERT INTO ECRIT VALUES(52,4153);
INSERT INTO ECRIT VALUES(52,4154);
INSERT INTO ECRIT VALUES(52,4155);
INSERT INTO ECRIT VALUES(52,4156);
INSERT INTO ECRIT VALUES(52,4157);
INSERT INTO ECRIT VALUES(52,4158);
INSERT INTO ECRIT VALUES(52,4159);
INSERT INTO ECRIT VALUES(52,4160);
INSERT INTO ECRIT VALUES(52,4161);
INSERT INTO ECRIT VALUES(80,4190);
INSERT INTO ECRIT VALUES(100,4190);
INSERT INTO ECRIT VALUES(80,4192);
INSERT INTO ECRIT VALUES(100,4192);
INSERT INTO ECRIT VALUES(80,4193);
INSERT INTO ECRIT VALUES(100,4193);
INSERT INTO ECRIT VALUES(80,4194);
INSERT INTO ECRIT VALUES(100,4194);
INSERT INTO ECRIT VALUES(80,4195);
INSERT INTO ECRIT VALUES(100,4195);
INSERT INTO ECRIT VALUES(80,4196);
INSERT INTO ECRIT VALUES(100,4196);
INSERT INTO ECRIT VALUES(80,4197);
INSERT INTO ECRIT VALUES(100,4197);
INSERT INTO ECRIT VALUES(80,4198);
INSERT INTO ECRIT VALUES(100,4198);
INSERT INTO ECRIT VALUES(80,4199);
INSERT INTO ECRIT VALUES(100,4199);
INSERT INTO ECRIT VALUES(80,4200);
INSERT INTO ECRIT VALUES(100,4200);
INSERT INTO ECRIT VALUES(80,4201);
INSERT INTO ECRIT VALUES(100,4201);
INSERT INTO ECRIT VALUES(80,4202);
INSERT INTO ECRIT VALUES(100,4202);
INSERT INTO ECRIT VALUES(80,4203);
INSERT INTO ECRIT VALUES(100,4203);
INSERT INTO ECRIT VALUES(80,4204);
INSERT INTO ECRIT VALUES(100,4204);
INSERT INTO ECRIT VALUES(80,4206);
INSERT INTO ECRIT VALUES(100,4206);
INSERT INTO ECRIT VALUES(80,4208);
INSERT INTO ECRIT VALUES(100,4208);
INSERT INTO ECRIT VALUES(80,4209);
INSERT INTO ECRIT VALUES(100,4209);
INSERT INTO ECRIT VALUES(80,4210);
INSERT INTO ECRIT VALUES(100,4210);
INSERT INTO ECRIT VALUES(80,4211);
INSERT INTO ECRIT VALUES(100,4211);
INSERT INTO ECRIT VALUES(80,4212);
INSERT INTO ECRIT VALUES(100,4212);
INSERT INTO ECRIT VALUES(80,4213);
INSERT INTO ECRIT VALUES(100,4213);
INSERT INTO ECRIT VALUES(80,4214);
INSERT INTO ECRIT VALUES(100,4214);
INSERT INTO ECRIT VALUES(80,4216);
INSERT INTO ECRIT VALUES(100,4216);
INSERT INTO ECRIT VALUES(80,4279);
INSERT INTO ECRIT VALUES(100,4279);
INSERT INTO ECRIT VALUES(52,4306);
INSERT INTO ECRIT VALUES(52,4307);
INSERT INTO ECRIT VALUES(52,4308);
INSERT INTO ECRIT VALUES(52,4309);
INSERT INTO ECRIT VALUES(52,4310);
INSERT INTO ECRIT VALUES(52,4311);
INSERT INTO ECRIT VALUES(52,4312);
INSERT INTO ECRIT VALUES(52,4313);
INSERT INTO ECRIT VALUES(52,4314);
INSERT INTO ECRIT VALUES(52,4315);
INSERT INTO ECRIT VALUES(52,4318);
INSERT INTO ECRIT VALUES(80,4323);
INSERT INTO ECRIT VALUES(100,4323);
INSERT INTO ECRIT VALUES(80,4324);
INSERT INTO ECRIT VALUES(100,4324);
INSERT INTO ECRIT VALUES(80,4332);
INSERT INTO ECRIT VALUES(100,4332);
INSERT INTO ECRIT VALUES(80,4333);
INSERT INTO ECRIT VALUES(100,4333);
INSERT INTO ECRIT VALUES(80,4366);
INSERT INTO ECRIT VALUES(100,4366);
INSERT INTO ECRIT VALUES(80,4377);
INSERT INTO ECRIT VALUES(100,4377);
INSERT INTO ECRIT VALUES(52,4413);
INSERT INTO ECRIT VALUES(52,4414);
INSERT INTO ECRIT VALUES(52,4415);
INSERT INTO ECRIT VALUES(52,4424);
INSERT INTO ECRIT VALUES(52,4425);
INSERT INTO ECRIT VALUES(52,4426);
INSERT INTO ECRIT VALUES(52,4427);
INSERT INTO ECRIT VALUES(52,4428);
INSERT INTO ECRIT VALUES(52,4430);
INSERT INTO ECRIT VALUES(52,4431);
INSERT INTO ECRIT VALUES(52,4432);
INSERT INTO ECRIT VALUES(52,4433);
INSERT INTO ECRIT VALUES(52,4434);
INSERT INTO ECRIT VALUES(52,4435);
INSERT INTO ECRIT VALUES(52,4436);
INSERT INTO ECRIT VALUES(52,4437);
INSERT INTO ECRIT VALUES(52,4485);
INSERT INTO ECRIT VALUES(52,4486);
INSERT INTO ECRIT VALUES(52,4488);
INSERT INTO ECRIT VALUES(52,4489);
INSERT INTO ECRIT VALUES(52,4490);
INSERT INTO ECRIT VALUES(52,4491);
INSERT INTO ECRIT VALUES(52,4492);
INSERT INTO ECRIT VALUES(52,4493);
INSERT INTO ECRIT VALUES(52,4494);
INSERT INTO ECRIT VALUES(52,4495);
INSERT INTO ECRIT VALUES(52,4496);
INSERT INTO ECRIT VALUES(52,4497);
INSERT INTO ECRIT VALUES(52,4498);
INSERT INTO ECRIT VALUES(52,4499);
INSERT INTO ECRIT VALUES(52,4500);
INSERT INTO ECRIT VALUES(80,4586);
INSERT INTO ECRIT VALUES(100,4586);
INSERT INTO ECRIT VALUES(80,4587);
INSERT INTO ECRIT VALUES(100,4587);
INSERT INTO ECRIT VALUES(80,4588);
INSERT INTO ECRIT VALUES(100,4588);
INSERT INTO ECRIT VALUES(80,4589);
INSERT INTO ECRIT VALUES(100,4589);
INSERT INTO ECRIT VALUES(80,4592);
INSERT INTO ECRIT VALUES(100,4592);
INSERT INTO ECRIT VALUES(80,4593);
INSERT INTO ECRIT VALUES(100,4593);
INSERT INTO ECRIT VALUES(80,4594);
INSERT INTO ECRIT VALUES(100,4594);
INSERT INTO ECRIT VALUES(80,4596);
INSERT INTO ECRIT VALUES(100,4596);
INSERT INTO ECRIT VALUES(80,4597);
INSERT INTO ECRIT VALUES(100,4597);
INSERT INTO ECRIT VALUES(80,4598);
INSERT INTO ECRIT VALUES(100,4598);
INSERT INTO ECRIT VALUES(80,4599);
INSERT INTO ECRIT VALUES(100,4599);
INSERT INTO ECRIT VALUES(80,4601);
INSERT INTO ECRIT VALUES(100,4601);
INSERT INTO ECRIT VALUES(80,4603);
INSERT INTO ECRIT VALUES(100,4603);
INSERT INTO ECRIT VALUES(52,4671);
INSERT INTO ECRIT VALUES(52,4672);
INSERT INTO ECRIT VALUES(52,4673);
INSERT INTO ECRIT VALUES(52,4675);
INSERT INTO ECRIT VALUES(52,4677);
INSERT INTO ECRIT VALUES(52,4684);
INSERT INTO ECRIT VALUES(52,4685);
INSERT INTO ECRIT VALUES(52,4761);
INSERT INTO ECRIT VALUES(52,4762);
INSERT INTO ECRIT VALUES(52,4763);
INSERT INTO ECRIT VALUES(52,4764);
INSERT INTO ECRIT VALUES(52,4765);
INSERT INTO ECRIT VALUES(52,4766);
INSERT INTO ECRIT VALUES(52,4767);
INSERT INTO ECRIT VALUES(52,4768);
INSERT INTO ECRIT VALUES(52,4769);
INSERT INTO ECRIT VALUES(52,4770);
INSERT INTO ECRIT VALUES(52,4771);
INSERT INTO ECRIT VALUES(52,4772);
INSERT INTO ECRIT VALUES(52,4773);
INSERT INTO ECRIT VALUES(143,4790);
INSERT INTO ECRIT VALUES(143,4791);
INSERT INTO ECRIT VALUES(143,4792);
INSERT INTO ECRIT VALUES(143,4793);
INSERT INTO ECRIT VALUES(143,4794);
INSERT INTO ECRIT VALUES(143,4795);
INSERT INTO ECRIT VALUES(143,4796);
INSERT INTO ECRIT VALUES(143,4797);
INSERT INTO ECRIT VALUES(143,4798);
INSERT INTO ECRIT VALUES(143,4799);
INSERT INTO ECRIT VALUES(143,4800);
INSERT INTO ECRIT VALUES(143,4801);
INSERT INTO ECRIT VALUES(143,4802);
INSERT INTO ECRIT VALUES(143,4803);
INSERT INTO ECRIT VALUES(143,4804);
INSERT INTO ECRIT VALUES(143,4806);
INSERT INTO ECRIT VALUES(143,4807);
INSERT INTO ECRIT VALUES(143,4808);
INSERT INTO ECRIT VALUES(143,4809);
INSERT INTO ECRIT VALUES(143,4810);
INSERT INTO ECRIT VALUES(143,4811);
INSERT INTO ECRIT VALUES(143,4812);
INSERT INTO ECRIT VALUES(143,4814);
INSERT INTO ECRIT VALUES(143,4815);
INSERT INTO ECRIT VALUES(143,4816);
INSERT INTO ECRIT VALUES(143,4817);
INSERT INTO ECRIT VALUES(143,4818);
INSERT INTO ECRIT VALUES(143,4819);
INSERT INTO ECRIT VALUES(143,4820);
INSERT INTO ECRIT VALUES(143,4821);
INSERT INTO ECRIT VALUES(143,4822);
INSERT INTO ECRIT VALUES(143,4823);
INSERT INTO ECRIT VALUES(143,4824);
INSERT INTO ECRIT VALUES(143,4826);
INSERT INTO ECRIT VALUES(143,4827);
INSERT INTO ECRIT VALUES(143,4828);
INSERT INTO ECRIT VALUES(143,4829);
INSERT INTO ECRIT VALUES(143,4830);
INSERT INTO ECRIT VALUES(143,4831);
INSERT INTO ECRIT VALUES(143,4833);
INSERT INTO ECRIT VALUES(143,4834);
INSERT INTO ECRIT VALUES(143,4836);
INSERT INTO ECRIT VALUES(143,4840);
INSERT INTO ECRIT VALUES(143,4843);
INSERT INTO ECRIT VALUES(143,4848);
INSERT INTO ECRIT VALUES(143,4849);
INSERT INTO ECRIT VALUES(143,4854);
INSERT INTO ECRIT VALUES(143,4855);
INSERT INTO ECRIT VALUES(143,4856);
INSERT INTO ECRIT VALUES(143,4858);
INSERT INTO ECRIT VALUES(143,4871);
INSERT INTO ECRIT VALUES(143,4872);
INSERT INTO ECRIT VALUES(143,4873);
INSERT INTO ECRIT VALUES(143,4874);
INSERT INTO ECRIT VALUES(143,4875);
INSERT INTO ECRIT VALUES(143,4876);
INSERT INTO ECRIT VALUES(143,4877);
INSERT INTO ECRIT VALUES(143,4878);
INSERT INTO ECRIT VALUES(143,4879);
INSERT INTO ECRIT VALUES(143,4880);
INSERT INTO ECRIT VALUES(143,4881);
INSERT INTO ECRIT VALUES(143,4882);
INSERT INTO ECRIT VALUES(143,4883);
INSERT INTO ECRIT VALUES(143,4884);
INSERT INTO ECRIT VALUES(143,4886);
INSERT INTO ECRIT VALUES(143,4887);
INSERT INTO ECRIT VALUES(143,4888);
INSERT INTO ECRIT VALUES(143,4889);
INSERT INTO ECRIT VALUES(143,4890);
INSERT INTO ECRIT VALUES(143,4891);
INSERT INTO ECRIT VALUES(143,4893);
INSERT INTO ECRIT VALUES(143,4894);
INSERT INTO ECRIT VALUES(143,4895);
INSERT INTO ECRIT VALUES(143,4896);
INSERT INTO ECRIT VALUES(143,4897);
INSERT INTO ECRIT VALUES(143,4898);
INSERT INTO ECRIT VALUES(143,4899);
INSERT INTO ECRIT VALUES(143,4900);
INSERT INTO ECRIT VALUES(143,4901);
INSERT INTO ECRIT VALUES(143,4902);
INSERT INTO ECRIT VALUES(143,4903);
INSERT INTO ECRIT VALUES(143,4904);
INSERT INTO ECRIT VALUES(143,4905);
INSERT INTO ECRIT VALUES(143,4906);
INSERT INTO ECRIT VALUES(143,4907);
INSERT INTO ECRIT VALUES(143,4908);
INSERT INTO ECRIT VALUES(143,4909);
INSERT INTO ECRIT VALUES(143,4910);
INSERT INTO ECRIT VALUES(143,4911);
INSERT INTO ECRIT VALUES(143,4912);
INSERT INTO ECRIT VALUES(143,4913);
INSERT INTO ECRIT VALUES(143,4914);
INSERT INTO ECRIT VALUES(143,4915);
INSERT INTO ECRIT VALUES(143,4916);
INSERT INTO ECRIT VALUES(143,4917);
INSERT INTO ECRIT VALUES(143,4918);
INSERT INTO ECRIT VALUES(143,4919);
INSERT INTO ECRIT VALUES(143,4925);
INSERT INTO ECRIT VALUES(143,4926);
INSERT INTO ECRIT VALUES(143,4930);
INSERT INTO ECRIT VALUES(143,4934);
INSERT INTO ECRIT VALUES(143,4936);
INSERT INTO ECRIT VALUES(143,4937);
INSERT INTO ECRIT VALUES(143,4939);
INSERT INTO ECRIT VALUES(143,4940);
INSERT INTO ECRIT VALUES(143,4941);
INSERT INTO ECRIT VALUES(143,4962);
INSERT INTO ECRIT VALUES(143,4963);
INSERT INTO ECRIT VALUES(143,4965);
INSERT INTO ECRIT VALUES(143,4966);
INSERT INTO ECRIT VALUES(143,4967);
INSERT INTO ECRIT VALUES(143,4968);
INSERT INTO ECRIT VALUES(143,4969);
INSERT INTO ECRIT VALUES(143,4970);
INSERT INTO ECRIT VALUES(143,4971);
INSERT INTO ECRIT VALUES(143,4972);
INSERT INTO ECRIT VALUES(143,4973);
INSERT INTO ECRIT VALUES(143,4974);
INSERT INTO ECRIT VALUES(143,4975);
INSERT INTO ECRIT VALUES(143,4976);
INSERT INTO ECRIT VALUES(143,4977);
INSERT INTO ECRIT VALUES(143,4978);
INSERT INTO ECRIT VALUES(143,4979);
INSERT INTO ECRIT VALUES(143,4980);
INSERT INTO ECRIT VALUES(143,4981);
INSERT INTO ECRIT VALUES(143,4982);
INSERT INTO ECRIT VALUES(143,4984);
INSERT INTO ECRIT VALUES(80,5340);
INSERT INTO ECRIT VALUES(100,5340);
INSERT INTO ECRIT VALUES(165,5386);
INSERT INTO ECRIT VALUES(165,5389);
INSERT INTO ECRIT VALUES(80,5510);
INSERT INTO ECRIT VALUES(100,5510);
INSERT INTO ECRIT VALUES(80,5513);
INSERT INTO ECRIT VALUES(100,5513);
INSERT INTO ECRIT VALUES(80,5515);
INSERT INTO ECRIT VALUES(100,5515);
INSERT INTO ECRIT VALUES(168,5530);
INSERT INTO ECRIT VALUES(168,5532);
INSERT INTO ECRIT VALUES(168,5533);
INSERT INTO ECRIT VALUES(168,5535);
INSERT INTO ECRIT VALUES(168,5536);
INSERT INTO ECRIT VALUES(168,5537);
INSERT INTO ECRIT VALUES(168,5538);
INSERT INTO ECRIT VALUES(168,5539);
INSERT INTO ECRIT VALUES(168,5540);
INSERT INTO ECRIT VALUES(168,5541);
INSERT INTO ECRIT VALUES(168,5543);
INSERT INTO ECRIT VALUES(168,5544);
INSERT INTO ECRIT VALUES(168,5545);
INSERT INTO ECRIT VALUES(168,5547);
INSERT INTO ECRIT VALUES(80,5579);
INSERT INTO ECRIT VALUES(100,5579);
INSERT INTO ECRIT VALUES(80,5580);
INSERT INTO ECRIT VALUES(100,5580);
INSERT INTO ECRIT VALUES(80,5581);
INSERT INTO ECRIT VALUES(100,5581);
INSERT INTO ECRIT VALUES(80,5583);
INSERT INTO ECRIT VALUES(100,5583);
INSERT INTO ECRIT VALUES(80,5584);
INSERT INTO ECRIT VALUES(100,5584);
INSERT INTO ECRIT VALUES(80,5585);
INSERT INTO ECRIT VALUES(100,5585);
INSERT INTO ECRIT VALUES(80,5586);
INSERT INTO ECRIT VALUES(100,5586);
INSERT INTO ECRIT VALUES(80,5588);
INSERT INTO ECRIT VALUES(100,5588);
INSERT INTO ECRIT VALUES(80,5660);
INSERT INTO ECRIT VALUES(100,5660);
INSERT INTO ECRIT VALUES(80,5661);
INSERT INTO ECRIT VALUES(100,5661);
INSERT INTO ECRIT VALUES(80,5662);
INSERT INTO ECRIT VALUES(100,5662);
INSERT INTO ECRIT VALUES(80,5663);
INSERT INTO ECRIT VALUES(100,5663);
INSERT INTO ECRIT VALUES(80,5664);
INSERT INTO ECRIT VALUES(100,5664);
INSERT INTO ECRIT VALUES(80,5665);
INSERT INTO ECRIT VALUES(100,5665);
INSERT INTO ECRIT VALUES(80,5666);
INSERT INTO ECRIT VALUES(100,5666);
INSERT INTO ECRIT VALUES(80,5667);
INSERT INTO ECRIT VALUES(100,5667);
INSERT INTO ECRIT VALUES(80,5668);
INSERT INTO ECRIT VALUES(100,5668);
INSERT INTO ECRIT VALUES(80,5669);
INSERT INTO ECRIT VALUES(100,5669);
INSERT INTO ECRIT VALUES(80,5670);
INSERT INTO ECRIT VALUES(100,5670);
INSERT INTO ECRIT VALUES(80,5671);
INSERT INTO ECRIT VALUES(100,5671);
INSERT INTO ECRIT VALUES(80,5672);
INSERT INTO ECRIT VALUES(100,5672);
INSERT INTO ECRIT VALUES(80,5673);
INSERT INTO ECRIT VALUES(100,5673);
INSERT INTO ECRIT VALUES(80,5674);
INSERT INTO ECRIT VALUES(100,5674);
INSERT INTO ECRIT VALUES(80,5675);
INSERT INTO ECRIT VALUES(100,5675);
INSERT INTO ECRIT VALUES(80,5877);
INSERT INTO ECRIT VALUES(100,5877);
INSERT INTO ECRIT VALUES(80,5878);
INSERT INTO ECRIT VALUES(100,5878);
INSERT INTO ECRIT VALUES(80,5879);
INSERT INTO ECRIT VALUES(100,5879);
INSERT INTO ECRIT VALUES(80,5880);
INSERT INTO ECRIT VALUES(100,5880);
INSERT INTO ECRIT VALUES(80,5881);
INSERT INTO ECRIT VALUES(100,5881);
INSERT INTO ECRIT VALUES(80,5882);
INSERT INTO ECRIT VALUES(100,5882);
INSERT INTO ECRIT VALUES(80,5883);
INSERT INTO ECRIT VALUES(100,5883);
INSERT INTO ECRIT VALUES(80,5884);
INSERT INTO ECRIT VALUES(100,5884);
INSERT INTO ECRIT VALUES(80,5885);
INSERT INTO ECRIT VALUES(100,5885);
INSERT INTO ECRIT VALUES(80,5886);
INSERT INTO ECRIT VALUES(100,5886);
INSERT INTO ECRIT VALUES(80,5887);
INSERT INTO ECRIT VALUES(100,5887);
INSERT INTO ECRIT VALUES(80,5888);
INSERT INTO ECRIT VALUES(100,5888);
INSERT INTO ECRIT VALUES(80,5889);
INSERT INTO ECRIT VALUES(100,5889);
INSERT INTO ECRIT VALUES(80,5890);
INSERT INTO ECRIT VALUES(100,5890);
INSERT INTO ECRIT VALUES(80,5891);
INSERT INTO ECRIT VALUES(100,5891);
INSERT INTO ECRIT VALUES(80,5892);
INSERT INTO ECRIT VALUES(100,5892);
INSERT INTO ECRIT VALUES(80,5893);
INSERT INTO ECRIT VALUES(100,5893);
INSERT INTO ECRIT VALUES(80,5894);
INSERT INTO ECRIT VALUES(100,5894);
INSERT INTO ECRIT VALUES(80,5895);
INSERT INTO ECRIT VALUES(100,5895);
INSERT INTO ECRIT VALUES(216,5971);
INSERT INTO ECRIT VALUES(143,5992);
INSERT INTO ECRIT VALUES(143,5993);
INSERT INTO ECRIT VALUES(143,5994);
INSERT INTO ECRIT VALUES(143,5995);
INSERT INTO ECRIT VALUES(143,5996);
INSERT INTO ECRIT VALUES(143,5997);
INSERT INTO ECRIT VALUES(143,5998);
INSERT INTO ECRIT VALUES(143,5999);
INSERT INTO ECRIT VALUES(143,6000);
INSERT INTO ECRIT VALUES(143,6001);
INSERT INTO ECRIT VALUES(143,6002);
INSERT INTO ECRIT VALUES(143,6003);
INSERT INTO ECRIT VALUES(143,6030);
INSERT INTO ECRIT VALUES(143,6031);
INSERT INTO ECRIT VALUES(143,6032);
INSERT INTO ECRIT VALUES(143,6033);
INSERT INTO ECRIT VALUES(143,6034);
INSERT INTO ECRIT VALUES(143,6035);
INSERT INTO ECRIT VALUES(143,6036);
INSERT INTO ECRIT VALUES(143,6037);
INSERT INTO ECRIT VALUES(143,6038);
INSERT INTO ECRIT VALUES(143,6039);
INSERT INTO ECRIT VALUES(143,6040);
INSERT INTO ECRIT VALUES(143,6041);
INSERT INTO ECRIT VALUES(52,6062);
INSERT INTO ECRIT VALUES(52,6064);
INSERT INTO ECRIT VALUES(52,6066);
INSERT INTO ECRIT VALUES(52,6070);
INSERT INTO ECRIT VALUES(52,6073);
INSERT INTO ECRIT VALUES(52,6458);
INSERT INTO ECRIT VALUES(52,6459);
INSERT INTO ECRIT VALUES(52,6460);
INSERT INTO ECRIT VALUES(52,6461);
INSERT INTO ECRIT VALUES(52,6462);
INSERT INTO ECRIT VALUES(52,6464);
INSERT INTO ECRIT VALUES(52,6465);
INSERT INTO ECRIT VALUES(52,6466);
INSERT INTO ECRIT VALUES(52,6467);
INSERT INTO ECRIT VALUES(80,6501);
INSERT INTO ECRIT VALUES(100,6501);
INSERT INTO ECRIT VALUES(216,6784);
INSERT INTO ECRIT VALUES(252,7132);
INSERT INTO ECRIT VALUES(214,7206);
INSERT INTO ECRIT VALUES(214,7207);
INSERT INTO ECRIT VALUES(214,7208);
INSERT INTO ECRIT VALUES(214,7209);
INSERT INTO ECRIT VALUES(214,7210);
INSERT INTO ECRIT VALUES(214,7211);
INSERT INTO ECRIT VALUES(214,7212);
INSERT INTO ECRIT VALUES(214,7213);
INSERT INTO ECRIT VALUES(214,7214);
INSERT INTO ECRIT VALUES(214,7215);
INSERT INTO ECRIT VALUES(214,7216);
INSERT INTO ECRIT VALUES(214,7217);
INSERT INTO ECRIT VALUES(214,7218);
INSERT INTO ECRIT VALUES(214,7219);
INSERT INTO ECRIT VALUES(214,7220);
INSERT INTO ECRIT VALUES(214,7221);
INSERT INTO ECRIT VALUES(214,7222);
INSERT INTO ECRIT VALUES(252,7304);
INSERT INTO ECRIT VALUES(216,7311);
INSERT INTO ECRIT VALUES(216,7312);
INSERT INTO ECRIT VALUES(216,7313);
INSERT INTO ECRIT VALUES(216,7314);
INSERT INTO ECRIT VALUES(216,7315);
INSERT INTO ECRIT VALUES(216,7316);
INSERT INTO ECRIT VALUES(216,7317);
INSERT INTO ECRIT VALUES(216,7318);
INSERT INTO ECRIT VALUES(216,7319);
INSERT INTO ECRIT VALUES(216,7320);
INSERT INTO ECRIT VALUES(216,7321);
INSERT INTO ECRIT VALUES(216,7322);
INSERT INTO ECRIT VALUES(216,7323);
INSERT INTO ECRIT VALUES(216,7324);
INSERT INTO ECRIT VALUES(216,7325);
INSERT INTO ECRIT VALUES(216,7326);
INSERT INTO ECRIT VALUES(216,7327);
INSERT INTO ECRIT VALUES(216,7328);
INSERT INTO ECRIT VALUES(216,7329);
INSERT INTO ECRIT VALUES(216,7330);
INSERT INTO ECRIT VALUES(216,7331);
INSERT INTO ECRIT VALUES(216,7332);
INSERT INTO ECRIT VALUES(216,7333);
INSERT INTO ECRIT VALUES(216,7334);
INSERT INTO ECRIT VALUES(216,7335);
INSERT INTO ECRIT VALUES(216,7336);
INSERT INTO ECRIT VALUES(252,8368);
INSERT INTO ECRIT VALUES(252,8369);
INSERT INTO ECRIT VALUES(252,8370);
INSERT INTO ECRIT VALUES(252,8371);
INSERT INTO ECRIT VALUES(252,8372);
INSERT INTO ECRIT VALUES(252,8373);
INSERT INTO ECRIT VALUES(252,8374);
INSERT INTO ECRIT VALUES(252,8375);
INSERT INTO ECRIT VALUES(252,8376);
INSERT INTO ECRIT VALUES(252,8377);
INSERT INTO ECRIT VALUES(252,8378);
INSERT INTO ECRIT VALUES(252,8379);
INSERT INTO ECRIT VALUES(252,8380);
INSERT INTO ECRIT VALUES(252,8381);
INSERT INTO ECRIT VALUES(252,8382);
INSERT INTO ECRIT VALUES(252,8384);
INSERT INTO ECRIT VALUES(252,8385);
INSERT INTO ECRIT VALUES(256,8462);
INSERT INTO ECRIT VALUES(256,8463);
INSERT INTO ECRIT VALUES(256,8464);
INSERT INTO ECRIT VALUES(256,8465);
INSERT INTO ECRIT VALUES(256,8466);
INSERT INTO ECRIT VALUES(256,8467);
INSERT INTO ECRIT VALUES(256,8468);
INSERT INTO ECRIT VALUES(256,8469);
INSERT INTO ECRIT VALUES(256,8470);
INSERT INTO ECRIT VALUES(256,8471);
INSERT INTO ECRIT VALUES(256,8472);
INSERT INTO ECRIT VALUES(256,8473);
INSERT INTO ECRIT VALUES(256,8474);
INSERT INTO ECRIT VALUES(256,8475);
INSERT INTO ECRIT VALUES(256,8476);
INSERT INTO ECRIT VALUES(256,8477);
INSERT INTO ECRIT VALUES(256,8478);
INSERT INTO ECRIT VALUES(256,8479);
INSERT INTO ECRIT VALUES(168,8480);
INSERT INTO ECRIT VALUES(168,8481);
INSERT INTO ECRIT VALUES(168,8483);
INSERT INTO ECRIT VALUES(168,8484);
INSERT INTO ECRIT VALUES(168,8485);
INSERT INTO ECRIT VALUES(168,8486);
INSERT INTO ECRIT VALUES(168,8487);
INSERT INTO ECRIT VALUES(168,8488);
INSERT INTO ECRIT VALUES(168,8489);
INSERT INTO ECRIT VALUES(168,8490);
INSERT INTO ECRIT VALUES(168,8493);
INSERT INTO ECRIT VALUES(168,8494);
INSERT INTO ECRIT VALUES(168,8495);
INSERT INTO ECRIT VALUES(168,8496);
INSERT INTO ECRIT VALUES(168,8497);
INSERT INTO ECRIT VALUES(168,8498);
INSERT INTO ECRIT VALUES(168,8499);
INSERT INTO ECRIT VALUES(168,8500);
INSERT INTO ECRIT VALUES(216,8523);
INSERT INTO ECRIT VALUES(216,8524);
INSERT INTO ECRIT VALUES(216,8525);
INSERT INTO ECRIT VALUES(216,8526);
INSERT INTO ECRIT VALUES(216,8528);
INSERT INTO ECRIT VALUES(216,8529);
INSERT INTO ECRIT VALUES(216,8530);
INSERT INTO ECRIT VALUES(216,8531);
INSERT INTO ECRIT VALUES(216,8532);
INSERT INTO ECRIT VALUES(216,8533);
INSERT INTO ECRIT VALUES(216,8534);
INSERT INTO ECRIT VALUES(216,8535);
INSERT INTO ECRIT VALUES(216,8536);
INSERT INTO ECRIT VALUES(216,8537);
INSERT INTO ECRIT VALUES(216,8538);
INSERT INTO ECRIT VALUES(216,8540);
INSERT INTO ECRIT VALUES(216,8541);
INSERT INTO ECRIT VALUES(216,8542);
INSERT INTO ECRIT VALUES(168,8543);
INSERT INTO ECRIT VALUES(168,8544);
INSERT INTO ECRIT VALUES(168,8545);
INSERT INTO ECRIT VALUES(168,8546);
INSERT INTO ECRIT VALUES(168,8547);
INSERT INTO ECRIT VALUES(168,8548);
INSERT INTO ECRIT VALUES(168,8549);
INSERT INTO ECRIT VALUES(168,8550);
INSERT INTO ECRIT VALUES(168,8551);
INSERT INTO ECRIT VALUES(168,8552);
INSERT INTO ECRIT VALUES(168,8553);
INSERT INTO ECRIT VALUES(168,8554);
INSERT INTO ECRIT VALUES(168,8555);
INSERT INTO ECRIT VALUES(168,8556);
INSERT INTO ECRIT VALUES(168,8557);
INSERT INTO ECRIT VALUES(168,8558);
INSERT INTO ECRIT VALUES(168,8559);
INSERT INTO ECRIT VALUES(168,8560);
INSERT INTO ECRIT VALUES(168,8561);
INSERT INTO ECRIT VALUES(168,8562);
INSERT INTO ECRIT VALUES(168,8563);
INSERT INTO ECRIT VALUES(168,8564);
INSERT INTO ECRIT VALUES(252,8611);
INSERT INTO ECRIT VALUES(252,8612);
INSERT INTO ECRIT VALUES(252,8613);
INSERT INTO ECRIT VALUES(252,8614);
INSERT INTO ECRIT VALUES(252,8615);
INSERT INTO ECRIT VALUES(252,8616);
INSERT INTO ECRIT VALUES(252,8617);
INSERT INTO ECRIT VALUES(252,8618);
INSERT INTO ECRIT VALUES(252,8619);
INSERT INTO ECRIT VALUES(252,8620);
INSERT INTO ECRIT VALUES(252,8621);
INSERT INTO ECRIT VALUES(252,8622);
INSERT INTO ECRIT VALUES(252,8623);
INSERT INTO ECRIT VALUES(252,8624);
INSERT INTO ECRIT VALUES(252,8625);
INSERT INTO ECRIT VALUES(252,8626);
INSERT INTO ECRIT VALUES(252,8627);
INSERT INTO ECRIT VALUES(252,8628);
INSERT INTO ECRIT VALUES(252,8629);
INSERT INTO ECRIT VALUES(252,8630);
INSERT INTO ECRIT VALUES(252,8631);
INSERT INTO ECRIT VALUES(252,8632);
INSERT INTO ECRIT VALUES(252,8633);
INSERT INTO ECRIT VALUES(252,8634);
INSERT INTO ECRIT VALUES(252,8635);
INSERT INTO ECRIT VALUES(252,8637);
INSERT INTO ECRIT VALUES(252,8638);
INSERT INTO ECRIT VALUES(252,8639);
INSERT INTO ECRIT VALUES(252,8640);
INSERT INTO ECRIT VALUES(252,8641);
INSERT INTO ECRIT VALUES(252,8642);
INSERT INTO ECRIT VALUES(252,8643);
INSERT INTO ECRIT VALUES(252,8644);
INSERT INTO ECRIT VALUES(252,8645);
INSERT INTO ECRIT VALUES(252,8646);
INSERT INTO ECRIT VALUES(252,8647);
INSERT INTO ECRIT VALUES(252,8648);
INSERT INTO ECRIT VALUES(252,8649);
INSERT INTO ECRIT VALUES(252,8650);
INSERT INTO ECRIT VALUES(252,8651);
INSERT INTO ECRIT VALUES(252,8652);
INSERT INTO ECRIT VALUES(252,8653);
INSERT INTO ECRIT VALUES(252,8654);
INSERT INTO ECRIT VALUES(252,8675);
INSERT INTO ECRIT VALUES(252,8676);
INSERT INTO ECRIT VALUES(252,8677);
INSERT INTO ECRIT VALUES(252,8678);
INSERT INTO ECRIT VALUES(252,8679);
INSERT INTO ECRIT VALUES(252,8680);
INSERT INTO ECRIT VALUES(252,8681);
INSERT INTO ECRIT VALUES(252,8682);
INSERT INTO ECRIT VALUES(252,8683);
INSERT INTO ECRIT VALUES(252,8684);
INSERT INTO ECRIT VALUES(252,8685);
INSERT INTO ECRIT VALUES(252,8686);
INSERT INTO ECRIT VALUES(252,8687);
INSERT INTO ECRIT VALUES(252,8688);
INSERT INTO ECRIT VALUES(252,8689);
INSERT INTO ECRIT VALUES(252,8690);
INSERT INTO ECRIT VALUES(252,8691);
INSERT INTO ECRIT VALUES(252,8692);
INSERT INTO ECRIT VALUES(252,8693);
INSERT INTO ECRIT VALUES(252,8694);
INSERT INTO ECRIT VALUES(252,8695);
INSERT INTO ECRIT VALUES(168,8749);
INSERT INTO ECRIT VALUES(168,8750);
INSERT INTO ECRIT VALUES(168,8751);
INSERT INTO ECRIT VALUES(168,8752);
INSERT INTO ECRIT VALUES(168,8753);
INSERT INTO ECRIT VALUES(168,8754);
INSERT INTO ECRIT VALUES(168,8755);
INSERT INTO ECRIT VALUES(168,8756);
INSERT INTO ECRIT VALUES(168,8757);
INSERT INTO ECRIT VALUES(168,8758);
INSERT INTO ECRIT VALUES(168,8759);
INSERT INTO ECRIT VALUES(168,8760);
INSERT INTO ECRIT VALUES(168,8761);
INSERT INTO ECRIT VALUES(168,8762);
INSERT INTO ECRIT VALUES(168,8763);
INSERT INTO ECRIT VALUES(168,8764);
INSERT INTO ECRIT VALUES(168,8765);
INSERT INTO ECRIT VALUES(168,8766);
INSERT INTO ECRIT VALUES(168,8767);
INSERT INTO ECRIT VALUES(168,8768);
INSERT INTO ECRIT VALUES(168,8769);
INSERT INTO ECRIT VALUES(168,8770);
INSERT INTO ECRIT VALUES(168,8771);
INSERT INTO ECRIT VALUES(168,8772);
INSERT INTO ECRIT VALUES(168,8815);
INSERT INTO ECRIT VALUES(168,8816);
INSERT INTO ECRIT VALUES(168,8817);
INSERT INTO ECRIT VALUES(168,8818);
INSERT INTO ECRIT VALUES(168,8819);
INSERT INTO ECRIT VALUES(168,8820);
INSERT INTO ECRIT VALUES(168,8821);
INSERT INTO ECRIT VALUES(168,8822);
INSERT INTO ECRIT VALUES(168,8823);
INSERT INTO ECRIT VALUES(168,8824);
INSERT INTO ECRIT VALUES(168,8825);
INSERT INTO ECRIT VALUES(168,8826);
INSERT INTO ECRIT VALUES(168,8827);
INSERT INTO ECRIT VALUES(168,8828);
INSERT INTO ECRIT VALUES(168,8829);
INSERT INTO ECRIT VALUES(168,8830);
INSERT INTO ECRIT VALUES(168,8831);
INSERT INTO ECRIT VALUES(168,8832);
INSERT INTO ECRIT VALUES(168,8833);
INSERT INTO ECRIT VALUES(168,8834);
INSERT INTO ECRIT VALUES(168,8835);
INSERT INTO ECRIT VALUES(168,8837);
INSERT INTO ECRIT VALUES(168,8838);
INSERT INTO ECRIT VALUES(168,8839);
INSERT INTO ECRIT VALUES(168,8840);
INSERT INTO ECRIT VALUES(168,8841);
INSERT INTO ECRIT VALUES(168,8842);
INSERT INTO ECRIT VALUES(168,8843);
INSERT INTO ECRIT VALUES(168,8844);
INSERT INTO ECRIT VALUES(168,8845);
INSERT INTO ECRIT VALUES(168,8846);
INSERT INTO ECRIT VALUES(168,8847);
INSERT INTO ECRIT VALUES(168,8848);
INSERT INTO ECRIT VALUES(168,8849);
INSERT INTO ECRIT VALUES(168,8850);
INSERT INTO ECRIT VALUES(168,8851);
INSERT INTO ECRIT VALUES(168,8852);
INSERT INTO ECRIT VALUES(168,8853);
INSERT INTO ECRIT VALUES(168,8854);
INSERT INTO ECRIT VALUES(168,8855);
INSERT INTO ECRIT VALUES(168,8857);
INSERT INTO ECRIT VALUES(168,8859);
INSERT INTO ECRIT VALUES(168,8860);
INSERT INTO ECRIT VALUES(168,8861);
INSERT INTO ECRIT VALUES(168,8897);
INSERT INTO ECRIT VALUES(168,8898);
INSERT INTO ECRIT VALUES(168,8899);
INSERT INTO ECRIT VALUES(168,8900);
INSERT INTO ECRIT VALUES(168,8901);
INSERT INTO ECRIT VALUES(168,8902);
INSERT INTO ECRIT VALUES(168,8903);
INSERT INTO ECRIT VALUES(168,8904);
INSERT INTO ECRIT VALUES(168,8905);
INSERT INTO ECRIT VALUES(168,8906);
INSERT INTO ECRIT VALUES(168,8907);
INSERT INTO ECRIT VALUES(168,8908);
INSERT INTO ECRIT VALUES(168,8909);
INSERT INTO ECRIT VALUES(168,8910);
INSERT INTO ECRIT VALUES(168,8911);
INSERT INTO ECRIT VALUES(168,8912);
INSERT INTO ECRIT VALUES(168,8913);
INSERT INTO ECRIT VALUES(168,8914);
INSERT INTO ECRIT VALUES(168,8915);
INSERT INTO ECRIT VALUES(168,8916);
INSERT INTO ECRIT VALUES(168,8917);
INSERT INTO ECRIT VALUES(168,8919);
INSERT INTO ECRIT VALUES(168,8935);
INSERT INTO ECRIT VALUES(168,8936);
INSERT INTO ECRIT VALUES(168,8937);
INSERT INTO ECRIT VALUES(168,8938);
INSERT INTO ECRIT VALUES(168,8939);
INSERT INTO ECRIT VALUES(168,8940);
INSERT INTO ECRIT VALUES(168,8942);
INSERT INTO ECRIT VALUES(216,8991);
INSERT INTO ECRIT VALUES(216,8992);
INSERT INTO ECRIT VALUES(216,8993);
INSERT INTO ECRIT VALUES(216,8994);
INSERT INTO ECRIT VALUES(216,8995);
INSERT INTO ECRIT VALUES(216,8997);
INSERT INTO ECRIT VALUES(216,8998);
INSERT INTO ECRIT VALUES(216,8999);
INSERT INTO ECRIT VALUES(216,9001);
INSERT INTO ECRIT VALUES(216,9002);
INSERT INTO ECRIT VALUES(216,9003);
INSERT INTO ECRIT VALUES(216,9004);
INSERT INTO ECRIT VALUES(216,9015);
INSERT INTO ECRIT VALUES(216,9016);
INSERT INTO ECRIT VALUES(216,9017);
INSERT INTO ECRIT VALUES(216,9018);
INSERT INTO ECRIT VALUES(216,9019);
INSERT INTO ECRIT VALUES(216,9020);
INSERT INTO ECRIT VALUES(216,9021);
INSERT INTO ECRIT VALUES(216,9022);
INSERT INTO ECRIT VALUES(216,9023);
INSERT INTO ECRIT VALUES(216,9024);
INSERT INTO ECRIT VALUES(216,9026);
INSERT INTO ECRIT VALUES(263,9034);
INSERT INTO ECRIT VALUES(263,9035);
INSERT INTO ECRIT VALUES(263,9036);
INSERT INTO ECRIT VALUES(263,9037);
INSERT INTO ECRIT VALUES(263,9038);
INSERT INTO ECRIT VALUES(263,9039);
INSERT INTO ECRIT VALUES(263,9040);
INSERT INTO ECRIT VALUES(263,9041);
INSERT INTO ECRIT VALUES(263,9042);
INSERT INTO ECRIT VALUES(216,9054);
INSERT INTO ECRIT VALUES(216,9055);
INSERT INTO ECRIT VALUES(216,9064);
INSERT INTO ECRIT VALUES(216,9066);
INSERT INTO ECRIT VALUES(216,9067);
INSERT INTO ECRIT VALUES(216,9068);
INSERT INTO ECRIT VALUES(216,9069);
INSERT INTO ECRIT VALUES(216,9070);
INSERT INTO ECRIT VALUES(216,9071);
INSERT INTO ECRIT VALUES(216,9072);
INSERT INTO ECRIT VALUES(216,9073);
INSERT INTO ECRIT VALUES(216,9091);
INSERT INTO ECRIT VALUES(216,9092);
INSERT INTO ECRIT VALUES(216,9093);
INSERT INTO ECRIT VALUES(216,9094);
INSERT INTO ECRIT VALUES(216,9095);
INSERT INTO ECRIT VALUES(216,9108);
INSERT INTO ECRIT VALUES(216,9109);
INSERT INTO ECRIT VALUES(216,9110);
INSERT INTO ECRIT VALUES(216,9112);
INSERT INTO ECRIT VALUES(216,9113);
INSERT INTO ECRIT VALUES(216,9114);
INSERT INTO ECRIT VALUES(216,9115);
INSERT INTO ECRIT VALUES(216,9116);
INSERT INTO ECRIT VALUES(216,9117);
INSERT INTO ECRIT VALUES(168,9126);
INSERT INTO ECRIT VALUES(168,9127);
INSERT INTO ECRIT VALUES(168,9128);
INSERT INTO ECRIT VALUES(168,9130);
INSERT INTO ECRIT VALUES(168,9131);
INSERT INTO ECRIT VALUES(216,9217);
INSERT INTO ECRIT VALUES(216,9218);
INSERT INTO ECRIT VALUES(216,9219);
INSERT INTO ECRIT VALUES(216,9220);
INSERT INTO ECRIT VALUES(216,9221);
INSERT INTO ECRIT VALUES(216,9222);
INSERT INTO ECRIT VALUES(216,9223);
INSERT INTO ECRIT VALUES(216,9224);
INSERT INTO ECRIT VALUES(216,9225);
INSERT INTO ECRIT VALUES(216,9226);
INSERT INTO ECRIT VALUES(216,9227);
INSERT INTO ECRIT VALUES(216,9228);
INSERT INTO ECRIT VALUES(216,9229);
INSERT INTO ECRIT VALUES(216,9230);
INSERT INTO ECRIT VALUES(216,9231);
INSERT INTO ECRIT VALUES(216,9232);
INSERT INTO ECRIT VALUES(252,9239);
INSERT INTO ECRIT VALUES(216,9244);
INSERT INTO ECRIT VALUES(216,9245);
INSERT INTO ECRIT VALUES(216,9246);
INSERT INTO ECRIT VALUES(216,9247);
INSERT INTO ECRIT VALUES(216,9248);
INSERT INTO ECRIT VALUES(216,9249);
INSERT INTO ECRIT VALUES(216,9250);
INSERT INTO ECRIT VALUES(216,9251);
INSERT INTO ECRIT VALUES(216,9252);
INSERT INTO ECRIT VALUES(216,9253);
INSERT INTO ECRIT VALUES(216,9254);
INSERT INTO ECRIT VALUES(168,9256);
INSERT INTO ECRIT VALUES(168,9258);
INSERT INTO ECRIT VALUES(168,9259);
INSERT INTO ECRIT VALUES(168,9260);
INSERT INTO ECRIT VALUES(168,9261);
INSERT INTO ECRIT VALUES(168,9262);
INSERT INTO ECRIT VALUES(168,9263);
INSERT INTO ECRIT VALUES(168,9264);
INSERT INTO ECRIT VALUES(168,9265);
INSERT INTO ECRIT VALUES(168,9266);
INSERT INTO ECRIT VALUES(168,9267);
INSERT INTO ECRIT VALUES(168,9268);
INSERT INTO ECRIT VALUES(168,9269);
INSERT INTO ECRIT VALUES(168,9270);
INSERT INTO ECRIT VALUES(168,9271);
INSERT INTO ECRIT VALUES(168,9272);
INSERT INTO ECRIT VALUES(168,9273);
INSERT INTO ECRIT VALUES(168,9274);
INSERT INTO ECRIT VALUES(168,9275);
INSERT INTO ECRIT VALUES(168,9276);
INSERT INTO ECRIT VALUES(168,9277);
INSERT INTO ECRIT VALUES(168,9278);
INSERT INTO ECRIT VALUES(168,9279);
INSERT INTO ECRIT VALUES(168,9280);
INSERT INTO ECRIT VALUES(168,9281);
INSERT INTO ECRIT VALUES(216,9302);
INSERT INTO ECRIT VALUES(216,9303);
INSERT INTO ECRIT VALUES(216,9304);
INSERT INTO ECRIT VALUES(216,9305);
INSERT INTO ECRIT VALUES(216,9306);
INSERT INTO ECRIT VALUES(216,9307);
INSERT INTO ECRIT VALUES(252,9425);
INSERT INTO ECRIT VALUES(252,9426);
INSERT INTO ECRIT VALUES(252,9427);
INSERT INTO ECRIT VALUES(252,9429);
INSERT INTO ECRIT VALUES(252,9430);
INSERT INTO ECRIT VALUES(252,9431);
INSERT INTO ECRIT VALUES(252,9433);
INSERT INTO ECRIT VALUES(252,9434);
INSERT INTO ECRIT VALUES(252,9435);
INSERT INTO ECRIT VALUES(252,9436);
INSERT INTO ECRIT VALUES(216,9437);
INSERT INTO ECRIT VALUES(216,9438);
INSERT INTO ECRIT VALUES(216,9439);
INSERT INTO ECRIT VALUES(216,9440);
INSERT INTO ECRIT VALUES(216,9441);
INSERT INTO ECRIT VALUES(216,9442);
INSERT INTO ECRIT VALUES(216,9443);
INSERT INTO ECRIT VALUES(216,9444);
INSERT INTO ECRIT VALUES(216,9445);
INSERT INTO ECRIT VALUES(216,9446);
INSERT INTO ECRIT VALUES(216,9447);
INSERT INTO ECRIT VALUES(216,9448);
INSERT INTO ECRIT VALUES(216,9449);
INSERT INTO ECRIT VALUES(216,9450);
INSERT INTO ECRIT VALUES(252,9536);
INSERT INTO ECRIT VALUES(252,9537);
INSERT INTO ECRIT VALUES(252,9538);
INSERT INTO ECRIT VALUES(252,9539);
INSERT INTO ECRIT VALUES(252,9542);
INSERT INTO ECRIT VALUES(252,9545);
INSERT INTO ECRIT VALUES(252,9548);
INSERT INTO ECRIT VALUES(252,9549);
INSERT INTO ECRIT VALUES(216,9551);
INSERT INTO ECRIT VALUES(216,9552);
INSERT INTO ECRIT VALUES(216,9553);
INSERT INTO ECRIT VALUES(216,9554);
INSERT INTO ECRIT VALUES(216,9555);
INSERT INTO ECRIT VALUES(216,9556);
INSERT INTO ECRIT VALUES(216,9557);
INSERT INTO ECRIT VALUES(216,9558);
INSERT INTO ECRIT VALUES(216,9559);
INSERT INTO ECRIT VALUES(216,9560);
INSERT INTO ECRIT VALUES(216,9561);
INSERT INTO ECRIT VALUES(216,9562);
INSERT INTO ECRIT VALUES(216,9563);
INSERT INTO ECRIT VALUES(216,9564);
INSERT INTO ECRIT VALUES(216,9565);
INSERT INTO ECRIT VALUES(216,9566);
INSERT INTO ECRIT VALUES(216,9567);
INSERT INTO ECRIT VALUES(168,9665);
INSERT INTO ECRIT VALUES(168,9666);
INSERT INTO ECRIT VALUES(168,9668);
INSERT INTO ECRIT VALUES(168,9669);
INSERT INTO ECRIT VALUES(168,9670);
INSERT INTO ECRIT VALUES(168,9671);
INSERT INTO ECRIT VALUES(168,9672);
INSERT INTO ECRIT VALUES(168,9673);
INSERT INTO ECRIT VALUES(168,9675);
INSERT INTO ECRIT VALUES(168,9677);
INSERT INTO ECRIT VALUES(168,9678);
INSERT INTO ECRIT VALUES(252,9714);
INSERT INTO ECRIT VALUES(252,9715);
INSERT INTO ECRIT VALUES(252,9718);
INSERT INTO ECRIT VALUES(252,9719);
INSERT INTO ECRIT VALUES(252,9721);
INSERT INTO ECRIT VALUES(252,9722);
INSERT INTO ECRIT VALUES(252,9723);
INSERT INTO ECRIT VALUES(252,9724);
INSERT INTO ECRIT VALUES(252,9725);
INSERT INTO ECRIT VALUES(252,9726);
INSERT INTO ECRIT VALUES(252,9727);
INSERT INTO ECRIT VALUES(252,9728);
INSERT INTO ECRIT VALUES(252,9765);
INSERT INTO ECRIT VALUES(252,9766);
INSERT INTO ECRIT VALUES(252,9767);
INSERT INTO ECRIT VALUES(252,9768);
INSERT INTO ECRIT VALUES(252,9769);
INSERT INTO ECRIT VALUES(252,9770);
INSERT INTO ECRIT VALUES(252,9771);
INSERT INTO ECRIT VALUES(252,9772);
INSERT INTO ECRIT VALUES(252,9773);
INSERT INTO ECRIT VALUES(252,9774);
INSERT INTO ECRIT VALUES(252,9775);
INSERT INTO ECRIT VALUES(252,9776);
INSERT INTO ECRIT VALUES(252,9777);
INSERT INTO ECRIT VALUES(252,9778);
INSERT INTO ECRIT VALUES(252,9779);
INSERT INTO ECRIT VALUES(252,9780);
INSERT INTO ECRIT VALUES(252,9781);
INSERT INTO ECRIT VALUES(252,9783);
INSERT INTO ECRIT VALUES(52,10844);
INSERT INTO ECRIT VALUES(284,10890);
INSERT INTO ECRIT VALUES(284,10891);
INSERT INTO ECRIT VALUES(80,10985);
INSERT INTO ECRIT VALUES(100,10985);
INSERT INTO ECRIT VALUES(80,10987);
INSERT INTO ECRIT VALUES(100,10987);
INSERT INTO ECRIT VALUES(80,10989);
INSERT INTO ECRIT VALUES(100,10989);
INSERT INTO ECRIT VALUES(80,10991);
INSERT INTO ECRIT VALUES(100,10991);
INSERT INTO ECRIT VALUES(80,10993);
INSERT INTO ECRIT VALUES(100,10993);
INSERT INTO ECRIT VALUES(80,11001);
INSERT INTO ECRIT VALUES(100,11001);
INSERT INTO ECRIT VALUES(165,11024);
INSERT INTO ECRIT VALUES(80,11054);
INSERT INTO ECRIT VALUES(100,11054);
INSERT INTO ECRIT VALUES(80,11058);
INSERT INTO ECRIT VALUES(100,11058);
INSERT INTO ECRIT VALUES(80,11060);
INSERT INTO ECRIT VALUES(100,11060);
INSERT INTO ECRIT VALUES(80,11061);
INSERT INTO ECRIT VALUES(100,11061);
INSERT INTO ECRIT VALUES(80,11064);
INSERT INTO ECRIT VALUES(100,11064);
INSERT INTO ECRIT VALUES(80,11069);
INSERT INTO ECRIT VALUES(100,11069);
INSERT INTO ECRIT VALUES(80,11070);
INSERT INTO ECRIT VALUES(100,11070);
INSERT INTO ECRIT VALUES(80,11071);
INSERT INTO ECRIT VALUES(100,11071);
INSERT INTO ECRIT VALUES(80,11072);
INSERT INTO ECRIT VALUES(100,11072);
INSERT INTO ECRIT VALUES(80,11074);
INSERT INTO ECRIT VALUES(100,11074);
INSERT INTO ECRIT VALUES(80,11075);
INSERT INTO ECRIT VALUES(100,11075);
INSERT INTO ECRIT VALUES(80,11076);
INSERT INTO ECRIT VALUES(100,11076);
INSERT INTO ECRIT VALUES(80,11078);
INSERT INTO ECRIT VALUES(100,11078);
INSERT INTO ECRIT VALUES(80,11081);
INSERT INTO ECRIT VALUES(100,11081);
INSERT INTO ECRIT VALUES(80,11083);
INSERT INTO ECRIT VALUES(100,11083);
INSERT INTO ECRIT VALUES(80,11085);
INSERT INTO ECRIT VALUES(100,11085);
INSERT INTO ECRIT VALUES(80,11086);
INSERT INTO ECRIT VALUES(100,11086);
INSERT INTO ECRIT VALUES(80,11087);
INSERT INTO ECRIT VALUES(100,11087);
INSERT INTO ECRIT VALUES(80,11100);
INSERT INTO ECRIT VALUES(100,11100);
INSERT INTO ECRIT VALUES(80,11105);
INSERT INTO ECRIT VALUES(100,11105);
INSERT INTO ECRIT VALUES(80,11106);
INSERT INTO ECRIT VALUES(100,11106);
INSERT INTO ECRIT VALUES(80,11107);
INSERT INTO ECRIT VALUES(100,11107);
INSERT INTO ECRIT VALUES(80,11110);
INSERT INTO ECRIT VALUES(100,11110);
INSERT INTO ECRIT VALUES(80,11111);
INSERT INTO ECRIT VALUES(100,11111);
INSERT INTO ECRIT VALUES(80,11112);
INSERT INTO ECRIT VALUES(100,11112);
INSERT INTO ECRIT VALUES(80,11117);
INSERT INTO ECRIT VALUES(100,11117);
INSERT INTO ECRIT VALUES(80,11118);
INSERT INTO ECRIT VALUES(100,11118);
INSERT INTO ECRIT VALUES(80,11120);
INSERT INTO ECRIT VALUES(100,11120);
INSERT INTO ECRIT VALUES(80,11122);
INSERT INTO ECRIT VALUES(100,11122);
INSERT INTO ECRIT VALUES(80,11123);
INSERT INTO ECRIT VALUES(100,11123);
INSERT INTO ECRIT VALUES(80,11124);
INSERT INTO ECRIT VALUES(100,11124);
INSERT INTO ECRIT VALUES(80,11136);
INSERT INTO ECRIT VALUES(100,11136);
INSERT INTO ECRIT VALUES(80,11139);
INSERT INTO ECRIT VALUES(100,11139);
INSERT INTO ECRIT VALUES(80,11143);
INSERT INTO ECRIT VALUES(100,11143);
INSERT INTO ECRIT VALUES(80,11146);
INSERT INTO ECRIT VALUES(100,11146);
INSERT INTO ECRIT VALUES(80,11147);
INSERT INTO ECRIT VALUES(100,11147);
INSERT INTO ECRIT VALUES(80,11153);
INSERT INTO ECRIT VALUES(100,11153);
INSERT INTO ECRIT VALUES(80,11156);
INSERT INTO ECRIT VALUES(100,11156);
INSERT INTO ECRIT VALUES(80,11162);
INSERT INTO ECRIT VALUES(100,11162);
INSERT INTO ECRIT VALUES(80,11163);
INSERT INTO ECRIT VALUES(100,11163);
INSERT INTO ECRIT VALUES(80,11165);
INSERT INTO ECRIT VALUES(100,11165);
INSERT INTO ECRIT VALUES(80,11168);
INSERT INTO ECRIT VALUES(100,11168);
INSERT INTO ECRIT VALUES(80,11171);
INSERT INTO ECRIT VALUES(100,11171);
INSERT INTO ECRIT VALUES(80,11172);
INSERT INTO ECRIT VALUES(100,11172);
INSERT INTO ECRIT VALUES(80,11173);
INSERT INTO ECRIT VALUES(100,11173);
INSERT INTO ECRIT VALUES(80,11174);
INSERT INTO ECRIT VALUES(100,11174);
INSERT INTO ECRIT VALUES(80,11175);
INSERT INTO ECRIT VALUES(100,11175);
INSERT INTO ECRIT VALUES(80,11176);
INSERT INTO ECRIT VALUES(100,11176);
INSERT INTO ECRIT VALUES(80,11177);
INSERT INTO ECRIT VALUES(100,11177);
INSERT INTO ECRIT VALUES(80,11178);
INSERT INTO ECRIT VALUES(100,11178);
INSERT INTO ECRIT VALUES(80,11179);
INSERT INTO ECRIT VALUES(100,11179);
INSERT INTO ECRIT VALUES(80,11180);
INSERT INTO ECRIT VALUES(100,11180);
INSERT INTO ECRIT VALUES(80,11181);
INSERT INTO ECRIT VALUES(100,11181);
INSERT INTO ECRIT VALUES(80,11183);
INSERT INTO ECRIT VALUES(100,11183);
INSERT INTO ECRIT VALUES(80,11184);
INSERT INTO ECRIT VALUES(100,11184);
INSERT INTO ECRIT VALUES(80,11185);
INSERT INTO ECRIT VALUES(100,11185);
INSERT INTO ECRIT VALUES(80,11186);
INSERT INTO ECRIT VALUES(100,11186);
INSERT INTO ECRIT VALUES(80,11187);
INSERT INTO ECRIT VALUES(100,11187);
INSERT INTO ECRIT VALUES(80,11188);
INSERT INTO ECRIT VALUES(100,11188);
INSERT INTO ECRIT VALUES(80,11189);
INSERT INTO ECRIT VALUES(100,11189);
INSERT INTO ECRIT VALUES(80,11190);
INSERT INTO ECRIT VALUES(100,11190);
INSERT INTO ECRIT VALUES(80,11296);
INSERT INTO ECRIT VALUES(100,11296);
INSERT INTO ECRIT VALUES(80,11300);
INSERT INTO ECRIT VALUES(100,11300);
INSERT INTO ECRIT VALUES(80,11302);
INSERT INTO ECRIT VALUES(100,11302);
INSERT INTO ECRIT VALUES(80,11303);
INSERT INTO ECRIT VALUES(100,11303);
INSERT INTO ECRIT VALUES(80,11304);
INSERT INTO ECRIT VALUES(100,11304);
INSERT INTO ECRIT VALUES(80,11305);
INSERT INTO ECRIT VALUES(100,11305);
INSERT INTO ECRIT VALUES(80,11306);
INSERT INTO ECRIT VALUES(100,11306);
INSERT INTO ECRIT VALUES(80,11307);
INSERT INTO ECRIT VALUES(100,11307);
INSERT INTO ECRIT VALUES(80,11308);
INSERT INTO ECRIT VALUES(100,11308);
INSERT INTO ECRIT VALUES(80,11309);
INSERT INTO ECRIT VALUES(100,11309);
INSERT INTO ECRIT VALUES(80,11311);
INSERT INTO ECRIT VALUES(100,11311);
INSERT INTO ECRIT VALUES(80,11315);
INSERT INTO ECRIT VALUES(100,11315);
INSERT INTO ECRIT VALUES(80,11316);
INSERT INTO ECRIT VALUES(100,11316);
INSERT INTO ECRIT VALUES(80,11318);
INSERT INTO ECRIT VALUES(100,11318);
INSERT INTO ECRIT VALUES(80,11319);
INSERT INTO ECRIT VALUES(100,11319);
INSERT INTO ECRIT VALUES(168,11558);
INSERT INTO ECRIT VALUES(168,11560);
INSERT INTO ECRIT VALUES(168,11561);
INSERT INTO ECRIT VALUES(168,11562);
INSERT INTO ECRIT VALUES(168,11563);
INSERT INTO ECRIT VALUES(168,11564);
INSERT INTO ECRIT VALUES(168,11565);
INSERT INTO ECRIT VALUES(168,11566);
INSERT INTO ECRIT VALUES(168,11567);
INSERT INTO ECRIT VALUES(168,11568);
INSERT INTO ECRIT VALUES(168,11569);
INSERT INTO ECRIT VALUES(168,11570);
INSERT INTO ECRIT VALUES(168,11571);
INSERT INTO ECRIT VALUES(168,11572);
INSERT INTO ECRIT VALUES(168,11573);
INSERT INTO ECRIT VALUES(168,11575);
INSERT INTO ECRIT VALUES(168,11576);
INSERT INTO ECRIT VALUES(168,11577);
INSERT INTO ECRIT VALUES(168,11578);
INSERT INTO ECRIT VALUES(168,11579);
INSERT INTO ECRIT VALUES(168,11581);
INSERT INTO ECRIT VALUES(168,11582);
INSERT INTO ECRIT VALUES(168,11583);
INSERT INTO ECRIT VALUES(168,11584);
INSERT INTO ECRIT VALUES(168,11585);
INSERT INTO CHANSON VALUES(1,'Jean Baltazaarrr',2,NULL,'f','2008-03-12 17:20:27');
INSERT INTO CHANSON VALUES(2,'Mona Lisa Klaxon',2,NULL,'f','2008-03-12 14:42:03');
INSERT INTO CHANSON VALUES(3,'Le Sud',2,NULL,'f','2008-03-12 15:53:26');
INSERT INTO CHANSON VALUES(4,'Louis',2,NULL,'f','2008-03-12 15:33:12');
INSERT INTO CHANSON VALUES(5,'The girl in black',0,NULL,'f','2008-03-12 13:41:36');
INSERT INTO CHANSON VALUES(6,'I can tell',0,NULL,'f','2008-03-12 09:27:09');
INSERT INTO CHANSON VALUES(7,'Lonely in the dark',0,NULL,NULL,'2008-03-12 16:32:17');
INSERT INTO CHANSON VALUES(8,'tesax chainsaw',0,NULL,'f','2008-03-12 18:16:48');
INSERT INTO CHANSON VALUES(9,'Milkcow blues',0,NULL,NULL,'2008-03-12 15:26:49');
INSERT INTO CHANSON VALUES(10,'Death is a bitch',0,NULL,'f','2008-03-12 10:56:50');
INSERT INTO CHANSON VALUES(11,'This ain''t no jukebox... we''re a rock''n roll band',0,NULL,NULL,'2008-03-12 15:44:11');
INSERT INTO CHANSON VALUES(12,'Take a chance on love',0,NULL,'f','2008-03-12 09:15:54');
INSERT INTO CHANSON VALUES(13,'The truck won''t start',0,NULL,NULL,'2008-03-12 09:55:47');
INSERT INTO CHANSON VALUES(14,'Phantom of the strip',0,NULL,'f','2008-03-12 15:32:21');
INSERT INTO CHANSON VALUES(15,'How could you',0,NULL,'f','2008-03-12 17:58:02');
INSERT INTO CHANSON VALUES(16,'Hellbound train',0,NULL,'f','2008-03-12 12:08:30');
INSERT INTO CHANSON VALUES(17,'Street legal',0,NULL,'f','2008-03-12 14:49:03');
INSERT INTO CHANSON VALUES(18,'What can I say',0,NULL,'f','2008-03-12 18:40:19');
INSERT INTO CHANSON VALUES(19,'Blues highway',0,NULL,'f','2008-03-12 15:17:46');
INSERT INTO CHANSON VALUES(20,'Look what the cat drug in',0,NULL,'f','2008-03-12 13:27:42');
INSERT INTO CHANSON VALUES(21,'Sam Brown',0,NULL,'f','2008-03-12 11:06:27');
INSERT INTO CHANSON VALUES(22,'Common One',0,NULL,'f','2008-03-12 14:11:43');
INSERT INTO CHANSON VALUES(23,'Wild Wild West',0,NULL,'f','2008-03-12 12:21:38');
INSERT INTO CHANSON VALUES(24,'Somewhere Over The Rainbrown',0,NULL,'f','2008-03-12 10:57:10');
INSERT INTO CHANSON VALUES(25,'The Hole',0,NULL,'f','2008-03-12 14:46:08');
INSERT INTO CHANSON VALUES(26,'That Wouldn''t Be Enought',0,NULL,'f','2008-03-12 15:10:16');
INSERT INTO CHANSON VALUES(27,'Where The Blues Get Born',0,NULL,NULL,'2008-03-12 09:44:06');
INSERT INTO CHANSON VALUES(28,'Texas Bop',0,NULL,'f','2008-03-12 10:35:46');
INSERT INTO CHANSON VALUES(29,'Retcha',0,NULL,'f','2008-03-12 14:14:04');
INSERT INTO CHANSON VALUES(30,'Dream Of A Better World',0,NULL,'f','2008-03-12 11:42:32');
INSERT INTO CHANSON VALUES(31,'Hells Bells',2,NULL,'f','2008-04-24 14:14:21');
INSERT INTO CHANSON VALUES(32,'Shoot To Thrill',2,NULL,'f','2008-03-12 19:01:38');
INSERT INTO CHANSON VALUES(33,'What Do You Do For Money Honey',2,NULL,'f','2008-03-12 13:31:50');
INSERT INTO CHANSON VALUES(34,'Given The Dog A Bone',2,NULL,'f','2008-03-12 09:56:12');
INSERT INTO CHANSON VALUES(35,'Let Me Put My Love Into You',2,NULL,'f','2008-03-12 17:08:10');
INSERT INTO CHANSON VALUES(36,'Back In Black',2,NULL,'f','2008-03-12 19:42:56');
INSERT INTO CHANSON VALUES(37,'You Shock Me All Night Long',2,NULL,'f','2008-03-12 09:18:07');
INSERT INTO CHANSON VALUES(38,'Have A Drink On Me',2,NULL,'f','2008-03-12 12:25:51');
INSERT INTO CHANSON VALUES(39,'Shake A Leg',2,NULL,'f','2008-03-12 14:36:26');
INSERT INTO CHANSON VALUES(40,'Rock And Roll Ain''t Noise Pollution',2,NULL,'f','2008-03-12 11:06:40');
INSERT INTO CHANSON VALUES(41,'Let the music play',0,NULL,'f','2008-03-12 12:22:22');
INSERT INTO CHANSON VALUES(42,'Nothin'' can save me',0,NULL,'f','2008-03-12 19:21:23');
INSERT INTO CHANSON VALUES(43,'I want to change the world',0,NULL,'f','2008-03-12 14:47:55');
INSERT INTO CHANSON VALUES(44,'Desperation',0,NULL,'f','2008-03-12 12:57:52');
INSERT INTO CHANSON VALUES(45,'Lovin'' you',0,NULL,NULL,'2008-03-12 15:45:00');
INSERT INTO CHANSON VALUES(46,'Mr.Mudd and Mr.Gold',0,NULL,'f','2008-03-12 17:44:42');
INSERT INTO CHANSON VALUES(47,'My love is so',0,NULL,'f','2008-03-12 16:52:01');
INSERT INTO CHANSON VALUES(48,'Time flies',0,NULL,NULL,'2008-03-12 18:17:26');
INSERT INTO CHANSON VALUES(49,'Cut the silver strings',0,NULL,'f','2008-03-12 16:48:02');
INSERT INTO CHANSON VALUES(50,'Drive by',0,NULL,'f','2008-03-12 09:06:09');
INSERT INTO CHANSON VALUES(51,'Phone booth',0,NULL,'f','2008-03-12 17:28:31');
INSERT INTO CHANSON VALUES(52,'Bad influence',0,NULL,'f','2008-03-12 10:24:53');
INSERT INTO CHANSON VALUES(53,'More than I can stand',0,NULL,'f','2008-03-12 15:57:41');
INSERT INTO CHANSON VALUES(54,'T-Bone shuffle',0,NULL,'f','2008-03-12 14:22:38');
INSERT INTO CHANSON VALUES(55,'False accusations',0,NULL,'f','2008-03-12 12:59:24');
INSERT INTO CHANSON VALUES(56,'I guess showed her',0,NULL,'f','2008-03-12 12:46:09');
INSERT INTO CHANSON VALUES(57,'Foul play',0,NULL,'f','2008-03-12 09:29:02');
INSERT INTO CHANSON VALUES(58,'Right next door',0,NULL,'f','2008-03-12 09:20:20');
INSERT INTO CHANSON VALUES(59,'Playing in the dirt',0,NULL,'f','2008-03-12 15:01:08');
INSERT INTO CHANSON VALUES(60,'Too many cooks',0,NULL,NULL,'2008-03-12 15:10:15');
INSERT INTO CHANSON VALUES(61,'Smokin'' gun',0,NULL,'f','2008-03-12 17:58:44');
INSERT INTO CHANSON VALUES(62,'Soldier',0,NULL,'f','2008-03-12 11:10:08');
INSERT INTO CHANSON VALUES(63,'Stranger',0,NULL,'f','2008-03-12 10:45:06');
INSERT INTO CHANSON VALUES(64,'Characters',0,NULL,'f','2008-03-12 18:16:28');
INSERT INTO CHANSON VALUES(65,'I Dreamed I Saw',0,NULL,'f','2008-03-12 14:40:27');
INSERT INTO CHANSON VALUES(66,'Rats & Roaches',0,NULL,'f','2008-03-12 19:04:13');
INSERT INTO CHANSON VALUES(67,'Down In Texas',0,NULL,'f','2008-03-12 09:11:43');
INSERT INTO CHANSON VALUES(68,'Shackles And Chains',0,NULL,'f','2008-03-12 09:19:03');
INSERT INTO CHANSON VALUES(69,'This Could Be The Day',0,NULL,'f','2008-03-12 13:54:05');
INSERT INTO CHANSON VALUES(70,'This Is Your World',0,NULL,'f','2008-03-12 15:32:15');
INSERT INTO CHANSON VALUES(71,'Army Of Me',2,NULL,'f','2008-03-12 18:19:14');
INSERT INTO CHANSON VALUES(72,'Hyper-ballad',2,NULL,'f','2008-03-12 15:38:24');
INSERT INTO CHANSON VALUES(73,'The Modern Things',2,NULL,'f','2008-03-12 17:50:10');
INSERT INTO CHANSON VALUES(74,'It''s Oh So Quiet',2,NULL,'f','2008-03-12 18:43:27');
INSERT INTO CHANSON VALUES(75,'Enjoy',2,NULL,'f','2008-03-12 11:16:07');
INSERT INTO CHANSON VALUES(76,'You''ve Been Flirting Again',2,NULL,'f','2008-03-12 17:12:11');
INSERT INTO CHANSON VALUES(77,'Isobel',2,NULL,'f','2008-03-12 08:19:23');
INSERT INTO CHANSON VALUES(78,'Possibly Maybe',2,NULL,'f','2008-03-12 16:28:43');
INSERT INTO CHANSON VALUES(79,'I Miss You',2,NULL,'f','2008-04-13 19:06:11');
INSERT INTO CHANSON VALUES(80,'Cover Me',2,NULL,'f','2008-03-12 17:57:37');
INSERT INTO CHANSON VALUES(81,'Headphones',2,NULL,'f','2008-03-12 18:34:10');
INSERT INTO CHANSON VALUES(82,'Don'' turn your head',0,NULL,'f','2008-03-12 09:27:30');
INSERT INTO CHANSON VALUES(83,'Trouble',0,NULL,'f','2008-03-12 12:04:09');
INSERT INTO CHANSON VALUES(84,'Valley far below',0,NULL,'f','2008-03-12 17:49:59');
INSERT INTO CHANSON VALUES(85,'We can live together',0,NULL,'f','2008-03-12 19:40:43');
INSERT INTO CHANSON VALUES(86,'I gave my soul to you',0,NULL,NULL,'2008-03-12 13:00:59');
INSERT INTO CHANSON VALUES(87,'So blue (about you)',0,NULL,'f','2008-03-12 14:47:12');
INSERT INTO CHANSON VALUES(88,'You''ll get yours',0,NULL,'f','2008-03-12 17:49:32');
INSERT INTO CHANSON VALUES(89,'The Answer?',0,NULL,'f','2008-03-12 09:33:00');
INSERT INTO CHANSON VALUES(90,'It''s my life',0,NULL,NULL,'2008-03-12 18:21:57');
INSERT INTO CHANSON VALUES(91,'All we got is Rock n'' Roll',0,NULL,'f','2008-03-12 14:15:32');
INSERT INTO CHANSON VALUES(92,'Keepin'' the demon down',0,NULL,'f','2008-03-12 16:24:00');
INSERT INTO CHANSON VALUES(93,'Full Circle',0,NULL,'f','2008-03-12 10:48:04');
INSERT INTO CHANSON VALUES(94,'I Think I Love You Too Much',0,NULL,NULL,'2008-03-12 12:37:54');
INSERT INTO CHANSON VALUES(95,'I Can''t Get My Hands on You',0,NULL,'f','2008-03-12 12:37:34');
INSERT INTO CHANSON VALUES(96,'How Long Can A Man Be Strong',0,NULL,'f','2008-03-12 09:04:35');
INSERT INTO CHANSON VALUES(97,'Let It All Go',0,NULL,'f','2008-03-12 09:38:23');
INSERT INTO CHANSON VALUES(98,'Hell To Pay',0,NULL,'f','2008-03-12 11:24:12');
INSERT INTO CHANSON VALUES(99,'While My Guitar Gently Wheeps',0,NULL,'f','2008-03-12 18:34:46');
INSERT INTO CHANSON VALUES(100,'Something To Hold On',0,NULL,'f','2008-03-12 18:27:07');
INSERT INTO CHANSON VALUES(101,'How Much',0,NULL,'f','2008-03-12 17:58:23');
INSERT INTO CHANSON VALUES(102,'Highway Of Dreams',0,NULL,'f','2008-03-12 12:39:48');
INSERT INTO CHANSON VALUES(103,'Life Beyond The Sky',0,NULL,'f','2008-03-12 12:51:36');
INSERT INTO CHANSON VALUES(104,'You''re my baby',0,NULL,'f','2008-03-12 13:13:14');
INSERT INTO CHANSON VALUES(105,'Last night',0,NULL,'f','2008-03-12 11:34:51');
INSERT INTO CHANSON VALUES(106,'One meat ball',0,NULL,'f','2008-03-12 18:39:55');
INSERT INTO CHANSON VALUES(107,'Crossroads',0,NULL,'f','2008-03-12 13:45:34');
INSERT INTO CHANSON VALUES(109,'Rockin'' the republicans',0,NULL,'f','2008-03-12 09:53:33');
INSERT INTO CHANSON VALUES(110,'Baby I love you',0,NULL,'f','2008-03-12 18:43:01');
INSERT INTO CHANSON VALUES(111,'Love stealer',0,NULL,'f','2008-03-12 08:32:59');
INSERT INTO CHANSON VALUES(112,'You don''t know',0,NULL,'f','2008-03-12 12:52:39');
INSERT INTO CHANSON VALUES(113,'Down down down',0,NULL,NULL,'2008-03-12 10:13:31');
INSERT INTO CHANSON VALUES(115,'She Caught The Katy',9,NULL,NULL,'2008-03-12 08:58:19');
INSERT INTO CHANSON VALUES(116,'Peter Gunn Theme',9,NULL,NULL,'2008-03-12 18:53:59');
INSERT INTO CHANSON VALUES(117,'Gimme Some Lovin''',9,NULL,NULL,'2008-03-12 17:23:44');
INSERT INTO CHANSON VALUES(118,'Shake Your Tailfeather',9,NULL,NULL,'2008-03-12 12:16:47');
INSERT INTO CHANSON VALUES(119,'Everybody Needs Somebody To Love',9,NULL,'f','2008-06-02 09:55:46.781584');
INSERT INTO CHANSON VALUES(120,'The Old Landmark',9,NULL,NULL,'2008-03-12 19:14:24');
INSERT INTO CHANSON VALUES(121,'Think',9,NULL,NULL,'2008-03-12 19:14:56');
INSERT INTO CHANSON VALUES(122,'Theme From Rawhide',9,NULL,NULL,'2008-03-12 19:38:49');
INSERT INTO CHANSON VALUES(123,'Minnie The Moocher',9,NULL,NULL,'2008-03-12 15:49:03');
INSERT INTO CHANSON VALUES(124,'Sweet Home Chicago',9,NULL,NULL,'2008-03-12 09:37:42');
INSERT INTO CHANSON VALUES(125,'Jailhouse Rock',9,NULL,'f','2008-03-12 18:40:41');
INSERT INTO CHANSON VALUES(126,'Confidence Man',0,NULL,'f','2008-03-12 10:34:35');
INSERT INTO CHANSON VALUES(127,'My Little Girl',0,NULL,'f','2008-03-12 10:24:58');
INSERT INTO CHANSON VALUES(128,'River Of No Return',0,NULL,'f','2008-03-12 19:48:15');
INSERT INTO CHANSON VALUES(129,'Don''t Let Your Chance Go By',0,NULL,'f','2008-03-12 16:11:37');
INSERT INTO CHANSON VALUES(130,'Angel Eyes',0,NULL,'f','2008-03-12 12:07:52');
INSERT INTO CHANSON VALUES(131,'Nice Problem To Have',0,NULL,NULL,'2008-03-12 17:05:07');
INSERT INTO CHANSON VALUES(132,'Someday, Someway',0,NULL,'f','2008-03-12 17:03:45');
INSERT INTO CHANSON VALUES(133,'I Need To Be Loved',0,NULL,'f','2008-03-12 15:40:35');
INSERT INTO CHANSON VALUES(134,'Blue Jean Blues',0,NULL,'f','2008-03-12 15:49:12');
INSERT INTO CHANSON VALUES(135,'That''s What They Say',0,NULL,'f','2008-03-12 12:42:53');
INSERT INTO CHANSON VALUES(136,'Hideaway',0,NULL,'f','2008-03-12 08:54:28');
INSERT INTO CHANSON VALUES(137,'See The Light',0,NULL,'f','2008-03-12 15:06:52');
INSERT INTO CHANSON VALUES(138,'Excerpt',0,NULL,'f','2008-03-12 15:02:40');
INSERT INTO CHANSON VALUES(139,'Living With The Law',0,NULL,'f','2008-03-12 18:46:51');
INSERT INTO CHANSON VALUES(140,'Big Sky Country',0,NULL,'f','2008-03-19 14:11:59');
INSERT INTO CHANSON VALUES(141,'Kick The Stones',0,NULL,'f','2008-03-12 12:00:05');
INSERT INTO CHANSON VALUES(142,'Make The Dirt Stick',0,NULL,'f','2008-03-12 14:45:08');
INSERT INTO CHANSON VALUES(143,'Poison Girl',0,NULL,'f','2008-03-12 11:21:49');
INSERT INTO CHANSON VALUES(144,'Dust Radio',0,NULL,'f','2008-03-12 18:59:38');
INSERT INTO CHANSON VALUES(145,'Phone Call from Leavenworth',0,NULL,'f','2008-03-12 08:21:21');
INSERT INTO CHANSON VALUES(146,'I Forget You Every Day',0,NULL,'f','2008-03-12 19:25:15');
INSERT INTO CHANSON VALUES(147,'Long Way Around',0,NULL,'f','2008-03-12 13:04:22');
INSERT INTO CHANSON VALUES(148,'Look What Love Has Done',0,NULL,'f','2008-03-12 11:41:25');
INSERT INTO CHANSON VALUES(149,'Bordertown',0,NULL,'f','2008-03-12 19:34:11');
INSERT INTO CHANSON VALUES(150,'No Title',0,NULL,'f','2008-03-12 18:05:22');
INSERT INTO CHANSON VALUES(151,'Rip The Sack',2,NULL,'f','2008-03-12 17:28:22');
INSERT INTO CHANSON VALUES(152,'She4s Your Woman',2,NULL,'f','2008-03-12 18:59:08');
INSERT INTO CHANSON VALUES(153,'Light That Torch',2,NULL,'f','2008-03-12 08:15:29');
INSERT INTO CHANSON VALUES(154,'Magalie',2,NULL,'f','2008-03-12 18:06:29');
INSERT INTO CHANSON VALUES(155,'Come To The Water',2,NULL,'f','2008-03-12 14:10:51');
INSERT INTO CHANSON VALUES(156,'One Way Love',2,NULL,'f','2008-03-12 18:07:16');
INSERT INTO CHANSON VALUES(157,'One Shot Shy',2,NULL,'f','2008-03-12 09:33:20');
INSERT INTO CHANSON VALUES(158,'Chippin4And Dippin4',2,NULL,'f','2008-03-12 14:51:02');
INSERT INTO CHANSON VALUES(159,'Make It Rough',2,NULL,'f','2008-03-12 19:49:36');
INSERT INTO CHANSON VALUES(160,'Bosom Of Love',2,NULL,NULL,'2008-03-12 09:39:42');
INSERT INTO CHANSON VALUES(161,'Love Goes Stumbling',2,NULL,'f','2008-03-12 14:29:11');
INSERT INTO CHANSON VALUES(162,'Alabama Song',2,NULL,'f','2008-03-12 18:24:11');
INSERT INTO CHANSON VALUES(163,'When The Nickel Drops',2,NULL,NULL,'2008-03-12 08:27:26');
INSERT INTO CHANSON VALUES(164,'Chain Link Fence',2,NULL,'f','2008-03-12 14:20:33');
INSERT INTO CHANSON VALUES(165,'Mona Lisa',2,NULL,'f','2008-03-12 08:52:44');
INSERT INTO CHANSON VALUES(166,'Cool',2,NULL,'f','2008-03-12 18:45:52');
INSERT INTO CHANSON VALUES(167,'Bye-Bye Baby',2,NULL,'f','2008-03-12 09:53:25');
INSERT INTO CHANSON VALUES(168,'Charades',2,NULL,'f','2008-03-12 13:25:16');
INSERT INTO CHANSON VALUES(169,'Dinah Lee',2,NULL,NULL,'2008-03-12 14:21:06');
INSERT INTO CHANSON VALUES(170,'Daddy''s Little Girl',2,NULL,NULL,'2008-03-12 09:29:46');
INSERT INTO CHANSON VALUES(171,'Wide Open',2,NULL,'f','2008-03-12 18:01:15');
INSERT INTO CHANSON VALUES(172,'Twisted',2,NULL,'f','2008-03-12 08:55:39');
INSERT INTO CHANSON VALUES(173,'Heart For Sale',2,NULL,NULL,'2008-03-12 10:58:07');
INSERT INTO CHANSON VALUES(175,'Cruel Little Number',0,NULL,'f','2008-03-12 10:33:20');
INSERT INTO CHANSON VALUES(176,'Leave The Light On',0,NULL,'f','2008-03-12 19:26:05');
INSERT INTO CHANSON VALUES(177,'Baby''s Lookin'' Hot',0,NULL,NULL,'2008-03-12 17:35:59');
INSERT INTO CHANSON VALUES(178,'Lost In Your Eyes',0,NULL,NULL,'2008-03-12 11:05:24');
INSERT INTO CHANSON VALUES(179,'House That Love Built',0,NULL,'f','2008-03-12 14:37:46');
INSERT INTO CHANSON VALUES(180,'Evil And Here To Stay',0,NULL,'f','2008-03-12 15:46:16');
INSERT INTO CHANSON VALUES(181,'My Kinda Lover',0,NULL,'f','2008-03-12 12:37:17');
INSERT INTO CHANSON VALUES(182,'It Could All Get Blown Away',0,NULL,'f','2008-03-12 16:39:12');
INSERT INTO CHANSON VALUES(183,'You''re Comming Home',0,NULL,'f','2008-03-12 12:53:10');
INSERT INTO CHANSON VALUES(184,'If you Can''t Fell Anything Else',0,NULL,'f','2008-03-12 13:33:41');
INSERT INTO CHANSON VALUES(185,'Heart Of An Angel',0,NULL,'f','2008-03-12 19:47:14');
INSERT INTO CHANSON VALUES(186,'Live And Love',0,NULL,'f','2008-03-12 11:45:41');
INSERT INTO CHANSON VALUES(187,'Joined At The Heart',0,NULL,NULL,'2008-03-12 12:35:17');
INSERT INTO CHANSON VALUES(188,'Dreams of Love',0,NULL,NULL,'2008-03-12 12:50:22');
INSERT INTO CHANSON VALUES(190,'Living At The End Of A Gun',0,NULL,NULL,'2008-03-12 14:01:46');
INSERT INTO CHANSON VALUES(191,'Big Brother',0,NULL,'f','2008-06-07 18:48:26.338099');
INSERT INTO CHANSON VALUES(192,'I Should Have Been Home',0,NULL,'f','2008-03-12 17:26:23');
INSERT INTO CHANSON VALUES(193,'Nothin''',0,NULL,NULL,'2008-03-12 09:06:03');
INSERT INTO CHANSON VALUES(194,'My Way',0,NULL,'f','2008-03-12 11:27:56');
INSERT INTO CHANSON VALUES(195,'Behind The 8 Ball',0,NULL,'f','2008-03-12 14:55:30');
INSERT INTO CHANSON VALUES(196,'This Is My Life',0,NULL,'f','2008-03-12 10:51:17');
INSERT INTO CHANSON VALUES(197,'Automated',0,NULL,'f','2008-03-12 13:08:03');
INSERT INTO CHANSON VALUES(198,'Little Stars',0,NULL,'f','2008-03-12 09:30:38');
INSERT INTO CHANSON VALUES(199,'North Austin Slim',0,NULL,'f','2008-03-12 13:52:29');
INSERT INTO CHANSON VALUES(200,'Moments',0,NULL,'f','2008-03-12 17:38:52');
INSERT INTO CHANSON VALUES(201,'One Step Ahead',0,NULL,'f','2008-03-12 17:11:53');
INSERT INTO CHANSON VALUES(202,'Wagon To Stars',0,NULL,'f','2008-03-12 14:00:19');
INSERT INTO CHANSON VALUES(203,'Quelqu''un m''a dit',5,NULL,'f','2008-03-12 19:06:26');
INSERT INTO CHANSON VALUES(204,'Raphaël',5,NULL,'f','2008-03-12 08:26:53');
INSERT INTO CHANSON VALUES(205,'Tout le monde',5,NULL,'f','2008-03-12 19:56:49');
INSERT INTO CHANSON VALUES(206,'La noyée',5,NULL,'f','2008-03-12 13:08:41');
INSERT INTO CHANSON VALUES(207,'Le toi du moi',5,NULL,'f','2008-03-12 17:35:49');
INSERT INTO CHANSON VALUES(208,'Le ciel dans une chambre',5,NULL,NULL,'2008-03-12 17:43:20');
INSERT INTO CHANSON VALUES(209,'J''en connais',5,NULL,'f','2008-03-12 13:08:12');
INSERT INTO CHANSON VALUES(210,'Le plus beau du quartier',5,NULL,'f','2008-03-12 19:56:50');
INSERT INTO CHANSON VALUES(211,'Chanson triste',5,NULL,NULL,'2008-03-12 17:44:01');
INSERT INTO CHANSON VALUES(212,'L''excessive',5,NULL,'f','2008-03-12 16:18:02');
INSERT INTO CHANSON VALUES(213,'L''amour',5,NULL,'f','2008-03-12 08:15:08');
INSERT INTO CHANSON VALUES(214,'La dernière minute',5,NULL,'f','2008-03-12 13:16:35');
INSERT INTO CHANSON VALUES(215,'Tie Your Mother Down',2,NULL,'f','2008-03-12 12:13:31');
INSERT INTO CHANSON VALUES(216,'You Take My Breath Away',2,NULL,'f','2008-03-12 10:40:39');
INSERT INTO CHANSON VALUES(217,'Long Away',2,NULL,'f','2008-03-22 18:25:14');
INSERT INTO CHANSON VALUES(218,'The Millionaire Waltz',2,NULL,'f','2008-03-12 16:13:57');
INSERT INTO CHANSON VALUES(219,'You And I',2,NULL,'f','2008-03-12 08:41:06');
INSERT INTO CHANSON VALUES(220,'Somebody To Love',2,NULL,'f','2008-03-12 10:37:02');
INSERT INTO CHANSON VALUES(221,'White Man',2,NULL,'f','2008-03-12 09:25:46');
INSERT INTO CHANSON VALUES(222,'Good Old Fashioned Lover Boy',2,NULL,'f','2008-03-12 09:07:05');
INSERT INTO CHANSON VALUES(223,'Drowse',2,NULL,'f','2008-03-12 09:08:20');
INSERT INTO CHANSON VALUES(224,'Teo Torriatte (Let Us Cling Together)',2,NULL,'f','2008-03-12 11:36:36');
INSERT INTO CHANSON VALUES(225,'New Lost World',0,NULL,'f','2008-03-12 18:58:49');
INSERT INTO CHANSON VALUES(226,'Breaking Your Fall',0,NULL,'f','2008-03-12 12:09:30');
INSERT INTO CHANSON VALUES(227,'Frontier',0,NULL,'f','2008-03-12 08:02:55');
INSERT INTO CHANSON VALUES(228,'Hotel Vast Horizon',0,NULL,'f','2008-03-12 11:44:09');
INSERT INTO CHANSON VALUES(229,'Blues For Andre',0,NULL,'f','2008-03-12 11:47:50');
INSERT INTO CHANSON VALUES(230,'Assassin Song',0,NULL,'f','2008-03-12 12:02:27');
INSERT INTO CHANSON VALUES(231,'Wide Open Return',0,NULL,'f','2008-03-12 13:07:53');
INSERT INTO CHANSON VALUES(232,'Silhouette',0,NULL,NULL,'2008-03-12 10:14:01');
INSERT INTO CHANSON VALUES(233,'Insurrection at Newtown',0,NULL,'f','2008-03-12 11:23:09');
INSERT INTO CHANSON VALUES(234,'Free Interval',0,NULL,'f','2008-03-12 15:41:46');
INSERT INTO CHANSON VALUES(235,'As Flat As The Earth (exp)',0,NULL,'f','2008-03-12 11:34:45');
INSERT INTO CHANSON VALUES(236,'Automatic',0,NULL,NULL,'2008-03-12 08:58:54');
INSERT INTO CHANSON VALUES(237,'Clear Blue Sky',0,NULL,'f','2008-03-12 14:02:57');
INSERT INTO CHANSON VALUES(238,'Weightless',0,NULL,'f','2008-03-12 14:21:42');
INSERT INTO CHANSON VALUES(239,'Power Down',0,NULL,'f','2008-03-12 15:38:29');
INSERT INTO CHANSON VALUES(240,'On Cue',0,NULL,'f','2008-03-12 14:01:31');
INSERT INTO CHANSON VALUES(241,'Immortal Blues',0,NULL,'f','2008-03-12 19:27:38');
INSERT INTO CHANSON VALUES(242,'Cool Wooden Crosses',0,NULL,'f','2008-03-12 18:40:53');
INSERT INTO CHANSON VALUES(243,'Still Point',0,NULL,'f','2008-03-12 18:57:16');
INSERT INTO CHANSON VALUES(244,'Gasket',0,NULL,'f','2008-03-12 08:36:57');
INSERT INTO CHANSON VALUES(245,'One Long Day',0,NULL,'f','2008-03-12 17:51:32');
INSERT INTO CHANSON VALUES(246,'Aerial',0,NULL,'f','2008-03-12 14:56:31');
INSERT INTO CHANSON VALUES(247,'Alien',0,NULL,'f','2008-03-12 13:31:33');
INSERT INTO CHANSON VALUES(248,'',0,NULL,'f','2008-03-12 13:01:55');
INSERT INTO CHANSON VALUES(249,'Up Around the bend',0,NULL,'f','2008-03-12 09:41:33');
INSERT INTO CHANSON VALUES(250,'Proud Mary',0,NULL,'f','2008-03-12 15:11:35');
INSERT INTO CHANSON VALUES(251,'Bad Moon Rising',0,NULL,'f','2008-03-12 10:10:02');
INSERT INTO CHANSON VALUES(252,'Born on the bayou',0,NULL,'f','2008-03-12 17:02:42');
INSERT INTO CHANSON VALUES(253,'Fortunate son',0,NULL,'f','2008-03-12 16:55:40');
INSERT INTO CHANSON VALUES(254,'Susie Q',0,NULL,'f','2008-06-01 18:07:29.972956');
INSERT INTO CHANSON VALUES(255,'I heard it through the Grapevine',0,NULL,'f','2008-03-12 19:47:07');
INSERT INTO CHANSON VALUES(256,'Travelin''Band',0,NULL,NULL,'2008-03-12 13:22:04');
INSERT INTO CHANSON VALUES(257,'Down on the corner',0,NULL,'f','2008-03-12 08:51:35');
INSERT INTO CHANSON VALUES(258,'Green river',0,NULL,'f','2008-03-12 14:18:36');
INSERT INTO CHANSON VALUES(259,'Have you ever seen the rain',0,NULL,'f','2008-03-12 13:27:18');
INSERT INTO CHANSON VALUES(260,'My baby left me',0,NULL,'f','2008-03-12 08:05:30');
INSERT INTO CHANSON VALUES(261,'Who''ll stop the rain',0,NULL,'f','2008-03-12 15:15:40');
INSERT INTO CHANSON VALUES(262,'The Midnight special',0,NULL,'f','2008-03-12 16:04:42');
INSERT INTO CHANSON VALUES(263,'Pagan baby',0,NULL,'f','2008-03-12 12:46:37');
INSERT INTO CHANSON VALUES(264,'Cotton fields',0,NULL,'f','2008-03-12 08:45:35');
INSERT INTO CHANSON VALUES(265,'Commotion',0,NULL,'f','2008-03-12 12:42:22');
INSERT INTO CHANSON VALUES(266,'J''traîne des pieds',5,NULL,'f','2008-03-12 13:11:45');
INSERT INTO CHANSON VALUES(267,'La femme chocolat',5,NULL,'f','2008-03-12 14:11:36');
INSERT INTO CHANSON VALUES(268,'I need a child',5,NULL,'f','2008-03-22 09:45:55');
INSERT INTO CHANSON VALUES(269,'Non-dits',5,NULL,'f','2008-03-12 16:14:22');
INSERT INTO CHANSON VALUES(270,'Thérapie de groupe',5,NULL,'f','2008-03-12 08:17:28');
INSERT INTO CHANSON VALUES(271,'La petite valse de Narbonne plage',5,NULL,'f','2008-03-12 14:56:43');
INSERT INTO CHANSON VALUES(272,'Quijote',5,NULL,'f','2008-03-12 10:37:48');
INSERT INTO CHANSON VALUES(273,'Cabaret blanc',5,NULL,'f','2008-03-12 19:00:35');
INSERT INTO CHANSON VALUES(274,'Goûtez-moi',5,NULL,'f','2008-03-12 14:04:20');
INSERT INTO CHANSON VALUES(275,'Vitrier',5,NULL,'f','2008-03-12 09:25:03');
INSERT INTO CHANSON VALUES(276,'La petite voleuse',5,NULL,'f','2008-03-12 14:53:14');
INSERT INTO CHANSON VALUES(277,'La fille du vent',5,NULL,'f','2008-03-12 11:26:26');
INSERT INTO CHANSON VALUES(278,'De toi a moi',5,NULL,'f','2008-03-12 18:33:11');
INSERT INTO CHANSON VALUES(280,'Bootleg',0,NULL,'f','2008-03-12 10:21:44');
INSERT INTO CHANSON VALUES(281,'Graveyard Train',0,NULL,'f','2008-03-12 15:54:40');
INSERT INTO CHANSON VALUES(282,'Good Molly Miss Molly',0,NULL,'f','2008-03-12 12:08:17');
INSERT INTO CHANSON VALUES(283,'Penthouse Pauper',0,NULL,'f','2008-03-12 10:04:18');
INSERT INTO CHANSON VALUES(285,'Keep On Chooglin''',0,NULL,'f','2008-03-12 09:47:47');
INSERT INTO CHANSON VALUES(286,'It''s All Over Now Baby Blue',2,NULL,'f','2008-03-12 10:19:41');
INSERT INTO CHANSON VALUES(287,'Love Minus Zero/No Limit',2,NULL,'f','2008-03-12 13:37:07');
INSERT INTO CHANSON VALUES(288,'Tangled Up In Blue',2,NULL,'f','2008-03-12 18:31:41');
INSERT INTO CHANSON VALUES(289,'The Water Is Wide',2,NULL,'f','2008-03-12 08:20:00');
INSERT INTO CHANSON VALUES(290,'It Takes A Lot To Laugh, It Takes A Train To Cry',2,NULL,'f','2008-03-12 14:31:21');
INSERT INTO CHANSON VALUES(291,'Oh, Sister',2,NULL,'f','2008-03-12 10:10:16');
INSERT INTO CHANSON VALUES(292,'Hurricane',2,NULL,'f','2008-03-12 19:34:25');
INSERT INTO CHANSON VALUES(293,'One More Cup Of Coffee (Valley Below)',2,NULL,'f','2008-03-12 10:45:30');
INSERT INTO CHANSON VALUES(294,'Sara',2,NULL,'f','2008-03-12 14:32:08');
INSERT INTO CHANSON VALUES(295,'Just Like A Woman',2,NULL,'f','2008-03-12 18:40:56');
INSERT INTO CHANSON VALUES(296,'Knockin'' On Heaven''s Door',2,NULL,'f','2008-03-12 16:52:16');
INSERT INTO CHANSON VALUES(306,'',1,NULL,NULL,'2008-03-12 12:18:53');
INSERT INTO CHANSON VALUES(307,'',1,NULL,NULL,'2008-03-12 13:10:24');
INSERT INTO CHANSON VALUES(308,'',1,NULL,NULL,'2008-03-12 10:14:45');
INSERT INTO CHANSON VALUES(309,'',1,NULL,NULL,'2008-03-12 10:44:16');
INSERT INTO CHANSON VALUES(310,'',1,NULL,NULL,'2008-03-12 14:59:27');
INSERT INTO CHANSON VALUES(311,'',1,NULL,NULL,'2008-03-12 17:54:01');
INSERT INTO CHANSON VALUES(312,'',1,NULL,NULL,'2008-03-12 11:07:47');
INSERT INTO CHANSON VALUES(313,'',1,NULL,NULL,'2008-03-12 17:37:20');
INSERT INTO CHANSON VALUES(314,'',1,NULL,NULL,'2008-03-12 18:31:01');
INSERT INTO CHANSON VALUES(315,'',1,NULL,NULL,'2008-03-12 18:12:53');
INSERT INTO CHANSON VALUES(316,'',1,NULL,NULL,'2008-03-12 09:34:11');
INSERT INTO CHANSON VALUES(317,'',1,NULL,NULL,'2008-03-12 08:04:21');
INSERT INTO CHANSON VALUES(318,'',1,NULL,NULL,'2008-03-12 13:15:36');
INSERT INTO CHANSON VALUES(319,'',1,NULL,NULL,'2008-03-12 10:27:20');
INSERT INTO CHANSON VALUES(320,'',1,NULL,NULL,'2008-03-12 13:00:20');
INSERT INTO CHANSON VALUES(321,'',1,NULL,NULL,'2008-03-12 18:50:15');
INSERT INTO CHANSON VALUES(322,'',1,NULL,NULL,'2008-03-12 19:05:22');
INSERT INTO CHANSON VALUES(323,'',1,NULL,NULL,'2008-03-12 16:51:00');
INSERT INTO CHANSON VALUES(324,'',1,NULL,NULL,'2008-03-12 08:45:31');
INSERT INTO CHANSON VALUES(325,'Allegro energico ma non troppo',1,NULL,NULL,'2008-03-12 09:36:43');
INSERT INTO CHANSON VALUES(326,'Scherzo (Wuchtig)',1,NULL,NULL,'2008-03-12 19:43:17');
INSERT INTO CHANSON VALUES(327,'Andante',1,NULL,NULL,'2008-03-12 09:44:22');
INSERT INTO CHANSON VALUES(328,'Finale: Allegro moderato',1,NULL,NULL,'2008-03-12 14:10:38');
INSERT INTO CHANSON VALUES(329,'Allegro maestoso',1,NULL,NULL,'2008-03-12 09:20:05');
INSERT INTO CHANSON VALUES(330,'Romance (larghetto)',1,NULL,NULL,'2008-03-12 13:48:05');
INSERT INTO CHANSON VALUES(331,'Rondo (vivace)',1,NULL,NULL,'2008-03-12 17:42:56');
INSERT INTO CHANSON VALUES(332,'Adagio through Andante mosso',1,NULL,NULL,'2008-03-12 08:39:02');
INSERT INTO CHANSON VALUES(333,'Allegro con grazia',1,NULL,NULL,'2008-03-12 13:23:53');
INSERT INTO CHANSON VALUES(334,'Allegro molto vivace',1,NULL,NULL,'2008-03-12 13:27:39');
INSERT INTO CHANSON VALUES(335,'Finale: Adagio lamentoso - Andante',1,NULL,NULL,'2008-03-12 19:32:15');
INSERT INTO CHANSON VALUES(336,'Overture',1,NULL,NULL,'2008-03-12 16:30:58');
INSERT INTO CHANSON VALUES(337,'Introduzione: Notte e giorno faticar',1,NULL,NULL,'2008-03-12 19:40:43');
INSERT INTO CHANSON VALUES(338,'Recitativo: Ah, del padre in periglio',1,NULL,NULL,'2008-03-12 12:12:53');
INSERT INTO CHANSON VALUES(339,'& Recitativo: Fuggi, crudele,fuggi!',1,NULL,NULL,'2008-03-12 19:20:14');
INSERT INTO CHANSON VALUES(340,'Recitativo: Orsu, spicciati presto',1,NULL,NULL,'2008-03-12 08:49:02');
INSERT INTO CHANSON VALUES(341,'Aria: Ah, chi mi dice mai',1,NULL,NULL,'2008-03-12 10:38:45');
INSERT INTO CHANSON VALUES(342,'Recitativo: Chi e la',1,NULL,NULL,'2008-03-12 09:42:24');
INSERT INTO CHANSON VALUES(343,'Aria: Madamina, il catalogo e questo',1,NULL,NULL,'2008-03-12 09:09:48');
INSERT INTO CHANSON VALUES(344,'Recitativo: In qusto forma',1,NULL,NULL,'2008-03-12 08:35:15');
INSERT INTO CHANSON VALUES(345,'Coro: Giovinette che fate all''amore',1,NULL,NULL,'2008-03-12 16:33:47');
INSERT INTO CHANSON VALUES(346,'Recitativo: Manco male e partita',1,NULL,NULL,'2008-03-12 19:14:18');
INSERT INTO CHANSON VALUES(347,'Aria: Ho capito, signor,si',1,NULL,NULL,'2008-03-12 19:13:59');
INSERT INTO CHANSON VALUES(348,'Recitativo: Alfin siam liberati',1,NULL,NULL,'2008-03-12 15:34:11');
INSERT INTO CHANSON VALUES(349,'& Duetto: la ci darem la mano',1,NULL,NULL,'2008-03-12 14:33:32');
INSERT INTO CHANSON VALUES(350,'Recitativo: Fermati, scellerato!',1,NULL,NULL,'2008-03-12 17:37:21');
INSERT INTO CHANSON VALUES(351,'Aria: Ah! fuggi il traditor!',1,NULL,NULL,'2008-03-12 17:47:59');
INSERT INTO CHANSON VALUES(352,'Recitativo: Mipar ch''oggi il demoio...',1,NULL,NULL,'2008-03-12 15:54:42');
INSERT INTO CHANSON VALUES(353,'& Quartetto: Non ti fidar, o mesera"',1,NULL,NULL,'2008-03-12 08:03:51');
INSERT INTO CHANSON VALUES(354,'Recitativo: Povera sventurata!',1,NULL,NULL,'2008-03-12 17:05:27');
INSERT INTO CHANSON VALUES(355,'Recitativo: Don Ottavio, son marta!',1,NULL,NULL,'2008-03-12 08:46:01');
INSERT INTO CHANSON VALUES(356,'& Aria: Or sai chi l''onore',1,NULL,NULL,'2008-03-12 18:43:16');
INSERT INTO CHANSON VALUES(357,'Recitativo: Come mai creder deggio',1,NULL,NULL,'2008-03-12 09:39:29');
INSERT INTO CHANSON VALUES(358,'& Aria: Dalla sua pace',1,NULL,NULL,'2008-03-12 09:18:03');
INSERT INTO CHANSON VALUES(359,'Trauermarsch: In gemessenem Schritt, streng wie ein Kondukt',1,NULL,NULL,'2008-03-12 12:51:37');
INSERT INTO CHANSON VALUES(360,'Sturmisch bewegt, mit grosster Vehemenz',1,NULL,NULL,'2008-03-12 18:38:15');
INSERT INTO CHANSON VALUES(361,'Scherzo: Kraftig, nicht zu schnell',1,NULL,NULL,'2008-03-12 10:28:03');
INSERT INTO CHANSON VALUES(362,'Adagietto: Sehr langsam',1,NULL,NULL,'2008-03-12 10:03:57');
INSERT INTO CHANSON VALUES(363,'Rondo-Finale: Allegro giocoso',1,NULL,NULL,'2008-03-12 19:03:01');
INSERT INTO CHANSON VALUES(364,'Rêveries; Passions',1,NULL,NULL,'2008-03-12 17:51:06');
INSERT INTO CHANSON VALUES(365,'Un Bal',1,NULL,NULL,'2008-03-12 11:55:53');
INSERT INTO CHANSON VALUES(366,'Scène aux Champs',1,NULL,NULL,'2008-03-12 11:46:36');
INSERT INTO CHANSON VALUES(367,'Marche au Supplice',1,NULL,NULL,'2008-03-12 14:55:16');
INSERT INTO CHANSON VALUES(368,'Songe d''une Nuit du Sabbat',1,NULL,NULL,'2008-03-12 08:03:34');
INSERT INTO CHANSON VALUES(369,'Allegro con brio',1,NULL,NULL,'2008-03-12 09:23:25');
INSERT INTO CHANSON VALUES(370,'Marcia funebre (Adagio assai)',1,NULL,NULL,'2008-03-12 16:15:04');
INSERT INTO CHANSON VALUES(371,'Scherzo (Allegro vivace)',1,NULL,NULL,'2008-03-12 19:29:32');
INSERT INTO CHANSON VALUES(372,'Finale (Allegro molto-Poco andante-Presto)',1,NULL,NULL,'2008-03-12 08:42:35');
INSERT INTO CHANSON VALUES(373,'Langsam Schleppend',1,NULL,NULL,'2008-03-12 08:38:39');
INSERT INTO CHANSON VALUES(374,'Kraftig Bewegt',1,NULL,NULL,'2008-03-12 08:26:30');
INSERT INTO CHANSON VALUES(375,'Feierlich Und Gemessen, Ohne Zu Schleppen',1,NULL,NULL,'2008-03-12 09:42:26');
INSERT INTO CHANSON VALUES(376,'Sturmisch Bewegt',1,NULL,NULL,'2008-03-12 08:59:12');
INSERT INTO CHANSON VALUES(377,'Allegro',1,NULL,NULL,'2008-03-12 15:32:07');
INSERT INTO CHANSON VALUES(378,'Andante con moto',1,NULL,NULL,'2008-03-12 18:34:10');
INSERT INTO CHANSON VALUES(379,'Scherzo: Allegro molto',1,NULL,NULL,'2008-03-12 13:41:34');
INSERT INTO CHANSON VALUES(380,'Presto',1,NULL,NULL,'2008-03-12 18:25:50');
INSERT INTO CHANSON VALUES(381,'String Quartet in C minor op. D703: Allegro assai',1,NULL,NULL,'2008-03-12 19:25:19');
INSERT INTO CHANSON VALUES(382,'Kronungsmesse C-DUR KV 317',1,NULL,NULL,'2008-03-12 14:27:02');
INSERT INTO CHANSON VALUES(383,'Laudate Dominum "Vespera Dominica" A-DUR KV 321',1,NULL,NULL,'2008-03-12 09:27:41');
INSERT INTO CHANSON VALUES(384,'Kirchensonate C-DUR KV328',1,NULL,NULL,'2008-03-12 17:29:08');
INSERT INTO CHANSON VALUES(385,'Motette "Exsultate Jubilate" F-DUR KV 165',1,NULL,NULL,'2008-03-12 11:36:50');
INSERT INTO CHANSON VALUES(386,'Wanderer Fantaisie op.15: Allegro con fuoco ma non troppo - Adagio - Presto - Allegro',1,NULL,NULL,'2008-03-12 16:38:49');
INSERT INTO CHANSON VALUES(387,'Symphony No.4: Adagio-Allegro vivace',1,NULL,NULL,'2008-03-12 18:16:22');
INSERT INTO CHANSON VALUES(388,'Symphony No.4: Andante',1,NULL,NULL,'2008-03-12 08:10:57');
INSERT INTO CHANSON VALUES(389,'Symphony No.4: Allegro',1,NULL,NULL,'2008-03-12 10:39:38');
INSERT INTO CHANSON VALUES(390,'Symphony No.4: Allegro vivace',1,NULL,NULL,'2008-03-12 17:34:04');
INSERT INTO CHANSON VALUES(391,'Concerto 1, 1er Mouvement',1,NULL,NULL,'2008-03-12 15:32:29');
INSERT INTO CHANSON VALUES(392,'Concerto 1, 2ème Mouvement',1,NULL,NULL,'2008-03-12 19:04:57');
INSERT INTO CHANSON VALUES(393,'Concerto 1, 3ème Mouvement',1,NULL,NULL,'2008-03-12 08:10:24');
INSERT INTO CHANSON VALUES(394,'Concerto 2, 1er Mouvement',1,NULL,NULL,'2008-03-12 16:56:53');
INSERT INTO CHANSON VALUES(395,'Concerto 2, 2ème Mouvement',1,NULL,NULL,'2008-03-12 18:12:30');
INSERT INTO CHANSON VALUES(396,'Concerto 2, 3ème Mouvement',1,NULL,NULL,'2008-03-12 16:55:08');
INSERT INTO CHANSON VALUES(397,'C.C. No. 1 - Moderato',1,NULL,NULL,'2008-03-12 14:49:25');
INSERT INTO CHANSON VALUES(398,'Adagio',1,NULL,NULL,'2008-03-12 18:51:35');
INSERT INTO CHANSON VALUES(399,'Allegro molto',1,NULL,NULL,'2008-03-12 17:04:14');
INSERT INTO CHANSON VALUES(400,'C.C. No. 2 - Allegro moderato',1,NULL,NULL,'2008-03-12 13:51:48');
INSERT INTO CHANSON VALUES(401,'Adagio',1,NULL,NULL,'2008-03-12 14:29:21');
INSERT INTO CHANSON VALUES(402,'Allegro',1,NULL,NULL,'2008-03-12 08:27:25');
INSERT INTO CHANSON VALUES(403,'5 / Allegro',1,NULL,NULL,'2008-03-12 19:27:36');
INSERT INTO CHANSON VALUES(404,'5 / Adagio un poco mosso',1,NULL,NULL,'2008-03-12 12:09:32');
INSERT INTO CHANSON VALUES(405,'5/ Rondo : Allegro',1,NULL,NULL,'2008-03-12 11:59:45');
INSERT INTO CHANSON VALUES(406,'17 / Largo, Allegro',1,NULL,NULL,'2008-03-12 17:40:40');
INSERT INTO CHANSON VALUES(407,'17 / Adagio',1,NULL,NULL,'2008-03-12 19:11:30');
INSERT INTO CHANSON VALUES(408,'17 / Allegretto',1,NULL,NULL,'2008-03-12 12:04:21');
INSERT INTO CHANSON VALUES(409,'Allegro con brio',1,NULL,NULL,'2008-03-12 19:54:25');
INSERT INTO CHANSON VALUES(410,'Adagio',1,NULL,NULL,'2008-03-12 10:23:17');
INSERT INTO CHANSON VALUES(411,'Rondo (molto allegro)',1,NULL,NULL,'2008-03-12 08:56:46');
INSERT INTO CHANSON VALUES(412,'Allegro',1,NULL,NULL,'2008-03-12 12:58:13');
INSERT INTO CHANSON VALUES(413,'Allegro un poco mosso',1,NULL,NULL,'2008-03-12 18:58:41');
INSERT INTO CHANSON VALUES(414,'Rondo (allegro)',1,NULL,NULL,'2008-03-12 13:22:51');
INSERT INTO CHANSON VALUES(415,'Allegro',1,NULL,NULL,'2008-03-12 19:41:50');
INSERT INTO CHANSON VALUES(416,'Andantino',1,NULL,NULL,'2008-03-12 16:30:31');
INSERT INTO CHANSON VALUES(417,'Rondo-Allegro',1,NULL,NULL,'2008-03-12 13:28:43');
INSERT INTO CHANSON VALUES(418,'Allegro Maestose',1,NULL,NULL,'2008-03-12 19:51:47');
INSERT INTO CHANSON VALUES(419,'Adagio Non Troppo',1,NULL,NULL,'2008-03-12 11:50:42');
INSERT INTO CHANSON VALUES(420,'Rondon (Empo Di Minuetto)',1,NULL,NULL,'2008-03-12 16:04:05');
INSERT INTO CHANSON VALUES(421,'Andante Pour Flute Et Orchestre Kv 315 Ut Majeu/C Major/C-Dur',1,NULL,NULL,'2008-03-12 08:06:01');
INSERT INTO CHANSON VALUES(422,'Concerto for Violin and Orchestra op. 36 in D major - Allegro moderato',1,NULL,NULL,'2008-03-12 17:31:00');
INSERT INTO CHANSON VALUES(423,'Concerto for Violin and Orchestra op. 36 in D major - Canzonetta: Andante',1,NULL,NULL,'2008-03-12 08:21:58');
INSERT INTO CHANSON VALUES(424,'Concerto for Violin and Orchestra op. 36 in D major - Finale: Allegrovivacissimo',1,NULL,NULL,'2008-03-12 16:48:21');
INSERT INTO CHANSON VALUES(425,'String Quartet No1. op. 11 in D major - Moderato e semplice',1,NULL,NULL,'2008-03-12 14:48:02');
INSERT INTO CHANSON VALUES(426,'String Quartet No1. op. 11 in D major - Andante cantabile',1,NULL,NULL,'2008-03-12 12:33:32');
INSERT INTO CHANSON VALUES(427,'String Quartet No1. op. 11 in D major - Scherzo: Allegro ma non tanto',1,NULL,NULL,'2008-03-12 19:58:01');
INSERT INTO CHANSON VALUES(428,'String Quartet No1. op. 11 in D major - Finale: Allegro giusto',1,NULL,NULL,'2008-03-12 15:53:53');
INSERT INTO CHANSON VALUES(429,'Poëme symphonique n°3 / Lamartine',1,NULL,NULL,'2008-03-12 13:10:43');
INSERT INTO CHANSON VALUES(430,'Concerto n°2 adagio sostenuto assai',1,NULL,NULL,'2008-03-12 09:53:47');
INSERT INTO CHANSON VALUES(431,'Concerto n°2 allegro agitato assaiy',1,NULL,NULL,'2008-03-12 11:53:54');
INSERT INTO CHANSON VALUES(432,'Concerto n°2 allegro moderatoy',1,NULL,NULL,'2008-03-12 11:40:25');
INSERT INTO CHANSON VALUES(433,'Allegro decisoy',1,NULL,NULL,'2008-03-12 11:41:47');
INSERT INTO CHANSON VALUES(434,'Concerto n°2 marzialey',1,NULL,NULL,'2008-03-12 11:24:35');
INSERT INTO CHANSON VALUES(435,'Concerto n°2 allegro animatoy',1,NULL,NULL,'2008-03-12 15:57:23');
INSERT INTO CHANSON VALUES(436,'Orphee poeme symphonique n°4',1,NULL,NULL,'2008-03-12 16:21:56');
INSERT INTO CHANSON VALUES(437,'Préude et fugue 9 sur Bachy',1,NULL,NULL,'2008-03-12 10:18:55');
INSERT INTO CHANSON VALUES(438,'Concerto No.4 in G  BWV1049 - Allegro',1,NULL,NULL,'2008-03-12 10:57:48');
INSERT INTO CHANSON VALUES(439,'-  Andante',1,NULL,NULL,'2008-03-12 09:25:59');
INSERT INTO CHANSON VALUES(440,'-  Presto',1,NULL,NULL,'2008-03-12 18:35:52');
INSERT INTO CHANSON VALUES(441,'Concerto No. 5 in D  BWV1050 - Allegro',1,NULL,NULL,'2008-03-12 15:50:46');
INSERT INTO CHANSON VALUES(442,'-  Affettuoso',1,NULL,NULL,'2008-03-12 14:07:26');
INSERT INTO CHANSON VALUES(443,'-  Allegro',1,NULL,NULL,'2008-03-12 19:25:08');
INSERT INTO CHANSON VALUES(444,'Concerto No. 6 in B  BWV1051 - Allegro',1,NULL,NULL,'2008-03-12 17:41:32');
INSERT INTO CHANSON VALUES(445,'- Adagio ma non tanto',1,NULL,NULL,'2008-03-12 12:19:30');
INSERT INTO CHANSON VALUES(446,'-  Allegro',1,NULL,NULL,'2008-03-12 17:59:51');
INSERT INTO CHANSON VALUES(447,'5: Allegro con brio',1,NULL,NULL,'2008-03-12 16:12:10');
INSERT INTO CHANSON VALUES(448,'5: Andante con moto',1,NULL,NULL,'2008-03-12 15:27:07');
INSERT INTO CHANSON VALUES(449,'5: Allegro',1,NULL,NULL,'2008-03-12 13:34:33');
INSERT INTO CHANSON VALUES(450,'5: Allegro',1,NULL,NULL,'2008-03-12 13:25:08');
INSERT INTO CHANSON VALUES(451,'6: Allegro ma non troppo',1,NULL,NULL,'2008-03-12 11:05:59');
INSERT INTO CHANSON VALUES(452,'6: Andante molot mosso',1,NULL,NULL,'2008-03-12 09:38:07');
INSERT INTO CHANSON VALUES(453,'6: Allegro',1,NULL,NULL,'2008-03-12 14:38:33');
INSERT INTO CHANSON VALUES(454,'6: Allegro',1,NULL,NULL,'2008-03-12 16:24:14');
INSERT INTO CHANSON VALUES(455,'6: Allegretto',1,NULL,NULL,'2008-03-12 10:46:34');
INSERT INTO CHANSON VALUES(456,'Albinoni- Adagio',1,NULL,NULL,'2008-03-12 16:32:33');
INSERT INTO CHANSON VALUES(457,'Bach- Air',1,NULL,NULL,'2008-03-12 15:15:46');
INSERT INTO CHANSON VALUES(458,'Pachelbel- Canon et Gigue',1,NULL,NULL,'2008-03-12 17:53:13');
INSERT INTO CHANSON VALUES(459,'Vivaldi- Al santo sepolcro (1)',1,NULL,NULL,'2008-03-12 18:20:48');
INSERT INTO CHANSON VALUES(460,'Mozart- Divertimento KV287 (4)',1,NULL,NULL,'2008-03-12 13:46:14');
INSERT INTO CHANSON VALUES(461,'Van Beethoven- Symphonie 7 (2)',1,NULL,NULL,'2008-03-12 15:05:19');
INSERT INTO CHANSON VALUES(462,'Brahms- Symphonie 3 (2)',1,NULL,NULL,'2008-03-12 15:11:58');
INSERT INTO CHANSON VALUES(463,'Massenet- Meditation fe Thais',1,NULL,NULL,'2008-03-12 16:43:36');
INSERT INTO CHANSON VALUES(464,'Grieg- La mort d''Aase',1,NULL,NULL,'2008-03-12 11:25:00');
INSERT INTO CHANSON VALUES(465,'Mahler- Sehr langsam',1,NULL,NULL,'2008-03-12 14:38:47');
INSERT INTO CHANSON VALUES(466,'Sibelius- Valse triste op 44',1,NULL,NULL,'2008-03-12 09:22:19');
INSERT INTO CHANSON VALUES(467,'Concerto No. 1 in F  BWV1046 - Allegro',1,NULL,NULL,'2008-03-12 15:57:34');
INSERT INTO CHANSON VALUES(468,'-  Adagio',1,NULL,NULL,'2008-03-12 13:43:27');
INSERT INTO CHANSON VALUES(469,'-  Allegro',1,NULL,NULL,'2008-03-12 15:37:47');
INSERT INTO CHANSON VALUES(470,'-  Menuetto; Trio; Polonaise',1,NULL,NULL,'2008-03-12 13:03:34');
INSERT INTO CHANSON VALUES(471,'Concerto No. 2 in F  BWV1047 - Allegro',1,NULL,NULL,'2008-03-12 16:39:40');
INSERT INTO CHANSON VALUES(472,'-  Andante',1,NULL,NULL,'2008-03-12 08:15:51');
INSERT INTO CHANSON VALUES(473,'- Allegro, assai',1,NULL,NULL,'2008-03-12 19:58:35');
INSERT INTO CHANSON VALUES(474,'Concerto No.3 in G  BWV1048 - Allegro',1,NULL,NULL,'2008-03-12 15:14:00');
INSERT INTO CHANSON VALUES(475,'-  Cadenza: Adagio',1,NULL,NULL,'2008-03-12 15:46:39');
INSERT INTO CHANSON VALUES(476,'-  Allegro',1,NULL,NULL,'2008-03-12 12:52:01');
INSERT INTO CHANSON VALUES(477,'01 Allegro, Concerto No. 1 in E "La Primaverra"',1,NULL,NULL,'2008-03-12 16:31:59');
INSERT INTO CHANSON VALUES(478,'02 Largo, Concerto No. 1 in E "La Primaverra"',1,NULL,NULL,'2008-03-12 11:57:43');
INSERT INTO CHANSON VALUES(479,'03 Allegro, Concerto No. 1 in E "La Primaverra"',1,NULL,NULL,'2008-03-12 16:36:20');
INSERT INTO CHANSON VALUES(480,'04 Allegro non molto, Concerto No. 2 in G minor "L''estate"',1,NULL,NULL,'2008-03-12 14:04:24');
INSERT INTO CHANSON VALUES(481,'05 Adagio, Concerto No. 2 in G minor "L''estate"',1,NULL,NULL,'2008-03-12 09:46:03');
INSERT INTO CHANSON VALUES(482,'06 Presto, Concerto No. 2 in G minor "L''estate"',1,NULL,NULL,'2008-03-12 17:47:19');
INSERT INTO CHANSON VALUES(483,'07 Allegro, Concerto No. 3 in F "L''autunno"',1,NULL,NULL,'2008-03-12 15:46:17');
INSERT INTO CHANSON VALUES(484,'08 Adagio molto, Concerto No. 3 in F "L''autunno"',1,NULL,NULL,'2008-03-12 11:22:32');
INSERT INTO CHANSON VALUES(485,'09 Allegro, Concerto No. 3 in F "L''autunno"',1,NULL,NULL,'2008-03-12 11:58:18');
INSERT INTO CHANSON VALUES(486,'10 Allegro non molto, Concerto No. 4 in F minor "L''inverno"',1,NULL,NULL,'2008-03-12 19:21:10');
INSERT INTO CHANSON VALUES(487,'11 Largo, Concerto No. 4 in F minor "L''inverno"',1,NULL,NULL,'2008-03-12 19:04:42');
INSERT INTO CHANSON VALUES(488,'12 Allegro, Concerto No. 4 in F minor "L''inverno"',1,NULL,NULL,'2008-03-12 19:21:39');
INSERT INTO CHANSON VALUES(489,'Prélude op.28 N 4, E minor',1,NULL,NULL,'2008-03-12 16:06:16');
INSERT INTO CHANSON VALUES(490,'Mazurka op.17 N 2, E minor',1,NULL,NULL,'2008-03-12 08:39:21');
INSERT INTO CHANSON VALUES(491,'Valse op.64 N 1, D flat major',1,NULL,NULL,'2008-03-12 13:46:08');
INSERT INTO CHANSON VALUES(492,'Etude op.10 N 12, C minor',1,NULL,NULL,'2008-03-12 13:34:55');
INSERT INTO CHANSON VALUES(493,'Prélude op.28 N 7, A minor',1,NULL,NULL,'2008-03-12 17:14:42');
INSERT INTO CHANSON VALUES(494,'Concerto op.21 N 2, F minor',1,NULL,NULL,'2008-03-12 09:29:05');
INSERT INTO CHANSON VALUES(495,'Mazurka op.17 N 4, A minor',1,NULL,NULL,'2008-03-12 15:45:03');
INSERT INTO CHANSON VALUES(496,'Mazurka op.41 N 2, E minor',1,NULL,NULL,'2008-03-12 19:41:25');
INSERT INTO CHANSON VALUES(497,'Polonaise op.44, F sharp minor',1,NULL,NULL,'2008-03-12 09:39:29');
INSERT INTO CHANSON VALUES(498,'Nocturne op.48 N 1, C minor',1,NULL,NULL,'2008-03-12 18:37:51');
INSERT INTO CHANSON VALUES(499,'Mazurka op.24 N 4, B flat minor',1,NULL,NULL,'2008-03-12 14:18:57');
INSERT INTO CHANSON VALUES(500,'Marche Funèbre (Sonata op.35), B flat minor',1,NULL,NULL,'2008-03-12 17:19:36');
INSERT INTO CHANSON VALUES(501,'Recitativo: io deggio ad ogni patto ...',1,NULL,NULL,'2008-03-12 09:45:23');
INSERT INTO CHANSON VALUES(502,'Aria: Finch'' han dal vino',1,NULL,NULL,'2008-03-12 11:15:58');
INSERT INTO CHANSON VALUES(503,'Recitativo: Masetto, senti un po''!',1,NULL,NULL,'2008-03-12 10:04:12');
INSERT INTO CHANSON VALUES(504,'Aria: Batti, batti, o bel Masetto',1,NULL,NULL,'2008-03-12 19:10:41');
INSERT INTO CHANSON VALUES(505,'Recitativo: Guarda un po'' ...',1,NULL,NULL,'2008-03-12 08:49:27');
INSERT INTO CHANSON VALUES(506,'Finale: Preso, presto, pria ch''ei venga',1,NULL,NULL,'2008-03-12 08:46:09');
INSERT INTO CHANSON VALUES(507,'Tra quest'' arbori celata',1,NULL,NULL,'2008-03-12 14:55:49');
INSERT INTO CHANSON VALUES(508,'Bisogna aver corraggio',1,NULL,NULL,'2008-03-12 19:46:26');
INSERT INTO CHANSON VALUES(509,'Protegga il giusto cielo/Vendichi il giusto cielo',1,NULL,NULL,'2008-03-12 18:17:44');
INSERT INTO CHANSON VALUES(510,'Riposate, vezzose ragazze',1,NULL,NULL,'2008-03-12 17:05:04');
INSERT INTO CHANSON VALUES(511,'Venite pur avanti',1,NULL,NULL,'2008-03-12 13:14:50');
INSERT INTO CHANSON VALUES(512,'Ecco il birbo che t'' ha offesa!',1,NULL,NULL,'2008-03-12 17:32:05');
INSERT INTO CHANSON VALUES(513,'Trema, trema o scellerato!',1,NULL,NULL,'2008-03-12 17:45:09');
INSERT INTO CHANSON VALUES(514,'Duetto: Eh via, buffone, non mi seccar!',1,NULL,NULL,'2008-03-12 19:41:19');
INSERT INTO CHANSON VALUES(515,'Recitativo: Leporello! . . . Signore?',1,NULL,NULL,'2008-03-12 16:42:08');
INSERT INTO CHANSON VALUES(516,'Trio: Ah taci, ingiusto core!',1,NULL,NULL,'2008-03-12 09:47:55');
INSERT INTO CHANSON VALUES(517,'Recitativo: Amico, che ti par?',1,NULL,NULL,'2008-03-12 11:18:51');
INSERT INTO CHANSON VALUES(518,'Serenata: Deh vieni alla finestra',1,NULL,NULL,'2008-03-12 09:17:38');
INSERT INTO CHANSON VALUES(519,'Recitativo: V''e gente all finestra',1,NULL,NULL,'2008-03-12 14:08:55');
INSERT INTO CHANSON VALUES(520,'Aria: Meta di voi qua vadano',1,NULL,NULL,'2008-03-12 11:56:01');
INSERT INTO CHANSON VALUES(521,'Recitativo: Zitto, lascia ch''io senta',1,NULL,NULL,'2008-03-12 12:21:16');
INSERT INTO CHANSON VALUES(522,'Aria: Vedrai, carino ...',1,NULL,NULL,'2008-03-12 10:10:48');
INSERT INTO CHANSON VALUES(523,'Recitativo: Di molte faci il lume...',1,NULL,NULL,'2008-03-12 11:57:34');
INSERT INTO CHANSON VALUES(524,'Sestetto: Sola, sola in buio loco',1,NULL,NULL,'2008-03-12 13:56:16');
INSERT INTO CHANSON VALUES(525,'Ferma briccone, dove ten vai!',1,NULL,NULL,'2008-03-12 17:37:59');
INSERT INTO CHANSON VALUES(526,'Mille torbidi pensieri',1,NULL,NULL,'2008-03-12 19:46:47');
INSERT INTO CHANSON VALUES(527,'Recitativo: Dunque quello sei tu...',1,NULL,NULL,'2008-03-12 18:05:05');
INSERT INTO CHANSON VALUES(528,'Aria: Ah, pieta, signori miei!',1,NULL,NULL,'2008-03-12 16:12:22');
INSERT INTO CHANSON VALUES(529,'Recitativo: Ferma, perfido, frema!',1,NULL,NULL,'2008-03-12 12:46:31');
INSERT INTO CHANSON VALUES(530,'Aria: Il mio tesoro',1,NULL,NULL,'2008-03-12 11:04:28');
INSERT INTO CHANSON VALUES(531,'I.     Introitus: Requiem',1,NULL,NULL,'2008-03-12 11:27:50');
INSERT INTO CHANSON VALUES(532,'II.     Kyrie',1,NULL,NULL,'2008-03-12 14:40:00');
INSERT INTO CHANSON VALUES(533,'III.    Sequentia: Dies irae',1,NULL,NULL,'2008-03-12 12:58:58');
INSERT INTO CHANSON VALUES(534,'         Tuba mirum',1,NULL,NULL,'2008-03-12 19:26:54');
INSERT INTO CHANSON VALUES(535,'         Rex tremendae',1,NULL,NULL,'2008-03-12 10:13:32');
INSERT INTO CHANSON VALUES(536,'         Recordare',1,NULL,NULL,'2008-03-12 10:09:19');
INSERT INTO CHANSON VALUES(537,'         Confutatis',1,NULL,NULL,'2008-03-12 19:01:24');
INSERT INTO CHANSON VALUES(538,'         Lacrimosa',1,NULL,NULL,'2008-03-12 09:45:37');
INSERT INTO CHANSON VALUES(539,'IV.   Offertorium: Domine Jesu',1,NULL,NULL,'2008-03-12 13:06:23');
INSERT INTO CHANSON VALUES(540,'         Hostias',1,NULL,NULL,'2008-03-12 19:24:28');
INSERT INTO CHANSON VALUES(541,'V.    Sanctus',1,NULL,NULL,'2008-03-12 13:42:55');
INSERT INTO CHANSON VALUES(542,'VI.   Benedictus',1,NULL,NULL,'2008-03-12 11:17:36');
INSERT INTO CHANSON VALUES(543,'VII.  Agnus Dei',1,NULL,NULL,'2008-03-12 11:40:34');
INSERT INTO CHANSON VALUES(544,'VIII. Communio: Lux aeterna',1,NULL,NULL,'2008-03-12 11:37:01');
INSERT INTO CHANSON VALUES(545,'Pachelbel - Canon in D major',1,NULL,NULL,'2008-03-12 10:51:14');
INSERT INTO CHANSON VALUES(546,'Albinoni/Giazotto - Adagio in G minor',1,NULL,NULL,'2008-03-12 16:04:24');
INSERT INTO CHANSON VALUES(547,'Bach - Jesu, Joy of Man''s Desiring',1,NULL,NULL,'2008-03-12 08:04:25');
INSERT INTO CHANSON VALUES(548,'Purcell - Chacony in G minor',1,NULL,NULL,'2008-03-12 13:09:11');
INSERT INTO CHANSON VALUES(549,'Bach - Air from : Orchestral Suite no.3 in D major',1,NULL,NULL,'2008-03-12 09:37:17');
INSERT INTO CHANSON VALUES(550,'Corelli - Concerto in G minor op. 6 no. 8 - Vivace - Grave',1,NULL,NULL,'2008-03-12 13:36:42');
INSERT INTO CHANSON VALUES(551,'Corelli - Concerto in G minor op. 6 no. 8 - Allegro',1,NULL,NULL,'2008-03-12 19:03:24');
INSERT INTO CHANSON VALUES(552,'Corelli - Concerto in G minor op. 6 no. 8 - Adagio - Allegro - Adagio',1,NULL,NULL,'2008-03-12 18:21:41');
INSERT INTO CHANSON VALUES(553,'Corelli - Concerto in G minor op. 6 no. 8 - Vivace',1,NULL,NULL,'2008-03-12 13:39:21');
INSERT INTO CHANSON VALUES(554,'Corelli - Concerto in G minor op. 6 no. 8 - Allegro - Pastorale. Largo',1,NULL,NULL,'2008-03-12 08:55:59');
INSERT INTO CHANSON VALUES(555,'Handel - Sinfonia in B flat major',1,NULL,NULL,'2008-03-12 08:06:50');
INSERT INTO CHANSON VALUES(556,'Handel - Largo',1,NULL,NULL,'2008-03-12 11:50:55');
INSERT INTO CHANSON VALUES(557,'Vivaldi - Concerto in B minor op. 3 no. 10 - Allegro',1,NULL,NULL,'2008-03-12 16:53:59');
INSERT INTO CHANSON VALUES(558,'Vivaldi - Concerto in B minor op. 3 no. 10 - Largo',1,NULL,NULL,'2008-03-12 09:21:08');
INSERT INTO CHANSON VALUES(559,'Vivaldi - Concerto in B minor op. 3 no. 10 - Allegro',1,NULL,NULL,'2008-03-12 12:26:45');
INSERT INTO CHANSON VALUES(560,'',1,NULL,NULL,'2008-03-12 15:54:22');
INSERT INTO CHANSON VALUES(561,'',1,NULL,NULL,'2008-03-12 12:51:25');
INSERT INTO CHANSON VALUES(562,'',1,NULL,NULL,'2008-03-12 17:44:46');
INSERT INTO CHANSON VALUES(563,'',1,NULL,NULL,'2008-03-12 13:12:26');
INSERT INTO CHANSON VALUES(564,'',1,NULL,NULL,'2008-03-12 17:16:21');
INSERT INTO CHANSON VALUES(565,'',1,NULL,NULL,'2008-03-12 17:21:27');
INSERT INTO CHANSON VALUES(566,'',1,NULL,NULL,'2008-03-12 15:40:17');
INSERT INTO CHANSON VALUES(567,'',1,NULL,NULL,'2008-03-12 14:24:10');
INSERT INTO CHANSON VALUES(568,'',1,NULL,NULL,'2008-03-12 14:33:32');
INSERT INTO CHANSON VALUES(569,'',1,NULL,NULL,'2008-03-12 16:53:58');
INSERT INTO CHANSON VALUES(570,'',1,NULL,NULL,'2008-03-12 13:32:53');
INSERT INTO CHANSON VALUES(571,'',1,NULL,NULL,'2008-03-12 17:52:45');
INSERT INTO CHANSON VALUES(572,'',1,NULL,NULL,'2008-03-12 11:37:29');
INSERT INTO CHANSON VALUES(573,'',1,NULL,NULL,'2008-03-12 08:04:42');
INSERT INTO CHANSON VALUES(574,'',1,NULL,NULL,'2008-03-12 13:52:58');
INSERT INTO CHANSON VALUES(575,'2ème prologue (version originale)',1,NULL,NULL,'2008-03-12 18:40:19');
INSERT INTO CHANSON VALUES(576,'Convoi funèbre de Juliette (version originale)',1,NULL,NULL,'2008-03-12 11:19:00');
INSERT INTO CHANSON VALUES(577,'Requiem aeternam',1,NULL,NULL,'2008-03-12 15:53:24');
INSERT INTO CHANSON VALUES(578,'Roméo au tombreau des Capulets/Final (version standard)',1,NULL,NULL,'2008-03-12 17:26:57');
INSERT INTO CHANSON VALUES(579,'Quoi! Roméo de retour',1,NULL,NULL,'2008-03-12 11:08:51');
INSERT INTO CHANSON VALUES(580,'Mais vous avez repris la guerre de famille',1,NULL,NULL,'2008-03-12 11:35:24');
INSERT INTO CHANSON VALUES(581,'Mais notre sang rougit leur glaive',1,NULL,NULL,'2008-03-12 10:25:16');
INSERT INTO CHANSON VALUES(582,'Jurez donc par l''auguste symbole',1,NULL,NULL,'2008-03-12 19:41:54');
INSERT INTO CHANSON VALUES(583,'Convoi funèbre de Juliette/Final (version originale)',1,NULL,NULL,'2008-03-12 13:44:59');
INSERT INTO CHANSON VALUES(584,'Quoi! Roméo de retour',1,NULL,NULL,'2008-03-12 09:13:51');
INSERT INTO CHANSON VALUES(585,'Mais vous avez repris la guerre de famille',1,NULL,NULL,'2008-03-12 09:03:32');
INSERT INTO CHANSON VALUES(586,'Mais notre sang rougit leur glaive',1,NULL,NULL,'2008-03-12 13:21:51');
INSERT INTO CHANSON VALUES(587,'Jurez donc par l''auguste symbole',1,NULL,NULL,'2008-03-12 13:56:44');
INSERT INTO CHANSON VALUES(588,'Et nous voulons par notre hommage',1,NULL,NULL,'2008-03-12 18:42:11');
INSERT INTO CHANSON VALUES(589,'Sonate I en Mi bemol Majeur, BWV 525 - Allegro',1,NULL,NULL,'2008-03-12 17:01:19');
INSERT INTO CHANSON VALUES(590,'Sonate I en Mi bemol Majeur, BWV 525 - Adagio',1,NULL,NULL,'2008-03-12 16:18:55');
INSERT INTO CHANSON VALUES(591,'Sonate I en Mi bemol Majeur, BWV 525 - Allegro',1,NULL,NULL,'2008-03-12 09:28:20');
INSERT INTO CHANSON VALUES(592,'Sonate II en Ut Mineur, BWV 526 - Vivace',1,NULL,NULL,'2008-03-12 12:24:02');
INSERT INTO CHANSON VALUES(593,'Sonate II en Ut Mineur, BWV 526 - Largo',1,NULL,NULL,'2008-03-12 11:50:47');
INSERT INTO CHANSON VALUES(594,'Sonate II en Ut Mineur, BWV 526 - Allegro',1,NULL,NULL,'2008-03-12 11:58:00');
INSERT INTO CHANSON VALUES(595,'Sonate III en Re Mineur, BWV 527 - Andante',1,NULL,NULL,'2008-03-12 09:04:04');
INSERT INTO CHANSON VALUES(596,'Sonate III en Re Mineur, BWV 527 - Adagio e dolce',1,NULL,NULL,'2008-03-12 16:30:26');
INSERT INTO CHANSON VALUES(597,'Sonate III en Re Mineur, BWV 527 - Vivace',1,NULL,NULL,'2008-03-12 14:57:22');
INSERT INTO CHANSON VALUES(598,'Sonate IV en MI Mineur, BWV 528 - Adagio - Vivace',1,NULL,NULL,'2008-03-12 11:48:05');
INSERT INTO CHANSON VALUES(599,'Sonate IV en MI Mineur, BWV 528 - Andante',1,NULL,NULL,'2008-03-12 13:38:06');
INSERT INTO CHANSON VALUES(600,'Sonate IV en MI Mineur, BWV 528 - Un poco Allegro',1,NULL,NULL,'2008-03-12 17:19:24');
INSERT INTO CHANSON VALUES(601,'Sonate V in Ut Majeur, BWV 529 - Allegro',1,NULL,NULL,'2008-03-12 16:24:53');
INSERT INTO CHANSON VALUES(602,'Sonate V in Ut Majeur, BWV 529 - Largo',1,NULL,NULL,'2008-03-12 08:46:18');
INSERT INTO CHANSON VALUES(603,'Sonate V in Ut Majeur, BWV 529 - Allegro',1,NULL,NULL,'2008-03-12 09:03:08');
INSERT INTO CHANSON VALUES(604,'Allegro',1,NULL,NULL,'2008-03-12 18:19:06');
INSERT INTO CHANSON VALUES(605,'largo assai',1,NULL,NULL,'2008-03-12 18:27:10');
INSERT INTO CHANSON VALUES(606,'Menuetto - allegretto',1,NULL,NULL,'2008-03-12 19:08:41');
INSERT INTO CHANSON VALUES(607,'Finale: Allegro con brio',1,NULL,NULL,'2008-03-12 12:40:39');
INSERT INTO CHANSON VALUES(608,'Adagio - Allegro vivace',1,NULL,NULL,'2008-03-12 17:57:28');
INSERT INTO CHANSON VALUES(609,'Adagio non lento',1,NULL,NULL,'2008-03-12 18:25:06');
INSERT INTO CHANSON VALUES(610,'Intermezzo',1,NULL,NULL,'2008-03-12 19:12:25');
INSERT INTO CHANSON VALUES(611,'Presto',1,NULL,NULL,'2008-03-12 12:54:50');
INSERT INTO CHANSON VALUES(612,'Allegro moderato non tanto',1,NULL,NULL,'2008-03-12 11:57:37');
INSERT INTO CHANSON VALUES(613,'Andante',1,NULL,NULL,'2008-03-12 15:03:41');
INSERT INTO CHANSON VALUES(614,'Menuetto',1,NULL,NULL,'2008-03-12 16:56:01');
INSERT INTO CHANSON VALUES(615,'Rondo (allegretto)',1,NULL,NULL,'2008-03-12 18:50:28');
INSERT INTO CHANSON VALUES(616,'Allegro lento',1,NULL,NULL,'2008-03-12 08:48:36');
INSERT INTO CHANSON VALUES(617,'Minuetto',1,NULL,NULL,'2008-03-12 16:13:17');
INSERT INTO CHANSON VALUES(618,'Larghetto',1,NULL,NULL,'2008-03-12 12:00:14');
INSERT INTO CHANSON VALUES(619,'Finale: allegro vivo assai',1,NULL,NULL,'2008-03-12 18:53:39');
INSERT INTO CHANSON VALUES(620,'Ricercare a 3',1,NULL,NULL,'2008-03-12 19:52:51');
INSERT INTO CHANSON VALUES(621,'Canon perpetuus super thema regium',1,NULL,NULL,'2008-03-12 12:15:46');
INSERT INTO CHANSON VALUES(622,'Canon a 2',1,NULL,NULL,'2008-03-12 10:32:43');
INSERT INTO CHANSON VALUES(623,'Canon a 2 Violini in unisono',1,NULL,NULL,'2008-03-12 17:07:47');
INSERT INTO CHANSON VALUES(624,'Canon a 2 per motum contrarium',1,NULL,NULL,'2008-03-12 14:50:43');
INSERT INTO CHANSON VALUES(625,'Canon a 2 per augmentationem, contrario motu',1,NULL,NULL,'2008-03-12 14:41:33');
INSERT INTO CHANSON VALUES(626,'Canon a 2 per tonos',1,NULL,NULL,'2008-03-12 08:42:22');
INSERT INTO CHANSON VALUES(627,'Fuga Canonica in Epidiapente',1,NULL,NULL,'2008-03-12 15:25:35');
INSERT INTO CHANSON VALUES(628,'Ricercare a 6',1,NULL,NULL,'2008-03-12 19:47:36');
INSERT INTO CHANSON VALUES(629,'Canon a 2',1,NULL,NULL,'2008-03-12 09:37:29');
INSERT INTO CHANSON VALUES(630,'Canon a 4',1,NULL,NULL,'2008-03-12 17:33:21');
INSERT INTO CHANSON VALUES(631,'Trio - Largo',1,NULL,NULL,'2008-03-12 16:55:37');
INSERT INTO CHANSON VALUES(632,'Trio - Allegro',1,NULL,NULL,'2008-03-12 13:08:09');
INSERT INTO CHANSON VALUES(633,'Trio - Andante',1,NULL,NULL,'2008-03-12 10:58:17');
INSERT INTO CHANSON VALUES(634,'Trio - Allegro',1,NULL,NULL,'2008-03-12 19:29:08');
INSERT INTO CHANSON VALUES(635,'Canon perpetuus',1,NULL,NULL,'2008-03-12 16:01:49');
INSERT INTO CHANSON VALUES(636,'',1,NULL,NULL,'2008-03-12 11:02:31');
INSERT INTO CHANSON VALUES(637,'',1,NULL,NULL,'2008-03-12 15:40:57');
INSERT INTO CHANSON VALUES(638,'',1,NULL,NULL,'2008-03-12 10:35:44');
INSERT INTO CHANSON VALUES(639,'',1,NULL,NULL,'2008-03-12 17:44:22');
INSERT INTO CHANSON VALUES(640,'',1,NULL,NULL,'2008-03-12 11:33:56');
INSERT INTO CHANSON VALUES(641,'',1,NULL,NULL,'2008-03-12 16:14:52');
INSERT INTO CHANSON VALUES(642,'',1,NULL,NULL,'2008-03-12 11:41:00');
INSERT INTO CHANSON VALUES(643,'',1,NULL,NULL,'2008-03-12 13:52:58');
INSERT INTO CHANSON VALUES(644,'',1,NULL,NULL,'2008-03-12 17:51:28');
INSERT INTO CHANSON VALUES(645,'',1,NULL,NULL,'2008-03-12 18:32:29');
INSERT INTO CHANSON VALUES(646,'',1,NULL,NULL,'2008-03-12 16:47:31');
INSERT INTO CHANSON VALUES(647,'',1,NULL,NULL,'2008-03-12 11:25:12');
INSERT INTO CHANSON VALUES(648,'',1,NULL,NULL,'2008-03-12 10:38:47');
INSERT INTO CHANSON VALUES(649,'',1,NULL,NULL,'2008-03-12 19:27:31');
INSERT INTO CHANSON VALUES(650,'',1,NULL,NULL,'2008-03-12 11:46:05');
INSERT INTO CHANSON VALUES(651,'O Fortuna',1,NULL,NULL,'2008-03-12 11:28:19');
INSERT INTO CHANSON VALUES(652,'Fortune plango vulnera',1,NULL,NULL,'2008-03-12 09:46:01');
INSERT INTO CHANSON VALUES(653,'Veris leta facies',1,NULL,NULL,'2008-03-12 09:15:54');
INSERT INTO CHANSON VALUES(654,'Omnis Sol temperat',1,NULL,NULL,'2008-03-12 09:00:45');
INSERT INTO CHANSON VALUES(655,'Ecce gratum',1,NULL,NULL,'2008-03-12 15:54:18');
INSERT INTO CHANSON VALUES(656,'Tanz',1,NULL,NULL,'2008-03-12 09:37:05');
INSERT INTO CHANSON VALUES(657,'Floret solva nobilis',1,NULL,NULL,'2008-03-12 15:52:31');
INSERT INTO CHANSON VALUES(658,'Chramer, gip die warve mir',1,NULL,NULL,'2008-03-12 17:05:09');
INSERT INTO CHANSON VALUES(659,'Reie - Swaz hie gat umbe - Chume, chum geselle min - Swaz hie gat umbe',1,NULL,NULL,'2008-03-12 15:02:37');
INSERT INTO CHANSON VALUES(660,'Were diu werlt alle min',1,NULL,NULL,'2008-03-12 09:22:23');
INSERT INTO CHANSON VALUES(661,'Estuans interius',1,NULL,NULL,'2008-03-12 10:38:52');
INSERT INTO CHANSON VALUES(662,'Olim lacus colueram',1,NULL,NULL,'2008-03-12 14:47:38');
INSERT INTO CHANSON VALUES(663,'Ego sum abbas',1,NULL,NULL,'2008-03-12 15:56:54');
INSERT INTO CHANSON VALUES(664,'In taberna quando sumus',1,NULL,NULL,'2008-03-12 13:05:55');
INSERT INTO CHANSON VALUES(665,'Amor volat undique',1,NULL,NULL,'2008-03-12 11:41:49');
INSERT INTO CHANSON VALUES(666,'Dies, nox et omnia',1,NULL,NULL,'2008-03-12 14:47:27');
INSERT INTO CHANSON VALUES(667,'Stetit puella',1,NULL,NULL,'2008-03-12 15:25:20');
INSERT INTO CHANSON VALUES(668,'Circa mea pectora',1,NULL,NULL,'2008-03-12 10:15:26');
INSERT INTO CHANSON VALUES(669,'Si puer cum puellula',1,NULL,NULL,'2008-03-12 11:52:28');
INSERT INTO CHANSON VALUES(670,'Veni, veni, venias',1,NULL,NULL,'2008-03-12 19:00:51');
INSERT INTO CHANSON VALUES(671,'In trutina',1,NULL,NULL,'2008-03-12 12:14:30');
INSERT INTO CHANSON VALUES(672,'Tempus est iocundum',1,NULL,NULL,'2008-03-12 10:48:17');
INSERT INTO CHANSON VALUES(673,'Dulcissime',1,NULL,NULL,'2008-03-12 18:24:14');
INSERT INTO CHANSON VALUES(674,'Ave formosissima',1,NULL,NULL,'2008-03-12 17:53:19');
INSERT INTO CHANSON VALUES(675,'O Fortuna',1,NULL,NULL,'2008-03-12 16:08:01');
INSERT INTO CHANSON VALUES(676,'Ouverture',1,NULL,NULL,'2008-03-12 14:42:48');
INSERT INTO CHANSON VALUES(677,'Erster Aufzug - No. 01 - "Zu Hilfe! zu Hilfe! sonst bin ich verloren" <Drei  Damen, Tamino>;',1,NULL,NULL,'2008-03-12 19:21:14');
INSERT INTO CHANSON VALUES(678,'Erster Aufzug - Zwischentext #01',1,NULL,NULL,'2008-03-12 11:32:29');
INSERT INTO CHANSON VALUES(679,'Erster Aufzug - No. 02 Aria - "Der Vogelfünger bin ich ja" <Papageno>',1,NULL,NULL,'2008-03-12 17:52:21');
INSERT INTO CHANSON VALUES(680,'Erster Aufzug - Zwischentext #02',1,NULL,NULL,'2008-03-12 10:48:22');
INSERT INTO CHANSON VALUES(681,'Erster Aufzug - No. 03 Aria - "Dies Bildnis ist bezaubernd schön" <Tamino>',1,NULL,NULL,'2008-03-12 09:09:37');
INSERT INTO CHANSON VALUES(682,'Erster Aufzug - Zwischentext #03',1,NULL,NULL,'2008-03-12 15:22:26');
INSERT INTO CHANSON VALUES(683,'Erster Aufzug - No. 04 Recitativo ed Aria - "O zitter nicht, mein lieber Sohn" <Königin derNacht>',1,NULL,NULL,'2008-03-12 18:14:50');
INSERT INTO CHANSON VALUES(684,'Erster Aufzug - Zwischentext #04',1,NULL,NULL,'2008-03-12 09:00:44');
INSERT INTO CHANSON VALUES(685,'Erster Aufzug - No. 05 Quintetto - "Hm! hm! hm!" <Drei Damen, Tamino, Papageno',1,NULL,NULL,'2008-03-12 13:41:53');
INSERT INTO CHANSON VALUES(686,'Erster Aufzug - Zwischentext #05',1,NULL,NULL,'2008-03-12 13:12:35');
INSERT INTO CHANSON VALUES(687,'Erster Aufzug - No. 06 Terzetto - "Du feines Töubchen" <Pamina, Monostatos, Papageno>',1,NULL,NULL,'2008-03-12 11:10:57');
INSERT INTO CHANSON VALUES(688,'Erster Aufzug - Zwischentext #06',1,NULL,NULL,'2008-03-12 14:30:29');
INSERT INTO CHANSON VALUES(689,'Erster Aufzug - No. 07 Duetto - "Bei Männern, welche Liebe fühlen" <Pamina, Papageno>',1,NULL,NULL,'2008-03-12 08:15:21');
INSERT INTO CHANSON VALUES(690,'Erster Aufzug - Zwischentext #07',1,NULL,NULL,'2008-03-12 12:29:10');
INSERT INTO CHANSON VALUES(691,'Erster Aufzug - No. 08 Finale - "Zum Ziele führt dich diese Bahn" <Pamina, Drei Knaben,  Tamino, Monostatos, Sarastro, Spr',1,NULL,NULL,'2008-03-12 17:35:20');
INSERT INTO CHANSON VALUES(692,'Zweiter Aufzug - No. 09 Marcia',1,NULL,NULL,'2008-03-12 12:10:42');
INSERT INTO CHANSON VALUES(693,'Zweiter Aufzug - Zwischentext #08',1,NULL,NULL,'2008-03-12 17:03:57');
INSERT INTO CHANSON VALUES(694,'Zweiter Aufzug - No. 11 Duetto - "O Isis und Osiris" <Sarastro, Chor>',1,NULL,NULL,'2008-03-12 16:11:57');
INSERT INTO CHANSON VALUES(695,'Zweiter Aufzug - Zwischentext #09',1,NULL,NULL,'2008-03-12 12:38:38');
INSERT INTO CHANSON VALUES(696,'Zweiter Aufzug - No. 11 Duetto - "Bewahret euch vor Weibertöcken" <Zweiter Prister, Sprecher>',1,NULL,NULL,'2008-03-12 11:07:50');
INSERT INTO CHANSON VALUES(697,'Zweiter Aufzug - Zwischentext #10',1,NULL,NULL,'2008-03-12 18:25:01');
INSERT INTO CHANSON VALUES(698,'Zweiter Aufzug - No. 12 Quintetto - "Wie? Wie? Wie? Ihr an diesem Schreckensort?" <Drei Damen, Tamino, Papageno>',1,NULL,NULL,'2008-03-12 18:57:31');
INSERT INTO CHANSON VALUES(699,'Zweiter Aufzug - Zwischentext #11',1,NULL,NULL,'2008-03-12 12:59:47');
INSERT INTO CHANSON VALUES(700,'Zweiter Aufzug - No. 13 Aria - "Alles fühlt der Liebe Freuden" <Monostatos>',1,NULL,NULL,'2008-03-12 16:22:16');
INSERT INTO CHANSON VALUES(701,'Zweiter Aufzug - Zwischentext #12',1,NULL,NULL,'2008-03-12 18:08:52');
INSERT INTO CHANSON VALUES(702,'Zweiter Aufzug - No. 14 Aria - "Der Hölle Rache kocht in meiner Herzen" <Königin der nacht>',1,NULL,NULL,'2008-03-12 10:32:02');
INSERT INTO CHANSON VALUES(703,'Zweiter Aufzug - Zwischentext #13',1,NULL,NULL,'2008-03-12 19:21:06');
INSERT INTO CHANSON VALUES(704,'Zweiter Aufzug - No. 15 Aria - "In diesen heil''gen Hallen kennt man die Rache nicht!" <Sarastro>',1,NULL,NULL,'2008-03-12 18:02:18');
INSERT INTO CHANSON VALUES(705,'Zweiter Aufzug - Zwischentext #14',1,NULL,NULL,'2008-03-12 17:26:57');
INSERT INTO CHANSON VALUES(706,'Zweiter Aufzug - No. 16 Terzetto - "Seid uns zum zweiten Mal willkommen" <Drei Knaben>',1,NULL,NULL,'2008-03-12 13:44:04');
INSERT INTO CHANSON VALUES(707,'Zweiter Aufzug - Zwischentext #15',1,NULL,NULL,'2008-03-12 11:37:30');
INSERT INTO CHANSON VALUES(708,'Zweiter Aufzug - No. 17 Aria - "Ach ich fühl''s, es ist verschwunden!" <Pamina>',1,NULL,NULL,'2008-03-12 11:28:27');
INSERT INTO CHANSON VALUES(709,'Zweiter Aufzug - Zwischentext #16',1,NULL,NULL,'2008-03-12 18:48:26');
INSERT INTO CHANSON VALUES(710,'Zweiter Aufzug - No. 18 Chor De Preister - "O Isis, und O Osiris, welche Wonne!"',1,NULL,NULL,'2008-03-12 15:30:49');
INSERT INTO CHANSON VALUES(711,'Zweiter Aufzug - Zwischentext #17',1,NULL,NULL,'2008-03-12 19:23:57');
INSERT INTO CHANSON VALUES(712,'Zweiter Aufzug - No 19 Terzetto - "Soll ich dich Teurer nicht mehr sehn?" <Pamina, Tamino, Sarastro>',1,NULL,NULL,'2008-03-12 17:35:29');
INSERT INTO CHANSON VALUES(713,'Zweiter Aufzug - Zwischentext #18',1,NULL,NULL,'2008-03-12 18:31:51');
INSERT INTO CHANSON VALUES(714,'Zweiter Aufzug - No. 2 Aria - "Ein Müden oder Weibchen wünscht Papageno sich!" <Papageno>',1,NULL,NULL,'2008-03-12 19:23:54');
INSERT INTO CHANSON VALUES(715,'Zweiter Aufzug - Zwischentext #19',1,NULL,NULL,'2008-03-12 10:13:20');
INSERT INTO CHANSON VALUES(716,'Zweiter Aufzug - No. 21 Finale - "Bald prangt, den Morgen zu verkünden"',1,NULL,NULL,'2008-03-12 10:41:05');
INSERT INTO CHANSON VALUES(717,'Vorspiel',1,NULL,NULL,'2008-03-12 11:59:43');
INSERT INTO CHANSON VALUES(718,'Wes Herd dies auch sei',1,NULL,NULL,'2008-03-12 17:19:12');
INSERT INTO CHANSON VALUES(719,'Einen Unseligen labtest du',1,NULL,NULL,'2008-03-12 10:11:01');
INSERT INTO CHANSON VALUES(720,'Mued am Herd fand ich den Mann',1,NULL,NULL,'2008-03-12 16:49:31');
INSERT INTO CHANSON VALUES(721,'Friedmund darf ich nicht heissen',1,NULL,NULL,'2008-03-12 14:45:55');
INSERT INTO CHANSON VALUES(722,'Die so leidig Los dir beschied',1,NULL,NULL,'2008-03-12 13:32:31');
INSERT INTO CHANSON VALUES(723,'Ich weiss ein wildes Geschlecht',1,NULL,NULL,'2008-03-12 19:22:02');
INSERT INTO CHANSON VALUES(724,'Ein Schwert verhiess mir der Vater',1,NULL,NULL,'2008-03-12 17:19:26');
INSERT INTO CHANSON VALUES(725,'Schlaefst du, Gast?',1,NULL,NULL,'2008-03-12 16:34:39');
INSERT INTO CHANSON VALUES(726,'Winterstuerme wichen dem Wonnemond',1,NULL,NULL,'2008-03-12 08:46:20');
INSERT INTO CHANSON VALUES(727,'Du bist der Lenz',1,NULL,NULL,'2008-03-12 10:02:20');
INSERT INTO CHANSON VALUES(728,'O suesseste Wonne! Seligstes Weib!',1,NULL,NULL,'2008-03-12 18:49:40');
INSERT INTO CHANSON VALUES(729,'Siegmund heiss'' ich und Siegmund bin ich!',1,NULL,NULL,'2008-03-12 09:03:51');
INSERT INTO CHANSON VALUES(730,'Walkürenritt',1,NULL,NULL,'2008-03-12 09:44:41');
INSERT INTO CHANSON VALUES(731,'Schützt mich und helft in höchster Not!',1,NULL,NULL,'2008-03-12 15:14:26');
INSERT INTO CHANSON VALUES(732,'Nicht sehre dich Sorge um mich',1,NULL,NULL,'2008-03-12 14:42:58');
INSERT INTO CHANSON VALUES(733,'Steh, Brünnhild''!',1,NULL,NULL,'2008-03-12 08:40:21');
INSERT INTO CHANSON VALUES(734,'Hier bin ich. Vater: gebiete die Strafe!',1,NULL,NULL,'2008-03-12 09:30:40');
INSERT INTO CHANSON VALUES(735,'War es so schmühlich, was ich verbrach',1,NULL,NULL,'2008-03-12 14:14:14');
INSERT INTO CHANSON VALUES(736,'Deinen leichten Sinn la dich denn leiten',1,NULL,NULL,'2008-03-12 10:18:00');
INSERT INTO CHANSON VALUES(737,'Du zeugtest ein edles Geschlecht',1,NULL,NULL,'2008-03-12 14:28:03');
INSERT INTO CHANSON VALUES(738,'Leb wohl, du kühnes, herrliches Kind!',1,NULL,NULL,'2008-03-12 18:22:52');
INSERT INTO CHANSON VALUES(739,'Der Augen leuchtendes Paar',1,NULL,NULL,'2008-03-12 14:27:56');
INSERT INTO CHANSON VALUES(740,'Loge, hör! Lausche hieher!',1,NULL,NULL,'2008-03-12 13:33:40');
INSERT INTO CHANSON VALUES(741,'Feuerzauber',1,NULL,NULL,'2008-03-12 09:12:55');
INSERT INTO CHANSON VALUES(742,'Vorspiel - Nun züume dein Roï, reisige Maid!',1,NULL,NULL,'2008-03-12 14:45:37');
INSERT INTO CHANSON VALUES(743,'Hojotoho! Hojotoho!',1,NULL,NULL,'2008-03-12 14:50:18');
INSERT INTO CHANSON VALUES(744,'Der alte Sturm, die alte Müh''!',1,NULL,NULL,'2008-03-12 18:57:48');
INSERT INTO CHANSON VALUES(745,'So ist es denn aus mit den ewigen Göttern',1,NULL,NULL,'2008-03-12 14:29:02');
INSERT INTO CHANSON VALUES(746,'Heiaha! Heiaha! Hojotoho! - Nimm den Eid!',1,NULL,NULL,'2008-03-12 17:42:21');
INSERT INTO CHANSON VALUES(747,'Schlimm, fürcht'' ich, schloï der Streit',1,NULL,NULL,'2008-03-12 17:14:49');
INSERT INTO CHANSON VALUES(748,'Als junger Liebe Lust mir verblich',1,NULL,NULL,'2008-03-12 18:08:11');
INSERT INTO CHANSON VALUES(749,'Ein andres ist''s: achte es wohl!',1,NULL,NULL,'2008-03-12 16:41:39');
INSERT INTO CHANSON VALUES(750,'So nimm du von Siegmund den Sieg?',1,NULL,NULL,'2008-03-12 16:07:13');
INSERT INTO CHANSON VALUES(751,'So nimm meinen Segen, Niblungen-Sohn!',1,NULL,NULL,'2008-03-12 12:13:25');
INSERT INTO CHANSON VALUES(752,'Raste nun hier, goenne Dir Ruh!',1,NULL,NULL,'2008-03-12 11:46:11');
INSERT INTO CHANSON VALUES(753,'Hinweg! Hinweg! Flieh die Entweihte!',1,NULL,NULL,'2008-03-12 18:17:01');
INSERT INTO CHANSON VALUES(754,'Siegmund! Sieh auf mich!',1,NULL,NULL,'2008-03-12 10:10:58');
INSERT INTO CHANSON VALUES(755,'Erdenluft muss sie noch atmen',1,NULL,NULL,'2008-03-12 19:43:28');
INSERT INTO CHANSON VALUES(756,'Weh! Weh! Suessestes Weib',1,NULL,NULL,'2008-03-12 08:30:10');
INSERT INTO CHANSON VALUES(757,'Zwei Leben lachen dir hier',1,NULL,NULL,'2008-03-12 12:19:25');
INSERT INTO CHANSON VALUES(758,'Zauberfest bezaehmt ein Schlaf',1,NULL,NULL,'2008-03-12 10:10:33');
INSERT INTO CHANSON VALUES(759,'Wehwalt! Wehwalt!',1,NULL,NULL,'2008-03-12 12:54:15');
INSERT INTO CHANSON VALUES(760,'Introduction',1,NULL,NULL,'2008-03-12 08:34:22');
INSERT INTO CHANSON VALUES(761,'Of the Backworldsmen',1,NULL,NULL,'2008-03-12 11:55:36');
INSERT INTO CHANSON VALUES(762,'Of the Great Longing',1,NULL,NULL,'2008-03-12 16:11:22');
INSERT INTO CHANSON VALUES(763,'Of Joys and Passions',1,NULL,NULL,'2008-03-12 18:04:40');
INSERT INTO CHANSON VALUES(764,'The Song of the Grave',1,NULL,NULL,'2008-03-12 18:15:51');
INSERT INTO CHANSON VALUES(765,'Of Science',1,NULL,NULL,'2008-03-12 18:15:34');
INSERT INTO CHANSON VALUES(766,'The Convalescent',1,NULL,NULL,'2008-03-12 12:18:05');
INSERT INTO CHANSON VALUES(767,'The Dance-Song',1,NULL,NULL,'2008-03-12 14:41:24');
INSERT INTO CHANSON VALUES(768,'Song of the Night Wanderer',1,NULL,NULL,'2008-03-12 19:54:35');
INSERT INTO CHANSON VALUES(769,'Don Juan opus 20 - Tone-Poem After Nikolaus Lenau',1,NULL,NULL,'2008-03-12 14:18:30');
INSERT INTO CHANSON VALUES(770,'Trollin''',1,NULL,'f','2008-03-12 17:22:05');
INSERT INTO CHANSON VALUES(771,'You Can''t Have Friends',1,NULL,'f','2008-03-12 09:39:00');
INSERT INTO CHANSON VALUES(772,'ATM',1,NULL,'f','2008-03-12 16:21:11');
INSERT INTO CHANSON VALUES(773,'My Idea Of Fun',1,NULL,'f','2008-03-12 09:14:16');
INSERT INTO CHANSON VALUES(774,'He Weirdness',1,NULL,'f','2008-03-12 17:09:32');
INSERT INTO CHANSON VALUES(775,'Free & Freaky',1,NULL,'f','2008-03-12 15:02:48');
INSERT INTO CHANSON VALUES(776,'Greedy Awful People',1,NULL,'f','2008-03-12 10:24:06');
INSERT INTO CHANSON VALUES(777,'She Took My Money',1,NULL,'f','2008-03-12 12:55:47');
INSERT INTO CHANSON VALUES(778,'The End Of Christianity',1,NULL,'f','2008-03-12 17:52:41');
INSERT INTO CHANSON VALUES(779,'Mexican Guy',1,NULL,'f','2008-03-12 12:23:00');
INSERT INTO CHANSON VALUES(780,'Passing Cloud',1,NULL,'f','2008-03-12 18:09:22');
INSERT INTO CHANSON VALUES(781,'I''m Fried',1,NULL,'f','2008-03-12 19:17:02');
INSERT INTO CHANSON VALUES(782,'Op. 30 - Einleitung',1,NULL,NULL,'2008-03-12 19:02:23');
INSERT INTO CHANSON VALUES(783,'Op. 30 - Von den Hintlerweltlern',1,NULL,NULL,'2008-03-12 09:10:38');
INSERT INTO CHANSON VALUES(784,'Op. 30 - Von der groïen Sehnsucht',1,NULL,NULL,'2008-03-12 13:59:48');
INSERT INTO CHANSON VALUES(785,'Op. 30 - Von den Freuden und Leidenshaften',1,NULL,NULL,'2008-03-12 19:38:50');
INSERT INTO CHANSON VALUES(786,'Op. 30 - Das Grablied',1,NULL,NULL,'2008-03-12 17:53:14');
INSERT INTO CHANSON VALUES(787,'Op. 30 - Von der Wissenschaft',1,NULL,NULL,'2008-03-12 18:13:10');
INSERT INTO CHANSON VALUES(788,'Op. 30 - Der Genesende',1,NULL,NULL,'2008-03-12 15:59:03');
INSERT INTO CHANSON VALUES(789,'Op. 30 - Das Tanzlied',1,NULL,NULL,'2008-03-12 12:20:27');
INSERT INTO CHANSON VALUES(790,'Op. 30 - Nachtwandlerlied',1,NULL,NULL,'2008-03-12 12:11:36');
INSERT INTO CHANSON VALUES(791,'Don Juan Op.20 - Tondichtung nach Nikolaus Lenau',1,NULL,NULL,'2008-03-12 16:07:54');
INSERT INTO CHANSON VALUES(792,'Puer Natus Est Nobis - Introito (Modo VII)',1,NULL,NULL,'2008-03-12 17:04:56');
INSERT INTO CHANSON VALUES(793,'Genuit Puerpera Regem - Antifona & Salmo 99 (Modo II)',1,NULL,NULL,'2008-03-12 10:13:07');
INSERT INTO CHANSON VALUES(794,'Ave Mundi Spes Maria - Secuencia (Modos VII & VIII)',1,NULL,NULL,'2008-03-12 17:38:06');
INSERT INTO CHANSON VALUES(795,'Occuli Omnium - Gradual (Modo VII)',1,NULL,NULL,'2008-03-12 15:36:45');
INSERT INTO CHANSON VALUES(796,'Veni Creator Spiritus - Himno (Modo VIII)',1,NULL,NULL,'2008-03-12 13:22:38');
INSERT INTO CHANSON VALUES(797,'Alleluia, Beatus Vir Qui Suffert - (Modo I)',1,NULL,NULL,'2008-03-12 16:14:52');
INSERT INTO CHANSON VALUES(798,'Os Iusti - Gradual (Modo I)',1,NULL,NULL,'2008-03-12 18:54:51');
INSERT INTO CHANSON VALUES(799,'Spiritus Domini - Introito (Modo VIII)',1,NULL,NULL,'2008-03-12 19:15:11');
INSERT INTO CHANSON VALUES(800,'Kyrie Fons Bonitatis - Tropo (Modo III)',1,NULL,NULL,'2008-03-12 12:37:23');
INSERT INTO CHANSON VALUES(801,'Laetatus Sum - Gradual (Modo VII)',1,NULL,NULL,'2008-03-12 08:21:30');
INSERT INTO CHANSON VALUES(802,'A Solis Ortus Cardine - Himno (Modo III)',1,NULL,NULL,'2008-03-12 19:08:35');
INSERT INTO CHANSON VALUES(803,'Christus Factus Est Pro Nobis - Gradual (Modo V)',1,NULL,NULL,'2008-03-12 18:19:48');
INSERT INTO CHANSON VALUES(804,'Mandatum Novum Do Vobis - Antifona & Salmo 132 (Modo III)',1,NULL,NULL,'2008-03-12 19:08:27');
INSERT INTO CHANSON VALUES(805,'Media Vita In Morte Sumus - Responsorio (Modo IV)',1,NULL,NULL,'2008-03-12 09:45:04');
INSERT INTO CHANSON VALUES(806,'Nos Autem - Introito (Modo Iv)',1,NULL,NULL,'2008-03-12 18:13:26');
INSERT INTO CHANSON VALUES(807,'Pange Lingua Gloriosi - Himno (Modo Iv)',1,NULL,NULL,'2008-03-12 13:56:41');
INSERT INTO CHANSON VALUES(808,'Jacta Cogitatum Tuum - Gradual (Modo Vii)',1,NULL,NULL,'2008-03-12 12:50:35');
INSERT INTO CHANSON VALUES(809,'Gloria xv - (Modo Iv)',1,NULL,NULL,'2008-03-12 10:47:51');
INSERT INTO CHANSON VALUES(810,'Veni Sancte Spiritus - Secuencia (Modo I)',1,NULL,NULL,'2008-03-12 13:12:28');
INSERT INTO CHANSON VALUES(811,'De Profundis - Ofertorio (Modo Ii)',1,NULL,NULL,'2008-03-12 17:14:50');
INSERT INTO CHANSON VALUES(812,'Salve Regina - (Solemne) Antéfona (Modo I)',1,NULL,NULL,'2008-03-12 11:09:58');
INSERT INTO CHANSON VALUES(813,'Kyrie Xi, a - (Modo I)',1,NULL,NULL,'2008-03-12 18:01:18');
INSERT INTO CHANSON VALUES(814,'Salve, Festa Dies - Himno (Modo Iv)',1,NULL,NULL,'2008-03-12 16:00:26');
INSERT INTO CHANSON VALUES(815,'Puer Natus in Bethlehem - Ritmo (Modo I)',1,NULL,NULL,'2008-03-12 10:05:12');
INSERT INTO CHANSON VALUES(816,'Alleluia, Dies Santificatus - (Modo Ii)',1,NULL,NULL,'2008-03-12 10:55:25');
INSERT INTO CHANSON VALUES(817,'Christe Redemptor - Himno (Modo I)',1,NULL,NULL,'2008-03-12 16:24:22');
INSERT INTO CHANSON VALUES(818,'Christus Natus - Invitatorio (Modo Iv)',1,NULL,NULL,'2008-03-12 12:46:12');
INSERT INTO CHANSON VALUES(819,'Verbum Caro Factum Est - Responsorio (Modo Viii)',1,NULL,NULL,'2008-03-12 19:59:00');
INSERT INTO CHANSON VALUES(820,'Hosanna Filio David - Antéfona (Modo Vii)',1,NULL,NULL,'2008-03-12 18:25:13');
INSERT INTO CHANSON VALUES(821,'Pueri Hebraeorum Portantes - Antéfona (Modo I)',1,NULL,NULL,'2008-03-12 11:13:27');
INSERT INTO CHANSON VALUES(822,'Improperium - Ofertorio (Modo Viii)',1,NULL,NULL,'2008-03-12 09:32:36');
INSERT INTO CHANSON VALUES(823,'Traditor Autem - Benedictus - Antifona (Modo i) - Cantico',1,NULL,NULL,'2008-03-12 09:26:37');
INSERT INTO CHANSON VALUES(981,'Rock & Roll Music to the world',2,NULL,'f','2008-03-12 14:51:32');
INSERT INTO CHANSON VALUES(982,'Detroit diesel',2,NULL,'f','2008-03-12 18:41:46');
INSERT INTO CHANSON VALUES(983,'I''m coming on',2,NULL,'f','2008-03-12 09:35:52');
INSERT INTO CHANSON VALUES(984,'Jenny Jenny',2,NULL,'f','2008-03-12 17:09:37');
INSERT INTO CHANSON VALUES(985,'50,000 miles beneath my brain',2,NULL,'f','2008-03-12 10:29:20');
INSERT INTO CHANSON VALUES(986,'Play it like it used to be',2,NULL,'f','2008-03-12 13:19:19');
INSERT INTO CHANSON VALUES(987,'Let''s shake it up',2,NULL,'f','2008-03-12 18:08:08');
INSERT INTO CHANSON VALUES(988,'Shot in the dark',2,NULL,'f','2008-03-12 11:04:56');
INSERT INTO CHANSON VALUES(989,'You can''t win them all',2,NULL,'f','2008-03-12 08:41:07');
INSERT INTO CHANSON VALUES(990,'Too late to run for cover',2,NULL,'f','2008-03-12 14:34:43');
INSERT INTO CHANSON VALUES(991,'Baby won''t you let me rock''n'' roll you',2,NULL,'f','2008-03-12 13:08:34');
INSERT INTO CHANSON VALUES(992,'Fight for your rights',2,NULL,'f','2008-03-12 19:59:15');
INSERT INTO CHANSON VALUES(993,'I love you when you rock and roll',2,NULL,'f','2008-03-12 16:07:51');
INSERT INTO CHANSON VALUES(994,'London Calling',2,NULL,'f','2008-03-12 15:52:01');
INSERT INTO CHANSON VALUES(995,'Brand New Cadillac',2,NULL,'f','2008-03-12 10:07:31');
INSERT INTO CHANSON VALUES(996,'Jimmy Jazz',2,NULL,'f','2008-03-12 14:35:50');
INSERT INTO CHANSON VALUES(997,'Hateful',2,NULL,'f','2008-03-12 18:30:58');
INSERT INTO CHANSON VALUES(998,'Rudie Can''t Fail',2,NULL,'f','2008-03-12 08:49:03');
INSERT INTO CHANSON VALUES(999,'Spanish Bombs',2,NULL,'f','2008-03-12 19:51:45');
INSERT INTO CHANSON VALUES(1000,'The Right Profile',2,NULL,'f','2008-03-12 09:23:20');
INSERT INTO CHANSON VALUES(1001,'Lost In The Supermarket',2,NULL,'f','2008-03-12 18:48:28');
INSERT INTO CHANSON VALUES(1002,'Clampdown',2,NULL,'f','2008-03-12 12:45:28');
INSERT INTO CHANSON VALUES(1003,'The Guns Of Brixton',2,NULL,'f','2008-03-12 16:29:35');
INSERT INTO CHANSON VALUES(1004,'Wrong ''Em Boyo',2,NULL,'f','2008-03-12 14:06:28');
INSERT INTO CHANSON VALUES(1005,'Death Or Glory',2,NULL,'f','2008-03-12 14:20:36');
INSERT INTO CHANSON VALUES(1006,'Koka Kola',2,NULL,'f','2008-03-12 08:54:11');
INSERT INTO CHANSON VALUES(1007,'The Card Cheat',2,NULL,'f','2008-03-12 19:48:42');
INSERT INTO CHANSON VALUES(1008,'Lover''s Rock',2,NULL,'f','2008-03-12 18:49:31');
INSERT INTO CHANSON VALUES(1009,'Four Horsemen',2,NULL,'f','2008-03-12 19:48:23');
INSERT INTO CHANSON VALUES(1010,'I''m Not Down',2,NULL,'f','2008-03-12 16:55:46');
INSERT INTO CHANSON VALUES(1011,'Revolution Rock',2,NULL,'f','2008-03-12 08:45:34');
INSERT INTO CHANSON VALUES(1012,'Train In Vain',2,NULL,'f','2008-03-12 14:09:20');
INSERT INTO CHANSON VALUES(1013,'On lèche, on lache, on lynche',2,NULL,'f','2008-03-12 19:49:50');
INSERT INTO CHANSON VALUES(1014,'Tout Ce Qui Est Bon Est Mal',2,NULL,'f','2008-03-17 15:22:57');
INSERT INTO CHANSON VALUES(1015,'J''ai vu Dieu',2,NULL,NULL,'2008-03-17 08:55:17');
INSERT INTO CHANSON VALUES(1016,'Ailleurs',2,NULL,NULL,'2008-03-12 15:00:11');
INSERT INTO CHANSON VALUES(1017,'Elle disait',2,NULL,'f','2008-03-12 18:56:59');
INSERT INTO CHANSON VALUES(1018,'Lutter sans cesse',2,NULL,'f','2008-03-12 14:50:49');
INSERT INTO CHANSON VALUES(1019,'Merci West',2,NULL,NULL,'2008-03-12 09:48:38');
INSERT INTO CHANSON VALUES(1020,'Fais où on te dit de faire',2,NULL,'f','2008-03-12 13:32:33');
INSERT INTO CHANSON VALUES(1021,'Tous ces visages',2,NULL,'f','2008-03-12 11:35:18');
INSERT INTO CHANSON VALUES(1022,'Ça vient, ça meurt',2,NULL,'f','2008-03-12 18:07:27');
INSERT INTO CHANSON VALUES(1023,'La Tounga !',2,NULL,'f','2008-03-12 10:07:17');
INSERT INTO CHANSON VALUES(1024,'Réac-prendre à vivre',2,NULL,'f','2008-03-12 08:42:39');
INSERT INTO CHANSON VALUES(1025,'Tout cela était-il prévu ?',2,NULL,NULL,'2008-03-12 19:46:35');
INSERT INTO CHANSON VALUES(1026,'Princesse Sarah',2,NULL,'f','2008-03-12 11:26:36');
INSERT INTO CHANSON VALUES(1027,'Le temps efface tout',2,NULL,'f','2008-03-12 13:18:32');
INSERT INTO CHANSON VALUES(1028,'Guerre civile',2,NULL,NULL,'2008-03-12 13:52:22');
INSERT INTO CHANSON VALUES(1029,'Europe et Haine',2,NULL,'f','2008-03-17 11:57:11');
INSERT INTO CHANSON VALUES(1030,'"Z" demo game from bitmap brothers (http://www.bitmap-brothers.co.uk/)',2,NULL,NULL,'2008-03-12 19:27:44');
INSERT INTO CHANSON VALUES(1031,'Black & white',2,NULL,'f','2008-03-12 13:42:19');
INSERT INTO CHANSON VALUES(1032,'Spooky',2,NULL,'f','2008-03-12 17:33:27');
INSERT INTO CHANSON VALUES(1033,'Highwire',2,NULL,'f','2008-06-02 10:02:32.031998');
INSERT INTO CHANSON VALUES(1034,'2000 light years from home',2,NULL,'f','2008-05-27 06:32:10.981767');
INSERT INTO CHANSON VALUES(1035,'Waitin'' For The Bus',2,NULL,'f','2008-03-12 10:45:03');
INSERT INTO CHANSON VALUES(1036,'Jesus Just Left Chicago',2,NULL,'f','2008-03-12 17:01:29');
INSERT INTO CHANSON VALUES(1037,'Beer Drinkers & Hell Raisers',2,NULL,'f','2008-03-12 13:29:47');
INSERT INTO CHANSON VALUES(1038,'Master Of Sparks',2,NULL,'f','2008-03-12 19:57:39');
INSERT INTO CHANSON VALUES(1039,'Hot, Blue And Righteous',2,NULL,'f','2008-03-12 12:15:37');
INSERT INTO CHANSON VALUES(1040,'Move Me On Down The Line',2,NULL,'f','2008-03-12 14:11:04');
INSERT INTO CHANSON VALUES(1041,'Precious And Grace',2,NULL,'f','2008-03-12 11:41:47');
INSERT INTO CHANSON VALUES(1042,'La Grange',2,NULL,'f','2008-04-18 16:05:34');
INSERT INTO CHANSON VALUES(1043,'Shiek',2,NULL,'f','2008-03-12 15:29:21');
INSERT INTO CHANSON VALUES(1044,'Have You Heard?',2,NULL,'f','2008-03-12 08:44:05');
INSERT INTO CHANSON VALUES(1045,'Thunderbird',2,NULL,'f','2008-03-12 15:18:52');
INSERT INTO CHANSON VALUES(1047,'Backdoor Medley: Backdoor Love Affair-Mellow Down Easy-BackdoorLove Affair no. 2 - Long Distance Boogie',2,NULL,'f','2008-03-12 19:20:40');
INSERT INTO CHANSON VALUES(1048,'Nasty Dogs And Funky Kings',2,NULL,'f','2008-03-12 13:46:10');
INSERT INTO CHANSON VALUES(1049,'Blue Jean Blues',2,NULL,'f','2008-03-12 11:44:08');
INSERT INTO CHANSON VALUES(1050,'Balinese',2,NULL,'f','2008-03-12 19:05:23');
INSERT INTO CHANSON VALUES(1051,'Mexican Blackbird',2,NULL,'f','2008-03-12 14:37:35');
INSERT INTO CHANSON VALUES(1052,'Heard It On The X',2,NULL,'f','2008-03-12 15:54:17');
INSERT INTO CHANSON VALUES(1053,'Tush',2,NULL,'f','2008-03-12 13:31:46');
INSERT INTO CHANSON VALUES(1054,'We Are All Made Of Stars',2,NULL,'f','2008-03-12 17:34:30');
INSERT INTO CHANSON VALUES(1055,'In This World',2,NULL,'f','2008-03-12 18:12:49');
INSERT INTO CHANSON VALUES(1056,'In My Heart',2,NULL,'f','2008-03-12 17:06:20');
INSERT INTO CHANSON VALUES(1057,'Great Escape',2,NULL,'f','2008-03-12 12:04:41');
INSERT INTO CHANSON VALUES(1058,'Signs Of Love',2,NULL,'f','2008-03-12 08:32:28');
INSERT INTO CHANSON VALUES(1059,'One Of These Mornings',2,NULL,'f','2008-03-12 10:47:12');
INSERT INTO CHANSON VALUES(1060,'Another Woman',2,NULL,'f','2008-03-12 12:42:17');
INSERT INTO CHANSON VALUES(1061,'Fireworks',2,NULL,'f','2008-03-12 17:15:55');
INSERT INTO CHANSON VALUES(1062,'Extreme Ways',2,NULL,'f','2008-03-12 12:52:50');
INSERT INTO CHANSON VALUES(1063,'Jam For The Ladies',2,NULL,NULL,'2008-03-12 15:18:21');
INSERT INTO CHANSON VALUES(1064,'Sunday (The Day Before My Birthday)',2,NULL,'f','2008-03-12 12:04:55');
INSERT INTO CHANSON VALUES(1065,'18',2,NULL,'f','2008-03-12 19:56:08');
INSERT INTO CHANSON VALUES(1066,'Sleep Alone',2,NULL,NULL,'2008-03-12 16:41:14');
INSERT INTO CHANSON VALUES(1067,'At Least We Tried',2,NULL,'f','2008-03-12 09:05:19');
INSERT INTO CHANSON VALUES(1068,'Harbour',2,NULL,'f','2008-03-12 17:09:51');
INSERT INTO CHANSON VALUES(1069,'Look Back In',2,NULL,'f','2008-03-12 11:23:38');
INSERT INTO CHANSON VALUES(1070,'Rafters',2,NULL,'f','2008-03-12 13:45:21');
INSERT INTO CHANSON VALUES(1071,'I''m Not Worried At All',2,NULL,'f','2008-03-12 17:31:36');
INSERT INTO CHANSON VALUES(1072,'Macadam massacre',2,NULL,'f','2008-03-12 16:52:29');
INSERT INTO CHANSON VALUES(1073,'Baston',2,NULL,NULL,'2008-03-12 14:31:47');
INSERT INTO CHANSON VALUES(1074,'Elsa je t''aime',2,NULL,'f','2008-03-12 18:56:51');
INSERT INTO CHANSON VALUES(1075,'Chromosome y',2,NULL,'f','2008-03-12 17:51:48');
INSERT INTO CHANSON VALUES(1076,'La nuit noire',2,NULL,'f','2008-03-12 19:36:30');
INSERT INTO CHANSON VALUES(1077,'Johnny revient d''la guerre',2,NULL,'f','2008-03-12 10:42:35');
INSERT INTO CHANSON VALUES(1078,'Freres d''armes!',2,NULL,'f','2008-03-12 14:30:44');
INSERT INTO CHANSON VALUES(1079,'J''ai peur',2,NULL,'f','2008-03-12 12:46:08');
INSERT INTO CHANSON VALUES(1080,'Manifeste',2,NULL,'f','2008-03-12 08:14:53');
INSERT INTO CHANSON VALUES(1081,'Noir les horreurs',2,NULL,'f','2008-03-12 12:01:24');
INSERT INTO CHANSON VALUES(1082,'La mort au choix',2,NULL,'f','2008-03-12 19:42:17');
INSERT INTO CHANSON VALUES(1083,'Nada 1',2,NULL,'f','2008-03-12 13:14:48');
INSERT INTO CHANSON VALUES(1084,'Bucherons',2,NULL,'f','2008-03-12 11:08:45');
INSERT INTO CHANSON VALUES(1085,'Nada 2',2,NULL,'f','2008-03-12 09:57:37');
INSERT INTO CHANSON VALUES(1086,'Amputé',2,NULL,'f','2008-03-12 19:54:14');
INSERT INTO CHANSON VALUES(1087,'Nada 3',2,NULL,'f','2008-03-12 13:06:56');
INSERT INTO CHANSON VALUES(1089,'Hopital lobotomie',2,NULL,'f','2008-03-12 17:01:14');
INSERT INTO CHANSON VALUES(1090,'Nada',2,NULL,'f','2008-03-12 19:04:29');
INSERT INTO CHANSON VALUES(1091,'Manifeste 2 (Le noir les horreurs)',2,NULL,'f','2008-03-12 17:27:30');
INSERT INTO CHANSON VALUES(1092,'It''s Only Love',2,NULL,'f','2008-03-12 10:27:12');
INSERT INTO CHANSON VALUES(1093,'Arrested For Driving While Blind',2,NULL,'f','2008-03-12 14:57:27');
INSERT INTO CHANSON VALUES(1094,'El Diablo',2,NULL,'f','2008-03-12 11:13:36');
INSERT INTO CHANSON VALUES(1095,'Snappy Kakkie',2,NULL,'f','2008-03-12 08:21:33');
INSERT INTO CHANSON VALUES(1096,'Enjoy And Get It On',2,NULL,'f','2008-03-12 16:17:27');
INSERT INTO CHANSON VALUES(1097,'Ten Dollar Man',2,NULL,'f','2008-03-12 19:44:34');
INSERT INTO CHANSON VALUES(1098,'Pan Am Highway Blues',2,NULL,'f','2008-03-12 18:47:12');
INSERT INTO CHANSON VALUES(1099,'Avalon Hideaway',2,NULL,'f','2008-04-11 16:11:10');
INSERT INTO CHANSON VALUES(1100,'She''s A Heartbreaker',2,NULL,'f','2008-03-12 12:34:14');
INSERT INTO CHANSON VALUES(1101,'Asleep In The Desert',2,NULL,'f','2008-03-12 14:30:18');
INSERT INTO CHANSON VALUES(1102,'Tube Snake Boogie',2,NULL,NULL,'2008-03-12 08:19:46');
INSERT INTO CHANSON VALUES(1103,'I Wanna Drive You Home',2,NULL,'f','2008-03-12 14:33:14');
INSERT INTO CHANSON VALUES(1104,'Ten Foot Pole',2,NULL,'f','2008-03-12 17:04:11');
INSERT INTO CHANSON VALUES(1105,'Lelia',2,NULL,NULL,'2008-03-12 10:23:24');
INSERT INTO CHANSON VALUES(1106,'Don''t Tease Me',2,NULL,'f','2008-03-12 18:28:46');
INSERT INTO CHANSON VALUES(1107,'It''s So Hard',2,NULL,'f','2008-03-12 12:10:04');
INSERT INTO CHANSON VALUES(1108,'Pearl Necklace',2,NULL,'f','2008-03-12 18:06:48');
INSERT INTO CHANSON VALUES(1109,'Groovy Little Hippie Pad',2,NULL,'f','2008-03-12 13:59:35');
INSERT INTO CHANSON VALUES(1110,'Heaven, Hell Or Houston',2,NULL,NULL,'2008-03-12 15:20:10');
INSERT INTO CHANSON VALUES(1111,'Party On The Patio',2,NULL,'f','2008-03-12 18:54:40');
INSERT INTO CHANSON VALUES(1112,'Get it on (bang a gong)',2,NULL,'f','2008-03-12 10:58:00');
INSERT INTO CHANSON VALUES(1113,'Hot love',2,NULL,'f','2008-03-12 19:32:33');
INSERT INTO CHANSON VALUES(1114,'Metal guru',2,NULL,'f','2008-03-12 10:18:37');
INSERT INTO CHANSON VALUES(1115,'Telegram Sam',2,NULL,'f','2008-04-07 18:35:37');
INSERT INTO CHANSON VALUES(1116,'Jeepster',2,NULL,'f','2008-04-09 14:10:06');
INSERT INTO CHANSON VALUES(1117,'Ride a white swan',2,NULL,'f','2008-03-12 13:33:01');
INSERT INTO CHANSON VALUES(1118,'Children of the revolution',2,NULL,'f','2008-03-12 18:24:29');
INSERT INTO CHANSON VALUES(1119,'Dandy in the underworld',2,NULL,'f','2008-03-12 15:48:40');
INSERT INTO CHANSON VALUES(1120,'Debora',2,NULL,'f','2008-03-12 16:40:47');
INSERT INTO CHANSON VALUES(1121,'20th century boy',2,NULL,'f','2008-03-12 13:07:47');
INSERT INTO CHANSON VALUES(1122,'The groover',2,NULL,'f','2008-03-12 09:46:07');
INSERT INTO CHANSON VALUES(1123,'Zip gun boogie',2,NULL,'f','2008-03-12 11:40:02');
INSERT INTO CHANSON VALUES(1124,'Mambo sun',2,NULL,'f','2008-03-12 19:53:00');
INSERT INTO CHANSON VALUES(1125,'Hot rod mama',2,NULL,'f','2008-03-12 19:52:32');
INSERT INTO CHANSON VALUES(1126,'One inch rock',2,NULL,'f','2008-03-12 13:06:51');
INSERT INTO CHANSON VALUES(1127,'She was born to be my unicorn',2,NULL,'f','2008-03-12 09:32:24');
INSERT INTO CHANSON VALUES(1128,'Salamander Palagander',2,NULL,'f','2008-03-12 09:22:48');
INSERT INTO CHANSON VALUES(1129,'Truck on (tyke)',2,NULL,NULL,'2008-03-12 15:59:37');
INSERT INTO CHANSON VALUES(1130,'Jive To The Beat',2,NULL,'f','2008-03-12 11:40:17');
INSERT INTO CHANSON VALUES(1131,'Elle Adore Le Noir',2,NULL,'f','2008-03-12 09:10:25');
INSERT INTO CHANSON VALUES(1132,'Lonesome Zorro',2,NULL,'f','2008-03-12 18:15:11');
INSERT INTO CHANSON VALUES(1133,'Mon Sissoyen',2,NULL,'f','2008-03-12 08:31:52');
INSERT INTO CHANSON VALUES(1134,'Cold Sweat',2,NULL,'f','2008-03-12 08:27:45');
INSERT INTO CHANSON VALUES(1135,'When The Rock',2,NULL,'f','2008-03-12 08:24:37');
INSERT INTO CHANSON VALUES(1136,'It''s All Over Now',2,NULL,'f','2008-06-01 18:05:12.573473');
INSERT INTO CHANSON VALUES(1137,'Oh La La La',2,NULL,'f','2008-03-12 15:53:44');
INSERT INTO CHANSON VALUES(1138,'Tango De La Peau',2,NULL,'f','2008-03-12 13:00:16');
INSERT INTO CHANSON VALUES(1139,'Bathroom Singer',2,NULL,'f','2008-03-12 18:08:39');
INSERT INTO CHANSON VALUES(1140,'Marie Tu M''as',2,NULL,'f','2008-03-12 16:46:38');
INSERT INTO CHANSON VALUES(1141,'Rythm Of The Sea',2,NULL,NULL,'2008-03-12 11:05:19');
INSERT INTO CHANSON VALUES(1142,'Le Bon Dieu',2,NULL,'f','2008-03-12 15:11:30');
INSERT INTO CHANSON VALUES(1143,'Pull Over Blanc',2,NULL,'f','2008-03-12 08:05:45');
INSERT INTO CHANSON VALUES(1144,'Yooh',2,NULL,'f','2008-03-12 10:05:16');
INSERT INTO CHANSON VALUES(1145,'Trouble In Mind',2,NULL,'f','2008-03-12 09:08:44');
INSERT INTO CHANSON VALUES(1146,'Music Is The Dope',2,NULL,'f','2008-03-12 18:12:08');
INSERT INTO CHANSON VALUES(1147,'Putain Putain',2,NULL,NULL,'2008-03-12 13:48:02');
INSERT INTO CHANSON VALUES(1148,'Astronomy Domine',6,NULL,'f','2008-03-12 10:16:03');
INSERT INTO CHANSON VALUES(1149,'Careful With That Axe, Eugene',6,NULL,'f','2008-03-12 13:08:12');
INSERT INTO CHANSON VALUES(1150,'Set The Controls For The Heart Of The Sun',6,NULL,'f','2008-03-24 09:49:58');
INSERT INTO CHANSON VALUES(1151,'A Saucerful Of Secrets',6,NULL,'f','2008-03-12 17:08:04');
INSERT INTO CHANSON VALUES(1152,'Charly Oleg, l''éternel comeback',2,NULL,'f','2008-03-12 09:44:16');
INSERT INTO CHANSON VALUES(1153,'Maria Callas + Placido Domingo',2,NULL,'f','2008-03-12 15:46:21');
INSERT INTO CHANSON VALUES(1154,'Ceausescu',2,NULL,'f','2008-03-12 12:59:27');
INSERT INTO CHANSON VALUES(1155,'Ayrton Senna',2,NULL,'f','2008-03-12 15:04:36');
INSERT INTO CHANSON VALUES(1156,'Paponade',2,NULL,'f','2008-03-12 12:54:48');
INSERT INTO CHANSON VALUES(1157,'Haroun Tazieff',2,NULL,'f','2008-03-12 14:23:37');
INSERT INTO CHANSON VALUES(1158,'Yet another Charly Oleg',2,NULL,'f','2008-03-12 14:35:54');
INSERT INTO CHANSON VALUES(1159,'Harry Callahan (I wanna be a poulet)',2,NULL,NULL,'2008-03-12 15:03:02');
INSERT INTO CHANSON VALUES(1160,'John got his gun',2,NULL,NULL,'2008-03-12 17:11:52');
INSERT INTO CHANSON VALUES(1161,'Eddie Van Halen',2,NULL,'f','2008-03-12 17:57:01');
INSERT INTO CHANSON VALUES(1162,'Beethoven',2,NULL,'f','2008-03-12 18:03:46');
INSERT INTO CHANSON VALUES(1163,'Value-added Charly Oleg',2,NULL,'f','2008-03-12 09:39:32');
INSERT INTO CHANSON VALUES(1164,'Arlette Laguiller',2,NULL,NULL,'2008-03-12 14:01:31');
INSERT INTO CHANSON VALUES(1165,'Pocahontas (Chaque fois)',2,NULL,'f','2008-03-12 19:40:35');
INSERT INTO CHANSON VALUES(1166,'Rocky Balboa',2,NULL,'f','2008-03-12 14:03:30');
INSERT INTO CHANSON VALUES(1167,'Jim Jones',2,NULL,'f','2008-03-12 12:34:53');
INSERT INTO CHANSON VALUES(1168,'Jacques Chirac',2,NULL,NULL,'2008-03-12 08:09:28');
INSERT INTO CHANSON VALUES(1169,'Jodie Foster',2,NULL,'f','2008-03-12 19:46:32');
INSERT INTO CHANSON VALUES(1170,'Sophie et Hans (Die weisse Rose)',2,NULL,'f','2008-03-12 19:35:43');
INSERT INTO CHANSON VALUES(1171,'Ayrton Sega',2,NULL,'f','2008-03-12 18:24:41');
INSERT INTO CHANSON VALUES(1172,'Alain Prieur (Je veux etre un oiseau)',2,NULL,'f','2008-03-12 18:16:45');
INSERT INTO CHANSON VALUES(1173,'Last Charly Oleg before apocalypse (featuring Charly, l''authentique',2,NULL,'f','2008-03-12 15:26:25');
INSERT INTO CHANSON VALUES(1174,'Leon Takes Us Outside',2,NULL,'f','2008-06-07 20:00:47.873135');
INSERT INTO CHANSON VALUES(1175,'Outside',2,NULL,'f','2008-06-07 12:08:05.831566');
INSERT INTO CHANSON VALUES(1176,'The Hearts Filthy Lesson',2,NULL,'f','2008-06-07 12:10:01.216929');
INSERT INTO CHANSON VALUES(1177,'A Small Plot of Land',2,NULL,'f','2008-03-27 17:53:45');
INSERT INTO CHANSON VALUES(1178,'segue - Baby Grace',2,NULL,NULL,'2008-06-07 18:59:10.573993');
INSERT INTO CHANSON VALUES(1179,'Hallo Spaceboy',2,NULL,'f','2008-06-07 12:26:43.932904');
INSERT INTO CHANSON VALUES(1180,'The Motel',2,NULL,'f','2008-06-07 12:27:05.483393');
INSERT INTO CHANSON VALUES(1181,'I Have Not Been To Oxford Town',2,NULL,'f','2008-06-07 12:27:23.559908');
INSERT INTO CHANSON VALUES(1182,'No Control',2,NULL,NULL,'2008-06-07 12:27:52.633182');
INSERT INTO CHANSON VALUES(1183,'segue - Algeria Touchshriek',2,NULL,NULL,'2008-06-07 12:28:10.935567');
INSERT INTO CHANSON VALUES(1184,'The Voyeur of Utter Destruction (As Beauty)',2,NULL,'f','2008-06-07 12:39:49.577742');
INSERT INTO CHANSON VALUES(1185,'segue - Ramona A. Stone / I Am With Name',2,NULL,'f','2008-06-07 12:40:06.155541');
INSERT INTO CHANSON VALUES(1186,'Wishful Beginnings',2,NULL,'f','2008-06-07 12:40:21.502507');
INSERT INTO CHANSON VALUES(1187,'We Prick You',2,NULL,'f','2008-06-07 12:40:36.842387');
INSERT INTO CHANSON VALUES(1188,'segue - Nathan Adler',2,NULL,'f','2008-06-07 12:40:50.051063');
INSERT INTO CHANSON VALUES(1189,'I''m Deranged',2,NULL,'f','2008-06-07 12:41:28.10237');
INSERT INTO CHANSON VALUES(1190,'Thru'' These Architects Eyes',2,NULL,'f','2008-06-07 12:41:53.84859');
INSERT INTO CHANSON VALUES(1192,'Strangers When We Meet',2,NULL,'f','2008-06-07 12:42:16.114144');
INSERT INTO CHANSON VALUES(1193,'Sunday (Moby Remix)',2,NULL,'f','2008-06-07 20:02:51.434194');
INSERT INTO CHANSON VALUES(1194,'A Better Future (Remix By Air)',2,NULL,'f','2008-06-07 19:26:39.696058');
INSERT INTO CHANSON VALUES(1195,'Conversation Piece (Written 1969, Recorded 1970, Re-Recorded 2002)',2,NULL,'f','2008-06-07 15:27:51.174588');
INSERT INTO CHANSON VALUES(1196,'Panic In Detroit (Outtake From A 1979 Recording)',2,NULL,'f','2008-04-12 18:45:30');
INSERT INTO CHANSON VALUES(1197,'Great balls of fire',2,NULL,'f','2008-03-12 12:20:30');
INSERT INTO CHANSON VALUES(1198,'Whole lotta shakin'' goin'' on',2,NULL,'f','2008-03-18 09:24:41');
INSERT INTO CHANSON VALUES(1199,'Breathless',2,NULL,'f','2008-03-12 17:15:35');
INSERT INTO CHANSON VALUES(1200,'High school confidential',2,NULL,'f','2008-03-12 12:00:39');
INSERT INTO CHANSON VALUES(1201,'What''d I say',2,NULL,'f','2008-03-12 17:27:27');
INSERT INTO CHANSON VALUES(1202,'Match box',2,NULL,'f','2008-03-12 08:10:43');
INSERT INTO CHANSON VALUES(1203,'Lewis boogie',2,NULL,'f','2008-03-12 19:34:08');
INSERT INTO CHANSON VALUES(1204,'Jambalaya (on the bayou)',2,NULL,'f','2008-03-12 13:55:27');
INSERT INTO CHANSON VALUES(1205,'Drinkin'' Wine spo-dee-o-dee',2,NULL,'f','2008-03-12 08:41:06');
INSERT INTO CHANSON VALUES(1206,'Ubangi stomp',2,NULL,'f','2008-03-12 09:47:32');
INSERT INTO CHANSON VALUES(1207,'Crazy arms',2,NULL,'f','2008-03-12 10:10:52');
INSERT INTO CHANSON VALUES(1208,'When the saints go marchin''in',2,NULL,'f','2008-03-12 16:20:17');
INSERT INTO CHANSON VALUES(1209,'Little queenie',2,NULL,'f','2008-04-13 18:54:03');
INSERT INTO CHANSON VALUES(1210,'Don''t be cruel',2,NULL,'f','2008-03-12 12:10:32');
INSERT INTO CHANSON VALUES(1211,'Mean woman blues',2,NULL,NULL,'2008-03-12 08:34:33');
INSERT INTO CHANSON VALUES(1212,'Lovin''up a storm',2,NULL,NULL,'2008-03-12 16:24:01');
INSERT INTO CHANSON VALUES(1213,'Sweet little sixteen',2,NULL,'f','2008-03-12 09:28:11');
INSERT INTO CHANSON VALUES(1214,'Goodnight Irene',2,NULL,'f','2008-03-12 18:26:45');
INSERT INTO CHANSON VALUES(1216,'Save the last dance for me',2,NULL,'f','2008-03-12 13:56:22');
INSERT INTO CHANSON VALUES(1217,'You win again',2,NULL,'f','2008-03-12 14:02:10');
INSERT INTO CHANSON VALUES(1218,'It won''t happen with me',2,NULL,'f','2008-03-12 09:15:21');
INSERT INTO CHANSON VALUES(1219,'Personality Crisis',2,NULL,'f','2008-03-12 19:58:42');
INSERT INTO CHANSON VALUES(1220,'Looking For A Kiss',2,NULL,'f','2008-03-12 11:23:52');
INSERT INTO CHANSON VALUES(1221,'Bad Girl',2,NULL,'f','2008-03-12 17:23:26');
INSERT INTO CHANSON VALUES(1222,'Subway Train',2,NULL,NULL,'2008-03-12 12:04:51');
INSERT INTO CHANSON VALUES(1223,'L''empereur Tomato-Ketchup',2,NULL,'f','2008-03-12 12:12:19');
INSERT INTO CHANSON VALUES(1224,'Pavillon 36',2,NULL,'f','2008-03-12 15:03:46');
INSERT INTO CHANSON VALUES(1225,'Nuit Apache',2,NULL,'f','2008-03-12 12:03:37');
INSERT INTO CHANSON VALUES(1226,'Ibrahim',2,NULL,'f','2008-03-12 08:31:34');
INSERT INTO CHANSON VALUES(1227,'Vie de Singe',2,NULL,'f','2008-03-12 13:04:36');
INSERT INTO CHANSON VALUES(1228,'Tzigane, Tzigane',2,NULL,'f','2008-03-12 15:11:51');
INSERT INTO CHANSON VALUES(1229,'L''Empereur Tomato-Ketchup II',2,NULL,'f','2008-03-12 19:09:50');
INSERT INTO CHANSON VALUES(1230,'Casse-t te Chinois (suivi de Joli Printemps)',2,NULL,'f','2008-03-12 16:25:14');
INSERT INTO CHANSON VALUES(1231,'Jim-la-Jungle',2,NULL,'f','2008-03-12 14:14:38');
INSERT INTO CHANSON VALUES(1232,'S.O.S',2,NULL,'f','2008-03-12 19:37:42');
INSERT INTO CHANSON VALUES(1233,'Descendons dans la Rue',2,NULL,'f','2008-03-12 18:01:54');
INSERT INTO CHANSON VALUES(1234,'Et Hop + Macadam Circus',2,NULL,'f','2008-03-12 10:37:58');
INSERT INTO CHANSON VALUES(1235,'On a Faim',2,NULL,'f','2008-03-12 19:58:02');
INSERT INTO CHANSON VALUES(1236,'Et Hop + Macadam Circus II',2,NULL,'f','2008-03-12 14:02:33');
INSERT INTO CHANSON VALUES(1237,'Nuit Apache II',2,NULL,'f','2008-03-12 09:28:38');
INSERT INTO CHANSON VALUES(1238,'Sur les Toits (suivi de Quartier G n ral des Rebelles du Hash)',2,NULL,'f','2008-03-12 16:04:49');
INSERT INTO CHANSON VALUES(1239,'Mineurs en Danger',2,NULL,'f','2008-03-12 15:03:59');
INSERT INTO CHANSON VALUES(1240,'La Marche Fun bre de la Jeunesse Suicidaire',2,NULL,NULL,'2008-03-12 13:43:25');
INSERT INTO CHANSON VALUES(1241,'Vi tnam Laos Cambodge',2,NULL,NULL,'2008-03-12 16:16:40');
INSERT INTO CHANSON VALUES(1242,'Comme un Bouddha',2,NULL,'f','2008-03-12 12:15:17');
INSERT INTO CHANSON VALUES(1243,'Cannonball',2,NULL,'f','2008-03-12 08:06:19');
INSERT INTO CHANSON VALUES(1244,'Cro-Aloha',2,NULL,NULL,'2008-03-12 19:16:57');
INSERT INTO CHANSON VALUES(1245,'Lord of the Thighs',2,NULL,'f','2008-03-23 19:12:56');
INSERT INTO CHANSON VALUES(1246,'900',2,NULL,'f','2008-03-12 19:46:58');
INSERT INTO CHANSON VALUES(1247,'(Somebody Else Been) Shaking Your Tree',2,NULL,'f','2008-03-12 14:54:26');
INSERT INTO CHANSON VALUES(1248,'Brown Sugar',2,NULL,NULL,'2008-03-12 10:39:31');
INSERT INTO CHANSON VALUES(1249,'Squank',2,NULL,'f','2008-03-12 19:15:34');
INSERT INTO CHANSON VALUES(1250,'Goin'' Down To Mexico',2,NULL,'f','2008-03-12 19:43:18');
INSERT INTO CHANSON VALUES(1251,'Old Man',2,NULL,'f','2008-03-12 12:25:35');
INSERT INTO CHANSON VALUES(1252,'Neighbor, Neighbor',2,NULL,'f','2008-03-12 08:46:51');
INSERT INTO CHANSON VALUES(1253,'Certified Blues',2,NULL,'f','2008-03-12 12:49:57');
INSERT INTO CHANSON VALUES(1254,'Bedroom Thang',2,NULL,'f','2008-03-12 16:47:14');
INSERT INTO CHANSON VALUES(1255,'Just Got Back From Baby''s',2,NULL,'f','2008-03-12 15:44:27');
INSERT INTO CHANSON VALUES(1256,'Backdoor Love Affair',2,NULL,'f','2008-03-12 15:43:14');
INSERT INTO CHANSON VALUES(1257,'Francine',2,NULL,'f','2008-03-12 14:15:09');
INSERT INTO CHANSON VALUES(1258,'Just Got Paid',2,NULL,'f','2008-03-12 19:25:48');
INSERT INTO CHANSON VALUES(1259,'Mushmouth Shoutin''',2,NULL,'f','2008-03-12 14:25:04');
INSERT INTO CHANSON VALUES(1260,'Ko Ko Blue',2,NULL,'f','2008-03-12 09:24:47');
INSERT INTO CHANSON VALUES(1261,'Chevrolet',2,NULL,'f','2008-03-12 12:49:12');
INSERT INTO CHANSON VALUES(1262,'Apologies To Pearly',2,NULL,'f','2008-03-12 08:53:58');
INSERT INTO CHANSON VALUES(1263,'Bar-B-Q',2,NULL,'f','2008-03-12 18:15:48');
INSERT INTO CHANSON VALUES(1264,'Sure Got Cold After The Rain Fell',2,NULL,'f','2008-03-12 17:57:36');
INSERT INTO CHANSON VALUES(1265,'Whiskey''n Mama',2,NULL,'f','2008-03-12 08:36:20');
INSERT INTO CHANSON VALUES(1266,'Down Brownie',2,NULL,'f','2008-03-12 14:11:04');
INSERT INTO CHANSON VALUES(1267,'Highwire (Full Length Version)',2,NULL,'f','2008-06-02 10:02:13.278035');
INSERT INTO CHANSON VALUES(1268,'Highwire (7'' Version)',2,NULL,NULL,'2008-06-02 10:02:22.727006');
INSERT INTO CHANSON VALUES(1269,'I Just Want To Make Love To You (Live)',2,NULL,'f','2008-03-22 16:16:10');
INSERT INTO CHANSON VALUES(1270,'Play With Fire',2,NULL,'f','2008-06-01 19:43:02.239399');
INSERT INTO CHANSON VALUES(1271,'Intro / Sweet Jane',2,NULL,NULL,'2008-03-12 15:46:24');
INSERT INTO CHANSON VALUES(1272,'Heroin',2,NULL,'f','2008-04-05 08:09:51');
INSERT INTO CHANSON VALUES(1273,'White Light / White Heat',2,NULL,'f','2008-04-15 19:25:19');
INSERT INTO CHANSON VALUES(1274,'Lady Day',2,NULL,'f','2008-03-12 17:47:18');
INSERT INTO CHANSON VALUES(1275,'Rock ''N'' Roll',2,NULL,'f','2008-03-12 17:38:33');
INSERT INTO CHANSON VALUES(1276,'Station To Station',2,NULL,'f','2008-04-15 18:50:33');
INSERT INTO CHANSON VALUES(1277,'Golden Years',2,NULL,'f','2008-06-07 15:28:41.669877');
INSERT INTO CHANSON VALUES(1278,'Word On A Wing',2,NULL,'f','2008-06-07 15:29:01.768207');
INSERT INTO CHANSON VALUES(1279,'TVC15',2,NULL,'f','2008-06-07 15:29:18.186723');
INSERT INTO CHANSON VALUES(1280,'Stay',2,NULL,'f','2008-06-07 15:05:31.260539');
INSERT INTO CHANSON VALUES(1281,'Wild Is the Wind',2,NULL,'f','2008-06-07 15:06:08.357071');
INSERT INTO CHANSON VALUES(1282,'Où veux-tu qu''je r''garde ?',2,NULL,'f','2008-03-12 16:29:05');
INSERT INTO CHANSON VALUES(1283,'Toujours être Ailleurs',2,NULL,'f','2008-03-17 18:18:27');
INSERT INTO CHANSON VALUES(1284,'La Rage',2,NULL,NULL,'2008-03-12 13:54:14');
INSERT INTO CHANSON VALUES(1285,'Pyromane',2,NULL,'f','2008-03-12 18:43:01');
INSERT INTO CHANSON VALUES(1286,'Danse sur le feu Maria',2,NULL,'f','2008-03-12 10:32:40');
INSERT INTO CHANSON VALUES(1287,'Lola',2,NULL,'f','2008-03-12 17:08:08');
INSERT INTO CHANSON VALUES(1288,'Give Peace A Chance',2,NULL,'f','2008-03-12 11:21:41');
INSERT INTO CHANSON VALUES(1289,'Instant Karma!',2,NULL,'f','2008-03-12 13:55:45');
INSERT INTO CHANSON VALUES(1290,'Power To The People',2,NULL,'f','2008-03-23 17:33:36');
INSERT INTO CHANSON VALUES(1291,'Whatever Gets You Thru The Night',2,NULL,'f','2008-03-12 18:30:21');
INSERT INTO CHANSON VALUES(1292,'#9 Dream',2,NULL,'f','2008-03-12 15:13:51');
INSERT INTO CHANSON VALUES(1293,'Mind Games',2,NULL,'f','2008-03-12 17:06:10');
INSERT INTO CHANSON VALUES(1294,'Love',2,NULL,'f','2008-03-12 10:35:04');
INSERT INTO CHANSON VALUES(1295,'Happy Xmas (War Is Over)',2,NULL,'f','2008-03-12 13:29:48');
INSERT INTO CHANSON VALUES(1296,'Imagine',2,NULL,NULL,'2008-04-24 16:48:37');
INSERT INTO CHANSON VALUES(1297,'Jealous Guy',2,NULL,'f','2008-03-12 13:41:20');
INSERT INTO CHANSON VALUES(1298,'Stand By Me',2,NULL,'f','2008-03-12 10:26:29');
INSERT INTO CHANSON VALUES(1299,'(Just Like) Starting Over',2,NULL,'f','2008-03-12 11:44:51');
INSERT INTO CHANSON VALUES(1300,'Woman',2,NULL,'f','2008-03-12 08:09:47');
INSERT INTO CHANSON VALUES(1301,'I''m Losing You',2,NULL,'f','2008-03-12 17:54:20');
INSERT INTO CHANSON VALUES(1302,'Beautiful Boy (Darling Boy)',2,NULL,'f','2008-03-12 12:44:50');
INSERT INTO CHANSON VALUES(1303,'Watching The Wheels',2,NULL,'f','2008-03-12 16:24:03');
INSERT INTO CHANSON VALUES(1304,'Dear Yoko',2,NULL,NULL,'2008-03-12 15:10:10');
INSERT INTO CHANSON VALUES(1305,'Move Over Ms. L',2,NULL,'f','2008-03-12 17:23:45');
INSERT INTO CHANSON VALUES(1306,'Cold Turkey',2,NULL,'f','2008-03-12 18:51:15');
INSERT INTO CHANSON VALUES(1307,'C''est un animal',2,NULL,'f','2008-03-12 15:21:56');
INSERT INTO CHANSON VALUES(1308,'La fille du Père Noel',2,NULL,'f','2008-03-23 10:54:28');
INSERT INTO CHANSON VALUES(1309,'Si tu dois partir',2,NULL,'f','2008-03-12 08:32:23');
INSERT INTO CHANSON VALUES(1310,'Le tueur',2,NULL,'f','2008-03-12 14:51:07');
INSERT INTO CHANSON VALUES(1311,'OK Carole',2,NULL,'f','2008-03-12 12:52:17');
INSERT INTO CHANSON VALUES(1312,'Sidonie',2,NULL,'f','2008-03-12 09:39:11');
INSERT INTO CHANSON VALUES(1313,'Décide-toi',2,NULL,'f','2008-03-12 13:02:56');
INSERT INTO CHANSON VALUES(1314,'Art majeur',2,NULL,'f','2008-03-12 12:47:21');
INSERT INTO CHANSON VALUES(1315,'Non, pas pour moi!',2,NULL,'f','2008-03-12 12:23:31');
INSERT INTO CHANSON VALUES(1316,'Les papillons noirs',2,NULL,'f','2008-03-12 14:10:55');
INSERT INTO CHANSON VALUES(1317,'Je te tuerai',2,NULL,'f','2008-03-12 12:01:46');
INSERT INTO CHANSON VALUES(1318,'Betty Jane Rose',2,NULL,'f','2008-03-12 15:41:08');
INSERT INTO CHANSON VALUES(1319,'Je pense à toi',2,NULL,'f','2008-03-12 14:42:40');
INSERT INTO CHANSON VALUES(1320,'Le kid',2,NULL,'f','2008-03-12 18:12:32');
INSERT INTO CHANSON VALUES(1321,'Je ne t''oublierai jamais',2,NULL,'f','2008-03-12 08:33:24');
INSERT INTO CHANSON VALUES(1322,'Woo ho ou Woo ho',2,NULL,'f','2008-03-12 11:42:03');
INSERT INTO CHANSON VALUES(1323,'Continental',2,NULL,'f','2008-03-12 14:12:06');
INSERT INTO CHANSON VALUES(1324,'Rock à la radio',2,NULL,NULL,'2008-03-12 13:32:53');
INSERT INTO CHANSON VALUES(1325,'Pas comme vous',2,NULL,NULL,'2008-03-12 17:56:17');
INSERT INTO CHANSON VALUES(1326,'Au nom de l''amour',2,NULL,'f','2008-03-12 12:31:27');
INSERT INTO CHANSON VALUES(1327,'Les gens parlent',2,NULL,'f','2008-03-12 11:51:29');
INSERT INTO CHANSON VALUES(1328,'Sourire d''ange',2,NULL,NULL,'2008-03-12 08:26:10');
INSERT INTO CHANSON VALUES(1329,'Atom Heart Mother Suite',6,NULL,'f','2008-03-12 10:58:52');
INSERT INTO CHANSON VALUES(1330,'If',6,NULL,'f','2008-03-12 18:53:05');
INSERT INTO CHANSON VALUES(1331,'Summer ''68',6,NULL,'f','2008-03-12 12:55:39');
INSERT INTO CHANSON VALUES(1332,'Fat Old Sun',6,NULL,'f','2008-03-12 17:14:21');
INSERT INTO CHANSON VALUES(1333,'Alan''s Psychedelic Breakfast',6,NULL,'f','2008-03-12 18:45:33');
INSERT INTO CHANSON VALUES(1334,'Vive le feu',2,NULL,'f','2008-03-12 19:13:06');
INSERT INTO CHANSON VALUES(1335,'Fils de ...',2,NULL,'f','2008-03-12 18:02:02');
INSERT INTO CHANSON VALUES(1336,'Viet nam Laos Cambodge',2,NULL,'f','2008-03-12 10:23:33');
INSERT INTO CHANSON VALUES(1337,'Djebel',2,NULL,'f','2008-03-12 15:40:25');
INSERT INTO CHANSON VALUES(1338,'Rebelles',2,NULL,'f','2008-03-12 09:43:52');
INSERT INTO CHANSON VALUES(1339,'Camouflage',2,NULL,'f','2008-03-12 11:55:50');
INSERT INTO CHANSON VALUES(1343,'Casse t te Chinois',2,NULL,'f','2008-03-12 11:55:39');
INSERT INTO CHANSON VALUES(1344,'Le Renard',2,NULL,'f','2008-03-12 18:55:53');
INSERT INTO CHANSON VALUES(1345,'Soleil Noir',2,NULL,'f','2008-03-23 19:48:55');
INSERT INTO CHANSON VALUES(1347,'Lobotomie',2,NULL,'f','2008-03-12 14:36:59');
INSERT INTO CHANSON VALUES(1348,'H l ne et le Sang',2,NULL,NULL,'2008-03-12 19:44:43');
INSERT INTO CHANSON VALUES(1350,'Petit Agit',2,NULL,'f','2008-03-12 16:13:26');
INSERT INTO CHANSON VALUES(1351,'Porcherie',2,NULL,'f','2008-03-12 13:29:39');
INSERT INTO CHANSON VALUES(1355,'Protesta',2,NULL,NULL,'2008-03-23 14:29:22');
INSERT INTO CHANSON VALUES(1356,'Vivre Libre ou Mourir',2,NULL,'f','2008-03-12 13:28:21');
INSERT INTO CHANSON VALUES(1357,'Panik',2,NULL,'f','2008-03-12 17:02:58');
INSERT INTO CHANSON VALUES(1358,'If the Kids are United',2,NULL,'f','2008-03-12 17:01:42');
INSERT INTO CHANSON VALUES(1360,'Macadam Circus',2,NULL,'f','2008-03-12 09:33:58');
INSERT INTO CHANSON VALUES(1361,'La société, elle est pourrie',2,NULL,'f','2008-03-12 15:59:27');
INSERT INTO CHANSON VALUES(1362,'Tcherno''blues',2,NULL,'f','2008-03-12 11:05:52');
INSERT INTO CHANSON VALUES(1363,'Barbapapa',2,NULL,'f','2008-03-12 19:04:33');
INSERT INTO CHANSON VALUES(1364,'M.S. thérapie',2,NULL,'f','2008-03-12 14:43:05');
INSERT INTO CHANSON VALUES(1365,'La carbonade flamande',2,NULL,'f','2008-03-12 09:15:34');
INSERT INTO CHANSON VALUES(1366,'On s''lave le sexe',2,NULL,'f','2008-03-12 14:43:03');
INSERT INTO CHANSON VALUES(1367,'One of these Days',6,NULL,'f','2008-03-12 18:31:05');
INSERT INTO CHANSON VALUES(1368,'A Pillow of Winds',6,NULL,'f','2008-03-12 18:18:06');
INSERT INTO CHANSON VALUES(1369,'Fearless',6,NULL,'f','2008-03-12 14:48:58');
INSERT INTO CHANSON VALUES(1370,'San Tropez',6,NULL,'f','2008-03-12 11:58:32');
INSERT INTO CHANSON VALUES(1371,'Seamus',6,NULL,'f','2008-03-12 11:33:32');
INSERT INTO CHANSON VALUES(1372,'Echoes',6,NULL,NULL,'2008-03-12 15:45:42');
INSERT INTO CHANSON VALUES(1373,'Shine On You Crazy Diamond (Part One)',6,NULL,'f','2008-03-12 10:20:25');
INSERT INTO CHANSON VALUES(1374,'Welcome To The Machine',6,NULL,'f','2008-03-12 11:28:41');
INSERT INTO CHANSON VALUES(1375,'Have A Cigar',6,NULL,'f','2008-03-12 18:58:25');
INSERT INTO CHANSON VALUES(1376,'Wish You Were Here',6,NULL,'f','2008-03-12 18:51:56');
INSERT INTO CHANSON VALUES(1377,'Shine On You Crazy Diamond (Part Two)',6,NULL,'f','2008-03-12 19:41:14');
INSERT INTO CHANSON VALUES(1378,'Stalag-tilt',2,NULL,'f','2008-03-12 09:14:03');
INSERT INTO CHANSON VALUES(1379,'Whiskeuses images again',2,NULL,'f','2008-03-12 09:32:01');
INSERT INTO CHANSON VALUES(1380,'Nictalopus airline',2,NULL,'f','2008-03-12 15:49:35');
INSERT INTO CHANSON VALUES(1381,'Femme de loth',2,NULL,'f','2008-03-12 10:33:23');
INSERT INTO CHANSON VALUES(1382,'Buenas noches, Jo',2,NULL,'f','2008-03-12 17:09:09');
INSERT INTO CHANSON VALUES(1383,'Un vendredi 13 a 5h',2,NULL,'f','2008-03-12 14:20:29');
INSERT INTO CHANSON VALUES(1384,'Chambre 2023 (et des poussieres)',2,NULL,NULL,'2008-03-12 19:35:58');
INSERT INTO CHANSON VALUES(1385,'Let There Be More Light',6,NULL,NULL,'2008-03-12 15:26:57');
INSERT INTO CHANSON VALUES(1386,'Remember A Day',6,NULL,'f','2008-03-12 08:20:48');
INSERT INTO CHANSON VALUES(1388,'Corporal Clegg',6,NULL,'f','2008-03-12 10:26:44');
INSERT INTO CHANSON VALUES(1390,'See Saw',6,NULL,'f','2008-03-12 11:09:06');
INSERT INTO CHANSON VALUES(1391,'Jugband Blues',6,NULL,'f','2008-03-12 18:20:39');
INSERT INTO CHANSON VALUES(1392,'The Musical Box',2,NULL,'f','2008-03-12 11:09:49');
INSERT INTO CHANSON VALUES(1393,'For Absent Friends',2,NULL,'f','2008-03-12 13:39:09');
INSERT INTO CHANSON VALUES(1394,'The Return Of The Giant Hogweed',2,NULL,'f','2008-03-12 19:36:45');
INSERT INTO CHANSON VALUES(1395,'Seven Stones',2,NULL,'f','2008-03-12 19:14:11');
INSERT INTO CHANSON VALUES(1396,'Harold The Barrel',2,NULL,NULL,'2008-04-07 19:12:49');
INSERT INTO CHANSON VALUES(1397,'Harlequin',2,NULL,'f','2008-03-12 18:18:32');
INSERT INTO CHANSON VALUES(1398,'The Fountain Of Salmacis',2,NULL,'f','2008-03-12 16:17:52');
INSERT INTO CHANSON VALUES(1400,'Je ne sais plus quoi faire pour te décevoir',2,NULL,'f','2008-03-12 19:49:50');
INSERT INTO CHANSON VALUES(1401,'Amants destroy',2,NULL,'f','2008-03-12 10:08:00');
INSERT INTO CHANSON VALUES(1402,'Pulque mescal y tequila',2,NULL,'f','2008-03-12 11:03:20');
INSERT INTO CHANSON VALUES(1403,'Septembre rose',2,NULL,'f','2008-03-12 19:22:30');
INSERT INTO CHANSON VALUES(1404,'Syndrome albatros',2,NULL,'f','2008-03-12 17:50:10');
INSERT INTO CHANSON VALUES(1405,'Droode song',2,NULL,'f','2008-03-12 19:48:46');
INSERT INTO CHANSON VALUES(1406,'``Je suis partout''''',2,NULL,'f','2008-03-12 17:45:01');
INSERT INTO CHANSON VALUES(1407,'Par Les Fils De Mandrin',2,NULL,'f','2008-03-12 19:38:19');
INSERT INTO CHANSON VALUES(1408,'Au Cafe Du Colibri',2,NULL,'f','2008-03-12 13:20:37');
INSERT INTO CHANSON VALUES(1409,'Ainsi S''en Ira La Pluie',2,NULL,'f','2008-03-12 12:31:08');
INSERT INTO CHANSON VALUES(1410,'Autour Du Feu',2,NULL,'f','2008-03-12 15:27:58');
INSERT INTO CHANSON VALUES(1411,'Saltimbanques',2,NULL,'f','2008-03-12 13:40:07');
INSERT INTO CHANSON VALUES(1412,'Des Yeux Couleur D''enfants',2,NULL,'f','2008-03-12 14:00:11');
INSERT INTO CHANSON VALUES(1413,'Atlantis Les Geants De La 3e Lune',2,NULL,'f','2008-03-12 18:59:33');
INSERT INTO CHANSON VALUES(1414,'Hymne À La Vie',2,NULL,NULL,'2008-03-12 12:48:24');
INSERT INTO CHANSON VALUES(1415,'Speed King',2,NULL,NULL,'2008-03-12 14:48:13');
INSERT INTO CHANSON VALUES(1416,'Bloodsucker',2,NULL,'f','2008-03-12 11:33:58');
INSERT INTO CHANSON VALUES(1417,'Child in time',2,NULL,'f','2008-03-19 11:30:36');
INSERT INTO CHANSON VALUES(1418,'Flight of the rat',2,NULL,'f','2008-04-04 14:26:42');
INSERT INTO CHANSON VALUES(1419,'Into the fire',2,NULL,'f','2008-04-07 13:14:18');
INSERT INTO CHANSON VALUES(1420,'Living wreck',2,NULL,'f','2008-03-12 15:59:57');
INSERT INTO CHANSON VALUES(1421,'Hard lovin'' man',2,NULL,'f','2008-04-11 16:34:52');
INSERT INTO CHANSON VALUES(1422,'You Have Placed A Chill In My Heart',2,NULL,'f','2008-03-12 11:20:29');
INSERT INTO CHANSON VALUES(1423,'Miracle Of Love',2,NULL,'f','2008-03-12 13:59:56');
INSERT INTO CHANSON VALUES(1424,'Sex Crime (1984)',2,NULL,'f','2008-03-12 12:29:37');
INSERT INTO CHANSON VALUES(1425,'Thorn In My Side',2,NULL,'f','2008-03-12 14:59:37');
INSERT INTO CHANSON VALUES(1426,'Don''t Ask Me Why',2,NULL,'f','2008-03-12 16:50:37');
INSERT INTO CHANSON VALUES(1427,'Angel',2,NULL,'f','2008-03-12 11:11:25');
INSERT INTO CHANSON VALUES(1428,'Would I Lie To You?',2,NULL,'f','2008-03-12 16:42:13');
INSERT INTO CHANSON VALUES(1429,'Missionary Man',2,NULL,'f','2008-03-12 18:01:46');
INSERT INTO CHANSON VALUES(1430,'Mama Nouvelle Orleans',2,NULL,'f','2008-03-12 18:20:16');
INSERT INTO CHANSON VALUES(1431,'Trois tonnes de T.N.T.',2,NULL,'f','2008-03-12 13:59:15');
INSERT INTO CHANSON VALUES(1432,'Ci-git une star',2,NULL,'f','2008-03-12 13:16:36');
INSERT INTO CHANSON VALUES(1433,'Avec la rage en d''dans',2,NULL,'f','2008-03-12 19:41:35');
INSERT INTO CHANSON VALUES(1434,'Je ne peux plus dire que je t''aime',2,NULL,'f','2008-03-23 18:05:05');
INSERT INTO CHANSON VALUES(1435,'Beau beau ou laid',2,NULL,'f','2008-03-12 14:36:04');
INSERT INTO CHANSON VALUES(1436,'Entre deux gares',2,NULL,'f','2008-03-12 09:18:54');
INSERT INTO CHANSON VALUES(1437,'Le fil a la patte du cameleon',2,NULL,'f','2008-03-12 16:34:06');
INSERT INTO CHANSON VALUES(1438,'Rappelle-moi',2,NULL,'f','2008-03-12 10:15:49');
INSERT INTO CHANSON VALUES(1439,'On a rainy sunday afternoon',2,NULL,NULL,'2008-03-12 12:08:50');
INSERT INTO CHANSON VALUES(1440,'A colin maillard',2,NULL,NULL,'2008-03-12 10:00:11');
INSERT INTO CHANSON VALUES(1441,'Dans les poches du berger',2,NULL,'f','2008-03-12 13:29:11');
INSERT INTO CHANSON VALUES(1442,'Un trou dans la case',2,NULL,'f','2008-04-13 15:32:39');
INSERT INTO CHANSON VALUES(1443,'Virgule',2,NULL,'f','2008-03-12 16:55:27');
INSERT INTO CHANSON VALUES(1444,'Réveille-toi',2,NULL,'f','2008-03-12 12:51:09');
INSERT INTO CHANSON VALUES(1445,'Capitaine cur de miel',2,NULL,NULL,'2008-03-24 19:44:14');
INSERT INTO CHANSON VALUES(1446,'In The Evening',2,NULL,'f','2008-03-12 08:14:50');
INSERT INTO CHANSON VALUES(1447,'South Bound Saurez',2,NULL,'f','2008-03-12 09:22:09');
INSERT INTO CHANSON VALUES(1448,'Fool In The Rain',2,NULL,'f','2008-03-12 08:06:44');
INSERT INTO CHANSON VALUES(1449,'Hot Dog',2,NULL,'f','2008-04-14 17:44:39');
INSERT INTO CHANSON VALUES(1450,'Carouselambra',2,NULL,'f','2008-03-12 09:17:59');
INSERT INTO CHANSON VALUES(1451,'All My Love',2,NULL,'f','2008-03-12 19:42:07');
INSERT INTO CHANSON VALUES(1452,'I''m Gonna Crawl',2,NULL,'f','2008-03-12 17:53:08');
INSERT INTO CHANSON VALUES(1453,'La belle petite cage',2,NULL,'f','2008-03-12 19:22:38');
INSERT INTO CHANSON VALUES(1454,'Lieutenants du désordre',2,NULL,'f','2008-03-12 09:06:34');
INSERT INTO CHANSON VALUES(1455,'Vive l''armée... du salut',2,NULL,'f','2008-03-12 15:27:25');
INSERT INTO CHANSON VALUES(1456,'B.M.C. dub',2,NULL,'f','2008-03-12 17:23:09');
INSERT INTO CHANSON VALUES(1457,'Irrécupérables',2,NULL,'f','2008-03-12 08:24:23');
INSERT INTO CHANSON VALUES(1458,'Roi des singes',2,NULL,'f','2008-03-12 18:30:45');
INSERT INTO CHANSON VALUES(1459,'On est là',2,NULL,'f','2008-03-12 08:31:52');
INSERT INTO CHANSON VALUES(1460,'Soleil Cherche Futur',2,NULL,NULL,'2008-03-12 16:38:10');
INSERT INTO CHANSON VALUES(1461,'Loreleï Sebasto Cha',2,NULL,'f','2008-03-23 13:39:22');
INSERT INTO CHANSON VALUES(1462,'Autoroutes Jeudi d''Automne',2,NULL,'f','2008-03-18 18:21:46');
INSERT INTO CHANSON VALUES(1463,'Ad Orgasmum Aeternum',2,NULL,'f','2008-03-12 08:20:08');
INSERT INTO CHANSON VALUES(1465,'Exit to Chatagoune-Goune',2,NULL,'f','2008-03-12 10:07:42');
INSERT INTO CHANSON VALUES(1466,'Rock Joyeux',2,NULL,'f','2008-03-12 15:53:05');
INSERT INTO CHANSON VALUES(1467,'Solexine et Ganja',2,NULL,'f','2008-03-12 17:54:30');
INSERT INTO CHANSON VALUES(1468,'Young Americans',2,NULL,'f','2008-06-07 15:55:19.860002');
INSERT INTO CHANSON VALUES(1469,'Win',2,NULL,'f','2008-06-07 15:55:53.543495');
INSERT INTO CHANSON VALUES(1470,'Fascination',2,NULL,'f','2008-06-07 15:56:08.064001');
INSERT INTO CHANSON VALUES(1471,'Right',2,NULL,NULL,'2008-06-07 15:40:06.820552');
INSERT INTO CHANSON VALUES(1472,'Somebody Up There Likes Me',2,NULL,NULL,'2008-06-07 15:40:24.44794');
INSERT INTO CHANSON VALUES(1473,'Across The Universe',2,NULL,'f','2008-06-07 15:40:38.155466');
INSERT INTO CHANSON VALUES(1474,'Can You Hear Me',2,NULL,'f','2008-06-07 15:40:53.289766');
INSERT INTO CHANSON VALUES(1475,'Fame',2,NULL,'f','2008-06-07 15:41:38.839895');
INSERT INTO CHANSON VALUES(1476,'Godevin Le Vilain',2,NULL,'f','2008-03-12 17:37:56');
INSERT INTO CHANSON VALUES(1477,'Les Longues Nuits D''Isaac',2,NULL,'f','2008-03-12 18:25:50');
INSERT INTO CHANSON VALUES(1478,'Si J''étais Le Messie',2,NULL,'f','2008-03-12 12:37:35');
INSERT INTO CHANSON VALUES(1479,'Ballade Pour Une Orgie',2,NULL,'f','2008-03-12 12:35:22');
INSERT INTO CHANSON VALUES(1480,'Exode',2,NULL,'f','2008-03-12 19:25:53');
INSERT INTO CHANSON VALUES(1481,'La Bataille Du Sucre',2,NULL,'f','2008-03-12 09:27:08');
INSERT INTO CHANSON VALUES(1482,'Fils De Lumière',2,NULL,NULL,'2008-03-12 17:21:16');
INSERT INTO CHANSON VALUES(1483,'Au Delà Du Délire',2,NULL,'f','2008-03-12 19:01:24');
INSERT INTO CHANSON VALUES(1484,'Woman From Tokyo',2,NULL,'f','2008-03-12 12:50:11');
INSERT INTO CHANSON VALUES(1485,'Mary Long',2,NULL,'f','2008-03-12 11:54:10');
INSERT INTO CHANSON VALUES(1486,'Super Trouper',2,NULL,'f','2008-03-12 12:41:48');
INSERT INTO CHANSON VALUES(1487,'Smooth Dancer',2,NULL,'f','2008-03-12 11:34:14');
INSERT INTO CHANSON VALUES(1488,'Rat Bat Blue',2,NULL,'f','2008-03-12 09:56:51');
INSERT INTO CHANSON VALUES(1489,'Place In Line',2,NULL,'f','2008-04-18 09:10:40');
INSERT INTO CHANSON VALUES(1490,'Our Lady',2,NULL,'f','2008-03-12 16:20:26');
INSERT INTO CHANSON VALUES(1491,'Highway Star',2,NULL,'f','2008-03-23 09:15:52');
INSERT INTO CHANSON VALUES(1493,'Smoke On The Water',2,NULL,'f','2008-03-23 12:06:42');
INSERT INTO CHANSON VALUES(1494,'The Mule',2,NULL,'f','2008-03-12 17:28:33');
INSERT INTO CHANSON VALUES(1495,'Strange Kind of Women',2,NULL,'f','2008-03-12 08:47:27');
INSERT INTO CHANSON VALUES(1496,'Lazy',2,NULL,'f','2008-03-12 10:08:09');
INSERT INTO CHANSON VALUES(1497,'Space Truckin''',2,NULL,'f','2008-03-23 19:26:43');
INSERT INTO CHANSON VALUES(1498,'Go Down',2,NULL,'f','2008-03-12 10:34:40');
INSERT INTO CHANSON VALUES(1499,'Dog Eat Dog',2,NULL,'f','2008-03-12 09:18:00');
INSERT INTO CHANSON VALUES(1500,'Let There Be Rock',2,NULL,NULL,'2008-03-26 14:24:16');
INSERT INTO CHANSON VALUES(1501,'Bad Boy Boogie',2,NULL,'f','2008-03-12 13:24:37');
INSERT INTO CHANSON VALUES(1502,'Problem Child',2,NULL,'f','2008-04-11 12:45:32');
INSERT INTO CHANSON VALUES(1503,'Overdose',2,NULL,'f','2008-04-24 17:30:03');
INSERT INTO CHANSON VALUES(1504,'Hell Ain''t A Bad Place To Be',2,NULL,'f','2008-03-12 17:32:48');
INSERT INTO CHANSON VALUES(1505,'Whole Lotta Rosie',2,NULL,'f','2008-04-15 08:13:47');
INSERT INTO CHANSON VALUES(1506,'Paris-New York, N.Y. Paris',2,NULL,'f','2008-03-12 13:57:55');
INSERT INTO CHANSON VALUES(1507,'Cigarette',2,NULL,'f','2008-03-23 09:46:24');
INSERT INTO CHANSON VALUES(1508,'Mono Lisa Klaxon',2,NULL,'f','2008-03-12 16:47:11');
INSERT INTO CHANSON VALUES(1509,'Chaud, chaud, bizness show',2,NULL,'f','2008-03-12 09:58:19');
INSERT INTO CHANSON VALUES(1510,'Est-ce que ma Guitare est un fusil',2,NULL,'f','2008-03-12 11:58:46');
INSERT INTO CHANSON VALUES(1511,'Une mouche sur la bouche',2,NULL,'f','2008-03-12 08:12:20');
INSERT INTO CHANSON VALUES(1512,'Oesophage-Boogie, cardiac blues',2,NULL,NULL,'2008-03-12 16:18:39');
INSERT INTO CHANSON VALUES(1513,'Boxon',2,NULL,'f','2008-03-12 16:51:03');
INSERT INTO CHANSON VALUES(1514,'Maybellene',2,NULL,'f','2008-03-12 08:16:28');
INSERT INTO CHANSON VALUES(1515,'Thirty Days',2,NULL,'f','2008-03-12 15:02:01');
INSERT INTO CHANSON VALUES(1516,'No Money Down',2,NULL,'f','2008-03-12 13:28:58');
INSERT INTO CHANSON VALUES(1517,'Roll Over Beethoven',2,NULL,'f','2008-03-12 12:37:45');
INSERT INTO CHANSON VALUES(1518,'Brown Eyed Handsome Man',2,NULL,'f','2008-03-12 17:19:32');
INSERT INTO CHANSON VALUES(1519,'Too Much Monkey Business',2,NULL,'f','2008-03-12 19:29:30');
INSERT INTO CHANSON VALUES(1520,'You Can''t Catch Me',2,NULL,'f','2008-06-02 09:56:29.722861');
INSERT INTO CHANSON VALUES(1521,'School Day (Ring! Ring! Goes The Bell)',2,NULL,'f','2008-03-12 08:51:41');
INSERT INTO CHANSON VALUES(1522,'Rock & Roll Music',2,NULL,'f','2008-03-12 12:34:59');
INSERT INTO CHANSON VALUES(1524,'Reelin'' and Rockin''',2,NULL,NULL,'2008-03-12 09:19:06');
INSERT INTO CHANSON VALUES(1525,'Johnny B. Goode',2,NULL,'f','2008-03-23 15:57:09');
INSERT INTO CHANSON VALUES(1526,'Around And Around',2,NULL,'f','2008-06-01 18:02:22.324065');
INSERT INTO CHANSON VALUES(1527,'Beutiful Delilah',2,NULL,NULL,'2008-03-12 15:45:15');
INSERT INTO CHANSON VALUES(1528,'Carol',2,NULL,'f','2008-06-02 10:14:00.060946');
INSERT INTO CHANSON VALUES(1529,'Sweet Little Rock And Roller',2,NULL,'f','2008-03-12 18:29:04');
INSERT INTO CHANSON VALUES(1530,'Almost Grown',2,NULL,'f','2008-06-07 19:27:30.506908');
INSERT INTO CHANSON VALUES(1532,'Back In The USA',2,NULL,'f','2008-03-12 18:50:44');
INSERT INTO CHANSON VALUES(1533,'Memphis, Tenessee',2,NULL,'f','2008-03-12 14:14:19');
INSERT INTO CHANSON VALUES(1534,'Let It Rock',2,NULL,'f','2008-04-24 14:32:38');
INSERT INTO CHANSON VALUES(1535,'Bye Bye Johnny',2,NULL,'f','2008-05-23 11:19:10');
INSERT INTO CHANSON VALUES(1536,'I''m Talking About You',2,NULL,'f','2008-06-02 09:25:24.662312');
INSERT INTO CHANSON VALUES(1538,'Nadine (Is It You?)',2,NULL,'f','2008-03-12 12:24:57');
INSERT INTO CHANSON VALUES(1539,'No Particular Place To Go',2,NULL,'f','2008-03-12 14:00:54');
INSERT INTO CHANSON VALUES(1540,'You Never Can Tell',2,NULL,'f','2008-03-12 15:37:18');
INSERT INTO CHANSON VALUES(1541,'Promised Land',2,NULL,'f','2008-03-12 11:12:04');
INSERT INTO CHANSON VALUES(1542,'Mannish Boy',2,NULL,NULL,'2008-06-01 18:01:41.964631');
INSERT INTO CHANSON VALUES(1543,'Cracking Up',2,NULL,'f','2008-06-01 18:02:04.734522');
INSERT INTO CHANSON VALUES(1544,'Little Red Rooster',2,NULL,'f','2008-06-01 20:17:19.480692');
INSERT INTO CHANSON VALUES(1546,'It''s Only Rock And Roll (But I Like It)',2,NULL,'f','2008-03-22 17:18:56');
INSERT INTO CHANSON VALUES(1549,'Sympathy For The Devil',2,NULL,'f','2008-03-17 09:52:14');
INSERT INTO CHANSON VALUES(1550,'Whole Lotta Love',2,NULL,'f','2008-03-12 17:16:39');
INSERT INTO CHANSON VALUES(1551,'What Is And What Should Never Be',2,NULL,'f','2008-03-12 16:46:40');
INSERT INTO CHANSON VALUES(1552,'The Lemon Song',2,NULL,'f','2008-03-12 15:26:17');
INSERT INTO CHANSON VALUES(1553,'Thank You',2,NULL,'f','2008-03-12 19:44:29');
INSERT INTO CHANSON VALUES(1554,'Heartbreaker',2,NULL,'f','2008-03-12 08:18:03');
INSERT INTO CHANSON VALUES(1555,'Living Loving Maid (She''s Just A Women)',2,NULL,'f','2008-03-12 15:26:30');
INSERT INTO CHANSON VALUES(1556,'Ramble On',2,NULL,'f','2008-03-12 16:38:22');
INSERT INTO CHANSON VALUES(1557,'Moby Dick',2,NULL,'f','2008-03-12 15:44:06');
INSERT INTO CHANSON VALUES(1558,'Bring It On Home',2,NULL,'f','2008-04-24 08:42:13');
INSERT INTO CHANSON VALUES(1559,'Gimme Shelter',2,NULL,'f','2008-03-17 11:33:25');
INSERT INTO CHANSON VALUES(1560,'Love In Vain',2,NULL,'f','2008-03-23 11:42:17');
INSERT INTO CHANSON VALUES(1561,'Country Honk',2,NULL,'f','2008-03-19 14:28:33');
INSERT INTO CHANSON VALUES(1562,'Live With Me',2,NULL,'f','2008-05-23 14:21:43');
INSERT INTO CHANSON VALUES(1563,'Let It Bleed',2,NULL,'f','2008-04-09 15:57:03');
INSERT INTO CHANSON VALUES(1564,'Midnight Rambler',2,NULL,'f','2008-06-01 17:31:18.980058');
INSERT INTO CHANSON VALUES(1565,'You Got The Silver',2,NULL,'f','2008-05-22 16:31:24');
INSERT INTO CHANSON VALUES(1566,'Monkey Man',2,NULL,'f','2008-06-01 18:00:59.371536');
INSERT INTO CHANSON VALUES(1567,'You Can''t Always Get What You Want (Version 2)',2,NULL,'f','2008-04-11 15:14:41');
INSERT INTO CHANSON VALUES(1568,'Psychanalyse du singe',2,NULL,'f','2008-03-12 09:47:32');
INSERT INTO CHANSON VALUES(1569,'Groupie 89 turbo 6',2,NULL,'f','2008-03-12 15:49:50');
INSERT INTO CHANSON VALUES(1570,'L''amour mou',2,NULL,'f','2008-03-12 16:27:16');
INSERT INTO CHANSON VALUES(1571,'Scorbut',2,NULL,'f','2008-03-12 10:11:55');
INSERT INTO CHANSON VALUES(1572,'Comme un chien dans un cimetière',2,NULL,'f','2008-03-12 14:47:39');
INSERT INTO CHANSON VALUES(1573,'De l''amour de l''art ou du cochon',2,NULL,'f','2008-03-12 15:06:13');
INSERT INTO CHANSON VALUES(1574,'L''agence des amants de madame Muller',2,NULL,'f','2008-03-12 09:21:55');
INSERT INTO CHANSON VALUES(1575,'Vendome gardenal snack',2,NULL,'f','2008-03-12 12:51:23');
INSERT INTO CHANSON VALUES(1576,'Hot Stuff',2,NULL,'f','2008-04-07 13:44:44');
INSERT INTO CHANSON VALUES(1577,'Hand of Fate',2,NULL,'f','2008-06-01 20:12:40.219648');
INSERT INTO CHANSON VALUES(1578,'Cherry Oh Baby',2,NULL,'f','2008-06-01 20:12:56.843536');
INSERT INTO CHANSON VALUES(1579,'Memory Motel',2,NULL,'f','2008-04-18 12:37:29');
INSERT INTO CHANSON VALUES(1580,'Hey Negrita',2,NULL,'f','2008-04-09 12:46:08');
INSERT INTO CHANSON VALUES(1581,'Melody',2,NULL,NULL,'2008-06-01 20:13:50.781154');
INSERT INTO CHANSON VALUES(1582,'Fool to Cry',2,NULL,'f','2008-06-01 20:14:06.260165');
INSERT INTO CHANSON VALUES(1583,'Crazy Mama',2,NULL,'f','2008-04-24 11:48:08');
INSERT INTO CHANSON VALUES(1584,'Reckless Life',2,NULL,'f','2008-03-12 13:15:31');
INSERT INTO CHANSON VALUES(1585,'Nice Boys',2,NULL,'f','2008-03-12 16:26:43');
INSERT INTO CHANSON VALUES(1586,'Move To The City',2,NULL,NULL,'2008-03-12 15:59:30');
INSERT INTO CHANSON VALUES(1587,'Mama Kin',2,NULL,'f','2008-04-15 09:23:30');
INSERT INTO CHANSON VALUES(1588,'Patience',2,NULL,'f','2008-03-12 11:38:36');
INSERT INTO CHANSON VALUES(1589,'Used To Love Her',2,NULL,'f','2008-03-12 14:43:57');
INSERT INTO CHANSON VALUES(1590,'You''re Crazy',2,NULL,'f','2008-03-12 13:06:49');
INSERT INTO CHANSON VALUES(1591,'One In A Million',2,NULL,'f','2008-03-12 18:03:51');
INSERT INTO CHANSON VALUES(1592,'Radio Gaga',2,NULL,'f','2008-03-12 13:21:42');
INSERT INTO CHANSON VALUES(1593,'Tear It Up',2,NULL,'f','2008-03-12 18:26:40');
INSERT INTO CHANSON VALUES(1594,'It''s A Hard Life',2,NULL,'f','2008-03-12 09:02:15');
INSERT INTO CHANSON VALUES(1595,'Man On The Prowl',2,NULL,'f','2008-03-12 10:30:30');
INSERT INTO CHANSON VALUES(1596,'Machines (or Back To Humans)',2,NULL,'f','2008-03-12 16:13:56');
INSERT INTO CHANSON VALUES(1597,'I Want To Break Free',2,NULL,NULL,'2008-03-12 13:52:55');
INSERT INTO CHANSON VALUES(1598,'Keep Passing The Open Windows',2,NULL,'f','2008-03-12 19:10:34');
INSERT INTO CHANSON VALUES(1599,'Hammer To Fall',2,NULL,'f','2008-03-12 14:42:18');
INSERT INTO CHANSON VALUES(1600,'Is This The World We Created ...?',2,NULL,'f','2008-03-12 14:08:25');
INSERT INTO CHANSON VALUES(1601,'Black Dog',2,NULL,'f','2008-04-14 13:46:50');
INSERT INTO CHANSON VALUES(1602,'Rock And Roll',2,NULL,'f','2008-03-16 12:59:29');
INSERT INTO CHANSON VALUES(1603,'The Battle Of Evermore',2,NULL,'f','2008-03-19 10:25:50');
INSERT INTO CHANSON VALUES(1604,'Stairway To Heaven',2,NULL,'f','2008-04-13 10:09:34');
INSERT INTO CHANSON VALUES(1605,'Misty Mountain Hop',2,NULL,'f','2008-04-11 09:37:44');
INSERT INTO CHANSON VALUES(1606,'Four Sticks',2,NULL,'f','2008-03-12 18:18:16');
INSERT INTO CHANSON VALUES(1607,'Going To California',2,NULL,'f','2008-03-12 14:26:19');
INSERT INTO CHANSON VALUES(1608,'When The Levee Breaks',2,NULL,NULL,'2008-03-12 18:38:49');
INSERT INTO CHANSON VALUES(1609,'Soul Sacrifice',9,NULL,NULL,'2008-03-12 12:22:02');
INSERT INTO CHANSON VALUES(1610,'I''m Going Home',9,NULL,NULL,'2008-03-12 11:49:55');
INSERT INTO CHANSON VALUES(1611,'Volunteers',9,NULL,NULL,'2008-03-26 10:46:06');
INSERT INTO CHANSON VALUES(1612,'Medley: Dance To The Music, Music Lover, I Want to Take You Higher',9,NULL,NULL,'2008-03-12 17:20:48');
INSERT INTO CHANSON VALUES(1613,'Rainbows All Over the World',9,NULL,NULL,'2008-03-12 09:51:57');
INSERT INTO CHANSON VALUES(1614,'Love March',9,NULL,NULL,'2008-03-12 14:12:56');
INSERT INTO CHANSON VALUES(1615,'Star Spangled Banner + Purple Haze + Instrumental Solo',9,NULL,NULL,'2008-04-07 14:30:53');
INSERT INTO CHANSON VALUES(1616,'Forget the cold sweat',2,NULL,'f','2008-03-12 08:25:21');
INSERT INTO CHANSON VALUES(1617,'Down and out',2,NULL,'f','2008-03-12 18:19:40');
INSERT INTO CHANSON VALUES(1618,'Congo',2,NULL,'f','2008-03-12 09:54:07');
INSERT INTO CHANSON VALUES(1619,'Play the guitar boy',2,NULL,'f','2008-03-12 13:44:46');
INSERT INTO CHANSON VALUES(1620,'Miss Nell',2,NULL,'f','2008-03-12 11:05:08');
INSERT INTO CHANSON VALUES(1622,'Qu''est-ce que c''est?',2,NULL,'f','2008-03-12 11:36:44');
INSERT INTO CHANSON VALUES(1623,'Come back',2,NULL,'f','2008-03-12 12:24:04');
INSERT INTO CHANSON VALUES(1625,'La Bella Rossa',2,NULL,'f','2008-03-12 09:04:09');
INSERT INTO CHANSON VALUES(1626,'Poison',2,NULL,'f','2008-03-12 08:06:34');
INSERT INTO CHANSON VALUES(1627,'Spark In The Dark',2,NULL,NULL,'2008-03-12 13:58:54');
INSERT INTO CHANSON VALUES(1628,'House Of Fire',2,NULL,'f','2008-03-12 09:06:48');
INSERT INTO CHANSON VALUES(1629,'Why Trust You',2,NULL,'f','2008-03-12 10:35:33');
INSERT INTO CHANSON VALUES(1630,'Only My Heart Talkin''',2,NULL,'f','2008-03-12 19:52:39');
INSERT INTO CHANSON VALUES(1631,'Bed Of Nails',2,NULL,'f','2008-03-12 09:12:01');
INSERT INTO CHANSON VALUES(1632,'This Maniac''s In Love With You',2,NULL,'f','2008-03-12 09:28:38');
INSERT INTO CHANSON VALUES(1633,'Trash',2,NULL,'f','2008-05-26 08:47:32');
INSERT INTO CHANSON VALUES(1634,'Hell Is Living Without You',2,NULL,'f','2008-03-12 18:51:02');
INSERT INTO CHANSON VALUES(1635,'I''m Your Gun',2,NULL,'f','2008-03-12 19:01:34');
INSERT INTO CHANSON VALUES(1636,'Good times',2,NULL,'f','2008-03-12 18:09:38');
INSERT INTO CHANSON VALUES(1637,'Boom boom',2,NULL,'f','2008-03-12 08:14:44');
INSERT INTO CHANSON VALUES(1638,'Allez monnaie blues',2,NULL,'f','2008-03-12 14:40:43');
INSERT INTO CHANSON VALUES(1639,'Paint it black',2,NULL,'f','2008-03-17 11:00:25');
INSERT INTO CHANSON VALUES(1640,'Petit papa Noël',2,NULL,'f','2008-03-12 18:00:17');
INSERT INTO CHANSON VALUES(1641,'Surveille ton look',2,NULL,'f','2008-03-12 14:09:30');
INSERT INTO CHANSON VALUES(1643,'Alley money blues',2,NULL,'f','2008-03-12 10:06:50');
INSERT INTO CHANSON VALUES(1644,'Invaders',2,NULL,'f','2008-03-12 10:01:52');
INSERT INTO CHANSON VALUES(1645,'Children Of The Damned',2,NULL,'f','2008-03-26 17:52:02');
INSERT INTO CHANSON VALUES(1646,'The Prisoner',2,NULL,'f','2008-03-12 13:53:16');
INSERT INTO CHANSON VALUES(1647,'22, Acacia Avenue',2,NULL,'f','2008-03-12 10:27:56');
INSERT INTO CHANSON VALUES(1648,'The Number Of The Beast',2,NULL,'f','2008-03-12 18:56:43');
INSERT INTO CHANSON VALUES(1649,'Run To The Hills',2,NULL,'f','2008-03-12 16:14:44');
INSERT INTO CHANSON VALUES(1650,'Gangland',2,NULL,'f','2008-03-12 09:05:45');
INSERT INTO CHANSON VALUES(1651,'Hallowed Be Thy Name',2,NULL,'f','2008-03-12 13:36:54');
INSERT INTO CHANSON VALUES(1652,'I Had A Dream',9,NULL,NULL,'2008-03-12 19:08:10');
INSERT INTO CHANSON VALUES(1653,'Going Up The Country',9,NULL,NULL,'2008-03-12 19:19:17');
INSERT INTO CHANSON VALUES(1654,'Freedom',9,NULL,NULL,'2008-03-12 17:33:18');
INSERT INTO CHANSON VALUES(1655,'Rock & Soul Music',9,NULL,NULL,'2008-03-12 15:21:11');
INSERT INTO CHANSON VALUES(1656,'Coming Into Los Angeles',9,NULL,NULL,'2008-03-12 16:48:05');
INSERT INTO CHANSON VALUES(1657,'At The Hop',9,NULL,NULL,'2008-03-12 19:00:32');
INSERT INTO CHANSON VALUES(1658,'The Fish Cheer',9,NULL,NULL,'2008-03-12 18:55:29');
INSERT INTO CHANSON VALUES(1659,'Drug Store Truck Drivin'' Man',9,NULL,NULL,'2008-03-12 15:40:44');
INSERT INTO CHANSON VALUES(1660,'Joe Hill',9,NULL,NULL,'2008-03-12 12:50:49');
INSERT INTO CHANSON VALUES(1661,'Suite: Judy Blue Eyes',9,NULL,NULL,'2008-03-12 09:17:26');
INSERT INTO CHANSON VALUES(1662,'Sea Of Madness',9,NULL,NULL,'2008-03-12 08:15:35');
INSERT INTO CHANSON VALUES(1663,'Wooden Ships',9,NULL,NULL,'2008-04-18 16:07:41');
INSERT INTO CHANSON VALUES(1664,'We''re Not Gonna Take It',9,NULL,NULL,'2008-03-12 10:12:54');
INSERT INTO CHANSON VALUES(1665,'With A Little Help From My Friends',9,NULL,NULL,'2008-03-12 14:59:28');
INSERT INTO CHANSON VALUES(1666,'Somebody Knockin''',2,NULL,'f','2008-03-12 18:38:49');
INSERT INTO CHANSON VALUES(1667,'Pressure Drop',2,NULL,'f','2008-03-12 08:20:38');
INSERT INTO CHANSON VALUES(1668,'Time Gone By',2,NULL,'f','2008-03-12 09:18:38');
INSERT INTO CHANSON VALUES(1669,'Shuffle It All',2,NULL,'f','2008-03-12 16:13:34');
INSERT INTO CHANSON VALUES(1670,'Bucket O'' Trouble',2,NULL,'f','2008-03-12 10:52:14');
INSERT INTO CHANSON VALUES(1671,'Train Tracks',2,NULL,'f','2008-03-12 18:15:04');
INSERT INTO CHANSON VALUES(1672,'How Will It Go',2,NULL,'f','2008-03-12 16:24:21');
INSERT INTO CHANSON VALUES(1673,'Cuttin'' The Rug',2,NULL,'f','2008-03-12 10:27:37');
INSERT INTO CHANSON VALUES(1674,'Take A Look At The Guy',2,NULL,'f','2008-03-12 17:42:49');
INSERT INTO CHANSON VALUES(1675,'Come On Now Inside',2,NULL,'f','2008-03-12 16:13:48');
INSERT INTO CHANSON VALUES(1676,'1984',2,NULL,'f','2008-03-12 09:03:27');
INSERT INTO CHANSON VALUES(1677,'Jump',2,NULL,'f','2008-03-12 19:06:48');
INSERT INTO CHANSON VALUES(1678,'Panama',2,NULL,NULL,'2008-03-19 15:13:07');
INSERT INTO CHANSON VALUES(1679,'Top Jimmy',2,NULL,'f','2008-03-12 11:54:20');
INSERT INTO CHANSON VALUES(1680,'Drop Dead Legs',2,NULL,'f','2008-03-12 17:04:13');
INSERT INTO CHANSON VALUES(1681,'Hot For Teacher',2,NULL,'f','2008-03-12 08:58:29');
INSERT INTO CHANSON VALUES(1682,'I''ll Wait',2,NULL,NULL,'2008-03-12 09:43:53');
INSERT INTO CHANSON VALUES(1683,'Girl Gone Bad',2,NULL,NULL,'2008-03-12 13:53:21');
INSERT INTO CHANSON VALUES(1684,'House Of Pain',2,NULL,NULL,'2008-03-12 09:39:03');
INSERT INTO CHANSON VALUES(1686,'Aujourd''hui c''est la fête de l''apprenti sorcier',2,NULL,'f','2008-03-12 16:28:21');
INSERT INTO CHANSON VALUES(1687,'Bivouac 1ère partie',2,NULL,'f','2008-03-12 10:26:27');
INSERT INTO CHANSON VALUES(1688,'L''espionne lesbienne',2,NULL,'f','2008-03-12 08:02:41');
INSERT INTO CHANSON VALUES(1689,'Bivouac final',2,NULL,'f','2008-03-12 09:17:35');
INSERT INTO CHANSON VALUES(1690,'De temps en temps',2,NULL,'f','2008-03-12 13:07:39');
INSERT INTO CHANSON VALUES(1691,'La route aux cyprès',2,NULL,'f','2008-03-12 16:10:38');
INSERT INTO CHANSON VALUES(1692,'Le cimetière des arlequins',2,NULL,'f','2008-03-12 10:18:21');
INSERT INTO CHANSON VALUES(1693,'Search And Destroy',2,NULL,'f','2008-03-12 08:48:15');
INSERT INTO CHANSON VALUES(1694,'Gimme Danger',2,NULL,'f','2008-03-12 13:54:54');
INSERT INTO CHANSON VALUES(1695,'Your Pretty Face Is Going To Hell',2,NULL,'f','2008-03-12 13:50:14');
INSERT INTO CHANSON VALUES(1696,'Penetration',2,NULL,'f','2008-03-12 17:35:42');
INSERT INTO CHANSON VALUES(1697,'Raw Power',2,NULL,'f','2008-03-12 09:47:08');
INSERT INTO CHANSON VALUES(1698,'I Need Somebody',2,NULL,'f','2008-03-12 14:48:11');
INSERT INTO CHANSON VALUES(1699,'Shake Appeal',2,NULL,'f','2008-03-12 11:55:29');
INSERT INTO CHANSON VALUES(1700,'Death Trip',2,NULL,'f','2008-03-12 18:24:36');
INSERT INTO CHANSON VALUES(1701,'Thursday''s Child',2,NULL,'f','2008-06-07 19:44:48.034132');
INSERT INTO CHANSON VALUES(1702,'Something In The Air',2,NULL,'f','2008-06-07 20:02:09.819539');
INSERT INTO CHANSON VALUES(1703,'Survive',2,NULL,'f','2008-03-26 14:20:53');
INSERT INTO CHANSON VALUES(1704,'If I''m Dreaming My Life',2,NULL,'f','2008-06-07 20:00:31.102221');
INSERT INTO CHANSON VALUES(1705,'Seven',2,NULL,'f','2008-03-24 16:15:39');
INSERT INTO CHANSON VALUES(1706,'What''s Really Happening',2,NULL,'f','2008-06-07 20:03:50.813851');
INSERT INTO CHANSON VALUES(1707,'The Pretty Things Are Going To Hell',2,NULL,'f','2008-06-07 20:03:28.961466');
INSERT INTO CHANSON VALUES(1708,'New Angels Of Promise',2,NULL,'f','2008-06-07 19:43:54.491793');
INSERT INTO CHANSON VALUES(1709,'Brilliant Adventure',2,NULL,NULL,'2008-06-07 19:17:59.439411');
INSERT INTO CHANSON VALUES(1710,'The Dreamers',2,NULL,'f','2008-06-07 19:45:04.077082');
INSERT INTO CHANSON VALUES(1711,'Suzanne',2,NULL,'f','2008-03-12 08:22:16');
INSERT INTO CHANSON VALUES(1712,'Master Song',2,NULL,'f','2008-03-12 18:32:32');
INSERT INTO CHANSON VALUES(1713,'Winter Lady',2,NULL,'f','2008-03-12 19:04:53');
INSERT INTO CHANSON VALUES(1714,'The Stranger Song',2,NULL,'f','2008-03-12 17:51:40');
INSERT INTO CHANSON VALUES(1715,'Sisters of Mercy',2,NULL,'f','2008-03-12 15:33:56');
INSERT INTO CHANSON VALUES(1716,'So Long, Marianne',2,NULL,'f','2008-03-12 11:29:58');
INSERT INTO CHANSON VALUES(1717,'Hey, That''s No Way To Say Goodbye',2,NULL,NULL,'2008-03-12 14:08:07');
INSERT INTO CHANSON VALUES(1718,'Stories of The Street',2,NULL,NULL,'2008-04-24 11:20:47');
INSERT INTO CHANSON VALUES(1719,'Teachers',2,NULL,'f','2008-03-12 14:55:51');
INSERT INTO CHANSON VALUES(1720,'One of Us Cannot Be Wrong',2,NULL,'f','2008-03-12 13:53:51');
INSERT INTO CHANSON VALUES(1721,'Demain les kids',2,NULL,'f','2008-03-12 10:21:43');
INSERT INTO CHANSON VALUES(1722,'Pogo sur la deadline',2,NULL,'f','2008-03-12 12:25:05');
INSERT INTO CHANSON VALUES(1723,'Un automne a Tanger',2,NULL,'f','2008-03-12 15:16:38');
INSERT INTO CHANSON VALUES(1724,'Camera terminus',2,NULL,'f','2008-03-12 10:11:42');
INSERT INTO CHANSON VALUES(1725,'542 lunes et 7 jours environ',2,NULL,'f','2008-03-12 09:00:34');
INSERT INTO CHANSON VALUES(1726,'Zoo zumains zébus',2,NULL,'f','2008-03-12 17:38:07');
INSERT INTO CHANSON VALUES(1727,'Portrait de femme en 1922',2,NULL,'f','2008-03-12 16:54:37');
INSERT INTO CHANSON VALUES(1728,'Misty dog in love',2,NULL,'f','2008-03-12 16:26:45');
INSERT INTO CHANSON VALUES(1729,'Villes natales et frenchitude',2,NULL,'f','2008-03-12 17:00:40');
INSERT INTO CHANSON VALUES(1730,'Chic Et Pas Cher',2,NULL,'f','2008-03-12 16:26:34');
INSERT INTO CHANSON VALUES(1731,'La Vie Est Une Partouze',2,NULL,'f','2008-03-12 14:38:56');
INSERT INTO CHANSON VALUES(1732,'Françoise',2,NULL,'f','2008-03-12 11:00:21');
INSERT INTO CHANSON VALUES(1733,'Fais Gaffe',2,NULL,'f','2008-03-12 12:40:37');
INSERT INTO CHANSON VALUES(1734,'Chanteur De Charme',2,NULL,'f','2008-03-12 19:52:49');
INSERT INTO CHANSON VALUES(1735,'Lili',2,NULL,'f','2008-03-12 16:57:50');
INSERT INTO CHANSON VALUES(1736,'Femme Riche',2,NULL,NULL,'2008-03-12 11:44:28');
INSERT INTO CHANSON VALUES(1737,'In Love Avec Une DJ',2,NULL,NULL,'2008-03-12 12:26:23');
INSERT INTO CHANSON VALUES(1738,'40 Ans',2,NULL,'f','2008-03-12 08:07:50');
INSERT INTO CHANSON VALUES(1739,'Vide',2,NULL,'f','2008-03-12 17:56:50');
INSERT INTO CHANSON VALUES(1740,'Bonbons',2,NULL,'f','2008-05-22 17:12:34');
INSERT INTO CHANSON VALUES(1741,'Voir Un Ami Pleurer',2,NULL,'f','2008-03-12 13:37:17');
INSERT INTO CHANSON VALUES(1742,'La Fête',2,NULL,'f','2008-03-12 08:10:55');
INSERT INTO CHANSON VALUES(1743,'Knowing Me, Knowing You',2,NULL,'f','2008-03-12 19:25:56');
INSERT INTO CHANSON VALUES(1744,'Back Door Man',2,NULL,'f','2008-03-12 11:46:36');
INSERT INTO CHANSON VALUES(1745,'Je Danse Et J''oublie',2,NULL,'f','2008-03-12 19:46:28');
INSERT INTO CHANSON VALUES(1746,'Sarah (La Femme Qui Est Dans Mon Lit)',2,NULL,'f','2008-03-12 17:28:26');
INSERT INTO CHANSON VALUES(1748,'Rock ''n'' Roll Damnation',2,NULL,'f','2008-03-12 08:08:37');
INSERT INTO CHANSON VALUES(1749,'Down Payment Blues',2,NULL,'f','2008-03-12 13:09:45');
INSERT INTO CHANSON VALUES(1750,'Gimme A Bullet',2,NULL,'f','2008-03-12 11:55:42');
INSERT INTO CHANSON VALUES(1751,'Riff Raff',2,NULL,'f','2008-03-12 09:21:19');
INSERT INTO CHANSON VALUES(1752,'Sin City',2,NULL,'f','2008-03-12 13:22:29');
INSERT INTO CHANSON VALUES(1753,'What''s Next To The Moon',2,NULL,'f','2008-03-12 12:19:55');
INSERT INTO CHANSON VALUES(1754,'Gone Shootin''',2,NULL,'f','2008-03-12 11:37:41');
INSERT INTO CHANSON VALUES(1755,'Up To My Neck In You',2,NULL,'f','2008-03-12 18:33:28');
INSERT INTO CHANSON VALUES(1756,'Kicked In The Teeth',2,NULL,'f','2008-03-12 12:19:56');
INSERT INTO CHANSON VALUES(1757,'a. Speak to Me / b. Breathe',6,NULL,NULL,'2008-03-12 17:54:41');
INSERT INTO CHANSON VALUES(1758,'On the Run',6,NULL,'f','2008-03-12 19:58:49');
INSERT INTO CHANSON VALUES(1759,'Time',6,NULL,'f','2008-03-26 15:26:59');
INSERT INTO CHANSON VALUES(1760,'The great Gig in the Sky',6,NULL,'f','2008-03-12 12:43:54');
INSERT INTO CHANSON VALUES(1761,'Money',6,NULL,'f','2008-04-09 10:41:13');
INSERT INTO CHANSON VALUES(1762,'Us and Them',6,NULL,NULL,'2008-03-12 08:52:15');
INSERT INTO CHANSON VALUES(1763,'Any Colour You like',6,NULL,'f','2008-03-12 12:18:38');
INSERT INTO CHANSON VALUES(1764,'Brain Damage',6,NULL,'f','2008-03-12 18:39:57');
INSERT INTO CHANSON VALUES(1765,'Eclipse',6,NULL,'f','2008-03-12 17:57:34');
INSERT INTO CHANSON VALUES(1766,'Dies ole sparadrap Joey',2,NULL,'f','2008-03-12 14:51:08');
INSERT INTO CHANSON VALUES(1768,'Precos ejaculator',2,NULL,NULL,'2008-03-12 19:03:22');
INSERT INTO CHANSON VALUES(1769,'Narine marchande',2,NULL,'f','2008-03-12 15:03:21');
INSERT INTO CHANSON VALUES(1770,'Affaire Rimbaud',2,NULL,'f','2008-03-12 13:40:47');
INSERT INTO CHANSON VALUES(1771,'Bipède à station verticale',2,NULL,'f','2008-03-12 13:03:31');
INSERT INTO CHANSON VALUES(1772,'Sweet amanite phalloïde queen',2,NULL,'f','2008-03-12 11:07:23');
INSERT INTO CHANSON VALUES(1773,'Diogène série 87',2,NULL,'f','2008-03-12 15:32:42');
INSERT INTO CHANSON VALUES(1774,'Errer humanum est',2,NULL,'f','2008-03-12 10:25:21');
INSERT INTO CHANSON VALUES(1775,'Immigrant Song',2,NULL,'f','2008-03-12 10:14:19');
INSERT INTO CHANSON VALUES(1776,'Friends',2,NULL,'f','2008-03-12 17:45:10');
INSERT INTO CHANSON VALUES(1777,'Celebration Day',2,NULL,'f','2008-03-19 18:44:24');
INSERT INTO CHANSON VALUES(1778,'Since I''ve Been Loving You',2,NULL,'f','2008-03-12 12:40:28');
INSERT INTO CHANSON VALUES(1779,'Out Of The Tiles',2,NULL,'f','2008-04-11 17:18:50');
INSERT INTO CHANSON VALUES(1780,'Gallows Pole',2,NULL,'f','2008-03-12 16:16:31');
INSERT INTO CHANSON VALUES(1781,'Tangerine',2,NULL,'f','2008-04-14 14:23:42');
INSERT INTO CHANSON VALUES(1782,'That''s The Way',2,NULL,'f','2008-03-12 09:43:11');
INSERT INTO CHANSON VALUES(1783,'Bron-Y-Aur Stomp',2,NULL,'f','2008-04-14 15:25:48');
INSERT INTO CHANSON VALUES(1784,'Hats Off To (Roy) Harper',2,NULL,'f','2008-03-12 18:09:14');
INSERT INTO CHANSON VALUES(1785,'J''ecume',2,NULL,'f','2008-03-12 12:29:22');
INSERT INTO CHANSON VALUES(1786,'Volutes(remix)',2,NULL,'f','2008-03-12 17:04:54');
INSERT INTO CHANSON VALUES(1787,'Happe',2,NULL,'f','2008-03-12 14:18:20');
INSERT INTO CHANSON VALUES(1788,'Well All Right',2,NULL,'f','2008-03-12 18:30:35');
INSERT INTO CHANSON VALUES(1789,'Les Grands Voyageurs',2,NULL,'f','2008-03-12 10:16:20');
INSERT INTO CHANSON VALUES(1790,'Blue Eyes Crying In The Rain',2,NULL,NULL,'2008-03-12 12:11:05');
INSERT INTO CHANSON VALUES(1791,'Osez Joséphine',2,NULL,NULL,'2008-03-12 17:33:45');
INSERT INTO CHANSON VALUES(1792,'Kalabougie',2,NULL,'f','2008-03-12 10:17:02');
INSERT INTO CHANSON VALUES(1793,'She Belongs To Me',2,NULL,'f','2008-03-12 17:23:45');
INSERT INTO CHANSON VALUES(1794,'Madame rêve',2,NULL,'f','2008-03-12 19:15:54');
INSERT INTO CHANSON VALUES(1795,'Nights In White Satin',2,NULL,'f','2008-03-12 10:40:23');
INSERT INTO CHANSON VALUES(1796,'Overture',2,NULL,'f','2008-03-12 15:27:28');
INSERT INTO CHANSON VALUES(1797,'It''s A Boy',2,NULL,'f','2008-03-12 14:57:47');
INSERT INTO CHANSON VALUES(1798,'1921',2,NULL,'f','2008-03-12 18:49:18');
INSERT INTO CHANSON VALUES(1799,'Amazing Journey',2,NULL,NULL,'2008-03-12 13:00:34');
INSERT INTO CHANSON VALUES(1800,'Sparks',2,NULL,'f','2008-03-12 17:22:46');
INSERT INTO CHANSON VALUES(1801,'Eyesight To The Blind (The Hawker)',2,NULL,'f','2008-03-20 18:08:19');
INSERT INTO CHANSON VALUES(1802,'Christmas',2,NULL,'f','2008-03-12 15:23:37');
INSERT INTO CHANSON VALUES(1803,'Cousin Kevin',2,NULL,'f','2008-04-07 14:13:27');
INSERT INTO CHANSON VALUES(1804,'The Acid Queen',2,NULL,'f','2008-03-27 15:09:00');
INSERT INTO CHANSON VALUES(1805,'Underture',2,NULL,'f','2008-03-12 13:08:16');
INSERT INTO CHANSON VALUES(1806,'Do You Think It''s Alright?',2,NULL,'f','2008-03-12 11:21:56');
INSERT INTO CHANSON VALUES(1807,'Fiddle About',2,NULL,'f','2008-03-12 16:56:24');
INSERT INTO CHANSON VALUES(1808,'Pinball Wizard',2,NULL,'f','2008-04-18 16:55:05');
INSERT INTO CHANSON VALUES(1809,'There''s A Doctor',2,NULL,'f','2008-03-12 10:27:22');
INSERT INTO CHANSON VALUES(1810,'Go To The Mirror!',2,NULL,'f','2008-03-12 19:18:12');
INSERT INTO CHANSON VALUES(1811,'Tommy Can You Hear Me?',2,NULL,'f','2008-03-12 11:44:13');
INSERT INTO CHANSON VALUES(1812,'Smash The Mirror',2,NULL,'f','2008-03-12 18:31:35');
INSERT INTO CHANSON VALUES(1813,'Sensation',2,NULL,'f','2008-03-12 15:23:44');
INSERT INTO CHANSON VALUES(1814,'Miracle Cure',2,NULL,'f','2008-03-12 19:00:08');
INSERT INTO CHANSON VALUES(1815,'Sally Simpson',2,NULL,'f','2008-04-11 09:43:54');
INSERT INTO CHANSON VALUES(1816,'I''m Free',2,NULL,'f','2008-04-24 12:16:23');
INSERT INTO CHANSON VALUES(1817,'Welcome',2,NULL,NULL,'2008-03-12 15:40:18');
INSERT INTO CHANSON VALUES(1818,'Tommy''s Holiday Camp',2,NULL,NULL,'2008-03-12 15:05:26');
INSERT INTO CHANSON VALUES(1820,'Sprint',2,NULL,NULL,'2008-03-12 18:09:44');
INSERT INTO CHANSON VALUES(1821,'Mon cur s''envole',2,NULL,'f','2008-03-24 11:21:11');
INSERT INTO CHANSON VALUES(1822,'Seoul bop (in gold we trust)',2,NULL,'f','2008-03-12 15:21:29');
INSERT INTO CHANSON VALUES(1823,'Faux départ',2,NULL,'f','2008-03-12 18:39:14');
INSERT INTO CHANSON VALUES(1824,'Les athlètes',2,NULL,'f','2008-03-12 08:32:45');
INSERT INTO CHANSON VALUES(1825,'110m haies',2,NULL,'f','2008-03-12 16:11:09');
INSERT INTO CHANSON VALUES(1826,'Mike Tyson',2,NULL,'f','2008-03-12 13:10:10');
INSERT INTO CHANSON VALUES(1827,'Saut en longueur',2,NULL,'f','2008-03-12 14:46:50');
INSERT INTO CHANSON VALUES(1828,'Bye Bye Till The Next Time',2,NULL,NULL,'2008-03-12 18:24:56');
INSERT INTO CHANSON VALUES(1829,'L''Union Fait La Force',2,NULL,'f','2008-03-12 11:18:22');
INSERT INTO CHANSON VALUES(1830,'With You',2,NULL,'f','2008-03-12 09:09:31');
INSERT INTO CHANSON VALUES(1831,'Stop Rock',2,NULL,'f','2008-03-12 18:25:52');
INSERT INTO CHANSON VALUES(1832,'The Parrot Bridge',2,NULL,'f','2008-03-12 08:04:13');
INSERT INTO CHANSON VALUES(1833,'I''m Not Like That',2,NULL,'f','2008-03-12 14:56:53');
INSERT INTO CHANSON VALUES(1834,'Give Them A Leader',2,NULL,'f','2008-03-12 17:01:25');
INSERT INTO CHANSON VALUES(1835,'Viva Boema',2,NULL,'f','2008-03-12 14:41:36');
INSERT INTO CHANSON VALUES(1836,'O La La La',2,NULL,'f','2008-03-12 16:07:46');
INSERT INTO CHANSON VALUES(1837,'Pitie Pour Lui',2,NULL,'f','2008-03-12 18:40:33');
INSERT INTO CHANSON VALUES(1838,'Highway To Hell',2,NULL,'f','2008-03-12 16:33:57');
INSERT INTO CHANSON VALUES(1839,'Girls Got Rhythm',2,NULL,'f','2008-04-14 14:30:49');
INSERT INTO CHANSON VALUES(1840,'Walk All Over You',2,NULL,'f','2008-03-12 15:51:15');
INSERT INTO CHANSON VALUES(1841,'Touch Too Much',2,NULL,'f','2008-03-12 08:58:25');
INSERT INTO CHANSON VALUES(1842,'Beating Around the Bush',2,NULL,'f','2008-03-12 14:48:51');
INSERT INTO CHANSON VALUES(1843,'Shot Down In Flames',2,NULL,NULL,'2008-03-12 13:50:56');
INSERT INTO CHANSON VALUES(1844,'Get It Hot',2,NULL,'f','2008-03-12 15:22:52');
INSERT INTO CHANSON VALUES(1845,'If You Want Blood (You''ve Got It)',2,NULL,'f','2008-03-12 14:09:53');
INSERT INTO CHANSON VALUES(1846,'Love Hungry Man',2,NULL,'f','2008-03-12 19:41:35');
INSERT INTO CHANSON VALUES(1847,'Night Prowler',2,NULL,'f','2008-04-15 08:17:15');
INSERT INTO CHANSON VALUES(1848,'Antisocial',2,NULL,NULL,'2008-03-17 18:59:57');
INSERT INTO CHANSON VALUES(1849,'Monsieur Comedie',2,NULL,NULL,'2008-03-17 18:39:48');
INSERT INTO CHANSON VALUES(1850,'Instinct De Mort',2,NULL,'f','2008-03-17 09:41:47');
INSERT INTO CHANSON VALUES(1851,'Au Nom De La Race',2,NULL,'f','2008-03-17 14:14:35');
INSERT INTO CHANSON VALUES(1852,'Passe',2,NULL,'f','2008-03-12 12:40:26');
INSERT INTO CHANSON VALUES(1853,'Fatalite',2,NULL,'f','2008-03-12 11:19:49');
INSERT INTO CHANSON VALUES(1854,'Saumur',2,NULL,'f','2008-03-17 10:51:59');
INSERT INTO CHANSON VALUES(1855,'Le Mitard',2,NULL,'f','2008-03-17 09:49:40');
INSERT INTO CHANSON VALUES(1856,'Sors Tes Griffes',2,NULL,'f','2008-03-12 16:23:04');
INSERT INTO CHANSON VALUES(1857,'Les Sectes',2,NULL,'f','2008-03-17 12:44:20');
INSERT INTO CHANSON VALUES(1858,'Hello Hooray',2,NULL,'f','2008-03-12 17:38:20');
INSERT INTO CHANSON VALUES(1859,'Raped and Freezin''',2,NULL,'f','2008-03-12 17:28:59');
INSERT INTO CHANSON VALUES(1860,'Elected',2,NULL,'f','2008-04-12 17:10:26');
INSERT INTO CHANSON VALUES(1861,'Billion Dollar Babies',2,NULL,'f','2008-04-12 18:28:14');
INSERT INTO CHANSON VALUES(1862,'Unfinished Sweet',2,NULL,'f','2008-03-12 14:35:41');
INSERT INTO CHANSON VALUES(1863,'No More Mr. Nice Guy',2,NULL,'f','2008-03-12 12:07:55');
INSERT INTO CHANSON VALUES(1864,'Generation Landslide',2,NULL,'f','2008-03-12 19:30:35');
INSERT INTO CHANSON VALUES(1865,'Sick Things',2,NULL,'f','2008-03-12 12:49:55');
INSERT INTO CHANSON VALUES(1866,'Mary Ann',2,NULL,NULL,'2008-03-12 10:01:47');
INSERT INTO CHANSON VALUES(1867,'I Love The Dead',2,NULL,'f','2008-03-12 10:06:37');
INSERT INTO CHANSON VALUES(1868,'Lonely at the Top',2,NULL,NULL,'2008-03-12 18:48:00');
INSERT INTO CHANSON VALUES(1869,'1/2 a Loaf',2,NULL,'f','2008-03-12 19:12:45');
INSERT INTO CHANSON VALUES(1870,'Running out of Luck',2,NULL,'f','2008-03-12 11:00:23');
INSERT INTO CHANSON VALUES(1871,'Turn the Girl Loose',2,NULL,'f','2008-03-12 15:45:52');
INSERT INTO CHANSON VALUES(1872,'Hard Woman',2,NULL,'f','2008-03-12 15:19:27');
INSERT INTO CHANSON VALUES(1873,'Just Another Night',2,NULL,'f','2008-03-12 11:40:34');
INSERT INTO CHANSON VALUES(1874,'Lucky in Love',2,NULL,'f','2008-03-12 11:36:04');
INSERT INTO CHANSON VALUES(1875,'Secrets',2,NULL,'f','2008-03-12 18:00:53');
INSERT INTO CHANSON VALUES(1876,'She''s the Boss',2,NULL,'f','2008-03-12 17:13:55');
INSERT INTO CHANSON VALUES(1877,'Le Minimum',2,NULL,'f','2008-03-12 14:25:02');
INSERT INTO CHANSON VALUES(1878,'Géant Jones',2,NULL,'f','2008-03-12 10:18:50');
INSERT INTO CHANSON VALUES(1879,'La rousse au chocolat',2,NULL,NULL,'2008-03-23 10:16:02');
INSERT INTO CHANSON VALUES(1880,'Je veux cette fille',2,NULL,'f','2008-03-12 19:34:02');
INSERT INTO CHANSON VALUES(1881,'J''suis qu''un grain de poussière',2,NULL,'f','2008-03-12 12:13:47');
INSERT INTO CHANSON VALUES(1882,'Aujourd''hui la crise',2,NULL,'f','2008-03-12 10:52:06');
INSERT INTO CHANSON VALUES(1883,'Rien',2,NULL,'f','2008-03-12 15:12:47');
INSERT INTO CHANSON VALUES(1884,'Coup de blues',2,NULL,'f','2008-03-12 10:27:24');
INSERT INTO CHANSON VALUES(1885,'Alertez les bébés',2,NULL,'f','2008-03-12 11:18:24');
INSERT INTO CHANSON VALUES(1886,'Demain ça s''ra vachement mieux',2,NULL,'f','2008-03-12 10:05:37');
INSERT INTO CHANSON VALUES(1887,'Blue Sky Mine',2,NULL,'f','2008-03-12 09:39:03');
INSERT INTO CHANSON VALUES(1888,'Stars of Warburton',2,NULL,'f','2008-03-12 09:50:22');
INSERT INTO CHANSON VALUES(1889,'Bedlam Bridge',2,NULL,'f','2008-03-12 08:02:38');
INSERT INTO CHANSON VALUES(1890,'Forgotten Years',2,NULL,'f','2008-03-12 08:59:13');
INSERT INTO CHANSON VALUES(1891,'Mountains of Burma',2,NULL,'f','2008-03-12 09:19:26');
INSERT INTO CHANSON VALUES(1892,'King of the Mountain',2,NULL,'f','2008-03-12 18:32:18');
INSERT INTO CHANSON VALUES(1893,'River Runs Red',2,NULL,'f','2008-03-12 19:12:31');
INSERT INTO CHANSON VALUES(1894,'Shakers and Movers',2,NULL,'f','2008-03-12 17:26:58');
INSERT INTO CHANSON VALUES(1895,'One Country',2,NULL,'f','2008-03-12 10:44:17');
INSERT INTO CHANSON VALUES(1896,'Antartica',2,NULL,'f','2008-03-12 15:57:23');
INSERT INTO CHANSON VALUES(1898,'Dance till you drop',2,NULL,'f','2008-03-12 11:15:52');
INSERT INTO CHANSON VALUES(1900,'Ratata',2,NULL,'f','2008-03-12 11:18:54');
INSERT INTO CHANSON VALUES(1901,'I''ve done my best',2,NULL,'f','2008-03-12 14:23:14');
INSERT INTO CHANSON VALUES(1902,'Whoop that thing',2,NULL,'f','2008-03-12 19:16:46');
INSERT INTO CHANSON VALUES(1903,'Marie tu m''as (Marie Thumas)',2,NULL,'f','2008-03-12 11:15:58');
INSERT INTO CHANSON VALUES(1904,'I''m not there',2,NULL,'f','2008-03-12 17:02:24');
INSERT INTO CHANSON VALUES(1905,'I can''t stand it',2,NULL,'f','2008-03-12 17:14:09');
INSERT INTO CHANSON VALUES(1907,'Watch That Man',2,NULL,'f','2008-04-11 09:08:05');
INSERT INTO CHANSON VALUES(1908,'Aladdin Sane',2,NULL,'f','2008-04-11 08:14:20');
INSERT INTO CHANSON VALUES(1909,'Drive In Saturday',2,NULL,NULL,'2008-03-19 13:03:12');
INSERT INTO CHANSON VALUES(1910,'Panic in Detroit',2,NULL,'f','2008-04-12 18:01:24');
INSERT INTO CHANSON VALUES(1911,'Cracked Actor',2,NULL,'f','2008-04-13 12:56:13');
INSERT INTO CHANSON VALUES(1912,'Time',2,NULL,'f','2008-03-26 13:20:27');
INSERT INTO CHANSON VALUES(1913,'The Prettiest Star',2,NULL,'f','2008-06-07 15:37:39.743084');
INSERT INTO CHANSON VALUES(1914,'Let''s Spend the Night Together',2,NULL,'f','2008-04-14 08:43:36');
INSERT INTO CHANSON VALUES(1915,'The Jean Genie',2,NULL,'f','2008-04-11 19:39:46');
INSERT INTO CHANSON VALUES(1916,'Lady Grinning Soul',2,NULL,'f','2008-04-13 08:10:11');
INSERT INTO CHANSON VALUES(1917,'Le Nord',2,NULL,'f','2008-03-12 11:16:01');
INSERT INTO CHANSON VALUES(1918,'Hey Joe',2,NULL,'f','2008-03-12 10:46:24');
INSERT INTO CHANSON VALUES(1919,'Stetson Blues',2,NULL,'f','2008-03-12 13:43:40');
INSERT INTO CHANSON VALUES(1920,'Ca m''fait tout drle',2,NULL,'f','2008-03-12 10:59:56');
INSERT INTO CHANSON VALUES(1921,'Cocaïne',2,NULL,'f','2008-03-12 10:46:59');
INSERT INTO CHANSON VALUES(1922,'Cole Younger',2,NULL,'f','2008-03-12 15:32:13');
INSERT INTO CHANSON VALUES(1923,'Rien à dire',2,NULL,'f','2008-03-12 16:35:03');
INSERT INTO CHANSON VALUES(1924,'Caracas',2,NULL,'f','2008-03-12 18:01:06');
INSERT INTO CHANSON VALUES(1925,'Suzy',2,NULL,'f','2008-03-12 08:29:26');
INSERT INTO CHANSON VALUES(1926,'Caught In A Dream',2,NULL,NULL,'2008-03-12 14:51:25');
INSERT INTO CHANSON VALUES(1927,'I''m Eighteen',2,NULL,'f','2008-04-15 18:14:05');
INSERT INTO CHANSON VALUES(1928,'Long Way To Go',2,NULL,'f','2008-03-12 11:07:42');
INSERT INTO CHANSON VALUES(1929,'Black Juju',2,NULL,'f','2008-04-12 16:42:52');
INSERT INTO CHANSON VALUES(1930,'Is It My Body',2,NULL,NULL,'2008-03-12 11:19:28');
INSERT INTO CHANSON VALUES(1931,'Hallowed Be My Name',2,NULL,NULL,'2008-03-12 16:44:12');
INSERT INTO CHANSON VALUES(1932,'Second Coming',2,NULL,'f','2008-03-12 12:56:12');
INSERT INTO CHANSON VALUES(1933,'Ballad Of Dwight Fry',2,NULL,'f','2008-03-12 11:06:58');
INSERT INTO CHANSON VALUES(1934,'Sun Arise',2,NULL,'f','2008-04-15 17:12:30');
INSERT INTO CHANSON VALUES(1935,'Préfabriqués',2,NULL,'f','2008-03-17 11:41:31');
INSERT INTO CHANSON VALUES(1936,'Palace',2,NULL,'f','2008-03-17 14:26:06');
INSERT INTO CHANSON VALUES(1937,'Le matteur',2,NULL,'f','2008-03-12 15:18:07');
INSERT INTO CHANSON VALUES(1938,'Bosser huit heures',2,NULL,'f','2008-03-24 14:18:15');
INSERT INTO CHANSON VALUES(1939,'Comme un damné',2,NULL,'f','2008-03-17 16:22:37');
INSERT INTO CHANSON VALUES(1940,'Dialogue de sourds',2,NULL,'f','2008-03-12 09:54:28');
INSERT INTO CHANSON VALUES(1941,'L''élite',2,NULL,'f','2008-03-17 15:10:36');
INSERT INTO CHANSON VALUES(1942,'Police-milice',2,NULL,'f','2008-03-12 11:27:55');
INSERT INTO CHANSON VALUES(1943,'H&D',2,NULL,'f','2008-03-17 17:08:40');
INSERT INTO CHANSON VALUES(1944,'Ride on',2,NULL,'f','2008-03-12 19:31:36');
INSERT INTO CHANSON VALUES(1945,'Toujours pas une tune',2,NULL,'f','2008-03-12 10:50:43');
INSERT INTO CHANSON VALUES(1946,'Signs of Life',6,NULL,'f','2008-03-12 09:09:25');
INSERT INTO CHANSON VALUES(1947,'Learning to Fly',6,NULL,'f','2008-06-07 19:24:19.182924');
INSERT INTO CHANSON VALUES(1948,'The Dogs of War',6,NULL,'f','2008-08-13 07:33:39.41352');
INSERT INTO CHANSON VALUES(1949,'One Slip',6,NULL,NULL,'2008-03-12 14:10:28');
INSERT INTO CHANSON VALUES(1950,'On the Turning Away',6,NULL,'f','2008-03-12 08:45:39');
INSERT INTO CHANSON VALUES(1951,'Yet Another Movie, Round and Round',6,NULL,'f','2008-03-12 15:02:06');
INSERT INTO CHANSON VALUES(1952,'A New Machine (Part 1)',6,NULL,'f','2008-03-12 14:48:14');
INSERT INTO CHANSON VALUES(1953,'Terminal Frost',6,NULL,'f','2008-03-12 10:47:46');
INSERT INTO CHANSON VALUES(1954,'A New Machine (Part 2)',6,NULL,'f','2008-03-12 18:57:36');
INSERT INTO CHANSON VALUES(1955,'Sorrow',6,NULL,'f','2008-08-13 07:27:11.235307');
INSERT INTO CHANSON VALUES(1956,'More Than This',2,NULL,'f','2008-03-12 08:48:28');
INSERT INTO CHANSON VALUES(1957,'The Space Between',2,NULL,'f','2008-03-12 18:35:46');
INSERT INTO CHANSON VALUES(1958,'Avalon',2,NULL,'f','2008-03-18 08:31:48');
INSERT INTO CHANSON VALUES(1959,'India',2,NULL,NULL,'2008-03-12 15:03:58');
INSERT INTO CHANSON VALUES(1960,'While My Heart Is Still Beating',2,NULL,'f','2008-03-12 09:05:44');
INSERT INTO CHANSON VALUES(1961,'The Main Thing',2,NULL,'f','2008-03-12 17:44:47');
INSERT INTO CHANSON VALUES(1962,'Take A Chance With Me',2,NULL,'f','2008-03-12 18:18:35');
INSERT INTO CHANSON VALUES(1963,'To Turn You On',2,NULL,'f','2008-03-12 09:33:23');
INSERT INTO CHANSON VALUES(1964,'True To Life',2,NULL,'f','2008-03-12 18:25:20');
INSERT INTO CHANSON VALUES(1965,'Tara',2,NULL,'f','2008-03-12 13:00:28');
INSERT INTO CHANSON VALUES(1966,'Hard As A Rock',2,NULL,'f','2008-04-24 08:03:58');
INSERT INTO CHANSON VALUES(1967,'Cover You In Oil',2,NULL,NULL,'2008-03-12 11:01:17');
INSERT INTO CHANSON VALUES(1968,'The Furor',2,NULL,'f','2008-03-12 16:55:53');
INSERT INTO CHANSON VALUES(1969,'Boogie Man',2,NULL,'f','2008-03-12 14:59:24');
INSERT INTO CHANSON VALUES(1970,'The Honey Roll',2,NULL,'f','2008-03-12 11:38:28');
INSERT INTO CHANSON VALUES(1971,'Burnin'' Alive',2,NULL,'f','2008-03-12 11:45:33');
INSERT INTO CHANSON VALUES(1972,'Hail Caesar',2,NULL,'f','2008-03-12 08:31:17');
INSERT INTO CHANSON VALUES(1973,'Love Bomb',2,NULL,'f','2008-03-12 17:23:36');
INSERT INTO CHANSON VALUES(1974,'Caught With Your Pants Down',2,NULL,'f','2008-03-12 13:30:09');
INSERT INTO CHANSON VALUES(1975,'Whiskey On The Rocks',2,NULL,NULL,'2008-03-12 17:24:34');
INSERT INTO CHANSON VALUES(1976,'Ballbreaker',2,NULL,'f','2008-03-12 09:53:35');
INSERT INTO CHANSON VALUES(1977,'She Said Yeah',2,NULL,'f','2008-04-13 11:20:06');
INSERT INTO CHANSON VALUES(1978,'Talkin'' About You',2,NULL,'f','2008-06-02 09:25:18.864791');
INSERT INTO CHANSON VALUES(1979,'You Better Move On',2,NULL,'f','2008-06-02 09:25:38.653477');
INSERT INTO CHANSON VALUES(1980,'Look What You''ve Done',2,NULL,'f','2008-06-02 09:31:28.564409');
INSERT INTO CHANSON VALUES(1981,'The Singer Not The Song',2,NULL,'f','2008-06-02 09:31:43.098236');
INSERT INTO CHANSON VALUES(1982,'Route 66 (Live)',2,NULL,'f','2008-04-11 19:08:30');
INSERT INTO CHANSON VALUES(1983,'Get Off Of My Cloud',2,NULL,'f','2008-06-01 17:13:57.63739');
INSERT INTO CHANSON VALUES(1984,'I''m Free',2,NULL,'f','2008-05-22 19:35:30');
INSERT INTO CHANSON VALUES(1985,'As Tears Go By',2,NULL,'f','2008-05-23 17:13:05');
INSERT INTO CHANSON VALUES(1986,'Gotta Get Away',2,NULL,'f','2008-06-02 09:33:20.134274');
INSERT INTO CHANSON VALUES(1987,'Blue Turns To Grey',2,NULL,'f','2008-06-02 09:33:39.155625');
INSERT INTO CHANSON VALUES(1988,'I''m Moving On',2,NULL,'f','2008-06-02 09:34:10.792193');
INSERT INTO CHANSON VALUES(1989,'Concrete And Steel',2,NULL,'f','2008-03-12 09:18:20');
INSERT INTO CHANSON VALUES(1990,'Lovething',2,NULL,'f','2008-03-12 11:07:44');
INSERT INTO CHANSON VALUES(1991,'Penthouse Eyes',2,NULL,'f','2008-03-12 18:16:38');
INSERT INTO CHANSON VALUES(1992,'Tell It',2,NULL,'f','2008-03-12 13:54:48');
INSERT INTO CHANSON VALUES(1993,'My Head''s In Mississippi',2,NULL,'f','2008-05-22 13:03:34');
INSERT INTO CHANSON VALUES(1994,'Decision Or Colission',2,NULL,'f','2008-03-12 08:50:41');
INSERT INTO CHANSON VALUES(1995,'Give It Up',2,NULL,'f','2008-03-12 15:38:06');
INSERT INTO CHANSON VALUES(1996,'2000 Blues',2,NULL,'f','2008-03-12 09:51:50');
INSERT INTO CHANSON VALUES(1997,'Burger Man',2,NULL,'f','2008-03-12 11:32:51');
INSERT INTO CHANSON VALUES(1998,'Doubleback',2,NULL,'f','2008-03-12 10:47:55');
INSERT INTO CHANSON VALUES(1999,'I wanna live',2,NULL,'f','2008-03-12 15:20:48');
INSERT INTO CHANSON VALUES(2000,'Pussy Walk',2,NULL,'f','2008-03-16 13:29:07');
INSERT INTO CHANSON VALUES(2001,'Innocent world',2,NULL,NULL,'2008-03-12 17:48:14');
INSERT INTO CHANSON VALUES(2002,'Knucklehead',2,NULL,'f','2008-03-12 14:41:31');
INSERT INTO CHANSON VALUES(2003,'To belong',2,NULL,'f','2008-03-12 10:09:26');
INSERT INTO CHANSON VALUES(2004,'Keep on believing',2,NULL,NULL,'2008-03-12 19:14:16');
INSERT INTO CHANSON VALUES(2005,'Outta my head',2,NULL,'f','2008-04-24 10:23:41');
INSERT INTO CHANSON VALUES(2006,'Shoeshine girl',2,NULL,'f','2008-03-12 16:50:55');
INSERT INTO CHANSON VALUES(2007,'Heart is saved',2,NULL,NULL,'2008-03-12 17:58:47');
INSERT INTO CHANSON VALUES(2008,'Look away',2,NULL,NULL,'2008-03-12 15:15:19');
INSERT INTO CHANSON VALUES(2009,'Sing This All Together',2,NULL,'f','2008-06-02 10:08:23.600798');
INSERT INTO CHANSON VALUES(2010,'Citadel',2,NULL,'f','2008-06-02 10:08:53.450331');
INSERT INTO CHANSON VALUES(2011,'In Another Land',2,NULL,'f','2008-05-26 13:04:22');
INSERT INTO CHANSON VALUES(2012,'2,000 Man',2,NULL,'f','2008-06-02 10:09:51.63473');
INSERT INTO CHANSON VALUES(2013,'Sing This All Together (See What Happens)',2,NULL,'f','2008-06-02 10:10:10.87615');
INSERT INTO CHANSON VALUES(2014,'She''s A Rainbow',2,NULL,'f','2008-06-02 10:10:35.775291');
INSERT INTO CHANSON VALUES(2015,'The Lantern',2,NULL,'f','2008-06-02 10:11:05.119588');
INSERT INTO CHANSON VALUES(2016,'Gomper',2,NULL,'f','2008-06-02 10:11:24.921622');
INSERT INTO CHANSON VALUES(2018,'On With The Show',2,NULL,'f','2008-06-02 10:11:58.89688');
INSERT INTO CHANSON VALUES(2019,'Universal Radio',2,NULL,'f','2008-03-12 14:14:55');
INSERT INTO CHANSON VALUES(2020,'Gods Of Aquarius',2,NULL,'f','2008-03-12 18:43:24');
INSERT INTO CHANSON VALUES(2021,'Russian Reggae',2,NULL,'f','2008-03-23 13:21:04');
INSERT INTO CHANSON VALUES(2022,'My Way',2,NULL,'f','2008-03-12 13:41:27');
INSERT INTO CHANSON VALUES(2023,'1985 Ekstasy Drive',2,NULL,'f','2008-03-12 10:17:23');
INSERT INTO CHANSON VALUES(2024,'Prima Nina In Ekstasy',2,NULL,'f','2008-03-12 16:23:30');
INSERT INTO CHANSON VALUES(2025,'Spirit In The Sky',2,NULL,'f','2008-03-12 11:56:37');
INSERT INTO CHANSON VALUES(2026,'Atomic Flash Deluxe',2,NULL,'f','2008-03-12 09:46:25');
INSERT INTO CHANSON VALUES(2027,'The Lord''s Prayer',2,NULL,'f','2008-03-12 17:31:01');
INSERT INTO CHANSON VALUES(2028,'Gott In Himmel (Spirit In The Sky)',2,NULL,'f','2008-03-12 13:03:15');
INSERT INTO CHANSON VALUES(2029,'Universal Radio (Dance Mix)',2,NULL,'f','2008-03-12 13:55:59');
INSERT INTO CHANSON VALUES(2030,'Money Changes Everything',2,NULL,'f','2008-03-12 17:55:07');
INSERT INTO CHANSON VALUES(2031,'Girl''s Just Want To Have Fun',2,NULL,'f','2008-03-12 12:24:28');
INSERT INTO CHANSON VALUES(2032,'When You Were Mine',2,NULL,'f','2008-03-12 13:50:10');
INSERT INTO CHANSON VALUES(2033,'Time After Time',2,NULL,NULL,'2008-03-12 18:03:28');
INSERT INTO CHANSON VALUES(2034,'She Bop',2,NULL,NULL,'2008-03-12 11:43:51');
INSERT INTO CHANSON VALUES(2035,'All Through The Night',2,NULL,'f','2008-03-12 17:00:48');
INSERT INTO CHANSON VALUES(2036,'Witness',2,NULL,'f','2008-03-12 12:09:35');
INSERT INTO CHANSON VALUES(2037,'I''ll Kiss You',2,NULL,'f','2008-03-12 17:58:07');
INSERT INTO CHANSON VALUES(2038,'He''s So Unusual',2,NULL,'f','2008-03-12 18:28:10');
INSERT INTO CHANSON VALUES(2039,'Yeah Yeah',2,NULL,'f','2008-03-12 09:54:06');
INSERT INTO CHANSON VALUES(2040,'Till Victory',2,NULL,'f','2008-03-12 09:44:02');
INSERT INTO CHANSON VALUES(2041,'Space Monkey',2,NULL,NULL,'2008-03-12 10:04:26');
INSERT INTO CHANSON VALUES(2042,'Because The Night',2,NULL,'f','2008-03-19 16:29:17');
INSERT INTO CHANSON VALUES(2043,'Ghost Dance',2,NULL,'f','2008-04-05 15:52:02');
INSERT INTO CHANSON VALUES(2044,'Babelogue',2,NULL,NULL,'2008-03-12 18:22:20');
INSERT INTO CHANSON VALUES(2045,'Rock''n''Roll Nigger',2,NULL,'f','2008-03-12 12:37:04');
INSERT INTO CHANSON VALUES(2046,'Privilige (Set Me Free)',2,NULL,'f','2008-03-12 10:24:04');
INSERT INTO CHANSON VALUES(2047,'We Three',2,NULL,'f','2008-03-12 08:47:14');
INSERT INTO CHANSON VALUES(2048,'25th Floor',2,NULL,'f','2008-03-12 15:36:13');
INSERT INTO CHANSON VALUES(2049,'High On Rebellion',2,NULL,'f','2008-03-12 16:26:41');
INSERT INTO CHANSON VALUES(2050,'Easter',2,NULL,'f','2008-04-11 13:26:55');
INSERT INTO CHANSON VALUES(2051,'Godspeed',2,NULL,'f','2008-03-12 18:32:36');
INSERT INTO CHANSON VALUES(2052,'Egg Cream',2,NULL,'f','2008-03-12 08:37:20');
INSERT INTO CHANSON VALUES(2053,'NYC Man',2,NULL,'f','2008-03-12 08:50:24');
INSERT INTO CHANSON VALUES(2054,'Finish Line',2,NULL,'f','2008-04-24 13:37:27');
INSERT INTO CHANSON VALUES(2055,'Trade In',2,NULL,'f','2008-04-24 14:25:03');
INSERT INTO CHANSON VALUES(2056,'Hang On to Your Emotions',2,NULL,'f','2008-03-12 14:32:53');
INSERT INTO CHANSON VALUES(2057,'Sex with Your Parents (Motherfucker) Part II',2,NULL,'f','2008-03-12 17:24:15');
INSERT INTO CHANSON VALUES(2058,'Hooky Wooky',2,NULL,'f','2008-03-12 09:44:53');
INSERT INTO CHANSON VALUES(2059,'The Proposition',2,NULL,'f','2008-03-12 10:57:17');
INSERT INTO CHANSON VALUES(2060,'Adventurer',2,NULL,'f','2008-04-11 19:26:09');
INSERT INTO CHANSON VALUES(2061,'Riptide',2,NULL,'f','2008-03-12 11:58:05');
INSERT INTO CHANSON VALUES(2062,'Set the Twilight Reeling',2,NULL,'f','2008-03-12 14:35:41');
INSERT INTO CHANSON VALUES(2063,'Waiting Underground',2,NULL,NULL,'2008-03-12 16:19:08');
INSERT INTO CHANSON VALUES(2064,'Whirl Away',2,NULL,NULL,'2008-03-12 13:13:40');
INSERT INTO CHANSON VALUES(2065,'1959',2,NULL,'f','2008-03-12 08:15:18');
INSERT INTO CHANSON VALUES(2066,'Spell',2,NULL,'f','2008-03-12 12:19:08');
INSERT INTO CHANSON VALUES(2067,'Don''T Say Nothing',2,NULL,NULL,'2008-03-12 17:49:40');
INSERT INTO CHANSON VALUES(2068,'Dead City',2,NULL,'f','2008-03-12 16:37:05');
INSERT INTO CHANSON VALUES(2069,'Blue Poles',2,NULL,'f','2008-03-12 19:45:49');
INSERT INTO CHANSON VALUES(2070,'Death Singing',2,NULL,'f','2008-04-24 18:11:22');
INSERT INTO CHANSON VALUES(2071,'Memento Mori',2,NULL,'f','2008-03-12 18:56:47');
INSERT INTO CHANSON VALUES(2072,'Last Call',2,NULL,'f','2008-03-12 09:13:45');
INSERT INTO CHANSON VALUES(2073,'Fly On The Wall',2,NULL,'f','2008-03-12 10:44:20');
INSERT INTO CHANSON VALUES(2074,'Shake Your Foundations',2,NULL,'f','2008-03-16 19:28:39');
INSERT INTO CHANSON VALUES(2075,'First Blood',2,NULL,'f','2008-03-12 08:54:53');
INSERT INTO CHANSON VALUES(2076,'Danger',2,NULL,'f','2008-03-12 16:56:08');
INSERT INTO CHANSON VALUES(2077,'Sink The Pink',2,NULL,'f','2008-04-13 15:17:26');
INSERT INTO CHANSON VALUES(2078,'Playing With Girls',2,NULL,'f','2008-03-12 08:18:27');
INSERT INTO CHANSON VALUES(2079,'Stand Up',2,NULL,'f','2008-03-12 10:05:17');
INSERT INTO CHANSON VALUES(2080,'Hell Or High Water',2,NULL,'f','2008-03-12 18:45:54');
INSERT INTO CHANSON VALUES(2081,'Back In Business',2,NULL,NULL,'2008-03-12 19:42:39');
INSERT INTO CHANSON VALUES(2082,'Send For The Man',2,NULL,'f','2008-03-12 17:32:36');
INSERT INTO CHANSON VALUES(2083,'Rock In Chair',2,NULL,'f','2008-03-12 14:40:50');
INSERT INTO CHANSON VALUES(2084,'O fais moi l''amour',2,NULL,'f','2008-03-12 11:54:34');
INSERT INTO CHANSON VALUES(2085,'Mon portrait dans la glace',2,NULL,'f','2008-03-12 16:49:03');
INSERT INTO CHANSON VALUES(2086,'Un oeil sur la bagarre',2,NULL,'f','2008-03-12 11:53:58');
INSERT INTO CHANSON VALUES(2087,'Irradie',2,NULL,'f','2008-03-12 10:37:54');
INSERT INTO CHANSON VALUES(2088,'L''ange et le salaud',2,NULL,'f','2008-03-12 12:39:13');
INSERT INTO CHANSON VALUES(2089,'La fille au cur d''acier',2,NULL,'f','2008-03-24 18:49:18');
INSERT INTO CHANSON VALUES(2090,'L''hymne aux paumes',2,NULL,'f','2008-03-12 09:40:04');
INSERT INTO CHANSON VALUES(2091,'Le courage de vivre',2,NULL,'f','2008-03-12 08:37:46');
INSERT INTO CHANSON VALUES(2092,'Ballade pour un matin',2,NULL,'f','2008-03-12 16:23:19');
INSERT INTO CHANSON VALUES(2093,'Baba O''Riley',2,NULL,'f','2008-03-12 11:56:00');
INSERT INTO CHANSON VALUES(2094,'Bargain',2,NULL,NULL,'2008-03-12 09:15:54');
INSERT INTO CHANSON VALUES(2095,'Love Ain''t For Keepin''',2,NULL,NULL,'2008-03-12 16:55:44');
INSERT INTO CHANSON VALUES(2096,'My Wife',2,NULL,'f','2008-03-12 17:15:38');
INSERT INTO CHANSON VALUES(2097,'The Song Is Over',2,NULL,'f','2008-03-12 16:29:15');
INSERT INTO CHANSON VALUES(2098,'Gettin'' In Tune',2,NULL,'f','2008-05-22 11:24:50');
INSERT INTO CHANSON VALUES(2099,'Goin'' Mobile',2,NULL,'f','2008-03-12 15:51:54');
INSERT INTO CHANSON VALUES(2100,'Behind Blue Eyes',2,NULL,'f','2008-03-12 18:42:44');
INSERT INTO CHANSON VALUES(2101,'Won''t Get Fooled Again',2,NULL,'f','2008-04-18 08:34:27');
INSERT INTO CHANSON VALUES(2102,'Champagne',2,NULL,'f','2008-03-12 10:49:25');
INSERT INTO CHANSON VALUES(2103,'Cayenne c''est fini',2,NULL,'f','2008-03-12 11:51:02');
INSERT INTO CHANSON VALUES(2104,'Tête en l''air',2,NULL,'f','2008-04-13 16:22:52');
INSERT INTO CHANSON VALUES(2105,'Dans mon aéroplane blindé',2,NULL,'f','2008-03-28 08:33:25');
INSERT INTO CHANSON VALUES(2106,'Ah la la quelle vie qu''cette vie',2,NULL,'f','2008-03-12 12:50:22');
INSERT INTO CHANSON VALUES(2107,'L''attentat la pudeur',2,NULL,'f','2008-03-12 12:58:38');
INSERT INTO CHANSON VALUES(2108,'Hold tight (sea food)',2,NULL,'f','2008-03-12 11:41:34');
INSERT INTO CHANSON VALUES(2109,'Captain bloody samura',2,NULL,'f','2008-03-12 08:28:50');
INSERT INTO CHANSON VALUES(2110,'Vague l''ame',2,NULL,NULL,'2008-03-12 15:13:19');
INSERT INTO CHANSON VALUES(2111,'Banlieue Boogie Blues',2,NULL,'f','2008-03-23 18:52:11');
INSERT INTO CHANSON VALUES(2112,'Pars',2,NULL,'f','2008-03-12 17:45:53');
INSERT INTO CHANSON VALUES(2113,'Denise',2,NULL,'f','2008-03-12 14:57:43');
INSERT INTO CHANSON VALUES(2114,'Un Aviateur dans l''Ascenseur',2,NULL,'f','2008-03-12 19:12:35');
INSERT INTO CHANSON VALUES(2115,'Lettre à la Petite Amie de l''Ennemi Public No 1',2,NULL,'f','2008-03-12 08:14:08');
INSERT INTO CHANSON VALUES(2116,'L... Comme Beauté',2,NULL,'f','2008-03-12 13:36:59');
INSERT INTO CHANSON VALUES(2117,'Les Robots',2,NULL,'f','2008-03-12 17:57:58');
INSERT INTO CHANSON VALUES(2118,'L''Amour sans Savoir ce que c''est',2,NULL,'f','2008-03-12 13:14:39');
INSERT INTO CHANSON VALUES(2119,'Les Histoires d''A',2,NULL,'f','2008-03-23 08:15:08');
INSERT INTO CHANSON VALUES(2120,'Andy',2,NULL,'f','2008-05-22 08:57:25');
INSERT INTO CHANSON VALUES(2121,'C''est comme ça',2,NULL,'f','2008-03-19 18:55:21');
INSERT INTO CHANSON VALUES(2122,'Vol de nuit',2,NULL,'f','2008-03-12 10:50:14');
INSERT INTO CHANSON VALUES(2123,'Someone to love',2,NULL,NULL,'2008-05-22 17:43:10');
INSERT INTO CHANSON VALUES(2124,'Stupid anyway',2,NULL,NULL,'2008-04-18 15:43:35');
INSERT INTO CHANSON VALUES(2125,'Un soir de chien',2,NULL,'f','2008-03-12 12:39:00');
INSERT INTO CHANSON VALUES(2126,'Bad days',2,NULL,'f','2008-03-12 11:12:57');
INSERT INTO CHANSON VALUES(2127,'Tonite',2,NULL,'f','2008-03-12 08:11:09');
INSERT INTO CHANSON VALUES(2128,'Nuit d''ivresse',2,NULL,'f','2008-03-12 15:11:24');
INSERT INTO CHANSON VALUES(2129,'Andy (english version)',2,NULL,'f','2008-03-12 16:38:00');
INSERT INTO CHANSON VALUES(2130,'The Perceptions Of Johnny Punter',2,NULL,'f','2008-03-12 16:27:58');
INSERT INTO CHANSON VALUES(2131,'Goldfish & Clowns',2,NULL,'f','2008-03-12 16:55:13');
INSERT INTO CHANSON VALUES(2132,'Change Of Heart',2,NULL,'f','2008-03-12 12:56:28');
INSERT INTO CHANSON VALUES(2133,'What Colour Is God?',2,NULL,'f','2008-03-12 13:48:24');
INSERT INTO CHANSON VALUES(2134,'Tara',2,NULL,NULL,'2008-03-12 18:00:14');
INSERT INTO CHANSON VALUES(2135,'Jungle Ride',2,NULL,'f','2008-03-12 09:24:53');
INSERT INTO CHANSON VALUES(2136,'Worm In A Bottle',2,NULL,'f','2008-03-12 09:41:06');
INSERT INTO CHANSON VALUES(2137,'Brother 52',2,NULL,'f','2008-03-12 08:41:17');
INSERT INTO CHANSON VALUES(2138,'Sunsets On Empire',2,NULL,'f','2008-03-12 10:17:29');
INSERT INTO CHANSON VALUES(2139,'Say It With Flowers',2,NULL,'f','2008-03-12 15:00:07');
INSERT INTO CHANSON VALUES(2140,'Is It a Crime',2,NULL,'f','2008-03-23 15:24:30');
INSERT INTO CHANSON VALUES(2141,'The Sweetest Taboo',2,NULL,'f','2008-03-12 18:45:27');
INSERT INTO CHANSON VALUES(2142,'War Of the Hearts',2,NULL,'f','2008-03-12 11:14:16');
INSERT INTO CHANSON VALUES(2143,'You''re Not the Man',2,NULL,'f','2008-03-12 16:05:16');
INSERT INTO CHANSON VALUES(2144,'Jezebel',2,NULL,'f','2008-03-12 19:10:40');
INSERT INTO CHANSON VALUES(2145,'Mr. Wrong',2,NULL,'f','2008-03-12 18:15:22');
INSERT INTO CHANSON VALUES(2146,'Punch Drunk',2,NULL,'f','2008-03-12 19:18:03');
INSERT INTO CHANSON VALUES(2147,'Never As Good As the First Time',2,NULL,'f','2008-03-12 11:31:20');
INSERT INTO CHANSON VALUES(2148,'Fear',2,NULL,'f','2008-04-24 13:28:35');
INSERT INTO CHANSON VALUES(2149,'Tar Baby',2,NULL,'f','2008-03-12 16:08:21');
INSERT INTO CHANSON VALUES(2150,'Maureen',2,NULL,'f','2008-03-12 18:47:05');
INSERT INTO CHANSON VALUES(2151,'Dancin Alone',2,NULL,'f','2008-03-12 13:24:30');
INSERT INTO CHANSON VALUES(2152,'Baby Jane',2,NULL,'f','2008-03-12 19:14:16');
INSERT INTO CHANSON VALUES(2153,'Move Me',2,NULL,NULL,'2008-03-12 13:34:30');
INSERT INTO CHANSON VALUES(2154,'Body Wishes',2,NULL,NULL,'2008-03-12 16:17:36');
INSERT INTO CHANSON VALUES(2155,'Sweet Surrender',2,NULL,'f','2008-03-12 19:15:46');
INSERT INTO CHANSON VALUES(2156,'What Am I Gonna Do',2,NULL,'f','2008-03-12 15:07:02');
INSERT INTO CHANSON VALUES(2157,'Ghetto Blaster',2,NULL,NULL,'2008-03-12 08:05:20');
INSERT INTO CHANSON VALUES(2158,'Ready Now',2,NULL,'f','2008-03-12 08:20:51');
INSERT INTO CHANSON VALUES(2159,'Strangers Again',2,NULL,'f','2008-03-12 13:04:00');
INSERT INTO CHANSON VALUES(2160,'Satisfied',2,NULL,NULL,'2008-03-12 17:56:47');
INSERT INTO CHANSON VALUES(2161,'Anna',2,NULL,'f','2008-03-12 18:24:11');
INSERT INTO CHANSON VALUES(2162,'Sur la route',2,NULL,'f','2008-03-24 14:35:31');
INSERT INTO CHANSON VALUES(2163,'Dans ton lit',2,NULL,'f','2008-03-12 12:22:26');
INSERT INTO CHANSON VALUES(2164,'La vaudou',2,NULL,'f','2008-03-12 16:47:00');
INSERT INTO CHANSON VALUES(2165,'Telephomme',2,NULL,'f','2008-03-12 10:28:18');
INSERT INTO CHANSON VALUES(2166,'Hygiaphone',2,NULL,'f','2008-03-12 17:26:34');
INSERT INTO CHANSON VALUES(2167,'Metro (c''est trop)',2,NULL,'f','2008-03-12 14:05:42');
INSERT INTO CHANSON VALUES(2168,'Prends ce que tu veux',2,NULL,'f','2008-03-12 15:06:47');
INSERT INTO CHANSON VALUES(2169,'Flipper',2,NULL,'f','2008-03-12 19:11:07');
INSERT INTO CHANSON VALUES(2170,'Fantastic voyage',2,NULL,'f','2008-06-07 15:17:15.282979');
INSERT INTO CHANSON VALUES(2171,'African night flight',2,NULL,'f','2008-06-07 15:17:35.819325');
INSERT INTO CHANSON VALUES(2172,'Move on',2,NULL,'f','2008-06-07 15:17:51.665785');
INSERT INTO CHANSON VALUES(2173,'Yassassin',2,NULL,'f','2008-04-07 14:28:59');
INSERT INTO CHANSON VALUES(2174,'Red sails',2,NULL,'f','2008-06-07 15:18:57.262302');
INSERT INTO CHANSON VALUES(2175,'D.J.',2,NULL,'f','2008-06-07 12:34:06.657115');
INSERT INTO CHANSON VALUES(2176,'Look back in anger',2,NULL,'f','2008-06-07 12:34:40.440019');
INSERT INTO CHANSON VALUES(2177,'Boys keep swinging',2,NULL,'f','2008-06-07 12:35:00.394766');
INSERT INTO CHANSON VALUES(2178,'Repetition',2,NULL,'f','2008-06-07 12:35:27.491735');
INSERT INTO CHANSON VALUES(2179,'Red money',2,NULL,NULL,'2008-06-07 12:35:44.479703');
INSERT INTO CHANSON VALUES(2180,'Love Is A Stranger',2,NULL,'f','2008-03-12 15:27:02');
INSERT INTO CHANSON VALUES(2181,'Sweet Dreams',2,NULL,'f','2008-04-15 08:18:00');
INSERT INTO CHANSON VALUES(2182,'Who''s That Girl',2,NULL,'f','2008-03-12 17:15:40');
INSERT INTO CHANSON VALUES(2183,'Right By Your Side',2,NULL,NULL,'2008-03-12 19:03:05');
INSERT INTO CHANSON VALUES(2184,'Here Comes The Rain Again',2,NULL,NULL,'2008-04-07 17:59:24');
INSERT INTO CHANSON VALUES(2185,'There Must Be An Angel (Playing With My Heart)',2,NULL,'f','2008-03-12 09:39:25');
INSERT INTO CHANSON VALUES(2186,'Sisters Are Doin'' It For Themselves',2,NULL,'f','2008-03-12 16:26:08');
INSERT INTO CHANSON VALUES(2187,'It''s Alright (Baby''s Coming Back)',2,NULL,'f','2008-03-12 15:39:31');
INSERT INTO CHANSON VALUES(2188,'When Tomorrow Comes',2,NULL,'f','2008-03-12 12:53:06');
INSERT INTO CHANSON VALUES(2189,'Let''s Stick Together',2,NULL,'f','2008-03-12 14:27:29');
INSERT INTO CHANSON VALUES(2190,'Casanova',2,NULL,'f','2008-03-12 09:35:24');
INSERT INTO CHANSON VALUES(2191,'Sea Breezes',2,NULL,'f','2008-03-12 18:25:56');
INSERT INTO CHANSON VALUES(2192,'Shame, Shame, Shame',2,NULL,'f','2008-04-05 09:02:15');
INSERT INTO CHANSON VALUES(2193,'2 HB',2,NULL,'f','2008-03-12 16:03:24');
INSERT INTO CHANSON VALUES(2194,'The Price Of Love',2,NULL,'f','2008-03-12 17:49:40');
INSERT INTO CHANSON VALUES(2195,'Chance Meeting',2,NULL,'f','2008-05-22 13:05:23');
INSERT INTO CHANSON VALUES(2196,'It''s Only Love',2,NULL,NULL,'2008-03-12 13:47:43');
INSERT INTO CHANSON VALUES(2197,'You Go To My Head',2,NULL,'f','2008-03-12 14:54:22');
INSERT INTO CHANSON VALUES(2198,'Re-Make/Re-Model',2,NULL,'f','2008-03-12 19:35:49');
INSERT INTO CHANSON VALUES(2199,'Heart On My Sleeve',2,NULL,'f','2008-03-12 09:12:28');
INSERT INTO CHANSON VALUES(2201,'Sway',2,NULL,'f','2008-06-02 09:31:08.114764');
INSERT INTO CHANSON VALUES(2202,'Wild Horses',2,NULL,'f','2008-04-15 16:41:08');
INSERT INTO CHANSON VALUES(2203,'Can''t You Hear Me Knocking',2,NULL,'f','2008-03-27 16:03:49');
INSERT INTO CHANSON VALUES(2204,'You Gotta Move',2,NULL,'f','2008-06-02 09:41:28.604634');
INSERT INTO CHANSON VALUES(2205,'Bitch',2,NULL,'f','2008-04-12 18:06:46');
INSERT INTO CHANSON VALUES(2206,'I Got The Blues',2,NULL,NULL,'2008-06-02 09:42:38.569888');
INSERT INTO CHANSON VALUES(2207,'Sister Morphine',2,NULL,'f','2008-04-24 13:53:52');
INSERT INTO CHANSON VALUES(2208,'Dead Flowers',2,NULL,'f','2008-06-02 09:43:12.153791');
INSERT INTO CHANSON VALUES(2209,'Moonlight Mile',2,NULL,'f','2008-06-02 09:43:44.458639');
INSERT INTO CHANSON VALUES(2210,'Lust For Life',2,NULL,'f','2008-06-07 15:19:50.890408');
INSERT INTO CHANSON VALUES(2211,'Sixteen',2,NULL,'f','2008-08-13 07:43:07.621532');
INSERT INTO CHANSON VALUES(2212,'Some Weird Sin',2,NULL,'f','2008-08-13 07:43:26.329338');
INSERT INTO CHANSON VALUES(2213,'The Passenger',2,NULL,'f','2008-06-07 18:56:46.533461');
INSERT INTO CHANSON VALUES(2214,'Tonight',2,NULL,'f','2008-06-07 18:05:15.371292');
INSERT INTO CHANSON VALUES(2215,'Success',2,NULL,'f','2008-08-13 07:43:45.087051');
INSERT INTO CHANSON VALUES(2216,'Turn Blue',2,NULL,'f','2008-06-07 18:43:37.195371');
INSERT INTO CHANSON VALUES(2217,'Neighborhood Threat',2,NULL,'f','2008-06-07 15:43:53.337569');
INSERT INTO CHANSON VALUES(2218,'Fall In Love With Me',2,NULL,'f','2008-04-24 11:41:33');
INSERT INTO CHANSON VALUES(2219,'Dure Limite',2,NULL,'f','2008-03-23 18:33:52');
INSERT INTO CHANSON VALUES(2220,'Ça (c''est vraiment toi)',2,NULL,'f','2008-03-12 09:07:38');
INSERT INTO CHANSON VALUES(2221,'Jour contre jour',2,NULL,'f','2008-03-20 13:37:01');
INSERT INTO CHANSON VALUES(2222,'ex-Robin des Bois',2,NULL,'f','2008-03-12 15:31:14');
INSERT INTO CHANSON VALUES(2223,'Le Chat',2,NULL,'f','2008-03-12 08:17:47');
INSERT INTO CHANSON VALUES(2224,'Serrez',2,NULL,'f','2008-03-12 09:52:26');
INSERT INTO CHANSON VALUES(2225,'Le Temps',2,NULL,'f','2008-03-12 11:56:43');
INSERT INTO CHANSON VALUES(2226,'Cendrillon',2,NULL,'f','2008-03-23 08:23:44');
INSERT INTO CHANSON VALUES(2227,'Juste un autre genre',2,NULL,'f','2008-03-12 18:39:00');
INSERT INTO CHANSON VALUES(2228,'Ce soir est ce soir',2,NULL,'f','2008-03-26 18:20:53');
INSERT INTO CHANSON VALUES(2229,'Sleeping bag',2,NULL,NULL,'2008-03-12 08:52:22');
INSERT INTO CHANSON VALUES(2230,'Stages',2,NULL,'f','2008-03-12 08:19:51');
INSERT INTO CHANSON VALUES(2231,'Woke up with wood',2,NULL,'f','2008-03-12 15:28:58');
INSERT INTO CHANSON VALUES(2232,'Rough boy',2,NULL,'f','2008-03-12 11:08:30');
INSERT INTO CHANSON VALUES(2233,'Can''t stop rockin''',2,NULL,NULL,'2008-03-12 14:13:47');
INSERT INTO CHANSON VALUES(2234,'Planet of women',2,NULL,NULL,'2008-03-12 11:18:40');
INSERT INTO CHANSON VALUES(2235,'I got the message',2,NULL,'f','2008-03-12 17:36:37');
INSERT INTO CHANSON VALUES(2236,'Velcro fly',2,NULL,'f','2008-03-12 13:39:00');
INSERT INTO CHANSON VALUES(2237,'Dipping low (in the lap of luxury)',2,NULL,NULL,'2008-03-12 10:31:39');
INSERT INTO CHANSON VALUES(2238,'Delirious',2,NULL,'f','2008-03-12 10:26:00');
INSERT INTO CHANSON VALUES(2239,'Le berceau de la vie',2,NULL,'f','2008-03-24 11:14:29');
INSERT INTO CHANSON VALUES(2240,'Électrocardiogramme plat',2,NULL,'f','2008-03-12 09:30:53');
INSERT INTO CHANSON VALUES(2241,'Sur la grande roue',2,NULL,'f','2008-03-12 14:33:12');
INSERT INTO CHANSON VALUES(2242,'Hot chaud',2,NULL,'f','2008-03-12 12:12:41');
INSERT INTO CHANSON VALUES(2243,'Le dragon, le tigre et la Geisha',2,NULL,'f','2008-03-12 12:30:50');
INSERT INTO CHANSON VALUES(2244,'Trou noir',2,NULL,'f','2008-03-12 18:02:04');
INSERT INTO CHANSON VALUES(2245,'Adolescent',2,NULL,'f','2008-03-23 09:24:32');
INSERT INTO CHANSON VALUES(2246,'Le naïf haïtien',2,NULL,'f','2008-03-12 15:22:22');
INSERT INTO CHANSON VALUES(2247,'Aux héros de la voltige',2,NULL,'f','2008-03-12 11:08:59');
INSERT INTO CHANSON VALUES(2248,'Little Wonder',2,NULL,'f','2008-06-07 18:26:55.39376');
INSERT INTO CHANSON VALUES(2249,'Looking For Satellites',2,NULL,'f','2008-06-07 18:27:32.425268');
INSERT INTO CHANSON VALUES(2250,'Battle For Britain (The Letter)',2,NULL,'f','2008-03-19 15:07:36');
INSERT INTO CHANSON VALUES(2251,'Seven Years In Tibet',2,NULL,'f','2008-04-05 17:04:14');
INSERT INTO CHANSON VALUES(2252,'Dead Man Walking',2,NULL,'f','2008-06-07 18:28:53.26317');
INSERT INTO CHANSON VALUES(2253,'Telling Lies',2,NULL,'f','2008-06-07 18:29:09.506283');
INSERT INTO CHANSON VALUES(2254,'The Last Thing You Should Do',2,NULL,'f','2008-06-07 18:08:27.293703');
INSERT INTO CHANSON VALUES(2255,'I''m Afraid Of Americans',2,NULL,'f','2008-04-24 19:44:42');
INSERT INTO CHANSON VALUES(2256,'Law (Earthling On Fire)',2,NULL,'f','2008-06-07 18:09:21.317187');
INSERT INTO CHANSON VALUES(2257,'If You Can''t Rock Me',2,NULL,'f','2008-04-11 11:43:19');
INSERT INTO CHANSON VALUES(2258,'Ain''t To Proud To Beg',2,NULL,NULL,'2008-06-02 09:51:34.805292');
INSERT INTO CHANSON VALUES(2260,'Till The Next Goodbye',2,NULL,'f','2008-06-02 09:52:31.639302');
INSERT INTO CHANSON VALUES(2261,'Time Waits For No One',2,NULL,'f','2008-06-01 17:57:23.550301');
INSERT INTO CHANSON VALUES(2262,'Luxury',2,NULL,'f','2008-04-18 14:07:02');
INSERT INTO CHANSON VALUES(2263,'Dance Little Sister',2,NULL,NULL,'2008-06-01 17:57:59.258895');
INSERT INTO CHANSON VALUES(2264,'If You Really Want To Be My Friend',2,NULL,NULL,'2008-06-01 17:58:15.819467');
INSERT INTO CHANSON VALUES(2265,'Short And Curlies',2,NULL,'f','2008-06-01 17:58:30.686506');
INSERT INTO CHANSON VALUES(2266,'Fingerprint File',2,NULL,'f','2008-05-27 09:26:36.011973');
INSERT INTO CHANSON VALUES(2267,'113e cigarette sans dormir',2,NULL,'f','2008-03-12 10:56:41');
INSERT INTO CHANSON VALUES(2268,'Narcisse 81',2,NULL,'f','2008-03-23 12:15:03');
INSERT INTO CHANSON VALUES(2269,'Mathématiques souterraines',2,NULL,'f','2008-03-12 19:38:51');
INSERT INTO CHANSON VALUES(2270,'Taxiphonant d''un pack de Kro',2,NULL,'f','2008-03-12 17:03:21');
INSERT INTO CHANSON VALUES(2271,'Scènes de panique tranquille',2,NULL,'f','2008-03-12 10:18:43');
INSERT INTO CHANSON VALUES(2272,'Cabaret Sainte-Lilith',2,NULL,'f','2008-03-12 15:37:44');
INSERT INTO CHANSON VALUES(2273,'Photographie tendresse',2,NULL,'f','2008-03-12 13:18:04');
INSERT INTO CHANSON VALUES(2274,'Une fille au rhésus négatif',2,NULL,'f','2008-03-12 12:59:20');
INSERT INTO CHANSON VALUES(2275,'Exil sur planète fantôme',2,NULL,'f','2008-03-12 08:19:32');
INSERT INTO CHANSON VALUES(2276,'Redescente climatisée',2,NULL,'f','2008-03-12 14:50:21');
INSERT INTO CHANSON VALUES(2277,'Les dessous chics',5,NULL,'f','2008-03-12 09:57:47');
INSERT INTO CHANSON VALUES(2278,'Elisa',5,NULL,'f','2008-03-12 08:12:43');
INSERT INTO CHANSON VALUES(2279,'Physique et sans issue',5,NULL,'f','2008-03-12 16:07:22');
INSERT INTO CHANSON VALUES(2280,'L''anamour',5,NULL,'f','2008-03-12 14:55:25');
INSERT INTO CHANSON VALUES(2281,'Amour des feintes',5,NULL,'f','2008-03-12 19:07:44');
INSERT INTO CHANSON VALUES(2282,'Des ils et des elles',5,NULL,'f','2008-03-12 16:45:21');
INSERT INTO CHANSON VALUES(2283,'Quoi',5,NULL,'f','2008-03-12 12:12:40');
INSERT INTO CHANSON VALUES(2284,'La gadoue',5,NULL,NULL,'2008-03-12 13:36:40');
INSERT INTO CHANSON VALUES(2285,'Dépression au dessus du jardin',5,NULL,'f','2008-03-12 17:37:00');
INSERT INTO CHANSON VALUES(2286,'Et quand bien même',5,NULL,'f','2008-03-12 12:08:50');
INSERT INTO CHANSON VALUES(2287,'Comment te dire adieu ?',5,NULL,'f','2008-03-12 14:18:59');
INSERT INTO CHANSON VALUES(2288,'La javanaise',5,NULL,'f','2008-03-12 11:02:06');
INSERT INTO CHANSON VALUES(2289,'Holidays in the sun',2,NULL,'f','2008-03-12 15:36:02');
INSERT INTO CHANSON VALUES(2290,'Bodies',2,NULL,'f','2008-03-12 08:32:09');
INSERT INTO CHANSON VALUES(2291,'No Feelings',2,NULL,NULL,'2008-03-12 17:12:54');
INSERT INTO CHANSON VALUES(2292,'Liar',2,NULL,'f','2008-03-12 09:37:06');
INSERT INTO CHANSON VALUES(2293,'God save the Queen',2,NULL,'f','2008-03-12 17:06:43');
INSERT INTO CHANSON VALUES(2294,'Problems',2,NULL,'f','2008-03-12 13:55:21');
INSERT INTO CHANSON VALUES(2295,'Seventeen',2,NULL,'f','2008-03-12 13:17:29');
INSERT INTO CHANSON VALUES(2296,'Anarchy in the UK',2,NULL,'f','2008-03-27 11:01:46');
INSERT INTO CHANSON VALUES(2297,'Sub-Mission',2,NULL,'f','2008-03-12 09:33:05');
INSERT INTO CHANSON VALUES(2298,'Pretty Vacant',2,NULL,'f','2008-03-12 09:48:07');
INSERT INTO CHANSON VALUES(2299,'New York',2,NULL,'f','2008-03-12 10:25:43');
INSERT INTO CHANSON VALUES(2300,'EMI unlimited edition',2,NULL,'f','2008-03-12 11:29:16');
INSERT INTO CHANSON VALUES(2301,'Procession',2,NULL,'f','2008-03-12 13:16:29');
INSERT INTO CHANSON VALUES(2302,'Father To Son',2,NULL,'f','2008-03-12 12:25:06');
INSERT INTO CHANSON VALUES(2303,'White Queen (As It Began)',2,NULL,'f','2008-03-12 13:14:12');
INSERT INTO CHANSON VALUES(2304,'Some Day One Day',2,NULL,'f','2008-03-12 10:43:08');
INSERT INTO CHANSON VALUES(2305,'The Loser In The End',2,NULL,NULL,'2008-03-12 14:12:25');
INSERT INTO CHANSON VALUES(2306,'Ogre Battle',2,NULL,NULL,'2008-03-12 08:32:27');
INSERT INTO CHANSON VALUES(2307,'The Fairy Feller''s Master-Stroke',2,NULL,'f','2008-03-12 17:39:00');
INSERT INTO CHANSON VALUES(2308,'Nevermore',2,NULL,'f','2008-04-24 15:27:10');
INSERT INTO CHANSON VALUES(2309,'The March Of The Black Queen',2,NULL,NULL,'2008-03-12 18:46:48');
INSERT INTO CHANSON VALUES(2310,'Funny How Love Is',2,NULL,'f','2008-03-12 08:00:14');
INSERT INTO CHANSON VALUES(2311,'Seven Seas Of Rhye',2,NULL,'f','2008-03-12 16:16:43');
INSERT INTO CHANSON VALUES(2312,'Heatseeker',2,NULL,'f','2008-04-24 17:20:55');
INSERT INTO CHANSON VALUES(2314,'Meanstreak',2,NULL,'f','2008-03-12 14:03:26');
INSERT INTO CHANSON VALUES(2315,'Go Zone',2,NULL,'f','2008-03-12 15:31:40');
INSERT INTO CHANSON VALUES(2316,'Kissin'' Dynamite',2,NULL,'f','2008-04-09 15:00:42');
INSERT INTO CHANSON VALUES(2317,'Nick Of Time',2,NULL,'f','2008-03-12 17:42:24');
INSERT INTO CHANSON VALUES(2318,'Some Sin For Nuthin''',2,NULL,'f','2008-03-12 19:15:36');
INSERT INTO CHANSON VALUES(2319,'Ruff Stuff',2,NULL,'f','2008-03-12 12:18:08');
INSERT INTO CHANSON VALUES(2320,'Two''s Up',2,NULL,'f','2008-03-12 18:07:48');
INSERT INTO CHANSON VALUES(2321,'This Means War',2,NULL,'f','2008-03-12 18:00:34');
INSERT INTO CHANSON VALUES(2322,'Nobody''s Wife',2,NULL,'f','2008-03-12 16:02:34');
INSERT INTO CHANSON VALUES(2323,'Together Alone',2,NULL,'f','2008-03-12 19:47:50');
INSERT INTO CHANSON VALUES(2324,'It''s So Hard',2,NULL,'f','2008-03-12 15:48:33');
INSERT INTO CHANSON VALUES(2325,'The Other Side Of Me',2,NULL,'f','2008-03-12 16:18:36');
INSERT INTO CHANSON VALUES(2326,'Pictures On Your Skin',2,NULL,'f','2008-03-12 09:55:07');
INSERT INTO CHANSON VALUES(2327,'Sacrifice',2,NULL,'f','2008-03-12 17:44:50');
INSERT INTO CHANSON VALUES(2328,'Fluid Conduction',2,NULL,'f','2008-03-12 10:42:06');
INSERT INTO CHANSON VALUES(2329,'My Life',2,NULL,'f','2008-03-12 17:05:24');
INSERT INTO CHANSON VALUES(2330,'It''s A Shame',2,NULL,'f','2008-03-12 19:56:31');
INSERT INTO CHANSON VALUES(2331,'Time Is A Jailer',2,NULL,NULL,'2008-03-12 16:48:32');
INSERT INTO CHANSON VALUES(2332,'Mood Indigo',2,NULL,'f','2008-04-24 08:20:28');
INSERT INTO CHANSON VALUES(2333,'Bourré Bourré Ratatam',2,NULL,'f','2008-03-12 11:29:35');
INSERT INTO CHANSON VALUES(2334,'Ceux Qui Se Lèvent Tt Le Matin',2,NULL,'f','2008-03-12 18:25:22');
INSERT INTO CHANSON VALUES(2335,'Province - Paris',2,NULL,'f','2008-03-12 16:04:10');
INSERT INTO CHANSON VALUES(2336,'Armez-Vous Les Uns Les Autres',2,NULL,NULL,'2008-03-12 11:44:28');
INSERT INTO CHANSON VALUES(2337,'Caroline',2,NULL,NULL,'2008-03-12 18:50:23');
INSERT INTO CHANSON VALUES(2338,'Hommage Au Doux nectar',2,NULL,'f','2008-03-12 08:37:08');
INSERT INTO CHANSON VALUES(2339,'Quelquefois',2,NULL,'f','2008-03-12 18:48:50');
INSERT INTO CHANSON VALUES(2340,'Super, Ce Matin, J''ai Rencontré Dieu',2,NULL,'f','2008-03-12 19:35:55');
INSERT INTO CHANSON VALUES(2341,'Tout Se Dégrade',2,NULL,'f','2008-03-12 12:31:52');
INSERT INTO CHANSON VALUES(2342,'Fermes Ta Gueule Et Fais-le !',2,NULL,'f','2008-03-12 18:16:41');
INSERT INTO CHANSON VALUES(2343,'Le Ska Du Brouillard',2,NULL,'f','2008-03-12 13:34:11');
INSERT INTO CHANSON VALUES(2344,'The Changeling',2,NULL,'f','2008-03-12 08:27:36');
INSERT INTO CHANSON VALUES(2345,'Love Her Madly',2,NULL,'f','2008-03-12 12:10:41');
INSERT INTO CHANSON VALUES(2346,'Been Down So Long',2,NULL,'f','2008-03-19 15:26:25');
INSERT INTO CHANSON VALUES(2347,'Cars Hiss By My Window',2,NULL,'f','2008-03-12 08:19:16');
INSERT INTO CHANSON VALUES(2348,'L.A. Woman',2,NULL,'f','2008-03-12 13:20:54');
INSERT INTO CHANSON VALUES(2349,'L''America',2,NULL,'f','2008-03-12 15:11:42');
INSERT INTO CHANSON VALUES(2350,'Hyacinth House',2,NULL,'f','2008-03-12 13:09:18');
INSERT INTO CHANSON VALUES(2351,'Crawling King Snake',2,NULL,'f','2008-03-12 12:33:50');
INSERT INTO CHANSON VALUES(2352,'The Wasp (Texas Radio and the Big Beat)',2,NULL,'f','2008-03-12 10:27:06');
INSERT INTO CHANSON VALUES(2353,'Riders On The Storm',2,NULL,'f','2008-03-12 19:55:41');
INSERT INTO CHANSON VALUES(2354,'Intro',5,NULL,NULL,'2008-03-12 09:58:08');
INSERT INTO CHANSON VALUES(2355,'Ces petits riens',5,NULL,'f','2008-03-12 16:23:19');
INSERT INTO CHANSON VALUES(2356,'Di doo dah',5,NULL,'f','2008-03-12 13:58:45');
INSERT INTO CHANSON VALUES(2357,'Fuire le bonheur de peur qu''il ne se sauve',5,NULL,'f','2008-03-12 18:02:05');
INSERT INTO CHANSON VALUES(2358,'Le moi et le je',5,NULL,'f','2008-03-12 09:30:25');
INSERT INTO CHANSON VALUES(2359,'Ex-fan des sixties',5,NULL,'f','2008-03-12 08:06:37');
INSERT INTO CHANSON VALUES(2360,'Baby lou',5,NULL,'f','2008-03-12 16:32:47');
INSERT INTO CHANSON VALUES(2361,'Leur plaisir sans moi',5,NULL,'f','2008-03-12 08:54:20');
INSERT INTO CHANSON VALUES(2362,'Etre ou ne pas naître',5,NULL,'f','2008-03-12 18:08:48');
INSERT INTO CHANSON VALUES(2363,'Ford mustang',5,NULL,'f','2008-03-12 19:05:43');
INSERT INTO CHANSON VALUES(2364,'Baby alone in Babylone',5,NULL,'f','2008-03-12 16:12:42');
INSERT INTO CHANSON VALUES(2365,'Con c''est con ces conséquences',5,NULL,NULL,'2008-03-12 17:56:05');
INSERT INTO CHANSON VALUES(2366,'Une chose entre autres',5,NULL,'f','2008-03-12 09:21:04');
INSERT INTO CHANSON VALUES(2367,'Ballade de Johnny Jane',5,NULL,'f','2008-03-12 18:12:07');
INSERT INTO CHANSON VALUES(2368,'Loving The Alien',2,NULL,'f','2008-06-07 18:04:05.460997');
INSERT INTO CHANSON VALUES(2369,'Don''t Look Down',2,NULL,'f','2008-06-07 18:04:29.276611');
INSERT INTO CHANSON VALUES(2370,'God Only Knows',2,NULL,'f','2008-06-07 18:04:47.238073');
INSERT INTO CHANSON VALUES(2373,'Blue Jean',2,NULL,'f','2008-06-07 15:44:06.618253');
INSERT INTO CHANSON VALUES(2374,'Tumble And Twirl',2,NULL,'f','2008-06-07 15:44:27.19903');
INSERT INTO CHANSON VALUES(2375,'I Keep Forgettin''',2,NULL,'f','2008-06-07 15:44:57.926187');
INSERT INTO CHANSON VALUES(2376,'Dancing With The Big Boys',2,NULL,'f','2008-06-07 15:49:28.162398');
INSERT INTO CHANSON VALUES(2377,'Big Enough',2,NULL,'f','2008-03-12 14:36:06');
INSERT INTO CHANSON VALUES(2378,'Take It So Hard',2,NULL,'f','2008-03-17 16:35:26');
INSERT INTO CHANSON VALUES(2379,'Struggle',2,NULL,'f','2008-03-12 11:00:48');
INSERT INTO CHANSON VALUES(2380,'I Could Have Stood You Up',2,NULL,'f','2008-03-22 08:02:55');
INSERT INTO CHANSON VALUES(2381,'Make No Mistake',2,NULL,'f','2008-03-12 11:51:06');
INSERT INTO CHANSON VALUES(2382,'You Don''t Move Me',2,NULL,'f','2008-03-12 13:00:09');
INSERT INTO CHANSON VALUES(2383,'How I Wish',2,NULL,'f','2008-03-12 17:57:13');
INSERT INTO CHANSON VALUES(2384,'Rockawhile',2,NULL,'f','2008-03-12 10:38:57');
INSERT INTO CHANSON VALUES(2385,'Whip It Up',2,NULL,'f','2008-06-05 16:13:50.033397');
INSERT INTO CHANSON VALUES(2386,'Locked Away',2,NULL,'f','2008-03-12 12:30:13');
INSERT INTO CHANSON VALUES(2387,'It Means A Lot',2,NULL,'f','2008-03-12 10:04:50');
INSERT INTO CHANSON VALUES(2388,'Strange Days',2,NULL,'f','2008-03-12 12:45:26');
INSERT INTO CHANSON VALUES(2389,'You''re Lost Little Girl',2,NULL,'f','2008-03-12 17:03:26');
INSERT INTO CHANSON VALUES(2390,'Love Me Two Times',2,NULL,'f','2008-03-12 15:05:29');
INSERT INTO CHANSON VALUES(2391,'Unhappy Girl',2,NULL,'f','2008-03-12 14:23:20');
INSERT INTO CHANSON VALUES(2392,'Horse Latitudes',2,NULL,'f','2008-03-12 15:51:20');
INSERT INTO CHANSON VALUES(2393,'Moonlight Drive',2,NULL,'f','2008-03-12 17:38:17');
INSERT INTO CHANSON VALUES(2394,'People Are Strange',2,NULL,'f','2008-03-12 08:50:56');
INSERT INTO CHANSON VALUES(2395,'My Eyes Have Seen You',2,NULL,'f','2008-05-22 12:04:44');
INSERT INTO CHANSON VALUES(2396,'I Can''t See Your Face In My Mind',2,NULL,'f','2008-03-12 19:38:57');
INSERT INTO CHANSON VALUES(2397,'When The Music''s Over',2,NULL,NULL,'2008-03-12 14:58:28');
INSERT INTO CHANSON VALUES(2398,'Freedom',2,NULL,'f','2008-03-12 16:13:33');
INSERT INTO CHANSON VALUES(2399,'Lock Me Up',2,NULL,'f','2008-03-12 14:35:19');
INSERT INTO CHANSON VALUES(2400,'Gave the Radio Back',2,NULL,'f','2008-03-12 08:22:23');
INSERT INTO CHANSON VALUES(2401,'Step on You',2,NULL,'f','2008-03-12 13:59:28');
INSERT INTO CHANSON VALUES(2402,'Not that Kind of Love',2,NULL,'f','2008-03-12 19:31:52');
INSERT INTO CHANSON VALUES(2403,'Prince of Darkness',2,NULL,'f','2008-03-12 11:10:43');
INSERT INTO CHANSON VALUES(2404,'Time to Kill',2,NULL,'f','2008-03-12 15:59:22');
INSERT INTO CHANSON VALUES(2405,'Chop, Chop, Chop',2,NULL,'f','2008-04-14 08:52:32');
INSERT INTO CHANSON VALUES(2406,'Gail',2,NULL,'f','2008-03-12 19:00:12');
INSERT INTO CHANSON VALUES(2407,'Roses on White Lace',2,NULL,'f','2008-04-14 11:54:46');
INSERT INTO CHANSON VALUES(2408,'Babooshka',2,NULL,'f','2008-03-12 18:00:50');
INSERT INTO CHANSON VALUES(2409,'Delius (Song Of Summer)',2,NULL,NULL,'2008-03-12 18:31:49');
INSERT INTO CHANSON VALUES(2410,'Blow Away (For Bill)',2,NULL,'f','2008-03-19 11:15:03');
INSERT INTO CHANSON VALUES(2411,'All We Ever Look For',2,NULL,'f','2008-03-27 18:50:38');
INSERT INTO CHANSON VALUES(2412,'Egypt',2,NULL,'f','2008-03-12 10:51:01');
INSERT INTO CHANSON VALUES(2413,'The Wedding List',2,NULL,NULL,'2008-03-12 15:19:00');
INSERT INTO CHANSON VALUES(2414,'Violin',2,NULL,NULL,'2008-03-12 08:17:32');
INSERT INTO CHANSON VALUES(2415,'The Infant Kiss',2,NULL,'f','2008-03-12 19:34:42');
INSERT INTO CHANSON VALUES(2416,'Night Scented Stock',2,NULL,'f','2008-03-12 16:13:41');
INSERT INTO CHANSON VALUES(2417,'Army Dreamers',2,NULL,'f','2008-03-12 08:09:42');
INSERT INTO CHANSON VALUES(2418,'Breathing',2,NULL,'f','2008-03-12 11:02:43');
INSERT INTO CHANSON VALUES(2419,'Tease Me Please Me',2,NULL,'f','2008-03-12 09:52:14');
INSERT INTO CHANSON VALUES(2420,'Don''t Believe Her',2,NULL,'f','2008-03-12 19:12:30');
INSERT INTO CHANSON VALUES(2421,'To Be With You In Heaven',2,NULL,'f','2008-03-12 19:05:20');
INSERT INTO CHANSON VALUES(2422,'Wind Of Change',2,NULL,'f','2008-03-12 15:18:12');
INSERT INTO CHANSON VALUES(2423,'Restless Nights',2,NULL,'f','2008-03-12 15:54:32');
INSERT INTO CHANSON VALUES(2424,'Lust Or Love',2,NULL,'f','2008-03-12 15:58:49');
INSERT INTO CHANSON VALUES(2425,'Kicks After Six',2,NULL,'f','2008-03-12 10:54:24');
INSERT INTO CHANSON VALUES(2426,'Hit Between The Eyes',2,NULL,'f','2008-03-12 18:35:38');
INSERT INTO CHANSON VALUES(2427,'Money And Fame',2,NULL,'f','2008-03-12 15:37:47');
INSERT INTO CHANSON VALUES(2428,'Crazy World',2,NULL,'f','2008-03-12 11:52:50');
INSERT INTO CHANSON VALUES(2429,'Send Me An Angel',2,NULL,'f','2008-03-12 08:58:43');
INSERT INTO CHANSON VALUES(2430,'Retour vers la lune noire',2,NULL,'f','2008-03-12 11:53:55');
INSERT INTO CHANSON VALUES(2431,'La ballade d''Abdallah Geronimo Cohen',2,NULL,'f','2008-03-12 17:52:01');
INSERT INTO CHANSON VALUES(2432,'Empreintes sur négatif',2,NULL,'f','2008-03-12 09:30:20');
INSERT INTO CHANSON VALUES(2433,'Méthode de dissection du pigeon à zone-la-ville',2,NULL,'f','2008-03-12 12:08:14');
INSERT INTO CHANSON VALUES(2434,'Dans quel état terre',2,NULL,NULL,'2008-03-12 18:48:12');
INSERT INTO CHANSON VALUES(2435,'Bouton de rose',2,NULL,'f','2008-03-12 16:59:07');
INSERT INTO CHANSON VALUES(2436,'27ème heure : suite faunesque',2,NULL,'f','2008-03-12 09:54:42');
INSERT INTO CHANSON VALUES(2437,'Eurydice nonante sept',2,NULL,'f','2008-03-12 17:31:20');
INSERT INTO CHANSON VALUES(2438,'Le chaos de la philosophie',2,NULL,'f','2008-03-12 14:50:13');
INSERT INTO CHANSON VALUES(2439,'Exercice de simple provocation avec 33 fois le mot coupable',2,NULL,'f','2008-03-12 12:52:11');
INSERT INTO CHANSON VALUES(2440,'Final Abdallah',2,NULL,NULL,'2008-03-12 09:09:05');
INSERT INTO CHANSON VALUES(2441,'TV-Glotzer (White Punks On Dope)',2,NULL,NULL,'2008-03-12 08:56:58');
INSERT INTO CHANSON VALUES(2442,'Ranghen',2,NULL,'f','2008-03-12 08:03:28');
INSERT INTO CHANSON VALUES(2443,'Unbeeschreiblich',2,NULL,'f','2008-03-12 12:24:36');
INSERT INTO CHANSON VALUES(2444,'Auf''m Bahnhof Zoo',2,NULL,'f','2008-03-27 15:16:25');
INSERT INTO CHANSON VALUES(2445,'Naturtrane',2,NULL,'f','2008-03-12 18:59:25');
INSERT INTO CHANSON VALUES(2446,'Superboy',2,NULL,'f','2008-03-12 19:06:19');
INSERT INTO CHANSON VALUES(2447,'Heiss',2,NULL,'f','2008-03-12 16:52:50');
INSERT INTO CHANSON VALUES(2448,'Fisch Im Wasser',2,NULL,'f','2008-03-12 08:25:41');
INSERT INTO CHANSON VALUES(2449,'Auf''m Friedhof',2,NULL,'f','2008-03-12 11:48:34');
INSERT INTO CHANSON VALUES(2450,'Der Spinner',2,NULL,'f','2008-04-11 13:05:38');
INSERT INTO CHANSON VALUES(2451,'Pank',2,NULL,NULL,'2008-03-12 13:55:43');
INSERT INTO CHANSON VALUES(2452,'Intro: Excerpt From ''Fanfare for the Common Man''',2,NULL,'f','2008-06-07 19:07:25.341667');
INSERT INTO CHANSON VALUES(2453,'Honky Tonk Women',2,NULL,'f','2008-04-12 12:16:19');
INSERT INTO CHANSON VALUES(2454,'If You Can''t Rock Me / Get Off Of My Cloud',2,NULL,'f','2008-06-01 17:14:26.301995');
INSERT INTO CHANSON VALUES(2455,'Happy',2,NULL,'f','2008-06-02 10:19:48.700477');
INSERT INTO CHANSON VALUES(2457,'Star Star',2,NULL,'f','2008-03-16 19:25:08');
INSERT INTO CHANSON VALUES(2458,'Tumbling Dice',2,NULL,'f','2008-04-11 14:56:27');
INSERT INTO CHANSON VALUES(2461,'You Can''t Always Get What You Want',2,NULL,'f','2008-04-11 11:21:17');
INSERT INTO CHANSON VALUES(2462,'Princess of the night',2,NULL,NULL,'2008-03-12 13:52:31');
INSERT INTO CHANSON VALUES(2463,'Never Surrender',2,NULL,NULL,'2008-03-12 16:33:23');
INSERT INTO CHANSON VALUES(2464,'Out of control',2,NULL,'f','2008-03-12 15:35:48');
INSERT INTO CHANSON VALUES(2465,'Rough and ready',2,NULL,'f','2008-03-12 11:50:37');
INSERT INTO CHANSON VALUES(2466,'Play it loud',2,NULL,'f','2008-03-12 18:17:32');
INSERT INTO CHANSON VALUES(2467,'Ant the bands played on',2,NULL,'f','2008-03-12 14:49:30');
INSERT INTO CHANSON VALUES(2468,'Midnight rider',2,NULL,'f','2008-03-12 10:19:31');
INSERT INTO CHANSON VALUES(2469,'Fire in the sky',2,NULL,'f','2008-03-12 19:17:56');
INSERT INTO CHANSON VALUES(2470,'Denim and leather',2,NULL,'f','2008-03-12 09:53:00');
INSERT INTO CHANSON VALUES(2472,'No Expectations',2,NULL,'f','2008-06-01 18:38:14.279456');
INSERT INTO CHANSON VALUES(2473,'Dear Doctor',2,NULL,'f','2008-03-19 13:03:20');
INSERT INTO CHANSON VALUES(2474,'Parachute Woman',2,NULL,'f','2008-06-01 18:39:07.297018');
INSERT INTO CHANSON VALUES(2475,'Jig-Saw Puzzle',2,NULL,'f','2008-04-07 11:00:32');
INSERT INTO CHANSON VALUES(2476,'Street Fighting Man',2,NULL,'f','2008-03-16 15:55:47');
INSERT INTO CHANSON VALUES(2477,'Prodigal Son',2,NULL,'f','2008-06-01 18:40:02.671701');
INSERT INTO CHANSON VALUES(2478,'Stray Cat Blues',2,NULL,'f','2008-04-11 11:25:27');
INSERT INTO CHANSON VALUES(2479,'Factory Girl',2,NULL,'f','2008-04-24 12:25:15');
INSERT INTO CHANSON VALUES(2480,'Salt of the Earth',2,NULL,NULL,'2008-06-01 18:40:41.50114');
INSERT INTO CHANSON VALUES(2481,'Chambre sous les toits',2,NULL,'f','2008-03-12 12:35:14');
INSERT INTO CHANSON VALUES(2482,'Une tranche de vie',2,NULL,'f','2008-03-12 18:34:32');
INSERT INTO CHANSON VALUES(2483,'Broyer du noir',2,NULL,'f','2008-03-12 17:41:25');
INSERT INTO CHANSON VALUES(2484,'L''accordéon désaccordé',2,NULL,'f','2008-03-12 17:13:18');
INSERT INTO CHANSON VALUES(2485,'La vie est folle',2,NULL,NULL,'2008-03-12 16:09:36');
INSERT INTO CHANSON VALUES(2486,'Rififi',2,NULL,NULL,'2008-03-12 13:37:40');
INSERT INTO CHANSON VALUES(2487,'Luxe, calme et volupté',2,NULL,'f','2008-03-12 18:27:18');
INSERT INTO CHANSON VALUES(2488,'L''héritière de Crao',2,NULL,'f','2008-03-12 17:07:14');
INSERT INTO CHANSON VALUES(2489,'Y''a pas de mot',2,NULL,'f','2008-03-12 14:24:00');
INSERT INTO CHANSON VALUES(2490,'Paradis Païen',2,NULL,'f','2008-03-12 15:14:21');
INSERT INTO CHANSON VALUES(2491,'Smiley Yeah Yeah Yeah',2,NULL,'f','2008-03-12 14:35:57');
INSERT INTO CHANSON VALUES(2492,'Mojo Box',2,NULL,'f','2008-03-12 17:27:31');
INSERT INTO CHANSON VALUES(2493,'Doublewide',2,NULL,'f','2008-03-12 11:16:13');
INSERT INTO CHANSON VALUES(2494,'I Want A Love',2,NULL,'f','2008-03-12 16:05:26');
INSERT INTO CHANSON VALUES(2495,'''69 El Camino',2,NULL,'f','2008-03-12 08:48:36');
INSERT INTO CHANSON VALUES(2496,'The Wet Spot',2,NULL,'f','2008-03-12 15:18:13');
INSERT INTO CHANSON VALUES(2497,'Soulful Garage',2,NULL,'f','2008-03-12 11:08:41');
INSERT INTO CHANSON VALUES(2498,'Biff Bang Pow',2,NULL,NULL,'2008-03-12 15:55:49');
INSERT INTO CHANSON VALUES(2499,'Where is the Moon?',2,NULL,'f','2008-03-12 18:28:13');
INSERT INTO CHANSON VALUES(2500,'Fire of Love',2,NULL,'f','2008-03-12 18:07:28');
INSERT INTO CHANSON VALUES(2501,'Swamp Fox',2,NULL,'f','2008-03-12 10:39:04');
INSERT INTO CHANSON VALUES(2502,'The Sweet Spot',2,NULL,'f','2008-03-12 10:26:31');
INSERT INTO CHANSON VALUES(2503,'It''s All Over But the Shoutin''',2,NULL,NULL,'2008-03-12 16:45:48');
INSERT INTO CHANSON VALUES(2504,'So Far Away',2,NULL,'f','2008-03-12 19:30:54');
INSERT INTO CHANSON VALUES(2505,'Money For Nothing',2,NULL,'f','2008-03-16 12:32:42');
INSERT INTO CHANSON VALUES(2506,'Walk Of Life',2,NULL,'f','2008-03-12 08:12:01');
INSERT INTO CHANSON VALUES(2507,'Your Latest Trick',2,NULL,'f','2008-06-05 16:12:53.220939');
INSERT INTO CHANSON VALUES(2508,'Why Worry',2,NULL,'f','2008-03-12 19:10:04');
INSERT INTO CHANSON VALUES(2509,'Ride Across The River',2,NULL,'f','2008-03-12 16:03:33');
INSERT INTO CHANSON VALUES(2510,'The Man''s Too Strong',2,NULL,'f','2008-03-12 19:56:40');
INSERT INTO CHANSON VALUES(2511,'One World',2,NULL,NULL,'2008-03-12 13:11:20');
INSERT INTO CHANSON VALUES(2512,'Brothers In Arms',2,NULL,'f','2008-03-12 14:23:47');
INSERT INTO CHANSON VALUES(2513,'Crache ton venin',2,NULL,'f','2008-03-23 08:07:33');
INSERT INTO CHANSON VALUES(2514,'Fait divers',2,NULL,'f','2008-03-12 18:04:03');
INSERT INTO CHANSON VALUES(2515,'J''suis parti de chez mes parents',2,NULL,'f','2008-03-12 17:28:36');
INSERT INTO CHANSON VALUES(2516,'Facile',2,NULL,'f','2008-03-12 13:28:49');
INSERT INTO CHANSON VALUES(2517,'La bombe humaine',2,NULL,'f','2008-03-12 13:42:21');
INSERT INTO CHANSON VALUES(2518,'J''sais pas quoi faire',2,NULL,'f','2008-03-12 15:37:31');
INSERT INTO CHANSON VALUES(2519,'Ne me regarde pas',2,NULL,'f','2008-03-12 16:22:35');
INSERT INTO CHANSON VALUES(2520,'Regarde moi',2,NULL,'f','2008-03-12 11:20:32');
INSERT INTO CHANSON VALUES(2521,'Un peu de ton amour',2,NULL,NULL,'2008-03-12 19:47:43');
INSERT INTO CHANSON VALUES(2522,'Tu vas me manquer',2,NULL,'f','2008-03-12 11:18:07');
INSERT INTO CHANSON VALUES(2523,'Symphony In Blue',2,NULL,'f','2008-03-12 09:21:14');
INSERT INTO CHANSON VALUES(2524,'In Search Of Peter Pan',2,NULL,'f','2008-06-07 19:24:53.762144');
INSERT INTO CHANSON VALUES(2525,'Wow',2,NULL,'f','2008-03-12 16:57:47');
INSERT INTO CHANSON VALUES(2526,'Don''t Push Your Foot On The Heartbrake',2,NULL,'f','2008-03-29 09:54:57');
INSERT INTO CHANSON VALUES(2527,'Oh England My Lionheart',2,NULL,'f','2008-03-12 14:32:35');
INSERT INTO CHANSON VALUES(2528,'Fullhouse',2,NULL,'f','2008-03-12 08:16:58');
INSERT INTO CHANSON VALUES(2529,'In The Warm Room',2,NULL,'f','2008-03-12 15:33:18');
INSERT INTO CHANSON VALUES(2530,'Kashka From Baghdad',2,NULL,'f','2008-03-12 10:31:06');
INSERT INTO CHANSON VALUES(2531,'Coffee Homeground',2,NULL,'f','2008-03-12 18:49:24');
INSERT INTO CHANSON VALUES(2532,'Hammer Horror',2,NULL,NULL,'2008-03-12 08:55:46');
INSERT INTO CHANSON VALUES(2533,'Ça cache quekchose',2,NULL,'f','2008-03-12 11:35:58');
INSERT INTO CHANSON VALUES(2534,'L''araignée',2,NULL,'f','2008-03-12 14:19:55');
INSERT INTO CHANSON VALUES(2535,'J''sors avec ma frangine',2,NULL,'f','2008-03-12 12:40:20');
INSERT INTO CHANSON VALUES(2536,'Aficionado',2,NULL,'f','2008-04-13 09:33:06');
INSERT INTO CHANSON VALUES(2537,'Idylle au Caire',2,NULL,'f','2008-03-12 15:49:14');
INSERT INTO CHANSON VALUES(2538,'Privé',2,NULL,'f','2008-03-12 15:20:47');
INSERT INTO CHANSON VALUES(2539,'Vertige de l''amour',2,NULL,'f','2008-03-12 10:23:03');
INSERT INTO CHANSON VALUES(2540,'Rebel',2,NULL,NULL,'2008-03-12 09:01:37');
INSERT INTO CHANSON VALUES(2541,'Retours',2,NULL,NULL,'2008-03-12 13:11:08');
INSERT INTO CHANSON VALUES(2542,'Reviens vas-t-en',2,NULL,'f','2008-03-12 14:05:57');
INSERT INTO CHANSON VALUES(2543,'Fan',2,NULL,'f','2008-03-12 19:06:53');
INSERT INTO CHANSON VALUES(2544,'Elle s''fait rougir toute seule',2,NULL,NULL,'2008-03-12 17:22:29');
INSERT INTO CHANSON VALUES(2545,'Gaby oh Gaby',2,NULL,'f','2008-03-12 16:57:49');
INSERT INTO CHANSON VALUES(2546,'Piece of My Heart',2,NULL,'f','2008-03-12 15:19:29');
INSERT INTO CHANSON VALUES(2547,'Cry Baby',2,NULL,'f','2008-03-12 08:57:19');
INSERT INTO CHANSON VALUES(2548,'Me and Bobby McGee',2,NULL,'f','2008-03-23 11:32:39');
INSERT INTO CHANSON VALUES(2549,'Try (Just a Little Bit Harder)',2,NULL,'f','2008-03-12 08:44:03');
INSERT INTO CHANSON VALUES(2550,'One Good Man',2,NULL,'f','2008-03-12 09:53:04');
INSERT INTO CHANSON VALUES(2551,'Move Over',2,NULL,'f','2008-03-12 16:21:16');
INSERT INTO CHANSON VALUES(2552,'I Need a Man to Love',2,NULL,'f','2008-03-12 18:56:22');
INSERT INTO CHANSON VALUES(2553,'Turtle Blues',2,NULL,'f','2008-04-24 11:47:43');
INSERT INTO CHANSON VALUES(2554,'A Woman Left Lonely',2,NULL,'f','2008-05-22 08:06:20');
INSERT INTO CHANSON VALUES(2555,'One Night Stand',2,NULL,'f','2008-03-12 17:55:29');
INSERT INTO CHANSON VALUES(2556,'La Peau',2,NULL,'f','2008-03-12 16:41:52');
INSERT INTO CHANSON VALUES(2557,'Genocide',2,NULL,'f','2008-03-12 10:24:49');
INSERT INTO CHANSON VALUES(2558,'They learn your Love',2,NULL,'f','2008-03-12 08:04:09');
INSERT INTO CHANSON VALUES(2559,'Epargne moi',2,NULL,'f','2008-03-12 14:04:06');
INSERT INTO CHANSON VALUES(2560,'Henry, serial killer',2,NULL,'f','2008-03-12 18:19:39');
INSERT INTO CHANSON VALUES(2561,'Rusted Faces',2,NULL,'f','2008-03-12 14:22:23');
INSERT INTO CHANSON VALUES(2562,'Le feu',2,NULL,'f','2008-03-12 14:29:17');
INSERT INTO CHANSON VALUES(2563,'Ne reste-t-il que la guerre pour tuer le silence ?',2,NULL,'f','2008-03-12 15:12:38');
INSERT INTO CHANSON VALUES(2564,'Another land',2,NULL,'f','2008-03-12 19:04:35');
INSERT INTO CHANSON VALUES(2565,'Beast in the bottle',2,NULL,'f','2008-03-12 11:53:30');
INSERT INTO CHANSON VALUES(2566,'Nova',2,NULL,NULL,'2008-03-12 17:37:11');
INSERT INTO CHANSON VALUES(2567,'Gratitude',2,NULL,'f','2008-03-12 15:49:36');
INSERT INTO CHANSON VALUES(2568,'Come On Louann',2,NULL,'f','2008-03-12 13:51:40');
INSERT INTO CHANSON VALUES(2569,'Strangers On A Train',2,NULL,'f','2008-03-12 15:23:45');
INSERT INTO CHANSON VALUES(2570,'A Little Push',2,NULL,NULL,'2008-03-12 16:13:05');
INSERT INTO CHANSON VALUES(2571,'Eiffel Tower Blue',2,NULL,'f','2008-03-12 12:44:27');
INSERT INTO CHANSON VALUES(2572,'Fix Me A Coffee',2,NULL,'f','2008-03-12 17:18:56');
INSERT INTO CHANSON VALUES(2573,'Dragon',2,NULL,'f','2008-03-12 08:56:09');
INSERT INTO CHANSON VALUES(2574,'Irish Eyes',2,NULL,'f','2008-03-12 16:52:13');
INSERT INTO CHANSON VALUES(2575,'Tell Me',2,NULL,'f','2008-03-12 11:09:07');
INSERT INTO CHANSON VALUES(2576,'Doctor Of Mercy',2,NULL,'f','2008-03-12 17:56:44');
INSERT INTO CHANSON VALUES(2577,'Black Crow',2,NULL,'f','2008-03-12 08:35:34');
INSERT INTO CHANSON VALUES(2578,'Hold On',2,NULL,'f','2008-03-12 15:04:26');
INSERT INTO CHANSON VALUES(2579,'Nothing Takes The Place Of You',2,NULL,'f','2008-03-12 11:42:49');
INSERT INTO CHANSON VALUES(2580,'Gimme All Your Lovin''',2,NULL,'f','2008-03-12 08:26:03');
INSERT INTO CHANSON VALUES(2581,'Got Me Under Pressure',2,NULL,'f','2008-03-12 09:50:48');
INSERT INTO CHANSON VALUES(2582,'Sharp Dressed Man',2,NULL,'f','2008-03-12 15:37:06');
INSERT INTO CHANSON VALUES(2583,'I Need You Tonight',2,NULL,NULL,'2008-03-12 14:42:02');
INSERT INTO CHANSON VALUES(2584,'I Got The Six',2,NULL,'f','2008-03-12 16:25:55');
INSERT INTO CHANSON VALUES(2585,'Legs',2,NULL,'f','2008-03-12 19:43:04');
INSERT INTO CHANSON VALUES(2586,'Thug',2,NULL,'f','2008-03-12 08:32:01');
INSERT INTO CHANSON VALUES(2587,'TV Dinners',2,NULL,'f','2008-03-12 17:33:37');
INSERT INTO CHANSON VALUES(2588,'Dirty Dog',2,NULL,'f','2008-03-12 12:10:41');
INSERT INTO CHANSON VALUES(2589,'If I Could Only Flag Her Down',2,NULL,'f','2008-03-12 18:29:23');
INSERT INTO CHANSON VALUES(2590,'Bad Girl',2,NULL,'f','2008-03-12 16:33:50');
INSERT INTO CHANSON VALUES(2591,'Ram It Down',2,NULL,'f','2008-03-12 16:42:41');
INSERT INTO CHANSON VALUES(2592,'Heavy Metal',2,NULL,'f','2008-03-12 14:19:18');
INSERT INTO CHANSON VALUES(2593,'Love Zone',2,NULL,'f','2008-03-12 15:52:00');
INSERT INTO CHANSON VALUES(2594,'Come And Get It',2,NULL,'f','2008-03-12 16:35:26');
INSERT INTO CHANSON VALUES(2595,'Hard As Iron',2,NULL,NULL,'2008-03-12 15:32:09');
INSERT INTO CHANSON VALUES(2596,'Blood Red Skies',2,NULL,NULL,'2008-03-12 16:37:41');
INSERT INTO CHANSON VALUES(2597,'I''m A Rocker',2,NULL,'f','2008-03-12 16:26:15');
INSERT INTO CHANSON VALUES(2599,'Love You To Death',2,NULL,'f','2008-03-12 08:40:55');
INSERT INTO CHANSON VALUES(2600,'Monsters Of Rock',2,NULL,'f','2008-03-12 13:20:28');
INSERT INTO CHANSON VALUES(2601,'Hello, I love you',2,NULL,'f','2008-03-12 11:04:11');
INSERT INTO CHANSON VALUES(2602,'Love street',2,NULL,'f','2008-03-12 19:36:30');
INSERT INTO CHANSON VALUES(2603,'Not to touch the earth',2,NULL,'f','2008-03-23 11:14:22');
INSERT INTO CHANSON VALUES(2604,'Summer''s almost gone',2,NULL,'f','2008-03-12 11:55:58');
INSERT INTO CHANSON VALUES(2605,'Wintertime love',2,NULL,'f','2008-03-12 16:31:31');
INSERT INTO CHANSON VALUES(2606,'The unknown soldier',2,NULL,NULL,'2008-03-12 18:12:08');
INSERT INTO CHANSON VALUES(2607,'Spanish caravan',2,NULL,NULL,'2008-03-12 14:55:34');
INSERT INTO CHANSON VALUES(2608,'My wild love',2,NULL,'f','2008-04-24 16:33:46');
INSERT INTO CHANSON VALUES(2609,'We could be so good together',2,NULL,'f','2008-03-12 17:15:24');
INSERT INTO CHANSON VALUES(2610,'Yes, the river knows',2,NULL,'f','2008-03-12 11:17:05');
INSERT INTO CHANSON VALUES(2611,'Five to one',2,NULL,'f','2008-03-12 10:42:26');
INSERT INTO CHANSON VALUES(2612,'I have been in you',2,NULL,'f','2008-03-12 16:58:30');
INSERT INTO CHANSON VALUES(2613,'Flakes',2,NULL,'f','2008-03-12 18:55:07');
INSERT INTO CHANSON VALUES(2614,'Broken hearts are for assholes',2,NULL,'f','2008-03-12 12:11:21');
INSERT INTO CHANSON VALUES(2615,'I''m so cute',2,NULL,'f','2008-03-12 17:28:17');
INSERT INTO CHANSON VALUES(2616,'Jones Crusher',2,NULL,'f','2008-03-12 16:10:48');
INSERT INTO CHANSON VALUES(2617,'What ever happened to all the fun in the world',2,NULL,'f','2008-03-12 10:02:01');
INSERT INTO CHANSON VALUES(2618,'Rat tomago',2,NULL,'f','2008-03-12 12:37:56');
INSERT INTO CHANSON VALUES(2619,'We''ve got to get into something real',2,NULL,'f','2008-03-12 19:26:12');
INSERT INTO CHANSON VALUES(2620,'Bobby Brown',2,NULL,'f','2008-03-12 12:42:29');
INSERT INTO CHANSON VALUES(2621,'Rubber shirt',2,NULL,'f','2008-03-12 13:54:12');
INSERT INTO CHANSON VALUES(2622,'The Sheik Yerbouti tango',2,NULL,'f','2008-03-12 18:34:10');
INSERT INTO CHANSON VALUES(2623,'Baby snakes',2,NULL,'f','2008-03-12 12:26:06');
INSERT INTO CHANSON VALUES(2624,'Tryin'' to grow a chin',2,NULL,'f','2008-03-12 14:48:18');
INSERT INTO CHANSON VALUES(2625,'City of tiny lites',2,NULL,'f','2008-03-12 18:33:46');
INSERT INTO CHANSON VALUES(2626,'Dancin'' fool',2,NULL,NULL,'2008-03-12 10:17:57');
INSERT INTO CHANSON VALUES(2627,'Jewish princess',2,NULL,NULL,'2008-03-12 19:31:00');
INSERT INTO CHANSON VALUES(2628,'Wild love',2,NULL,'f','2008-03-12 08:54:37');
INSERT INTO CHANSON VALUES(2629,'Yo'' mama',2,NULL,'f','2008-03-12 19:52:04');
INSERT INTO CHANSON VALUES(2630,'Pincushion',2,NULL,'f','2008-03-12 10:14:46');
INSERT INTO CHANSON VALUES(2631,'Breakaway',2,NULL,'f','2008-03-12 15:41:40');
INSERT INTO CHANSON VALUES(2632,'World Of Swirl',2,NULL,'f','2008-03-12 18:35:15');
INSERT INTO CHANSON VALUES(2633,'Fuzzbox Voodoo',2,NULL,'f','2008-04-05 17:54:04');
INSERT INTO CHANSON VALUES(2634,'Girl In A T-Shirt',2,NULL,'f','2008-03-12 08:59:41');
INSERT INTO CHANSON VALUES(2635,'Antenna Head',2,NULL,'f','2008-03-12 09:31:29');
INSERT INTO CHANSON VALUES(2636,'PCH',2,NULL,'f','2008-03-12 13:24:03');
INSERT INTO CHANSON VALUES(2637,'Cherry Red',2,NULL,'f','2008-03-12 10:35:20');
INSERT INTO CHANSON VALUES(2638,'Cover Your Rig',2,NULL,'f','2008-03-12 10:34:52');
INSERT INTO CHANSON VALUES(2639,'Lizard Life',2,NULL,'f','2008-03-12 10:35:46');
INSERT INTO CHANSON VALUES(2640,'Deal Goin'' Down',2,NULL,'f','2008-03-12 17:32:38');
INSERT INTO CHANSON VALUES(2641,'Everything',2,NULL,'f','2008-03-12 18:42:53');
INSERT INTO CHANSON VALUES(2642,'Death on Two Legs',2,NULL,'f','2008-03-12 15:22:35');
INSERT INTO CHANSON VALUES(2643,'Lazing on a Sunday Afternoon',2,NULL,'f','2008-03-12 11:13:10');
INSERT INTO CHANSON VALUES(2644,'I''m In Love With My Car',2,NULL,'f','2008-03-12 14:16:10');
INSERT INTO CHANSON VALUES(2645,'You''re My Best Friend',2,NULL,'f','2008-03-12 11:25:42');
INSERT INTO CHANSON VALUES(2646,'''39',2,NULL,'f','2008-04-07 10:22:25');
INSERT INTO CHANSON VALUES(2647,'Sweet Lady',2,NULL,NULL,'2008-03-12 17:53:07');
INSERT INTO CHANSON VALUES(2648,'Seaside Rendezvous',2,NULL,'f','2008-03-12 17:06:42');
INSERT INTO CHANSON VALUES(2649,'The Prophet''s Song',2,NULL,'f','2008-03-12 09:18:16');
INSERT INTO CHANSON VALUES(2650,'Love of My Life',2,NULL,'f','2008-03-12 08:29:51');
INSERT INTO CHANSON VALUES(2651,'Good Company',2,NULL,'f','2008-03-12 17:18:24');
INSERT INTO CHANSON VALUES(2652,'Bohemian Rhapsody',2,NULL,NULL,'2008-03-12 13:10:07');
INSERT INTO CHANSON VALUES(2653,'God Save the Queen',2,NULL,'f','2008-03-12 12:50:29');
INSERT INTO CHANSON VALUES(2654,'My Generation',2,NULL,NULL,'2008-03-12 19:10:43');
INSERT INTO CHANSON VALUES(2655,'Holiday In The Sun',2,NULL,NULL,'2008-03-12 09:45:00');
INSERT INTO CHANSON VALUES(2656,'I Can''t Explain',2,NULL,NULL,'2008-04-14 19:13:45');
INSERT INTO CHANSON VALUES(2658,'Teaser',2,NULL,NULL,'2008-03-12 11:01:26');
INSERT INTO CHANSON VALUES(2659,'The Boys Are Back In Town',2,NULL,NULL,'2008-03-12 19:47:19');
INSERT INTO CHANSON VALUES(2662,'Hound Dog',2,NULL,NULL,'2008-03-12 09:47:13');
INSERT INTO CHANSON VALUES(2663,'Long Tall Sally',2,NULL,'f','2008-03-12 19:35:31');
INSERT INTO CHANSON VALUES(2664,'Blue Suede Shoes',2,NULL,NULL,'2008-03-12 12:02:42');
INSERT INTO CHANSON VALUES(2665,'Intro',2,NULL,'f','2008-03-12 13:22:33');
INSERT INTO CHANSON VALUES(2666,'I drove all night',2,NULL,NULL,'2008-03-12 19:18:43');
INSERT INTO CHANSON VALUES(2667,'Primitive',2,NULL,NULL,'2008-03-12 16:25:28');
INSERT INTO CHANSON VALUES(2668,'My first night without you',2,NULL,'f','2008-03-12 16:42:29');
INSERT INTO CHANSON VALUES(2669,'Like a cat',2,NULL,'f','2008-03-12 10:41:17');
INSERT INTO CHANSON VALUES(2670,'Heading west',2,NULL,'f','2008-03-12 13:48:53');
INSERT INTO CHANSON VALUES(2671,'A night to remember',2,NULL,'f','2008-03-12 19:37:39');
INSERT INTO CHANSON VALUES(2672,'Unconditional love',2,NULL,'f','2008-03-12 15:43:26');
INSERT INTO CHANSON VALUES(2673,'Insecurious',2,NULL,'f','2008-04-24 19:08:20');
INSERT INTO CHANSON VALUES(2674,'Dancing with a stranger',2,NULL,'f','2008-03-12 18:40:02');
INSERT INTO CHANSON VALUES(2675,'I don''t want to be your friend',2,NULL,'f','2008-03-12 13:03:04');
INSERT INTO CHANSON VALUES(2676,'Kindred spirit',2,NULL,'f','2008-03-12 09:33:27');
INSERT INTO CHANSON VALUES(2677,'Dancing with Mr. D.',2,NULL,'f','2008-03-16 12:16:11');
INSERT INTO CHANSON VALUES(2678,'100 Years Ago',2,NULL,'f','2008-06-02 09:48:08.389266');
INSERT INTO CHANSON VALUES(2679,'Coming Down Again',2,NULL,'f','2008-06-02 09:48:27.434636');
INSERT INTO CHANSON VALUES(2680,'Doo Doo Doo Doo Doo (Heartbreaker)',2,NULL,'f','2008-06-02 09:48:41.160369');
INSERT INTO CHANSON VALUES(2681,'Angie',2,NULL,'f','2008-03-16 14:35:01');
INSERT INTO CHANSON VALUES(2682,'Silver Train',2,NULL,NULL,'2008-03-16 10:15:44');
INSERT INTO CHANSON VALUES(2683,'Hide Your Love',2,NULL,'f','2008-06-02 09:49:43.403706');
INSERT INTO CHANSON VALUES(2684,'Winter',2,NULL,'f','2008-06-02 09:50:03.769838');
INSERT INTO CHANSON VALUES(2685,'Can You Hear The Music',2,NULL,'f','2008-06-02 09:50:20.97251');
INSERT INTO CHANSON VALUES(2687,'A.C rocker',2,NULL,'f','2008-03-12 08:47:51');
INSERT INTO CHANSON VALUES(2688,'Highwire',2,NULL,'f','2008-03-12 10:40:52');
INSERT INTO CHANSON VALUES(2689,'Acid kewpie',2,NULL,'f','2008-03-12 09:03:03');
INSERT INTO CHANSON VALUES(2690,'Control freak',2,NULL,'f','2008-03-12 16:43:43');
INSERT INTO CHANSON VALUES(2691,'Penicillin',2,NULL,'f','2008-03-12 08:17:18');
INSERT INTO CHANSON VALUES(2692,'A place to hide',2,NULL,'f','2008-03-12 09:31:34');
INSERT INTO CHANSON VALUES(2693,'Soup',2,NULL,'f','2008-03-12 17:11:43');
INSERT INTO CHANSON VALUES(2694,'Are you enemy?',2,NULL,'f','2008-03-12 11:53:17');
INSERT INTO CHANSON VALUES(2695,'Don''t come around',2,NULL,NULL,'2008-03-12 16:40:00');
INSERT INTO CHANSON VALUES(2696,'Coup d''état',2,NULL,NULL,'2008-03-12 17:54:23');
INSERT INTO CHANSON VALUES(2697,'Reviver gene',2,NULL,NULL,'2008-03-12 12:55:11');
INSERT INTO CHANSON VALUES(2698,'Carstairs',2,NULL,'f','2008-03-12 10:06:52');
INSERT INTO CHANSON VALUES(2699,'Subterranean Homesick Blues',2,NULL,'f','2008-03-12 08:11:56');
INSERT INTO CHANSON VALUES(2701,'Maggie''s Farm',2,NULL,'f','2008-03-12 18:56:57');
INSERT INTO CHANSON VALUES(2702,'Love Minus Zero  /  No Limit',2,NULL,'f','2008-03-12 09:01:28');
INSERT INTO CHANSON VALUES(2703,'Outlaw Blues',2,NULL,'f','2008-03-12 16:51:39');
INSERT INTO CHANSON VALUES(2704,'On The Road Again',2,NULL,'f','2008-03-12 13:06:33');
INSERT INTO CHANSON VALUES(2705,'Bob Dylan''s 115th Dream',2,NULL,'f','2008-03-12 17:49:13');
INSERT INTO CHANSON VALUES(2706,'Mr. Tamburine Man',2,NULL,'f','2008-03-12 17:35:08');
INSERT INTO CHANSON VALUES(2707,'Gates Of Eden',2,NULL,NULL,'2008-03-12 09:55:03');
INSERT INTO CHANSON VALUES(2708,'It''S Alright , Ma ( I''m Only Bleeding)',2,NULL,'f','2008-03-12 12:07:10');
INSERT INTO CHANSON VALUES(2710,'Throwaway',2,NULL,'f','2008-03-12 09:18:14');
INSERT INTO CHANSON VALUES(2711,'Let''s Work',2,NULL,'f','2008-03-12 17:08:10');
INSERT INTO CHANSON VALUES(2712,'Radio Control',2,NULL,'f','2008-03-12 17:18:11');
INSERT INTO CHANSON VALUES(2713,'Say You Will',2,NULL,'f','2008-03-12 11:01:02');
INSERT INTO CHANSON VALUES(2714,'Primitive Cool',2,NULL,'f','2008-03-12 18:29:09');
INSERT INTO CHANSON VALUES(2715,'Kow Tow',2,NULL,'f','2008-03-12 13:14:59');
INSERT INTO CHANSON VALUES(2716,'Shoot Off Your Mouth',2,NULL,'f','2008-03-12 16:00:34');
INSERT INTO CHANSON VALUES(2717,'Peace For The Wicked',2,NULL,'f','2008-03-12 18:09:29');
INSERT INTO CHANSON VALUES(2718,'Party Doll',2,NULL,'f','2008-03-12 18:31:37');
INSERT INTO CHANSON VALUES(2719,'War Baby',2,NULL,'f','2008-03-12 08:44:48');
INSERT INTO CHANSON VALUES(2720,'Under My Thumb',2,NULL,'f','2008-06-01 18:09:03.898673');
INSERT INTO CHANSON VALUES(2722,'Lady Jane',2,NULL,'f','2008-03-20 16:44:16');
INSERT INTO CHANSON VALUES(2723,'Not Fade Away',2,NULL,'f','2008-05-22 08:56:46');
INSERT INTO CHANSON VALUES(2724,'I''ve Been Loving You Too Long',2,NULL,NULL,'2008-06-02 11:05:55.011672');
INSERT INTO CHANSON VALUES(2725,'Fortune Teller',2,NULL,'f','2008-06-01 18:41:36.792522');
INSERT INTO CHANSON VALUES(2726,'The Last Time',2,NULL,'f','2008-03-26 09:41:05');
INSERT INTO CHANSON VALUES(2727,'19th Nervous Breakdown',2,NULL,'f','2008-03-17 11:09:20');
INSERT INTO CHANSON VALUES(2728,'Time Is On My Side',2,NULL,'f','2008-06-01 18:03:47.99733');
INSERT INTO CHANSON VALUES(2729,'I''m Alright',2,NULL,'f','2008-04-09 14:50:04');
INSERT INTO CHANSON VALUES(2730,'Have You Seen Your Mother, Baby, Standing In The Shadow?',2,NULL,'f','2008-06-02 10:03:07.827131');
INSERT INTO CHANSON VALUES(2731,'(I can''t get no) Satisfaction',2,NULL,'f','2008-03-17 11:37:01');
INSERT INTO CHANSON VALUES(2732,'Rosalyn',2,NULL,NULL,'2008-06-07 20:01:21.265651');
INSERT INTO CHANSON VALUES(2733,'Here Comes The Night',2,NULL,'f','2008-06-07 18:40:07.01889');
INSERT INTO CHANSON VALUES(2734,'I Wish You Would',2,NULL,'f','2008-06-07 18:40:22.125195');
INSERT INTO CHANSON VALUES(2735,'See Emily Play',2,NULL,'f','2008-03-24 09:40:55');
INSERT INTO CHANSON VALUES(2736,'Everything''s Alright',2,NULL,'f','2008-04-07 13:45:08');
INSERT INTO CHANSON VALUES(2738,'Friday On My Mind',2,NULL,'f','2008-06-07 18:42:41.982923');
INSERT INTO CHANSON VALUES(2739,'Sorrow',2,NULL,'f','2008-04-13 09:02:05');
INSERT INTO CHANSON VALUES(2740,'Don''t Bring Me Down',2,NULL,'f','2008-06-07 18:23:26.237296');
INSERT INTO CHANSON VALUES(2741,'Shapes Of Things',2,NULL,'f','2008-06-07 18:23:43.759139');
INSERT INTO CHANSON VALUES(2742,'Anyway, Anyhow, Anywhere',2,NULL,'f','2008-06-07 18:23:57.907635');
INSERT INTO CHANSON VALUES(2743,'Where Have All The Good Times Gone',2,NULL,'f','2008-06-07 18:24:14.588674');
INSERT INTO CHANSON VALUES(2744,'Growin'' Up',2,NULL,'f','2008-06-07 18:24:40.978349');
INSERT INTO CHANSON VALUES(2745,'Port Of Amsterdam',2,NULL,'f','2008-03-17 12:05:33');
INSERT INTO CHANSON VALUES(2746,'Break On Through (To The Other Side)',2,NULL,'f','2008-03-12 08:57:23');
INSERT INTO CHANSON VALUES(2747,'Soul Kitchen',2,NULL,'f','2008-03-12 13:05:03');
INSERT INTO CHANSON VALUES(2748,'The Crystal Ship',2,NULL,'f','2008-06-07 19:28:08.026519');
INSERT INTO CHANSON VALUES(2749,'Twentieth Century Fox',2,NULL,'f','2008-03-12 09:07:36');
INSERT INTO CHANSON VALUES(2751,'Light My Fire',2,NULL,'f','2008-03-12 08:17:58');
INSERT INTO CHANSON VALUES(2753,'I Looked At You',2,NULL,'f','2008-03-12 14:59:29');
INSERT INTO CHANSON VALUES(2754,'End Of The Night',2,NULL,'f','2008-03-12 11:36:50');
INSERT INTO CHANSON VALUES(2755,'Take It As It Comes',2,NULL,NULL,'2008-03-12 16:58:55');
INSERT INTO CHANSON VALUES(2756,'The End',2,NULL,'f','2008-03-12 11:02:52');
INSERT INTO CHANSON VALUES(2758,'Court-métrage',2,NULL,'f','2008-03-12 16:55:46');
INSERT INTO CHANSON VALUES(2759,'La mome kaleïdoscope',2,NULL,'f','2008-03-12 13:02:54');
INSERT INTO CHANSON VALUES(2760,'L''homme politique, le roll-mops et la cuve à mazout',2,NULL,'f','2008-03-12 09:31:26');
INSERT INTO CHANSON VALUES(2761,'Variation autour du complexe d''Icare',2,NULL,'f','2008-03-12 17:33:44');
INSERT INTO CHANSON VALUES(2762,'Enfermé dans les cabinets (avec la fille mineure des 80 chasseurs)',2,NULL,'f','2008-03-12 16:59:07');
INSERT INTO CHANSON VALUES(2763,'La queue',2,NULL,'f','2008-03-12 17:31:06');
INSERT INTO CHANSON VALUES(2764,'Dernière station avant l''autoroute',2,NULL,'f','2008-03-12 11:47:42');
INSERT INTO CHANSON VALUES(2765,'Rock-autopsie',2,NULL,NULL,'2008-03-12 09:28:41');
INSERT INTO CHANSON VALUES(2766,'Autorisation de délirer',2,NULL,NULL,'2008-03-12 08:44:44');
INSERT INTO CHANSON VALUES(2767,'Alligator 427',2,NULL,'f','2008-03-12 19:22:15');
INSERT INTO CHANSON VALUES(2768,'Hunter',2,NULL,'f','2008-03-12 19:05:11');
INSERT INTO CHANSON VALUES(2769,'Jòga',2,NULL,'f','2008-03-12 16:34:13');
INSERT INTO CHANSON VALUES(2770,'Unravel',2,NULL,'f','2008-03-12 15:40:45');
INSERT INTO CHANSON VALUES(2771,'Bachelorette',2,NULL,'f','2008-03-12 08:26:18');
INSERT INTO CHANSON VALUES(2772,'All Neon Like',2,NULL,'f','2008-03-12 17:10:17');
INSERT INTO CHANSON VALUES(2773,'5 Years',2,NULL,'f','2008-03-12 19:58:49');
INSERT INTO CHANSON VALUES(2774,'Immature',2,NULL,'f','2008-03-12 08:17:36');
INSERT INTO CHANSON VALUES(2775,'Alarm Call',2,NULL,'f','2008-03-12 17:26:05');
INSERT INTO CHANSON VALUES(2776,'Pluto',2,NULL,NULL,'2008-03-12 13:31:50');
INSERT INTO CHANSON VALUES(2777,'All Is Full Of Love',2,NULL,'f','2008-03-12 10:28:12');
INSERT INTO CHANSON VALUES(2778,'Solar Sex Panel',2,NULL,'f','2008-03-12 13:24:18');
INSERT INTO CHANSON VALUES(2779,'The Action',2,NULL,'f','2008-03-12 15:06:53');
INSERT INTO CHANSON VALUES(2780,'Inside Job',2,NULL,'f','2008-03-12 18:43:33');
INSERT INTO CHANSON VALUES(2781,'Big Love',2,NULL,'f','2008-03-12 15:46:59');
INSERT INTO CHANSON VALUES(2782,'Take Another Look',2,NULL,'f','2008-03-12 19:33:09');
INSERT INTO CHANSON VALUES(2783,'Do You Want My Job',2,NULL,'f','2008-03-12 10:29:08');
INSERT INTO CHANSON VALUES(2784,'Don''t Go Away Mad',2,NULL,'f','2008-03-12 08:31:26');
INSERT INTO CHANSON VALUES(2785,'Fool Who Knows',2,NULL,'f','2008-03-12 16:16:52');
INSERT INTO CHANSON VALUES(2786,'She Runs Hot',2,NULL,'f','2008-03-12 17:44:23');
INSERT INTO CHANSON VALUES(2787,'Don''t Think About Her When You''re Trying To Drive',2,NULL,'f','2008-03-12 15:56:52');
INSERT INTO CHANSON VALUES(2788,'Don''t Bug Me When I''m Working',2,NULL,'f','2008-03-12 17:23:16');
INSERT INTO CHANSON VALUES(2789,'Plâtre et ciment',2,NULL,'f','2008-03-12 09:02:22');
INSERT INTO CHANSON VALUES(2790,'Les plages',2,NULL,'f','2008-03-12 08:55:05');
INSERT INTO CHANSON VALUES(2791,'L''horizon',2,NULL,'f','2008-03-12 14:33:52');
INSERT INTO CHANSON VALUES(2792,'Compromis',2,NULL,'f','2008-03-12 14:30:25');
INSERT INTO CHANSON VALUES(2793,'Les gens disent que',2,NULL,'f','2008-03-12 16:44:55');
INSERT INTO CHANSON VALUES(2794,'Quand Paris s''éteint',2,NULL,'f','2008-03-12 18:48:26');
INSERT INTO CHANSON VALUES(2795,'Chaque pas',2,NULL,NULL,'2008-03-12 11:29:43');
INSERT INTO CHANSON VALUES(2796,'J''t''adore tellement',2,NULL,NULL,'2008-03-12 10:15:27');
INSERT INTO CHANSON VALUES(2797,'Tel est l''amour (mon amour)',2,NULL,NULL,'2008-03-12 15:52:24');
INSERT INTO CHANSON VALUES(2798,'Juste une illusion',2,NULL,'f','2008-03-12 13:41:47');
INSERT INTO CHANSON VALUES(2799,'Oui et non',2,NULL,'f','2008-03-12 16:49:50');
INSERT INTO CHANSON VALUES(2800,'Thirty was a long time ago',2,NULL,'f','2008-03-12 09:50:45');
INSERT INTO CHANSON VALUES(2801,'The day after Valentine''s day',2,NULL,'f','2008-03-12 10:24:19');
INSERT INTO CHANSON VALUES(2802,'Lo and behold',2,NULL,'f','2008-03-12 08:58:49');
INSERT INTO CHANSON VALUES(2803,'New world order',2,NULL,'f','2008-03-12 14:42:33');
INSERT INTO CHANSON VALUES(2805,'Immigration cross the nation',2,NULL,'f','2008-03-12 18:54:51');
INSERT INTO CHANSON VALUES(2806,'On romeo street',2,NULL,'f','2008-03-12 15:06:06');
INSERT INTO CHANSON VALUES(2807,'I wish i was Picasso',2,NULL,'f','2008-03-12 08:41:59');
INSERT INTO CHANSON VALUES(2808,'Fool for love',2,NULL,'f','2008-03-12 13:09:40');
INSERT INTO CHANSON VALUES(2809,'Bullet',2,NULL,'f','2008-03-12 11:53:30');
INSERT INTO CHANSON VALUES(2810,'Put it down',2,NULL,'f','2008-03-12 09:59:20');
INSERT INTO CHANSON VALUES(2811,'Gone Again',2,NULL,'f','2008-03-12 18:12:44');
INSERT INTO CHANSON VALUES(2812,'Beneath the Southern Cross',2,NULL,'f','2008-03-12 10:16:43');
INSERT INTO CHANSON VALUES(2813,'About a Boy',2,NULL,'f','2008-03-12 08:47:26');
INSERT INTO CHANSON VALUES(2814,'My Madrigal',2,NULL,'f','2008-03-12 15:12:01');
INSERT INTO CHANSON VALUES(2815,'Summer Cannibals',2,NULL,'f','2008-03-12 19:05:56');
INSERT INTO CHANSON VALUES(2816,'Dead to the World',2,NULL,'f','2008-03-12 17:41:02');
INSERT INTO CHANSON VALUES(2817,'Wing',2,NULL,'f','2008-03-12 19:45:44');
INSERT INTO CHANSON VALUES(2818,'Ravens',2,NULL,'f','2008-04-24 10:53:52');
INSERT INTO CHANSON VALUES(2819,'Wicked Messenger',2,NULL,NULL,'2008-03-12 18:13:53');
INSERT INTO CHANSON VALUES(2820,'Fireflies',2,NULL,'f','2008-03-12 15:29:46');
INSERT INTO CHANSON VALUES(2821,'Farewell Reel',2,NULL,'f','2008-03-12 09:35:46');
INSERT INTO CHANSON VALUES(2822,'Hey Stoopid',2,NULL,'f','2008-03-23 13:28:58');
INSERT INTO CHANSON VALUES(2823,'Love''s A Loaded Gun',2,NULL,NULL,'2008-03-23 10:39:15');
INSERT INTO CHANSON VALUES(2824,'Snakebite',2,NULL,NULL,'2008-03-23 18:40:02');
INSERT INTO CHANSON VALUES(2825,'Burning Our Bed',2,NULL,'f','2008-03-23 12:16:15');
INSERT INTO CHANSON VALUES(2826,'Dangerous Tonight',2,NULL,'f','2008-03-23 12:13:20');
INSERT INTO CHANSON VALUES(2827,'Might As Well Be On Mars',2,NULL,'f','2008-03-23 11:02:01');
INSERT INTO CHANSON VALUES(2828,'Feed My Frankenstein',2,NULL,'f','2008-03-23 12:57:47');
INSERT INTO CHANSON VALUES(2829,'Hurricane Years',2,NULL,'f','2008-03-23 09:52:01');
INSERT INTO CHANSON VALUES(2830,'Little By Little',2,NULL,'f','2008-03-23 19:28:30');
INSERT INTO CHANSON VALUES(2831,'Die For You',2,NULL,'f','2008-03-23 17:34:06');
INSERT INTO CHANSON VALUES(2832,'Dirty Dreams',2,NULL,'f','2008-03-23 14:01:34');
INSERT INTO CHANSON VALUES(2833,'Wind-Up Toy',2,NULL,'f','2008-03-23 13:12:14');
INSERT INTO CHANSON VALUES(2834,'The Song Remains The Same',2,NULL,'f','2008-03-22 16:07:55');
INSERT INTO CHANSON VALUES(2835,'The Rain Song',2,NULL,'f','2008-03-12 17:28:11');
INSERT INTO CHANSON VALUES(2836,'D''yer Mak''er',2,NULL,'f','2008-03-20 08:51:25');
INSERT INTO CHANSON VALUES(2837,'No Quarter',2,NULL,'f','2008-03-12 12:10:27');
INSERT INTO CHANSON VALUES(2838,'Houses Of The Holy',2,NULL,'f','2008-04-07 15:55:51');
INSERT INTO CHANSON VALUES(2839,'Kashmir',2,NULL,'f','2008-03-12 13:31:25');
INSERT INTO CHANSON VALUES(2840,'Trampled Underfoot',2,NULL,'f','2008-03-12 10:36:18');
INSERT INTO CHANSON VALUES(2841,'Nobody''s Fault But Mine',2,NULL,'f','2008-03-12 10:35:46');
INSERT INTO CHANSON VALUES(2842,'Achilles Last Stand',2,NULL,'f','2008-03-12 16:20:21');
INSERT INTO CHANSON VALUES(2845,'A l''arrière des taxis',2,NULL,'f','2008-03-23 16:06:42');
INSERT INTO CHANSON VALUES(2846,'Aux sombres héros de l''amer',2,NULL,'f','2008-03-23 15:54:11');
INSERT INTO CHANSON VALUES(2847,'Le fleuve',2,NULL,'f','2008-03-23 17:56:02');
INSERT INTO CHANSON VALUES(2848,'What I need',2,NULL,'f','2008-04-07 12:11:56');
INSERT INTO CHANSON VALUES(2849,'Apprends à dormir',2,NULL,'f','2008-03-23 10:19:12');
INSERT INTO CHANSON VALUES(2850,'Sweet Mary',2,NULL,'f','2008-03-12 16:44:43');
INSERT INTO CHANSON VALUES(2851,'La chaleur',2,NULL,'f','2008-03-12 09:57:20');
INSERT INTO CHANSON VALUES(2852,'Les écorchés',2,NULL,NULL,'2008-03-23 10:55:16');
INSERT INTO CHANSON VALUES(2853,'Joey I',2,NULL,NULL,'2008-03-23 14:47:08');
INSERT INTO CHANSON VALUES(2854,'Joey II',2,NULL,'f','2008-03-23 19:13:30');
INSERT INTO CHANSON VALUES(2855,'The wound',2,NULL,'f','2008-03-12 14:54:37');
INSERT INTO CHANSON VALUES(2856,'Les dunes',2,NULL,'f','2008-03-12 10:30:31');
INSERT INTO CHANSON VALUES(2857,'New York avec toi',2,NULL,'f','2008-03-24 10:29:07');
INSERT INTO CHANSON VALUES(2858,'Loin de toi (un peu trop loin)',2,NULL,'f','2008-03-23 12:18:28');
INSERT INTO CHANSON VALUES(2859,'66 heures',2,NULL,'f','2008-03-12 13:31:48');
INSERT INTO CHANSON VALUES(2860,'Ce que je veux',2,NULL,'f','2008-03-12 16:12:33');
INSERT INTO CHANSON VALUES(2861,'Le gar on d''ascenseur',2,NULL,'f','2008-03-12 12:18:30');
INSERT INTO CHANSON VALUES(2862,'Oublie ça',2,NULL,'f','2008-03-23 16:42:41');
INSERT INTO CHANSON VALUES(2863,'T''as qu''ces mots',2,NULL,NULL,'2008-03-12 16:53:37');
INSERT INTO CHANSON VALUES(2864,'Le taxi las',2,NULL,'f','2008-03-12 19:26:25');
INSERT INTO CHANSON VALUES(2865,'Electric Cit',2,NULL,'f','2008-03-12 09:21:38');
INSERT INTO CHANSON VALUES(2866,'Un autre monde',2,NULL,'f','2008-03-12 15:51:33');
INSERT INTO CHANSON VALUES(2867,'Since I Don''t Have You',2,NULL,'f','2008-03-12 10:04:03');
INSERT INTO CHANSON VALUES(2868,'New Rose',2,NULL,'f','2008-03-12 17:29:22');
INSERT INTO CHANSON VALUES(2869,'Down On The Farm',2,NULL,'f','2008-03-12 11:56:54');
INSERT INTO CHANSON VALUES(2870,'Human Being',2,NULL,'f','2008-03-12 08:36:07');
INSERT INTO CHANSON VALUES(2872,'Ain''t It Fun',2,NULL,'f','2008-03-12 09:45:08');
INSERT INTO CHANSON VALUES(2873,'Buick Makane',2,NULL,'f','2008-03-12 17:26:01');
INSERT INTO CHANSON VALUES(2874,'Hair Of The Dog',2,NULL,'f','2008-03-12 13:23:27');
INSERT INTO CHANSON VALUES(2875,'Attitude',2,NULL,'f','2008-03-12 18:29:49');
INSERT INTO CHANSON VALUES(2876,'Black Leather',2,NULL,'f','2008-03-12 14:06:40');
INSERT INTO CHANSON VALUES(2877,'You Can''t Put Your Arms Around A Memory',2,NULL,'f','2008-03-12 08:21:45');
INSERT INTO CHANSON VALUES(2878,'I Don''t Care About You',2,NULL,'f','2008-03-12 09:08:15');
INSERT INTO CHANSON VALUES(2879,'Malaxe',2,NULL,'f','2008-03-12 14:23:12');
INSERT INTO CHANSON VALUES(2880,'La nuit je mens',2,NULL,'f','2008-03-12 13:27:49');
INSERT INTO CHANSON VALUES(2881,'Fantaisie militaire',2,NULL,'f','2008-03-12 14:04:49');
INSERT INTO CHANSON VALUES(2882,'2043',2,NULL,NULL,'2008-03-12 19:12:35');
INSERT INTO CHANSON VALUES(2883,'Mes prisons',2,NULL,NULL,'2008-03-12 09:02:01');
INSERT INTO CHANSON VALUES(2884,'Ode à la vie',2,NULL,'f','2008-03-12 09:30:24');
INSERT INTO CHANSON VALUES(2885,'Dehors',2,NULL,'f','2008-03-12 15:23:54');
INSERT INTO CHANSON VALUES(2886,'Samuel Hall',2,NULL,NULL,'2008-03-12 13:54:01');
INSERT INTO CHANSON VALUES(2887,'Aucun express',2,NULL,'f','2008-03-12 09:59:23');
INSERT INTO CHANSON VALUES(2888,'Au pavillon des lauriers',2,NULL,'f','2008-03-12 18:08:32');
INSERT INTO CHANSON VALUES(2889,'Sommes-nous',2,NULL,'f','2008-03-12 09:39:55');
INSERT INTO CHANSON VALUES(2890,'Angora',2,NULL,'f','2008-03-12 11:05:23');
INSERT INTO CHANSON VALUES(2891,'Bêle, bêle petite chèvre',2,NULL,'f','2008-03-12 09:38:28');
INSERT INTO CHANSON VALUES(2892,'Sur la trace des fées',2,NULL,'f','2008-03-12 19:37:41');
INSERT INTO CHANSON VALUES(2893,'Le nain de Stanislas',2,NULL,'f','2008-03-12 14:44:43');
INSERT INTO CHANSON VALUES(2894,'Jour après jour',2,NULL,'f','2008-03-12 15:53:13');
INSERT INTO CHANSON VALUES(2895,'Ode à Emile',2,NULL,'f','2008-03-12 08:30:36');
INSERT INTO CHANSON VALUES(2896,'Ego et Deus',2,NULL,'f','2008-03-12 18:56:31');
INSERT INTO CHANSON VALUES(2897,'J''irai dormir plus loin que ton sommeil',2,NULL,'f','2008-03-12 19:02:31');
INSERT INTO CHANSON VALUES(2898,'Auréalia',2,NULL,'f','2008-03-12 12:54:39');
INSERT INTO CHANSON VALUES(2899,'Les noces',2,NULL,'f','2008-03-12 18:01:19');
INSERT INTO CHANSON VALUES(2900,'Le marchand des planètes',2,NULL,'f','2008-03-12 17:20:24');
INSERT INTO CHANSON VALUES(2902,'Little T & A',2,NULL,'f','2008-05-23 14:34:11');
INSERT INTO CHANSON VALUES(2904,'She''s so cold',2,NULL,'f','2008-06-02 10:31:05.016727');
INSERT INTO CHANSON VALUES(2905,'Hang fire',2,NULL,'f','2008-06-02 09:18:36.600597');
INSERT INTO CHANSON VALUES(2906,'Miss you',2,NULL,'f','2008-04-13 13:59:31');
INSERT INTO CHANSON VALUES(2909,'Start me up',2,NULL,'f','2008-03-16 12:00:26');
INSERT INTO CHANSON VALUES(2912,'Années folles',2,NULL,'f','2008-03-12 11:35:50');
INSERT INTO CHANSON VALUES(2913,'Le vide',2,NULL,'f','2008-03-12 19:30:46');
INSERT INTO CHANSON VALUES(2914,'Paradis',2,NULL,'f','2008-03-12 13:26:48');
INSERT INTO CHANSON VALUES(2915,'Le matin au réveil',2,NULL,'f','2008-03-12 19:47:43');
INSERT INTO CHANSON VALUES(2916,'Les bêtes',2,NULL,'f','2008-03-12 15:39:44');
INSERT INTO CHANSON VALUES(2917,'Rêves',2,NULL,'f','2008-03-12 19:27:05');
INSERT INTO CHANSON VALUES(2918,'Ces idées là',2,NULL,'f','2008-03-12 12:39:33');
INSERT INTO CHANSON VALUES(2919,'J''attendrai',2,NULL,'f','2008-03-12 13:19:00');
INSERT INTO CHANSON VALUES(2920,'Lady Ann',2,NULL,'f','2008-03-12 09:41:01');
INSERT INTO CHANSON VALUES(2921,'Faux',2,NULL,'f','2008-03-12 14:45:36');
INSERT INTO CHANSON VALUES(2922,'Combien de nuits',2,NULL,'f','2008-03-12 18:04:11');
INSERT INTO CHANSON VALUES(2923,'Simple visite',2,NULL,'f','2008-03-12 16:00:42');
INSERT INTO CHANSON VALUES(2924,'Ode To My Family',2,NULL,NULL,'2008-03-12 14:27:09');
INSERT INTO CHANSON VALUES(2925,'I Can''t Be With You',2,NULL,'f','2008-03-12 11:26:56');
INSERT INTO CHANSON VALUES(2926,'Twenty One',2,NULL,'f','2008-03-12 08:04:35');
INSERT INTO CHANSON VALUES(2927,'Zombie',2,NULL,'f','2008-03-12 17:01:02');
INSERT INTO CHANSON VALUES(2928,'Empty',2,NULL,'f','2008-03-12 18:23:42');
INSERT INTO CHANSON VALUES(2929,'Everything I Said',2,NULL,'f','2008-03-12 13:48:02');
INSERT INTO CHANSON VALUES(2930,'The Icicle Melts',2,NULL,'f','2008-03-12 13:55:43');
INSERT INTO CHANSON VALUES(2931,'Disappointment',2,NULL,'f','2008-03-12 13:29:29');
INSERT INTO CHANSON VALUES(2932,'Ridiculous Thoughts',2,NULL,'f','2008-03-12 08:22:33');
INSERT INTO CHANSON VALUES(2933,'Dreaming My Dreams',2,NULL,'f','2008-03-12 11:06:33');
INSERT INTO CHANSON VALUES(2934,'Yeat''s Grave',2,NULL,'f','2008-03-12 19:37:01');
INSERT INTO CHANSON VALUES(2935,'Daffodil Lament',2,NULL,'f','2008-03-12 09:57:27');
INSERT INTO CHANSON VALUES(2936,'No Need To Argue',2,NULL,NULL,'2008-03-12 08:59:31');
INSERT INTO CHANSON VALUES(2937,'One Hit (To The Body)',2,NULL,NULL,'2008-05-26 09:32:17');
INSERT INTO CHANSON VALUES(2938,'Fight',2,NULL,'f','2008-06-02 09:34:49.364996');
INSERT INTO CHANSON VALUES(2939,'Harlem Shuffle',2,NULL,'f','2008-03-22 16:38:56');
INSERT INTO CHANSON VALUES(2940,'Hold Back',2,NULL,'f','2008-06-02 09:35:27.765021');
INSERT INTO CHANSON VALUES(2941,'Too Rude',2,NULL,'f','2008-06-02 09:35:50.841594');
INSERT INTO CHANSON VALUES(2942,'Winning Ugly',2,NULL,'f','2008-06-02 09:36:06.636639');
INSERT INTO CHANSON VALUES(2943,'Back To Zero',2,NULL,NULL,'2008-06-02 09:36:22.548159');
INSERT INTO CHANSON VALUES(2944,'Dirty Work',2,NULL,'f','2008-06-02 09:36:43.548438');
INSERT INTO CHANSON VALUES(2945,'Had It With You',2,NULL,'f','2008-06-02 10:27:15.272747');
INSERT INTO CHANSON VALUES(2946,'Sleep Tonight',2,NULL,'f','2008-06-02 10:27:32.096081');
INSERT INTO CHANSON VALUES(2947,'(Piano Instrumental)',2,NULL,NULL,'2008-06-02 11:20:16.805786');
INSERT INTO CHANSON VALUES(2948,'Sad Sad Sad',2,NULL,'f','2008-03-24 17:09:01');
INSERT INTO CHANSON VALUES(2949,'Mixed Emotions',2,NULL,'f','2008-05-27 14:18:42.240573');
INSERT INTO CHANSON VALUES(2950,'Terrifying',2,NULL,'f','2008-06-02 09:27:22.502637');
INSERT INTO CHANSON VALUES(2951,'Hold on to your hat',2,NULL,'f','2008-06-02 09:27:39.466362');
INSERT INTO CHANSON VALUES(2952,'Hearts for sale',2,NULL,'f','2008-06-02 09:28:00.857906');
INSERT INTO CHANSON VALUES(2953,'Blinded by love',2,NULL,'f','2008-06-02 09:28:19.694292');
INSERT INTO CHANSON VALUES(2954,'Rock and a hard place',2,NULL,'f','2008-04-13 10:47:05');
INSERT INTO CHANSON VALUES(2955,'Can''t be seen',2,NULL,'f','2008-06-02 09:29:19.558666');
INSERT INTO CHANSON VALUES(2956,'Almost hear you sigh',2,NULL,'f','2008-06-02 09:29:40.096004');
INSERT INTO CHANSON VALUES(2957,'Continental drift',2,NULL,'f','2008-06-02 09:29:56.980389');
INSERT INTO CHANSON VALUES(2958,'Break the spell',2,NULL,'f','2008-06-02 09:30:24.433308');
INSERT INTO CHANSON VALUES(2959,'Slipping away',2,NULL,'f','2008-06-02 11:22:47.974002');
INSERT INTO CHANSON VALUES(2960,'Roadhouse Blues',2,NULL,'f','2008-03-12 18:37:56');
INSERT INTO CHANSON VALUES(2961,'Waiting For The Sun',2,NULL,NULL,'2008-03-18 14:53:12');
INSERT INTO CHANSON VALUES(2962,'You Make Me Real',2,NULL,NULL,'2008-03-12 11:54:54');
INSERT INTO CHANSON VALUES(2963,'Peace Frog',2,NULL,'f','2008-03-12 15:36:46');
INSERT INTO CHANSON VALUES(2964,'Blue Sunday',2,NULL,'f','2008-03-12 18:28:17');
INSERT INTO CHANSON VALUES(2965,'Ship of Fools',2,NULL,NULL,'2008-03-12 10:53:00');
INSERT INTO CHANSON VALUES(2966,'Land Ho!',2,NULL,'f','2008-03-12 18:59:29');
INSERT INTO CHANSON VALUES(2967,'The Spy',2,NULL,'f','2008-03-12 18:22:46');
INSERT INTO CHANSON VALUES(2968,'Queen of the Highway',2,NULL,'f','2008-03-12 11:00:17');
INSERT INTO CHANSON VALUES(2969,'Indian Summer',2,NULL,'f','2008-03-12 10:53:35');
INSERT INTO CHANSON VALUES(2970,'Maggie M''Gill',2,NULL,'f','2008-03-12 11:46:13');
INSERT INTO CHANSON VALUES(2971,'Scarabée',2,NULL,'f','2008-03-23 10:20:07');
INSERT INTO CHANSON VALUES(2972,'Deux Clowns',2,NULL,'f','2008-03-12 12:39:01');
INSERT INTO CHANSON VALUES(2975,'Carnet De Route',2,NULL,'f','2008-03-12 12:18:00');
INSERT INTO CHANSON VALUES(2976,'J''suis Zinzin',2,NULL,'f','2008-03-12 12:10:59');
INSERT INTO CHANSON VALUES(2977,'Ainsi Squattent-ils',2,NULL,'f','2008-04-24 15:30:20');
INSERT INTO CHANSON VALUES(2978,'Quesako',2,NULL,'f','2008-03-12 18:00:22');
INSERT INTO CHANSON VALUES(2981,'La Danseuse de L''orient',2,NULL,'f','2008-03-12 14:42:02');
INSERT INTO CHANSON VALUES(2982,'Clockwork Beru',2,NULL,'f','2008-03-12 17:54:23');
INSERT INTO CHANSON VALUES(2983,'Sysyphus Part 1',6,NULL,NULL,'2008-03-12 18:18:03');
INSERT INTO CHANSON VALUES(2984,'Sysyphus Part 2',6,NULL,'f','2008-03-12 19:36:18');
INSERT INTO CHANSON VALUES(2985,'Sysyphus Part 3',6,NULL,'f','2008-03-12 14:41:26');
INSERT INTO CHANSON VALUES(2986,'Sysyphus Part 4',6,NULL,'f','2008-03-12 16:04:45');
INSERT INTO CHANSON VALUES(2987,'Grantchester Meadows',6,NULL,'f','2008-04-07 16:13:00');
INSERT INTO CHANSON VALUES(2988,'Several Species of Small Furry Animals Gathered Together in a Cave and Grooving with a Pict',6,NULL,'f','2008-03-12 16:28:55');
INSERT INTO CHANSON VALUES(2989,'The Narrow Way Part 1',6,NULL,'f','2008-03-12 16:21:56');
INSERT INTO CHANSON VALUES(2990,'The Narrow Way Part 2',6,NULL,'f','2008-03-12 08:00:12');
INSERT INTO CHANSON VALUES(2991,'The Narrow Way Part 3',6,NULL,'f','2008-03-12 13:57:39');
INSERT INTO CHANSON VALUES(2992,'The Grand Vizier''s Garden Party Part 1 Entrance',6,NULL,'f','2008-03-12 16:30:21');
INSERT INTO CHANSON VALUES(2993,'The Grand Vizier''s Garden Party Part 2 Entertainment',6,NULL,NULL,'2008-03-12 16:16:15');
INSERT INTO CHANSON VALUES(2994,'The Grand Vizier''s Garden Party Part 3 Exit',6,NULL,'f','2008-03-12 09:10:33');
INSERT INTO CHANSON VALUES(2995,'Baby Universal',2,NULL,'f','2008-06-07 18:20:02.071464');
INSERT INTO CHANSON VALUES(2996,'One Shot',2,NULL,'f','2008-06-07 18:20:44.63556');
INSERT INTO CHANSON VALUES(2997,'You Belong In Rock N''Roll',2,NULL,'f','2008-06-07 18:21:23.246155');
INSERT INTO CHANSON VALUES(2998,'If There Is Something',2,NULL,'f','2008-06-07 18:22:09.362963');
INSERT INTO CHANSON VALUES(2999,'Amlapura',2,NULL,'f','2008-04-07 14:03:38');
INSERT INTO CHANSON VALUES(3000,'Betty Wrong',2,NULL,'f','2008-06-07 18:22:36.71618');
INSERT INTO CHANSON VALUES(3001,'You Can''t Talk',2,NULL,'f','2008-06-07 18:22:56.13155');
INSERT INTO CHANSON VALUES(3002,'Stateside',2,NULL,'f','2008-06-07 18:23:12.471917');
INSERT INTO CHANSON VALUES(3003,'Shopping For Girls',2,NULL,'f','2008-06-07 18:02:53.764025');
INSERT INTO CHANSON VALUES(3004,'A Big Hurt',2,NULL,'f','2008-06-07 18:03:11.092577');
INSERT INTO CHANSON VALUES(3005,'Sorry',2,NULL,'f','2008-06-07 18:03:28.156356');
INSERT INTO CHANSON VALUES(3006,'Goodbye Mr. Ed',2,NULL,'f','2008-04-24 18:20:11');
INSERT INTO CHANSON VALUES(3007,'Une ambulance pour Elmo Lewis',2,NULL,'f','2008-03-12 15:58:48');
INSERT INTO CHANSON VALUES(3008,'Quand la banlieue descendra sur la ville',2,NULL,'f','2008-03-12 17:28:29');
INSERT INTO CHANSON VALUES(3009,'Le Touquet juillet 1925',2,NULL,'f','2008-03-12 16:25:50');
INSERT INTO CHANSON VALUES(3010,'Also spracht Winnie l''ourson',2,NULL,'f','2008-03-12 15:06:52');
INSERT INTO CHANSON VALUES(3011,'Guichet 102',2,NULL,'f','2008-03-12 08:44:35');
INSERT INTO CHANSON VALUES(3012,'Joli Mai mois de Marie',2,NULL,'f','2008-03-12 17:18:22');
INSERT INTO CHANSON VALUES(3013,'Camélia : huile sur toile',2,NULL,NULL,'2008-03-12 15:05:34');
INSERT INTO CHANSON VALUES(3014,'Parano-Safari en ego-trip-transit ou comment plumer son ange-gardien',2,NULL,'f','2008-03-12 12:31:28');
INSERT INTO CHANSON VALUES(3015,'Éloge de la tristesse',2,NULL,'f','2008-03-12 14:19:07');
INSERT INTO CHANSON VALUES(3016,'Roots & déroutes + croisement',2,NULL,'f','2008-03-12 09:22:54');
INSERT INTO CHANSON VALUES(3017,'Les fastes de la solitude',2,NULL,'f','2008-03-12 17:00:52');
INSERT INTO CHANSON VALUES(3018,'New Coat of Paint',2,NULL,'f','2008-03-12 15:47:21');
INSERT INTO CHANSON VALUES(3019,'San Diego Serenade',2,NULL,'f','2008-03-12 08:28:46');
INSERT INTO CHANSON VALUES(3020,'Semi Suite',2,NULL,'f','2008-03-12 19:06:53');
INSERT INTO CHANSON VALUES(3021,'Shiver Me Timbers',2,NULL,'f','2008-03-12 17:09:37');
INSERT INTO CHANSON VALUES(3022,'Diamonds on My Windshield',2,NULL,'f','2008-03-12 12:58:56');
INSERT INTO CHANSON VALUES(3023,'(Looking for) The Heart of Saturday Night',2,NULL,NULL,'2008-03-12 17:34:02');
INSERT INTO CHANSON VALUES(3024,'Fumblin'' With the Blues',2,NULL,'f','2008-03-12 12:54:33');
INSERT INTO CHANSON VALUES(3025,'Please Call Me, Baby',2,NULL,'f','2008-03-12 17:29:52');
INSERT INTO CHANSON VALUES(3026,'Depot, Depot',2,NULL,'f','2008-03-12 19:34:15');
INSERT INTO CHANSON VALUES(3027,'Drunk on the Moon',2,NULL,NULL,'2008-03-12 18:21:15');
INSERT INTO CHANSON VALUES(3028,'The Ghosts of Saturday Night (After Hours at Napoleone''s Pizza House)',2,NULL,NULL,'2008-03-12 16:57:03');
INSERT INTO CHANSON VALUES(3029,'Pure Morning',2,NULL,'f','2008-03-23 09:02:32');
INSERT INTO CHANSON VALUES(3030,'Brick Shithouse',2,NULL,'f','2008-03-12 18:57:38');
INSERT INTO CHANSON VALUES(3031,'You Don''t Care About Us',2,NULL,'f','2008-03-12 17:45:47');
INSERT INTO CHANSON VALUES(3032,'Ask For Answers',2,NULL,'f','2008-03-12 12:08:46');
INSERT INTO CHANSON VALUES(3033,'Without You I''m Nothing',2,NULL,'f','2008-03-12 12:54:20');
INSERT INTO CHANSON VALUES(3034,'Allergic (To Thoughts Of Mother Earth)',2,NULL,'f','2008-03-12 12:14:15');
INSERT INTO CHANSON VALUES(3035,'The Crawl',2,NULL,'f','2008-03-12 19:03:44');
INSERT INTO CHANSON VALUES(3036,'Every You Every Me',2,NULL,'f','2008-03-12 17:00:19');
INSERT INTO CHANSON VALUES(3037,'My Sweet Prince',2,NULL,'f','2008-03-12 08:51:40');
INSERT INTO CHANSON VALUES(3038,'Summer''s Gone',2,NULL,'f','2008-03-12 12:36:38');
INSERT INTO CHANSON VALUES(3039,'Scared Of Girls',2,NULL,NULL,'2008-03-12 12:42:40');
INSERT INTO CHANSON VALUES(3040,'Burger Queen',2,NULL,'f','2008-03-12 19:34:38');
INSERT INTO CHANSON VALUES(3041,'Vicious',2,NULL,'f','2008-03-12 14:20:23');
INSERT INTO CHANSON VALUES(3042,'Andy''s Chest',2,NULL,'f','2008-03-12 12:43:32');
INSERT INTO CHANSON VALUES(3043,'Perfect Day',2,NULL,'f','2008-03-12 09:03:26');
INSERT INTO CHANSON VALUES(3044,'Hangin'' ''round',2,NULL,'f','2008-03-12 13:26:40');
INSERT INTO CHANSON VALUES(3045,'Walk On The Wild Side',2,NULL,'f','2008-03-12 16:22:43');
INSERT INTO CHANSON VALUES(3046,'Make Up',2,NULL,'f','2008-03-12 13:12:43');
INSERT INTO CHANSON VALUES(3047,'Satellite Of Love',2,NULL,'f','2008-03-12 17:16:35');
INSERT INTO CHANSON VALUES(3048,'Wagon Wheel',2,NULL,'f','2008-03-12 13:37:12');
INSERT INTO CHANSON VALUES(3049,'New York Telephone Conversation',2,NULL,'f','2008-03-12 09:01:54');
INSERT INTO CHANSON VALUES(3050,'I''m So Free',2,NULL,'f','2008-03-12 17:58:29');
INSERT INTO CHANSON VALUES(3051,'Goodnight Ladies',2,NULL,'f','2008-03-12 13:32:49');
INSERT INTO CHANSON VALUES(3052,'Blew',2,NULL,'f','2008-03-12 18:54:33');
INSERT INTO CHANSON VALUES(3053,'Floyd The Barber',2,NULL,'f','2008-03-12 12:02:37');
INSERT INTO CHANSON VALUES(3054,'About A Girl',2,NULL,'f','2008-03-12 17:31:03');
INSERT INTO CHANSON VALUES(3055,'School',2,NULL,'f','2008-03-12 13:16:26');
INSERT INTO CHANSON VALUES(3056,'Love Buzz',2,NULL,'f','2008-03-12 10:46:38');
INSERT INTO CHANSON VALUES(3057,'Paper Cuts',2,NULL,'f','2008-03-12 19:34:55');
INSERT INTO CHANSON VALUES(3058,'Negative Creep',2,NULL,'f','2008-03-12 14:04:32');
INSERT INTO CHANSON VALUES(3059,'Scoff',2,NULL,'f','2008-03-12 16:12:34');
INSERT INTO CHANSON VALUES(3060,'Swap Meet',2,NULL,NULL,'2008-03-12 15:00:32');
INSERT INTO CHANSON VALUES(3061,'Mr. Moustache',2,NULL,NULL,'2008-03-12 09:27:05');
INSERT INTO CHANSON VALUES(3062,'Sifting',2,NULL,'f','2008-03-12 19:17:59');
INSERT INTO CHANSON VALUES(3063,'Big Cheese',2,NULL,'f','2008-03-12 14:39:02');
INSERT INTO CHANSON VALUES(3064,'Downer',2,NULL,NULL,'2008-03-12 09:27:33');
INSERT INTO CHANSON VALUES(3065,'Ame errante',2,NULL,'f','2008-03-12 10:56:50');
INSERT INTO CHANSON VALUES(3066,'Tank',2,NULL,'f','2008-03-12 15:08:36');
INSERT INTO CHANSON VALUES(3067,'Seigneur Tigre',2,NULL,'f','2008-03-12 11:04:11');
INSERT INTO CHANSON VALUES(3068,'Fille du Viêt-Nam',2,NULL,NULL,'2008-03-12 10:36:15');
INSERT INTO CHANSON VALUES(3069,'Tango Massaï',2,NULL,'f','2008-03-12 16:20:27');
INSERT INTO CHANSON VALUES(3070,'Haute-Région',2,NULL,'f','2008-03-12 11:59:28');
INSERT INTO CHANSON VALUES(3071,'Kalachnikov style',2,NULL,'f','2008-03-12 18:07:55');
INSERT INTO CHANSON VALUES(3072,'Elephant reggae',2,NULL,'f','2008-03-12 19:05:12');
INSERT INTO CHANSON VALUES(3073,'Brigade d''amour',2,NULL,'f','2008-03-12 19:35:51');
INSERT INTO CHANSON VALUES(3074,'Du cté du Laos',2,NULL,'f','2008-03-12 19:43:19');
INSERT INTO CHANSON VALUES(3075,'La complainte des ouvriers',2,NULL,'f','2008-03-12 14:55:15');
INSERT INTO CHANSON VALUES(3076,'Les baleines',2,NULL,'f','2008-03-12 12:33:24');
INSERT INTO CHANSON VALUES(3077,'La pluie qui tombe',2,NULL,'f','2008-03-12 19:49:28');
INSERT INTO CHANSON VALUES(3078,'Les îles au soleil (los)',2,NULL,'f','2008-03-12 10:01:05');
INSERT INTO CHANSON VALUES(3079,'Allison',2,NULL,'f','2008-03-27 13:46:26');
INSERT INTO CHANSON VALUES(3080,'Grande sensation',2,NULL,'f','2008-03-12 18:06:26');
INSERT INTO CHANSON VALUES(3081,'Wibration',2,NULL,'f','2008-03-12 12:58:34');
INSERT INTO CHANSON VALUES(3082,'Comme un ange (qui pleure)',2,NULL,'f','2008-03-12 11:56:39');
INSERT INTO CHANSON VALUES(3083,'Les bottes rouges',2,NULL,'f','2008-03-12 13:53:15');
INSERT INTO CHANSON VALUES(3084,'J''y crois',2,NULL,'f','2008-03-12 12:52:59');
INSERT INTO CHANSON VALUES(3085,'Euroslow',2,NULL,'f','2008-03-12 15:25:54');
INSERT INTO CHANSON VALUES(3086,'Le ciel est un océan',2,NULL,'f','2008-03-12 19:48:27');
INSERT INTO CHANSON VALUES(3087,'Les anges',2,NULL,'f','2008-03-12 11:47:17');
INSERT INTO CHANSON VALUES(3088,'Hear It',2,NULL,'f','2008-03-12 17:57:18');
INSERT INTO CHANSON VALUES(3089,'Shades Of Truth',2,NULL,'f','2008-03-12 18:23:05');
INSERT INTO CHANSON VALUES(3090,'All Fantastic Images',2,NULL,NULL,'2008-03-12 12:16:11');
INSERT INTO CHANSON VALUES(3091,'The Biggest Killer In American History',2,NULL,'f','2008-03-12 17:37:09');
INSERT INTO CHANSON VALUES(3092,'No Substance',2,NULL,'f','2008-03-12 12:54:06');
INSERT INTO CHANSON VALUES(3093,'Raise Your Voice!',2,NULL,'f','2008-03-12 08:23:59');
INSERT INTO CHANSON VALUES(3094,'Sowing The Seeds Of Utopia',2,NULL,'f','2008-03-12 11:43:51');
INSERT INTO CHANSON VALUES(3095,'The Hippy Killers',2,NULL,NULL,'2008-03-12 11:23:16');
INSERT INTO CHANSON VALUES(3096,'The State Of The End Of The Millennium Address',2,NULL,NULL,'2008-03-12 10:18:05');
INSERT INTO CHANSON VALUES(3097,'The Voracious March Of Godliness',2,NULL,'f','2008-03-26 15:38:52');
INSERT INTO CHANSON VALUES(3098,'Mediocre Minds',2,NULL,'f','2008-03-12 19:26:49');
INSERT INTO CHANSON VALUES(3099,'Victims Of The Revolution',2,NULL,'f','2008-03-12 10:20:13');
INSERT INTO CHANSON VALUES(3100,'Strange Denial',2,NULL,'f','2008-03-12 11:41:29');
INSERT INTO CHANSON VALUES(3101,'At The Mercy Of Imbeciles',2,NULL,'f','2008-03-12 14:28:07');
INSERT INTO CHANSON VALUES(3102,'The Same Person',2,NULL,'f','2008-03-12 16:49:01');
INSERT INTO CHANSON VALUES(3103,'In So Many Ways',2,NULL,'f','2008-03-12 17:50:24');
INSERT INTO CHANSON VALUES(3104,'L''ascenseur de 22h43 (1ère partie)',2,NULL,'f','2008-03-12 17:07:08');
INSERT INTO CHANSON VALUES(3105,'La fin du St Empire Romain-Germanique',2,NULL,'f','2008-03-12 15:23:32');
INSERT INTO CHANSON VALUES(3106,'Je t''en remets au vent',2,NULL,'f','2008-03-12 18:34:51');
INSERT INTO CHANSON VALUES(3107,'La maison Borniol',2,NULL,'f','2008-03-12 19:12:29');
INSERT INTO CHANSON VALUES(3108,'La cancoillote',2,NULL,NULL,'2008-03-12 18:07:55');
INSERT INTO CHANSON VALUES(3109,'L''ascenseur de 22h43 (2ème partie)',2,NULL,NULL,'2008-03-12 16:21:15');
INSERT INTO CHANSON VALUES(3110,'Première descente aux enfers par la face Nord',2,NULL,'f','2008-03-12 19:41:56');
INSERT INTO CHANSON VALUES(3111,'22 Mai',2,NULL,'f','2008-03-12 12:11:25');
INSERT INTO CHANSON VALUES(3112,'La deche, le twist et le reste',2,NULL,'f','2008-03-12 14:52:14');
INSERT INTO CHANSON VALUES(3113,'La fille du coupeur de joints',2,NULL,'f','2008-03-12 14:38:05');
INSERT INTO CHANSON VALUES(3114,'Le chant du fou',2,NULL,'f','2008-03-12 19:24:13');
INSERT INTO CHANSON VALUES(3115,'Au cœur de la nuit',2,NULL,'f','2008-04-13 18:27:46');
INSERT INTO CHANSON VALUES(3116,'Ploum Ploum',2,NULL,NULL,'2008-03-12 09:01:37');
INSERT INTO CHANSON VALUES(3117,'Pourquoi n''essaies-tu pas',2,NULL,NULL,'2008-03-12 15:56:11');
INSERT INTO CHANSON VALUES(3118,'Seul',2,NULL,'f','2008-03-12 14:55:24');
INSERT INTO CHANSON VALUES(3119,'Laisse tomber',2,NULL,'f','2008-03-12 19:47:32');
INSERT INTO CHANSON VALUES(3120,'Un homme + une femme',2,NULL,'f','2008-03-12 19:30:54');
INSERT INTO CHANSON VALUES(3121,'Les ils et les ons',2,NULL,'f','2008-03-12 10:25:35');
INSERT INTO CHANSON VALUES(3122,'Argent trop cher',2,NULL,'f','2008-03-12 09:49:46');
INSERT INTO CHANSON VALUES(3123,'Ordinaire',2,NULL,'f','2008-03-12 14:20:39');
INSERT INTO CHANSON VALUES(3124,'2000 nuits',2,NULL,'f','2008-03-12 17:53:17');
INSERT INTO CHANSON VALUES(3125,'Fleur de ma ville',2,NULL,'f','2008-03-12 18:51:42');
INSERT INTO CHANSON VALUES(3126,'La laisse',2,NULL,'f','2008-03-12 09:58:44');
INSERT INTO CHANSON VALUES(3127,'Le silence',2,NULL,NULL,'2008-03-12 16:37:40');
INSERT INTO CHANSON VALUES(3128,'Hip kit',2,NULL,'f','2008-03-23 19:08:36');
INSERT INTO CHANSON VALUES(3129,'Smog',2,NULL,'f','2008-03-23 12:08:24');
INSERT INTO CHANSON VALUES(3130,'Mandolino City',2,NULL,'f','2008-03-23 18:03:54');
INSERT INTO CHANSON VALUES(3131,'Le petit train',2,NULL,'f','2008-03-23 17:14:19');
INSERT INTO CHANSON VALUES(3132,'Perfect eyes',2,NULL,'f','2008-03-23 12:22:09');
INSERT INTO CHANSON VALUES(3133,'Tongue dance',2,NULL,'f','2008-03-23 10:55:30');
INSERT INTO CHANSON VALUES(3134,'Singing in the shower',2,NULL,'f','2008-05-22 08:43:28');
INSERT INTO CHANSON VALUES(3135,'Petite fille princesse',2,NULL,'f','2008-03-23 17:43:23');
INSERT INTO CHANSON VALUES(3136,'Harpie & Harpo',2,NULL,'f','2008-03-23 09:37:15');
INSERT INTO CHANSON VALUES(3137,'Ailleurs',2,NULL,'f','2008-03-23 17:44:14');
INSERT INTO CHANSON VALUES(3138,'Live in Las Vegas',2,NULL,'f','2008-03-23 14:29:52');
INSERT INTO CHANSON VALUES(3139,'In the Air Tonight',2,NULL,'f','2008-03-12 11:26:00');
INSERT INTO CHANSON VALUES(3140,'This Must Be Love',2,NULL,'f','2008-03-12 18:47:08');
INSERT INTO CHANSON VALUES(3141,'Behind the Lines',2,NULL,'f','2008-03-12 11:40:11');
INSERT INTO CHANSON VALUES(3142,'The Roof is Leaking',2,NULL,'f','2008-03-12 10:28:26');
INSERT INTO CHANSON VALUES(3143,'Droned',2,NULL,NULL,'2008-03-12 14:51:48');
INSERT INTO CHANSON VALUES(3144,'Hand in Hand',2,NULL,'f','2008-03-12 16:02:44');
INSERT INTO CHANSON VALUES(3145,'I Missed Again',2,NULL,'f','2008-03-12 10:51:28');
INSERT INTO CHANSON VALUES(3146,'You Know What I Mean',2,NULL,'f','2008-03-12 14:58:05');
INSERT INTO CHANSON VALUES(3147,'Thunder and Lightning',2,NULL,'f','2008-03-12 18:48:50');
INSERT INTO CHANSON VALUES(3148,'I''m Not Moving',2,NULL,'f','2008-03-12 08:23:20');
INSERT INTO CHANSON VALUES(3149,'If Leaving Me Is Easy',2,NULL,'f','2008-03-12 19:38:46');
INSERT INTO CHANSON VALUES(3150,'Tomorrow Never Knows',2,NULL,NULL,'2008-03-12 19:30:33');
INSERT INTO CHANSON VALUES(3151,'Odéon',5,NULL,NULL,'2008-03-12 09:47:14');
INSERT INTO CHANSON VALUES(3152,'Le Promeneur',5,NULL,'f','2008-03-12 11:58:43');
INSERT INTO CHANSON VALUES(3153,'Emma',5,NULL,NULL,'2008-03-12 16:30:35');
INSERT INTO CHANSON VALUES(3154,'Petit Testament',5,NULL,'f','2008-03-12 14:10:37');
INSERT INTO CHANSON VALUES(3155,'Le Repenti',5,NULL,'f','2008-03-12 11:21:28');
INSERT INTO CHANSON VALUES(3156,'Gardez Vos Rêves',5,NULL,'f','2008-03-12 17:56:27');
INSERT INTO CHANSON VALUES(3157,'L''Amant De Secours',5,NULL,'f','2008-03-12 18:46:16');
INSERT INTO CHANSON VALUES(3158,'Petite âme sur',5,NULL,'f','2008-03-24 16:51:39');
INSERT INTO CHANSON VALUES(3159,'Quand J''Étais Un Voyou',5,NULL,'f','2008-03-12 08:48:17');
INSERT INTO CHANSON VALUES(3160,'Ephémère Éternité',5,NULL,'f','2008-03-12 17:46:48');
INSERT INTO CHANSON VALUES(3161,'Je M''En Irai',5,NULL,'f','2008-03-12 12:52:35');
INSERT INTO CHANSON VALUES(3162,'Paris a le cur tendre',5,NULL,'f','2008-03-24 15:09:34');
INSERT INTO CHANSON VALUES(3164,'The One To Sing The Blues',2,NULL,'f','2008-03-12 18:26:15');
INSERT INTO CHANSON VALUES(3165,'I''m So Bad (Baby I Don''t Care)',2,NULL,'f','2008-03-12 14:43:37');
INSERT INTO CHANSON VALUES(3166,'No Voices In The Sky',2,NULL,'f','2008-03-12 19:28:34');
INSERT INTO CHANSON VALUES(3167,'Going To Brazil',2,NULL,'f','2008-04-11 16:36:50');
INSERT INTO CHANSON VALUES(3168,'Nightmare / The Dreamtime',2,NULL,'f','2008-03-12 13:19:21');
INSERT INTO CHANSON VALUES(3169,'Love Me Forever',2,NULL,'f','2008-03-12 16:00:12');
INSERT INTO CHANSON VALUES(3170,'Angel City',2,NULL,'f','2008-03-12 12:01:01');
INSERT INTO CHANSON VALUES(3171,'Make My Day',2,NULL,'f','2008-03-12 16:48:47');
INSERT INTO CHANSON VALUES(3172,'Ramones',2,NULL,'f','2008-03-12 13:09:39');
INSERT INTO CHANSON VALUES(3173,'Shut You Down',2,NULL,'f','2008-03-12 08:45:49');
INSERT INTO CHANSON VALUES(3174,'1916',2,NULL,'f','2008-03-12 15:03:43');
INSERT INTO CHANSON VALUES(3175,'Hey You',6,NULL,'f','2008-03-12 16:57:09');
INSERT INTO CHANSON VALUES(3176,'Is There Anybody Out There?',6,NULL,'f','2008-03-12 08:27:52');
INSERT INTO CHANSON VALUES(3177,'Nobody Home',6,NULL,'f','2008-03-23 15:26:21');
INSERT INTO CHANSON VALUES(3178,'Vera',6,NULL,'f','2008-03-12 10:53:40');
INSERT INTO CHANSON VALUES(3179,'Bring the Boys Back Home',6,NULL,NULL,'2008-03-12 14:36:40');
INSERT INTO CHANSON VALUES(3180,'Comfortably Numb',6,NULL,'f','2008-03-12 17:59:42');
INSERT INTO CHANSON VALUES(3181,'The Show Must Go On',6,NULL,'f','2008-03-12 17:40:31');
INSERT INTO CHANSON VALUES(3182,'In The Flesh',6,NULL,'f','2008-03-12 14:09:40');
INSERT INTO CHANSON VALUES(3183,'Run Like Hell',6,NULL,'f','2008-03-12 10:14:26');
INSERT INTO CHANSON VALUES(3184,'Waiting for the Worms',6,NULL,'f','2008-03-12 08:53:29');
INSERT INTO CHANSON VALUES(3185,'Stop',6,NULL,NULL,'2008-03-12 17:37:27');
INSERT INTO CHANSON VALUES(3186,'The Trial',6,NULL,NULL,'2008-03-12 19:38:54');
INSERT INTO CHANSON VALUES(3187,'Outside the Wall',6,NULL,'f','2008-03-12 17:16:21');
INSERT INTO CHANSON VALUES(3188,'Charlie Big Potato',2,NULL,'f','2008-03-12 10:28:15');
INSERT INTO CHANSON VALUES(3189,'On My Hotel T.V.',2,NULL,NULL,'2008-03-12 18:01:52');
INSERT INTO CHANSON VALUES(3190,'We Don''t Need Who You Think You Are',2,NULL,'f','2008-03-12 14:47:52');
INSERT INTO CHANSON VALUES(3191,'Tracy''s Flaw',2,NULL,'f','2008-03-12 10:34:32');
INSERT INTO CHANSON VALUES(3192,'The Skank Heads',2,NULL,'f','2008-03-12 16:09:41');
INSERT INTO CHANSON VALUES(3193,'Lately',2,NULL,'f','2008-03-12 13:23:55');
INSERT INTO CHANSON VALUES(3194,'Secretly',2,NULL,'f','2008-03-12 18:27:49');
INSERT INTO CHANSON VALUES(3195,'Good Things Don''t Always Come To You',2,NULL,'f','2008-03-12 12:14:26');
INSERT INTO CHANSON VALUES(3196,'Cheap Honesty',2,NULL,'f','2008-03-12 17:10:05');
INSERT INTO CHANSON VALUES(3197,'You''ll Follow Me Down',2,NULL,'f','2008-03-12 16:00:21');
INSERT INTO CHANSON VALUES(3198,'And This Is Nothing That I Thought I Had',2,NULL,'f','2008-03-12 09:10:49');
INSERT INTO CHANSON VALUES(3199,'I''m Not Afraid',2,NULL,'f','2008-03-12 12:01:50');
INSERT INTO CHANSON VALUES(3200,'(Get Your Kicks On) Route 66',2,NULL,'f','2008-04-11 08:57:46');
INSERT INTO CHANSON VALUES(3201,'I Just Wanna Make Love To You',2,NULL,'f','2008-03-22 10:33:37');
INSERT INTO CHANSON VALUES(3202,'Honest I Do',2,NULL,NULL,'2008-04-11 12:17:54');
INSERT INTO CHANSON VALUES(3203,'I Need You Baby (Mona)',2,NULL,'f','2008-06-02 10:57:05.745338');
INSERT INTO CHANSON VALUES(3204,'Now I''ve Got A Witness (Like Uncle Phil And Uncle Gene)',2,NULL,'f','2008-06-07 19:07:37.941627');
INSERT INTO CHANSON VALUES(3206,'I''m A King Bee',2,NULL,'f','2008-06-02 10:13:45.617332');
INSERT INTO CHANSON VALUES(3208,'Tell Me (You''re Coming Back)',2,NULL,'f','2008-05-22 10:27:06');
INSERT INTO CHANSON VALUES(3209,'Can I Get A Witness',2,NULL,'f','2008-06-02 10:15:04.280297');
INSERT INTO CHANSON VALUES(3210,'You Can Make It If You Try',2,NULL,'f','2008-06-02 10:15:27.98163');
INSERT INTO CHANSON VALUES(3211,'Walkiing The Dog',2,NULL,'f','2008-06-02 10:45:47.400254');
INSERT INTO CHANSON VALUES(3212,'Tom Traubert''s Blues (Four Sheets To The Wind In Copenhagen)',2,NULL,'f','2008-03-12 19:48:47');
INSERT INTO CHANSON VALUES(3213,'Step Right Up',2,NULL,'f','2008-03-12 17:09:49');
INSERT INTO CHANSON VALUES(3214,'Jitterburg Boy (Sharing A Curbstone With Chuck E. Weiss, Robert Marchese, Poul Body And The Mug And Artie)',2,NULL,'f','2008-03-12 15:22:23');
INSERT INTO CHANSON VALUES(3215,'I Wish I Was In New Orleans (In The Ninth Ward)',2,NULL,'f','2008-03-12 11:26:09');
INSERT INTO CHANSON VALUES(3216,'The Piano Has Been Drinking (Not Me) (An Evening With Pete King)',2,NULL,'f','2008-03-12 13:04:41');
INSERT INTO CHANSON VALUES(3217,'Invitation To The Blues',2,NULL,NULL,'2008-03-12 17:22:38');
INSERT INTO CHANSON VALUES(3218,'Pasties And A G-String (At The Two O''Clock Club)',2,NULL,NULL,'2008-03-12 14:37:28');
INSERT INTO CHANSON VALUES(3219,'Bad Liver And A Broken Heart (In Lowell)',2,NULL,'f','2008-03-12 17:40:39');
INSERT INTO CHANSON VALUES(3220,'The One That Got Away',2,NULL,'f','2008-03-12 10:11:39');
INSERT INTO CHANSON VALUES(3221,'Small Change (Got Rained On With His Own)',2,NULL,'f','2008-03-12 17:46:22');
INSERT INTO CHANSON VALUES(3222,'I Can''t Wait To Get Off Work (And See My Baby On Montgomery Avenue)',2,NULL,'f','2008-03-12 13:43:11');
INSERT INTO CHANSON VALUES(3223,'Beauty And The Beast',2,NULL,'f','2008-06-07 18:09:42.96232');
INSERT INTO CHANSON VALUES(3224,'Joe The Lion',2,NULL,'f','2008-06-07 18:10:02.575289');
INSERT INTO CHANSON VALUES(3225,'''Heroes''',2,NULL,'f','2008-06-07 18:11:05.565763');
INSERT INTO CHANSON VALUES(3226,'Sons Of The Silent Age',2,NULL,'f','2008-04-07 11:56:51');
INSERT INTO CHANSON VALUES(3227,'Blackout',2,NULL,NULL,'2008-06-07 18:11:57.319229');
INSERT INTO CHANSON VALUES(3228,'V-2 Schneider',2,NULL,'f','2008-06-07 19:59:11.073736');
INSERT INTO CHANSON VALUES(3229,'Sense Of Doubt',2,NULL,'f','2008-06-07 19:41:19.237225');
INSERT INTO CHANSON VALUES(3230,'Moss Garden',2,NULL,'f','2008-06-07 19:52:20.32616');
INSERT INTO CHANSON VALUES(3231,'Neukoeln',2,NULL,'f','2008-06-07 20:23:58.709799');
INSERT INTO CHANSON VALUES(3232,'The Secret Life Of Arabia',2,NULL,'f','2008-06-07 15:58:43.794461');
INSERT INTO CHANSON VALUES(3233,'Abdulmajid',2,NULL,'f','2008-06-07 19:06:29.829756');
INSERT INTO CHANSON VALUES(3235,'Yes It''s Fucking Political',2,NULL,'f','2008-03-12 15:37:12');
INSERT INTO CHANSON VALUES(3236,'All I Want',2,NULL,'f','2008-03-12 11:03:34');
INSERT INTO CHANSON VALUES(3237,'She''s My Heroine',2,NULL,'f','2008-03-12 13:39:23');
INSERT INTO CHANSON VALUES(3238,'Infidelity (Only You)',2,NULL,'f','2008-03-12 16:56:01');
INSERT INTO CHANSON VALUES(3239,'Hedonism (Just Because You Feel Good)',2,NULL,'f','2008-03-12 11:53:13');
INSERT INTO CHANSON VALUES(3240,'Twisted (Everyday Hurts)',2,NULL,'f','2008-03-12 14:17:09');
INSERT INTO CHANSON VALUES(3241,'We Love Your Apathy',2,NULL,'f','2008-05-22 16:02:23');
INSERT INTO CHANSON VALUES(3242,'Brazen (Weep)',2,NULL,'f','2008-08-13 07:26:39.96367');
INSERT INTO CHANSON VALUES(3243,'Pickin On Me',2,NULL,'f','2008-03-12 13:20:17');
INSERT INTO CHANSON VALUES(3244,'Milk Is My Sugar',2,NULL,'f','2008-04-24 09:21:38');
INSERT INTO CHANSON VALUES(3245,'Glorious Pop Song',2,NULL,'f','2008-03-12 14:03:13');
INSERT INTO CHANSON VALUES(3246,'Smells Like Teen Spirit',2,NULL,'f','2008-03-12 12:08:34');
INSERT INTO CHANSON VALUES(3247,'In Bloom',2,NULL,'f','2008-03-12 19:25:09');
INSERT INTO CHANSON VALUES(3248,'Come As You Are',2,NULL,'f','2008-03-12 08:02:46');
INSERT INTO CHANSON VALUES(3249,'Breed',2,NULL,NULL,'2008-03-27 11:22:49');
INSERT INTO CHANSON VALUES(3250,'Lithium',2,NULL,NULL,'2008-03-12 18:51:29');
INSERT INTO CHANSON VALUES(3251,'Polly',2,NULL,'f','2008-03-12 11:33:25');
INSERT INTO CHANSON VALUES(3252,'Territorial Pissings',2,NULL,NULL,'2008-03-12 11:52:18');
INSERT INTO CHANSON VALUES(3253,'Drain You',2,NULL,'f','2008-03-12 14:24:36');
INSERT INTO CHANSON VALUES(3254,'Lounge Act',2,NULL,'f','2008-03-12 16:51:57');
INSERT INTO CHANSON VALUES(3255,'Stay Away',2,NULL,'f','2008-03-12 19:22:00');
INSERT INTO CHANSON VALUES(3256,'On A Plain',2,NULL,'f','2008-03-12 10:46:09');
INSERT INTO CHANSON VALUES(3257,'Something In The Way',2,NULL,'f','2008-03-12 17:45:34');
INSERT INTO CHANSON VALUES(3258,'Mano Negra',2,NULL,'f','2008-03-12 18:50:37');
INSERT INTO CHANSON VALUES(3259,'Ronde de nuit',2,NULL,'f','2008-03-12 16:07:59');
INSERT INTO CHANSON VALUES(3260,'Baby you''re mine',2,NULL,'f','2008-03-12 14:59:51');
INSERT INTO CHANSON VALUES(3261,'Indios de Barcelona',2,NULL,'f','2008-03-12 08:15:24');
INSERT INTO CHANSON VALUES(3262,'Rock island line',2,NULL,'f','2008-03-12 13:33:17');
INSERT INTO CHANSON VALUES(3263,'Noche de accion',2,NULL,'f','2008-03-12 16:05:42');
INSERT INTO CHANSON VALUES(3264,'Darling darling',2,NULL,'f','2008-03-12 12:45:33');
INSERT INTO CHANSON VALUES(3265,'Killin''rats',2,NULL,'f','2008-03-12 11:43:56');
INSERT INTO CHANSON VALUES(3266,'Mala vida',2,NULL,'f','2008-03-12 11:55:42');
INSERT INTO CHANSON VALUES(3267,'Takin''it up',2,NULL,'f','2008-03-12 13:41:28');
INSERT INTO CHANSON VALUES(3268,'La ventura',2,NULL,'f','2008-03-12 08:35:18');
INSERT INTO CHANSON VALUES(3269,'Lonesome bop',2,NULL,'f','2008-03-12 16:17:26');
INSERT INTO CHANSON VALUES(3270,'Bragg jack',2,NULL,'f','2008-03-12 16:48:26');
INSERT INTO CHANSON VALUES(3271,'Salga la luna',2,NULL,'f','2008-03-12 14:48:42');
INSERT INTO CHANSON VALUES(3272,'Bring The Fire',2,NULL,'f','2008-03-12 19:14:16');
INSERT INTO CHANSON VALUES(3273,'King Of Bongo',2,NULL,'f','2008-03-12 10:59:21');
INSERT INTO CHANSON VALUES(3274,'Don''t Want You No More',2,NULL,NULL,'2008-03-12 19:20:07');
INSERT INTO CHANSON VALUES(3275,'Le Bruit Du Frigo',2,NULL,'f','2008-03-12 14:38:51');
INSERT INTO CHANSON VALUES(3276,'Letter To The Censors',2,NULL,'f','2008-03-12 13:56:46');
INSERT INTO CHANSON VALUES(3277,'El Jako',2,NULL,NULL,'2008-03-12 09:25:27');
INSERT INTO CHANSON VALUES(3278,'It''s My Heart',2,NULL,'f','2008-03-12 15:28:03');
INSERT INTO CHANSON VALUES(3279,'Mad Man''s Dead',2,NULL,'f','2008-03-12 19:08:20');
INSERT INTO CHANSON VALUES(3280,'Out Of Time Man',2,NULL,'f','2008-03-12 12:49:08');
INSERT INTO CHANSON VALUES(3281,'Madame Oscar',2,NULL,'f','2008-03-23 17:20:57');
INSERT INTO CHANSON VALUES(3282,'Welcome In Occident',2,NULL,'f','2008-03-12 14:17:11');
INSERT INTO CHANSON VALUES(3283,'Furious Fiesta',2,NULL,NULL,'2008-03-12 17:31:10');
INSERT INTO CHANSON VALUES(3284,'The Fool',2,NULL,NULL,'2008-03-12 10:27:30');
INSERT INTO CHANSON VALUES(3285,'Paris La Nuit',2,NULL,'f','2008-03-23 14:42:02');
INSERT INTO CHANSON VALUES(3286,'Running Up That Hill (A Deal With God)',2,NULL,'f','2008-03-12 11:58:08');
INSERT INTO CHANSON VALUES(3287,'Hounds Of Love',2,NULL,'f','2008-03-12 09:24:05');
INSERT INTO CHANSON VALUES(3288,'The Big Sky',2,NULL,'f','2008-03-12 19:33:30');
INSERT INTO CHANSON VALUES(3289,'Mother Stands For Comfort',2,NULL,'f','2008-03-12 12:11:58');
INSERT INTO CHANSON VALUES(3290,'Cloudbusting',2,NULL,'f','2008-03-12 13:07:07');
INSERT INTO CHANSON VALUES(3291,'And Dream Of Sheep',2,NULL,'f','2008-03-12 17:30:57');
INSERT INTO CHANSON VALUES(3292,'Under Ice',2,NULL,'f','2008-03-12 19:20:18');
INSERT INTO CHANSON VALUES(3293,'Waking The Witch',2,NULL,'f','2008-03-12 18:53:35');
INSERT INTO CHANSON VALUES(3294,'Watching You Without Me',2,NULL,'f','2008-03-12 09:42:06');
INSERT INTO CHANSON VALUES(3295,'Jig Of Life',2,NULL,'f','2008-06-05 16:12:00.448835');
INSERT INTO CHANSON VALUES(3296,'Hello Earth',2,NULL,'f','2008-03-12 17:11:33');
INSERT INTO CHANSON VALUES(3297,'The Morning Fog',2,NULL,'f','2008-03-12 19:21:57');
INSERT INTO CHANSON VALUES(3298,'L''enfant roi',2,NULL,'f','2008-03-12 08:18:31');
INSERT INTO CHANSON VALUES(3299,'Le grand incendie',2,NULL,'f','2008-03-12 14:42:42');
INSERT INTO CHANSON VALUES(3300,'Le vent nous portera',2,NULL,NULL,'2008-03-12 14:09:49');
INSERT INTO CHANSON VALUES(3301,'Des armes',2,NULL,'f','2008-03-12 15:57:20');
INSERT INTO CHANSON VALUES(3302,'L''appartement',2,NULL,'f','2008-03-12 15:54:41');
INSERT INTO CHANSON VALUES(3303,'Des visages des figures',2,NULL,'f','2008-04-07 18:59:06');
INSERT INTO CHANSON VALUES(3304,'Son style1',2,NULL,'f','2008-03-12 18:48:34');
INSERT INTO CHANSON VALUES(3305,'son style2',2,NULL,'f','2008-03-12 13:53:17');
INSERT INTO CHANSON VALUES(3306,'A l''envers à l''endroit',2,NULL,'f','2008-03-12 15:09:11');
INSERT INTO CHANSON VALUES(3307,'Lost',2,NULL,'f','2008-03-12 10:56:23');
INSERT INTO CHANSON VALUES(3308,'Bouquets de nerf',2,NULL,'f','2008-03-12 16:52:44');
INSERT INTO CHANSON VALUES(3309,'L''Europe',2,NULL,'f','2008-03-12 16:53:02');
INSERT INTO CHANSON VALUES(3310,'Losing Grip',2,NULL,'f','2008-03-12 10:25:45');
INSERT INTO CHANSON VALUES(3311,'Complicated',2,NULL,'f','2008-05-22 14:00:19');
INSERT INTO CHANSON VALUES(3312,'Sk8er Boi',2,NULL,'f','2008-03-12 19:57:54');
INSERT INTO CHANSON VALUES(3313,'I''m With You',2,NULL,'f','2008-03-12 17:36:52');
INSERT INTO CHANSON VALUES(3314,'Mobile',2,NULL,NULL,'2008-03-12 09:12:46');
INSERT INTO CHANSON VALUES(3315,'Unwanted',2,NULL,NULL,'2008-03-12 17:06:34');
INSERT INTO CHANSON VALUES(3316,'Tomorrow',2,NULL,'f','2008-03-12 12:36:28');
INSERT INTO CHANSON VALUES(3317,'Anything But Ordinary',2,NULL,NULL,'2008-03-12 16:13:37');
INSERT INTO CHANSON VALUES(3318,'Things I''ll Never Say',2,NULL,'f','2008-03-12 18:25:34');
INSERT INTO CHANSON VALUES(3319,'My World',2,NULL,'f','2008-03-12 10:10:26');
INSERT INTO CHANSON VALUES(3320,'Nobody''s Fool',2,NULL,'f','2008-03-12 19:52:20');
INSERT INTO CHANSON VALUES(3321,'Too Much To Ask',2,NULL,'f','2008-03-12 08:06:46');
INSERT INTO CHANSON VALUES(3322,'Naked',2,NULL,'f','2008-03-12 17:02:43');
INSERT INTO CHANSON VALUES(3324,'Enter Sandman',2,NULL,'f','2008-03-12 14:54:32');
INSERT INTO CHANSON VALUES(3325,'Sad But True',2,NULL,'f','2008-03-12 12:43:39');
INSERT INTO CHANSON VALUES(3326,'Holier Than Thou',2,NULL,'f','2008-03-22 19:06:15');
INSERT INTO CHANSON VALUES(3327,'The Unforgiven',2,NULL,NULL,'2008-03-12 12:46:29');
INSERT INTO CHANSON VALUES(3328,'Wherever I May Roam',2,NULL,'f','2008-03-12 08:38:55');
INSERT INTO CHANSON VALUES(3329,'Don''t Tread On Me',2,NULL,'f','2008-03-12 15:52:05');
INSERT INTO CHANSON VALUES(3330,'Through The Never',2,NULL,'f','2008-03-12 08:52:58');
INSERT INTO CHANSON VALUES(3331,'Nothing Else Matters',2,NULL,'f','2008-03-12 12:54:04');
INSERT INTO CHANSON VALUES(3332,'Of Wolf And Man',2,NULL,'f','2008-03-12 09:41:06');
INSERT INTO CHANSON VALUES(3333,'The God That Failed',2,NULL,'f','2008-03-12 18:24:55');
INSERT INTO CHANSON VALUES(3334,'My Friend Of Misery',2,NULL,'f','2008-03-12 10:58:50');
INSERT INTO CHANSON VALUES(3335,'The Struggle Within',2,NULL,'f','2008-03-12 16:18:33');
INSERT INTO CHANSON VALUES(3336,'Flip The Switch',2,NULL,'f','2008-04-04 13:33:21');
INSERT INTO CHANSON VALUES(3337,'Anybody Seen My Baby?',2,NULL,'f','2008-06-02 09:16:23.167212');
INSERT INTO CHANSON VALUES(3338,'Low Down',2,NULL,'f','2008-03-23 15:36:25');
INSERT INTO CHANSON VALUES(3339,'Already Over Me',2,NULL,'f','2008-03-27 09:37:04');
INSERT INTO CHANSON VALUES(3340,'Gunface',2,NULL,'f','2008-04-09 13:30:45');
INSERT INTO CHANSON VALUES(3341,'You Don''t Have To Mean It',2,NULL,'f','2008-06-02 09:17:27.56123');
INSERT INTO CHANSON VALUES(3342,'Out Of Control',2,NULL,'f','2008-06-02 09:22:19.129331');
INSERT INTO CHANSON VALUES(3343,'Saint Of Me',2,NULL,'f','2008-06-02 09:22:43.370947');
INSERT INTO CHANSON VALUES(3344,'Might As Well Get Juiced',2,NULL,'f','2008-06-02 09:23:03.424606');
INSERT INTO CHANSON VALUES(3345,'Always Suffering',2,NULL,NULL,'2008-06-02 09:23:19.942245');
INSERT INTO CHANSON VALUES(3346,'Too Tight',2,NULL,NULL,'2008-06-02 09:23:34.795916');
INSERT INTO CHANSON VALUES(3347,'Thief In The Night',2,NULL,'f','2008-06-02 09:23:52.26396');
INSERT INTO CHANSON VALUES(3348,'How Can I Stop',2,NULL,'f','2008-06-02 09:24:32.598842');
INSERT INTO CHANSON VALUES(3349,'In the Flesh?',6,NULL,'f','2008-03-12 11:32:57');
INSERT INTO CHANSON VALUES(3350,'The Thin Ice',6,NULL,'f','2008-03-12 16:41:34');
INSERT INTO CHANSON VALUES(3351,'Another Brick in the Wall Part 1',6,NULL,'f','2008-03-12 17:44:47');
INSERT INTO CHANSON VALUES(3352,'The Happiest Days of our Lives',6,NULL,'f','2008-03-12 16:53:02');
INSERT INTO CHANSON VALUES(3353,'Another Brick in the Wall part 2',6,NULL,'f','2008-03-12 14:01:38');
INSERT INTO CHANSON VALUES(3354,'Mother',6,NULL,'f','2008-03-12 11:13:23');
INSERT INTO CHANSON VALUES(3355,'Goodbye Blue Sky',6,NULL,'f','2008-03-12 16:32:59');
INSERT INTO CHANSON VALUES(3356,'Empty Spaces',6,NULL,'f','2008-04-24 11:13:31');
INSERT INTO CHANSON VALUES(3357,'Young Lust',6,NULL,'f','2008-03-12 14:46:47');
INSERT INTO CHANSON VALUES(3358,'One of My Turns',6,NULL,NULL,'2008-03-12 11:51:18');
INSERT INTO CHANSON VALUES(3359,'Don''t Leave Me Now',6,NULL,'f','2008-03-12 13:28:12');
INSERT INTO CHANSON VALUES(3360,'Another Brick in the Wall Part 3',6,NULL,'f','2008-03-12 17:45:45');
INSERT INTO CHANSON VALUES(3361,'Goodbye Cruel World',6,NULL,'f','2008-03-12 16:28:26');
INSERT INTO CHANSON VALUES(3362,'666.667 Club',2,NULL,'f','2008-03-12 11:15:11');
INSERT INTO CHANSON VALUES(3363,'Fin de Siècle',2,NULL,'f','2008-03-12 09:58:05');
INSERT INTO CHANSON VALUES(3364,'Un jour en France',2,NULL,'f','2008-03-23 09:31:06');
INSERT INTO CHANSON VALUES(3365,'A ton étoile',2,NULL,'f','2008-03-12 17:47:20');
INSERT INTO CHANSON VALUES(3366,'Ernestine',2,NULL,'f','2008-03-12 10:29:52');
INSERT INTO CHANSON VALUES(3367,'Comme elle vient',2,NULL,'f','2008-03-23 10:00:39');
INSERT INTO CHANSON VALUES(3368,'Prayer for a Wanker',2,NULL,'f','2008-03-12 19:19:31');
INSERT INTO CHANSON VALUES(3369,'Les persiennes',2,NULL,'f','2008-03-12 11:44:59');
INSERT INTO CHANSON VALUES(3370,'L''homme pressé',2,NULL,'f','2008-03-23 10:13:13');
INSERT INTO CHANSON VALUES(3371,'Lazy',2,NULL,'f','2008-05-22 15:20:07');
INSERT INTO CHANSON VALUES(3372,'A la longue',2,NULL,'f','2008-03-12 16:31:28');
INSERT INTO CHANSON VALUES(3373,'Septembre en attendant',2,NULL,NULL,'2008-03-12 18:37:27');
INSERT INTO CHANSON VALUES(3374,'Song for JLP',2,NULL,'f','2008-03-12 19:46:58');
INSERT INTO CHANSON VALUES(3375,'Sunday',2,NULL,'f','2008-06-07 20:02:24.118215');
INSERT INTO CHANSON VALUES(3376,'Cactus',2,NULL,'f','2008-06-07 20:19:33.63305');
INSERT INTO CHANSON VALUES(3377,'Slip away',2,NULL,'f','2008-06-07 20:01:52.427152');
INSERT INTO CHANSON VALUES(3378,'Slow burn',2,NULL,'f','2008-04-07 15:32:18');
INSERT INTO CHANSON VALUES(3379,'Afraid',2,NULL,NULL,'2008-06-07 19:27:12.642807');
INSERT INTO CHANSON VALUES(3380,'I''ve been waiting for you',2,NULL,NULL,'2008-06-07 20:20:59.026109');
INSERT INTO CHANSON VALUES(3381,'I would be your slave',2,NULL,'f','2008-06-07 19:36:59.787009');
INSERT INTO CHANSON VALUES(3382,'Gemini spacecraft',2,NULL,'f','2008-06-07 19:29:36.978249');
INSERT INTO CHANSON VALUES(3383,'5.15 the angels have gone',2,NULL,'f','2008-06-07 20:18:49.88982');
INSERT INTO CHANSON VALUES(3384,'Everyone says ''Hi''',2,NULL,'f','2008-06-07 19:28:50.221992');
INSERT INTO CHANSON VALUES(3385,'A better future',2,NULL,'f','2008-06-07 19:26:27.887872');
INSERT INTO CHANSON VALUES(3386,'Heathen',2,NULL,'f','2008-06-07 19:30:10.46196');
INSERT INTO CHANSON VALUES(3387,'Comme Un Igloo',5,NULL,'f','2008-03-12 09:49:16');
INSERT INTO CHANSON VALUES(3388,'Des Heures Hindoues',5,NULL,'f','2008-03-12 12:06:10');
INSERT INTO CHANSON VALUES(3389,'Le Premier Jour',5,NULL,'f','2008-03-12 16:04:01');
INSERT INTO CHANSON VALUES(3390,'Tombé Pour La France',5,NULL,'f','2008-03-12 11:32:08');
INSERT INTO CHANSON VALUES(3391,'Epaule Tattoo',5,NULL,'f','2008-03-12 14:00:44');
INSERT INTO CHANSON VALUES(3392,'San Antonio De La Luna',5,NULL,'f','2008-03-12 13:14:35');
INSERT INTO CHANSON VALUES(3393,'Week-End A Rome',5,NULL,'f','2008-03-12 13:42:05');
INSERT INTO CHANSON VALUES(3394,'Le Brasier',5,NULL,'f','2008-03-12 09:38:29');
INSERT INTO CHANSON VALUES(3395,'La Nage Indienne',5,NULL,'f','2008-03-12 11:02:49');
INSERT INTO CHANSON VALUES(3396,'Duel Au Soleil',5,NULL,'f','2008-03-12 11:24:14');
INSERT INTO CHANSON VALUES(3397,'Quand Tu M''Appelles Eden',5,NULL,'f','2008-03-12 18:33:04');
INSERT INTO CHANSON VALUES(3398,'Comme Un Boomerang',5,NULL,NULL,'2008-03-12 09:58:11');
INSERT INTO CHANSON VALUES(3399,'Follow The Line',2,NULL,'f','2008-03-12 11:38:15');
INSERT INTO CHANSON VALUES(3400,'La fuite dans les idées',2,NULL,'f','2008-03-12 12:53:47');
INSERT INTO CHANSON VALUES(3401,'Bras de fer',2,NULL,'f','2008-03-12 13:28:48');
INSERT INTO CHANSON VALUES(3402,'Parc Montsouris',2,NULL,NULL,'2008-03-12 10:53:03');
INSERT INTO CHANSON VALUES(3403,'Tombé du ciel',2,NULL,'f','2008-03-23 08:09:41');
INSERT INTO CHANSON VALUES(3404,'Poil dans la main',2,NULL,'f','2008-03-28 13:42:59');
INSERT INTO CHANSON VALUES(3405,'Chanson',2,NULL,'f','2008-03-12 17:22:45');
INSERT INTO CHANSON VALUES(3406,'Tom Bonbadilom',2,NULL,'f','2008-03-12 19:28:24');
INSERT INTO CHANSON VALUES(3407,'Ballade pour Roger',2,NULL,'f','2008-04-09 15:22:40');
INSERT INTO CHANSON VALUES(3408,'Le drapeau de la colère',2,NULL,'f','2008-03-12 12:47:26');
INSERT INTO CHANSON VALUES(3409,'Symphonie des droits de l''homme',2,NULL,'f','2008-03-12 10:06:51');
INSERT INTO CHANSON VALUES(3410,'?',2,NULL,'f','2008-03-12 13:59:25');
INSERT INTO CHANSON VALUES(3411,'Thunder road',2,NULL,'f','2008-03-12 14:08:23');
INSERT INTO CHANSON VALUES(3412,'Adam raised a chain',2,NULL,NULL,'2008-03-12 16:27:02');
INSERT INTO CHANSON VALUES(3413,'Spirit inthe night',2,NULL,NULL,'2008-03-12 19:48:56');
INSERT INTO CHANSON VALUES(3414,'4th of July, Ashbury Park (Sandy)',2,NULL,'f','2008-03-12 17:18:24');
INSERT INTO CHANSON VALUES(3415,'Paradise by the ''C''',2,NULL,'f','2008-03-12 13:18:09');
INSERT INTO CHANSON VALUES(3416,'Fire',2,NULL,'f','2008-03-12 17:42:56');
INSERT INTO CHANSON VALUES(3417,'Growin'' up',2,NULL,'f','2008-03-12 11:57:03');
INSERT INTO CHANSON VALUES(3418,'It''s hard to be a saint in the city',2,NULL,'f','2008-06-07 16:06:38.132017');
INSERT INTO CHANSON VALUES(3419,'Backstreets',2,NULL,'f','2008-03-12 14:00:10');
INSERT INTO CHANSON VALUES(3420,'Rosalita (come out tonight)',2,NULL,'f','2008-03-12 19:44:38');
INSERT INTO CHANSON VALUES(3421,'Raise your hand',2,NULL,'f','2008-03-12 19:44:26');
INSERT INTO CHANSON VALUES(3422,'Hungry heart',2,NULL,'f','2008-03-12 19:31:44');
INSERT INTO CHANSON VALUES(3423,'Two hearts',2,NULL,NULL,'2008-03-12 11:07:17');
INSERT INTO CHANSON VALUES(3424,'Prélude',5,NULL,'f','2008-03-12 15:46:40');
INSERT INTO CHANSON VALUES(3425,'Pistonné',5,NULL,'f','2008-03-12 11:11:58');
INSERT INTO CHANSON VALUES(3426,'Faute de ...',5,NULL,'f','2008-03-12 13:01:41');
INSERT INTO CHANSON VALUES(3427,'Voguons',5,NULL,'f','2008-03-12 12:17:38');
INSERT INTO CHANSON VALUES(3428,'Union',5,NULL,'f','2008-03-12 13:24:05');
INSERT INTO CHANSON VALUES(3429,'Danseuse',5,NULL,'f','2008-03-12 14:57:05');
INSERT INTO CHANSON VALUES(3430,'Voilà malgré tout',5,NULL,'f','2008-03-12 16:54:50');
INSERT INTO CHANSON VALUES(3431,'À jamais',5,NULL,'f','2008-03-12 11:54:34');
INSERT INTO CHANSON VALUES(3432,'Anatole',5,NULL,'f','2008-03-12 17:49:05');
INSERT INTO CHANSON VALUES(3433,'Nostalgique',5,NULL,'f','2008-03-12 14:09:12');
INSERT INTO CHANSON VALUES(3434,'Le paon',5,NULL,'f','2008-03-12 17:47:59');
INSERT INTO CHANSON VALUES(3435,'Evasion',5,NULL,'f','2008-03-12 13:06:11');
INSERT INTO CHANSON VALUES(3436,'Un plat pays ?',5,NULL,'f','2008-03-12 13:34:12');
INSERT INTO CHANSON VALUES(3437,'Welcome To The Jungle',2,NULL,'f','2008-03-12 09:59:29');
INSERT INTO CHANSON VALUES(3438,'It''s So Easy',2,NULL,'f','2008-03-12 17:27:54');
INSERT INTO CHANSON VALUES(3439,'Nightrain',2,NULL,'f','2008-03-23 18:57:51');
INSERT INTO CHANSON VALUES(3440,'Out Ta Get Me',2,NULL,'f','2008-03-12 19:38:46');
INSERT INTO CHANSON VALUES(3441,'Mr. Brownstone',2,NULL,'f','2008-03-12 17:57:40');
INSERT INTO CHANSON VALUES(3442,'Paradise City',2,NULL,'f','2008-03-12 12:43:30');
INSERT INTO CHANSON VALUES(3443,'My Michelle',2,NULL,'f','2008-03-12 13:13:40');
INSERT INTO CHANSON VALUES(3444,'Think About You',2,NULL,'f','2008-03-12 16:01:27');
INSERT INTO CHANSON VALUES(3445,'Sweet Child O'' Mine',2,NULL,NULL,'2008-03-12 16:29:34');
INSERT INTO CHANSON VALUES(3447,'Anything Goes',2,NULL,NULL,'2008-03-12 08:03:08');
INSERT INTO CHANSON VALUES(3448,'Rocket Queen',2,NULL,NULL,'2008-03-12 14:49:35');
INSERT INTO CHANSON VALUES(3449,'Paranoia Key of E',2,NULL,'f','2008-03-12 13:41:33');
INSERT INTO CHANSON VALUES(3450,'Mystic Child',2,NULL,NULL,'2008-03-12 11:39:12');
INSERT INTO CHANSON VALUES(3451,'Mad',2,NULL,'f','2008-03-12 09:27:10');
INSERT INTO CHANSON VALUES(3452,'Ecstasy',2,NULL,'f','2008-03-29 17:50:53');
INSERT INTO CHANSON VALUES(3453,'Modern Dance',2,NULL,'f','2008-05-22 18:10:40');
INSERT INTO CHANSON VALUES(3454,'Tatters',2,NULL,'f','2008-03-12 11:18:07');
INSERT INTO CHANSON VALUES(3455,'Future Farmers of America',2,NULL,'f','2008-03-12 19:59:08');
INSERT INTO CHANSON VALUES(3456,'Turning Time Around',2,NULL,'f','2008-03-12 13:39:38');
INSERT INTO CHANSON VALUES(3457,'White Prism',2,NULL,'f','2008-03-12 08:32:33');
INSERT INTO CHANSON VALUES(3458,'Rock Minuet',2,NULL,'f','2008-03-12 09:36:37');
INSERT INTO CHANSON VALUES(3459,'Baton Rouge',2,NULL,'f','2008-03-12 11:10:26');
INSERT INTO CHANSON VALUES(3460,'Like a Possum',2,NULL,'f','2008-03-12 18:38:08');
INSERT INTO CHANSON VALUES(3461,'Rouge',2,NULL,'f','2008-03-12 13:58:47');
INSERT INTO CHANSON VALUES(3462,'Big Sky',2,NULL,'f','2008-03-12 15:04:15');
INSERT INTO CHANSON VALUES(3463,'Mache De La Gomme',2,NULL,'f','2008-03-12 17:52:05');
INSERT INTO CHANSON VALUES(3464,'Rock''n''Roll',2,NULL,'f','2008-03-12 16:10:23');
INSERT INTO CHANSON VALUES(3465,'Ego-Dames',2,NULL,'f','2008-03-12 18:09:22');
INSERT INTO CHANSON VALUES(3466,'intermède 1',2,NULL,'f','2008-03-12 19:35:02');
INSERT INTO CHANSON VALUES(3467,'Yakety-Yak',2,NULL,'f','2008-03-12 15:36:34');
INSERT INTO CHANSON VALUES(3468,'Twist À St-Tropez',2,NULL,'f','2008-03-12 10:46:11');
INSERT INTO CHANSON VALUES(3469,'L''Île Du Bonheur',2,NULL,'f','2008-03-12 17:04:21');
INSERT INTO CHANSON VALUES(3470,'Détonateur Rock',2,NULL,'f','2008-03-12 10:58:00');
INSERT INTO CHANSON VALUES(3471,'Des Mégalos Pour Mes Galas',2,NULL,'f','2008-03-12 12:25:58');
INSERT INTO CHANSON VALUES(3472,'intermède 2',2,NULL,'f','2008-03-12 10:04:03');
INSERT INTO CHANSON VALUES(3473,'Ramses',2,NULL,'f','2008-03-12 13:53:55');
INSERT INTO CHANSON VALUES(3474,'Oh! Les Filles',2,NULL,'f','2008-03-12 14:36:06');
INSERT INTO CHANSON VALUES(3475,'Here It Comes Slowly',2,NULL,NULL,'2008-03-12 19:26:15');
INSERT INTO CHANSON VALUES(3476,'Ici Paris',2,NULL,'f','2008-03-12 11:25:51');
INSERT INTO CHANSON VALUES(3477,'Oublié',2,NULL,'f','2008-03-12 12:02:28');
INSERT INTO CHANSON VALUES(3478,'Alice',2,NULL,'f','2008-03-27 19:13:14');
INSERT INTO CHANSON VALUES(3479,'One Trip / One Noise',2,NULL,'f','2008-08-13 07:36:18.86633');
INSERT INTO CHANSON VALUES(3480,'Tostaky (Le Continent)',2,NULL,'f','2008-03-23 14:16:17');
INSERT INTO CHANSON VALUES(3481,'Marlène',2,NULL,NULL,'2008-03-12 14:39:42');
INSERT INTO CHANSON VALUES(3482,'Johny Colère',2,NULL,NULL,'2008-03-12 13:50:47');
INSERT INTO CHANSON VALUES(3483,'7 Minutes',2,NULL,'f','2008-03-12 14:16:40');
INSERT INTO CHANSON VALUES(3484,'Sober Song',2,NULL,'f','2008-03-12 13:48:17');
INSERT INTO CHANSON VALUES(3485,'It Spurts',2,NULL,'f','2008-03-12 14:44:44');
INSERT INTO CHANSON VALUES(3486,'Lolita Nie En Bloc',2,NULL,'f','2008-03-12 18:03:10');
INSERT INTO CHANSON VALUES(3487,'24 heures dans la nuit d''un faune',2,NULL,'f','2008-03-12 16:24:13');
INSERT INTO CHANSON VALUES(3488,'Critique du chapitre 3',2,NULL,'f','2008-03-12 09:21:26');
INSERT INTO CHANSON VALUES(3489,'La nostalgie de dieu',2,NULL,'f','2008-03-12 12:29:28');
INSERT INTO CHANSON VALUES(3490,'Orphée nonante huit',2,NULL,'f','2008-03-12 16:59:44');
INSERT INTO CHANSON VALUES(3492,'Sentiments numériques revisités',2,NULL,NULL,'2008-03-12 16:58:14');
INSERT INTO CHANSON VALUES(3493,'Mojo - dépanneur tv (1948-2023)',2,NULL,'f','2008-03-12 14:31:30');
INSERT INTO CHANSON VALUES(3494,'Copyright apéro mundi',2,NULL,'f','2008-03-12 10:59:19');
INSERT INTO CHANSON VALUES(3495,'Psychopompes / métempsychose & sportswear',2,NULL,'f','2008-03-12 13:34:04');
INSERT INTO CHANSON VALUES(3496,'Des adieux .../...',2,NULL,'f','2008-03-12 10:25:07');
INSERT INTO CHANSON VALUES(3497,'La philosophie du chaos',2,NULL,'f','2008-03-12 12:06:31');
INSERT INTO CHANSON VALUES(3498,'La nostalgie de dieu - version unplugged',2,NULL,'f','2008-03-12 15:16:53');
INSERT INTO CHANSON VALUES(3499,'Heaven And Hell',2,NULL,NULL,'2008-03-12 08:41:22');
INSERT INTO CHANSON VALUES(3502,'Tattoo',2,NULL,'f','2008-03-12 16:10:50');
INSERT INTO CHANSON VALUES(3503,'Young Man Blues',2,NULL,'f','2008-03-12 19:42:21');
INSERT INTO CHANSON VALUES(3504,'Substitute',2,NULL,'f','2008-03-12 13:54:21');
INSERT INTO CHANSON VALUES(3505,'Happy Jack',2,NULL,'f','2008-03-12 17:24:55');
INSERT INTO CHANSON VALUES(3506,'I''m A Boy',2,NULL,'f','2008-03-12 18:38:20');
INSERT INTO CHANSON VALUES(3507,'A Quick One, While He''s Away',2,NULL,'f','2008-03-12 19:02:27');
INSERT INTO CHANSON VALUES(3508,'Amazing Journey / Sparks',2,NULL,'f','2008-03-12 13:39:44');
INSERT INTO CHANSON VALUES(3509,'Summertime Blues',2,NULL,'f','2008-03-12 12:43:26');
INSERT INTO CHANSON VALUES(3510,'Shakin'' All Over',2,NULL,'f','2008-03-12 16:15:51');
INSERT INTO CHANSON VALUES(3512,'Magic Bus',2,NULL,NULL,'2008-04-11 08:26:38');
INSERT INTO CHANSON VALUES(3513,'Molodoï',2,NULL,NULL,'2008-03-12 19:14:29');
INSERT INTO CHANSON VALUES(3514,'Métis',2,NULL,'f','2008-03-12 17:09:11');
INSERT INTO CHANSON VALUES(3517,'Golan United',2,NULL,'f','2008-03-12 13:12:08');
INSERT INTO CHANSON VALUES(3518,'Politichiens',2,NULL,'f','2008-03-12 17:09:10');
INSERT INTO CHANSON VALUES(3519,'Trait''ment spécial',2,NULL,'f','2008-03-12 10:38:49');
INSERT INTO CHANSON VALUES(3520,'30 avril 1975',2,NULL,'f','2008-03-12 19:00:32');
INSERT INTO CHANSON VALUES(3521,'Bonze déchu',2,NULL,'f','2008-03-12 13:44:48');
INSERT INTO CHANSON VALUES(3522,'La rage',2,NULL,'f','2008-03-12 11:50:21');
INSERT INTO CHANSON VALUES(3523,'Skalopards',2,NULL,'f','2008-03-12 15:48:35');
INSERT INTO CHANSON VALUES(3524,'Evasion',2,NULL,NULL,'2008-03-12 08:36:45');
INSERT INTO CHANSON VALUES(3525,'H.P. 84',2,NULL,'f','2008-03-12 11:45:21');
INSERT INTO CHANSON VALUES(3526,'La marche des Molodoï',2,NULL,'f','2008-03-12 12:16:43');
INSERT INTO CHANSON VALUES(3527,'It Won''t Be Long',2,NULL,'f','2008-03-12 18:42:55');
INSERT INTO CHANSON VALUES(3528,'All I''ve Got to Do',2,NULL,'f','2008-03-12 08:29:05');
INSERT INTO CHANSON VALUES(3529,'All My Loving',2,NULL,'f','2008-03-12 10:44:43');
INSERT INTO CHANSON VALUES(3530,'Don''t Bother Me',2,NULL,'f','2008-03-12 08:44:43');
INSERT INTO CHANSON VALUES(3531,'Little Child',2,NULL,'f','2008-03-12 14:10:28');
INSERT INTO CHANSON VALUES(3532,'Till There Was You',2,NULL,'f','2008-03-12 12:27:19');
INSERT INTO CHANSON VALUES(3533,'Please Mister Postman',2,NULL,'f','2008-03-12 16:02:08');
INSERT INTO CHANSON VALUES(3535,'Hold Me Tight',2,NULL,'f','2008-03-12 08:23:30');
INSERT INTO CHANSON VALUES(3536,'You Really Got a Hold on Me',2,NULL,'f','2008-03-12 13:46:46');
INSERT INTO CHANSON VALUES(3538,'Devil in Her Heart',2,NULL,'f','2008-03-12 09:38:29');
INSERT INTO CHANSON VALUES(3539,'Not a Second Time',2,NULL,'f','2008-03-12 09:38:59');
INSERT INTO CHANSON VALUES(3540,'Money',2,NULL,'f','2008-03-12 10:49:43');
INSERT INTO CHANSON VALUES(3541,'The Width Of A Circle',2,NULL,'f','2008-04-13 19:20:15');
INSERT INTO CHANSON VALUES(3542,'All The Madmen',2,NULL,'f','2008-06-07 15:08:38.657056');
INSERT INTO CHANSON VALUES(3543,'Black Country Rock',2,NULL,'f','2008-06-07 15:09:11.409197');
INSERT INTO CHANSON VALUES(3544,'After All',2,NULL,'f','2008-06-07 15:09:53.595175');
INSERT INTO CHANSON VALUES(3545,'Running Gun Blues',2,NULL,'f','2008-04-15 13:17:02');
INSERT INTO CHANSON VALUES(3546,'Saviour Machine',2,NULL,'f','2008-06-07 15:10:30.853032');
INSERT INTO CHANSON VALUES(3547,'She Shook Me Cold',2,NULL,NULL,'2008-04-13 09:31:24');
INSERT INTO CHANSON VALUES(3548,'The Man Who Sold The World',2,NULL,'f','2008-04-11 16:13:37');
INSERT INTO CHANSON VALUES(3549,'The Supermen',2,NULL,'f','2008-03-17 14:47:16');
INSERT INTO CHANSON VALUES(3550,'Lightning Frightning (Previously Unreleased)',2,NULL,'f','2008-06-07 12:31:46.713744');
INSERT INTO CHANSON VALUES(3551,'Holy Holy',2,NULL,'f','2008-06-07 12:32:04.68818');
INSERT INTO CHANSON VALUES(3552,'Moonage Daydream',2,NULL,'f','2008-04-11 09:15:54');
INSERT INTO CHANSON VALUES(3553,'Hang On To Yourself',2,NULL,'f','2008-06-07 19:14:14.706531');
INSERT INTO CHANSON VALUES(3554,'Wired All Night',2,NULL,'f','2008-03-12 08:33:44');
INSERT INTO CHANSON VALUES(3555,'Sweet Thing',2,NULL,'f','2008-03-12 08:43:33');
INSERT INTO CHANSON VALUES(3556,'Out Of Focus',2,NULL,'f','2008-03-12 17:38:23');
INSERT INTO CHANSON VALUES(3557,'Don''t Tear Me Up',2,NULL,'f','2008-03-12 11:16:46');
INSERT INTO CHANSON VALUES(3558,'Put Me In The Trash',2,NULL,'f','2008-03-12 18:22:31');
INSERT INTO CHANSON VALUES(3559,'Use Me',2,NULL,'f','2008-03-12 08:48:58');
INSERT INTO CHANSON VALUES(3560,'Evening Gown',2,NULL,'f','2008-03-12 09:23:45');
INSERT INTO CHANSON VALUES(3561,'Mother Of A Man',2,NULL,'f','2008-03-12 13:41:37');
INSERT INTO CHANSON VALUES(3562,'Think',2,NULL,'f','2008-03-26 09:30:55');
INSERT INTO CHANSON VALUES(3563,'Wandering Spirit',2,NULL,'f','2008-03-12 14:05:22');
INSERT INTO CHANSON VALUES(3564,'Hang On To Me Tonght',2,NULL,'f','2008-03-12 15:09:55');
INSERT INTO CHANSON VALUES(3565,'I''ve Been Lonely For So Long',2,NULL,NULL,'2008-03-12 12:12:39');
INSERT INTO CHANSON VALUES(3566,'Angel In My Heart',2,NULL,'f','2008-03-12 19:59:17');
INSERT INTO CHANSON VALUES(3567,'Handsome Molly',2,NULL,'f','2008-03-12 11:15:34');
INSERT INTO CHANSON VALUES(3568,'Romeo And Juliette',2,NULL,'f','2008-03-12 09:09:57');
INSERT INTO CHANSON VALUES(3569,'Halloween Parade',2,NULL,'f','2008-03-12 15:10:45');
INSERT INTO CHANSON VALUES(3570,'Dirty Blvd.',2,NULL,'f','2008-03-12 15:19:09');
INSERT INTO CHANSON VALUES(3571,'Endless Cycle',2,NULL,NULL,'2008-03-12 12:44:50');
INSERT INTO CHANSON VALUES(3572,'There Is No Time',2,NULL,NULL,'2008-03-12 19:50:21');
INSERT INTO CHANSON VALUES(3573,'Last Great American Whale',2,NULL,NULL,'2008-03-12 18:22:26');
INSERT INTO CHANSON VALUES(3574,'Beginning Of A Great Adventure',2,NULL,'f','2008-03-12 11:00:35');
INSERT INTO CHANSON VALUES(3575,'Busload Of Faith',2,NULL,'f','2008-04-09 13:35:26');
INSERT INTO CHANSON VALUES(3576,'Sick Of You',2,NULL,'f','2008-03-12 10:22:48');
INSERT INTO CHANSON VALUES(3577,'Hold On',2,NULL,'f','2008-03-12 18:17:48');
INSERT INTO CHANSON VALUES(3578,'Good Evening Mr. Waldheim',2,NULL,'f','2008-03-12 09:36:04');
INSERT INTO CHANSON VALUES(3579,'Xmas In February',2,NULL,'f','2008-03-12 16:41:14');
INSERT INTO CHANSON VALUES(3580,'Strawman',2,NULL,'f','2008-03-12 16:17:24');
INSERT INTO CHANSON VALUES(3581,'Dime Store Mystery',2,NULL,'f','2008-04-11 14:01:10');
INSERT INTO CHANSON VALUES(3582,'Serve The Servants',2,NULL,'f','2008-03-12 13:52:43');
INSERT INTO CHANSON VALUES(3583,'Scentless Apprentice',2,NULL,'f','2008-03-12 15:13:27');
INSERT INTO CHANSON VALUES(3584,'Heart-Shaped Box',2,NULL,'f','2008-03-12 13:12:17');
INSERT INTO CHANSON VALUES(3585,'Rape me',2,NULL,'f','2008-03-12 17:06:40');
INSERT INTO CHANSON VALUES(3586,'Frances Farmer Will Have Her Revenge On Seattle',2,NULL,'f','2008-03-12 10:22:41');
INSERT INTO CHANSON VALUES(3587,'Dumb',2,NULL,'f','2008-03-12 18:35:03');
INSERT INTO CHANSON VALUES(3588,'Very Ape',2,NULL,'f','2008-03-12 15:26:20');
INSERT INTO CHANSON VALUES(3589,'Milk It',2,NULL,'f','2008-03-12 13:36:56');
INSERT INTO CHANSON VALUES(3590,'Pennyroyal Tea',2,NULL,'f','2008-03-12 14:20:38');
INSERT INTO CHANSON VALUES(3591,'Radio Friendly Unit Shifter',2,NULL,NULL,'2008-03-12 17:01:55');
INSERT INTO CHANSON VALUES(3592,'tourette''s',2,NULL,'f','2008-03-12 09:28:48');
INSERT INTO CHANSON VALUES(3593,'All Apologies',2,NULL,'f','2008-03-12 18:05:02');
INSERT INTO CHANSON VALUES(3594,'Birthday',2,NULL,'f','2008-03-12 12:32:15');
INSERT INTO CHANSON VALUES(3595,'Yer Blues',2,NULL,'f','2008-03-12 15:19:21');
INSERT INTO CHANSON VALUES(3596,'Mother Nature''s Son',2,NULL,'f','2008-03-12 11:34:44');
INSERT INTO CHANSON VALUES(3597,'Everybody''s Got Something To Hide Except Me And My Monkey',2,NULL,'f','2008-03-12 08:24:19');
INSERT INTO CHANSON VALUES(3598,'Sexy Sadie',2,NULL,'f','2008-03-12 08:03:46');
INSERT INTO CHANSON VALUES(3599,'Helter Skelter',2,NULL,'f','2008-03-12 12:30:23');
INSERT INTO CHANSON VALUES(3600,'Long, Long, Long',2,NULL,'f','2008-03-12 12:02:44');
INSERT INTO CHANSON VALUES(3601,'Revolution 1',2,NULL,'f','2008-03-12 19:48:46');
INSERT INTO CHANSON VALUES(3602,'Honey Pie',2,NULL,'f','2008-03-12 19:58:15');
INSERT INTO CHANSON VALUES(3603,'Savoy Truffle',2,NULL,'f','2008-03-12 16:51:20');
INSERT INTO CHANSON VALUES(3604,'Cry Baby Cry',2,NULL,NULL,'2008-03-12 17:12:52');
INSERT INTO CHANSON VALUES(3605,'Revolution 9',2,NULL,NULL,'2008-03-12 08:50:12');
INSERT INTO CHANSON VALUES(3606,'Good Night',2,NULL,'f','2008-03-12 12:10:46');
INSERT INTO CHANSON VALUES(3607,'In the sand',2,NULL,'f','2008-03-12 09:10:11');
INSERT INTO CHANSON VALUES(3608,'Don''t',2,NULL,'f','2008-03-12 13:13:14');
INSERT INTO CHANSON VALUES(3609,'R u kiddin'' me',2,NULL,'f','2008-03-12 11:37:45');
INSERT INTO CHANSON VALUES(3610,'Tom Waits',2,NULL,'f','2008-03-12 15:58:48');
INSERT INTO CHANSON VALUES(3611,'Urban solitude',2,NULL,'f','2008-03-12 12:57:36');
INSERT INTO CHANSON VALUES(3612,'U being U',2,NULL,'f','2008-03-12 10:52:35');
INSERT INTO CHANSON VALUES(3613,'Michel',2,NULL,'f','2008-03-12 13:36:26');
INSERT INTO CHANSON VALUES(3614,'The dark',2,NULL,'f','2008-03-12 17:22:39');
INSERT INTO CHANSON VALUES(3615,'My best wasn''t me',2,NULL,NULL,'2008-03-12 15:24:30');
INSERT INTO CHANSON VALUES(3616,'It wasn''t me',2,NULL,NULL,'2008-03-12 18:48:40');
INSERT INTO CHANSON VALUES(3617,'Cry',2,NULL,'f','2008-03-12 15:57:50');
INSERT INTO CHANSON VALUES(3618,'Body brain (2)',2,NULL,'f','2008-03-12 17:26:03');
INSERT INTO CHANSON VALUES(3619,'My friend',2,NULL,'f','2008-03-12 08:42:41');
INSERT INTO CHANSON VALUES(3620,'Uncle Arthur',2,NULL,'f','2008-06-07 16:09:39.75276');
INSERT INTO CHANSON VALUES(3621,'Sell Me A Coat',2,NULL,'f','2008-03-16 15:45:36');
INSERT INTO CHANSON VALUES(3622,'Rubber Band',2,NULL,'f','2008-03-23 11:55:28');
INSERT INTO CHANSON VALUES(3623,'Love You Til Tuesday',2,NULL,'f','2008-06-07 19:38:48.532996');
INSERT INTO CHANSON VALUES(3624,'There Is A Happy Land',2,NULL,'f','2008-06-07 18:15:37.975975');
INSERT INTO CHANSON VALUES(3625,'We Are Hungry Men',2,NULL,'f','2008-06-07 18:16:00.898551');
INSERT INTO CHANSON VALUES(3626,'When I Live My Dream',2,NULL,'f','2008-06-07 18:16:23.759467');
INSERT INTO CHANSON VALUES(3627,'Little Bombardier',2,NULL,'f','2008-06-07 19:33:06.261276');
INSERT INTO CHANSON VALUES(3628,'Silly Boy Blue',2,NULL,'f','2008-06-07 18:17:02.260223');
INSERT INTO CHANSON VALUES(3629,'Come And Buy My Toys',2,NULL,'f','2008-06-07 18:17:27.701755');
INSERT INTO CHANSON VALUES(3630,'Join The Gang',2,NULL,'f','2008-06-07 18:31:28.71226');
INSERT INTO CHANSON VALUES(3631,'She''s Got Medals',2,NULL,'f','2008-06-07 18:31:47.124147');
INSERT INTO CHANSON VALUES(3632,'Maid Of Bond Street',2,NULL,'f','2008-06-07 18:32:01.93235');
INSERT INTO CHANSON VALUES(3633,'Please Mr. Gravedigger',2,NULL,'f','2008-04-11 10:16:31');
INSERT INTO CHANSON VALUES(3634,'Depuis Ce Jour-là',2,NULL,'f','2008-03-12 13:42:12');
INSERT INTO CHANSON VALUES(3635,'Les Yeux De Ma Mère',2,NULL,'f','2008-03-12 14:59:19');
INSERT INTO CHANSON VALUES(3636,'Laisse-moi Danser',2,NULL,'f','2008-03-12 19:56:05');
INSERT INTO CHANSON VALUES(3637,'Elle Pense à Lui',2,NULL,NULL,'2008-03-12 18:23:42');
INSERT INTO CHANSON VALUES(3639,'La Danseuse de Java',2,NULL,NULL,'2008-03-12 10:27:02');
INSERT INTO CHANSON VALUES(3640,'T''Inquiète Pas',2,NULL,'f','2008-03-12 11:28:11');
INSERT INTO CHANSON VALUES(3642,'... Tu Sais',2,NULL,NULL,'2008-03-12 11:33:47');
INSERT INTO CHANSON VALUES(3643,'Je Ne Veux Pas Être Grand',2,NULL,'f','2008-03-12 10:31:39');
INSERT INTO CHANSON VALUES(3644,'Seul',2,NULL,'f','2008-03-12 08:58:21');
INSERT INTO CHANSON VALUES(3645,'Oui, Là-Bas',2,NULL,'f','2008-03-12 11:30:21');
INSERT INTO CHANSON VALUES(3646,'Comme à Ostende',2,NULL,'f','2008-03-12 15:30:18');
INSERT INTO CHANSON VALUES(3647,'Hyperspace',2,NULL,'f','2008-03-12 16:22:41');
INSERT INTO CHANSON VALUES(3648,'Amateur',2,NULL,'f','2008-03-12 12:56:11');
INSERT INTO CHANSON VALUES(3649,'Why are you so mean to me?',2,NULL,'f','2008-03-12 12:08:39');
INSERT INTO CHANSON VALUES(3650,'Mother''s Day',2,NULL,'f','2008-03-12 12:27:08');
INSERT INTO CHANSON VALUES(3651,'Troublemaker',2,NULL,'f','2008-03-12 15:34:20');
INSERT INTO CHANSON VALUES(3652,'80 windows',2,NULL,'f','2008-03-12 17:51:53');
INSERT INTO CHANSON VALUES(3653,'Bacardi',2,NULL,'f','2008-03-12 14:03:24');
INSERT INTO CHANSON VALUES(3654,'Bad Best Friend',2,NULL,'f','2008-03-12 10:06:22');
INSERT INTO CHANSON VALUES(3655,'Disposession',2,NULL,'f','2008-03-12 15:22:53');
INSERT INTO CHANSON VALUES(3656,'The Voices',2,NULL,'f','2008-03-12 19:57:23');
INSERT INTO CHANSON VALUES(3657,'Firecracker',2,NULL,'f','2008-03-12 10:38:46');
INSERT INTO CHANSON VALUES(3658,'Slow Down',2,NULL,'f','2008-03-12 19:02:42');
INSERT INTO CHANSON VALUES(3659,'Robot',2,NULL,'f','2008-03-12 09:24:51');
INSERT INTO CHANSON VALUES(3660,'Au fond du couloir',2,NULL,'f','2008-03-12 17:48:18');
INSERT INTO CHANSON VALUES(3661,'Get up, Get older',2,NULL,NULL,'2008-03-12 19:25:53');
INSERT INTO CHANSON VALUES(3662,'Y''a d''la haine',2,NULL,'f','2008-03-12 11:12:44');
INSERT INTO CHANSON VALUES(3663,'La steppe',2,NULL,'f','2008-03-12 09:46:48');
INSERT INTO CHANSON VALUES(3664,'Les amants',2,NULL,'f','2008-03-12 14:59:55');
INSERT INTO CHANSON VALUES(3665,'L''htel particulier',2,NULL,'f','2008-03-12 19:34:17');
INSERT INTO CHANSON VALUES(3666,'Femme d''affaire',2,NULL,'f','2008-03-12 18:31:15');
INSERT INTO CHANSON VALUES(3667,'My love is bad',2,NULL,NULL,'2008-03-12 10:46:53');
INSERT INTO CHANSON VALUES(3668,'Chanson d''a',2,NULL,'f','2008-03-12 08:42:55');
INSERT INTO CHANSON VALUES(3669,'Elevator',2,NULL,'f','2008-03-12 16:50:19');
INSERT INTO CHANSON VALUES(3670,'Godfather of soul',2,NULL,'f','2008-03-12 14:38:08');
INSERT INTO CHANSON VALUES(3671,'Chère petites',2,NULL,'f','2008-03-12 18:35:33');
INSERT INTO CHANSON VALUES(3672,'La belle vie',2,NULL,'f','2008-03-12 17:51:45');
INSERT INTO CHANSON VALUES(3673,'Modern baleine',2,NULL,NULL,'2008-03-12 14:01:32');
INSERT INTO CHANSON VALUES(3674,'Sultans of Swing',2,NULL,'f','2008-03-12 11:35:31');
INSERT INTO CHANSON VALUES(3675,'Down To The Waterline',2,NULL,'f','2008-03-12 11:32:06');
INSERT INTO CHANSON VALUES(3676,'Portobello Belle - Live',2,NULL,'f','2008-03-12 14:23:38');
INSERT INTO CHANSON VALUES(3677,'Twisting By The Pool (Remix)',2,NULL,'f','2008-04-07 11:18:37');
INSERT INTO CHANSON VALUES(3678,'Tunnel Of Love',2,NULL,'f','2008-03-12 17:37:24');
INSERT INTO CHANSON VALUES(3679,'Romeo And Juliet',2,NULL,'f','2008-03-12 16:38:06');
INSERT INTO CHANSON VALUES(3680,'Where Do You Think You''re Going',2,NULL,'f','2008-04-18 16:11:11');
INSERT INTO CHANSON VALUES(3682,'Private Investigations',2,NULL,'f','2008-03-12 19:55:35');
INSERT INTO CHANSON VALUES(3683,'Telegraph Road - Live (Remix)',2,NULL,'f','2008-03-12 09:48:11');
INSERT INTO CHANSON VALUES(3686,'Change Of Ideas',2,NULL,'f','2008-03-12 19:25:40');
INSERT INTO CHANSON VALUES(3687,'Big Bang',2,NULL,'f','2008-03-12 13:40:13');
INSERT INTO CHANSON VALUES(3688,'No Control',2,NULL,'f','2008-03-12 14:13:36');
INSERT INTO CHANSON VALUES(3689,'Sometimes I Feel Like',2,NULL,'f','2008-03-12 10:01:14');
INSERT INTO CHANSON VALUES(3690,'Automatic Man',2,NULL,'f','2008-03-12 15:42:53');
INSERT INTO CHANSON VALUES(3691,'I Want To Conquer The World',2,NULL,'f','2008-03-12 16:19:14');
INSERT INTO CHANSON VALUES(3692,'Sanity',2,NULL,'f','2008-03-12 16:16:09');
INSERT INTO CHANSON VALUES(3693,'Henchman',2,NULL,NULL,'2008-03-12 11:21:58');
INSERT INTO CHANSON VALUES(3694,'It Must Look Pretty Appealing',2,NULL,'f','2008-03-12 13:00:32');
INSERT INTO CHANSON VALUES(3695,'You',2,NULL,'f','2008-03-12 14:25:38');
INSERT INTO CHANSON VALUES(3696,'Progress',2,NULL,'f','2008-03-12 15:21:04');
INSERT INTO CHANSON VALUES(3697,'I Want Something More',2,NULL,'f','2008-03-12 11:50:44');
INSERT INTO CHANSON VALUES(3698,'Anxiety',2,NULL,'f','2008-03-12 13:25:58');
INSERT INTO CHANSON VALUES(3699,'Billy',2,NULL,'f','2008-03-12 09:37:59');
INSERT INTO CHANSON VALUES(3700,'The World Won''t Stop',2,NULL,'f','2008-03-12 12:15:42');
INSERT INTO CHANSON VALUES(3701,'Future Legend',2,NULL,'f','2008-06-07 18:32:29.629552');
INSERT INTO CHANSON VALUES(3702,'Diamond Dogs',2,NULL,'f','2008-06-07 18:32:56.722373');
INSERT INTO CHANSON VALUES(3704,'Candidate',2,NULL,NULL,'2008-06-07 18:33:52.29076');
INSERT INTO CHANSON VALUES(3705,'Sweet Thing ( Reprise )',2,NULL,'f','2008-06-07 18:46:45.936859');
INSERT INTO CHANSON VALUES(3706,'Rebel Rebel',2,NULL,'f','2008-03-23 17:30:27');
INSERT INTO CHANSON VALUES(3708,'We Are The Dead',2,NULL,'f','2008-03-26 18:46:17');
INSERT INTO CHANSON VALUES(3709,'1984',2,NULL,'f','2008-04-11 19:14:41');
INSERT INTO CHANSON VALUES(3710,'Big Brother',2,NULL,'f','2008-04-13 18:06:10');
INSERT INTO CHANSON VALUES(3711,'Chant of The Skeletal Family',2,NULL,'f','2008-06-07 18:48:42.727082');
INSERT INTO CHANSON VALUES(3712,'Dodo',2,NULL,'f','2008-06-07 18:49:05.748321');
INSERT INTO CHANSON VALUES(3713,'Candidate',2,NULL,NULL,'2008-06-07 18:33:45.116043');
INSERT INTO CHANSON VALUES(3714,'Crépuscule - Transfert',2,NULL,'f','2008-03-12 11:56:34');
INSERT INTO CHANSON VALUES(3715,'Les mouches bleues',2,NULL,'f','2008-03-12 11:25:14');
INSERT INTO CHANSON VALUES(3716,'Est-ce ta première fin de millénaire?',2,NULL,'f','2008-03-12 15:04:10');
INSERT INTO CHANSON VALUES(3717,'Bruit de bulles',2,NULL,'f','2008-03-12 11:41:34');
INSERT INTO CHANSON VALUES(3718,'Fin de partie',2,NULL,'f','2008-03-12 19:51:30');
INSERT INTO CHANSON VALUES(3719,'Animal en quarantaine',2,NULL,'f','2008-03-23 08:39:00');
INSERT INTO CHANSON VALUES(3720,'Série de 7 rêves en crash position',2,NULL,'f','2008-03-12 14:32:46');
INSERT INTO CHANSON VALUES(3721,'Juste une valse noire',2,NULL,'f','2008-03-12 17:09:01');
INSERT INTO CHANSON VALUES(3722,'Paranoïd Game',2,NULL,'f','2008-03-12 14:44:23');
INSERT INTO CHANSON VALUES(3723,'Maalox Texas Blues',2,NULL,'f','2008-03-12 18:19:05');
INSERT INTO CHANSON VALUES(3724,'La Terre tremble',2,NULL,'f','2008-03-12 13:36:01');
INSERT INTO CHANSON VALUES(3725,'Une provinciale de petite bourgeoisie',2,NULL,'f','2008-03-12 08:55:27');
INSERT INTO CHANSON VALUES(3726,'Encore un petit café',2,NULL,'f','2008-03-12 10:32:31');
INSERT INTO CHANSON VALUES(3727,'Terrien, t''es rien',2,NULL,'f','2008-03-12 13:50:13');
INSERT INTO CHANSON VALUES(3728,'Lola Etc',2,NULL,'f','2008-03-12 08:48:05');
INSERT INTO CHANSON VALUES(3729,'Je Veux Nager',2,NULL,'f','2008-03-12 14:51:45');
INSERT INTO CHANSON VALUES(3730,'Mother''s Little Helper',2,NULL,'f','2008-03-17 14:22:17');
INSERT INTO CHANSON VALUES(3731,'Ma Femme',2,NULL,'f','2008-03-12 11:10:26');
INSERT INTO CHANSON VALUES(3732,'They Look At Me',2,NULL,NULL,'2008-03-12 11:40:11');
INSERT INTO CHANSON VALUES(3734,'Amor',2,NULL,'f','2008-03-12 17:58:07');
INSERT INTO CHANSON VALUES(3735,'Elle A Eu',2,NULL,NULL,'2008-03-12 17:58:02');
INSERT INTO CHANSON VALUES(3736,'Lovin'' You',2,NULL,'f','2008-03-12 11:13:35');
INSERT INTO CHANSON VALUES(3737,'Il Est Tombé Du Ciel',2,NULL,'f','2008-03-12 17:38:25');
INSERT INTO CHANSON VALUES(3738,'Not In Love',2,NULL,'f','2008-03-12 08:39:14');
INSERT INTO CHANSON VALUES(3739,'Honky Tonk',2,NULL,'f','2008-03-12 09:09:05');
INSERT INTO CHANSON VALUES(3740,'Hey Sister',2,NULL,'f','2008-03-12 18:40:27');
INSERT INTO CHANSON VALUES(3741,'Pas Heureux Ni Malheureux (Bonus)',2,NULL,'f','2008-03-12 09:58:37');
INSERT INTO CHANSON VALUES(3742,'Solo Gigolo (Bonus)',2,NULL,NULL,'2008-03-12 15:18:18');
INSERT INTO CHANSON VALUES(3743,'Vision Of Paradise',2,NULL,'f','2008-03-12 17:00:50');
INSERT INTO CHANSON VALUES(3744,'Joy',2,NULL,'f','2008-04-11 16:53:13');
INSERT INTO CHANSON VALUES(3745,'Dancing In The Starlight',2,NULL,'f','2008-03-12 11:48:48');
INSERT INTO CHANSON VALUES(3746,'God Gave Me Everything',2,NULL,'f','2008-03-12 13:38:47');
INSERT INTO CHANSON VALUES(3747,'Hide Away',2,NULL,'f','2008-03-12 13:55:01');
INSERT INTO CHANSON VALUES(3748,'Don''t Call Me Up',2,NULL,'f','2008-03-12 08:43:40');
INSERT INTO CHANSON VALUES(3749,'Goddess In The Doorway',2,NULL,'f','2008-03-12 14:45:19');
INSERT INTO CHANSON VALUES(3750,'Lucky Day',2,NULL,'f','2008-03-12 16:53:29');
INSERT INTO CHANSON VALUES(3751,'Everybody Getting High',2,NULL,'f','2008-03-12 18:46:10');
INSERT INTO CHANSON VALUES(3752,'Gun',2,NULL,'f','2008-03-12 11:55:08');
INSERT INTO CHANSON VALUES(3753,'Too Far Gone',2,NULL,'f','2008-03-12 19:32:27');
INSERT INTO CHANSON VALUES(3754,'Brand New Set Of Rules',2,NULL,'f','2008-03-12 10:20:28');
INSERT INTO CHANSON VALUES(3755,'Temptation Waits',2,NULL,'f','2008-03-23 09:38:16');
INSERT INTO CHANSON VALUES(3756,'I Think I''m Paranoid',2,NULL,'f','2008-03-23 18:04:55');
INSERT INTO CHANSON VALUES(3757,'When I Grow Up',2,NULL,'f','2008-03-23 16:33:50');
INSERT INTO CHANSON VALUES(3758,'Medication',2,NULL,'f','2008-03-23 16:38:33');
INSERT INTO CHANSON VALUES(3759,'Special',2,NULL,'f','2008-03-23 12:09:19');
INSERT INTO CHANSON VALUES(3760,'Hammering in My Head',2,NULL,'f','2008-03-23 10:44:59');
INSERT INTO CHANSON VALUES(3761,'Push It',2,NULL,NULL,'2008-03-23 12:02:55');
INSERT INTO CHANSON VALUES(3762,'The Trick Is To Keep Breathing',2,NULL,'f','2008-03-23 14:57:27');
INSERT INTO CHANSON VALUES(3763,'Dumb',2,NULL,'f','2008-03-23 19:12:47');
INSERT INTO CHANSON VALUES(3764,'Sleep Together',2,NULL,'f','2008-03-23 13:17:26');
INSERT INTO CHANSON VALUES(3765,'Wicked Ways',2,NULL,'f','2008-03-12 16:11:31');
INSERT INTO CHANSON VALUES(3766,'You Look So Fine',2,NULL,'f','2008-03-23 15:52:05');
INSERT INTO CHANSON VALUES(3767,'Restez Avec Moi',2,NULL,NULL,'2008-03-12 13:34:43');
INSERT INTO CHANSON VALUES(3768,'Jalousie',2,NULL,NULL,'2008-03-12 08:56:52');
INSERT INTO CHANSON VALUES(3769,'La Futur N°4',2,NULL,'f','2008-03-12 12:38:46');
INSERT INTO CHANSON VALUES(3770,'La Fille Venue Du Froid',2,NULL,'f','2008-03-12 14:49:30');
INSERT INTO CHANSON VALUES(3771,'Yakatagan',2,NULL,'f','2008-03-12 14:10:33');
INSERT INTO CHANSON VALUES(3772,'In My Tea',2,NULL,'f','2008-03-12 13:40:30');
INSERT INTO CHANSON VALUES(3773,'Marcia Baïla',2,NULL,'f','2008-03-12 19:38:43');
INSERT INTO CHANSON VALUES(3774,'Oum Khalsoum',2,NULL,'f','2008-03-12 16:03:00');
INSERT INTO CHANSON VALUES(3775,'Amnésie',2,NULL,'f','2008-03-12 10:45:12');
INSERT INTO CHANSON VALUES(3776,'Don''t forget the nite',2,NULL,'f','2008-03-12 16:23:04');
INSERT INTO CHANSON VALUES(3777,'Galoping',2,NULL,'f','2008-03-12 17:50:39');
INSERT INTO CHANSON VALUES(3778,'Dans La Steppe',2,NULL,'f','2008-03-12 14:52:36');
INSERT INTO CHANSON VALUES(3779,'Minuit Dansant',2,NULL,'f','2008-03-12 13:14:14');
INSERT INTO CHANSON VALUES(3780,'Aïe (Kriptonite miss Spleïn)',2,NULL,'f','2008-03-12 10:49:04');
INSERT INTO CHANSON VALUES(3781,'Space Oddity',2,NULL,'f','2008-04-12 16:13:47');
INSERT INTO CHANSON VALUES(3782,'Unwashed And Somewhat Slightly Dazed',2,NULL,'f','2008-03-17 16:23:15');
INSERT INTO CHANSON VALUES(3783,'Don''t Sit Down',2,NULL,NULL,'2008-06-07 15:57:14.281626');
INSERT INTO CHANSON VALUES(3784,'Letter To Hermione',2,NULL,NULL,'2008-06-07 15:57:30.935103');
INSERT INTO CHANSON VALUES(3785,'Cygnet Committee',2,NULL,'f','2008-04-07 15:04:56');
INSERT INTO CHANSON VALUES(3786,'Janine',2,NULL,'f','2008-04-11 08:38:19');
INSERT INTO CHANSON VALUES(3787,'An Occasional Dream',2,NULL,'f','2008-06-07 15:58:24.151614');
INSERT INTO CHANSON VALUES(3788,'Wild Eyed Boy From Freecloud',2,NULL,'f','2008-06-07 15:26:24.16802');
INSERT INTO CHANSON VALUES(3789,'God Knows I''m Good',2,NULL,'f','2008-04-24 17:48:41');
INSERT INTO CHANSON VALUES(3790,'Memory Of A Free Festival',2,NULL,'f','2008-06-07 15:27:01.953163');
INSERT INTO CHANSON VALUES(3791,'Conversation Piece',2,NULL,'f','2008-06-07 15:27:41.878158');
INSERT INTO CHANSON VALUES(3792,'Memory Of A Free Festival Part 1',2,NULL,'f','2008-06-07 15:27:07.74437');
INSERT INTO CHANSON VALUES(3793,'Memory Of A Free Festival Part 2',2,NULL,NULL,'2008-06-07 15:27:17.906783');
INSERT INTO CHANSON VALUES(3794,'Let Be Must The Queen',2,NULL,NULL,'2008-03-12 11:26:33');
INSERT INTO CHANSON VALUES(3795,'Triangle',2,NULL,'f','2008-03-12 12:09:56');
INSERT INTO CHANSON VALUES(3796,'Etienne',2,NULL,'f','2008-03-12 15:25:48');
INSERT INTO CHANSON VALUES(3797,'Backstage D''une Star',2,NULL,'f','2008-03-12 14:12:38');
INSERT INTO CHANSON VALUES(3798,'Bon Anniversaire',2,NULL,'f','2008-03-12 09:42:12');
INSERT INTO CHANSON VALUES(3799,'Faits Divers',2,NULL,'f','2008-03-12 17:13:58');
INSERT INTO CHANSON VALUES(3800,'Roule.. Tu Dis',2,NULL,'f','2008-03-12 09:56:26');
INSERT INTO CHANSON VALUES(3801,'Culture',2,NULL,'f','2008-03-12 18:44:43');
INSERT INTO CHANSON VALUES(3802,'Cul Cul Clan',2,NULL,'f','2008-03-12 14:10:33');
INSERT INTO CHANSON VALUES(3803,'Manque un Détail',2,NULL,NULL,'2008-03-12 08:13:47');
INSERT INTO CHANSON VALUES(3804,'Tout Seul...',2,NULL,'f','2008-03-12 17:30:13');
INSERT INTO CHANSON VALUES(3805,'C''est Pas Assez',2,NULL,'f','2008-03-12 11:52:23');
INSERT INTO CHANSON VALUES(3806,'Un Espoir',2,NULL,'f','2008-03-12 11:29:48');
INSERT INTO CHANSON VALUES(3807,'Small Town',2,NULL,'f','2008-03-12 08:02:01');
INSERT INTO CHANSON VALUES(3808,'Open House',2,NULL,'f','2008-03-12 16:09:43');
INSERT INTO CHANSON VALUES(3809,'Style It Takes',2,NULL,'f','2008-03-12 19:55:57');
INSERT INTO CHANSON VALUES(3810,'Work',2,NULL,'f','2008-03-12 18:03:53');
INSERT INTO CHANSON VALUES(3811,'Trouble With Classicists',2,NULL,'f','2008-03-12 12:58:38');
INSERT INTO CHANSON VALUES(3812,'Starlight',2,NULL,'f','2008-03-12 08:30:48');
INSERT INTO CHANSON VALUES(3813,'Faces And Names',2,NULL,'f','2008-03-12 15:33:02');
INSERT INTO CHANSON VALUES(3814,'Images',2,NULL,'f','2008-03-12 12:19:33');
INSERT INTO CHANSON VALUES(3815,'Slip Away (A Warning)',2,NULL,'f','2008-03-12 15:39:25');
INSERT INTO CHANSON VALUES(3816,'It Wasn''t Me',2,NULL,'f','2008-03-12 08:55:55');
INSERT INTO CHANSON VALUES(3817,'I Believe',2,NULL,'f','2008-03-12 18:59:57');
INSERT INTO CHANSON VALUES(3818,'Nobody But You',2,NULL,'f','2008-03-12 18:42:07');
INSERT INTO CHANSON VALUES(3819,'A Dream',2,NULL,'f','2008-03-12 14:37:02');
INSERT INTO CHANSON VALUES(3820,'Forever Changed',2,NULL,'f','2008-03-12 14:31:06');
INSERT INTO CHANSON VALUES(3821,'Hello It''s Me',2,NULL,'f','2008-03-12 13:51:04');
INSERT INTO CHANSON VALUES(3822,'The River',2,NULL,'f','2008-03-12 08:55:35');
INSERT INTO CHANSON VALUES(3823,'War',2,NULL,NULL,'2008-03-12 18:32:08');
INSERT INTO CHANSON VALUES(3824,'Darlington County',2,NULL,'f','2008-03-12 19:57:28');
INSERT INTO CHANSON VALUES(3825,'Working on the highway',2,NULL,'f','2008-03-12 13:35:07');
INSERT INTO CHANSON VALUES(3826,'The promised Land',2,NULL,NULL,'2008-03-12 18:36:02');
INSERT INTO CHANSON VALUES(3827,'Cover me',2,NULL,NULL,'2008-03-12 17:27:02');
INSERT INTO CHANSON VALUES(3828,'I''m on fire',2,NULL,'f','2008-03-12 17:18:44');
INSERT INTO CHANSON VALUES(3829,'Bobby jean',2,NULL,NULL,'2008-03-12 18:53:22');
INSERT INTO CHANSON VALUES(3830,'My hometown',2,NULL,'f','2008-03-12 19:25:54');
INSERT INTO CHANSON VALUES(3831,'Born to run',2,NULL,'f','2008-03-12 08:50:45');
INSERT INTO CHANSON VALUES(3832,'No surrender',2,NULL,'f','2008-06-05 16:12:16.951411');
INSERT INTO CHANSON VALUES(3833,'Tenth Avenue freeze out',2,NULL,'f','2008-03-12 16:47:14');
INSERT INTO CHANSON VALUES(3834,'Jersey girl',2,NULL,'f','2008-03-12 18:42:11');
INSERT INTO CHANSON VALUES(3835,'Sgt. Pepper''s Lonely Hearts Club Band',2,NULL,'f','2008-03-12 12:10:46');
INSERT INTO CHANSON VALUES(3837,'Lucy In The Sky With Diamonds',2,NULL,'f','2008-03-12 14:54:50');
INSERT INTO CHANSON VALUES(3838,'Getting Better',2,NULL,'f','2008-03-12 14:42:08');
INSERT INTO CHANSON VALUES(3839,'Fixing A Hole',2,NULL,'f','2008-03-12 11:36:02');
INSERT INTO CHANSON VALUES(3840,'She''s Leaving Home',2,NULL,'f','2008-03-12 16:34:27');
INSERT INTO CHANSON VALUES(3841,'Being For The Benefit Of Mr. Kite',2,NULL,'f','2008-03-12 15:38:17');
INSERT INTO CHANSON VALUES(3842,'Within You Without You',2,NULL,'f','2008-03-12 12:47:12');
INSERT INTO CHANSON VALUES(3843,'When I''m Sixty-four',2,NULL,'f','2008-03-12 08:31:59');
INSERT INTO CHANSON VALUES(3844,'Lovely Rita',2,NULL,'f','2008-03-12 11:24:42');
INSERT INTO CHANSON VALUES(3845,'Good Morning Good Morning',2,NULL,'f','2008-03-12 13:46:53');
INSERT INTO CHANSON VALUES(3846,'Sgt. Pepper''s Lonely Hearts Club Band (Reprise)',2,NULL,'f','2008-03-12 10:15:58');
INSERT INTO CHANSON VALUES(3847,'A Day In The Life',2,NULL,'f','2008-03-12 15:46:53');
INSERT INTO CHANSON VALUES(3848,'No,No,No',2,NULL,'f','2008-03-12 13:20:35');
INSERT INTO CHANSON VALUES(3849,'En route pour la joie',2,NULL,'f','2008-03-12 15:38:12');
INSERT INTO CHANSON VALUES(3850,'Charlie',2,NULL,'f','2008-03-24 16:17:35');
INSERT INTO CHANSON VALUES(3851,'Tu m''donnes le mal',2,NULL,'f','2008-03-12 15:20:46');
INSERT INTO CHANSON VALUES(3852,'Si rien ne bouge',2,NULL,'f','2008-03-12 09:55:25');
INSERT INTO CHANSON VALUES(3853,'The holy economic war',2,NULL,'f','2008-03-12 12:17:12');
INSERT INTO CHANSON VALUES(3854,'Tout l''or',2,NULL,NULL,'2008-03-12 15:20:44');
INSERT INTO CHANSON VALUES(3855,'La chanson de la main',2,NULL,'f','2008-03-12 15:37:09');
INSERT INTO CHANSON VALUES(3856,'Pictures of yourself',2,NULL,'f','2008-03-12 11:05:55');
INSERT INTO CHANSON VALUES(3857,'Les oriflammes',2,NULL,'f','2008-03-12 10:19:10');
INSERT INTO CHANSON VALUES(3858,'Elle va où elle veut',2,NULL,'f','2008-03-12 10:57:57');
INSERT INTO CHANSON VALUES(3859,'Le zen Emoi',2,NULL,'f','2008-03-12 08:26:17');
INSERT INTO CHANSON VALUES(3860,'The chameleon',2,NULL,NULL,'2008-03-12 18:43:16');
INSERT INTO CHANSON VALUES(3861,'Hoo Doo',2,NULL,NULL,'2008-03-12 15:50:12');
INSERT INTO CHANSON VALUES(3862,'Boogie Woogie into town',2,NULL,'f','2008-03-12 08:15:29');
INSERT INTO CHANSON VALUES(3863,'Dancing inside my head',2,NULL,'f','2008-03-12 11:52:50');
INSERT INTO CHANSON VALUES(3864,'Funky you''re not',2,NULL,'f','2008-03-12 08:29:27');
INSERT INTO CHANSON VALUES(3865,'Vive ma liberte',2,NULL,'f','2008-03-12 09:48:32');
INSERT INTO CHANSON VALUES(3866,'A beautiful day in L..A.',2,NULL,'f','2008-03-12 08:00:52');
INSERT INTO CHANSON VALUES(3867,'Rita rose',2,NULL,'f','2008-03-12 11:10:49');
INSERT INTO CHANSON VALUES(3868,'Give me the gift',2,NULL,NULL,'2008-03-12 10:14:16');
INSERT INTO CHANSON VALUES(3869,'I sold my soul on MTV',2,NULL,'f','2008-03-12 13:52:20');
INSERT INTO CHANSON VALUES(3870,'Martha ma douce',2,NULL,'f','2008-03-12 13:43:04');
INSERT INTO CHANSON VALUES(3871,'Hoi Hoi (I''m your baby)',2,NULL,'f','2008-03-12 16:21:55');
INSERT INTO CHANSON VALUES(3872,'New born monkey',2,NULL,'f','2008-03-12 18:24:10');
INSERT INTO CHANSON VALUES(3873,'Knock knock',2,NULL,'f','2008-03-12 12:40:03');
INSERT INTO CHANSON VALUES(3874,'Les filles du bord de mer',2,NULL,'f','2008-03-12 10:41:32');
INSERT INTO CHANSON VALUES(3875,'La barre est dure',2,NULL,'f','2008-03-12 16:50:20');
INSERT INTO CHANSON VALUES(3876,'Allo Paris',2,NULL,'f','2008-03-12 10:55:20');
INSERT INTO CHANSON VALUES(3877,'Je  marche seul',2,NULL,'f','2008-03-12 09:10:31');
INSERT INTO CHANSON VALUES(3878,'Sacré Cur',2,NULL,'f','2008-03-24 19:22:45');
INSERT INTO CHANSON VALUES(3879,'Chacun sa peine',2,NULL,'f','2008-03-12 10:52:38');
INSERT INTO CHANSON VALUES(3880,'15 ans du matin',2,NULL,NULL,'2008-03-12 14:18:22');
INSERT INTO CHANSON VALUES(3881,'Pas du gateau',2,NULL,'f','2008-03-12 15:01:44');
INSERT INTO CHANSON VALUES(3882,'Julie',2,NULL,'f','2008-03-12 14:55:09');
INSERT INTO CHANSON VALUES(3883,'Allez viens',2,NULL,'f','2008-03-12 16:20:50');
INSERT INTO CHANSON VALUES(3884,'Toujours quand tu dors',2,NULL,'f','2008-03-12 17:35:31');
INSERT INTO CHANSON VALUES(3885,'Au creux de ton bras',2,NULL,'f','2008-03-12 12:17:22');
INSERT INTO CHANSON VALUES(3886,'Le monde entier',2,NULL,'f','2008-03-12 16:31:17');
INSERT INTO CHANSON VALUES(3887,'La lune',2,NULL,'f','2008-03-12 08:38:28');
INSERT INTO CHANSON VALUES(3888,'On boira de la bière',2,NULL,'f','2008-03-12 14:34:51');
INSERT INTO CHANSON VALUES(3889,'Trop de silence',2,NULL,'f','2008-03-12 11:47:44');
INSERT INTO CHANSON VALUES(3890,'Day-In Day-Out',2,NULL,'f','2008-06-07 12:01:49.64608');
INSERT INTO CHANSON VALUES(3891,'Time Will Crawl',2,NULL,'f','2008-06-07 12:02:04.576409');
INSERT INTO CHANSON VALUES(3892,'Beat of Your Drum',2,NULL,'f','2008-03-19 08:33:59');
INSERT INTO CHANSON VALUES(3893,'Never Let Me Down',2,NULL,'f','2008-06-07 12:02:42.630237');
INSERT INTO CHANSON VALUES(3894,'Zeroes',2,NULL,NULL,'2008-06-07 18:53:14.355409');
INSERT INTO CHANSON VALUES(3895,'Girls (Japanese Version)',2,NULL,NULL,'2008-06-07 18:53:48.278493');
INSERT INTO CHANSON VALUES(3896,'Glass Spider',2,NULL,'f','2008-06-07 18:54:04.567645');
INSERT INTO CHANSON VALUES(3897,'Shining Star (Makin'' My Love)',2,NULL,'f','2008-06-07 18:54:39.888197');
INSERT INTO CHANSON VALUES(3898,'New York''s In Love',2,NULL,'f','2008-06-07 18:55:00.795465');
INSERT INTO CHANSON VALUES(3899,'''87 and Cry',2,NULL,'f','2008-06-07 18:55:17.753449');
INSERT INTO CHANSON VALUES(3900,'Too Dizzy',2,NULL,'f','2008-06-07 18:55:33.559283');
INSERT INTO CHANSON VALUES(3901,'Bang Bang',2,NULL,'f','2008-04-13 15:08:49');
INSERT INTO CHANSON VALUES(3903,'Last of the rockstars',2,NULL,'f','2008-03-12 13:26:40');
INSERT INTO CHANSON VALUES(3904,'On Elvis Presley''s birthday',2,NULL,'f','2008-03-12 12:40:57');
INSERT INTO CHANSON VALUES(3906,'Caught short in the long run',2,NULL,'f','2008-03-12 16:19:30');
INSERT INTO CHANSON VALUES(3907,'Blind Willie McTell',2,NULL,'f','2008-03-12 18:17:37');
INSERT INTO CHANSON VALUES(3908,'Anastasia',2,NULL,'f','2008-03-12 15:32:47');
INSERT INTO CHANSON VALUES(3909,'Dusty roses',2,NULL,'f','2008-03-12 08:16:31');
INSERT INTO CHANSON VALUES(3910,'Change will come',2,NULL,'f','2008-03-12 19:51:34');
INSERT INTO CHANSON VALUES(3911,'Cortez the killer',2,NULL,'f','2008-03-12 17:10:35');
INSERT INTO CHANSON VALUES(3912,'Intro',2,NULL,'f','2008-03-20 18:32:57');
INSERT INTO CHANSON VALUES(3913,'Eat The Rich',2,NULL,'f','2008-03-12 19:57:24');
INSERT INTO CHANSON VALUES(3914,'Get A Grip',2,NULL,'f','2008-03-20 15:22:04');
INSERT INTO CHANSON VALUES(3915,'Fever',2,NULL,'f','2008-03-29 16:48:09');
INSERT INTO CHANSON VALUES(3916,'Livin'' On The Edge',2,NULL,'f','2008-04-09 18:04:09');
INSERT INTO CHANSON VALUES(3917,'Flesh',2,NULL,NULL,'2008-03-12 10:42:26');
INSERT INTO CHANSON VALUES(3918,'Walk On Down',2,NULL,NULL,'2008-04-18 13:31:47');
INSERT INTO CHANSON VALUES(3919,'Shut Up And Dance',2,NULL,'f','2008-03-12 17:21:59');
INSERT INTO CHANSON VALUES(3920,'Cryin''',2,NULL,NULL,'2008-03-12 15:23:15');
INSERT INTO CHANSON VALUES(3921,'Gotta Love It',2,NULL,'f','2008-03-12 09:23:06');
INSERT INTO CHANSON VALUES(3922,'Crazy',2,NULL,'f','2008-03-12 16:09:17');
INSERT INTO CHANSON VALUES(3923,'Line Up',2,NULL,'f','2008-03-12 11:02:50');
INSERT INTO CHANSON VALUES(3924,'Can''t Stop Messin''',2,NULL,'f','2008-03-12 11:01:48');
INSERT INTO CHANSON VALUES(3925,'Amazing',2,NULL,'f','2008-03-12 15:41:10');
INSERT INTO CHANSON VALUES(3926,'Boogie Man',2,NULL,'f','2008-03-12 16:19:19');
INSERT INTO CHANSON VALUES(3927,'Intro Wagner',2,NULL,'f','2008-03-12 14:00:07');
INSERT INTO CHANSON VALUES(3928,'Puta',2,NULL,'f','2008-03-12 16:12:50');
INSERT INTO CHANSON VALUES(3929,'Eccl. 5:1',2,NULL,'f','2008-03-12 09:01:12');
INSERT INTO CHANSON VALUES(3930,'Surfin''love',2,NULL,'f','2008-03-12 09:38:36');
INSERT INTO CHANSON VALUES(3931,'C''est facile de se moquer',2,NULL,'f','2008-03-12 12:46:00');
INSERT INTO CHANSON VALUES(3932,'Petite fille',2,NULL,'f','2008-06-07 19:26:13.196656');
INSERT INTO CHANSON VALUES(3933,'Le costume violet',2,NULL,'f','2008-03-12 17:46:12');
INSERT INTO CHANSON VALUES(3934,'Wo how wo ho wo (pour toi)',2,NULL,'f','2008-03-12 15:02:14');
INSERT INTO CHANSON VALUES(3935,'Ca tourne',2,NULL,'f','2008-03-12 13:42:56');
INSERT INTO CHANSON VALUES(3936,'Tataratatata',2,NULL,'f','2008-03-12 15:26:15');
INSERT INTO CHANSON VALUES(3937,'Je n''suis pas fou',2,NULL,'f','2008-03-12 19:00:16');
INSERT INTO CHANSON VALUES(3938,'Vie, mort et résurection d''un papillon',2,NULL,'f','2008-03-12 08:43:28');
INSERT INTO CHANSON VALUES(3939,'Ce soir c''est  Noël',2,NULL,'f','2008-03-12 19:52:30');
INSERT INTO CHANSON VALUES(3940,'Quand j''étais p''tit',2,NULL,'f','2008-03-12 09:00:08');
INSERT INTO CHANSON VALUES(3941,'L''éternel',2,NULL,'f','2008-03-12 16:24:54');
INSERT INTO CHANSON VALUES(3942,'Quelle joie le rock''n''roll',2,NULL,'f','2008-03-12 17:55:22');
INSERT INTO CHANSON VALUES(3943,'I''m Waiting For The Man',2,NULL,'f','2008-06-07 18:44:34.065558');
INSERT INTO CHANSON VALUES(3944,'Femme Fatale',2,NULL,NULL,'2008-03-12 09:22:11');
INSERT INTO CHANSON VALUES(3945,'Run Run Run',2,NULL,'f','2008-03-23 12:49:53');
INSERT INTO CHANSON VALUES(3947,'All Tomorrow''s Parties',2,NULL,NULL,'2008-03-12 11:26:20');
INSERT INTO CHANSON VALUES(3948,'I''ll Be Your Mirror',2,NULL,'f','2008-03-12 14:23:21');
INSERT INTO CHANSON VALUES(3950,'Stephanie Says',2,NULL,'f','2008-03-12 17:28:04');
INSERT INTO CHANSON VALUES(3951,'What Goes On',2,NULL,'f','2008-03-12 11:23:57');
INSERT INTO CHANSON VALUES(3952,'Beginning To See The Light',2,NULL,NULL,'2008-03-12 17:32:58');
INSERT INTO CHANSON VALUES(3953,'Pale Blue Eyes',2,NULL,NULL,'2008-03-12 19:16:23');
INSERT INTO CHANSON VALUES(3954,'I Can''t Stand It',2,NULL,'f','2008-03-12 18:02:18');
INSERT INTO CHANSON VALUES(3955,'Lisa Says',2,NULL,'f','2008-03-12 10:57:02');
INSERT INTO CHANSON VALUES(3956,'Sweet Jane',2,NULL,'f','2008-03-12 12:04:24');
INSERT INTO CHANSON VALUES(3957,'Rock And Roll',2,NULL,'f','2008-03-12 15:26:13');
INSERT INTO CHANSON VALUES(3958,'Intro',2,NULL,'f','2008-06-07 19:07:47.266479');
INSERT INTO CHANSON VALUES(3959,'You got me rocking',2,NULL,'f','2008-06-02 10:23:58.625599');
INSERT INTO CHANSON VALUES(3963,'Corinna',2,NULL,'f','2008-04-09 16:17:24');
INSERT INTO CHANSON VALUES(3965,'Waiting on a friend',2,NULL,'f','2008-06-02 09:55:19.643723');
INSERT INTO CHANSON VALUES(3968,'Respectable',2,NULL,'f','2008-04-09 13:36:40');
INSERT INTO CHANSON VALUES(3972,'Intro',2,NULL,'f','2008-03-12 19:38:49');
INSERT INTO CHANSON VALUES(3973,'J''ai rencontré Marilou',2,NULL,'f','2008-03-12 12:13:15');
INSERT INTO CHANSON VALUES(3974,'Les boeings',2,NULL,'f','2008-03-12 14:42:00');
INSERT INTO CHANSON VALUES(3975,'J''ai avalé une mouche',2,NULL,'f','2008-03-12 10:32:17');
INSERT INTO CHANSON VALUES(3976,'Aubusson 99',2,NULL,'f','2008-03-12 11:43:25');
INSERT INTO CHANSON VALUES(3977,'The sun don''t shine',2,NULL,NULL,'2008-03-12 18:59:50');
INSERT INTO CHANSON VALUES(3978,'Barbe à papa',2,NULL,'f','2008-03-12 17:13:04');
INSERT INTO CHANSON VALUES(3979,'Tournesol',2,NULL,'f','2008-03-12 10:25:15');
INSERT INTO CHANSON VALUES(3980,'Denise (my love)',2,NULL,'f','2008-03-12 08:01:16');
INSERT INTO CHANSON VALUES(3981,'Les gens riches',2,NULL,'f','2008-03-12 17:54:31');
INSERT INTO CHANSON VALUES(3982,'DW',2,NULL,'f','2008-03-12 14:50:10');
INSERT INTO CHANSON VALUES(3983,'Rising',2,NULL,'f','2008-03-12 12:10:24');
INSERT INTO CHANSON VALUES(3984,'Dauga a raison',2,NULL,'f','2008-03-12 15:44:06');
INSERT INTO CHANSON VALUES(3985,'Je pleurerais quand même',2,NULL,'f','2008-03-12 15:58:39');
INSERT INTO CHANSON VALUES(3986,'Comme un punk en hiver',2,NULL,'f','2008-03-12 18:16:22');
INSERT INTO CHANSON VALUES(3987,'Kiss',2,NULL,'f','2008-03-12 11:06:22');
INSERT INTO CHANSON VALUES(3988,'Pride (In The Name Of Love)',2,NULL,'f','2008-03-12 10:53:36');
INSERT INTO CHANSON VALUES(3989,'New Year''s Day',2,NULL,'f','2008-03-12 11:08:02');
INSERT INTO CHANSON VALUES(3990,'With Or Without You',2,NULL,'f','2008-03-12 14:08:03');
INSERT INTO CHANSON VALUES(3991,'I Still Haven''t Found What I''m Looking For',2,NULL,NULL,'2008-03-12 17:55:58');
INSERT INTO CHANSON VALUES(3992,'Sunday Bloody Sunday',2,NULL,NULL,'2008-03-12 11:27:49');
INSERT INTO CHANSON VALUES(3993,'Bad',2,NULL,'f','2008-03-12 13:48:00');
INSERT INTO CHANSON VALUES(3994,'Where The Streets Have No Name',2,NULL,'f','2008-03-12 18:25:44');
INSERT INTO CHANSON VALUES(3995,'I Will Follow',2,NULL,'f','2008-03-12 08:01:43');
INSERT INTO CHANSON VALUES(3996,'The Unforgettable Fire',2,NULL,'f','2008-03-12 15:56:59');
INSERT INTO CHANSON VALUES(3997,'Sweetest Thing (The Single Mix)',2,NULL,'f','2008-03-12 08:16:06');
INSERT INTO CHANSON VALUES(3998,'Desire',2,NULL,NULL,'2008-03-12 12:26:59');
INSERT INTO CHANSON VALUES(3999,'When Love Comes To Town',2,NULL,'f','2008-03-12 08:41:08');
INSERT INTO CHANSON VALUES(4000,'Angel Of Harlem',2,NULL,'f','2008-03-12 08:12:17');
INSERT INTO CHANSON VALUES(4001,'All I Want Is You',2,NULL,NULL,'2008-03-12 09:58:12');
INSERT INTO CHANSON VALUES(4002,'Taxman',2,NULL,'f','2008-03-12 09:17:40');
INSERT INTO CHANSON VALUES(4003,'Eleanor Rigby',2,NULL,'f','2008-03-12 18:46:29');
INSERT INTO CHANSON VALUES(4004,'I''m Only Sleeping',2,NULL,'f','2008-03-12 18:40:54');
INSERT INTO CHANSON VALUES(4005,'Love You To',2,NULL,'f','2008-03-12 15:40:56');
INSERT INTO CHANSON VALUES(4006,'Here, There And Everywhere',2,NULL,'f','2008-03-12 12:19:52');
INSERT INTO CHANSON VALUES(4007,'Yellow Submarine',2,NULL,'f','2008-03-12 12:21:09');
INSERT INTO CHANSON VALUES(4008,'She Said She Said',2,NULL,'f','2008-03-12 13:46:36');
INSERT INTO CHANSON VALUES(4009,'Good Day Sunshine',2,NULL,'f','2008-03-12 13:47:17');
INSERT INTO CHANSON VALUES(4010,'And Your Bird Can Sing',2,NULL,'f','2008-03-12 15:51:30');
INSERT INTO CHANSON VALUES(4011,'For No One',2,NULL,'f','2008-03-12 18:58:28');
INSERT INTO CHANSON VALUES(4012,'Doctor Robert',2,NULL,'f','2008-03-12 09:03:46');
INSERT INTO CHANSON VALUES(4013,'I Want To Tell You',2,NULL,'f','2008-03-12 17:58:33');
INSERT INTO CHANSON VALUES(4014,'Got To Get You Into My Life',2,NULL,'f','2008-03-12 11:52:13');
INSERT INTO CHANSON VALUES(4015,'Tomorrow Never Knows',2,NULL,'f','2008-03-12 10:32:53');
INSERT INTO CHANSON VALUES(4016,'Docteur Renaud, Mister Renard',2,NULL,'f','2008-03-12 09:54:13');
INSERT INTO CHANSON VALUES(4017,'Petit pédé',2,NULL,'f','2008-03-12 19:16:35');
INSERT INTO CHANSON VALUES(4018,'Je vis caché',2,NULL,'f','2008-03-12 09:44:22');
INSERT INTO CHANSON VALUES(4019,'Cur perdu',2,NULL,'f','2008-03-24 16:12:10');
INSERT INTO CHANSON VALUES(4020,'Manhattan-Kaboul',2,NULL,'f','2008-03-12 08:49:01');
INSERT INTO CHANSON VALUES(4021,'Elle a vu le loup',2,NULL,'f','2008-03-12 14:43:59');
INSERT INTO CHANSON VALUES(4022,'Tout arrêter...',2,NULL,NULL,'2008-03-12 08:49:03');
INSERT INTO CHANSON VALUES(4023,'Baltique',2,NULL,NULL,'2008-03-12 17:37:01');
INSERT INTO CHANSON VALUES(4024,'L''entarté',2,NULL,'f','2008-03-12 12:53:54');
INSERT INTO CHANSON VALUES(4025,'Boucan d''enfer',2,NULL,NULL,'2008-03-12 14:04:26');
INSERT INTO CHANSON VALUES(4026,'Mon nain de jardin',2,NULL,'f','2008-03-12 13:11:21');
INSERT INTO CHANSON VALUES(4027,'Mal barrés',2,NULL,'f','2008-03-12 16:10:37');
INSERT INTO CHANSON VALUES(4028,'Corsic''armes',2,NULL,'f','2008-03-12 11:19:21');
INSERT INTO CHANSON VALUES(4029,'Mon bistrot préféré',2,NULL,'f','2008-03-12 16:04:34');
INSERT INTO CHANSON VALUES(4030,'The Wedding',2,NULL,'f','2008-06-07 19:47:57.356198');
INSERT INTO CHANSON VALUES(4031,'You''ve Been Around',2,NULL,'f','2008-06-07 15:38:34.526133');
INSERT INTO CHANSON VALUES(4032,'I Feel Free',2,NULL,'f','2008-03-22 18:42:57');
INSERT INTO CHANSON VALUES(4033,'Black Tie White Noise',2,NULL,'f','2008-06-07 15:39:06.09981');
INSERT INTO CHANSON VALUES(4034,'Jump They Say',2,NULL,'f','2008-04-09 15:03:21');
INSERT INTO CHANSON VALUES(4035,'Nite Flights',2,NULL,'f','2008-06-07 16:07:44.999883');
INSERT INTO CHANSON VALUES(4036,'Pallas Athena',2,NULL,'f','2008-06-07 16:07:58.98227');
INSERT INTO CHANSON VALUES(4037,'Miracle Goodnight',2,NULL,'f','2008-06-07 15:20:31.502166');
INSERT INTO CHANSON VALUES(4038,'Don''t Let Me Down & Down',2,NULL,'f','2008-06-07 16:08:18.117105');
INSERT INTO CHANSON VALUES(4039,'Looking For Lester',2,NULL,'f','2008-06-07 19:39:23.087876');
INSERT INTO CHANSON VALUES(4040,'I Know It''s Gonna Happen Someday',2,NULL,NULL,'2008-06-07 16:08:37.284394');
INSERT INTO CHANSON VALUES(4041,'The Wedding Song',2,NULL,'f','2008-06-07 16:08:58.834861');
INSERT INTO CHANSON VALUES(4042,'Jump They Say (Alternate Mix)',2,NULL,'f','2008-04-09 09:51:21');
INSERT INTO CHANSON VALUES(4043,'Lucy Can''t Dance',2,NULL,'f','2008-06-07 16:09:19.627064');
INSERT INTO CHANSON VALUES(4044,'Anter-ouache/Ouache',3,NULL,'f','2008-03-12 16:06:48');
INSERT INTO CHANSON VALUES(4045,'Emma',3,NULL,'f','2008-03-12 16:01:18');
INSERT INTO CHANSON VALUES(4046,'Lambé An Dro',3,NULL,'f','2008-03-12 10:56:09');
INSERT INTO CHANSON VALUES(4047,'Troglodyte',3,NULL,'f','2008-04-07 11:55:15');
INSERT INTO CHANSON VALUES(4048,'Kerfautras',3,NULL,'f','2008-03-12 16:47:35');
INSERT INTO CHANSON VALUES(4049,'Dernière journée en mer',3,NULL,'f','2008-03-12 10:03:29');
INSERT INTO CHANSON VALUES(4050,'L''apologie',3,NULL,'f','2008-03-12 19:41:06');
INSERT INTO CHANSON VALUES(4051,'La fille du Chat Noir',3,NULL,NULL,'2008-03-12 18:56:00');
INSERT INTO CHANSON VALUES(4052,'An Den Coz',3,NULL,'f','2008-03-12 09:34:34');
INSERT INTO CHANSON VALUES(4053,'Derrière ton dos',3,NULL,'f','2008-03-12 12:45:58');
INSERT INTO CHANSON VALUES(4054,'Les moutons',3,NULL,'f','2008-03-12 17:21:14');
INSERT INTO CHANSON VALUES(4055,'La complainte de Fanch',3,NULL,'f','2008-03-12 19:04:21');
INSERT INTO CHANSON VALUES(4056,'Ribette''s',3,NULL,'f','2008-03-12 16:45:22');
INSERT INTO CHANSON VALUES(4057,'Toujours ensemble',2,NULL,NULL,'2008-03-12 08:59:19');
INSERT INTO CHANSON VALUES(4058,'Royaume de jeunesse',2,NULL,NULL,'2008-03-12 10:41:06');
INSERT INTO CHANSON VALUES(4059,'La boxe de l''ombre',2,NULL,'f','2008-03-12 17:56:10');
INSERT INTO CHANSON VALUES(4060,'Tatouages',2,NULL,'f','2008-03-12 11:53:52');
INSERT INTO CHANSON VALUES(4061,'Les combattants de la spirale d''or',2,NULL,'f','2008-03-12 12:45:49');
INSERT INTO CHANSON VALUES(4062,'Cassons les murs',2,NULL,'f','2008-03-12 12:50:23');
INSERT INTO CHANSON VALUES(4063,'Au Québec',2,NULL,'f','2008-03-12 19:14:08');
INSERT INTO CHANSON VALUES(4064,'A bout portant',2,NULL,'f','2008-03-12 19:04:30');
INSERT INTO CHANSON VALUES(4065,'Shambala',2,NULL,'f','2008-03-12 10:00:35');
INSERT INTO CHANSON VALUES(4066,'Rue des fusillés',2,NULL,'f','2008-03-12 14:44:20');
INSERT INTO CHANSON VALUES(4067,'Les blousons noirs',2,NULL,'f','2008-03-12 19:47:19');
INSERT INTO CHANSON VALUES(4068,'Choeurs fidèles',2,NULL,'f','2008-03-12 11:59:01');
INSERT INTO CHANSON VALUES(4069,'Paris Saïgon',2,NULL,'f','2008-03-12 12:47:57');
INSERT INTO CHANSON VALUES(4070,'Chevaliers de la table ronde',2,NULL,'f','2008-03-12 14:05:51');
INSERT INTO CHANSON VALUES(4071,'Civil War',2,NULL,'f','2008-03-12 13:30:37');
INSERT INTO CHANSON VALUES(4072,'14 Years',2,NULL,'f','2008-03-12 11:54:27');
INSERT INTO CHANSON VALUES(4073,'Yesterdays',2,NULL,'f','2008-03-12 15:54:42');
INSERT INTO CHANSON VALUES(4075,'Get In The Ring',2,NULL,'f','2008-03-12 11:05:47');
INSERT INTO CHANSON VALUES(4076,'Shotgun Blues',2,NULL,'f','2008-03-12 18:39:31');
INSERT INTO CHANSON VALUES(4077,'Breakdown',2,NULL,NULL,'2008-03-12 10:36:19');
INSERT INTO CHANSON VALUES(4078,'Pretty Tied Up',2,NULL,'f','2008-04-14 08:43:24');
INSERT INTO CHANSON VALUES(4079,'Locomotive',2,NULL,'f','2008-03-12 14:54:18');
INSERT INTO CHANSON VALUES(4080,'So Fine',2,NULL,'f','2008-03-12 15:18:06');
INSERT INTO CHANSON VALUES(4081,'Estranged',2,NULL,'f','2008-03-12 14:52:12');
INSERT INTO CHANSON VALUES(4082,'You Could Be Mine',2,NULL,'f','2008-03-12 13:19:42');
INSERT INTO CHANSON VALUES(4083,'Don''t Cry (Alt. Lyrics)',2,NULL,'f','2008-03-12 08:35:37');
INSERT INTO CHANSON VALUES(4084,'My World',2,NULL,'f','2008-03-12 14:14:31');
INSERT INTO CHANSON VALUES(4085,'Trop precieux',2,NULL,'f','2008-03-12 10:02:23');
INSERT INTO CHANSON VALUES(4086,'C''est l''amour',2,NULL,NULL,'2008-03-12 08:21:28');
INSERT INTO CHANSON VALUES(4087,'Ne dis pas aux copains',2,NULL,'f','2008-03-23 17:15:08');
INSERT INTO CHANSON VALUES(4088,'Le soleil',2,NULL,'f','2008-03-12 11:29:45');
INSERT INTO CHANSON VALUES(4089,'Paolo',2,NULL,'f','2008-03-12 15:04:39');
INSERT INTO CHANSON VALUES(4090,'Il viendra',2,NULL,'f','2008-03-12 19:40:57');
INSERT INTO CHANSON VALUES(4091,'Sur la langue',2,NULL,'f','2008-03-12 08:14:50');
INSERT INTO CHANSON VALUES(4092,'Johnny Mac Donald',2,NULL,NULL,'2008-03-12 11:39:10');
INSERT INTO CHANSON VALUES(4093,'Pas d''argent dans mon dos',2,NULL,NULL,'2008-03-12 19:42:46');
INSERT INTO CHANSON VALUES(4094,'Les poissons',2,NULL,'f','2008-03-12 14:12:00');
INSERT INTO CHANSON VALUES(4095,'Mes amis / Oui, je vous aime',2,NULL,'f','2008-03-12 09:26:03');
INSERT INTO CHANSON VALUES(4096,'1, 2, 3, 4, 5...',2,NULL,'f','2008-03-12 13:26:25');
INSERT INTO CHANSON VALUES(4097,'Gisele',2,NULL,'f','2008-03-12 19:13:40');
INSERT INTO CHANSON VALUES(4098,'Marilyn',2,NULL,'f','2008-03-12 09:32:10');
INSERT INTO CHANSON VALUES(4099,'C''est juste une petite voix',2,NULL,'f','2008-03-12 18:10:14');
INSERT INTO CHANSON VALUES(4100,'The Three Sunrises',2,NULL,'f','2008-03-12 14:06:55');
INSERT INTO CHANSON VALUES(4101,'Spanish Eyes',2,NULL,'f','2008-03-12 13:10:09');
INSERT INTO CHANSON VALUES(4102,'Sweetest Thing',2,NULL,NULL,'2008-03-12 11:25:49');
INSERT INTO CHANSON VALUES(4103,'Love Comes Tumbling',2,NULL,'f','2008-03-12 13:23:31');
INSERT INTO CHANSON VALUES(4104,'Bass Trap',2,NULL,'f','2008-03-12 10:57:44');
INSERT INTO CHANSON VALUES(4105,'Dancing Barefoot',2,NULL,'f','2008-03-12 11:03:10');
INSERT INTO CHANSON VALUES(4106,'Everlasting Love',2,NULL,'f','2008-03-12 11:33:36');
INSERT INTO CHANSON VALUES(4107,'Unchained Melody',2,NULL,'f','2008-03-12 16:31:49');
INSERT INTO CHANSON VALUES(4108,'Walk To The Water',2,NULL,'f','2008-03-12 13:38:22');
INSERT INTO CHANSON VALUES(4109,'Luminous Times (Hold On To Love)',2,NULL,'f','2008-03-12 15:29:32');
INSERT INTO CHANSON VALUES(4110,'Hallelujah Here She Comes',2,NULL,'f','2008-03-12 18:00:39');
INSERT INTO CHANSON VALUES(4111,'Silver And Gold',2,NULL,'f','2008-03-12 17:28:49');
INSERT INTO CHANSON VALUES(4112,'Endless Deep',2,NULL,'f','2008-03-12 18:46:14');
INSERT INTO CHANSON VALUES(4113,'A Room At The Heartbreak Hotel',2,NULL,'f','2008-03-12 16:15:37');
INSERT INTO CHANSON VALUES(4114,'Trash, Trampoline And The Party Girl',2,NULL,'f','2008-03-12 11:30:35');
INSERT INTO CHANSON VALUES(4115,'Houla la !',2,NULL,'f','2008-03-12 08:46:39');
INSERT INTO CHANSON VALUES(4116,'Pololop (Les iroquois aux cheveux verts)',2,NULL,'f','2008-03-12 10:06:13');
INSERT INTO CHANSON VALUES(4117,'Lapin Billy s''en va t''en guerre',2,NULL,'f','2008-03-12 17:50:44');
INSERT INTO CHANSON VALUES(4118,'Assez !',2,NULL,'f','2008-03-12 15:16:23');
INSERT INTO CHANSON VALUES(4119,'HLM',2,NULL,'f','2008-03-12 08:51:52');
INSERT INTO CHANSON VALUES(4120,'Sur la vie d''mon père',2,NULL,'f','2008-03-12 14:42:52');
INSERT INTO CHANSON VALUES(4121,'Marche',2,NULL,'f','2008-03-12 10:27:20');
INSERT INTO CHANSON VALUES(4122,'Sur les sentiers de la gloire',2,NULL,'f','2008-03-12 08:22:07');
INSERT INTO CHANSON VALUES(4123,'On m''appelle',2,NULL,'f','2008-03-12 11:06:22');
INSERT INTO CHANSON VALUES(4124,'Bilbao (Panoramix)',2,NULL,NULL,'2008-03-12 18:22:53');
INSERT INTO CHANSON VALUES(4125,'Le crapaud et la princesse',2,NULL,NULL,'2008-03-12 13:22:39');
INSERT INTO CHANSON VALUES(4126,'Libanais raides',2,NULL,'f','2008-03-12 09:33:45');
INSERT INTO CHANSON VALUES(4127,'Bière & Punk',2,NULL,NULL,'2008-03-12 12:21:36');
INSERT INTO CHANSON VALUES(4128,'Des barbelés sur la prairie',2,NULL,'f','2008-03-12 09:59:53');
INSERT INTO CHANSON VALUES(4129,'Hurle (F comme...)',2,NULL,'f','2008-03-12 14:59:45');
INSERT INTO CHANSON VALUES(4130,'Bilbao (Live)',2,NULL,NULL,'2008-03-12 12:32:27');
INSERT INTO CHANSON VALUES(4131,'Nada 84',2,NULL,'f','2008-03-12 11:43:54');
INSERT INTO CHANSON VALUES(4132,'Petit Agité',2,NULL,'f','2008-03-12 15:44:17');
INSERT INTO CHANSON VALUES(4134,'Conte cruel de la Jeunesse',2,NULL,'f','2008-03-12 09:53:45');
INSERT INTO CHANSON VALUES(4136,'Les Rebelles',2,NULL,'f','2008-03-12 15:32:42');
INSERT INTO CHANSON VALUES(4138,'Commando Pernod',2,NULL,'f','2008-03-12 08:01:03');
INSERT INTO CHANSON VALUES(4139,'Les Eléphants',2,NULL,'f','2008-03-12 18:32:03');
INSERT INTO CHANSON VALUES(4141,'Hélène et le Sang',2,NULL,'f','2008-03-12 09:10:19');
INSERT INTO CHANSON VALUES(4142,'Il tua son Petit Frère',2,NULL,'f','2008-03-12 08:45:04');
INSERT INTO CHANSON VALUES(4143,'La Mère Noël',2,NULL,'f','2008-03-12 11:29:04');
INSERT INTO CHANSON VALUES(4144,'J''aime pas la Soupe',2,NULL,'f','2008-03-12 16:35:58');
INSERT INTO CHANSON VALUES(4146,'Salut à Toi',2,NULL,'f','2008-03-12 15:13:53');
INSERT INTO CHANSON VALUES(4147,'Changes',2,NULL,'f','2008-04-13 17:02:29');
INSERT INTO CHANSON VALUES(4148,'Oh! You Pretty Things',2,NULL,'f','2008-06-07 12:37:38.242315');
INSERT INTO CHANSON VALUES(4149,'Eight Line Poem',2,NULL,'f','2008-03-20 12:39:49');
INSERT INTO CHANSON VALUES(4150,'Life On Mars?',2,NULL,'f','2008-04-11 10:56:10');
INSERT INTO CHANSON VALUES(4151,'Kooks',2,NULL,'f','2008-04-07 13:34:21');
INSERT INTO CHANSON VALUES(4152,'Quicksand',2,NULL,'f','2008-03-23 14:13:16');
INSERT INTO CHANSON VALUES(4153,'Fill Your Heart',2,NULL,NULL,'2008-04-18 19:19:44');
INSERT INTO CHANSON VALUES(4154,'Andy Warhol',2,NULL,'f','2008-06-07 15:30:11.176393');
INSERT INTO CHANSON VALUES(4155,'Song For Bob Dylan',2,NULL,'f','2008-06-07 15:30:32.861925');
INSERT INTO CHANSON VALUES(4156,'Queen Bitch',2,NULL,'f','2008-04-15 09:10:19');
INSERT INTO CHANSON VALUES(4157,'The Bewlay Brothers',2,NULL,NULL,'2008-04-13 12:13:09');
INSERT INTO CHANSON VALUES(4158,'Bombers (Previously unreleased)',2,NULL,NULL,'2008-06-07 15:33:47.479029');
INSERT INTO CHANSON VALUES(4159,'The Supermen (Altenative Version)',2,NULL,'f','2008-03-17 14:23:16');
INSERT INTO CHANSON VALUES(4160,'Quicksand (Demo Version)',2,NULL,'f','2008-03-23 14:51:51');
INSERT INTO CHANSON VALUES(4161,'The Bewlay Brothers (Altenative Mix)',2,NULL,'f','2008-04-13 17:41:09');
INSERT INTO CHANSON VALUES(4162,'Airportman',2,NULL,'f','2008-03-12 18:27:04');
INSERT INTO CHANSON VALUES(4163,'Lotus',2,NULL,'f','2008-03-12 17:46:42');
INSERT INTO CHANSON VALUES(4164,'Suspicion',2,NULL,'f','2008-03-12 15:09:21');
INSERT INTO CHANSON VALUES(4165,'Hope',2,NULL,'f','2008-03-12 13:35:55');
INSERT INTO CHANSON VALUES(4166,'At My Most Beautiful',2,NULL,'f','2008-03-12 17:05:09');
INSERT INTO CHANSON VALUES(4167,'The Apologist',2,NULL,'f','2008-03-12 08:12:30');
INSERT INTO CHANSON VALUES(4168,'Sad Professor',2,NULL,'f','2008-03-12 14:37:52');
INSERT INTO CHANSON VALUES(4169,'You''re In The Air',2,NULL,'f','2008-03-12 16:08:33');
INSERT INTO CHANSON VALUES(4170,'Walk Unafraid',2,NULL,'f','2008-03-12 12:42:56');
INSERT INTO CHANSON VALUES(4171,'Why Not Smile',2,NULL,'f','2008-03-12 16:15:48');
INSERT INTO CHANSON VALUES(4172,'Daysleeper',2,NULL,'f','2008-03-12 14:10:16');
INSERT INTO CHANSON VALUES(4173,'Diminished',2,NULL,NULL,'2008-03-12 15:58:02');
INSERT INTO CHANSON VALUES(4174,'Parakeet',2,NULL,'f','2008-03-12 11:33:11');
INSERT INTO CHANSON VALUES(4175,'Falls To Climb',2,NULL,'f','2008-03-12 16:59:47');
INSERT INTO CHANSON VALUES(4176,'Cadillac Ranch',2,NULL,'f','2008-03-12 15:46:52');
INSERT INTO CHANSON VALUES(4177,'You Can Look (But You Better Not Touch)',2,NULL,NULL,'2008-03-12 17:49:05');
INSERT INTO CHANSON VALUES(4178,'Independence Day',2,NULL,'f','2008-03-12 11:20:42');
INSERT INTO CHANSON VALUES(4179,'Badlands',2,NULL,'f','2008-03-27 09:03:50');
INSERT INTO CHANSON VALUES(4181,'Candy''s Room',2,NULL,'f','2008-03-12 15:10:49');
INSERT INTO CHANSON VALUES(4182,'Darkness On The Edge Of Town',2,NULL,'f','2008-03-12 13:43:59');
INSERT INTO CHANSON VALUES(4183,'Racing In The Street',2,NULL,'f','2008-03-12 16:20:57');
INSERT INTO CHANSON VALUES(4184,'This Is Your Land',2,NULL,'f','2008-03-12 17:40:31');
INSERT INTO CHANSON VALUES(4185,'Nebraska',2,NULL,'f','2008-03-12 19:22:30');
INSERT INTO CHANSON VALUES(4186,'Johnny 99',2,NULL,'f','2008-03-12 16:59:17');
INSERT INTO CHANSON VALUES(4187,'Reason To Believe',2,NULL,'f','2008-03-12 15:46:07');
INSERT INTO CHANSON VALUES(4188,'Born In The U.S.A.',2,NULL,'f','2008-03-12 16:02:27');
INSERT INTO CHANSON VALUES(4189,'Seeds',2,NULL,'f','2008-03-12 13:12:31');
INSERT INTO CHANSON VALUES(4190,'Love Is Strong',2,NULL,'f','2008-05-23 09:29:37');
INSERT INTO CHANSON VALUES(4192,'Sparks Will Fly',2,NULL,'f','2008-06-02 10:24:14.262385');
INSERT INTO CHANSON VALUES(4193,'The Worst',2,NULL,NULL,'2008-06-02 10:24:30.713602');
INSERT INTO CHANSON VALUES(4194,'New Faces',2,NULL,NULL,'2008-06-02 10:24:47.078082');
INSERT INTO CHANSON VALUES(4195,'Moon Is Up',2,NULL,'f','2008-06-02 10:25:07.152158');
INSERT INTO CHANSON VALUES(4196,'Out Of Tears',2,NULL,'f','2008-04-18 18:56:16');
INSERT INTO CHANSON VALUES(4197,'I Go Wild',2,NULL,'f','2008-06-02 10:25:43.026789');
INSERT INTO CHANSON VALUES(4198,'Brand New Car',2,NULL,'f','2008-06-02 10:26:01.658137');
INSERT INTO CHANSON VALUES(4199,'Sweethearts Together',2,NULL,'f','2008-06-02 10:26:21.286022');
INSERT INTO CHANSON VALUES(4200,'Suck On The Jugular',2,NULL,'f','2008-06-02 10:26:38.462825');
INSERT INTO CHANSON VALUES(4201,'Blinded By Rainbows',2,NULL,'f','2008-06-02 10:26:58.459349');
INSERT INTO CHANSON VALUES(4202,'Baby Break It Down',2,NULL,'f','2008-05-26 10:46:41');
INSERT INTO CHANSON VALUES(4203,'Thru And Thru',2,NULL,NULL,'2008-06-01 17:54:03.664066');
INSERT INTO CHANSON VALUES(4204,'Mean Disposition',2,NULL,'f','2008-06-01 17:54:23.109303');
INSERT INTO CHANSON VALUES(4206,'When the whip comes down',2,NULL,'f','2008-03-18 12:06:10');
INSERT INTO CHANSON VALUES(4208,'Shattered',2,NULL,'f','2008-05-22 13:23:09');
INSERT INTO CHANSON VALUES(4209,'Neighbours',2,NULL,'f','2008-06-02 09:19:04.674257');
INSERT INTO CHANSON VALUES(4210,'Black limousine',2,NULL,'f','2008-04-24 19:50:52');
INSERT INTO CHANSON VALUES(4211,'Just my imagination (Running away with me)',2,NULL,'f','2008-06-01 20:21:36.494012');
INSERT INTO CHANSON VALUES(4212,'Twenty flight rock',2,NULL,'f','2008-04-07 08:05:06');
INSERT INTO CHANSON VALUES(4213,'Going to a go go',2,NULL,NULL,'2008-04-07 10:29:55');
INSERT INTO CHANSON VALUES(4214,'Let me go',2,NULL,'f','2008-05-22 10:58:24');
INSERT INTO CHANSON VALUES(4216,'Beast of burden',2,NULL,'f','2008-05-22 12:56:45');
INSERT INTO CHANSON VALUES(4219,'Jack in the box',2,NULL,'f','2008-03-12 19:29:32');
INSERT INTO CHANSON VALUES(4220,'Slim Back Boogie',2,NULL,NULL,'2008-03-12 10:32:52');
INSERT INTO CHANSON VALUES(4221,'Fiche anthropometrique',2,NULL,'f','2008-03-12 13:35:02');
INSERT INTO CHANSON VALUES(4222,'Cult Movie',2,NULL,NULL,'2008-03-12 10:47:52');
INSERT INTO CHANSON VALUES(4223,'Captain dodecaphonique Dada',2,NULL,'f','2008-03-12 08:53:21');
INSERT INTO CHANSON VALUES(4224,'Excès de zéle',2,NULL,'f','2008-03-12 16:13:28');
INSERT INTO CHANSON VALUES(4225,'Coup de lune',2,NULL,'f','2008-03-12 18:28:44');
INSERT INTO CHANSON VALUES(4226,'Brodway',2,NULL,'f','2008-03-12 14:00:41');
INSERT INTO CHANSON VALUES(4227,'Mamy',2,NULL,'f','2008-03-12 14:48:34');
INSERT INTO CHANSON VALUES(4228,'Adios',2,NULL,'f','2008-03-12 12:38:32');
INSERT INTO CHANSON VALUES(4229,'La croisade des Enfants',2,NULL,'f','2008-03-23 10:11:08');
INSERT INTO CHANSON VALUES(4230,'Je ne sais',2,NULL,'f','2008-03-12 18:34:02');
INSERT INTO CHANSON VALUES(4231,'Ai',2,NULL,'f','2008-03-12 13:47:34');
INSERT INTO CHANSON VALUES(4232,'Laura Lorelei',2,NULL,'f','2008-03-12 11:12:09');
INSERT INTO CHANSON VALUES(4233,'Serre moi',2,NULL,'f','2008-03-12 12:25:57');
INSERT INTO CHANSON VALUES(4234,'Victoria',2,NULL,'f','2008-03-12 10:28:50');
INSERT INTO CHANSON VALUES(4235,'Beetlebum',2,NULL,'f','2008-03-12 15:08:03');
INSERT INTO CHANSON VALUES(4236,'Song 2',2,NULL,'f','2008-03-12 08:59:32');
INSERT INTO CHANSON VALUES(4237,'Country Sad Ballad Man',2,NULL,'f','2008-03-12 17:33:32');
INSERT INTO CHANSON VALUES(4238,'M.O.R.',2,NULL,'f','2008-03-12 14:04:20');
INSERT INTO CHANSON VALUES(4239,'On Your Own',2,NULL,'f','2008-03-12 09:29:58');
INSERT INTO CHANSON VALUES(4240,'Theme From Retro',2,NULL,'f','2008-03-12 15:24:32');
INSERT INTO CHANSON VALUES(4241,'You''re So Great',2,NULL,'f','2008-03-12 15:51:20');
INSERT INTO CHANSON VALUES(4242,'Death Of A Party',2,NULL,'f','2008-03-12 10:10:32');
INSERT INTO CHANSON VALUES(4243,'Chinese Bombs',2,NULL,'f','2008-03-12 12:32:58');
INSERT INTO CHANSON VALUES(4244,'I''m Just A Killer For Your Love',2,NULL,'f','2008-03-12 12:46:26');
INSERT INTO CHANSON VALUES(4245,'Look Inside America',2,NULL,'f','2008-03-12 11:27:35');
INSERT INTO CHANSON VALUES(4246,'Strange News From Another Star',2,NULL,'f','2008-03-12 17:16:08');
INSERT INTO CHANSON VALUES(4247,'Movin'' On',2,NULL,NULL,'2008-03-12 11:47:13');
INSERT INTO CHANSON VALUES(4248,'Essex Dogs',2,NULL,'f','2008-03-12 16:52:42');
INSERT INTO CHANSON VALUES(4249,'Dreams of death',2,NULL,NULL,'2008-03-12 15:29:07');
INSERT INTO CHANSON VALUES(4250,'Lie 4 def',2,NULL,NULL,'2008-03-12 10:09:58');
INSERT INTO CHANSON VALUES(4251,'Manifest destiny',2,NULL,NULL,'2008-03-12 14:23:09');
INSERT INTO CHANSON VALUES(4252,'Commandments',2,NULL,NULL,'2008-03-12 08:47:42');
INSERT INTO CHANSON VALUES(4253,'Heart attack',2,NULL,NULL,'2008-03-12 08:09:28');
INSERT INTO CHANSON VALUES(4254,'Paradox',2,NULL,NULL,'2008-03-12 13:20:51');
INSERT INTO CHANSON VALUES(4255,'Kill yourself',2,NULL,NULL,'2008-03-12 08:36:18');
INSERT INTO CHANSON VALUES(4256,'Corrupt minds',2,NULL,NULL,'2008-03-12 16:23:35');
INSERT INTO CHANSON VALUES(4257,'Fought for death',2,NULL,NULL,'2008-03-12 17:43:22');
INSERT INTO CHANSON VALUES(4258,'Evil has no boudaries (live)',2,NULL,NULL,'2008-03-12 08:23:15');
INSERT INTO CHANSON VALUES(4259,'Death squad',2,NULL,NULL,'2008-03-12 16:02:44');
INSERT INTO CHANSON VALUES(4260,'Baptised by fire',2,NULL,NULL,'2008-03-12 18:14:54');
INSERT INTO CHANSON VALUES(4261,'Satan says',2,NULL,NULL,'2008-03-12 18:45:17');
INSERT INTO CHANSON VALUES(4262,'Chemical dependency',2,NULL,NULL,'2008-03-12 19:50:05');
INSERT INTO CHANSON VALUES(4263,'Opinionate!',2,NULL,NULL,'2008-03-12 16:53:14');
INSERT INTO CHANSON VALUES(4264,'Dans mon lit',2,NULL,'f','2008-03-12 10:22:35');
INSERT INTO CHANSON VALUES(4265,'Je rêve',2,NULL,'f','2008-03-12 08:27:11');
INSERT INTO CHANSON VALUES(4266,'La java des chaussettes à clous',2,NULL,'f','2008-03-12 12:07:35');
INSERT INTO CHANSON VALUES(4267,'L''année à l''envers',2,NULL,'f','2008-03-12 19:56:18');
INSERT INTO CHANSON VALUES(4268,'Huit jours en Italie',2,NULL,NULL,'2008-03-12 11:58:42');
INSERT INTO CHANSON VALUES(4269,'L''âme slave',2,NULL,NULL,'2008-03-12 14:43:44');
INSERT INTO CHANSON VALUES(4270,'A Django',2,NULL,'f','2008-03-12 11:35:58');
INSERT INTO CHANSON VALUES(4271,'Isabelle',2,NULL,'f','2008-03-12 10:25:44');
INSERT INTO CHANSON VALUES(4272,'Quand j''improvise sur mon piano',2,NULL,NULL,'2008-03-12 14:25:34');
INSERT INTO CHANSON VALUES(4273,'Fleur de pavor',2,NULL,'f','2008-03-12 15:06:27');
INSERT INTO CHANSON VALUES(4274,'On est là pour ça',2,NULL,'f','2008-03-12 18:17:50');
INSERT INTO CHANSON VALUES(4275,'Priez pour Saint-Germain des Prés',2,NULL,'f','2008-03-12 13:19:17');
INSERT INTO CHANSON VALUES(4276,'La grippe',2,NULL,'f','2008-03-12 15:41:25');
INSERT INTO CHANSON VALUES(4277,'Communication Breakdown',2,NULL,'f','2008-03-12 10:38:21');
INSERT INTO CHANSON VALUES(4278,'Babe I''m Gonna Leave You',2,NULL,'f','2008-03-12 14:58:19');
INSERT INTO CHANSON VALUES(4279,'Good Times Bad Times',2,NULL,'f','2008-03-12 10:33:02');
INSERT INTO CHANSON VALUES(4280,'Dazed And Confused',2,NULL,'f','2008-03-28 19:52:37');
INSERT INTO CHANSON VALUES(4292,'Heaven''s in here',2,NULL,'f','2008-06-07 18:51:45.083453');
INSERT INTO CHANSON VALUES(4293,'Tin machine',2,NULL,'f','2008-06-07 18:52:06.782402');
INSERT INTO CHANSON VALUES(4294,'Prisoner of love',2,NULL,'f','2008-06-07 18:52:26.838687');
INSERT INTO CHANSON VALUES(4295,'Crack city',2,NULL,'f','2008-03-28 16:51:41');
INSERT INTO CHANSON VALUES(4296,'I can''t read',2,NULL,'f','2008-06-07 18:52:57.382254');
INSERT INTO CHANSON VALUES(4297,'Under the god',2,NULL,NULL,'2008-06-07 18:36:09.870134');
INSERT INTO CHANSON VALUES(4298,'Amazing',2,NULL,'f','2008-06-07 18:37:06.266234');
INSERT INTO CHANSON VALUES(4299,'Working class hero',2,NULL,'f','2008-06-07 18:37:30.121304');
INSERT INTO CHANSON VALUES(4300,'Bus stop',2,NULL,'f','2008-06-07 18:37:43.1949');
INSERT INTO CHANSON VALUES(4301,'Pretty thing',2,NULL,'f','2008-06-07 15:59:37.206627');
INSERT INTO CHANSON VALUES(4302,'Video crime',2,NULL,'f','2008-06-07 18:37:58.615485');
INSERT INTO CHANSON VALUES(4303,'Run',2,NULL,'f','2008-06-07 18:39:03.497576');
INSERT INTO CHANSON VALUES(4304,'Sacrifice yourself',2,NULL,'f','2008-06-07 18:38:35.83205');
INSERT INTO CHANSON VALUES(4305,'Baby can dance',2,NULL,'f','2008-06-07 18:39:27.384231');
INSERT INTO CHANSON VALUES(4306,'It''s No Game (Part 1)',2,NULL,'f','2008-06-07 18:25:39.092291');
INSERT INTO CHANSON VALUES(4307,'Up The Hill Backwards',2,NULL,'f','2008-06-07 18:25:59.75252');
INSERT INTO CHANSON VALUES(4308,'Scary Monsters (And Super Creeps)',2,NULL,'f','2008-03-24 14:28:04');
INSERT INTO CHANSON VALUES(4309,'Ashes To Ashes',2,NULL,'f','2008-03-27 09:20:26');
INSERT INTO CHANSON VALUES(4310,'Fashion',2,NULL,NULL,'2008-04-07 08:33:22');
INSERT INTO CHANSON VALUES(4311,'Teenage Wildlife',2,NULL,'f','2008-06-07 18:07:07.286515');
INSERT INTO CHANSON VALUES(4312,'Scream Like A Baby',2,NULL,'f','2008-06-07 18:07:20.957921');
INSERT INTO CHANSON VALUES(4313,'Kingdom Come',2,NULL,'f','2008-04-12 15:28:35');
INSERT INTO CHANSON VALUES(4314,'Because You''re Young',2,NULL,'f','2008-04-13 08:53:57');
INSERT INTO CHANSON VALUES(4315,'It''s No Game (Part 2)',2,NULL,'f','2008-06-07 18:08:06.057608');
INSERT INTO CHANSON VALUES(4318,'Crystal Japan',2,NULL,'f','2008-06-07 19:19:15.634259');
INSERT INTO CHANSON VALUES(4321,'Like a Rolling Stone',2,NULL,'f','2008-06-02 09:44:52.402552');
INSERT INTO CHANSON VALUES(4323,'Shine a Light',2,NULL,'f','2008-05-22 10:04:44');
INSERT INTO CHANSON VALUES(4324,'The Spider and the Fly',2,NULL,'f','2008-04-11 17:26:12');
INSERT INTO CHANSON VALUES(4332,'Sweet Virginia',2,NULL,'f','2008-06-02 10:18:17.14528');
INSERT INTO CHANSON VALUES(4333,'Little Baby',2,NULL,'f','2008-06-02 09:45:09.511725');
INSERT INTO CHANSON VALUES(4336,'Take your love away',2,NULL,'f','2008-03-12 12:45:19');
INSERT INTO CHANSON VALUES(4337,'Hard core',2,NULL,'f','2008-03-12 14:16:38');
INSERT INTO CHANSON VALUES(4338,'Drive all night',2,NULL,'f','2008-03-12 15:30:26');
INSERT INTO CHANSON VALUES(4339,'Somebodies anniversary',2,NULL,'f','2008-03-12 15:18:46');
INSERT INTO CHANSON VALUES(4341,'Diamonds by the yard',2,NULL,'f','2008-03-12 17:30:36');
INSERT INTO CHANSON VALUES(4343,'Hollywood',2,NULL,'f','2008-03-12 19:55:59');
INSERT INTO CHANSON VALUES(4344,'Rock ballad',2,NULL,'f','2008-03-12 13:42:31');
INSERT INTO CHANSON VALUES(4345,'Party girls and broken poets',2,NULL,'f','2008-03-12 09:45:19');
INSERT INTO CHANSON VALUES(4346,'Vent d''est',2,NULL,'f','2008-03-12 16:07:04');
INSERT INTO CHANSON VALUES(4347,'Jeune Irlande',2,NULL,'f','2008-03-12 08:37:21');
INSERT INTO CHANSON VALUES(4348,'A poil les militants',2,NULL,'f','2008-03-18 15:16:51');
INSERT INTO CHANSON VALUES(4349,'Harkis',2,NULL,'f','2008-03-12 09:53:10');
INSERT INTO CHANSON VALUES(4350,'Okinawa',2,NULL,'f','2008-03-12 18:55:21');
INSERT INTO CHANSON VALUES(4351,'Génération destruction',2,NULL,'f','2008-03-12 09:43:52');
INSERT INTO CHANSON VALUES(4352,'U.H.T.',2,NULL,'f','2008-03-12 16:23:50');
INSERT INTO CHANSON VALUES(4353,'Graine de violence',2,NULL,'f','2008-03-12 18:21:46');
INSERT INTO CHANSON VALUES(4354,'Amazone Hoa-Hao',2,NULL,'f','2008-03-12 18:51:29');
INSERT INTO CHANSON VALUES(4355,'Quartiers du monde',2,NULL,'f','2008-03-12 12:59:14');
INSERT INTO CHANSON VALUES(4356,'Piranha',2,NULL,'f','2008-03-12 16:40:21');
INSERT INTO CHANSON VALUES(4357,'Dragon libre',2,NULL,'f','2008-03-12 17:40:58');
INSERT INTO CHANSON VALUES(4358,'Détresse',2,NULL,'f','2008-03-12 09:19:15');
INSERT INTO CHANSON VALUES(4359,'Soleil et acier',2,NULL,'f','2008-03-12 08:25:08');
INSERT INTO CHANSON VALUES(4360,'Nations en flammes',2,NULL,NULL,'2008-03-12 10:18:03');
INSERT INTO CHANSON VALUES(4361,'(Intro) Continental Drift',2,NULL,'f','2008-06-02 09:30:09.03673');
INSERT INTO CHANSON VALUES(4366,'Ruby Tuesday',2,NULL,'f','2008-05-23 10:00:08');
INSERT INTO CHANSON VALUES(4377,'Sex Drive',2,NULL,'f','2008-06-02 10:45:05.992794');
INSERT INTO CHANSON VALUES(4378,'Sleep On The Left Side',2,NULL,'f','2008-03-12 11:59:18');
INSERT INTO CHANSON VALUES(4379,'Brimful of Asha',2,NULL,NULL,'2008-03-23 13:15:18');
INSERT INTO CHANSON VALUES(4380,'Butter The Soul',2,NULL,NULL,'2008-03-12 08:16:10');
INSERT INTO CHANSON VALUES(4381,'Chocolat',2,NULL,'f','2008-03-12 13:48:24');
INSERT INTO CHANSON VALUES(4382,'We''re in Yr Corner',2,NULL,NULL,'2008-03-12 17:33:21');
INSERT INTO CHANSON VALUES(4383,'Funky Days Are Back Again',2,NULL,NULL,'2008-03-12 18:40:05');
INSERT INTO CHANSON VALUES(4384,'What''s Happening?',2,NULL,'f','2008-03-12 14:46:57');
INSERT INTO CHANSON VALUES(4385,'When The Lights Appears Boy',2,NULL,'f','2008-03-12 15:06:49');
INSERT INTO CHANSON VALUES(4386,'Coming Up',2,NULL,'f','2008-03-12 08:36:52');
INSERT INTO CHANSON VALUES(4387,'Good Shit',2,NULL,'f','2008-03-12 18:08:27');
INSERT INTO CHANSON VALUES(4388,'Good To Be On The Road Back Home Again',2,NULL,'f','2008-03-12 08:28:27');
INSERT INTO CHANSON VALUES(4389,'It''s Indian Tobacco My Friend',2,NULL,'f','2008-03-12 12:57:42');
INSERT INTO CHANSON VALUES(4390,'Candyman',2,NULL,'f','2008-03-12 15:58:59');
INSERT INTO CHANSON VALUES(4391,'State Troopers',2,NULL,'f','2008-03-12 17:23:47');
INSERT INTO CHANSON VALUES(4392,'Norwegian Wood (This Bird Has Flown)',2,NULL,'f','2008-03-12 10:12:21');
INSERT INTO CHANSON VALUES(4393,'Dream On',2,NULL,'f','2008-03-12 15:03:01');
INSERT INTO CHANSON VALUES(4395,'Same Old Song And Dance',2,NULL,'f','2008-03-12 16:37:47');
INSERT INTO CHANSON VALUES(4396,'Seasons Of Wither',2,NULL,'f','2008-03-12 15:14:54');
INSERT INTO CHANSON VALUES(4397,'Sweet Emotion',2,NULL,'f','2008-03-12 13:19:30');
INSERT INTO CHANSON VALUES(4398,'Walk This Way',2,NULL,'f','2008-03-12 12:10:39');
INSERT INTO CHANSON VALUES(4399,'Big Ten-Inch Record',2,NULL,'f','2008-03-12 17:12:07');
INSERT INTO CHANSON VALUES(4400,'Last Child',2,NULL,'f','2008-03-12 11:32:05');
INSERT INTO CHANSON VALUES(4401,'Back In The Saddle',2,NULL,NULL,'2008-03-12 19:11:03');
INSERT INTO CHANSON VALUES(4402,'Draw The Line',2,NULL,'f','2008-03-12 19:01:27');
INSERT INTO CHANSON VALUES(4403,'Kings And Queens',2,NULL,'f','2008-03-12 17:16:39');
INSERT INTO CHANSON VALUES(4404,'Come Together',2,NULL,'f','2008-03-12 09:52:43');
INSERT INTO CHANSON VALUES(4405,'Remember (Walking In The Sand)',2,NULL,'f','2008-03-12 09:33:20');
INSERT INTO CHANSON VALUES(4406,'Lightning Strikes',2,NULL,'f','2008-03-12 19:11:35');
INSERT INTO CHANSON VALUES(4407,'Chip Away The Stone',2,NULL,'f','2008-03-12 18:39:54');
INSERT INTO CHANSON VALUES(4408,'Sweet Emotion (1991 Thoener Remix)',2,NULL,'f','2008-03-12 12:00:05');
INSERT INTO CHANSON VALUES(4409,'One Way Street (Live)',2,NULL,'f','2008-03-12 08:49:17');
INSERT INTO CHANSON VALUES(4413,'This Is Not America',2,NULL,'f','2008-06-07 18:57:10.430811');
INSERT INTO CHANSON VALUES(4414,'Absolute Beginners',2,NULL,'f','2008-04-07 13:43:20');
INSERT INTO CHANSON VALUES(4415,'Always Crashing In The Same Car',2,NULL,'f','2008-06-07 12:36:32.619138');
INSERT INTO CHANSON VALUES(4424,'Let''s Dance',2,NULL,'f','2008-04-14 09:16:55');
INSERT INTO CHANSON VALUES(4425,'Speed Of Life',2,NULL,NULL,'2008-06-07 19:56:41.681519');
INSERT INTO CHANSON VALUES(4426,'Breaking Glass',2,NULL,NULL,'2008-06-07 19:00:15.857284');
INSERT INTO CHANSON VALUES(4427,'What In The World',2,NULL,'f','2008-06-07 12:36:02.631488');
INSERT INTO CHANSON VALUES(4428,'Sound And Vision',2,NULL,'f','2008-03-26 11:47:30');
INSERT INTO CHANSON VALUES(4430,'Be My Wife',2,NULL,'f','2008-04-09 19:52:38');
INSERT INTO CHANSON VALUES(4431,'A New Career In A New Town',2,NULL,'f','2008-06-07 19:17:04.199172');
INSERT INTO CHANSON VALUES(4432,'Warszawa',2,NULL,'f','2008-06-07 12:00:42.292244');
INSERT INTO CHANSON VALUES(4433,'Art Decade',2,NULL,'f','2008-06-07 19:17:32.098384');
INSERT INTO CHANSON VALUES(4434,'Weeping Wall',2,NULL,'f','2008-06-07 19:37:29.985202');
INSERT INTO CHANSON VALUES(4435,'Subterraneans',2,NULL,'f','2008-06-07 12:00:53.773268');
INSERT INTO CHANSON VALUES(4436,'Some Are',2,NULL,NULL,'2008-06-07 12:01:13.931078');
INSERT INTO CHANSON VALUES(4437,'All Saints',2,NULL,'f','2008-06-07 19:16:09.200721');
INSERT INTO CHANSON VALUES(4439,'Sonny',2,NULL,'f','2008-03-12 18:13:23');
INSERT INTO CHANSON VALUES(4444,'I want to talk to you',2,NULL,'f','2008-03-12 19:53:47');
INSERT INTO CHANSON VALUES(4448,'Euro tour',2,NULL,'f','2008-03-12 15:35:51');
INSERT INTO CHANSON VALUES(4449,'You never know what you''re in for',2,NULL,'f','2008-03-12 10:29:05');
INSERT INTO CHANSON VALUES(4452,'Viva Zapata',2,NULL,'f','2008-03-12 10:21:56');
INSERT INTO CHANSON VALUES(4453,'Casa Babylon',2,NULL,'f','2008-03-12 09:36:43');
INSERT INTO CHANSON VALUES(4454,'The Monkey',2,NULL,'f','2008-03-12 19:32:37');
INSERT INTO CHANSON VALUES(4455,'Seqor Matanza',2,NULL,'f','2008-03-12 16:26:13');
INSERT INTO CHANSON VALUES(4456,'Santa Maradona',2,NULL,'f','2008-03-12 14:41:56');
INSERT INTO CHANSON VALUES(4457,'Super Chango',2,NULL,'f','2008-03-12 18:45:18');
INSERT INTO CHANSON VALUES(4458,'Bala perdida',2,NULL,'f','2008-03-12 17:22:53');
INSERT INTO CHANSON VALUES(4459,'Machine gun',2,NULL,'f','2008-03-12 15:35:22');
INSERT INTO CHANSON VALUES(4460,'El alakran',2,NULL,'f','2008-03-12 16:11:16');
INSERT INTO CHANSON VALUES(4461,'Mama perfecta',2,NULL,'f','2008-03-12 16:24:05');
INSERT INTO CHANSON VALUES(4462,'Love and hate',2,NULL,'f','2008-03-12 12:37:26');
INSERT INTO CHANSON VALUES(4463,'Drives me crazy',2,NULL,'f','2008-03-12 11:43:03');
INSERT INTO CHANSON VALUES(4464,'Hamburger fields',2,NULL,'f','2008-03-12 08:39:35');
INSERT INTO CHANSON VALUES(4465,'La vida',2,NULL,NULL,'2008-03-12 15:22:01');
INSERT INTO CHANSON VALUES(4466,'Sueqo de Solentiname',2,NULL,NULL,'2008-03-12 18:56:43');
INSERT INTO CHANSON VALUES(4467,'This is my world',2,NULL,'f','2008-03-12 17:47:28');
INSERT INTO CHANSON VALUES(4468,'Back In The USSR',2,NULL,NULL,'2008-03-12 09:34:51');
INSERT INTO CHANSON VALUES(4469,'Dear Prudence',2,NULL,'f','2008-03-12 08:13:26');
INSERT INTO CHANSON VALUES(4470,'Glass Onion',2,NULL,'f','2008-03-12 12:57:38');
INSERT INTO CHANSON VALUES(4471,'Ob-la-di, Ob-la-da',2,NULL,'f','2008-03-12 15:38:02');
INSERT INTO CHANSON VALUES(4472,'Wild Honey Pie',2,NULL,'f','2008-03-12 17:58:40');
INSERT INTO CHANSON VALUES(4473,'The Continuing Story Of Bungalow Bill',2,NULL,'f','2008-03-12 10:15:24');
INSERT INTO CHANSON VALUES(4475,'Happiness Is A Warm Gun',2,NULL,'f','2008-03-12 18:54:26');
INSERT INTO CHANSON VALUES(4476,'Martha My Dear',2,NULL,'f','2008-03-12 18:46:22');
INSERT INTO CHANSON VALUES(4477,'I''m So Tired',2,NULL,'f','2008-03-12 15:35:10');
INSERT INTO CHANSON VALUES(4478,'Blackbird',2,NULL,NULL,'2008-03-12 08:42:45');
INSERT INTO CHANSON VALUES(4479,'Piggies',2,NULL,'f','2008-03-12 18:43:58');
INSERT INTO CHANSON VALUES(4480,'Rocky Raccoon',2,NULL,'f','2008-03-12 12:06:55');
INSERT INTO CHANSON VALUES(4481,'Don''t Pass Me By',2,NULL,'f','2008-03-12 19:46:33');
INSERT INTO CHANSON VALUES(4482,'Why Don''t We Do It In The Road?',2,NULL,'f','2008-03-12 08:31:32');
INSERT INTO CHANSON VALUES(4483,'I Will',2,NULL,'f','2008-03-12 16:43:47');
INSERT INTO CHANSON VALUES(4484,'Julia',2,NULL,'f','2008-03-12 09:58:03');
INSERT INTO CHANSON VALUES(4485,'Five Years',2,NULL,'f','2008-04-12 17:59:58');
INSERT INTO CHANSON VALUES(4486,'Soul Love',2,NULL,'f','2008-06-07 12:33:21.744295');
INSERT INTO CHANSON VALUES(4488,'Starman',2,NULL,'f','2008-06-07 11:57:33.211219');
INSERT INTO CHANSON VALUES(4489,'It Ain''t Easy',2,NULL,'f','2008-04-07 17:37:38');
INSERT INTO CHANSON VALUES(4490,'Lady Stardust',2,NULL,'f','2008-06-07 11:58:10.877275');
INSERT INTO CHANSON VALUES(4491,'Star',2,NULL,'f','2008-06-07 11:58:43.857584');
INSERT INTO CHANSON VALUES(4492,'Hang onto Yourself',2,NULL,'f','2008-04-12 13:33:33');
INSERT INTO CHANSON VALUES(4493,'Ziggy Stardust',2,NULL,'f','2008-04-07 16:19:50');
INSERT INTO CHANSON VALUES(4494,'Suffragette City',2,NULL,'f','2008-04-18 09:28:52');
INSERT INTO CHANSON VALUES(4495,'Rock ''N'' Roll Suicide',2,NULL,'f','2008-04-14 19:34:49');
INSERT INTO CHANSON VALUES(4496,'John, I''m Only Dancing',2,NULL,'f','2008-06-07 16:07:08.42871');
INSERT INTO CHANSON VALUES(4497,'Velvet Goldmine',2,NULL,'f','2008-03-17 19:13:44');
INSERT INTO CHANSON VALUES(4498,'Sweet Head',2,NULL,'f','2008-03-26 18:34:50');
INSERT INTO CHANSON VALUES(4499,'Ziggy Stardust (demo)',2,NULL,'f','2008-04-07 12:07:07');
INSERT INTO CHANSON VALUES(4500,'Lady Stardust (demo)',2,NULL,'f','2008-06-07 11:58:15.862526');
INSERT INTO CHANSON VALUES(4501,'Pompidou',2,NULL,'f','2008-03-12 12:36:08');
INSERT INTO CHANSON VALUES(4502,'Twist a Chicoutimi',2,NULL,'f','2008-03-17 19:19:51');
INSERT INTO CHANSON VALUES(4503,'Ma mère me rend folle',2,NULL,'f','2008-03-12 16:26:50');
INSERT INTO CHANSON VALUES(4504,'Bang ! Bang ! Bang !',2,NULL,'f','2008-03-27 16:15:18');
INSERT INTO CHANSON VALUES(4505,'For the Rock',2,NULL,'f','2008-03-12 13:15:34');
INSERT INTO CHANSON VALUES(4506,'14 ans',2,NULL,'f','2008-03-12 17:26:53');
INSERT INTO CHANSON VALUES(4507,'Jean Luc le ténia',2,NULL,'f','2008-03-12 17:22:07');
INSERT INTO CHANSON VALUES(4508,'Jalabert',2,NULL,NULL,'2008-03-12 14:16:42');
INSERT INTO CHANSON VALUES(4509,'Peggy - Sue I',2,NULL,'f','2008-03-12 12:06:16');
INSERT INTO CHANSON VALUES(4510,'Peggy - Sue II',2,NULL,'f','2008-03-12 19:30:52');
INSERT INTO CHANSON VALUES(4511,'Joëlle',2,NULL,'f','2008-03-12 09:26:12');
INSERT INTO CHANSON VALUES(4512,'Oï',2,NULL,'f','2008-03-12 19:09:38');
INSERT INTO CHANSON VALUES(4513,'Castorama',2,NULL,NULL,'2008-03-12 17:55:16');
INSERT INTO CHANSON VALUES(4514,'Les vieux Allemands',2,NULL,'f','2008-03-12 13:39:32');
INSERT INTO CHANSON VALUES(4515,'Lucie Anna',2,NULL,'f','2008-03-12 17:06:47');
INSERT INTO CHANSON VALUES(4516,'Je t''aimerai toujours',2,NULL,'f','2008-03-12 12:52:14');
INSERT INTO CHANSON VALUES(4517,'Trop souffert',2,NULL,'f','2008-03-12 10:40:36');
INSERT INTO CHANSON VALUES(4518,'Toto',2,NULL,'f','2008-03-12 12:12:53');
INSERT INTO CHANSON VALUES(4524,'Les Dingues et les paumes',2,NULL,'f','2008-03-12 08:33:02');
INSERT INTO CHANSON VALUES(4525,'Sweet amandinte phalloide queen',2,NULL,'f','2008-03-12 12:02:41');
INSERT INTO CHANSON VALUES(4526,'Zone chaude, mome',2,NULL,'f','2008-03-12 18:49:48');
INSERT INTO CHANSON VALUES(4529,'Les chaos de la philosophie',2,NULL,NULL,'2008-03-12 14:46:34');
INSERT INTO CHANSON VALUES(4531,'Talking',2,NULL,'f','2008-03-12 13:10:45');
INSERT INTO CHANSON VALUES(4532,'Les adieux',2,NULL,'f','2008-03-12 19:23:29');
INSERT INTO CHANSON VALUES(4533,'Lorelei sebasto cha',2,NULL,'f','2008-03-23 09:56:00');
INSERT INTO CHANSON VALUES(4535,'Voilà voilà',2,NULL,NULL,'2008-03-12 19:52:47');
INSERT INTO CHANSON VALUES(4536,'Free wheel',2,NULL,NULL,'2008-03-12 08:12:49');
INSERT INTO CHANSON VALUES(4537,'Papagaïo do futuro',2,NULL,NULL,'2008-03-12 16:04:38');
INSERT INTO CHANSON VALUES(4538,'Il n''y a pas de jolie fille à droite',2,NULL,NULL,'2008-03-12 14:45:49');
INSERT INTO CHANSON VALUES(4539,'Les p''tits papiers',2,NULL,NULL,'2008-03-12 10:40:14');
INSERT INTO CHANSON VALUES(4541,'Etranges étrangers',2,NULL,NULL,'2008-03-12 09:37:51');
INSERT INTO CHANSON VALUES(4542,'Sur le fil',2,NULL,NULL,'2008-03-12 11:03:02');
INSERT INTO CHANSON VALUES(4543,'Pas des chiens',2,NULL,NULL,'2008-03-12 08:59:26');
INSERT INTO CHANSON VALUES(4544,'La bouteille de gaz',2,NULL,NULL,'2008-03-12 14:52:14');
INSERT INTO CHANSON VALUES(4545,'Hoy me voy',2,NULL,NULL,'2008-03-12 17:51:07');
INSERT INTO CHANSON VALUES(4546,'Algeria',2,NULL,NULL,'2008-03-12 14:52:19');
INSERT INTO CHANSON VALUES(4547,'Azertis',2,NULL,NULL,'2008-03-12 12:35:24');
INSERT INTO CHANSON VALUES(4548,'Kiss off',2,NULL,NULL,'2008-03-12 08:06:09');
INSERT INTO CHANSON VALUES(4550,'Character',2,NULL,'f','2008-03-12 09:53:02');
INSERT INTO CHANSON VALUES(4551,'Wild America',2,NULL,'f','2008-03-12 09:02:39');
INSERT INTO CHANSON VALUES(4552,'Mixin'' The Colors',2,NULL,'f','2008-03-23 19:20:42');
INSERT INTO CHANSON VALUES(4553,'Jealousy',2,NULL,'f','2008-03-12 08:25:41');
INSERT INTO CHANSON VALUES(4554,'Hate',2,NULL,'f','2008-03-12 13:59:34');
INSERT INTO CHANSON VALUES(4555,'It''s Our Love',2,NULL,'f','2008-03-12 16:46:25');
INSERT INTO CHANSON VALUES(4556,'Plastic & Concrete',2,NULL,NULL,'2008-03-12 17:21:18');
INSERT INTO CHANSON VALUES(4557,'Fuckin'' Alone',2,NULL,'f','2008-03-12 09:45:53');
INSERT INTO CHANSON VALUES(4558,'Highway Song',2,NULL,'f','2008-03-12 14:48:00');
INSERT INTO CHANSON VALUES(4559,'Beside You',2,NULL,'f','2008-03-12 16:40:19');
INSERT INTO CHANSON VALUES(4560,'Sickness',2,NULL,'f','2008-03-12 14:46:13');
INSERT INTO CHANSON VALUES(4561,'Boogie Boy',2,NULL,'f','2008-03-12 15:53:15');
INSERT INTO CHANSON VALUES(4562,'Perforation Problems',2,NULL,'f','2008-03-12 11:51:35');
INSERT INTO CHANSON VALUES(4563,'Social Life',2,NULL,'f','2008-03-12 19:53:01');
INSERT INTO CHANSON VALUES(4564,'Louie Louie',2,NULL,'f','2008-03-12 16:21:00');
INSERT INTO CHANSON VALUES(4565,'Caesar',2,NULL,'f','2008-03-12 10:03:46');
INSERT INTO CHANSON VALUES(4566,'Girls Of N.Y.',2,NULL,'f','2008-03-12 16:53:08');
INSERT INTO CHANSON VALUES(4586,'Rocks Off',2,NULL,'f','2008-05-27 11:54:31.053217');
INSERT INTO CHANSON VALUES(4587,'Rip This Joint',2,NULL,'f','2008-03-16 08:23:05');
INSERT INTO CHANSON VALUES(4588,'Shake Your Hips',2,NULL,'f','2008-06-02 10:58:54.602925');
INSERT INTO CHANSON VALUES(4589,'Casino Boogie',2,NULL,'f','2008-03-27 09:13:46');
INSERT INTO CHANSON VALUES(4592,'Torn And Frayed',2,NULL,'f','2008-06-02 10:18:33.356542');
INSERT INTO CHANSON VALUES(4593,'Sweet Black Angel',2,NULL,'f','2008-06-02 10:18:52.056971');
INSERT INTO CHANSON VALUES(4594,'Loving Cup',2,NULL,'f','2008-05-22 15:21:12');
INSERT INTO CHANSON VALUES(4596,'Turd On The Run',2,NULL,'f','2008-06-02 10:20:19.042168');
INSERT INTO CHANSON VALUES(4597,'Ventilator Blues',2,NULL,'f','2008-05-23 17:12:32');
INSERT INTO CHANSON VALUES(4598,'I Just Want To See His Face',2,NULL,'f','2008-06-02 09:59:54.864132');
INSERT INTO CHANSON VALUES(4599,'Let It Loose',2,NULL,NULL,'2008-05-26 13:17:34');
INSERT INTO CHANSON VALUES(4601,'Stop Breaking Down',2,NULL,NULL,'2008-06-02 10:00:44.169137');
INSERT INTO CHANSON VALUES(4603,'Soul Survivor',2,NULL,'f','2008-06-02 10:01:36.717803');
INSERT INTO CHANSON VALUES(4604,'Cold Song',2,NULL,NULL,'2008-03-12 14:35:11');
INSERT INTO CHANSON VALUES(4605,'Can''t Help Falling In Love',2,NULL,NULL,'2008-03-12 15:43:25');
INSERT INTO CHANSON VALUES(4606,'Der Nussbaum',2,NULL,NULL,'2008-03-12 13:33:31');
INSERT INTO CHANSON VALUES(4607,'Just One Look',2,NULL,NULL,'2008-03-12 14:46:49');
INSERT INTO CHANSON VALUES(4608,'The Twist',2,NULL,NULL,'2008-03-12 15:08:33');
INSERT INTO CHANSON VALUES(4609,'Total Eclipse',2,NULL,NULL,'2008-03-12 11:32:58');
INSERT INTO CHANSON VALUES(4610,'Three Wishes',2,NULL,NULL,'2008-03-12 16:50:39');
INSERT INTO CHANSON VALUES(4611,'Icurok',2,NULL,NULL,'2008-03-12 19:54:38');
INSERT INTO CHANSON VALUES(4612,'Wasting My Times',2,NULL,NULL,'2008-03-12 15:07:55');
INSERT INTO CHANSON VALUES(4613,'Rubberband Lazer',2,NULL,NULL,'2008-03-12 08:32:17');
INSERT INTO CHANSON VALUES(4614,'Ding Dong',2,NULL,NULL,'2008-03-12 18:02:52');
INSERT INTO CHANSON VALUES(4615,'Nomi Chant',2,NULL,NULL,'2008-03-12 08:41:35');
INSERT INTO CHANSON VALUES(4616,'Death',2,NULL,NULL,'2008-03-12 13:07:09');
INSERT INTO CHANSON VALUES(4617,'Wayward Sisters',2,NULL,NULL,'2008-03-12 19:41:55');
INSERT INTO CHANSON VALUES(4618,'From Beyond',2,NULL,NULL,'2008-03-12 17:19:04');
INSERT INTO CHANSON VALUES(4619,'Falling In Love Again',2,NULL,NULL,'2008-03-12 12:35:37');
INSERT INTO CHANSON VALUES(4621,'Rock''n Roll Band',2,NULL,NULL,'2008-03-12 08:12:22');
INSERT INTO CHANSON VALUES(4622,'King Kong Five',2,NULL,'f','2008-03-12 15:49:29');
INSERT INTO CHANSON VALUES(4623,'Soledad',2,NULL,'f','2008-03-12 14:53:02');
INSERT INTO CHANSON VALUES(4624,'Sidi H''bibi',2,NULL,'f','2008-03-12 18:45:04');
INSERT INTO CHANSON VALUES(4625,'The Rebel Spell',2,NULL,'f','2008-03-12 16:48:46');
INSERT INTO CHANSON VALUES(4626,'Peligro',2,NULL,'f','2008-03-12 11:17:53');
INSERT INTO CHANSON VALUES(4627,'Pas Assez De Toi',2,NULL,'f','2008-03-23 12:06:54');
INSERT INTO CHANSON VALUES(4628,'Magic Dice',2,NULL,'f','2008-03-12 13:30:30');
INSERT INTO CHANSON VALUES(4629,'Mad House',2,NULL,'f','2008-03-12 09:51:47');
INSERT INTO CHANSON VALUES(4630,'Guayaquil City',2,NULL,'f','2008-03-12 14:52:59');
INSERT INTO CHANSON VALUES(4631,'Voodoo',2,NULL,'f','2008-03-12 19:31:49');
INSERT INTO CHANSON VALUES(4632,'Patchanka',2,NULL,'f','2008-03-12 13:05:42');
INSERT INTO CHANSON VALUES(4633,'La Rançon Du Succès',2,NULL,'f','2008-03-12 13:56:27');
INSERT INTO CHANSON VALUES(4634,'The Devil''s Call',2,NULL,'f','2008-03-12 14:40:16');
INSERT INTO CHANSON VALUES(4635,'Roger Cageot',2,NULL,'f','2008-03-23 11:59:34');
INSERT INTO CHANSON VALUES(4636,'El Sur',2,NULL,'f','2008-03-12 10:28:51');
INSERT INTO CHANSON VALUES(4637,'Patchuko Hop',2,NULL,'f','2008-03-12 17:53:58');
INSERT INTO CHANSON VALUES(4638,'Right Next Door To Hell',2,NULL,'f','2008-03-12 16:22:28');
INSERT INTO CHANSON VALUES(4639,'Dust N'' Bones',2,NULL,'f','2008-03-12 10:28:20');
INSERT INTO CHANSON VALUES(4640,'Live And Let Die',2,NULL,'f','2008-03-12 19:02:12');
INSERT INTO CHANSON VALUES(4641,'Don''t Cry',2,NULL,'f','2008-03-12 19:58:43');
INSERT INTO CHANSON VALUES(4642,'Perfect Crime',2,NULL,'f','2008-03-12 17:24:49');
INSERT INTO CHANSON VALUES(4643,'You Ain''t The First',2,NULL,'f','2008-03-12 14:52:45');
INSERT INTO CHANSON VALUES(4644,'Bad Obsession',2,NULL,'f','2008-03-12 19:24:25');
INSERT INTO CHANSON VALUES(4645,'Back Off Bitch',2,NULL,'f','2008-03-12 11:42:25');
INSERT INTO CHANSON VALUES(4646,'Double Talkin'' Jive',2,NULL,NULL,'2008-03-12 17:54:54');
INSERT INTO CHANSON VALUES(4647,'November Rain',2,NULL,'f','2008-03-12 16:41:47');
INSERT INTO CHANSON VALUES(4648,'The Garden',2,NULL,'f','2008-03-12 15:23:10');
INSERT INTO CHANSON VALUES(4649,'Garden Of Eden',2,NULL,'f','2008-03-12 09:35:38');
INSERT INTO CHANSON VALUES(4650,'Don''t Damn Me',2,NULL,'f','2008-03-12 13:34:41');
INSERT INTO CHANSON VALUES(4651,'Bad Apples',2,NULL,'f','2008-03-12 16:32:39');
INSERT INTO CHANSON VALUES(4652,'Dead Horse',2,NULL,NULL,'2008-03-12 13:20:03');
INSERT INTO CHANSON VALUES(4653,'Coma',2,NULL,NULL,'2008-03-12 10:50:55');
INSERT INTO CHANSON VALUES(4654,'Come Together',2,NULL,'f','2008-03-12 08:48:20');
INSERT INTO CHANSON VALUES(4655,'Something',2,NULL,'f','2008-03-12 13:03:02');
INSERT INTO CHANSON VALUES(4656,'Maxwell''s Silver Hammer',2,NULL,'f','2008-03-12 18:53:57');
INSERT INTO CHANSON VALUES(4657,'Oh! Darling',2,NULL,'f','2008-03-12 17:34:39');
INSERT INTO CHANSON VALUES(4658,'Octopus''s Garden',2,NULL,'f','2008-03-12 14:13:02');
INSERT INTO CHANSON VALUES(4659,'I Want You (She''s So Heavy)',2,NULL,'f','2008-03-12 16:22:38');
INSERT INTO CHANSON VALUES(4660,'Here Comes The Sun',2,NULL,'f','2008-03-12 12:51:12');
INSERT INTO CHANSON VALUES(4661,'Because',2,NULL,'f','2008-03-12 08:32:44');
INSERT INTO CHANSON VALUES(4662,'You Never Give Me Your Money',2,NULL,NULL,'2008-03-12 16:58:04');
INSERT INTO CHANSON VALUES(4663,'Sun King',2,NULL,'f','2008-03-12 17:13:55');
INSERT INTO CHANSON VALUES(4664,'Mean Mr. Mustard',2,NULL,'f','2008-03-12 16:13:44');
INSERT INTO CHANSON VALUES(4665,'Polythene Pam',2,NULL,'f','2008-03-12 08:40:48');
INSERT INTO CHANSON VALUES(4666,'She Came In Through The Bathroom Window',2,NULL,'f','2008-03-12 09:32:41');
INSERT INTO CHANSON VALUES(4667,'Golden Slumbers',2,NULL,'f','2008-03-12 08:18:15');
INSERT INTO CHANSON VALUES(4668,'Carry That Weight',2,NULL,'f','2008-03-12 16:52:29');
INSERT INTO CHANSON VALUES(4669,'The End',2,NULL,'f','2008-03-12 17:36:51');
INSERT INTO CHANSON VALUES(4670,'Her Majesty',2,NULL,NULL,'2008-03-12 12:59:42');
INSERT INTO CHANSON VALUES(4671,'In The Heat Of The Morning',2,NULL,'f','2008-06-07 19:43:39.958983');
INSERT INTO CHANSON VALUES(4672,'London Bye Ta Ta',2,NULL,'f','2008-06-07 15:36:58.013269');
INSERT INTO CHANSON VALUES(4673,'Karma Man',2,NULL,'f','2008-03-22 13:34:27');
INSERT INTO CHANSON VALUES(4675,'Let Me Sleep Beside You',2,NULL,'f','2008-06-07 20:01:04.85777');
INSERT INTO CHANSON VALUES(4677,'Amsterdam',2,NULL,'f','2008-03-17 18:27:53');
INSERT INTO CHANSON VALUES(4684,'Bombers',2,NULL,'f','2008-06-07 15:33:52.470061');
INSERT INTO CHANSON VALUES(4685,'Looking For A Friend',2,NULL,'f','2008-06-07 15:37:21.93817');
INSERT INTO CHANSON VALUES(4689,'Sex my soul on fire',2,NULL,NULL,'2008-03-12 18:10:24');
INSERT INTO CHANSON VALUES(4691,'N.L.A.',2,NULL,NULL,'2008-03-12 18:09:13');
INSERT INTO CHANSON VALUES(4692,'Lovers and pink phenomeno',2,NULL,NULL,'2008-03-12 17:45:44');
INSERT INTO CHANSON VALUES(4693,'Silent movies',2,NULL,NULL,'2008-03-12 19:35:59');
INSERT INTO CHANSON VALUES(4694,'Tequila',2,NULL,NULL,'2008-03-12 08:56:00');
INSERT INTO CHANSON VALUES(4695,'Dans les bars',2,NULL,NULL,'2008-03-12 16:07:25');
INSERT INTO CHANSON VALUES(4696,'Lover man',2,NULL,NULL,'2008-03-12 12:01:27');
INSERT INTO CHANSON VALUES(4697,'Implosion',2,NULL,NULL,'2008-03-12 09:10:49');
INSERT INTO CHANSON VALUES(4698,'Colour of love',2,NULL,NULL,'2008-03-12 15:33:38');
INSERT INTO CHANSON VALUES(4699,'Babylon sky',2,NULL,NULL,'2008-03-12 16:23:48');
INSERT INTO CHANSON VALUES(4700,'Crime',2,NULL,NULL,'2008-03-12 09:54:04');
INSERT INTO CHANSON VALUES(4701,'Dead of night',2,NULL,NULL,'2008-03-12 18:46:14');
INSERT INTO CHANSON VALUES(4702,'Wah ha ha',2,NULL,NULL,'2008-03-12 09:32:59');
INSERT INTO CHANSON VALUES(4703,'L''été 66',2,NULL,NULL,'2008-03-12 18:28:35');
INSERT INTO CHANSON VALUES(4704,'Hi m''énerve',2,NULL,NULL,'2008-03-12 18:29:31');
INSERT INTO CHANSON VALUES(4705,'Jerry watchin'' T.V.',2,NULL,NULL,'2008-03-12 18:11:38');
INSERT INTO CHANSON VALUES(4706,'Do it',2,NULL,NULL,'2008-03-12 11:32:40');
INSERT INTO CHANSON VALUES(4707,'Machines',2,NULL,NULL,'2008-03-12 16:37:50');
INSERT INTO CHANSON VALUES(4708,'Temple bar',2,NULL,'f','2008-03-12 14:14:24');
INSERT INTO CHANSON VALUES(4709,'From room 102',2,NULL,'f','2008-03-12 10:56:47');
INSERT INTO CHANSON VALUES(4712,'Telle me',2,NULL,'f','2008-03-12 11:02:01');
INSERT INTO CHANSON VALUES(4715,'Just a story from America',2,NULL,'f','2008-03-12 12:34:11');
INSERT INTO CHANSON VALUES(4717,'A Mountain Of Love',2,NULL,'f','2008-03-12 16:34:21');
INSERT INTO CHANSON VALUES(4718,'Mick''s Dream',2,NULL,'f','2008-03-12 14:07:35');
INSERT INTO CHANSON VALUES(4719,'La Belle Dame Sans Merci',2,NULL,'f','2008-03-12 19:18:32');
INSERT INTO CHANSON VALUES(4720,'Everybody Got Lucky',2,NULL,'f','2008-03-12 16:18:36');
INSERT INTO CHANSON VALUES(4721,'Look Around You',2,NULL,'f','2008-03-12 13:22:32');
INSERT INTO CHANSON VALUES(4722,'Cutting The Cake',2,NULL,'f','2008-03-12 19:40:35');
INSERT INTO CHANSON VALUES(4723,'Bird',2,NULL,'f','2008-03-12 19:57:29');
INSERT INTO CHANSON VALUES(4724,'Jet-Leg',2,NULL,'f','2008-03-12 13:49:13');
INSERT INTO CHANSON VALUES(4725,'Moan',2,NULL,NULL,'2008-03-12 13:13:47');
INSERT INTO CHANSON VALUES(4726,'O Catarina',2,NULL,'f','2008-03-12 15:15:39');
INSERT INTO CHANSON VALUES(4727,'The Red Lights',2,NULL,'f','2008-03-12 12:57:13');
INSERT INTO CHANSON VALUES(4728,'Green River',2,NULL,'f','2008-03-12 17:30:21');
INSERT INTO CHANSON VALUES(4729,'Night Falls',2,NULL,'f','2008-03-12 12:27:39');
INSERT INTO CHANSON VALUES(4730,'The Best Kiss',2,NULL,'f','2008-03-12 18:12:58');
INSERT INTO CHANSON VALUES(4731,'Big Sky',2,NULL,'f','2008-03-12 13:40:20');
INSERT INTO CHANSON VALUES(4732,'The Poet And The Priest',2,NULL,'f','2008-03-12 08:36:00');
INSERT INTO CHANSON VALUES(4733,'Le Future',2,NULL,'f','2008-03-12 15:34:58');
INSERT INTO CHANSON VALUES(4735,'The Banks Of The Ohio',2,NULL,'f','2008-03-12 12:31:01');
INSERT INTO CHANSON VALUES(4736,'The Last Star Of The Night',2,NULL,'f','2008-03-12 09:11:17');
INSERT INTO CHANSON VALUES(4737,'Day Is Gone',2,NULL,'f','2008-03-12 17:34:15');
INSERT INTO CHANSON VALUES(4743,'Yallah',2,NULL,NULL,'2008-03-12 12:45:17');
INSERT INTO CHANSON VALUES(4744,'City Don''t Cry',2,NULL,'f','2008-03-12 12:52:21');
INSERT INTO CHANSON VALUES(4747,'Wonderful One',2,NULL,'f','2008-03-12 13:10:38');
INSERT INTO CHANSON VALUES(4748,'Wah Wah',2,NULL,'f','2008-03-12 16:12:57');
INSERT INTO CHANSON VALUES(4753,'Ma page blanche',5,NULL,'f','2008-03-12 19:21:08');
INSERT INTO CHANSON VALUES(4754,'Promets qu''tu viens',5,NULL,'f','2008-03-12 11:42:01');
INSERT INTO CHANSON VALUES(4755,'Rue',5,NULL,'f','2008-03-12 15:50:15');
INSERT INTO CHANSON VALUES(4756,'Afrique, ma mère',5,NULL,'f','2008-03-12 13:01:37');
INSERT INTO CHANSON VALUES(4757,'Treichville',5,NULL,'f','2008-03-12 14:28:48');
INSERT INTO CHANSON VALUES(4758,'Danse, mendy',5,NULL,'f','2008-03-12 10:11:00');
INSERT INTO CHANSON VALUES(4759,'Encore',5,NULL,'f','2008-03-12 09:39:35');
INSERT INTO CHANSON VALUES(4760,'à mamie',5,NULL,NULL,'2008-03-12 17:21:13');
INSERT INTO CHANSON VALUES(4761,'New Killer Star',2,NULL,NULL,'2008-06-07 19:44:10.873954');
INSERT INTO CHANSON VALUES(4762,'Pablo Picasso',2,NULL,'f','2008-06-07 19:44:31.771178');
INSERT INTO CHANSON VALUES(4763,'Never Get Old',2,NULL,NULL,'2008-03-23 15:41:12');
INSERT INTO CHANSON VALUES(4764,'The Loneliest Guy',2,NULL,'f','2008-06-07 20:25:45.119628');
INSERT INTO CHANSON VALUES(4765,'Looking For Water',2,NULL,'f','2008-06-07 20:22:14.431695');
INSERT INTO CHANSON VALUES(4766,'She''ll Drive the Big Car',2,NULL,'f','2008-06-07 19:55:27.020555');
INSERT INTO CHANSON VALUES(4767,'Days',2,NULL,'f','2008-06-07 19:28:26.686155');
INSERT INTO CHANSON VALUES(4768,'Fall Dog Bombs the Moon',2,NULL,'f','2008-06-07 20:20:19.315955');
INSERT INTO CHANSON VALUES(4769,'Try Some, Buy Some',2,NULL,'f','2008-06-07 19:58:49.918713');
INSERT INTO CHANSON VALUES(4770,'Reality',2,NULL,'f','2008-06-07 19:53:09.723357');
INSERT INTO CHANSON VALUES(4771,'Bring Me the Disco King',2,NULL,'f','2008-06-07 19:27:51.54963');
INSERT INTO CHANSON VALUES(4772,'Fly',2,NULL,'f','2008-06-07 19:29:12.172314');
INSERT INTO CHANSON VALUES(4773,'Queen Of All The Tarts (Overture)',2,NULL,'f','2008-06-07 20:24:35.225306');
INSERT INTO CHANSON VALUES(4775,'Ex Fan des Sixties',5,NULL,'f','2008-03-12 10:14:53');
INSERT INTO CHANSON VALUES(4776,'Apocalypstick',5,NULL,'f','2008-03-12 19:18:56');
INSERT INTO CHANSON VALUES(4777,'Exercice en forme de Z',5,NULL,'f','2008-03-12 16:00:32');
INSERT INTO CHANSON VALUES(4778,'Mélodie interdite',5,NULL,'f','2008-03-12 19:31:19');
INSERT INTO CHANSON VALUES(4779,'L''aquoiboniste',5,NULL,'f','2008-03-12 13:03:14');
INSERT INTO CHANSON VALUES(4780,'Vie mort et résurrection d''un amour passion',5,NULL,'f','2008-03-12 14:11:57');
INSERT INTO CHANSON VALUES(4781,'Nicotine',5,NULL,'f','2008-03-12 08:31:40');
INSERT INTO CHANSON VALUES(4782,'Rocking chair',5,NULL,'f','2008-03-12 19:44:39');
INSERT INTO CHANSON VALUES(4783,'Dépressive',5,NULL,'f','2008-03-12 15:47:17');
INSERT INTO CHANSON VALUES(4784,'Le velours des vierges',5,NULL,'f','2008-03-12 08:03:42');
INSERT INTO CHANSON VALUES(4785,'Classée X',5,NULL,'f','2008-03-12 12:14:57');
INSERT INTO CHANSON VALUES(4786,'Mélo mélo',5,NULL,'f','2008-03-12 10:11:16');
INSERT INTO CHANSON VALUES(4788,'Raccrochez c''est une horreur',5,NULL,'f','2008-03-12 10:55:17');
INSERT INTO CHANSON VALUES(4789,'Yesterday yes a day',5,NULL,NULL,'2008-03-12 16:54:49');
INSERT INTO CHANSON VALUES(4790,'Ma Gonzesse',2,NULL,'f','2008-03-29 08:20:52');
INSERT INTO CHANSON VALUES(4791,'Sans dec''',2,NULL,'f','2008-03-29 11:53:03');
INSERT INTO CHANSON VALUES(4792,'La tire à Dédé',2,NULL,'f','2008-03-29 11:53:35');
INSERT INTO CHANSON VALUES(4793,'Ch''timi rock',2,NULL,NULL,'2008-03-29 19:50:19');
INSERT INTO CHANSON VALUES(4794,'J''ai la vie qui m''pique les yeux',2,NULL,NULL,'2008-03-29 09:25:40');
INSERT INTO CHANSON VALUES(4795,'C''est mon dernier bal',2,NULL,'f','2008-03-29 15:29:06');
INSERT INTO CHANSON VALUES(4796,'Le tango de Massy-Palaiseau',2,NULL,'f','2008-03-29 18:30:10');
INSERT INTO CHANSON VALUES(4797,'Chanson pour Pierrot',2,NULL,'f','2008-03-29 15:51:24');
INSERT INTO CHANSON VALUES(4798,'Salut manouche',2,NULL,'f','2008-03-29 14:05:35');
INSERT INTO CHANSON VALUES(4799,'Peau aime',2,NULL,'f','2008-03-29 19:03:46');
INSERT INTO CHANSON VALUES(4800,'Étudiant poil aux dents',2,NULL,'f','2008-04-07 11:34:02');
INSERT INTO CHANSON VALUES(4801,'La teigne',2,NULL,'f','2008-03-29 17:20:39');
INSERT INTO CHANSON VALUES(4802,'Le Père Noël noir',2,NULL,'f','2008-04-07 10:04:32');
INSERT INTO CHANSON VALUES(4803,'Banlieue rouge',2,NULL,'f','2008-03-12 17:17:30');
INSERT INTO CHANSON VALUES(4804,'La blanche',2,NULL,'f','2008-04-07 12:58:07');
INSERT INTO CHANSON VALUES(4806,'Manu',2,NULL,'f','2008-04-13 15:52:57');
INSERT INTO CHANSON VALUES(4807,'J''ai raté Télé Foot',2,NULL,'f','2008-04-07 17:29:14');
INSERT INTO CHANSON VALUES(4808,'Dans mon HLM',2,NULL,'f','2008-03-24 10:36:09');
INSERT INTO CHANSON VALUES(4809,'Cent ans',2,NULL,'f','2008-04-07 11:58:13');
INSERT INTO CHANSON VALUES(4810,'Fatigué',2,NULL,'f','2008-04-13 17:22:50');
INSERT INTO CHANSON VALUES(4811,'Miss Maggie',2,NULL,NULL,'2008-03-23 18:36:33');
INSERT INTO CHANSON VALUES(4812,'Petite',2,NULL,'f','2008-04-13 13:32:39');
INSERT INTO CHANSON VALUES(4814,'Près des auto-tamponneuses',2,NULL,'f','2008-03-12 13:31:24');
INSERT INTO CHANSON VALUES(4815,'Morts les enfants',2,NULL,'f','2008-04-13 10:24:41');
INSERT INTO CHANSON VALUES(4816,'La pêche à la ligne',2,NULL,'f','2008-04-13 15:09:33');
INSERT INTO CHANSON VALUES(4817,'Socialiste',2,NULL,'f','2008-04-07 16:20:40');
INSERT INTO CHANSON VALUES(4818,'Mistral gagnant',2,NULL,'f','2008-04-07 16:16:20');
INSERT INTO CHANSON VALUES(4819,'Dès que le vent soufflera',2,NULL,'f','2008-04-13 16:11:40');
INSERT INTO CHANSON VALUES(4820,'Triviale poursuite',2,NULL,'f','2008-04-07 08:33:51');
INSERT INTO CHANSON VALUES(4821,'Il pleut',2,NULL,'f','2008-04-07 11:22:31');
INSERT INTO CHANSON VALUES(4822,'Putain de camion',2,NULL,'f','2008-03-29 17:06:53');
INSERT INTO CHANSON VALUES(4823,'La mère à Titi',2,NULL,'f','2008-04-07 14:23:04');
INSERT INTO CHANSON VALUES(4824,'Morgane de toi',2,NULL,'f','2008-04-07 13:36:30');
INSERT INTO CHANSON VALUES(4826,'Me jette pas',2,NULL,'f','2008-04-07 19:32:05');
INSERT INTO CHANSON VALUES(4827,'Jonathan',2,NULL,'f','2008-04-07 08:44:27');
INSERT INTO CHANSON VALUES(4828,'Où c''est qu''j''ai mis mon flingue ?',2,NULL,'f','2008-03-29 11:11:51');
INSERT INTO CHANSON VALUES(4829,'Les aventures de Gérard Lambert',2,NULL,'f','2008-03-29 18:59:23');
INSERT INTO CHANSON VALUES(4830,'Soleil immonde',2,NULL,'f','2008-04-07 10:30:40');
INSERT INTO CHANSON VALUES(4831,'La chanson du loubard',2,NULL,'f','2008-03-12 08:34:14');
INSERT INTO CHANSON VALUES(4833,'Germaine',2,NULL,'f','2008-03-12 13:06:20');
INSERT INTO CHANSON VALUES(4834,'Mon beauf''',2,NULL,'f','2008-04-07 19:47:07');
INSERT INTO CHANSON VALUES(4836,'L''auto-stoppeuse',2,NULL,'f','2008-03-29 08:55:37');
INSERT INTO CHANSON VALUES(4840,'Le retour de Gerard Lambert',2,NULL,'f','2008-04-07 08:50:01');
INSERT INTO CHANSON VALUES(4843,'Oscar',2,NULL,'f','2008-04-07 08:32:48');
INSERT INTO CHANSON VALUES(4848,'A quelle heure on arrive ?',2,NULL,'f','2008-04-07 12:17:40');
INSERT INTO CHANSON VALUES(4849,'Marche à l''ombre',2,NULL,'f','2008-03-29 14:02:38');
INSERT INTO CHANSON VALUES(4854,'It is not because you are',2,NULL,'f','2008-03-29 17:45:02');
INSERT INTO CHANSON VALUES(4855,'Baston !',2,NULL,'f','2008-03-29 08:39:43');
INSERT INTO CHANSON VALUES(4856,'Mimi l''ennui',2,NULL,'f','2008-03-29 12:50:17');
INSERT INTO CHANSON VALUES(4858,'Pourquoi d''abord ?',2,NULL,'f','2008-03-29 16:47:50');
INSERT INTO CHANSON VALUES(4859,'Tout in haut de Ch''terril',2,NULL,NULL,'2008-03-29 19:15:57');
INSERT INTO CHANSON VALUES(4860,'el pinsionn e',2,NULL,'f','2008-03-12 11:20:53');
INSERT INTO CHANSON VALUES(4861,'ch''m neu d''qu vaux',2,NULL,'f','2008-03-12 19:55:55');
INSERT INTO CHANSON VALUES(4862,'les tomates',2,NULL,'f','2008-03-12 14:55:53');
INSERT INTO CHANSON VALUES(4863,'le tango du cachalot',2,NULL,'f','2008-03-12 11:42:38');
INSERT INTO CHANSON VALUES(4864,'adieu ch''terril d''rimbert',2,NULL,'f','2008-03-12 11:09:15');
INSERT INTO CHANSON VALUES(4865,'eun'' goutt'' ed'' jus',2,NULL,NULL,'2008-03-12 19:10:19');
INSERT INTO CHANSON VALUES(4866,'m''lampiste',2,NULL,NULL,'2008-03-12 09:34:09');
INSERT INTO CHANSON VALUES(4867,'y''in a qu''pour li',2,NULL,'f','2008-03-12 13:52:53');
INSERT INTO CHANSON VALUES(4868,'les molettes',2,NULL,'f','2008-03-12 16:34:41');
INSERT INTO CHANSON VALUES(4869,'i bot un d''mi',2,NULL,'f','2008-03-12 14:30:57');
INSERT INTO CHANSON VALUES(4870,'d  qu''i sont',2,NULL,'f','2008-03-12 14:47:17');
INSERT INTO CHANSON VALUES(4871,'La ballade de Willy Brouillard',2,NULL,'f','2008-03-29 13:42:12');
INSERT INTO CHANSON VALUES(4872,'À la belle de Mai',2,NULL,'f','2008-04-07 11:55:48');
INSERT INTO CHANSON VALUES(4873,'C''est quand qu''on va où',2,NULL,'f','2008-03-29 12:16:08');
INSERT INTO CHANSON VALUES(4874,'Le sirop de la rue',2,NULL,'f','2008-03-29 10:32:50');
INSERT INTO CHANSON VALUES(4875,'Devant les lavabos',2,NULL,'f','2008-03-29 18:50:00');
INSERT INTO CHANSON VALUES(4876,'Cheveu blanc',2,NULL,'f','2008-03-29 09:48:11');
INSERT INTO CHANSON VALUES(4877,'Le petit chat est mort',2,NULL,'f','2008-03-29 13:56:46');
INSERT INTO CHANSON VALUES(4878,'Adios Zapata',2,NULL,'f','2008-03-29 15:21:38');
INSERT INTO CHANSON VALUES(4879,'Son bleu',2,NULL,'f','2008-03-29 14:04:12');
INSERT INTO CHANSON VALUES(4880,'Mon amoureux',2,NULL,'f','2008-03-29 10:37:43');
INSERT INTO CHANSON VALUES(4881,'Lolito Lolita',2,NULL,'f','2008-03-12 09:09:31');
INSERT INTO CHANSON VALUES(4882,'La médaille',2,NULL,'f','2008-03-29 13:34:13');
INSERT INTO CHANSON VALUES(4883,'Laisse Béton',2,NULL,'f','2008-03-29 15:55:30');
INSERT INTO CHANSON VALUES(4884,'Le Blues de la Porte d''Orléans',2,NULL,NULL,'2008-03-29 17:09:02');
INSERT INTO CHANSON VALUES(4886,'Je suis une bande de Jeunes',2,NULL,'f','2008-03-29 15:09:41');
INSERT INTO CHANSON VALUES(4887,'Adieu Minette',2,NULL,'f','2008-03-29 18:35:37');
INSERT INTO CHANSON VALUES(4888,'Les Charognards',2,NULL,'f','2008-03-29 15:12:59');
INSERT INTO CHANSON VALUES(4889,'Jojo le Démago',2,NULL,'f','2008-03-29 11:42:04');
INSERT INTO CHANSON VALUES(4890,'Buffalo Débile',2,NULL,'f','2008-04-13 18:09:50');
INSERT INTO CHANSON VALUES(4891,'La Boum',2,NULL,'f','2008-03-29 13:53:41');
INSERT INTO CHANSON VALUES(4893,'Mélusine',2,NULL,'f','2008-03-29 16:29:25');
INSERT INTO CHANSON VALUES(4894,'La Bande à Lucien',2,NULL,'f','2008-03-29 19:08:20');
INSERT INTO CHANSON VALUES(4895,'Amoureux de Paname',2,NULL,'f','2008-03-29 13:56:29');
INSERT INTO CHANSON VALUES(4896,'Societe tu m''auras pas',2,NULL,'f','2008-03-29 13:34:31');
INSERT INTO CHANSON VALUES(4897,'Petite fille des sombres rues',2,NULL,NULL,'2008-03-29 12:13:40');
INSERT INTO CHANSON VALUES(4898,'La java sans joie',2,NULL,'f','2008-03-29 08:19:00');
INSERT INTO CHANSON VALUES(4899,'Gueule d''Aminche',2,NULL,NULL,'2008-03-29 08:03:16');
INSERT INTO CHANSON VALUES(4900,'La Coupole',2,NULL,'f','2008-03-29 16:39:28');
INSERT INTO CHANSON VALUES(4901,'Hexagone',2,NULL,'f','2008-03-29 16:54:10');
INSERT INTO CHANSON VALUES(4902,'Ecoutez-moi les Gavroches',2,NULL,'f','2008-03-29 17:22:04');
INSERT INTO CHANSON VALUES(4903,'Rita',2,NULL,'f','2008-03-29 19:53:25');
INSERT INTO CHANSON VALUES(4904,'Camarade Bourgeois',2,NULL,'f','2008-03-29 13:34:07');
INSERT INTO CHANSON VALUES(4905,'Le Gringalet',2,NULL,'f','2008-04-13 18:35:20');
INSERT INTO CHANSON VALUES(4906,'La Menthe a l''eau',2,NULL,'f','2008-03-29 11:16:37');
INSERT INTO CHANSON VALUES(4907,'Greta',2,NULL,'f','2008-03-29 16:13:45');
INSERT INTO CHANSON VALUES(4908,'Lézard',2,NULL,NULL,'2008-04-07 10:28:32');
INSERT INTO CHANSON VALUES(4909,'C''est un mauvais garçon',2,NULL,'f','2008-03-12 08:40:42');
INSERT INTO CHANSON VALUES(4910,'Du gris',2,NULL,'f','2008-03-12 14:09:16');
INSERT INTO CHANSON VALUES(4911,'Tel qu''il est',2,NULL,'f','2008-03-12 09:32:29');
INSERT INTO CHANSON VALUES(4912,'C''est un mâle',2,NULL,'f','2008-03-12 17:36:33');
INSERT INTO CHANSON VALUES(4913,'Le p''tit bal du samedi soir',2,NULL,'f','2008-03-12 08:18:13');
INSERT INTO CHANSON VALUES(4914,'Un chat qui miaule',2,NULL,'f','2008-03-12 14:59:08');
INSERT INTO CHANSON VALUES(4915,'Rue Saint-Vincent',2,NULL,'f','2008-03-12 16:45:31');
INSERT INTO CHANSON VALUES(4916,'La Java',2,NULL,'f','2008-03-12 17:12:05');
INSERT INTO CHANSON VALUES(4917,'La jeune fille du métro',2,NULL,'f','2008-03-12 18:31:22');
INSERT INTO CHANSON VALUES(4918,'La butte rouge',2,NULL,'f','2008-03-12 14:14:36');
INSERT INTO CHANSON VALUES(4919,'La plus bath des Javas',2,NULL,'f','2008-03-12 11:19:16');
INSERT INTO CHANSON VALUES(4925,'Rouge gorge',2,NULL,'f','2008-04-07 16:48:40');
INSERT INTO CHANSON VALUES(4926,'Allongés sous les vagues',2,NULL,'f','2008-04-07 16:05:02');
INSERT INTO CHANSON VALUES(4930,'Chanson dégueulasse',2,NULL,'f','2008-04-13 09:36:07');
INSERT INTO CHANSON VALUES(4934,'Si t''es mon pote',2,NULL,'f','2008-04-07 17:50:32');
INSERT INTO CHANSON VALUES(4936,'Trois Matelots',2,NULL,'f','2008-04-13 11:35:21');
INSERT INTO CHANSON VALUES(4937,'Tu vas au bal',2,NULL,'f','2008-04-07 16:06:35');
INSERT INTO CHANSON VALUES(4939,'Baby-Sitting Blues',2,NULL,'f','2008-04-13 19:13:43');
INSERT INTO CHANSON VALUES(4940,'P''tite Conne',2,NULL,'f','2008-04-13 11:58:55');
INSERT INTO CHANSON VALUES(4941,'Le retour de la pépette',2,NULL,'f','2008-04-13 11:22:55');
INSERT INTO CHANSON VALUES(4962,'Deuxième Génération',2,NULL,NULL,'2008-04-07 10:47:24');
INSERT INTO CHANSON VALUES(4963,'Pochtron!',2,NULL,NULL,'2008-04-07 09:31:41');
INSERT INTO CHANSON VALUES(4965,'Doudou S''en Fout',2,NULL,'f','2008-04-07 10:55:29');
INSERT INTO CHANSON VALUES(4966,'En Cloque',2,NULL,NULL,'2008-04-07 09:10:53');
INSERT INTO CHANSON VALUES(4967,'Ma Chanson Leur A Pas Plu',2,NULL,'f','2008-04-07 19:43:18');
INSERT INTO CHANSON VALUES(4968,'Déserteur',2,NULL,'f','2008-04-07 17:33:11');
INSERT INTO CHANSON VALUES(4969,'Près Des Autos Tamponneuses',2,NULL,'f','2008-04-07 13:03:55');
INSERT INTO CHANSON VALUES(4970,'Loulou',2,NULL,'f','2008-04-13 19:02:24');
INSERT INTO CHANSON VALUES(4971,'Marchand de cailloux',2,NULL,'f','2008-03-29 12:49:12');
INSERT INTO CHANSON VALUES(4972,'L''aquarium',2,NULL,NULL,'2008-03-29 10:46:31');
INSERT INTO CHANSON VALUES(4973,'P''tit voleur',2,NULL,'f','2008-03-29 14:59:09');
INSERT INTO CHANSON VALUES(4974,'Olé!',2,NULL,'f','2008-03-12 08:54:11');
INSERT INTO CHANSON VALUES(4975,'Les dimanches à la con',2,NULL,'f','2008-03-29 10:38:31');
INSERT INTO CHANSON VALUES(4976,'Dans ton sac',2,NULL,'f','2008-03-29 17:35:51');
INSERT INTO CHANSON VALUES(4977,'Le tango des élus',2,NULL,'f','2008-03-29 08:44:31');
INSERT INTO CHANSON VALUES(4978,'La ballade nord-irlandaise',2,NULL,'f','2008-03-29 19:25:48');
INSERT INTO CHANSON VALUES(4979,'500 connards sur la ligne de départ',2,NULL,'f','2008-03-29 14:42:48');
INSERT INTO CHANSON VALUES(4980,'Tonton',2,NULL,'f','2008-03-29 10:01:39');
INSERT INTO CHANSON VALUES(4981,'Je cruel',2,NULL,'f','2008-03-29 14:18:51');
INSERT INTO CHANSON VALUES(4982,'C''est pas du pipeau',2,NULL,'f','2008-03-29 18:26:28');
INSERT INTO CHANSON VALUES(4984,'Tant qu''il y aura des ombres',2,NULL,'f','2008-03-29 19:26:17');
INSERT INTO CHANSON VALUES(4985,'Brain of J.',2,NULL,'f','2008-03-12 15:20:34');
INSERT INTO CHANSON VALUES(4986,'Faithfull',2,NULL,'f','2008-03-12 16:18:17');
INSERT INTO CHANSON VALUES(4987,'No Way',2,NULL,'f','2008-03-12 08:50:17');
INSERT INTO CHANSON VALUES(4988,'Given To Fly',2,NULL,'f','2008-03-12 10:52:11');
INSERT INTO CHANSON VALUES(4989,'Wishlist',2,NULL,'f','2008-03-12 12:06:50');
INSERT INTO CHANSON VALUES(4990,'Pilate',2,NULL,'f','2008-03-12 19:10:34');
INSERT INTO CHANSON VALUES(4991,'Do The Evolution',2,NULL,'f','2008-03-12 13:08:59');
INSERT INTO CHANSON VALUES(4992,'The Color Red',2,NULL,NULL,'2008-03-12 11:23:01');
INSERT INTO CHANSON VALUES(4993,'MFC',2,NULL,'f','2008-03-12 18:15:28');
INSERT INTO CHANSON VALUES(4994,'Low Light',2,NULL,'f','2008-03-12 12:19:06');
INSERT INTO CHANSON VALUES(4995,'In Hiding',2,NULL,'f','2008-03-12 15:54:26');
INSERT INTO CHANSON VALUES(4996,'Push Me, Pull Me',2,NULL,'f','2008-03-12 10:39:45');
INSERT INTO CHANSON VALUES(4997,'All Those Yesterdays',2,NULL,'f','2008-03-12 14:43:36');
INSERT INTO CHANSON VALUES(4998,'Entrée',2,NULL,NULL,'2008-03-12 17:56:28');
INSERT INTO CHANSON VALUES(4999,'Évasion',2,NULL,NULL,'2008-03-12 19:20:35');
INSERT INTO CHANSON VALUES(5000,'Vieux rodéo',2,NULL,'f','2008-03-12 18:16:45');
INSERT INTO CHANSON VALUES(5001,'Triton',2,NULL,'f','2008-03-12 12:42:53');
INSERT INTO CHANSON VALUES(5002,'Trop bonne',2,NULL,'f','2008-03-12 12:58:16');
INSERT INTO CHANSON VALUES(5003,'Tous mes voeux',2,NULL,'f','2008-03-12 13:53:31');
INSERT INTO CHANSON VALUES(5004,'Tu me manques',2,NULL,'f','2008-03-12 18:17:51');
INSERT INTO CHANSON VALUES(5005,'J''applaudis',2,NULL,'f','2008-03-12 08:56:45');
INSERT INTO CHANSON VALUES(5006,'Melodica',2,NULL,'f','2008-03-12 13:10:25');
INSERT INTO CHANSON VALUES(5007,'Interlude',2,NULL,'f','2008-03-12 10:41:09');
INSERT INTO CHANSON VALUES(5008,'Ce sale ton',2,NULL,'f','2008-03-12 18:29:05');
INSERT INTO CHANSON VALUES(5009,'Sacha',2,NULL,'f','2008-03-12 11:29:26');
INSERT INTO CHANSON VALUES(5010,'1928',2,NULL,'f','2008-03-12 18:19:42');
INSERT INTO CHANSON VALUES(5011,'Country Home',2,NULL,'f','2008-03-12 16:43:25');
INSERT INTO CHANSON VALUES(5012,'White Line',2,NULL,'f','2008-03-12 14:07:24');
INSERT INTO CHANSON VALUES(5013,'F-!#in'' Up',2,NULL,'f','2008-03-12 18:33:17');
INSERT INTO CHANSON VALUES(5014,'Over And Over',2,NULL,'f','2008-03-12 12:28:35');
INSERT INTO CHANSON VALUES(5015,'Love To Burn',2,NULL,NULL,'2008-03-12 10:29:31');
INSERT INTO CHANSON VALUES(5016,'Farmer John',2,NULL,NULL,'2008-03-12 19:57:42');
INSERT INTO CHANSON VALUES(5017,'Mansion On The Hill',2,NULL,'f','2008-03-12 13:11:23');
INSERT INTO CHANSON VALUES(5018,'Days That Used To Be',2,NULL,'f','2008-03-12 14:01:52');
INSERT INTO CHANSON VALUES(5019,'Love And Only Love',2,NULL,'f','2008-03-12 15:20:21');
INSERT INTO CHANSON VALUES(5020,'Mother Earth (Natural Anthem)',2,NULL,'f','2008-03-12 09:15:40');
INSERT INTO CHANSON VALUES(5021,'Le Télégramme de Brest',2,NULL,'f','2008-03-12 17:55:24');
INSERT INTO CHANSON VALUES(5022,'Manu Chao',2,NULL,'f','2008-03-12 10:29:32');
INSERT INTO CHANSON VALUES(5023,'Comme un Kenyan',2,NULL,'f','2008-03-12 15:19:06');
INSERT INTO CHANSON VALUES(5024,'Je t''ai donné ma vie',2,NULL,'f','2008-03-12 19:42:34');
INSERT INTO CHANSON VALUES(5025,'Little Daewoo',2,NULL,'f','2008-03-12 14:56:03');
INSERT INTO CHANSON VALUES(5026,'Toulouse',2,NULL,'f','2008-03-12 08:55:00');
INSERT INTO CHANSON VALUES(5027,'C.R.S',2,NULL,'f','2008-03-12 16:21:12');
INSERT INTO CHANSON VALUES(5028,'Vol à voile',2,NULL,'f','2008-03-12 09:55:13');
INSERT INTO CHANSON VALUES(5029,'Le vélo violet',2,NULL,'f','2008-03-12 08:35:34');
INSERT INTO CHANSON VALUES(5030,'Chocorêve',2,NULL,NULL,'2008-03-12 12:41:49');
INSERT INTO CHANSON VALUES(5031,'Giscard complice',2,NULL,NULL,'2008-03-12 08:30:45');
INSERT INTO CHANSON VALUES(5032,'Les apprentis charcutiers',2,NULL,'f','2008-03-12 13:44:14');
INSERT INTO CHANSON VALUES(5033,'Country in Croatie',2,NULL,'f','2008-03-12 19:22:34');
INSERT INTO CHANSON VALUES(5034,'L''aquarium tactile',2,NULL,'f','2008-03-12 08:17:17');
INSERT INTO CHANSON VALUES(5035,'Liste de droite',2,NULL,'f','2008-03-12 15:48:13');
INSERT INTO CHANSON VALUES(5036,'Sweet Home Alabama',2,NULL,'f','2008-03-12 16:51:09');
INSERT INTO CHANSON VALUES(5037,'I Ain''t The One',2,NULL,'f','2008-03-12 16:36:30');
INSERT INTO CHANSON VALUES(5038,'Was I Right Or Wrong',2,NULL,'f','2008-03-12 19:44:25');
INSERT INTO CHANSON VALUES(5039,'Gimme Three Steps',2,NULL,'f','2008-04-05 11:16:19');
INSERT INTO CHANSON VALUES(5040,'Workin'' For MCA',2,NULL,'f','2008-03-12 09:44:00');
INSERT INTO CHANSON VALUES(5041,'Simple Man',2,NULL,NULL,'2008-03-12 16:05:42');
INSERT INTO CHANSON VALUES(5042,'Swamp Music',2,NULL,'f','2008-03-12 14:08:12');
INSERT INTO CHANSON VALUES(5043,'The Ballad Of Curtis Loew',2,NULL,'f','2008-04-24 15:24:41');
INSERT INTO CHANSON VALUES(5044,'Saturday Night Special',2,NULL,'f','2008-03-12 11:34:56');
INSERT INTO CHANSON VALUES(5045,'Mr. Banker',2,NULL,'f','2008-03-12 14:33:18');
INSERT INTO CHANSON VALUES(5046,'Comin'' Home (Previously Unreleased Version)',2,NULL,'f','2008-03-12 09:38:36');
INSERT INTO CHANSON VALUES(5047,'Call Me The Breeze',2,NULL,'f','2008-03-12 13:17:25');
INSERT INTO CHANSON VALUES(5048,'Free Bird',2,NULL,'f','2008-03-12 15:00:17');
INSERT INTO CHANSON VALUES(5049,'What''s Your Name',2,NULL,'f','2008-03-12 17:44:53');
INSERT INTO CHANSON VALUES(5050,'Whiskey Rock-A-Roller (Live)',2,NULL,'f','2008-03-12 11:40:37');
INSERT INTO CHANSON VALUES(5051,'Tuesday''s Gone',2,NULL,'f','2008-03-12 16:49:22');
INSERT INTO CHANSON VALUES(5052,'Double Trouble',2,NULL,'f','2008-03-29 17:34:28');
INSERT INTO CHANSON VALUES(5053,'I Know A Little',2,NULL,'f','2008-04-09 17:45:21');
INSERT INTO CHANSON VALUES(5054,'Four Walls Of Raiford',2,NULL,'f','2008-03-12 13:08:36');
INSERT INTO CHANSON VALUES(5055,'I Never Dreamed',2,NULL,'f','2008-03-12 16:28:10');
INSERT INTO CHANSON VALUES(5056,'Gimme Back My Bullets (Live)',2,NULL,'f','2008-03-12 15:03:44');
INSERT INTO CHANSON VALUES(5057,'You Got That Right',2,NULL,'f','2008-03-12 19:12:22');
INSERT INTO CHANSON VALUES(5058,'All I Can Do Is Write About It (Acoustic Version)',2,NULL,'f','2008-03-12 14:38:40');
INSERT INTO CHANSON VALUES(5059,'That Smell',2,NULL,'f','2008-03-12 19:18:40');
INSERT INTO CHANSON VALUES(5060,'Free Bird (Live)',2,NULL,'f','2008-03-12 10:07:24');
INSERT INTO CHANSON VALUES(5061,'God Save The Queen (Symphony)',2,NULL,NULL,'2008-03-12 09:26:04');
INSERT INTO CHANSON VALUES(5062,'Johnny B. Goode - Road Runner',2,NULL,'f','2008-03-23 17:10:54');
INSERT INTO CHANSON VALUES(5063,'Black Arab Medley',2,NULL,'f','2008-03-12 09:56:28');
INSERT INTO CHANSON VALUES(5066,'Don''t Gimme No Lip Child',2,NULL,NULL,'2008-03-12 12:40:09');
INSERT INTO CHANSON VALUES(5067,'(I''m Not Your) Stepping Stone',2,NULL,NULL,'2008-03-12 09:35:21');
INSERT INTO CHANSON VALUES(5068,'L''Anarchie Pour Le UK',2,NULL,'f','2008-03-12 14:07:00');
INSERT INTO CHANSON VALUES(5069,'Belsen Was A Gas',2,NULL,NULL,'2008-03-12 10:04:19');
INSERT INTO CHANSON VALUES(5070,'Belsen Vos A Gasser',2,NULL,'f','2008-03-12 18:18:26');
INSERT INTO CHANSON VALUES(5071,'Silly Thing',2,NULL,'f','2008-03-12 11:26:53');
INSERT INTO CHANSON VALUES(5073,'I Wanna Be Me',2,NULL,'f','2008-03-12 11:21:00');
INSERT INTO CHANSON VALUES(5074,'Something Else',2,NULL,'f','2008-03-12 16:57:23');
INSERT INTO CHANSON VALUES(5075,'Rock Around The Clock',2,NULL,'f','2008-03-12 12:10:27');
INSERT INTO CHANSON VALUES(5076,'Lonely Boy',2,NULL,'f','2008-03-12 13:35:07');
INSERT INTO CHANSON VALUES(5077,'No One is Innocent',2,NULL,'f','2008-03-12 15:43:43');
INSERT INTO CHANSON VALUES(5078,'C''Mon Everybody',2,NULL,'f','2008-03-12 19:14:50');
INSERT INTO CHANSON VALUES(5079,'EMI (ORCH)',2,NULL,'f','2008-03-12 08:25:55');
INSERT INTO CHANSON VALUES(5080,'The Great Rock N Roll Swindle',2,NULL,'f','2008-03-12 11:16:14');
INSERT INTO CHANSON VALUES(5081,'Friggin In The Riggin',2,NULL,'f','2008-03-12 17:32:41');
INSERT INTO CHANSON VALUES(5082,'You Need Hands',2,NULL,'f','2008-03-12 15:53:54');
INSERT INTO CHANSON VALUES(5083,'Who Killed Bambi',2,NULL,'f','2008-03-12 16:08:15');
INSERT INTO CHANSON VALUES(5084,'Europe Endless',6,NULL,'f','2008-03-12 16:52:12');
INSERT INTO CHANSON VALUES(5085,'Hall Of Mirrors',6,NULL,'f','2008-03-12 09:14:23');
INSERT INTO CHANSON VALUES(5086,'Showroom Dummies',6,NULL,'f','2008-03-12 15:42:58');
INSERT INTO CHANSON VALUES(5087,'Trans-Europe Express',6,NULL,'f','2008-03-12 16:20:42');
INSERT INTO CHANSON VALUES(5088,'Metal On Metal',6,NULL,'f','2008-03-12 13:19:56');
INSERT INTO CHANSON VALUES(5089,'Franz Schubert',6,NULL,'f','2008-03-12 11:20:21');
INSERT INTO CHANSON VALUES(5090,'Endless Endless',6,NULL,'f','2008-03-12 10:39:38');
INSERT INTO CHANSON VALUES(5091,'Embryonic Journey',2,NULL,'f','2008-03-12 13:26:10');
INSERT INTO CHANSON VALUES(5092,'High Flying Bird',2,NULL,'f','2008-03-12 09:06:03');
INSERT INTO CHANSON VALUES(5093,'It''s no Secret',2,NULL,'f','2008-04-18 10:45:43');
INSERT INTO CHANSON VALUES(5094,'Come up The Years',2,NULL,'f','2008-03-12 08:50:12');
INSERT INTO CHANSON VALUES(5095,'Somebody to Love',2,NULL,NULL,'2008-04-18 19:38:39');
INSERT INTO CHANSON VALUES(5096,'Blues From an Airplane',2,NULL,'f','2008-04-18 08:14:09');
INSERT INTO CHANSON VALUES(5097,'White Rabbit',2,NULL,'f','2008-04-18 13:46:39');
INSERT INTO CHANSON VALUES(5098,'Plastic Fantastic Lover',2,NULL,'f','2008-04-18 19:17:27');
INSERT INTO CHANSON VALUES(5099,'Aerie (Gang of Eagles)',2,NULL,'f','2008-04-18 11:34:05');
INSERT INTO CHANSON VALUES(5100,'The Ballad of You And me And Pooneil',2,NULL,NULL,'2008-04-18 10:42:14');
INSERT INTO CHANSON VALUES(5101,'Crown of Creation',2,NULL,NULL,'2008-04-18 16:24:19');
INSERT INTO CHANSON VALUES(5102,'Lather',2,NULL,'f','2008-04-18 11:08:15');
INSERT INTO CHANSON VALUES(5103,'The Last Wall of The Castle',2,NULL,'f','2008-04-18 19:45:23');
INSERT INTO CHANSON VALUES(5104,'Greasy Heart',2,NULL,'f','2008-04-18 12:47:37');
INSERT INTO CHANSON VALUES(5106,'When The Earth Moves Again',2,NULL,'f','2008-04-18 12:14:23');
INSERT INTO CHANSON VALUES(5107,'Triad',2,NULL,'f','2008-04-18 08:09:41');
INSERT INTO CHANSON VALUES(5108,'We Can be Together',2,NULL,NULL,'2008-04-18 14:10:55');
INSERT INTO CHANSON VALUES(5110,'Milk Train (Live)',2,NULL,'f','2008-03-12 19:17:02');
INSERT INTO CHANSON VALUES(5111,'Have You Seen The Saucers (Live)',2,NULL,'f','2008-04-18 17:17:04');
INSERT INTO CHANSON VALUES(5112,'Sting : Roxanne',2,NULL,'f','2008-03-12 18:00:23');
INSERT INTO CHANSON VALUES(5113,'Sting : Message in a bottle',2,NULL,'f','2008-03-12 15:27:43');
INSERT INTO CHANSON VALUES(5114,'Jeff Beck & Eric Clapton : ''Cause We''ve Ended As Lovers',2,NULL,'f','2008-03-12 14:45:03');
INSERT INTO CHANSON VALUES(5115,'Jeff Beck & Eric Clapton : Farther Up On The Road',2,NULL,'f','2008-03-12 18:58:43');
INSERT INTO CHANSON VALUES(5116,'Jeff Beck & Eric Clapton : Crossroads',2,NULL,'f','2008-03-12 14:26:09');
INSERT INTO CHANSON VALUES(5117,'Bob geldof  : I Don''t Like Mondays',2,NULL,'f','2008-03-12 16:36:16');
INSERT INTO CHANSON VALUES(5118,'Phil Collins : In The Air Tonight',2,NULL,'f','2008-03-12 17:39:06');
INSERT INTO CHANSON VALUES(5119,'Phil Collins : The Roof Is Leaking',2,NULL,'f','2008-03-12 19:57:40');
INSERT INTO CHANSON VALUES(5120,'Donovan : The Universal Soldier',2,NULL,NULL,'2008-03-12 08:29:22');
INSERT INTO CHANSON VALUES(5121,'Donovan : Catch The Wind',2,NULL,'f','2008-03-12 12:24:40');
INSERT INTO CHANSON VALUES(5122,'The Secret Police : I Shall Be Released',2,NULL,'f','2008-03-12 13:18:41');
INSERT INTO CHANSON VALUES(5123,'Get It On',2,NULL,'f','2008-03-12 18:54:09');
INSERT INTO CHANSON VALUES(5126,'Woodland Bop',2,NULL,'f','2008-03-12 12:55:20');
INSERT INTO CHANSON VALUES(5127,'By The Light Of A Magical Moon',2,NULL,'f','2008-03-12 14:38:56');
INSERT INTO CHANSON VALUES(5128,'Beltane Walk',2,NULL,'f','2008-03-12 17:26:35');
INSERT INTO CHANSON VALUES(5130,'Rip Off',2,NULL,'f','2008-03-12 18:25:33');
INSERT INTO CHANSON VALUES(5131,'King Of The Rumbling Spires',2,NULL,'f','2008-03-12 14:30:02');
INSERT INTO CHANSON VALUES(5134,'Child Star',2,NULL,'f','2008-03-12 11:12:39');
INSERT INTO CHANSON VALUES(5135,'Planet Queen',2,NULL,'f','2008-03-12 13:46:07');
INSERT INTO CHANSON VALUES(5136,'Diamond Meadows',2,NULL,'f','2008-03-12 12:23:29');
INSERT INTO CHANSON VALUES(5137,'Cosmic Dancer',2,NULL,'f','2008-03-12 11:43:25');
INSERT INTO CHANSON VALUES(5138,'Cat Black (The Wizard''s Hat)',2,NULL,'f','2008-03-12 15:13:04');
INSERT INTO CHANSON VALUES(5139,'Like A White Star, Tangled And Far, That''s What You Are',2,NULL,NULL,'2008-03-12 14:59:30');
INSERT INTO CHANSON VALUES(5140,'Life''s A Gas',2,NULL,NULL,'2008-03-12 09:52:56');
INSERT INTO CHANSON VALUES(5141,'Mrs. Robinson',2,NULL,'f','2008-03-12 16:25:26');
INSERT INTO CHANSON VALUES(5142,'Homeward Bound',2,NULL,'f','2008-03-12 16:22:21');
INSERT INTO CHANSON VALUES(5143,'America',2,NULL,'f','2008-03-12 10:58:43');
INSERT INTO CHANSON VALUES(5144,'Me And Julio Down By The Schoolyard',2,NULL,'f','2008-03-12 19:16:55');
INSERT INTO CHANSON VALUES(5145,'Scarborough Fair',2,NULL,'f','2008-03-12 15:43:41');
INSERT INTO CHANSON VALUES(5146,'April Come She Will',2,NULL,'f','2008-03-12 16:05:05');
INSERT INTO CHANSON VALUES(5147,'Wake Up Little Susie',2,NULL,'f','2008-03-12 10:20:48');
INSERT INTO CHANSON VALUES(5148,'Still Crazy After All These Years',2,NULL,NULL,'2008-04-24 14:31:17');
INSERT INTO CHANSON VALUES(5149,'American Tune',2,NULL,'f','2008-03-12 15:56:02');
INSERT INTO CHANSON VALUES(5150,'Late In The Evening',2,NULL,'f','2008-03-12 16:28:02');
INSERT INTO CHANSON VALUES(5151,'Slip Slidin'' Away',2,NULL,'f','2008-03-12 10:35:55');
INSERT INTO CHANSON VALUES(5152,'A Heart In New York',2,NULL,'f','2008-03-12 09:16:20');
INSERT INTO CHANSON VALUES(5153,'Kodachrome/Mabellene',2,NULL,'f','2008-03-12 14:00:43');
INSERT INTO CHANSON VALUES(5154,'Bridge Over Troubled Water',2,NULL,'f','2008-03-12 19:10:41');
INSERT INTO CHANSON VALUES(5155,'Fifty Ways To Leave Your Lover',2,NULL,NULL,'2008-03-12 15:05:58');
INSERT INTO CHANSON VALUES(5156,'The Boxer',2,NULL,'f','2008-03-12 15:41:42');
INSERT INTO CHANSON VALUES(5157,'Old Friends',2,NULL,'f','2008-03-12 11:23:47');
INSERT INTO CHANSON VALUES(5158,'The 59th Street Bridge Song (Feelin'' Groovy)',2,NULL,'f','2008-03-12 12:36:08');
INSERT INTO CHANSON VALUES(5159,'The Sounds Of Silence',2,NULL,'f','2008-03-12 10:13:04');
INSERT INTO CHANSON VALUES(5160,'Manque de trop',2,NULL,'f','2008-03-12 10:55:32');
INSERT INTO CHANSON VALUES(5161,'Question d''éthique',2,NULL,'f','2008-03-12 11:07:08');
INSERT INTO CHANSON VALUES(5162,'Fin de siècle',2,NULL,'f','2008-03-12 10:15:24');
INSERT INTO CHANSON VALUES(5163,'Edouard',2,NULL,'f','2008-03-17 14:50:25');
INSERT INTO CHANSON VALUES(5164,'Mrice',2,NULL,'f','2008-03-17 10:46:35');
INSERT INTO CHANSON VALUES(5165,'Révolutionnaire',2,NULL,'f','2008-03-12 19:26:41');
INSERT INTO CHANSON VALUES(5166,'Maréchal',2,NULL,'f','2008-03-12 19:01:22');
INSERT INTO CHANSON VALUES(5167,'Dieu est conservateur, le diable est libéral',2,NULL,NULL,'2008-03-12 15:18:46');
INSERT INTO CHANSON VALUES(5168,'Chaque homme',2,NULL,NULL,'2008-03-12 13:40:22');
INSERT INTO CHANSON VALUES(5169,'Drles de gens',2,NULL,'f','2008-03-12 14:51:36');
INSERT INTO CHANSON VALUES(5170,'Chair & honneur',2,NULL,NULL,'2008-03-12 15:04:32');
INSERT INTO CHANSON VALUES(5171,'Pensées',2,NULL,'f','2008-03-12 10:20:40');
INSERT INTO CHANSON VALUES(5172,'We Will Rock You',2,NULL,'f','2008-03-12 11:30:55');
INSERT INTO CHANSON VALUES(5173,'We Are the Champions',2,NULL,'f','2008-03-23 16:02:46');
INSERT INTO CHANSON VALUES(5174,'Sheer Heart Attack',2,NULL,'f','2008-03-12 09:16:33');
INSERT INTO CHANSON VALUES(5175,'All Dead, All Dead',2,NULL,'f','2008-03-27 16:13:59');
INSERT INTO CHANSON VALUES(5176,'Spread Your Wings',2,NULL,'f','2008-03-12 13:08:00');
INSERT INTO CHANSON VALUES(5177,'Fight from the Inside',2,NULL,'f','2008-03-12 17:46:19');
INSERT INTO CHANSON VALUES(5178,'Get Down, Make Love',2,NULL,'f','2008-03-12 15:12:00');
INSERT INTO CHANSON VALUES(5179,'Sleeping on the Sidewalk',2,NULL,'f','2008-03-12 19:46:51');
INSERT INTO CHANSON VALUES(5180,'Who Needs You',2,NULL,'f','2008-03-12 15:24:55');
INSERT INTO CHANSON VALUES(5181,'It''s Late',2,NULL,'f','2008-03-12 09:35:16');
INSERT INTO CHANSON VALUES(5182,'My Melancholy Blues',2,NULL,'f','2008-03-12 17:54:46');
INSERT INTO CHANSON VALUES(5183,'Cool Frenesie',2,NULL,'f','2008-03-12 16:38:48');
INSERT INTO CHANSON VALUES(5184,'Femme de Moyen Age',2,NULL,'f','2008-03-12 14:47:05');
INSERT INTO CHANSON VALUES(5185,'Toi & Moi & Elle',2,NULL,'f','2008-03-12 08:32:18');
INSERT INTO CHANSON VALUES(5186,'La Sorciere et l''Inquisiteur',2,NULL,'f','2008-03-12 08:59:27');
INSERT INTO CHANSON VALUES(5187,'Dis-moi des Mots',2,NULL,'f','2008-03-12 08:48:13');
INSERT INTO CHANSON VALUES(5188,'Allo !',2,NULL,'f','2008-03-12 12:25:26');
INSERT INTO CHANSON VALUES(5189,'Gripshitrider in Paris',2,NULL,'f','2008-03-12 12:24:12');
INSERT INTO CHANSON VALUES(5190,'C''etait un Homme',2,NULL,'f','2008-03-12 11:01:37');
INSERT INTO CHANSON VALUES(5191,'Les Guerriers',2,NULL,'f','2008-03-12 10:09:12');
INSERT INTO CHANSON VALUES(5192,'Fatigue d''Etre Fatigue',2,NULL,'f','2008-03-12 13:58:07');
INSERT INTO CHANSON VALUES(5193,'Pense à ta Carriere',2,NULL,'f','2008-03-12 10:43:45');
INSERT INTO CHANSON VALUES(5194,'Un Zero',2,NULL,'f','2008-03-12 08:14:33');
INSERT INTO CHANSON VALUES(5195,'Alors c''est Quoi',2,NULL,NULL,'2008-03-12 09:18:05');
INSERT INTO CHANSON VALUES(5196,'Jam',2,NULL,'f','2008-03-12 13:21:04');
INSERT INTO CHANSON VALUES(5197,'Intro',2,NULL,NULL,'2008-03-12 18:26:53');
INSERT INTO CHANSON VALUES(5198,'Le challenger',2,NULL,'f','2008-03-12 09:49:18');
INSERT INTO CHANSON VALUES(5199,'Un scratch, un beat, un rap',2,NULL,'f','2008-03-12 14:13:43');
INSERT INTO CHANSON VALUES(5200,'J''pète les plombs',2,NULL,'f','2008-03-12 17:28:44');
INSERT INTO CHANSON VALUES(5201,'C''est ça la France',2,NULL,NULL,'2008-03-12 12:40:54');
INSERT INTO CHANSON VALUES(5202,'Dieu seul sait quand le glas sonne',2,NULL,NULL,'2008-03-12 15:07:52');
INSERT INTO CHANSON VALUES(5203,'J''irai cracher sur vos tombes',2,NULL,'f','2008-03-12 16:21:35');
INSERT INTO CHANSON VALUES(5204,'Ghetto Sitcom',2,NULL,'f','2008-03-12 14:23:49');
INSERT INTO CHANSON VALUES(5205,'Fuck Disiz',2,NULL,'f','2008-03-12 08:31:08');
INSERT INTO CHANSON VALUES(5206,'Klash pas quand même fat. Bricefa',2,NULL,'f','2008-03-12 09:57:29');
INSERT INTO CHANSON VALUES(5207,'Plus l''temps',2,NULL,'f','2008-03-12 10:51:55');
INSERT INTO CHANSON VALUES(5208,'L''Associé du Diable',2,NULL,'f','2008-03-12 09:59:45');
INSERT INTO CHANSON VALUES(5209,'L''Avocat des Anges',2,NULL,'f','2008-03-12 12:33:59');
INSERT INTO CHANSON VALUES(5210,'Lyrics de gamins',2,NULL,'f','2008-03-12 09:19:28');
INSERT INTO CHANSON VALUES(5211,'Gnibi',2,NULL,'f','2008-03-12 18:43:08');
INSERT INTO CHANSON VALUES(5212,'La philosophie du Hall',2,NULL,'f','2008-03-12 17:20:15');
INSERT INTO CHANSON VALUES(5213,'Le poisson rouge',2,NULL,'f','2008-03-12 15:04:37');
INSERT INTO CHANSON VALUES(5214,'Les Rumeurs',2,NULL,'f','2008-03-12 10:34:00');
INSERT INTO CHANSON VALUES(5215,'Le 6ème sens',2,NULL,'f','2008-03-12 08:38:32');
INSERT INTO CHANSON VALUES(5216,'Outro',2,NULL,'f','2008-03-12 10:46:29');
INSERT INTO CHANSON VALUES(5217,'Intro',3,NULL,'f','2008-03-12 16:59:21');
INSERT INTO CHANSON VALUES(5218,'La tribu de Dana',3,NULL,'f','2008-03-12 15:06:20');
INSERT INTO CHANSON VALUES(5219,'L''avenir est un  long passé',3,NULL,'f','2008-03-20 12:30:54');
INSERT INTO CHANSON VALUES(5220,'Panique celtique',3,NULL,NULL,'2008-03-12 12:38:14');
INSERT INTO CHANSON VALUES(5221,'Le chant des druides',3,NULL,'f','2008-03-12 18:31:57');
INSERT INTO CHANSON VALUES(5222,'Faut pas tiser en Bretagne',3,NULL,'f','2008-03-12 08:17:18');
INSERT INTO CHANSON VALUES(5223,'Le chien du forgeron',3,NULL,'f','2008-03-12 11:56:23');
INSERT INTO CHANSON VALUES(5224,'La confession',3,NULL,'f','2008-03-12 18:11:58');
INSERT INTO CHANSON VALUES(5225,'Un mauvais Dieu',3,NULL,'f','2008-03-12 18:16:36');
INSERT INTO CHANSON VALUES(5226,'Mais qui est la belette',3,NULL,'f','2008-03-12 13:29:23');
INSERT INTO CHANSON VALUES(5227,'Je parle',3,NULL,'f','2008-03-12 19:11:23');
INSERT INTO CHANSON VALUES(5229,'A part ça',2,NULL,'f','2008-03-12 15:15:59');
INSERT INTO CHANSON VALUES(5230,'Faut qu''j''rode',2,NULL,'f','2008-03-12 14:39:38');
INSERT INTO CHANSON VALUES(5231,'Tous les goûts sont dans ma nature',2,NULL,'f','2008-03-12 17:31:09');
INSERT INTO CHANSON VALUES(5232,'Entrez m''sieur dans l''humanité',2,NULL,'f','2008-03-12 17:32:27');
INSERT INTO CHANSON VALUES(5233,'La pianiste dans une boîte à Gand',2,NULL,NULL,'2008-03-12 08:49:24');
INSERT INTO CHANSON VALUES(5234,'Elle m''a rien dit m''a tout dit',2,NULL,NULL,'2008-03-12 13:43:35');
INSERT INTO CHANSON VALUES(5235,'Brèves rencontres',2,NULL,'f','2008-03-12 13:38:52');
INSERT INTO CHANSON VALUES(5236,'Laisse lucie faire',2,NULL,'f','2008-03-12 08:05:21');
INSERT INTO CHANSON VALUES(5237,'Rappelez-moi de vous oublier',2,NULL,'f','2008-03-12 13:02:33');
INSERT INTO CHANSON VALUES(5238,'Thomas (instrumantal)',2,NULL,'f','2008-03-12 17:20:24');
INSERT INTO CHANSON VALUES(5240,'Water Of Love',2,NULL,'f','2008-03-12 11:33:18');
INSERT INTO CHANSON VALUES(5241,'Setting Me Up',2,NULL,NULL,'2008-03-12 19:20:50');
INSERT INTO CHANSON VALUES(5242,'Six Blade Knife',2,NULL,'f','2008-03-12 09:06:23');
INSERT INTO CHANSON VALUES(5243,'Southbound Again',2,NULL,'f','2008-03-12 14:10:12');
INSERT INTO CHANSON VALUES(5245,'In The Gallery',2,NULL,'f','2008-03-12 14:03:35');
INSERT INTO CHANSON VALUES(5246,'Wild West End',2,NULL,'f','2008-03-12 13:05:40');
INSERT INTO CHANSON VALUES(5247,'Lions',2,NULL,NULL,'2008-06-07 19:25:54.045665');
INSERT INTO CHANSON VALUES(5248,'Sur le timbre du temps',5,NULL,'f','2008-03-12 12:19:03');
INSERT INTO CHANSON VALUES(5249,'La serpette et le sot',5,NULL,'f','2008-03-12 17:37:03');
INSERT INTO CHANSON VALUES(5250,'Les Italiennes',5,NULL,'f','2008-03-12 12:54:36');
INSERT INTO CHANSON VALUES(5251,'Les souffrances du jeune Günther',5,NULL,'f','2008-03-12 16:51:57');
INSERT INTO CHANSON VALUES(5252,'Katrina',5,NULL,'f','2008-03-12 14:56:03');
INSERT INTO CHANSON VALUES(5253,'Au bord d''elle',5,NULL,'f','2008-03-12 19:30:13');
INSERT INTO CHANSON VALUES(5254,'Réveillez les morts',5,NULL,'f','2008-03-12 10:27:50');
INSERT INTO CHANSON VALUES(5255,'Les transports de l''amour en commun',5,NULL,'f','2008-03-12 09:00:53');
INSERT INTO CHANSON VALUES(5256,'Grand reporter',5,NULL,'f','2008-03-12 16:26:59');
INSERT INTO CHANSON VALUES(5257,'Frites, mensonges et mobil-home',5,NULL,'f','2008-03-12 12:13:30');
INSERT INTO CHANSON VALUES(5258,'Olida in the sun',2,NULL,'f','2008-03-12 09:34:50');
INSERT INTO CHANSON VALUES(5259,'Lucille',2,NULL,'f','2008-03-12 09:20:27');
INSERT INTO CHANSON VALUES(5260,'Il aime l''ail',2,NULL,'f','2008-03-12 10:45:22');
INSERT INTO CHANSON VALUES(5261,'Boby''s',2,NULL,'f','2008-03-12 17:28:13');
INSERT INTO CHANSON VALUES(5262,'Avarice in U.K',2,NULL,'f','2008-03-12 17:02:10');
INSERT INTO CHANSON VALUES(5263,'Zobmission',2,NULL,'f','2008-03-12 17:00:40');
INSERT INTO CHANSON VALUES(5264,'Pretty volcan',2,NULL,'f','2008-03-12 08:10:07');
INSERT INTO CHANSON VALUES(5265,'Belle-sœur was a garce',2,NULL,'f','2008-04-13 09:36:44');
INSERT INTO CHANSON VALUES(5266,'Trop blême',2,NULL,'f','2008-03-12 18:16:08');
INSERT INTO CHANSON VALUES(5267,'God save the gouines',2,NULL,'f','2008-03-12 17:58:35');
INSERT INTO CHANSON VALUES(5268,'Maille ouais',2,NULL,'f','2008-03-12 16:20:49');
INSERT INTO CHANSON VALUES(5269,'La grande pogotterie',2,NULL,NULL,'2008-03-12 11:25:24');
INSERT INTO CHANSON VALUES(5270,'Part a: Saor / Free / Part b: News From Nowhere',3,NULL,NULL,'2008-03-12 09:34:44');
INSERT INTO CHANSON VALUES(5271,'Whirl-Y-Reel 1 (Beard and Sandals Mix)',3,NULL,'f','2008-03-12 14:46:29');
INSERT INTO CHANSON VALUES(5272,'Inion / Daughter',3,NULL,NULL,'2008-03-12 19:34:58');
INSERT INTO CHANSON VALUES(5273,'Part a: Sure-As-Not / Part b: Sure-As-Knot (Jungle Segue)',3,NULL,'f','2008-03-12 09:19:01');
INSERT INTO CHANSON VALUES(5274,'Nil Cead Againn Dul Abhaile / We Cannot Go Home',3,NULL,'f','2008-03-12 11:07:01');
INSERT INTO CHANSON VALUES(5275,'Dark Moon, High Tide (including Farewell to Eireann)',3,NULL,'f','2008-03-12 19:09:11');
INSERT INTO CHANSON VALUES(5276,'Whirl-Y-Reel 2 (Folk Police Mix)',3,NULL,'f','2008-03-12 09:01:28');
INSERT INTO CHANSON VALUES(5277,'House Of The Ancestors',3,NULL,'f','2008-03-12 11:46:26');
INSERT INTO CHANSON VALUES(5278,'Part a: Eistigh Liomsa Sealad / Listen To Me / Part b: Saor Reprise',3,NULL,'f','2008-03-12 18:31:47');
INSERT INTO CHANSON VALUES(5279,'Stiff Upper Lip',2,NULL,'f','2008-03-12 16:46:13');
INSERT INTO CHANSON VALUES(5280,'Meltdown',2,NULL,'f','2008-03-12 08:51:48');
INSERT INTO CHANSON VALUES(5281,'House Of Jazz',2,NULL,'f','2008-03-12 17:24:34');
INSERT INTO CHANSON VALUES(5282,'Hold Me Back',2,NULL,'f','2008-03-12 11:20:08');
INSERT INTO CHANSON VALUES(5283,'Safe In New York City',2,NULL,'f','2008-03-12 11:29:28');
INSERT INTO CHANSON VALUES(5284,'Can''t Stand Still',2,NULL,'f','2008-03-12 11:48:35');
INSERT INTO CHANSON VALUES(5285,'Can''t Stop Rock ''N'' Roll',2,NULL,'f','2008-04-14 17:19:01');
INSERT INTO CHANSON VALUES(5286,'Satellite Blues',2,NULL,'f','2008-03-12 12:48:44');
INSERT INTO CHANSON VALUES(5287,'Damned',2,NULL,NULL,'2008-03-12 14:56:45');
INSERT INTO CHANSON VALUES(5288,'Come And Get It',2,NULL,'f','2008-03-12 08:12:32');
INSERT INTO CHANSON VALUES(5289,'All Screwed Up',2,NULL,'f','2008-03-12 13:03:03');
INSERT INTO CHANSON VALUES(5290,'Give It Up',2,NULL,'f','2008-03-12 11:44:50');
INSERT INTO CHANSON VALUES(5291,'Le retour de gogol et la horde',2,NULL,'f','2008-03-12 13:48:42');
INSERT INTO CHANSON VALUES(5292,'Voilà des paroles faciles à comprendre',2,NULL,'f','2008-03-12 11:37:07');
INSERT INTO CHANSON VALUES(5293,'Je pisse',2,NULL,'f','2008-03-12 18:56:27');
INSERT INTO CHANSON VALUES(5294,'Je bois et je suis le roi',2,NULL,'f','2008-03-12 08:13:57');
INSERT INTO CHANSON VALUES(5295,'J''encule',2,NULL,'f','2008-03-12 13:32:45');
INSERT INTO CHANSON VALUES(5296,'Moi',2,NULL,'f','2008-03-12 08:53:34');
INSERT INTO CHANSON VALUES(5297,'Dernière prière du soir',2,NULL,'f','2008-03-12 17:25:30');
INSERT INTO CHANSON VALUES(5298,'Travail famille patrie',2,NULL,NULL,'2008-03-12 14:25:42');
INSERT INTO CHANSON VALUES(5299,'Vengeance anonyme',2,NULL,'f','2008-03-12 09:52:46');
INSERT INTO CHANSON VALUES(5300,'Mais qui va nous faire marrer',2,NULL,'f','2008-03-12 10:08:31');
INSERT INTO CHANSON VALUES(5301,'On se cache',2,NULL,'f','2008-03-12 08:37:19');
INSERT INTO CHANSON VALUES(5302,'Une minute avant la fin',2,NULL,'f','2008-03-12 16:54:57');
INSERT INTO CHANSON VALUES(5303,'Sergent pépère',2,NULL,NULL,'2008-03-12 18:45:54');
INSERT INTO CHANSON VALUES(5304,'Pas d''papier water',2,NULL,NULL,'2008-03-12 11:46:08');
INSERT INTO CHANSON VALUES(5305,'Comme tu dégueules',2,NULL,'f','2008-03-12 11:14:40');
INSERT INTO CHANSON VALUES(5306,'Look anorak',2,NULL,'f','2008-03-12 08:18:33');
INSERT INTO CHANSON VALUES(5307,'Les p''tites bites',2,NULL,'f','2008-03-12 15:06:59');
INSERT INTO CHANSON VALUES(5308,'Assaut sur mon grand-père',2,NULL,'f','2008-03-12 09:41:24');
INSERT INTO CHANSON VALUES(5309,'L''usine in the sky',2,NULL,'f','2008-03-12 17:48:17');
INSERT INTO CHANSON VALUES(5310,'Twist n''chat',2,NULL,'f','2008-03-12 15:58:25');
INSERT INTO CHANSON VALUES(5311,'Hep!',2,NULL,'f','2008-03-12 09:00:02');
INSERT INTO CHANSON VALUES(5312,'Seau d''eau sous-marine',2,NULL,'f','2008-03-12 13:44:56');
INSERT INTO CHANSON VALUES(5313,'Hard les smacs',2,NULL,'f','2008-03-12 12:35:42');
INSERT INTO CHANSON VALUES(5314,'A walibi j''t''emmène',2,NULL,'f','2008-03-12 11:55:28');
INSERT INTO CHANSON VALUES(5315,'Get claques',2,NULL,'f','2008-03-12 13:11:43');
INSERT INTO CHANSON VALUES(5316,'Hey Jules',2,NULL,'f','2008-03-12 09:13:01');
INSERT INTO CHANSON VALUES(5317,'Sale (c''est vraiment toi)',2,NULL,'f','2008-03-12 16:49:08');
INSERT INTO CHANSON VALUES(5318,'Cendrier',2,NULL,'f','2008-03-12 16:56:50');
INSERT INTO CHANSON VALUES(5319,'La pompe à merde',2,NULL,'f','2008-03-12 09:45:38');
INSERT INTO CHANSON VALUES(5320,'Claque ton voisin',2,NULL,'f','2008-03-12 12:21:37');
INSERT INTO CHANSON VALUES(5321,'Agent trop fier',2,NULL,'f','2008-03-12 17:27:37');
INSERT INTO CHANSON VALUES(5322,'Ex-rupin de choix',2,NULL,NULL,'2008-03-12 18:54:21');
INSERT INTO CHANSON VALUES(5323,'Les gros (c''est gros)',2,NULL,'f','2008-03-12 17:18:57');
INSERT INTO CHANSON VALUES(5324,'Fête d''hiver',2,NULL,'f','2008-03-12 14:37:52');
INSERT INTO CHANSON VALUES(5325,'Avale',2,NULL,'f','2008-03-12 08:05:04');
INSERT INTO CHANSON VALUES(5326,'Bondy avec toi',2,NULL,'f','2008-03-12 16:13:17');
INSERT INTO CHANSON VALUES(5327,'(Parler quand t''es) aphone',2,NULL,'f','2008-03-12 17:55:07');
INSERT INTO CHANSON VALUES(5328,'Tu vas chez l''banquier',2,NULL,'f','2008-03-12 18:37:03');
INSERT INTO CHANSON VALUES(5329,'La prostate (est toujours patraque)',2,NULL,'f','2008-03-12 16:42:49');
INSERT INTO CHANSON VALUES(5330,'Une autre tombe',2,NULL,'f','2008-03-12 12:06:10');
INSERT INTO CHANSON VALUES(5331,'Fantastique',2,NULL,NULL,'2008-03-12 19:55:37');
INSERT INTO CHANSON VALUES(5332,'Dans mon Lit',2,NULL,'f','2008-03-12 15:47:32');
INSERT INTO CHANSON VALUES(5333,'European Cowboy',2,NULL,'f','2008-03-12 19:36:51');
INSERT INTO CHANSON VALUES(5334,'Ronde et Belle',2,NULL,'f','2008-03-12 19:08:28');
INSERT INTO CHANSON VALUES(5335,'Mercy',2,NULL,'f','2008-03-12 17:08:34');
INSERT INTO CHANSON VALUES(5337,'Mon Anniversaire',2,NULL,'f','2008-03-12 10:38:43');
INSERT INTO CHANSON VALUES(5338,'Sous ton Balcon',2,NULL,NULL,'2008-03-12 11:32:20');
INSERT INTO CHANSON VALUES(5339,'Tatouages du Passe',2,NULL,NULL,'2008-03-12 12:16:03');
INSERT INTO CHANSON VALUES(5340,'High and Dry',2,NULL,'f','2008-03-12 10:39:09');
INSERT INTO CHANSON VALUES(5341,'Sitting in Car',2,NULL,'f','2008-03-12 12:39:05');
INSERT INTO CHANSON VALUES(5342,'J''ai un Probleme',2,NULL,'f','2008-03-12 19:16:52');
INSERT INTO CHANSON VALUES(5343,'Je suis un Homme',2,NULL,'f','2008-03-12 14:14:29');
INSERT INTO CHANSON VALUES(5344,'(I can''t get no) Satisfaction',2,NULL,'f','2008-03-12 12:10:37');
INSERT INTO CHANSON VALUES(5345,'Taxe ma clope',2,NULL,'f','2008-03-12 18:59:46');
INSERT INTO CHANSON VALUES(5346,'Jumpin''jack flasque',2,NULL,'f','2008-03-12 13:52:38');
INSERT INTO CHANSON VALUES(5347,'Plaintes en vrac',2,NULL,'f','2008-03-12 10:02:16');
INSERT INTO CHANSON VALUES(5348,'Syumpathy for the debile',2,NULL,NULL,'2008-03-12 19:20:49');
INSERT INTO CHANSON VALUES(5349,'Roger',2,NULL,'f','2008-03-12 11:42:06');
INSERT INTO CHANSON VALUES(5350,'Get off of St Cloud',2,NULL,'f','2008-03-12 11:53:45');
INSERT INTO CHANSON VALUES(5351,'Brown se barre',2,NULL,'f','2008-03-12 13:14:24');
INSERT INTO CHANSON VALUES(5352,'Laisse pas de nappe sous les fleurs',2,NULL,'f','2008-03-12 14:13:40');
INSERT INTO CHANSON VALUES(5353,'Your gateau mou',2,NULL,'f','2008-03-12 13:44:55');
INSERT INTO CHANSON VALUES(5354,'Pissenlit rock n''roll',2,NULL,'f','2008-03-12 19:07:06');
INSERT INTO CHANSON VALUES(5355,'Tigidon wouah',2,NULL,'f','2008-03-12 14:58:05');
INSERT INTO CHANSON VALUES(5356,'Under ma teub',2,NULL,'f','2008-03-12 11:23:57');
INSERT INTO CHANSON VALUES(5357,'Midnight branleur',2,NULL,'f','2008-03-12 19:36:59');
INSERT INTO CHANSON VALUES(5358,'L''ascenseur de 22h43',2,NULL,'f','2008-03-12 11:32:20');
INSERT INTO CHANSON VALUES(5361,'Talking',2,NULL,'f','2008-03-12 19:36:10');
INSERT INTO CHANSON VALUES(5363,'Maison Borniol',2,NULL,'f','2008-03-12 08:38:08');
INSERT INTO CHANSON VALUES(5367,'Was ist das rock''n''roll',2,NULL,'f','2008-03-12 09:26:13');
INSERT INTO CHANSON VALUES(5369,'La vierge au dodge 51',2,NULL,'f','2008-03-12 13:47:34');
INSERT INTO CHANSON VALUES(5372,'Tita dong dong song',2,NULL,'f','2008-03-12 15:17:30');
INSERT INTO CHANSON VALUES(5374,'Stone Free',2,NULL,'f','2008-03-12 10:19:43');
INSERT INTO CHANSON VALUES(5375,'Radio One Theme',2,NULL,'f','2008-03-12 13:23:51');
INSERT INTO CHANSON VALUES(5376,'Day Tripper',2,NULL,'f','2008-03-12 16:34:20');
INSERT INTO CHANSON VALUES(5377,'Killing Floor',2,NULL,'f','2008-03-12 11:41:47');
INSERT INTO CHANSON VALUES(5378,'Love or Confusion',2,NULL,NULL,'2008-03-12 14:49:29');
INSERT INTO CHANSON VALUES(5379,'Drivin'' South',2,NULL,'f','2008-03-12 11:17:16');
INSERT INTO CHANSON VALUES(5380,'Catfish Blues',2,NULL,NULL,'2008-03-12 18:48:15');
INSERT INTO CHANSON VALUES(5381,'Wait Until Tomorrow',2,NULL,'f','2008-03-12 15:15:11');
INSERT INTO CHANSON VALUES(5382,'Hear My Train A Comin''',2,NULL,'f','2008-03-12 18:52:29');
INSERT INTO CHANSON VALUES(5383,'Hound Dog',2,NULL,NULL,'2008-03-12 12:54:49');
INSERT INTO CHANSON VALUES(5384,'Fire',2,NULL,'f','2008-03-12 14:04:08');
INSERT INTO CHANSON VALUES(5385,'Hoochie Koochie Man',2,NULL,'f','2008-03-12 11:31:32');
INSERT INTO CHANSON VALUES(5386,'Purple Haze',2,NULL,'f','2008-04-07 19:10:44');
INSERT INTO CHANSON VALUES(5387,'Spanish Castle Magic',2,NULL,'f','2008-03-12 09:12:06');
INSERT INTO CHANSON VALUES(5389,'Foxy Lady',2,NULL,'f','2008-03-12 11:03:37');
INSERT INTO CHANSON VALUES(5390,'Burning Of The Midnight Lamp',2,NULL,'f','2008-03-12 17:21:55');
INSERT INTO CHANSON VALUES(5391,'Et moi et moi et moi',2,NULL,'f','2008-03-23 08:15:43');
INSERT INTO CHANSON VALUES(5392,'J''ai mis un tigre dans ma guitare',2,NULL,'f','2008-03-12 11:50:58');
INSERT INTO CHANSON VALUES(5393,'Les gens sont fous, les temps sont flous',2,NULL,'f','2008-03-12 14:45:50');
INSERT INTO CHANSON VALUES(5394,'Les play-boys',2,NULL,'f','2008-03-23 17:43:49');
INSERT INTO CHANSON VALUES(5395,'On nous cache tout, on nous dit rien',2,NULL,'f','2008-03-23 19:00:20');
INSERT INTO CHANSON VALUES(5396,'Les cactus',2,NULL,'f','2008-03-24 15:38:54');
INSERT INTO CHANSON VALUES(5397,'J''ai tout lu, tout vu, tout bu',2,NULL,'f','2008-03-12 14:10:32');
INSERT INTO CHANSON VALUES(5398,'Hippie, hippie, hourrah',2,NULL,'f','2008-03-12 15:39:03');
INSERT INTO CHANSON VALUES(5399,'L''augmentation',2,NULL,'f','2008-03-12 13:56:07');
INSERT INTO CHANSON VALUES(5400,'La leçon de gymnastique du professeur Dutronc',2,NULL,'f','2008-03-12 08:42:29');
INSERT INTO CHANSON VALUES(5401,'Amour toujours, tendresse caresse',2,NULL,'f','2008-03-12 19:45:44');
INSERT INTO CHANSON VALUES(5402,'A tout berzingue',2,NULL,'f','2008-03-12 16:04:34');
INSERT INTO CHANSON VALUES(5403,'Le roi de la fête',2,NULL,NULL,'2008-03-12 16:35:19');
INSERT INTO CHANSON VALUES(5404,'Laquelle des deux est la plus snob',2,NULL,'f','2008-03-12 14:34:29');
INSERT INTO CHANSON VALUES(5405,'Restons français, soyons gaulois',2,NULL,'f','2008-03-12 11:24:13');
INSERT INTO CHANSON VALUES(5406,'J''avais la cervelle qui faisait des vagues',2,NULL,'f','2008-03-12 09:22:14');
INSERT INTO CHANSON VALUES(5407,'Le testamour',2,NULL,'f','2008-03-12 13:53:24');
INSERT INTO CHANSON VALUES(5408,'Le bras mécanique',2,NULL,'f','2008-03-12 08:31:03');
INSERT INTO CHANSON VALUES(5409,'Staying Power',2,NULL,NULL,'2008-03-12 08:58:00');
INSERT INTO CHANSON VALUES(5410,'Dancer',2,NULL,NULL,'2008-03-12 10:02:42');
INSERT INTO CHANSON VALUES(5411,'Back Chat',2,NULL,'f','2008-03-12 16:02:28');
INSERT INTO CHANSON VALUES(5412,'Body Language',2,NULL,'f','2008-03-27 12:45:33');
INSERT INTO CHANSON VALUES(5413,'Action This Day',2,NULL,'f','2008-03-12 19:27:08');
INSERT INTO CHANSON VALUES(5414,'Put Out The Fire',2,NULL,'f','2008-03-12 11:59:43');
INSERT INTO CHANSON VALUES(5415,'Life Is Real (Song for Lennon)',2,NULL,'f','2008-03-12 17:17:08');
INSERT INTO CHANSON VALUES(5416,'Calling All Girls',2,NULL,'f','2008-03-12 08:24:30');
INSERT INTO CHANSON VALUES(5417,'Las Palabras De Amor (The Words of Love)',2,NULL,'f','2008-03-12 11:52:24');
INSERT INTO CHANSON VALUES(5418,'Cool Cat',2,NULL,'f','2008-03-12 16:53:56');
INSERT INTO CHANSON VALUES(5419,'Under Pressure',2,NULL,'f','2008-06-07 18:43:53.170062');
INSERT INTO CHANSON VALUES(5420,'Par compromission',2,NULL,'f','2008-03-12 17:09:57');
INSERT INTO CHANSON VALUES(5421,'Varsovie',2,NULL,'f','2008-03-12 13:49:00');
INSERT INTO CHANSON VALUES(5422,'Les armes aux yeux',2,NULL,'f','2008-03-12 19:14:45');
INSERT INTO CHANSON VALUES(5423,'Idéal',2,NULL,'f','2008-03-12 14:14:13');
INSERT INTO CHANSON VALUES(5424,'Le pouvoir et la gloire',2,NULL,'f','2008-03-12 15:33:13');
INSERT INTO CHANSON VALUES(5425,'Purgatoire',2,NULL,'f','2008-03-12 12:22:30');
INSERT INTO CHANSON VALUES(5426,'Le pacte',2,NULL,'f','2008-03-12 14:24:54');
INSERT INTO CHANSON VALUES(5427,'La luxure',2,NULL,'f','2008-03-12 08:41:47');
INSERT INTO CHANSON VALUES(5428,'Jugement dernier',2,NULL,'f','2008-03-12 13:22:40');
INSERT INTO CHANSON VALUES(5429,'La Grande Illusion',2,NULL,'f','2008-03-12 12:07:37');
INSERT INTO CHANSON VALUES(5430,'Le Sauvage',2,NULL,'f','2008-03-12 11:53:47');
INSERT INTO CHANSON VALUES(5431,'Répression',2,NULL,'f','2008-03-12 11:21:37');
INSERT INTO CHANSON VALUES(5432,'La Junte',2,NULL,'f','2008-03-12 11:18:51');
INSERT INTO CHANSON VALUES(5433,'Misère',2,NULL,'f','2008-03-12 08:48:06');
INSERT INTO CHANSON VALUES(5434,'Les Brutes',2,NULL,NULL,'2008-03-12 10:27:39');
INSERT INTO CHANSON VALUES(5435,'Certitude Solitude',2,NULL,NULL,'2008-03-12 13:50:01');
INSERT INTO CHANSON VALUES(5436,'Marche ou Crève',2,NULL,'f','2008-03-12 19:21:26');
INSERT INTO CHANSON VALUES(5437,'Les Templiers',2,NULL,'f','2008-03-12 18:23:08');
INSERT INTO CHANSON VALUES(5438,'Ton Dernier Acte',2,NULL,'f','2008-03-17 15:49:31');
INSERT INTO CHANSON VALUES(5439,'One Vision (1985)',2,NULL,'f','2008-03-12 12:12:39');
INSERT INTO CHANSON VALUES(5440,'A Kind Of Magic',2,NULL,'f','2008-03-23 19:29:32');
INSERT INTO CHANSON VALUES(5441,'One Year Of Love',2,NULL,'f','2008-03-12 17:44:53');
INSERT INTO CHANSON VALUES(5442,'Pain Is So Close To Pleasure',2,NULL,'f','2008-03-12 12:00:11');
INSERT INTO CHANSON VALUES(5443,'Friends Will Be Friends',2,NULL,'f','2008-03-12 10:01:00');
INSERT INTO CHANSON VALUES(5444,'Who Wants To Live Forever',2,NULL,'f','2008-03-12 12:15:27');
INSERT INTO CHANSON VALUES(5445,'Gimme The Prize',2,NULL,NULL,'2008-03-12 08:43:18');
INSERT INTO CHANSON VALUES(5446,'Don''t Lose Your Head',2,NULL,'f','2008-03-12 08:41:39');
INSERT INTO CHANSON VALUES(5447,'Princes Of The Universe',2,NULL,'f','2008-03-12 13:33:03');
INSERT INTO CHANSON VALUES(5448,'A Kind Of A Kind Of Magic',2,NULL,'f','2008-03-12 15:13:52');
INSERT INTO CHANSON VALUES(5449,'Friends Will Be Friends Will Be Friends',2,NULL,'f','2008-03-12 09:33:04');
INSERT INTO CHANSON VALUES(5450,'Forever',2,NULL,'f','2008-03-12 17:32:34');
INSERT INTO CHANSON VALUES(5451,'Chacun sa haine',2,NULL,'f','2008-03-12 12:17:19');
INSERT INTO CHANSON VALUES(5452,'Mongolo''s land',2,NULL,'f','2008-03-12 10:40:19');
INSERT INTO CHANSON VALUES(5453,'Paris',2,NULL,'f','2008-03-12 13:54:21');
INSERT INTO CHANSON VALUES(5454,'Les notables',2,NULL,'f','2008-03-12 13:15:37');
INSERT INTO CHANSON VALUES(5455,'Avenir',2,NULL,'f','2008-03-12 18:16:20');
INSERT INTO CHANSON VALUES(5456,'Serre les poings',2,NULL,'f','2008-03-12 10:18:01');
INSERT INTO CHANSON VALUES(5457,'I shall return (Je reviendrai)',2,NULL,'f','2008-03-12 18:47:35');
INSERT INTO CHANSON VALUES(5458,'Rock ''n'' Roll star',2,NULL,'f','2008-03-12 18:25:49');
INSERT INTO CHANSON VALUES(5473,'Dog love dog',2,NULL,'f','2008-03-12 11:36:45');
INSERT INTO CHANSON VALUES(5474,'Dirty',2,NULL,'f','2008-03-12 09:03:32');
INSERT INTO CHANSON VALUES(5475,'Mais pas chez moi',2,NULL,'f','2008-03-12 09:07:12');
INSERT INTO CHANSON VALUES(5476,'Your fame',2,NULL,'f','2008-03-12 14:32:04');
INSERT INTO CHANSON VALUES(5477,'Sorcière',2,NULL,'f','2008-03-12 09:58:48');
INSERT INTO CHANSON VALUES(5478,'Are we talking enough',2,NULL,'f','2008-03-12 15:01:27');
INSERT INTO CHANSON VALUES(5479,'Drowning',2,NULL,'f','2008-03-12 13:52:53');
INSERT INTO CHANSON VALUES(5480,'Spank on me',2,NULL,'f','2008-03-12 18:07:11');
INSERT INTO CHANSON VALUES(5481,'Un hémisphère dans une chevelure',2,NULL,'f','2008-03-12 16:18:56');
INSERT INTO CHANSON VALUES(5482,'Dedicated to the press',2,NULL,'f','2008-03-12 09:42:26');
INSERT INTO CHANSON VALUES(5483,'Nightime',2,NULL,'f','2008-03-12 14:59:03');
INSERT INTO CHANSON VALUES(5484,'One two three four boys',2,NULL,'f','2008-03-12 11:05:06');
INSERT INTO CHANSON VALUES(5485,'Lay Me Down',2,NULL,'f','2008-03-12 18:15:13');
INSERT INTO CHANSON VALUES(5486,'Puppeteer',2,NULL,'f','2008-03-12 08:45:46');
INSERT INTO CHANSON VALUES(5487,'Through Here Quite Often',2,NULL,'f','2008-03-12 09:54:45');
INSERT INTO CHANSON VALUES(5488,'Grace',2,NULL,'f','2008-03-12 19:30:46');
INSERT INTO CHANSON VALUES(5489,'Jesus of Rio',2,NULL,'f','2008-03-12 12:57:38');
INSERT INTO CHANSON VALUES(5490,'I Surrender',2,NULL,'f','2008-03-12 11:51:46');
INSERT INTO CHANSON VALUES(5491,'Luck Dragon',2,NULL,'f','2008-03-12 13:31:05');
INSERT INTO CHANSON VALUES(5492,'On the Other Side of Town',2,NULL,'f','2008-03-12 12:40:47');
INSERT INTO CHANSON VALUES(5493,'Half Your Angels',2,NULL,'f','2008-03-12 18:13:47');
INSERT INTO CHANSON VALUES(5494,'They Want it All -Enron-',2,NULL,'f','2008-03-12 19:31:52');
INSERT INTO CHANSON VALUES(5495,'How Does it Shine?',2,NULL,'f','2008-03-12 08:21:08');
INSERT INTO CHANSON VALUES(5496,'Don''t Dig Here',2,NULL,'f','2008-03-12 11:24:53');
INSERT INTO CHANSON VALUES(5497,'Milky Way Tonight',2,NULL,NULL,'2008-03-12 08:31:48');
INSERT INTO CHANSON VALUES(5498,'Charlie',2,NULL,'f','2008-03-12 17:27:19');
INSERT INTO CHANSON VALUES(5499,'Penguin In A Palm Tree',2,NULL,'f','2008-03-12 14:51:16');
INSERT INTO CHANSON VALUES(5500,'Michael (Hedges Here)',2,NULL,'f','2008-03-12 10:08:08');
INSERT INTO CHANSON VALUES(5501,'Samurai',2,NULL,'f','2008-03-12 19:37:39');
INSERT INTO CHANSON VALUES(5502,'Shining On Your Dreams',2,NULL,NULL,'2008-03-12 08:02:19');
INSERT INTO CHANSON VALUES(5503,'Live On (The Wall)',2,NULL,NULL,'2008-03-12 18:54:32');
INSERT INTO CHANSON VALUES(5504,'My Country ''Tis Of Thee',2,NULL,'f','2008-03-12 15:49:04');
INSERT INTO CHANSON VALUES(5509,'That''s How Strong My Love Is',2,NULL,'f','2008-06-01 19:39:48.505342');
INSERT INTO CHANSON VALUES(5510,'The Nearness Of You',2,NULL,'f','2008-04-11 17:04:22');
INSERT INTO CHANSON VALUES(5513,'Rock Me, Baby',2,NULL,'f','2008-06-02 11:19:47.060348');
INSERT INTO CHANSON VALUES(5515,'Worried About You',2,NULL,'f','2008-06-02 09:20:31.995664');
INSERT INTO CHANSON VALUES(5530,'You''re Under Arrest',5,NULL,'f','2008-03-12 10:33:46');
INSERT INTO CHANSON VALUES(5532,'Five Easy Pisseuses',5,NULL,'f','2008-03-12 16:49:10');
INSERT INTO CHANSON VALUES(5533,'Hey Man Amen',5,NULL,'f','2008-03-12 19:57:15');
INSERT INTO CHANSON VALUES(5535,'Manon',5,NULL,'f','2008-03-12 08:24:30');
INSERT INTO CHANSON VALUES(5536,'Valse De Melody',5,NULL,'f','2008-03-12 08:29:28');
INSERT INTO CHANSON VALUES(5537,'Dispatch Box',5,NULL,'f','2008-03-12 17:03:31');
INSERT INTO CHANSON VALUES(5538,'Harley David Son Of A Bitch',5,NULL,'f','2008-03-12 09:01:13');
INSERT INTO CHANSON VALUES(5539,'You You You But Not You',5,NULL,'f','2008-03-12 16:11:38');
INSERT INTO CHANSON VALUES(5540,'Seigneur Et Saigneur',5,NULL,'f','2008-03-12 08:25:11');
INSERT INTO CHANSON VALUES(5541,'Bonnie And Clyde',5,NULL,'f','2008-03-12 17:49:42');
INSERT INTO CHANSON VALUES(5543,'Couleur Café',5,NULL,'f','2008-03-12 17:29:29');
INSERT INTO CHANSON VALUES(5544,'Aux Armes Et Caetera',5,NULL,NULL,'2008-03-12 08:08:15');
INSERT INTO CHANSON VALUES(5545,'Aux Enfants De La Chance',5,NULL,'f','2008-03-12 12:10:40');
INSERT INTO CHANSON VALUES(5547,'Mon Légionnaire',5,NULL,'f','2008-03-12 11:03:13');
INSERT INTO CHANSON VALUES(5548,'NYC Of Time',2,NULL,NULL,'2008-03-12 18:12:15');
INSERT INTO CHANSON VALUES(5549,'The Irish Keep',2,NULL,NULL,'2008-03-12 08:55:26');
INSERT INTO CHANSON VALUES(5550,'After Dark',2,NULL,NULL,'2008-03-12 16:59:52');
INSERT INTO CHANSON VALUES(5551,'I Found Out',2,NULL,NULL,'2008-03-12 18:48:42');
INSERT INTO CHANSON VALUES(5552,'No Cities Left',2,NULL,NULL,'2008-03-12 15:24:14');
INSERT INTO CHANSON VALUES(5553,'The Sure Ain''t Right',2,NULL,NULL,'2008-03-12 09:11:43');
INSERT INTO CHANSON VALUES(5554,'Goodbye',2,NULL,NULL,'2008-03-12 15:12:51');
INSERT INTO CHANSON VALUES(5555,'Mean Man',2,NULL,NULL,'2008-03-12 18:33:01');
INSERT INTO CHANSON VALUES(5556,'Sugarcoated',2,NULL,NULL,'2008-03-12 14:25:15');
INSERT INTO CHANSON VALUES(5557,'LSF (Lost Soul Forever)',2,NULL,NULL,'2008-03-12 16:45:18');
INSERT INTO CHANSON VALUES(5558,'From Cayman Islands With Love',2,NULL,NULL,'2008-03-12 19:36:31');
INSERT INTO CHANSON VALUES(5559,'7 heures du matin',2,NULL,NULL,'2008-03-12 10:40:27');
INSERT INTO CHANSON VALUES(5560,'Si Haut',2,NULL,NULL,'2008-03-12 15:23:26');
INSERT INTO CHANSON VALUES(5561,'Turning Inside Out',2,NULL,NULL,'2008-03-12 14:17:15');
INSERT INTO CHANSON VALUES(5562,'Hold Me Now',2,NULL,NULL,'2008-03-12 10:53:40');
INSERT INTO CHANSON VALUES(5563,'Love Or A Lesson',2,NULL,NULL,'2008-03-12 13:01:51');
INSERT INTO CHANSON VALUES(5564,'Pla',2,NULL,NULL,'2008-03-12 10:38:04');
INSERT INTO CHANSON VALUES(5565,'Dreaming (,,,Again)',2,NULL,NULL,'2008-03-12 08:31:37');
INSERT INTO CHANSON VALUES(5566,'Broken',2,NULL,NULL,'2008-03-12 08:04:03');
INSERT INTO CHANSON VALUES(5567,'Closer To You',2,NULL,NULL,'2008-03-12 12:47:48');
INSERT INTO CHANSON VALUES(5568,'La fille qui rêve de moi',2,NULL,'f','2008-03-12 15:44:24');
INSERT INTO CHANSON VALUES(5569,'Le prince en otage',2,NULL,'f','2008-03-12 10:56:05');
INSERT INTO CHANSON VALUES(5570,'Rosy',2,NULL,'f','2008-03-12 15:34:29');
INSERT INTO CHANSON VALUES(5571,'La vie, la vie m''a quitté',2,NULL,'f','2008-03-12 08:05:47');
INSERT INTO CHANSON VALUES(5572,'Le fille qui rêve de moi (instrumental)',2,NULL,NULL,'2008-03-12 11:19:40');
INSERT INTO CHANSON VALUES(5573,'Le grand chapiteau',2,NULL,'f','2008-03-12 19:46:42');
INSERT INTO CHANSON VALUES(5574,'Il est gros',2,NULL,'f','2008-03-12 18:58:21');
INSERT INTO CHANSON VALUES(5575,'I love you because',2,NULL,'f','2008-03-12 18:00:53');
INSERT INTO CHANSON VALUES(5576,'Polnarève (instrumental)',2,NULL,NULL,'2008-06-07 19:07:07.965742');
INSERT INTO CHANSON VALUES(5577,'Tibili',2,NULL,'f','2008-03-12 15:25:45');
INSERT INTO CHANSON VALUES(5578,'L''homme qui pleurait des larmes de verre',2,NULL,'f','2008-03-12 12:04:29');
INSERT INTO CHANSON VALUES(5579,'Dance (Pt. 1)',2,NULL,'f','2008-06-02 10:27:50.842132');
INSERT INTO CHANSON VALUES(5580,'Summer Romance',2,NULL,'f','2008-03-17 19:52:00');
INSERT INTO CHANSON VALUES(5581,'Send It To Me',2,NULL,'f','2008-03-24 12:56:06');
INSERT INTO CHANSON VALUES(5583,'Indian Girl',2,NULL,'f','2008-06-02 10:29:34.642445');
INSERT INTO CHANSON VALUES(5584,'Where The Boys Go',2,NULL,'f','2008-06-02 10:29:53.384161');
INSERT INTO CHANSON VALUES(5585,'Down In The Hole',2,NULL,'f','2008-06-02 10:30:13.940681');
INSERT INTO CHANSON VALUES(5586,'Emotional Rescue',2,NULL,'f','2008-05-26 16:53:04');
INSERT INTO CHANSON VALUES(5588,'All About You',2,NULL,'f','2008-06-02 10:31:26.27827');
INSERT INTO CHANSON VALUES(5590,'Le roi des fourmis',2,NULL,'f','2008-03-12 14:32:47');
INSERT INTO CHANSON VALUES(5591,'Rosée d''amour n''a pas vu le jour',2,NULL,'f','2008-03-12 08:21:02');
INSERT INTO CHANSON VALUES(5592,'Ta Ta Ta Ta',2,NULL,'f','2008-03-12 13:16:55');
INSERT INTO CHANSON VALUES(5593,'Mes regrets',2,NULL,'f','2008-03-12 13:41:51');
INSERT INTO CHANSON VALUES(5594,'Les grands sentiments humains',2,NULL,'f','2008-03-12 15:52:07');
INSERT INTO CHANSON VALUES(5595,'Pipelette',2,NULL,'f','2008-03-12 08:44:21');
INSERT INTO CHANSON VALUES(5597,'Y''a qu''un ch''veu',2,NULL,NULL,'2008-03-12 13:16:26');
INSERT INTO CHANSON VALUES(5598,'Le bal des Laze',2,NULL,'f','2008-03-12 15:07:58');
INSERT INTO CHANSON VALUES(5599,'Oh! Louis',2,NULL,NULL,'2008-03-12 19:55:06');
INSERT INTO CHANSON VALUES(5600,'Y''en a marre des pauvres',5,NULL,'f','2008-04-07 15:44:23');
INSERT INTO CHANSON VALUES(5601,'Petit caniche, peluche pour vieux',5,NULL,'f','2008-04-07 17:12:55');
INSERT INTO CHANSON VALUES(5602,'Rêve d''un monde',5,NULL,'f','2008-03-12 15:28:38');
INSERT INTO CHANSON VALUES(5603,'On va tous crever',5,NULL,'f','2008-04-07 18:40:46');
INSERT INTO CHANSON VALUES(5604,'Dis moi Didier',5,NULL,'f','2008-03-12 13:32:00');
INSERT INTO CHANSON VALUES(5605,'Arrête de t''la pêter',5,NULL,'f','2008-03-12 13:01:17');
INSERT INTO CHANSON VALUES(5606,'Le club des catholiques',5,NULL,'f','2008-04-07 18:24:07');
INSERT INTO CHANSON VALUES(5607,'Ben t''es con',5,NULL,'f','2008-04-07 14:23:25');
INSERT INTO CHANSON VALUES(5608,'Y''en a des biens',5,NULL,'f','2008-04-07 16:32:10');
INSERT INTO CHANSON VALUES(5609,'Majorette',5,NULL,'f','2008-04-07 19:15:21');
INSERT INTO CHANSON VALUES(5610,'He ben t''es con (demo version)',5,NULL,'f','2008-04-07 11:38:46');
INSERT INTO CHANSON VALUES(5611,'Y''en a des biens (demo version)',5,NULL,'f','2008-04-07 11:12:11');
INSERT INTO CHANSON VALUES(5612,'Arrête de t''la pêter (demo version)',5,NULL,'f','2008-03-12 12:31:58');
INSERT INTO CHANSON VALUES(5614,'Can you touch me?',2,NULL,'f','2008-03-12 12:09:36');
INSERT INTO CHANSON VALUES(5615,'Top of the hops',2,NULL,'f','2008-03-12 17:24:56');
INSERT INTO CHANSON VALUES(5616,'Johnny show time',2,NULL,'f','2008-03-12 10:50:13');
INSERT INTO CHANSON VALUES(5617,'Hey? My lovely girl',2,NULL,'f','2008-03-12 15:28:20');
INSERT INTO CHANSON VALUES(5618,'DSL Blues',2,NULL,'f','2008-03-12 15:24:15');
INSERT INTO CHANSON VALUES(5619,'Death song',2,NULL,'f','2008-03-12 16:02:44');
INSERT INTO CHANSON VALUES(5620,'Ou est le plaisir?',2,NULL,'f','2008-03-12 12:28:16');
INSERT INTO CHANSON VALUES(5621,'Big RDV',2,NULL,'f','2008-03-12 12:58:17');
INSERT INTO CHANSON VALUES(5622,'Kids?',2,NULL,NULL,'2008-03-12 15:22:48');
INSERT INTO CHANSON VALUES(5623,'Lipstick',2,NULL,'f','2008-03-12 15:38:56');
INSERT INTO CHANSON VALUES(5624,'Money',2,NULL,'f','2008-03-12 13:02:05');
INSERT INTO CHANSON VALUES(5625,'Morte',2,NULL,NULL,'2008-03-12 09:47:30');
INSERT INTO CHANSON VALUES(5626,'Cher tueur',2,NULL,'f','2008-03-12 08:59:21');
INSERT INTO CHANSON VALUES(5627,'Comme je suis',2,NULL,'f','2008-03-12 11:37:50');
INSERT INTO CHANSON VALUES(5628,'L''alchifulmiste',2,NULL,'f','2008-03-12 15:13:14');
INSERT INTO CHANSON VALUES(5629,'Seules a Paris',2,NULL,'f','2008-03-12 18:56:16');
INSERT INTO CHANSON VALUES(5630,'Corine',2,NULL,'f','2008-03-12 15:18:45');
INSERT INTO CHANSON VALUES(5631,'I wanna be your doll',2,NULL,NULL,'2008-03-12 18:40:43');
INSERT INTO CHANSON VALUES(5632,'Plastic hooker',2,NULL,NULL,'2008-03-12 09:19:06');
INSERT INTO CHANSON VALUES(5633,'Froide',2,NULL,'f','2008-03-12 19:57:45');
INSERT INTO CHANSON VALUES(5634,'Naufragés de l''ombre',2,NULL,'f','2008-03-12 18:26:47');
INSERT INTO CHANSON VALUES(5635,'Cloue moi au ciel',2,NULL,'f','2008-03-12 19:31:34');
INSERT INTO CHANSON VALUES(5636,'Tell me',2,NULL,'f','2008-03-12 14:33:33');
INSERT INTO CHANSON VALUES(5637,'Bad Boyfriend',2,NULL,'f','2008-03-12 18:49:10');
INSERT INTO CHANSON VALUES(5638,'Run Baby Run',2,NULL,'f','2008-03-16 16:24:24');
INSERT INTO CHANSON VALUES(5639,'Right Between The Eyes',2,NULL,'f','2008-03-23 10:51:39');
INSERT INTO CHANSON VALUES(5640,'Why Do You Love Me (album version)',2,NULL,'f','2008-03-12 19:42:19');
INSERT INTO CHANSON VALUES(5641,'Bleed Like Me',2,NULL,'f','2008-03-12 16:52:39');
INSERT INTO CHANSON VALUES(5642,'Metal Heart',2,NULL,'f','2008-03-12 17:50:36');
INSERT INTO CHANSON VALUES(5643,'Sex Is Not The Enemy',2,NULL,'f','2008-03-12 14:44:02');
INSERT INTO CHANSON VALUES(5644,'It''s All Over But The Crying',2,NULL,'f','2008-03-12 12:43:34');
INSERT INTO CHANSON VALUES(5645,'Boys Wanna Fight',2,NULL,'f','2008-03-12 19:14:08');
INSERT INTO CHANSON VALUES(5646,'Why Don''t You Come Over',2,NULL,'f','2008-03-12 13:06:57');
INSERT INTO CHANSON VALUES(5647,'Happy Home',2,NULL,'f','2008-03-12 16:48:21');
INSERT INTO CHANSON VALUES(5648,'Pocket Change',2,NULL,'f','2008-03-12 09:44:37');
INSERT INTO CHANSON VALUES(5649,'Tennessee Tears',2,NULL,'f','2008-03-12 13:57:28');
INSERT INTO CHANSON VALUES(5650,'Tolling',2,NULL,NULL,'2008-03-12 09:56:11');
INSERT INTO CHANSON VALUES(5652,'Sublime Guérison',2,NULL,'f','2008-03-12 09:29:54');
INSERT INTO CHANSON VALUES(5653,'L''étrangère',2,NULL,'f','2008-03-12 16:03:38');
INSERT INTO CHANSON VALUES(5654,'Dress Tails',2,NULL,'f','2008-03-12 16:25:21');
INSERT INTO CHANSON VALUES(5655,'Great White Ghost',2,NULL,'f','2008-03-12 11:21:36');
INSERT INTO CHANSON VALUES(5656,'Pagan Paradise',2,NULL,'f','2008-03-12 13:50:42');
INSERT INTO CHANSON VALUES(5657,'Lying Still',2,NULL,'f','2008-03-12 12:30:30');
INSERT INTO CHANSON VALUES(5658,'Believe',2,NULL,'f','2008-03-12 17:36:14');
INSERT INTO CHANSON VALUES(5659,'Little Girls',2,NULL,'f','2008-03-12 12:02:12');
INSERT INTO CHANSON VALUES(5660,'Rough Justice',2,NULL,'f','2008-04-11 16:20:36');
INSERT INTO CHANSON VALUES(5661,'Let Me Down Slow',2,NULL,'f','2008-06-02 10:56:19.242461');
INSERT INTO CHANSON VALUES(5662,'It Won''t Take Long',2,NULL,'f','2008-06-02 11:09:23.463606');
INSERT INTO CHANSON VALUES(5663,'Rain Fall Down',2,NULL,'f','2008-06-02 11:14:23.991009');
INSERT INTO CHANSON VALUES(5664,'Streets Of Love',2,NULL,'f','2008-04-18 18:30:54');
INSERT INTO CHANSON VALUES(5665,'Back Of My Hand',2,NULL,NULL,'2008-06-02 11:02:34.233394');
INSERT INTO CHANSON VALUES(5666,'She Saw Me Coming',2,NULL,NULL,'2008-06-02 11:13:28.201676');
INSERT INTO CHANSON VALUES(5667,'Biggest Mistake',2,NULL,'f','2008-06-02 10:58:28.892367');
INSERT INTO CHANSON VALUES(5668,'This Place Is Empty',2,NULL,NULL,'2008-06-02 11:23:50.553769');
INSERT INTO CHANSON VALUES(5669,'Oh No Not You Again',2,NULL,'f','2008-06-02 10:55:56.797531');
INSERT INTO CHANSON VALUES(5670,'Dangerous Beauty',2,NULL,'f','2008-05-26 18:13:55');
INSERT INTO CHANSON VALUES(5671,'Laugh, I Nearly Died',2,NULL,'f','2008-06-02 11:12:01.70068');
INSERT INTO CHANSON VALUES(5672,'Sweet Neo-Con',2,NULL,'f','2008-05-23 15:28:54');
INSERT INTO CHANSON VALUES(5673,'Look What The Cat Dragged In',2,NULL,'f','2008-06-02 11:15:46.13343');
INSERT INTO CHANSON VALUES(5674,'Driving Too Fast',2,NULL,'f','2008-06-02 10:58:11.485116');
INSERT INTO CHANSON VALUES(5675,'Infamy',2,NULL,'f','2008-06-02 10:57:28.430204');
INSERT INTO CHANSON VALUES(5677,'Ideal Standard',2,NULL,'f','2008-03-12 15:36:58');
INSERT INTO CHANSON VALUES(5678,'Parle-moi',2,NULL,NULL,'2008-03-12 19:17:05');
INSERT INTO CHANSON VALUES(5679,'Ailleurs',2,NULL,'f','2008-03-12 17:20:31');
INSERT INTO CHANSON VALUES(5680,'Glissons',2,NULL,'f','2008-03-12 18:59:24');
INSERT INTO CHANSON VALUES(5681,'Point final',2,NULL,'f','2008-03-12 18:21:42');
INSERT INTO CHANSON VALUES(5682,'On vit d''amour',2,NULL,'f','2008-03-12 12:13:45');
INSERT INTO CHANSON VALUES(5683,'L''heure bleue',2,NULL,'f','2008-03-12 13:20:13');
INSERT INTO CHANSON VALUES(5684,'Tu comptes',2,NULL,'f','2008-03-12 15:40:34');
INSERT INTO CHANSON VALUES(5685,'On aime',2,NULL,'f','2008-03-12 19:09:59');
INSERT INTO CHANSON VALUES(5686,'Le meilleur de toi-même',2,NULL,'f','2008-03-12 18:26:33');
INSERT INTO CHANSON VALUES(5687,'Je pars',2,NULL,'f','2008-03-12 13:02:10');
INSERT INTO CHANSON VALUES(5688,'A ceux qui passent',2,NULL,'f','2008-03-12 13:00:28');
INSERT INTO CHANSON VALUES(5689,'Sensation (de Rimbaud)',2,NULL,'f','2008-03-12 14:45:48');
INSERT INTO CHANSON VALUES(5692,'Joupolle Joutunut',3,NULL,'f','2008-03-12 10:54:23');
INSERT INTO CHANSON VALUES(5693,'Kruspolska',3,NULL,'f','2008-03-12 19:23:43');
INSERT INTO CHANSON VALUES(5694,'Vottikaalina',3,NULL,'f','2008-03-12 09:00:24');
INSERT INTO CHANSON VALUES(5695,'Viktorin',3,NULL,'f','2008-03-12 16:57:33');
INSERT INTO CHANSON VALUES(5696,'Aivoton',3,NULL,'f','2008-03-12 16:48:59');
INSERT INTO CHANSON VALUES(5697,'Ful-Valsen',3,NULL,'f','2008-03-12 11:15:02');
INSERT INTO CHANSON VALUES(5698,'Skamgreppet',3,NULL,'f','2008-03-12 13:41:03');
INSERT INTO CHANSON VALUES(5699,'Tüss''on Nainen',3,NULL,'f','2008-03-12 19:13:49');
INSERT INTO CHANSON VALUES(5700,'Min Skog',3,NULL,NULL,'2008-03-12 16:16:28');
INSERT INTO CHANSON VALUES(5701,'Vargtimmen',3,NULL,NULL,'2008-03-12 14:45:00');
INSERT INTO CHANSON VALUES(5702,'Gorrlaus',3,NULL,'f','2008-03-12 16:55:54');
INSERT INTO CHANSON VALUES(5703,'Saglaten',3,NULL,NULL,'2008-03-12 09:52:17');
INSERT INTO CHANSON VALUES(5704,'Rüven',3,NULL,'f','2008-03-12 17:01:18');
INSERT INTO CHANSON VALUES(5705,'Brighid''s Kiss',3,NULL,NULL,'2008-03-12 10:45:16');
INSERT INTO CHANSON VALUES(5706,'Omeath Music',3,NULL,NULL,'2008-03-12 17:28:05');
INSERT INTO CHANSON VALUES(5707,'Senex Puer',3,NULL,NULL,'2008-03-12 17:45:21');
INSERT INTO CHANSON VALUES(5708,'Éirigh suas a stóirín',3,NULL,NULL,'2008-03-12 17:12:02');
INSERT INTO CHANSON VALUES(5709,'Dónal Dubh',3,NULL,NULL,'2008-03-12 18:08:16');
INSERT INTO CHANSON VALUES(5710,'The Mummers'' March Highland and Reels',3,NULL,NULL,'2008-03-12 16:52:33');
INSERT INTO CHANSON VALUES(5711,'Lough Erne Shore',3,NULL,NULL,'2008-03-12 10:25:18');
INSERT INTO CHANSON VALUES(5712,'A Bruxa',3,NULL,NULL,'2008-03-12 10:08:14');
INSERT INTO CHANSON VALUES(5713,'Tá sé ''na lá',3,NULL,NULL,'2008-03-12 09:14:06');
INSERT INTO CHANSON VALUES(5714,'Bealtaine Song',3,NULL,NULL,'2008-03-12 12:04:08');
INSERT INTO CHANSON VALUES(5715,'The Donnellan Sel',3,NULL,NULL,'2008-03-12 16:18:53');
INSERT INTO CHANSON VALUES(5716,'The Rose in the Garden',3,NULL,NULL,'2008-03-12 19:05:22');
INSERT INTO CHANSON VALUES(5717,'Mál Bhán Ni Chuilleannáin',3,NULL,NULL,'2008-03-12 08:52:07');
INSERT INTO CHANSON VALUES(5718,'The Emigrant''s Farewell',3,NULL,NULL,'2008-03-12 13:42:20');
INSERT INTO CHANSON VALUES(5719,'Cum On Feel The Noize',2,NULL,'f','2008-03-12 13:36:28');
INSERT INTO CHANSON VALUES(5720,'Look Wot You Dun',2,NULL,'f','2008-03-12 17:19:21');
INSERT INTO CHANSON VALUES(5722,'One Way Hotel',2,NULL,'f','2008-03-12 15:42:54');
INSERT INTO CHANSON VALUES(5724,'Pouk Hill',2,NULL,'f','2008-03-12 19:13:13');
INSERT INTO CHANSON VALUES(5725,'The Shape Of Things To Come',2,NULL,'f','2008-03-12 09:57:31');
INSERT INTO CHANSON VALUES(5726,'Take Me Bak ''Ome',2,NULL,'f','2008-03-12 08:56:37');
INSERT INTO CHANSON VALUES(5727,'Coz I Luv You',2,NULL,'f','2008-03-12 12:01:29');
INSERT INTO CHANSON VALUES(5728,'Wild Winds Are Blowin''',2,NULL,'f','2008-03-12 14:27:12');
INSERT INTO CHANSON VALUES(5729,'Know Who You Are',2,NULL,'f','2008-03-20 18:56:48');
INSERT INTO CHANSON VALUES(5730,'Get Down And Get With It',2,NULL,'f','2008-03-12 11:41:07');
INSERT INTO CHANSON VALUES(5731,'Look At Last Nite',2,NULL,'f','2008-03-12 16:59:38');
INSERT INTO CHANSON VALUES(5732,'Mama Weer All Crazee Now',2,NULL,'f','2008-03-12 13:36:21');
INSERT INTO CHANSON VALUES(5733,'Libido moriendi',2,NULL,'f','2008-03-12 12:27:10');
INSERT INTO CHANSON VALUES(5734,'Scandale mélancolique',2,NULL,'f','2008-03-12 14:25:24');
INSERT INTO CHANSON VALUES(5735,'Gynécées',2,NULL,NULL,'2008-03-12 16:32:21');
INSERT INTO CHANSON VALUES(5736,'Confessions d''un never been',2,NULL,'f','2008-03-12 11:32:18');
INSERT INTO CHANSON VALUES(5737,'Le jeu de la folie',2,NULL,'f','2008-03-12 18:55:19');
INSERT INTO CHANSON VALUES(5738,'Last exit to paradise',2,NULL,'f','2008-03-12 12:25:47');
INSERT INTO CHANSON VALUES(5739,'L''étranger dans la glace',2,NULL,'f','2008-03-12 15:17:43');
INSERT INTO CHANSON VALUES(5740,'Les jardins sauvages',2,NULL,'f','2008-03-12 12:36:24');
INSERT INTO CHANSON VALUES(5741,'Télégramme 2003',2,NULL,NULL,'2008-03-12 14:17:23');
INSERT INTO CHANSON VALUES(5742,'Loin des temples en marbre de lune',2,NULL,NULL,'2008-03-12 09:45:00');
INSERT INTO CHANSON VALUES(5743,'La nuit de Samain',2,NULL,'f','2008-03-12 14:07:27');
INSERT INTO CHANSON VALUES(5744,'When Maurice meets Alice',2,NULL,'f','2008-03-12 16:39:53');
INSERT INTO CHANSON VALUES(5745,'That angry man on the pier',2,NULL,'f','2008-03-12 09:24:25');
INSERT INTO CHANSON VALUES(5746,'Sgt. Hetfield''s Motorbreath Pub Band',2,NULL,'f','2008-03-12 13:40:57');
INSERT INTO CHANSON VALUES(5747,'A Garage Dayz Night',2,NULL,'f','2008-03-12 17:34:53');
INSERT INTO CHANSON VALUES(5748,'For Horsemen',2,NULL,'f','2008-03-12 08:57:19');
INSERT INTO CHANSON VALUES(5749,'No Remorseful Reply',2,NULL,'f','2008-03-12 18:33:36');
INSERT INTO CHANSON VALUES(5750,'The Thing That Should Not Let It Be',2,NULL,'f','2008-03-12 14:57:13');
INSERT INTO CHANSON VALUES(5751,'Everybody''s Got A Ticket To Ride Except For Me And My Lightning',2,NULL,'f','2008-03-12 19:28:30');
INSERT INTO CHANSON VALUES(5752,'...And Justice For All My Loving',2,NULL,'f','2008-03-12 12:38:16');
INSERT INTO CHANSON VALUES(5753,'Blackened The USSR',2,NULL,'f','2008-03-12 12:08:23');
INSERT INTO CHANSON VALUES(5754,'Sandman',2,NULL,'f','2008-03-12 18:50:03');
INSERT INTO CHANSON VALUES(5755,'And I''m Evil',2,NULL,'f','2008-03-12 17:55:27');
INSERT INTO CHANSON VALUES(5756,'Got To Get You Trapped Under Ice',2,NULL,'f','2008-03-12 10:22:08');
INSERT INTO CHANSON VALUES(5757,'Leper Madonna',2,NULL,'f','2008-03-12 09:07:42');
INSERT INTO CHANSON VALUES(5758,'Hey Dude',2,NULL,'f','2008-03-12 08:12:40');
INSERT INTO CHANSON VALUES(5759,'I Want To Choke Your Band',2,NULL,'f','2008-03-12 12:04:14');
INSERT INTO CHANSON VALUES(5760,'We Can Hit The Lightz',2,NULL,NULL,'2008-03-12 19:39:11');
INSERT INTO CHANSON VALUES(5761,'Les Larmes Du Dalaï Lama',2,NULL,'f','2008-03-12 10:38:40');
INSERT INTO CHANSON VALUES(5762,'Le Ballon De Billy',2,NULL,'f','2008-03-12 16:02:18');
INSERT INTO CHANSON VALUES(5763,'Tout Oublier',2,NULL,'f','2008-03-12 19:25:27');
INSERT INTO CHANSON VALUES(5764,'La Bête',2,NULL,'f','2008-03-12 12:17:17');
INSERT INTO CHANSON VALUES(5765,'Bonnet Rouge',2,NULL,NULL,'2008-03-12 12:02:13');
INSERT INTO CHANSON VALUES(5766,'Nonne Asssistante À Personne À Tanger',2,NULL,'f','2008-03-12 18:13:35');
INSERT INTO CHANSON VALUES(5767,'Couleurs En Colère',2,NULL,'f','2008-03-12 08:22:43');
INSERT INTO CHANSON VALUES(5768,'Les Herbes Folles',2,NULL,'f','2008-03-12 16:24:56');
INSERT INTO CHANSON VALUES(5769,'Les Enfants Du Hasard',2,NULL,'f','2008-03-12 12:45:00');
INSERT INTO CHANSON VALUES(5770,'Médiseuse',2,NULL,'f','2008-03-12 15:42:39');
INSERT INTO CHANSON VALUES(5771,'Neurones à crètes',2,NULL,'f','2008-03-12 17:52:18');
INSERT INTO CHANSON VALUES(5772,'Body Building',2,NULL,'f','2008-03-20 13:33:20');
INSERT INTO CHANSON VALUES(5773,'Tout l''temps t''aimer toujours',2,NULL,'f','2008-03-12 17:31:46');
INSERT INTO CHANSON VALUES(5774,'Pantoufles',2,NULL,NULL,'2008-03-20 11:52:03');
INSERT INTO CHANSON VALUES(5775,'Comme un balai',2,NULL,'f','2008-03-20 14:16:06');
INSERT INTO CHANSON VALUES(5776,'Bla, bla, bla',2,NULL,'f','2008-03-12 17:08:19');
INSERT INTO CHANSON VALUES(5777,'Femmes mûres',2,NULL,'f','2008-03-24 17:58:06');
INSERT INTO CHANSON VALUES(5779,'Brrr...',2,NULL,'f','2008-03-12 09:51:06');
INSERT INTO CHANSON VALUES(5780,'Arrête ton crin crin',2,NULL,'f','2008-03-24 16:20:20');
INSERT INTO CHANSON VALUES(5781,'La 7ème compagnie en Jamaïque',2,NULL,'f','2008-03-12 08:15:52');
INSERT INTO CHANSON VALUES(5783,'Ram dam Reclame',2,NULL,NULL,'2008-03-12 16:42:27');
INSERT INTO CHANSON VALUES(5784,'La fée depovga',2,NULL,'f','2008-03-12 08:12:01');
INSERT INTO CHANSON VALUES(5785,'Ma sœur',2,NULL,'f','2008-07-12 07:04:26.680011');
INSERT INTO CHANSON VALUES(5786,'La grosse madame',2,NULL,'f','2008-03-12 09:16:25');
INSERT INTO CHANSON VALUES(5787,'Sauvez moi',2,NULL,'f','2008-03-12 10:50:42');
INSERT INTO CHANSON VALUES(5788,'Raoul et Alain',2,NULL,'f','2008-04-11 12:39:01');
INSERT INTO CHANSON VALUES(5789,'62 méfie te',2,NULL,'f','2008-03-20 11:37:50');
INSERT INTO CHANSON VALUES(5790,'School''s Out',2,NULL,'f','2008-03-12 15:00:59');
INSERT INTO CHANSON VALUES(5791,'Luney Tune',2,NULL,'f','2008-03-12 12:06:50');
INSERT INTO CHANSON VALUES(5792,'Gutter Cat vs. The Jets',2,NULL,'f','2008-03-12 13:09:06');
INSERT INTO CHANSON VALUES(5793,'Street Fight',2,NULL,'f','2008-03-12 11:12:59');
INSERT INTO CHANSON VALUES(5794,'Blue Turk',2,NULL,'f','2008-03-12 18:55:41');
INSERT INTO CHANSON VALUES(5795,'My Stars',2,NULL,'f','2008-03-12 12:56:53');
INSERT INTO CHANSON VALUES(5796,'Public Animal #9',2,NULL,'f','2008-04-14 08:57:39');
INSERT INTO CHANSON VALUES(5797,'Alma Mater',2,NULL,'f','2008-03-12 12:18:54');
INSERT INTO CHANSON VALUES(5798,'Grand Finale',2,NULL,'f','2008-03-12 19:27:11');
INSERT INTO CHANSON VALUES(5799,'What Do You Want From Me?',2,NULL,'f','2008-04-18 18:35:39');
INSERT INTO CHANSON VALUES(5800,'Between High School & Old School',2,NULL,NULL,'2008-04-18 18:55:46');
INSERT INTO CHANSON VALUES(5801,'Man Of The Year',2,NULL,NULL,'2008-04-18 16:22:55');
INSERT INTO CHANSON VALUES(5802,'Novocaine',2,NULL,NULL,'2008-04-18 13:56:47');
INSERT INTO CHANSON VALUES(5803,'Bye Bye, Baby',2,NULL,'f','2008-04-18 17:41:07');
INSERT INTO CHANSON VALUES(5804,'Be With You Awhile',2,NULL,NULL,'2008-04-18 17:34:03');
INSERT INTO CHANSON VALUES(5805,'Detroit City',2,NULL,'f','2008-04-18 14:56:59');
INSERT INTO CHANSON VALUES(5806,'Spirits Rebellious',2,NULL,'f','2008-04-18 12:18:18');
INSERT INTO CHANSON VALUES(5807,'This House Is Haunted',2,NULL,'f','2008-04-18 11:14:45');
INSERT INTO CHANSON VALUES(5808,'Love Should Never Feel Like This',2,NULL,'f','2008-04-18 09:01:51');
INSERT INTO CHANSON VALUES(5809,'The Song That Didn''t Rhyme',2,NULL,'f','2008-04-18 12:42:10');
INSERT INTO CHANSON VALUES(5810,'I''m So Angry',2,NULL,'f','2008-04-18 15:21:08');
INSERT INTO CHANSON VALUES(5811,'Backyard Brawl',2,NULL,'f','2008-04-18 15:31:51');
INSERT INTO CHANSON VALUES(5812,'Triggerman',2,NULL,'f','2008-03-12 14:34:24');
INSERT INTO CHANSON VALUES(5813,'Deeper',2,NULL,'f','2008-03-12 14:37:22');
INSERT INTO CHANSON VALUES(5814,'Dragontown',2,NULL,'f','2008-04-18 19:42:56');
INSERT INTO CHANSON VALUES(5815,'Sex, Death and Money',2,NULL,'f','2008-03-12 10:31:57');
INSERT INTO CHANSON VALUES(5816,'Fantasy Man',2,NULL,'f','2008-03-12 18:23:53');
INSERT INTO CHANSON VALUES(5817,'Somewhere In The Jungle',2,NULL,'f','2008-03-12 15:07:15');
INSERT INTO CHANSON VALUES(5818,'Disgraceland',2,NULL,'f','2008-03-12 14:57:57');
INSERT INTO CHANSON VALUES(5819,'Sister Sara',2,NULL,'f','2008-03-12 16:46:31');
INSERT INTO CHANSON VALUES(5820,'Every Woman Has A Name',2,NULL,'f','2008-03-26 16:17:27');
INSERT INTO CHANSON VALUES(5821,'I Just Wanna Be God',2,NULL,'f','2008-04-18 19:10:17');
INSERT INTO CHANSON VALUES(5822,'It''s Much Too Late',2,NULL,'f','2008-03-12 16:42:46');
INSERT INTO CHANSON VALUES(5823,'The Sentinel',2,NULL,'f','2008-03-12 08:01:00');
INSERT INTO CHANSON VALUES(5824,'Body''s Building',2,NULL,'f','2008-03-12 17:32:35');
INSERT INTO CHANSON VALUES(5825,'Stewball',2,NULL,'f','2008-03-12 10:05:13');
INSERT INTO CHANSON VALUES(5826,'Pépé et Mémé',2,NULL,'f','2008-03-12 14:17:44');
INSERT INTO CHANSON VALUES(5828,'BRRR...(Au début elle est froide)',2,NULL,'f','2008-03-20 16:24:59');
INSERT INTO CHANSON VALUES(5830,'La communion (du petit Raymond)',2,NULL,NULL,'2008-03-20 16:18:13');
INSERT INTO CHANSON VALUES(5831,'Politiquement X',2,NULL,'f','2008-03-12 15:58:00');
INSERT INTO CHANSON VALUES(5832,'Afanana',2,NULL,'f','2008-03-20 10:42:18');
INSERT INTO CHANSON VALUES(5833,'Un bien beau tableau',2,NULL,'f','2008-03-12 15:25:00');
INSERT INTO CHANSON VALUES(5834,'Skakaline',2,NULL,'f','2008-03-12 12:27:02');
INSERT INTO CHANSON VALUES(5835,'Welcome in night box',2,NULL,'f','2008-03-12 13:15:35');
INSERT INTO CHANSON VALUES(5836,'Où sont passées mes pantoufles',2,NULL,'f','2008-03-20 08:28:40');
INSERT INTO CHANSON VALUES(5838,'La complainte de la ménagère',2,NULL,'f','2008-03-20 19:35:05');
INSERT INTO CHANSON VALUES(5839,'Avanaguila',2,NULL,'f','2008-03-20 19:35:45');
INSERT INTO CHANSON VALUES(5840,'Chantal',2,NULL,'f','2008-03-20 08:01:00');
INSERT INTO CHANSON VALUES(5842,'Out Of The Blue',2,NULL,'f','2008-03-12 11:17:32');
INSERT INTO CHANSON VALUES(5843,'Pyjamarama',2,NULL,'f','2008-03-12 10:17:07');
INSERT INTO CHANSON VALUES(5844,'The Bogus Man',2,NULL,'f','2008-03-26 11:26:08');
INSERT INTO CHANSON VALUES(5846,'Both Ends Burning',2,NULL,'f','2008-03-12 10:50:51');
INSERT INTO CHANSON VALUES(5848,'In Every Dream Home A Heartache',2,NULL,'f','2008-03-12 14:08:45');
INSERT INTO CHANSON VALUES(5849,'Do The Strand',2,NULL,'f','2008-03-12 12:06:55');
INSERT INTO CHANSON VALUES(5850,'Welcome To My Nightmare',2,NULL,'f','2008-04-14 15:05:27');
INSERT INTO CHANSON VALUES(5851,'Devil''s Food',2,NULL,'f','2008-04-14 08:26:41');
INSERT INTO CHANSON VALUES(5852,'The Black Widow',2,NULL,'f','2008-04-14 15:38:13');
INSERT INTO CHANSON VALUES(5853,'Some Folks',2,NULL,'f','2008-03-12 15:04:30');
INSERT INTO CHANSON VALUES(5854,'Only Women Bleed',2,NULL,'f','2008-03-12 12:05:31');
INSERT INTO CHANSON VALUES(5855,'Department Of Youth',2,NULL,'f','2008-03-12 12:41:34');
INSERT INTO CHANSON VALUES(5856,'Cold Ethyl',2,NULL,'f','2008-04-14 14:08:10');
INSERT INTO CHANSON VALUES(5857,'Years Ago',2,NULL,'f','2008-03-12 18:57:52');
INSERT INTO CHANSON VALUES(5858,'Steven',2,NULL,'f','2008-03-12 13:11:09');
INSERT INTO CHANSON VALUES(5859,'The Awakening',2,NULL,'f','2008-03-12 14:31:35');
INSERT INTO CHANSON VALUES(5860,'Escape',2,NULL,'f','2008-03-12 16:42:26');
INSERT INTO CHANSON VALUES(5861,'Dance On A Volcano',2,NULL,NULL,'2008-03-12 14:03:55');
INSERT INTO CHANSON VALUES(5862,'Entangled',2,NULL,NULL,'2008-03-12 17:33:04');
INSERT INTO CHANSON VALUES(5863,'Squonk',2,NULL,'f','2008-03-12 14:54:11');
INSERT INTO CHANSON VALUES(5864,'Mad Man Moon',2,NULL,'f','2008-03-12 13:33:15');
INSERT INTO CHANSON VALUES(5865,'Robbery, Assault And Battery',2,NULL,'f','2008-03-12 19:57:21');
INSERT INTO CHANSON VALUES(5866,'Ripples',2,NULL,'f','2008-03-12 13:22:03');
INSERT INTO CHANSON VALUES(5867,'A Trick Of The Tail',2,NULL,'f','2008-03-12 08:16:01');
INSERT INTO CHANSON VALUES(5868,'Los Endos',2,NULL,'f','2008-03-12 19:41:12');
INSERT INTO CHANSON VALUES(5869,'Dancing With The Moonlight Knight',2,NULL,'f','2008-03-12 09:15:44');
INSERT INTO CHANSON VALUES(5870,'I Know What I Like (In Your Wardrobe)',2,NULL,'f','2008-03-12 16:57:26');
INSERT INTO CHANSON VALUES(5871,'Firth Of Fifth',2,NULL,'f','2008-03-12 09:31:29');
INSERT INTO CHANSON VALUES(5872,'More Fool Me',2,NULL,NULL,'2008-05-22 16:36:00');
INSERT INTO CHANSON VALUES(5873,'The Battle Of Epping Forest',2,NULL,'f','2008-03-12 08:17:03');
INSERT INTO CHANSON VALUES(5874,'After The Ordeal',2,NULL,'f','2008-03-12 09:49:57');
INSERT INTO CHANSON VALUES(5875,'The Cinema Show',2,NULL,'f','2008-03-12 11:16:31');
INSERT INTO CHANSON VALUES(5876,'Aisle Of Plenty',2,NULL,'f','2008-03-12 15:14:29');
INSERT INTO CHANSON VALUES(5877,'Let''s Spend The Night Together - David Bowie',2,NULL,'f','2008-04-14 19:56:11');
INSERT INTO CHANSON VALUES(5878,'Street Fighting Man - Rod Stewart',2,NULL,'f','2008-03-16 19:43:51');
INSERT INTO CHANSON VALUES(5879,'Jumpin'' Jack Flash - Aretha Franklin',2,NULL,'f','2008-04-13 15:09:37');
INSERT INTO CHANSON VALUES(5880,'(I can''t get no) Satisfaction - Otis Reddingn',2,NULL,'f','2008-03-17 08:47:08');
INSERT INTO CHANSON VALUES(5881,'Tumbling Dice - Linda Ronstadt',2,NULL,'f','2008-04-11 18:53:29');
INSERT INTO CHANSON VALUES(5882,'Honky Tonk Women - Ike & Tina Turner',2,NULL,NULL,'2008-04-12 08:49:46');
INSERT INTO CHANSON VALUES(5883,'Sympathy For The Devil - Bryan Ferry',2,NULL,'f','2008-04-11 15:34:53');
INSERT INTO CHANSON VALUES(5884,'Gimme Shelter - Grand Funk Railroad',2,NULL,'f','2008-03-17 08:42:50');
INSERT INTO CHANSON VALUES(5885,'Paint It Black - Mighty Lemon Drops',2,NULL,'f','2008-03-17 10:48:05');
INSERT INTO CHANSON VALUES(5886,'Lady Jane - Tony Merrick',2,NULL,'f','2008-03-20 19:29:02');
INSERT INTO CHANSON VALUES(5887,'Out Of Time - Ramones',2,NULL,'f','2008-06-01 16:07:18.706675');
INSERT INTO CHANSON VALUES(5888,'Get Off Of My Cloud - Flying Pickets',2,NULL,'f','2008-06-01 17:14:16.284909');
INSERT INTO CHANSON VALUES(5889,'19th Nervous Breakdown - Jason & The Scorchers',2,NULL,'f','2008-03-17 19:41:51');
INSERT INTO CHANSON VALUES(5890,'Bitch - Exodus',2,NULL,'f','2008-04-12 10:21:30');
INSERT INTO CHANSON VALUES(5891,'Dandelion - Miranda Lee Richards',2,NULL,'f','2008-05-26 19:35:56');
INSERT INTO CHANSON VALUES(5892,'Wild Horses - Leon Russell',2,NULL,NULL,'2008-04-15 16:43:06');
INSERT INTO CHANSON VALUES(5893,'Doo Doo Doo Doo Doo (Heartbreaker) - Quireboys',2,NULL,NULL,'2008-06-02 09:48:46.796943');
INSERT INTO CHANSON VALUES(5894,'Dead Flowers - Gilby Clarke',2,NULL,NULL,'2008-06-02 09:43:28.720962');
INSERT INTO CHANSON VALUES(5895,'Brown Sugar - Thunder (live)',2,NULL,'f','2008-04-15 19:27:25');
INSERT INTO CHANSON VALUES(5897,'La minute de bruit',2,NULL,'f','2008-03-12 19:42:56');
INSERT INTO CHANSON VALUES(5898,'La noche de accion',2,NULL,'f','2008-03-12 17:43:44');
INSERT INTO CHANSON VALUES(5899,'Bla,bla,bla (3)',2,NULL,'f','2008-03-12 19:45:27');
INSERT INTO CHANSON VALUES(5900,'Les vaches',2,NULL,'f','2008-04-11 08:32:02');
INSERT INTO CHANSON VALUES(5902,'Don''t Speak',2,NULL,NULL,'2008-03-12 18:59:45');
INSERT INTO CHANSON VALUES(5903,'Mauvais Garçon',2,NULL,NULL,'2008-03-12 19:24:22');
INSERT INTO CHANSON VALUES(5904,'When It Comes To You I''m Lazy',2,NULL,NULL,'2008-03-12 13:19:04');
INSERT INTO CHANSON VALUES(5905,'Something is Calling',2,NULL,NULL,'2008-03-12 12:17:54');
INSERT INTO CHANSON VALUES(5906,'Your Side Of Town',2,NULL,NULL,'2008-03-12 08:14:03');
INSERT INTO CHANSON VALUES(5907,'This Is War',2,NULL,NULL,'2008-03-12 19:41:49');
INSERT INTO CHANSON VALUES(5908,'Cutting Out A Career',2,NULL,NULL,'2008-03-12 10:39:31');
INSERT INTO CHANSON VALUES(5909,'Tenley Town',2,NULL,NULL,'2008-03-12 09:28:15');
INSERT INTO CHANSON VALUES(5910,'I Fell Deep',2,NULL,NULL,'2008-03-12 18:25:00');
INSERT INTO CHANSON VALUES(5911,'Soulève Moi',2,NULL,NULL,'2008-03-12 12:13:01');
INSERT INTO CHANSON VALUES(5912,'Beers Before The Barbican',2,NULL,NULL,'2008-03-12 15:06:00');
INSERT INTO CHANSON VALUES(5913,'I Wanna Bit',2,NULL,NULL,'2008-03-12 12:01:25');
INSERT INTO CHANSON VALUES(5914,'Party',2,NULL,NULL,'2008-03-12 16:30:45');
INSERT INTO CHANSON VALUES(5915,'Be My Baby',2,NULL,NULL,'2008-03-12 17:50:03');
INSERT INTO CHANSON VALUES(5916,'Model Girl',2,NULL,NULL,'2008-03-12 16:52:17');
INSERT INTO CHANSON VALUES(5917,'Blues & Reds',2,NULL,NULL,'2008-03-12 17:51:59');
INSERT INTO CHANSON VALUES(5918,'Ketang',2,NULL,NULL,'2008-03-12 15:04:38');
INSERT INTO CHANSON VALUES(5919,'Lalala',2,NULL,NULL,'2008-03-12 09:14:07');
INSERT INTO CHANSON VALUES(5920,'The Modern',2,NULL,NULL,'2008-03-12 12:08:33');
INSERT INTO CHANSON VALUES(5921,'Play The Fool',2,NULL,NULL,'2008-03-12 12:28:46');
INSERT INTO CHANSON VALUES(5922,'Holy',2,NULL,NULL,'2008-03-12 13:05:52');
INSERT INTO CHANSON VALUES(5923,'Gubbish',2,NULL,NULL,'2008-03-12 13:27:53');
INSERT INTO CHANSON VALUES(5924,'Abacab',2,NULL,'f','2008-03-12 18:11:24');
INSERT INTO CHANSON VALUES(5925,'No Reply At All',2,NULL,'f','2008-03-12 15:00:14');
INSERT INTO CHANSON VALUES(5926,'Me And Sarah Jane',2,NULL,'f','2008-03-23 19:29:58');
INSERT INTO CHANSON VALUES(5927,'Keep It Dark',2,NULL,'f','2008-03-12 19:05:02');
INSERT INTO CHANSON VALUES(5928,'Dodo Lurker',2,NULL,'f','2008-03-12 15:13:17');
INSERT INTO CHANSON VALUES(5929,'Who Dunnit?',2,NULL,'f','2008-03-12 16:36:25');
INSERT INTO CHANSON VALUES(5930,'Man On The Corner',2,NULL,'f','2008-03-12 11:00:54');
INSERT INTO CHANSON VALUES(5931,'Like It Or Not',2,NULL,'f','2008-03-12 08:26:59');
INSERT INTO CHANSON VALUES(5932,'Another Record',2,NULL,'f','2008-03-12 19:52:26');
INSERT INTO CHANSON VALUES(5933,'Eleventh Earl Of Mar',2,NULL,'f','2008-03-12 18:44:38');
INSERT INTO CHANSON VALUES(5934,'One For The Vine',2,NULL,'f','2008-03-12 10:21:38');
INSERT INTO CHANSON VALUES(5935,'Your Own Special Way',2,NULL,'f','2008-03-12 13:02:21');
INSERT INTO CHANSON VALUES(5936,'Wot Gorilla ?',2,NULL,'f','2008-03-12 15:01:51');
INSERT INTO CHANSON VALUES(5937,'All In A Mouse''s Night',2,NULL,'f','2008-03-12 14:59:57');
INSERT INTO CHANSON VALUES(5938,'Blood On The Rooftops',2,NULL,'f','2008-04-09 17:58:04');
INSERT INTO CHANSON VALUES(5939,'"Unquiet Slumbers For The Sleepers ...',2,NULL,'f','2008-03-12 15:36:11');
INSERT INTO CHANSON VALUES(5940,'... In That Quiet Earth''',2,NULL,'f','2008-03-12 18:20:48');
INSERT INTO CHANSON VALUES(5941,'Afterglow',2,NULL,NULL,'2008-03-12 11:38:48');
INSERT INTO CHANSON VALUES(5942,'Cambodia',2,NULL,'f','2008-03-12 10:41:14');
INSERT INTO CHANSON VALUES(5943,'Kids In America',2,NULL,'f','2008-03-12 10:38:07');
INSERT INTO CHANSON VALUES(5944,'Love Blonde',2,NULL,'f','2008-03-12 15:28:51');
INSERT INTO CHANSON VALUES(5945,'Chequered Love',2,NULL,'f','2008-03-12 11:43:12');
INSERT INTO CHANSON VALUES(5946,'View From A Bridge',2,NULL,'f','2008-03-12 19:12:15');
INSERT INTO CHANSON VALUES(5947,'Boys',2,NULL,NULL,'2008-03-12 11:47:16');
INSERT INTO CHANSON VALUES(5948,'Dancing In The Dark',2,NULL,'f','2008-03-12 10:21:15');
INSERT INTO CHANSON VALUES(5949,'Water On Glass',2,NULL,NULL,'2008-03-12 09:58:51');
INSERT INTO CHANSON VALUES(5950,'26580',2,NULL,NULL,'2008-03-12 11:51:12');
INSERT INTO CHANSON VALUES(5951,'Our Town',2,NULL,'f','2008-03-12 09:11:50');
INSERT INTO CHANSON VALUES(5952,'Everything We Know',2,NULL,'f','2008-03-12 19:24:32');
INSERT INTO CHANSON VALUES(5953,'You''ll Never Be So Wrong',2,NULL,'f','2008-03-12 10:37:10');
INSERT INTO CHANSON VALUES(5954,'House Of Salome',2,NULL,'f','2008-03-12 11:17:39');
INSERT INTO CHANSON VALUES(5955,'Child Come Away',2,NULL,'f','2008-03-12 09:35:22');
INSERT INTO CHANSON VALUES(5956,'Take Me Tonight',2,NULL,'f','2008-03-12 12:31:34');
INSERT INTO CHANSON VALUES(5957,'Stay Awhile',2,NULL,'f','2008-03-12 15:49:22');
INSERT INTO CHANSON VALUES(5958,'Watching For Shapes',2,NULL,'f','2008-03-12 18:59:43');
INSERT INTO CHANSON VALUES(5959,'Dancing In The Dark (Remix By Nile Rodgers)',2,NULL,'f','2008-03-12 09:07:41');
INSERT INTO CHANSON VALUES(5960,'Love Blonde (Remix)',2,NULL,'f','2008-03-12 08:26:33');
INSERT INTO CHANSON VALUES(5961,'Hey Gamin',2,NULL,'f','2008-03-20 10:33:44');
INSERT INTO CHANSON VALUES(5962,'Petite culotte',2,NULL,'f','2008-03-20 08:29:09');
INSERT INTO CHANSON VALUES(5963,'Soleil dans les bouchons',2,NULL,'f','2008-03-12 15:40:47');
INSERT INTO CHANSON VALUES(5964,'Fil à retordre',2,NULL,'f','2008-03-20 13:27:18');
INSERT INTO CHANSON VALUES(5965,'Baisse la tete',2,NULL,'f','2008-03-20 13:07:39');
INSERT INTO CHANSON VALUES(5966,'Minimum requis',2,NULL,'f','2008-03-12 17:29:10');
INSERT INTO CHANSON VALUES(5967,'Détournement de studio',2,NULL,'f','2008-03-12 12:07:00');
INSERT INTO CHANSON VALUES(5968,'Angélique',2,NULL,'f','2008-03-20 13:05:50');
INSERT INTO CHANSON VALUES(5969,'La voix d''Alice',2,NULL,'f','2008-03-20 17:00:00');
INSERT INTO CHANSON VALUES(5970,'Blasphème',2,NULL,'f','2008-03-24 15:53:25');
INSERT INTO CHANSON VALUES(5971,'Le Pornographe',2,NULL,'f','2008-03-26 14:10:07');
INSERT INTO CHANSON VALUES(5972,'Ma copine cathy',2,NULL,'f','2008-03-12 10:11:34');
INSERT INTO CHANSON VALUES(5973,'Proce''bal',2,NULL,'f','2008-03-12 17:24:07');
INSERT INTO CHANSON VALUES(5974,'Utopistes debout',2,NULL,'f','2008-03-12 14:29:37');
INSERT INTO CHANSON VALUES(5975,'Bad trip poker',2,NULL,'f','2008-03-20 14:26:07');
INSERT INTO CHANSON VALUES(5976,'Dédé',2,NULL,'f','2008-03-24 11:00:26');
INSERT INTO CHANSON VALUES(5978,'Sucker Train Blues',2,NULL,'f','2008-03-12 13:53:15');
INSERT INTO CHANSON VALUES(5979,'Do It For The Kids',2,NULL,'f','2008-03-12 14:20:23');
INSERT INTO CHANSON VALUES(5980,'Big Machine',2,NULL,'f','2008-03-12 10:10:52');
INSERT INTO CHANSON VALUES(5981,'Illegal I Song',2,NULL,'f','2008-03-12 12:34:59');
INSERT INTO CHANSON VALUES(5982,'Spectacle',2,NULL,'f','2008-03-12 12:22:00');
INSERT INTO CHANSON VALUES(5983,'Fall To Pieces',2,NULL,'f','2008-03-12 12:52:10');
INSERT INTO CHANSON VALUES(5984,'Headspace',2,NULL,'f','2008-03-12 14:05:21');
INSERT INTO CHANSON VALUES(5985,'Superhuman',2,NULL,NULL,'2008-04-24 16:42:49');
INSERT INTO CHANSON VALUES(5986,'Set Me Free',2,NULL,NULL,'2008-03-12 09:51:46');
INSERT INTO CHANSON VALUES(5987,'You Got No Right',2,NULL,'f','2008-03-12 10:22:15');
INSERT INTO CHANSON VALUES(5988,'Slither',2,NULL,'f','2008-03-12 18:03:21');
INSERT INTO CHANSON VALUES(5989,'Dirty Little Thing',2,NULL,'f','2008-03-12 09:30:14');
INSERT INTO CHANSON VALUES(5992,'Pas de dimanches',2,NULL,'f','2008-03-12 15:35:19');
INSERT INTO CHANSON VALUES(5993,'Adieu l''enfance',2,NULL,'f','2008-03-12 15:58:41');
INSERT INTO CHANSON VALUES(5994,'Jusqu''a la fin du monde',2,NULL,'f','2008-03-12 15:21:34');
INSERT INTO CHANSON VALUES(5995,'Sentimentale mon cul',2,NULL,'f','2008-03-12 18:51:39');
INSERT INTO CHANSON VALUES(5996,'Elsa',2,NULL,'f','2008-03-12 10:56:31');
INSERT INTO CHANSON VALUES(5997,'Rien a te mettre',2,NULL,'f','2008-03-12 19:09:54');
INSERT INTO CHANSON VALUES(5998,'A la teloche',2,NULL,'f','2008-03-12 11:00:57');
INSERT INTO CHANSON VALUES(5999,'A la chose',2,NULL,'f','2008-03-12 15:07:28');
INSERT INTO CHANSON VALUES(6000,'Leonards song',2,NULL,'f','2008-03-12 18:31:31');
INSERT INTO CHANSON VALUES(6001,'Malone',2,NULL,'f','2008-03-12 13:17:45');
INSERT INTO CHANSON VALUES(6002,'En la selva',2,NULL,'f','2008-03-12 10:56:21');
INSERT INTO CHANSON VALUES(6003,'Je m''appelle Galilee',2,NULL,'f','2008-03-12 14:36:19');
INSERT INTO CHANSON VALUES(6004,'Renaud - OpenDisc - Rouge Sang - CD2',2,NULL,'f','2008-03-12 10:16:40');
INSERT INTO CHANSON VALUES(6005,'You Keep Me Hangin'' On',2,NULL,'f','2008-03-12 17:06:32');
INSERT INTO CHANSON VALUES(6006,'Hit Him',2,NULL,'f','2008-03-12 13:19:29');
INSERT INTO CHANSON VALUES(6007,'Another Step (Closer To You)',2,NULL,'f','2008-03-12 19:18:39');
INSERT INTO CHANSON VALUES(6008,'The Thrill Of It',2,NULL,'f','2008-03-12 18:33:39');
INSERT INTO CHANSON VALUES(6009,'I''ve Got So Much Love',2,NULL,NULL,'2008-03-12 17:10:47');
INSERT INTO CHANSON VALUES(6010,'Victim',2,NULL,NULL,'2008-03-12 11:02:18');
INSERT INTO CHANSON VALUES(6011,'Schoolgirl',2,NULL,NULL,'2008-03-12 17:28:36');
INSERT INTO CHANSON VALUES(6012,'Say You Really Want Me',2,NULL,'f','2008-03-12 15:39:32');
INSERT INTO CHANSON VALUES(6013,'She Hasn''t Got Time For You',2,NULL,'f','2008-03-12 19:09:09');
INSERT INTO CHANSON VALUES(6014,'Brothers',2,NULL,'f','2008-03-12 11:21:25');
INSERT INTO CHANSON VALUES(6015,'Missing',2,NULL,'f','2008-03-12 19:08:31');
INSERT INTO CHANSON VALUES(6016,'How Do You Want My Love',2,NULL,'f','2008-03-12 14:34:51');
INSERT INTO CHANSON VALUES(6017,'Don''t Say Nothing''s Changed',2,NULL,'f','2008-03-12 19:32:09');
INSERT INTO CHANSON VALUES(6018,'5:55',5,NULL,'f','2008-03-12 15:25:43');
INSERT INTO CHANSON VALUES(6019,'AF607105',5,NULL,'f','2008-03-12 11:15:54');
INSERT INTO CHANSON VALUES(6020,'The operation',5,NULL,'f','2008-03-12 09:33:56');
INSERT INTO CHANSON VALUES(6021,'Tel que tu es',5,NULL,'f','2008-03-12 12:23:24');
INSERT INTO CHANSON VALUES(6022,'The songs that we sing',5,NULL,'f','2008-03-12 08:58:03');
INSERT INTO CHANSON VALUES(6023,'Beauty mark',5,NULL,'f','2008-03-12 14:54:13');
INSERT INTO CHANSON VALUES(6024,'Little monsters',5,NULL,'f','2008-03-12 16:10:34');
INSERT INTO CHANSON VALUES(6025,'Jamais',5,NULL,'f','2008-03-12 09:08:43');
INSERT INTO CHANSON VALUES(6026,'Night time intermission',5,NULL,'f','2008-03-12 16:38:18');
INSERT INTO CHANSON VALUES(6027,'Everything I cannot see',5,NULL,'f','2008-03-12 14:37:51');
INSERT INTO CHANSON VALUES(6028,'Morning song',5,NULL,'f','2008-03-12 16:17:16');
INSERT INTO CHANSON VALUES(6030,'Les bobos',2,NULL,NULL,'2008-03-12 11:42:04');
INSERT INTO CHANSON VALUES(6031,'Dans la jungle',2,NULL,'f','2008-03-12 11:07:27');
INSERT INTO CHANSON VALUES(6032,'Arretez la clope',2,NULL,'f','2008-03-12 16:08:25');
INSERT INTO CHANSON VALUES(6033,'RS & RS',2,NULL,'f','2008-03-12 16:42:20');
INSERT INTO CHANSON VALUES(6034,'Ma Blonde',2,NULL,'f','2008-03-12 19:25:31');
INSERT INTO CHANSON VALUES(6035,'Rouge Sang',2,NULL,'f','2008-03-12 14:33:39');
INSERT INTO CHANSON VALUES(6036,'Elle est facho',2,NULL,'f','2008-03-12 10:13:17');
INSERT INTO CHANSON VALUES(6037,'Les cinq sens',2,NULL,NULL,'2008-03-12 14:45:55');
INSERT INTO CHANSON VALUES(6038,'J''ai retrouve mon flingue',2,NULL,'f','2008-03-12 12:26:12');
INSERT INTO CHANSON VALUES(6039,'Nos vieux',2,NULL,'f','2008-03-12 16:50:48');
INSERT INTO CHANSON VALUES(6040,'Filles de joie',2,NULL,'f','2008-03-12 10:10:30');
INSERT INTO CHANSON VALUES(6041,'Danser a Rome',2,NULL,'f','2008-03-12 11:25:38');
INSERT INTO CHANSON VALUES(6042,'OpenDisc Renaud Rouge Sang',2,NULL,'f','2008-03-12 16:05:46');
INSERT INTO CHANSON VALUES(6043,'Queue de paon',2,NULL,'f','2008-03-12 09:49:28');
INSERT INTO CHANSON VALUES(6044,'Prise de bec',2,NULL,NULL,'2008-03-12 14:45:53');
INSERT INTO CHANSON VALUES(6045,'Ice dream',2,NULL,NULL,'2008-03-12 08:17:27');
INSERT INTO CHANSON VALUES(6046,'L''hiver au lit à Liverpool',2,NULL,'f','2008-03-12 16:32:41');
INSERT INTO CHANSON VALUES(6047,'Se revoir et s''émouvoir',2,NULL,'f','2008-03-12 19:04:26');
INSERT INTO CHANSON VALUES(6048,'Halloween',2,NULL,'f','2008-03-12 18:28:52');
INSERT INTO CHANSON VALUES(6049,'Crocodaïl',2,NULL,'f','2008-03-12 09:08:43');
INSERT INTO CHANSON VALUES(6050,'Ici, c''est l''enfer',2,NULL,'f','2008-03-12 19:20:53');
INSERT INTO CHANSON VALUES(6051,'Amor doloroso',2,NULL,'f','2008-03-12 13:36:18');
INSERT INTO CHANSON VALUES(6052,'J''t''aime telle',2,NULL,'f','2008-03-12 08:20:24');
INSERT INTO CHANSON VALUES(6053,'J''aime',2,NULL,'f','2008-03-12 18:29:13');
INSERT INTO CHANSON VALUES(6062,'All the Young Dudes',2,NULL,'f','2008-06-07 18:58:22.235875');
INSERT INTO CHANSON VALUES(6064,'Rock ''n'' Roll with Me',2,NULL,'f','2008-04-14 15:12:54');
INSERT INTO CHANSON VALUES(6066,'Knock on Wood',2,NULL,'f','2008-04-11 10:23:08');
INSERT INTO CHANSON VALUES(6070,'Jean Genie',2,NULL,'f','2008-04-11 09:24:22');
INSERT INTO CHANSON VALUES(6072,'Band Intro',2,NULL,'f','2008-06-07 19:11:10.185495');
INSERT INTO CHANSON VALUES(6073,'Here Today, Gone Tomorrow',2,NULL,'f','2008-06-07 18:13:06.360462');
INSERT INTO CHANSON VALUES(6075,'Watcher Of The Skies',2,NULL,'f','2008-03-12 10:35:19');
INSERT INTO CHANSON VALUES(6076,'Time Table',2,NULL,NULL,'2008-03-12 14:16:01');
INSERT INTO CHANSON VALUES(6077,'Get ''em Out By Friday',2,NULL,'f','2008-06-07 19:24:02.334918');
INSERT INTO CHANSON VALUES(6078,'Can-Utility And The Coastliners',2,NULL,'f','2008-03-12 10:26:17');
INSERT INTO CHANSON VALUES(6079,'Horizons',2,NULL,'f','2008-03-12 15:07:00');
INSERT INTO CHANSON VALUES(6080,'Supper''s Ready',2,NULL,'f','2008-03-12 09:30:38');
INSERT INTO CHANSON VALUES(6081,'Le public s''impatiente',2,NULL,'f','2008-03-20 19:47:43');
INSERT INTO CHANSON VALUES(6083,'Soirée de soutien',2,NULL,'f','2008-03-20 11:24:55');
INSERT INTO CHANSON VALUES(6090,'Quelques chiffres en passant',2,NULL,'f','2008-03-20 10:32:20');
INSERT INTO CHANSON VALUES(6094,'Si ça rapporte',2,NULL,'f','2008-03-20 14:24:28');
INSERT INTO CHANSON VALUES(6095,'Le bourreau',2,NULL,'f','2008-03-20 13:58:06');
INSERT INTO CHANSON VALUES(6097,'Révélation exclusive sur Bouli',2,NULL,'f','2008-03-20 15:02:22');
INSERT INTO CHANSON VALUES(6098,'En plein front',2,NULL,'f','2008-03-20 16:15:05');
INSERT INTO CHANSON VALUES(6099,'Le public en redemande',2,NULL,'f','2008-03-20 14:10:02');
INSERT INTO CHANSON VALUES(6104,'Dispersez vous',2,NULL,'f','2008-03-20 15:06:04');
INSERT INTO CHANSON VALUES(6160,'Afraid',2,NULL,'f','2008-03-12 16:06:28');
INSERT INTO CHANSON VALUES(6161,'Maneater',2,NULL,'f','2008-03-12 14:40:25');
INSERT INTO CHANSON VALUES(6162,'Promiscuous',2,NULL,'f','2008-03-12 19:26:04');
INSERT INTO CHANSON VALUES(6163,'Glow',2,NULL,NULL,'2008-03-12 14:24:48');
INSERT INTO CHANSON VALUES(6164,'Showtime',2,NULL,'f','2008-03-12 18:18:38');
INSERT INTO CHANSON VALUES(6165,'No Hay Igual',2,NULL,'f','2008-03-12 10:01:37');
INSERT INTO CHANSON VALUES(6166,'Te Busque',2,NULL,'f','2008-03-12 09:43:37');
INSERT INTO CHANSON VALUES(6167,'Say It Right',2,NULL,'f','2008-03-12 11:49:50');
INSERT INTO CHANSON VALUES(6168,'Do It',2,NULL,'f','2008-03-12 09:23:38');
INSERT INTO CHANSON VALUES(6169,'In God''s Hands',2,NULL,'f','2008-03-12 10:14:55');
INSERT INTO CHANSON VALUES(6170,'What I Wanted',2,NULL,'f','2008-03-12 10:57:01');
INSERT INTO CHANSON VALUES(6171,'Wait For You',2,NULL,'f','2008-03-12 16:28:42');
INSERT INTO CHANSON VALUES(6172,'All Good Things (Come To An En',2,NULL,'f','2008-03-12 09:24:09');
INSERT INTO CHANSON VALUES(6173,'Let My Hair Down',2,NULL,'f','2008-03-12 10:54:33');
INSERT INTO CHANSON VALUES(6174,'Somebody To love',2,NULL,'f','2008-03-12 19:48:51');
INSERT INTO CHANSON VALUES(6175,'You''ve Got A Chance',2,NULL,'f','2008-03-12 15:02:53');
INSERT INTO CHANSON VALUES(6176,'It''s A Long Way To The Promised Land',2,NULL,'f','2008-03-12 10:08:36');
INSERT INTO CHANSON VALUES(6177,'A World Without Melody',2,NULL,'f','2008-03-12 18:26:26');
INSERT INTO CHANSON VALUES(6178,'New America',2,NULL,'f','2008-03-12 16:32:50');
INSERT INTO CHANSON VALUES(6179,'1000 Memories',2,NULL,'f','2008-03-12 12:45:04');
INSERT INTO CHANSON VALUES(6180,'A Streetkid Named Desire',2,NULL,'f','2008-03-12 11:56:01');
INSERT INTO CHANSON VALUES(6181,'Whisper In Time',2,NULL,'f','2008-03-12 11:37:30');
INSERT INTO CHANSON VALUES(6182,'Believe It',2,NULL,NULL,'2008-03-12 08:42:54');
INSERT INTO CHANSON VALUES(6183,'I Love My Computer',2,NULL,'f','2008-03-12 09:52:49');
INSERT INTO CHANSON VALUES(6184,'The Hopeless Housewife',2,NULL,'f','2008-03-12 16:51:38');
INSERT INTO CHANSON VALUES(6185,'There Will Be A Way',2,NULL,'f','2008-03-12 14:27:40');
INSERT INTO CHANSON VALUES(6186,'Let It Burn',2,NULL,'f','2008-03-12 13:41:49');
INSERT INTO CHANSON VALUES(6187,'Don''t Sell Me Short',2,NULL,'f','2008-03-12 08:32:15');
INSERT INTO CHANSON VALUES(6188,'The Fast Life',2,NULL,'f','2008-03-12 13:14:48');
INSERT INTO CHANSON VALUES(6189,'Quelle heure reptile ?',2,NULL,NULL,'2008-03-12 11:34:33');
INSERT INTO CHANSON VALUES(6190,'Les éléphants',2,NULL,NULL,'2008-03-12 12:50:30');
INSERT INTO CHANSON VALUES(6191,'Tic-Tac',2,NULL,'f','2008-03-12 13:08:07');
INSERT INTO CHANSON VALUES(6192,'Horribles regrets suite à la déchirure, donc !',2,NULL,'f','2008-03-12 19:08:50');
INSERT INTO CHANSON VALUES(6193,'Haute tension Léon',2,NULL,'f','2008-03-12 18:17:43');
INSERT INTO CHANSON VALUES(6194,'La bière',2,NULL,'f','2008-03-12 16:00:34');
INSERT INTO CHANSON VALUES(6195,'Tout ça m''est tergal',2,NULL,'f','2008-03-12 11:34:02');
INSERT INTO CHANSON VALUES(6197,'Je ne vois pas pourquoi vous reggae',2,NULL,'f','2008-03-12 17:04:17');
INSERT INTO CHANSON VALUES(6198,'Troupeau pour être vrai',2,NULL,'f','2008-03-12 08:34:32');
INSERT INTO CHANSON VALUES(6199,'Le puéricultwist',2,NULL,'f','2008-03-12 18:54:07');
INSERT INTO CHANSON VALUES(6200,'Boogie sonne le glas ?',2,NULL,'f','2008-03-12 13:19:57');
INSERT INTO CHANSON VALUES(6201,'Zorro',2,NULL,'f','2008-03-12 19:45:05');
INSERT INTO CHANSON VALUES(6202,'Le cerf',2,NULL,'f','2008-03-12 09:42:14');
INSERT INTO CHANSON VALUES(6217,'Enlève ta langue',2,NULL,NULL,'2008-03-12 19:33:31');
INSERT INTO CHANSON VALUES(6218,'I''m not into hop',2,NULL,NULL,'2008-03-12 15:14:31');
INSERT INTO CHANSON VALUES(6219,'Mourir à plusieurs',2,NULL,'f','2008-03-12 10:32:06');
INSERT INTO CHANSON VALUES(6220,'Miss Amérique',2,NULL,'f','2008-03-12 11:32:07');
INSERT INTO CHANSON VALUES(6221,'Reviens Marie',2,NULL,'f','2008-03-12 08:21:11');
INSERT INTO CHANSON VALUES(6222,'From zero to hero',2,NULL,'f','2008-03-12 11:25:46');
INSERT INTO CHANSON VALUES(6223,'Jusqu''au bout',2,NULL,'f','2008-04-24 10:44:00');
INSERT INTO CHANSON VALUES(6224,'Hit the night',2,NULL,'f','2008-03-12 18:18:40');
INSERT INTO CHANSON VALUES(6225,'Douce',2,NULL,'f','2008-03-12 19:44:00');
INSERT INTO CHANSON VALUES(6226,'Red lipstick',2,NULL,'f','2008-03-12 19:41:45');
INSERT INTO CHANSON VALUES(6227,'Toute la nuit',2,NULL,'f','2008-03-12 08:47:28');
INSERT INTO CHANSON VALUES(6228,'Een boeket met pisseblomen',2,NULL,'f','2008-03-12 11:42:01');
INSERT INTO CHANSON VALUES(6229,'Les filles de mon quartier',2,NULL,'f','2008-03-12 17:22:16');
INSERT INTO CHANSON VALUES(6230,'Help me mary',2,NULL,'f','2008-03-12 12:36:49');
INSERT INTO CHANSON VALUES(6231,'999',2,NULL,'f','2008-03-12 13:54:21');
INSERT INTO CHANSON VALUES(6232,'Wicked As It Seems',2,NULL,'f','2008-03-12 14:56:42');
INSERT INTO CHANSON VALUES(6233,'Eileen',2,NULL,NULL,'2008-03-20 17:15:07');
INSERT INTO CHANSON VALUES(6234,'Words Of Wonder',2,NULL,NULL,'2008-03-12 14:07:26');
INSERT INTO CHANSON VALUES(6235,'Yap Yap',2,NULL,'f','2008-03-12 10:06:10');
INSERT INTO CHANSON VALUES(6236,'Bodytalks',2,NULL,'f','2008-03-12 10:03:52');
INSERT INTO CHANSON VALUES(6237,'Hate It When You Leave',2,NULL,'f','2008-03-12 19:05:39');
INSERT INTO CHANSON VALUES(6238,'Runnin'' Too Deep',2,NULL,'f','2008-03-12 13:22:22');
INSERT INTO CHANSON VALUES(6239,'Will But You Won''t',2,NULL,'f','2008-03-12 13:10:45');
INSERT INTO CHANSON VALUES(6240,'Demon',2,NULL,'f','2008-03-12 17:30:21');
INSERT INTO CHANSON VALUES(6243,'Mother Of Pearl',2,NULL,'f','2008-03-12 15:15:27');
INSERT INTO CHANSON VALUES(6245,'Dance Away',2,NULL,'f','2008-03-12 10:59:41');
INSERT INTO CHANSON VALUES(6247,'Editions Of You',2,NULL,'f','2008-03-12 11:11:49');
INSERT INTO CHANSON VALUES(6248,'Virginia Plain',2,NULL,'f','2008-03-12 18:38:11');
INSERT INTO CHANSON VALUES(6249,'Love Is A Drug',2,NULL,'f','2008-03-12 11:07:22');
INSERT INTO CHANSON VALUES(6251,'For Pour Pleasure',2,NULL,'f','2008-03-12 12:26:49');
INSERT INTO CHANSON VALUES(6252,'Video-Track',2,NULL,'f','2008-03-12 16:21:19');
INSERT INTO CHANSON VALUES(6254,'the eyes of the children of maria',2,NULL,'f','2008-03-12 12:45:21');
INSERT INTO CHANSON VALUES(6255,'the last of the rock stars',2,NULL,'f','2008-03-12 19:57:21');
INSERT INTO CHANSON VALUES(6258,'silver bullet',2,NULL,'f','2008-03-12 10:29:24');
INSERT INTO CHANSON VALUES(6259,'hey miss betty',2,NULL,'f','2008-03-12 12:47:31');
INSERT INTO CHANSON VALUES(6262,'How''s the family',2,NULL,'f','2008-06-01 18:32:51.699779');
INSERT INTO CHANSON VALUES(6265,'Dead End Street',2,NULL,'f','2008-03-12 12:08:57');
INSERT INTO CHANSON VALUES(6266,'Big Black Smoke',2,NULL,'f','2008-03-12 16:03:54');
INSERT INTO CHANSON VALUES(6267,'Waterloo Sunset',2,NULL,'f','2008-03-12 08:40:14');
INSERT INTO CHANSON VALUES(6268,'Act Nice and Gentle',2,NULL,'f','2008-03-12 15:00:49');
INSERT INTO CHANSON VALUES(6269,'Autumn Almanac',2,NULL,'f','2008-03-12 13:11:19');
INSERT INTO CHANSON VALUES(6270,'Nr, Pleasant',2,NULL,'f','2008-03-12 17:33:06');
INSERT INTO CHANSON VALUES(6271,'Poly',2,NULL,'f','2008-03-12 12:18:56');
INSERT INTO CHANSON VALUES(6272,'Wonderboy',2,NULL,NULL,'2008-03-12 16:55:11');
INSERT INTO CHANSON VALUES(6273,'Days',2,NULL,'f','2008-03-12 14:22:07');
INSERT INTO CHANSON VALUES(6274,'She''s Got Everything',2,NULL,'f','2008-03-12 17:08:55');
INSERT INTO CHANSON VALUES(6275,'King Kong',2,NULL,'f','2008-03-12 19:29:03');
INSERT INTO CHANSON VALUES(6276,'Plastic Man',2,NULL,NULL,'2008-03-12 18:12:07');
INSERT INTO CHANSON VALUES(6277,'This Man He Weeps Tonight',2,NULL,NULL,'2008-03-12 17:17:47');
INSERT INTO CHANSON VALUES(6278,'Shangri La',2,NULL,NULL,'2008-03-12 08:57:48');
INSERT INTO CHANSON VALUES(6279,'Victoria',2,NULL,'f','2008-03-12 18:22:59');
INSERT INTO CHANSON VALUES(6280,'Mr Churchill Says',2,NULL,'f','2008-03-12 10:12:33');
INSERT INTO CHANSON VALUES(6281,'Lola',2,NULL,'f','2008-03-12 11:33:51');
INSERT INTO CHANSON VALUES(6282,'Berkeley Mews',2,NULL,'f','2008-03-12 11:17:47');
INSERT INTO CHANSON VALUES(6283,'Rats',2,NULL,'f','2008-03-12 13:52:09');
INSERT INTO CHANSON VALUES(6284,'Apeman',2,NULL,'f','2008-03-12 14:39:18');
INSERT INTO CHANSON VALUES(6285,'Rêver D''L',2,NULL,'f','2008-03-12 13:36:47');
INSERT INTO CHANSON VALUES(6286,'Je Joue',2,NULL,'f','2008-03-12 14:31:00');
INSERT INTO CHANSON VALUES(6287,'Elle Pleure',2,NULL,'f','2008-03-12 16:21:18');
INSERT INTO CHANSON VALUES(6288,'Les Frleuses',2,NULL,'f','2008-03-12 13:24:15');
INSERT INTO CHANSON VALUES(6289,'Audimat',2,NULL,'f','2008-03-12 11:17:38');
INSERT INTO CHANSON VALUES(6290,'La Saga Des Gnous',2,NULL,'f','2008-03-12 11:29:50');
INSERT INTO CHANSON VALUES(6291,'Sous La Pluie',2,NULL,'f','2008-03-12 18:47:23');
INSERT INTO CHANSON VALUES(6292,'Sans Toi',2,NULL,'f','2008-03-12 16:03:41');
INSERT INTO CHANSON VALUES(6293,'J''ai Pas Le Temps',2,NULL,'f','2008-03-12 13:30:34');
INSERT INTO CHANSON VALUES(6294,'Tant Pis Pour Tout',2,NULL,'f','2008-03-12 15:05:13');
INSERT INTO CHANSON VALUES(6295,'Rendez-vous Là-haut',2,NULL,'f','2008-03-12 19:34:50');
INSERT INTO CHANSON VALUES(6296,'Longtemps',2,NULL,'f','2008-03-12 16:08:21');
INSERT INTO CHANSON VALUES(6297,'I Took My Baby Home',2,NULL,'f','2008-03-12 17:50:43');
INSERT INTO CHANSON VALUES(6299,'You Still Want Me',2,NULL,'f','2008-03-12 12:36:25');
INSERT INTO CHANSON VALUES(6300,'You Do Something To Me',2,NULL,'f','2008-03-12 19:54:54');
INSERT INTO CHANSON VALUES(6301,'You Really Got Me',2,NULL,'f','2008-03-12 17:44:42');
INSERT INTO CHANSON VALUES(6302,'It''s All Right',2,NULL,'f','2008-03-12 10:26:46');
INSERT INTO CHANSON VALUES(6303,'All Day And All Of The Night',2,NULL,NULL,'2008-03-12 18:55:16');
INSERT INTO CHANSON VALUES(6304,'I Gotta Move',2,NULL,'f','2008-03-12 13:34:21');
INSERT INTO CHANSON VALUES(6305,'Tired Of Waiting For You',2,NULL,'f','2008-03-12 16:31:56');
INSERT INTO CHANSON VALUES(6306,'Come On Now',2,NULL,'f','2008-03-12 14:16:05');
INSERT INTO CHANSON VALUES(6307,'Everybody''s Gonna Be Happy',2,NULL,'f','2008-03-12 18:01:55');
INSERT INTO CHANSON VALUES(6308,'Wholl Be Next In Line',2,NULL,'f','2008-03-12 15:06:14');
INSERT INTO CHANSON VALUES(6309,'I Need You',2,NULL,'f','2008-03-12 16:26:51');
INSERT INTO CHANSON VALUES(6310,'Set Me Free',2,NULL,NULL,'2008-03-12 10:25:45');
INSERT INTO CHANSON VALUES(6311,'See My Friends',2,NULL,NULL,'2008-03-12 08:14:30');
INSERT INTO CHANSON VALUES(6312,'Never Met A Girl Like You Before',2,NULL,'f','2008-03-12 17:27:57');
INSERT INTO CHANSON VALUES(6313,'Till The End Of The Day',2,NULL,'f','2008-03-12 14:22:53');
INSERT INTO CHANSON VALUES(6315,'Sunny Afternoon',2,NULL,'f','2008-03-12 10:31:59');
INSERT INTO CHANSON VALUES(6316,'I''m Not Like Everybody Else',2,NULL,'f','2008-03-12 09:03:15');
INSERT INTO CHANSON VALUES(6318,'Beauty Queen',2,NULL,'f','2008-03-12 09:33:23');
INSERT INTO CHANSON VALUES(6319,'Strictly Confidential',2,NULL,NULL,'2008-03-12 12:18:50');
INSERT INTO CHANSON VALUES(6323,'Grey Lagoons',2,NULL,'f','2008-03-12 13:54:20');
INSERT INTO CHANSON VALUES(6324,'For Your Pleasure',2,NULL,'f','2008-03-12 12:44:11');
INSERT INTO CHANSON VALUES(6325,'In The Midnight Hour',2,NULL,'f','2008-03-12 18:57:43');
INSERT INTO CHANSON VALUES(6327,'Same Old Scene',2,NULL,'f','2008-03-12 09:20:43');
INSERT INTO CHANSON VALUES(6328,'Flesh And Blood',2,NULL,'f','2008-03-12 12:30:17');
INSERT INTO CHANSON VALUES(6329,'My Only Love',2,NULL,'f','2008-03-12 17:55:35');
INSERT INTO CHANSON VALUES(6330,'Over You',2,NULL,'f','2008-03-12 15:11:03');
INSERT INTO CHANSON VALUES(6331,'Eight Miles High',2,NULL,'f','2008-03-12 18:13:36');
INSERT INTO CHANSON VALUES(6332,'Rain, Rain, Rain',2,NULL,'f','2008-03-12 12:45:57');
INSERT INTO CHANSON VALUES(6333,'No Strange Delight',2,NULL,NULL,'2008-03-12 12:15:51');
INSERT INTO CHANSON VALUES(6334,'Running Wild',2,NULL,'f','2008-03-12 16:38:36');
INSERT INTO CHANSON VALUES(6335,'Love Is The Drug',2,NULL,'f','2008-03-12 18:28:33');
INSERT INTO CHANSON VALUES(6336,'End Of The Line',2,NULL,'f','2008-03-12 15:18:39');
INSERT INTO CHANSON VALUES(6337,'Sentimental Fool',2,NULL,'f','2008-03-12 12:23:00');
INSERT INTO CHANSON VALUES(6338,'Whirlwind',2,NULL,'f','2008-03-12 09:45:30');
INSERT INTO CHANSON VALUES(6339,'She Sells',2,NULL,'f','2008-03-12 12:32:25');
INSERT INTO CHANSON VALUES(6340,'Could It Happen To Me',2,NULL,'f','2008-04-11 09:26:40');
INSERT INTO CHANSON VALUES(6342,'Nightingale',2,NULL,'f','2008-03-12 08:02:50');
INSERT INTO CHANSON VALUES(6343,'Just Another High',2,NULL,'f','2008-03-12 16:27:36');
INSERT INTO CHANSON VALUES(6344,'Hole In The Sky',2,NULL,'f','2008-03-12 15:49:52');
INSERT INTO CHANSON VALUES(6345,'Into The Void',2,NULL,'f','2008-03-12 13:33:30');
INSERT INTO CHANSON VALUES(6346,'Sabbath Bloody Sabbath',2,NULL,'f','2008-03-12 09:27:58');
INSERT INTO CHANSON VALUES(6347,'N.I.B.',2,NULL,'f','2008-03-12 15:04:17');
INSERT INTO CHANSON VALUES(6348,'Paranoid',2,NULL,'f','2008-03-12 11:28:40');
INSERT INTO CHANSON VALUES(6349,'War Pigs',2,NULL,NULL,'2008-03-12 11:35:26');
INSERT INTO CHANSON VALUES(6350,'Iron Man',2,NULL,NULL,'2008-03-12 17:00:58');
INSERT INTO CHANSON VALUES(6351,'Wicked World',2,NULL,'f','2008-03-12 11:00:08');
INSERT INTO CHANSON VALUES(6352,'Supernaut',2,NULL,'f','2008-03-12 18:03:11');
INSERT INTO CHANSON VALUES(6353,'Back Street Kids',2,NULL,'f','2008-03-12 16:43:38');
INSERT INTO CHANSON VALUES(6354,'Never Say Die',2,NULL,'f','2008-03-12 12:20:28');
INSERT INTO CHANSON VALUES(6355,'Neon Knights',2,NULL,'f','2008-03-12 10:49:01');
INSERT INTO CHANSON VALUES(6356,'Mob Rules',2,NULL,'f','2008-03-12 16:55:28');
INSERT INTO CHANSON VALUES(6357,'The Dark / Zero The Hero',2,NULL,'f','2008-03-12 16:34:33');
INSERT INTO CHANSON VALUES(6358,'Black Sabbath',2,NULL,'f','2008-03-12 19:53:01');
INSERT INTO CHANSON VALUES(6359,'Out for the killing',2,NULL,NULL,'2008-03-12 16:12:37');
INSERT INTO CHANSON VALUES(6360,'Clean it up',2,NULL,'f','2008-03-12 09:02:38');
INSERT INTO CHANSON VALUES(6361,'Taking the silence',2,NULL,'f','2008-03-12 09:17:38');
INSERT INTO CHANSON VALUES(6362,'People don''t learn',2,NULL,'f','2008-03-12 10:10:42');
INSERT INTO CHANSON VALUES(6365,'Many can read',2,NULL,'f','2008-03-12 14:28:36');
INSERT INTO CHANSON VALUES(6366,'Chain of pain',2,NULL,'f','2008-03-12 14:11:32');
INSERT INTO CHANSON VALUES(6367,'You got it made',2,NULL,'f','2008-03-12 08:53:06');
INSERT INTO CHANSON VALUES(6368,'The fall of Saigon',2,NULL,'f','2008-03-12 14:53:59');
INSERT INTO CHANSON VALUES(6369,'Continental kinda girl',2,NULL,NULL,'2008-03-12 15:33:12');
INSERT INTO CHANSON VALUES(6371,'It feels like',2,NULL,'f','2008-03-12 18:45:32');
INSERT INTO CHANSON VALUES(6372,'Razor love',2,NULL,'f','2008-03-12 14:59:42');
INSERT INTO CHANSON VALUES(6377,'Talkin'' about America',2,NULL,'f','2008-03-12 15:33:26');
INSERT INTO CHANSON VALUES(6378,'Euro-tour',2,NULL,'f','2008-03-12 16:07:19');
INSERT INTO CHANSON VALUES(6379,'Sicily',2,NULL,'f','2008-03-12 16:44:53');
INSERT INTO CHANSON VALUES(6381,'If poets were king',2,NULL,'f','2008-03-12 09:51:19');
INSERT INTO CHANSON VALUES(6382,'Niagara falls',2,NULL,'f','2008-03-12 16:23:18');
INSERT INTO CHANSON VALUES(6383,'In a minute',2,NULL,'f','2008-03-12 12:37:42');
INSERT INTO CHANSON VALUES(6384,'Time flies',2,NULL,'f','2008-03-12 08:17:10');
INSERT INTO CHANSON VALUES(6385,'Let it rain',2,NULL,'f','2008-03-12 18:44:09');
INSERT INTO CHANSON VALUES(6386,'Sacrifice',2,NULL,'f','2008-03-12 11:48:41');
INSERT INTO CHANSON VALUES(6387,'I couldn''t touch you',2,NULL,NULL,'2008-03-12 17:24:14');
INSERT INTO CHANSON VALUES(6388,'Party girls & Broken poets',2,NULL,NULL,'2008-03-12 10:07:21');
INSERT INTO CHANSON VALUES(6389,'Geindre',2,NULL,NULL,'2008-03-12 14:50:06');
INSERT INTO CHANSON VALUES(6390,'Faut pas s''inquiéter',2,NULL,'f','2008-03-12 13:45:04');
INSERT INTO CHANSON VALUES(6391,'Betty',2,NULL,'f','2008-03-12 08:55:56');
INSERT INTO CHANSON VALUES(6392,'A quoi servent les prières',2,NULL,'f','2008-03-12 12:37:19');
INSERT INTO CHANSON VALUES(6393,'Parking',2,NULL,'f','2008-03-12 15:01:57');
INSERT INTO CHANSON VALUES(6394,'Joyeux anniversaire',2,NULL,'f','2008-03-12 12:03:14');
INSERT INTO CHANSON VALUES(6395,'Qu''importent les spasmes',2,NULL,'f','2008-03-12 14:58:59');
INSERT INTO CHANSON VALUES(6396,'Ronde',2,NULL,'f','2008-03-12 16:14:47');
INSERT INTO CHANSON VALUES(6397,'Si Dormir Faisait',2,NULL,'f','2008-03-12 12:03:12');
INSERT INTO CHANSON VALUES(6398,'Allaient-ils s''aimer ?',2,NULL,'f','2008-03-12 15:17:20');
INSERT INTO CHANSON VALUES(6399,'Il incesta',2,NULL,'f','2008-03-12 19:52:11');
INSERT INTO CHANSON VALUES(6400,'Anguille',2,NULL,'f','2008-03-12 09:21:57');
INSERT INTO CHANSON VALUES(6401,'Fond de cale',2,NULL,'f','2008-03-12 10:23:52');
INSERT INTO CHANSON VALUES(6402,'Il y a dans les rues de la ville',2,NULL,'f','2008-03-12 09:44:30');
INSERT INTO CHANSON VALUES(6403,'Il faudra bien t''asseoir',2,NULL,'f','2008-03-12 13:23:31');
INSERT INTO CHANSON VALUES(6404,'J''t''aime bien',2,NULL,'f','2008-03-12 12:45:35');
INSERT INTO CHANSON VALUES(6405,'Il boit du café',2,NULL,'f','2008-03-12 15:18:34');
INSERT INTO CHANSON VALUES(6406,'Homosexuel',2,NULL,'f','2008-03-12 15:59:49');
INSERT INTO CHANSON VALUES(6407,'J''peux plus t''dire que j''t''aime',2,NULL,'f','2008-03-12 12:22:52');
INSERT INTO CHANSON VALUES(6408,'Aldebert',2,NULL,'f','2008-03-12 15:00:10');
INSERT INTO CHANSON VALUES(6409,'Pigalle',2,NULL,'f','2008-03-12 19:59:03');
INSERT INTO CHANSON VALUES(6410,'La Goutte d''Or',2,NULL,'f','2008-03-12 09:04:24');
INSERT INTO CHANSON VALUES(6411,'Elle glisse',2,NULL,NULL,'2008-03-12 09:15:47');
INSERT INTO CHANSON VALUES(6412,'Couper le cordon',2,NULL,'f','2008-03-12 08:21:31');
INSERT INTO CHANSON VALUES(6413,'Franc tireur',2,NULL,'f','2008-03-12 14:48:55');
INSERT INTO CHANSON VALUES(6414,'Fait divers',2,NULL,'f','2008-03-12 08:11:41');
INSERT INTO CHANSON VALUES(6415,'La fille au teint rouge',2,NULL,NULL,'2008-03-12 15:49:59');
INSERT INTO CHANSON VALUES(6416,'Brèves rencontres',2,NULL,'f','2008-03-12 10:26:58');
INSERT INTO CHANSON VALUES(6417,'Dans la salle du Bar-Tabac... (orgue de barbarie)',2,NULL,'f','2008-03-12 08:51:21');
INSERT INTO CHANSON VALUES(6419,'Chez Rascal et Ronan',2,NULL,'f','2008-03-12 08:27:21');
INSERT INTO CHANSON VALUES(6421,'En Bas, En Haut',2,NULL,'f','2008-03-12 14:44:41');
INSERT INTO CHANSON VALUES(6422,'Le Chaland',2,NULL,'f','2008-03-12 11:44:03');
INSERT INTO CHANSON VALUES(6423,'Angèle',2,NULL,'f','2008-03-12 18:15:51');
INSERT INTO CHANSON VALUES(6424,'L''éboueur',2,NULL,'f','2008-03-12 17:17:02');
INSERT INTO CHANSON VALUES(6425,'Première fois',2,NULL,'f','2008-03-12 13:55:52');
INSERT INTO CHANSON VALUES(6427,'Marie la Rouquine',2,NULL,'f','2008-03-12 13:09:09');
INSERT INTO CHANSON VALUES(6430,'Dans la salle du Bar-Tabac de la rue des Martyrs',2,NULL,'f','2008-03-12 14:16:43');
INSERT INTO CHANSON VALUES(6431,'Eternel salaud',2,NULL,'f','2008-03-12 19:48:27');
INSERT INTO CHANSON VALUES(6432,'Une nuit',2,NULL,'f','2008-03-12 15:08:12');
INSERT INTO CHANSON VALUES(6434,'Les lettres de l''autoroute',2,NULL,'f','2008-03-12 14:46:44');
INSERT INTO CHANSON VALUES(6435,'Sophie de Nantes',2,NULL,'f','2008-03-12 15:14:40');
INSERT INTO CHANSON VALUES(6436,'Pauvre grand',2,NULL,'f','2008-03-12 13:41:47');
INSERT INTO CHANSON VALUES(6438,'Paris, le soir',2,NULL,'f','2008-03-12 19:55:01');
INSERT INTO CHANSON VALUES(6439,'La Goutte d''Or (fin)',2,NULL,NULL,'2008-03-12 15:05:09');
INSERT INTO CHANSON VALUES(6440,'Les amants du vieux pont (studio)',2,NULL,'f','2008-03-12 16:36:25');
INSERT INTO CHANSON VALUES(6441,'Rungis',2,NULL,'f','2008-03-12 13:34:14');
INSERT INTO CHANSON VALUES(6442,'Le Fou au chien fou',2,NULL,'f','2008-03-12 18:13:22');
INSERT INTO CHANSON VALUES(6443,'Crime contre l''humanité (Le pape a dit : "Plastique tu ne mettras pas")',2,NULL,'f','2008-03-12 09:55:21');
INSERT INTO CHANSON VALUES(6444,'Derrière le mur',2,NULL,'f','2008-03-12 14:28:08');
INSERT INTO CHANSON VALUES(6445,'Ne reviens !',2,NULL,'f','2008-03-12 11:04:22');
INSERT INTO CHANSON VALUES(6446,'La Petite Cirrhose du port de Copenhague',2,NULL,'f','2008-03-12 19:33:04');
INSERT INTO CHANSON VALUES(6447,'Le Dernier Eléphant',2,NULL,'f','2008-03-12 17:20:11');
INSERT INTO CHANSON VALUES(6448,'Un amour simple',2,NULL,'f','2008-03-12 16:16:06');
INSERT INTO CHANSON VALUES(6449,'Paris 2034, vingtième jour d''insurrection',2,NULL,'f','2008-03-12 17:52:12');
INSERT INTO CHANSON VALUES(6450,'Maîtresse au goût de terroir',2,NULL,'f','2008-03-12 18:34:48');
INSERT INTO CHANSON VALUES(6451,'Et pourtant si',2,NULL,'f','2008-03-12 12:59:23');
INSERT INTO CHANSON VALUES(6452,'L''Amour forain',2,NULL,'f','2008-03-12 15:52:36');
INSERT INTO CHANSON VALUES(6453,'Vendredi 13',2,NULL,'f','2008-03-12 19:58:31');
INSERT INTO CHANSON VALUES(6454,'Patate',2,NULL,NULL,'2008-03-12 11:31:00');
INSERT INTO CHANSON VALUES(6455,'On assassine Belleville',2,NULL,NULL,'2008-03-12 13:49:05');
INSERT INTO CHANSON VALUES(6456,'Les deux surs',2,NULL,'f','2008-03-24 18:47:38');
INSERT INTO CHANSON VALUES(6457,'Dis-moi si ça vaut le coup de rester',2,NULL,'f','2008-03-12 18:34:58');
INSERT INTO CHANSON VALUES(6458,'Buddha Of Suburbia',2,NULL,'f','2008-06-07 19:00:33.860663');
INSERT INTO CHANSON VALUES(6459,'Sex And The Church',2,NULL,'f','2008-06-07 20:01:37.736996');
INSERT INTO CHANSON VALUES(6460,'South Horizon',2,NULL,NULL,'2008-06-07 19:40:58.825028');
INSERT INTO CHANSON VALUES(6461,'The Mysteries',2,NULL,'f','2008-06-07 19:40:13.790342');
INSERT INTO CHANSON VALUES(6462,'Bleed Like A Craze, Dad',2,NULL,'f','2008-06-07 18:59:59.678106');
INSERT INTO CHANSON VALUES(6464,'Dead Against It',2,NULL,'f','2008-06-07 18:45:46.257822');
INSERT INTO CHANSON VALUES(6465,'Untitled No. 1',2,NULL,'f','2008-06-07 18:44:09.995048');
INSERT INTO CHANSON VALUES(6466,'Ian Fish, U.K. Heir',2,NULL,NULL,'2008-06-07 20:21:38.96161');
INSERT INTO CHANSON VALUES(6467,'Buddha Of Suburbia',2,NULL,'f','2008-06-07 19:00:41.749591');
INSERT INTO CHANSON VALUES(6477,'Pneumonia alley',2,NULL,'f','2008-03-12 09:01:30');
INSERT INTO CHANSON VALUES(6478,'As good as',2,NULL,'f','2008-03-12 13:28:01');
INSERT INTO CHANSON VALUES(6479,'A touch of kindness',2,NULL,'f','2008-03-12 08:11:45');
INSERT INTO CHANSON VALUES(6480,'Making friends with the dead',2,NULL,'f','2008-03-12 16:03:53');
INSERT INTO CHANSON VALUES(6481,'40 Days and 40 nights',2,NULL,'f','2008-03-12 11:37:16');
INSERT INTO CHANSON VALUES(6482,'Losing it',2,NULL,'f','2008-03-12 10:54:14');
INSERT INTO CHANSON VALUES(6483,'The prince of chaos',2,NULL,'f','2008-03-12 08:46:26');
INSERT INTO CHANSON VALUES(6484,'Mary Ann''s garage sale',2,NULL,'f','2008-03-12 17:12:22');
INSERT INTO CHANSON VALUES(6485,'Not enough time',2,NULL,'f','2008-03-12 16:43:04');
INSERT INTO CHANSON VALUES(6486,'Johnny boy gone',2,NULL,'f','2008-03-12 11:10:36');
INSERT INTO CHANSON VALUES(6487,'Canaries in the mind',2,NULL,'f','2008-03-12 12:19:38');
INSERT INTO CHANSON VALUES(6488,'Jesse',2,NULL,'f','2008-03-12 18:45:07');
INSERT INTO CHANSON VALUES(6489,'Home again',2,NULL,'f','2008-03-12 18:47:19');
INSERT INTO CHANSON VALUES(6501,'Connection',2,NULL,'f','2008-06-01 19:45:01.569532');
INSERT INTO CHANSON VALUES(6503,'Clandestino',2,NULL,'f','2008-03-12 19:55:50');
INSERT INTO CHANSON VALUES(6504,'Desaparecido',2,NULL,'f','2008-03-12 18:58:53');
INSERT INTO CHANSON VALUES(6505,'Bongo Bong',2,NULL,'f','2008-03-19 14:28:44');
INSERT INTO CHANSON VALUES(6506,'Je Ne T''Aime Plus',2,NULL,NULL,'2008-03-12 13:20:17');
INSERT INTO CHANSON VALUES(6507,'Mentira...',2,NULL,NULL,'2008-03-12 08:16:06');
INSERT INTO CHANSON VALUES(6508,'Lagrimas De Oro',2,NULL,NULL,'2008-03-12 17:49:18');
INSERT INTO CHANSON VALUES(6509,'Mama Call',2,NULL,'f','2008-03-12 18:01:22');
INSERT INTO CHANSON VALUES(6510,'Luna Y Sol',2,NULL,'f','2008-03-12 17:19:20');
INSERT INTO CHANSON VALUES(6511,'Por El Suelo',2,NULL,'f','2008-03-12 13:57:56');
INSERT INTO CHANSON VALUES(6512,'Welcome To Tijuana',2,NULL,'f','2008-03-12 14:56:03');
INSERT INTO CHANSON VALUES(6513,'Dia Luna... Dia Pena',2,NULL,'f','2008-03-12 13:55:59');
INSERT INTO CHANSON VALUES(6514,'Malegria',2,NULL,'f','2008-03-12 11:48:58');
INSERT INTO CHANSON VALUES(6515,'La Vie A 2',2,NULL,'f','2008-03-12 10:21:26');
INSERT INTO CHANSON VALUES(6516,'Minha Galera',2,NULL,'f','2008-03-12 19:46:46');
INSERT INTO CHANSON VALUES(6517,'La Despedida',2,NULL,'f','2008-03-12 10:48:03');
INSERT INTO CHANSON VALUES(6518,'El Viento',2,NULL,'f','2008-03-12 11:36:53');
INSERT INTO CHANSON VALUES(6519,'Living on the End of a gun',0,NULL,'f','2008-03-12 15:31:54');
INSERT INTO CHANSON VALUES(6523,'A Crack in Time',0,NULL,'f','2008-03-12 12:46:04');
INSERT INTO CHANSON VALUES(6525,'Play with Fire',0,NULL,'f','2008-03-12 12:15:14');
INSERT INTO CHANSON VALUES(6527,'Should''ve Been Home with You',0,NULL,NULL,'2008-03-12 14:23:49');
INSERT INTO CHANSON VALUES(6529,'It''s Just You',0,NULL,'f','2008-03-12 14:22:57');
INSERT INTO CHANSON VALUES(6532,'Maybe Someday',0,NULL,'f','2008-03-12 18:04:21');
INSERT INTO CHANSON VALUES(6534,'Right on Time',0,NULL,'f','2008-03-12 09:48:11');
INSERT INTO CHANSON VALUES(6535,'A. blues',0,NULL,'f','2008-03-12 19:09:27');
INSERT INTO CHANSON VALUES(6536,'The Lady''s Second Song',3,NULL,NULL,'2008-03-12 10:56:38');
INSERT INTO CHANSON VALUES(6537,'Leda en de Zwaan (Agamemnon)',3,NULL,NULL,'2008-03-12 11:31:01');
INSERT INTO CHANSON VALUES(6538,'Tumbling',3,NULL,NULL,'2008-03-12 08:09:45');
INSERT INTO CHANSON VALUES(6539,'Ni Vandaag',3,NULL,NULL,'2008-03-12 14:41:07');
INSERT INTO CHANSON VALUES(6540,'Leda and the Swan (Sudden Blow)',3,NULL,NULL,'2008-03-12 13:08:31');
INSERT INTO CHANSON VALUES(6541,'Item-Sortilegium',3,NULL,NULL,'2008-03-12 16:50:17');
INSERT INTO CHANSON VALUES(6542,'The Wild Swans at Coole (The woodlands)',3,NULL,NULL,'2008-03-12 17:43:21');
INSERT INTO CHANSON VALUES(6543,'Serenade Portugaise',3,NULL,NULL,'2008-03-12 09:45:47');
INSERT INTO CHANSON VALUES(6544,'Joskesong',3,NULL,NULL,'2008-03-12 11:51:35');
INSERT INTO CHANSON VALUES(6545,'Before The World was made (Mirror, Mirror)',3,NULL,NULL,'2008-03-12 13:51:44');
INSERT INTO CHANSON VALUES(6546,'A Clymène',3,NULL,NULL,'2008-03-12 19:05:41');
INSERT INTO CHANSON VALUES(6547,'Pandora',3,NULL,NULL,'2008-03-12 14:20:12');
INSERT INTO CHANSON VALUES(6548,'Witte Bij',3,NULL,NULL,'2008-03-12 15:25:22');
INSERT INTO CHANSON VALUES(6549,'This Town Ain''t Big Enough For Both Of Us',2,NULL,'f','2008-03-12 12:56:04');
INSERT INTO CHANSON VALUES(6550,'Amateur Hour',2,NULL,'f','2008-03-12 13:24:12');
INSERT INTO CHANSON VALUES(6551,'Falling In Love With Myself Again',2,NULL,'f','2008-03-12 08:09:02');
INSERT INTO CHANSON VALUES(6552,'Here In Heaven',2,NULL,'f','2008-04-05 19:21:31');
INSERT INTO CHANSON VALUES(6553,'Thank God It''s Not Christmas',2,NULL,'f','2008-03-12 11:56:46');
INSERT INTO CHANSON VALUES(6554,'Hasta Manana Monsieur',2,NULL,'f','2008-04-05 15:52:28');
INSERT INTO CHANSON VALUES(6555,'Talent Is An Asset',2,NULL,NULL,'2008-03-12 15:05:31');
INSERT INTO CHANSON VALUES(6556,'Complaints',2,NULL,'f','2008-03-12 13:21:23');
INSERT INTO CHANSON VALUES(6557,'In My Family',2,NULL,'f','2008-03-12 08:50:14');
INSERT INTO CHANSON VALUES(6558,'Equator',2,NULL,'f','2008-03-12 17:46:20');
INSERT INTO CHANSON VALUES(6559,'Barbecutie',2,NULL,'f','2008-03-12 13:20:40');
INSERT INTO CHANSON VALUES(6560,'Lost And Found',2,NULL,'f','2008-03-12 16:56:06');
INSERT INTO CHANSON VALUES(6570,'All The Tired Horses',2,NULL,'f','2008-03-12 08:17:02');
INSERT INTO CHANSON VALUES(6571,'Alberta # 1',2,NULL,NULL,'2008-03-12 09:46:27');
INSERT INTO CHANSON VALUES(6572,'I Forgot More Than You''ll Ever Know',2,NULL,NULL,'2008-03-12 12:47:36');
INSERT INTO CHANSON VALUES(6573,'Days Of 49',2,NULL,'f','2008-03-12 12:05:33');
INSERT INTO CHANSON VALUES(6574,'Early Mornin'' Rain',2,NULL,'f','2008-03-12 10:44:38');
INSERT INTO CHANSON VALUES(6575,'In Search Of Little Sadie',2,NULL,'f','2008-03-12 16:11:00');
INSERT INTO CHANSON VALUES(6576,'Let It Be Me',2,NULL,'f','2008-03-12 09:14:51');
INSERT INTO CHANSON VALUES(6577,'Little Sadie',2,NULL,'f','2008-03-12 12:01:37');
INSERT INTO CHANSON VALUES(6578,'Woogie Boogie',2,NULL,'f','2008-03-12 16:31:57');
INSERT INTO CHANSON VALUES(6579,'Belle Isle',2,NULL,'f','2008-03-12 12:13:54');
INSERT INTO CHANSON VALUES(6580,'Living The Blues',2,NULL,'f','2008-03-12 13:18:11');
INSERT INTO CHANSON VALUES(6582,'Copper Kettle (The Pale Moonlight)',2,NULL,'f','2008-03-12 19:48:46');
INSERT INTO CHANSON VALUES(6583,'Gotta Travel On',2,NULL,'f','2008-03-12 14:12:51');
INSERT INTO CHANSON VALUES(6584,'Blue Moon',2,NULL,'f','2008-03-12 09:23:36');
INSERT INTO CHANSON VALUES(6586,'The Mighty Quinn (Quinn, The Eskimo)',2,NULL,'f','2008-03-12 17:11:02');
INSERT INTO CHANSON VALUES(6587,'Take Me As I Am (Or Let Me Go)',2,NULL,'f','2008-03-12 15:31:04');
INSERT INTO CHANSON VALUES(6588,'Take A Message To Mary',2,NULL,'f','2008-03-12 11:12:35');
INSERT INTO CHANSON VALUES(6589,'It Hurts Me Too',2,NULL,'f','2008-03-12 10:33:49');
INSERT INTO CHANSON VALUES(6590,'Minstrel Boy',2,NULL,NULL,'2008-09-28 10:50:36.415675');
INSERT INTO CHANSON VALUES(6592,'Wigwam',2,NULL,'f','2008-03-12 11:26:22');
INSERT INTO CHANSON VALUES(6593,'Alberta # 2',2,NULL,'f','2008-03-12 08:00:34');
INSERT INTO CHANSON VALUES(6595,'Tombstone Blues',2,NULL,'f','2008-03-12 14:54:03');
INSERT INTO CHANSON VALUES(6597,'From A Buick 6',2,NULL,'f','2008-03-12 12:19:45');
INSERT INTO CHANSON VALUES(6598,'Ballad Of A Thin Man',2,NULL,'f','2008-03-12 13:35:57');
INSERT INTO CHANSON VALUES(6599,'Queen Jane Approximately',2,NULL,'f','2008-03-12 08:48:31');
INSERT INTO CHANSON VALUES(6600,'Highway 61 Revisited',2,NULL,'f','2008-03-12 18:56:31');
INSERT INTO CHANSON VALUES(6601,'Just Like Tom Thumb''s Blues',2,NULL,NULL,'2008-03-12 19:15:01');
INSERT INTO CHANSON VALUES(6602,'Desolation Row',2,NULL,'f','2008-03-12 14:33:28');
INSERT INTO CHANSON VALUES(6603,'Tonight I''ll Be Staying Here With You',2,NULL,'f','2008-03-12 19:38:28');
INSERT INTO CHANSON VALUES(6604,'It Ain''t Me, Babe',2,NULL,'f','2008-03-12 14:34:36');
INSERT INTO CHANSON VALUES(6605,'A Hard Rain''s A-Gonna Fall',2,NULL,'f','2008-03-12 13:07:31');
INSERT INTO CHANSON VALUES(6606,'The Lonesome Death Of Hattie Carroll',2,NULL,'f','2008-03-12 14:28:12');
INSERT INTO CHANSON VALUES(6607,'Romance In Durango',2,NULL,'f','2008-03-12 17:51:32');
INSERT INTO CHANSON VALUES(6608,'Isis',2,NULL,'f','2008-03-12 14:18:07');
INSERT INTO CHANSON VALUES(6609,'Mr. Tambourine Man',2,NULL,'f','2008-03-12 13:22:55');
INSERT INTO CHANSON VALUES(6610,'Simple Twist Of Fate',2,NULL,'f','2008-03-12 08:14:51');
INSERT INTO CHANSON VALUES(6611,'Blowin'' In The Wind',2,NULL,'f','2008-03-12 14:14:07');
INSERT INTO CHANSON VALUES(6612,'Mama, You Been On My Mind',2,NULL,'f','2008-03-12 14:47:41');
INSERT INTO CHANSON VALUES(6613,'I Shall Be Released',2,NULL,NULL,'2008-03-12 08:43:19');
INSERT INTO CHANSON VALUES(6632,'L''espoir',5,NULL,'f','2008-03-12 14:14:54');
INSERT INTO CHANSON VALUES(6633,'Je ne te reconnais plus',5,NULL,'f','2008-03-12 09:42:01');
INSERT INTO CHANSON VALUES(6634,'1000 cœurs debout',5,NULL,'f','2008-05-26 16:11:50');
INSERT INTO CHANSON VALUES(6635,'Comme j''étais en vie',5,NULL,'f','2008-05-26 15:19:01');
INSERT INTO CHANSON VALUES(6636,'Je suis laid',5,NULL,'f','2008-03-12 15:14:30');
INSERT INTO CHANSON VALUES(6637,'Sophie Calle nâ°108',5,NULL,'f','2008-03-12 18:00:21');
INSERT INTO CHANSON VALUES(6638,'Résistance',5,NULL,'f','2008-05-26 11:44:35');
INSERT INTO CHANSON VALUES(6639,'Amoureuse',5,NULL,'f','2008-03-12 12:32:40');
INSERT INTO CHANSON VALUES(6640,'Pas la guerre',5,NULL,'f','2008-03-12 14:02:02');
INSERT INTO CHANSON VALUES(6641,'Giuseppe et Maria',5,NULL,'f','2008-03-12 13:03:17');
INSERT INTO CHANSON VALUES(6642,'Les beaux jours approchent',5,NULL,'f','2008-03-12 11:36:31');
INSERT INTO CHANSON VALUES(6643,'Je me sens belle',5,NULL,'f','2008-03-12 13:10:18');
INSERT INTO CHANSON VALUES(6644,'Paola',5,NULL,'f','2008-03-12 09:13:02');
INSERT INTO CHANSON VALUES(6645,'Le droit des pères',5,NULL,'f','2008-05-26 18:08:33');
INSERT INTO CHANSON VALUES(6646,'List of Lies',5,NULL,'f','2008-03-12 13:44:16');
INSERT INTO CHANSON VALUES(6648,'Canicule',5,NULL,'f','2008-05-26 19:34:04');
INSERT INTO CHANSON VALUES(6649,'Je suis liquide',5,NULL,'f','2008-05-26 13:04:03');
INSERT INTO CHANSON VALUES(6650,'Rondes larmes',5,NULL,'f','2008-05-26 14:56:07');
INSERT INTO CHANSON VALUES(6651,'Voilà',5,NULL,'f','2008-05-26 11:33:28');
INSERT INTO CHANSON VALUES(6652,'Le tissu',5,NULL,'f','2008-05-26 16:47:51');
INSERT INTO CHANSON VALUES(6653,'La peau sur les os',5,NULL,'f','2008-05-26 10:24:41');
INSERT INTO CHANSON VALUES(6654,'Tu m''attires',5,NULL,'f','2008-05-26 19:32:48');
INSERT INTO CHANSON VALUES(6655,'Frédéric',5,NULL,NULL,'2008-05-26 10:32:23');
INSERT INTO CHANSON VALUES(6656,'L''eau',5,NULL,NULL,'2008-05-26 08:05:07');
INSERT INTO CHANSON VALUES(6657,'On dirait que c''est normal',5,NULL,NULL,'2008-05-26 10:40:55');
INSERT INTO CHANSON VALUES(6658,'Une tonne',5,NULL,'f','2008-05-26 13:35:30');
INSERT INTO CHANSON VALUES(6659,'Merci',5,NULL,'f','2008-05-26 14:03:34');
INSERT INTO CHANSON VALUES(6660,'Petite soupe',5,NULL,NULL,'2008-05-26 15:35:30');
INSERT INTO CHANSON VALUES(6661,'Plage Opendisc',5,NULL,'f','2008-03-12 12:32:14');
INSERT INTO CHANSON VALUES(6662,'Changing of the Guards',2,NULL,'f','2008-03-12 18:24:15');
INSERT INTO CHANSON VALUES(6663,'New Pony',2,NULL,'f','2008-03-12 11:48:48');
INSERT INTO CHANSON VALUES(6664,'No Time to Think',2,NULL,'f','2008-03-12 19:20:51');
INSERT INTO CHANSON VALUES(6665,'Baby Stop Crying',2,NULL,'f','2008-03-12 19:47:55');
INSERT INTO CHANSON VALUES(6666,'Is Your Love in Vain?',2,NULL,'f','2008-03-12 11:07:31');
INSERT INTO CHANSON VALUES(6667,'Señor (Tales of Yankee Power)',2,NULL,'f','2008-03-12 17:34:42');
INSERT INTO CHANSON VALUES(6668,'True Love Tends to Forget',2,NULL,'f','2008-03-12 09:42:55');
INSERT INTO CHANSON VALUES(6669,'We Better Talk This Over',2,NULL,'f','2008-03-12 09:11:39');
INSERT INTO CHANSON VALUES(6670,'Where Are You Tonight? (Journey through Dark Heart)',2,NULL,'f','2008-03-12 12:33:32');
INSERT INTO CHANSON VALUES(6681,'I rim bo ro',3,NULL,'f','2008-03-18 12:58:04');
INSERT INTO CHANSON VALUES(6682,'Je m''en vas',3,NULL,'f','2008-03-18 13:05:51');
INSERT INTO CHANSON VALUES(6683,'Le chasseur de temps',3,NULL,'f','2008-03-18 18:08:17');
INSERT INTO CHANSON VALUES(6684,'Keenan''s Pub',3,NULL,'f','2008-03-12 16:04:37');
INSERT INTO CHANSON VALUES(6685,'Les filles d''Irlande',3,NULL,'f','2008-03-18 14:03:25');
INSERT INTO CHANSON VALUES(6686,'La geste de Sarajevo',3,NULL,'f','2008-03-16 13:19:33');
INSERT INTO CHANSON VALUES(6687,'Korantenig',3,NULL,NULL,'2008-03-18 18:47:26');
INSERT INTO CHANSON VALUES(6688,'Fransozig',3,NULL,'f','2008-04-18 08:27:20');
INSERT INTO CHANSON VALUES(6689,'Maïawela',3,NULL,'f','2008-03-18 12:41:34');
INSERT INTO CHANSON VALUES(6690,'Buvons vin de Clisson',3,NULL,NULL,'2008-03-18 16:24:39');
INSERT INTO CHANSON VALUES(6691,'Gwerz Porsal',3,NULL,'f','2008-03-16 11:58:43');
INSERT INTO CHANSON VALUES(6692,'L''ULM merveilleux',3,NULL,'f','2008-03-18 16:27:02');
INSERT INTO CHANSON VALUES(6693,'De nivse en frimaire',3,NULL,'f','2008-03-18 11:27:08');
INSERT INTO CHANSON VALUES(6694,'A matine à la télé',3,NULL,'f','2008-03-18 13:10:19');
INSERT INTO CHANSON VALUES(6695,'Kas-abahr en Okitania',3,NULL,NULL,'2008-03-12 11:48:38');
INSERT INTO CHANSON VALUES(6696,'Dansons la listériole',3,NULL,'f','2008-03-18 11:06:23');
INSERT INTO CHANSON VALUES(6697,'L''arrivée à Compostelle',3,NULL,'f','2008-03-12 18:56:31');
INSERT INTO CHANSON VALUES(6698,'The lark in the morning',3,NULL,NULL,'2008-03-12 13:51:19');
INSERT INTO CHANSON VALUES(6699,'Cumla',3,NULL,NULL,'2008-03-12 18:14:01');
INSERT INTO CHANSON VALUES(6700,'When will we be married?',3,NULL,NULL,'2008-03-12 13:55:25');
INSERT INTO CHANSON VALUES(6701,'In a lifetime',3,NULL,NULL,'2008-03-12 09:13:24');
INSERT INTO CHANSON VALUES(6702,'Botkol-Sant-Nigouden',3,NULL,NULL,'2008-03-12 18:58:51');
INSERT INTO CHANSON VALUES(6703,'The celtic connection suite',3,NULL,NULL,'2008-03-12 18:16:19');
INSERT INTO CHANSON VALUES(6704,'Brown eyed girl',3,NULL,NULL,'2008-03-12 08:41:29');
INSERT INTO CHANSON VALUES(6705,'Richmond le reel du pendu',3,NULL,NULL,'2008-03-12 12:58:18');
INSERT INTO CHANSON VALUES(6706,'An toul (cercle)',3,NULL,'t','2008-03-12 08:16:25');
INSERT INTO CHANSON VALUES(6707,'Against the wind',3,NULL,NULL,'2008-03-12 12:10:21');
INSERT INTO CHANSON VALUES(6708,'The wild rover (live)',3,NULL,NULL,'2008-03-12 19:39:12');
INSERT INTO CHANSON VALUES(6709,'Quinze marins',3,NULL,NULL,'2008-03-12 11:33:27');
INSERT INTO CHANSON VALUES(6710,'Mab al loar',3,NULL,NULL,'2008-03-12 11:03:22');
INSERT INTO CHANSON VALUES(6711,'The chuilfhionn',3,NULL,NULL,'2008-03-12 16:12:36');
INSERT INTO CHANSON VALUES(6712,'Tickelled',3,NULL,NULL,'2008-03-12 09:04:34');
INSERT INTO CHANSON VALUES(6713,'Gwerz ar Oezhinerien',3,NULL,NULL,'2008-03-12 19:59:50');
INSERT INTO CHANSON VALUES(6714,'The island',3,NULL,NULL,'2008-03-12 11:02:32');
INSERT INTO CHANSON VALUES(6715,'Liou ar chreiz/La couleur du mil',3,NULL,NULL,'2008-03-12 17:24:30');
INSERT INTO CHANSON VALUES(6716,'Irska suita',3,NULL,NULL,'2008-03-12 09:25:47');
INSERT INTO CHANSON VALUES(6717,'The grey cock',3,NULL,NULL,'2008-03-12 14:49:58');
INSERT INTO CHANSON VALUES(6718,'Sally Mac Lennane',3,NULL,NULL,'2008-03-12 18:45:37');
INSERT INTO CHANSON VALUES(6719,'Borders of salt',3,NULL,NULL,'2008-03-12 09:00:11');
INSERT INTO CHANSON VALUES(6720,'Come on Eileen',3,NULL,NULL,'2008-03-12 14:17:14');
INSERT INTO CHANSON VALUES(6721,'Tranquilo majete',3,NULL,NULL,'2008-03-12 18:59:27');
INSERT INTO CHANSON VALUES(6722,'Belfast child',3,NULL,NULL,'2008-03-12 14:05:32');
INSERT INTO CHANSON VALUES(6723,'Me zo ganet',3,NULL,'t','2008-03-12 09:03:31');
INSERT INTO CHANSON VALUES(6724,'The big mistake',3,NULL,NULL,'2008-03-12 19:21:33');
INSERT INTO CHANSON VALUES(6725,'Carry me',3,NULL,NULL,'2008-03-12 13:08:58');
INSERT INTO CHANSON VALUES(6726,'Suite sudarmoricaine',3,NULL,'t','2008-03-12 19:13:23');
INSERT INTO CHANSON VALUES(6727,'Golden Mile',3,NULL,NULL,'2008-03-12 17:44:13');
INSERT INTO CHANSON VALUES(6728,'Three weeks we were wed',3,NULL,NULL,'2008-03-12 17:36:59');
INSERT INTO CHANSON VALUES(6729,'The green groves/The flowers of red hill',3,NULL,NULL,'2008-03-12 12:41:00');
INSERT INTO CHANSON VALUES(6730,'Odopomo',3,NULL,NULL,'2008-03-12 14:13:17');
INSERT INTO CHANSON VALUES(6731,'King of the fairies',3,NULL,NULL,'2008-03-12 17:08:16');
INSERT INTO CHANSON VALUES(6732,'The jig',3,NULL,NULL,'2008-03-12 11:39:22');
INSERT INTO CHANSON VALUES(6733,'Down the broon',3,NULL,NULL,'2008-03-12 17:45:26');
INSERT INTO CHANSON VALUES(6734,'O iesu mawr',3,NULL,NULL,'2008-03-12 11:41:47');
INSERT INTO CHANSON VALUES(6735,'Date prisa',3,NULL,NULL,'2008-03-12 18:09:55');
INSERT INTO CHANSON VALUES(6736,'The blackbird set',3,NULL,NULL,'2008-03-12 18:09:09');
INSERT INTO CHANSON VALUES(6737,'Dirty old town',3,NULL,NULL,'2008-03-12 11:56:53');
INSERT INTO CHANSON VALUES(6738,'Guerre, guerre, vente, vent',3,NULL,'f','2008-03-16 13:41:30');
INSERT INTO CHANSON VALUES(6739,'Si mort a mors',3,NULL,'t','2008-03-24 17:47:15');
INSERT INTO CHANSON VALUES(6740,'Suite ecossaise: Oliver Jack-Willafjord / Drumdelgie / Elslie Marly /Shane''s Fancy',3,NULL,'f','2008-03-12 13:04:11');
INSERT INTO CHANSON VALUES(6741,'Au jardin de mon père, les lilas sont fanés',3,NULL,'t','2008-03-16 13:38:25');
INSERT INTO CHANSON VALUES(6742,'Grand bal de Kermaria-An-Isquit: Ballade / Psaume / Danse',3,NULL,NULL,'2008-03-18 17:27:33');
INSERT INTO CHANSON VALUES(6743,'An heol a zo glaz: Lug / Kan ar kann / Dans koz / Kan an heol / Dans nevez',3,NULL,'t','2008-03-24 12:25:25');
INSERT INTO CHANSON VALUES(6744,'Kelma (Overoad mix)',3,NULL,NULL,'2008-03-12 08:43:13');
INSERT INTO CHANSON VALUES(6745,'Non non non (Stacey Pullen Electro Funk Dub M',3,NULL,'f','2008-03-12 13:31:58');
INSERT INTO CHANSON VALUES(6746,'Rhorhomania (Steve Hillage Remix)',3,NULL,'f','2008-03-12 18:51:39');
INSERT INTO CHANSON VALUES(6747,'Indie (Percussion Frenzy Mix)',3,NULL,'f','2008-03-12 15:44:49');
INSERT INTO CHANSON VALUES(6748,'Voilà, voilà (Lion Rock Orchestra Dub)',3,NULL,'f','2008-03-12 15:36:58');
INSERT INTO CHANSON VALUES(6749,'La fête aux copains',5,NULL,'f','2008-03-12 16:51:54');
INSERT INTO CHANSON VALUES(6750,'Les nomades',5,NULL,'f','2008-03-12 15:20:36');
INSERT INTO CHANSON VALUES(6751,'L''homme à l''oreille coupée',5,NULL,'f','2008-03-12 09:48:40');
INSERT INTO CHANSON VALUES(6752,'Les noctambules',5,NULL,'f','2008-03-12 11:16:18');
INSERT INTO CHANSON VALUES(6753,'Ma mme',5,NULL,'f','2008-03-12 17:02:45');
INSERT INTO CHANSON VALUES(6754,'J''entends, j''entends',5,NULL,'f','2008-03-12 11:05:29');
INSERT INTO CHANSON VALUES(6755,'Deux enfants au soleil',5,NULL,'f','2008-03-12 14:30:00');
INSERT INTO CHANSON VALUES(6756,'Quatre cents enfants noirs',5,NULL,'f','2008-03-12 14:22:51');
INSERT INTO CHANSON VALUES(6757,'Nuit et brouillard',5,NULL,'f','2008-03-12 10:01:35');
INSERT INTO CHANSON VALUES(6758,'Nous dormirons ensemble',5,NULL,NULL,'2008-03-12 08:36:12');
INSERT INTO CHANSON VALUES(6759,'La montagne',5,NULL,'f','2008-03-12 19:20:03');
INSERT INTO CHANSON VALUES(6760,'C''est beau la vie',5,NULL,'f','2008-03-12 18:58:23');
INSERT INTO CHANSON VALUES(6761,'Les belles étrangères',5,NULL,'f','2008-03-12 13:07:11');
INSERT INTO CHANSON VALUES(6762,'Au bout de mon âge',5,NULL,NULL,'2008-03-12 10:26:28');
INSERT INTO CHANSON VALUES(6763,'Potemkine',5,NULL,'f','2008-03-12 13:11:31');
INSERT INTO CHANSON VALUES(6764,'Je ne chante pas pour passer le temps',5,NULL,'f','2008-03-12 10:30:36');
INSERT INTO CHANSON VALUES(6765,'Le sabre et le goupillon',5,NULL,'f','2008-03-12 16:03:06');
INSERT INTO CHANSON VALUES(6766,'Que serai-je sans toi',5,NULL,'f','2008-03-12 16:33:28');
INSERT INTO CHANSON VALUES(6767,'On ne voit pas le temps passer',5,NULL,'f','2008-03-12 15:44:29');
INSERT INTO CHANSON VALUES(6768,'En groupe, en ligue, en procession',5,NULL,'f','2008-03-12 10:44:06');
INSERT INTO CHANSON VALUES(6769,'C''est toujours la première fois',5,NULL,'f','2008-03-12 12:43:27');
INSERT INTO CHANSON VALUES(6770,'Maria',5,NULL,'f','2008-03-12 13:36:25');
INSERT INTO CHANSON VALUES(6771,'C''est si peu dire que je t''aime',5,NULL,'f','2008-03-12 18:06:32');
INSERT INTO CHANSON VALUES(6772,'Cuba si',5,NULL,'f','2008-03-12 08:16:59');
INSERT INTO CHANSON VALUES(6773,'Un jour un jour',5,NULL,'f','2008-03-12 14:45:11');
INSERT INTO CHANSON VALUES(6774,'Les guerilleros',5,NULL,'f','2008-03-12 08:00:42');
INSERT INTO CHANSON VALUES(6775,'Pauvres petits',5,NULL,'f','2008-03-12 15:43:45');
INSERT INTO CHANSON VALUES(6776,'Heureux celui qui meurt d''aimer',5,NULL,'f','2008-03-12 17:28:19');
INSERT INTO CHANSON VALUES(6777,'A Santiago',5,NULL,NULL,'2008-03-12 10:03:03');
INSERT INTO CHANSON VALUES(6778,'Les poètes',5,NULL,NULL,'2008-03-12 16:15:48');
INSERT INTO CHANSON VALUES(6779,'La matinée',5,NULL,'f','2008-03-12 18:38:31');
INSERT INTO CHANSON VALUES(6780,'Un jour futur',5,NULL,'f','2008-03-12 11:05:08');
INSERT INTO CHANSON VALUES(6781,'Ma France',5,NULL,'f','2008-03-12 16:56:15');
INSERT INTO CHANSON VALUES(6782,'L''idole à papa',5,NULL,'f','2008-03-12 11:58:31');
INSERT INTO CHANSON VALUES(6783,'Sacré Félicien',5,NULL,'f','2008-03-12 11:29:17');
INSERT INTO CHANSON VALUES(6784,'Les lilas',5,NULL,'f','2008-03-12 13:32:17');
INSERT INTO CHANSON VALUES(6785,'Camarades',5,NULL,NULL,'2008-03-12 09:10:01');
INSERT INTO CHANSON VALUES(6786,'Et pour l''exemple',5,NULL,'f','2008-03-12 18:56:29');
INSERT INTO CHANSON VALUES(6787,'La commune',5,NULL,'f','2008-03-12 10:10:33');
INSERT INTO CHANSON VALUES(6788,'Picasso colombe',5,NULL,'f','2008-03-12 11:54:48');
INSERT INTO CHANSON VALUES(6789,'Une femme honnête',5,NULL,'f','2008-03-12 09:44:27');
INSERT INTO CHANSON VALUES(6790,'Les saisons',5,NULL,'f','2008-03-12 15:02:32');
INSERT INTO CHANSON VALUES(6791,'Les touristes partis',5,NULL,'f','2008-03-12 17:45:28');
INSERT INTO CHANSON VALUES(6792,'Aimer à perdre la raison',5,NULL,'f','2008-03-12 08:01:27');
INSERT INTO CHANSON VALUES(6793,'Paris an 2000',5,NULL,'f','2008-03-12 14:17:57');
INSERT INTO CHANSON VALUES(6794,'Hou hou, méfions nous',5,NULL,'f','2008-03-12 18:44:29');
INSERT INTO CHANSON VALUES(6795,'Si j''étais peintre ou maçon',5,NULL,'f','2008-03-12 09:54:40');
INSERT INTO CHANSON VALUES(6796,'Pauvre Boris',5,NULL,'f','2008-03-12 09:49:36');
INSERT INTO CHANSON VALUES(6797,'Le monde bouge',3,NULL,'f','2008-03-12 15:03:46');
INSERT INTO CHANSON VALUES(6798,'Prisons',3,NULL,'f','2008-03-12 10:21:40');
INSERT INTO CHANSON VALUES(6799,'Les jours sont courts',3,NULL,'f','2008-03-12 19:28:25');
INSERT INTO CHANSON VALUES(6800,'Elle voyage',3,NULL,'f','2008-03-12 13:06:27');
INSERT INTO CHANSON VALUES(6801,'Le vieux rêve',3,NULL,'f','2008-03-12 19:52:13');
INSERT INTO CHANSON VALUES(6802,'Département 26',3,NULL,'f','2008-03-12 13:54:14');
INSERT INTO CHANSON VALUES(6803,'Comme un chromo',3,NULL,'f','2008-03-12 19:27:32');
INSERT INTO CHANSON VALUES(6804,'Magouille blues',3,NULL,'f','2008-03-12 18:18:16');
INSERT INTO CHANSON VALUES(6805,'Twist des clés',3,NULL,'f','2008-03-12 12:26:10');
INSERT INTO CHANSON VALUES(6806,'Rachel',3,NULL,'f','2008-03-12 08:35:00');
INSERT INTO CHANSON VALUES(6807,'La fille que j''aime',3,NULL,NULL,'2008-03-12 15:13:03');
INSERT INTO CHANSON VALUES(6808,'Tango de l''ennui',3,NULL,'f','2008-03-17 09:24:53');
INSERT INTO CHANSON VALUES(6809,'Le vieux',3,NULL,'f','2008-03-12 14:51:59');
INSERT INTO CHANSON VALUES(6810,'Chanson à danser',3,NULL,'f','2008-03-12 19:51:52');
INSERT INTO CHANSON VALUES(6811,'Nous sommes un cas',3,NULL,'f','2008-03-12 10:19:46');
INSERT INTO CHANSON VALUES(6812,'Le balayeur d''Amérique',3,NULL,'f','2008-03-12 13:15:14');
INSERT INTO CHANSON VALUES(6813,'La gigue de la Reine',3,NULL,'f','2008-03-12 19:08:32');
INSERT INTO CHANSON VALUES(6814,'Manifeste',3,NULL,'f','2008-03-12 11:30:58');
INSERT INTO CHANSON VALUES(6815,'Madeeh',3,NULL,'f','2008-03-12 13:32:34');
INSERT INTO CHANSON VALUES(6816,'Wahrane Wahrane',3,NULL,'f','2008-03-12 13:10:47');
INSERT INTO CHANSON VALUES(6817,'Les Ailes',3,NULL,'f','2008-03-12 14:35:12');
INSERT INTO CHANSON VALUES(6818,'La Camel',3,NULL,'f','2008-03-12 19:41:37');
INSERT INTO CHANSON VALUES(6819,'Abdel Kader',3,NULL,'f','2008-03-12 17:13:29');
INSERT INTO CHANSON VALUES(6820,'Bent Sahra',3,NULL,'f','2008-03-12 17:12:20');
INSERT INTO CHANSON VALUES(6821,'Aicha',3,NULL,'f','2008-03-23 16:25:40');
INSERT INTO CHANSON VALUES(6822,'Tellement N''Brick',3,NULL,'f','2008-03-12 13:52:55');
INSERT INTO CHANSON VALUES(6823,'Didi',3,NULL,'f','2008-03-12 16:51:03');
INSERT INTO CHANSON VALUES(6824,'Ya Rayah',3,NULL,'f','2008-03-12 11:07:34');
INSERT INTO CHANSON VALUES(6825,'Carry On',2,NULL,'f','2008-03-12 10:34:06');
INSERT INTO CHANSON VALUES(6826,'Teach Your Children',2,NULL,'f','2008-03-12 17:01:17');
INSERT INTO CHANSON VALUES(6827,'Almost Cut My Hair',2,NULL,'f','2008-03-12 15:32:53');
INSERT INTO CHANSON VALUES(6828,'Helpless',2,NULL,NULL,'2008-03-12 17:28:34');
INSERT INTO CHANSON VALUES(6829,'Woodstock',2,NULL,'f','2008-03-12 13:18:48');
INSERT INTO CHANSON VALUES(6830,'Deja Vu',2,NULL,'f','2008-03-12 19:07:00');
INSERT INTO CHANSON VALUES(6831,'Our House',2,NULL,'f','2008-03-12 11:49:25');
INSERT INTO CHANSON VALUES(6832,'4 + 20',2,NULL,'f','2008-03-12 19:17:18');
INSERT INTO CHANSON VALUES(6833,'Country Girl',2,NULL,'f','2008-03-12 18:00:09');
INSERT INTO CHANSON VALUES(6834,'Everybody I Love You',2,NULL,'f','2008-03-12 19:16:17');
INSERT INTO CHANSON VALUES(6835,'Out on the Weekend',2,NULL,NULL,'2008-03-12 14:31:52');
INSERT INTO CHANSON VALUES(6836,'Harvest',2,NULL,NULL,'2008-03-12 15:19:54');
INSERT INTO CHANSON VALUES(6837,'A man needs a maid',2,NULL,'f','2008-03-12 19:56:27');
INSERT INTO CHANSON VALUES(6838,'Heart of Gold',2,NULL,NULL,'2008-03-12 17:45:56');
INSERT INTO CHANSON VALUES(6839,'Are you ready for the Country',2,NULL,'f','2008-03-12 12:12:14');
INSERT INTO CHANSON VALUES(6840,'Old man',2,NULL,'f','2008-03-12 10:09:22');
INSERT INTO CHANSON VALUES(6841,'There''s a world',2,NULL,'f','2008-03-12 10:27:11');
INSERT INTO CHANSON VALUES(6843,'The needle and the damage done',2,NULL,'f','2008-03-12 19:19:30');
INSERT INTO CHANSON VALUES(6844,'Words (between the lines of age)',2,NULL,'f','2008-03-12 09:16:46');
INSERT INTO CHANSON VALUES(6845,'Goin''Back',2,NULL,'f','2008-03-12 13:49:17');
INSERT INTO CHANSON VALUES(6846,'Comes A Time',2,NULL,'f','2008-03-12 11:27:37');
INSERT INTO CHANSON VALUES(6847,'Look Out For My Love',2,NULL,'f','2008-03-23 10:24:33');
INSERT INTO CHANSON VALUES(6848,'Lotta Love',2,NULL,'f','2008-03-12 15:13:19');
INSERT INTO CHANSON VALUES(6849,'Peace Of Mind',2,NULL,'f','2008-05-22 11:03:43');
INSERT INTO CHANSON VALUES(6850,'Human Highway',2,NULL,'f','2008-03-12 15:38:32');
INSERT INTO CHANSON VALUES(6851,'Already One',2,NULL,'f','2008-03-12 18:51:42');
INSERT INTO CHANSON VALUES(6852,'Field Of Opportunity',2,NULL,'f','2008-03-12 10:04:09');
INSERT INTO CHANSON VALUES(6853,'Motorcycle Mama',2,NULL,'f','2008-03-12 13:43:34');
INSERT INTO CHANSON VALUES(6854,'Four Strong Winds',2,NULL,'f','2008-03-12 18:41:53');
INSERT INTO CHANSON VALUES(6855,'Bonnie Dundee',3,NULL,NULL,'2008-03-12 12:48:10');
INSERT INTO CHANSON VALUES(6856,'Home by Bearna',3,NULL,NULL,'2008-03-12 10:14:59');
INSERT INTO CHANSON VALUES(6857,'Thousands are sailing',3,NULL,NULL,'2008-03-12 13:32:27');
INSERT INTO CHANSON VALUES(6858,'All for me grog',3,NULL,NULL,'2008-03-12 09:44:51');
INSERT INTO CHANSON VALUES(6859,'My old man''s a dustman',3,NULL,NULL,'2008-03-12 15:24:05');
INSERT INTO CHANSON VALUES(6860,'Lady of the bottles',3,NULL,NULL,'2008-03-12 19:00:43');
INSERT INTO CHANSON VALUES(6861,'Jim Ledean',3,NULL,NULL,'2008-03-12 14:50:35');
INSERT INTO CHANSON VALUES(6862,'Sam Hall',3,NULL,NULL,'2008-03-12 10:04:39');
INSERT INTO CHANSON VALUES(6863,'The wild rover',3,NULL,NULL,'2008-03-12 12:29:23');
INSERT INTO CHANSON VALUES(6864,'Van den hoeksteen',3,NULL,NULL,'2008-03-12 19:23:05');
INSERT INTO CHANSON VALUES(6865,'Derya u mazir (Les héritiers de l''avenir)',3,NULL,NULL,'2008-03-12 18:48:53');
INSERT INTO CHANSON VALUES(6866,'Fihel asirem (Il faut agir)',3,NULL,NULL,'2008-03-12 08:59:08');
INSERT INTO CHANSON VALUES(6867,'Nura (Norah)',3,NULL,NULL,'2008-03-12 08:28:40');
INSERT INTO CHANSON VALUES(6868,'Tilemzit brir ad zhur (Je suis jeune et je veux vivre)',3,NULL,NULL,'2008-03-12 14:34:24');
INSERT INTO CHANSON VALUES(6869,'Azemmur (Ma terre et ses oliviers)',3,NULL,NULL,'2008-03-12 12:14:48');
INSERT INTO CHANSON VALUES(6870,'Ad cethent tulas (Les jeunes filles vont danser)',3,NULL,NULL,'2008-03-12 13:13:48');
INSERT INTO CHANSON VALUES(6871,'A dezzi a saa (La roue du destin)',3,NULL,NULL,'2008-03-12 10:45:39');
INSERT INTO CHANSON VALUES(6872,'A seltan nat Maslaht (Le roi du balai)',3,NULL,NULL,'2008-03-12 17:59:43');
INSERT INTO CHANSON VALUES(6873,'Sika (Sika)',3,NULL,NULL,'2008-03-12 13:22:12');
INSERT INTO CHANSON VALUES(6874,'A yemma (À ma mère)',3,NULL,NULL,'2008-03-12 17:19:36');
INSERT INTO CHANSON VALUES(6875,'Nachtvrijage',3,NULL,NULL,'2008-03-12 18:11:25');
INSERT INTO CHANSON VALUES(6876,'Scottish on the rocks',3,NULL,NULL,'2008-03-12 17:13:24');
INSERT INTO CHANSON VALUES(6877,'Van Boord',3,NULL,NULL,'2008-03-12 19:16:53');
INSERT INTO CHANSON VALUES(6878,'Silvia',3,NULL,NULL,'2008-03-12 15:46:28');
INSERT INTO CHANSON VALUES(6879,'Mezelve niet',3,NULL,NULL,'2008-03-12 08:08:42');
INSERT INTO CHANSON VALUES(6880,'Bourrée entre la sacoche et la valise',3,NULL,NULL,'2008-03-12 17:35:55');
INSERT INTO CHANSON VALUES(6881,'Gestraft bedrog',3,NULL,NULL,'2008-03-12 15:46:41');
INSERT INTO CHANSON VALUES(6882,'Chansonette',3,NULL,NULL,'2008-03-12 11:32:40');
INSERT INTO CHANSON VALUES(6883,'Noten kraken',3,NULL,NULL,'2008-03-12 08:58:02');
INSERT INTO CHANSON VALUES(6884,'La fin du carneval',3,NULL,NULL,'2008-03-12 11:48:22');
INSERT INTO CHANSON VALUES(6885,'Grasseng',3,NULL,NULL,'2008-03-12 18:42:33');
INSERT INTO CHANSON VALUES(6886,'Fanny Ardant et moi',5,NULL,'f','2008-03-12 11:30:47');
INSERT INTO CHANSON VALUES(6887,'La vipère du Gabon',5,NULL,'f','2008-03-12 16:27:04');
INSERT INTO CHANSON VALUES(6888,'Châtenay Malabry',5,NULL,'f','2008-03-12 15:03:50');
INSERT INTO CHANSON VALUES(6889,'Catégorie Bukowski',5,NULL,'f','2008-03-12 08:04:58');
INSERT INTO CHANSON VALUES(6890,'Tes parents',5,NULL,'f','2008-03-12 17:54:34');
INSERT INTO CHANSON VALUES(6891,'Cosmopolitan',5,NULL,'f','2008-03-12 16:32:20');
INSERT INTO CHANSON VALUES(6892,'Slalom géant',5,NULL,'f','2008-03-12 12:51:53');
INSERT INTO CHANSON VALUES(6893,'Le monologue Shakespearien',5,NULL,'f','2008-03-12 08:53:52');
INSERT INTO CHANSON VALUES(6894,'Charlotte Carrington',5,NULL,'f','2008-03-12 09:08:40');
INSERT INTO CHANSON VALUES(6895,'Deauville sans Trintignant',5,NULL,'f','2008-03-12 13:00:23');
INSERT INTO CHANSON VALUES(6896,'L''heure du thé',5,NULL,'f','2008-03-12 08:17:54');
INSERT INTO CHANSON VALUES(6898,'El Condor Pasa (If I Could)',2,NULL,'f','2008-03-12 18:34:25');
INSERT INTO CHANSON VALUES(6899,'Cecilia',2,NULL,'f','2008-03-12 16:37:29');
INSERT INTO CHANSON VALUES(6900,'Keep The Customer Satisfied',2,NULL,NULL,'2008-03-12 16:23:24');
INSERT INTO CHANSON VALUES(6901,'So Long, Frank Lloyd Wright',2,NULL,NULL,'2008-03-12 11:05:57');
INSERT INTO CHANSON VALUES(6903,'Baby Driver',2,NULL,'f','2008-03-12 14:31:42');
INSERT INTO CHANSON VALUES(6904,'The Only Living Boy In New York',2,NULL,'f','2008-03-12 12:36:50');
INSERT INTO CHANSON VALUES(6905,'Why Don''t You Write Me',2,NULL,'f','2008-03-12 08:04:50');
INSERT INTO CHANSON VALUES(6906,'Bye Bye Love',2,NULL,'f','2008-03-12 13:06:07');
INSERT INTO CHANSON VALUES(6907,'Song For The Asking',2,NULL,'f','2008-03-12 12:55:06');
INSERT INTO CHANSON VALUES(6908,'The Wind of Keltia',3,NULL,NULL,'2008-03-12 16:49:40');
INSERT INTO CHANSON VALUES(6909,'An Dro',3,NULL,NULL,'2008-03-12 09:33:18');
INSERT INTO CHANSON VALUES(6910,'The Trees They Do Grow High',3,NULL,NULL,'2008-03-12 15:15:42');
INSERT INTO CHANSON VALUES(6911,'An Alarch''s',3,NULL,NULL,'2008-03-16 08:32:47');
INSERT INTO CHANSON VALUES(6912,'An Durzhunel',3,NULL,'t','2008-03-12 19:10:15');
INSERT INTO CHANSON VALUES(6913,'Telenn Gwad / The Foggy Dew',3,NULL,NULL,'2008-03-12 17:41:46');
INSERT INTO CHANSON VALUES(6914,'Pop Plinn',3,NULL,NULL,'2008-03-12 13:04:22');
INSERT INTO CHANSON VALUES(6915,'Tha Misgith',3,NULL,'t','2008-03-12 12:08:27');
INSERT INTO CHANSON VALUES(6916,'The King of the Fairies',3,NULL,'t','2008-03-12 10:35:33');
INSERT INTO CHANSON VALUES(6918,'Kost Ar C''hoad',3,NULL,'t','2008-03-12 13:39:18');
INSERT INTO CHANSON VALUES(6919,'Suite Sudarmoricaine',3,NULL,'t','2008-03-12 09:47:51');
INSERT INTO CHANSON VALUES(6920,'Doran',3,NULL,'f','2008-04-07 12:52:18');
INSERT INTO CHANSON VALUES(6921,'Belle',3,NULL,NULL,'2008-04-13 10:39:35');
INSERT INTO CHANSON VALUES(6922,'(houd) uw Kanneke',3,NULL,NULL,'2008-04-07 11:53:05');
INSERT INTO CHANSON VALUES(6923,'Benedetta',3,NULL,NULL,'2008-03-12 12:24:07');
INSERT INTO CHANSON VALUES(6924,'Tina Vieri',3,NULL,NULL,'2008-04-07 12:29:49');
INSERT INTO CHANSON VALUES(6925,'Le renard et la belette',3,NULL,'f','2008-04-07 11:53:41');
INSERT INTO CHANSON VALUES(6926,'Les douze mois',3,NULL,NULL,'2008-03-12 09:26:40');
INSERT INTO CHANSON VALUES(6927,'De valse zeeman',3,NULL,NULL,'2008-03-12 18:26:50');
INSERT INTO CHANSON VALUES(6928,'Marider',3,NULL,NULL,'2008-03-12 09:13:31');
INSERT INTO CHANSON VALUES(6929,'Comme au sein de la nuit',3,NULL,NULL,'2008-03-12 19:43:35');
INSERT INTO CHANSON VALUES(6930,'Dorothea',3,NULL,'f','2008-04-07 17:04:01');
INSERT INTO CHANSON VALUES(6931,'Klaas',3,NULL,NULL,'2008-04-07 17:28:36');
INSERT INTO CHANSON VALUES(6932,'De wanhoop (bonus track)',3,NULL,NULL,'2008-04-13 10:00:45');
INSERT INTO CHANSON VALUES(6933,'Joue, joue, joue',0,NULL,'f','2008-03-12 11:03:44');
INSERT INTO CHANSON VALUES(6934,'Emmène-moi',0,NULL,NULL,'2008-03-12 17:14:20');
INSERT INTO CHANSON VALUES(6935,'Qui a tué Davy Moore',0,NULL,'f','2008-03-12 11:33:16');
INSERT INTO CHANSON VALUES(6936,'Petites boîtes',0,NULL,'f','2008-03-12 17:58:56');
INSERT INTO CHANSON VALUES(6937,'Il faut que je m''en aille',0,NULL,'f','2008-03-12 09:04:43');
INSERT INTO CHANSON VALUES(6938,'Ca je ne l''ai jamais vu',0,NULL,'f','2008-03-12 19:28:08');
INSERT INTO CHANSON VALUES(6939,'Viendras-tu avec moi ?',0,NULL,'f','2008-06-01 16:10:21.270084');
INSERT INTO CHANSON VALUES(6940,'Sacrée bouteille',0,NULL,'f','2008-03-12 17:28:01');
INSERT INTO CHANSON VALUES(6941,'Qu''as-tu appris à l''école ?',0,NULL,'f','2008-03-12 15:37:15');
INSERT INTO CHANSON VALUES(6942,'Petit garçon',0,NULL,'f','2008-03-12 09:32:58');
INSERT INTO CHANSON VALUES(6943,'Ballade de la désescalade',0,NULL,'f','2008-03-12 16:50:02');
INSERT INTO CHANSON VALUES(6945,'Les sœurs de la miséricorde',0,NULL,'f','2008-06-01 16:10:40.58499');
INSERT INTO CHANSON VALUES(6946,'L''étranger',0,NULL,'f','2008-03-12 09:44:49');
INSERT INTO CHANSON VALUES(6947,'Demain sera bien',0,NULL,'f','2008-03-12 08:51:53');
INSERT INTO CHANSON VALUES(6948,'Diamants dans la mine',0,NULL,'f','2008-03-12 17:49:22');
INSERT INTO CHANSON VALUES(6949,'Lover, lover, lover',0,NULL,'f','2008-03-12 18:56:57');
INSERT INTO CHANSON VALUES(6950,'Petite fleur fanée',0,NULL,'f','2008-03-12 13:43:26');
INSERT INTO CHANSON VALUES(6952,'Leaves that are green',2,NULL,'f','2008-03-12 16:13:27');
INSERT INTO CHANSON VALUES(6953,'Blessed',2,NULL,'f','2008-03-12 17:42:03');
INSERT INTO CHANSON VALUES(6954,'Kathy''s song',2,NULL,'f','2008-03-12 08:31:59');
INSERT INTO CHANSON VALUES(6955,'Somewhere they can''t find me',2,NULL,'f','2008-03-12 19:37:43');
INSERT INTO CHANSON VALUES(6956,'Anji',2,NULL,NULL,'2008-03-12 17:39:34');
INSERT INTO CHANSON VALUES(6958,'Richard Cory',2,NULL,NULL,'2008-03-12 08:19:20');
INSERT INTO CHANSON VALUES(6959,'A most peculiar man',2,NULL,NULL,'2008-03-12 08:48:04');
INSERT INTO CHANSON VALUES(6961,'We''ve got the groovey thing goin''',2,NULL,'f','2008-03-12 14:04:53');
INSERT INTO CHANSON VALUES(6962,'I am a rock',2,NULL,'f','2008-03-12 09:49:06');
INSERT INTO CHANSON VALUES(6963,'Khalliouni Khalliouni',3,NULL,'f','2008-03-12 14:36:49');
INSERT INTO CHANSON VALUES(6964,'Menfi',3,NULL,'f','2008-03-12 15:41:20');
INSERT INTO CHANSON VALUES(6965,'Eray',3,NULL,'f','2008-03-12 15:37:57');
INSERT INTO CHANSON VALUES(6966,'N''ssi N''ssi',3,NULL,'f','2008-03-12 12:22:36');
INSERT INTO CHANSON VALUES(6967,'Ida',3,NULL,'f','2008-03-12 19:02:01');
INSERT INTO CHANSON VALUES(6968,'Baida',3,NULL,'f','2008-03-12 11:04:20');
INSERT INTO CHANSON VALUES(6969,'Omri',3,NULL,'f','2008-03-12 16:04:09');
INSERT INTO CHANSON VALUES(6970,'Voila voila',3,NULL,'f','2008-03-12 16:31:27');
INSERT INTO CHANSON VALUES(6971,'Indie',3,NULL,'f','2008-03-12 09:01:32');
INSERT INTO CHANSON VALUES(6972,'Chebba',3,NULL,'f','2008-03-12 08:08:21');
INSERT INTO CHANSON VALUES(6973,'Sahra',3,NULL,'f','2008-03-12 09:43:57');
INSERT INTO CHANSON VALUES(6974,'Les Programmeurs',3,NULL,'f','2008-03-12 19:21:39');
INSERT INTO CHANSON VALUES(6975,'La ville que j''ai tant aimée',3,NULL,'f','2008-03-18 11:59:16');
INSERT INTO CHANSON VALUES(6976,'Kan Peoc''h',3,NULL,'t','2008-03-24 18:09:24');
INSERT INTO CHANSON VALUES(6977,'O''Caroland''s devotion - Irish dances 1',3,NULL,'f','2008-03-12 11:19:39');
INSERT INTO CHANSON VALUES(6978,'Kalonkadour',3,NULL,'f','2008-03-12 18:15:41');
INSERT INTO CHANSON VALUES(6979,'La ville de La Rochelle',3,NULL,'f','2008-03-16 18:34:46');
INSERT INTO CHANSON VALUES(6980,'An tourter',3,NULL,'f','2008-03-18 17:13:43');
INSERT INTO CHANSON VALUES(6981,'Irish coffee - Abigal Judge',3,NULL,NULL,'2008-03-12 11:15:51');
INSERT INTO CHANSON VALUES(6982,'Aventurou Marian',3,NULL,'f','2008-03-12 12:00:22');
INSERT INTO CHANSON VALUES(6983,'Chanson à boire',3,NULL,'f','2008-03-18 12:11:32');
INSERT INTO CHANSON VALUES(6984,'Complainte de Yuna Madalen',3,NULL,'f','2008-03-18 17:20:16');
INSERT INTO CHANSON VALUES(6985,'Les chevaux de Mene-Bre',3,NULL,'f','2008-03-12 16:18:37');
INSERT INTO CHANSON VALUES(6986,'Go No More A-Roving',2,NULL,'f','2008-03-12 12:37:37');
INSERT INTO CHANSON VALUES(6987,'Because Of',2,NULL,'f','2008-03-12 15:53:57');
INSERT INTO CHANSON VALUES(6988,'The Letters',2,NULL,'f','2008-03-12 11:46:12');
INSERT INTO CHANSON VALUES(6989,'Undertow',2,NULL,'f','2008-03-12 08:40:47');
INSERT INTO CHANSON VALUES(6990,'Morning Glory',2,NULL,NULL,'2008-05-22 14:56:00');
INSERT INTO CHANSON VALUES(6991,'On That Day',2,NULL,NULL,'2008-03-12 17:55:02');
INSERT INTO CHANSON VALUES(6992,'Villanelle For Our Time',2,NULL,'f','2008-03-12 15:19:02');
INSERT INTO CHANSON VALUES(6993,'There For You',2,NULL,'f','2008-03-12 08:11:12');
INSERT INTO CHANSON VALUES(6994,'Dear Heather',2,NULL,'f','2008-05-22 19:14:31');
INSERT INTO CHANSON VALUES(6995,'Nightingale',2,NULL,'f','2008-03-12 12:36:23');
INSERT INTO CHANSON VALUES(6996,'To A Teacher',2,NULL,'f','2008-03-12 19:22:44');
INSERT INTO CHANSON VALUES(6997,'The Faith',2,NULL,'f','2008-03-12 10:06:03');
INSERT INTO CHANSON VALUES(6998,'Tennessee Waltz (Live Version)',2,NULL,'f','2008-03-12 18:30:40');
INSERT INTO CHANSON VALUES(7001,'Habina',3,NULL,'f','2008-03-12 15:29:00');
INSERT INTO CHANSON VALUES(7003,'Ach Adani',3,NULL,'f','2008-03-12 13:55:15');
INSERT INTO CHANSON VALUES(7004,'El H''Mame',3,NULL,'f','2008-03-12 14:56:27');
INSERT INTO CHANSON VALUES(7005,'Enti Rahti',3,NULL,'f','2008-03-12 16:21:03');
INSERT INTO CHANSON VALUES(7007,'Bani Al Insane',3,NULL,'f','2008-03-12 18:32:32');
INSERT INTO CHANSON VALUES(7008,'Malheureux Toujours',3,NULL,'f','2008-03-12 18:24:02');
INSERT INTO CHANSON VALUES(7009,'Aiya Aiya',3,NULL,'f','2008-03-12 15:53:12');
INSERT INTO CHANSON VALUES(7010,'Achille',3,NULL,NULL,'2008-03-12 09:19:41');
INSERT INTO CHANSON VALUES(7011,'Quelle histoire à la con',3,NULL,'f','2008-03-12 13:58:11');
INSERT INTO CHANSON VALUES(7012,'Manges! manges! manges!',3,NULL,'f','2008-03-12 14:23:28');
INSERT INTO CHANSON VALUES(7013,'L''Irlandais',3,NULL,'f','2008-03-12 13:51:24');
INSERT INTO CHANSON VALUES(7014,'Rosalie la blonde',3,NULL,'f','2008-03-12 16:22:20');
INSERT INTO CHANSON VALUES(7015,'Le blues du petit rat (interlude)',3,NULL,'f','2008-03-12 09:05:42');
INSERT INTO CHANSON VALUES(7016,'Psycho-lied',3,NULL,'f','2008-03-12 10:12:01');
INSERT INTO CHANSON VALUES(7017,'J''ai failli crever',3,NULL,'f','2008-03-12 15:03:34');
INSERT INTO CHANSON VALUES(7018,'Allez les gars on s''paye une frite',3,NULL,'f','2008-03-12 10:58:58');
INSERT INTO CHANSON VALUES(7019,'Reviens maman',3,NULL,'f','2008-03-12 10:34:52');
INSERT INTO CHANSON VALUES(7020,'La belle madone de Malo les bains',3,NULL,'f','2008-03-12 13:43:12');
INSERT INTO CHANSON VALUES(7021,'Brumes',3,NULL,'f','2008-03-12 09:13:10');
INSERT INTO CHANSON VALUES(7030,'Party girls & broken poets/Gloria',2,NULL,'f','2008-03-12 16:43:28');
INSERT INTO CHANSON VALUES(7033,'Been up these stairs before',2,NULL,NULL,'2008-03-12 08:09:26');
INSERT INTO CHANSON VALUES(7035,'Spike Island Lasses',3,NULL,NULL,'2008-03-12 09:08:30');
INSERT INTO CHANSON VALUES(7036,'Language of the Gaels',3,NULL,NULL,'2008-03-12 18:40:32');
INSERT INTO CHANSON VALUES(7037,'Green Lands',3,NULL,NULL,'2008-03-12 17:55:46');
INSERT INTO CHANSON VALUES(7038,'Maro Eo Ma Mestrez',3,NULL,'t','2008-03-12 19:11:40');
INSERT INTO CHANSON VALUES(7039,'April The 3rd',3,NULL,NULL,'2008-03-12 09:01:44');
INSERT INTO CHANSON VALUES(7040,'Eliziza',3,NULL,NULL,'2008-03-12 11:50:02');
INSERT INTO CHANSON VALUES(7041,'King of Laois',3,NULL,NULL,'2008-03-12 08:32:45');
INSERT INTO CHANSON VALUES(7042,'The Island',3,NULL,NULL,'2008-03-12 14:26:36');
INSERT INTO CHANSON VALUES(7043,'Scottish Suite',3,NULL,NULL,'2008-03-12 10:30:46');
INSERT INTO CHANSON VALUES(7044,'Me Zo Ganet E Kreiz Ar Mor',3,NULL,'t','2008-04-07 11:18:09');
INSERT INTO CHANSON VALUES(7045,'Call to the dance',3,NULL,NULL,'2008-03-12 15:09:42');
INSERT INTO CHANSON VALUES(7046,'Bells of Beauregard',2,NULL,NULL,'2008-03-12 11:14:50');
INSERT INTO CHANSON VALUES(7048,'Made in Freud',2,NULL,'f','2008-03-12 11:57:27');
INSERT INTO CHANSON VALUES(7049,'O Wyoming',2,NULL,'f','2008-03-12 09:54:39');
INSERT INTO CHANSON VALUES(7051,'Moving sky',2,NULL,'f','2008-03-12 14:19:31');
INSERT INTO CHANSON VALUES(7052,'Well intentioned pedestrians',2,NULL,'f','2008-03-12 14:21:03');
INSERT INTO CHANSON VALUES(7053,'Small room',2,NULL,'f','2008-03-12 11:52:29');
INSERT INTO CHANSON VALUES(7055,'Last train th Memphis',2,NULL,'f','2008-03-12 16:44:10');
INSERT INTO CHANSON VALUES(7056,'St. Elmo''s Motel',2,NULL,'f','2008-03-12 12:01:25');
INSERT INTO CHANSON VALUES(7057,'You can'' t go home',2,NULL,'f','2008-03-12 11:48:34');
INSERT INTO CHANSON VALUES(7058,'All these days',2,NULL,NULL,'2008-03-12 17:07:31');
INSERT INTO CHANSON VALUES(7059,'Intro',3,NULL,NULL,'2008-03-12 10:13:26');
INSERT INTO CHANSON VALUES(7060,'Voici la Saint Jean',3,NULL,NULL,'2008-03-12 18:59:27');
INSERT INTO CHANSON VALUES(7061,'Weverdans',3,NULL,NULL,'2008-03-12 14:30:47');
INSERT INTO CHANSON VALUES(7062,'Feest',3,NULL,NULL,'2008-03-12 09:03:09');
INSERT INTO CHANSON VALUES(7064,'Hanter dro / En dro',3,NULL,NULL,'2008-03-12 15:18:07');
INSERT INTO CHANSON VALUES(7065,'Het heerke van Maldegem',3,NULL,NULL,'2008-03-12 15:59:51');
INSERT INTO CHANSON VALUES(7067,'De vogel in de muite',3,NULL,NULL,'2008-03-12 10:39:41');
INSERT INTO CHANSON VALUES(7068,'De zeven vrouwtjes',3,NULL,NULL,'2008-03-12 17:26:48');
INSERT INTO CHANSON VALUES(7069,'Seerlands dale (Eva)',3,NULL,NULL,'2008-03-12 12:40:02');
INSERT INTO CHANSON VALUES(7070,'Louise (demo)',3,NULL,NULL,'2008-03-12 17:34:01');
INSERT INTO CHANSON VALUES(7071,'Van de twee koningskinderen',3,NULL,NULL,'2008-03-12 10:08:32');
INSERT INTO CHANSON VALUES(7072,'De treurende',3,NULL,NULL,'2008-03-12 08:14:35');
INSERT INTO CHANSON VALUES(7074,'Tous les bateaux, tous les oiseaux',2,NULL,'f','2008-03-12 10:01:16');
INSERT INTO CHANSON VALUES(7075,'Je cherche un job',2,NULL,'f','2008-03-12 12:40:16');
INSERT INTO CHANSON VALUES(7077,'La Mouche',2,NULL,'f','2008-03-12 09:43:19');
INSERT INTO CHANSON VALUES(7078,'Ame Caline',2,NULL,'f','2008-03-12 17:31:46');
INSERT INTO CHANSON VALUES(7079,'Dans la maison vide',2,NULL,'f','2008-03-12 15:52:26');
INSERT INTO CHANSON VALUES(7080,'Ca n''arrive qu''aux autres',2,NULL,'f','2008-03-12 15:38:01');
INSERT INTO CHANSON VALUES(7081,'Gloria',2,NULL,'f','2008-03-12 15:52:10');
INSERT INTO CHANSON VALUES(7082,'On ira tous au Paradis',2,NULL,'f','2008-03-12 10:54:24');
INSERT INTO CHANSON VALUES(7083,'La trompette',2,NULL,'f','2008-03-12 17:05:47');
INSERT INTO CHANSON VALUES(7084,'Love me, please love me',2,NULL,'f','2008-03-12 17:19:49');
INSERT INTO CHANSON VALUES(7085,'Boogie Woogie',2,NULL,'f','2008-03-12 08:40:29');
INSERT INTO CHANSON VALUES(7086,'Princes qu''en mains tenez',3,NULL,'f','2008-03-16 11:52:58');
INSERT INTO CHANSON VALUES(7087,'Complainte Gallaise',3,NULL,'f','2008-03-16 19:58:42');
INSERT INTO CHANSON VALUES(7088,'La botte d''asperges',3,NULL,'f','2008-03-12 11:46:14');
INSERT INTO CHANSON VALUES(7089,'Kiss the children for me Mary',3,NULL,NULL,'2008-03-24 09:40:37');
INSERT INTO CHANSON VALUES(7090,'La jument de Michao',3,NULL,'t','2008-03-16 09:22:06');
INSERT INTO CHANSON VALUES(7091,'Mrs Mac Dermott',3,NULL,'f','2008-03-12 14:59:44');
INSERT INTO CHANSON VALUES(7092,'La levée des 300.000 Hommes',3,NULL,NULL,'2008-03-18 09:39:49');
INSERT INTO CHANSON VALUES(7093,'Le mariage insolite de Marie la Bretonne',3,NULL,'f','2008-03-18 14:39:37');
INSERT INTO CHANSON VALUES(7094,'Derobée de Guingamp',3,NULL,'t','2008-03-12 16:51:31');
INSERT INTO CHANSON VALUES(7095,'Quand la bergère',3,NULL,'f','2008-03-18 19:18:42');
INSERT INTO CHANSON VALUES(7096,'Le grand valet',3,NULL,'f','2008-03-18 19:26:56');
INSERT INTO CHANSON VALUES(7097,'La découverte ou l''ignorance',3,NULL,NULL,'2008-03-16 16:29:36');
INSERT INTO CHANSON VALUES(7098,'Merry Blues',2,NULL,NULL,'2008-03-12 10:49:29');
INSERT INTO CHANSON VALUES(7099,'Bixo',2,NULL,'f','2008-03-12 10:48:28');
INSERT INTO CHANSON VALUES(7100,'Eldorado 1997',2,NULL,'f','2008-03-12 19:07:14');
INSERT INTO CHANSON VALUES(7101,'Pomiscuity',2,NULL,'f','2008-03-12 09:13:36');
INSERT INTO CHANSON VALUES(7102,'La Primavera',2,NULL,'f','2008-03-12 11:45:36');
INSERT INTO CHANSON VALUES(7103,'Me Gustas Tu',2,NULL,'f','2008-03-12 19:19:16');
INSERT INTO CHANSON VALUES(7104,'Denia',2,NULL,'f','2008-03-12 15:03:08');
INSERT INTO CHANSON VALUES(7105,'Mi Vida',2,NULL,'f','2008-03-12 09:11:48');
INSERT INTO CHANSON VALUES(7106,'Trapped By Love',2,NULL,'f','2008-03-12 17:06:15');
INSERT INTO CHANSON VALUES(7107,'Le Rendez Vous',2,NULL,'f','2008-03-12 16:51:45');
INSERT INTO CHANSON VALUES(7108,'Mr. Bobby',2,NULL,NULL,'2008-03-12 11:05:34');
INSERT INTO CHANSON VALUES(7109,'Papito',2,NULL,'f','2008-03-12 17:18:23');
INSERT INTO CHANSON VALUES(7110,'La Chinita',2,NULL,'f','2008-03-12 11:14:31');
INSERT INTO CHANSON VALUES(7111,'La Marea',2,NULL,'f','2008-03-12 14:23:44');
INSERT INTO CHANSON VALUES(7112,'Homens',2,NULL,'f','2008-03-12 09:38:30');
INSERT INTO CHANSON VALUES(7113,'La Vacaloca',2,NULL,'f','2008-03-12 17:38:49');
INSERT INTO CHANSON VALUES(7114,'Infinita Tristeza',2,NULL,'f','2008-03-12 08:15:52');
INSERT INTO CHANSON VALUES(7115,'Ys',3,NULL,NULL,'2008-03-12 10:23:04');
INSERT INTO CHANSON VALUES(7116,'Mary Pontkalleg',3,NULL,'t','2008-03-12 19:09:11');
INSERT INTO CHANSON VALUES(7117,'Ap Huw Penllyn',3,NULL,NULL,'2008-03-12 11:52:02');
INSERT INTO CHANSON VALUES(7118,'Eliz Iza',3,NULL,'t','2008-03-12 08:11:08');
INSERT INTO CHANSON VALUES(7119,'Gaeltacht',3,NULL,NULL,'2008-03-12 15:00:27');
INSERT INTO CHANSON VALUES(7120,'Caitlin triall',3,NULL,NULL,'2008-03-12 19:18:41');
INSERT INTO CHANSON VALUES(7121,'Port ui Mhuigheasa',3,NULL,NULL,'2008-03-12 14:51:05');
INSERT INTO CHANSON VALUES(7122,'Airde Cuan',3,NULL,NULL,'2008-03-12 10:00:43');
INSERT INTO CHANSON VALUES(7123,'Na reubairean',3,NULL,NULL,'2008-03-12 17:46:22');
INSERT INTO CHANSON VALUES(7124,'Melodie manxoise',3,NULL,'t','2008-03-12 15:48:37');
INSERT INTO CHANSON VALUES(7125,'Heman dubh',3,NULL,NULL,'2008-03-12 13:59:01');
INSERT INTO CHANSON VALUES(7126,'Gaelic waltz',3,NULL,NULL,'2008-03-12 14:59:11');
INSERT INTO CHANSON VALUES(7127,'Struan Robertson',3,NULL,NULL,'2008-03-12 16:14:03');
INSERT INTO CHANSON VALUES(7128,'The little cascade',3,NULL,NULL,'2008-03-12 17:15:14');
INSERT INTO CHANSON VALUES(7129,'Braigh Loch Lall',3,NULL,NULL,'2008-03-12 18:50:15');
INSERT INTO CHANSON VALUES(7130,'De wijn',3,NULL,NULL,'2008-03-12 12:48:33');
INSERT INTO CHANSON VALUES(7131,'Barbagal',3,NULL,NULL,'2008-03-12 08:19:24');
INSERT INTO CHANSON VALUES(7132,'Isabelle',3,NULL,'f','2008-04-07 08:01:00');
INSERT INTO CHANSON VALUES(7133,'''t Zoutvat',3,NULL,NULL,'2008-04-07 12:09:16');
INSERT INTO CHANSON VALUES(7134,'De wanhoop',3,NULL,NULL,'2008-04-13 12:04:08');
INSERT INTO CHANSON VALUES(7135,'In this heart',3,NULL,NULL,'2008-03-12 09:33:25');
INSERT INTO CHANSON VALUES(7136,'Min morfar',3,NULL,NULL,'2008-04-07 19:41:38');
INSERT INTO CHANSON VALUES(7137,'''t Jeugdig groen',3,NULL,NULL,'2008-04-13 14:32:03');
INSERT INTO CHANSON VALUES(7138,'De wereld vergaat',3,NULL,NULL,'2008-04-07 10:42:38');
INSERT INTO CHANSON VALUES(7139,'Warme garnas',3,NULL,NULL,'2008-03-12 18:19:11');
INSERT INTO CHANSON VALUES(7140,'''t Smidje',3,NULL,NULL,'2008-04-07 10:21:20');
INSERT INTO CHANSON VALUES(7141,'Grand Jacques',3,NULL,NULL,'2008-03-12 11:54:00');
INSERT INTO CHANSON VALUES(7142,'Bruidsnacht',3,NULL,NULL,'2008-04-07 16:38:13');
INSERT INTO CHANSON VALUES(7143,'7 Steken',3,NULL,NULL,'2008-04-13 11:05:00');
INSERT INTO CHANSON VALUES(7144,'neketS 7',3,NULL,NULL,'2008-03-12 18:22:00');
INSERT INTO CHANSON VALUES(7145,'Erin Shore (Traditional Intro)',3,NULL,'f','2008-03-12 18:54:00');
INSERT INTO CHANSON VALUES(7146,'Forgiven Not Forgotten',3,NULL,'f','2008-03-12 09:37:14');
INSERT INTO CHANSON VALUES(7147,'Heaven Knows',3,NULL,'f','2008-03-12 09:23:30');
INSERT INTO CHANSON VALUES(7148,'Along With The Girls',3,NULL,'f','2008-03-12 12:17:20');
INSERT INTO CHANSON VALUES(7149,'Someday',3,NULL,'f','2008-03-12 15:40:09');
INSERT INTO CHANSON VALUES(7150,'Runaway',3,NULL,'f','2008-03-12 10:43:28');
INSERT INTO CHANSON VALUES(7151,'The Right Time',3,NULL,'f','2008-03-12 15:52:02');
INSERT INTO CHANSON VALUES(7152,'The Minstrel Boy',3,NULL,NULL,'2008-09-28 10:51:26.477379');
INSERT INTO CHANSON VALUES(7153,'Toss The Feathers',3,NULL,'f','2008-03-12 11:01:15');
INSERT INTO CHANSON VALUES(7154,'Love To Love You',3,NULL,'f','2008-03-12 11:54:38');
INSERT INTO CHANSON VALUES(7155,'Secret Life',3,NULL,'f','2008-03-12 11:49:32');
INSERT INTO CHANSON VALUES(7156,'Carraroe Jig',3,NULL,'f','2008-03-12 11:55:09');
INSERT INTO CHANSON VALUES(7157,'Closer',3,NULL,'f','2008-03-12 14:04:33');
INSERT INTO CHANSON VALUES(7158,'Leave Me Alone',3,NULL,'f','2008-03-12 08:29:51');
INSERT INTO CHANSON VALUES(7159,'Erin Shore',3,NULL,NULL,'2008-03-12 12:08:31');
INSERT INTO CHANSON VALUES(7160,'Les moines de Gyuto -',3,NULL,NULL,'2008-03-12 14:21:15');
INSERT INTO CHANSON VALUES(7161,'',3,NULL,NULL,'2008-03-12 08:00:07');
INSERT INTO CHANSON VALUES(7162,'',3,NULL,NULL,'2008-03-12 08:03:53');
INSERT INTO CHANSON VALUES(7163,'',3,NULL,NULL,'2008-03-12 12:19:54');
INSERT INTO CHANSON VALUES(7164,'',3,NULL,NULL,'2008-03-12 16:35:49');
INSERT INTO CHANSON VALUES(7165,'',3,NULL,NULL,'2008-03-12 11:53:38');
INSERT INTO CHANSON VALUES(7166,'',3,NULL,NULL,'2008-03-12 18:10:33');
INSERT INTO CHANSON VALUES(7167,'',3,NULL,NULL,'2008-03-12 08:43:38');
INSERT INTO CHANSON VALUES(7168,'',3,NULL,NULL,'2008-03-12 14:46:07');
INSERT INTO CHANSON VALUES(7169,'',3,NULL,NULL,'2008-03-12 11:45:42');
INSERT INTO CHANSON VALUES(7170,'',3,NULL,NULL,'2008-03-12 10:10:01');
INSERT INTO CHANSON VALUES(7171,'',3,NULL,NULL,'2008-03-12 09:51:37');
INSERT INTO CHANSON VALUES(7172,'',3,NULL,NULL,'2008-03-12 19:09:31');
INSERT INTO CHANSON VALUES(7173,'',3,NULL,NULL,'2008-03-12 15:01:41');
INSERT INTO CHANSON VALUES(7174,'',3,NULL,NULL,'2008-03-12 09:01:25');
INSERT INTO CHANSON VALUES(7175,'',3,NULL,NULL,'2008-03-12 17:35:11');
INSERT INTO CHANSON VALUES(7176,'If I Should Fall From Grace With God',3,NULL,NULL,'2008-03-12 19:00:20');
INSERT INTO CHANSON VALUES(7177,'Turkish Song Of The Damned',3,NULL,'f','2008-03-12 10:57:02');
INSERT INTO CHANSON VALUES(7178,'Bottle of Smoke',3,NULL,'f','2008-03-12 18:08:44');
INSERT INTO CHANSON VALUES(7179,'Fairytale of New York',3,NULL,'f','2008-03-12 13:27:30');
INSERT INTO CHANSON VALUES(7180,'Metropolis',3,NULL,'f','2008-03-12 10:40:40');
INSERT INTO CHANSON VALUES(7182,'South Australia',3,NULL,'f','2008-03-12 18:45:41');
INSERT INTO CHANSON VALUES(7183,'Fiesta',3,NULL,'f','2008-03-12 12:20:43');
INSERT INTO CHANSON VALUES(7184,'Medley',3,NULL,'f','2008-05-22 11:24:40');
INSERT INTO CHANSON VALUES(7185,'Streets of Sorrow/Birmingham Six',3,NULL,'f','2008-03-12 08:28:45');
INSERT INTO CHANSON VALUES(7186,'Lullaby of London',3,NULL,'f','2008-03-12 13:16:20');
INSERT INTO CHANSON VALUES(7187,'The Battle March Medley',3,NULL,'f','2008-03-12 16:12:21');
INSERT INTO CHANSON VALUES(7188,'Sit Down By The Fire',3,NULL,'f','2008-03-12 08:24:18');
INSERT INTO CHANSON VALUES(7189,'The Broad Majestic Shannon',3,NULL,'f','2008-03-12 08:15:27');
INSERT INTO CHANSON VALUES(7190,'Worms',3,NULL,'f','2008-03-12 17:44:54');
INSERT INTO CHANSON VALUES(7192,'Douce France',3,NULL,'f','2008-03-12 08:09:23');
INSERT INTO CHANSON VALUES(7193,'Bleu de Marseille',3,NULL,'f','2008-03-12 14:01:08');
INSERT INTO CHANSON VALUES(7194,'Rhorhomanie',3,NULL,NULL,'2008-03-12 11:23:28');
INSERT INTO CHANSON VALUES(7195,'Ramsa',3,NULL,'f','2008-03-12 19:27:57');
INSERT INTO CHANSON VALUES(7196,'Zoubida',3,NULL,'f','2008-03-12 16:57:14');
INSERT INTO CHANSON VALUES(7197,'Barbès',3,NULL,'f','2008-03-12 08:38:26');
INSERT INTO CHANSON VALUES(7198,'Bled',3,NULL,'f','2008-03-12 13:40:51');
INSERT INTO CHANSON VALUES(7199,'Malika',3,NULL,NULL,'2008-03-12 16:45:06');
INSERT INTO CHANSON VALUES(7200,'Voilà, Voilà',3,NULL,'f','2008-03-12 10:35:50');
INSERT INTO CHANSON VALUES(7201,'Indie (Voval Version/ 1+1+1...)',3,NULL,'f','2008-03-12 09:55:47');
INSERT INTO CHANSON VALUES(7202,'Non Non Non (Original Version)',3,NULL,'f','2008-03-12 16:56:56');
INSERT INTO CHANSON VALUES(7203,'Valencia',3,NULL,'f','2008-03-12 08:29:57');
INSERT INTO CHANSON VALUES(7204,'Jungle Fiction',3,NULL,'f','2008-03-12 10:44:21');
INSERT INTO CHANSON VALUES(7205,'Kelma',3,NULL,'f','2008-03-12 16:42:49');
INSERT INTO CHANSON VALUES(7206,'A vava inouva',3,NULL,NULL,'2008-03-12 15:25:46');
INSERT INTO CHANSON VALUES(7207,'Isefra',3,NULL,NULL,'2008-03-12 18:30:24');
INSERT INTO CHANSON VALUES(7208,'Ssendu',3,NULL,NULL,'2008-03-26 12:55:05');
INSERT INTO CHANSON VALUES(7209,'Azger',3,NULL,NULL,'2008-03-12 10:40:51');
INSERT INTO CHANSON VALUES(7210,'Murleg',3,NULL,NULL,'2008-03-12 11:51:26');
INSERT INTO CHANSON VALUES(7211,'Zwit rwit',3,NULL,NULL,'2008-03-12 09:57:21');
INSERT INTO CHANSON VALUES(7212,'Cfig',3,NULL,NULL,'2008-03-12 19:39:18');
INSERT INTO CHANSON VALUES(7213,'Azwaw',3,NULL,NULL,'2008-03-12 18:44:47');
INSERT INTO CHANSON VALUES(7214,'Tagrawla',3,NULL,NULL,'2008-03-12 18:57:32');
INSERT INTO CHANSON VALUES(7215,'Tigri Bw Gdud',3,NULL,NULL,'2008-03-12 10:39:15');
INSERT INTO CHANSON VALUES(7216,'Acawi',3,NULL,NULL,'2008-03-12 08:19:41');
INSERT INTO CHANSON VALUES(7217,'Ay arac nneg',3,NULL,NULL,'2008-03-12 17:13:11');
INSERT INTO CHANSON VALUES(7218,'Cteduyi',3,NULL,NULL,'2008-03-12 10:33:07');
INSERT INTO CHANSON VALUES(7219,'Izumal',3,NULL,NULL,'2008-03-12 11:44:47');
INSERT INTO CHANSON VALUES(7220,'L''mut',3,NULL,NULL,'2008-03-12 09:02:39');
INSERT INTO CHANSON VALUES(7221,'W''ibgun',3,NULL,NULL,'2008-03-12 15:11:37');
INSERT INTO CHANSON VALUES(7222,'Agrib',3,NULL,NULL,'2008-03-12 19:07:16');
INSERT INTO CHANSON VALUES(7223,'Tous les palmiers',3,NULL,'f','2008-03-12 11:59:00');
INSERT INTO CHANSON VALUES(7224,'A toutes les fois',3,NULL,'f','2008-03-12 08:50:58');
INSERT INTO CHANSON VALUES(7225,'Chinatown',3,NULL,'f','2008-03-12 15:02:37');
INSERT INTO CHANSON VALUES(7226,'La complainte du phoque en Alaska',3,NULL,NULL,'2008-03-12 18:03:57');
INSERT INTO CHANSON VALUES(7227,'Le Picbois',3,NULL,NULL,'2008-03-12 14:50:10');
INSERT INTO CHANSON VALUES(7228,'Harmonie du soir à Chateauguay',3,NULL,'f','2008-03-12 16:03:44');
INSERT INTO CHANSON VALUES(7229,'Le géant Beaupré',3,NULL,'f','2008-03-12 18:21:28');
INSERT INTO CHANSON VALUES(7230,'Ginette',3,NULL,'f','2008-03-12 15:30:31');
INSERT INTO CHANSON VALUES(7231,'Un ange gardien',3,NULL,'f','2008-03-12 11:06:42');
INSERT INTO CHANSON VALUES(7232,'23 décembre',3,NULL,'f','2008-03-12 18:04:49');
INSERT INTO CHANSON VALUES(7233,'Montréal',3,NULL,'f','2008-03-12 10:20:49');
INSERT INTO CHANSON VALUES(7234,'Le blues de la métropole',3,NULL,'f','2008-03-12 10:24:39');
INSERT INTO CHANSON VALUES(7235,'Assis dans'' cuisine',3,NULL,'f','2008-03-12 09:00:42');
INSERT INTO CHANSON VALUES(7236,'Amène pas ta gang',3,NULL,NULL,'2008-03-12 17:52:45');
INSERT INTO CHANSON VALUES(7237,'Motel "Mon repos"',3,NULL,'f','2008-03-12 16:24:35');
INSERT INTO CHANSON VALUES(7238,'J''ai oublié le jour',3,NULL,'f','2008-03-12 19:08:38');
INSERT INTO CHANSON VALUES(7239,'Beaj',3,NULL,NULL,'2008-03-12 15:58:00');
INSERT INTO CHANSON VALUES(7240,'Gwerz I',3,NULL,NULL,'2008-03-12 09:37:30');
INSERT INTO CHANSON VALUES(7241,'Loc''h ar goulen',3,NULL,NULL,'2008-03-12 15:54:37');
INSERT INTO CHANSON VALUES(7242,'Divodan',3,NULL,NULL,'2008-03-12 12:48:42');
INSERT INTO CHANSON VALUES(7243,'Emskiant',3,NULL,NULL,'2008-03-12 10:59:03');
INSERT INTO CHANSON VALUES(7244,'Kendaskren',3,NULL,NULL,'2008-03-12 08:10:27');
INSERT INTO CHANSON VALUES(7245,'Imram',3,NULL,NULL,'2008-03-12 16:19:28');
INSERT INTO CHANSON VALUES(7246,'Dilestran',3,NULL,NULL,'2008-03-12 12:07:20');
INSERT INTO CHANSON VALUES(7247,'Ar C''hammou Kentan',3,NULL,NULL,'2008-03-12 09:51:45');
INSERT INTO CHANSON VALUES(7248,'Ar Geoded Skedus',3,NULL,NULL,'2008-03-12 17:46:53');
INSERT INTO CHANSON VALUES(7249,'Ar Bale',3,NULL,NULL,'2008-03-12 12:26:52');
INSERT INTO CHANSON VALUES(7250,'Gouel Hollvedel (I)',3,NULL,NULL,'2008-03-12 12:34:29');
INSERT INTO CHANSON VALUES(7251,'Gouel Hollvedel (II)',3,NULL,NULL,'2008-03-12 19:13:23');
INSERT INTO CHANSON VALUES(7252,'Gouel Hollvedel (III)',3,NULL,NULL,'2008-03-12 14:36:12');
INSERT INTO CHANSON VALUES(7253,'Gouel Hollvedel (IV)',3,NULL,NULL,'2008-03-12 10:48:11');
INSERT INTO CHANSON VALUES(7254,'An Distro',3,NULL,NULL,'2008-03-12 11:51:21');
INSERT INTO CHANSON VALUES(7255,'Le lac orange au chien qui fume',3,NULL,NULL,'2008-03-12 17:32:41');
INSERT INTO CHANSON VALUES(7256,'Guendun',3,NULL,NULL,'2008-03-12 10:56:48');
INSERT INTO CHANSON VALUES(7257,'Mammouth',3,NULL,NULL,'2008-03-12 14:05:40');
INSERT INTO CHANSON VALUES(7258,'Tout le monde est là',3,NULL,NULL,'2008-03-12 11:51:27');
INSERT INTO CHANSON VALUES(7259,'Petit Homme',3,NULL,NULL,'2008-03-12 10:15:53');
INSERT INTO CHANSON VALUES(7260,'Les cons pressent',3,NULL,NULL,'2008-03-12 09:39:28');
INSERT INTO CHANSON VALUES(7261,'Kang Yul (Pays des neiges)',3,NULL,NULL,'2008-03-12 15:34:41');
INSERT INTO CHANSON VALUES(7262,'Fantastic Planet',3,NULL,NULL,'2008-03-12 19:06:18');
INSERT INTO CHANSON VALUES(7263,'The Orientalist',3,NULL,NULL,'2008-03-12 10:21:07');
INSERT INTO CHANSON VALUES(7264,'Magique',3,NULL,NULL,'2008-03-12 12:39:58');
INSERT INTO CHANSON VALUES(7265,'Song of Amdo',3,NULL,NULL,'2008-03-12 17:25:31');
INSERT INTO CHANSON VALUES(7266,'Insectos voladores',3,NULL,NULL,'2008-03-12 13:39:28');
INSERT INTO CHANSON VALUES(7267,'Ignorance',3,NULL,NULL,'2008-03-12 11:14:34');
INSERT INTO CHANSON VALUES(7268,'Douma Né Izdouma',3,NULL,NULL,'2008-03-12 19:33:25');
INSERT INTO CHANSON VALUES(7269,'Values (R)evolution',3,NULL,NULL,'2008-03-12 12:47:40');
INSERT INTO CHANSON VALUES(7270,'Revolution Dub',3,NULL,NULL,'2008-03-12 11:53:19');
INSERT INTO CHANSON VALUES(7271,'Free flou of a secret',3,NULL,NULL,'2008-03-12 17:28:53');
INSERT INTO CHANSON VALUES(7272,'Je m''appelle Jane',5,NULL,'f','2008-03-12 13:27:00');
INSERT INTO CHANSON VALUES(7273,'T''as pas le droit d''avoir moins mal que moi',5,NULL,'f','2008-03-12 17:39:22');
INSERT INTO CHANSON VALUES(7275,'Palais Royal',5,NULL,'f','2008-03-12 18:47:27');
INSERT INTO CHANSON VALUES(7277,'Strange Melody',5,NULL,'f','2008-03-12 18:30:21');
INSERT INTO CHANSON VALUES(7278,'O Leazinho',5,NULL,'f','2008-03-12 13:26:55');
INSERT INTO CHANSON VALUES(7279,'Pour un flirt avec toi',5,NULL,'f','2008-03-12 18:50:42');
INSERT INTO CHANSON VALUES(7280,'The Simple Story',5,NULL,'f','2008-03-12 14:07:35');
INSERT INTO CHANSON VALUES(7281,'Te souviens-tu?',5,NULL,'f','2008-03-12 18:53:04');
INSERT INTO CHANSON VALUES(7282,'Smile',5,NULL,'f','2008-03-12 16:20:32');
INSERT INTO CHANSON VALUES(7283,'Surannée',5,NULL,'f','2008-03-12 17:06:11');
INSERT INTO CHANSON VALUES(7284,'Canary Canary',5,NULL,'f','2008-03-12 09:00:14');
INSERT INTO CHANSON VALUES(7285,'Chiamami adesso',5,NULL,'f','2008-03-12 10:52:02');
INSERT INTO CHANSON VALUES(7286,'Port-Bail',5,NULL,'f','2008-03-12 15:15:17');
INSERT INTO CHANSON VALUES(7287,'Canary Canary',5,NULL,'f','2008-03-12 17:07:47');
INSERT INTO CHANSON VALUES(7289,'Tria Cantica Eucharistica',3,NULL,NULL,'2008-03-12 08:23:04');
INSERT INTO CHANSON VALUES(7290,'De Reiziger',3,NULL,NULL,'2008-04-07 13:09:19');
INSERT INTO CHANSON VALUES(7291,'After The Goldrush',3,NULL,NULL,'2008-03-12 16:55:11');
INSERT INTO CHANSON VALUES(7292,'Belle (Je M''en Vais)',3,NULL,NULL,'2008-03-12 11:45:04');
INSERT INTO CHANSON VALUES(7293,'May Morning Dew',3,NULL,NULL,'2008-03-12 12:30:25');
INSERT INTO CHANSON VALUES(7294,'Tjanne',3,NULL,NULL,'2008-03-12 19:15:32');
INSERT INTO CHANSON VALUES(7295,'Wee Mij',3,NULL,NULL,'2008-03-12 09:23:32');
INSERT INTO CHANSON VALUES(7296,'Kabouter Kiekeboe',3,NULL,NULL,'2008-03-12 12:33:24');
INSERT INTO CHANSON VALUES(7297,'???',3,NULL,NULL,'2008-03-12 13:12:39');
INSERT INTO CHANSON VALUES(7298,'Marie Madeleine',3,NULL,NULL,'2008-03-12 16:57:47');
INSERT INTO CHANSON VALUES(7299,'Rinaldo',3,NULL,NULL,'2008-04-13 10:29:15');
INSERT INTO CHANSON VALUES(7300,'Jasio U Pana',3,NULL,NULL,'2008-03-12 13:04:20');
INSERT INTO CHANSON VALUES(7301,'Wanhoop van een wees',3,NULL,NULL,'2008-03-12 16:06:44');
INSERT INTO CHANSON VALUES(7302,'De klacht van een verstoten minnares',3,NULL,NULL,'2008-03-12 17:50:39');
INSERT INTO CHANSON VALUES(7303,'Opzij',3,NULL,NULL,'2008-06-07 19:25:13.356483');
INSERT INTO CHANSON VALUES(7304,'Marieke',3,NULL,'f','2008-03-12 08:34:55');
INSERT INTO CHANSON VALUES(7305,'La plus belle de Céans',3,NULL,'f','2008-03-12 13:30:11');
INSERT INTO CHANSON VALUES(7306,'Al Béole 17',3,NULL,NULL,'2008-03-12 08:38:35');
INSERT INTO CHANSON VALUES(7307,'De drie Maagdekens',3,NULL,NULL,'2008-03-12 14:01:08');
INSERT INTO CHANSON VALUES(7308,'Dormez, dormez',3,NULL,NULL,'2008-03-12 19:26:21');
INSERT INTO CHANSON VALUES(7309,'Hymne',3,NULL,NULL,'2008-03-12 15:08:18');
INSERT INTO CHANSON VALUES(7311,'La traîtresse',5,NULL,NULL,'2008-04-13 16:15:06');
INSERT INTO CHANSON VALUES(7312,'Tonton Nestor',5,NULL,NULL,'2008-03-26 12:48:08');
INSERT INTO CHANSON VALUES(7313,'Le bistrot',5,NULL,'f','2008-03-24 17:21:28');
INSERT INTO CHANSON VALUES(7314,'Embrasse-les tous',5,NULL,'f','2008-03-24 14:07:09');
INSERT INTO CHANSON VALUES(7315,'La ballade des cimetières',5,NULL,'f','2008-03-24 09:08:29');
INSERT INTO CHANSON VALUES(7316,'L''enterrement de Verlaine',5,NULL,'f','2008-03-24 14:13:03');
INSERT INTO CHANSON VALUES(7317,'Germaine Tourangelle',5,NULL,'f','2008-03-24 19:17:07');
INSERT INTO CHANSON VALUES(7318,'à Mireille, dite Petit Verglas',5,NULL,'f','2008-03-24 13:42:34');
INSERT INTO CHANSON VALUES(7319,'Pénélope',5,NULL,'f','2008-04-13 17:39:31');
INSERT INTO CHANSON VALUES(7320,'L''orage',5,NULL,'f','2008-03-24 13:16:41');
INSERT INTO CHANSON VALUES(7321,'Le mécréant',5,NULL,'f','2008-04-07 10:04:23');
INSERT INTO CHANSON VALUES(7322,'Le verger du roi Louis',5,NULL,'f','2008-03-24 16:44:13');
INSERT INTO CHANSON VALUES(7323,'Le temps passé',5,NULL,'f','2008-03-26 11:18:14');
INSERT INTO CHANSON VALUES(7324,'La fille à cent sous',5,NULL,'f','2008-03-24 18:45:44');
INSERT INTO CHANSON VALUES(7325,'Les trompettes de la renommée',5,NULL,'f','2008-03-26 17:55:50');
INSERT INTO CHANSON VALUES(7326,'Jeanne',5,NULL,'f','2008-03-24 12:08:09');
INSERT INTO CHANSON VALUES(7327,'Dans l''eau de la claire fontaine',5,NULL,'f','2008-03-24 08:20:28');
INSERT INTO CHANSON VALUES(7328,'Je rejoindrai ma belle',5,NULL,'f','2008-03-24 13:05:50');
INSERT INTO CHANSON VALUES(7329,'La marguerite',5,NULL,'f','2008-03-24 19:35:00');
INSERT INTO CHANSON VALUES(7330,'Si le bon Dieu l''avait voulu',5,NULL,'f','2008-03-12 11:43:08');
INSERT INTO CHANSON VALUES(7331,'La guerre de 14-18',5,NULL,'f','2008-03-24 18:37:15');
INSERT INTO CHANSON VALUES(7332,'Les amours d''antan',5,NULL,'f','2008-04-13 17:25:50');
INSERT INTO CHANSON VALUES(7333,'Le temps ne fait rien à l''affaire',5,NULL,'f','2008-03-26 17:17:21');
INSERT INTO CHANSON VALUES(7334,'Marquise',5,NULL,'f','2008-03-12 17:47:04');
INSERT INTO CHANSON VALUES(7335,'L''assassinat',5,NULL,NULL,'2008-04-13 18:09:18');
INSERT INTO CHANSON VALUES(7336,'La complainte des filles de joie',5,NULL,'f','2008-03-24 12:28:49');
INSERT INTO CHANSON VALUES(7337,'Whisky Whisky',3,NULL,'f','2008-03-12 15:44:07');
INSERT INTO CHANSON VALUES(7338,'Sein 1940',3,NULL,'f','2008-03-12 18:09:24');
INSERT INTO CHANSON VALUES(7339,'Lest du Diable',3,NULL,'f','2008-03-12 14:55:19');
INSERT INTO CHANSON VALUES(7340,'Divent An Dour',3,NULL,'t','2008-03-12 12:00:40');
INSERT INTO CHANSON VALUES(7341,'L''épopée de Monsieur Cassard',3,NULL,'f','2008-03-12 18:28:45');
INSERT INTO CHANSON VALUES(7342,'Nantillaise',3,NULL,'f','2008-03-12 16:25:20');
INSERT INTO CHANSON VALUES(7343,'Le Naufrage du Chaland de Jim Boyd',3,NULL,NULL,'2008-03-12 16:41:04');
INSERT INTO CHANSON VALUES(7344,'Marie-Jeanne-Gabrielle',3,NULL,NULL,'2008-03-12 18:26:22');
INSERT INTO CHANSON VALUES(7345,'La campagne du Belem de 1902',3,NULL,'f','2008-03-16 10:15:09');
INSERT INTO CHANSON VALUES(7346,'Belle Virginie',3,NULL,'f','2008-03-12 11:38:37');
INSERT INTO CHANSON VALUES(7347,'Le navire étonnant',3,NULL,'f','2008-03-12 09:15:22');
INSERT INTO CHANSON VALUES(7348,'La complainte de Louis-Marie Jossic',3,NULL,'f','2008-03-12 10:06:32');
INSERT INTO CHANSON VALUES(7349,'La mer est sans fin',3,NULL,NULL,'2008-03-12 15:38:27');
INSERT INTO CHANSON VALUES(7350,'Les prisons de Nantes',3,NULL,'t','2008-03-16 19:01:28');
INSERT INTO CHANSON VALUES(7351,'Le soleil est noir',3,NULL,'f','2008-03-16 15:52:57');
INSERT INTO CHANSON VALUES(7352,'Les filles des forges (Pilé  Menu)',3,NULL,'t','2008-03-16 12:34:22');
INSERT INTO CHANSON VALUES(7358,'Pelot d''Hennebont',3,NULL,'t','2008-03-24 08:15:16');
INSERT INTO CHANSON VALUES(7360,'Le renard',3,NULL,'f','2008-03-24 14:20:14');
INSERT INTO CHANSON VALUES(7363,'Gwerz jorj courtois',3,NULL,'f','2008-03-18 12:59:46');
INSERT INTO CHANSON VALUES(7365,'Réel de Louis Marie',3,NULL,'f','2008-03-12 12:38:26');
INSERT INTO CHANSON VALUES(7366,'Les filles de Redon',3,NULL,'f','2008-03-16 18:17:19');
INSERT INTO CHANSON VALUES(7368,'Déjà  mal mariée (en public)',3,NULL,'f','2008-03-18 09:27:09');
INSERT INTO CHANSON VALUES(7369,'La jument de Michao (en public)',3,NULL,'t','2008-03-16 10:17:17');
INSERT INTO CHANSON VALUES(7370,'Mont a rin da saludin ma c''habiten',3,NULL,NULL,'2008-06-02 15:08:43.22607');
INSERT INTO CHANSON VALUES(7371,'Undeiz oan éfoennat',3,NULL,NULL,'2008-06-02 15:08:21.375565');
INSERT INTO CHANSON VALUES(7372,'Bal et gavotte pourlet',3,NULL,'t','2008-06-02 15:07:28.11447');
INSERT INTO CHANSON VALUES(7373,'Marche',3,NULL,NULL,'2008-03-12 14:11:59');
INSERT INTO CHANSON VALUES(7374,'Dérobées et tarentelles',3,NULL,NULL,'2008-06-02 15:06:50.95777');
INSERT INTO CHANSON VALUES(7375,'Marion les roses',3,NULL,NULL,'2008-06-02 15:07:22.712031');
INSERT INTO CHANSON VALUES(7376,'Dans plin -extrait-',3,NULL,NULL,'2008-06-02 15:07:14.91639');
INSERT INTO CHANSON VALUES(7378,'Suite montagne',3,NULL,'t','2008-03-12 12:13:45');
INSERT INTO CHANSON VALUES(7379,'Suite nantaise',3,NULL,'t','2008-03-12 14:27:02');
INSERT INTO CHANSON VALUES(7380,'A-barh jardin er Minour',3,NULL,NULL,'2008-03-12 18:11:32');
INSERT INTO CHANSON VALUES(7381,'Suite de Kas-a-barh & de Kejaj',3,NULL,'t','2008-03-12 13:41:23');
INSERT INTO CHANSON VALUES(7382,'A-barh jardin er Minour (variante)',3,NULL,NULL,'2008-03-12 16:35:13');
INSERT INTO CHANSON VALUES(7383,'Suite Laridés six temps gallo-vannetaises',3,NULL,'t','2008-06-02 15:07:58.06185');
INSERT INTO CHANSON VALUES(7384,'Clam',3,NULL,NULL,'2008-03-12 16:28:30');
INSERT INTO CHANSON VALUES(7385,'Mélodie vannetaise',3,NULL,NULL,'2008-06-02 15:06:31.74465');
INSERT INTO CHANSON VALUES(7386,'Bigoud 1',3,NULL,NULL,'2008-03-12 15:25:13');
INSERT INTO CHANSON VALUES(7387,'Gwerzenn ar labourer-douar',3,NULL,'t','2008-03-12 10:56:16');
INSERT INTO CHANSON VALUES(7388,'Laride Mod-nevez',3,NULL,'t','2008-03-12 14:19:30');
INSERT INTO CHANSON VALUES(7389,'Ton bale ar c''hezeg',3,NULL,'t','2008-03-12 11:53:58');
INSERT INTO CHANSON VALUES(7390,'Kost ar c''hoad',3,NULL,'t','2008-03-12 11:44:09');
INSERT INTO CHANSON VALUES(7391,'Kas ar barh',3,NULL,'t','2008-03-12 18:12:51');
INSERT INTO CHANSON VALUES(7392,'Porc qu''au pot',3,NULL,NULL,'2008-03-12 11:56:26');
INSERT INTO CHANSON VALUES(7393,'Kanomp Noël',3,NULL,NULL,'2008-06-02 15:09:46.758278');
INSERT INTO CHANSON VALUES(7394,'Marchalombe',3,NULL,NULL,'2008-03-12 18:23:04');
INSERT INTO CHANSON VALUES(7395,'Hypnoz',3,NULL,NULL,'2008-03-12 12:45:18');
INSERT INTO CHANSON VALUES(7396,'Suite de Loudéac',3,NULL,'t','2008-06-02 15:09:19.409643');
INSERT INTO CHANSON VALUES(7397,'Gavotte Pourlet',3,NULL,'t','2008-03-12 14:38:39');
INSERT INTO CHANSON VALUES(7398,'La marche amère',3,NULL,NULL,'2008-06-02 15:09:30.735011');
INSERT INTO CHANSON VALUES(7399,'Gavottenn ar menez',3,NULL,'t','2008-03-12 12:25:53');
INSERT INTO CHANSON VALUES(7400,'Marie a''r m''enez',3,NULL,NULL,'2008-06-02 15:10:02.472386');
INSERT INTO CHANSON VALUES(7401,'Suite plinn',3,NULL,'t','2008-03-12 14:36:51');
INSERT INTO CHANSON VALUES(7402,'Tuchant e arruiou en hanv',3,NULL,NULL,'2008-03-12 12:51:47');
INSERT INTO CHANSON VALUES(7403,'Marche du pays plin, Dans tro-lin',3,NULL,'t','2008-03-12 17:20:27');
INSERT INTO CHANSON VALUES(7405,'Dans les prisons de Nantes',3,NULL,'t','2008-03-16 13:39:36');
INSERT INTO CHANSON VALUES(7407,'Mrs Mc Dermott / Roches favourite',3,NULL,'f','2008-03-12 17:00:01');
INSERT INTO CHANSON VALUES(7409,'Les 90 maçons',3,NULL,'f','2008-03-18 13:34:40');
INSERT INTO CHANSON VALUES(7411,'Kan an alarc''h',3,NULL,'t','2008-03-16 09:48:15');
INSERT INTO CHANSON VALUES(7412,'Le dauphin',3,NULL,'f','2008-03-18 08:08:00');
INSERT INTO CHANSON VALUES(7413,'Song for ye Jacobites',3,NULL,'f','2008-03-18 16:39:37');
INSERT INTO CHANSON VALUES(7414,'Brian Boru',3,NULL,'t','2008-03-12 14:00:29');
INSERT INTO CHANSON VALUES(7415,'Guerre guerre, vente vent / La fleur d''Ugénie',3,NULL,'f','2008-03-16 11:48:49');
INSERT INTO CHANSON VALUES(7416,'Kan ar kann',3,NULL,'t','2008-03-24 16:02:14');
INSERT INTO CHANSON VALUES(7417,'Le loup, le renard, la jument de Michao etc. / Horse reel',3,NULL,'t','2008-03-16 17:11:04');
INSERT INTO CHANSON VALUES(7418,'Les métamorphoses de Madeleine Bernard',3,NULL,'f','2008-03-18 15:39:44');
INSERT INTO CHANSON VALUES(7419,'Madeleine Bernard',3,NULL,'f','2008-03-18 11:25:45');
INSERT INTO CHANSON VALUES(7420,'Ce sont les filles des Forges',3,NULL,'t','2008-03-16 11:55:20');
INSERT INTO CHANSON VALUES(7421,'Vive la République, vive la Liberté',3,NULL,'f','2008-03-16 19:04:46');
INSERT INTO CHANSON VALUES(7422,'5 den...',3,NULL,'f','2008-03-12 17:13:34');
INSERT INTO CHANSON VALUES(7423,'Bidoc''hig (ridées 6 temps)',3,NULL,'f','2008-03-20 08:16:43');
INSERT INTO CHANSON VALUES(7424,'Kasabeach (Kas a barzh)',3,NULL,'f','2008-03-12 08:57:22');
INSERT INTO CHANSON VALUES(7425,'Allez... gavotte! (ton simpl gavotenn)',3,NULL,'f','2008-03-12 16:29:22');
INSERT INTO CHANSON VALUES(7426,'Allez... gavotte! (tamm kreiz)',3,NULL,'f','2008-03-12 09:49:11');
INSERT INTO CHANSON VALUES(7427,'Allez... gavotte! (ton doubl gavotenn)',3,NULL,'f','2008-03-12 19:37:23');
INSERT INTO CHANSON VALUES(7428,'Diwskouarn vras an aotrou Spock (scottosch)',3,NULL,'f','2008-03-12 08:15:02');
INSERT INTO CHANSON VALUES(7429,'6 L 6 (rond de Loudéac 1)',3,NULL,'f','2008-03-20 17:30:27');
INSERT INTO CHANSON VALUES(7430,'6 L 6 (baleu)',3,NULL,NULL,'2008-03-12 14:47:22');
INSERT INTO CHANSON VALUES(7431,'6 L 6 (rond de Loudéac 2)',3,NULL,NULL,'2008-03-20 18:44:27');
INSERT INTO CHANSON VALUES(7432,'6 L 6 (riquegnée)',3,NULL,'f','2008-03-20 16:30:41');
INSERT INTO CHANSON VALUES(7433,'Disul (mélodie)',3,NULL,'f','2008-03-20 10:32:57');
INSERT INTO CHANSON VALUES(7434,'Les ronds à pof (ronds de St Vincent)',3,NULL,'f','2008-03-20 19:36:55');
INSERT INTO CHANSON VALUES(7435,'Le plinn n''a pas des titre (ton simpl plinn)',3,NULL,'f','2008-03-12 12:16:24');
INSERT INTO CHANSON VALUES(7436,'Le plinn n''a pas des titre (bal plinn)',3,NULL,'f','2008-03-12 16:26:14');
INSERT INTO CHANSON VALUES(7437,'Le plinn n''a pas des titre (ton doubl plinn)',3,NULL,'f','2008-03-12 18:25:51');
INSERT INTO CHANSON VALUES(7438,'N''avec (polka)',3,NULL,'f','2008-03-12 11:30:07');
INSERT INTO CHANSON VALUES(7439,'Caravane',3,NULL,'f','2008-03-12 11:19:37');
INSERT INTO CHANSON VALUES(7440,'Wold wide noz - la nuit de mon dentier (ton simpl gavotenn)',3,NULL,NULL,'2008-03-12 17:53:25');
INSERT INTO CHANSON VALUES(7441,'Wold wide noz - la nuit de mon dentier (tamm kreiz)',3,NULL,'f','2008-03-12 10:47:09');
INSERT INTO CHANSON VALUES(7442,'Wold wide noz - la nuit de mon dentier (ton doubl gavotenn)',3,NULL,'f','2008-03-12 15:28:40');
INSERT INTO CHANSON VALUES(7443,'Breizhier',3,NULL,'f','2008-03-12 11:42:13');
INSERT INTO CHANSON VALUES(7444,'Saler la soupe',3,NULL,'f','2008-03-12 11:40:49');
INSERT INTO CHANSON VALUES(7445,'Goran velu',3,NULL,'f','2008-03-12 10:01:05');
INSERT INTO CHANSON VALUES(7446,'Ska',3,NULL,'f','2008-03-12 15:43:32');
INSERT INTO CHANSON VALUES(7447,'Saler la soupe (20Syl Interlude)',3,NULL,'f','2008-03-12 18:37:58');
INSERT INTO CHANSON VALUES(7448,'Mariage d''argent',3,NULL,'f','2008-03-12 16:55:28');
INSERT INTO CHANSON VALUES(7449,'Hep diskrog',3,NULL,NULL,'2008-03-12 17:14:47');
INSERT INTO CHANSON VALUES(7450,'Karreg an tan',3,NULL,NULL,'2008-03-12 13:02:40');
INSERT INTO CHANSON VALUES(7451,'Ela Ela',3,NULL,NULL,'2008-03-12 18:12:28');
INSERT INTO CHANSON VALUES(7452,'Suite du Pays Leon',3,NULL,'t','2008-03-12 08:50:56');
INSERT INTO CHANSON VALUES(7454,'C''hoarzadeg',3,NULL,'t','2008-03-12 19:26:20');
INSERT INTO CHANSON VALUES(7455,'Emotional Allegiance',3,NULL,NULL,'2008-03-12 16:38:21');
INSERT INTO CHANSON VALUES(7456,'HOPI (dans plinn) - Ton Simpl',3,NULL,NULL,'2008-03-12 18:14:05');
INSERT INTO CHANSON VALUES(7457,'HOPI (dans plinn) - Bal',3,NULL,NULL,'2008-03-12 12:04:43');
INSERT INTO CHANSON VALUES(7458,'HOPI (dans plinn) - Ton Doubl',3,NULL,NULL,'2008-03-12 12:46:38');
INSERT INTO CHANSON VALUES(7459,'PLAISIRS DU DIABLE - Scottish',3,NULL,NULL,'2008-03-12 17:35:53');
INSERT INTO CHANSON VALUES(7460,'SIMA (rond de loudéac) - 1er rond',3,NULL,NULL,'2008-03-12 15:01:55');
INSERT INTO CHANSON VALUES(7461,'SIMA (rond de loudéac) - Baleu',3,NULL,NULL,'2008-03-12 11:54:08');
INSERT INTO CHANSON VALUES(7462,'SIMA (rond de loudéac) - 2ème rond',3,NULL,NULL,'2008-03-12 17:55:59');
INSERT INTO CHANSON VALUES(7463,'MAD - Cercle circassien',3,NULL,NULL,'2008-03-12 16:37:09');
INSERT INTO CHANSON VALUES(7464,'Spered Hollvedel',3,NULL,NULL,'2008-03-12 12:32:35');
INSERT INTO CHANSON VALUES(7465,'Délivrance',3,NULL,NULL,'2008-03-23 13:25:23');
INSERT INTO CHANSON VALUES(7466,'Ha Konpren''t Vin Erfin',3,NULL,NULL,'2008-03-12 16:17:13');
INSERT INTO CHANSON VALUES(7467,'Tenwal Eo''r Bed',3,NULL,NULL,'2008-03-12 08:07:28');
INSERT INTO CHANSON VALUES(7468,'Digor Eo An Hent',3,NULL,'t','2008-03-12 09:30:32');
INSERT INTO CHANSON VALUES(7469,'Debhair An Rinceoir',3,NULL,NULL,'2008-03-12 18:51:19');
INSERT INTO CHANSON VALUES(7470,'Pachpi Kozh Pachpi New',3,NULL,NULL,'2008-03-12 14:40:54');
INSERT INTO CHANSON VALUES(7471,'Laridenn',3,NULL,'t','2008-03-12 12:16:56');
INSERT INTO CHANSON VALUES(7472,'Ton-Bale Pourled',3,NULL,'t','2008-03-12 11:34:50');
INSERT INTO CHANSON VALUES(7474,'An Droiou',3,NULL,NULL,'2008-03-12 13:03:24');
INSERT INTO CHANSON VALUES(7476,'An Dro/tha mi sgith',3,NULL,NULL,'2008-03-12 10:07:14');
INSERT INTO CHANSON VALUES(7477,'Ar an garraig/telen wad',3,NULL,NULL,'2008-03-12 13:11:22');
INSERT INTO CHANSON VALUES(7478,'The foggy dew',3,NULL,'t','2008-03-12 19:20:52');
INSERT INTO CHANSON VALUES(7479,'Suzy Mc Guire',3,NULL,NULL,'2008-03-12 13:13:43');
INSERT INTO CHANSON VALUES(7480,'Suite Irlandaise',3,NULL,'t','2008-03-12 17:43:23');
INSERT INTO CHANSON VALUES(7482,'Son ar chistr',3,NULL,'t','2008-03-12 15:27:14');
INSERT INTO CHANSON VALUES(7483,'Marv ma mestrez',3,NULL,'t','2008-03-12 13:55:35');
INSERT INTO CHANSON VALUES(7484,'Kimiad',3,NULL,NULL,'2008-03-12 11:23:38');
INSERT INTO CHANSON VALUES(7485,'Suite des montagnes',3,NULL,'t','2008-03-12 16:00:03');
INSERT INTO CHANSON VALUES(7486,'Metig',3,NULL,NULL,'2008-04-11 19:53:49');
INSERT INTO CHANSON VALUES(7487,'Pop-Plinn',3,NULL,NULL,'2008-03-12 15:13:11');
INSERT INTO CHANSON VALUES(7488,'Bal-ha-dans-plinn',3,NULL,'t','2008-03-12 18:39:23');
INSERT INTO CHANSON VALUES(7489,'O''Neil''s march/The king of the fairies',3,NULL,NULL,'2008-03-12 11:34:43');
INSERT INTO CHANSON VALUES(7490,'Ian Morrisson reel',3,NULL,NULL,'2008-03-12 09:02:57');
INSERT INTO CHANSON VALUES(7491,'Tri martolod',3,NULL,'t','2008-03-12 18:50:41');
INSERT INTO CHANSON VALUES(7492,'Fisel',3,NULL,NULL,'2008-03-12 11:32:49');
INSERT INTO CHANSON VALUES(7493,'An dorn',3,NULL,NULL,'2008-03-12 19:11:16');
INSERT INTO CHANSON VALUES(7494,'Ker pondi',3,NULL,NULL,'2008-03-12 10:41:12');
INSERT INTO CHANSON VALUES(7495,'Kimiad ar Zoudard yaouank',3,NULL,NULL,'2008-03-12 17:58:35');
INSERT INTO CHANSON VALUES(7496,'Gres mat Pier',3,NULL,NULL,'2008-03-12 13:39:35');
INSERT INTO CHANSON VALUES(7497,'Ton kentan',3,NULL,NULL,'2008-03-12 13:18:48');
INSERT INTO CHANSON VALUES(7498,'Ton bal',3,NULL,NULL,'2008-03-12 16:11:28');
INSERT INTO CHANSON VALUES(7499,'Yon diwezhan',3,NULL,NULL,'2008-03-12 08:26:03');
INSERT INTO CHANSON VALUES(7500,'Gwerz zantez Henori',3,NULL,NULL,'2008-03-12 17:35:06');
INSERT INTO CHANSON VALUES(7501,'Noir comme la mer',3,NULL,NULL,'2008-03-12 17:27:56');
INSERT INTO CHANSON VALUES(7503,'An dvarnijen',3,NULL,NULL,'2008-03-12 13:43:29');
INSERT INTO CHANSON VALUES(7504,'Defixio',3,NULL,NULL,'2008-03-12 11:40:41');
INSERT INTO CHANSON VALUES(7505,'Kanet berjelenig!',3,NULL,NULL,'2008-03-12 14:51:23');
INSERT INTO CHANSON VALUES(7506,'Gwerz DomYann Derrian',3,NULL,NULL,'2008-03-12 16:39:21');
INSERT INTO CHANSON VALUES(7507,'Joke',3,NULL,NULL,'2008-03-12 11:04:01');
INSERT INTO CHANSON VALUES(7508,'Gave Hot',3,NULL,NULL,'2008-03-12 18:34:19');
INSERT INTO CHANSON VALUES(7509,'Gigue O''Low',3,NULL,NULL,'2008-03-12 16:14:31');
INSERT INTO CHANSON VALUES(7510,'La Niña del Norte',3,NULL,NULL,'2008-03-12 10:18:57');
INSERT INTO CHANSON VALUES(7511,'Stone Eire',3,NULL,NULL,'2008-03-12 10:06:32');
INSERT INTO CHANSON VALUES(7512,'Stone Jig',3,NULL,NULL,'2008-03-12 12:51:00');
INSERT INTO CHANSON VALUES(7513,'Skai Reel',3,NULL,NULL,'2008-03-12 11:17:43');
INSERT INTO CHANSON VALUES(7514,'Stand All',3,NULL,NULL,'2008-03-12 17:33:23');
INSERT INTO CHANSON VALUES(7515,'Barz Gwen',3,NULL,NULL,'2008-03-12 13:04:15');
INSERT INTO CHANSON VALUES(7516,'Barz Dal',3,NULL,NULL,'2008-03-12 18:48:54');
INSERT INTO CHANSON VALUES(7517,'Barz Du',3,NULL,NULL,'2008-03-12 10:07:59');
INSERT INTO CHANSON VALUES(7518,'Suite d''Arrées',3,NULL,NULL,'2008-03-12 10:02:33');
INSERT INTO CHANSON VALUES(7519,'Arane',3,NULL,NULL,'2008-03-12 14:45:48');
INSERT INTO CHANSON VALUES(7520,'War-Raog',3,NULL,NULL,'2008-03-12 09:56:06');
INSERT INTO CHANSON VALUES(7521,'Meli-andro (live) (an-dro)',3,NULL,NULL,'2008-03-12 08:11:13');
INSERT INTO CHANSON VALUES(7522,'107â°-11â° (live) (cochincine)',3,NULL,NULL,'2008-03-12 15:31:05');
INSERT INTO CHANSON VALUES(7523,'Carhaix-Loudeac (live) (laridé 8 temps)',3,NULL,NULL,'2008-03-12 15:48:22');
INSERT INTO CHANSON VALUES(7524,'Noz (live) (suite gavotte) - ton simpl',3,NULL,NULL,'2008-03-12 11:35:55');
INSERT INTO CHANSON VALUES(7525,'Noz (live) (suite gavotte) - tamm kreiz',3,NULL,NULL,'2008-03-12 16:02:00');
INSERT INTO CHANSON VALUES(7526,'Noz (live) (suite gavotte) - ton doubl''',3,NULL,NULL,'2008-03-12 18:06:57');
INSERT INTO CHANSON VALUES(7527,'Chas plone (live) (pach''pi)',3,NULL,NULL,'2008-03-12 18:20:59');
INSERT INTO CHANSON VALUES(7528,'Kanomp ha roulomp atao (live) (rond pagam)',3,NULL,NULL,'2008-03-12 13:54:44');
INSERT INTO CHANSON VALUES(7529,'Lassie (live) (avant-2 de travers)',3,NULL,NULL,'2008-03-12 11:59:41');
INSERT INTO CHANSON VALUES(7530,'La légende de Connor (live) (valse)',3,NULL,NULL,'2008-03-12 12:02:52');
INSERT INTO CHANSON VALUES(7531,'Tredan (live) (cercle circassien)',3,NULL,NULL,'2008-03-12 15:38:24');
INSERT INTO CHANSON VALUES(7532,'L''artilleur (live) (an-dro)',3,NULL,NULL,'2008-03-12 16:14:12');
INSERT INTO CHANSON VALUES(7533,'Les papillons (live) (rond de Saint-Vincent)',3,NULL,NULL,'2008-03-12 08:34:47');
INSERT INTO CHANSON VALUES(7534,'En dro mod koh / En dro folk',3,NULL,NULL,'2008-03-12 19:17:50');
INSERT INTO CHANSON VALUES(7535,'Louise',3,NULL,NULL,'2008-03-12 08:16:44');
INSERT INTO CHANSON VALUES(7536,'Hilde''s wals',3,NULL,NULL,'2008-03-12 17:10:51');
INSERT INTO CHANSON VALUES(7538,'Bourree la belle inconnue',3,NULL,NULL,'2008-03-12 17:30:06');
INSERT INTO CHANSON VALUES(7539,'Bedelaarslied',3,NULL,NULL,'2008-03-12 14:45:06');
INSERT INTO CHANSON VALUES(7540,'I still dream',3,NULL,NULL,'2008-03-12 10:07:08');
INSERT INTO CHANSON VALUES(7541,'Menuet a quarter / Wals voor mijn schoon lief',3,NULL,NULL,'2008-03-12 09:43:47');
INSERT INTO CHANSON VALUES(7542,'She''s like the swallow',3,NULL,NULL,'2008-03-12 13:24:01');
INSERT INTO CHANSON VALUES(7543,'Seerlands dale',3,NULL,NULL,'2008-03-12 16:27:35');
INSERT INTO CHANSON VALUES(7544,'Het venijn',3,NULL,NULL,'2008-03-12 13:27:53');
INSERT INTO CHANSON VALUES(7545,'Nooit met krijt',3,NULL,NULL,'2008-03-12 12:28:10');
INSERT INTO CHANSON VALUES(7546,'Wachterlied',3,NULL,NULL,'2008-03-12 08:17:20');
INSERT INTO CHANSON VALUES(7547,'Holy',3,NULL,NULL,'2008-03-12 19:04:25');
INSERT INTO CHANSON VALUES(7548,'Suite de marches',3,NULL,'t','2008-03-12 09:51:55');
INSERT INTO CHANSON VALUES(7549,'Suite de Ronds de Saint Vincent sur Oust',3,NULL,'t','2008-03-12 10:22:41');
INSERT INTO CHANSON VALUES(7550,'Complaintes',3,NULL,NULL,'2008-03-12 12:34:49');
INSERT INTO CHANSON VALUES(7551,'Suite Hanter Dro',3,NULL,'t','2008-03-12 13:39:33');
INSERT INTO CHANSON VALUES(7552,'Suite de Ridée 6 temps',3,NULL,'t','2008-03-12 11:08:57');
INSERT INTO CHANSON VALUES(7553,'Quistinic',3,NULL,NULL,'2008-03-12 11:50:25');
INSERT INTO CHANSON VALUES(7554,'Suite de Tour',3,NULL,'t','2008-03-12 18:20:52');
INSERT INTO CHANSON VALUES(7555,'Suite Plinn',3,NULL,'t','2008-03-12 17:40:20');
INSERT INTO CHANSON VALUES(7556,'Suite gavotte de montagnes',3,NULL,'t','2008-03-12 19:45:38');
INSERT INTO CHANSON VALUES(7557,'Le mariage anglais',3,NULL,NULL,'2008-03-12 11:41:43');
INSERT INTO CHANSON VALUES(7558,'Le garçon jardinier',3,NULL,NULL,'2008-03-12 16:49:34');
INSERT INTO CHANSON VALUES(7559,'La fille aux chansons (Marion s''y promène)',3,NULL,NULL,'2008-03-12 16:03:56');
INSERT INTO CHANSON VALUES(7560,'J''ai vu le loup, le renard et la belette',3,NULL,NULL,'2008-03-16 12:24:31');
INSERT INTO CHANSON VALUES(7561,'Cortège de noce',3,NULL,NULL,'2008-03-12 10:53:11');
INSERT INTO CHANSON VALUES(7562,'Branle La Peronelle',3,NULL,NULL,'2008-03-12 16:10:20');
INSERT INTO CHANSON VALUES(7563,'Le galant indiscret',3,NULL,NULL,'2008-03-12 16:29:10');
INSERT INTO CHANSON VALUES(7564,'Marions les roses (Chant de quête)',3,NULL,NULL,'2008-03-12 09:23:30');
INSERT INTO CHANSON VALUES(7565,'Suite : Bourrée, Scotish-valse',3,NULL,NULL,'2008-03-12 19:11:11');
INSERT INTO CHANSON VALUES(7566,'Le bouvier',3,NULL,NULL,'2008-03-12 12:09:57');
INSERT INTO CHANSON VALUES(7567,'An Dro / Neg La Cho',3,NULL,NULL,'2008-03-12 19:29:38');
INSERT INTO CHANSON VALUES(7568,'Polkas',3,NULL,NULL,'2008-03-12 16:13:28');
INSERT INTO CHANSON VALUES(7569,'Ton Maodez Kerjean',3,NULL,NULL,'2008-03-12 11:53:31');
INSERT INTO CHANSON VALUES(7570,'Gavotenn',3,NULL,'t','2008-03-12 10:15:55');
INSERT INTO CHANSON VALUES(7571,'Gwenegan / Suite Fisel',3,NULL,NULL,'2008-03-12 16:26:49');
INSERT INTO CHANSON VALUES(7572,'Ton Kentan',3,NULL,NULL,'2008-03-12 19:10:00');
INSERT INTO CHANSON VALUES(7573,'Bal',3,NULL,NULL,'2008-03-12 11:52:29');
INSERT INTO CHANSON VALUES(7574,'Ton Diwezhan',3,NULL,NULL,'2008-03-12 13:59:53');
INSERT INTO CHANSON VALUES(7575,'Valse en G',3,NULL,NULL,'2008-03-12 19:58:04');
INSERT INTO CHANSON VALUES(7576,'Ridees Six Temps',3,NULL,NULL,'2008-03-12 09:19:14');
INSERT INTO CHANSON VALUES(7577,'Me''m Eus Kompozet Ur Son / Plinn ton simpl',3,NULL,NULL,'2008-03-12 09:18:43');
INSERT INTO CHANSON VALUES(7578,'Son Kloareg / Plinn bal',3,NULL,NULL,'2008-03-12 17:00:57');
INSERT INTO CHANSON VALUES(7579,'Parrez Kanihuel / Plinn ton double',3,NULL,NULL,'2008-03-12 10:16:50');
INSERT INTO CHANSON VALUES(7580,'Kas A-Barh',3,NULL,'t','2008-03-12 17:30:05');
INSERT INTO CHANSON VALUES(7581,'Ronds de St Vincent',3,NULL,NULL,'2008-03-12 16:14:32');
INSERT INTO CHANSON VALUES(7582,'Tout en passant',3,NULL,NULL,'2008-03-12 14:10:42');
INSERT INTO CHANSON VALUES(7583,'Aires De Pontevedra',3,NULL,NULL,'2008-03-12 14:26:35');
INSERT INTO CHANSON VALUES(7584,'Left In Peace',3,NULL,NULL,'2008-03-12 08:52:34');
INSERT INTO CHANSON VALUES(7586,'Brezhoneg''Raok',3,NULL,NULL,'2008-03-12 19:58:52');
INSERT INTO CHANSON VALUES(7587,'Gouel Hollvedel (Fête Universelle)',3,NULL,NULL,'2008-03-12 10:05:10');
INSERT INTO CHANSON VALUES(7588,'Borders Of Salt',3,NULL,NULL,'2008-03-12 19:50:10');
INSERT INTO CHANSON VALUES(7589,'An Alarc''h',3,NULL,'t','2008-03-16 18:04:27');
INSERT INTO CHANSON VALUES(7590,'Tri Martolod',3,NULL,'t','2008-03-12 16:50:57');
INSERT INTO CHANSON VALUES(7592,'Airs du pays Plin',3,NULL,'t','2008-03-12 12:02:22');
INSERT INTO CHANSON VALUES(7593,'Variations (Pays Pagan)',3,NULL,NULL,'2008-03-12 08:33:48');
INSERT INTO CHANSON VALUES(7594,'Suite Sud-Cornouaille',3,NULL,'t','2008-03-12 15:33:41');
INSERT INTO CHANSON VALUES(7595,'Suite Langonnet-Pluvigner',3,NULL,'t','2008-03-12 10:26:31');
INSERT INTO CHANSON VALUES(7596,'Suite de Haute-Bretagne',3,NULL,'t','2008-03-12 17:24:30');
INSERT INTO CHANSON VALUES(7597,'Suite Écossaise',3,NULL,'t','2008-03-12 16:37:35');
INSERT INTO CHANSON VALUES(7598,'Variations (Pays de Loudéac)',3,NULL,NULL,'2008-03-12 18:33:26');
INSERT INTO CHANSON VALUES(7599,'Concert Lorient 1988',3,NULL,NULL,'2008-03-12 08:27:31');
INSERT INTO CHANSON VALUES(7602,'Favet Neptunus eunti',3,NULL,'f','2008-03-12 13:00:53');
INSERT INTO CHANSON VALUES(7603,'Le tourdion des manants',3,NULL,NULL,'2008-03-12 16:22:55');
INSERT INTO CHANSON VALUES(7604,'Les Pailles d''Or brisées',3,NULL,'f','2008-03-12 08:27:29');
INSERT INTO CHANSON VALUES(7605,'Produced and bottled in Nantes',3,NULL,'f','2008-03-12 18:07:02');
INSERT INTO CHANSON VALUES(7606,'Korydwen et le Rouge de Kenholl',3,NULL,'f','2008-03-12 14:21:29');
INSERT INTO CHANSON VALUES(7607,'La petite Perrine, la marchande de coccinelles',3,NULL,'f','2008-03-12 08:09:54');
INSERT INTO CHANSON VALUES(7608,'Sonate de Paul Ladmirault',3,NULL,'f','2008-03-12 15:50:31');
INSERT INTO CHANSON VALUES(7609,'Sur la fosse au boulot',3,NULL,'f','2008-03-12 10:41:05');
INSERT INTO CHANSON VALUES(7610,'Belle et rebelle',3,NULL,'f','2008-03-12 15:43:32');
INSERT INTO CHANSON VALUES(7612,'Gavotte de l''aven',3,NULL,'t','2008-03-12 14:41:44');
INSERT INTO CHANSON VALUES(7614,'T''en vas pas max',3,NULL,NULL,'2008-03-12 12:24:34');
INSERT INTO CHANSON VALUES(7615,'Aman hag aze',3,NULL,'t','2008-03-12 17:16:41');
INSERT INTO CHANSON VALUES(7616,'Voisins de palier',3,NULL,NULL,'2008-03-12 18:49:03');
INSERT INTO CHANSON VALUES(7617,'Amzer Nevez',3,NULL,'t','2008-03-12 12:54:13');
INSERT INTO CHANSON VALUES(7618,'Ti eliza',3,NULL,'t','2008-03-12 11:29:03');
INSERT INTO CHANSON VALUES(7619,'An dro - Kas ha barh',3,NULL,NULL,'2008-03-12 17:40:45');
INSERT INTO CHANSON VALUES(7620,'Suite de gavottes des montagnes',3,NULL,'t','2008-03-12 18:18:28');
INSERT INTO CHANSON VALUES(7621,'Azeliz iza',3,NULL,'t','2008-03-12 13:27:42');
INSERT INTO CHANSON VALUES(7622,'Ar-men',3,NULL,NULL,'2008-03-12 09:58:23');
INSERT INTO CHANSON VALUES(7623,'Démago',3,NULL,NULL,'2008-03-12 18:23:45');
INSERT INTO CHANSON VALUES(7624,'Le route de Kemper',3,NULL,NULL,'2008-03-24 08:44:09');
INSERT INTO CHANSON VALUES(7625,'La maison d''Irlande',3,NULL,NULL,'2008-03-12 15:34:25');
INSERT INTO CHANSON VALUES(7626,'Dir Ha Tan',3,NULL,'t','2008-03-12 11:26:15');
INSERT INTO CHANSON VALUES(7629,'Si mort à mors',3,NULL,'t','2008-03-24 15:18:01');
INSERT INTO CHANSON VALUES(7630,'Franzozig',3,NULL,NULL,'2008-03-12 15:53:19');
INSERT INTO CHANSON VALUES(7631,'Le loup, le renard, la jument de Michaud, etc.',3,NULL,'t','2008-03-16 18:11:05');
INSERT INTO CHANSON VALUES(7632,'Les deux frères',3,NULL,NULL,'2008-03-12 14:20:04');
INSERT INTO CHANSON VALUES(7633,'Le cimetière des bateaux',3,NULL,NULL,'2008-03-12 19:14:27');
INSERT INTO CHANSON VALUES(7634,'Cayenne',3,NULL,NULL,'2008-03-12 16:16:12');
INSERT INTO CHANSON VALUES(7635,'Gwall Amzer',3,NULL,NULL,'2008-03-12 18:52:46');
INSERT INTO CHANSON VALUES(7636,'Vents d''Est',3,NULL,NULL,'2008-03-12 11:09:12');
INSERT INTO CHANSON VALUES(7637,'Santa Maria',3,NULL,NULL,'2008-03-12 14:30:02');
INSERT INTO CHANSON VALUES(7638,'Café du Port',3,NULL,NULL,'2008-03-12 16:04:07');
INSERT INTO CHANSON VALUES(7639,'Pub',3,NULL,NULL,'2008-03-12 12:42:00');
INSERT INTO CHANSON VALUES(7640,'Doue Lann',3,NULL,NULL,'2008-03-12 16:05:46');
INSERT INTO CHANSON VALUES(7641,'Félicité',3,NULL,NULL,'2008-03-12 12:56:58');
INSERT INTO CHANSON VALUES(7642,'Cap''tain',3,NULL,NULL,'2008-03-12 13:30:18');
INSERT INTO CHANSON VALUES(7643,'Port Blanc',3,NULL,NULL,'2008-03-12 14:28:33');
INSERT INTO CHANSON VALUES(7644,'Noz vad bugale',3,NULL,'f','2008-03-12 19:11:49');
INSERT INTO CHANSON VALUES(7645,'Déjà   mal mariée',3,NULL,'f','2008-03-18 10:04:41');
INSERT INTO CHANSON VALUES(7646,'Marche en sol',3,NULL,'f','2008-03-12 19:22:51');
INSERT INTO CHANSON VALUES(7647,'An cailin rua',3,NULL,NULL,'2008-03-12 09:55:22');
INSERT INTO CHANSON VALUES(7648,'En dro venete',3,NULL,'f','2008-03-12 10:38:27');
INSERT INTO CHANSON VALUES(7649,'La dame de la roche',3,NULL,NULL,'2008-03-12 11:01:09');
INSERT INTO CHANSON VALUES(7650,'Selen Kelann',3,NULL,NULL,'2008-03-12 12:43:14');
INSERT INTO CHANSON VALUES(7651,'Le capitaine de Saint-Malo',3,NULL,NULL,'2008-03-12 09:03:11');
INSERT INTO CHANSON VALUES(7655,'La ballade du cheval mallet',3,NULL,'f','2008-03-12 17:08:27');
INSERT INTO CHANSON VALUES(7656,'La Blanche Hermine',3,NULL,NULL,'2008-03-24 18:03:28');
INSERT INTO CHANSON VALUES(7657,'Kalandour',3,NULL,NULL,'2008-03-12 13:05:49');
INSERT INTO CHANSON VALUES(7658,'Je dors en Bretagne ce soir',3,NULL,NULL,'2008-03-20 12:15:45');
INSERT INTO CHANSON VALUES(7659,'Madame La Colline',3,NULL,NULL,'2008-03-12 16:26:24');
INSERT INTO CHANSON VALUES(7660,'Me Zo Ganet',3,NULL,'t','2008-04-07 10:04:25');
INSERT INTO CHANSON VALUES(7661,'Heure De Grace',3,NULL,NULL,'2008-03-12 10:46:25');
INSERT INTO CHANSON VALUES(7662,'L''hirondelle',3,NULL,NULL,'2008-03-12 12:06:08');
INSERT INTO CHANSON VALUES(7663,'L''ile De Groix',3,NULL,NULL,'2008-03-12 15:12:12');
INSERT INTO CHANSON VALUES(7664,'Les Colonies',3,NULL,NULL,'2008-03-12 17:18:41');
INSERT INTO CHANSON VALUES(7665,'La Forêt Sur La Rade',3,NULL,NULL,'2008-03-12 13:42:41');
INSERT INTO CHANSON VALUES(7666,'Retrouver Groix',3,NULL,NULL,'2008-03-12 16:39:39');
INSERT INTO CHANSON VALUES(7667,'Je vous emporte dans mon cœur',3,NULL,NULL,'2008-06-02 13:54:28.965706');
INSERT INTO CHANSON VALUES(7668,'Marche du pays de Retz',3,NULL,'t','2008-03-12 14:55:54');
INSERT INTO CHANSON VALUES(7669,'Ronds de Saint Vincent',3,NULL,'t','2008-03-12 12:16:09');
INSERT INTO CHANSON VALUES(7671,'Ar Mor Divent - La mer est immense',3,NULL,NULL,'2008-03-12 14:10:22');
INSERT INTO CHANSON VALUES(7672,'Suite de gavottes du pays montagne',3,NULL,'t','2008-03-12 19:30:28');
INSERT INTO CHANSON VALUES(7673,'Ensemble de bombardes - Kas a barzh / Valse du Guéméné',3,NULL,'t','2008-03-12 08:05:41');
INSERT INTO CHANSON VALUES(7674,'Suite Pipe-Band - B.C. Niven / Journey to sky / Flee the Glen / The Panda',3,NULL,NULL,'2008-03-12 11:52:59');
INSERT INTO CHANSON VALUES(7675,'Ensemble de batterie',3,NULL,NULL,'2008-03-12 19:21:41');
INSERT INTO CHANSON VALUES(7676,'Marche d''Elven (business anti-swing)',3,NULL,'t','2008-03-12 15:01:21');
INSERT INTO CHANSON VALUES(7677,'Dans Plinn',3,NULL,'t','2008-03-12 11:05:47');
INSERT INTO CHANSON VALUES(7678,'Ag an douar d''Ar Mor',3,NULL,NULL,'2008-03-12 09:36:43');
INSERT INTO CHANSON VALUES(7679,'Triniou',3,NULL,NULL,'2008-03-12 08:57:00');
INSERT INTO CHANSON VALUES(7680,'Glen River',3,NULL,NULL,'2008-03-12 10:03:59');
INSERT INTO CHANSON VALUES(7681,'Jigger Jig',3,NULL,NULL,'2008-03-12 17:33:10');
INSERT INTO CHANSON VALUES(7682,'Glaz Noz',3,NULL,NULL,'2008-03-12 10:29:40');
INSERT INTO CHANSON VALUES(7683,'Uilean Mandinga (1ère partie)',3,NULL,NULL,'2008-03-12 15:33:46');
INSERT INTO CHANSON VALUES(7684,'Uilean Mandinga (2ème partie)',3,NULL,NULL,'2008-03-12 11:49:38');
INSERT INTO CHANSON VALUES(7685,'Colombaneon',3,NULL,NULL,'2008-03-12 11:46:59');
INSERT INTO CHANSON VALUES(7686,'Noces de granit',3,NULL,NULL,'2008-03-12 08:25:01');
INSERT INTO CHANSON VALUES(7687,'Steren',3,NULL,NULL,'2008-03-12 12:44:06');
INSERT INTO CHANSON VALUES(7688,'La Tarentule',3,NULL,NULL,'2008-03-12 10:52:42');
INSERT INTO CHANSON VALUES(7689,'Celtic Bridge',3,NULL,NULL,'2008-03-12 18:54:40');
INSERT INTO CHANSON VALUES(7690,'Les champs bothorel (1ère partie)',3,NULL,NULL,'2008-03-12 18:05:43');
INSERT INTO CHANSON VALUES(7691,'Les champs bothorel (2ème partie)',3,NULL,NULL,'2008-03-12 18:53:17');
INSERT INTO CHANSON VALUES(7692,'Intro',3,NULL,NULL,'2008-03-12 08:03:46');
INSERT INTO CHANSON VALUES(7693,'Toboggan',3,NULL,NULL,'2008-03-12 16:41:19');
INSERT INTO CHANSON VALUES(7694,'An tad moualc''h kozh - Le vieux merle',3,NULL,'t','2008-03-12 14:01:09');
INSERT INTO CHANSON VALUES(7695,'Ar martolod farw - Le matelot fanfaron',3,NULL,'t','2008-03-12 09:21:56');
INSERT INTO CHANSON VALUES(7696,'Konskried Sant Nikolaz - Les conscrits de St Nicolas',3,NULL,'t','2008-03-12 09:22:21');
INSERT INTO CHANSON VALUES(7697,'Al lez vamm - La maratre',3,NULL,'t','2008-03-12 10:44:06');
INSERT INTO CHANSON VALUES(7698,'Ar verjelenn - La bergere',3,NULL,'t','2008-03-12 11:54:58');
INSERT INTO CHANSON VALUES(7699,'Ar plac''h diw wech eureujet - La fille deux fois mariée',3,NULL,'t','2008-03-12 08:48:52');
INSERT INTO CHANSON VALUES(7700,'Ar sorserez - La sorcière',3,NULL,'t','2008-03-12 16:42:58');
INSERT INTO CHANSON VALUES(7701,'Margodig La Boissière',3,NULL,'t','2008-03-12 12:36:51');
INSERT INTO CHANSON VALUES(7702,'Janedig ar rouz',3,NULL,'t','2008-03-12 16:40:55');
INSERT INTO CHANSON VALUES(7703,'An daou bichon yaouank - Les deux jeunes tourtereaux',3,NULL,'t','2008-03-12 13:25:37');
INSERT INTO CHANSON VALUES(7704,'Ar yar ni gor - La poule qui couve',3,NULL,'t','2008-03-12 17:56:39');
INSERT INTO CHANSON VALUES(7705,'Perinaïg Lanuon - Perrine de Lannion',3,NULL,'t','2008-03-12 19:06:00');
INSERT INTO CHANSON VALUES(7706,'Ar vagerez - La nourrice',3,NULL,'t','2008-03-12 18:15:22');
INSERT INTO CHANSON VALUES(7707,'Ur Wech E Vo',3,NULL,NULL,'2008-03-12 11:26:07');
INSERT INTO CHANSON VALUES(7708,'Padal',3,NULL,NULL,'2008-03-12 12:43:02');
INSERT INTO CHANSON VALUES(7709,'Ma C''hemenerez',3,NULL,NULL,'2008-03-12 12:43:50');
INSERT INTO CHANSON VALUES(7710,'Glav',3,NULL,NULL,'2008-03-12 10:23:33');
INSERT INTO CHANSON VALUES(7711,'Y Byd Newydd',3,NULL,NULL,'2008-03-12 10:47:09');
INSERT INTO CHANSON VALUES(7712,'Son Ar Plac''h n''he Doa Netra',3,NULL,NULL,'2008-03-12 08:28:50');
INSERT INTO CHANSON VALUES(7713,'Luskell Ma Mab',3,NULL,NULL,'2008-03-12 19:56:16');
INSERT INTO CHANSON VALUES(7714,'A-Dreuz Kleuz Ha Moger',3,NULL,NULL,'2008-03-12 15:44:12');
INSERT INTO CHANSON VALUES(7715,'Deuit Gann-me',3,NULL,NULL,'2008-03-12 10:41:19');
INSERT INTO CHANSON VALUES(7716,'Sant Ma Fardon',3,NULL,NULL,'2008-03-12 11:34:35');
INSERT INTO CHANSON VALUES(7717,'Heklev',3,NULL,NULL,'2008-03-12 15:49:01');
INSERT INTO CHANSON VALUES(7718,'Plac''h Ar Gwele-Kloz',3,NULL,NULL,'2008-03-12 17:10:44');
INSERT INTO CHANSON VALUES(7719,'Babour',3,NULL,NULL,'2008-03-12 17:31:27');
INSERT INTO CHANSON VALUES(7721,'Astronaut',3,NULL,NULL,'2008-03-12 10:56:38');
INSERT INTO CHANSON VALUES(7724,'De ballade van Boon',3,NULL,NULL,'2008-04-07 19:52:30');
INSERT INTO CHANSON VALUES(7725,'Meisje loos',3,NULL,NULL,'2008-03-12 13:33:47');
INSERT INTO CHANSON VALUES(7726,'Qui a tué grand maman ?',3,NULL,NULL,'2008-03-12 16:48:28');
INSERT INTO CHANSON VALUES(7727,'Keerom',3,NULL,NULL,'2008-03-12 08:03:02');
INSERT INTO CHANSON VALUES(7729,'Kalima kadara',3,NULL,NULL,'2008-03-12 15:41:51');
INSERT INTO CHANSON VALUES(7731,'Swedisch designer drugs',3,NULL,NULL,'2008-03-12 15:26:02');
INSERT INTO CHANSON VALUES(7733,'Le grand vent',3,NULL,NULL,'2008-03-12 17:52:18');
INSERT INTO CHANSON VALUES(7734,'Hani Kuni',3,NULL,NULL,'2008-03-12 15:04:14');
INSERT INTO CHANSON VALUES(7739,'Helplessly hoping',3,NULL,NULL,'2008-03-12 13:06:47');
INSERT INTO CHANSON VALUES(7742,'Blind boy',3,NULL,NULL,'2008-03-12 10:47:35');
INSERT INTO CHANSON VALUES(7748,'Irish Jig',3,NULL,NULL,'2008-03-12 10:10:54');
INSERT INTO CHANSON VALUES(7749,'Sacra Matao',3,NULL,NULL,'2008-03-12 14:50:59');
INSERT INTO CHANSON VALUES(7750,'Me Meus Bet Plijadur',3,NULL,NULL,'2008-03-12 17:08:24');
INSERT INTO CHANSON VALUES(7751,'Cam''Ye Ower Frae France',3,NULL,NULL,'2008-03-12 08:33:02');
INSERT INTO CHANSON VALUES(7752,'Patrick''s Day',3,NULL,NULL,'2008-03-12 10:00:09');
INSERT INTO CHANSON VALUES(7753,'Galway Bay',3,NULL,NULL,'2008-03-12 08:15:56');
INSERT INTO CHANSON VALUES(7754,'The Walls Of Liscarroll',3,NULL,NULL,'2008-03-12 15:57:44');
INSERT INTO CHANSON VALUES(7755,'Butterfly',3,NULL,NULL,'2008-03-12 11:43:08');
INSERT INTO CHANSON VALUES(7756,'Deu Tu Ganeme',3,NULL,NULL,'2008-03-12 15:20:09');
INSERT INTO CHANSON VALUES(7757,'Aurore Boreale',3,NULL,NULL,'2008-03-12 13:00:31');
INSERT INTO CHANSON VALUES(7758,'Da Scalloway Lasses',3,NULL,NULL,'2008-03-12 13:13:42');
INSERT INTO CHANSON VALUES(7759,'Erwam O''Clock',3,NULL,NULL,'2008-03-12 12:45:33');
INSERT INTO CHANSON VALUES(7760,'Bee New',3,NULL,NULL,'2008-03-12 12:32:41');
INSERT INTO CHANSON VALUES(7761,'Galway Hills',3,NULL,NULL,'2008-03-12 17:34:14');
INSERT INTO CHANSON VALUES(7762,'Le Reggae Gai de Gueret',3,NULL,NULL,'2008-03-12 17:49:15');
INSERT INTO CHANSON VALUES(7765,'Pbkata (live)',3,NULL,NULL,'2008-03-12 19:48:31');
INSERT INTO CHANSON VALUES(7767,'Mat''lot Barreaux',3,NULL,NULL,'2008-03-12 10:37:31');
INSERT INTO CHANSON VALUES(7768,'Chat Huant',3,NULL,NULL,'2008-03-12 17:58:04');
INSERT INTO CHANSON VALUES(7770,'"Doucement Les Basses"',3,NULL,NULL,'2008-03-12 16:32:28');
INSERT INTO CHANSON VALUES(7771,'Rigolo, Rigolo Pas',3,NULL,NULL,'2008-03-12 19:30:19');
INSERT INTO CHANSON VALUES(7772,'D''accord, Pas D''accord ?',3,NULL,NULL,'2008-03-12 13:25:48');
INSERT INTO CHANSON VALUES(7773,'Koad Kimerc''h',3,NULL,'t','2008-03-12 19:04:33');
INSERT INTO CHANSON VALUES(7774,'L''homme Rouge',3,NULL,NULL,'2008-03-12 09:52:57');
INSERT INTO CHANSON VALUES(7775,'Bomb-Hard',3,NULL,NULL,'2008-03-12 15:50:45');
INSERT INTO CHANSON VALUES(7776,'Casino',3,NULL,NULL,'2008-03-12 10:19:00');
INSERT INTO CHANSON VALUES(7777,'Vord An Elle',3,NULL,NULL,'2008-03-12 19:31:38');
INSERT INTO CHANSON VALUES(7778,'Galicienne',3,NULL,NULL,'2008-03-12 13:17:36');
INSERT INTO CHANSON VALUES(7779,'Kejadenn',3,NULL,'t','2008-03-12 14:44:20');
INSERT INTO CHANSON VALUES(7780,'Tears (l''Appel)',3,NULL,NULL,'2008-03-12 10:27:53');
INSERT INTO CHANSON VALUES(7781,'Boules et guirlandes',3,NULL,NULL,'2008-03-12 15:24:24');
INSERT INTO CHANSON VALUES(7782,'Bal Plinn du vertige',3,NULL,NULL,'2008-03-12 19:52:49');
INSERT INTO CHANSON VALUES(7783,'Ton-doubl plinn',3,NULL,NULL,'2008-03-12 17:49:54');
INSERT INTO CHANSON VALUES(7784,'Kalon intanvez',3,NULL,NULL,'2008-03-12 12:56:46');
INSERT INTO CHANSON VALUES(7785,'Gwerz Skolvan',3,NULL,NULL,'2008-03-12 11:36:37');
INSERT INTO CHANSON VALUES(7786,'... and Swing',3,NULL,NULL,'2008-03-12 08:48:56');
INSERT INTO CHANSON VALUES(7787,'Son ar vot',3,NULL,NULL,'2008-03-12 09:44:28');
INSERT INTO CHANSON VALUES(7788,'Ronds de Saint Vincent sur Oust',3,NULL,NULL,'2008-03-12 16:13:46');
INSERT INTO CHANSON VALUES(7789,'La banane dans l''oreille',3,NULL,NULL,'2008-03-12 12:45:30');
INSERT INTO CHANSON VALUES(7790,'Les pêcheurs',3,NULL,NULL,'2008-03-12 16:57:57');
INSERT INTO CHANSON VALUES(7791,'Loudia',3,NULL,NULL,'2008-03-12 14:37:22');
INSERT INTO CHANSON VALUES(7792,'Tears (Skolvan)',3,NULL,NULL,'2008-03-12 19:36:15');
INSERT INTO CHANSON VALUES(7793,'Marie-Camille Lehuédé',3,NULL,'f','2008-03-12 17:24:04');
INSERT INTO CHANSON VALUES(7795,'Gerry Adams',3,NULL,'f','2008-03-12 13:04:37');
INSERT INTO CHANSON VALUES(7796,'Arthur Plantagenest',3,NULL,'f','2008-03-12 09:08:25');
INSERT INTO CHANSON VALUES(7797,'Goulven Salaün',3,NULL,'f','2008-03-12 08:13:10');
INSERT INTO CHANSON VALUES(7798,'Olivier Herry',3,NULL,'f','2008-03-12 14:57:24');
INSERT INTO CHANSON VALUES(7800,'Aloida',3,NULL,NULL,'2008-03-12 17:58:07');
INSERT INTO CHANSON VALUES(7801,'Anne de Bretagne',3,NULL,'f','2008-03-12 17:32:44');
INSERT INTO CHANSON VALUES(7802,'Guillaume Seznec : le voyage',3,NULL,'f','2008-03-12 09:31:20');
INSERT INTO CHANSON VALUES(7803,'Guillaume Seznec : le procès',3,NULL,'f','2008-03-12 12:19:44');
INSERT INTO CHANSON VALUES(7804,'Guillaume Seznec : l''adieu',3,NULL,'f','2008-03-12 13:01:30');
INSERT INTO CHANSON VALUES(7805,'Guillaume Seznec : le bagne',3,NULL,'f','2008-03-12 14:30:35');
INSERT INTO CHANSON VALUES(7806,'Guillaume Seznec : la délivrance',3,NULL,NULL,'2008-03-23 09:36:43');
INSERT INTO CHANSON VALUES(7807,'Seznec est innocent !',3,NULL,'f','2008-03-12 14:39:57');
INSERT INTO CHANSON VALUES(7808,'Warme garnars (live)',3,NULL,NULL,'2008-03-12 17:10:54');
INSERT INTO CHANSON VALUES(7809,'Sim sam',3,NULL,NULL,'2008-03-12 09:28:11');
INSERT INTO CHANSON VALUES(7810,'De wanhoop (live)',3,NULL,NULL,'2008-04-13 14:10:50');
INSERT INTO CHANSON VALUES(7812,'De wereld vergaat (live)',3,NULL,NULL,'2008-04-07 15:59:55');
INSERT INTO CHANSON VALUES(7813,'Bruidsnacht (live)',3,NULL,NULL,'2008-04-07 17:26:18');
INSERT INTO CHANSON VALUES(7814,'De wijn (live)',3,NULL,NULL,'2008-03-12 11:17:10');
INSERT INTO CHANSON VALUES(7815,'Jeugdig groen (live)',3,NULL,NULL,'2008-04-13 17:42:30');
INSERT INTO CHANSON VALUES(7816,'''t Zoutvat (live)',3,NULL,NULL,'2008-04-07 16:29:43');
INSERT INTO CHANSON VALUES(7817,'2 emmertjes (live)',3,NULL,NULL,'2008-03-12 13:03:42');
INSERT INTO CHANSON VALUES(7819,'Vers les îles et villes de verre',3,NULL,NULL,'2008-03-12 14:37:33');
INSERT INTO CHANSON VALUES(7820,'Rêves (Hunvreo'')',3,NULL,NULL,'2008-03-12 11:06:34');
INSERT INTO CHANSON VALUES(7821,'Ceux qui sèment la mort',3,NULL,NULL,'2008-03-12 17:37:05');
INSERT INTO CHANSON VALUES(7822,'Arvor-you',3,NULL,NULL,'2008-03-27 12:45:41');
INSERT INTO CHANSON VALUES(7823,'Rock harp',3,NULL,NULL,'2008-03-12 09:19:20');
INSERT INTO CHANSON VALUES(7824,'Skoit ''n treid !',3,NULL,NULL,'2008-03-12 08:04:31');
INSERT INTO CHANSON VALUES(7825,'Iroise',3,NULL,NULL,'2008-03-12 19:14:59');
INSERT INTO CHANSON VALUES(7826,'E kreiz hag endro',3,NULL,NULL,'2008-03-12 10:33:16');
INSERT INTO CHANSON VALUES(7827,'Back to Breizh !',3,NULL,NULL,'2008-03-12 12:00:20');
INSERT INTO CHANSON VALUES(7828,'Harpe de vies',3,NULL,NULL,'2008-03-12 08:12:33');
INSERT INTO CHANSON VALUES(7829,'Brian Boru in French',3,NULL,'t','2008-03-12 11:44:11');
INSERT INTO CHANSON VALUES(7830,'Armoricaine (suite)',3,NULL,'t','2008-03-12 18:01:18');
INSERT INTO CHANSON VALUES(7831,'Ar Re Yaouank /  M.A.I.',3,NULL,NULL,'2008-03-12 13:49:55');
INSERT INTO CHANSON VALUES(7832,'Carré Manchot / An dro/Neg la cho',3,NULL,NULL,'2008-03-12 14:12:40');
INSERT INTO CHANSON VALUES(7833,'Loened Fall / An daou vreur Ton Doubl',3,NULL,NULL,'2008-03-12 10:19:00');
INSERT INTO CHANSON VALUES(7834,'Karma / Gavotte pourlet',3,NULL,NULL,'2008-03-12 14:23:05');
INSERT INTO CHANSON VALUES(7835,'Filifala / Histoires maternelles',3,NULL,NULL,'2008-03-12 08:21:20');
INSERT INTO CHANSON VALUES(7836,'Skolvan / Tournemine & gasdebois',3,NULL,NULL,'2008-03-12 08:32:54');
INSERT INTO CHANSON VALUES(7837,'Tan Ba''n Ti / Dans-tro',3,NULL,NULL,'2008-03-12 11:53:54');
INSERT INTO CHANSON VALUES(7838,'Menestra / Hanter dro',3,NULL,NULL,'2008-03-12 16:56:07');
INSERT INTO CHANSON VALUES(7839,'Hamon Martin Quintet / Les draps de lit',3,NULL,NULL,'2008-03-12 10:13:51');
INSERT INTO CHANSON VALUES(7840,'Darhaou / Suite plin',3,NULL,NULL,'2008-03-12 13:04:53');
INSERT INTO CHANSON VALUES(7841,'Follenn / En triplette',3,NULL,NULL,'2008-03-12 11:10:15');
INSERT INTO CHANSON VALUES(7842,'Marialla / Aline',3,NULL,NULL,'2008-03-12 12:42:38');
INSERT INTO CHANSON VALUES(7843,'Spontus / Danse des spontailhou',3,NULL,NULL,'2008-03-12 13:45:00');
INSERT INTO CHANSON VALUES(7844,'Pennou Skoulm / Suite de ridées',3,NULL,NULL,'2008-03-12 17:48:33');
INSERT INTO CHANSON VALUES(7845,'Pevar Den / Suite fisel',3,NULL,NULL,'2008-03-12 16:07:26');
INSERT INTO CHANSON VALUES(7846,'Emsaverien / Vendanges',3,NULL,NULL,'2008-03-12 14:47:22');
INSERT INTO CHANSON VALUES(7847,'Ti Jaz / Rèves sauvages',3,NULL,NULL,'2008-03-12 16:01:36');
INSERT INTO CHANSON VALUES(7848,'Gwenfol Orchestra / Anna',3,NULL,NULL,'2008-03-12 14:26:40');
INSERT INTO CHANSON VALUES(7849,'Mot de bienvenu de Valentine',3,NULL,NULL,'2008-03-12 13:10:10');
INSERT INTO CHANSON VALUES(7850,'Ton berr :Melanie vihan',3,NULL,NULL,'2008-03-12 10:49:09');
INSERT INTO CHANSON VALUES(7851,'Bal : Ar fal''cher braz',3,NULL,NULL,'2008-03-12 09:08:20');
INSERT INTO CHANSON VALUES(7852,'Ton hir : An diviz etre ar fañch hag ar fisel',3,NULL,NULL,'2008-03-12 12:29:03');
INSERT INTO CHANSON VALUES(7853,'Podo'' fer fisel : Madelenig',3,NULL,NULL,'2008-03-12 08:55:49');
INSERT INTO CHANSON VALUES(7854,'entretien avec Erik Marchand',3,NULL,NULL,'2008-03-12 08:41:37');
INSERT INTO CHANSON VALUES(7855,'Dans plinn : Paotrig koant an douar nevez',3,NULL,NULL,'2008-03-12 14:21:45');
INSERT INTO CHANSON VALUES(7856,'Ton kentan : Ar gorventenn',3,NULL,NULL,'2008-03-18 08:56:33');
INSERT INTO CHANSON VALUES(7857,'Tamm kreiz : Ar gavrig',3,NULL,NULL,'2008-03-12 12:38:35');
INSERT INTO CHANSON VALUES(7858,'Ton doubl : Ar serjant major',3,NULL,NULL,'2008-03-12 19:12:02');
INSERT INTO CHANSON VALUES(7859,'Pachpi : Demp da..',3,NULL,'t','2008-03-12 16:39:12');
INSERT INTO CHANSON VALUES(7860,'entretien avec Marcel Guilloux',3,NULL,NULL,'2008-03-12 18:49:01');
INSERT INTO CHANSON VALUES(7861,'Ton kentañ : Noz kentañ ma eured',3,NULL,NULL,'2008-03-12 08:56:10');
INSERT INTO CHANSON VALUES(7862,'Bal : Ar minorez',3,NULL,NULL,'2008-03-12 12:17:39');
INSERT INTO CHANSON VALUES(7863,'Ton diwezhañ : Ar verjelenig',3,NULL,NULL,'2008-03-12 13:18:34');
INSERT INTO CHANSON VALUES(7864,'Ton berr : Ar c''hoz paotr yaouank',3,NULL,NULL,'2008-03-12 10:18:15');
INSERT INTO CHANSON VALUES(7865,'Tamm Kreieh : Un Ti bihan',3,NULL,NULL,'2008-03-12 18:52:36');
INSERT INTO CHANSON VALUES(7866,'Ton doubl : Kloareg Kertangi',3,NULL,NULL,'2008-03-12 15:53:33');
INSERT INTO CHANSON VALUES(7867,'entretien avec Erik Marchand (2)',3,NULL,NULL,'2008-03-12 10:16:11');
INSERT INTO CHANSON VALUES(7868,'Ton Kentañ : Ar c''hog hag ar bolez',3,NULL,NULL,'2008-03-12 17:16:23');
INSERT INTO CHANSON VALUES(7869,'Bal : Klevet ''m eus alies',3,NULL,NULL,'2008-03-12 17:57:03');
INSERT INTO CHANSON VALUES(7870,'Ton diwezhañ : Alexandre',3,NULL,NULL,'2008-03-12 08:48:52');
INSERT INTO CHANSON VALUES(7871,'entretien avec Marcel Guilloux (2)',3,NULL,NULL,'2008-03-12 08:49:48');
INSERT INTO CHANSON VALUES(7872,'Ton berr : An disput etre ar c''hernevad hag an tregeriad',3,NULL,NULL,'2008-03-12 10:11:06');
INSERT INTO CHANSON VALUES(7873,'Tamm kreizh : Mari Perin',3,NULL,NULL,'2008-03-12 18:36:24');
INSERT INTO CHANSON VALUES(7874,'Ton doubl : An desertour',3,NULL,NULL,'2008-03-12 13:51:43');
INSERT INTO CHANSON VALUES(7875,'Ken a vo',3,NULL,NULL,'2008-03-12 16:44:36');
INSERT INTO CHANSON VALUES(7876,'Diaouled ar menez / Dans fisel',3,NULL,NULL,'2008-03-12 11:23:29');
INSERT INTO CHANSON VALUES(7877,'Dir Ha Tan / Mazad ha ma mamm',3,NULL,NULL,'2008-03-12 18:34:46');
INSERT INTO CHANSON VALUES(7878,'Kouerien Saint-Yann / Suite de branles marichins',3,NULL,NULL,'2008-03-12 08:22:02');
INSERT INTO CHANSON VALUES(7879,'La Godinette / Suite d''en avant-deux Saint-Jeanl',3,NULL,NULL,'2008-03-12 13:11:59');
INSERT INTO CHANSON VALUES(7880,'Kanforded Ar C''Hoat / Dans fisel',3,NULL,NULL,'2008-03-12 14:12:48');
INSERT INTO CHANSON VALUES(7881,'Kistnidiz / An dro',3,NULL,NULL,'2008-03-12 12:15:37');
INSERT INTO CHANSON VALUES(7882,'La Mirlitantouille / Les guédennes',3,NULL,NULL,'2008-03-12 10:27:48');
INSERT INTO CHANSON VALUES(7883,'Kanfarded Rostren / Dans fisel',3,NULL,NULL,'2008-03-12 11:19:25');
INSERT INTO CHANSON VALUES(7884,'Sataneset / An-droElfenn',3,NULL,NULL,'2008-03-12 16:45:17');
INSERT INTO CHANSON VALUES(7885,'Ar Skolferien / Gavotte à deux violons',3,NULL,NULL,'2008-03-12 13:27:02');
INSERT INTO CHANSON VALUES(7886,'Dremmwel / Re zo re',3,NULL,NULL,'2008-03-12 08:45:25');
INSERT INTO CHANSON VALUES(7887,'Galorn / Highlands',3,NULL,NULL,'2008-03-12 14:36:00');
INSERT INTO CHANSON VALUES(7888,'Senerien Du / L''artilleur',3,NULL,NULL,'2008-03-12 12:40:22');
INSERT INTO CHANSON VALUES(7889,'Tammles / Sans bagage',3,NULL,NULL,'2008-03-12 12:07:33');
INSERT INTO CHANSON VALUES(7890,'Diwall / E-kichen ar mor',3,NULL,NULL,'2008-03-12 12:38:46');
INSERT INTO CHANSON VALUES(7891,'Bleizi Ruz / Trouz e kerdiez',3,NULL,NULL,'2008-03-12 10:01:01');
INSERT INTO CHANSON VALUES(7892,'Korriganed / Sonit plac''hed yaouank',3,NULL,NULL,'2008-03-12 17:14:29');
INSERT INTO CHANSON VALUES(7893,'BF 15 / Rond de Loudia',3,NULL,NULL,'2008-03-12 15:33:48');
INSERT INTO CHANSON VALUES(7894,'Tro Breizh',3,NULL,'t','2008-03-12 08:17:34');
INSERT INTO CHANSON VALUES(7895,'Noite Pecha',3,NULL,NULL,'2008-03-12 12:44:01');
INSERT INTO CHANSON VALUES(7896,'Gavotte-Pandeirada',3,NULL,NULL,'2008-03-12 12:49:46');
INSERT INTO CHANSON VALUES(7897,'Une Autre Fin De Terre',3,NULL,NULL,'2008-03-12 17:22:23');
INSERT INTO CHANSON VALUES(7898,'Karante Doh Doue',3,NULL,NULL,'2008-03-12 17:43:04');
INSERT INTO CHANSON VALUES(7899,'Polka De Karnoïd',3,NULL,NULL,'2008-03-12 10:05:11');
INSERT INTO CHANSON VALUES(7900,'An Hini A Garan',3,NULL,'t','2008-03-12 16:28:50');
INSERT INTO CHANSON VALUES(7901,'The Three Pipers',3,NULL,NULL,'2008-03-12 14:38:51');
INSERT INTO CHANSON VALUES(7902,'Saint Patrick''s An Dro',3,NULL,'t','2008-03-12 14:27:06');
INSERT INTO CHANSON VALUES(7903,'Yann Derrien',3,NULL,NULL,'2008-03-12 08:04:39');
INSERT INTO CHANSON VALUES(7904,'Bretoña',3,NULL,NULL,'2008-03-12 17:06:57');
INSERT INTO CHANSON VALUES(7905,'Un Galicien Libre À Paris',3,NULL,NULL,'2008-03-12 12:27:42');
INSERT INTO CHANSON VALUES(7906,'Ponthus Et Sidoine',3,NULL,NULL,'2008-03-12 12:49:31');
INSERT INTO CHANSON VALUES(7907,'L''argent qui brille - Le moulin de Pao',3,NULL,NULL,'2008-03-12 10:37:54');
INSERT INTO CHANSON VALUES(7908,'Préparez-vous jeunes fillettes - On arrive...',3,NULL,NULL,'2008-03-12 15:25:37');
INSERT INTO CHANSON VALUES(7909,'Suite de maraîchines',3,NULL,NULL,'2008-03-12 15:36:43');
INSERT INTO CHANSON VALUES(7910,'La guilanu - Métamorphose - Polka Marguerite',3,NULL,NULL,'2008-03-12 18:20:11');
INSERT INTO CHANSON VALUES(7911,'Dilidom scottish - Scottish Bob',3,NULL,NULL,'2008-03-12 16:50:50');
INSERT INTO CHANSON VALUES(7912,'Grand-danse comme cadeau - Grand-danse du c''teau',3,NULL,NULL,'2008-03-12 14:21:17');
INSERT INTO CHANSON VALUES(7913,'La fille du bonhomme qu''est riche',3,NULL,NULL,'2008-03-12 15:22:21');
INSERT INTO CHANSON VALUES(7914,'Mon petit bonnet rond',3,NULL,NULL,'2008-03-12 11:11:28');
INSERT INTO CHANSON VALUES(7915,'Mélodie de Montaigu - Marche de Noimoutier',3,NULL,NULL,'2008-03-12 11:34:56');
INSERT INTO CHANSON VALUES(7916,'Marcha do Entrelazado de Allariz',3,NULL,NULL,'2008-03-12 19:59:45');
INSERT INTO CHANSON VALUES(7917,'Pasacorredoiras',3,NULL,NULL,'2008-03-12 14:10:23');
INSERT INTO CHANSON VALUES(7918,'Mayo Longo',3,NULL,NULL,'2008-03-12 12:46:49');
INSERT INTO CHANSON VALUES(7919,'The Moon Says Hello',3,NULL,NULL,'2008-03-12 08:25:26');
INSERT INTO CHANSON VALUES(7920,'Vento d''as Cies',3,NULL,NULL,'2008-03-12 17:16:46');
INSERT INTO CHANSON VALUES(7921,'A Moura',3,NULL,NULL,'2008-03-12 19:57:36');
INSERT INTO CHANSON VALUES(7922,'Astros, fuentes y flores',3,NULL,NULL,'2008-03-12 17:30:58');
INSERT INTO CHANSON VALUES(7923,'Capitan Nemo',3,NULL,NULL,'2008-03-12 09:09:20');
INSERT INTO CHANSON VALUES(7924,'Nona de lluvia',3,NULL,NULL,'2008-03-12 13:29:32');
INSERT INTO CHANSON VALUES(7925,'El pozo de Aran',3,NULL,NULL,'2008-03-12 19:45:07');
INSERT INTO CHANSON VALUES(7926,'Foliada dos Aires da Terra',3,NULL,NULL,'2008-03-12 18:44:06');
INSERT INTO CHANSON VALUES(7927,'Alborada Anterga de Pontevedra',3,NULL,NULL,'2008-03-12 15:15:17');
INSERT INTO CHANSON VALUES(7928,'Canto de Seitura',3,NULL,NULL,'2008-03-12 08:40:03');
INSERT INTO CHANSON VALUES(7929,'Aires de Pontevedra',3,NULL,NULL,'2008-03-12 18:42:29');
INSERT INTO CHANSON VALUES(7930,'Jigs and Bulls',3,NULL,NULL,'2008-03-12 11:28:45');
INSERT INTO CHANSON VALUES(7931,'Os Amores Libres',3,NULL,NULL,'2008-03-12 08:25:42');
INSERT INTO CHANSON VALUES(7932,'Muiñeiras da Sorte',3,NULL,NULL,'2008-03-12 16:13:12');
INSERT INTO CHANSON VALUES(7933,'Maréa Soliña',3,NULL,NULL,'2008-03-12 16:19:22');
INSERT INTO CHANSON VALUES(7934,'A Orillas del Rio Sil',3,NULL,NULL,'2008-03-12 08:47:51');
INSERT INTO CHANSON VALUES(7935,'Alma Barca',3,NULL,NULL,'2008-03-12 14:44:37');
INSERT INTO CHANSON VALUES(7936,'O Cabalo Azul',3,NULL,NULL,'2008-03-12 16:37:22');
INSERT INTO CHANSON VALUES(7937,'The Raggle Taggle Gipsy',3,NULL,NULL,'2008-03-12 17:16:38');
INSERT INTO CHANSON VALUES(7938,'Danza da Lia en Santiago',3,NULL,NULL,'2008-03-12 09:19:18');
INSERT INTO CHANSON VALUES(7939,'A Lavandeira da Noite',3,NULL,NULL,'2008-03-12 09:11:00');
INSERT INTO CHANSON VALUES(7940,'Viva la Quinta Brigada',3,NULL,NULL,'2008-03-12 15:29:28');
INSERT INTO CHANSON VALUES(7941,'O Castro da Moura ( Etnodance )',3,NULL,NULL,'2008-03-12 12:34:54');
INSERT INTO CHANSON VALUES(7942,'Dawn',3,NULL,NULL,'2008-03-12 09:16:08');
INSERT INTO CHANSON VALUES(7943,'Brotherhood of Stars',3,NULL,NULL,'2008-03-12 11:56:28');
INSERT INTO CHANSON VALUES(7944,'Two Shores',3,NULL,NULL,'2008-03-12 16:58:16');
INSERT INTO CHANSON VALUES(7945,'Black Shadow',3,NULL,NULL,'2008-03-12 14:31:00');
INSERT INTO CHANSON VALUES(7946,'The Moonlight Piper',3,NULL,NULL,'2008-03-12 10:12:38');
INSERT INTO CHANSON VALUES(7947,'Cantigueiras',3,NULL,NULL,'2008-03-12 14:00:55');
INSERT INTO CHANSON VALUES(7948,'Galician Carol',3,NULL,NULL,'2008-03-12 10:05:14');
INSERT INTO CHANSON VALUES(7949,'Dancing with Rosina',3,NULL,NULL,'2008-03-12 14:14:25');
INSERT INTO CHANSON VALUES(7950,'Lela',3,NULL,NULL,'2008-03-12 14:52:55');
INSERT INTO CHANSON VALUES(7951,'The Flight of the Earls',3,NULL,NULL,'2008-03-12 19:16:30');
INSERT INTO CHANSON VALUES(7952,'The Rainmaker''s Air',3,NULL,NULL,'2008-03-12 18:22:46');
INSERT INTO CHANSON VALUES(7953,'Para Vigo me voy',3,NULL,NULL,'2008-03-12 08:41:43');
INSERT INTO CHANSON VALUES(7954,'Bemdez c''houlou',3,NULL,NULL,'2008-03-12 14:22:41');
INSERT INTO CHANSON VALUES(7955,'Termaji',3,NULL,NULL,'2008-03-12 17:56:13');
INSERT INTO CHANSON VALUES(7956,'Dal',3,NULL,NULL,'2008-03-12 17:07:25');
INSERT INTO CHANSON VALUES(7957,'Valsenn Trefin',3,NULL,NULL,'2008-03-12 13:41:25');
INSERT INTO CHANSON VALUES(7958,'News from town for my love who stayed home',3,NULL,NULL,'2008-03-12 12:53:31');
INSERT INTO CHANSON VALUES(7959,'Yanning ha Mai',3,NULL,NULL,'2008-03-12 15:23:46');
INSERT INTO CHANSON VALUES(7960,'Pardon an dreinded',3,NULL,NULL,'2008-03-12 08:54:38');
INSERT INTO CHANSON VALUES(7961,'Dafydd y Garreg Wen',3,NULL,NULL,'2008-03-12 19:54:55');
INSERT INTO CHANSON VALUES(7962,'Un petit navire d''Espagne',3,NULL,NULL,'2008-03-12 13:48:17');
INSERT INTO CHANSON VALUES(7963,'Olole',3,NULL,NULL,'2008-03-12 10:50:58');
INSERT INTO CHANSON VALUES(7964,'Sous le ciel de cuivre et d''eau',3,NULL,NULL,'2008-03-12 19:21:21');
INSERT INTO CHANSON VALUES(7965,'Bugaleaj Nevez',3,NULL,NULL,'2008-03-12 15:07:17');
INSERT INTO CHANSON VALUES(7966,'Si tu t''en vas',3,NULL,NULL,'2008-03-12 18:54:24');
INSERT INTO CHANSON VALUES(7967,'Dansez la gavotenn',3,NULL,NULL,'2008-03-12 11:20:05');
INSERT INTO CHANSON VALUES(7968,'Marig ar Pollanton',3,NULL,NULL,'2008-03-12 16:41:59');
INSERT INTO CHANSON VALUES(7969,'Bleuenn',3,NULL,NULL,'2008-03-12 11:16:22');
INSERT INTO CHANSON VALUES(7970,'L''amour que tu donnes',3,NULL,NULL,'2008-03-12 08:18:17');
INSERT INTO CHANSON VALUES(7971,'Kenavo d''an Naoned',3,NULL,NULL,'2008-03-12 16:15:12');
INSERT INTO CHANSON VALUES(7972,'Rianxeirra',3,NULL,NULL,'2008-03-12 15:43:00');
INSERT INTO CHANSON VALUES(7973,'Sur la montagne de Brasparzh',3,NULL,NULL,'2008-03-12 18:57:51');
INSERT INTO CHANSON VALUES(7974,'Phare de l''Ile Vierge',3,NULL,NULL,'2008-03-12 18:55:12');
INSERT INTO CHANSON VALUES(7975,'Le général des binious',3,NULL,NULL,'2008-03-12 10:34:20');
INSERT INTO CHANSON VALUES(7976,'Vielle ville de merde',3,NULL,NULL,'2008-03-12 14:27:15');
INSERT INTO CHANSON VALUES(7977,'Il est des êtres beaux',3,NULL,NULL,'2008-03-12 19:45:35');
INSERT INTO CHANSON VALUES(7978,'Yezhoù bihan',3,NULL,NULL,'2008-03-20 08:29:17');
INSERT INTO CHANSON VALUES(7979,'A white horse',3,NULL,NULL,'2008-03-12 08:44:34');
INSERT INTO CHANSON VALUES(7980,'Men du',3,NULL,NULL,'2008-03-20 12:45:52');
INSERT INTO CHANSON VALUES(7981,'Sur les quais de Dublin',3,NULL,NULL,'2008-03-12 16:25:08');
INSERT INTO CHANSON VALUES(7984,'Ar brezhoneg ev ma bro',3,NULL,NULL,'2008-03-12 17:46:45');
INSERT INTO CHANSON VALUES(7985,'When last I saw you',3,NULL,NULL,'2008-03-12 19:59:20');
INSERT INTO CHANSON VALUES(7986,'Carrickfergus',3,NULL,NULL,'2008-03-12 11:30:47');
INSERT INTO CHANSON VALUES(7987,'Les derniers rayons',3,NULL,NULL,'2008-03-20 14:26:32');
INSERT INTO CHANSON VALUES(7988,'Contredanse -- Contredanse no.16 -- La victoire (trad)',3,NULL,NULL,'2008-03-12 10:28:01');
INSERT INTO CHANSON VALUES(7989,'Marche du déserteur -- Marche (trad)',3,NULL,NULL,'2008-03-12 13:29:46');
INSERT INTO CHANSON VALUES(7990,'Menuet de la chaine (trad)',3,NULL,NULL,'2008-03-12 08:53:31');
INSERT INTO CHANSON VALUES(7991,'The baulk -- Le rossignol au bois (trad)',3,NULL,NULL,'2008-03-12 18:34:56');
INSERT INTO CHANSON VALUES(7992,'Black joack -- Change alley (trad)',3,NULL,NULL,'2008-03-12 08:28:57');
INSERT INTO CHANSON VALUES(7993,'Taxim (Luc Pilartz) -- Hopa! (Luc Pilartz)',3,NULL,NULL,'2008-03-12 18:23:51');
INSERT INTO CHANSON VALUES(7994,'Valse -- La marchande d''amour no.89 -- Contredanse no.14 -- Contredanse no.12 (trad)',3,NULL,NULL,'2008-03-12 16:09:38');
INSERT INTO CHANSON VALUES(7995,'Valse hongroise no.4 (trad)',3,NULL,NULL,'2008-03-12 13:08:37');
INSERT INTO CHANSON VALUES(7996,'Contredanse no.8 La denise -- Contredanse no.5 (trad)',3,NULL,NULL,'2008-03-12 17:28:08');
INSERT INTO CHANSON VALUES(7997,'Valse no.10 -- Valse (trad)',3,NULL,NULL,'2008-03-12 15:02:34');
INSERT INTO CHANSON VALUES(7998,'Contredanse no.96 -- Contredanse no.97 (trad)',3,NULL,NULL,'2008-03-12 09:13:02');
INSERT INTO CHANSON VALUES(7999,'Menuet de l''hermite no.4 -- Matelotte -- Merri Kate (trad)',3,NULL,NULL,'2008-03-12 10:40:31');
INSERT INTO CHANSON VALUES(8000,'Bagpipe tune (anon. England)',3,NULL,NULL,'2008-03-12 19:42:24');
INSERT INTO CHANSON VALUES(8001,'Valse no.8 (trad) -- Valse a Noel (Noel Warnier)',3,NULL,NULL,'2008-03-12 13:36:59');
INSERT INTO CHANSON VALUES(8002,'The boys of Malin (trad. Ireland)',3,NULL,NULL,'2008-03-12 13:39:27');
INSERT INTO CHANSON VALUES(8003,'Heuliadenn Gouel ha daeroù 1.2.3.4.5.6.7.(Gavotte)',3,NULL,NULL,'2008-03-20 12:33:51');
INSERT INTO CHANSON VALUES(8004,'Tournemine et Gasdebois (Scottisch)',3,NULL,NULL,'2008-03-12 11:17:00');
INSERT INTO CHANSON VALUES(8005,'Chenchet''n eus an amzer (Mélodie)',3,NULL,NULL,'2008-03-12 18:46:09');
INSERT INTO CHANSON VALUES(8006,'Tadin-Tinaketa (Hanter dro)',3,NULL,NULL,'2008-03-12 14:35:37');
INSERT INTO CHANSON VALUES(8007,'Intermède: Pedenn (piano solo)',3,NULL,NULL,'2008-03-12 15:13:40');
INSERT INTO CHANSON VALUES(8008,'My Favorite Things',3,NULL,NULL,'2008-03-12 10:22:53');
INSERT INTO CHANSON VALUES(8009,'An tolgenn aour 1.2.3 (Rond de St-Vincent)',3,NULL,NULL,'2008-03-12 11:34:34');
INSERT INTO CHANSON VALUES(8010,'Intermède: Le sonneur 1',3,NULL,NULL,'2008-03-12 17:32:16');
INSERT INTO CHANSON VALUES(8011,'Pedenn chanté',3,NULL,NULL,'2008-03-12 10:01:53');
INSERT INTO CHANSON VALUES(8012,'Intermède: Le sonneur 2',3,NULL,NULL,'2008-03-12 10:27:32');
INSERT INTO CHANSON VALUES(8013,'O vont e-biou Landevant (Laridé)',3,NULL,NULL,'2008-03-12 15:50:05');
INSERT INTO CHANSON VALUES(8014,'Du-hont e Menez Are (Gavotte)',3,NULL,NULL,'2008-03-12 14:06:22');
INSERT INTO CHANSON VALUES(8015,'Ar c''hwezh nevez 1.2.3.4 (An Dro)',3,NULL,NULL,'2008-03-12 14:00:09');
INSERT INTO CHANSON VALUES(8016,'Intermède: Pedenn (contrebasse)',3,NULL,NULL,'2008-03-12 16:31:45');
INSERT INTO CHANSON VALUES(8017,'Pedenn sonné',3,NULL,NULL,'2008-03-12 11:10:58');
INSERT INTO CHANSON VALUES(8018,'Daskren al lanchenno'' (Ton simpl plinn)',3,NULL,NULL,'2008-03-12 19:24:21');
INSERT INTO CHANSON VALUES(8019,'Al lanchenno'' sioul (Bal plinn)',3,NULL,NULL,'2008-03-12 18:40:55');
INSERT INTO CHANSON VALUES(8020,'Kan al lanchenno'' (Ton doubl plinn)',3,NULL,NULL,'2008-03-12 13:28:28');
INSERT INTO CHANSON VALUES(8021,'G... de bois (Scottisch)',3,NULL,NULL,'2008-03-12 16:41:29');
INSERT INTO CHANSON VALUES(8022,'Nous sommes chanteurs de sornettes',3,NULL,NULL,'2008-03-12 15:52:56');
INSERT INTO CHANSON VALUES(8023,'Le prince d''Orange',3,NULL,NULL,'2008-03-12 09:32:47');
INSERT INTO CHANSON VALUES(8024,'Marions les roses',3,NULL,NULL,'2008-03-12 11:03:54');
INSERT INTO CHANSON VALUES(8025,'Margot',3,NULL,NULL,'2008-03-12 15:35:54');
INSERT INTO CHANSON VALUES(8026,'La mule',3,NULL,NULL,'2008-04-13 13:59:29');
INSERT INTO CHANSON VALUES(8027,'Paysans sans peur',3,NULL,NULL,'2008-03-12 17:17:25');
INSERT INTO CHANSON VALUES(8028,'La blanche biche',3,NULL,NULL,'2008-03-12 14:36:36');
INSERT INTO CHANSON VALUES(8029,'Salut la compagnie',3,NULL,NULL,'2008-03-12 14:36:00');
INSERT INTO CHANSON VALUES(8030,'Daniel mon fils',3,NULL,NULL,'2008-04-24 10:15:39');
INSERT INTO CHANSON VALUES(8031,'Les filles sont volages',3,NULL,NULL,'2008-03-12 18:29:41');
INSERT INTO CHANSON VALUES(8032,'La conduite',3,NULL,NULL,'2008-03-12 17:57:10');
INSERT INTO CHANSON VALUES(8033,'Les couleurs',3,NULL,NULL,'2008-03-12 11:41:51');
INSERT INTO CHANSON VALUES(8034,'La complainte du coureur de bois',3,NULL,NULL,'2008-03-12 17:19:44');
INSERT INTO CHANSON VALUES(8035,'Voici venir le joli mai',3,NULL,NULL,'2008-03-12 16:29:17');
INSERT INTO CHANSON VALUES(8036,'C''est le mai',3,NULL,NULL,'2008-03-12 13:45:20');
INSERT INTO CHANSON VALUES(8037,'Le navire de Bayonne - Paye paysan',3,NULL,NULL,'2008-03-12 12:23:56');
INSERT INTO CHANSON VALUES(8038,'Marions les roses (remixage)',3,NULL,NULL,'2008-03-12 11:10:13');
INSERT INTO CHANSON VALUES(8039,'Don''t slit your wrists for me',3,NULL,NULL,'2008-03-12 16:43:50');
INSERT INTO CHANSON VALUES(8040,'Star of the County Down',3,NULL,NULL,'2008-03-12 11:14:26');
INSERT INTO CHANSON VALUES(8041,'Internal exile',3,NULL,NULL,'2008-03-12 11:06:55');
INSERT INTO CHANSON VALUES(8042,'Young Ned of the hill',3,NULL,NULL,'2008-03-26 08:53:53');
INSERT INTO CHANSON VALUES(8043,'Raggle taggle gypsy',3,NULL,NULL,'2008-03-12 10:09:35');
INSERT INTO CHANSON VALUES(8044,'Great Enoch',3,NULL,NULL,'2008-03-12 08:54:54');
INSERT INTO CHANSON VALUES(8045,'Loch Lomond',3,NULL,NULL,'2008-03-12 17:36:24');
INSERT INTO CHANSON VALUES(8046,'Whiskey in the jar',3,NULL,NULL,'2008-03-12 08:05:09');
INSERT INTO CHANSON VALUES(8047,'John Henry',3,NULL,NULL,'2008-03-12 12:29:33');
INSERT INTO CHANSON VALUES(8048,'Les suédoises et la patate à Pampam',3,NULL,NULL,'2008-05-26 10:10:33');
INSERT INTO CHANSON VALUES(8049,'L''enfance',3,NULL,NULL,'2008-03-12 12:46:43');
INSERT INTO CHANSON VALUES(8050,'La mariénée',3,NULL,NULL,'2008-05-26 13:21:26');
INSERT INTO CHANSON VALUES(8051,'Les oies sauvages',3,NULL,NULL,'2008-03-12 15:29:27');
INSERT INTO CHANSON VALUES(8052,'New Orlean''s Dream',3,NULL,NULL,'2008-03-12 13:49:41');
INSERT INTO CHANSON VALUES(8053,'Le spleen du Moustic',3,NULL,NULL,'2008-03-12 18:08:47');
INSERT INTO CHANSON VALUES(8054,'Le mal du pays',3,NULL,NULL,'2008-03-12 17:10:41');
INSERT INTO CHANSON VALUES(8055,'Deux petites filles',3,NULL,NULL,'2008-03-12 16:21:50');
INSERT INTO CHANSON VALUES(8056,'À la première auberge là',3,NULL,'f','2008-05-26 19:24:18');
INSERT INTO CHANSON VALUES(8057,'Lys Jigs',3,NULL,NULL,'2008-03-12 11:23:44');
INSERT INTO CHANSON VALUES(8058,'Nag an tu all',3,NULL,NULL,'2008-03-12 10:10:20');
INSERT INTO CHANSON VALUES(8059,'Latitude 48',3,NULL,NULL,'2008-03-12 15:14:26');
INSERT INTO CHANSON VALUES(8060,'Ar plac''h iferniet',3,NULL,NULL,'2008-03-12 17:38:55');
INSERT INTO CHANSON VALUES(8061,'Ar merc''hed yaouank',3,NULL,NULL,'2008-03-12 11:59:42');
INSERT INTO CHANSON VALUES(8062,'Ma mije bet liou ha paper gwenn',3,NULL,NULL,'2008-03-12 08:35:12');
INSERT INTO CHANSON VALUES(8063,'Gwerz Penmarc''h',3,NULL,NULL,'2008-03-12 13:00:01');
INSERT INTO CHANSON VALUES(8064,'Ar gwall lezvamm',3,NULL,NULL,'2008-03-12 10:52:10');
INSERT INTO CHANSON VALUES(8065,'Je suis venu vous inviter',3,NULL,NULL,'2008-03-12 19:40:20');
INSERT INTO CHANSON VALUES(8066,'Merc''hed ar friturioù',3,NULL,NULL,'2008-03-12 15:21:42');
INSERT INTO CHANSON VALUES(8067,'Pa voen ba'' ti ma mamm',3,NULL,NULL,'2008-03-12 14:38:05');
INSERT INTO CHANSON VALUES(8068,'Saluez riches heureux',3,NULL,NULL,'2008-03-12 10:49:16');
INSERT INTO CHANSON VALUES(8069,'Diwar merc''hed firturioù Sant-Gwenole',3,NULL,NULL,'2008-03-12 15:25:30');
INSERT INTO CHANSON VALUES(8070,'Pardon Santez Anna',3,NULL,NULL,'2008-03-12 08:11:09');
INSERT INTO CHANSON VALUES(8071,'Gwerz an Titanic',3,NULL,NULL,'2008-03-12 19:29:09');
INSERT INTO CHANSON VALUES(8072,'Touri toura',3,NULL,NULL,'2008-03-12 16:32:44');
INSERT INTO CHANSON VALUES(8073,'Pinard',3,NULL,NULL,'2008-03-12 18:02:45');
INSERT INTO CHANSON VALUES(8084,'Gloire a toi, Neptune',3,NULL,NULL,'2008-03-12 19:13:37');
INSERT INTO CHANSON VALUES(8085,'La solette et le limandin',3,NULL,NULL,'2008-03-12 09:12:18');
INSERT INTO CHANSON VALUES(8086,'Bransles des muresnes',3,NULL,NULL,'2008-03-12 13:52:40');
INSERT INTO CHANSON VALUES(8087,'Dessous la ville de Nantes',3,NULL,'f','2008-03-12 09:22:18');
INSERT INTO CHANSON VALUES(8088,'Lorc''hentez ker Is',3,NULL,'f','2008-03-12 10:37:07');
INSERT INTO CHANSON VALUES(8089,'Dans la lune au fond de l''eau',3,NULL,'f','2008-03-12 14:13:33');
INSERT INTO CHANSON VALUES(8090,'Petite sirène',3,NULL,'f','2008-03-12 08:15:44');
INSERT INTO CHANSON VALUES(8091,'J''ai croisé les néréides',3,NULL,'f','2008-03-12 10:13:14');
INSERT INTO CHANSON VALUES(8092,'Sonnen ar mor donn',3,NULL,'f','2008-03-12 12:54:47');
INSERT INTO CHANSON VALUES(8093,'Gavotenn ar seizh',3,NULL,'f','2008-03-12 08:47:49');
INSERT INTO CHANSON VALUES(8094,'Lancastria',3,NULL,'f','2008-03-12 17:42:03');
INSERT INTO CHANSON VALUES(8095,'Tif-fo-tonn',3,NULL,'f','2008-03-12 13:48:15');
INSERT INTO CHANSON VALUES(8096,'Le sous marin',3,NULL,'f','2008-03-12 17:14:07');
INSERT INTO CHANSON VALUES(8097,'L''eden des mers',3,NULL,'f','2008-03-12 13:23:30');
INSERT INTO CHANSON VALUES(8099,'John Wesley Harding',2,NULL,'f','2008-03-12 18:08:20');
INSERT INTO CHANSON VALUES(8100,'As I Went Out One Morning',2,NULL,'f','2008-03-12 13:10:36');
INSERT INTO CHANSON VALUES(8101,'I Dreamed I Saw St. Augustine',2,NULL,'f','2008-03-12 10:21:49');
INSERT INTO CHANSON VALUES(8102,'All Along The Watchtower',2,NULL,'f','2008-03-12 13:41:44');
INSERT INTO CHANSON VALUES(8103,'The Ballad Of Frankie Lee And Judas Priest',2,NULL,NULL,'2008-03-12 10:45:31');
INSERT INTO CHANSON VALUES(8104,'Drifter''s Escape',2,NULL,'f','2008-03-12 08:35:14');
INSERT INTO CHANSON VALUES(8105,'Dear Landlord',2,NULL,'f','2008-03-12 09:02:02');
INSERT INTO CHANSON VALUES(8106,'I Am A Lonesome Hobo',2,NULL,'f','2008-03-12 12:48:17');
INSERT INTO CHANSON VALUES(8107,'I Pity The Poor Immigrant',2,NULL,'f','2008-03-12 13:14:40');
INSERT INTO CHANSON VALUES(8108,'The Wicked Messenger',2,NULL,'f','2008-03-12 19:58:18');
INSERT INTO CHANSON VALUES(8109,'Down Along The Cove',2,NULL,'f','2008-03-12 09:50:27');
INSERT INTO CHANSON VALUES(8110,'I''ll Be Your Baby Tonight',2,NULL,'f','2008-03-12 13:16:37');
INSERT INTO CHANSON VALUES(8113,'You''re a Big Girl Now',2,NULL,'f','2008-03-12 15:04:25');
INSERT INTO CHANSON VALUES(8114,'Idiot Wind',2,NULL,'f','2008-03-12 09:06:01');
INSERT INTO CHANSON VALUES(8115,'You''re Gonna Make Me Lonesome When You Go',2,NULL,'f','2008-03-12 12:11:04');
INSERT INTO CHANSON VALUES(8116,'Meet Me in the Morning',2,NULL,'f','2008-03-12 13:32:53');
INSERT INTO CHANSON VALUES(8117,'Lily, Rosemary and the Jack of Hearts',2,NULL,'f','2008-03-12 16:01:07');
INSERT INTO CHANSON VALUES(8118,'If You See Her, Say Hello',2,NULL,'f','2008-03-12 12:00:06');
INSERT INTO CHANSON VALUES(8119,'Shelter From the Storm',2,NULL,'f','2008-03-12 16:06:57');
INSERT INTO CHANSON VALUES(8120,'Buckets of Rain',2,NULL,NULL,'2008-03-12 10:34:13');
INSERT INTO CHANSON VALUES(8121,'Girl From The North Country',2,NULL,NULL,'2008-03-12 17:37:40');
INSERT INTO CHANSON VALUES(8122,'Nashville Skyline Rag',2,NULL,'f','2008-03-12 17:31:32');
INSERT INTO CHANSON VALUES(8123,'To Be Alone With You',2,NULL,'f','2008-03-12 13:08:37');
INSERT INTO CHANSON VALUES(8124,'I Threw It All Away',2,NULL,'f','2008-03-12 18:17:43');
INSERT INTO CHANSON VALUES(8125,'Peggy Day',2,NULL,'f','2008-03-12 19:41:55');
INSERT INTO CHANSON VALUES(8126,'Lay Lady Lay',2,NULL,'f','2008-03-12 19:07:27');
INSERT INTO CHANSON VALUES(8127,'One More Night',2,NULL,'f','2008-03-12 18:51:28');
INSERT INTO CHANSON VALUES(8128,'Tell Me That It Isn''t True',2,NULL,'f','2008-03-12 08:16:28');
INSERT INTO CHANSON VALUES(8129,'Country Pie',2,NULL,'f','2008-03-12 09:59:35');
INSERT INTO CHANSON VALUES(8141,'The Times They Are A-Changin''',2,NULL,NULL,'2008-03-12 11:59:48');
INSERT INTO CHANSON VALUES(8142,'Ballad Of Hollis Brown',2,NULL,NULL,'2008-03-12 19:47:19');
INSERT INTO CHANSON VALUES(8143,'With God On Our Side',2,NULL,'f','2008-03-12 14:15:28');
INSERT INTO CHANSON VALUES(8144,'One Too Many Mornings',2,NULL,'f','2008-03-12 09:09:45');
INSERT INTO CHANSON VALUES(8145,'North Country Blues',2,NULL,'f','2008-03-12 18:04:26');
INSERT INTO CHANSON VALUES(8146,'Only A Pawn In Their Game',2,NULL,'f','2008-03-12 17:04:34');
INSERT INTO CHANSON VALUES(8147,'Boots Of Spanish Leather',2,NULL,'f','2008-03-12 11:57:25');
INSERT INTO CHANSON VALUES(8148,'When The Ship Comes In',2,NULL,'f','2008-03-12 16:58:41');
INSERT INTO CHANSON VALUES(8150,'Restless Farewell',2,NULL,'f','2008-03-12 17:10:51');
INSERT INTO CHANSON VALUES(8151,'Suil a ruin',3,NULL,NULL,'2008-03-12 19:29:51');
INSERT INTO CHANSON VALUES(8152,'Le vent m''emporte',3,NULL,NULL,'2008-03-12 17:28:38');
INSERT INTO CHANSON VALUES(8153,'Stor mo chroi',3,NULL,NULL,'2008-03-12 09:00:54');
INSERT INTO CHANSON VALUES(8154,'She moved through the fair',3,NULL,NULL,'2008-03-12 15:10:03');
INSERT INTO CHANSON VALUES(8155,'Auchindoun',3,NULL,NULL,'2008-03-12 12:03:08');
INSERT INTO CHANSON VALUES(8156,'Blackbird',3,NULL,NULL,'2008-03-12 17:51:13');
INSERT INTO CHANSON VALUES(8157,'C''hoant dimein',3,NULL,NULL,'2008-03-12 12:06:11');
INSERT INTO CHANSON VALUES(8158,'Bemnoz',3,NULL,NULL,'2008-03-12 17:51:10');
INSERT INTO CHANSON VALUES(8159,'Three ravens',3,NULL,NULL,'2008-03-12 13:04:16');
INSERT INTO CHANSON VALUES(8160,'Dellum down',3,NULL,NULL,'2008-03-12 10:53:27');
INSERT INTO CHANSON VALUES(8161,'Red rose',3,NULL,NULL,'2008-03-12 08:52:56');
INSERT INTO CHANSON VALUES(8162,'Valse des ondines (2006 version)',3,NULL,NULL,'2008-03-12 18:40:25');
INSERT INTO CHANSON VALUES(8164,'Bran',3,NULL,NULL,'2008-03-12 13:22:36');
INSERT INTO CHANSON VALUES(8165,'Shir Al Etz',3,NULL,NULL,'2008-03-12 14:43:39');
INSERT INTO CHANSON VALUES(8166,'Hija Mia',3,NULL,NULL,'2008-03-12 15:31:30');
INSERT INTO CHANSON VALUES(8167,'Je M''endors',3,NULL,NULL,'2008-03-12 18:53:37');
INSERT INTO CHANSON VALUES(8168,'Valse Des Ondines',3,NULL,NULL,'2008-03-12 08:41:28');
INSERT INTO CHANSON VALUES(8173,'Ou nous entraine la haine',3,NULL,NULL,'2008-03-12 12:48:52');
INSERT INTO CHANSON VALUES(8178,'Demain',3,NULL,NULL,'2008-03-12 15:35:09');
INSERT INTO CHANSON VALUES(8181,'La route de Kemper',3,NULL,NULL,'2008-03-24 19:54:14');
INSERT INTO CHANSON VALUES(8182,'Le moulin de Guérande',3,NULL,NULL,'2008-06-02 13:57:21.744412');
INSERT INTO CHANSON VALUES(8188,'Mozambique',2,NULL,'f','2008-03-12 12:33:54');
INSERT INTO CHANSON VALUES(8189,'One More Cup of Coffee',2,NULL,'f','2008-03-12 14:43:58');
INSERT INTO CHANSON VALUES(8191,'Joey',2,NULL,'f','2008-03-12 08:15:54');
INSERT INTO CHANSON VALUES(8193,'Black Diamond Bay',2,NULL,'f','2008-03-12 12:51:03');
INSERT INTO CHANSON VALUES(8195,'Thunder On The Mountain',2,NULL,'f','2008-03-12 18:24:38');
INSERT INTO CHANSON VALUES(8196,'Spirit On The Water',2,NULL,'f','2008-03-12 14:31:26');
INSERT INTO CHANSON VALUES(8197,'Rollin'' And Tumblin''',2,NULL,'f','2008-03-12 13:55:23');
INSERT INTO CHANSON VALUES(8198,'When The Deal Goes Down',2,NULL,'f','2008-03-12 17:19:56');
INSERT INTO CHANSON VALUES(8199,'Someday Baby',2,NULL,'f','2008-03-12 16:52:40');
INSERT INTO CHANSON VALUES(8200,'Workingman''s Blues #2',2,NULL,'f','2008-03-12 16:57:01');
INSERT INTO CHANSON VALUES(8201,'Beyond The Horizon',2,NULL,'f','2008-03-12 16:58:17');
INSERT INTO CHANSON VALUES(8202,'Nettie Moore',2,NULL,'f','2008-03-12 15:13:27');
INSERT INTO CHANSON VALUES(8203,'The Levee''s Gonna Break',2,NULL,NULL,'2008-03-12 16:33:19');
INSERT INTO CHANSON VALUES(8204,'Ain''t Talkin''',2,NULL,NULL,'2008-03-12 17:16:01');
INSERT INTO CHANSON VALUES(8205,'Love Sick',2,NULL,NULL,'2008-03-12 09:11:25');
INSERT INTO CHANSON VALUES(8206,'Dirt Road Blues',2,NULL,'f','2008-03-12 16:44:56');
INSERT INTO CHANSON VALUES(8207,'Standing In The Doorway',2,NULL,'f','2008-03-12 10:13:52');
INSERT INTO CHANSON VALUES(8208,'Million Miles',2,NULL,'f','2008-03-12 14:02:11');
INSERT INTO CHANSON VALUES(8209,'Tryin''n To Get To Heaven',2,NULL,'f','2008-03-12 14:44:03');
INSERT INTO CHANSON VALUES(8210,'"Til I Fell In Love With You',2,NULL,'f','2008-03-12 10:25:01');
INSERT INTO CHANSON VALUES(8211,'Not Dark Yet',2,NULL,'f','2008-03-12 10:06:59');
INSERT INTO CHANSON VALUES(8212,'Cold Irons Bound',2,NULL,'f','2008-03-12 13:41:12');
INSERT INTO CHANSON VALUES(8213,'Make you Feel My Love',2,NULL,'f','2008-03-12 19:23:45');
INSERT INTO CHANSON VALUES(8214,'Can''t Wait',2,NULL,'f','2008-03-12 11:08:02');
INSERT INTO CHANSON VALUES(8215,'Highlands',2,NULL,'f','2008-03-12 11:15:13');
INSERT INTO CHANSON VALUES(8225,'Kalondour',3,NULL,NULL,'2008-03-12 16:59:58');
INSERT INTO CHANSON VALUES(8226,'Chantez la vie, l''amour est mort',3,NULL,NULL,'2008-03-12 16:10:11');
INSERT INTO CHANSON VALUES(8227,'Liberté couleur des feuilles',3,NULL,NULL,'2008-06-02 13:55:52.524392');
INSERT INTO CHANSON VALUES(8228,'Yawankiz ma bro',3,NULL,NULL,'2008-03-12 16:15:58');
INSERT INTO CHANSON VALUES(8229,'Eléanor',3,NULL,NULL,'2008-06-02 13:56:00.585141');
INSERT INTO CHANSON VALUES(8231,'Comme je voudrai',3,NULL,NULL,'2008-03-12 17:09:12');
INSERT INTO CHANSON VALUES(8232,'Le pays',3,NULL,NULL,'2008-03-12 08:06:36');
INSERT INTO CHANSON VALUES(8238,'Me ''garje Bout',3,NULL,NULL,'2008-03-12 13:23:10');
INSERT INTO CHANSON VALUES(8241,'Tregont vlé Zo',3,NULL,NULL,'2008-06-02 13:55:35.019632');
INSERT INTO CHANSON VALUES(8242,'Au bord du lac Pontchartrain',3,NULL,NULL,'2008-03-12 14:51:32');
INSERT INTO CHANSON VALUES(8243,'Histoires maternelles',3,NULL,NULL,'2008-03-12 10:38:56');
INSERT INTO CHANSON VALUES(8244,'The entertainer',4,NULL,NULL,'2008-03-12 19:28:38');
INSERT INTO CHANSON VALUES(8245,'Mapple leaf rag',4,NULL,NULL,'2008-03-12 19:31:04');
INSERT INTO CHANSON VALUES(8246,'Saint Louis blues',4,NULL,NULL,'2008-03-12 19:32:10');
INSERT INTO CHANSON VALUES(8247,'Saint James infirmary',4,NULL,NULL,'2008-03-12 09:46:49');
INSERT INTO CHANSON VALUES(8248,'Yancey special',4,NULL,NULL,'2008-03-12 08:13:13');
INSERT INTO CHANSON VALUES(8249,'Honky tonk train blue',4,NULL,NULL,'2008-03-12 10:40:25');
INSERT INTO CHANSON VALUES(8250,'Summertime',4,NULL,NULL,'2008-03-12 17:30:27');
INSERT INTO CHANSON VALUES(8251,'On the sunny side of the street',4,NULL,NULL,'2008-03-12 09:52:17');
INSERT INTO CHANSON VALUES(8252,'Original rag',4,NULL,NULL,'2008-03-12 14:26:09');
INSERT INTO CHANSON VALUES(8253,'Something doing',4,NULL,NULL,'2008-03-12 08:36:47');
INSERT INTO CHANSON VALUES(8254,'Pinetop boogie',4,NULL,NULL,'2008-03-12 19:32:15');
INSERT INTO CHANSON VALUES(8255,'Fanny''s boogie',4,NULL,NULL,'2008-03-12 15:29:47');
INSERT INTO CHANSON VALUES(8256,'Lover man',4,NULL,NULL,'2008-03-12 16:25:20');
INSERT INTO CHANSON VALUES(8257,'Nobody knows',4,NULL,NULL,'2008-03-12 18:33:06');
INSERT INTO CHANSON VALUES(8258,'Over the rainbow',4,NULL,NULL,'2008-03-12 16:35:20');
INSERT INTO CHANSON VALUES(8259,'After you''ve gone',4,NULL,NULL,'2008-03-12 19:48:00');
INSERT INTO CHANSON VALUES(8260,'Blues in New Orleans',4,NULL,NULL,'2008-03-12 12:37:31');
INSERT INTO CHANSON VALUES(8261,'Elite syncopations',4,NULL,NULL,'2008-03-12 17:42:23');
INSERT INTO CHANSON VALUES(8262,'Sunflower slow rag',4,NULL,NULL,'2008-03-12 09:13:49');
INSERT INTO CHANSON VALUES(8263,'Nashville blue',4,NULL,NULL,'2008-03-12 11:15:26');
INSERT INTO CHANSON VALUES(8264,'Black and Tan Fantasy',4,NULL,'f','2008-03-12 08:14:58');
INSERT INTO CHANSON VALUES(8265,'Creole Love Call',4,NULL,'f','2008-03-12 11:51:28');
INSERT INTO CHANSON VALUES(8266,'East St. Louis Toodle-Oo',4,NULL,'f','2008-03-12 09:33:53');
INSERT INTO CHANSON VALUES(8267,'The Mooche',4,NULL,'f','2008-03-12 13:25:27');
INSERT INTO CHANSON VALUES(8268,'Saturday Night Function',4,NULL,'f','2008-03-12 14:07:02');
INSERT INTO CHANSON VALUES(8269,'Cotton Club Stomp',4,NULL,'f','2008-03-12 18:03:51');
INSERT INTO CHANSON VALUES(8270,'Saratoga Swing',4,NULL,'f','2008-03-12 19:24:28');
INSERT INTO CHANSON VALUES(8271,'Jungle Nights in Harlem',4,NULL,'f','2008-03-12 13:12:11');
INSERT INTO CHANSON VALUES(8272,'Mood Indigo',4,NULL,NULL,'2008-03-12 17:18:25');
INSERT INTO CHANSON VALUES(8273,'Rockin''in Rhythm',4,NULL,'f','2008-03-12 15:33:41');
INSERT INTO CHANSON VALUES(8274,'Echoes of the Jungle',4,NULL,'f','2008-03-12 09:36:55');
INSERT INTO CHANSON VALUES(8275,'Delta Serenade',4,NULL,'f','2008-03-12 08:55:47');
INSERT INTO CHANSON VALUES(8276,'Solitude',4,NULL,'f','2008-03-12 14:01:21');
INSERT INTO CHANSON VALUES(8277,'Merry Go-Round',4,NULL,'f','2008-03-12 13:28:46');
INSERT INTO CHANSON VALUES(8278,'In a Sentimental Mood',4,NULL,'f','2008-03-12 18:01:54');
INSERT INTO CHANSON VALUES(8279,'Country Gal',4,NULL,NULL,'2008-03-12 19:55:57');
INSERT INTO CHANSON VALUES(8280,'Harlem Speaks',4,NULL,'f','2008-03-12 17:50:21');
INSERT INTO CHANSON VALUES(8281,'Clarinet Lament',4,NULL,'f','2008-03-12 11:17:34');
INSERT INTO CHANSON VALUES(8282,'Echoes of Harlem',4,NULL,'f','2008-03-12 13:07:52');
INSERT INTO CHANSON VALUES(8283,'Caravan',4,NULL,'f','2008-03-12 18:46:25');
INSERT INTO CHANSON VALUES(8284,'Sophisticated Lady',4,NULL,'f','2008-03-12 14:52:01');
INSERT INTO CHANSON VALUES(8285,'Prelude To A Kiss',4,NULL,'f','2008-03-12 14:57:57');
INSERT INTO CHANSON VALUES(8286,'Diminuendo In Blue',4,NULL,NULL,'2008-03-12 11:30:58');
INSERT INTO CHANSON VALUES(8287,'Crescendo In Blue',4,NULL,NULL,'2008-03-12 15:57:26');
INSERT INTO CHANSON VALUES(8288,'Ko-Ko',4,NULL,'f','2008-03-12 13:51:28');
INSERT INTO CHANSON VALUES(8289,'Do Nothin'' Till You Hear From Me',4,NULL,'f','2008-03-12 12:48:24');
INSERT INTO CHANSON VALUES(8290,'Harlem Airshaft',4,NULL,'f','2008-03-12 11:35:15');
INSERT INTO CHANSON VALUES(8291,'All Too Soon',4,NULL,'f','2008-03-12 15:52:32');
INSERT INTO CHANSON VALUES(8292,'Sepia Panorama',4,NULL,'f','2008-03-12 10:20:40');
INSERT INTO CHANSON VALUES(8293,'Across The Track Blues',4,NULL,'f','2008-03-12 09:13:27');
INSERT INTO CHANSON VALUES(8294,'Chloe',4,NULL,'f','2008-03-12 14:47:19');
INSERT INTO CHANSON VALUES(8295,'Take The ''A'' Train',4,NULL,'f','2008-03-12 14:18:17');
INSERT INTO CHANSON VALUES(8296,'Just A-Settin'' And A-Rockin''',4,NULL,'f','2008-03-12 14:36:48');
INSERT INTO CHANSON VALUES(8297,'I Got It Bad And That Ain''t Good',4,NULL,'f','2008-03-12 13:15:46');
INSERT INTO CHANSON VALUES(8298,'Things Ain''t What They Used To Be',4,NULL,'f','2008-03-12 19:41:37');
INSERT INTO CHANSON VALUES(8299,'Perdido',4,NULL,'f','2008-03-12 13:01:25');
INSERT INTO CHANSON VALUES(8300,'The ''C'' Jam Blues',4,NULL,'f','2008-03-12 17:19:01');
INSERT INTO CHANSON VALUES(8301,'The Hawk Talks',4,NULL,'f','2008-03-12 09:59:53');
INSERT INTO CHANSON VALUES(8302,'Soul Call',4,NULL,'f','2008-03-12 15:13:13');
INSERT INTO CHANSON VALUES(8303,'Open House',4,NULL,NULL,'2008-03-12 11:19:27');
INSERT INTO CHANSON VALUES(8304,'Le cosmos, c''est chouette',5,NULL,'f','2008-03-12 17:51:14');
INSERT INTO CHANSON VALUES(8305,'Chérie',5,NULL,'f','2008-03-12 09:25:33');
INSERT INTO CHANSON VALUES(8306,'Marouchka',5,NULL,'f','2008-03-12 12:55:09');
INSERT INTO CHANSON VALUES(8307,'Un aveugle au volant',5,NULL,'f','2008-03-12 10:25:24');
INSERT INTO CHANSON VALUES(8308,'Con comme la lune',5,NULL,'f','2008-03-12 19:21:05');
INSERT INTO CHANSON VALUES(8309,'C''est extra',5,NULL,'f','2008-03-12 15:46:07');
INSERT INTO CHANSON VALUES(8310,'Georgia',5,NULL,'f','2008-03-12 08:36:27');
INSERT INTO CHANSON VALUES(8311,'Eléonore et Léonard',5,NULL,'f','2008-03-12 08:41:27');
INSERT INTO CHANSON VALUES(8312,'Sans amour',5,NULL,'f','2008-03-12 19:19:40');
INSERT INTO CHANSON VALUES(8313,'Cool jazz',5,NULL,'f','2008-03-12 09:38:00');
INSERT INTO CHANSON VALUES(8314,'I can''t give you anything but love',4,NULL,'f','2008-03-12 15:23:51');
INSERT INTO CHANSON VALUES(8315,'Mahogany hall stomp',4,NULL,'f','2008-03-12 18:29:17');
INSERT INTO CHANSON VALUES(8316,'Ain''t misbehavin''',4,NULL,NULL,'2008-03-12 12:52:12');
INSERT INTO CHANSON VALUES(8317,'When you''re smiling',4,NULL,'f','2008-03-12 14:03:38');
INSERT INTO CHANSON VALUES(8318,'St. Louis blues',4,NULL,'f','2008-03-12 19:01:59');
INSERT INTO CHANSON VALUES(8319,'I''m a ding dong daddy',4,NULL,NULL,'2008-03-12 08:36:46');
INSERT INTO CHANSON VALUES(8320,'Sweethearts on parade',4,NULL,NULL,'2008-03-12 10:37:23');
INSERT INTO CHANSON VALUES(8321,'Shine',4,NULL,'f','2008-03-12 15:39:04');
INSERT INTO CHANSON VALUES(8322,'Chinatown, my Chinatown',4,NULL,'f','2008-03-12 09:35:24');
INSERT INTO CHANSON VALUES(8323,'Star dust',4,NULL,'f','2008-03-12 17:44:02');
INSERT INTO CHANSON VALUES(8324,'Betweeen the devil and the deep blue sea',4,NULL,'f','2008-03-12 17:21:26');
INSERT INTO CHANSON VALUES(8325,'Lawd, you made the night too long',4,NULL,'f','2008-03-12 16:13:55');
INSERT INTO CHANSON VALUES(8326,'Mahogany hall stomp',4,NULL,'f','2008-03-12 19:38:47');
INSERT INTO CHANSON VALUES(8327,'I''ve got my fingers crossed',4,NULL,'f','2008-03-12 10:12:51');
INSERT INTO CHANSON VALUES(8328,'Thanks a million',4,NULL,'f','2008-03-12 17:10:52');
INSERT INTO CHANSON VALUES(8329,'Swing that music',4,NULL,NULL,'2008-03-12 17:14:29');
INSERT INTO CHANSON VALUES(8330,'Struttin'' with some barbecue',4,NULL,'f','2008-03-12 15:26:06');
INSERT INTO CHANSON VALUES(8331,'I can''t give you anything but love',4,NULL,'f','2008-03-12 19:06:45');
INSERT INTO CHANSON VALUES(8332,'Ciaconna',4,NULL,'f','2008-03-12 08:13:21');
INSERT INTO CHANSON VALUES(8333,'La Muntagnella',4,NULL,'f','2008-03-12 13:02:06');
INSERT INTO CHANSON VALUES(8334,'Serpent D''Or',4,NULL,'f','2008-03-12 14:51:27');
INSERT INTO CHANSON VALUES(8335,'C''era Una Strega, C''era Una Fata',4,NULL,'f','2008-03-12 19:31:41');
INSERT INTO CHANSON VALUES(8336,'Canto Della Sibilia',4,NULL,'f','2008-03-12 18:29:19');
INSERT INTO CHANSON VALUES(8337,'Huit',4,NULL,'f','2008-03-12 16:40:31');
INSERT INTO CHANSON VALUES(8338,'Preghiera',4,NULL,'f','2008-03-12 14:28:42');
INSERT INTO CHANSON VALUES(8339,'Un',4,NULL,'f','2008-03-12 13:17:56');
INSERT INTO CHANSON VALUES(8340,'Ah! Vita Bella',4,NULL,'f','2008-03-12 18:52:23');
INSERT INTO CHANSON VALUES(8341,'Crisbell',4,NULL,'f','2008-03-12 08:51:30');
INSERT INTO CHANSON VALUES(8342,'Le Vent Respire',4,NULL,'f','2008-03-12 17:54:44');
INSERT INTO CHANSON VALUES(8343,'Magnificat',4,NULL,'f','2008-03-12 09:21:46');
INSERT INTO CHANSON VALUES(8344,'Una Serenata',4,NULL,'f','2008-03-12 10:52:37');
INSERT INTO CHANSON VALUES(8345,'Cathedrale Sans Nom',4,NULL,'f','2008-03-12 16:49:09');
INSERT INTO CHANSON VALUES(8346,'Murmures',4,NULL,'f','2008-03-12 12:42:38');
INSERT INTO CHANSON VALUES(8347,'Voi Che Amate',4,NULL,'f','2008-03-12 16:23:18');
INSERT INTO CHANSON VALUES(8348,'The St. Louis blues',4,NULL,'f','2008-03-12 10:55:47');
INSERT INTO CHANSON VALUES(8349,'Heebies jeebies',4,NULL,'f','2008-03-12 19:20:05');
INSERT INTO CHANSON VALUES(8350,'Cornet shop suey',4,NULL,'f','2008-03-12 18:14:58');
INSERT INTO CHANSON VALUES(8351,'Willie th weeper',4,NULL,NULL,'2008-03-12 11:15:49');
INSERT INTO CHANSON VALUES(8352,'Potato head blues',4,NULL,NULL,'2008-03-12 17:01:43');
INSERT INTO CHANSON VALUES(8354,'Hotter than than',4,NULL,NULL,'2008-03-12 11:21:57');
INSERT INTO CHANSON VALUES(8355,'Savoy blues',4,NULL,'f','2008-03-12 18:03:47');
INSERT INTO CHANSON VALUES(8356,'West end blues',4,NULL,'f','2008-03-12 08:26:29');
INSERT INTO CHANSON VALUES(8357,'Basin street blues',4,NULL,'f','2008-03-12 16:08:52');
INSERT INTO CHANSON VALUES(8358,'Weather bird',4,NULL,'f','2008-03-12 08:22:48');
INSERT INTO CHANSON VALUES(8359,'Muggles',4,NULL,'f','2008-03-12 17:19:09');
INSERT INTO CHANSON VALUES(8360,'St james infirmary',4,NULL,'f','2008-03-12 18:12:23');
INSERT INTO CHANSON VALUES(8361,'Tight like this',4,NULL,NULL,'2008-03-12 18:29:38');
INSERT INTO CHANSON VALUES(8362,'Knockin'' a jug',4,NULL,'f','2008-03-12 16:16:40');
INSERT INTO CHANSON VALUES(8363,'Darling Nelly Gray',4,NULL,'f','2008-03-12 12:47:48');
INSERT INTO CHANSON VALUES(8364,'Nobody knows the trouble I''ve seen',4,NULL,'f','2008-03-12 14:04:10');
INSERT INTO CHANSON VALUES(8365,'Perdido street blues',4,NULL,'f','2008-03-12 13:59:13');
INSERT INTO CHANSON VALUES(8366,'Every Breath You Take',2,NULL,'f','2008-03-12 10:02:39');
INSERT INTO CHANSON VALUES(8367,'Every Little Thing She Does Is Magic',2,NULL,'f','2008-03-12 16:45:48');
INSERT INTO CHANSON VALUES(8368,'Au printemps',5,NULL,'f','2008-03-12 15:45:11');
INSERT INTO CHANSON VALUES(8369,'Je ne sais pas',5,NULL,'f','2008-03-12 13:34:30');
INSERT INTO CHANSON VALUES(8370,'Dors ma mie, bonsoir',5,NULL,'f','2008-03-12 15:28:43');
INSERT INTO CHANSON VALUES(8371,'Dites si c''était vrai (poème)',5,NULL,'f','2008-03-12 19:20:12');
INSERT INTO CHANSON VALUES(8372,'Le colonel',5,NULL,'f','2008-03-12 15:01:29');
INSERT INTO CHANSON VALUES(8373,'L''homme dans la cité',5,NULL,'f','2008-03-12 11:26:17');
INSERT INTO CHANSON VALUES(8374,'La lumière jaillira',5,NULL,'f','2008-03-12 09:56:22');
INSERT INTO CHANSON VALUES(8375,'Voici',5,NULL,'f','2008-03-12 11:24:21');
INSERT INTO CHANSON VALUES(8376,'Litanies pour un retour',5,NULL,'f','2008-03-12 14:39:24');
INSERT INTO CHANSON VALUES(8377,'Seul',5,NULL,'f','2008-03-12 10:23:09');
INSERT INTO CHANSON VALUES(8378,'La dame patronesse',5,NULL,'f','2008-03-12 19:01:55');
INSERT INTO CHANSON VALUES(8379,'La mort',5,NULL,NULL,'2008-03-12 10:27:29');
INSERT INTO CHANSON VALUES(8380,'La valse à mille temps',5,NULL,'f','2008-03-12 16:02:58');
INSERT INTO CHANSON VALUES(8381,'Je t''aime',5,NULL,'f','2008-03-12 12:01:18');
INSERT INTO CHANSON VALUES(8382,'Ne me quitte pas',5,NULL,'f','2008-03-12 15:39:20');
INSERT INTO CHANSON VALUES(8384,'La tendresse',5,NULL,NULL,'2008-03-12 12:04:43');
INSERT INTO CHANSON VALUES(8385,'La colombe',5,NULL,'f','2008-03-12 17:21:07');
INSERT INTO CHANSON VALUES(8386,'San Francisco',5,NULL,'f','2008-03-12 09:53:46');
INSERT INTO CHANSON VALUES(8387,'Education sentimentale',5,NULL,'f','2008-03-12 14:04:10');
INSERT INTO CHANSON VALUES(8388,'Comme un arbre',5,NULL,'f','2008-03-12 16:04:11');
INSERT INTO CHANSON VALUES(8389,'Fontenay-aux-roses',5,NULL,'f','2008-03-12 15:15:38');
INSERT INTO CHANSON VALUES(8390,'Marie, Pierre et Charlemagne',5,NULL,'f','2008-03-12 09:56:41');
INSERT INTO CHANSON VALUES(8391,'Parachutiste',5,NULL,'f','2008-03-12 09:21:42');
INSERT INTO CHANSON VALUES(8392,'Dialogue',5,NULL,'f','2008-03-12 13:59:21');
INSERT INTO CHANSON VALUES(8393,'Saltimbanque',5,NULL,'f','2008-03-12 17:07:18');
INSERT INTO CHANSON VALUES(8394,'Je veux quitter ce monde, heureux',5,NULL,'f','2008-03-12 14:31:22');
INSERT INTO CHANSON VALUES(8395,'Approximative',5,NULL,'f','2008-03-12 11:19:44');
INSERT INTO CHANSON VALUES(8396,'La salle des pas perdus',5,NULL,'f','2008-03-12 12:28:37');
INSERT INTO CHANSON VALUES(8397,'Les jours meilleurs',5,NULL,'f','2008-03-12 10:01:42');
INSERT INTO CHANSON VALUES(8398,'Né quelque part',5,NULL,'f','2008-03-12 12:45:46');
INSERT INTO CHANSON VALUES(8399,'Ambalaba',5,NULL,'f','2008-03-12 14:24:01');
INSERT INTO CHANSON VALUES(8400,'Bille de verre',5,NULL,NULL,'2008-03-12 10:32:58');
INSERT INTO CHANSON VALUES(8401,'Passer ma route',5,NULL,NULL,'2008-03-12 18:40:20');
INSERT INTO CHANSON VALUES(8402,'Chienne d''idée',5,NULL,'f','2008-03-12 15:06:19');
INSERT INTO CHANSON VALUES(8403,'Marin du cap',5,NULL,'f','2008-03-12 19:52:27');
INSERT INTO CHANSON VALUES(8404,'Raymonde',5,NULL,'f','2008-03-12 11:25:59');
INSERT INTO CHANSON VALUES(8405,'Mon Frère',5,NULL,'f','2008-03-12 15:42:18');
INSERT INTO CHANSON VALUES(8406,'Chanter c''est lancer des balles',5,NULL,'f','2008-03-12 12:06:46');
INSERT INTO CHANSON VALUES(8407,'Manivelle',5,NULL,'f','2008-03-12 08:17:48');
INSERT INTO CHANSON VALUES(8408,'Frenchy bébé blues',5,NULL,'f','2008-03-12 16:38:33');
INSERT INTO CHANSON VALUES(8409,'Les regrets',5,NULL,'f','2008-03-12 13:11:57');
INSERT INTO CHANSON VALUES(8410,'Les bergères',5,NULL,'f','2008-03-12 14:23:30');
INSERT INTO CHANSON VALUES(8411,'Ultra moderne solitude',5,NULL,'f','2008-03-12 14:16:10');
INSERT INTO CHANSON VALUES(8412,'Les cadors',5,NULL,NULL,'2008-03-12 18:51:16');
INSERT INTO CHANSON VALUES(8413,'Courrier',5,NULL,NULL,'2008-03-12 10:48:08');
INSERT INTO CHANSON VALUES(8414,'Rame',5,NULL,'f','2008-03-12 15:03:34');
INSERT INTO CHANSON VALUES(8415,'Arlette',5,NULL,'f','2008-03-12 15:42:16');
INSERT INTO CHANSON VALUES(8416,'Lettre aux dames',5,NULL,'f','2008-03-12 19:05:22');
INSERT INTO CHANSON VALUES(8417,'Les écureuils',5,NULL,'f','2008-03-12 16:05:39');
INSERT INTO CHANSON VALUES(8418,'Somerset Maugham',5,NULL,'f','2008-03-12 13:49:18');
INSERT INTO CHANSON VALUES(8420,'On s''aime pas',5,NULL,'f','2008-03-12 08:50:53');
INSERT INTO CHANSON VALUES(8421,'Le fils pape',5,NULL,'f','2008-03-12 14:21:10');
INSERT INTO CHANSON VALUES(8422,'Le fil',5,NULL,'f','2008-03-12 16:12:02');
INSERT INTO CHANSON VALUES(8423,'L''opportuniste',5,NULL,'f','2008-03-23 19:23:50');
INSERT INTO CHANSON VALUES(8424,'J''aime les filles',5,NULL,'f','2008-03-23 09:01:54');
INSERT INTO CHANSON VALUES(8426,'Qui se soucie de nous',5,NULL,'f','2008-03-12 15:38:36');
INSERT INTO CHANSON VALUES(8427,'Les roses fanées',5,NULL,'f','2008-03-12 19:33:42');
INSERT INTO CHANSON VALUES(8429,'J''comprends pas',5,NULL,'f','2008-03-12 11:15:48');
INSERT INTO CHANSON VALUES(8430,'L''hymne a l''amour (moi l''noeud)',5,NULL,'f','2008-03-12 19:44:37');
INSERT INTO CHANSON VALUES(8431,'Opium',5,NULL,'f','2008-03-12 11:47:56');
INSERT INTO CHANSON VALUES(8432,'Corsica',5,NULL,'f','2008-03-12 17:47:46');
INSERT INTO CHANSON VALUES(8433,'A la vie, A l''amour',5,NULL,'f','2008-03-12 15:17:08');
INSERT INTO CHANSON VALUES(8434,'J''ai déjà donné',5,NULL,'f','2008-03-12 18:58:20');
INSERT INTO CHANSON VALUES(8436,'L''âme sœur',5,NULL,'f','2008-03-24 16:00:44');
INSERT INTO CHANSON VALUES(8437,'Berceuse',5,NULL,'f','2008-03-12 15:39:22');
INSERT INTO CHANSON VALUES(8438,'Il est cinq heures, Paris s''eveille',5,NULL,NULL,'2008-03-23 10:35:55');
INSERT INTO CHANSON VALUES(8439,'La compapade',5,NULL,'f','2008-03-12 19:53:10');
INSERT INTO CHANSON VALUES(8440,'Merde in France (Cacapoum)',5,NULL,'f','2008-03-12 17:51:55');
INSERT INTO CHANSON VALUES(8442,'J''suis jamais allé',5,NULL,NULL,'2008-03-12 11:54:30');
INSERT INTO CHANSON VALUES(8443,'Rue des cascades',5,NULL,NULL,'2008-03-12 09:34:48');
INSERT INTO CHANSON VALUES(8444,'Pas si simple',5,NULL,'f','2008-03-12 10:24:47');
INSERT INTO CHANSON VALUES(8445,'Comptine d''été n-2',5,NULL,'f','2008-03-12 14:16:42');
INSERT INTO CHANSON VALUES(8446,'Comptine d''été n-3',5,NULL,'f','2008-03-12 11:59:42');
INSERT INTO CHANSON VALUES(8447,'déjà loin',5,NULL,'f','2008-03-12 08:37:22');
INSERT INTO CHANSON VALUES(8448,'la chambre',5,NULL,'f','2008-03-12 12:52:58');
INSERT INTO CHANSON VALUES(8449,'Mouvement introductif',5,NULL,'f','2008-03-12 11:49:52');
INSERT INTO CHANSON VALUES(8450,'La muette',5,NULL,'f','2008-03-12 14:34:43');
INSERT INTO CHANSON VALUES(8451,'Naomi',5,NULL,'f','2008-03-12 13:56:51');
INSERT INTO CHANSON VALUES(8452,'Soir de fête',5,NULL,'f','2008-03-12 09:15:45');
INSERT INTO CHANSON VALUES(8453,'Le vieux en veut encore',5,NULL,'f','2008-03-12 16:20:19');
INSERT INTO CHANSON VALUES(8454,'Toujours là',5,NULL,'f','2008-03-12 13:33:44');
INSERT INTO CHANSON VALUES(8455,'C''étaitici',5,NULL,'f','2008-03-12 11:07:00');
INSERT INTO CHANSON VALUES(8456,'Prière n-2',5,NULL,'f','2008-03-12 19:24:00');
INSERT INTO CHANSON VALUES(8457,'Comptine d''été n-1',5,NULL,'f','2008-03-12 16:25:38');
INSERT INTO CHANSON VALUES(8458,'La fenêtre',5,NULL,'f','2008-03-12 08:49:30');
INSERT INTO CHANSON VALUES(8459,'Prière n-3',5,NULL,'f','2008-03-12 08:09:20');
INSERT INTO CHANSON VALUES(8460,'La pièce vide',5,NULL,'f','2008-03-12 18:40:54');
INSERT INTO CHANSON VALUES(8461,'La vie quotidienne',5,NULL,'f','2008-03-12 15:06:51');
INSERT INTO CHANSON VALUES(8462,'Sacré Géranium',5,NULL,'f','2008-03-12 14:16:06');
INSERT INTO CHANSON VALUES(8463,'La Transformation',5,NULL,'f','2008-03-12 11:56:27');
INSERT INTO CHANSON VALUES(8464,'Hé Hé Hé',5,NULL,'f','2008-03-12 15:26:00');
INSERT INTO CHANSON VALUES(8465,'Paladin Braconnier',5,NULL,'f','2008-03-12 11:42:07');
INSERT INTO CHANSON VALUES(8466,'Volet Fermé',5,NULL,'f','2008-03-12 12:41:32');
INSERT INTO CHANSON VALUES(8467,'Ubu',5,NULL,NULL,'2008-03-12 12:22:58');
INSERT INTO CHANSON VALUES(8468,'Le Roi Du Métro',5,NULL,'f','2008-03-12 19:26:47');
INSERT INTO CHANSON VALUES(8469,'Bruxelles',5,NULL,'f','2008-03-12 13:29:57');
INSERT INTO CHANSON VALUES(8470,'Coutances',5,NULL,'f','2008-03-12 18:23:37');
INSERT INTO CHANSON VALUES(8471,'Mireille',5,NULL,'f','2008-03-12 17:02:43');
INSERT INTO CHANSON VALUES(8472,'Nicotine Queen',5,NULL,'f','2008-03-12 15:32:59');
INSERT INTO CHANSON VALUES(8473,'Golda',5,NULL,'f','2008-03-12 16:48:56');
INSERT INTO CHANSON VALUES(8474,'L''Orage',5,NULL,NULL,'2008-03-12 10:23:22');
INSERT INTO CHANSON VALUES(8475,'Les Enfants',5,NULL,NULL,'2008-03-12 10:43:05');
INSERT INTO CHANSON VALUES(8476,'Bébé Éléphant',5,NULL,'f','2008-03-12 11:03:46');
INSERT INTO CHANSON VALUES(8477,'L''Institutrice',5,NULL,'f','2008-03-12 18:24:09');
INSERT INTO CHANSON VALUES(8478,'La Mer',5,NULL,'f','2008-03-12 17:23:36');
INSERT INTO CHANSON VALUES(8479,'De Bémols Et De Dièses',5,NULL,'f','2008-03-12 15:53:06');
INSERT INTO CHANSON VALUES(8480,'Chanson du forcat',5,NULL,'f','2008-03-12 14:43:30');
INSERT INTO CHANSON VALUES(8481,'Chanson du forcat II',5,NULL,NULL,'2008-03-12 10:29:32');
INSERT INTO CHANSON VALUES(8483,'Requiem pour un c...',5,NULL,'f','2008-03-12 19:49:52');
INSERT INTO CHANSON VALUES(8484,'L''herbe tendre',5,NULL,'f','2008-03-12 18:00:16');
INSERT INTO CHANSON VALUES(8485,'Initials B.B.',5,NULL,'f','2008-03-12 11:11:59');
INSERT INTO CHANSON VALUES(8486,'Comic strip',5,NULL,'f','2008-03-12 12:30:03');
INSERT INTO CHANSON VALUES(8487,'Bloody Jack',5,NULL,'f','2008-03-12 09:22:28');
INSERT INTO CHANSON VALUES(8488,'Docteur Jekyll et monsieur Hyde',5,NULL,'f','2008-03-12 11:11:52');
INSERT INTO CHANSON VALUES(8489,'Torrey canyon',5,NULL,'f','2008-03-12 18:48:46');
INSERT INTO CHANSON VALUES(8490,'Shu ba du ba loo la',5,NULL,'f','2008-03-12 08:23:30');
INSERT INTO CHANSON VALUES(8493,'Black & white',5,NULL,'f','2008-03-12 09:25:54');
INSERT INTO CHANSON VALUES(8494,'Qui est ''In'' qui est ''Out''',5,NULL,'f','2008-03-12 19:18:55');
INSERT INTO CHANSON VALUES(8495,'Hold up',5,NULL,'f','2008-03-12 11:33:06');
INSERT INTO CHANSON VALUES(8496,'Marilu',5,NULL,NULL,'2008-03-12 11:53:37');
INSERT INTO CHANSON VALUES(8497,'Bonnie and Clyde (version anglaise)',5,NULL,'f','2008-03-12 12:01:59');
INSERT INTO CHANSON VALUES(8498,'Comic strip (version anglaise)',5,NULL,'f','2008-03-12 17:18:11');
INSERT INTO CHANSON VALUES(8499,'Chatterton',5,NULL,'f','2008-03-12 16:12:00');
INSERT INTO CHANSON VALUES(8500,'Je t''aime... Moi non plus',5,NULL,'f','2008-03-12 13:13:23');
INSERT INTO CHANSON VALUES(8501,'Saucisson de cheval no 1',5,NULL,'f','2008-03-12 19:43:58');
INSERT INTO CHANSON VALUES(8502,'Saucisson de cheval no 2',5,NULL,'f','2008-03-12 19:46:28');
INSERT INTO CHANSON VALUES(8503,'L''ami Zantrop',5,NULL,'f','2008-03-12 08:53:54');
INSERT INTO CHANSON VALUES(8504,'La banane anana',5,NULL,'f','2008-03-12 19:53:12');
INSERT INTO CHANSON VALUES(8505,'L''été où est-il',5,NULL,'f','2008-03-12 18:09:45');
INSERT INTO CHANSON VALUES(8506,'La question ne se pose pas',5,NULL,'f','2008-03-12 19:26:39');
INSERT INTO CHANSON VALUES(8507,'Andréa c''est toi',5,NULL,'f','2008-03-12 15:46:40');
INSERT INTO CHANSON VALUES(8508,'L''idole et l''enfant',5,NULL,'f','2008-03-12 15:35:59');
INSERT INTO CHANSON VALUES(8509,'Comprend qui peut',5,NULL,'f','2008-03-12 17:16:12');
INSERT INTO CHANSON VALUES(8510,'Monsieur l''agent',5,NULL,NULL,'2008-03-12 17:44:25');
INSERT INTO CHANSON VALUES(8511,'Méli-mélodie',5,NULL,NULL,'2008-03-12 10:42:09');
INSERT INTO CHANSON VALUES(8512,'Diba diba',5,NULL,'f','2008-03-12 10:39:55');
INSERT INTO CHANSON VALUES(8513,'Le tube de toilette',5,NULL,'f','2008-03-12 15:41:49');
INSERT INTO CHANSON VALUES(8514,'Madam''Mado m''a dit',5,NULL,'f','2008-03-12 14:39:42');
INSERT INTO CHANSON VALUES(8515,'Moi, le philosophe et l''esthète',5,NULL,'f','2008-03-12 17:31:52');
INSERT INTO CHANSON VALUES(8516,'La maman des poissons',5,NULL,'f','2008-03-23 14:30:19');
INSERT INTO CHANSON VALUES(8517,'Revanche',5,NULL,'f','2008-03-12 10:07:05');
INSERT INTO CHANSON VALUES(8518,'Sentimental bourreau',5,NULL,'f','2008-03-24 12:36:10');
INSERT INTO CHANSON VALUES(8519,'Ça va ça vient',5,NULL,'f','2008-03-12 18:44:40');
INSERT INTO CHANSON VALUES(8520,'In the desert',5,NULL,NULL,'2008-03-12 18:32:57');
INSERT INTO CHANSON VALUES(8521,'Mon père et ses verres',5,NULL,'f','2008-03-12 08:21:41');
INSERT INTO CHANSON VALUES(8522,'Je suis né au Chili',5,NULL,'f','2008-03-12 13:33:23');
INSERT INTO CHANSON VALUES(8523,'Une jolie fleur (dans une peau d''vache)',5,NULL,'f','2008-04-13 17:47:20');
INSERT INTO CHANSON VALUES(8524,'Gastibelza (L''homme à la carabine)',5,NULL,'f','2008-03-24 15:44:03');
INSERT INTO CHANSON VALUES(8525,'La prière',5,NULL,'f','2008-03-26 14:24:44');
INSERT INTO CHANSON VALUES(8526,'Hécatombe',5,NULL,'f','2008-03-24 12:58:23');
INSERT INTO CHANSON VALUES(8528,'Corne d''Aurochs',5,NULL,'f','2008-03-24 19:18:26');
INSERT INTO CHANSON VALUES(8529,'Marinette',5,NULL,'f','2008-03-24 11:31:34');
INSERT INTO CHANSON VALUES(8530,'La légende de la nonne',5,NULL,'f','2008-04-13 08:14:41');
INSERT INTO CHANSON VALUES(8531,'Colombine',5,NULL,'f','2008-03-12 12:24:19');
INSERT INTO CHANSON VALUES(8532,'Auprès de mon arbre',5,NULL,'f','2008-03-12 08:16:52');
INSERT INTO CHANSON VALUES(8533,'Le testament',5,NULL,'f','2008-03-26 08:20:13');
INSERT INTO CHANSON VALUES(8534,'Je me suis fait tout petit',5,NULL,'f','2008-03-24 16:50:47');
INSERT INTO CHANSON VALUES(8535,'Les croquants',5,NULL,'f','2008-04-13 11:40:06');
INSERT INTO CHANSON VALUES(8536,'L''amandier',5,NULL,'f','2008-03-24 12:00:26');
INSERT INTO CHANSON VALUES(8537,'Oncle Archibald',5,NULL,'f','2008-03-24 09:28:31');
INSERT INTO CHANSON VALUES(8538,'La marche nuptiale',5,NULL,'f','2008-03-24 15:33:38');
INSERT INTO CHANSON VALUES(8540,'Au bois de mon cur',5,NULL,'f','2008-03-24 16:05:27');
INSERT INTO CHANSON VALUES(8541,'Grand-père',5,NULL,'f','2008-04-13 13:32:46');
INSERT INTO CHANSON VALUES(8542,'Celui qui a mal tourné',5,NULL,'f','2008-03-24 10:03:55');
INSERT INTO CHANSON VALUES(8543,'La Decadanse',5,NULL,'f','2008-03-12 19:26:54');
INSERT INTO CHANSON VALUES(8544,'Sex Shop',5,NULL,'f','2008-03-12 11:32:39');
INSERT INTO CHANSON VALUES(8545,'Je Suis Venu Te Dire Que Je M''en Vais',5,NULL,'f','2008-03-12 10:32:58');
INSERT INTO CHANSON VALUES(8546,'Vu De L''exterieur',5,NULL,'f','2008-03-12 16:50:29');
INSERT INTO CHANSON VALUES(8547,'Panpan Culcul',5,NULL,'f','2008-03-12 11:14:53');
INSERT INTO CHANSON VALUES(8548,'Par Hasard Et Pas Rase',5,NULL,'f','2008-03-12 14:18:10');
INSERT INTO CHANSON VALUES(8549,'Des Vents Des Pets Des Poums',5,NULL,NULL,'2008-03-12 13:20:30');
INSERT INTO CHANSON VALUES(8550,'Titicaca',5,NULL,'f','2008-03-12 16:04:21');
INSERT INTO CHANSON VALUES(8551,'Pamela Popo',5,NULL,NULL,'2008-03-12 13:11:50');
INSERT INTO CHANSON VALUES(8552,'La Poupee Qui Fait',5,NULL,'f','2008-03-12 19:21:53');
INSERT INTO CHANSON VALUES(8553,'L''hippodame',5,NULL,'f','2008-03-12 18:17:19');
INSERT INTO CHANSON VALUES(8554,'Sensuelle Et Sans Suite',5,NULL,'f','2008-03-12 17:36:52');
INSERT INTO CHANSON VALUES(8555,'Nazi Rock',5,NULL,'f','2008-03-12 13:50:24');
INSERT INTO CHANSON VALUES(8556,'Tata Teutonne',5,NULL,'f','2008-03-12 13:31:15');
INSERT INTO CHANSON VALUES(8557,'J''entends Des Voix Off',5,NULL,NULL,'2008-03-12 19:47:29');
INSERT INTO CHANSON VALUES(8558,'Eva',5,NULL,NULL,'2008-03-12 18:21:48');
INSERT INTO CHANSON VALUES(8559,'Smoke Gets In Your Eyes',5,NULL,'f','2008-03-12 08:48:09');
INSERT INTO CHANSON VALUES(8560,'Zig Zag Avec Toi',5,NULL,'f','2008-03-12 14:28:13');
INSERT INTO CHANSON VALUES(8561,'Est-ce Est-ce Si Bon?',5,NULL,'f','2008-03-12 18:55:25');
INSERT INTO CHANSON VALUES(8562,'Yellow Star',5,NULL,'f','2008-03-12 16:54:47');
INSERT INTO CHANSON VALUES(8563,'Rock Around The Bunker',5,NULL,'f','2008-03-12 15:49:04');
INSERT INTO CHANSON VALUES(8564,'S.S. In Uruguay',5,NULL,'f','2008-03-12 19:37:40');
INSERT INTO CHANSON VALUES(8565,'Clair de Lune a Pampelune',5,NULL,'f','2008-03-12 17:06:31');
INSERT INTO CHANSON VALUES(8566,'Chanson de Charme pour Faux-Nez',5,NULL,'f','2008-03-12 10:32:02');
INSERT INTO CHANSON VALUES(8567,'The Lolobrigidada Foxtrot',5,NULL,'f','2008-03-12 13:29:49');
INSERT INTO CHANSON VALUES(8568,'Toti al Soler',5,NULL,'f','2008-03-12 19:19:11');
INSERT INTO CHANSON VALUES(8569,'Le Dompteur de Mouches de Figueres',5,NULL,'f','2008-03-12 17:20:59');
INSERT INTO CHANSON VALUES(8570,'Il  Ventilator della F.A.I.',5,NULL,'f','2008-03-12 19:52:28');
INSERT INTO CHANSON VALUES(8571,'Danseur de Tango Descandant un Escalier',5,NULL,'f','2008-03-12 10:44:23');
INSERT INTO CHANSON VALUES(8572,'L''Irradiador del Port',5,NULL,'f','2008-03-12 15:27:18');
INSERT INTO CHANSON VALUES(8573,'Dali''s Mustache With Gitano''s Chaussure',5,NULL,'f','2008-03-12 12:03:07');
INSERT INTO CHANSON VALUES(8574,'Your Eyes Like Juan Gris Cubist Guitars',5,NULL,'f','2008-03-12 13:59:45');
INSERT INTO CHANSON VALUES(8575,'Le Fakir de la Chapelle',5,NULL,NULL,'2008-03-12 09:47:51');
INSERT INTO CHANSON VALUES(8576,'Un la Minimal Nu',5,NULL,'f','2008-03-12 15:00:23');
INSERT INTO CHANSON VALUES(8577,'L''Espinosa etica de la Santa Espina',5,NULL,'f','2008-03-12 16:28:53');
INSERT INTO CHANSON VALUES(8578,'Chanson Triste pour Ventrilique Aphone',5,NULL,'f','2008-03-12 14:27:13');
INSERT INTO CHANSON VALUES(8579,'On se L''Hegel en Enfer',5,NULL,'f','2008-03-12 16:14:33');
INSERT INTO CHANSON VALUES(8580,'Tokyo Bay Blues',5,NULL,'f','2008-03-12 16:11:25');
INSERT INTO CHANSON VALUES(8581,'Historia d''un Amor',5,NULL,'f','2008-03-12 10:21:10');
INSERT INTO CHANSON VALUES(8582,'Moritat von Mackie Messer',5,NULL,'f','2008-03-12 14:57:38');
INSERT INTO CHANSON VALUES(8583,'A Tombouctou Sans Mariachis',5,NULL,'f','2008-03-12 18:19:42');
INSERT INTO CHANSON VALUES(8584,'Lente Melodie Plaintive Empreinte d''un Grand Charme Nostalgique',5,NULL,'f','2008-03-12 08:46:41');
INSERT INTO CHANSON VALUES(8585,'Clair de Lune a Pampelune',5,NULL,'f','2008-03-12 17:53:28');
INSERT INTO CHANSON VALUES(8586,'Tango del Rossello',5,NULL,'f','2008-03-12 15:31:29');
INSERT INTO CHANSON VALUES(8588,'Egyptian Reggae',5,NULL,'f','2008-03-12 18:43:25');
INSERT INTO CHANSON VALUES(8589,'Let my Try',5,NULL,NULL,'2008-03-12 09:26:39');
INSERT INTO CHANSON VALUES(8590,'Alibib',5,NULL,NULL,'2008-03-12 16:08:50');
INSERT INTO CHANSON VALUES(8591,'Rue des Surs Noires',5,NULL,'f','2008-03-24 09:19:12');
INSERT INTO CHANSON VALUES(8592,'Your Labios as Tulips',5,NULL,'f','2008-03-12 11:54:09');
INSERT INTO CHANSON VALUES(8593,'Put a Straw under Baby',5,NULL,'f','2008-03-12 18:47:29');
INSERT INTO CHANSON VALUES(8594,'C''era una Volta il West',5,NULL,'f','2008-03-12 15:48:15');
INSERT INTO CHANSON VALUES(8595,'Love Theme from Ben-Hur',5,NULL,'f','2008-03-12 11:33:09');
INSERT INTO CHANSON VALUES(8596,'Mexican Theme from Rio Bravo',5,NULL,'f','2008-03-12 17:10:40');
INSERT INTO CHANSON VALUES(8597,'Nocturn, a Joan Salvat-Papasseit',5,NULL,'f','2008-03-12 11:11:53');
INSERT INTO CHANSON VALUES(8598,'Souvenir de Vernet-les-Bains',5,NULL,'f','2008-03-12 10:05:36');
INSERT INTO CHANSON VALUES(8599,'The Sad Skinhead',5,NULL,'f','2008-03-12 16:12:03');
INSERT INTO CHANSON VALUES(8600,'Goood-Bye Pork-Pie Hat',5,NULL,'f','2008-03-12 12:52:11');
INSERT INTO CHANSON VALUES(8601,'GreenLands',5,NULL,'f','2008-03-12 10:58:31');
INSERT INTO CHANSON VALUES(8602,'Abril 74',5,NULL,'f','2008-03-12 12:15:25');
INSERT INTO CHANSON VALUES(8603,'Valse de L''Aiguille Creuse',5,NULL,'f','2008-03-12 14:10:13');
INSERT INTO CHANSON VALUES(8604,'4 Roses Pour Marie',5,NULL,'f','2008-03-12 08:47:01');
INSERT INTO CHANSON VALUES(8605,'Marcha Mora',5,NULL,'f','2008-03-12 11:05:35');
INSERT INTO CHANSON VALUES(8606,'Amarcord',5,NULL,'f','2008-03-12 13:52:45');
INSERT INTO CHANSON VALUES(8607,'I Surrender',5,NULL,'f','2008-03-12 09:09:57');
INSERT INTO CHANSON VALUES(8608,'Besame Mucho',5,NULL,'f','2008-03-12 08:23:02');
INSERT INTO CHANSON VALUES(8609,'96 Tears',5,NULL,'f','2008-03-12 15:04:14');
INSERT INTO CHANSON VALUES(8610,'Les Humeurs de Catherine',5,NULL,'f','2008-03-12 16:24:07');
INSERT INTO CHANSON VALUES(8611,'La haine',5,NULL,'f','2008-03-12 18:35:05');
INSERT INTO CHANSON VALUES(8612,'Grand Jacques (c''est trop facile)',5,NULL,'f','2008-03-12 12:58:21');
INSERT INTO CHANSON VALUES(8613,'Il pleut',5,NULL,NULL,'2008-03-12 17:31:31');
INSERT INTO CHANSON VALUES(8614,'Le diable (ça va)',5,NULL,NULL,'2008-03-12 08:33:18');
INSERT INTO CHANSON VALUES(8615,'Il nous faut regarder',5,NULL,NULL,'2008-03-12 08:50:23');
INSERT INTO CHANSON VALUES(8616,'C''est comme ça',5,NULL,'f','2008-03-12 15:17:16');
INSERT INTO CHANSON VALUES(8617,'Il peut pleuvoir',5,NULL,'f','2008-03-12 13:24:25');
INSERT INTO CHANSON VALUES(8618,'Le fou du roi',5,NULL,'f','2008-03-12 12:24:49');
INSERT INTO CHANSON VALUES(8619,'Sur la place',5,NULL,'f','2008-03-12 12:01:53');
INSERT INTO CHANSON VALUES(8620,'S''il te faut',5,NULL,'f','2008-03-12 15:42:17');
INSERT INTO CHANSON VALUES(8621,'La bastille',5,NULL,'f','2008-03-12 17:34:53');
INSERT INTO CHANSON VALUES(8622,'Prière païenne',5,NULL,'f','2008-03-12 18:58:52');
INSERT INTO CHANSON VALUES(8623,'L''air de la bêtise',5,NULL,'f','2008-03-12 10:47:23');
INSERT INTO CHANSON VALUES(8624,'Qu''avons-nous fait, bonnes gens',5,NULL,'f','2008-03-12 16:50:57');
INSERT INTO CHANSON VALUES(8625,'Pardons',5,NULL,'f','2008-03-12 08:54:48');
INSERT INTO CHANSON VALUES(8626,'Saint Pierre',5,NULL,'f','2008-03-12 13:34:05');
INSERT INTO CHANSON VALUES(8627,'Les pieds dans le ruisseau',5,NULL,'f','2008-03-12 16:59:29');
INSERT INTO CHANSON VALUES(8628,'Quand on n''a que l''amour',5,NULL,'f','2008-03-12 09:21:54');
INSERT INTO CHANSON VALUES(8629,'J''en appelle',5,NULL,'f','2008-03-12 19:46:55');
INSERT INTO CHANSON VALUES(8630,'La bourrée du célibataire',5,NULL,'f','2008-03-12 18:25:38');
INSERT INTO CHANSON VALUES(8631,'Heureux',5,NULL,'f','2008-03-12 09:11:12');
INSERT INTO CHANSON VALUES(8632,'Les blés',5,NULL,'f','2008-03-12 08:03:10');
INSERT INTO CHANSON VALUES(8633,'Demain l''on se marie (la chanson des fiancés)',5,NULL,'f','2008-03-12 19:16:57');
INSERT INTO CHANSON VALUES(8634,'Les flamandes',5,NULL,'f','2008-03-12 11:01:48');
INSERT INTO CHANSON VALUES(8635,'L''ivrogne',5,NULL,'f','2008-03-12 11:04:42');
INSERT INTO CHANSON VALUES(8637,'Le moribond',5,NULL,'f','2008-03-12 10:14:16');
INSERT INTO CHANSON VALUES(8638,'Le prochain amour',5,NULL,'f','2008-03-12 16:22:38');
INSERT INTO CHANSON VALUES(8639,'Vivre debout',5,NULL,'f','2008-03-12 14:21:24');
INSERT INTO CHANSON VALUES(8640,'Les prénoms de Paris',5,NULL,'f','2008-03-12 13:12:50');
INSERT INTO CHANSON VALUES(8641,'Clara',5,NULL,'f','2008-03-12 09:22:01');
INSERT INTO CHANSON VALUES(8642,'On n''oublie rien',5,NULL,'f','2008-03-12 12:25:05');
INSERT INTO CHANSON VALUES(8643,'Les singes',5,NULL,'f','2008-03-12 14:21:22');
INSERT INTO CHANSON VALUES(8644,'Voir',5,NULL,'f','2008-03-12 13:40:23');
INSERT INTO CHANSON VALUES(8645,'L''aventure',5,NULL,'f','2008-03-12 11:57:27');
INSERT INTO CHANSON VALUES(8646,'Les moutons',5,NULL,'f','2008-03-12 19:02:58');
INSERT INTO CHANSON VALUES(8647,'Les amants de cur (the lovers)',5,NULL,'f','2008-03-24 11:12:12');
INSERT INTO CHANSON VALUES(8648,'Il neige sur Liège',5,NULL,'f','2008-03-12 14:52:35');
INSERT INTO CHANSON VALUES(8649,'Pourquoi faut-il que les hommes s''ennuient?',5,NULL,'f','2008-03-12 10:26:56');
INSERT INTO CHANSON VALUES(8650,'Les cur tendres',5,NULL,'f','2008-03-24 15:56:09');
INSERT INTO CHANSON VALUES(8651,'L''enfance',5,NULL,'f','2008-03-12 13:04:31');
INSERT INTO CHANSON VALUES(8652,'La chanson de Van Horst',5,NULL,'f','2008-03-12 13:24:57');
INSERT INTO CHANSON VALUES(8653,'Il y a',5,NULL,'f','2008-03-12 14:55:18');
INSERT INTO CHANSON VALUES(8654,'La foire',5,NULL,'f','2008-03-12 19:24:58');
INSERT INTO CHANSON VALUES(8655,'Introduction',7,NULL,NULL,'2008-03-12 11:41:56');
INSERT INTO CHANSON VALUES(8656,'La drogue, c''est de la merde',7,NULL,'f','2008-03-12 17:40:58');
INSERT INTO CHANSON VALUES(8657,'La rumeur',7,NULL,'f','2008-03-12 16:56:11');
INSERT INTO CHANSON VALUES(8658,'Monégascons',7,NULL,'f','2008-03-12 19:29:04');
INSERT INTO CHANSON VALUES(8659,'Dieu n''est pas bien',7,NULL,'f','2008-03-12 14:40:30');
INSERT INTO CHANSON VALUES(8660,'Humilié',7,NULL,'f','2008-03-12 13:15:27');
INSERT INTO CHANSON VALUES(8661,'Bestiaire',7,NULL,'f','2008-03-12 15:41:32');
INSERT INTO CHANSON VALUES(8662,'Catherine et le boucher',7,NULL,'f','2008-03-12 09:09:57');
INSERT INTO CHANSON VALUES(8663,'Gros mots',7,NULL,'f','2008-03-12 09:43:52');
INSERT INTO CHANSON VALUES(8664,'Joëlle',7,NULL,NULL,'2008-03-12 12:38:17');
INSERT INTO CHANSON VALUES(8665,'Lady PLM',7,NULL,'f','2008-03-12 12:56:58');
INSERT INTO CHANSON VALUES(8666,'Laura',7,NULL,'f','2008-03-12 11:42:38');
INSERT INTO CHANSON VALUES(8667,'Le règne animal',7,NULL,'f','2008-03-12 11:26:35');
INSERT INTO CHANSON VALUES(8668,'Les trois draps du prince d''orient',7,NULL,'f','2008-03-12 13:23:05');
INSERT INTO CHANSON VALUES(8669,'Figeac',7,NULL,'f','2008-03-12 14:54:45');
INSERT INTO CHANSON VALUES(8670,'Misères',7,NULL,'f','2008-03-12 08:22:01');
INSERT INTO CHANSON VALUES(8671,'Résurrection',7,NULL,NULL,'2008-03-12 14:59:43');
INSERT INTO CHANSON VALUES(8672,'Le printemps',7,NULL,NULL,'2008-03-12 08:07:53');
INSERT INTO CHANSON VALUES(8673,'De cheval',7,NULL,'f','2008-03-12 08:13:36');
INSERT INTO CHANSON VALUES(8674,'Conclusion',7,NULL,'f','2008-03-12 18:37:14');
INSERT INTO CHANSON VALUES(8675,'Le plat pays',5,NULL,'f','2008-03-12 10:00:11');
INSERT INTO CHANSON VALUES(8676,'Zangra',5,NULL,'f','2008-03-12 09:18:54');
INSERT INTO CHANSON VALUES(8677,'Le caporal casse-pompon',5,NULL,'f','2008-03-12 17:36:21');
INSERT INTO CHANSON VALUES(8678,'La statue',5,NULL,'f','2008-03-12 12:04:44');
INSERT INTO CHANSON VALUES(8679,'Rosa',5,NULL,'f','2008-03-12 13:37:38');
INSERT INTO CHANSON VALUES(8680,'Les bourgeois',5,NULL,'f','2008-03-12 10:40:01');
INSERT INTO CHANSON VALUES(8681,'Madeleine',5,NULL,'f','2008-03-12 11:11:00');
INSERT INTO CHANSON VALUES(8682,'Les paumés du petit matin',5,NULL,'f','2008-03-12 19:15:08');
INSERT INTO CHANSON VALUES(8683,'Bruxelles',5,NULL,'f','2008-03-12 18:16:21');
INSERT INTO CHANSON VALUES(8684,'Chanson sans parole',5,NULL,'f','2008-03-12 13:09:58');
INSERT INTO CHANSON VALUES(8685,'Une île',5,NULL,'f','2008-03-12 16:20:58');
INSERT INTO CHANSON VALUES(8686,'Les bigotes',5,NULL,'f','2008-03-12 18:29:17');
INSERT INTO CHANSON VALUES(8687,'Les vieux',5,NULL,'f','2008-03-12 17:17:53');
INSERT INTO CHANSON VALUES(8688,'Les fenêtres',5,NULL,'f','2008-03-12 09:40:58');
INSERT INTO CHANSON VALUES(8689,'Les toros',5,NULL,'f','2008-03-12 18:09:35');
INSERT INTO CHANSON VALUES(8690,'La parlote',5,NULL,'f','2008-03-12 14:23:15');
INSERT INTO CHANSON VALUES(8691,'Les filles et les chiens',5,NULL,'f','2008-03-12 14:39:27');
INSERT INTO CHANSON VALUES(8692,'La fanette',5,NULL,NULL,'2008-03-12 14:38:42');
INSERT INTO CHANSON VALUES(8693,'J''aimais',5,NULL,NULL,'2008-03-12 16:30:58');
INSERT INTO CHANSON VALUES(8694,'Les bergers',5,NULL,NULL,'2008-03-12 08:58:08');
INSERT INTO CHANSON VALUES(8695,'Les bonbons',5,NULL,'f','2008-03-12 08:41:28');
INSERT INTO CHANSON VALUES(8696,'',5,NULL,NULL,'2008-03-12 08:35:58');
INSERT INTO CHANSON VALUES(8697,'',5,NULL,NULL,'2008-03-12 11:23:15');
INSERT INTO CHANSON VALUES(8698,'',5,NULL,NULL,'2008-03-12 10:33:55');
INSERT INTO CHANSON VALUES(8699,'',5,NULL,NULL,'2008-03-12 10:27:05');
INSERT INTO CHANSON VALUES(8700,'',5,NULL,NULL,'2008-03-12 17:00:28');
INSERT INTO CHANSON VALUES(8701,'',5,NULL,NULL,'2008-03-12 08:34:07');
INSERT INTO CHANSON VALUES(8702,'',5,NULL,NULL,'2008-03-12 13:08:45');
INSERT INTO CHANSON VALUES(8703,'',5,NULL,NULL,'2008-03-12 10:51:16');
INSERT INTO CHANSON VALUES(8704,'',5,NULL,NULL,'2008-03-12 10:55:14');
INSERT INTO CHANSON VALUES(8705,'',5,NULL,NULL,'2008-03-12 12:58:55');
INSERT INTO CHANSON VALUES(8706,'',5,NULL,NULL,'2008-03-12 17:59:31');
INSERT INTO CHANSON VALUES(8707,'',5,NULL,NULL,'2008-03-12 17:17:55');
INSERT INTO CHANSON VALUES(8708,'',5,NULL,NULL,'2008-03-12 08:29:28');
INSERT INTO CHANSON VALUES(8709,'',5,NULL,NULL,'2008-03-12 19:40:56');
INSERT INTO CHANSON VALUES(8710,'',5,NULL,NULL,'2008-03-12 08:25:56');
INSERT INTO CHANSON VALUES(8711,'',5,NULL,NULL,'2008-03-12 14:27:30');
INSERT INTO CHANSON VALUES(8712,'',5,NULL,NULL,'2008-03-12 16:57:39');
INSERT INTO CHANSON VALUES(8713,'',5,NULL,NULL,'2008-03-12 13:09:31');
INSERT INTO CHANSON VALUES(8714,'',5,NULL,NULL,'2008-03-12 16:21:26');
INSERT INTO CHANSON VALUES(8715,'',5,NULL,NULL,'2008-03-12 19:41:24');
INSERT INTO CHANSON VALUES(8716,'',5,NULL,NULL,'2008-03-12 18:30:24');
INSERT INTO CHANSON VALUES(8717,'',5,NULL,NULL,'2008-03-12 12:17:41');
INSERT INTO CHANSON VALUES(8718,'',5,NULL,NULL,'2008-03-12 11:20:11');
INSERT INTO CHANSON VALUES(8719,'Banlieue nord',5,NULL,'f','2008-03-12 17:18:51');
INSERT INTO CHANSON VALUES(8720,'Avant l''exil',5,NULL,'f','2008-03-12 16:22:17');
INSERT INTO CHANSON VALUES(8721,'Filles des jardins',5,NULL,'f','2008-03-12 16:54:44');
INSERT INTO CHANSON VALUES(8722,'Solitude des latitudes',5,NULL,'f','2008-03-12 10:35:41');
INSERT INTO CHANSON VALUES(8723,'Camion bâché',5,NULL,'f','2008-03-12 18:01:51');
INSERT INTO CHANSON VALUES(8724,'Toutes choses',5,NULL,'f','2008-03-12 12:43:12');
INSERT INTO CHANSON VALUES(8725,'Matrice',5,NULL,'f','2008-03-12 17:39:53');
INSERT INTO CHANSON VALUES(8749,'Le poinçonneur des lilas (enregistrement public)',5,NULL,'f','2008-03-12 13:50:22');
INSERT INTO CHANSON VALUES(8750,'Le poinçonneur des lilas',5,NULL,'f','2008-03-12 18:19:06');
INSERT INTO CHANSON VALUES(8751,'La recette de l''amour fou',5,NULL,'f','2008-03-12 09:31:30');
INSERT INTO CHANSON VALUES(8752,'Douze belles dans la peau',5,NULL,'f','2008-03-12 19:20:17');
INSERT INTO CHANSON VALUES(8753,'Ce mortel ennui',5,NULL,'f','2008-03-12 12:22:10');
INSERT INTO CHANSON VALUES(8754,'Ronsard 58',5,NULL,'f','2008-03-12 13:37:01');
INSERT INTO CHANSON VALUES(8755,'La femme des uns sous le corps des autres',5,NULL,'f','2008-03-12 12:48:01');
INSERT INTO CHANSON VALUES(8756,'L''alcool',5,NULL,'f','2008-03-12 19:37:05');
INSERT INTO CHANSON VALUES(8757,'Du jazz dans le ravin',5,NULL,'f','2008-03-12 14:34:37');
INSERT INTO CHANSON VALUES(8758,'Charleston des déménageurs de piano',5,NULL,'f','2008-03-12 15:37:17');
INSERT INTO CHANSON VALUES(8759,'La jambe de bois ''Friedland''',5,NULL,'f','2008-03-12 15:02:07');
INSERT INTO CHANSON VALUES(8760,'Le claqueur de doigts',5,NULL,'f','2008-03-12 19:55:26');
INSERT INTO CHANSON VALUES(8761,'La nuit d''Octobre',5,NULL,'f','2008-03-12 09:04:58');
INSERT INTO CHANSON VALUES(8762,'Adieu créature',5,NULL,'f','2008-03-12 15:00:19');
INSERT INTO CHANSON VALUES(8763,'L''anthracite',5,NULL,NULL,'2008-03-12 18:24:41');
INSERT INTO CHANSON VALUES(8764,'Mambo Miam Miam',5,NULL,'f','2008-03-12 08:49:19');
INSERT INTO CHANSON VALUES(8765,'Indifférente',5,NULL,'f','2008-03-12 09:10:08');
INSERT INTO CHANSON VALUES(8766,'Jeunes femmes et vieux messieurs',5,NULL,'f','2008-03-12 09:07:45');
INSERT INTO CHANSON VALUES(8767,'l''amour à la papa',5,NULL,'f','2008-03-12 10:38:19');
INSERT INTO CHANSON VALUES(8768,'Cha cha cha du loup',5,NULL,'f','2008-03-12 18:16:56');
INSERT INTO CHANSON VALUES(8769,'Sois belle et tais toi',5,NULL,'f','2008-03-12 09:52:59');
INSERT INTO CHANSON VALUES(8770,'Laissez-moi tranquille',5,NULL,NULL,'2008-03-12 10:51:55');
INSERT INTO CHANSON VALUES(8771,'Judith',5,NULL,NULL,'2008-03-12 16:57:59');
INSERT INTO CHANSON VALUES(8772,'L''eau à la bouche',5,NULL,'f','2008-03-12 16:33:59');
INSERT INTO CHANSON VALUES(8773,'L''alternative',5,NULL,'f','2008-03-12 08:27:24');
INSERT INTO CHANSON VALUES(8774,'Tous ces mots terribles',5,NULL,'f','2008-03-12 16:32:14');
INSERT INTO CHANSON VALUES(8775,'Sous les pavés',5,NULL,'f','2008-03-12 08:38:24');
INSERT INTO CHANSON VALUES(8776,'Y''a qu''la foi qui sauve',5,NULL,'f','2008-03-12 09:45:31');
INSERT INTO CHANSON VALUES(8777,'Amours envolées',5,NULL,'f','2008-03-12 18:58:10');
INSERT INTO CHANSON VALUES(8778,'Paris Lumière',5,NULL,'f','2008-03-12 10:49:26');
INSERT INTO CHANSON VALUES(8779,'Jamais content',5,NULL,'f','2008-03-12 10:56:19');
INSERT INTO CHANSON VALUES(8780,'J''appelle',5,NULL,'f','2008-03-12 10:11:11');
INSERT INTO CHANSON VALUES(8781,'Billy m''aime',5,NULL,'f','2008-03-12 09:53:09');
INSERT INTO CHANSON VALUES(8782,'Casablanca',5,NULL,'f','2008-03-12 09:34:42');
INSERT INTO CHANSON VALUES(8784,'S''assoir par terre',5,NULL,NULL,'2008-03-12 13:16:42');
INSERT INTO CHANSON VALUES(8785,'Le dégoût',5,NULL,'f','2008-03-12 16:18:20');
INSERT INTO CHANSON VALUES(8786,'18 ans que je t''ai à l''oiel',5,NULL,'f','2008-03-12 09:27:06');
INSERT INTO CHANSON VALUES(8787,'Sardine',5,NULL,'f','2008-03-12 15:22:05');
INSERT INTO CHANSON VALUES(8788,'Lennon kaput valse',5,NULL,NULL,'2008-03-12 17:37:54');
INSERT INTO CHANSON VALUES(8789,'Allo maman bobo',5,NULL,'f','2008-03-12 11:48:51');
INSERT INTO CHANSON VALUES(8790,'Poulaillers'' song',5,NULL,'f','2008-03-12 15:59:03');
INSERT INTO CHANSON VALUES(8793,'Les papas des bébés',5,NULL,'f','2008-03-12 15:15:06');
INSERT INTO CHANSON VALUES(8794,'Y''a d''la rumba dans l''air',5,NULL,'f','2008-03-12 18:44:23');
INSERT INTO CHANSON VALUES(8795,'J''étais pas là',5,NULL,'f','2008-03-12 14:27:41');
INSERT INTO CHANSON VALUES(8799,'On avance',5,NULL,'f','2008-03-12 19:20:57');
INSERT INTO CHANSON VALUES(8800,'Saute en l''air',5,NULL,'f','2008-03-12 17:56:57');
INSERT INTO CHANSON VALUES(8801,'Help',5,NULL,'f','2008-03-12 18:44:02');
INSERT INTO CHANSON VALUES(8802,'Lumières',5,NULL,'f','2008-03-12 18:42:13');
INSERT INTO CHANSON VALUES(8803,'Que deviens-tu',5,NULL,'f','2008-03-12 12:22:29');
INSERT INTO CHANSON VALUES(8804,'Finir pécheur',5,NULL,'f','2008-03-12 13:12:14');
INSERT INTO CHANSON VALUES(8805,'Vies monotones',5,NULL,NULL,'2008-03-12 18:44:42');
INSERT INTO CHANSON VALUES(8806,'Entrez dans le rêve',5,NULL,NULL,'2008-03-12 14:37:17');
INSERT INTO CHANSON VALUES(8807,'Un jour être pauvre',5,NULL,'f','2008-03-12 16:36:31');
INSERT INTO CHANSON VALUES(8808,'Tristes tropiques',5,NULL,'f','2008-03-12 10:40:35');
INSERT INTO CHANSON VALUES(8809,'Le chant du cygne',5,NULL,'f','2008-03-12 12:38:55');
INSERT INTO CHANSON VALUES(8810,'Le lieu désiré',5,NULL,'f','2008-03-12 12:28:52');
INSERT INTO CHANSON VALUES(8811,'Revivre',5,NULL,'f','2008-03-12 11:21:37');
INSERT INTO CHANSON VALUES(8812,'Capitaine courageux',5,NULL,'f','2008-03-12 11:11:19');
INSERT INTO CHANSON VALUES(8813,'Eden Bay',5,NULL,'f','2008-03-12 14:33:41');
INSERT INTO CHANSON VALUES(8814,'Territoire de l''Inini',5,NULL,'f','2008-03-12 08:01:53');
INSERT INTO CHANSON VALUES(8815,'La chanson de Prevert',5,NULL,NULL,'2008-03-12 11:52:38');
INSERT INTO CHANSON VALUES(8816,'En relisant ta lettre',5,NULL,'f','2008-03-12 08:24:15');
INSERT INTO CHANSON VALUES(8817,'Le rock de Nerval',5,NULL,'f','2008-03-12 11:06:52');
INSERT INTO CHANSON VALUES(8818,'Les oubliettes',5,NULL,'f','2008-03-12 17:19:32');
INSERT INTO CHANSON VALUES(8819,'Chanson de Maglia',5,NULL,'f','2008-03-12 13:42:11');
INSERT INTO CHANSON VALUES(8820,'Viva Villa',5,NULL,'f','2008-03-12 12:02:39');
INSERT INTO CHANSON VALUES(8821,'Les amours perdues',5,NULL,'f','2008-03-12 10:19:00');
INSERT INTO CHANSON VALUES(8822,'Les femmes c''est du chinois',5,NULL,'f','2008-03-12 18:39:11');
INSERT INTO CHANSON VALUES(8823,'Personne',5,NULL,'f','2008-03-12 10:13:44');
INSERT INTO CHANSON VALUES(8824,'Le sonnet d''arvers',5,NULL,'f','2008-03-12 18:16:46');
INSERT INTO CHANSON VALUES(8825,'Les Goemons',5,NULL,'f','2008-03-12 17:35:38');
INSERT INTO CHANSON VALUES(8826,'Black trombone',5,NULL,'f','2008-03-12 12:36:03');
INSERT INTO CHANSON VALUES(8827,'Baudelaire',5,NULL,'f','2008-03-12 15:54:09');
INSERT INTO CHANSON VALUES(8828,'Intoxicated man',5,NULL,'f','2008-03-12 14:44:29');
INSERT INTO CHANSON VALUES(8829,'Quand tu t''y mets',5,NULL,'f','2008-03-12 08:09:11');
INSERT INTO CHANSON VALUES(8830,'Les cigarillos',5,NULL,'f','2008-03-12 11:30:14');
INSERT INTO CHANSON VALUES(8831,'Requiem pour un Twister',5,NULL,NULL,'2008-03-12 19:43:33');
INSERT INTO CHANSON VALUES(8832,'Ce grand mechant vous',5,NULL,'f','2008-03-12 19:34:13');
INSERT INTO CHANSON VALUES(8833,'L''appareil à sous',5,NULL,'f','2008-03-12 09:44:26');
INSERT INTO CHANSON VALUES(8834,'Vilaines filles, mauvais garcons',5,NULL,'f','2008-03-12 18:35:43');
INSERT INTO CHANSON VALUES(8835,'Un violon, un jambon',5,NULL,'f','2008-03-12 15:21:18');
INSERT INTO CHANSON VALUES(8837,'Chez les ye-ye',5,NULL,'f','2008-03-12 12:25:49');
INSERT INTO CHANSON VALUES(8838,'Sait-on jamais ou va une femme quand elle vous quitte',5,NULL,'f','2008-03-12 13:57:33');
INSERT INTO CHANSON VALUES(8839,'Le talkie-walkie',5,NULL,'f','2008-03-12 19:02:42');
INSERT INTO CHANSON VALUES(8840,'La fille au rasoir',5,NULL,NULL,'2008-03-12 10:18:12');
INSERT INTO CHANSON VALUES(8841,'La saison des pluies',5,NULL,NULL,'2008-03-12 13:13:56');
INSERT INTO CHANSON VALUES(8842,'Elaeudanla teiteia',5,NULL,'f','2008-03-12 19:09:30');
INSERT INTO CHANSON VALUES(8843,'Scenic railway',5,NULL,'f','2008-03-12 10:17:14');
INSERT INTO CHANSON VALUES(8844,'Le temps des yoyos',5,NULL,'f','2008-03-12 15:10:50');
INSERT INTO CHANSON VALUES(8845,'Amour sans amour',5,NULL,'f','2008-03-12 12:49:11');
INSERT INTO CHANSON VALUES(8846,'No no thank''s no',5,NULL,'f','2008-03-12 16:06:56');
INSERT INTO CHANSON VALUES(8847,'Maxim''s',5,NULL,'f','2008-03-12 15:26:22');
INSERT INTO CHANSON VALUES(8848,'Negative blues',5,NULL,'f','2008-03-12 13:56:19');
INSERT INTO CHANSON VALUES(8849,'Joanna',5,NULL,'f','2008-03-12 19:55:21');
INSERT INTO CHANSON VALUES(8850,'La-bas c''est naturel',5,NULL,'f','2008-03-12 16:06:40');
INSERT INTO CHANSON VALUES(8851,'Pauvre Lola',5,NULL,'f','2008-03-12 18:31:53');
INSERT INTO CHANSON VALUES(8852,'Quand mon 6''35 me fait les yeux doux',5,NULL,'f','2008-03-12 17:30:03');
INSERT INTO CHANSON VALUES(8853,'Machin choses',5,NULL,'f','2008-03-12 11:42:21');
INSERT INTO CHANSON VALUES(8854,'Les sambassadeurs',5,NULL,'f','2008-03-12 14:21:31');
INSERT INTO CHANSON VALUES(8855,'New-York USA',5,NULL,'f','2008-03-12 12:44:20');
INSERT INTO CHANSON VALUES(8857,'Marabout',5,NULL,'f','2008-03-12 14:01:53');
INSERT INTO CHANSON VALUES(8859,'Tatoue Jeremie',5,NULL,'f','2008-03-12 10:25:45');
INSERT INTO CHANSON VALUES(8860,'Coco and Co',5,NULL,'f','2008-03-12 15:06:52');
INSERT INTO CHANSON VALUES(8861,'Comment trouvez-vous ma sœur ?',5,NULL,'f','2008-07-12 07:04:19.125259');
INSERT INTO CHANSON VALUES(8862,'',5,NULL,NULL,'2008-03-12 10:50:54');
INSERT INTO CHANSON VALUES(8863,'',5,NULL,NULL,'2008-03-12 10:09:36');
INSERT INTO CHANSON VALUES(8864,'',5,NULL,NULL,'2008-03-12 14:44:58');
INSERT INTO CHANSON VALUES(8865,'',5,NULL,NULL,'2008-03-12 09:08:42');
INSERT INTO CHANSON VALUES(8866,'',5,NULL,NULL,'2008-03-12 13:44:08');
INSERT INTO CHANSON VALUES(8867,'',5,NULL,NULL,'2008-03-12 18:16:09');
INSERT INTO CHANSON VALUES(8868,'',5,NULL,NULL,'2008-03-12 17:11:36');
INSERT INTO CHANSON VALUES(8869,'',5,NULL,NULL,'2008-03-12 15:25:02');
INSERT INTO CHANSON VALUES(8870,'',5,NULL,NULL,'2008-03-12 12:01:08');
INSERT INTO CHANSON VALUES(8871,'',5,NULL,NULL,'2008-03-12 11:17:08');
INSERT INTO CHANSON VALUES(8872,'',5,NULL,NULL,'2008-03-12 16:27:59');
INSERT INTO CHANSON VALUES(8873,'',5,NULL,NULL,'2008-03-12 15:40:08');
INSERT INTO CHANSON VALUES(8874,'',5,NULL,NULL,'2008-03-12 10:15:53');
INSERT INTO CHANSON VALUES(8875,'',5,NULL,NULL,'2008-03-12 10:22:01');
INSERT INTO CHANSON VALUES(8876,'',5,NULL,NULL,'2008-03-12 18:49:45');
INSERT INTO CHANSON VALUES(8877,'',5,NULL,NULL,'2008-03-12 08:43:02');
INSERT INTO CHANSON VALUES(8878,'',5,NULL,NULL,'2008-03-12 10:31:13');
INSERT INTO CHANSON VALUES(8879,'',5,NULL,NULL,'2008-03-12 17:10:38');
INSERT INTO CHANSON VALUES(8880,'',5,NULL,NULL,'2008-03-12 18:34:39');
INSERT INTO CHANSON VALUES(8881,'',5,NULL,NULL,'2008-03-12 19:51:57');
INSERT INTO CHANSON VALUES(8882,'',5,NULL,NULL,'2008-03-12 09:32:24');
INSERT INTO CHANSON VALUES(8883,'',5,NULL,NULL,'2008-03-12 09:07:05');
INSERT INTO CHANSON VALUES(8884,'Prisonnier de l''inutile',5,NULL,'f','2008-03-12 11:19:21');
INSERT INTO CHANSON VALUES(8885,'Et l''or de leur corps',5,NULL,'f','2008-03-12 09:30:43');
INSERT INTO CHANSON VALUES(8886,'Mauvais Karma',5,NULL,'f','2008-03-12 10:24:33');
INSERT INTO CHANSON VALUES(8887,'Les enfants des tours',5,NULL,'f','2008-03-12 19:26:16');
INSERT INTO CHANSON VALUES(8888,'Chambres d''Asie',5,NULL,'f','2008-03-12 19:38:48');
INSERT INTO CHANSON VALUES(8889,'Deux voiles blanches',5,NULL,'f','2008-03-12 10:26:59');
INSERT INTO CHANSON VALUES(8890,'Est-ce ainsi que les hommes meurent ?',5,NULL,NULL,'2008-03-12 18:17:34');
INSERT INTO CHANSON VALUES(8891,'Un Peu D''eau',5,NULL,'f','2008-03-12 14:17:26');
INSERT INTO CHANSON VALUES(8892,'Des Ronds dans L''eau',5,NULL,'f','2008-03-12 13:25:58');
INSERT INTO CHANSON VALUES(8894,'Soleil',5,NULL,'f','2008-03-12 19:49:26');
INSERT INTO CHANSON VALUES(8895,'La Question',5,NULL,'f','2008-03-12 11:58:57');
INSERT INTO CHANSON VALUES(8896,'Et Si je M''en Vais Avant Toi',5,NULL,'f','2008-03-12 08:09:21');
INSERT INTO CHANSON VALUES(8897,'L''homme à la tête de chou',5,NULL,'f','2008-03-12 15:06:47');
INSERT INTO CHANSON VALUES(8898,'Chez Max coiffeur pour homme',5,NULL,NULL,'2008-03-12 18:04:25');
INSERT INTO CHANSON VALUES(8899,'Marilou reggae',5,NULL,NULL,'2008-03-12 16:16:52');
INSERT INTO CHANSON VALUES(8900,'Transit à Marilou',5,NULL,NULL,'2008-03-12 16:06:10');
INSERT INTO CHANSON VALUES(8901,'Flash Forward',5,NULL,'f','2008-03-12 10:37:27');
INSERT INTO CHANSON VALUES(8902,'Aéroplanes',5,NULL,'f','2008-03-12 16:05:53');
INSERT INTO CHANSON VALUES(8903,'Premiers Symptomes',5,NULL,'f','2008-03-12 15:57:26');
INSERT INTO CHANSON VALUES(8904,'Malou marilou',5,NULL,'f','2008-03-12 17:55:16');
INSERT INTO CHANSON VALUES(8905,'Variations sur Marilou',5,NULL,'f','2008-03-12 10:14:15');
INSERT INTO CHANSON VALUES(8906,'Meurtre à l''extincteur',5,NULL,'f','2008-03-12 09:16:25');
INSERT INTO CHANSON VALUES(8907,'Marilou sous la neige',5,NULL,'f','2008-03-12 14:51:31');
INSERT INTO CHANSON VALUES(8908,'Lunatic Asylum',5,NULL,'f','2008-03-12 11:44:35');
INSERT INTO CHANSON VALUES(8909,'L''Ami Caouette',5,NULL,'f','2008-03-12 16:25:51');
INSERT INTO CHANSON VALUES(8910,'Le cadavre exquis',5,NULL,'f','2008-03-12 15:05:58');
INSERT INTO CHANSON VALUES(8911,'My Lady Heroine',5,NULL,'f','2008-03-12 17:20:36');
INSERT INTO CHANSON VALUES(8912,'Trois millions de Joconde',5,NULL,'f','2008-03-12 11:01:41');
INSERT INTO CHANSON VALUES(8913,'Good-Bye Emmanuelle',5,NULL,'f','2008-03-12 09:40:39');
INSERT INTO CHANSON VALUES(8914,'Sea, Sex and Sun',5,NULL,'f','2008-03-12 15:27:34');
INSERT INTO CHANSON VALUES(8915,'Mister Iceberg',5,NULL,'f','2008-03-12 18:39:48');
INSERT INTO CHANSON VALUES(8916,'Sea, Sex and Sun (version anglaise)',5,NULL,NULL,'2008-03-12 09:49:04');
INSERT INTO CHANSON VALUES(8917,'Mister Iceberg (version anglaise)',5,NULL,'f','2008-03-12 14:20:56');
INSERT INTO CHANSON VALUES(8919,'Souviens-toi de m''oublier',5,NULL,'f','2008-03-12 15:23:06');
INSERT INTO CHANSON VALUES(8920,'Henri Pescarolo',7,NULL,'f','2008-03-12 14:01:12');
INSERT INTO CHANSON VALUES(8921,'Léon Zitrone',7,NULL,'f','2008-03-12 13:48:33');
INSERT INTO CHANSON VALUES(8922,'François de Closets',7,NULL,'f','2008-03-12 09:04:34');
INSERT INTO CHANSON VALUES(8923,'Yvan Dautin',7,NULL,'f','2008-03-12 17:13:15');
INSERT INTO CHANSON VALUES(8924,'Jacques Séguéla',7,NULL,'f','2008-03-12 13:49:42');
INSERT INTO CHANSON VALUES(8925,'Patrick Poivre d''Arvor',7,NULL,'f','2008-03-12 08:41:22');
INSERT INTO CHANSON VALUES(8926,'Alain Gillot-Pétré',7,NULL,'f','2008-03-12 18:48:12');
INSERT INTO CHANSON VALUES(8927,'Love to Soon',5,NULL,'f','2008-03-12 19:20:33');
INSERT INTO CHANSON VALUES(8928,'Aigua de Florida',5,NULL,'f','2008-03-12 18:24:12');
INSERT INTO CHANSON VALUES(8929,'The Letter',5,NULL,'f','2008-03-12 14:03:36');
INSERT INTO CHANSON VALUES(8930,'Trowboning R''N''B'' Formidable',5,NULL,'f','2008-03-12 15:34:38');
INSERT INTO CHANSON VALUES(8931,'Comiendo la Banana d''Ayer',5,NULL,'f','2008-03-12 18:04:26');
INSERT INTO CHANSON VALUES(8932,'The Great Ricardo Solfa',5,NULL,NULL,'2008-03-12 13:10:31');
INSERT INTO CHANSON VALUES(8933,'Featherhead',5,NULL,NULL,'2008-03-12 08:58:44');
INSERT INTO CHANSON VALUES(8934,'Love to Soon (Piano Version)',5,NULL,'f','2008-03-12 11:25:33');
INSERT INTO CHANSON VALUES(8935,'Love on the beat',5,NULL,'f','2008-03-12 19:27:15');
INSERT INTO CHANSON VALUES(8936,'Sorry angel',5,NULL,'f','2008-03-12 12:17:03');
INSERT INTO CHANSON VALUES(8937,'Hmm hmm hmm',5,NULL,'f','2008-03-12 14:12:24');
INSERT INTO CHANSON VALUES(8938,'Kiss me hardy',5,NULL,'f','2008-03-12 09:04:48');
INSERT INTO CHANSON VALUES(8939,'No comment',5,NULL,'f','2008-03-12 12:37:52');
INSERT INTO CHANSON VALUES(8940,'I''m the boy',5,NULL,'f','2008-03-12 19:17:26');
INSERT INTO CHANSON VALUES(8942,'Lemon incest',5,NULL,'f','2008-03-12 08:36:41');
INSERT INTO CHANSON VALUES(8943,'Intro',7,NULL,'f','2008-03-12 14:36:39');
INSERT INTO CHANSON VALUES(8944,'Robert Lamoureux 16-12-80',7,NULL,'f','2008-03-12 11:53:05');
INSERT INTO CHANSON VALUES(8945,'Renée Saint-Cyr 06-04-81',7,NULL,NULL,'2008-03-12 18:51:33');
INSERT INTO CHANSON VALUES(8946,'Gorges-Jean Arnaud 14-05-81',7,NULL,'f','2008-03-12 09:13:51');
INSERT INTO CHANSON VALUES(8947,'Djamel Allam 19-05-81',7,NULL,'f','2008-03-12 10:47:03');
INSERT INTO CHANSON VALUES(8948,'Gérard Vié 26-05-81',7,NULL,'f','2008-03-12 15:55:08');
INSERT INTO CHANSON VALUES(8949,'Daniel Cohn-Bendit 14-09-82',7,NULL,'f','2008-03-12 12:15:46');
INSERT INTO CHANSON VALUES(8950,'Jean d''Ormesson 16-09-82',7,NULL,'f','2008-03-12 11:13:04');
INSERT INTO CHANSON VALUES(8951,'Hughette Bouchardeau 06-10-82',7,NULL,'f','2008-03-12 16:48:14');
INSERT INTO CHANSON VALUES(8952,'Comme un guerrier',5,NULL,'f','2008-03-12 10:51:51');
INSERT INTO CHANSON VALUES(8953,'La mer rouge',5,NULL,'f','2008-03-12 19:25:28');
INSERT INTO CHANSON VALUES(8954,'L''enfant qui vole',5,NULL,'f','2008-03-12 15:43:21');
INSERT INTO CHANSON VALUES(8955,'Toujours ensemble',5,NULL,'f','2008-03-12 16:35:13');
INSERT INTO CHANSON VALUES(8956,'Maubert',5,NULL,'f','2008-03-12 10:42:26');
INSERT INTO CHANSON VALUES(8957,'La route de terre',5,NULL,'f','2008-03-12 09:53:14');
INSERT INTO CHANSON VALUES(8958,'Il faut toujours se dire adieu',5,NULL,'f','2008-03-12 09:28:09');
INSERT INTO CHANSON VALUES(8959,'L''épée de lumière',5,NULL,'f','2008-03-12 11:53:25');
INSERT INTO CHANSON VALUES(8960,'Un trait Danger',5,NULL,'f','2008-03-24 10:59:31');
INSERT INTO CHANSON VALUES(8961,'Ce soir',5,NULL,'f','2008-03-12 08:09:39');
INSERT INTO CHANSON VALUES(8962,'Ne t''inquiète de rien',5,NULL,'f','2008-03-24 19:09:19');
INSERT INTO CHANSON VALUES(8963,'La famille',5,NULL,'f','2008-03-17 09:53:28');
INSERT INTO CHANSON VALUES(8964,'Madame Suzie',5,NULL,'f','2008-03-12 12:07:19');
INSERT INTO CHANSON VALUES(8965,'Donges',5,NULL,NULL,'2008-03-17 10:02:44');
INSERT INTO CHANSON VALUES(8966,'Les berceaux brodés',5,NULL,NULL,'2008-03-24 09:04:02');
INSERT INTO CHANSON VALUES(8967,'[sans titre]',5,NULL,NULL,'2008-03-12 16:37:28');
INSERT INTO CHANSON VALUES(8968,'L''homme',5,NULL,'f','2008-03-12 08:18:03');
INSERT INTO CHANSON VALUES(8969,'Mes problèmes de relation',5,NULL,'f','2008-03-17 11:32:46');
INSERT INTO CHANSON VALUES(8970,'Roberto',5,NULL,'f','2008-03-12 17:38:40');
INSERT INTO CHANSON VALUES(8971,'Avec des si',5,NULL,'f','2008-03-17 19:47:09');
INSERT INTO CHANSON VALUES(8972,'Les bistros Les Bastringues',5,NULL,'f','2008-03-24 08:15:39');
INSERT INTO CHANSON VALUES(8973,'Jean-Marie Le Pen - 28-11-82',7,NULL,'f','2008-03-12 15:08:12');
INSERT INTO CHANSON VALUES(8974,'Marcel Marceau 23-11-82',7,NULL,'f','2008-03-12 10:17:05');
INSERT INTO CHANSON VALUES(8975,'Yannick Noah 26-11-82',7,NULL,'f','2008-03-12 16:40:12');
INSERT INTO CHANSON VALUES(8976,'Jean-Marc Roberts 06-12-82',7,NULL,'f','2008-03-12 08:55:15');
INSERT INTO CHANSON VALUES(8977,'William Sheller 17-12-82',7,NULL,'f','2008-03-12 17:38:52');
INSERT INTO CHANSON VALUES(8978,'José Giovanni 13-01-83',7,NULL,'f','2008-03-12 11:43:11');
INSERT INTO CHANSON VALUES(8979,'Inès de la Fressange 18-01-83',7,NULL,'f','2008-03-12 11:01:44');
INSERT INTO CHANSON VALUES(8980,'François Romério 27-01-83',7,NULL,'f','2008-03-12 09:47:22');
INSERT INTO CHANSON VALUES(8981,'Y''a une route',5,NULL,'f','2008-03-12 17:46:09');
INSERT INTO CHANSON VALUES(8982,'Il voyage en solitaire',5,NULL,'f','2008-03-12 19:56:13');
INSERT INTO CHANSON VALUES(8983,'Attends que le temps te vide',5,NULL,'f','2008-03-12 19:32:22');
INSERT INTO CHANSON VALUES(8984,'Rouge Gorge',5,NULL,'f','2008-03-12 10:47:39');
INSERT INTO CHANSON VALUES(8985,'C''est un parc',5,NULL,'f','2008-03-12 11:30:20');
INSERT INTO CHANSON VALUES(8986,'On sait que tu vas vite',5,NULL,'f','2008-03-12 13:32:15');
INSERT INTO CHANSON VALUES(8987,'Qu''il est loin le temps devant nous',5,NULL,'f','2008-03-12 16:19:54');
INSERT INTO CHANSON VALUES(8988,'Les vases bleus',5,NULL,NULL,'2008-03-12 15:34:38');
INSERT INTO CHANSON VALUES(8989,'Amis',5,NULL,'f','2008-03-12 17:54:40');
INSERT INTO CHANSON VALUES(8990,'2870',5,NULL,'f','2008-03-12 14:00:27');
INSERT INTO CHANSON VALUES(8991,'La mauvaise réputation',5,NULL,'f','2008-03-24 18:46:14');
INSERT INTO CHANSON VALUES(8992,'Le fossoyeur',5,NULL,'f','2008-04-13 15:51:30');
INSERT INTO CHANSON VALUES(8993,'Le gorille',5,NULL,'f','2008-03-24 14:35:15');
INSERT INTO CHANSON VALUES(8994,'Le petit cheval',5,NULL,'f','2008-03-26 08:42:11');
INSERT INTO CHANSON VALUES(8995,'Ballade des dames du temps jadis',5,NULL,'f','2008-03-12 11:41:43');
INSERT INTO CHANSON VALUES(8997,'La chasse aux papillons',5,NULL,NULL,'2008-04-13 15:20:42');
INSERT INTO CHANSON VALUES(8998,'Le parapluie',5,NULL,'f','2008-03-26 15:36:33');
INSERT INTO CHANSON VALUES(8999,'La marine',5,NULL,'f','2008-04-13 17:40:05');
INSERT INTO CHANSON VALUES(9001,'Il suffit de passer le pont',5,NULL,'f','2008-03-24 18:56:28');
INSERT INTO CHANSON VALUES(9002,'Comme hier',5,NULL,'f','2008-03-24 16:00:16');
INSERT INTO CHANSON VALUES(9003,'Maman, papa',5,NULL,'f','2008-03-24 09:36:50');
INSERT INTO CHANSON VALUES(9004,'Le mauvais sujet repenti',5,NULL,'f','2008-03-24 13:44:22');
INSERT INTO CHANSON VALUES(9005,'Tous Les Garçons et Les Filles',5,NULL,NULL,'2008-03-12 10:16:22');
INSERT INTO CHANSON VALUES(9006,'Oh, Oh, Chéri',5,NULL,'f','2008-03-12 15:11:09');
INSERT INTO CHANSON VALUES(9007,'Le Temps de L''Amour',5,NULL,'f','2008-03-12 18:14:52');
INSERT INTO CHANSON VALUES(9008,'J''Suis D''Accord',5,NULL,'f','2008-03-12 08:32:33');
INSERT INTO CHANSON VALUES(9009,'C''est à L''Amour Auquel Je Pense',5,NULL,'f','2008-03-12 17:11:25');
INSERT INTO CHANSON VALUES(9010,'Va Pas Prendre un Tambour',5,NULL,'f','2008-03-12 11:31:33');
INSERT INTO CHANSON VALUES(9011,'Mon Amie Le Rose',5,NULL,'f','2008-03-12 11:11:10');
INSERT INTO CHANSON VALUES(9012,'Le Temps Des Souvenirs',5,NULL,'f','2008-03-12 18:07:30');
INSERT INTO CHANSON VALUES(9013,'La Maison où J''ai Grandi (Il Ragazzo Della Via Gluck)',5,NULL,'f','2008-03-12 17:57:27');
INSERT INTO CHANSON VALUES(9014,'Je Ne Suis Lá Pour Personne',5,NULL,'f','2008-03-12 10:27:12');
INSERT INTO CHANSON VALUES(9015,'Les amoureux des bancs publics',5,NULL,'f','2008-03-24 15:37:29');
INSERT INTO CHANSON VALUES(9016,'Brave Margot',5,NULL,'f','2008-04-13 09:07:54');
INSERT INTO CHANSON VALUES(9017,'Pauvre Martin',5,NULL,NULL,'2008-03-26 19:15:40');
INSERT INTO CHANSON VALUES(9018,'La première fille',5,NULL,NULL,'2008-03-26 13:59:45');
INSERT INTO CHANSON VALUES(9019,'La cane de Jeanne',5,NULL,'f','2008-03-24 14:43:00');
INSERT INTO CHANSON VALUES(9020,'Je suis un voyou',5,NULL,'f','2008-04-13 08:12:26');
INSERT INTO CHANSON VALUES(9021,'J''ai rendez-vous avec vous',5,NULL,'f','2008-03-26 19:27:06');
INSERT INTO CHANSON VALUES(9022,'Le vent',5,NULL,'f','2008-03-26 14:00:38');
INSERT INTO CHANSON VALUES(9023,'Il n''y a pas d''amour heureux',5,NULL,'f','2008-04-13 09:32:58');
INSERT INTO CHANSON VALUES(9024,'La mauvaise herbe',5,NULL,'f','2008-04-13 14:39:21');
INSERT INTO CHANSON VALUES(9026,'P... de toi',5,NULL,'f','2008-04-13 16:32:28');
INSERT INTO CHANSON VALUES(9034,'Pour la femme veuve qui s'' veille',5,NULL,'f','2008-03-12 18:11:31');
INSERT INTO CHANSON VALUES(9035,'Supporter',5,NULL,'f','2008-03-12 12:11:46');
INSERT INTO CHANSON VALUES(9036,'Les petits lolos',5,NULL,'f','2008-03-12 08:20:54');
INSERT INTO CHANSON VALUES(9037,'Frappe avec ta t te',5,NULL,'f','2008-03-12 19:21:06');
INSERT INTO CHANSON VALUES(9038,'Vid o S rie noire',5,NULL,'f','2008-03-12 12:56:06');
INSERT INTO CHANSON VALUES(9039,'Partir avec les miens',5,NULL,'f','2008-03-12 08:56:25');
INSERT INTO CHANSON VALUES(9040,'Poissons dans la cage',5,NULL,'f','2008-03-12 08:27:56');
INSERT INTO CHANSON VALUES(9041,'Elu par les boeufs',5,NULL,'f','2008-03-12 14:09:30');
INSERT INTO CHANSON VALUES(9042,'Revolu ion',5,NULL,'f','2008-03-12 13:03:42');
INSERT INTO CHANSON VALUES(9043,'Lolilta go home',5,NULL,'f','2008-03-12 19:26:53');
INSERT INTO CHANSON VALUES(9044,'What is this thing called love?',5,NULL,'f','2008-03-12 16:29:13');
INSERT INTO CHANSON VALUES(9045,'Bébé song',5,NULL,'f','2008-03-12 15:27:35');
INSERT INTO CHANSON VALUES(9046,'Where or when',5,NULL,'f','2008-03-12 16:52:32');
INSERT INTO CHANSON VALUES(9047,'Si ça peut te consoler',5,NULL,'f','2008-03-12 18:55:28');
INSERT INTO CHANSON VALUES(9048,'Love for sale',5,NULL,'f','2008-03-12 11:10:58');
INSERT INTO CHANSON VALUES(9049,'Just me and you',5,NULL,NULL,'2008-03-12 12:45:11');
INSERT INTO CHANSON VALUES(9050,'La fille aux claquettes',5,NULL,NULL,'2008-03-12 19:50:39');
INSERT INTO CHANSON VALUES(9051,'Rien pour rien',5,NULL,NULL,'2008-03-12 18:21:48');
INSERT INTO CHANSON VALUES(9052,'French graffiti',5,NULL,'f','2008-03-12 13:46:51');
INSERT INTO CHANSON VALUES(9053,'There''s a small motel',5,NULL,'f','2008-03-12 09:43:17');
INSERT INTO CHANSON VALUES(9054,'Chanson pour l''Auvergnat',5,NULL,'f','2008-03-24 08:25:46');
INSERT INTO CHANSON VALUES(9055,'Les sabots d''Hélène',5,NULL,'f','2008-03-26 19:37:14');
INSERT INTO CHANSON VALUES(9064,'Le nombril des femmes d''agents',5,NULL,'f','2008-03-24 08:09:48');
INSERT INTO CHANSON VALUES(9066,'La mauvaise réputation nouvel  enregistrement',5,NULL,'f','2008-03-24 15:04:10');
INSERT INTO CHANSON VALUES(9067,'Le parapluie nouvel  enregistrement',5,NULL,'f','2008-03-26 13:29:56');
INSERT INTO CHANSON VALUES(9068,'Le petit cheval nouvel  enregistrement',5,NULL,'f','2008-03-26 11:36:39');
INSERT INTO CHANSON VALUES(9069,'Le fossoyeur nouvel  enregistrement',5,NULL,'f','2008-04-13 09:49:22');
INSERT INTO CHANSON VALUES(9070,'Le gorille nouvel  enregistrement',5,NULL,NULL,'2008-03-24 10:54:06');
INSERT INTO CHANSON VALUES(9071,'Corne d''Aurochs nouvel  enregistrement',5,NULL,'f','2008-03-24 12:52:08');
INSERT INTO CHANSON VALUES(9072,'La chasse aux papillons nouvel  enregistrement',5,NULL,'f','2008-04-13 10:24:39');
INSERT INTO CHANSON VALUES(9073,'Hécatombe nouvel  enregistrement',5,NULL,'f','2008-03-24 15:42:53');
INSERT INTO CHANSON VALUES(9074,'Coluche',7,NULL,'f','2008-03-12 16:04:29');
INSERT INTO CHANSON VALUES(9075,'Christine',7,NULL,'f','2008-03-12 16:55:21');
INSERT INTO CHANSON VALUES(9076,'Les chanteurs engagés',7,NULL,'f','2008-03-12 19:44:33');
INSERT INTO CHANSON VALUES(9077,'Le ministre de la culture',7,NULL,'f','2008-03-12 18:45:43');
INSERT INTO CHANSON VALUES(9078,'RPR',7,NULL,'f','2008-03-12 16:25:47');
INSERT INTO CHANSON VALUES(9079,'Ce soir je dors dans tes bras',7,NULL,'f','2008-03-12 18:52:17');
INSERT INTO CHANSON VALUES(9080,'Soixante-huit',7,NULL,'f','2008-03-12 17:11:54');
INSERT INTO CHANSON VALUES(9081,'Je ne connais rien de plus doux',7,NULL,'f','2008-03-12 13:47:31');
INSERT INTO CHANSON VALUES(9082,'Le ministre de l''intérieur',7,NULL,'f','2008-03-12 14:10:24');
INSERT INTO CHANSON VALUES(9091,'Le vin',5,NULL,'f','2008-03-26 10:49:33');
INSERT INTO CHANSON VALUES(9092,'Philistins',5,NULL,'f','2008-03-26 08:00:36');
INSERT INTO CHANSON VALUES(9093,'La mala reputacion',5,NULL,'f','2008-03-12 16:42:01');
INSERT INTO CHANSON VALUES(9094,'La pata de Juana',5,NULL,'f','2008-03-12 14:34:54');
INSERT INTO CHANSON VALUES(9095,'El testamento',5,NULL,'f','2008-03-12 17:22:06');
INSERT INTO CHANSON VALUES(9097,'Zou je houden van?',3,NULL,'f','2008-03-12 16:51:54');
INSERT INTO CHANSON VALUES(9098,'Naar de maan',3,NULL,'f','2008-03-12 11:25:04');
INSERT INTO CHANSON VALUES(9099,'Poeziewoede',3,NULL,NULL,'2008-03-12 15:07:51');
INSERT INTO CHANSON VALUES(9100,'Zuster',3,NULL,'f','2008-03-12 17:43:19');
INSERT INTO CHANSON VALUES(9101,'De hemel breekt',3,NULL,'f','2008-03-12 19:50:31');
INSERT INTO CHANSON VALUES(9102,'Windstil',3,NULL,'f','2008-03-12 08:17:38');
INSERT INTO CHANSON VALUES(9103,'Hotel ijdele hoop',3,NULL,'f','2008-03-12 19:18:39');
INSERT INTO CHANSON VALUES(9104,'Tram 17',3,NULL,'f','2008-03-12 14:03:21');
INSERT INTO CHANSON VALUES(9105,'Het beest is baas',3,NULL,'f','2008-03-12 14:35:55');
INSERT INTO CHANSON VALUES(9106,'Wat wil ze dat ik doe',3,NULL,'f','2008-03-12 13:24:18');
INSERT INTO CHANSON VALUES(9107,'Ze houd te veel van mij',3,NULL,'f','2008-03-12 15:08:09');
INSERT INTO CHANSON VALUES(9108,'Le vieux Léon',5,NULL,'f','2008-03-26 12:14:52');
INSERT INTO CHANSON VALUES(9109,'La ronde des jurons',5,NULL,'f','2008-03-26 14:23:35');
INSERT INTO CHANSON VALUES(9110,'à l''ombre du cur de ma mie',5,NULL,'f','2008-03-24 15:31:33');
INSERT INTO CHANSON VALUES(9112,'Le Père Noël et la petite fille',5,NULL,'f','2008-03-26 13:49:27');
INSERT INTO CHANSON VALUES(9113,'La femme d''Hector',5,NULL,'f','2008-03-24 09:29:45');
INSERT INTO CHANSON VALUES(9114,'Bonhomme',5,NULL,NULL,'2008-03-24 17:47:17');
INSERT INTO CHANSON VALUES(9115,'Les funérailles d''antan',5,NULL,'f','2008-04-13 13:54:39');
INSERT INTO CHANSON VALUES(9116,'Le cocu',5,NULL,'f','2008-03-24 10:42:39');
INSERT INTO CHANSON VALUES(9117,'Comme une sur',5,NULL,'f','2008-03-24 12:12:41');
INSERT INTO CHANSON VALUES(9126,'Baille baille Samantha',5,NULL,'f','2008-03-12 10:59:05');
INSERT INTO CHANSON VALUES(9127,'Suck baby suck',5,NULL,NULL,'2008-03-12 12:29:28');
INSERT INTO CHANSON VALUES(9128,'Glommy sunday',5,NULL,'f','2008-03-12 19:04:32');
INSERT INTO CHANSON VALUES(9130,'Shotgun',5,NULL,'f','2008-03-12 09:16:08');
INSERT INTO CHANSON VALUES(9131,'Glass securit',5,NULL,'f','2008-03-12 13:33:00');
INSERT INTO CHANSON VALUES(9134,'Itkin',3,NULL,'f','2008-03-12 18:03:03');
INSERT INTO CHANSON VALUES(9135,'Käppee',3,NULL,'f','2008-03-12 12:56:27');
INSERT INTO CHANSON VALUES(9136,'Laiska',3,NULL,'f','2008-03-12 11:08:26');
INSERT INTO CHANSON VALUES(9137,'Liigua',3,NULL,'f','2008-03-12 12:30:55');
INSERT INTO CHANSON VALUES(9138,'Milja',3,NULL,'f','2008-03-12 18:28:00');
INSERT INTO CHANSON VALUES(9139,'Äijo',3,NULL,'f','2008-03-12 13:08:30');
INSERT INTO CHANSON VALUES(9140,'Kivutar',3,NULL,'f','2008-03-12 17:16:47');
INSERT INTO CHANSON VALUES(9141,'Linnunmieli',3,NULL,NULL,'2008-03-12 19:41:20');
INSERT INTO CHANSON VALUES(9142,'Lieto',3,NULL,NULL,'2008-03-12 19:41:50');
INSERT INTO CHANSON VALUES(9143,'Sanat',3,NULL,'f','2008-03-12 17:35:55');
INSERT INTO CHANSON VALUES(9144,'Meri',3,NULL,'f','2008-03-12 18:25:58');
INSERT INTO CHANSON VALUES(9145,'Czerkinsky',5,NULL,'f','2008-03-12 19:48:55');
INSERT INTO CHANSON VALUES(9146,'Natacha',5,NULL,'f','2008-03-12 12:07:03');
INSERT INTO CHANSON VALUES(9147,'I''m hot',5,NULL,'f','2008-03-12 18:32:34');
INSERT INTO CHANSON VALUES(9148,'Le monde entier',5,NULL,'f','2008-03-12 17:26:02');
INSERT INTO CHANSON VALUES(9149,'Princesse de cire',5,NULL,'f','2008-03-12 17:52:11');
INSERT INTO CHANSON VALUES(9150,'Les sacs en plastic',5,NULL,'f','2008-03-12 11:40:28');
INSERT INTO CHANSON VALUES(9151,'Les anges (ne pleurez pas)',5,NULL,NULL,'2008-03-12 08:36:10');
INSERT INTO CHANSON VALUES(9152,'Miss Caraïbes',5,NULL,'f','2008-03-12 13:33:51');
INSERT INTO CHANSON VALUES(9153,'Redonne moi la nuit',5,NULL,'f','2008-03-12 11:18:26');
INSERT INTO CHANSON VALUES(9154,'Pour être aimé, faut être aimable',5,NULL,'f','2008-03-12 10:12:52');
INSERT INTO CHANSON VALUES(9155,'Georges Guétary 10-04-81',7,NULL,'f','2008-03-12 10:09:40');
INSERT INTO CHANSON VALUES(9156,'Roger Coggio 11-10-82',7,NULL,'f','2008-03-12 09:33:48');
INSERT INTO CHANSON VALUES(9157,'Charles Dumont 18-10-82',7,NULL,'f','2008-03-12 09:24:21');
INSERT INTO CHANSON VALUES(9158,'Gisèle Halimi 20-10-82',7,NULL,'f','2008-03-12 16:11:47');
INSERT INTO CHANSON VALUES(9159,'François Béranger 21-10-82',7,NULL,'f','2008-03-12 17:57:40');
INSERT INTO CHANSON VALUES(9160,'André Balland 04-11-82',7,NULL,'f','2008-03-12 19:15:20');
INSERT INTO CHANSON VALUES(9161,'Robert Dhéry 05-11-82',7,NULL,'f','2008-03-12 13:19:56');
INSERT INTO CHANSON VALUES(9162,'Sapho 16-11-82',7,NULL,'f','2008-03-12 15:45:29');
INSERT INTO CHANSON VALUES(9163,'Avoir tort',7,NULL,'f','2008-03-12 13:00:48');
INSERT INTO CHANSON VALUES(9164,'Pascaline',7,NULL,'f','2008-03-12 19:12:01');
INSERT INTO CHANSON VALUES(9165,'Le sida a rendez-vous avec la Lune',7,NULL,'f','2008-03-12 17:22:10');
INSERT INTO CHANSON VALUES(9166,'Le nouveau vingt heures',7,NULL,'f','2008-03-12 13:28:44');
INSERT INTO CHANSON VALUES(9167,'La politique',7,NULL,'f','2008-03-12 11:37:09');
INSERT INTO CHANSON VALUES(9168,'Bath-man',7,NULL,'f','2008-03-12 15:21:20');
INSERT INTO CHANSON VALUES(9169,'La suisse',7,NULL,'f','2008-03-12 13:08:18');
INSERT INTO CHANSON VALUES(9170,'Les versets érotique',7,NULL,'f','2008-03-12 09:06:33');
INSERT INTO CHANSON VALUES(9171,'La grande Jaja',7,NULL,'f','2008-03-12 13:33:53');
INSERT INTO CHANSON VALUES(9172,'Jean-Marie la pine',7,NULL,'f','2008-03-12 12:09:38');
INSERT INTO CHANSON VALUES(9173,'Super malades show',7,NULL,'f','2008-03-12 18:37:38');
INSERT INTO CHANSON VALUES(9174,'Foule sentimentale',5,NULL,NULL,'2008-03-12 16:32:51');
INSERT INTO CHANSON VALUES(9175,'L''amour à la machine',5,NULL,NULL,'2008-03-12 16:19:13');
INSERT INTO CHANSON VALUES(9176,'Sous les jupes des filles',5,NULL,'f','2008-03-12 18:47:42');
INSERT INTO CHANSON VALUES(9179,'Arlette laguiller',5,NULL,'f','2008-03-12 09:06:49');
INSERT INTO CHANSON VALUES(9181,'Sans queue ni tête',5,NULL,'f','2008-03-12 19:37:29');
INSERT INTO CHANSON VALUES(9183,'Le zèbre',5,NULL,'f','2008-03-12 13:52:16');
INSERT INTO CHANSON VALUES(9184,'C''est déjà ça',5,NULL,'f','2008-03-12 09:33:49');
INSERT INTO CHANSON VALUES(9185,'Introduction',5,NULL,'f','2008-03-12 19:15:09');
INSERT INTO CHANSON VALUES(9186,'La Mort D''Orion',5,NULL,'f','2008-03-12 10:07:57');
INSERT INTO CHANSON VALUES(9187,'Où l''horizon prend fin',5,NULL,'f','2008-03-12 19:45:01');
INSERT INTO CHANSON VALUES(9188,'Salomon l''hermite',5,NULL,'f','2008-03-12 11:31:42');
INSERT INTO CHANSON VALUES(9189,'Final',5,NULL,'f','2008-03-12 19:38:49');
INSERT INTO CHANSON VALUES(9190,'Vivent Les Hommes (Part 1)',5,NULL,'f','2008-03-12 17:03:01');
INSERT INTO CHANSON VALUES(9191,'Enchaînement',5,NULL,'f','2008-03-12 16:02:39');
INSERT INTO CHANSON VALUES(9192,'Ils',5,NULL,'f','2008-03-12 10:53:39');
INSERT INTO CHANSON VALUES(9193,'Le Paradis Terrestre',5,NULL,'f','2008-03-12 18:22:31');
INSERT INTO CHANSON VALUES(9194,'Elégie Funèbre',5,NULL,'f','2008-03-12 09:31:05');
INSERT INTO CHANSON VALUES(9195,'Royaume de Siam',5,NULL,'f','2008-03-12 19:31:20');
INSERT INTO CHANSON VALUES(9196,'La mer n''a pas cesse de descendre',5,NULL,'f','2008-03-12 09:44:28');
INSERT INTO CHANSON VALUES(9197,'Le jour ou tu voudras partir',5,NULL,'f','2008-03-12 08:40:13');
INSERT INTO CHANSON VALUES(9198,'Manteau rouge',5,NULL,'f','2008-03-12 09:55:45');
INSERT INTO CHANSON VALUES(9199,'Les iles de la Sonde',5,NULL,'f','2008-03-12 17:52:24');
INSERT INTO CHANSON VALUES(9200,'Le pont',5,NULL,'f','2008-03-12 15:39:28');
INSERT INTO CHANSON VALUES(9201,'La neige est blanche',5,NULL,NULL,'2008-03-12 15:22:30');
INSERT INTO CHANSON VALUES(9202,'Quand tu portes',5,NULL,'f','2008-03-12 11:35:24');
INSERT INTO CHANSON VALUES(9203,'Ton ame heureuse',5,NULL,'f','2008-03-12 19:27:47');
INSERT INTO CHANSON VALUES(9204,'Le masque sur le mur',5,NULL,'f','2008-03-12 13:35:18');
INSERT INTO CHANSON VALUES(9205,'Les clés du paradis',5,NULL,'f','2008-03-12 14:34:49');
INSERT INTO CHANSON VALUES(9206,'Les avalanches',5,NULL,'f','2008-03-12 18:41:34');
INSERT INTO CHANSON VALUES(9207,'A la légère',5,NULL,NULL,'2008-03-12 12:45:14');
INSERT INTO CHANSON VALUES(9208,'Plus loin de ta rue',5,NULL,NULL,'2008-03-12 15:51:10');
INSERT INTO CHANSON VALUES(9209,'Trouble',5,NULL,'f','2008-03-12 12:39:02');
INSERT INTO CHANSON VALUES(9210,'La bulle',5,NULL,'f','2008-03-12 17:17:41');
INSERT INTO CHANSON VALUES(9211,'Love slow motion',5,NULL,'f','2008-03-12 11:56:04');
INSERT INTO CHANSON VALUES(9212,'Si tout était faux',5,NULL,'f','2008-03-12 17:14:39');
INSERT INTO CHANSON VALUES(9213,'L''autre moi',5,NULL,'f','2008-03-12 10:11:06');
INSERT INTO CHANSON VALUES(9214,'La pleine lune',5,NULL,'f','2008-03-12 19:41:42');
INSERT INTO CHANSON VALUES(9215,'Simple en français',5,NULL,'f','2008-03-12 11:15:16');
INSERT INTO CHANSON VALUES(9216,'C''est comme ça',5,NULL,'f','2008-03-12 09:10:57');
INSERT INTO CHANSON VALUES(9217,'Trompe la mort',5,NULL,NULL,'2008-03-26 18:09:36');
INSERT INTO CHANSON VALUES(9218,'Les ricochets',5,NULL,'f','2008-03-12 16:34:43');
INSERT INTO CHANSON VALUES(9219,'Tempête dans un bénitier',5,NULL,'f','2008-03-26 19:11:34');
INSERT INTO CHANSON VALUES(9220,'Le boulevard du temps qui passe',5,NULL,'f','2008-03-12 09:34:14');
INSERT INTO CHANSON VALUES(9221,'Le modeste',5,NULL,'f','2008-03-12 09:22:32');
INSERT INTO CHANSON VALUES(9222,'Don Juan',5,NULL,'f','2008-04-13 11:54:11');
INSERT INTO CHANSON VALUES(9223,'Mélanie',5,NULL,'f','2008-03-12 18:39:28');
INSERT INTO CHANSON VALUES(9224,'Les casseuses',5,NULL,'f','2008-03-12 18:26:42');
INSERT INTO CHANSON VALUES(9225,'Cupidon s''en fout',5,NULL,NULL,'2008-04-13 18:43:33');
INSERT INTO CHANSON VALUES(9226,'Montélimar',5,NULL,'f','2008-03-12 14:37:54');
INSERT INTO CHANSON VALUES(9227,'Histoire de faussaire',5,NULL,'f','2008-03-12 16:36:35');
INSERT INTO CHANSON VALUES(9228,'La messe au pendu',5,NULL,'f','2008-03-12 12:53:51');
INSERT INTO CHANSON VALUES(9229,'Lèche-cocu',5,NULL,'f','2008-03-12 15:59:02');
INSERT INTO CHANSON VALUES(9230,'Les patriotes',5,NULL,'f','2008-03-12 15:40:36');
INSERT INTO CHANSON VALUES(9231,'La visite',5,NULL,'f','2008-03-12 12:36:47');
INSERT INTO CHANSON VALUES(9232,'élégie à un rat de cave',5,NULL,'f','2008-03-24 19:20:25');
INSERT INTO CHANSON VALUES(9239,'Les biches',5,NULL,'f','2008-03-12 12:15:58');
INSERT INTO CHANSON VALUES(9244,'Les copains d''abord',5,NULL,'f','2008-03-24 09:00:51');
INSERT INTO CHANSON VALUES(9245,'Les quat''z''arts',5,NULL,'f','2008-04-13 15:37:15');
INSERT INTO CHANSON VALUES(9246,'Le petit joueur de flûteau',5,NULL,'f','2008-03-26 09:48:22');
INSERT INTO CHANSON VALUES(9247,'La tondue',5,NULL,'f','2008-03-26 14:38:41');
INSERT INTO CHANSON VALUES(9248,'Le vingt-deux septembre',5,NULL,'f','2008-03-24 17:02:56');
INSERT INTO CHANSON VALUES(9249,'Les deux oncles',5,NULL,'f','2008-03-24 16:01:30');
INSERT INTO CHANSON VALUES(9250,'Vénus callipyge',5,NULL,'f','2008-03-26 15:40:27');
INSERT INTO CHANSON VALUES(9251,'Le mouton de Panurge',5,NULL,'f','2008-03-24 10:49:56');
INSERT INTO CHANSON VALUES(9252,'La route aux quatre chansons',5,NULL,'f','2008-03-26 19:04:39');
INSERT INTO CHANSON VALUES(9253,'Saturne',5,NULL,'f','2008-03-26 15:25:51');
INSERT INTO CHANSON VALUES(9254,'Le grand Pan',5,NULL,'f','2008-03-12 15:18:25');
INSERT INTO CHANSON VALUES(9256,'Javanaise remake',5,NULL,'f','2008-03-12 11:31:52');
INSERT INTO CHANSON VALUES(9258,'Les locataires',5,NULL,'f','2008-03-12 14:19:42');
INSERT INTO CHANSON VALUES(9259,'Des laids des laids',5,NULL,'f','2008-03-12 12:10:26');
INSERT INTO CHANSON VALUES(9260,'Brigade des stups',5,NULL,'f','2008-03-12 19:25:20');
INSERT INTO CHANSON VALUES(9261,'Vieille Canaille ''You rascal you''',5,NULL,'f','2008-03-12 09:31:08');
INSERT INTO CHANSON VALUES(9262,'Lola Rastaquouere',5,NULL,'f','2008-03-12 14:06:45');
INSERT INTO CHANSON VALUES(9263,'Relax baby be cool',5,NULL,'f','2008-03-12 17:46:47');
INSERT INTO CHANSON VALUES(9264,'Daisy temple',5,NULL,NULL,'2008-03-12 11:26:05');
INSERT INTO CHANSON VALUES(9265,'Eau et gaz à tous les étages',5,NULL,'f','2008-03-12 16:03:42');
INSERT INTO CHANSON VALUES(9266,'Pas long feu',5,NULL,'f','2008-03-12 16:21:14');
INSERT INTO CHANSON VALUES(9267,'Marilou reggae dub',5,NULL,'f','2008-03-12 14:54:28');
INSERT INTO CHANSON VALUES(9268,'Overseas telegram',5,NULL,'f','2008-03-12 11:27:48');
INSERT INTO CHANSON VALUES(9269,'Ecce homo',5,NULL,'f','2008-03-12 19:51:58');
INSERT INTO CHANSON VALUES(9270,'Mickey Maousse',5,NULL,'f','2008-03-12 13:49:23');
INSERT INTO CHANSON VALUES(9271,'Juif et dieu',5,NULL,'f','2008-03-12 17:58:55');
INSERT INTO CHANSON VALUES(9272,'Shush Shush Charlotte',5,NULL,'f','2008-03-12 19:30:01');
INSERT INTO CHANSON VALUES(9273,'Toi mourrir',5,NULL,'f','2008-03-12 16:17:48');
INSERT INTO CHANSON VALUES(9274,'La nostalgie camarade',5,NULL,'f','2008-03-12 13:35:14');
INSERT INTO CHANSON VALUES(9275,'Bana basadi balalo',5,NULL,'f','2008-03-12 14:19:18');
INSERT INTO CHANSON VALUES(9276,'Evguenie sokolov',5,NULL,NULL,'2008-03-12 11:01:39');
INSERT INTO CHANSON VALUES(9277,'Negusa nagast',5,NULL,NULL,'2008-03-12 14:36:34');
INSERT INTO CHANSON VALUES(9278,'Strike',5,NULL,NULL,'2008-03-12 08:53:01');
INSERT INTO CHANSON VALUES(9279,'Bad news from the stars',5,NULL,'f','2008-03-12 17:53:53');
INSERT INTO CHANSON VALUES(9280,'Harley Davidson',5,NULL,'f','2008-03-12 17:19:42');
INSERT INTO CHANSON VALUES(9281,'Elle est si',5,NULL,'f','2008-03-12 10:06:41');
INSERT INTO CHANSON VALUES(9284,'Le Bagad de Lann Bihoué',5,NULL,'f','2008-03-12 19:11:06');
INSERT INTO CHANSON VALUES(9285,'Quand j''serai KO',5,NULL,'f','2008-03-12 10:45:25');
INSERT INTO CHANSON VALUES(9288,'La ballade de Jim',5,NULL,'f','2008-03-12 16:35:57');
INSERT INTO CHANSON VALUES(9290,'Medley',5,NULL,'f','2008-03-12 15:11:11');
INSERT INTO CHANSON VALUES(9291,'Bidon',5,NULL,'f','2008-03-12 12:23:17');
INSERT INTO CHANSON VALUES(9293,'Les filles électriques',5,NULL,'f','2008-03-12 11:38:01');
INSERT INTO CHANSON VALUES(9302,'Supplique pour être enterré à la plage de Sète',5,NULL,'f','2008-03-26 11:17:00');
INSERT INTO CHANSON VALUES(9303,'Le fantme',5,NULL,'f','2008-04-13 19:59:05');
INSERT INTO CHANSON VALUES(9304,'La fessée',5,NULL,'f','2008-04-13 14:52:15');
INSERT INTO CHANSON VALUES(9305,'Le pluriel',5,NULL,'f','2008-03-26 17:27:35');
INSERT INTO CHANSON VALUES(9306,'Les quatre bacheliers',5,NULL,'f','2008-03-26 18:12:10');
INSERT INTO CHANSON VALUES(9307,'Le bulletin de santé',5,NULL,'f','2008-03-24 17:58:34');
INSERT INTO CHANSON VALUES(9308,'Ouverture',5,NULL,'f','2008-03-12 16:38:46');
INSERT INTO CHANSON VALUES(9309,'Rendez-vous à Vedra',5,NULL,'f','2008-03-12 18:01:09');
INSERT INTO CHANSON VALUES(9310,'Le grand sommeil',5,NULL,'f','2008-03-12 09:06:39');
INSERT INTO CHANSON VALUES(9311,'Corps et armes',5,NULL,'f','2008-03-12 13:22:17');
INSERT INTO CHANSON VALUES(9312,'Jungle pulse',5,NULL,'f','2008-03-12 13:09:52');
INSERT INTO CHANSON VALUES(9313,'Sur mon cou',5,NULL,'f','2008-03-12 16:02:39');
INSERT INTO CHANSON VALUES(9314,'L''année du dragon',5,NULL,NULL,'2008-03-12 15:20:57');
INSERT INTO CHANSON VALUES(9315,'Des attractions désastre',5,NULL,'f','2008-03-12 16:06:25');
INSERT INTO CHANSON VALUES(9316,'Saudade',5,NULL,'f','2008-03-12 11:57:37');
INSERT INTO CHANSON VALUES(9317,'Soudain',5,NULL,'f','2008-03-12 13:45:36');
INSERT INTO CHANSON VALUES(9318,'Au commencement',5,NULL,'f','2008-03-12 08:25:15');
INSERT INTO CHANSON VALUES(9319,'Aragon Et Castille',5,NULL,'f','2008-03-23 17:17:16');
INSERT INTO CHANSON VALUES(9320,'Framboise (Du Film "Tirez Sur Le Pianiste")',5,NULL,NULL,'2008-03-12 19:25:22');
INSERT INTO CHANSON VALUES(9321,'Marcelle (Du Film "Tirez Sur Le Pianiste")',5,NULL,'f','2008-03-12 15:53:45');
INSERT INTO CHANSON VALUES(9322,'Insomnie',5,NULL,NULL,'2008-03-12 18:22:54');
INSERT INTO CHANSON VALUES(9323,'Le Poisson Fa',5,NULL,NULL,'2008-03-12 17:03:56');
INSERT INTO CHANSON VALUES(9324,'Embrouille-Minet',5,NULL,'f','2008-03-12 13:43:17');
INSERT INTO CHANSON VALUES(9325,'Petit Homme Qui Vit D''espoir',5,NULL,'f','2008-03-12 12:23:24');
INSERT INTO CHANSON VALUES(9326,'Bobo Léon',5,NULL,'f','2008-03-12 17:39:21');
INSERT INTO CHANSON VALUES(9327,'Tchita',5,NULL,'f','2008-03-12 13:06:06');
INSERT INTO CHANSON VALUES(9328,'Le Beau Voyage',5,NULL,'f','2008-03-12 08:07:32');
INSERT INTO CHANSON VALUES(9329,'L''ange',5,NULL,'f','2008-03-12 11:55:49');
INSERT INTO CHANSON VALUES(9330,'Troubadour Ou La Crue Du Tage "Chanson Fleuve"',5,NULL,'f','2008-03-12 19:29:08');
INSERT INTO CHANSON VALUES(9331,'La Fleur Bleue Contondante',5,NULL,'f','2008-03-12 16:22:31');
INSERT INTO CHANSON VALUES(9332,'La Fille Du Pêcheur',5,NULL,'f','2008-03-12 15:09:35');
INSERT INTO CHANSON VALUES(9333,'Eh! Toto',5,NULL,'f','2008-03-12 14:35:18');
INSERT INTO CHANSON VALUES(9334,'L''hélicon',5,NULL,'f','2008-03-23 18:58:42');
INSERT INTO CHANSON VALUES(9335,'Léna',5,NULL,'f','2008-03-12 11:47:21');
INSERT INTO CHANSON VALUES(9336,'La Peinture À L''huile',5,NULL,'f','2008-03-12 15:13:28');
INSERT INTO CHANSON VALUES(9337,'Hé! V''nez Les Potes',5,NULL,'f','2008-03-12 16:15:35');
INSERT INTO CHANSON VALUES(9338,'J''ai Fantaisie',5,NULL,'f','2008-03-12 11:32:31');
INSERT INTO CHANSON VALUES(9339,'Leçon De Guitare Sommaire',5,NULL,'f','2008-03-12 09:07:24');
INSERT INTO CHANSON VALUES(9340,'Ta Katie T''a Quitté',5,NULL,NULL,'2008-03-23 12:04:53');
INSERT INTO CHANSON VALUES(9341,'Je Joue Du Violon Tzigane',5,NULL,'f','2008-03-23 14:47:15');
INSERT INTO CHANSON VALUES(9342,'T''as Pas, T''as Pas Tout Dit',5,NULL,'f','2008-03-23 08:25:25');
INSERT INTO CHANSON VALUES(9343,'Le Papa Du Papa',5,NULL,'f','2008-03-23 15:59:00');
INSERT INTO CHANSON VALUES(9344,' Aubade à Lydie en do',5,NULL,'f','2008-03-23 19:51:58');
INSERT INTO CHANSON VALUES(9345,'Lumière Tango',5,NULL,'f','2008-03-23 15:07:45');
INSERT INTO CHANSON VALUES(9346,'From Two To Two',5,NULL,'f','2008-03-23 19:44:58');
INSERT INTO CHANSON VALUES(9347,'La godiche',5,NULL,'f','2008-03-12 13:28:14');
INSERT INTO CHANSON VALUES(9348,'Y''a du monde',5,NULL,'f','2008-03-12 08:44:47');
INSERT INTO CHANSON VALUES(9349,'J''ai aimé',5,NULL,'f','2008-03-12 15:50:54');
INSERT INTO CHANSON VALUES(9350,'Placébo',5,NULL,'f','2008-03-12 19:12:58');
INSERT INTO CHANSON VALUES(9351,'Manquait plus qu''ça',5,NULL,'f','2008-03-12 18:42:46');
INSERT INTO CHANSON VALUES(9352,'Vos condoléances',5,NULL,'f','2008-03-12 09:44:11');
INSERT INTO CHANSON VALUES(9353,'M''envoyer des fleurs',5,NULL,'f','2008-03-12 14:21:11');
INSERT INTO CHANSON VALUES(9355,'Le chagrin d''une fille',5,NULL,'f','2008-03-12 14:54:10');
INSERT INTO CHANSON VALUES(9356,'Le quotidien',5,NULL,NULL,'2008-03-12 11:54:55');
INSERT INTO CHANSON VALUES(9357,'Girl',5,NULL,NULL,'2008-03-12 11:22:23');
INSERT INTO CHANSON VALUES(9360,'Où va la chance ?',5,NULL,'f','2008-03-12 10:01:11');
INSERT INTO CHANSON VALUES(9364,'La mésange',5,NULL,'f','2008-03-12 10:35:00');
INSERT INTO CHANSON VALUES(9365,'Parlez-moi de lui',5,NULL,'f','2008-03-12 12:09:17');
INSERT INTO CHANSON VALUES(9366,'A quoi ça sert ?',5,NULL,'f','2008-03-12 13:42:12');
INSERT INTO CHANSON VALUES(9367,'Il vaut mieux qu''une petite maison dans la main qu''un grand château dans les nuages',5,NULL,'f','2008-03-12 15:00:07');
INSERT INTO CHANSON VALUES(9368,'La rue des curs perdus',5,NULL,'f','2008-03-24 14:17:29');
INSERT INTO CHANSON VALUES(9369,'Etonnez-moi, Benoît... !',5,NULL,NULL,'2008-03-12 18:49:56');
INSERT INTO CHANSON VALUES(9370,'La mer, les étoiles et le vent',5,NULL,NULL,'2008-03-12 08:07:58');
INSERT INTO CHANSON VALUES(9371,'La Jeune Fille Aux Cheveux Blancs',5,NULL,'f','2008-03-12 08:20:59');
INSERT INTO CHANSON VALUES(9372,'Ta Douleur',5,NULL,'f','2008-03-12 10:32:53');
INSERT INTO CHANSON VALUES(9373,'Assise',5,NULL,'f','2008-03-12 09:30:55');
INSERT INTO CHANSON VALUES(9374,'Janine 1',5,NULL,'f','2008-03-12 17:40:31');
INSERT INTO CHANSON VALUES(9375,'Vous',5,NULL,'f','2008-03-12 17:02:41');
INSERT INTO CHANSON VALUES(9376,'Baby Carni Bird',5,NULL,'f','2008-03-12 08:27:23');
INSERT INTO CHANSON VALUES(9377,'Pour Que L''Amour Me Quitte',5,NULL,'f','2008-03-12 11:03:23');
INSERT INTO CHANSON VALUES(9378,'Zenza',5,NULL,'f','2008-03-12 12:34:41');
INSERT INTO CHANSON VALUES(9379,'Janine 2',5,NULL,'f','2008-03-12 18:28:30');
INSERT INTO CHANSON VALUES(9380,'Vertigo',5,NULL,'f','2008-03-12 17:30:38');
INSERT INTO CHANSON VALUES(9381,'Au Port',5,NULL,'f','2008-03-12 17:31:59');
INSERT INTO CHANSON VALUES(9382,'Janine 3',5,NULL,'f','2008-03-12 17:44:31');
INSERT INTO CHANSON VALUES(9383,'Pâle Septembre',5,NULL,'f','2008-03-12 15:50:01');
INSERT INTO CHANSON VALUES(9384,'Rue De Ménilmontant',5,NULL,'f','2008-03-12 15:35:42');
INSERT INTO CHANSON VALUES(9385,'Quand Je Marche',5,NULL,'f','2008-03-12 09:21:45');
INSERT INTO CHANSON VALUES(9387,'1.2.3',5,NULL,'f','2008-03-12 10:40:16');
INSERT INTO CHANSON VALUES(9388,'Paris',5,NULL,'f','2008-03-12 14:02:50');
INSERT INTO CHANSON VALUES(9389,'La demeure d''un ciel',5,NULL,'f','2008-03-12 11:55:19');
INSERT INTO CHANSON VALUES(9390,'Les ex',5,NULL,'f','2008-03-12 17:44:49');
INSERT INTO CHANSON VALUES(9391,'Mon petit vieux',5,NULL,'f','2008-03-12 13:31:21');
INSERT INTO CHANSON VALUES(9392,'Ruby',5,NULL,'f','2008-03-12 12:17:05');
INSERT INTO CHANSON VALUES(9393,'Le sac des filles',5,NULL,'f','2008-03-12 19:57:56');
INSERT INTO CHANSON VALUES(9394,'Un homme déserté',5,NULL,NULL,'2008-03-12 19:32:31');
INSERT INTO CHANSON VALUES(9395,'Je ne suis pas ta chose',5,NULL,NULL,'2008-03-12 16:38:52');
INSERT INTO CHANSON VALUES(9396,'Elle s''en va',5,NULL,NULL,'2008-03-12 13:26:17');
INSERT INTO CHANSON VALUES(9397,'Là ou je suis née',5,NULL,'f','2008-03-12 15:37:57');
INSERT INTO CHANSON VALUES(9398,'Larvatus Prodéo',5,NULL,'f','2008-03-12 19:11:00');
INSERT INTO CHANSON VALUES(9399,'À l''amour comme à la guerre',5,NULL,'f','2008-03-12 17:27:55');
INSERT INTO CHANSON VALUES(9400,'Drle de Caroline',5,NULL,'f','2008-03-12 09:14:40');
INSERT INTO CHANSON VALUES(9401,'Chte play plus',5,NULL,'f','2008-03-12 19:39:12');
INSERT INTO CHANSON VALUES(9402,'Cinéma',5,NULL,'f','2008-03-12 11:03:30');
INSERT INTO CHANSON VALUES(9403,'Jeune fille interdite',5,NULL,'f','2008-03-12 12:59:27');
INSERT INTO CHANSON VALUES(9404,'Parfaitement, parce que',5,NULL,'f','2008-03-12 11:56:59');
INSERT INTO CHANSON VALUES(9405,'Suave mari magno',5,NULL,'f','2008-03-12 18:37:38');
INSERT INTO CHANSON VALUES(9406,'Demi-mots amers',5,NULL,'f','2008-03-12 16:02:05');
INSERT INTO CHANSON VALUES(9407,'Un requin drle',5,NULL,'f','2008-03-12 08:41:42');
INSERT INTO CHANSON VALUES(9408,'Mon cur et le monde bougent',5,NULL,'f','2008-03-24 19:37:54');
INSERT INTO CHANSON VALUES(9409,'Autoroute zéro',5,NULL,'f','2008-03-12 19:23:22');
INSERT INTO CHANSON VALUES(9420,'Le mal intérieur',5,NULL,'f','2008-03-12 13:48:09');
INSERT INTO CHANSON VALUES(9424,'Physique et sans ennui',5,NULL,'f','2008-03-12 08:11:46');
INSERT INTO CHANSON VALUES(9425,'Jaures',5,NULL,NULL,'2008-03-12 11:56:01');
INSERT INTO CHANSON VALUES(9426,'La ville s''endormait',5,NULL,'f','2008-03-12 10:19:59');
INSERT INTO CHANSON VALUES(9427,'Vieillir',5,NULL,'f','2008-03-12 09:48:57');
INSERT INTO CHANSON VALUES(9429,'Les F...',5,NULL,'f','2008-03-12 08:06:48');
INSERT INTO CHANSON VALUES(9430,'Orly',5,NULL,'f','2008-03-12 16:35:37');
INSERT INTO CHANSON VALUES(9431,'Les remparts de Varsovie',5,NULL,'f','2008-03-12 18:41:00');
INSERT INTO CHANSON VALUES(9433,'Knokke-le-Zoute Tango',5,NULL,'f','2008-03-12 16:45:38');
INSERT INTO CHANSON VALUES(9434,'Jojo',5,NULL,NULL,'2008-03-12 09:47:49');
INSERT INTO CHANSON VALUES(9435,'Le lion',5,NULL,'f','2008-03-12 18:07:45');
INSERT INTO CHANSON VALUES(9436,'Les marquises',5,NULL,'f','2008-03-12 18:19:05');
INSERT INTO CHANSON VALUES(9437,'La non-demande en mariage',5,NULL,'f','2008-03-24 11:35:14');
INSERT INTO CHANSON VALUES(9438,'Le grand chene',5,NULL,'f','2008-03-24 18:29:53');
INSERT INTO CHANSON VALUES(9439,'Concurrence déloyale',5,NULL,'f','2008-03-24 16:46:03');
INSERT INTO CHANSON VALUES(9440,'L''épave',5,NULL,'f','2008-03-24 15:43:07');
INSERT INTO CHANSON VALUES(9441,'Le moyenâgeux',5,NULL,NULL,'2008-03-24 11:20:33');
INSERT INTO CHANSON VALUES(9442,'Misogynie a part',5,NULL,NULL,'2008-03-24 10:39:02');
INSERT INTO CHANSON VALUES(9443,'Bécassine',5,NULL,'f','2008-04-13 15:28:22');
INSERT INTO CHANSON VALUES(9444,'L''ancetre',5,NULL,'f','2008-03-12 18:18:54');
INSERT INTO CHANSON VALUES(9445,'Rien a jeter',5,NULL,'f','2008-03-12 16:22:00');
INSERT INTO CHANSON VALUES(9446,'Les oiseaux de passage',5,NULL,'f','2008-03-12 14:05:36');
INSERT INTO CHANSON VALUES(9447,'La religieuse',5,NULL,'f','2008-03-12 10:58:17');
INSERT INTO CHANSON VALUES(9448,'Pensees de mort',5,NULL,'f','2008-03-12 10:24:20');
INSERT INTO CHANSON VALUES(9449,'La rose, la bouteille, et la poignee ..',5,NULL,'f','2008-03-12 12:08:06');
INSERT INTO CHANSON VALUES(9450,'Sale petit bonhomme',5,NULL,'f','2008-03-12 08:15:54');
INSERT INTO CHANSON VALUES(9451,'Introduction',1,NULL,NULL,'2008-03-12 18:08:01');
INSERT INTO CHANSON VALUES(9452,'Prologue: D''anciennes haines endormies..',1,NULL,NULL,'2008-03-12 15:01:21');
INSERT INTO CHANSON VALUES(9453,'Prologue: La fete est terminee..',1,NULL,NULL,'2008-03-12 16:54:50');
INSERT INTO CHANSON VALUES(9454,'Strophes:  Premiers transports que nul n''oublie',1,NULL,NULL,'2008-03-12 15:45:08');
INSERT INTO CHANSON VALUES(9455,'Scherzetto:  Mab la messagere...',1,NULL,NULL,'2008-03-12 13:30:30');
INSERT INTO CHANSON VALUES(9456,'Scherzetto:  Bientot la mort est souveraine...',1,NULL,NULL,'2008-03-12 14:03:36');
INSERT INTO CHANSON VALUES(9457,'Romeo seul',1,NULL,NULL,'2008-03-12 09:13:34');
INSERT INTO CHANSON VALUES(9458,'Scene d''amour',1,NULL,NULL,'2008-03-12 12:25:59');
INSERT INTO CHANSON VALUES(9459,'La Reine Mab, ou la fee des songes',1,NULL,NULL,'2008-03-12 16:47:08');
INSERT INTO CHANSON VALUES(9460,'Prologue (Version Original): D''anciennes haines endormies..',1,NULL,NULL,'2008-03-12 18:47:23');
INSERT INTO CHANSON VALUES(9461,'Prologue: Pousse par un desir..',1,NULL,NULL,'2008-03-12 16:38:31');
INSERT INTO CHANSON VALUES(9462,'Scherzetto (Version Originale): Mab la messagere...',1,NULL,NULL,'2008-03-12 17:14:33');
INSERT INTO CHANSON VALUES(9463,'Scherzetto (version originale): Tel son d''abord, tels sont les tableaux',1,NULL,NULL,'2008-03-12 09:56:28');
INSERT INTO CHANSON VALUES(9465,'The Way I Walk',5,NULL,'f','2008-03-12 09:02:43');
INSERT INTO CHANSON VALUES(9466,'Let Me Try',5,NULL,'f','2008-03-12 15:32:47');
INSERT INTO CHANSON VALUES(9469,'Yo Quiero',5,NULL,'f','2008-03-12 17:46:13');
INSERT INTO CHANSON VALUES(9471,'Let Yeux Nois',5,NULL,'f','2008-03-12 12:21:39');
INSERT INTO CHANSON VALUES(9472,'Sunny Afternoon',5,NULL,'f','2008-03-12 18:07:54');
INSERT INTO CHANSON VALUES(9473,'Le Sacre Du Printemps',5,NULL,'f','2008-03-12 13:14:51');
INSERT INTO CHANSON VALUES(9474,'L''Été Indien',5,NULL,'f','2008-03-12 18:12:23');
INSERT INTO CHANSON VALUES(9475,'The Third Man Theme',5,NULL,'f','2008-03-12 09:19:25');
INSERT INTO CHANSON VALUES(9478,'Zuhalter Ballade',5,NULL,NULL,'2008-03-12 15:00:39');
INSERT INTO CHANSON VALUES(9479,'Le Temps de Cerises',5,NULL,'f','2008-03-12 09:49:26');
INSERT INTO CHANSON VALUES(9480,'Ti Amo',5,NULL,'f','2008-03-12 11:45:03');
INSERT INTO CHANSON VALUES(9481,'Amapola',5,NULL,'f','2008-03-12 11:05:25');
INSERT INTO CHANSON VALUES(9482,'The Godfather Waltz',5,NULL,'f','2008-03-12 19:57:32');
INSERT INTO CHANSON VALUES(9483,'La Bella Ciao',5,NULL,'f','2008-03-12 18:23:47');
INSERT INTO CHANSON VALUES(9485,'Alifib',5,NULL,'f','2008-03-12 09:24:19');
INSERT INTO CHANSON VALUES(9487,'Moulin Rouge',5,NULL,'f','2008-03-12 14:54:29');
INSERT INTO CHANSON VALUES(9490,'L''Air de Bijoux',5,NULL,'f','2008-03-12 10:57:04');
INSERT INTO CHANSON VALUES(9491,'Dali''s Car',5,NULL,'f','2008-03-12 11:17:10');
INSERT INTO CHANSON VALUES(9494,'Qui c''est celui-la',5,NULL,'f','2008-03-12 08:56:48');
INSERT INTO CHANSON VALUES(9495,'En vadrouille à Montpellier',5,NULL,'f','2008-03-12 08:05:12');
INSERT INTO CHANSON VALUES(9496,'Pauvre flic',5,NULL,'f','2008-03-12 12:39:28');
INSERT INTO CHANSON VALUES(9497,'Dans ma maison d''amour',5,NULL,NULL,'2008-03-12 16:12:23');
INSERT INTO CHANSON VALUES(9498,'Déshabille-toi',5,NULL,'f','2008-03-12 09:22:56');
INSERT INTO CHANSON VALUES(9499,'Je lui téléphone',5,NULL,'f','2008-03-12 15:10:35');
INSERT INTO CHANSON VALUES(9500,'Sophie',5,NULL,NULL,'2008-03-12 19:25:33');
INSERT INTO CHANSON VALUES(9501,'Enfant roi',5,NULL,'f','2008-03-12 08:44:50');
INSERT INTO CHANSON VALUES(9502,'J''ai trouvé un journal dans le hall de l''aéroport',5,NULL,'f','2008-03-12 10:27:07');
INSERT INTO CHANSON VALUES(9503,'L''amour amitié',5,NULL,'f','2008-03-12 12:43:17');
INSERT INTO CHANSON VALUES(9504,'Film',5,NULL,'f','2008-03-12 18:47:14');
INSERT INTO CHANSON VALUES(9505,'Le vent souffle où il veut et quand il veut',5,NULL,'f','2008-03-12 16:50:19');
INSERT INTO CHANSON VALUES(9506,'Tu t''en vas',5,NULL,'f','2008-03-12 18:14:59');
INSERT INTO CHANSON VALUES(9507,'Il est tard ce samedi soir',5,NULL,'f','2008-03-12 12:54:11');
INSERT INTO CHANSON VALUES(9508,'Puisque vous partez en voyage',5,NULL,'f','2008-03-12 17:03:33');
INSERT INTO CHANSON VALUES(9509,'Tous mes souvenirs me tuent (Tears)',5,NULL,NULL,'2008-03-12 16:43:44');
INSERT INTO CHANSON VALUES(9510,'Celui que tu veux',5,NULL,'f','2008-03-12 11:41:10');
INSERT INTO CHANSON VALUES(9511,'Clair-Obscur',5,NULL,'f','2008-03-12 18:44:54');
INSERT INTO CHANSON VALUES(9512,'Un homme est mort',5,NULL,'f','2008-03-12 16:57:22');
INSERT INTO CHANSON VALUES(9513,'Duck''s blues',5,NULL,'f','2008-03-12 18:19:05');
INSERT INTO CHANSON VALUES(9514,'I''ll be seeing you',5,NULL,'f','2008-03-12 09:12:53');
INSERT INTO CHANSON VALUES(9515,'Tu ressembles à tous ceux qui ont eu du chagrin',5,NULL,'f','2008-03-12 12:54:44');
INSERT INTO CHANSON VALUES(9517,'So sad',5,NULL,'f','2008-03-12 16:12:52');
INSERT INTO CHANSON VALUES(9519,'Contre vents et marées',5,NULL,'f','2008-03-12 13:42:40');
INSERT INTO CHANSON VALUES(9520,'La vérité des choses',5,NULL,'f','2008-03-12 10:02:21');
INSERT INTO CHANSON VALUES(9521,'Fidèle',5,NULL,'f','2008-03-12 12:55:05');
INSERT INTO CHANSON VALUES(9522,'La mer est grise',5,NULL,'f','2008-03-12 11:38:03');
INSERT INTO CHANSON VALUES(9523,'Y''a un grillon dans la maison',5,NULL,'f','2008-03-12 16:37:34');
INSERT INTO CHANSON VALUES(9524,'Le revenant',5,NULL,'f','2008-03-12 15:59:29');
INSERT INTO CHANSON VALUES(9525,'La dame au piano',5,NULL,'f','2008-03-12 12:41:18');
INSERT INTO CHANSON VALUES(9526,'Les accordéons',5,NULL,'f','2008-03-12 12:22:30');
INSERT INTO CHANSON VALUES(9527,'Il pleut sur ma chaumière',5,NULL,'f','2008-03-12 10:14:29');
INSERT INTO CHANSON VALUES(9528,'Joue moi de l''électrophone',5,NULL,'f','2008-03-12 10:41:12');
INSERT INTO CHANSON VALUES(9529,'L''homme au singe savant',5,NULL,'f','2008-03-12 18:53:15');
INSERT INTO CHANSON VALUES(9530,'Gilles je t''achète une automobile',5,NULL,'f','2008-03-12 10:15:10');
INSERT INTO CHANSON VALUES(9531,'Le gros Bill',5,NULL,'f','2008-03-12 11:32:48');
INSERT INTO CHANSON VALUES(9532,'La chance aux chansons',5,NULL,'f','2008-03-12 12:11:17');
INSERT INTO CHANSON VALUES(9533,'L''écologiste',5,NULL,'f','2008-03-12 16:56:54');
INSERT INTO CHANSON VALUES(9534,'Il vend des téléviseurs aux paysans',5,NULL,NULL,'2008-03-12 11:34:54');
INSERT INTO CHANSON VALUES(9535,'A la brocante',5,NULL,NULL,'2008-03-12 17:56:35');
INSERT INTO CHANSON VALUES(9536,'Amsterdam',5,NULL,NULL,'2008-03-12 09:16:57');
INSERT INTO CHANSON VALUES(9537,'Les timides',5,NULL,'f','2008-03-12 15:30:12');
INSERT INTO CHANSON VALUES(9538,'Le dernier repas',5,NULL,'f','2008-03-12 09:40:53');
INSERT INTO CHANSON VALUES(9539,'Les jardins du casino',5,NULL,'f','2008-03-12 11:31:47');
INSERT INTO CHANSON VALUES(9542,'Tango funèbre',5,NULL,'f','2008-03-12 14:21:46');
INSERT INTO CHANSON VALUES(9545,'Mathilde',5,NULL,'f','2008-03-12 15:09:13');
INSERT INTO CHANSON VALUES(9548,'Jef',5,NULL,'f','2008-03-12 12:56:41');
INSERT INTO CHANSON VALUES(9549,'Au suivant',5,NULL,'f','2008-03-12 11:14:12');
INSERT INTO CHANSON VALUES(9551,'Heureux qui comme Ulysse',5,NULL,'f','2008-04-13 13:52:22');
INSERT INTO CHANSON VALUES(9552,'Fernande',5,NULL,'f','2008-03-12 09:30:56');
INSERT INTO CHANSON VALUES(9553,'Stances à un cambrioleur',5,NULL,'f','2008-03-26 16:02:18');
INSERT INTO CHANSON VALUES(9554,'La ballade des gens qui sont nés quelque part',5,NULL,'f','2008-04-13 10:36:45');
INSERT INTO CHANSON VALUES(9555,'La princesse et le croques-notes',5,NULL,'f','2008-03-26 15:28:58');
INSERT INTO CHANSON VALUES(9556,'Sauf le respect que je vous dois',5,NULL,'f','2008-04-13 08:48:46');
INSERT INTO CHANSON VALUES(9557,'Le blason',5,NULL,'f','2008-03-12 13:15:55');
INSERT INTO CHANSON VALUES(9558,'Quatre-vingt-quinze pour cent',5,NULL,'f','2008-03-24 19:03:44');
INSERT INTO CHANSON VALUES(9559,'Mourir pour des idées',5,NULL,'f','2008-03-24 16:28:10');
INSERT INTO CHANSON VALUES(9560,'Les passantes',5,NULL,'f','2008-03-12 10:40:01');
INSERT INTO CHANSON VALUES(9561,'Le roi',5,NULL,'f','2008-03-12 10:03:57');
INSERT INTO CHANSON VALUES(9562,'A l''ombre des maris',5,NULL,'f','2008-03-24 13:15:27');
INSERT INTO CHANSON VALUES(9563,'Carcassonne',5,NULL,'f','2008-03-12 18:20:11');
INSERT INTO CHANSON VALUES(9564,'Ballade à la lune',5,NULL,NULL,'2008-03-12 09:24:58');
INSERT INTO CHANSON VALUES(9565,'Jehan l''advenu',5,NULL,'f','2008-03-12 08:31:29');
INSERT INTO CHANSON VALUES(9566,'A mon frère revenant d''Italie',5,NULL,'f','2008-03-12 19:13:32');
INSERT INTO CHANSON VALUES(9567,'Le roi boiteux',5,NULL,'f','2008-03-12 11:42:24');
INSERT INTO CHANSON VALUES(9583,'Vandanaa Trayee',3,NULL,NULL,'2008-03-12 08:50:00');
INSERT INTO CHANSON VALUES(9584,'Omkaaraaya Namaha',3,NULL,NULL,'2008-03-12 18:32:27');
INSERT INTO CHANSON VALUES(9585,'Vedic Chanting',3,NULL,NULL,'2008-03-12 09:13:57');
INSERT INTO CHANSON VALUES(9586,'Asato Maa',3,NULL,NULL,'2008-03-12 18:24:26');
INSERT INTO CHANSON VALUES(9587,'Sahanaa Vavavtu',3,NULL,NULL,'2008-03-12 18:07:12');
INSERT INTO CHANSON VALUES(9588,'Poornamadah',3,NULL,NULL,'2008-03-12 14:14:39');
INSERT INTO CHANSON VALUES(9589,'Gaayatri',3,NULL,NULL,'2008-03-12 09:23:32');
INSERT INTO CHANSON VALUES(9590,'Mahaa Mrityunjaya',3,NULL,NULL,'2008-03-12 08:58:33');
INSERT INTO CHANSON VALUES(9591,'Veenaa-Murali',3,NULL,NULL,'2008-03-12 11:34:52');
INSERT INTO CHANSON VALUES(9592,'Geetaa',3,NULL,NULL,'2008-03-12 18:38:43');
INSERT INTO CHANSON VALUES(9593,'Managalam',3,NULL,NULL,'2008-03-12 18:31:16');
INSERT INTO CHANSON VALUES(9594,'Hari Om',3,NULL,NULL,'2008-03-12 12:39:30');
INSERT INTO CHANSON VALUES(9595,'Svara Mantra',3,NULL,NULL,'2008-03-12 12:32:54');
INSERT INTO CHANSON VALUES(9596,'Vedic Chanting',3,NULL,NULL,'2008-03-12 17:24:02');
INSERT INTO CHANSON VALUES(9597,'Prabhujee',3,NULL,NULL,'2008-03-12 19:58:16');
INSERT INTO CHANSON VALUES(9598,'Sarve Shaam',3,NULL,NULL,'2008-03-12 15:06:39');
INSERT INTO CHANSON VALUES(9599,'Intro',7,NULL,'f','2008-03-12 10:10:27');
INSERT INTO CHANSON VALUES(9600,'Je baisse',7,NULL,'f','2008-03-12 19:13:26');
INSERT INTO CHANSON VALUES(9601,'Dernières volontés',7,NULL,NULL,'2008-03-12 14:28:00');
INSERT INTO CHANSON VALUES(9602,'Que choisir?',7,NULL,NULL,'2008-03-12 12:22:38');
INSERT INTO CHANSON VALUES(9603,'Accents toniques',7,NULL,'f','2008-03-12 09:17:10');
INSERT INTO CHANSON VALUES(9604,'Obsessions',7,NULL,'f','2008-03-12 12:40:50');
INSERT INTO CHANSON VALUES(9605,'La femme de monsieur Seguin',7,NULL,'f','2008-03-12 18:00:22');
INSERT INTO CHANSON VALUES(9606,'Ma femme a de l''humour',7,NULL,'f','2008-03-12 17:47:47');
INSERT INTO CHANSON VALUES(9607,'Dies Irae',7,NULL,'f','2008-03-12 18:46:45');
INSERT INTO CHANSON VALUES(9608,'Haute couture',7,NULL,'f','2008-03-12 09:24:52');
INSERT INTO CHANSON VALUES(9609,'Haute coiffure',7,NULL,'f','2008-03-12 17:36:03');
INSERT INTO CHANSON VALUES(9610,'Basse fosse',7,NULL,'f','2008-03-12 10:33:16');
INSERT INTO CHANSON VALUES(9611,'Résumé du spectacle',7,NULL,'f','2008-03-12 16:05:44');
INSERT INTO CHANSON VALUES(9612,'Mini, mini, mini',5,NULL,'f','2008-03-23 16:29:07');
INSERT INTO CHANSON VALUES(9613,'Sur une nappe de restaurant',5,NULL,'f','2008-03-23 12:36:24');
INSERT INTO CHANSON VALUES(9616,'L''opération',5,NULL,'f','2008-03-12 12:53:05');
INSERT INTO CHANSON VALUES(9617,'L''espace d''une fille',5,NULL,'f','2008-03-12 16:42:52');
INSERT INTO CHANSON VALUES(9619,'Les petites annonces',5,NULL,'f','2008-03-12 11:39:04');
INSERT INTO CHANSON VALUES(9620,'La publicité',5,NULL,'f','2008-03-23 09:26:40');
INSERT INTO CHANSON VALUES(9621,'L''idle',5,NULL,NULL,'2008-03-12 10:40:14');
INSERT INTO CHANSON VALUES(9622,'Les rois de la réforme',5,NULL,NULL,'2008-03-12 13:22:19');
INSERT INTO CHANSON VALUES(9623,'Le plus difficile',5,NULL,'f','2008-03-12 10:03:48');
INSERT INTO CHANSON VALUES(9624,'Il est cinq heures, Paris s''éveille',5,NULL,'f','2008-03-23 12:23:24');
INSERT INTO CHANSON VALUES(9625,'Comment elles dorment',5,NULL,'f','2008-03-12 17:54:24');
INSERT INTO CHANSON VALUES(9626,'Fais pas ci, fais pas ça',5,NULL,'f','2008-03-12 18:16:18');
INSERT INTO CHANSON VALUES(9627,'Le courrier du cur',5,NULL,'f','2008-03-24 19:00:00');
INSERT INTO CHANSON VALUES(9628,'Ca prend, ça ne prend pas',5,NULL,'f','2008-03-12 17:31:32');
INSERT INTO CHANSON VALUES(9630,'La romance de Paris',5,NULL,'f','2008-03-12 14:58:38');
INSERT INTO CHANSON VALUES(9631,'Que reste-t-il de nos amours',5,NULL,'f','2008-03-12 10:10:19');
INSERT INTO CHANSON VALUES(9632,'Débit de l''eau, débit de lait',5,NULL,'f','2008-03-12 13:39:41');
INSERT INTO CHANSON VALUES(9633,'La mer',5,NULL,'f','2008-03-12 17:53:44');
INSERT INTO CHANSON VALUES(9634,'Revoir Paris',5,NULL,'f','2008-03-12 14:13:08');
INSERT INTO CHANSON VALUES(9636,'Mes jeunes années',5,NULL,'f','2008-03-12 12:49:19');
INSERT INTO CHANSON VALUES(9637,'L''âme des poêtes',5,NULL,'f','2008-03-12 16:46:20');
INSERT INTO CHANSON VALUES(9638,'Au clair de la lune',5,NULL,'f','2008-03-12 16:35:51');
INSERT INTO CHANSON VALUES(9639,'De la fenêtre d''en haut',5,NULL,NULL,'2008-03-12 11:03:40');
INSERT INTO CHANSON VALUES(9640,'Formidable',5,NULL,NULL,'2008-03-12 13:36:38');
INSERT INTO CHANSON VALUES(9641,'Cœur de palmier',5,NULL,'f','2008-04-07 08:24:29');
INSERT INTO CHANSON VALUES(9642,'Berceuse',5,NULL,'f','2008-03-12 09:48:48');
INSERT INTO CHANSON VALUES(9643,'La cité de Carcassonne',5,NULL,'f','2008-03-12 13:15:28');
INSERT INTO CHANSON VALUES(9644,'Dans les pharmacies',5,NULL,'f','2008-03-12 09:01:22');
INSERT INTO CHANSON VALUES(9645,'Le serpent python',5,NULL,'f','2008-03-12 18:34:36');
INSERT INTO CHANSON VALUES(9646,'mouvement introductif',5,NULL,'f','2008-03-12 08:33:35');
INSERT INTO CHANSON VALUES(9647,'la valse des monstres',5,NULL,'f','2008-03-12 08:57:25');
INSERT INTO CHANSON VALUES(9648,'frida',5,NULL,'f','2008-03-12 12:39:11');
INSERT INTO CHANSON VALUES(9649,'quimper 84',5,NULL,'f','2008-03-12 16:21:46');
INSERT INTO CHANSON VALUES(9650,'ballendai',5,NULL,'f','2008-03-12 15:37:50');
INSERT INTO CHANSON VALUES(9651,'comptine d''ete n-17',5,NULL,'f','2008-03-12 11:05:26');
INSERT INTO CHANSON VALUES(9652,'cleo au trapeze',5,NULL,'f','2008-03-12 18:12:14');
INSERT INTO CHANSON VALUES(9654,'le banquet',5,NULL,'f','2008-03-12 10:45:31');
INSERT INTO CHANSON VALUES(9655,'comptine d''ete n-17',5,NULL,'f','2008-03-12 15:38:06');
INSERT INTO CHANSON VALUES(9656,'mouvement introductif',5,NULL,'f','2008-03-12 10:39:39');
INSERT INTO CHANSON VALUES(9657,'la rue',5,NULL,'f','2008-03-12 17:43:37');
INSERT INTO CHANSON VALUES(9658,'iwakichi',5,NULL,'f','2008-03-12 10:08:16');
INSERT INTO CHANSON VALUES(9659,'hanako',5,NULL,'f','2008-03-12 12:53:38');
INSERT INTO CHANSON VALUES(9660,'la plaisanterie',5,NULL,'f','2008-03-12 09:30:15');
INSERT INTO CHANSON VALUES(9661,'le compteur',5,NULL,'f','2008-03-12 08:47:21');
INSERT INTO CHANSON VALUES(9662,'mouvement introductif',5,NULL,'f','2008-03-12 13:42:33');
INSERT INTO CHANSON VALUES(9665,'Sous le soleil exactement',5,NULL,'f','2008-03-12 16:14:35');
INSERT INTO CHANSON VALUES(9666,'69 année érotique',5,NULL,NULL,'2008-03-12 17:25:14');
INSERT INTO CHANSON VALUES(9668,'Les sucettes',5,NULL,'f','2008-03-12 09:23:07');
INSERT INTO CHANSON VALUES(9669,'La chanson de slogan',5,NULL,'f','2008-03-12 12:47:00');
INSERT INTO CHANSON VALUES(9670,'Cannabis',5,NULL,'f','2008-03-12 08:57:31');
INSERT INTO CHANSON VALUES(9671,'Charlie Brown ''A Boy named Charlie Brown''',5,NULL,NULL,'2008-03-12 11:57:18');
INSERT INTO CHANSON VALUES(9672,'Melody',5,NULL,NULL,'2008-03-12 15:23:00');
INSERT INTO CHANSON VALUES(9673,'Ballade de Melody Nelson',5,NULL,NULL,'2008-03-12 10:05:26');
INSERT INTO CHANSON VALUES(9675,'Ah! Melody',5,NULL,'f','2008-03-12 12:59:19');
INSERT INTO CHANSON VALUES(9677,'En Melody',5,NULL,'f','2008-03-12 10:18:56');
INSERT INTO CHANSON VALUES(9678,'Cargo Culte',5,NULL,'f','2008-03-12 10:25:20');
INSERT INTO CHANSON VALUES(9679,'Annonce',7,NULL,'f','2008-03-12 11:47:07');
INSERT INTO CHANSON VALUES(9680,'Intro',7,NULL,'f','2008-03-12 11:48:04');
INSERT INTO CHANSON VALUES(9681,'L''Artiste dégagé',7,NULL,'f','2008-03-12 17:05:02');
INSERT INTO CHANSON VALUES(9682,'Q.I. 130',7,NULL,'f','2008-03-12 09:44:26');
INSERT INTO CHANSON VALUES(9683,'Gardez Sakharov',7,NULL,'f','2008-03-12 09:56:31');
INSERT INTO CHANSON VALUES(9684,'Les piles',7,NULL,'f','2008-03-12 14:20:48');
INSERT INTO CHANSON VALUES(9685,'Les cintres',7,NULL,'f','2008-03-12 15:41:47');
INSERT INTO CHANSON VALUES(9686,'Les Juifs',7,NULL,'f','2008-03-12 19:38:37');
INSERT INTO CHANSON VALUES(9687,'Rachid',7,NULL,'f','2008-03-12 16:49:55');
INSERT INTO CHANSON VALUES(9688,'La merveille',7,NULL,'f','2008-03-12 16:59:21');
INSERT INTO CHANSON VALUES(9689,'L''ascenseur',7,NULL,'f','2008-03-12 08:17:09');
INSERT INTO CHANSON VALUES(9690,'J''ai envie de tuer quelqu''un',7,NULL,'f','2008-03-12 09:35:57');
INSERT INTO CHANSON VALUES(9691,'Ondine',7,NULL,'f','2008-03-12 10:25:03');
INSERT INTO CHANSON VALUES(9692,'Bilan',7,NULL,'f','2008-03-12 11:33:47');
INSERT INTO CHANSON VALUES(9693,'Musique de fin',7,NULL,'f','2008-03-12 16:41:43');
INSERT INTO CHANSON VALUES(9694,'Rappel',7,NULL,'f','2008-03-12 10:15:04');
INSERT INTO CHANSON VALUES(9695,'Chanson',7,NULL,'f','2008-03-12 08:55:45');
INSERT INTO CHANSON VALUES(9696,'Music-hall parade',7,NULL,NULL,'2008-03-12 17:54:24');
INSERT INTO CHANSON VALUES(9697,'C''est l''histoire d''un mec...sur le pont de l''Alma',7,NULL,NULL,'2008-03-12 13:37:13');
INSERT INTO CHANSON VALUES(9698,'J''y ai dis viens',7,NULL,NULL,'2008-03-12 12:17:13');
INSERT INTO CHANSON VALUES(9699,'La procession télévisée',7,NULL,NULL,'2008-03-12 16:18:30');
INSERT INTO CHANSON VALUES(9700,'Je me marre',7,NULL,NULL,'2008-03-12 18:26:06');
INSERT INTO CHANSON VALUES(9701,'La manifestation',7,NULL,NULL,'2008-03-12 18:40:31');
INSERT INTO CHANSON VALUES(9702,'Histoire à bide : Le couvreur',7,NULL,NULL,'2008-03-12 18:55:04');
INSERT INTO CHANSON VALUES(9703,'Histoire à bide : L''éléphant',7,NULL,NULL,'2008-03-12 16:37:45');
INSERT INTO CHANSON VALUES(9704,'Le match France-Angleterre',7,NULL,NULL,'2008-03-12 13:50:01');
INSERT INTO CHANSON VALUES(9705,'Le CRS arabe',7,NULL,NULL,'2008-03-12 13:51:56');
INSERT INTO CHANSON VALUES(9706,'J''suis l''andouille qui fait l''imbécile',7,NULL,NULL,'2008-03-12 11:40:51');
INSERT INTO CHANSON VALUES(9707,'Le flic',7,NULL,NULL,'2008-03-12 15:07:28');
INSERT INTO CHANSON VALUES(9708,'L''auto-stoppeur',7,NULL,NULL,'2008-03-12 18:29:46');
INSERT INTO CHANSON VALUES(9709,'Je suis un voyou',7,NULL,NULL,'2008-04-13 12:59:38');
INSERT INTO CHANSON VALUES(9710,'Le blouson noir',7,NULL,NULL,'2008-03-12 09:12:05');
INSERT INTO CHANSON VALUES(9711,'L''ancien combattant',7,NULL,NULL,'2008-03-12 15:04:32');
INSERT INTO CHANSON VALUES(9714,'Les désespérés',5,NULL,'f','2008-03-12 12:30:45');
INSERT INTO CHANSON VALUES(9715,'L''âge idiot',5,NULL,'f','2008-03-12 09:55:36');
INSERT INTO CHANSON VALUES(9718,'Titine',5,NULL,'f','2008-03-12 19:20:16');
INSERT INTO CHANSON VALUES(9719,'Quand maman reviendra',5,NULL,NULL,'2008-03-12 13:13:45');
INSERT INTO CHANSON VALUES(9721,'Grand-mère',5,NULL,'f','2008-03-12 11:58:02');
INSERT INTO CHANSON VALUES(9722,'Fernand',5,NULL,'f','2008-03-12 17:42:56');
INSERT INTO CHANSON VALUES(9723,'La chanson de Jacky',5,NULL,'f','2008-03-12 08:58:45');
INSERT INTO CHANSON VALUES(9724,'Ces gens-là',5,NULL,'f','2008-03-12 10:19:15');
INSERT INTO CHANSON VALUES(9725,'La, la, la',5,NULL,'f','2008-03-12 19:26:11');
INSERT INTO CHANSON VALUES(9726,'Le cheval',5,NULL,'f','2008-03-12 14:35:36');
INSERT INTO CHANSON VALUES(9727,'Mon enfance',5,NULL,NULL,'2008-03-12 08:40:17');
INSERT INTO CHANSON VALUES(9728,'Les bonbons 67 (2e version)',5,NULL,NULL,'2008-03-12 10:36:37');
INSERT INTO CHANSON VALUES(9729,'Gérard, "tel" père et fils',7,NULL,NULL,'2008-03-12 13:01:51');
INSERT INTO CHANSON VALUES(9730,'The blues in Clermont-Ferrand',7,NULL,NULL,'2008-03-12 10:14:11');
INSERT INTO CHANSON VALUES(9731,'Le schmilblick',7,NULL,NULL,'2008-03-12 09:31:09');
INSERT INTO CHANSON VALUES(9732,'J''ai pas dit ça... sur les sportifs',7,NULL,NULL,'2008-03-12 10:21:52');
INSERT INTO CHANSON VALUES(9733,'Les militaires',7,NULL,NULL,'2008-03-12 09:22:51');
INSERT INTO CHANSON VALUES(9734,'Et puis y''a la télé',7,NULL,NULL,'2008-03-12 18:32:11');
INSERT INTO CHANSON VALUES(9735,'"Sois fainéant" ou conseils à   un nourrisson',7,NULL,NULL,'2008-03-12 09:28:38');
INSERT INTO CHANSON VALUES(9736,'Le clochard analphabète',7,NULL,NULL,'2008-03-12 11:01:13');
INSERT INTO CHANSON VALUES(9737,'Les Français parlent aux...',7,NULL,NULL,'2008-03-12 19:02:53');
INSERT INTO CHANSON VALUES(9738,'On n''a pas eu de bol',7,NULL,NULL,'2008-03-12 10:12:30');
INSERT INTO CHANSON VALUES(9739,'Je suis bien content d''être en France',7,NULL,NULL,'2008-03-12 18:38:32');
INSERT INTO CHANSON VALUES(9740,'La bagarre',7,NULL,NULL,'2008-03-12 16:49:46');
INSERT INTO CHANSON VALUES(9741,'Oh ! que c''est beau. (biguine)',7,NULL,NULL,'2008-03-12 18:59:17');
INSERT INTO CHANSON VALUES(9742,'Le cancer du bras droit',7,NULL,NULL,'2008-03-12 08:10:38');
INSERT INTO CHANSON VALUES(9743,'Qui perd perd',7,NULL,NULL,'2008-03-12 19:18:01');
INSERT INTO CHANSON VALUES(9744,'La publicité',7,NULL,NULL,'2008-03-12 17:12:34');
INSERT INTO CHANSON VALUES(9745,'Le syndicat : le délégué',7,NULL,NULL,'2008-03-12 08:20:03');
INSERT INTO CHANSON VALUES(9746,'La politique (en politique on est ''achement balèze)',7,NULL,NULL,'2008-03-12 15:40:04');
INSERT INTO CHANSON VALUES(9747,'Les papes (Jean-Paul 2 et Jean retiens 1)',7,NULL,NULL,'2008-03-12 18:37:06');
INSERT INTO CHANSON VALUES(9748,'Le viol',7,NULL,NULL,'2008-03-12 17:51:18');
INSERT INTO CHANSON VALUES(9749,'Misère',7,NULL,NULL,'2008-03-12 11:42:56');
INSERT INTO CHANSON VALUES(9750,'Stéphane Maréchal',7,NULL,NULL,'2008-03-12 17:25:46');
INSERT INTO CHANSON VALUES(9751,'Tous les chemins mènent à Rome',7,NULL,NULL,'2008-03-12 14:20:46');
INSERT INTO CHANSON VALUES(9752,'On est pas là pour se faire engueuler',7,NULL,NULL,'2008-03-12 18:24:56');
INSERT INTO CHANSON VALUES(9753,'Quand je serai grand',7,NULL,NULL,'2008-03-12 13:22:15');
INSERT INTO CHANSON VALUES(9754,'La guitare enragée',7,NULL,NULL,'2008-03-12 14:11:27');
INSERT INTO CHANSON VALUES(9755,'Revue de presse',7,NULL,NULL,'2008-03-12 09:11:48');
INSERT INTO CHANSON VALUES(9756,'Votez nul',7,NULL,NULL,'2008-03-12 09:50:29');
INSERT INTO CHANSON VALUES(9757,'Si j''ai bien tout lu Freud',7,NULL,NULL,'2008-03-12 10:42:06');
INSERT INTO CHANSON VALUES(9758,'L''étudiant',7,NULL,NULL,'2008-03-12 11:27:58');
INSERT INTO CHANSON VALUES(9759,'Faché avec tout le monde',7,NULL,NULL,'2008-03-12 15:43:40');
INSERT INTO CHANSON VALUES(9760,'J''m''en fous',7,NULL,NULL,'2008-03-12 15:30:06');
INSERT INTO CHANSON VALUES(9761,'Les vacances',7,NULL,NULL,'2008-03-12 12:04:26');
INSERT INTO CHANSON VALUES(9762,'La fanfare : un homme averti en vaut deux',7,NULL,NULL,'2008-03-12 09:55:51');
INSERT INTO CHANSON VALUES(9763,'Trois quatre',7,NULL,NULL,'2008-03-12 08:25:13');
INSERT INTO CHANSON VALUES(9764,'Un train peut en cacher un autre',7,NULL,NULL,'2008-03-12 12:56:24');
INSERT INTO CHANSON VALUES(9765,'La chanson des vieux amants',5,NULL,'f','2008-03-12 17:02:36');
INSERT INTO CHANSON VALUES(9766,'A jeun',5,NULL,'f','2008-03-12 15:11:26');
INSERT INTO CHANSON VALUES(9767,'Fils de ...',5,NULL,'f','2008-03-12 09:24:08');
INSERT INTO CHANSON VALUES(9768,'Mon père disait',5,NULL,'f','2008-03-12 10:44:36');
INSERT INTO CHANSON VALUES(9769,'Le gaz',5,NULL,'f','2008-03-12 10:22:19');
INSERT INTO CHANSON VALUES(9770,'L''ostendaise',5,NULL,NULL,'2008-03-12 18:57:50');
INSERT INTO CHANSON VALUES(9771,'Je suis un soir d''été',5,NULL,'f','2008-03-12 19:19:55');
INSERT INTO CHANSON VALUES(9772,'Un enfant',5,NULL,'f','2008-03-12 13:27:50');
INSERT INTO CHANSON VALUES(9773,'Comment tuer l''amant de sa femme quand on a été élevé comme moi dansla tradition',5,NULL,'f','2008-03-12 11:32:16');
INSERT INTO CHANSON VALUES(9774,'Vesoul',5,NULL,'f','2008-03-12 14:52:13');
INSERT INTO CHANSON VALUES(9775,'J''arrive',5,NULL,'f','2008-03-12 19:40:15');
INSERT INTO CHANSON VALUES(9776,'La bière',5,NULL,'f','2008-03-12 14:17:27');
INSERT INTO CHANSON VALUES(9777,'L''éclusier',5,NULL,'f','2008-03-12 19:23:51');
INSERT INTO CHANSON VALUES(9778,'Regarde bien petit',5,NULL,'f','2008-03-12 09:36:35');
INSERT INTO CHANSON VALUES(9779,'La quète',5,NULL,'f','2008-03-12 16:48:58');
INSERT INTO CHANSON VALUES(9780,'Mijn vlakke land (le plat pays)',5,NULL,'f','2008-03-12 08:40:55');
INSERT INTO CHANSON VALUES(9781,'De burgerij (les bourgeois)',5,NULL,NULL,'2008-03-12 18:38:14');
INSERT INTO CHANSON VALUES(9783,'De nuttelozen van de nacht (les paumés du petit matin)',5,NULL,'f','2008-03-12 15:21:14');
INSERT INTO CHANSON VALUES(9784,'La gym',7,NULL,NULL,'2008-03-12 19:52:06');
INSERT INTO CHANSON VALUES(9785,'Quand je la vois',7,NULL,NULL,'2008-03-12 09:48:46');
INSERT INTO CHANSON VALUES(9786,'Mes adieux au music-hall',7,NULL,NULL,'2008-03-12 13:20:03');
INSERT INTO CHANSON VALUES(9787,'Je veux rester dans le noir',7,NULL,NULL,'2008-03-12 18:18:27');
INSERT INTO CHANSON VALUES(9788,'Les blagues de Coluche Europe 1',7,NULL,NULL,'2008-03-12 16:26:03');
INSERT INTO CHANSON VALUES(9789,'Les blagues de Coluche Europe 1',7,NULL,NULL,'2008-03-12 12:10:51');
INSERT INTO CHANSON VALUES(9790,'Les blagues de Coluche Europe 1',7,NULL,NULL,'2008-03-12 11:13:32');
INSERT INTO CHANSON VALUES(9791,'J''tape un doigt',7,NULL,NULL,'2008-03-12 10:07:10');
INSERT INTO CHANSON VALUES(9792,'Gugusse',7,NULL,NULL,'2008-03-12 13:56:15');
INSERT INTO CHANSON VALUES(9793,'Le poème',7,NULL,NULL,'2008-03-12 10:36:36');
INSERT INTO CHANSON VALUES(9794,'Le Belge',7,NULL,NULL,'2008-03-12 13:33:29');
INSERT INTO CHANSON VALUES(9795,'PC GT - Russie-Pologne',7,NULL,NULL,'2008-03-12 14:43:17');
INSERT INTO CHANSON VALUES(9796,'Médecins sans diplme',7,NULL,NULL,'2008-03-12 11:08:37');
INSERT INTO CHANSON VALUES(9797,'Les discours en disent long',7,NULL,NULL,'2008-03-12 12:01:56');
INSERT INTO CHANSON VALUES(9798,'La politesse',7,NULL,NULL,'2008-03-12 17:46:22');
INSERT INTO CHANSON VALUES(9799,'Y s''foutent bien de notre gueule',7,NULL,NULL,'2008-03-12 18:07:32');
INSERT INTO CHANSON VALUES(9800,'Le chmeur',7,NULL,NULL,'2008-03-12 17:26:46');
INSERT INTO CHANSON VALUES(9801,'L''administration',7,NULL,NULL,'2008-03-12 11:41:54');
INSERT INTO CHANSON VALUES(9802,'Le sida',7,NULL,NULL,'2008-03-12 13:10:51');
INSERT INTO CHANSON VALUES(9803,'Jean-Marie',7,NULL,NULL,'2008-03-12 16:21:28');
INSERT INTO CHANSON VALUES(9804,'La pute',7,NULL,NULL,'2008-03-12 12:46:01');
INSERT INTO CHANSON VALUES(9805,'La lettre à   la sécu',7,NULL,NULL,'2008-03-12 17:18:44');
INSERT INTO CHANSON VALUES(9806,'Moi, ça va',7,NULL,NULL,'2008-03-12 09:36:53');
INSERT INTO CHANSON VALUES(9807,'Mon papa',7,NULL,NULL,'2008-03-12 16:59:55');
INSERT INTO CHANSON VALUES(9808,'Les restos du cur',7,NULL,NULL,'2008-03-24 15:48:42');
INSERT INTO CHANSON VALUES(9809,'Oh ! Ginette',7,NULL,NULL,'2008-03-12 08:41:50');
INSERT INTO CHANSON VALUES(9810,'Noël',7,NULL,NULL,'2008-03-12 15:27:16');
INSERT INTO CHANSON VALUES(9811,'Reviens vas t''en',7,NULL,NULL,'2008-03-12 12:44:57');
INSERT INTO CHANSON VALUES(9814,'L''amour de moi',5,NULL,'f','2008-03-12 15:17:16');
INSERT INTO CHANSON VALUES(9816,'Anno Close the River',5,NULL,'f','2008-03-12 12:13:11');
INSERT INTO CHANSON VALUES(9818,'La valse de Melody',5,NULL,'f','2008-03-12 10:37:59');
INSERT INTO CHANSON VALUES(9819,'Haine pour aime',5,NULL,'f','2008-03-12 18:39:41');
INSERT INTO CHANSON VALUES(9820,'Amours des feintes',5,NULL,'f','2008-03-12 17:14:08');
INSERT INTO CHANSON VALUES(9821,'She left Home',5,NULL,'f','2008-03-12 08:36:53');
INSERT INTO CHANSON VALUES(9824,'Fuir le bonheur',5,NULL,'f','2008-03-12 15:36:20');
INSERT INTO CHANSON VALUES(9828,'Retour à toi',5,NULL,'f','2008-03-12 18:06:15');
INSERT INTO CHANSON VALUES(9829,'Réévolution',5,NULL,'f','2008-03-12 18:01:55');
INSERT INTO CHANSON VALUES(9830,'L''orage',5,NULL,'f','2008-03-12 14:46:10');
INSERT INTO CHANSON VALUES(9831,'If',5,NULL,NULL,'2008-03-12 16:48:46');
INSERT INTO CHANSON VALUES(9832,'Les remparts',5,NULL,NULL,'2008-03-12 14:47:39');
INSERT INTO CHANSON VALUES(9833,'Vis à vis',5,NULL,'f','2008-03-12 15:54:40');
INSERT INTO CHANSON VALUES(9834,'Le jour et la nuit',5,NULL,'f','2008-03-12 16:31:17');
INSERT INTO CHANSON VALUES(9835,'L''inconstant',5,NULL,'f','2008-03-12 08:25:32');
INSERT INTO CHANSON VALUES(9836,'Les jalousies',5,NULL,'f','2008-03-12 14:53:09');
INSERT INTO CHANSON VALUES(9837,'Talisman',5,NULL,'f','2008-03-12 10:34:03');
INSERT INTO CHANSON VALUES(9838,'Les liens d''Eros',5,NULL,'f','2008-03-12 17:25:09');
INSERT INTO CHANSON VALUES(9839,'Au Jack aumois d''avril',5,NULL,'f','2008-03-12 08:16:11');
INSERT INTO CHANSON VALUES(9841,'Putain ça penche',5,NULL,NULL,'2008-03-12 10:28:45');
INSERT INTO CHANSON VALUES(9842,'J''aimais mieux quand c''était toi',5,NULL,'f','2008-03-12 19:02:32');
INSERT INTO CHANSON VALUES(9843,'Bonjour tristesse',5,NULL,'f','2008-03-12 15:42:27');
INSERT INTO CHANSON VALUES(9844,'La vie Théodore',5,NULL,'f','2008-03-12 11:25:59');
INSERT INTO CHANSON VALUES(9845,'En collant l''oreille sur l''appareil',5,NULL,'f','2008-03-12 14:28:25');
INSERT INTO CHANSON VALUES(9846,'À cause d''elle',5,NULL,'f','2008-03-12 09:58:19');
INSERT INTO CHANSON VALUES(9847,'Et si en plus y''a personne',5,NULL,'f','2008-03-12 11:09:53');
INSERT INTO CHANSON VALUES(9848,'Le mystère',5,NULL,'f','2008-03-12 11:59:18');
INSERT INTO CHANSON VALUES(9849,'Le marin',5,NULL,NULL,'2008-03-12 13:04:35');
INSERT INTO CHANSON VALUES(9850,'L''ile du dédain',5,NULL,'f','2008-03-12 16:04:23');
INSERT INTO CHANSON VALUES(9851,'Lisa',5,NULL,'f','2008-03-12 15:14:52');
INSERT INTO CHANSON VALUES(9852,'L''ami ennemi',2,NULL,'f','2008-03-12 12:11:55');
INSERT INTO CHANSON VALUES(9853,'Communiqueur d''amour',2,NULL,'f','2008-03-12 19:48:37');
INSERT INTO CHANSON VALUES(9854,'Réverie',2,NULL,'f','2008-03-24 12:05:02');
INSERT INTO CHANSON VALUES(9855,'Berceuse',2,NULL,'f','2008-03-27 12:39:30');
INSERT INTO CHANSON VALUES(9856,'Même si',2,NULL,'f','2008-03-12 17:45:29');
INSERT INTO CHANSON VALUES(9857,'Rendez-vous avec moi-même',2,NULL,'f','2008-03-12 09:02:39');
INSERT INTO CHANSON VALUES(9858,'She''s a chameleon',2,NULL,'f','2008-03-12 08:21:38');
INSERT INTO CHANSON VALUES(9859,'Soir de peine',2,NULL,'f','2008-03-12 12:51:42');
INSERT INTO CHANSON VALUES(9860,'Badluck queen',2,NULL,'f','2008-03-12 19:32:47');
INSERT INTO CHANSON VALUES(9861,'Ma vieille ville',2,NULL,'f','2008-03-12 12:10:01');
INSERT INTO CHANSON VALUES(9862,'Ding ding dong (ringing at your bell)',2,NULL,'f','2008-03-12 10:33:13');
INSERT INTO CHANSON VALUES(9863,'Terminal beauty',2,NULL,NULL,'2008-03-12 09:30:01');
INSERT INTO CHANSON VALUES(9864,'Berceuse (version chinois mandarin) - Bonus track',2,NULL,NULL,'2008-03-27 17:54:06');
INSERT INTO CHANSON VALUES(9865,'Communic''hearts in love - Bonus track',2,NULL,NULL,'2008-03-12 17:19:45');
INSERT INTO CHANSON VALUES(9866,'Terminal beauté - Bonus track',2,NULL,'f','2008-03-12 11:09:31');
INSERT INTO CHANSON VALUES(9867,'Pardon',5,NULL,'f','2008-03-12 17:17:33');
INSERT INTO CHANSON VALUES(9868,'Le baiser',5,NULL,'f','2008-03-12 13:20:55');
INSERT INTO CHANSON VALUES(9869,'Tailler la zone',5,NULL,'f','2008-03-12 09:41:46');
INSERT INTO CHANSON VALUES(9870,'Rive gauche',5,NULL,'f','2008-03-12 17:38:19');
INSERT INTO CHANSON VALUES(9871,'l''horrible bye-bye',5,NULL,'f','2008-03-12 15:58:29');
INSERT INTO CHANSON VALUES(9872,'Au ras des paquerettes',5,NULL,'f','2008-03-12 15:11:03');
INSERT INTO CHANSON VALUES(9873,'Menti',5,NULL,'f','2008-03-12 18:19:33');
INSERT INTO CHANSON VALUES(9874,'Petit tas tombé',5,NULL,'f','2008-03-12 18:04:28');
INSERT INTO CHANSON VALUES(9875,'Une guitare un citoyen',5,NULL,'f','2008-03-12 19:52:47');
INSERT INTO CHANSON VALUES(9876,'Caterpillar',5,NULL,'f','2008-03-12 16:11:56');
INSERT INTO CHANSON VALUES(9898,'La complainte des filles de joies',2,NULL,'f','2008-03-24 12:57:57');
INSERT INTO CHANSON VALUES(9899,'Les illusions perdues',2,NULL,'f','2008-03-12 19:42:29');
INSERT INTO CHANSON VALUES(9900,'Le dîner',5,NULL,'f','2008-03-12 11:13:49');
INSERT INTO CHANSON VALUES(9901,'Maritie et Gilbert Carpentier',5,NULL,'f','2008-03-12 10:03:44');
INSERT INTO CHANSON VALUES(9902,'Quatre murs et un toit',5,NULL,'f','2008-03-12 08:22:16');
INSERT INTO CHANSON VALUES(9903,'Bruxelles',5,NULL,'f','2008-03-12 09:45:38');
INSERT INTO CHANSON VALUES(9904,'Triste compagne',5,NULL,'f','2008-03-12 14:41:52');
INSERT INTO CHANSON VALUES(9905,'La berceuse',5,NULL,'f','2008-03-12 08:06:03');
INSERT INTO CHANSON VALUES(9906,'Les épices du souk du Caire',5,NULL,NULL,'2008-03-12 12:19:58');
INSERT INTO CHANSON VALUES(9907,'Qu''est-ce que tu voulais que je lui dise',5,NULL,'f','2008-03-12 19:29:07');
INSERT INTO CHANSON VALUES(9908,'Le méchant de James Bond',5,NULL,NULL,'2008-03-12 13:53:05');
INSERT INTO CHANSON VALUES(9909,'Le fou rire',5,NULL,'f','2008-03-12 13:53:47');
INSERT INTO CHANSON VALUES(9910,'Tu peux compter sur moi',5,NULL,'f','2008-03-12 18:09:01');
INSERT INTO CHANSON VALUES(9911,'Le cahier de solfège',5,NULL,'f','2008-03-12 16:20:04');
INSERT INTO CHANSON VALUES(9912,'Monospace',5,NULL,'f','2008-03-12 13:24:27');
INSERT INTO CHANSON VALUES(9913,'Dis-lui oui',5,NULL,NULL,'2008-03-12 16:32:12');
INSERT INTO CHANSON VALUES(9914,'Paresseuse',5,NULL,NULL,'2008-03-12 12:04:54');
INSERT INTO CHANSON VALUES(9915,'Je suis de celles',5,NULL,'f','2008-03-12 11:05:00');
INSERT INTO CHANSON VALUES(9916,'Vade retro téléphone',5,NULL,'f','2008-03-12 12:28:20');
INSERT INTO CHANSON VALUES(9917,'L''itinéraire',5,NULL,'f','2008-03-12 11:23:49');
INSERT INTO CHANSON VALUES(9918,'Sac à main',5,NULL,'f','2008-03-12 13:51:43');
INSERT INTO CHANSON VALUES(9919,'La station Mir',5,NULL,'f','2008-03-12 14:16:36');
INSERT INTO CHANSON VALUES(9920,'La coquette',5,NULL,'f','2008-03-12 11:10:46');
INSERT INTO CHANSON VALUES(9921,'Les mots d''amour',5,NULL,'f','2008-03-12 12:54:06');
INSERT INTO CHANSON VALUES(9922,'Monsieur René',5,NULL,'f','2008-03-12 13:22:31');
INSERT INTO CHANSON VALUES(9923,'Le zoo de Vincennes',5,NULL,'f','2008-03-12 18:07:04');
INSERT INTO CHANSON VALUES(9925,'Cuba',2,NULL,'f','2008-03-12 19:47:15');
INSERT INTO CHANSON VALUES(9926,'Chassez le naturel, il revient au bungalow',2,NULL,'f','2008-03-12 08:07:43');
INSERT INTO CHANSON VALUES(9927,'C''est toujours la même chose, même chose, même chose',2,NULL,'f','2008-03-12 12:25:07');
INSERT INTO CHANSON VALUES(9928,'Les plus courtes sont les meilleures',2,NULL,'f','2008-03-12 10:51:58');
INSERT INTO CHANSON VALUES(9929,'C''est l''été',2,NULL,'f','2008-03-12 18:23:15');
INSERT INTO CHANSON VALUES(9930,'Eric',2,NULL,NULL,'2008-03-12 13:43:25');
INSERT INTO CHANSON VALUES(9931,'I am ze reggaeman',2,NULL,'f','2008-03-12 11:04:20');
INSERT INTO CHANSON VALUES(9932,'Les plus courtes sont les meilleures (Remix)',2,NULL,'f','2008-03-12 12:30:43');
INSERT INTO CHANSON VALUES(9933,'Voter pour moi',2,NULL,'f','2008-03-12 18:22:50');
INSERT INTO CHANSON VALUES(9934,'Berceuse électrique',2,NULL,'f','2008-03-27 19:28:21');
INSERT INTO CHANSON VALUES(9935,'Pas la peine',2,NULL,'f','2008-03-12 09:27:09');
INSERT INTO CHANSON VALUES(9936,'Wak-wak',2,NULL,'f','2008-03-12 12:28:16');
INSERT INTO CHANSON VALUES(9937,'Les avions',2,NULL,'f','2008-03-12 09:48:41');
INSERT INTO CHANSON VALUES(9938,'C''est pas moi',2,NULL,'f','2008-03-12 10:58:33');
INSERT INTO CHANSON VALUES(9939,'ole ola ole ola',2,NULL,'f','2008-03-12 10:52:57');
INSERT INTO CHANSON VALUES(9940,'Mon boomerang s''appelle Reviens',2,NULL,'f','2008-03-12 13:22:41');
INSERT INTO CHANSON VALUES(9941,'Comment une simple partie de tennis d''étable peut devenir une horrible match de King Kong',2,NULL,'f','2008-03-12 18:38:46');
INSERT INTO CHANSON VALUES(9942,'Cheyenne de vie',2,NULL,'f','2008-03-12 11:01:16');
INSERT INTO CHANSON VALUES(9943,'Marie-Louise',2,NULL,NULL,'2008-03-12 19:56:39');
INSERT INTO CHANSON VALUES(9944,'C''est la fête quand Bob Kennedy',2,NULL,NULL,'2008-03-18 17:55:07');
INSERT INTO CHANSON VALUES(9945,'Année 80',2,NULL,'f','2008-03-12 10:03:35');
INSERT INTO CHANSON VALUES(9946,'Le mur',2,NULL,'f','2008-03-12 12:27:03');
INSERT INTO CHANSON VALUES(9947,'Katmandou express',2,NULL,'f','2008-03-12 15:34:52');
INSERT INTO CHANSON VALUES(9948,'De James Bourg a Gainsbond',2,NULL,'f','2008-03-12 11:48:51');
INSERT INTO CHANSON VALUES(9949,'La comptina turner (Al canto del cucu)',2,NULL,NULL,'2008-03-12 18:02:43');
INSERT INTO CHANSON VALUES(9950,'Remember de ferme',2,NULL,'f','2008-03-12 17:30:05');
INSERT INTO CHANSON VALUES(9951,'Les grenouilles',2,NULL,'f','2008-03-12 14:24:43');
INSERT INTO CHANSON VALUES(9952,'Dresseur de plaisir',2,NULL,'f','2008-03-12 11:40:45');
INSERT INTO CHANSON VALUES(9953,'Quand t''es pas là',2,NULL,NULL,'2008-03-18 14:38:41');
INSERT INTO CHANSON VALUES(9954,'Mandchou s''en va en guerre',2,NULL,'f','2008-03-12 10:28:37');
INSERT INTO CHANSON VALUES(9955,'Eddy Merckx',2,NULL,'f','2008-03-12 12:39:40');
INSERT INTO CHANSON VALUES(9956,'Mobylhead',2,NULL,'f','2008-03-12 19:00:07');
INSERT INTO CHANSON VALUES(9958,'Home',5,NULL,'f','2008-03-12 18:55:30');
INSERT INTO CHANSON VALUES(9959,'Alice',5,NULL,'f','2008-03-12 16:48:32');
INSERT INTO CHANSON VALUES(9960,'Living In Limbo',5,NULL,'f','2008-03-12 13:38:03');
INSERT INTO CHANSON VALUES(9961,'Waterloo Station',5,NULL,'f','2008-03-12 14:09:28');
INSERT INTO CHANSON VALUES(9962,'My Secret',5,NULL,'f','2008-03-12 11:27:08');
INSERT INTO CHANSON VALUES(9963,'O'' est la ville',5,NULL,'f','2008-03-12 08:01:47');
INSERT INTO CHANSON VALUES(9964,'Steal My Dream',5,NULL,'f','2008-03-12 16:15:15');
INSERT INTO CHANSON VALUES(9965,'Sans toi',5,NULL,'f','2008-03-12 12:37:55');
INSERT INTO CHANSON VALUES(9966,'Harvest Moon',5,NULL,'f','2008-03-12 08:34:55');
INSERT INTO CHANSON VALUES(9967,'La reine sans royaume',5,NULL,'f','2008-03-12 09:34:33');
INSERT INTO CHANSON VALUES(9968,'Mother stands for comfort',5,NULL,'f','2008-03-12 18:27:28');
INSERT INTO CHANSON VALUES(9969,'Image fant''me - pavane pour une infante défunte',5,NULL,'f','2008-03-12 12:10:17');
INSERT INTO CHANSON VALUES(9972,'Under My Wheels',2,NULL,'f','2008-04-14 12:47:44');
INSERT INTO CHANSON VALUES(9973,'Be My Lover',2,NULL,'f','2008-03-12 13:26:31');
INSERT INTO CHANSON VALUES(9974,'Halo Of Flies',2,NULL,'f','2008-03-12 15:28:33');
INSERT INTO CHANSON VALUES(9975,'Desperado',2,NULL,NULL,'2008-04-24 13:56:41');
INSERT INTO CHANSON VALUES(9976,'You Drive Me Nervous',2,NULL,NULL,'2008-04-12 13:27:32');
INSERT INTO CHANSON VALUES(9977,'Yeah, Yeah, Yeah',2,NULL,NULL,'2008-03-12 12:12:49');
INSERT INTO CHANSON VALUES(9978,'Dead Babies',2,NULL,'f','2008-03-12 15:33:26');
INSERT INTO CHANSON VALUES(9979,'Killer',2,NULL,'f','2008-03-12 14:36:00');
INSERT INTO CHANSON VALUES(9980,'Intro Moines',2,NULL,'f','2008-03-12 13:45:34');
INSERT INTO CHANSON VALUES(9981,'Les tartines',2,NULL,'f','2008-03-12 08:37:02');
INSERT INTO CHANSON VALUES(9982,'Roger ?',2,NULL,'f','2008-03-12 14:00:12');
INSERT INTO CHANSON VALUES(9983,'A Tahiti',2,NULL,'f','2008-03-12 17:55:50');
INSERT INTO CHANSON VALUES(9984,'Avec Sabine',2,NULL,'f','2008-03-12 16:54:01');
INSERT INTO CHANSON VALUES(9986,'Are You Ready To Will Rock You Avec Nous ?',2,NULL,'f','2008-03-12 12:56:57');
INSERT INTO CHANSON VALUES(9987,'Nous Ne Roucoulons Pas Devant Les Pigeons',2,NULL,'f','2008-03-12 18:19:09');
INSERT INTO CHANSON VALUES(9988,'Première Rencontre Avec Dieu',2,NULL,'f','2008-03-12 16:57:43');
INSERT INTO CHANSON VALUES(9989,'Robert Et Cathy',2,NULL,'f','2008-03-12 09:30:19');
INSERT INTO CHANSON VALUES(9990,'Dieu Est-il Moustachu avec des cheveux heavy metal',2,NULL,NULL,'2008-03-12 09:59:05');
INSERT INTO CHANSON VALUES(9991,'Aglaé',2,NULL,'f','2008-03-12 16:01:43');
INSERT INTO CHANSON VALUES(9992,'Première Rencontre Avec La Guitare',2,NULL,'f','2008-03-12 17:32:44');
INSERT INTO CHANSON VALUES(9993,'La Tasse De Café',2,NULL,'f','2008-03-12 19:20:40');
INSERT INTO CHANSON VALUES(9994,'J''accorde ma guitare si je sais pouvoir ! (en tout cas essayer)',2,NULL,'f','2008-03-12 18:04:34');
INSERT INTO CHANSON VALUES(9996,'Tap H.E.A.D.',2,NULL,'f','2008-03-12 11:12:53');
INSERT INTO CHANSON VALUES(9997,'Annie',2,NULL,'f','2008-03-12 11:06:12');
INSERT INTO CHANSON VALUES(9998,'Je Suis Céline',2,NULL,'f','2008-03-12 13:49:09');
INSERT INTO CHANSON VALUES(9999,'Bon Anniversaire Stevie',2,NULL,'f','2008-03-12 10:58:40');
INSERT INTO CHANSON VALUES(10000,'Je M''ennuie',2,NULL,NULL,'2008-03-12 14:07:39');
INSERT INTO CHANSON VALUES(10001,'Nagasaki Ne Profite Jamais',2,NULL,NULL,'2008-03-12 15:51:40');
INSERT INTO CHANSON VALUES(10002,'Le jour o'' la philosophie démarrait',2,NULL,'f','2008-03-12 11:38:13');
INSERT INTO CHANSON VALUES(10003,'Il y a toujours un train qui part',2,NULL,'f','2008-03-12 08:37:34');
INSERT INTO CHANSON VALUES(10004,'Wo-Wo-O-Wo-O Nâ°1',2,NULL,'f','2008-03-12 16:28:38');
INSERT INTO CHANSON VALUES(10006,'La botanique des hommes ressemble-t-elle a la biologie des plantes ?Ou pas ?',2,NULL,'f','2008-03-12 11:38:43');
INSERT INTO CHANSON VALUES(10007,'Dracula',2,NULL,'f','2008-03-12 09:55:50');
INSERT INTO CHANSON VALUES(10008,'Allez-Allez Rouillez Jeunesse',2,NULL,'f','2008-03-12 12:22:39');
INSERT INTO CHANSON VALUES(10009,'Fumée sur la montre étanche (smoke on the water proof)',2,NULL,'f','2008-03-23 14:32:37');
INSERT INTO CHANSON VALUES(10010,'Torremolinos',2,NULL,'f','2008-04-11 17:18:01');
INSERT INTO CHANSON VALUES(10011,'Wo-Wo-O-Wo-O- Nâ°2',2,NULL,'f','2008-03-12 10:02:44');
INSERT INTO CHANSON VALUES(10012,'Parade Mongole',2,NULL,'f','2008-03-12 17:38:36');
INSERT INTO CHANSON VALUES(10014,'Brigitte Bardot Danse Le Tango',2,NULL,NULL,'2008-03-12 16:02:53');
INSERT INTO CHANSON VALUES(10015,'Wo-Wo-O-Wo-O Nâ° 3',2,NULL,NULL,'2008-03-12 11:46:21');
INSERT INTO CHANSON VALUES(10016,'Batterie sans laisser d''adresse',2,NULL,'f','2008-03-12 19:05:40');
INSERT INTO CHANSON VALUES(10018,'Street Life',2,NULL,'f','2008-03-19 10:28:15');
INSERT INTO CHANSON VALUES(10019,'Ladytron',2,NULL,'f','2008-03-12 08:49:37');
INSERT INTO CHANSON VALUES(10022,'A Song For Europe',2,NULL,'f','2008-03-12 08:20:51');
INSERT INTO CHANSON VALUES(10025,'Oh Yeah!',2,NULL,'f','2008-03-12 17:54:39');
INSERT INTO CHANSON VALUES(10028,'The Loser',2,NULL,'f','2008-03-12 10:32:34');
INSERT INTO CHANSON VALUES(10029,'Sicily (Tropic Of Seperation)',2,NULL,'f','2008-03-12 13:35:23');
INSERT INTO CHANSON VALUES(10031,'The Malady And The Medicine',2,NULL,'f','2008-03-12 10:36:13');
INSERT INTO CHANSON VALUES(10032,'Destiny',2,NULL,'f','2008-03-12 13:39:33');
INSERT INTO CHANSON VALUES(10034,'Greetings From Sydney',2,NULL,'f','2008-03-12 09:16:00');
INSERT INTO CHANSON VALUES(10035,'The Price I Pay',2,NULL,'f','2008-03-12 19:05:54');
INSERT INTO CHANSON VALUES(10036,'The Epicenter',2,NULL,'f','2008-03-12 15:16:45');
INSERT INTO CHANSON VALUES(10037,'Mr. Coffee',2,NULL,'f','2008-03-12 12:07:05');
INSERT INTO CHANSON VALUES(10038,'No I ... I Couldn''t Touch You',2,NULL,'f','2008-03-12 13:18:37');
INSERT INTO CHANSON VALUES(10039,'Automatic Erotic',2,NULL,'f','2008-03-12 08:43:12');
INSERT INTO CHANSON VALUES(10040,'All The Way From Tokyo',2,NULL,'f','2008-03-12 13:46:29');
INSERT INTO CHANSON VALUES(10041,'Bilingual Lover',2,NULL,'f','2008-03-12 10:59:05');
INSERT INTO CHANSON VALUES(10042,'All That Money Can Do',2,NULL,'f','2008-03-12 12:24:45');
INSERT INTO CHANSON VALUES(10043,'You''re Gonna Chase Love Away',2,NULL,'f','2008-03-12 19:41:06');
INSERT INTO CHANSON VALUES(10044,'The Dolly Sisters',2,NULL,'f','2008-03-12 12:47:23');
INSERT INTO CHANSON VALUES(10045,'Sad After Sex',2,NULL,'f','2008-03-12 12:46:28');
INSERT INTO CHANSON VALUES(10046,'Something Like Steve McQueen',2,NULL,'f','2008-03-12 11:25:45');
INSERT INTO CHANSON VALUES(10047,'Where Is My Baby?',2,NULL,'f','2008-03-12 08:49:52');
INSERT INTO CHANSON VALUES(10049,'L''amour à la sauvette',5,NULL,NULL,'2008-06-02 13:53:16.918041');
INSERT INTO CHANSON VALUES(10050,'Glaçon brulant',5,NULL,'f','2008-06-02 13:53:24.772865');
INSERT INTO CHANSON VALUES(10051,'Un songe',5,NULL,NULL,'2008-03-12 13:02:41');
INSERT INTO CHANSON VALUES(10052,'Champagne',5,NULL,'f','2008-03-12 15:27:05');
INSERT INTO CHANSON VALUES(10053,'La chanson du marchand de journaux',5,NULL,'f','2008-03-12 12:25:46');
INSERT INTO CHANSON VALUES(10054,'Chanson de la fille du garde-barrière',5,NULL,NULL,'2008-03-20 13:49:34');
INSERT INTO CHANSON VALUES(10055,'Scato',5,NULL,NULL,'2008-03-12 18:12:21');
INSERT INTO CHANSON VALUES(10056,'L''hiver en avance',5,NULL,'f','2008-03-12 11:30:46');
INSERT INTO CHANSON VALUES(10057,'George Sand',5,NULL,'f','2008-03-12 08:33:36');
INSERT INTO CHANSON VALUES(10058,'La nuit est jeune',5,NULL,'f','2008-03-12 19:41:55');
INSERT INTO CHANSON VALUES(10059,'L''amputé',5,NULL,'f','2008-06-02 13:53:37.092899');
INSERT INTO CHANSON VALUES(10060,'Le mauvais client',5,NULL,'f','2008-03-12 08:28:09');
INSERT INTO CHANSON VALUES(10061,'Cantique',5,NULL,'f','2008-03-12 16:57:11');
INSERT INTO CHANSON VALUES(10062,'Menteur',5,NULL,'f','2008-03-12 13:32:38');
INSERT INTO CHANSON VALUES(10145,'Le humeurs de Catherine',5,NULL,'f','2008-03-12 13:31:47');
INSERT INTO CHANSON VALUES(10146,'Bolero Callejero',5,NULL,NULL,'2008-03-12 11:12:11');
INSERT INTO CHANSON VALUES(10149,'----',5,NULL,'f','2008-03-12 12:31:34');
INSERT INTO CHANSON VALUES(10150,'Les filles du Calvaire',5,NULL,'f','2008-03-12 18:36:20');
INSERT INTO CHANSON VALUES(10151,'Nocturn, à Joan Salvat-Papasseit',5,NULL,'f','2008-03-12 10:41:59');
INSERT INTO CHANSON VALUES(10152,'Slow Italien ou Barbarie: The Way I Walk',5,NULL,'f','2008-03-12 17:58:46');
INSERT INTO CHANSON VALUES(10153,'Slow Italien ou Barbarie: Egyptian Reggae',5,NULL,'f','2008-03-12 08:27:37');
INSERT INTO CHANSON VALUES(10154,'Slow Italien ou Barbarie: Madame Yamilah',5,NULL,'f','2008-03-12 13:11:47');
INSERT INTO CHANSON VALUES(10155,'Slow Italien ou Barbarie: Cafe Mozart',5,NULL,'f','2008-03-12 10:38:18');
INSERT INTO CHANSON VALUES(10156,'Slow Italien ou Barbarie: Mirades Orientals',5,NULL,'f','2008-03-12 08:55:31');
INSERT INTO CHANSON VALUES(10157,'Slow Italien ou Barbarie: Amapola',5,NULL,'f','2008-03-12 10:52:39');
INSERT INTO CHANSON VALUES(10158,'Slow Italien ou Barbarie: Moulin Rouge',5,NULL,'f','2008-03-12 10:12:47');
INSERT INTO CHANSON VALUES(10159,'Slow Italien ou Barbarie: Teresa',5,NULL,'f','2008-03-12 10:34:19');
INSERT INTO CHANSON VALUES(10160,'Slow Italien ou Barbarie: 33 bars',5,NULL,NULL,'2008-03-12 16:26:56');
INSERT INTO CHANSON VALUES(10161,'Slow Italien ou Barbarie: La bella ciao',5,NULL,'f','2008-03-12 09:39:37');
INSERT INTO CHANSON VALUES(10164,'Le Temps des cerises',5,NULL,'f','2008-03-12 13:56:14');
INSERT INTO CHANSON VALUES(10165,'Red Bologna',5,NULL,'f','2008-03-12 11:09:53');
INSERT INTO CHANSON VALUES(10166,'Onliyu',5,NULL,'f','2008-03-12 14:11:49');
INSERT INTO CHANSON VALUES(10167,'Un ennemi du peuple',5,NULL,'f','2008-03-12 09:23:42');
INSERT INTO CHANSON VALUES(10168,'Els segadors',5,NULL,'f','2008-03-12 17:36:54');
INSERT INTO CHANSON VALUES(10169,'Valse de la demoiselle aux yeux verts',5,NULL,'f','2008-03-12 14:46:28');
INSERT INTO CHANSON VALUES(10170,'Syldavian rapsodie',5,NULL,'f','2008-03-12 18:30:55');
INSERT INTO CHANSON VALUES(10171,'Petenera',5,NULL,'f','2008-03-12 17:36:34');
INSERT INTO CHANSON VALUES(10172,'La dansa de Castellterçol',5,NULL,'f','2008-03-12 13:41:01');
INSERT INTO CHANSON VALUES(10174,'La notte di blu (standard)',5,NULL,NULL,'2008-03-12 09:00:28');
INSERT INTO CHANSON VALUES(10175,'Les Dimanches au Palmarium',5,NULL,'f','2008-03-12 12:16:38');
INSERT INTO CHANSON VALUES(10176,'Jac B. and his dancing dogs',5,NULL,'f','2008-03-12 11:50:49');
INSERT INTO CHANSON VALUES(10177,'O Caroline',5,NULL,'f','2008-03-12 08:55:13');
INSERT INTO CHANSON VALUES(10179,'Memories',5,NULL,'f','2008-03-12 16:14:35');
INSERT INTO CHANSON VALUES(10181,'Brune on brune',5,NULL,'f','2008-03-12 09:57:42');
INSERT INTO CHANSON VALUES(10183,'Ball de l''Aliga',5,NULL,'f','2008-03-12 16:28:55');
INSERT INTO CHANSON VALUES(10184,'Lieberslied',5,NULL,'f','2008-03-12 10:35:56');
INSERT INTO CHANSON VALUES(10185,'El Cant dels ocells',5,NULL,'f','2008-03-12 16:57:12');
INSERT INTO CHANSON VALUES(10186,'Volando voy',5,NULL,'f','2008-03-12 12:12:02');
INSERT INTO CHANSON VALUES(10187,'O, Caroline',5,NULL,'f','2008-03-12 09:16:58');
INSERT INTO CHANSON VALUES(10188,'Honey',2,NULL,'f','2008-03-12 12:03:40');
INSERT INTO CHANSON VALUES(10189,'Find My Baby',2,NULL,'f','2008-03-12 10:44:54');
INSERT INTO CHANSON VALUES(10190,'Porcelain',2,NULL,'f','2008-03-12 17:54:02');
INSERT INTO CHANSON VALUES(10191,'Why Does My Heart Feel So Bad?',2,NULL,'f','2008-03-12 18:00:00');
INSERT INTO CHANSON VALUES(10192,'South Side',2,NULL,'f','2008-03-12 15:40:25');
INSERT INTO CHANSON VALUES(10193,'Rushing',2,NULL,'f','2008-03-12 08:22:54');
INSERT INTO CHANSON VALUES(10194,'Bodyrock',2,NULL,'f','2008-03-12 19:36:30');
INSERT INTO CHANSON VALUES(10195,'Natural Blues',2,NULL,'f','2008-03-12 18:18:27');
INSERT INTO CHANSON VALUES(10196,'Machete',2,NULL,NULL,'2008-03-12 09:38:40');
INSERT INTO CHANSON VALUES(10197,'7',2,NULL,NULL,'2008-03-12 09:48:56');
INSERT INTO CHANSON VALUES(10198,'Run On',2,NULL,'f','2008-03-12 09:10:00');
INSERT INTO CHANSON VALUES(10199,'Down Slow',2,NULL,'f','2008-03-12 17:22:44');
INSERT INTO CHANSON VALUES(10200,'If Things Were Perfect',2,NULL,'f','2008-03-12 16:10:39');
INSERT INTO CHANSON VALUES(10201,'Everloving',2,NULL,'f','2008-03-12 17:04:40');
INSERT INTO CHANSON VALUES(10202,'Inside',2,NULL,'f','2008-03-12 17:41:21');
INSERT INTO CHANSON VALUES(10203,'Guitar, Flute, & String',2,NULL,'f','2008-03-12 10:42:43');
INSERT INTO CHANSON VALUES(10204,'The Sky is Broken',2,NULL,'f','2008-03-12 09:39:20');
INSERT INTO CHANSON VALUES(10205,'My Weakness',2,NULL,'f','2008-03-12 15:33:38');
INSERT INTO CHANSON VALUES(10225,'Geiger counter',6,NULL,'f','2008-03-12 08:47:18');
INSERT INTO CHANSON VALUES(10226,'Radioactivity',6,NULL,'f','2008-03-12 19:35:18');
INSERT INTO CHANSON VALUES(10227,'Radioland',6,NULL,'f','2008-03-12 14:44:30');
INSERT INTO CHANSON VALUES(10228,'Airwaves',6,NULL,NULL,'2008-03-12 18:36:50');
INSERT INTO CHANSON VALUES(10229,'Intermission',6,NULL,NULL,'2008-03-12 17:49:47');
INSERT INTO CHANSON VALUES(10230,'News',6,NULL,'f','2008-03-12 12:41:50');
INSERT INTO CHANSON VALUES(10231,'The voice of energy',6,NULL,'f','2008-03-12 14:50:38');
INSERT INTO CHANSON VALUES(10232,'Antenna',6,NULL,'f','2008-03-12 13:06:08');
INSERT INTO CHANSON VALUES(10233,'Radio stars',6,NULL,'f','2008-03-12 12:38:21');
INSERT INTO CHANSON VALUES(10234,'Uranium',6,NULL,'f','2008-03-12 08:50:01');
INSERT INTO CHANSON VALUES(10235,'Transistor',6,NULL,'f','2008-03-12 09:52:48');
INSERT INTO CHANSON VALUES(10236,'Ohm sweet ohm',6,NULL,'f','2008-03-12 13:49:24');
INSERT INTO CHANSON VALUES(10237,'Computer world',6,NULL,'f','2008-03-12 17:21:08');
INSERT INTO CHANSON VALUES(10238,'Pocket calculator',6,NULL,'f','2008-03-12 11:12:45');
INSERT INTO CHANSON VALUES(10239,'Numbers',6,NULL,'f','2008-03-12 09:01:34');
INSERT INTO CHANSON VALUES(10240,'Computer world-2',6,NULL,'f','2008-03-12 19:21:16');
INSERT INTO CHANSON VALUES(10241,'Computer love',6,NULL,'f','2008-03-12 17:52:07');
INSERT INTO CHANSON VALUES(10242,'Home computer',6,NULL,'f','2008-03-12 12:22:13');
INSERT INTO CHANSON VALUES(10243,'It''s more fun to compute',6,NULL,'f','2008-03-12 14:46:52');
INSERT INTO CHANSON VALUES(10367,'Wild thing are blowing',2,NULL,'f','2008-03-12 12:04:35');
INSERT INTO CHANSON VALUES(10368,'Shape of thing to come',2,NULL,'f','2008-03-16 11:28:56');
INSERT INTO CHANSON VALUES(10375,'Take me bak''ome',2,NULL,NULL,'2008-03-12 18:34:34');
INSERT INTO CHANSON VALUES(10378,'Skweeze me pleeze me',2,NULL,NULL,'2008-03-12 19:48:37');
INSERT INTO CHANSON VALUES(10379,'How d''you ride',2,NULL,'f','2008-03-12 18:43:06');
INSERT INTO CHANSON VALUES(10380,'The whole world''s goin'' crazee',2,NULL,'f','2008-03-12 18:12:23');
INSERT INTO CHANSON VALUES(10381,'Look at last night',2,NULL,'f','2008-03-12 14:36:30');
INSERT INTO CHANSON VALUES(10382,'I won''t let it ''appen agen',2,NULL,'f','2008-03-12 18:05:51');
INSERT INTO CHANSON VALUES(10384,'Gudbuy t''Jane',2,NULL,'f','2008-03-12 11:14:26');
INSERT INTO CHANSON VALUES(10385,'Gudbuy gudbuy',2,NULL,'f','2008-03-12 12:07:01');
INSERT INTO CHANSON VALUES(10386,'I don''t mind',2,NULL,'f','2008-03-12 19:48:11');
INSERT INTO CHANSON VALUES(10387,'Let the good times roll',2,NULL,'f','2008-03-12 08:10:42');
INSERT INTO CHANSON VALUES(10413,'Baader',7,NULL,'f','2008-03-12 11:58:30');
INSERT INTO CHANSON VALUES(10414,'Pierrot',7,NULL,'f','2008-03-12 09:23:42');
INSERT INTO CHANSON VALUES(10415,'Villa-mon-cul',7,NULL,'f','2008-03-12 10:30:05');
INSERT INTO CHANSON VALUES(10416,'Le sport',7,NULL,'f','2008-03-12 12:07:15');
INSERT INTO CHANSON VALUES(10417,'St Nicolas',7,NULL,'f','2008-03-12 14:00:20');
INSERT INTO CHANSON VALUES(10418,'La mer mousse',7,NULL,'f','2008-03-12 15:20:42');
INSERT INTO CHANSON VALUES(10419,'Lourdes',7,NULL,'f','2008-03-12 09:44:52');
INSERT INTO CHANSON VALUES(10420,'Les usages',7,NULL,'f','2008-03-12 17:18:40');
INSERT INTO CHANSON VALUES(10421,'Le candidat des cons',7,NULL,'f','2008-03-12 08:34:15');
INSERT INTO CHANSON VALUES(10422,'Les marins',7,NULL,'f','2008-03-12 10:46:00');
INSERT INTO CHANSON VALUES(10423,'La rivière',7,NULL,'f','2008-03-12 14:03:59');
INSERT INTO CHANSON VALUES(10424,'Chien abandonné',7,NULL,'f','2008-03-12 08:12:23');
INSERT INTO CHANSON VALUES(10425,'La colombe',7,NULL,'f','2008-03-12 16:24:53');
INSERT INTO CHANSON VALUES(10426,'L''allemand',7,NULL,'f','2008-03-12 17:47:01');
INSERT INTO CHANSON VALUES(10427,'Copernic',7,NULL,'f','2008-03-12 08:21:01');
INSERT INTO CHANSON VALUES(10428,'La vieille',7,NULL,'f','2008-03-12 12:59:22');
INSERT INTO CHANSON VALUES(10429,'Subvention',7,NULL,'f','2008-03-12 09:05:06');
INSERT INTO CHANSON VALUES(10430,'L''isoloir',7,NULL,'f','2008-03-12 19:53:24');
INSERT INTO CHANSON VALUES(10431,'Giscard élection',7,NULL,'f','2008-03-12 16:57:58');
INSERT INTO CHANSON VALUES(10432,'Miss Émilie',7,NULL,'f','2008-03-12 19:07:45');
INSERT INTO CHANSON VALUES(10434,'OEsophage-boogie, Cardiac'' blues',2,NULL,'f','2008-03-12 19:38:01');
INSERT INTO CHANSON VALUES(10435,'Encore une journée d''foutue',2,NULL,NULL,'2008-03-23 11:22:26');
INSERT INTO CHANSON VALUES(10437,'Ce qui est dit doit être fait',2,NULL,'f','2008-03-12 10:16:36');
INSERT INTO CHANSON VALUES(10438,'Paris - New York, New York - Paris',2,NULL,'f','2008-03-12 15:48:40');
INSERT INTO CHANSON VALUES(10439,'L''homme oiseau',2,NULL,'f','2008-03-12 17:47:34');
INSERT INTO CHANSON VALUES(10441,'Illicite',2,NULL,NULL,'2008-03-12 09:23:40');
INSERT INTO CHANSON VALUES(10442,'Il n''y a pas de nom (pour le repos de son Àme)',2,NULL,NULL,'2008-03-12 18:19:18');
INSERT INTO CHANSON VALUES(10443,'x',2,NULL,'f','2008-03-12 16:16:57');
INSERT INTO CHANSON VALUES(10444,'x',2,NULL,'f','2008-03-12 17:35:19');
INSERT INTO CHANSON VALUES(10445,'x',2,NULL,'f','2008-03-12 10:48:31');
INSERT INTO CHANSON VALUES(10446,'x',2,NULL,'f','2008-03-12 13:03:47');
INSERT INTO CHANSON VALUES(10447,'x',2,NULL,NULL,'2008-03-12 08:19:29');
INSERT INTO CHANSON VALUES(10448,'x',2,NULL,'f','2008-03-12 15:58:17');
INSERT INTO CHANSON VALUES(10449,'x',2,NULL,'f','2008-03-12 11:43:05');
INSERT INTO CHANSON VALUES(10450,'x',2,NULL,'f','2008-03-12 18:53:34');
INSERT INTO CHANSON VALUES(10451,'x',2,NULL,'f','2008-03-12 13:01:57');
INSERT INTO CHANSON VALUES(10452,'x',2,NULL,'f','2008-03-12 09:56:17');
INSERT INTO CHANSON VALUES(10453,'Les vacances',7,NULL,'f','2008-03-12 12:40:33');
INSERT INTO CHANSON VALUES(10454,'Premier amour',7,NULL,'f','2008-03-12 12:25:08');
INSERT INTO CHANSON VALUES(10455,'Smile',7,NULL,'f','2008-03-12 16:37:57');
INSERT INTO CHANSON VALUES(10456,'Don Quichotte',7,NULL,'f','2008-03-12 10:03:00');
INSERT INTO CHANSON VALUES(10457,'Le premier de la classe',7,NULL,'f','2008-03-12 08:05:20');
INSERT INTO CHANSON VALUES(10458,'La conquête du Sud',7,NULL,'f','2008-03-12 13:44:18');
INSERT INTO CHANSON VALUES(10459,'Bonjour',7,NULL,'f','2008-03-12 17:03:01');
INSERT INTO CHANSON VALUES(10460,'Petite Copine',7,NULL,NULL,'2008-03-12 18:56:54');
INSERT INTO CHANSON VALUES(10461,'Camarade',7,NULL,'f','2008-03-12 13:22:56');
INSERT INTO CHANSON VALUES(10462,'Changez vos cavalières',7,NULL,'f','2008-03-12 13:28:52');
INSERT INTO CHANSON VALUES(10463,'Oublié (Replicant mix) (One Trip One Noise)',2,NULL,'f','2008-03-12 16:52:32');
INSERT INTO CHANSON VALUES(10464,'Lazy (Démo 1996)',2,NULL,'f','2008-05-22 17:52:11');
INSERT INTO CHANSON VALUES(10465,'La chaleur (Veuillez Rendre L''âme)',2,NULL,'f','2008-03-12 11:13:57');
INSERT INTO CHANSON VALUES(10466,'The holy economic war (Dies Irae)',2,NULL,'f','2008-03-12 12:54:35');
INSERT INTO CHANSON VALUES(10467,'Drunken sailors (Élysée Montmartre 89)',2,NULL,'f','2008-03-12 12:06:38');
INSERT INTO CHANSON VALUES(10468,'Les écorchés (Dies Irae)',2,NULL,'f','2008-03-23 12:07:44');
INSERT INTO CHANSON VALUES(10469,'Toujours être ailleurs (Où veux-tu qu''je r''garde)',2,NULL,'f','2008-03-17 16:36:28');
INSERT INTO CHANSON VALUES(10470,'A l''arrière des taxis (Veuillez Rendre L''âme)',2,NULL,'f','2008-03-23 08:23:31');
INSERT INTO CHANSON VALUES(10471,'Twilight zone (Maxi L''Homme Pressé)',2,NULL,'f','2008-03-12 08:17:28');
INSERT INTO CHANSON VALUES(10472,'Volontaire (Climax - Alain Bashung)',2,NULL,'f','2008-03-12 19:44:50');
INSERT INTO CHANSON VALUES(10473,'I want you (She''s so heavy) (Maxi Tostaki)',2,NULL,NULL,'2008-03-12 18:10:18');
INSERT INTO CHANSON VALUES(10474,'Les écorchés (Sloy mix) (One Trip One Noise)',2,NULL,NULL,'2008-03-23 11:08:24');
INSERT INTO CHANSON VALUES(10475,'Helter skelter (Nyon 1989)',2,NULL,'f','2008-03-12 11:33:19');
INSERT INTO CHANSON VALUES(10476,'Long time man (Dies Irae)',2,NULL,'f','2008-03-12 18:55:25');
INSERT INTO CHANSON VALUES(10477,'Ces gens-là (Aux Suivants)',2,NULL,'f','2008-03-12 13:18:32');
INSERT INTO CHANSON VALUES(10478,'Back to you (Maxi L''Homme Pressé)',2,NULL,'f','2008-03-12 10:01:09');
INSERT INTO CHANSON VALUES(10479,'Le fleuve (Dies Irae)',2,NULL,'f','2008-03-23 16:02:33');
INSERT INTO CHANSON VALUES(10480,'Là-bas (Maxi L''Homme Pressé)',2,NULL,'f','2008-03-12 11:04:50');
INSERT INTO CHANSON VALUES(10481,'À ton étoile (Yann Tiersen Mix)',2,NULL,'f','2008-03-12 16:01:35');
INSERT INTO CHANSON VALUES(10482,'Lullaby (Maxi Tostaky)',2,NULL,'f','2008-03-12 14:54:45');
INSERT INTO CHANSON VALUES(10483,'One trip one noise (One Trip One Noise)',2,NULL,NULL,'2008-03-12 18:39:38');
INSERT INTO CHANSON VALUES(10484,'What I need (Dies Irae)',2,NULL,'f','2008-04-07 13:16:00');
INSERT INTO CHANSON VALUES(10485,'Oublié (Dies Irae)',2,NULL,'f','2008-03-12 08:57:46');
INSERT INTO CHANSON VALUES(10486,'Dirty (Maxi Lolita Nie En Bloc)',2,NULL,'f','2008-03-12 13:14:20');
INSERT INTO CHANSON VALUES(10487,'La rage (Dies Irae)',2,NULL,'f','2008-03-12 17:05:15');
INSERT INTO CHANSON VALUES(10488,'Aux sombres héros de l''amer (Veuillez Rendre L''âme)',2,NULL,NULL,'2008-03-23 10:35:34');
INSERT INTO CHANSON VALUES(10508,'Would you believe?',2,NULL,'f','2008-03-12 15:42:59');
INSERT INTO CHANSON VALUES(10510,'Bitters end',2,NULL,NULL,'2008-03-12 10:09:32');
INSERT INTO CHANSON VALUES(10511,'The thrill of it all',2,NULL,'f','2008-03-12 16:37:50');
INSERT INTO CHANSON VALUES(10512,'Three and nine',2,NULL,'f','2008-03-12 11:20:21');
INSERT INTO CHANSON VALUES(10513,'All I want is you',2,NULL,'f','2008-03-12 13:37:40');
INSERT INTO CHANSON VALUES(10514,'If it takes all night',2,NULL,'f','2008-03-12 13:30:54');
INSERT INTO CHANSON VALUES(10515,'Bitter sweet',2,NULL,'f','2008-04-11 10:11:11');
INSERT INTO CHANSON VALUES(10516,'Triptych',2,NULL,'f','2008-04-18 14:40:53');
INSERT INTO CHANSON VALUES(10648,'Is This Love',8,NULL,'f','2008-03-12 15:55:43');
INSERT INTO CHANSON VALUES(10649,'No Women No Cry',8,NULL,'f','2008-03-12 17:04:53');
INSERT INTO CHANSON VALUES(10650,'Could You Be Loved',8,NULL,'f','2008-03-12 12:06:39');
INSERT INTO CHANSON VALUES(10651,'Three Little Birds',8,NULL,'f','2008-03-12 09:04:43');
INSERT INTO CHANSON VALUES(10652,'Buffalo Soldier',8,NULL,'f','2008-03-12 17:34:28');
INSERT INTO CHANSON VALUES(10653,'Get Up Stand Up',8,NULL,'f','2008-03-12 08:14:54');
INSERT INTO CHANSON VALUES(10654,'Stir It Up',8,NULL,'f','2008-03-12 10:40:16');
INSERT INTO CHANSON VALUES(10655,'One Love (People Get Ready)',8,NULL,'f','2008-03-12 13:33:50');
INSERT INTO CHANSON VALUES(10656,'I Shot The Sheriff',8,NULL,'f','2008-06-07 19:24:37.709599');
INSERT INTO CHANSON VALUES(10657,'Waiting In Vain',8,NULL,'f','2008-03-12 14:02:14');
INSERT INTO CHANSON VALUES(10658,'Redemption Song',8,NULL,'f','2008-03-12 12:42:09');
INSERT INTO CHANSON VALUES(10659,'Satisfy My Soul',8,NULL,'f','2008-03-12 08:28:13');
INSERT INTO CHANSON VALUES(10660,'Exodus',8,NULL,'f','2008-03-12 19:52:20');
INSERT INTO CHANSON VALUES(10661,'Jamming',8,NULL,'f','2008-03-12 15:00:24');
INSERT INTO CHANSON VALUES(10662,'Love etc.',9,NULL,NULL,'2008-03-12 11:46:59');
INSERT INTO CHANSON VALUES(10663,'Take this waltz (Léonard Cohen)',9,NULL,NULL,'2008-03-12 17:50:14');
INSERT INTO CHANSON VALUES(10664,'Z''Holiday (The Zombietles)',9,NULL,NULL,'2008-03-12 16:02:54');
INSERT INTO CHANSON VALUES(10665,'Nessun dorma (Turandot/Eugenio Fernandi)',9,NULL,NULL,'2008-03-12 19:27:28');
INSERT INTO CHANSON VALUES(10666,'Le Portel',9,NULL,NULL,'2008-03-12 17:44:42');
INSERT INTO CHANSON VALUES(10667,'La première rencontre',9,NULL,NULL,'2008-03-12 17:17:44');
INSERT INTO CHANSON VALUES(10668,'L''amour etc...',9,NULL,NULL,'2008-03-12 08:37:27');
INSERT INTO CHANSON VALUES(10669,'Thème de Marie',9,NULL,NULL,'2008-03-12 10:41:55');
INSERT INTO CHANSON VALUES(10670,'Le mariage',9,NULL,NULL,'2008-03-12 13:37:48');
INSERT INTO CHANSON VALUES(10671,'Le confidences de Benoît',9,NULL,NULL,'2008-03-12 17:13:48');
INSERT INTO CHANSON VALUES(10672,'Pierre est amoureux',9,NULL,NULL,'2008-03-12 10:33:35');
INSERT INTO CHANSON VALUES(10673,'L''usure du temps',9,NULL,NULL,'2008-03-12 10:22:26');
INSERT INTO CHANSON VALUES(10674,'La trahison',9,NULL,NULL,'2008-03-12 13:05:28');
INSERT INTO CHANSON VALUES(10675,'La déclaration d''amour',9,NULL,NULL,'2008-03-12 12:04:56');
INSERT INTO CHANSON VALUES(10676,'La fleuriste',9,NULL,NULL,'2008-03-12 17:53:40');
INSERT INTO CHANSON VALUES(10677,'Les soupçons de Benoît',9,NULL,NULL,'2008-03-12 14:43:57');
INSERT INTO CHANSON VALUES(10678,'Rendez-vous en l''an 2000',9,NULL,NULL,'2008-03-12 11:46:35');
INSERT INTO CHANSON VALUES(10679,'Marie peint',9,NULL,NULL,'2008-03-12 16:59:16');
INSERT INTO CHANSON VALUES(10680,'Les nuits d''htel',9,NULL,NULL,'2008-03-12 15:26:54');
INSERT INTO CHANSON VALUES(10681,'Le jardin de Pierre',9,NULL,NULL,'2008-03-12 13:14:08');
INSERT INTO CHANSON VALUES(10682,'L''amour etc.. (reprise)',9,NULL,NULL,'2008-03-12 11:26:41');
INSERT INTO CHANSON VALUES(10683,'Blankenberg 1er janvier 2000',9,NULL,NULL,'2008-03-12 18:37:04');
INSERT INTO CHANSON VALUES(10684,'J''y suis jamais allé',9,NULL,'f','2008-03-12 11:02:09');
INSERT INTO CHANSON VALUES(10685,'Les jours tristes (instrumental)',9,NULL,'f','2008-06-07 19:08:19.718218');
INSERT INTO CHANSON VALUES(10686,'La valse d''Amélie',9,NULL,'f','2008-03-12 16:11:06');
INSERT INTO CHANSON VALUES(10687,'Comptine d''un autre été : l''après midi',9,NULL,'f','2008-03-12 12:41:49');
INSERT INTO CHANSON VALUES(10688,'La noyée',9,NULL,NULL,'2008-03-12 12:57:36');
INSERT INTO CHANSON VALUES(10689,'L''autre valse d''Amélie',9,NULL,'f','2008-03-12 19:40:36');
INSERT INTO CHANSON VALUES(10690,'Guilty',9,NULL,'f','2008-03-12 10:18:03');
INSERT INTO CHANSON VALUES(10691,'A quai',9,NULL,'f','2008-03-12 09:46:17');
INSERT INTO CHANSON VALUES(10692,'Le moulin',9,NULL,'f','2008-03-12 11:02:44');
INSERT INTO CHANSON VALUES(10694,'La valse d'' Amélie (version orchestre)',9,NULL,'f','2008-03-12 08:13:23');
INSERT INTO CHANSON VALUES(10695,'La valse des vieux os',9,NULL,'f','2008-03-12 10:59:46');
INSERT INTO CHANSON VALUES(10696,'La dispute',9,NULL,NULL,'2008-03-12 12:42:58');
INSERT INTO CHANSON VALUES(10697,'Si tu n''étais pas là (Fréhel)',9,NULL,NULL,'2008-03-12 14:06:39');
INSERT INTO CHANSON VALUES(10699,'La redécouverte',9,NULL,'f','2008-03-12 19:25:17');
INSERT INTO CHANSON VALUES(10700,'Sur le fil',9,NULL,'f','2008-03-12 14:39:36');
INSERT INTO CHANSON VALUES(10702,'La valse d'' Amélie (version piano)',9,NULL,'f','2008-03-12 19:02:25');
INSERT INTO CHANSON VALUES(10704,'Interviews',9,NULL,NULL,'2008-03-12 08:01:33');
INSERT INTO CHANSON VALUES(10705,'Lullaby of birdland',9,NULL,NULL,'2008-03-12 13:12:33');
INSERT INTO CHANSON VALUES(10706,'Yvan au cinéma',9,NULL,NULL,'2008-03-12 10:37:16');
INSERT INTO CHANSON VALUES(10707,'Another shade of blue',9,NULL,NULL,'2008-03-12 10:08:23');
INSERT INTO CHANSON VALUES(10708,'Action',9,NULL,NULL,'2008-03-12 18:30:51');
INSERT INTO CHANSON VALUES(10709,'London calling',9,NULL,NULL,'2008-03-12 13:28:17');
INSERT INTO CHANSON VALUES(10710,'Camping next to water',9,NULL,NULL,'2008-03-12 17:02:56');
INSERT INTO CHANSON VALUES(10711,'Soho',9,NULL,NULL,'2008-03-12 12:41:43');
INSERT INTO CHANSON VALUES(10712,'Annie''s lament',9,NULL,NULL,'2008-03-12 17:38:46');
INSERT INTO CHANSON VALUES(10713,'Dans la loge',9,NULL,NULL,'2008-03-12 10:18:46');
INSERT INTO CHANSON VALUES(10714,'Au petit matin',9,NULL,NULL,'2008-03-12 14:20:48');
INSERT INTO CHANSON VALUES(10715,'Honey suckle rose',9,NULL,NULL,'2008-03-12 09:46:01');
INSERT INTO CHANSON VALUES(10716,'Thai-chi et brie de meaux',9,NULL,NULL,'2008-03-12 15:59:39');
INSERT INTO CHANSON VALUES(10717,'Sonnet - 1',9,NULL,NULL,'2008-03-12 19:09:47');
INSERT INTO CHANSON VALUES(10718,'Song song',9,NULL,NULL,'2008-03-12 11:00:17');
INSERT INTO CHANSON VALUES(10719,'Sonnet - 2',9,NULL,NULL,'2008-03-12 10:28:45');
INSERT INTO CHANSON VALUES(10720,'Singalong junk-Charlotte''s theme - 1',9,NULL,NULL,'2008-03-12 13:13:48');
INSERT INTO CHANSON VALUES(10721,'Come on let''s go',9,NULL,NULL,'2008-03-12 13:35:30');
INSERT INTO CHANSON VALUES(10722,'Singalong junk-Charlotte''s theme - 2',9,NULL,NULL,'2008-03-12 09:21:08');
INSERT INTO CHANSON VALUES(10723,'Bedroom dancing',9,NULL,NULL,'2008-03-12 19:31:27');
INSERT INTO CHANSON VALUES(10724,'It''s all right now',9,NULL,NULL,'2008-03-12 16:03:47');
INSERT INTO CHANSON VALUES(10725,'Young at heart',9,NULL,NULL,'2008-03-12 14:08:33');
INSERT INTO CHANSON VALUES(10726,'The end',9,NULL,NULL,'2008-03-12 14:47:32');
INSERT INTO CHANSON VALUES(10727,'Streets of Philadelphia',9,NULL,NULL,'2008-03-12 10:43:42');
INSERT INTO CHANSON VALUES(10728,'Lovetown',9,NULL,NULL,'2008-03-12 08:01:42');
INSERT INTO CHANSON VALUES(10729,'It''s in your Eyes',9,NULL,NULL,'2008-03-12 11:12:11');
INSERT INTO CHANSON VALUES(10730,'Ibo Lele (Dreams come True)',9,NULL,NULL,'2008-03-12 08:41:24');
INSERT INTO CHANSON VALUES(10731,'Please send me someone to love',9,NULL,NULL,'2008-03-12 18:06:00');
INSERT INTO CHANSON VALUES(10732,'Have you ever seen the Rain?',9,NULL,NULL,'2008-03-12 12:16:21');
INSERT INTO CHANSON VALUES(10733,'I don''t wanna talk about it',9,NULL,NULL,'2008-03-12 14:12:53');
INSERT INTO CHANSON VALUES(10734,'La Mamma Morta',9,NULL,NULL,'2008-03-12 19:55:57');
INSERT INTO CHANSON VALUES(10735,'Philadelphia',9,NULL,NULL,'2008-03-12 17:27:05');
INSERT INTO CHANSON VALUES(10736,'Precedent',9,NULL,NULL,'2008-03-12 12:00:53');
INSERT INTO CHANSON VALUES(10737,'Opening Titles Including Underground',9,NULL,NULL,'2008-06-07 15:34:15.077201');
INSERT INTO CHANSON VALUES(10738,'Into the Labyrinth',9,NULL,NULL,'2008-03-12 15:13:38');
INSERT INTO CHANSON VALUES(10739,'Magic Dance',9,NULL,NULL,'2008-06-07 15:34:40.439933');
INSERT INTO CHANSON VALUES(10740,'Sarah',9,NULL,NULL,'2008-03-12 14:36:32');
INSERT INTO CHANSON VALUES(10741,'Chilly Down',9,NULL,NULL,'2008-06-07 15:34:54.981618');
INSERT INTO CHANSON VALUES(10742,'Hallucination',9,NULL,NULL,'2008-03-12 19:53:54');
INSERT INTO CHANSON VALUES(10743,'As the World Falls Down',9,NULL,NULL,'2008-06-07 15:11:50.297527');
INSERT INTO CHANSON VALUES(10744,'The Goblin Battle',9,NULL,NULL,'2008-03-12 10:25:02');
INSERT INTO CHANSON VALUES(10745,'Within You',9,NULL,NULL,'2008-06-07 15:12:17.413361');
INSERT INTO CHANSON VALUES(10746,'Thirteen O''clock',9,NULL,NULL,'2008-03-12 10:33:30');
INSERT INTO CHANSON VALUES(10747,'Home at Last',9,NULL,NULL,'2008-03-12 09:27:43');
INSERT INTO CHANSON VALUES(10748,'Underground',9,NULL,NULL,'2008-06-07 15:12:51.626528');
INSERT INTO CHANSON VALUES(10749,'Main Title (I Had A Farm In Africa)',9,NULL,NULL,'2008-03-12 12:24:29');
INSERT INTO CHANSON VALUES(10750,'I''m Better At Hello (Karen''s Theme I)',9,NULL,NULL,'2008-03-12 10:55:06');
INSERT INTO CHANSON VALUES(10751,'Have You Got A Story For Me?',9,NULL,NULL,'2008-03-12 16:50:35');
INSERT INTO CHANSON VALUES(10752,'Concerto For Clarinet And Orchestra In A (K.622)',9,NULL,NULL,'2008-03-12 12:46:29');
INSERT INTO CHANSON VALUES(10753,'Safari',9,NULL,NULL,'2008-03-12 11:04:55');
INSERT INTO CHANSON VALUES(10754,'Karen''s Journey, Siyawe',9,NULL,NULL,'2008-03-12 13:15:21');
INSERT INTO CHANSON VALUES(10755,'Flying Over Africa',9,NULL,NULL,'2008-03-12 13:24:34');
INSERT INTO CHANSON VALUES(10756,'I Had A Compass From Denys (Karen''s Theme II)',9,NULL,NULL,'2008-03-12 19:38:07');
INSERT INTO CHANSON VALUES(10757,'Alone On The Farm',9,NULL,NULL,'2008-03-12 13:45:35');
INSERT INTO CHANSON VALUES(10758,'Let The Rest Of The World Go By',9,NULL,NULL,'2008-03-12 10:29:40');
INSERT INTO CHANSON VALUES(10759,'If I Know A Song Of Africa (Karen''s Theme III)',9,NULL,NULL,'2008-03-12 09:51:04');
INSERT INTO CHANSON VALUES(10760,'End Title (You Are Karen)',9,NULL,NULL,'2008-03-12 15:03:00');
INSERT INTO CHANSON VALUES(10762,'Thoura-Jarvagh Koulchi',9,NULL,NULL,'2008-03-12 11:12:37');
INSERT INTO CHANSON VALUES(10763,'Ayrib',9,NULL,NULL,'2008-03-12 17:30:41');
INSERT INTO CHANSON VALUES(10764,'Ayadhou Goual',9,NULL,NULL,'2008-03-12 16:55:57');
INSERT INTO CHANSON VALUES(10765,'Non je n''ai pas oublié',9,NULL,NULL,'2008-03-12 09:23:22');
INSERT INTO CHANSON VALUES(10766,'Avava Inouva',9,NULL,NULL,'2008-03-12 16:20:00');
INSERT INTO CHANSON VALUES(10767,'Je vis encore',9,NULL,NULL,'2008-03-12 17:47:46');
INSERT INTO CHANSON VALUES(10768,'Asaru',9,NULL,NULL,'2008-03-12 12:58:16');
INSERT INTO CHANSON VALUES(10769,'Rire Zarga Ouana',9,NULL,NULL,'2008-03-12 08:06:07');
INSERT INTO CHANSON VALUES(10770,'Haoulou',9,NULL,NULL,'2008-03-12 09:43:11');
INSERT INTO CHANSON VALUES(10771,'Ana El Owerka',9,NULL,NULL,'2008-03-12 09:27:00');
INSERT INTO CHANSON VALUES(10772,'Ebhergh Ghi Lemzi ( )',9,NULL,NULL,'2008-03-12 08:46:12');
INSERT INTO CHANSON VALUES(10773,'Bled Sidi ( )',9,NULL,NULL,'2008-03-12 15:35:42');
INSERT INTO CHANSON VALUES(10774,'Zaâma ( )',9,NULL,NULL,'2008-03-12 11:20:38');
INSERT INTO CHANSON VALUES(10776,'Boys Play Football - Dialogue',9,NULL,NULL,'2008-03-12 15:06:22');
INSERT INTO CHANSON VALUES(10778,'Mother''s Letter - Dialogue',9,NULL,NULL,'2008-03-12 13:19:07');
INSERT INTO CHANSON VALUES(10779,'I Believe',9,NULL,NULL,'2008-03-12 16:23:13');
INSERT INTO CHANSON VALUES(10780,'Town Called Malice',9,NULL,NULL,'2008-03-12 18:33:57');
INSERT INTO CHANSON VALUES(10781,'The Sun Will Come Out - Dialogue',9,NULL,NULL,'2008-03-12 08:42:24');
INSERT INTO CHANSON VALUES(10782,'I Love To Boogie',9,NULL,NULL,'2008-03-12 08:43:11');
INSERT INTO CHANSON VALUES(10783,'Burning Up',9,NULL,NULL,'2008-03-12 10:20:46');
INSERT INTO CHANSON VALUES(10784,'Royal Ballet School - Dialogue',9,NULL,NULL,'2008-03-12 19:40:07');
INSERT INTO CHANSON VALUES(10786,'Children of the Revolution ',9,NULL,NULL,'2008-03-12 15:36:41');
INSERT INTO CHANSON VALUES(10787,'Audition Panel - Dialogue',9,NULL,NULL,'2008-03-12 19:17:36');
INSERT INTO CHANSON VALUES(10788,'Shout to the Top',9,NULL,NULL,'2008-03-12 09:44:55');
INSERT INTO CHANSON VALUES(10789,'Walls Come Tumbling Down',9,NULL,NULL,'2008-03-12 11:28:19');
INSERT INTO CHANSON VALUES(10790,'Ride a White Swan',9,NULL,NULL,'2008-03-12 14:19:52');
INSERT INTO CHANSON VALUES(10791,'Cosmic Dancer (Reprise)',9,NULL,NULL,'2008-03-12 13:21:35');
INSERT INTO CHANSON VALUES(10793,'Deep Blue Day',9,NULL,NULL,'2008-03-12 08:38:39');
INSERT INTO CHANSON VALUES(10794,'Trainspotting',9,NULL,NULL,'2008-03-12 17:36:19');
INSERT INTO CHANSON VALUES(10795,'Atomic',9,NULL,NULL,'2008-03-12 19:11:17');
INSERT INTO CHANSON VALUES(10796,'Temptation',9,NULL,NULL,'2008-03-12 14:48:54');
INSERT INTO CHANSON VALUES(10797,'Nightclubbing',9,NULL,NULL,'2008-03-12 10:48:11');
INSERT INTO CHANSON VALUES(10798,'Sing',9,NULL,NULL,'2008-03-12 17:56:56');
INSERT INTO CHANSON VALUES(10800,'Mile End',9,NULL,NULL,'2008-03-12 08:44:43');
INSERT INTO CHANSON VALUES(10801,'For What You Dream Of',9,NULL,NULL,'2008-03-12 19:11:05');
INSERT INTO CHANSON VALUES(10802,'2:1',9,NULL,NULL,'2008-03-12 14:03:29');
INSERT INTO CHANSON VALUES(10803,'A Final Hit',9,NULL,NULL,'2008-03-12 18:06:08');
INSERT INTO CHANSON VALUES(10804,'Born Slippy',9,NULL,NULL,'2008-03-12 14:56:44');
INSERT INTO CHANSON VALUES(10805,'Closet Romantic',9,NULL,NULL,'2008-03-12 18:54:56');
INSERT INTO CHANSON VALUES(10806,'Merci patron',2,NULL,'f','2008-03-12 09:26:44');
INSERT INTO CHANSON VALUES(10807,'Paulette la reine des paupiettes',2,NULL,'f','2008-03-12 08:39:33');
INSERT INTO CHANSON VALUES(10808,'Albert le contractuel',2,NULL,'f','2008-03-12 10:29:30');
INSERT INTO CHANSON VALUES(10809,'La biguine au biniou',2,NULL,'f','2008-03-12 09:14:43');
INSERT INTO CHANSON VALUES(10810,'Cet été c''était toi',2,NULL,'f','2008-03-12 14:18:27');
INSERT INTO CHANSON VALUES(10811,'Sois érotique',2,NULL,'f','2008-03-12 11:16:39');
INSERT INTO CHANSON VALUES(10812,'Berry blues',2,NULL,'f','2008-03-12 12:49:43');
INSERT INTO CHANSON VALUES(10813,'Hey Max',2,NULL,'f','2008-03-12 18:40:49');
INSERT INTO CHANSON VALUES(10814,'Il était une fois dans le sud',2,NULL,NULL,'2008-03-12 08:12:46');
INSERT INTO CHANSON VALUES(10815,'On n''est pas là pour se faire engueuler',2,NULL,NULL,'2008-03-12 17:03:40');
INSERT INTO CHANSON VALUES(10816,'Si tu ne veux pas payer d''impts',2,NULL,'f','2008-03-12 16:11:07');
INSERT INTO CHANSON VALUES(10817,'Sur la route de Penzac',2,NULL,'f','2008-03-12 13:13:46');
INSERT INTO CHANSON VALUES(10818,'Ouvr''la f''nêtre',2,NULL,NULL,'2008-03-12 08:27:15');
INSERT INTO CHANSON VALUES(10819,'Derrière chez moi',2,NULL,NULL,'2008-03-12 14:37:29');
INSERT INTO CHANSON VALUES(10820,'Touche mabada',2,NULL,'f','2008-03-12 10:11:48');
INSERT INTO CHANSON VALUES(10821,'Le chou farci',2,NULL,'f','2008-03-12 16:29:05');
INSERT INTO CHANSON VALUES(10822,'Histoire merveilleuse',2,NULL,'f','2008-03-12 12:52:54');
INSERT INTO CHANSON VALUES(10823,'Je dis n''importe quoi et je fais tout ce qu''on dit',2,NULL,'f','2008-03-12 08:46:34');
INSERT INTO CHANSON VALUES(10825,'Killer Blow',9,NULL,NULL,'2008-03-12 18:48:46');
INSERT INTO CHANSON VALUES(10826,'Have You Ever Had It Blue',9,NULL,NULL,'2008-03-12 16:35:49');
INSERT INTO CHANSON VALUES(10827,'Quit Life',9,NULL,NULL,'2008-03-12 12:18:01');
INSERT INTO CHANSON VALUES(10828,'Va Va Voom',9,NULL,NULL,'2008-03-12 13:46:14');
INSERT INTO CHANSON VALUES(10829,'That''s Motivation',9,NULL,NULL,'2008-04-11 08:28:48');
INSERT INTO CHANSON VALUES(10830,'Having It All',9,NULL,NULL,'2008-03-12 11:47:41');
INSERT INTO CHANSON VALUES(10831,'Rodrigo Bay',9,NULL,NULL,'2008-03-12 14:18:18');
INSERT INTO CHANSON VALUES(10832,'Selling Out',9,NULL,NULL,'2008-03-12 08:32:29');
INSERT INTO CHANSON VALUES(10833,'Riot City',9,NULL,NULL,'2008-03-12 18:15:59');
INSERT INTO CHANSON VALUES(10834,'Boogie Stop Shuffle (Rough and Smooth)',9,NULL,NULL,'2008-03-12 19:37:52');
INSERT INTO CHANSON VALUES(10835,'Ted Ain''t Ded',9,NULL,NULL,'2008-03-12 17:42:38');
INSERT INTO CHANSON VALUES(10836,'Volare',9,NULL,NULL,'2008-03-12 12:36:27');
INSERT INTO CHANSON VALUES(10837,'Napoli',9,NULL,NULL,'2008-03-12 10:18:02');
INSERT INTO CHANSON VALUES(10838,'Little Cat',9,NULL,NULL,'2008-03-12 08:40:20');
INSERT INTO CHANSON VALUES(10839,'Better Git It In Your Soul',9,NULL,NULL,'2008-03-12 08:10:06');
INSERT INTO CHANSON VALUES(10840,'So What? (Lyric Version)',9,NULL,NULL,'2008-03-12 11:26:53');
INSERT INTO CHANSON VALUES(10841,'Absolute Beginners (refrain)',9,NULL,NULL,'2008-04-07 18:41:20');
INSERT INTO CHANSON VALUES(10844,'Heroes / Helden',2,NULL,'f','2008-06-07 18:13:43.936736');
INSERT INTO CHANSON VALUES(10851,'Overture (Leonard Bernstein)',9,NULL,NULL,'2008-03-12 09:13:05');
INSERT INTO CHANSON VALUES(10852,'Prologue (Leonard Bernstein)',9,NULL,NULL,'2008-03-12 10:30:31');
INSERT INTO CHANSON VALUES(10853,'Jet song (Russ Tambling & The Jets)',9,NULL,NULL,'2008-03-12 09:28:29');
INSERT INTO CHANSON VALUES(10854,'Something''s coming (Jim Bryant)',9,NULL,NULL,'2008-03-12 11:44:28');
INSERT INTO CHANSON VALUES(10855,'Dance at the gym (Leonard Bernstein)',9,NULL,NULL,'2008-03-12 08:31:18');
INSERT INTO CHANSON VALUES(10856,'Maria (Jim Bryant)',9,NULL,NULL,'2008-03-12 08:17:03');
INSERT INTO CHANSON VALUES(10857,'America (Betty Wand, George Chakiris, The Sharks & Their Girls)',9,NULL,NULL,'2008-03-12 15:55:37');
INSERT INTO CHANSON VALUES(10858,'Tonight (Jim Bryant & Marni Nixon)',9,NULL,NULL,'2008-03-12 19:12:36');
INSERT INTO CHANSON VALUES(10859,'Gee, Officer Krupke (Russ Tamblyn & The Jets)',9,NULL,NULL,'2008-03-12 18:57:46');
INSERT INTO CHANSON VALUES(10860,'I feel pretty (Marni Nixon, Yvonne Othon, Suzie Kaye & Joanne Miya)',9,NULL,NULL,'2008-03-12 09:43:57');
INSERT INTO CHANSON VALUES(10861,'One hand, one heart (Jim Bryant & Marni Nixon)',9,NULL,NULL,'2008-03-12 08:49:10');
INSERT INTO CHANSON VALUES(10862,'Quintet (Jim Bryant, Marni Nixon, Betty Wand, The Jets & The Sharks)',9,NULL,NULL,'2008-03-12 10:02:40');
INSERT INTO CHANSON VALUES(10863,'The rumble (Leonard Bernstein)',9,NULL,NULL,'2008-03-12 16:08:08');
INSERT INTO CHANSON VALUES(10864,'Somewhere (Jim Bryant & Marni Nixon)',9,NULL,NULL,'2008-03-12 10:25:53');
INSERT INTO CHANSON VALUES(10865,'Cool (Tucker Smith & The Jets)',9,NULL,NULL,'2008-03-12 16:27:24');
INSERT INTO CHANSON VALUES(10866,'A boy like that, I have a love (Betty Wand & Marni Nixon)',9,NULL,'f','2008-03-12 19:29:42');
INSERT INTO CHANSON VALUES(10867,'Finale (Nathalie Wood)',9,NULL,NULL,'2008-03-12 08:08:37');
INSERT INTO CHANSON VALUES(10868,'End credits (Leonard Bernstein)',9,NULL,NULL,'2008-03-12 15:06:50');
INSERT INTO CHANSON VALUES(10869,'Les Choristes',9,NULL,NULL,'2008-03-12 11:00:47');
INSERT INTO CHANSON VALUES(10870,'In Memoriam',9,NULL,NULL,'2008-03-12 08:09:31');
INSERT INTO CHANSON VALUES(10871,'L''arrivée à l''école',9,NULL,NULL,'2008-03-12 19:13:20');
INSERT INTO CHANSON VALUES(10872,'Pépinot',9,NULL,NULL,'2008-03-12 09:23:22');
INSERT INTO CHANSON VALUES(10873,'Vois sur ton chemin',9,NULL,NULL,'2008-03-12 18:05:30');
INSERT INTO CHANSON VALUES(10874,'Les partitions',9,NULL,NULL,'2008-03-12 19:17:56');
INSERT INTO CHANSON VALUES(10875,'Caresse sur l''océan',9,NULL,NULL,'2008-03-12 18:57:24');
INSERT INTO CHANSON VALUES(10876,'Lueur d''été',9,NULL,NULL,'2008-03-12 11:55:53');
INSERT INTO CHANSON VALUES(10877,'Cerf-volant',9,NULL,NULL,'2008-03-12 19:57:01');
INSERT INTO CHANSON VALUES(10878,'Sous la pluie',9,NULL,NULL,'2008-03-12 15:36:08');
INSERT INTO CHANSON VALUES(10879,'Compère Guilleri',9,NULL,NULL,'2008-03-12 13:52:08');
INSERT INTO CHANSON VALUES(10880,'La désillusion',9,NULL,NULL,'2008-03-12 11:53:18');
INSERT INTO CHANSON VALUES(10881,'La nuit',9,NULL,NULL,'2008-03-12 17:52:31');
INSERT INTO CHANSON VALUES(10882,'L''incendie',9,NULL,NULL,'2008-03-12 09:01:55');
INSERT INTO CHANSON VALUES(10883,'L''évocation',9,NULL,NULL,'2008-03-12 14:51:01');
INSERT INTO CHANSON VALUES(10884,'Les avions en papier',9,NULL,NULL,'2008-03-12 08:50:18');
INSERT INTO CHANSON VALUES(10885,'Action... Réaction !',9,NULL,NULL,'2008-03-12 19:42:16');
INSERT INTO CHANSON VALUES(10886,'Seuls',9,NULL,NULL,'2008-03-12 12:59:12');
INSERT INTO CHANSON VALUES(10887,'Morhange',9,NULL,NULL,'2008-03-12 11:59:09');
INSERT INTO CHANSON VALUES(10888,'In Memoriam (a capella)',9,NULL,NULL,'2008-03-12 11:36:46');
INSERT INTO CHANSON VALUES(10889,'Nous sommes de Fond de l''Etang',9,NULL,NULL,'2008-03-12 13:04:38');
INSERT INTO CHANSON VALUES(10890,'Tubular Bells - Part One',6,NULL,'f','2008-03-12 14:20:32');
INSERT INTO CHANSON VALUES(10891,'Tubular Bells - Part Two',6,NULL,'f','2008-03-12 18:06:24');
INSERT INTO CHANSON VALUES(10892,'Un couple normal',5,NULL,'f','2008-03-24 10:23:33');
INSERT INTO CHANSON VALUES(10893,'Les photos de mariage',5,NULL,'f','2008-03-17 15:45:26');
INSERT INTO CHANSON VALUES(10894,'ça sent le sapin',5,NULL,'f','2008-03-17 12:14:25');
INSERT INTO CHANSON VALUES(10895,'Douze fois par an',5,NULL,'f','2008-03-17 11:44:17');
INSERT INTO CHANSON VALUES(10896,'Le petit voisin',5,NULL,'f','2008-03-17 12:45:07');
INSERT INTO CHANSON VALUES(10897,'Sad love song',5,NULL,'f','2008-03-24 11:38:38');
INSERT INTO CHANSON VALUES(10898,'Super 8',5,NULL,'f','2008-03-17 15:43:50');
INSERT INTO CHANSON VALUES(10899,'Parfait inconnu',5,NULL,NULL,'2008-03-17 19:05:50');
INSERT INTO CHANSON VALUES(10900,'La station',5,NULL,'f','2008-03-24 19:05:05');
INSERT INTO CHANSON VALUES(10901,'Rural',5,NULL,'f','2008-03-17 10:46:16');
INSERT INTO CHANSON VALUES(10902,'Les chiens de faïence',5,NULL,NULL,'2008-03-24 10:30:06');
INSERT INTO CHANSON VALUES(10903,'Je voudrais dormir',5,NULL,NULL,'2008-03-17 09:20:49');
INSERT INTO CHANSON VALUES(10904,'Also sprach Zarathustra Op.30 -I / (Einleitung)',1,NULL,NULL,'2008-03-12 11:37:25');
INSERT INTO CHANSON VALUES(10905,'Also sprach Zarathustra Op.30 -II / Von den Hintlerweltlern',1,NULL,NULL,'2008-03-12 08:02:30');
INSERT INTO CHANSON VALUES(10906,'Also sprach Zarathustra Op.30 -III / Von der groïen Sehnsucht',1,NULL,NULL,'2008-03-12 16:36:50');
INSERT INTO CHANSON VALUES(10907,'Also sprach Zarathustra Op.30 -IV / Von den Freuden und Leidenshaften',1,NULL,NULL,'2008-03-12 11:28:57');
INSERT INTO CHANSON VALUES(10908,'Also sprach Zarathustra Op.30 -V / Das Grablied',1,NULL,NULL,'2008-03-12 15:52:11');
INSERT INTO CHANSON VALUES(10909,'Also sprach Zarathustra Op.30 -VI / Von der Wissenschaft',1,NULL,NULL,'2008-03-12 09:12:55');
INSERT INTO CHANSON VALUES(10910,'Also sprach Zarathustra Op.30 -VII / Der Genesende',1,NULL,NULL,'2008-03-12 12:33:41');
INSERT INTO CHANSON VALUES(10911,'Also sprach Zarathustra Op.30 -VIII / Das Tanzlied',1,NULL,NULL,'2008-03-12 14:13:24');
INSERT INTO CHANSON VALUES(10912,'Also sprach Zarathustra Op.30 -IX / Nachtwandlerlied',1,NULL,NULL,'2008-03-12 12:09:29');
INSERT INTO CHANSON VALUES(10913,'Don Juan Op.20 / Tondichtung nach Nikolaus Lenau',1,NULL,NULL,'2008-03-12 10:17:50');
INSERT INTO CHANSON VALUES(10915,'Shadow Of Doubt',0,NULL,'f','2008-03-12 08:35:27');
INSERT INTO CHANSON VALUES(10916,'It Is What It Is',0,NULL,'f','2008-03-12 13:39:30');
INSERT INTO CHANSON VALUES(10917,'Barroom Girls',0,NULL,'f','2008-03-12 19:22:07');
INSERT INTO CHANSON VALUES(10918,'No Expectations',0,NULL,'f','2008-03-12 17:37:36');
INSERT INTO CHANSON VALUES(10919,'Country Boy',0,NULL,'f','2008-03-12 17:17:29');
INSERT INTO CHANSON VALUES(10920,'Freight Train Blues',0,NULL,'f','2008-03-12 19:22:42');
INSERT INTO CHANSON VALUES(10921,'Pass You By',0,NULL,'f','2008-03-12 18:45:15');
INSERT INTO CHANSON VALUES(10922,'Still Lookin'' For You',0,NULL,'f','2008-03-12 14:15:29');
INSERT INTO CHANSON VALUES(10923,'Wild Roses',0,NULL,'f','2008-03-12 19:36:39');
INSERT INTO CHANSON VALUES(10924,'I Never Cared For You',0,NULL,'f','2008-03-12 13:48:57');
INSERT INTO CHANSON VALUES(10925,'Ain''t Leavin'' Your Love',0,NULL,NULL,'2008-03-12 11:49:32');
INSERT INTO CHANSON VALUES(10926,'I''ll Be Here In The Morning',0,NULL,'f','2008-03-12 17:17:12');
INSERT INTO CHANSON VALUES(10927,'Nothin'' Is',0,NULL,'f','2008-03-12 11:14:35');
INSERT INTO CHANSON VALUES(10947,'On Your Feet Or On Your Knees ',2,NULL,'f','2008-03-30 12:02:12');
INSERT INTO CHANSON VALUES(10948,'Burner',2,NULL,'f','2008-03-30 08:47:29');
INSERT INTO CHANSON VALUES(10949,'Death Or Glory',2,NULL,NULL,'2008-03-30 14:44:52');
INSERT INTO CHANSON VALUES(10950,'I Am The Sword',2,NULL,'f','2008-03-30 10:37:37');
INSERT INTO CHANSON VALUES(10951,'Born To Raise Hell',2,NULL,'f','2008-03-30 13:11:53');
INSERT INTO CHANSON VALUES(10952,'Don''t Let Daddy Kiss Me',2,NULL,'f','2008-03-30 19:10:30');
INSERT INTO CHANSON VALUES(10953,'Bad Woman',2,NULL,'f','2008-03-30 15:39:18');
INSERT INTO CHANSON VALUES(10954,'Liar',2,NULL,'f','2008-03-30 14:58:08');
INSERT INTO CHANSON VALUES(10955,'Lost In The Ozone',2,NULL,'f','2008-03-30 09:44:25');
INSERT INTO CHANSON VALUES(10956,'I''m Your Man',2,NULL,'f','2008-03-30 11:01:40');
INSERT INTO CHANSON VALUES(10957,'We Bring The Shake',2,NULL,'f','2008-03-30 18:26:43');
INSERT INTO CHANSON VALUES(10958,'Devils',2,NULL,'f','2008-03-30 09:27:31');
INSERT INTO CHANSON VALUES(10959,'Christine',2,NULL,'f','2008-03-30 19:23:16');
INSERT INTO CHANSON VALUES(10960,'Chirac En Prison',2,NULL,NULL,'2008-03-30 15:57:15');
INSERT INTO CHANSON VALUES(10961,'Danser Sur U2',2,NULL,NULL,'2008-03-30 13:10:53');
INSERT INTO CHANSON VALUES(10962,'Quand J''étais psycho',2,NULL,'f','2008-03-30 09:39:05');
INSERT INTO CHANSON VALUES(10963,'St-RéMI',2,NULL,'f','2008-03-30 08:37:16');
INSERT INTO CHANSON VALUES(10964,'Rimini',2,NULL,'f','2008-03-30 14:15:55');
INSERT INTO CHANSON VALUES(10965,'Hélicoptère',2,NULL,'f','2008-03-30 17:50:53');
INSERT INTO CHANSON VALUES(10966,'Patrick',2,NULL,'f','2008-03-30 19:57:38');
INSERT INTO CHANSON VALUES(10967,'Tokyo Yaki',2,NULL,'f','2008-03-30 12:17:40');
INSERT INTO CHANSON VALUES(10968,'Seul En Gaspésie',2,NULL,'f','2008-03-30 08:12:06');
INSERT INTO CHANSON VALUES(10969,'Boogaloo',2,NULL,'f','2008-03-30 17:19:33');
INSERT INTO CHANSON VALUES(10970,'Johnny',2,NULL,'f','2008-03-30 11:56:31');
INSERT INTO CHANSON VALUES(10971,'Edimbourg',2,NULL,NULL,'2008-04-07 08:49:37');
INSERT INTO CHANSON VALUES(10972,'La robe et l''échelle',5,NULL,'f','2008-04-14 13:22:35');
INSERT INTO CHANSON VALUES(10973,'Les cardinaux en costume',5,NULL,'f','2008-04-14 18:00:45');
INSERT INTO CHANSON VALUES(10974,'Le chêne liège',5,NULL,'f','2008-04-14 13:28:46');
INSERT INTO CHANSON VALUES(10975,'Le cygne blanc',5,NULL,'f','2008-04-14 08:18:03');
INSERT INTO CHANSON VALUES(10976,'Des hommes pareils',5,NULL,'f','2008-04-14 12:06:45');
INSERT INTO CHANSON VALUES(10977,'Mademoiselle l''aventure',5,NULL,'f','2008-04-14 10:48:45');
INSERT INTO CHANSON VALUES(10978,'Des roses et des orties',5,NULL,'f','2008-04-14 13:29:10');
INSERT INTO CHANSON VALUES(10979,'Né dans le bayou',5,NULL,'f','2008-04-14 12:56:18');
INSERT INTO CHANSON VALUES(10980,'African tour',5,NULL,'f','2008-04-14 14:02:55');
INSERT INTO CHANSON VALUES(10981,'Madame n''aime pas',5,NULL,'f','2008-04-14 12:24:58');
INSERT INTO CHANSON VALUES(10982,'Des gens formidables',5,NULL,'f','2008-04-14 11:28:27');
INSERT INTO CHANSON VALUES(10983,'L''ombre au tableau',5,NULL,NULL,'2008-04-14 13:59:32');
INSERT INTO CHANSON VALUES(10984,'Elle m''appartient (c''est une artiste)',5,NULL,'f','2008-04-14 17:42:04');
INSERT INTO CHANSON VALUES(10985,'Jumpin'' Jack Flash',2,NULL,'f','2008-05-23 17:57:50');
INSERT INTO CHANSON VALUES(10987,'She was hot',2,NULL,'f','2008-05-23 13:19:07');
INSERT INTO CHANSON VALUES(10988,'All down the line',2,NULL,NULL,'2008-05-23 08:29:47');
INSERT INTO CHANSON VALUES(10989,'Loving cup',2,NULL,'f','2008-05-23 15:02:05');
INSERT INTO CHANSON VALUES(10991,'Some girls',2,NULL,NULL,'2008-05-23 16:56:13');
INSERT INTO CHANSON VALUES(10993,'Faraway eyes',2,NULL,'f','2008-05-23 10:21:40');
INSERT INTO CHANSON VALUES(10994,'Champagne & Reefer',2,NULL,'f','2008-05-23 08:29:56');
INSERT INTO CHANSON VALUES(10996,'Band introduction',2,NULL,'f','2008-05-23 09:36:29');
INSERT INTO CHANSON VALUES(10999,'Martin Scorcese intro',2,NULL,'f','2008-05-23 11:23:14');
INSERT INTO CHANSON VALUES(11001,'Live with me',2,NULL,'f','2008-05-23 18:33:34');
INSERT INTO CHANSON VALUES(11010,'Take Me Where You Sleep At Night',2,NULL,'f','2008-05-25 11:20:39');
INSERT INTO CHANSON VALUES(11012,'Let''s Go To Heaven',2,NULL,'f','2008-05-25 08:21:45');
INSERT INTO CHANSON VALUES(11014,'Black Doll',2,NULL,'f','2008-05-25 09:21:11');
INSERT INTO CHANSON VALUES(11016,'Shoutback',2,NULL,'f','2008-05-25 09:36:38');
INSERT INTO CHANSON VALUES(11017,'Fun, Money & Pleasure',2,NULL,'f','2008-05-25 13:32:01');
INSERT INTO CHANSON VALUES(11019,'Bathroom Singer (2nd Version)',2,NULL,'f','2008-05-25 11:55:08');
INSERT INTO CHANSON VALUES(11020,'Take Me Where You Sleep At Night (2nd Version)',2,NULL,'f','2008-05-25 08:15:28');
INSERT INTO CHANSON VALUES(11021,'Tango De La Peau (2nd Version)',2,NULL,'f','2008-05-25 16:39:05');
INSERT INTO CHANSON VALUES(11022,'Introduction by Brian Jones',2,NULL,'f','2008-05-25 13:44:27');
INSERT INTO CHANSON VALUES(11024,'Foxey Lady',2,NULL,'f','2008-05-25 09:41:44');
INSERT INTO CHANSON VALUES(11026,'Rock Me Baby',2,NULL,'f','2008-05-25 08:46:12');
INSERT INTO CHANSON VALUES(11028,'Can You See Me',2,NULL,'f','2008-05-25 16:18:56');
INSERT INTO CHANSON VALUES(11029,'The Wind Cries Mary',2,NULL,'f','2008-05-25 12:36:52');
INSERT INTO CHANSON VALUES(11031,'Wild Thing',2,NULL,'f','2008-05-25 19:21:47');
INSERT INTO CHANSON VALUES(11032,'Danza de Touton',3,NULL,NULL,'2008-05-27 06:22:31.324143');
INSERT INTO CHANSON VALUES(11033,'Canto de abril de lourido',3,NULL,NULL,'2008-05-26 08:26:05');
INSERT INTO CHANSON VALUES(11034,'Couragie',3,NULL,NULL,'2008-05-26 19:40:30');
INSERT INTO CHANSON VALUES(11035,'De Spanjaard In Gent',3,NULL,NULL,'2008-05-26 16:36:02');
INSERT INTO CHANSON VALUES(11036,'Foliada De Tenorio',3,NULL,NULL,'2008-05-27 06:24:06.653038');
INSERT INTO CHANSON VALUES(11037,'Foliada De Francisco Paradela',3,NULL,NULL,'2008-05-26 18:01:16');
INSERT INTO CHANSON VALUES(11038,'Een Schamel Mersenier',3,NULL,NULL,'2008-05-26 17:29:52');
INSERT INTO CHANSON VALUES(11039,'Romance',3,NULL,NULL,'2008-05-27 06:25:25.920098');
INSERT INTO CHANSON VALUES(11040,'Rozemarijn',3,NULL,NULL,'2008-05-26 18:38:30');
INSERT INTO CHANSON VALUES(11041,'Maneo E Muiñeira De Silván',3,NULL,NULL,'2008-05-27 06:26:25.779128');
INSERT INTO CHANSON VALUES(11042,'Mijn Oogskens Wenen',3,NULL,NULL,'2008-05-27 06:27:05.973589');
INSERT INTO CHANSON VALUES(11043,'Uterus',3,NULL,NULL,'2008-05-27 05:58:33.416441');
INSERT INTO CHANSON VALUES(11044,'Paspied D''espagne - Bourgond',3,NULL,NULL,'2008-05-27 06:07:12.421567');
INSERT INTO CHANSON VALUES(11045,'Danza De Cuntis',3,NULL,NULL,'2008-05-27 06:29:33.908241');
INSERT INTO CHANSON VALUES(11046,'Los Bilbilicos',3,NULL,NULL,'2008-05-27 06:28:56.201436');
INSERT INTO CHANSON VALUES(11047,'Een Aardig Vrouwken',3,NULL,NULL,'2008-05-27 06:30:04.457394');
INSERT INTO CHANSON VALUES(11048,'Muiñeira De Camposa',3,NULL,NULL,'2008-05-27 06:30:18.997147');
INSERT INTO CHANSON VALUES(11050,'Een Ridder En Een Meysken Jonc',3,NULL,NULL,'2008-05-27 06:31:13.601516');
INSERT INTO CHANSON VALUES(11051,'La Paloma Negra',3,NULL,NULL,'2008-05-27 06:33:00.054467');
INSERT INTO CHANSON VALUES(11052,'Paradela (Accordeon Mix)',3,NULL,NULL,'2008-05-27 06:33:20.130729');
INSERT INTO CHANSON VALUES(11053,'Mercy Mercy',2,NULL,'f','2008-06-01 19:38:23.49813');
INSERT INTO CHANSON VALUES(11054,'Hitch Hike',2,NULL,NULL,'2008-06-01 19:38:45.914801');
INSERT INTO CHANSON VALUES(11058,'I''m All Right',2,NULL,NULL,'2008-06-02 11:05:08.441082');
INSERT INTO CHANSON VALUES(11060,'Cry To Me',2,NULL,'f','2008-06-01 19:41:30.444506');
INSERT INTO CHANSON VALUES(11061,'The Under Assistant West Coast Promotion Man',2,NULL,'f','2008-06-01 19:41:59.754438');
INSERT INTO CHANSON VALUES(11064,'One More Try',2,NULL,'f','2008-06-01 19:43:55.687941');
INSERT INTO CHANSON VALUES(11069,'Out Of Time',2,NULL,'f','2008-06-01 16:19:06.169391');
INSERT INTO CHANSON VALUES(11070,'My Girl',2,NULL,'f','2008-06-01 17:31:43.239014');
INSERT INTO CHANSON VALUES(11071,'Backstreet Girl',2,NULL,'f','2008-06-02 10:04:39.136323');
INSERT INTO CHANSON VALUES(11072,'Please Go Home',2,NULL,'f','2008-06-02 10:04:59.937467');
INSERT INTO CHANSON VALUES(11074,'Take It Or Leave It',2,NULL,'f','2008-06-02 10:05:37.294714');
INSERT INTO CHANSON VALUES(11075,'Ride On, Baby',2,NULL,'f','2008-06-02 10:05:54.022316');
INSERT INTO CHANSON VALUES(11076,'Sittin'' On A Fence',2,NULL,'f','2008-06-01 16:21:45.084458');
INSERT INTO CHANSON VALUES(11078,'Stupid Girl',2,NULL,'f','2008-06-01 18:07:59.4207');
INSERT INTO CHANSON VALUES(11081,'Doncha Bother Me',2,NULL,'f','2008-06-01 18:09:38.756254');
INSERT INTO CHANSON VALUES(11083,'Flight 505',2,NULL,NULL,'2008-06-01 16:27:35.149198');
INSERT INTO CHANSON VALUES(11085,'It''s Not Easy',2,NULL,'f','2008-06-01 18:36:03.056755');
INSERT INTO CHANSON VALUES(11086,'I Am Waiting',2,NULL,'f','2008-06-01 18:36:36.599526');
INSERT INTO CHANSON VALUES(11087,'Going Home',2,NULL,'f','2008-06-01 18:37:12.165201');
INSERT INTO CHANSON VALUES(11100,'Slave',2,NULL,'f','2008-06-01 16:42:57.144612');
INSERT INTO CHANSON VALUES(11105,'Tops',2,NULL,'f','2008-06-01 16:44:45.698882');
INSERT INTO CHANSON VALUES(11106,'Heaven',2,NULL,'f','2008-06-01 16:45:12.108722');
INSERT INTO CHANSON VALUES(11107,'No Use In Crying',2,NULL,'f','2008-06-02 09:54:48.321239');
INSERT INTO CHANSON VALUES(11109,'Come On',2,NULL,'f','2008-06-01 17:05:44.999385');
INSERT INTO CHANSON VALUES(11110,'I Want To Be Loved',2,NULL,NULL,'2008-06-01 19:44:21.371815');
INSERT INTO CHANSON VALUES(11111,'I Wanna Be Your Man',2,NULL,'f','2008-06-01 17:06:15.93511');
INSERT INTO CHANSON VALUES(11112,'Stoned',2,NULL,'f','2008-06-01 17:06:33.536376');
INSERT INTO CHANSON VALUES(11117,'Tell Me',2,NULL,'f','2008-06-01 17:09:08.453913');
INSERT INTO CHANSON VALUES(11118,'I Just Want To Make Love To You',2,NULL,'f','2008-06-01 17:09:32.605433');
INSERT INTO CHANSON VALUES(11120,'Congratulations',2,NULL,'f','2008-06-01 18:06:09.759695');
INSERT INTO CHANSON VALUES(11122,'Off The Hook',2,NULL,'f','2008-06-02 09:58:39.20984');
INSERT INTO CHANSON VALUES(11123,'Heart Of Stone',2,NULL,'f','2008-06-02 09:56:57.698329');
INSERT INTO CHANSON VALUES(11124,'What A Shame',2,NULL,NULL,'2008-06-02 09:57:20.088868');
INSERT INTO CHANSON VALUES(11136,'Sad Day',2,NULL,'f','2008-06-01 20:18:13.883905');
INSERT INTO CHANSON VALUES(11139,'Long Long While',2,NULL,'f','2008-06-01 20:18:37.121295');
INSERT INTO CHANSON VALUES(11143,'Who''s Driving Your Plane?',2,NULL,'f','2008-06-01 20:18:59.514827');
INSERT INTO CHANSON VALUES(11146,'We Love You',2,NULL,'f','2008-06-01 20:19:20.41558');
INSERT INTO CHANSON VALUES(11147,'Dandelion',2,NULL,'f','2008-06-01 17:21:11.181624');
INSERT INTO CHANSON VALUES(11153,'Child Of The Moon',2,NULL,'f','2008-06-01 17:24:15.68039');
INSERT INTO CHANSON VALUES(11156,'Surprise, Surprise',2,NULL,'f','2008-06-02 10:08:02.608006');
INSERT INTO CHANSON VALUES(11159,'Memo From Turner',2,NULL,'f','2008-06-01 17:27:06.258408');
INSERT INTO CHANSON VALUES(11162,'I Don''t Know Why (AKA Don''t Know Why I Love You)',2,NULL,'f','2008-06-01 18:18:17.824827');
INSERT INTO CHANSON VALUES(11163,'Try A Little Harder',2,NULL,'f','2008-06-01 18:14:19.659766');
INSERT INTO CHANSON VALUES(11165,'Jiving Sister Fanny',2,NULL,'f','2008-06-01 17:29:12.446486');
INSERT INTO CHANSON VALUES(11168,'Yesterday''s Papers',2,NULL,'f','2008-06-02 08:55:49.561725');
INSERT INTO CHANSON VALUES(11171,'She Smiled Sweetly',2,NULL,NULL,'2008-06-02 08:57:05.934649');
INSERT INTO CHANSON VALUES(11172,'Cool, Calm, & Collected',2,NULL,NULL,'2008-06-02 08:57:43.306214');
INSERT INTO CHANSON VALUES(11173,'All Sold Out',2,NULL,'f','2008-06-02 08:58:02.132442');
INSERT INTO CHANSON VALUES(11174,'My Obsession',2,NULL,'f','2008-06-02 08:58:24.292328');
INSERT INTO CHANSON VALUES(11175,'Who''s Been Sleeping Here?',2,NULL,NULL,'2008-06-02 08:58:44.760702');
INSERT INTO CHANSON VALUES(11176,'Complicated',2,NULL,'f','2008-06-02 08:59:02.292597');
INSERT INTO CHANSON VALUES(11177,'Miss Amanda Jones',2,NULL,'f','2008-06-02 08:59:25.016958');
INSERT INTO CHANSON VALUES(11178,'Something Happened To Me Yesterday',2,NULL,'f','2008-06-02 08:59:43.846435');
INSERT INTO CHANSON VALUES(11179,'Fancy Man Blues',2,NULL,'f','2008-06-02 10:56:41.567541');
INSERT INTO CHANSON VALUES(11180,'Tumbling Dice (Live)',2,NULL,'f','2008-06-02 09:03:10.91216');
INSERT INTO CHANSON VALUES(11181,'Wild Horses (Live Stripped Version)',2,NULL,'f','2008-06-02 09:03:35.84937');
INSERT INTO CHANSON VALUES(11182,'Beast Of Burden (Live)',2,NULL,'f','2008-06-02 09:03:58.553443');
INSERT INTO CHANSON VALUES(11183,'Anyway You Look At It',2,NULL,'f','2008-06-02 11:01:43.966122');
INSERT INTO CHANSON VALUES(11184,'If I Was A Dancer (Dance Pt. 2)',2,NULL,'f','2008-06-02 09:45:28.84555');
INSERT INTO CHANSON VALUES(11185,'Miss You (Dance Version)',2,NULL,'f','2008-06-02 09:05:10.153242');
INSERT INTO CHANSON VALUES(11186,'Wish I''d Never Met You',2,NULL,'f','2008-06-02 11:26:29.534055');
INSERT INTO CHANSON VALUES(11187,'I Just Wanna Make Love To You (Live)',2,NULL,'f','2008-06-02 09:05:48.995888');
INSERT INTO CHANSON VALUES(11188,'Mixed Emotions (12" Version)',2,NULL,'f','2008-06-02 09:06:11.905821');
INSERT INTO CHANSON VALUES(11189,'Through The Lonely Nights',2,NULL,'f','2008-06-02 11:24:50.066713');
INSERT INTO CHANSON VALUES(11190,'Live With Me (Live)',2,NULL,'f','2008-06-02 09:07:13.209936');
INSERT INTO CHANSON VALUES(11192,'Harlem Shuffle (NY Mix)',2,NULL,'f','2008-06-02 09:08:02.448833');
INSERT INTO CHANSON VALUES(11193,'Mannish Boy (Live)',2,NULL,NULL,'2008-06-02 09:08:31.090151');
INSERT INTO CHANSON VALUES(11194,'Thru And Thru (Live)',2,NULL,'f','2008-06-02 09:10:03.392979');
INSERT INTO CHANSON VALUES(11195,'Meditatie over een voorbije jeugd',3,NULL,NULL,'2008-06-02 13:28:33.562395');
INSERT INTO CHANSON VALUES(11196,'De kapiteinsdochter',3,NULL,NULL,'2008-06-02 13:28:39.538289');
INSERT INTO CHANSON VALUES(11197,'La charge-L''ensorceleuse',3,NULL,NULL,'2008-06-02 13:28:44.427033');
INSERT INTO CHANSON VALUES(11198,'De schaduw van het bos',3,NULL,NULL,'2008-06-02 13:28:49.627835');
INSERT INTO CHANSON VALUES(11199,'Bea''s farewell to Brussels',3,NULL,NULL,'2008-06-02 13:28:55.423297');
INSERT INTO CHANSON VALUES(11200,'Het kerelslied',3,NULL,NULL,'2008-06-02 13:29:00.438034');
INSERT INTO CHANSON VALUES(11201,'Le compère galand',3,NULL,NULL,'2008-06-02 13:29:05.591832');
INSERT INTO CHANSON VALUES(11202,'Martelen',3,NULL,NULL,'2008-06-02 13:29:11.901717');
INSERT INTO CHANSON VALUES(11203,'Glorieuze Violette-Papichon',3,NULL,NULL,'2008-06-02 13:29:18.977657');
INSERT INTO CHANSON VALUES(11204,'Wanneer ik slaap',3,NULL,NULL,'2008-06-02 13:29:24.28023');
INSERT INTO CHANSON VALUES(11205,'La femme sans tête',3,NULL,NULL,'2008-06-02 13:29:30.710378');
INSERT INTO CHANSON VALUES(11206,'Zoals ik eenmaal beminde',3,NULL,NULL,'2008-06-02 13:29:35.812064');
INSERT INTO CHANSON VALUES(11207,'Le chant',2,NULL,'f','2008-06-02 13:49:38.091792');
INSERT INTO CHANSON VALUES(11208,'Moi je',2,NULL,'f','2008-06-02 13:49:45.969218');
INSERT INTO CHANSON VALUES(11209,'Lachesis',2,NULL,NULL,'2008-06-02 13:49:51.331664');
INSERT INTO CHANSON VALUES(11210,'Bernard Robert',2,NULL,'f','2008-06-02 13:49:57.172487');
INSERT INTO CHANSON VALUES(11211,'Madeleine vs Madelon',2,NULL,'f','2008-06-02 13:50:02.11869');
INSERT INTO CHANSON VALUES(11213,'Ankou anken ankoun',2,NULL,NULL,'2008-06-02 13:50:14.510086');
INSERT INTO CHANSON VALUES(11214,'Le fond de l''homme part 1',2,NULL,NULL,'2008-06-02 13:50:24.704755');
INSERT INTO CHANSON VALUES(11215,'Les années primaires',2,NULL,'f','2008-06-02 13:50:32.441394');
INSERT INTO CHANSON VALUES(11216,'Gnagnagna',2,NULL,'f','2008-06-02 13:50:39.9329');
INSERT INTO CHANSON VALUES(11217,'Tripoergie',2,NULL,'f','2008-06-02 13:50:44.799905');
INSERT INTO CHANSON VALUES(11218,'Mes grolles',2,NULL,'f','2008-06-02 13:50:51.102792');
INSERT INTO CHANSON VALUES(11219,'Le fond de l''homme part 2',2,NULL,'f','2008-06-02 13:50:58.017561');
INSERT INTO CHANSON VALUES(11220,'Y''a dix ans - Loïc Lantoine',5,NULL,'f','2008-06-02 14:01:15.610559');
INSERT INTO CHANSON VALUES(11221,'Mamadou m''a dit - Raoul Petite',5,NULL,'f','2008-06-02 14:03:31.352034');
INSERT INTO CHANSON VALUES(11222,'Ma fleur - Tryo',5,NULL,'f','2008-06-02 14:01:27.79938');
INSERT INTO CHANSON VALUES(11223,'Antonio - Les Blaireaux',5,NULL,'f','2008-06-02 14:01:33.346994');
INSERT INTO CHANSON VALUES(11224,'Rachel - Jeanne Cherhal',5,NULL,'f','2008-06-02 14:01:38.12474');
INSERT INTO CHANSON VALUES(11225,'Le monument aux oiseaux - Jamait',5,NULL,'f','2008-06-02 14:01:43.377722');
INSERT INTO CHANSON VALUES(11226,'Magouilles blues - Marcel et son orchestre',5,NULL,'f','2008-06-02 14:01:48.959011');
INSERT INTO CHANSON VALUES(11227,'Le vieux - Michel Bûhler',5,NULL,'f','2008-06-02 14:01:54.385627');
INSERT INTO CHANSON VALUES(11228,'La fille que j''aime - La rue Ketanou',5,NULL,'f','2008-06-02 14:02:00.174858');
INSERT INTO CHANSON VALUES(11229,'Tranche de vie - H.-F. Thiéfaine',5,NULL,'f','2008-06-02 14:02:05.927188');
INSERT INTO CHANSON VALUES(11230,'Brésils - Sanseverino',5,NULL,'f','2008-06-02 14:02:10.995702');
INSERT INTO CHANSON VALUES(11231,'Manifeste - Mell',5,NULL,NULL,'2008-06-02 14:02:16.474354');
INSERT INTO CHANSON VALUES(11232,'En avant - Les Szgaboonistes',5,NULL,'f','2008-06-02 14:02:22.489468');
INSERT INTO CHANSON VALUES(11233,'Tous ces mots terribles - Gérard Blanchard',5,NULL,'f','2008-06-02 14:02:27.53831');
INSERT INTO CHANSON VALUES(11234,'Dans les arbres - Edgard Ravahatra',5,NULL,'f','2008-06-02 14:02:33.193443');
INSERT INTO CHANSON VALUES(11235,'La guigue de la reine - Tony Truand',5,NULL,'f','2008-06-02 14:02:39.57012');
INSERT INTO CHANSON VALUES(11236,'Dure mère - Emmanuelle Béranger',5,NULL,'f','2008-06-02 14:02:44.794281');
INSERT INTO CHANSON VALUES(11237,'Je T''Ai Manqué',2,NULL,'f','2008-06-02 14:10:43.59962');
INSERT INTO CHANSON VALUES(11238,'Résidents De La République',2,NULL,'f','2008-06-02 14:10:49.456677');
INSERT INTO CHANSON VALUES(11239,'Tant De Nuits',2,NULL,'f','2008-06-02 14:10:54.173608');
INSERT INTO CHANSON VALUES(11240,'Hier A Sousse',2,NULL,'f','2008-06-02 14:11:01.578351');
INSERT INTO CHANSON VALUES(11241,'Vénus',2,NULL,'f','2008-06-02 14:11:05.634371');
INSERT INTO CHANSON VALUES(11242,'Comme Un Lego',2,NULL,'f','2008-06-02 14:11:10.504877');
INSERT INTO CHANSON VALUES(11243,'Sur Un Trapèze',2,NULL,NULL,'2008-06-02 14:11:15.969961');
INSERT INTO CHANSON VALUES(11244,'Je Tuerai La Pianiste',2,NULL,NULL,'2008-06-02 14:11:21.333271');
INSERT INTO CHANSON VALUES(11246,'Le Secret Des Banquises',2,NULL,NULL,'2008-06-02 14:11:31.770622');
INSERT INTO CHANSON VALUES(11248,'Chant d''entrée - Iubilate Deo',1,NULL,NULL,'2008-06-02 14:43:03.802198');
INSERT INTO CHANSON VALUES(11249,'Antienne des laudes des martyrs au temps pascal',1,NULL,NULL,'2008-06-02 14:43:13.595236');
INSERT INTO CHANSON VALUES(11250,'Kyrie IX',1,NULL,NULL,'2008-06-02 14:43:19.042991');
INSERT INTO CHANSON VALUES(11251,'Gloria IX',1,NULL,NULL,'2008-06-02 14:43:24.832534');
INSERT INTO CHANSON VALUES(11252,'Offertoire- Recordare',1,NULL,NULL,'2008-06-02 14:43:30.071294');
INSERT INTO CHANSON VALUES(11253,'Répons - Sancta et Immaculata',1,NULL,NULL,'2008-06-02 14:43:36.72502');
INSERT INTO CHANSON VALUES(11254,'Hymne - Sanctorum Meritis',1,NULL,NULL,'2008-06-02 14:43:42.173054');
INSERT INTO CHANSON VALUES(11255,'Communion - Pascha Nostrum',1,NULL,NULL,'2008-06-02 14:43:47.226961');
INSERT INTO CHANSON VALUES(11256,'Hymne - Salve Festa Dies',1,NULL,NULL,'2008-06-02 14:43:52.510394');
INSERT INTO CHANSON VALUES(11257,'Chant d''entrée - Salus Autem',1,NULL,NULL,'2008-06-02 14:44:00.968387');
INSERT INTO CHANSON VALUES(11258,'Répons - Subvenite',1,NULL,NULL,'2008-06-02 14:44:06.891528');
INSERT INTO CHANSON VALUES(11259,'Séquence - Laetabundus',1,NULL,NULL,'2008-06-02 14:44:11.730752');
INSERT INTO CHANSON VALUES(11260,'Graduel - Concupivit',1,NULL,NULL,'2008-06-02 14:44:16.613766');
INSERT INTO CHANSON VALUES(11261,'Communion - Semel Iuravi',1,NULL,NULL,'2008-06-02 14:44:21.682592');
INSERT INTO CHANSON VALUES(11262,'Séquence - Ave Maria',1,NULL,NULL,'2008-06-02 14:44:26.387751');
INSERT INTO CHANSON VALUES(11263,'Communion - Laetabitur Iustus',1,NULL,NULL,'2008-06-02 14:44:32.375411');
INSERT INTO CHANSON VALUES(11264,'Antienne + PS Inv. - Regem Cui Omnia',1,NULL,NULL,'2008-06-02 14:44:38.07772');
INSERT INTO CHANSON VALUES(11265,'Graduel - Viderunt Omnes',1,NULL,NULL,'2008-06-02 14:44:43.07306');
INSERT INTO CHANSON VALUES(11266,'Offertoire - Tui Sunt',1,NULL,NULL,'2008-06-02 14:44:48.221336');
INSERT INTO CHANSON VALUES(11267,'Alleluia - De Profundis',1,NULL,NULL,'2008-06-02 14:44:53.281045');
INSERT INTO CHANSON VALUES(11268,'Communion - Cantate Domino',1,NULL,NULL,'2008-06-02 14:45:00.489163');
INSERT INTO CHANSON VALUES(11269,'Antienne - Salve Regina',1,NULL,NULL,'2008-06-02 14:45:05.672977');
INSERT INTO CHANSON VALUES(11270,'Sonnerie de l''angelus',1,NULL,NULL,'2008-06-02 14:45:10.377705');
INSERT INTO CHANSON VALUES(11271,'La bière',3,NULL,NULL,'2008-06-02 15:01:42.583252');
INSERT INTO CHANSON VALUES(11272,'Un jour à la promenade',3,NULL,NULL,'2008-06-02 15:01:50.274458');
INSERT INTO CHANSON VALUES(11273,'Le galion d''Espagne',3,NULL,NULL,'2008-06-02 15:01:57.336028');
INSERT INTO CHANSON VALUES(11274,'Le petit ramoneur',3,NULL,NULL,'2008-06-02 15:02:02.772014');
INSERT INTO CHANSON VALUES(11275,'Élève toi donc belle',3,NULL,NULL,'2008-06-02 15:02:14.400553');
INSERT INTO CHANSON VALUES(11277,'Gambrinus',3,NULL,NULL,'2008-06-02 15:02:32.231964');
INSERT INTO CHANSON VALUES(11278,'Jésus s''habille en pauvre',3,NULL,NULL,'2008-06-02 15:03:00.456305');
INSERT INTO CHANSON VALUES(11279,'Voici la Saint Jean',3,NULL,NULL,'2008-06-02 15:03:29.434766');
INSERT INTO CHANSON VALUES(11280,'La belle est en jardin d''amour',3,NULL,NULL,'2008-06-02 15:03:43.725766');
INSERT INTO CHANSON VALUES(11281,'Berceuse / Alfred le chien',3,NULL,NULL,'2008-06-02 15:03:56.576782');
INSERT INTO CHANSON VALUES(11282,'Mon père m''envoie t''à l''herbe',3,NULL,NULL,'2008-06-02 15:04:07.966815');
INSERT INTO CHANSON VALUES(11283,'Les trois demoiselles',3,NULL,NULL,'2008-06-02 15:04:15.17608');
INSERT INTO CHANSON VALUES(11284,'La belle aperçoit une barque',3,NULL,NULL,'2008-06-02 15:04:23.650689');
INSERT INTO CHANSON VALUES(11285,'Le chemin d''Emblise / La rue de l''égalité',3,NULL,NULL,'2008-06-02 15:04:38.175804');
INSERT INTO CHANSON VALUES(11286,'Le voyage à Maurice',3,NULL,NULL,'2008-06-02 15:04:50.900929');
INSERT INTO CHANSON VALUES(11287,'Tiens tiens tiens voilà Jean qui vient',3,NULL,NULL,'2008-06-02 15:05:39.727195');
INSERT INTO CHANSON VALUES(11288,'Intro: Take the A train',2,NULL,'f','2008-06-05 15:50:46.893047');
INSERT INTO CHANSON VALUES(11293,'Going to a go-go',2,NULL,'f','2008-06-05 15:52:52.641264');
INSERT INTO CHANSON VALUES(11296,'Just my imagination',2,NULL,'f','2008-06-05 15:54:50.449147');
INSERT INTO CHANSON VALUES(11299,'Outro: Star spangled banner',2,NULL,'f','2008-06-05 15:55:51.555275');
INSERT INTO CHANSON VALUES(11300,'Undercover Of The Night',2,NULL,'f','2008-06-05 15:59:47.90315');
INSERT INTO CHANSON VALUES(11302,'Tie You Up (The Pain Of Love)',2,NULL,'f','2008-06-05 16:00:49.599334');
INSERT INTO CHANSON VALUES(11303,'Wanna Hold You',2,NULL,'f','2008-06-05 16:03:10.314567');
INSERT INTO CHANSON VALUES(11304,'Feel On Baby',2,NULL,'f','2008-06-05 16:03:40.345379');
INSERT INTO CHANSON VALUES(11305,'Too Much Blood',2,NULL,'f','2008-06-05 16:03:58.268388');
INSERT INTO CHANSON VALUES(11306,'Pretty Beat Up',2,NULL,'f','2008-06-05 16:04:16.551159');
INSERT INTO CHANSON VALUES(11307,'Too Tough',2,NULL,'f','2008-06-05 16:06:18.900263');
INSERT INTO CHANSON VALUES(11308,'All The Way Down',2,NULL,'f','2008-06-05 16:06:42.294589');
INSERT INTO CHANSON VALUES(11309,'It Must Be Hell',2,NULL,'f','2008-06-05 16:07:12.601634');
INSERT INTO CHANSON VALUES(11311,'Down Home Girl',2,NULL,'f','2008-06-05 16:08:49.965334');
INSERT INTO CHANSON VALUES(11315,'Mona (I Need You Baby)',2,NULL,'f','2008-06-05 16:10:36.201228');
INSERT INTO CHANSON VALUES(11316,'Down the Road Apiece',2,NULL,'f','2008-06-05 16:14:11.351703');
INSERT INTO CHANSON VALUES(11318,'Pain in My Heart',2,NULL,'f','2008-06-05 16:14:46.723528');
INSERT INTO CHANSON VALUES(11319,'Oh baby (we''ve got a good thing goin'')',2,NULL,'f','2008-06-05 16:15:43.715336');
INSERT INTO CHANSON VALUES(11322,'Vieux frère',3,NULL,'f','2008-07-09 09:38:41.047881');
INSERT INTO CHANSON VALUES(11323,'Sous l''Hangar',3,NULL,NULL,'2008-07-09 09:38:47.244448');
INSERT INTO CHANSON VALUES(11324,'La Prison de Pontanezen',3,NULL,NULL,'2008-07-09 09:38:52.900614');
INSERT INTO CHANSON VALUES(11325,'Identity',3,NULL,'f','2008-07-09 09:38:58.777377');
INSERT INTO CHANSON VALUES(11326,'Spered An Tan',3,NULL,'f','2008-07-09 09:39:04.137206');
INSERT INTO CHANSON VALUES(11327,'Les Belles Années 70',3,NULL,NULL,'2008-07-09 09:39:10.297338');
INSERT INTO CHANSON VALUES(11328,'Sur le Port de Concarneau',3,NULL,'f','2008-07-09 09:40:21.542133');
INSERT INTO CHANSON VALUES(11329,'Logonna',3,NULL,'f','2008-07-09 09:39:23.237407');
INSERT INTO CHANSON VALUES(11330,'À la Guerre',3,NULL,'f','2008-07-09 09:39:31.908924');
INSERT INTO CHANSON VALUES(11331,'À Lampedusa',3,NULL,'f','2008-07-09 09:39:42.083966');
INSERT INTO CHANSON VALUES(11332,'Sonneurs !',3,NULL,'f','2008-07-09 09:39:50.111084');
INSERT INTO CHANSON VALUES(11333,'Pollution Solution',3,NULL,NULL,'2008-07-09 09:39:55.859364');
INSERT INTO CHANSON VALUES(11334,'Faut Qu''Il Aille',3,NULL,'f','2008-07-09 09:40:03.619183');
INSERT INTO CHANSON VALUES(11335,'Ballazeux (Bonus)',3,NULL,'f','2008-07-09 09:40:09.066458');
INSERT INTO CHANSON VALUES(11336,'Dieu',2,NULL,'f','2008-07-12 07:00:32.094475');
INSERT INTO CHANSON VALUES(11337,'Toi tu parles des filles ',2,NULL,'f','2008-07-12 07:00:55.007525');
INSERT INTO CHANSON VALUES(11338,'Femmes divines',2,NULL,'f','2008-07-12 07:01:11.916316');
INSERT INTO CHANSON VALUES(11339,'Libertine ',2,NULL,'f','2008-07-12 07:04:55.187498');
INSERT INTO CHANSON VALUES(11340,'Ce que tu as trouvé',2,NULL,'f','2008-07-12 07:06:53.572453');
INSERT INTO CHANSON VALUES(11341,'Le camion',2,NULL,'f','2008-07-12 07:10:20.339293');
INSERT INTO CHANSON VALUES(11342,'Et alors ?',2,NULL,'f','2008-07-12 07:12:15.176025');
INSERT INTO CHANSON VALUES(11343,'La libellule',2,NULL,'f','2008-07-12 07:14:19.029848');
INSERT INTO CHANSON VALUES(11344,'A la recherche de l ''hameçon',2,NULL,'f','2008-07-12 07:16:37.400454');
INSERT INTO CHANSON VALUES(11345,'J''en ai presque pleuré',2,NULL,'f','2008-07-12 07:20:06.449271');
INSERT INTO CHANSON VALUES(11346,'Jazz à entube',2,NULL,'f','2008-07-12 07:22:31.824114');
INSERT INTO CHANSON VALUES(11347,'N''importe quoi',2,NULL,'f','2008-07-12 07:25:09.396142');
INSERT INTO CHANSON VALUES(11348,'On sera mieux là',2,NULL,'f','2008-07-12 07:28:32.313555');
INSERT INTO CHANSON VALUES(11349,' Je t''ai promis',2,NULL,NULL,'2008-07-12 07:32:23.364661');
INSERT INTO CHANSON VALUES(11350,'Chien et chat',2,NULL,'f','2008-07-12 07:33:57.277391');
INSERT INTO CHANSON VALUES(11351,'Mon p ''tit quinquin (L ''canchon dormoire)',2,NULL,'f','2008-07-12 07:40:45.731285');
INSERT INTO CHANSON VALUES(11352,'K.A. (andro)',2,NULL,NULL,'2009-02-15 16:45:33.874193');
INSERT INTO CHANSON VALUES(11353,'Bellarb',2,NULL,NULL,'2009-02-15 16:45:38.821691');
INSERT INTO CHANSON VALUES(11354,'Dans Gwadek 1 (plinn)',2,NULL,NULL,'2009-02-15 16:45:44.418631');
INSERT INTO CHANSON VALUES(11355,'Yaw ha yaw ha yaw (andro)',2,NULL,NULL,'2009-02-15 16:45:49.137143');
INSERT INTO CHANSON VALUES(11356,'Nomades',2,NULL,NULL,'2009-02-15 16:45:53.795656');
INSERT INTO CHANSON VALUES(11357,'Edan ur blez (laridé)',2,NULL,NULL,'2009-02-15 16:46:02.396576');
INSERT INTO CHANSON VALUES(11358,'Na gast na matzeh (gavotte pourlet)',2,NULL,NULL,'2009-02-15 16:46:08.011323');
INSERT INTO CHANSON VALUES(11359,'Captain Kirk (rock)',2,NULL,NULL,'2009-02-15 16:46:12.670069');
INSERT INTO CHANSON VALUES(11360,'Dans Gwadek 2 (plinn)',2,NULL,NULL,'2009-02-15 16:46:16.930675');
INSERT INTO CHANSON VALUES(11361,'Vive Le Feu (rock)',2,NULL,NULL,'2009-02-15 16:46:22.115915');
INSERT INTO CHANSON VALUES(11362,'''vel un tour-tan (gavotte d''honneur)',2,NULL,NULL,'2009-02-15 16:46:28.656794');
INSERT INTO CHANSON VALUES(11363,'Rock N Roll Train',2,NULL,NULL,'2009-02-15 17:44:05.63555');
INSERT INTO CHANSON VALUES(11364,'Skies On Fire',2,NULL,'f','2009-02-15 17:44:10.899986');
INSERT INTO CHANSON VALUES(11365,'Big Jack',2,NULL,'f','2009-02-15 17:44:15.423238');
INSERT INTO CHANSON VALUES(11366,'Anything Goes',2,NULL,'f','2009-02-15 17:44:20.096901');
INSERT INTO CHANSON VALUES(11367,'War Machine',2,NULL,'f','2009-02-15 17:44:24.367069');
INSERT INTO CHANSON VALUES(11368,'Smash N Grab',2,NULL,'f','2009-02-15 17:44:28.591902');
INSERT INTO CHANSON VALUES(11369,'Spoilin'' For A Fight',2,NULL,'f','2009-02-15 17:44:35.731499');
INSERT INTO CHANSON VALUES(11370,'Wheels',2,NULL,'f','2009-02-15 17:44:39.844438');
INSERT INTO CHANSON VALUES(11371,'Decibel',2,NULL,'f','2009-02-15 17:44:43.16004');
INSERT INTO CHANSON VALUES(11372,'Stormy May Day',2,NULL,'f','2009-02-15 17:44:48.480353');
INSERT INTO CHANSON VALUES(11373,'She Likes Rock N'' Roll',2,NULL,'f','2009-02-15 17:45:04.680057');
INSERT INTO CHANSON VALUES(11374,'Money Made',2,NULL,'f','2009-02-15 17:45:09.741382');
INSERT INTO CHANSON VALUES(11375,'Rock N'' Roll Dream',2,NULL,'f','2009-02-15 17:45:14.699986');
INSERT INTO CHANSON VALUES(11376,'Rocking All The Way',2,NULL,'f','2009-02-15 17:45:19.456007');
INSERT INTO CHANSON VALUES(11377,'Black Ice',2,NULL,'f','2009-02-15 17:45:23.98579');
INSERT INTO CHANSON VALUES(11378,'Bucéphale',5,NULL,'f','2009-02-15 17:49:57.316878');
INSERT INTO CHANSON VALUES(11379,'Ma Douceur',5,NULL,'f','2009-02-15 17:50:02.429676');
INSERT INTO CHANSON VALUES(11380,'Les Papillons',5,NULL,NULL,'2009-02-15 17:50:11.098701');
INSERT INTO CHANSON VALUES(11381,'Que L''on Est Bête',5,NULL,'f','2009-02-15 17:50:16.662803');
INSERT INTO CHANSON VALUES(11382,'Moi Qui Me Croyais Un Saint',5,NULL,'f','2009-02-15 17:50:20.944496');
INSERT INTO CHANSON VALUES(11383,'La Blatte',5,NULL,'f','2009-02-15 17:50:25.616152');
INSERT INTO CHANSON VALUES(11384,'Pickpocket',5,NULL,'f','2009-02-15 17:50:29.019925');
INSERT INTO CHANSON VALUES(11385,'Bijou',5,NULL,'f','2009-02-15 17:50:32.303528');
INSERT INTO CHANSON VALUES(11386,'Les Tours D''horloge',5,NULL,'f','2009-02-15 17:50:49.058181');
INSERT INTO CHANSON VALUES(11387,'Où Trouver Des Fleurs Un Lundi Soir Après Minuit?',5,NULL,'f','2009-02-15 17:50:54.198387');
INSERT INTO CHANSON VALUES(11388,'Je Suis Dev''nue La Bonne',5,NULL,'f','2009-02-15 17:51:00.417928');
INSERT INTO CHANSON VALUES(11389,'Are you ready',2,NULL,'f','2009-02-15 17:58:13.090958');
INSERT INTO CHANSON VALUES(11390,'Free in freedom',2,NULL,NULL,'2009-02-15 17:58:24.034078');
INSERT INTO CHANSON VALUES(11391,'Don''t want to go heaven',2,NULL,NULL,'2009-02-15 17:58:29.506495');
INSERT INTO CHANSON VALUES(11392,'Midnite man',2,NULL,'f','2009-02-15 17:58:34.185799');
INSERT INTO CHANSON VALUES(11393,'When you smile',2,NULL,'f','2009-02-15 17:58:38.792469');
INSERT INTO CHANSON VALUES(11394,'Why I love her',2,NULL,'f','2009-02-15 17:58:44.168979');
INSERT INTO CHANSON VALUES(11395,'The more I know',2,NULL,'f','2009-02-15 17:58:48.651572');
INSERT INTO CHANSON VALUES(11396,'Me and you',2,NULL,'f','2009-02-15 17:58:56.054689');
INSERT INTO CHANSON VALUES(11397,'Different people',2,NULL,'f','2009-02-15 17:59:02.585811');
INSERT INTO CHANSON VALUES(11398,'Petit Gars',2,NULL,'f','2009-02-15 17:59:09.269247');
INSERT INTO CHANSON VALUES(11399,'Ace Of Spades',2,NULL,'f','2009-02-15 17:59:56.971477');
INSERT INTO CHANSON VALUES(11400,'Stay Clean',2,NULL,'f','2009-02-15 18:00:02.392991');
INSERT INTO CHANSON VALUES(11401,'Metropolis',2,NULL,'f','2009-02-15 18:00:07.055318');
INSERT INTO CHANSON VALUES(11402,'The Hammer',2,NULL,'f','2009-02-15 18:00:11.550469');
INSERT INTO CHANSON VALUES(11403,'Iron Horse',2,NULL,'f','2009-02-15 18:00:15.66407');
INSERT INTO CHANSON VALUES(11404,'No Class',2,NULL,'f','2009-02-15 18:00:20.143794');
INSERT INTO CHANSON VALUES(11405,'Overkill',2,NULL,'f','2009-02-15 18:00:23.213089');
INSERT INTO CHANSON VALUES(11406,'(We Are) The Road Crew',2,NULL,'f','2009-02-15 18:00:29.567778');
INSERT INTO CHANSON VALUES(11407,'Capricorn',2,NULL,'f','2009-02-15 18:00:34.327732');
INSERT INTO CHANSON VALUES(11408,'Bomber',2,NULL,'f','2009-02-15 18:00:38.695581');
INSERT INTO CHANSON VALUES(11409,'Motörhead',2,NULL,'f','2009-02-15 18:00:42.373274');
INSERT INTO CHANSON VALUES(11410,'Over The Top',2,NULL,'f','2009-02-15 18:00:49.183367');
INSERT INTO CHANSON VALUES(11411,'Capricorn (Alternate Version)',2,NULL,'f','2009-02-15 18:00:55.371297');
INSERT INTO CHANSON VALUES(11412,'Train Kept-A-Rollin''',2,NULL,'f','2009-02-15 18:01:00.409249');
INSERT INTO CHANSON VALUES(11413,'Teenage Rampage',2,NULL,'f','2009-02-15 18:02:14.634277');
INSERT INTO CHANSON VALUES(11414,'Rebel Rouser',2,NULL,'f','2009-02-15 18:02:18.762698');
INSERT INTO CHANSON VALUES(11415,'Solid Gold Brass',2,NULL,'f','2009-02-15 18:02:23.330027');
INSERT INTO CHANSON VALUES(11416,'Stairway To The Stars',2,NULL,'f','2009-02-15 18:02:27.551018');
INSERT INTO CHANSON VALUES(11417,'Turn It Down',2,NULL,'f','2009-02-15 18:02:31.74473');
INSERT INTO CHANSON VALUES(11418,'The Sixteens',2,NULL,NULL,'2009-02-15 18:02:36.254542');
INSERT INTO CHANSON VALUES(11419,'Into The Night',2,NULL,NULL,'2009-02-15 18:02:40.982591');
INSERT INTO CHANSON VALUES(11420,'No You Don''t',2,NULL,'f','2009-02-15 18:02:46.034165');
INSERT INTO CHANSON VALUES(11421,'Fever Of Love',2,NULL,'f','2009-02-15 18:02:50.557416');
INSERT INTO CHANSON VALUES(11422,'Lies In Your Eyes',2,NULL,NULL,'2009-02-15 18:02:54.717616');
INSERT INTO CHANSON VALUES(11423,'Fox On The Run',2,NULL,'f','2009-02-15 18:02:59.267631');
INSERT INTO CHANSON VALUES(11424,'Restless',2,NULL,'f','2009-02-15 18:03:03.161441');
INSERT INTO CHANSON VALUES(11425,'Set Me Free',2,NULL,'f','2009-02-15 18:03:07.766213');
INSERT INTO CHANSON VALUES(11426,'AC/DC',2,NULL,'f','2009-02-15 18:03:11.685006');
INSERT INTO CHANSON VALUES(11427,'Sweet F.A.',2,NULL,'f','2009-02-15 18:03:16.255782');
INSERT INTO CHANSON VALUES(11428,'Action',2,NULL,'f','2009-02-15 18:03:19.658196');
INSERT INTO CHANSON VALUES(11429,'Peppermint Twist',2,NULL,'f','2009-02-15 18:04:08.335917');
INSERT INTO CHANSON VALUES(11430,'Heartbreak Today',2,NULL,'f','2009-02-15 18:03:33.399566');
INSERT INTO CHANSON VALUES(11431,'Lost Angels',2,NULL,'f','2009-02-15 18:03:39.097666');
INSERT INTO CHANSON VALUES(11432,'Prête à tout  ',2,NULL,'f','2009-02-15 18:09:42.8382');
INSERT INTO CHANSON VALUES(11433,'Loin de tout oublier',2,NULL,'f','2009-02-15 18:09:57.380739');
INSERT INTO CHANSON VALUES(11434,'Entre deux',2,NULL,'f','2009-02-15 18:10:12.983226');
INSERT INTO CHANSON VALUES(11435,'Dormir au chaud',2,NULL,'f','2009-02-15 18:10:21.617129');
INSERT INTO CHANSON VALUES(11436,'Paulette',2,NULL,'f','2009-02-15 18:10:35.18552');
INSERT INTO CHANSON VALUES(11437,'La reine impie',2,NULL,'f','2009-02-15 18:11:03.032654');
INSERT INTO CHANSON VALUES(11438,'Ma petite ombre bleue',2,NULL,'f','2009-02-15 18:11:22.058303');
INSERT INTO CHANSON VALUES(11439,'Les chants les plus beaux',2,NULL,'f','2009-02-15 18:12:14.251222');
INSERT INTO CHANSON VALUES(11440,'Que les diables nous emportent',2,NULL,'f','2009-02-15 18:12:28.417129');
INSERT INTO CHANSON VALUES(11441,'Comme un petit coquelicot',2,NULL,'f','2009-02-15 18:12:44.030661');
INSERT INTO CHANSON VALUES(11443,'If I Needed Someone',2,NULL,NULL,'2009-02-15 18:14:33.396908');
INSERT INTO CHANSON VALUES(11446,'Think For Yourself',2,NULL,'f','2009-02-15 18:14:54.237526');
INSERT INTO CHANSON VALUES(11447,'For You Blue',2,NULL,'f','2009-02-15 18:14:59.108338');
INSERT INTO CHANSON VALUES(11449,'My Sweet Lord',2,NULL,'f','2009-02-15 18:15:08.675841');
INSERT INTO CHANSON VALUES(11450,'Give Me Love (Give Me Peace On Earth)',2,NULL,NULL,'2009-02-15 18:15:15.10378');
INSERT INTO CHANSON VALUES(11451,'You',2,NULL,'f','2009-02-15 18:15:18.600517');
INSERT INTO CHANSON VALUES(11452,'Bangla Desh',2,NULL,'f','2009-02-15 18:15:24.165092');
INSERT INTO CHANSON VALUES(11453,'Dark Horse',2,NULL,'f','2009-02-15 18:15:28.465634');
INSERT INTO CHANSON VALUES(11454,'What Is Life',2,NULL,'f','2009-02-15 18:15:32.442835');
INSERT INTO CHANSON VALUES(11455,'Gavotenn : La mal mariée',3,NULL,'t','2009-04-26 09:48:44.422377');
INSERT INTO CHANSON VALUES(11456,'Tamm Kreiz',3,NULL,'t','2009-04-26 09:48:49.902909');
INSERT INTO CHANSON VALUES(11457,'Gavotenn : Les deux pigeons',3,NULL,'t','2009-04-26 09:48:54.929178');
INSERT INTO CHANSON VALUES(11458,'La fontaine de Wassadeg',3,NULL,'t','2009-04-26 09:49:00.678498');
INSERT INTO CHANSON VALUES(11459,'Plinn : la garde robe du mari défunt',3,NULL,'t','2009-04-26 09:49:06.208119');
INSERT INTO CHANSON VALUES(11460,'Pach Pi',3,NULL,'t','2009-04-26 09:49:10.86879');
INSERT INTO CHANSON VALUES(11461,'Plinn',3,NULL,'t','2009-04-26 09:49:15.041158');
INSERT INTO CHANSON VALUES(11462,'Bal plinn',3,NULL,'t','2009-04-26 09:49:22.252773');
INSERT INTO CHANSON VALUES(11463,'Plinn (2)',3,NULL,'t','2009-04-26 09:49:27.398476');
INSERT INTO CHANSON VALUES(11464,'Deus ganin d''em bro',3,NULL,'t','2009-04-26 09:49:33.433231');
INSERT INTO CHANSON VALUES(11465,'Gavotenn : danse des marmites',3,NULL,'t','2009-04-26 09:49:38.71072');
INSERT INTO CHANSON VALUES(11466,'Tamm Kreizh (2)',3,NULL,'t','2009-04-26 09:49:43.75177');
INSERT INTO CHANSON VALUES(11467,'Gavotenn ar menez',3,NULL,'t','2009-04-26 09:49:48.852771');
INSERT INTO CHANSON VALUES(11468,'Elysa',3,NULL,'t','2009-04-26 09:49:53.126913');
INSERT INTO CHANSON VALUES(11469,'Prologue - I Know Where You Live',2,NULL,'f','2009-04-26 09:51:25.969664');
INSERT INTO CHANSON VALUES(11470,'Vengeance Is Mine',2,NULL,'f','2009-04-26 09:51:31.099006');
INSERT INTO CHANSON VALUES(11471,'Wake The Dead',2,NULL,'f','2009-04-26 09:51:35.596251');
INSERT INTO CHANSON VALUES(11472,'Catch Me If You Can',2,NULL,'f','2009-04-26 09:51:40.820391');
INSERT INTO CHANSON VALUES(11473,'(In Touch With) Your Feminine Side',2,NULL,'f','2009-04-26 09:51:45.634575');
INSERT INTO CHANSON VALUES(11474,'Wrapped In Silk',2,NULL,'f','2009-04-26 09:51:50.569847');
INSERT INTO CHANSON VALUES(11475,'Killed By Love',2,NULL,'f','2009-04-26 09:51:54.51843');
INSERT INTO CHANSON VALUES(11476,'I''m Hungry',2,NULL,'f','2009-04-26 09:51:58.625211');
INSERT INTO CHANSON VALUES(11477,'The One That Got Away',2,NULL,'f','2009-04-26 09:52:03.894188');
INSERT INTO CHANSON VALUES(11478,'Salvation',2,NULL,'f','2009-04-26 09:52:08.555985');
INSERT INTO CHANSON VALUES(11479,'I Am The Spider - Epilogue',2,NULL,'f','2009-04-26 09:52:14.639063');
INSERT INTO CHANSON VALUES(11480,'Thunderstruck',2,NULL,'f','2009-04-26 10:32:05.884744');
INSERT INTO CHANSON VALUES(11481,'Fire Your Guns',2,NULL,'f','2009-04-26 10:32:23.127471');
INSERT INTO CHANSON VALUES(11482,'Moneytalks',2,NULL,'f','2009-04-26 10:27:50.951801');
INSERT INTO CHANSON VALUES(11483,'The Razors Edge',2,NULL,'f','2009-04-26 10:28:14.697793');
INSERT INTO CHANSON VALUES(11484,'Mistress For Chrismas',2,NULL,'f','2009-04-26 10:28:38.911837');
INSERT INTO CHANSON VALUES(11485,'Rock Your Heart Out',2,NULL,'f','2009-04-26 10:29:20.467617');
INSERT INTO CHANSON VALUES(11486,'Are You Ready',2,NULL,'f','2009-04-26 10:30:21.817904');
INSERT INTO CHANSON VALUES(11487,'Got You By The Balls',2,NULL,NULL,'2009-04-26 10:30:25.817336');
INSERT INTO CHANSON VALUES(11488,'Shot Of Love',2,NULL,NULL,'2009-04-26 10:30:34.525367');
INSERT INTO CHANSON VALUES(11489,'Lets Me Take It',2,NULL,'f','2009-04-26 10:30:41.256606');
INSERT INTO CHANSON VALUES(11490,'Goodbye & Good Riddance To Bad Luck',2,NULL,'f','2009-04-26 10:31:03.174852');
INSERT INTO CHANSON VALUES(11491,'If You Dare',2,NULL,'f','2009-04-26 10:31:21.427668');
INSERT INTO CHANSON VALUES(11492,'Dirty Deeds Done Dirt Cheap',2,NULL,'f','2009-04-26 10:34:08.269676');
INSERT INTO CHANSON VALUES(11493,'Love at First Feel',2,NULL,'f','2009-04-26 10:34:32.563901');
INSERT INTO CHANSON VALUES(11494,'Big Balls',2,NULL,'f','2009-04-26 10:34:52.899249');
INSERT INTO CHANSON VALUES(11495,'Rocker',2,NULL,'f','2009-04-26 10:35:29.993962');
INSERT INTO CHANSON VALUES(11497,'There''s Gonna Be Some Rockin''',2,NULL,'f','2009-04-26 10:36:10.751199');
INSERT INTO CHANSON VALUES(11498,'Ain''t No Fun (Waiting Round To Be A Millionaire)',2,NULL,NULL,'2009-04-26 10:36:40.840748');
INSERT INTO CHANSON VALUES(11500,'Squealer',2,NULL,'f','2009-04-26 10:37:24.523048');
INSERT INTO CHANSON VALUES(11501,'Jailbreak',2,NULL,'f','2009-04-26 10:40:22.003444');
INSERT INTO CHANSON VALUES(11502,'You Ain''t Got A Hold On Me',2,NULL,'f','2009-04-26 11:34:39.680771');
INSERT INTO CHANSON VALUES(11503,'Show Business',2,NULL,'f','2009-04-26 11:35:06.913776');
INSERT INTO CHANSON VALUES(11504,'Soul Stripper',2,NULL,'f','2009-04-26 11:35:47.122043');
INSERT INTO CHANSON VALUES(11505,'Baby, Please Don''t Go',2,NULL,'f','2009-04-26 11:37:48.53482');
INSERT INTO CHANSON VALUES(11507,'Summer House',2,NULL,NULL,'2009-04-26 11:40:27.650301');
INSERT INTO CHANSON VALUES(11510,'Think Too Hard',2,NULL,'f','2009-04-26 11:41:17.600938');
INSERT INTO CHANSON VALUES(11512,'Darlin'' (And She Called Me)',2,NULL,'f','2009-04-26 11:42:14.78462');
INSERT INTO CHANSON VALUES(11513,'Let Go',2,NULL,'f','2009-04-26 11:42:24.123297');
INSERT INTO CHANSON VALUES(11515,'And General Robert E. Lee',2,NULL,'f','2009-04-26 11:45:02.042118');
INSERT INTO CHANSON VALUES(11516,'Lost And Lonely',2,NULL,'f','2009-04-26 11:45:10.408117');
INSERT INTO CHANSON VALUES(11517,'The Valley Below',2,NULL,'f','2009-04-26 11:45:32.613464');
INSERT INTO CHANSON VALUES(11518,'On My Mind',2,NULL,'f','2009-04-26 11:45:34.797312');
INSERT INTO CHANSON VALUES(11519,'Ophelia',2,NULL,'f','2009-04-26 11:45:38.60302');
INSERT INTO CHANSON VALUES(11520,'What''s That',2,NULL,'f','2009-04-26 11:45:46.18966');
INSERT INTO CHANSON VALUES(11521,'Crepuscule',2,NULL,NULL,'2009-04-26 11:46:12.704342');
INSERT INTO CHANSON VALUES(11522,'Scandinavian Skies',2,NULL,NULL,'2009-04-26 11:47:34.611105');
INSERT INTO CHANSON VALUES(11523,'Razzmatazz',2,NULL,'f','2009-04-26 11:47:43.110946');
INSERT INTO CHANSON VALUES(11524,'Frankenstein''s Daughter',2,NULL,'f','2009-04-26 11:47:50.537955');
INSERT INTO CHANSON VALUES(11525,'Crying Creatures of the Universe',2,NULL,NULL,'2009-04-26 11:47:58.613423');
INSERT INTO CHANSON VALUES(11526,'Charlotte for ever',5,NULL,'f','2009-04-26 11:50:07.764726');
INSERT INTO CHANSON VALUES(11527,'Ouvertures éclair',5,NULL,'f','2009-04-26 11:50:12.764899');
INSERT INTO CHANSON VALUES(11528,'Oh daddy oh',5,NULL,'f','2009-04-26 11:50:17.232526');
INSERT INTO CHANSON VALUES(11529,'Don''t forget to forget me',5,NULL,'f','2009-04-26 11:50:23.635687');
INSERT INTO CHANSON VALUES(11530,'Pour ceux que tu n''étais pas',5,NULL,'f','2009-04-26 11:50:29.58427');
INSERT INTO CHANSON VALUES(11531,'Plus doux avec moi',5,NULL,'f','2009-04-26 11:50:35.143408');
INSERT INTO CHANSON VALUES(11532,'Élastique',5,NULL,'f','2009-04-26 11:50:46.619898');
INSERT INTO CHANSON VALUES(11533,'Zéro pointé vers l''infini',5,NULL,'f','2009-04-26 11:50:54.745406');
INSERT INTO CHANSON VALUES(11535,'Le cinéma',7,NULL,'f','2009-04-26 11:53:54.937549');
INSERT INTO CHANSON VALUES(11536,'Chacun pense être plus fin que les autres',7,NULL,'f','2009-04-26 11:54:00.065071');
INSERT INTO CHANSON VALUES(11537,'À Brassens',7,NULL,'f','2009-04-26 11:54:15.429478');
INSERT INTO CHANSON VALUES(11538,'Le journal',7,NULL,'f','2009-04-26 11:54:21.056232');
INSERT INTO CHANSON VALUES(11539,'On s''en va',7,NULL,'f','2009-04-26 11:54:26.168227');
INSERT INTO CHANSON VALUES(11540,'On s''en branle',7,NULL,'f','2009-04-26 11:54:30.699741');
INSERT INTO CHANSON VALUES(11541,'Ordre moral',7,NULL,'f','2009-04-26 11:55:42.221008');
INSERT INTO CHANSON VALUES(11542,'Les ploucs',7,NULL,'f','2009-04-26 11:55:46.823905');
INSERT INTO CHANSON VALUES(11543,'Pépé',7,NULL,'f','2009-04-26 11:55:50.587388');
INSERT INTO CHANSON VALUES(11544,'Les lycéens',7,NULL,'f','2009-04-26 11:55:55.638622');
INSERT INTO CHANSON VALUES(11545,'Chanson pour Chico Mendes',7,NULL,'f','2009-04-26 11:56:00.858945');
INSERT INTO CHANSON VALUES(11546,'La rentrée littéraire',7,NULL,'f','2009-04-26 11:56:06.54968');
INSERT INTO CHANSON VALUES(11547,'Ils sont partis',7,NULL,'f','2009-04-26 12:35:01.401905');
INSERT INTO CHANSON VALUES(11548,'Avis de recherche',7,NULL,'f','2009-04-26 12:35:08.563401');
INSERT INTO CHANSON VALUES(11549,'Ça baigne',7,NULL,NULL,'2009-04-26 12:35:16.609707');
INSERT INTO CHANSON VALUES(11550,'Rue Rossini',7,NULL,'f','2009-04-26 12:35:27.555179');
INSERT INTO CHANSON VALUES(11551,'Émigré',7,NULL,NULL,'2009-04-26 12:35:37.499435');
INSERT INTO CHANSON VALUES(11552,'L''aumonier militaire',7,NULL,'f','2009-04-26 12:35:46.999211');
INSERT INTO CHANSON VALUES(11553,'Les trois culottes',7,NULL,'f','2009-04-26 12:35:56.338939');
INSERT INTO CHANSON VALUES(11554,'Le vigile',7,NULL,NULL,'2009-04-26 12:36:04.3837');
INSERT INTO CHANSON VALUES(11555,'Marie',7,NULL,NULL,'2009-04-26 12:36:09.939698');
INSERT INTO CHANSON VALUES(11556,'Voilà',7,NULL,'f','2009-04-26 12:36:56.99764');
INSERT INTO CHANSON VALUES(11557,'Ma p''tite chérie',7,NULL,'f','2009-04-26 12:37:08.936514');
INSERT INTO CHANSON VALUES(11558,'Sous le soleil exactement (orchestre)',5,NULL,'f','2009-04-26 12:39:36.163814');
INSERT INTO CHANSON VALUES(11560,'C''est la cristallisation comme dit Stendhal',5,NULL,'f','2009-04-26 12:39:45.975279');
INSERT INTO CHANSON VALUES(11561,'Pas mal pas mal du tout',5,NULL,'f','2009-04-26 12:39:50.622694');
INSERT INTO CHANSON VALUES(11562,'J''étais fait pour les sympathies',5,NULL,'f','2009-04-26 12:39:55.672126');
INSERT INTO CHANSON VALUES(11563,'Photographes et religieuses',5,NULL,'f','2009-04-26 12:40:03.093366');
INSERT INTO CHANSON VALUES(11564,'Rien rien j''disais ça comme ça',5,NULL,'f','2009-04-26 12:40:08.220888');
INSERT INTO CHANSON VALUES(11565,'Un jour comme un autre',5,NULL,'f','2009-04-26 12:40:13.938235');
INSERT INTO CHANSON VALUES(11566,'Boomerang',5,NULL,'f','2009-04-26 12:40:18.141684');
INSERT INTO CHANSON VALUES(11567,'Un poison violent, c''est ça l''amour',5,NULL,'f','2009-04-26 12:40:25.301365');
INSERT INTO CHANSON VALUES(11568,'De plus en plus, de moins en moins',5,NULL,'f','2009-04-26 12:40:30.772157');
INSERT INTO CHANSON VALUES(11569,'Roller girl',5,NULL,'f','2009-04-26 12:40:34.926516');
INSERT INTO CHANSON VALUES(11570,'Ne dis rien',5,NULL,'f','2009-04-26 12:40:39.816143');
INSERT INTO CHANSON VALUES(11571,'Pistolet Jo',5,NULL,'f','2009-04-26 12:40:44.711923');
INSERT INTO CHANSON VALUES(11572,'G.I. Jo',5,NULL,'f','2009-04-26 12:40:49.820594');
INSERT INTO CHANSON VALUES(11573,'Je n''avais qu''un seul mot à lui dire',5,NULL,NULL,'2009-04-26 12:40:58.156507');
INSERT INTO CHANSON VALUES(11575,'Le camion jaune',5,NULL,'f','2009-04-26 12:41:09.124435');
INSERT INTO CHANSON VALUES(11576,'Banjo au bord du Styx',5,NULL,'f','2009-04-26 12:41:13.993177');
INSERT INTO CHANSON VALUES(11577,'Rock''n''roll autour de Johnny',5,NULL,'f','2009-04-26 12:41:20.055372');
INSERT INTO CHANSON VALUES(11578,'L''abominable strip-tease',5,NULL,'f','2009-04-26 12:41:56.641671');
INSERT INTO CHANSON VALUES(11579,'Joe Banjo',5,NULL,'f','2009-04-26 12:42:01.322111');
INSERT INTO CHANSON VALUES(11581,'Je t''aime... Moi non plus au motel',5,NULL,'f','2009-04-26 12:42:16.913653');
INSERT INTO CHANSON VALUES(11582,'Je pense queue',5,NULL,'f','2009-04-26 12:42:28.415218');
INSERT INTO CHANSON VALUES(11583,'Je vous salue Marie',5,NULL,'f','2009-04-26 12:42:34.03771');
INSERT INTO CHANSON VALUES(11584,'La fautive',5,NULL,'f','2009-04-26 12:42:38.385159');
INSERT INTO CHANSON VALUES(11585,'Dieu fumeur de havanes',5,NULL,'f','2009-04-26 12:42:44.069409');
INSERT INTO CHANSON VALUES(11586,'Nocturne No.1 in B flat minor, Op.9 No.1 - Larghetto',1,NULL,NULL,'2009-04-26 12:49:49.841266');
INSERT INTO CHANSON VALUES(11587,'Nocturne No.2 in E flat major, Op.9 No.2 - Andante',1,NULL,NULL,'2009-04-26 12:49:56.263581');
INSERT INTO CHANSON VALUES(11588,'Nocturne No.3 in B major, Op.9 No.3 - Allegretto',1,NULL,NULL,'2009-04-26 12:50:02.687364');
INSERT INTO CHANSON VALUES(11589,'Nocturne No.4 in F major, Op.15 No.1 - Andante cantabile',1,NULL,NULL,'2009-04-26 12:50:15.896227');
INSERT INTO CHANSON VALUES(11590,'Nocturne No.5 in F sharp major, Op.15 No.2 - Larghetto',1,NULL,NULL,'2009-04-26 12:50:23.506671');
INSERT INTO CHANSON VALUES(11591,'Nocturne No.6 in G minor, Op.15 No.3 - Lento',1,NULL,NULL,'2009-04-26 12:50:29.107858');
INSERT INTO CHANSON VALUES(11592,'Nocturne No.7 in C sharp minor, Op.27 No.1 - Larghetto',1,NULL,NULL,'2009-04-26 12:50:34.549589');
INSERT INTO CHANSON VALUES(11593,'Nocturne No.8 in D flat major, Op.27 No.2 - Lento sostenuto',1,NULL,NULL,'2009-04-26 12:50:40.820794');
INSERT INTO CHANSON VALUES(11594,'Nocturne No.9 in B major, Op.32 No.1 - Andante sostenuto',1,NULL,NULL,'2009-04-26 12:50:45.945615');
INSERT INTO CHANSON VALUES(11595,'Nocturne No.10 in A flat major, Op.32 No.2 - Lento',1,NULL,NULL,'2009-04-26 12:50:52.038307');
INSERT INTO CHANSON VALUES(11596,'Nocturne No.11 in G minor, op.37 no.1 - Andante sostenuto',1,NULL,NULL,'2009-04-26 12:52:17.809562');
INSERT INTO CHANSON VALUES(11597,'Nocturne No.12 in G major, op.37 no.2 - Andantino',1,NULL,NULL,'2009-04-26 12:52:23.478338');
INSERT INTO CHANSON VALUES(11598,'Chopin Nocturne No.13 in C minor, op.48 no.1 - Lento',1,NULL,NULL,'2009-04-26 12:52:28.383764');
INSERT INTO CHANSON VALUES(11599,'Chopin Nocturne No.14 in F sharp minor, op.48 no.2 - Andantino',1,NULL,NULL,'2009-04-26 12:52:34.569597');
INSERT INTO CHANSON VALUES(11600,'Chopin Nocturne No.15 in F minor, op.55 no.1 - Andante',1,NULL,NULL,'2009-04-26 12:52:39.450973');
INSERT INTO CHANSON VALUES(11601,'Chopin Nocturne No.16 in E flat major, op.55 no.2 - Lento sostenuto',1,NULL,NULL,'2009-04-26 12:52:45.140632');
INSERT INTO CHANSON VALUES(11602,'Chopin Nocturne No.17 in B major, op.62 no.1 - Andante',1,NULL,NULL,'2009-04-26 12:52:49.897976');
INSERT INTO CHANSON VALUES(11603,'Chopin Nocturne No.18 in E major, op.62 no.2 - Lento',1,NULL,NULL,'2009-04-26 12:52:54.339947');
INSERT INTO CHANSON VALUES(11604,'Chopin Nocturne No.19 in E minor, op.post.72 no.1 - Andante',1,NULL,NULL,'2009-04-26 12:52:59.771797');
INSERT INTO CHANSON VALUES(11605,'Chopin Nocturne No.20 in C sharp minor, op.post. - Lento con gran espressione',1,NULL,NULL,'2009-04-26 12:53:05.726776');
INSERT INTO CHANSON VALUES(11606,'Chopin Nocturne No.21 in C minor, op.post',1,NULL,NULL,'2009-04-26 12:53:19.502929');
INSERT INTO CHANSON VALUES(11607,'Bolero',1,NULL,NULL,'2009-04-26 12:55:15.734614');
INSERT INTO CHANSON VALUES(11608,'Pavane pour une infante défunte',1,NULL,NULL,'2009-04-26 12:55:20.724148');
INSERT INTO CHANSON VALUES(11609,'Rapsodie Espagnole - Prélude à la nuit',1,NULL,NULL,'2009-04-26 12:55:30.613803');
INSERT INTO CHANSON VALUES(11610,'Rapsodie Espagnole - Malaguena',1,NULL,NULL,'2009-04-26 12:55:38.199922');
INSERT INTO CHANSON VALUES(11611,'Rapsodie Espagnole - Habanera',1,NULL,NULL,'2009-04-26 12:55:44.806416');
INSERT INTO CHANSON VALUES(11612,'Rapsodie Espagnole - Feria',1,NULL,NULL,'2009-04-26 12:55:50.080354');
INSERT INTO CHANSON VALUES(11613,'Daphnis et Chloé (2ème suite)',1,NULL,NULL,'2009-04-26 12:55:55.379218');
INSERT INTO CHANSON VALUES(11614,'Chansons marrantes',5,NULL,'f','2009-06-04 17:16:15.962048');
INSERT INTO CHANSON VALUES(11615,'Mamadou m''a dit',5,NULL,'f','2009-06-04 17:16:20.213188');
INSERT INTO CHANSON VALUES(11616,'Je ne veux plus le savoir',5,NULL,'f','2009-06-04 17:16:25.423657');
INSERT INTO CHANSON VALUES(11617,'Joue pas avec mes nerfs',5,NULL,'f','2009-06-04 17:16:35.564441');
INSERT INTO CHANSON VALUES(11618,'Pour ma grand-mère',5,NULL,'f','2009-06-04 17:16:40.732837');
INSERT INTO CHANSON VALUES(11619,'Tous ces milliers de kilomètre',5,NULL,'f','2009-06-04 17:16:46.986368');
INSERT INTO CHANSON VALUES(11620,'A consommer jamais',5,NULL,NULL,'2009-06-04 17:16:52.276442');
INSERT INTO CHANSON VALUES(11621,'Canal 19',5,NULL,'f','2009-06-04 17:16:57.0323');
INSERT INTO CHANSON VALUES(11622,'Au poing de sang',5,NULL,'f','2009-06-04 17:17:02.622028');
INSERT INTO CHANSON VALUES(11623,'Y''a plus d''papier',5,NULL,'f','2009-06-04 17:17:13.846352');
INSERT INTO CHANSON VALUES(11624,'Article sans suite',5,NULL,NULL,'2009-06-04 17:17:15.798659');
INSERT INTO CHANSON VALUES(11625,'Exterminator',5,NULL,'f','2009-06-04 17:21:48.657392');
INSERT INTO CHANSON VALUES(11626,'Le messager',5,NULL,'f','2009-06-04 17:21:53.647028');
INSERT INTO CHANSON VALUES(11627,'Dans les arbres',5,NULL,'f','2009-06-04 17:21:57.913135');
INSERT INTO CHANSON VALUES(11628,'Culture Mickey',5,NULL,'f','2009-06-04 17:22:02.810265');
INSERT INTO CHANSON VALUES(11629,'Ma maison',5,NULL,'f','2009-06-04 17:22:07.61831');
INSERT INTO CHANSON VALUES(11630,'Allemagne',5,NULL,'f','2009-06-04 17:22:12.401343');
INSERT INTO CHANSON VALUES(11632,'Combien ça coûte ?',5,NULL,'f','2009-06-04 17:26:17.32923');
INSERT INTO CHANSON VALUES(11633,'Aux exclus',5,NULL,'f','2009-06-04 17:26:21.853712');
INSERT INTO CHANSON VALUES(11635,'Mamadou',5,NULL,'f','2009-06-04 17:26:31.771492');
INSERT INTO CHANSON VALUES(11636,'En avant',5,NULL,'f','2009-06-04 17:26:37.012163');
INSERT INTO CHANSON VALUES(11637,'L''état de merdre',5,NULL,'f','2009-06-04 17:26:43.380343');
INSERT INTO CHANSON VALUES(11638,'Dure mère',5,NULL,'f','2009-06-04 17:26:48.915544');
INSERT INTO CHANSON VALUES(11639,'Pour une fois',5,NULL,'f','2009-06-04 17:26:54.541363');
INSERT INTO CHANSON VALUES(11643,'Grand-mère',5,NULL,'f','2009-06-04 17:27:14.221205');
INSERT INTO CHANSON VALUES(11644,'Natacha',5,NULL,'f','2009-06-04 17:28:05.137268');
INSERT INTO CHANSON VALUES(11645,'L''évidence',5,NULL,NULL,'2009-06-04 17:28:09.669125');
INSERT INTO CHANSON VALUES(11646,'Antonio',5,NULL,NULL,'2009-06-04 17:28:13.312615');
INSERT INTO CHANSON VALUES(11647,'Milonga de mis amores',5,NULL,'f','2009-06-04 17:28:17.733314');
INSERT INTO CHANSON VALUES(11648,'Parcours de nuit',5,NULL,'f','2009-06-04 17:28:22.557114');
INSERT INTO CHANSON VALUES(11650,'Aux bouffons',5,NULL,'f','2009-06-04 17:28:32.723571');
INSERT INTO CHANSON VALUES(11651,'Ma fleur',5,NULL,'f','2009-06-04 17:28:38.000774');
INSERT INTO CHANSON VALUES(11652,'Fin de l''été',5,NULL,'f','2009-06-04 17:28:42.193255');
INSERT INTO CHANSON VALUES(11654,'Marizibill - La chanson du pharmacien',5,NULL,'f','2009-06-04 17:28:52.311636');
INSERT INTO CHANSON VALUES(11659,'Who Made Who',2,NULL,'f','2009-06-04 17:30:35.613406');
INSERT INTO CHANSON VALUES(11663,'The Jack',2,NULL,'f','2009-06-04 17:30:51.463305');
INSERT INTO CHANSON VALUES(11669,'That''s The Way I Wanna Rock ''N'' Roll',2,NULL,'f','2009-06-04 17:32:16.12043');
INSERT INTO CHANSON VALUES(11670,'High Voltage',2,NULL,'f','2009-06-04 17:32:29.172629');
INSERT INTO CHANSON VALUES(11674,'Bonny',2,NULL,'f','2009-06-04 17:32:49.558382');
INSERT INTO CHANSON VALUES(11676,'T.N.T.',2,NULL,'f','2009-06-04 17:33:07.644589');
INSERT INTO CHANSON VALUES(11677,'For Those About To Rock (We Salute You)',2,NULL,'f','2009-06-04 17:33:12.790362');
COMMIT;

CREATE INDEX artiste_ind_1 ON artiste(art_num);
CREATE INDEX chanson_ind_1 ON chanson(cha_num);
CREATE INDEX etat_ind_1 ON etat(eta_num);
CREATE INDEX genre_ind_1 ON genre(gen_num);
CREATE INDEX droits_ind_1 ON droits(dro_num);
CREATE INDEX langue_ind_1 ON langue(lan_num);
CREATE INDEX laa_ind_1 ON langueartiste(laa_langue);
CREATE INDEX laa_ind_2 ON langueartiste(laa_artiste);
CREATE INDEX lc_ind_1 ON languechanson(lac_langue);
CREATE INDEX lc_ind_2 ON languechanson(lac_chanson);
CREATE INDEX disque_ind_1 ON disque(dis_num);
CREATE INDEX disque_ind_2 ON disque(dis_artiste);
CREATE INDEX disque_ind_3 ON disque(dis_etat);
CREATE INDEX int_ind_1 ON interprete(int_artiste);
CREATE INDEX int_ind_2 ON interprete(int_chanson);
CREATE INDEX int_ind_3 ON interprete(int_disque);
CREATE INDEX int_ind_4 ON interprete(int_numero);
